/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Z=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/platform","vs/base/common/path","vs/base/common/async","vs/platform/environment/common/environment","vs/platform/files/common/files","vs/base/common/errors","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/base/common/resources","vs/base/common/types","vs/base/common/network","vs/base/node/pfs","vs/platform/log/common/log","vs/base/common/arrays","vs/platform/storage/common/storage","vs/platform/userDataSync/common/userDataSync","vs/base/common/strings","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/base/common/buffer","vs/base/common/objects","vs/platform/product/common/productService","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/cancellation","vs/base/common/uuid","vs/platform/registry/common/platform","vs/base/common/json","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/process","os","vs/base/parts/ipc/common/ipc","vs/platform/configuration/common/configurationRegistry","vs/base/common/map","vs/platform/request/common/request","vs/base/common/jsonEdit","vs/base/common/extpath","fs","child_process","vs/base/common/errorMessage","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/jsonFormatter","vs/base/common/stream","vs/base/parts/ipc/node/ipc.cp","vs/platform/instantiation/common/descriptors","vs/platform/product/common/product","vs/platform/userDataSync/common/content","vs/base/common/iterator","vs/base/common/codicons","vs/base/common/date","vs/platform/localizations/common/localizations","vs/base/common/semver/semver","vs/platform/native/electron-sandbox/native","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/node/decoder","vs/base/parts/storage/common/storage","vs/platform/extensions/common/extensionValidator","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/extensions/common/extensions","vs/platform/files/node/watcher/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/log/common/logIpc","vs/platform/files/common/io","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/extensionsStorageSync","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/userDataSync/common/userDataAutoSyncService","vs/base/common/assert","vs/base/common/stopwatch","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/uriIpc","vs/base/node/macAddress","vs/base/node/id","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/ps","vs/base/node/watcher","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","electron","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/processes","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/code/electron-browser/sharedProcess/contrib/deprecatedExtensionsCleaner","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/checksum/node/checksumService","crypto","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/platform/ipc/electron-sandbox/services","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/localizations/node/localizations","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/code/electron-browser/sharedProcess/contrib/nodeCachedDataCleaner","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/storage/common/storageIpc","vs/platform/storage/electron-sandbox/storageService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/userDataSync/common/userDataSyncResourceEnablementService","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/windows/node/windowTracker","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","string_decoder","util","path","yauzl","yazl","vs/code/electron-browser/sharedProcess/sharedProcessMain","graceful-fs"],ee=function(H){for(var e=[],y=0,R=H.length;y<R;y++)e[y]=Z[H[y]];return e};define(Z[87],ee([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function y(R,L){if(!R)throw new Error(L?`Assertion failed (${L})`:"Assertion Failed")}e.ok=y}),define(Z[63],ee([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const y=Object.prototype.hasOwnProperty;function R(n){const v=[];for(let h in n)y.call(n,h)&&v.push(n[h]);return v}e.values=R;function L(n,v){for(let h in n)if(y.call(n,h)&&v({key:h,value:n[h]},function(){delete n[h]})===!1)return}e.forEach=L;function A(n,v){const h=Object.create(null);for(const C of n){const f=v(C);let I=h[f];I||(I=h[f]=[]),I.push(C)}return h}e.groupBy=A;function O(n){const v=Object.create(null);return n&&n.forEach((h,C)=>{v[C]=h}),v}e.fromMap=O;function P(n,v){const h=[],C=[];for(let f of n)v.has(f)||h.push(f);for(let f of v)n.has(f)||C.push(f);return{removed:h,added:C}}e.diffSets=P;function p(n,v){const h=[],C=[];for(let[f,I]of n)v.has(f)||h.push(I);for(let[f,I]of v)n.has(f)||C.push(I);return{removed:h,added:C}}e.diffMaps=p;class S{constructor(){this.map=new Map}add(v,h){let C=this.map.get(v);C||(C=new Set,this.map.set(v,C)),C.add(h)}delete(v,h){const C=this.map.get(v);!C||(C.delete(h),C.size===0&&this.map.delete(v))}forEach(v,h){const C=this.map.get(v);!C||C.forEach(h)}}e.SetMap=S}),define(Z[64],ee([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function y(O){return(P,p,S)=>{let n=null,v=null;if(typeof S.value=="function"?(n="value",v=S.value):typeof S.get=="function"&&(n="get",v=S.get),!v)throw new Error("not supported");S[n]=O(v,p)}}e.createDecorator=y;function R(O,P,p){let S=null,n=null;if(typeof p.value=="function"?(S="value",n=p.value,n.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof p.get=="function"&&(S="get",n=p.get),!n)throw new Error("not supported");const v=`$memoize$${P}`;p[S]=function(...h){return this.hasOwnProperty(v)||Object.defineProperty(this,v,{configurable:!1,enumerable:!1,writable:!1,value:n.apply(this,h)}),this[v]}}e.memoize=R;function L(O,P,p){return y((S,n)=>{const v=`$debounce$${n}`,h=`$debounce$result$${n}`;return function(...C){this[h]||(this[h]=p?p():void 0),clearTimeout(this[v]),P&&(this[h]=P(this[h],...C),C=[this[h]]),this[v]=setTimeout(()=>{S.apply(this,C),this[h]=p?p():void 0},O)}})}e.debounce=L;function A(O,P,p){return y((S,n)=>{const v=`$throttle$timer$${n}`,h=`$throttle$result$${n}`,C=`$throttle$lastRun$${n}`,f=`$throttle$pending$${n}`;return function(...I){if(this[h]||(this[h]=p?p():void 0),(this[C]===null||this[C]===void 0)&&(this[C]=-Number.MAX_VALUE),P&&(this[h]=P(this[h],...I)),this[f])return;const D=this[C]+O;D<=Date.now()?(this[C]=Date.now(),S.apply(this,[this[h]]),this[h]=p?p():void 0):(this[f]=!0,this[v]=setTimeout(()=>{this[f]=!1,this[C]=Date.now(),S.apply(this,[this[h]]),this[h]=p?p():void 0},D-Date.now()))}})}e.throttle=A}),define(Z[11],ee([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class y{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(r=>{r(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=y,e.errorHandler=new y;function R(s){e.errorHandler.setUnexpectedErrorHandler(s)}e.setUnexpectedErrorHandler=R;function L(s){p(s)||e.errorHandler.onUnexpectedError(s)}e.onUnexpectedError=L;function A(s){p(s)||e.errorHandler.onUnexpectedExternalError(s)}e.onUnexpectedExternalError=A;function O(s){if(s instanceof Error){let{name:t,message:r}=s;const i=s.stacktrace||s.stack;return{$isError:!0,name:t,message:r,stack:i}}return s}e.transformErrorForSerialization=O;const P="Canceled";function p(s){return s instanceof Error&&s.name===P&&s.message===P}e.isPromiseCanceledError=p;class S extends Error{constructor(){super(P);this.name=this.message}}e.CancellationError=S;function n(){const s=new Error(P);return s.name=s.message,s}e.canceled=n;function v(s){return s?new Error(`Illegal argument: ${s}`):new Error("Illegal argument")}e.illegalArgument=v;function h(s){return s?new Error(`Illegal state: ${s}`):new Error("Illegal state")}e.illegalState=h;function C(s){return s?new Error(`readonly property '${s} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=C;function f(s){const t=new Error(`${s} has been disposed`);return t.name="DISPOSED",t}e.disposed=f;function I(s){return s?s.message?s.message:s.stack?s.stack.split(`
`)[0]:String(s):"Error"}e.getErrorMessage=I;class D extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=D;class E extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=E;class b extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=b;function g(s){const t=s;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=g;function o(s,t=Object.create(null)){const r=new Error(s);return t.actions&&(r.actions=t.actions),r}e.createErrorWithActions=o}),define(Z[19],ee([0,1,11]),function(H,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.maxIndex=e.minIndex=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function R(M,U=0){return M[M.length-(1+U)]}e.tail=R;function L(M){if(M.length===0)throw new Error("Invalid tail call");return[M.slice(0,M.length-1),M[M.length-1]]}e.tail2=L;function A(M,U,k=(F,N)=>F===N){if(M===U)return!0;if(!M||!U||M.length!==U.length)return!1;for(let F=0,N=M.length;F<N;F++)if(!k(M[F],U[F]))return!1;return!0}e.equals=A;function O(M,U,k){let F=0,N=M.length-1;for(;F<=N;){const q=(F+N)/2|0,W=k(M[q],U);if(W<0)F=q+1;else if(W>0)N=q-1;else return q}return-(F+1)}e.binarySearch=O;function P(M,U){let k=0,F=M.length;if(F===0)return 0;for(;k<F;){const N=Math.floor((k+F)/2);U(M[N])?F=N:k=N+1}return k}e.findFirstInSorted=P;function p(M,U,k){if(M=M|0,M>=U.length)throw new TypeError("invalid index");let F=U[Math.floor(U.length*Math.random())],N=[],q=[],W=[];for(let Q of U){const X=k(Q,F);X<0?N.push(Q):X>0?q.push(Q):W.push(Q)}return M<N.length?p(M,N,k):M<N.length+W.length?W[0]:p(M-(N.length+W.length),q,k)}e.quickSelect=p;function S(M,U){const k=[];let F;for(const N of M.slice(0).sort(U))!F||U(F[0],N)!==0?(F=[N],k.push(F)):F.push(N);return k}e.groupBy=S;function n(M,U,k){const F=[];function N(Q,X,ie){if(X===0&&ie.length===0)return;const ne=F[F.length-1];ne&&ne.start+ne.deleteCount===Q?(ne.deleteCount+=X,ne.toInsert.push(...ie)):F.push({start:Q,deleteCount:X,toInsert:ie})}let q=0,W=0;for(;;){if(q===M.length){N(q,0,U.slice(W));break}if(W===U.length){N(q,M.length-q,[]);break}const Q=M[q],X=U[W],ie=k(Q,X);ie===0?(q+=1,W+=1):ie<0?(N(q,1,[]),q+=1):ie>0&&(N(q,0,[X]),W+=1)}return F}e.sortedDiff=n;function v(M,U,k){const F=n(M,U,k),N=[],q=[];for(const W of F)N.push(...M.slice(W.start,W.start+W.deleteCount)),q.push(...W.toInsert);return{removed:N,added:q}}e.delta=v;function h(M,U,k){if(k===0)return[];const F=M.slice(0,k).sort(U);return f(M,U,F,k,M.length),F}e.top=h;function C(M,U,k,F,N){return k===0?Promise.resolve([]):new Promise((q,W)=>{(async()=>{const Q=M.length,X=M.slice(0,k).sort(U);for(let ie=k,ne=Math.min(k+F,Q);ie<Q;ie=ne,ne=Math.min(ne+F,Q)){if(ie>k&&await new Promise(ce=>setTimeout(ce)),N&&N.isCancellationRequested)throw y.canceled();f(M,U,X,ie,ne)}return X})().then(q,W)})}e.topAsync=C;function f(M,U,k,F,N){for(const q=k.length;F<N;F++){const W=M[F];if(U(W,k[q-1])<0){k.pop();const Q=P(k,X=>U(W,X)<0);k.splice(Q,0,W)}}}function I(M){return M.filter(U=>!!U)}e.coalesce=I;function D(M){let U=0;for(let k=0;k<M.length;k++)M[k]&&(M[U]=M[k],U+=1);M.length=U}e.coalesceInPlace=D;function E(M,U,k){M.splice(k,0,M.splice(U,1)[0])}e.move=E;function b(M){return!Array.isArray(M)||M.length===0}e.isFalsyOrEmpty=b;function g(M){return Array.isArray(M)&&M.length>0}e.isNonEmptyArray=g;function o(M,U){if(!U)return M.filter((F,N)=>M.indexOf(F)===N);const k=Object.create(null);return M.filter(F=>{const N=U(F);return k[N]?!1:(k[N]=!0,!0)})}e.distinct=o;function s(M){const U=new Set;return M.filter(k=>U.has(k)?!1:(U.add(k),!0))}e.distinctES6=s;function t(M){const U=Object.create(null);return k=>{const F=M(k);return U[F]?!1:(U[F]=!0,!0)}}e.uniqueFilter=t;function r(M,U){for(let k=M.length-1;k>=0;k--){const F=M[k];if(U(F))return k}return-1}e.lastIndex=r;function i(M,U){return M.length>0?M[0]:U}e.firstOrDefault=i;function a(M,U,k=(F,N)=>F===N){let F=0;for(let N=0,q=Math.min(M.length,U.length);N<q&&k(M[N],U[N]);N++)F++;return F}e.commonPrefixLength=a;function c(M){return[].concat(...M)}e.flatten=c;function u(M,U){let k=typeof U=="number"?M:0;typeof U=="number"?k=M:(k=0,U=M);const F=[];if(k<=U)for(let N=k;N<U;N++)F.push(N);else for(let N=k;N>U;N--)F.push(N);return F}e.range=u;function l(M,U,k){return M.reduce((F,N)=>(F[U(N)]=k?k(N):N,F),Object.create(null))}e.index=l;function m(M,U){return M.push(U),()=>w(M,U)}e.insert=m;function w(M,U){const k=M.indexOf(U);if(k>-1)return M.splice(k,1),U}e.remove=w;function d(M,U,k){const F=M.slice(0,U),N=M.slice(U);return F.concat(k,N)}e.arrayInsert=d;function T(M,U){let k;if(typeof U=="number"){let F=U;k=()=>{const N=Math.sin(F++)*179426549;return N-Math.floor(N)}}else k=Math.random;for(let F=M.length-1;F>0;F-=1){const N=Math.floor(k()*(F+1)),q=M[F];M[F]=M[N],M[N]=q}}e.shuffle=T;function _(M,U){const k=M.indexOf(U);k>-1&&(M.splice(k,1),M.unshift(U))}e.pushToStart=_;function j(M,U){const k=M.indexOf(U);k>-1&&(M.splice(k,1),M.push(U))}e.pushToEnd=j;function $(M,U){return Array.isArray(M)?M.map(U):U(M)}e.mapArrayOrNot=$;function K(M){return Array.isArray(M)?M:[M]}e.asArray=K;function B(M){return M[Math.floor(Math.random()*M.length)]}e.getRandomElement=B;function z(M,U){for(const k of M){const F=U(k);if(F!==void 0)return F}}e.mapFind=z;function G(M,U){let k=Number.MAX_SAFE_INTEGER,F=0;return M.forEach((N,q)=>{const W=U(N);W<k&&(k=W,F=q)}),F}e.minIndex=G;function V(M,U){let k=Number.MIN_SAFE_INTEGER,F=0;return M.forEach((N,q)=>{const W=U(N);W>k&&(k=W,F=q)}),F}e.maxIndex=V}),define(Z[65],ee([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function y(R){const L=this;let A=!1,O;return function(){return A||(A=!0,O=R.apply(L,arguments)),O}}e.once=y}),define(Z[53],ee([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var y;(function(R){function L(s){return s&&typeof s=="object"&&typeof s[Symbol.iterator]=="function"}R.is=L;const A=Object.freeze([]);function O(){return A}R.empty=O;function*P(s){yield s}R.single=P;function p(s){return s||A}R.from=p;function S(s){return!s||s[Symbol.iterator]().next().done===!0}R.isEmpty=S;function n(s){return s[Symbol.iterator]().next().value}R.first=n;function v(s,t){for(const r of s)if(t(r))return!0;return!1}R.some=v;function h(s,t){for(const r of s)if(t(r))return r}R.find=h;function*C(s,t){for(const r of s)t(r)&&(yield r)}R.filter=C;function*f(s,t){let r=0;for(const i of s)yield t(i,r++)}R.map=f;function*I(...s){for(const t of s)for(const r of t)yield r}R.concat=I;function*D(s){for(const t of s)for(const r of t)yield r}R.concatNested=D;function E(s,t,r){let i=r;for(const a of s)i=t(i,a);return i}R.reduce=E;function*b(s,t,r=s.length){for(t<0&&(t+=s.length),r<0?r+=s.length:r>s.length&&(r=s.length);t<r;t++)yield s[t]}R.slice=b;function g(s,t=Number.POSITIVE_INFINITY){const r=[];if(t===0)return[r,s];const i=s[Symbol.iterator]();for(let a=0;a<t;a++){const c=i.next();if(c.done)return[r,R.empty()];r.push(c.value)}return[r,{[Symbol.iterator](){return i}}]}R.consume=g;function o(s,t,r=(i,a)=>i===a){const i=s[Symbol.iterator](),a=t[Symbol.iterator]();for(;;){const c=i.next(),u=a.next();if(c.done!==u.done)return!1;if(c.done)return!0;if(!r(c.value,u.value))return!1}}R.equals=o})(y=e.Iterable||(e.Iterable={}))}),define(Z[32],ee([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var y;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(y=e.ScanError||(e.ScanError={}));var R;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(R=e.SyntaxKind||(e.SyntaxKind={}));var L;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(L=e.ParseErrorCode||(e.ParseErrorCode={}));var A;(function(t){t.DEFAULT={allowTrailingComma:!0}})(A=e.ParseOptions||(e.ParseOptions={}));function O(t,r=!1){let i=0,a=t.length,c="",u=0,l=16,m=0;function w(B){let z=0,G=0;for(;z<B;){const V=t.charCodeAt(i);if(V>=48&&V<=57)G=G*16+V-48;else if(V>=65&&V<=70)G=G*16+V-65+10;else if(V>=97&&V<=102)G=G*16+V-97+10;else break;i++,z++}return z<B&&(G=-1),G}function d(B){i=B,c="",u=0,l=16,m=0}function T(){const B=i;if(t.charCodeAt(i)===48)i++;else for(i++;i<t.length&&S(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===46)if(i++,i<t.length&&S(t.charCodeAt(i)))for(i++;i<t.length&&S(t.charCodeAt(i));)i++;else return m=3,t.substring(B,i);let z=i;if(i<t.length&&(t.charCodeAt(i)===69||t.charCodeAt(i)===101))if(i++,(i<t.length&&t.charCodeAt(i)===43||t.charCodeAt(i)===45)&&i++,i<t.length&&S(t.charCodeAt(i))){for(i++;i<t.length&&S(t.charCodeAt(i));)i++;z=i}else m=3;return t.substring(B,z)}function _(){let B="",z=i;for(;;){if(i>=a){B+=t.substring(z,i),m=2;break}const G=t.charCodeAt(i);if(G===34){B+=t.substring(z,i),i++;break}if(G===92){if(B+=t.substring(z,i),i++,i>=a){m=2;break}switch(t.charCodeAt(i++)){case 34:B+='"';break;case 92:B+="\\";break;case 47:B+="/";break;case 98:B+="\b";break;case 102:B+="\f";break;case 110:B+=`
`;break;case 114:B+="\r";break;case 116:B+="	";break;case 117:const M=w(4);M>=0?B+=String.fromCharCode(M):m=4;break;default:m=5}z=i;continue}if(G>=0&&G<=31)if(p(G)){B+=t.substring(z,i),m=2;break}else m=6;i++}return B}function j(){if(c="",m=0,u=i,i>=a)return u=a,l=17;let B=t.charCodeAt(i);if(P(B)){do i++,c+=String.fromCharCode(B),B=t.charCodeAt(i);while(P(B));return l=15}if(p(B))return i++,c+=String.fromCharCode(B),B===13&&t.charCodeAt(i)===10&&(i++,c+=`
`),l=14;switch(B){case 123:return i++,l=1;case 125:return i++,l=2;case 91:return i++,l=3;case 93:return i++,l=4;case 58:return i++,l=6;case 44:return i++,l=5;case 34:return i++,c=_(),l=10;case 47:const z=i-1;if(t.charCodeAt(i+1)===47){for(i+=2;i<a&&!p(t.charCodeAt(i));)i++;return c=t.substring(z,i),l=12}if(t.charCodeAt(i+1)===42){i+=2;const G=a-1;let V=!1;for(;i<G;){if(t.charCodeAt(i)===42&&t.charCodeAt(i+1)===47){i+=2,V=!0;break}i++}return V||(i++,m=1),c=t.substring(z,i),l=13}return c+=String.fromCharCode(B),i++,l=16;case 45:if(c+=String.fromCharCode(B),i++,i===a||!S(t.charCodeAt(i)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return c+=T(),l=11;default:for(;i<a&&$(B);)i++,B=t.charCodeAt(i);if(u!==i){switch(c=t.substring(u,i),c){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return c+=String.fromCharCode(B),i++,l=16}}function $(B){if(P(B)||p(B))return!1;switch(B){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function K(){let B;do B=j();while(B>=12&&B<=15);return B}return{setPosition:d,getPosition:()=>i,scan:r?K:j,getToken:()=>l,getTokenValue:()=>c,getTokenOffset:()=>u,getTokenLength:()=>i-u,getTokenError:()=>m}}e.createScanner=O;function P(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function p(t){return t===10||t===13||t===8232||t===8233}function S(t){return t>=48&&t<=57}var n;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(n||(n={}));function v(t,r){const i=[],a=new Object;let c;const u={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function m(w,d,T,_){u.value=w,u.offset=d,u.length=T,u.type=_,u.colonOffset=void 0,c=u}try{g(t,{onObjectBegin:(w,d)=>{if(r<=w)throw a;c=void 0,l=r>w,i.push("")},onObjectProperty:(w,d,T)=>{if(r<d||(m(w,d,T,"property"),i[i.length-1]=w,r<=d+T))throw a},onObjectEnd:(w,d)=>{if(r<=w)throw a;c=void 0,i.pop()},onArrayBegin:(w,d)=>{if(r<=w)throw a;c=void 0,i.push(0)},onArrayEnd:(w,d)=>{if(r<=w)throw a;c=void 0,i.pop()},onLiteralValue:(w,d,T)=>{if(r<d||(m(w,d,T,s(w)),r<=d+T))throw a},onSeparator:(w,d,T)=>{if(r<=d)throw a;if(w===":"&&c&&c.type==="property")c.colonOffset=d,l=!1,c=void 0;else if(w===","){const _=i[i.length-1];typeof _=="number"?i[i.length-1]=_+1:(l=!0,i[i.length-1]=""),c=void 0}}})}catch(w){if(w!==a)throw w}return{path:i,previousNode:c,isAtPropertyKey:l,matches:w=>{let d=0;for(let T=0;d<w.length&&T<i.length;T++)if(w[d]===i[T]||w[d]==="*")d++;else if(w[d]!=="**")return!1;return d===w.length}}}e.getLocation=v;function h(t,r=[],i=A.DEFAULT){let a=null,c=[];const u=[];function l(w){Array.isArray(c)?c.push(w):a!==null&&(c[a]=w)}return g(t,{onObjectBegin:()=>{const w={};l(w),u.push(c),c=w,a=null},onObjectProperty:w=>{a=w},onObjectEnd:()=>{c=u.pop()},onArrayBegin:()=>{const w=[];l(w),u.push(c),c=w,a=null},onArrayEnd:()=>{c=u.pop()},onLiteralValue:l,onError:(w,d,T)=>{r.push({error:w,offset:d,length:T})}},i),c[0]}e.parse=h;function C(t,r=[],i=A.DEFAULT){let a={type:"array",offset:-1,length:-1,children:[],parent:void 0};function c(w){a.type==="property"&&(a.length=w-a.offset,a=a.parent)}function u(w){return a.children.push(w),w}g(t,{onObjectBegin:w=>{a=u({type:"object",offset:w,length:-1,parent:a,children:[]})},onObjectProperty:(w,d,T)=>{a=u({type:"property",offset:d,length:-1,parent:a,children:[]}),a.children.push({type:"string",value:w,offset:d,length:T,parent:a})},onObjectEnd:(w,d)=>{a.length=w+d-a.offset,a=a.parent,c(w+d)},onArrayBegin:(w,d)=>{a=u({type:"array",offset:w,length:-1,parent:a,children:[]})},onArrayEnd:(w,d)=>{a.length=w+d-a.offset,a=a.parent,c(w+d)},onLiteralValue:(w,d,T)=>{u({type:s(w),offset:d,length:T,parent:a,value:w}),c(d+T)},onSeparator:(w,d,T)=>{a.type==="property"&&(w===":"?a.colonOffset=d:w===","&&c(d))},onError:(w,d,T)=>{r.push({error:w,offset:d,length:T})}},i);const m=a.children[0];return m&&delete m.parent,m}e.parseTree=C;function f(t,r){if(!t)return;let i=t;for(let a of r)if(typeof a=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let c=!1;for(const u of i.children)if(Array.isArray(u.children)&&u.children[0].value===a){i=u.children[1],c=!0;break}if(!c)return}else{const c=a;if(i.type!=="array"||c<0||!Array.isArray(i.children)||c>=i.children.length)return;i=i.children[c]}return i}e.findNodeAtLocation=f;function I(t){if(!t.parent||!t.parent.children)return[];const r=I(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;r.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&r.push(i)}return r}e.getNodePath=I;function D(t){switch(t.type){case"array":return t.children.map(D);case"object":const r=Object.create(null);for(let i of t.children){const a=i.children[1];a&&(r[i.children[0].value]=D(a))}return r;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=D;function E(t,r,i=!1){return r>=t.offset&&r<t.offset+t.length||i&&r===t.offset+t.length}e.contains=E;function b(t,r,i=!1){if(E(t,r,i)){const a=t.children;if(Array.isArray(a))for(let c=0;c<a.length&&a[c].offset<=r;c++){const u=b(a[c],r,i);if(u)return u}return t}}e.findNodeAtOffset=b;function g(t,r,i=A.DEFAULT){const a=O(t,!1);function c(W){return W?()=>W(a.getTokenOffset(),a.getTokenLength()):()=>!0}function u(W){return W?Q=>W(Q,a.getTokenOffset(),a.getTokenLength()):()=>!0}const l=c(r.onObjectBegin),m=u(r.onObjectProperty),w=c(r.onObjectEnd),d=c(r.onArrayBegin),T=c(r.onArrayEnd),_=u(r.onLiteralValue),j=u(r.onSeparator),$=c(r.onComment),K=u(r.onError),B=i&&i.disallowComments,z=i&&i.allowTrailingComma;function G(){for(;;){const W=a.scan();switch(a.getTokenError()){case 4:V(14);break;case 5:V(15);break;case 3:V(13);break;case 1:B||V(11);break;case 2:V(12);break;case 6:V(16);break}switch(W){case 12:case 13:B?V(10):$();break;case 16:V(1);break;case 15:case 14:break;default:return W}}}function V(W,Q=[],X=[]){if(K(W),Q.length+X.length>0){let ie=a.getToken();for(;ie!==17;){if(Q.indexOf(ie)!==-1){G();break}else if(X.indexOf(ie)!==-1)break;ie=G()}}}function M(W){const Q=a.getTokenValue();return W?_(Q):m(Q),G(),!0}function U(){switch(a.getToken()){case 11:let W=0;try{W=JSON.parse(a.getTokenValue()),typeof W!="number"&&(V(2),W=0)}catch(Q){V(2)}_(W);break;case 7:_(null);break;case 8:_(!0);break;case 9:_(!1);break;default:return!1}return G(),!0}function k(){return a.getToken()!==10?(V(3,[],[2,5]),!1):(M(!1),a.getToken()===6?(j(":"),G(),q()||V(4,[],[2,5])):V(5,[],[2,5]),!0)}function F(){l(),G();let W=!1;for(;a.getToken()!==2&&a.getToken()!==17;){if(a.getToken()===5){if(W||V(4,[],[]),j(","),G(),a.getToken()===2&&z)break}else W&&V(6,[],[]);k()||V(4,[],[2,5]),W=!0}return w(),a.getToken()!==2?V(7,[2],[]):G(),!0}function N(){d(),G();let W=!1;for(;a.getToken()!==4&&a.getToken()!==17;){if(a.getToken()===5){if(W||V(4,[],[]),j(","),G(),a.getToken()===4&&z)break}else W&&V(6,[],[]);q()||V(4,[],[4,5]),W=!0}return T(),a.getToken()!==4?V(8,[4],[]):G(),!0}function q(){switch(a.getToken()){case 3:return N();case 1:return F();case 10:return M(!0);default:return U()}}return G(),a.getToken()===17?i.allowEmptyContent?!0:(V(4,[],[]),!1):q()?(a.getToken()!==17&&V(9,[],[]),!0):(V(4,[],[]),!1)}e.visit=g;function o(t,r){let i=O(t),a=[],c,u=0,l;do switch(l=i.getPosition(),c=i.scan(),c){case 12:case 13:case 17:u!==l&&a.push(t.substring(u,l)),r!==void 0&&a.push(i.getTokenValue().replace(/[^\r\n]/g,r)),u=i.getPosition();break}while(c!==17);return a.join("")}e.stripComments=o;function s(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=s}),define(Z[47],ee([0,1,32]),function(H,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function R(p,S,n){let v,h,C,f,I;if(S){for(f=S.offset,I=f+S.length,C=f;C>0&&!P(p,C-1);)C--;let u=I;for(;u<p.length&&!P(p,u);)u++;h=p.substring(C,u),v=A(h,n)}else h=p,v=0,C=0,f=0,I=p.length;const D=O(n,p);let E=!1,b=0,g;n.insertSpaces?g=L(" ",n.tabSize||4):g="	";const o=y.createScanner(h,!1);let s=!1;function t(){return D+L(g,v+b)}function r(){let u=o.scan();for(E=!1;u===15||u===14;)E=E||u===14,u=o.scan();return s=u===16||o.getTokenError()!==0,u}const i=[];function a(u,l,m){!s&&l<I&&m>f&&p.substring(l,m)!==u&&i.push({offset:l,length:m-l,content:u})}let c=r();if(c!==17){const u=o.getTokenOffset()+C,l=L(g,v);a(l,C,u)}for(;c!==17;){let u=o.getTokenOffset()+o.getTokenLength()+C,l=r(),m="";for(;!E&&(l===12||l===13);){const d=o.getTokenOffset()+C;a(" ",u,d),u=o.getTokenOffset()+o.getTokenLength()+C,m=l===12?t():"",l=r()}if(l===2)c!==1&&(b--,m=t());else if(l===4)c!==3&&(b--,m=t());else{switch(c){case 3:case 1:b++,m=t();break;case 5:case 12:m=t();break;case 13:E?m=t():m=" ";break;case 6:m=" ";break;case 10:if(l===6){m="";break}case 7:case 8:case 9:case 11:case 2:case 4:l===12||l===13?m=" ":l!==5&&l!==17&&(s=!0);break;case 16:s=!0;break}E&&(l===12||l===13)&&(m=t())}const w=o.getTokenOffset()+C;a(m,u,w),c=l}return i}e.format=R;function L(p,S){let n="";for(let v=0;v<S;v++)n+=p;return n}function A(p,S){let n=0,v=0;const h=S.tabSize||4;for(;n<p.length;){const C=p.charAt(n);if(C===" ")v++;else if(C==="	")v+=h;else break;n++}return Math.floor(v/h)}function O(p,S){for(let n=0;n<S.length;n++){const v=S.charAt(n);if(v==="\r")return n+1<S.length&&S.charAt(n+1)===`
`?`\r
`:"\r";if(v===`
`)return`
`}return p&&p.eol||`
`}e.getEOL=O;function P(p,S){return`\r
`.indexOf(p.charAt(S))!==-1}e.isEOL=P}),define(Z[40],ee([0,1,32,47]),function(H,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function L(S,n,v){return A(S,n,void 0,v)}e.removeProperty=L;function A(S,n,v,h,C){const f=n.slice(),I=[],D=y.parseTree(S,I);let E,b;for(;f.length>0&&(b=f.pop(),E=y.findNodeAtLocation(D,f),E===void 0&&v!==void 0);)typeof b=="string"?v={[b]:v}:v=[v];if(E)if(E.type==="object"&&typeof b=="string"&&Array.isArray(E.children)){const g=y.findNodeAtLocation(E,[b]);if(g!==void 0)if(v===void 0){if(!g.parent)throw new Error("Malformed AST");const o=E.children.indexOf(g.parent);let s,t=g.parent.offset+g.parent.length;if(o>0){const r=E.children[o-1];s=r.offset+r.length}else s=E.offset+1,E.children.length>1&&(t=E.children[1].offset);return O(S,{offset:s,length:t-s,content:""},h)}else return O(S,{offset:g.offset,length:g.length,content:JSON.stringify(v)},h);else{if(v===void 0)return[];const o=`${JSON.stringify(b)}: ${JSON.stringify(v)}`,s=C?C(E.children.map(r=>r.children[0].value)):E.children.length;let t;if(s>0){const r=E.children[s-1];t={offset:r.offset+r.length,length:0,content:","+o}}else E.children.length===0?t={offset:E.offset+1,length:0,content:o}:t={offset:E.offset+1,length:0,content:o+","};return O(S,t,h)}}else if(E.type==="array"&&typeof b=="number"&&Array.isArray(E.children))if(v!==void 0){const g=`${JSON.stringify(v)}`;let o;if(E.children.length===0||b===0)o={offset:E.offset+1,length:0,content:E.children.length===0?g:g+","};else{const s=b===-1||b>E.children.length?E.children.length:b,t=E.children[s-1];o={offset:t.offset+t.length,length:0,content:","+g}}return O(S,o,h)}else{const g=b,o=E.children[g];let s;if(E.children.length===1)s={offset:E.offset+1,length:E.length-2,content:""};else if(E.children.length-1===g){const t=E.children[g-1],r=t.offset+t.length,i=E.offset+E.length;s={offset:r,length:i-2-r,content:""}}else s={offset:o.offset,length:E.children[g+1].offset-o.offset,content:""};return O(S,s,h)}else throw new Error(`Can not add ${typeof b!="number"?"index":"property"} to parent of type ${E.type}`);else{if(v===void 0)throw new Error("Can not delete in empty document");return O(S,{offset:D?D.offset:0,length:D?D.length:0,content:JSON.stringify(v)},h)}}e.setProperty=A;function O(S,n,v){let h=P(S,n),C=n.offset,f=n.offset+n.content.length;if(n.length===0||n.content.length===0){for(;C>0&&!R.isEOL(h,C-1);)C--;for(;f<h.length&&!R.isEOL(h,f);)f++}const I=R.format(h,{offset:C,length:f-C},v);for(let E=I.length-1;E>=0;E--){const b=I[E];h=P(h,b),C=Math.min(C,b.offset),f=Math.max(f,b.offset+b.length),f+=b.content.length-b.length}const D=S.length-(h.length-f)-C;return[{offset:C,length:D,content:h.substring(C,f)}]}e.withFormatting=O;function P(S,n){return S.substring(0,n.offset)+n.content+S.substring(n.offset+n.length)}e.applyEdit=P;function p(S,n){let v=n.slice(0).sort((C,f)=>{const I=C.offset-f.offset;return I===0?C.length-f.length:I}),h=S.length;for(let C=v.length-1;C>=0;C--){let f=v[C];if(f.offset+f.length<=h)S=P(S,f);else throw new Error("Overlapping edit");h=f.offset}return S}e.applyEdits=p}),define(Z[2],ee([0,1,65,53]),function(H,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const L=!1;let A=null;function O(g){A=g}if(e.setDisposableTracker=O,L){const g="__is_disposable_tracked__";A=new class{trackDisposable(o){const s=new Error("Potentially leaked disposable").stack;setTimeout(()=>{o[g]||console.log(s)},3e3)}markTracked(o){if(o&&o!==I.None)try{o[g]=!0}catch(s){}}}}function P(g){!A||A.markTracked(g)}function p(g){return A&&A.trackDisposable(g),g}e.trackDisposable=p;class S extends Error{constructor(o){super(`Encountered errors while disposing of store. Errors: [${o.join(", ")}]`);this.errors=o}}e.MultiDisposeError=S;function n(g){return typeof g.dispose=="function"&&g.dispose.length===0}e.isDisposable=n;function v(g){if(R.Iterable.is(g)){let o=[];for(const s of g)if(s){P(s);try{s.dispose()}catch(t){o.push(t)}}if(o.length===1)throw o[0];if(o.length>1)throw new S(o);return Array.isArray(g)?[]:g}else if(g)return P(g),g.dispose(),g}e.dispose=v;function h(...g){return g.forEach(P),C(()=>v(g))}e.combinedDisposable=h;function C(g){const o=p({dispose:()=>{P(o),g()}});return o}e.toDisposable=C;class f{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(P(this),this._isDisposed=!0,this.clear())}clear(){try{v(this._toDispose.values())}finally{this._toDispose.clear()}}add(o){if(!o)return o;if(o===this)throw new Error("Cannot register a disposable on itself!");return P(o),this._isDisposed?f.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(o),o}}e.DisposableStore=f,f.DISABLE_DISPOSED_WARNING=!1;class I{constructor(){this._store=new f,p(this)}dispose(){P(this),this._store.dispose()}_register(o){if(o===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(o)}}e.Disposable=I,I.None=Object.freeze({dispose(){}});class D{constructor(){this._isDisposed=!1,p(this)}get value(){return this._isDisposed?void 0:this._value}set value(o){var s;this._isDisposed||o===this._value||((s=this._value)===null||s===void 0||s.dispose(),o&&P(o),this._value=o)}clear(){this.value=void 0}dispose(){var o;this._isDisposed=!0,P(this),(o=this._value)===null||o===void 0||o.dispose(),this._value=void 0}}e.MutableDisposable=D;class E{constructor(){this.references=new Map}acquire(o,...s){let t=this.references.get(o);t||(t={counter:0,object:this.createReferencedObject(o,...s)},this.references.set(o,t));const{object:r}=t,i=y.once(()=>{--t.counter==0&&(this.destroyReferencedObject(o,t.object),this.references.delete(o))});return t.counter++,{object:r,dispose:i}}}e.ReferenceCollection=E;class b{constructor(o){this.object=o}dispose(){}}e.ImmortalReference=b}),define(Z[66],ee([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class y{constructor(A){this.element=A,this.next=y.Undefined,this.prev=y.Undefined}}y.Undefined=new y(void 0);class R{constructor(){this._first=y.Undefined,this._last=y.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===y.Undefined}clear(){let A=this._first;for(;A!==y.Undefined;){const O=A.next;A.prev=y.Undefined,A.next=y.Undefined,A=O}this._first=y.Undefined,this._last=y.Undefined,this._size=0}unshift(A){return this._insert(A,!1)}push(A){return this._insert(A,!0)}_insert(A,O){const P=new y(A);if(this._first===y.Undefined)this._first=P,this._last=P;else if(O){const S=this._last;this._last=P,P.prev=S,S.next=P}else{const S=this._first;this._first=P,P.next=S,S.prev=P}this._size+=1;let p=!1;return()=>{p||(p=!0,this._remove(P))}}shift(){if(this._first!==y.Undefined){const A=this._first.element;return this._remove(this._first),A}}pop(){if(this._last!==y.Undefined){const A=this._last.element;return this._remove(this._last),A}}_remove(A){if(A.prev!==y.Undefined&&A.next!==y.Undefined){const O=A.prev;O.next=A.next,A.next.prev=O}else A.prev===y.Undefined&&A.next===y.Undefined?(this._first=y.Undefined,this._last=y.Undefined):A.next===y.Undefined?(this._last=this._last.prev,this._last.next=y.Undefined):A.prev===y.Undefined&&(this._first=this._first.next,this._first.prev=y.Undefined);this._size-=1}*[Symbol.iterator](){let A=this._first;for(;A!==y.Undefined;)yield A.element,A=A.next}}e.LinkedList=R}),function(){function H(L){const A=[];typeof L=="number"&&A.push("code/timeOrigin",L);function O(p){A.push(p,Date.now())}function P(){const p=[];for(let S=0;S<A.length;S+=2)p.push({name:A[S],startTime:A[S+1]});return p}return{mark:O,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?H():{mark(L){performance.mark(L)},getMarks(){let L=performance.timeOrigin;typeof L!="number"&&(L=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(L)}];for(const O of performance.getEntriesByType("mark"))A.push({name:O.name,startTime:Math.round(L+O.startTime)});return A}};if(typeof process=="object"){const L=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return H(L)}else return console.trace("perf-util loaded in UNKNOWN environment"),H()}function y(L){return L.MonacoPerformanceMarks||(L.MonacoPerformanceMarks=e()),L.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return y(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=y(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=y(R))}(),define(Z[6],ee([0,1]),function(H,e){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const R="en";let L=!1,A=!1,O=!1,P=!1,p=!1,S=!1,n=!1,v,h=R,C,f;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let I;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?I=e.globals.vscode.process:typeof process!="undefined"&&(I=process);const D=typeof((y=I==null?void 0:I.versions)===null||y===void 0?void 0:y.electron)=="string"&&I.type==="renderer";if(e.isElectronSandboxed=D&&(I==null?void 0:I.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const a=I==null?void 0:I.env.VSCODE_BROWSER_CODE_LOADING;if(typeof a=="string")return a==="none"||a==="code"||a==="bypassHeatCheck"||a==="bypassHeatCheckAndEagerCompile"?a:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!D)f=navigator.userAgent,L=f.indexOf("Windows")>=0,A=f.indexOf("Macintosh")>=0,n=(f.indexOf("Macintosh")>=0||f.indexOf("iPad")>=0||f.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,O=f.indexOf("Linux")>=0,S=!0,v=navigator.language,h=v;else if(typeof I=="object"){L=I.platform==="win32",A=I.platform==="darwin",O=I.platform==="linux",P=O&&!!I.env.SNAP&&!!I.env.SNAP_REVISION,v=R,h=R;const a=I.env.VSCODE_NLS_CONFIG;if(a)try{const c=JSON.parse(a),u=c.availableLanguages["*"];v=c.locale,h=u||R,C=c._translationsConfigFile}catch(c){}p=!0}else console.error("Unable to resolve platform.");var E;(function(a){a[a.Web=0]="Web",a[a.Mac=1]="Mac",a[a.Linux=2]="Linux",a[a.Windows=3]="Windows"})(E=e.Platform||(e.Platform={}));function b(a){switch(a){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=b;let g=0;A?g=1:L?g=3:O&&(g=2),e.isWindows=L,e.isMacintosh=A,e.isLinux=O,e.isLinuxSnap=P,e.isNative=p,e.isWeb=S,e.isIOS=n,e.platform=g,e.userAgent=f,e.language=h;var o;(function(a){function c(){return e.language}a.value=c;function u(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}a.isDefaultVariant=u;function l(){return e.language==="en"}a.isDefault=l})(o=e.Language||(e.Language={})),e.locale=v,e.translationsConfigFile=C,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let u=[];e.globals.addEventListener("message",m=>{if(m.data&&m.data.vscodeSetImmediateId)for(let w=0,d=u.length;w<d;w++){const T=u[w];if(T.id===m.data.vscodeSetImmediateId){u.splice(w,1),T.callback();return}}});let l=0;return m=>{const w=++l;u.push({id:w,callback:m}),e.globals.postMessage({vscodeSetImmediateId:w},"*")}}if(typeof(I==null?void 0:I.nextTick)=="function")return I.nextTick.bind(I);const c=Promise.resolve();return u=>c.then(u)}();var s;(function(a){a[a.Windows=1]="Windows",a[a.Macintosh=2]="Macintosh",a[a.Linux=3]="Linux"})(s=e.OperatingSystem||(e.OperatingSystem={})),e.OS=A||n?2:L?1:3;let t=!0,r=!1;function i(){if(!r){r=!0;const a=new Uint8Array(2);a[0]=1,a[1]=2,t=new Uint16Array(a.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=i}),define(Z[34],ee([0,1,6]),function(H,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let R;if(typeof y.globals.vscode!="undefined"&&typeof y.globals.vscode.process!="undefined"){const L=y.globals.vscode.process;R={get platform(){return L.platform},get env(){return L.env},cwd(){return L.cwd()},nextTick(A){return y.setImmediate(A)}}}else typeof process!="undefined"?R={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(L){return process.nextTick(L)}}:R={get platform(){return y.isWindows?"win32":y.isMacintosh?"darwin":"linux"},nextTick(L){return y.setImmediate(L)},get env(){return{}},cwd(){return"/"}};e.cwd=R.cwd,e.env=R.env,e.platform=R.platform,e.nextTick=R.nextTick}),define(Z[7],ee([0,1,34]),function(H,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const R=65,L=97,A=90,O=122,P=46,p=47,S=92,n=58,v=63;class h extends Error{constructor(o,s,t){let r;typeof s=="string"&&s.indexOf("not ")===0?(r="must not be",s=s.replace(/^not /,"")):r="must be";const i=o.indexOf(".")!==-1?"property":"argument";let a=`The "${o}" ${i} ${r} of type ${s}`;a+=`. Received type ${typeof t}`,super(a),this.code="ERR_INVALID_ARG_TYPE"}}function C(g,o){if(typeof g!="string")throw new h(o,"string",g)}function f(g){return g===p||g===S}function I(g){return g===p}function D(g){return g>=R&&g<=A||g>=L&&g<=O}function E(g,o,s,t){let r="",i=0,a=-1,c=0,u=0;for(let l=0;l<=g.length;++l){if(l<g.length)u=g.charCodeAt(l);else{if(t(u))break;u=p}if(t(u)){if(!(a===l-1||c===1))if(c===2){if(r.length<2||i!==2||r.charCodeAt(r.length-1)!==P||r.charCodeAt(r.length-2)!==P){if(r.length>2){const m=r.lastIndexOf(s);m===-1?(r="",i=0):(r=r.slice(0,m),i=r.length-1-r.lastIndexOf(s)),a=l,c=0;continue}else if(r.length!==0){r="",i=0,a=l,c=0;continue}}o&&(r+=r.length>0?`${s}..`:"..",i=2)}else r.length>0?r+=`${s}${g.slice(a+1,l)}`:r=g.slice(a+1,l),i=l-a-1;a=l,c=0}else u===P&&c!==-1?++c:c=-1}return r}function b(g,o){if(o===null||typeof o!="object")throw new h("pathObject","Object",o);const s=o.dir||o.root,t=o.base||`${o.name||""}${o.ext||""}`;return s?s===o.root?`${s}${t}`:`${s}${g}${t}`:t}e.win32={resolve(...g){let o="",s="",t=!1;for(let r=g.length-1;r>=-1;r--){let i;if(r>=0){if(i=g[r],C(i,"path"),i.length===0)continue}else o.length===0?i=y.cwd():(i=y.env[`=${o}`]||y.cwd(),(i===void 0||i.slice(0,2).toLowerCase()!==o.toLowerCase()&&i.charCodeAt(2)===S)&&(i=`${o}\\`));const a=i.length;let c=0,u="",l=!1;const m=i.charCodeAt(0);if(a===1)f(m)&&(c=1,l=!0);else if(f(m))if(l=!0,f(i.charCodeAt(1))){let w=2,d=w;for(;w<a&&!f(i.charCodeAt(w));)w++;if(w<a&&w!==d){const T=i.slice(d,w);for(d=w;w<a&&f(i.charCodeAt(w));)w++;if(w<a&&w!==d){for(d=w;w<a&&!f(i.charCodeAt(w));)w++;(w===a||w!==d)&&(u=`\\\\${T}\\${i.slice(d,w)}`,c=w)}}}else c=1;else D(m)&&i.charCodeAt(1)===n&&(u=i.slice(0,2),c=2,a>2&&f(i.charCodeAt(2))&&(l=!0,c=3));if(u.length>0)if(o.length>0){if(u.toLowerCase()!==o.toLowerCase())continue}else o=u;if(t){if(o.length>0)break}else if(s=`${i.slice(c)}\\${s}`,t=l,l&&o.length>0)break}return s=E(s,!t,"\\",f),t?`${o}\\${s}`:`${o}${s}`||"."},normalize(g){C(g,"path");const o=g.length;if(o===0)return".";let s=0,t,r=!1;const i=g.charCodeAt(0);if(o===1)return I(i)?"\\":g;if(f(i))if(r=!0,f(g.charCodeAt(1))){let c=2,u=c;for(;c<o&&!f(g.charCodeAt(c));)c++;if(c<o&&c!==u){const l=g.slice(u,c);for(u=c;c<o&&f(g.charCodeAt(c));)c++;if(c<o&&c!==u){for(u=c;c<o&&!f(g.charCodeAt(c));)c++;if(c===o)return`\\\\${l}\\${g.slice(u)}\\`;c!==u&&(t=`\\\\${l}\\${g.slice(u,c)}`,s=c)}}}else s=1;else D(i)&&g.charCodeAt(1)===n&&(t=g.slice(0,2),s=2,o>2&&f(g.charCodeAt(2))&&(r=!0,s=3));let a=s<o?E(g.slice(s),!r,"\\",f):"";return a.length===0&&!r&&(a="."),a.length>0&&f(g.charCodeAt(o-1))&&(a+="\\"),t===void 0?r?`\\${a}`:a:r?`${t}\\${a}`:`${t}${a}`},isAbsolute(g){C(g,"path");const o=g.length;if(o===0)return!1;const s=g.charCodeAt(0);return f(s)||o>2&&D(s)&&g.charCodeAt(1)===n&&f(g.charCodeAt(2))},join(...g){if(g.length===0)return".";let o,s;for(let i=0;i<g.length;++i){const a=g[i];C(a,"path"),a.length>0&&(o===void 0?o=s=a:o+=`\\${a}`)}if(o===void 0)return".";let t=!0,r=0;if(typeof s=="string"&&f(s.charCodeAt(0))){++r;const i=s.length;i>1&&f(s.charCodeAt(1))&&(++r,i>2&&(f(s.charCodeAt(2))?++r:t=!1))}if(t){for(;r<o.length&&f(o.charCodeAt(r));)r++;r>=2&&(o=`\\${o.slice(r)}`)}return e.win32.normalize(o)},relative(g,o){if(C(g,"from"),C(o,"to"),g===o)return"";const s=e.win32.resolve(g),t=e.win32.resolve(o);if(s===t||(g=s.toLowerCase(),o=t.toLowerCase(),g===o))return"";let r=0;for(;r<g.length&&g.charCodeAt(r)===S;)r++;let i=g.length;for(;i-1>r&&g.charCodeAt(i-1)===S;)i--;const a=i-r;let c=0;for(;c<o.length&&o.charCodeAt(c)===S;)c++;let u=o.length;for(;u-1>c&&o.charCodeAt(u-1)===S;)u--;const l=u-c,m=a<l?a:l;let w=-1,d=0;for(;d<m;d++){const _=g.charCodeAt(r+d);if(_!==o.charCodeAt(c+d))break;_===S&&(w=d)}if(d!==m){if(w===-1)return t}else{if(l>m){if(o.charCodeAt(c+d)===S)return t.slice(c+d+1);if(d===2)return t.slice(c+d)}a>m&&(g.charCodeAt(r+d)===S?w=d:d===2&&(w=3)),w===-1&&(w=0)}let T="";for(d=r+w+1;d<=i;++d)(d===i||g.charCodeAt(d)===S)&&(T+=T.length===0?"..":"\\..");return c+=w,T.length>0?`${T}${t.slice(c,u)}`:(t.charCodeAt(c)===S&&++c,t.slice(c,u))},toNamespacedPath(g){if(typeof g!="string")return g;if(g.length===0)return"";const o=e.win32.resolve(g);if(o.length<=2)return g;if(o.charCodeAt(0)===S){if(o.charCodeAt(1)===S){const s=o.charCodeAt(2);if(s!==v&&s!==P)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(D(o.charCodeAt(0))&&o.charCodeAt(1)===n&&o.charCodeAt(2)===S)return`\\\\?\\${o}`;return g},dirname(g){C(g,"path");const o=g.length;if(o===0)return".";let s=-1,t=0;const r=g.charCodeAt(0);if(o===1)return f(r)?g:".";if(f(r)){if(s=t=1,f(g.charCodeAt(1))){let c=2,u=c;for(;c<o&&!f(g.charCodeAt(c));)c++;if(c<o&&c!==u){for(u=c;c<o&&f(g.charCodeAt(c));)c++;if(c<o&&c!==u){for(u=c;c<o&&!f(g.charCodeAt(c));)c++;if(c===o)return g;c!==u&&(s=t=c+1)}}}}else D(r)&&g.charCodeAt(1)===n&&(s=o>2&&f(g.charCodeAt(2))?3:2,t=s);let i=-1,a=!0;for(let c=o-1;c>=t;--c)if(f(g.charCodeAt(c))){if(!a){i=c;break}}else a=!1;if(i===-1){if(s===-1)return".";i=s}return g.slice(0,i)},basename(g,o){o!==void 0&&C(o,"ext"),C(g,"path");let s=0,t=-1,r=!0,i;if(g.length>=2&&D(g.charCodeAt(0))&&g.charCodeAt(1)===n&&(s=2),o!==void 0&&o.length>0&&o.length<=g.length){if(o===g)return"";let a=o.length-1,c=-1;for(i=g.length-1;i>=s;--i){const u=g.charCodeAt(i);if(f(u)){if(!r){s=i+1;break}}else c===-1&&(r=!1,c=i+1),a>=0&&(u===o.charCodeAt(a)?--a==-1&&(t=i):(a=-1,t=c))}return s===t?t=c:t===-1&&(t=g.length),g.slice(s,t)}for(i=g.length-1;i>=s;--i)if(f(g.charCodeAt(i))){if(!r){s=i+1;break}}else t===-1&&(r=!1,t=i+1);return t===-1?"":g.slice(s,t)},extname(g){C(g,"path");let o=0,s=-1,t=0,r=-1,i=!0,a=0;g.length>=2&&g.charCodeAt(1)===n&&D(g.charCodeAt(0))&&(o=t=2);for(let c=g.length-1;c>=o;--c){const u=g.charCodeAt(c);if(f(u)){if(!i){t=c+1;break}continue}r===-1&&(i=!1,r=c+1),u===P?s===-1?s=c:a!==1&&(a=1):s!==-1&&(a=-1)}return s===-1||r===-1||a===0||a===1&&s===r-1&&s===t+1?"":g.slice(s,r)},format:b.bind(null,"\\"),parse(g){C(g,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(g.length===0)return o;const s=g.length;let t=0,r=g.charCodeAt(0);if(s===1)return f(r)?(o.root=o.dir=g,o):(o.base=o.name=g,o);if(f(r)){if(t=1,f(g.charCodeAt(1))){let w=2,d=w;for(;w<s&&!f(g.charCodeAt(w));)w++;if(w<s&&w!==d){for(d=w;w<s&&f(g.charCodeAt(w));)w++;if(w<s&&w!==d){for(d=w;w<s&&!f(g.charCodeAt(w));)w++;w===s?t=w:w!==d&&(t=w+1)}}}}else if(D(r)&&g.charCodeAt(1)===n){if(s<=2)return o.root=o.dir=g,o;if(t=2,f(g.charCodeAt(2))){if(s===3)return o.root=o.dir=g,o;t=3}}t>0&&(o.root=g.slice(0,t));let i=-1,a=t,c=-1,u=!0,l=g.length-1,m=0;for(;l>=t;--l){if(r=g.charCodeAt(l),f(r)){if(!u){a=l+1;break}continue}c===-1&&(u=!1,c=l+1),r===P?i===-1?i=l:m!==1&&(m=1):i!==-1&&(m=-1)}return c!==-1&&(i===-1||m===0||m===1&&i===c-1&&i===a+1?o.base=o.name=g.slice(a,c):(o.name=g.slice(a,i),o.base=g.slice(a,c),o.ext=g.slice(i,c))),a>0&&a!==t?o.dir=g.slice(0,a-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...g){let o="",s=!1;for(let t=g.length-1;t>=-1&&!s;t--){const r=t>=0?g[t]:y.cwd();C(r,"path"),r.length!==0&&(o=`${r}/${o}`,s=r.charCodeAt(0)===p)}return o=E(o,!s,"/",I),s?`/${o}`:o.length>0?o:"."},normalize(g){if(C(g,"path"),g.length===0)return".";const o=g.charCodeAt(0)===p,s=g.charCodeAt(g.length-1)===p;return g=E(g,!o,"/",I),g.length===0?o?"/":s?"./":".":(s&&(g+="/"),o?`/${g}`:g)},isAbsolute(g){return C(g,"path"),g.length>0&&g.charCodeAt(0)===p},join(...g){if(g.length===0)return".";let o;for(let s=0;s<g.length;++s){const t=g[s];C(t,"path"),t.length>0&&(o===void 0?o=t:o+=`/${t}`)}return o===void 0?".":e.posix.normalize(o)},relative(g,o){if(C(g,"from"),C(o,"to"),g===o||(g=e.posix.resolve(g),o=e.posix.resolve(o),g===o))return"";const s=1,t=g.length,r=t-s,i=1,a=o.length-i,c=r<a?r:a;let u=-1,l=0;for(;l<c;l++){const w=g.charCodeAt(s+l);if(w!==o.charCodeAt(i+l))break;w===p&&(u=l)}if(l===c)if(a>c){if(o.charCodeAt(i+l)===p)return o.slice(i+l+1);if(l===0)return o.slice(i+l)}else r>c&&(g.charCodeAt(s+l)===p?u=l:l===0&&(u=0));let m="";for(l=s+u+1;l<=t;++l)(l===t||g.charCodeAt(l)===p)&&(m+=m.length===0?"..":"/..");return`${m}${o.slice(i+u)}`},toNamespacedPath(g){return g},dirname(g){if(C(g,"path"),g.length===0)return".";const o=g.charCodeAt(0)===p;let s=-1,t=!0;for(let r=g.length-1;r>=1;--r)if(g.charCodeAt(r)===p){if(!t){s=r;break}}else t=!1;return s===-1?o?"/":".":o&&s===1?"//":g.slice(0,s)},basename(g,o){o!==void 0&&C(o,"ext"),C(g,"path");let s=0,t=-1,r=!0,i;if(o!==void 0&&o.length>0&&o.length<=g.length){if(o===g)return"";let a=o.length-1,c=-1;for(i=g.length-1;i>=0;--i){const u=g.charCodeAt(i);if(u===p){if(!r){s=i+1;break}}else c===-1&&(r=!1,c=i+1),a>=0&&(u===o.charCodeAt(a)?--a==-1&&(t=i):(a=-1,t=c))}return s===t?t=c:t===-1&&(t=g.length),g.slice(s,t)}for(i=g.length-1;i>=0;--i)if(g.charCodeAt(i)===p){if(!r){s=i+1;break}}else t===-1&&(r=!1,t=i+1);return t===-1?"":g.slice(s,t)},extname(g){C(g,"path");let o=-1,s=0,t=-1,r=!0,i=0;for(let a=g.length-1;a>=0;--a){const c=g.charCodeAt(a);if(c===p){if(!r){s=a+1;break}continue}t===-1&&(r=!1,t=a+1),c===P?o===-1?o=a:i!==1&&(i=1):o!==-1&&(i=-1)}return o===-1||t===-1||i===0||i===1&&o===t-1&&o===s+1?"":g.slice(o,t)},format:b.bind(null,"/"),parse(g){C(g,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(g.length===0)return o;const s=g.charCodeAt(0)===p;let t;s?(o.root="/",t=1):t=0;let r=-1,i=0,a=-1,c=!0,u=g.length-1,l=0;for(;u>=t;--u){const m=g.charCodeAt(u);if(m===p){if(!c){i=u+1;break}continue}a===-1&&(c=!1,a=u+1),m===P?r===-1?r=u:l!==1&&(l=1):r!==-1&&(l=-1)}if(a!==-1){const m=i===0&&s?1:i;r===-1||l===0||l===1&&r===a-1&&r===i+1?o.base=o.name=g.slice(m,a):(o.name=g.slice(m,r),o.base=g.slice(m,a),o.ext=g.slice(r,a))}return i>0?o.dir=g.slice(0,i-1):s&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=y.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=y.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=y.platform==="win32"?e.win32.join:e.posix.join,e.resolve=y.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=y.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=y.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=y.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=y.platform==="win32"?e.win32.extname:e.posix.extname,e.format=y.platform==="win32"?e.win32.format:e.posix.format,e.parse=y.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=y.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=y.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=y.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),function(H,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var y=e();for(var R in y)(typeof exports=="object"?exports:H)[R]=y[R]}}(typeof self!="undefined"?self:this,function(){return function(H){var e={};function y(R){if(e[R])return e[R].exports;var L=e[R]={i:R,l:!1,exports:{}};return H[R].call(L.exports,L,L.exports,y),L.l=!0,L.exports}return y.m=H,y.c=e,y.d=function(R,L,A){y.o(R,L)||Object.defineProperty(R,L,{enumerable:!0,get:A})},y.r=function(R){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(R,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(R,"__esModule",{value:!0})},y.t=function(R,L){if(1&L&&(R=y(R)),8&L||4&L&&typeof R=="object"&&R&&R.__esModule)return R;var A=Object.create(null);if(y.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:R}),2&L&&typeof R!="string")for(var O in R)y.d(A,O,function(P){return R[P]}.bind(null,O));return A},y.n=function(R){var L=R&&R.__esModule?function(){return R.default}:function(){return R};return y.d(L,"a",L),L},y.o=function(R,L){return Object.prototype.hasOwnProperty.call(R,L)},y.p="",y(y.s=0)}([function(H,e,y){(function(R){var L;e=H.exports=X,L=typeof R=="object"&&R.env&&R.env.NODE_DEBUG&&/\bsemver\b/i.test(R.env.NODE_DEBUG)?function(){var J=Array.prototype.slice.call(arguments,0);J.unshift("SEMVER"),console.log.apply(console,J)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,O=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],p=e.src=[],S=0,n=S++;p[n]="0|[1-9]\\d*";var v=S++;p[v]="[0-9]+";var h=S++;p[h]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var C=S++;p[C]="("+p[n]+")\\.("+p[n]+")\\.("+p[n]+")";var f=S++;p[f]="("+p[v]+")\\.("+p[v]+")\\.("+p[v]+")";var I=S++;p[I]="(?:"+p[n]+"|"+p[h]+")";var D=S++;p[D]="(?:"+p[v]+"|"+p[h]+")";var E=S++;p[E]="(?:-("+p[I]+"(?:\\."+p[I]+")*))";var b=S++;p[b]="(?:-?("+p[D]+"(?:\\."+p[D]+")*))";var g=S++;p[g]="[0-9A-Za-z-]+";var o=S++;p[o]="(?:\\+("+p[g]+"(?:\\."+p[g]+")*))";var s=S++,t="v?"+p[C]+p[E]+"?"+p[o]+"?";p[s]="^"+t+"$";var r="[v=\\s]*"+p[f]+p[b]+"?"+p[o]+"?",i=S++;p[i]="^"+r+"$";var a=S++;p[a]="((?:<|>)?=?)";var c=S++;p[c]=p[v]+"|x|X|\\*";var u=S++;p[u]=p[n]+"|x|X|\\*";var l=S++;p[l]="[v=\\s]*("+p[u]+")(?:\\.("+p[u]+")(?:\\.("+p[u]+")(?:"+p[E]+")?"+p[o]+"?)?)?";var m=S++;p[m]="[v=\\s]*("+p[c]+")(?:\\.("+p[c]+")(?:\\.("+p[c]+")(?:"+p[b]+")?"+p[o]+"?)?)?";var w=S++;p[w]="^"+p[a]+"\\s*"+p[l]+"$";var d=S++;p[d]="^"+p[a]+"\\s*"+p[m]+"$";var T=S++;p[T]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var _=S++;p[_]="(?:~>?)";var j=S++;p[j]="(\\s*)"+p[_]+"\\s+",P[j]=new RegExp(p[j],"g");var $=S++;p[$]="^"+p[_]+p[l]+"$";var K=S++;p[K]="^"+p[_]+p[m]+"$";var B=S++;p[B]="(?:\\^)";var z=S++;p[z]="(\\s*)"+p[B]+"\\s+",P[z]=new RegExp(p[z],"g");var G=S++;p[G]="^"+p[B]+p[l]+"$";var V=S++;p[V]="^"+p[B]+p[m]+"$";var M=S++;p[M]="^"+p[a]+"\\s*("+r+")$|^$";var U=S++;p[U]="^"+p[a]+"\\s*("+t+")$|^$";var k=S++;p[k]="(\\s*)"+p[a]+"\\s*("+r+"|"+p[l]+")",P[k]=new RegExp(p[k],"g");var F=S++;p[F]="^\\s*("+p[l]+")\\s+-\\s+("+p[l]+")\\s*$";var N=S++;p[N]="^\\s*("+p[m]+")\\s+-\\s+("+p[m]+")\\s*$";var q=S++;p[q]="(<|>)?=?\\s*\\*";for(var W=0;W<35;W++)L(W,p[W]),P[W]||(P[W]=new RegExp(p[W]));function Q(J,re){if(J instanceof X)return J;if(typeof J!="string"||J.length>A||!(re?P[i]:P[s]).test(J))return null;try{return new X(J,re)}catch(se){return null}}function X(J,re){if(J instanceof X){if(J.loose===re)return J;J=J.version}else if(typeof J!="string")throw new TypeError("Invalid Version: "+J);if(J.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof X))return new X(J,re);L("SemVer",J,re),this.loose=re;var se=J.trim().match(re?P[i]:P[s]);if(!se)throw new TypeError("Invalid Version: "+J);if(this.raw=J,this.major=+se[1],this.minor=+se[2],this.patch=+se[3],this.major>O||this.major<0)throw new TypeError("Invalid major version");if(this.minor>O||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>O||this.patch<0)throw new TypeError("Invalid patch version");se[4]?this.prerelease=se[4].split(".").map(function(me){if(/^[0-9]+$/.test(me)){var Se=+me;if(Se>=0&&Se<O)return Se}return me}):this.prerelease=[],this.build=se[5]?se[5].split("."):[],this.format()}e.parse=Q,e.valid=function(J,re){var se=Q(J,re);return se?se.version:null},e.clean=function(J,re){var se=Q(J.trim().replace(/^[=v]+/,""),re);return se?se.version:null},e.SemVer=X,X.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},X.prototype.toString=function(){return this.version},X.prototype.compare=function(J){return L("SemVer.compare",this.version,this.loose,J),J instanceof X||(J=new X(J,this.loose)),this.compareMain(J)||this.comparePre(J)},X.prototype.compareMain=function(J){return J instanceof X||(J=new X(J,this.loose)),ne(this.major,J.major)||ne(this.minor,J.minor)||ne(this.patch,J.patch)},X.prototype.comparePre=function(J){if(J instanceof X||(J=new X(J,this.loose)),this.prerelease.length&&!J.prerelease.length)return-1;if(!this.prerelease.length&&J.prerelease.length)return 1;if(!this.prerelease.length&&!J.prerelease.length)return 0;var re=0;do{var se=this.prerelease[re],me=J.prerelease[re];if(L("prerelease compare",re,se,me),se===void 0&&me===void 0)return 0;if(me===void 0)return 1;if(se===void 0)return-1;if(se!==me)return ne(se,me)}while(++re)},X.prototype.inc=function(J,re){switch(J){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",re);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",re);break;case"prepatch":this.prerelease.length=0,this.inc("patch",re),this.inc("pre",re);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",re),this.inc("pre",re);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var se=this.prerelease.length;--se>=0;)typeof this.prerelease[se]=="number"&&(this.prerelease[se]++,se=-2);se===-1&&this.prerelease.push(0)}re&&(this.prerelease[0]===re?isNaN(this.prerelease[1])&&(this.prerelease=[re,0]):this.prerelease=[re,0]);break;default:throw new Error("invalid increment argument: "+J)}return this.format(),this.raw=this.version,this},e.inc=function(J,re,se,me){typeof se=="string"&&(me=se,se=void 0);try{return new X(J,se).inc(re,me).version}catch(Se){return null}},e.diff=function(J,re){if(pe(J,re))return null;var se=Q(J),me=Q(re);if(se.prerelease.length||me.prerelease.length){for(var Se in se)if((Se==="major"||Se==="minor"||Se==="patch")&&se[Se]!==me[Se])return"pre"+Se;return"prerelease"}for(var Se in se)if((Se==="major"||Se==="minor"||Se==="patch")&&se[Se]!==me[Se])return Se},e.compareIdentifiers=ne;var ie=/^[0-9]+$/;function ne(J,re){var se=ie.test(J),me=ie.test(re);return se&&me&&(J=+J,re=+re),se&&!me?-1:me&&!se?1:J<re?-1:J>re?1:0}function ce(J,re,se){return new X(J,se).compare(new X(re,se))}function le(J,re,se){return ce(J,re,se)>0}function ve(J,re,se){return ce(J,re,se)<0}function pe(J,re,se){return ce(J,re,se)===0}function Ce(J,re,se){return ce(J,re,se)!==0}function Ae(J,re,se){return ce(J,re,se)>=0}function _e(J,re,se){return ce(J,re,se)<=0}function Oe(J,re,se,me){var Se;switch(re){case"===":typeof J=="object"&&(J=J.version),typeof se=="object"&&(se=se.version),Se=J===se;break;case"!==":typeof J=="object"&&(J=J.version),typeof se=="object"&&(se=se.version),Se=J!==se;break;case"":case"=":case"==":Se=pe(J,se,me);break;case"!=":Se=Ce(J,se,me);break;case">":Se=le(J,se,me);break;case">=":Se=Ae(J,se,me);break;case"<":Se=ve(J,se,me);break;case"<=":Se=_e(J,se,me);break;default:throw new TypeError("Invalid operator: "+re)}return Se}function ke(J,re){if(J instanceof ke){if(J.loose===re)return J;J=J.value}if(!(this instanceof ke))return new ke(J,re);L("comparator",J,re),this.loose=re,this.parse(J),this.semver===je?this.value="":this.value=this.operator+this.semver.version,L("comp",this)}e.rcompareIdentifiers=function(J,re){return ne(re,J)},e.major=function(J,re){return new X(J,re).major},e.minor=function(J,re){return new X(J,re).minor},e.patch=function(J,re){return new X(J,re).patch},e.compare=ce,e.compareLoose=function(J,re){return ce(J,re,!0)},e.rcompare=function(J,re,se){return ce(re,J,se)},e.sort=function(J,re){return J.sort(function(se,me){return e.compare(se,me,re)})},e.rsort=function(J,re){return J.sort(function(se,me){return e.rcompare(se,me,re)})},e.gt=le,e.lt=ve,e.eq=pe,e.neq=Ce,e.gte=Ae,e.lte=_e,e.cmp=Oe,e.Comparator=ke;var je={};function Ie(J,re){if(J instanceof Ie)return J.loose===re?J:new Ie(J.raw,re);if(J instanceof ke)return new Ie(J.value,re);if(!(this instanceof Ie))return new Ie(J,re);if(this.loose=re,this.raw=J,this.set=J.split(/\s*\|\|\s*/).map(function(se){return this.parseRange(se.trim())},this).filter(function(se){return se.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+J);this.format()}function Te(J){return!J||J.toLowerCase()==="x"||J==="*"}function Ke(J,re,se,me,Se,Pe,be,Ue,De,x,te,ae,oe){return((re=Te(se)?"":Te(me)?">="+se+".0.0":Te(Se)?">="+se+"."+me+".0":">="+re)+" "+(Ue=Te(De)?"":Te(x)?"<"+(+De+1)+".0.0":Te(te)?"<"+De+"."+(+x+1)+".0":ae?"<="+De+"."+x+"."+te+"-"+ae:"<="+Ue)).trim()}function Ye(J,re){for(var se=0;se<J.length;se++)if(!J[se].test(re))return!1;if(re.prerelease.length){for(se=0;se<J.length;se++)if(L(J[se].semver),J[se].semver!==je&&J[se].semver.prerelease.length>0){var me=J[se].semver;if(me.major===re.major&&me.minor===re.minor&&me.patch===re.patch)return!0}return!1}return!0}function $e(J,re,se){try{re=new Ie(re,se)}catch(me){return!1}return re.test(J)}function qe(J,re,se,me){var Se,Pe,be,Ue,De;switch(J=new X(J,me),re=new Ie(re,me),se){case">":Se=le,Pe=_e,be=ve,Ue=">",De=">=";break;case"<":Se=ve,Pe=Ae,be=le,Ue="<",De="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if($e(J,re,me))return!1;for(var x=0;x<re.set.length;++x){var te=re.set[x],ae=null,oe=null;if(te.forEach(function(he){he.semver===je&&(he=new ke(">=0.0.0")),ae=ae||he,oe=oe||he,Se(he.semver,ae.semver,me)?ae=he:be(he.semver,oe.semver,me)&&(oe=he)}),ae.operator===Ue||ae.operator===De||(!oe.operator||oe.operator===Ue)&&Pe(J,oe.semver)||oe.operator===De&&be(J,oe.semver))return!1}return!0}ke.prototype.parse=function(J){var re=this.loose?P[M]:P[U],se=J.match(re);if(!se)throw new TypeError("Invalid comparator: "+J);this.operator=se[1],this.operator==="="&&(this.operator=""),se[2]?this.semver=new X(se[2],this.loose):this.semver=je},ke.prototype.toString=function(){return this.value},ke.prototype.test=function(J){return L("Comparator.test",J,this.loose),this.semver===je||(typeof J=="string"&&(J=new X(J,this.loose)),Oe(J,this.operator,this.semver,this.loose))},ke.prototype.intersects=function(J,re){if(!(J instanceof ke))throw new TypeError("a Comparator is required");var se;if(this.operator==="")return se=new Ie(J.value,re),$e(this.value,se,re);if(J.operator==="")return se=new Ie(this.value,re),$e(J.semver,se,re);var me=!(this.operator!==">="&&this.operator!==">"||J.operator!==">="&&J.operator!==">"),Se=!(this.operator!=="<="&&this.operator!=="<"||J.operator!=="<="&&J.operator!=="<"),Pe=this.semver.version===J.semver.version,be=!(this.operator!==">="&&this.operator!=="<="||J.operator!==">="&&J.operator!=="<="),Ue=Oe(this.semver,"<",J.semver,re)&&(this.operator===">="||this.operator===">")&&(J.operator==="<="||J.operator==="<"),De=Oe(this.semver,">",J.semver,re)&&(this.operator==="<="||this.operator==="<")&&(J.operator===">="||J.operator===">");return me||Se||Pe&&be||Ue||De},e.Range=Ie,Ie.prototype.format=function(){return this.range=this.set.map(function(J){return J.join(" ").trim()}).join("||").trim(),this.range},Ie.prototype.toString=function(){return this.range},Ie.prototype.parseRange=function(J){var re=this.loose;J=J.trim(),L("range",J,re);var se=re?P[N]:P[F];J=J.replace(se,Ke),L("hyphen replace",J),J=J.replace(P[k],"$1$2$3"),L("comparator trim",J,P[k]),J=(J=(J=J.replace(P[j],"$1~")).replace(P[z],"$1^")).split(/\s+/).join(" ");var me=re?P[M]:P[U],Se=J.split(" ").map(function(Pe){return function(be,Ue){return L("comp",be),be=function(De,x){return De.trim().split(/\s+/).map(function(te){return function(ae,oe){L("caret",ae,oe);var he=oe?P[V]:P[G];return ae.replace(he,function(ge,fe,ye,we,Ee){var ue;return L("caret",ae,ge,fe,ye,we,Ee),Te(fe)?ue="":Te(ye)?ue=">="+fe+".0.0 <"+(+fe+1)+".0.0":Te(we)?ue=fe==="0"?">="+fe+"."+ye+".0 <"+fe+"."+(+ye+1)+".0":">="+fe+"."+ye+".0 <"+(+fe+1)+".0.0":Ee?(L("replaceCaret pr",Ee),Ee.charAt(0)!=="-"&&(Ee="-"+Ee),ue=fe==="0"?ye==="0"?">="+fe+"."+ye+"."+we+Ee+" <"+fe+"."+ye+"."+(+we+1):">="+fe+"."+ye+"."+we+Ee+" <"+fe+"."+(+ye+1)+".0":">="+fe+"."+ye+"."+we+Ee+" <"+(+fe+1)+".0.0"):(L("no pr"),ue=fe==="0"?ye==="0"?">="+fe+"."+ye+"."+we+" <"+fe+"."+ye+"."+(+we+1):">="+fe+"."+ye+"."+we+" <"+fe+"."+(+ye+1)+".0":">="+fe+"."+ye+"."+we+" <"+(+fe+1)+".0.0"),L("caret return",ue),ue})}(te,x)}).join(" ")}(be,Ue),L("caret",be),be=function(De,x){return De.trim().split(/\s+/).map(function(te){return function(ae,oe){var he=oe?P[K]:P[$];return ae.replace(he,function(ge,fe,ye,we,Ee){var ue;return L("tilde",ae,ge,fe,ye,we,Ee),Te(fe)?ue="":Te(ye)?ue=">="+fe+".0.0 <"+(+fe+1)+".0.0":Te(we)?ue=">="+fe+"."+ye+".0 <"+fe+"."+(+ye+1)+".0":Ee?(L("replaceTilde pr",Ee),Ee.charAt(0)!=="-"&&(Ee="-"+Ee),ue=">="+fe+"."+ye+"."+we+Ee+" <"+fe+"."+(+ye+1)+".0"):ue=">="+fe+"."+ye+"."+we+" <"+fe+"."+(+ye+1)+".0",L("tilde return",ue),ue})}(te,x)}).join(" ")}(be,Ue),L("tildes",be),be=function(De,x){return L("replaceXRanges",De,x),De.split(/\s+/).map(function(te){return function(ae,oe){ae=ae.trim();var he=oe?P[d]:P[w];return ae.replace(he,function(ge,fe,ye,we,Ee,ue){L("xRange",ae,ge,fe,ye,we,Ee,ue);var Re=Te(ye),Fe=Re||Te(we),Me=Fe||Te(Ee);return fe==="="&&Me&&(fe=""),Re?ge=fe===">"||fe==="<"?"<0.0.0":"*":fe&&Me?(Fe&&(we=0),Me&&(Ee=0),fe===">"?(fe=">=",Fe?(ye=+ye+1,we=0,Ee=0):Me&&(we=+we+1,Ee=0)):fe==="<="&&(fe="<",Fe?ye=+ye+1:we=+we+1),ge=fe+ye+"."+we+"."+Ee):Fe?ge=">="+ye+".0.0 <"+(+ye+1)+".0.0":Me&&(ge=">="+ye+"."+we+".0 <"+ye+"."+(+we+1)+".0"),L("xRange return",ge),ge})}(te,x)}).join(" ")}(be,Ue),L("xrange",be),be=function(De,x){return L("replaceStars",De,x),De.trim().replace(P[q],"")}(be,Ue),L("stars",be),be}(Pe,re)}).join(" ").split(/\s+/);return this.loose&&(Se=Se.filter(function(Pe){return!!Pe.match(me)})),Se=Se.map(function(Pe){return new ke(Pe,re)})},Ie.prototype.intersects=function(J,re){if(!(J instanceof Ie))throw new TypeError("a Range is required");return this.set.some(function(se){return se.every(function(me){return J.set.some(function(Se){return Se.every(function(Pe){return me.intersects(Pe,re)})})})})},e.toComparators=function(J,re){return new Ie(J,re).set.map(function(se){return se.map(function(me){return me.value}).join(" ").trim().split(" ")})},Ie.prototype.test=function(J){if(!J)return!1;typeof J=="string"&&(J=new X(J,this.loose));for(var re=0;re<this.set.length;re++)if(Ye(this.set[re],J))return!0;return!1},e.satisfies=$e,e.maxSatisfying=function(J,re,se){var me=null,Se=null;try{var Pe=new Ie(re,se)}catch(be){return null}return J.forEach(function(be){Pe.test(be)&&(me&&Se.compare(be)!==-1||(Se=new X(me=be,se)))}),me},e.minSatisfying=function(J,re,se){var me=null,Se=null;try{var Pe=new Ie(re,se)}catch(be){return null}return J.forEach(function(be){Pe.test(be)&&(me&&Se.compare(be)!==1||(Se=new X(me=be,se)))}),me},e.validRange=function(J,re){try{return new Ie(J,re).range||"*"}catch(se){return null}},e.ltr=function(J,re,se){return qe(J,re,"<",se)},e.gtr=function(J,re,se){return qe(J,re,">",se)},e.outside=qe,e.prerelease=function(J,re){var se=Q(J,re);return se&&se.prerelease.length?se.prerelease:null},e.intersects=function(J,re,se){return J=new Ie(J,se),re=new Ie(re,se),J.intersects(re)},e.coerce=function(J){if(J instanceof X)return J;if(typeof J!="string")return null;var re=J.match(P[T]);return re==null?null:Q((re[1]||"0")+"."+(re[2]||"0")+"."+(re[3]||"0"))}}).call(this,y(1))},function(H,e){var y,R,L=H.exports={};function A(){throw new Error("setTimeout has not been defined")}function O(){throw new Error("clearTimeout has not been defined")}function P(D){if(y===setTimeout)return setTimeout(D,0);if((y===A||!y)&&setTimeout)return y=setTimeout,setTimeout(D,0);try{return y(D,0)}catch(E){try{return y.call(null,D,0)}catch(b){return y.call(this,D,0)}}}(function(){try{y=typeof setTimeout=="function"?setTimeout:A}catch(D){y=A}try{R=typeof clearTimeout=="function"?clearTimeout:O}catch(D){R=O}})();var p,S=[],n=!1,v=-1;function h(){n&&p&&(n=!1,p.length?S=p.concat(S):v=-1,S.length&&C())}function C(){if(!n){var D=P(h);n=!0;for(var E=S.length;E;){for(p=S,S=[];++v<E;)p&&p[v].run();v=-1,E=S.length}p=null,n=!1,function(b){if(R===clearTimeout)return clearTimeout(b);if((R===O||!R)&&clearTimeout)return R=clearTimeout,clearTimeout(b);try{R(b)}catch(g){try{return R.call(null,b)}catch(o){return R.call(this,b)}}}(D)}}function f(D,E){this.fun=D,this.array=E}function I(){}L.nextTick=function(D){var E=new Array(arguments.length-1);if(arguments.length>1)for(var b=1;b<arguments.length;b++)E[b-1]=arguments[b];S.push(new f(D,E)),S.length!==1||n||P(C)},f.prototype.run=function(){this.fun.apply(null,this.array)},L.title="browser",L.browser=!0,L.env={},L.argv=[],L.version="",L.versions={},L.on=I,L.addListener=I,L.once=I,L.off=I,L.removeListener=I,L.removeAllListeners=I,L.emit=I,L.prependListener=I,L.prependOnceListener=I,L.listeners=function(D){return[]},L.binding=function(D){throw new Error("process.binding is not supported")},L.cwd=function(){return"/"},L.chdir=function(D){throw new Error("process.chdir is not supported")},L.umask=function(){return 0}}])}),define(Z[88],ee([0,1,6]),function(H,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const R=y.globals.performance&&typeof y.globals.performance.now=="function";class L{constructor(O){this._highResolution=R&&O,this._startTime=this._now(),this._stopTime=-1}static create(O=!0){return new L(O)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?y.globals.performance.now():Date.now()}}e.StopWatch=L}),define(Z[3],ee([0,1,11,65,2,66,88]),function(H,e,y,R,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var P;(function(E){E.None=()=>L.Disposable.None;function b(B){return(z,G=null,V)=>{let M=!1,U;return U=B(k=>{if(!M)return U?U.dispose():M=!0,z.call(G,k)},null,V),M&&U.dispose(),U}}E.once=b;function g(B,z){return a((G,V=null,M)=>B(U=>G.call(V,z(U)),null,M))}E.map=g;function o(B,z){return a((G,V=null,M)=>B(U=>{z(U),G.call(V,U)},null,M))}E.forEach=o;function s(B,z){return a((G,V=null,M)=>B(U=>z(U)&&G.call(V,U),null,M))}E.filter=s;function t(B){return B}E.signal=t;function r(...B){return(z,G=null,V)=>L.combinedDisposable(...B.map(M=>M(U=>z.call(G,U),null,V)))}E.any=r;function i(B,z,G){let V=G;return g(B,M=>(V=z(V,M),V))}E.reduce=i;function a(B){let z;const G=new h({onFirstListenerAdd(){z=B(G.fire,G)},onLastListenerRemove(){z.dispose()}});return G.event}E.snapshot=a;function c(B,z,G=100,V=!1,M){let U,k,F,N=0;const q=new h({leakWarningThreshold:M,onFirstListenerAdd(){U=B(W=>{N++,k=z(k,W),V&&!F&&(q.fire(k),k=void 0),clearTimeout(F),F=setTimeout(()=>{const Q=k;k=void 0,F=void 0,(!V||N>1)&&q.fire(Q),N=0},G)})},onLastListenerRemove(){U.dispose()}});return q.event}E.debounce=c;function u(B){const z=new Date().getTime();return g(b(B),G=>new Date().getTime()-z)}E.stopwatch=u;function l(B,z=(G,V)=>G===V){let G=!0,V;return s(B,M=>{const U=G||!z(M,V);return G=!1,V=M,U})}E.latch=l;function m(B,z){return[E.filter(B,z),E.filter(B,G=>!z(G))]}E.split=m;function w(B,z=!1,G=[]){let V=G.slice(),M=B(F=>{V?V.push(F):k.fire(F)});const U=()=>{V&&V.forEach(F=>k.fire(F)),V=null},k=new h({onFirstListenerAdd(){M||(M=B(F=>k.fire(F)))},onFirstListenerDidAdd(){V&&(z?setTimeout(U):U())},onLastListenerRemove(){M&&M.dispose(),M=null}});return k.event}E.buffer=w;class d{constructor(z){this.event=z}map(z){return new d(g(this.event,z))}forEach(z){return new d(o(this.event,z))}filter(z){return new d(s(this.event,z))}reduce(z,G){return new d(i(this.event,z,G))}latch(){return new d(l(this.event))}debounce(z,G=100,V=!1,M){return new d(c(this.event,z,G,V,M))}on(z,G,V){return this.event(z,G,V)}once(z,G,V){return b(this.event)(z,G,V)}}function T(B){return new d(B)}E.chain=T;function _(B,z,G=V=>V){const V=(...F)=>k.fire(G(...F)),M=()=>B.on(z,V),U=()=>B.removeListener(z,V),k=new h({onFirstListenerAdd:M,onLastListenerRemove:U});return k.event}E.fromNodeEventEmitter=_;function j(B,z,G=V=>V){const V=(...F)=>k.fire(G(...F)),M=()=>B.addEventListener(z,V),U=()=>B.removeEventListener(z,V),k=new h({onFirstListenerAdd:M,onLastListenerRemove:U});return k.event}E.fromDOMEventEmitter=j;function $(B){const z=new h;let G=!1;return B.then(void 0,()=>null).then(()=>{G?z.fire(void 0):setTimeout(()=>z.fire(void 0),0)}),G=!0,z.event}E.fromPromise=$;function K(B){return new Promise(z=>b(B)(z))}E.toPromise=K})(P=e.Event||(e.Event={}));class p{constructor(b){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${b}_${p._idPool++}`}start(b){this._stopWatch=new O.StopWatch(!0),this._listenerCount=b}stop(){if(this._stopWatch){const b=this._stopWatch.elapsed();this._elapsedOverall+=b,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${b.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}p._idPool=0;let S=-1;function n(E){const b=S;return S=E,{dispose(){S=b}}}e.setGlobalLeakWarningThreshold=n;class v{constructor(b,g=Math.random().toString(18).slice(2,5)){this.customThreshold=b,this.name=g,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(b){let g=S;if(typeof this.customThreshold=="number"&&(g=this.customThreshold),g<=0||b<g)return;this._stacks||(this._stacks=new Map);const o=new Error().stack.split(`
`).slice(3).join(`
`),s=this._stacks.get(o)||0;if(this._stacks.set(o,s+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=g*.5;let t,r=0;for(const[i,a]of this._stacks)(!t||r<a)&&(t=i,r=a);console.warn(`[${this.name}] potential listener LEAK detected, having ${b} listeners already. MOST frequent listener (${r}):`),console.warn(t)}return()=>{const t=this._stacks.get(o)||0;this._stacks.set(o,t-1)}}}class h{constructor(b){var g;this._disposed=!1,this._options=b,this._leakageMon=S>0?new v(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((g=this._options)===null||g===void 0?void 0:g._profName)?new p(this._options._profName):void 0}get event(){return this._event||(this._event=(b,g,o)=>{var s;this._listeners||(this._listeners=new A.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const r=this._listeners.push(g?[b,g]:b);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,b,g);const i=(s=this._leakageMon)===null||s===void 0?void 0:s.check(this._listeners.size);let a;return a={dispose:()=>{i&&i(),a.dispose=h._noop,this._disposed||(r(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},o instanceof L.DisposableStore?o.add(a):Array.isArray(o)&&o.push(a),a}),this._event}fire(b){var g,o;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new A.LinkedList);for(let s of this._listeners)this._deliveryQueue.push([s,b]);for((g=this._perfMon)===null||g===void 0||g.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[s,t]=this._deliveryQueue.shift();try{typeof s=="function"?s.call(void 0,t):s[0].call(s[1],t)}catch(r){y.onUnexpectedError(r)}}(o=this._perfMon)===null||o===void 0||o.stop()}}dispose(){var b,g,o,s,t;this._disposed||(this._disposed=!0,(b=this._listeners)===null||b===void 0||b.clear(),(g=this._deliveryQueue)===null||g===void 0||g.clear(),(s=(o=this._options)===null||o===void 0?void 0:o.onLastListenerRemove)===null||s===void 0||s.call(o),(t=this._leakageMon)===null||t===void 0||t.dispose())}}e.Emitter=h,h._noop=function(){};class C extends h{constructor(b){super(b);this._isPaused=0,this._eventQueue=new A.LinkedList,this._mergeFn=b==null?void 0:b.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const b=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(b))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(b){this._listeners&&(this._isPaused!==0?this._eventQueue.push(b):super.fire(b))}}e.PauseableEmitter=C;class f{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new h({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(b){const g={event:b,listener:null};this.events.push(g),this.hasListeners&&this.hook(g);const o=()=>{this.hasListeners&&this.unhook(g);const s=this.events.indexOf(g);this.events.splice(s,1)};return L.toDisposable(R.once(o))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(b=>this.hook(b))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(b=>this.unhook(b))}hook(b){b.listener=b.event(g=>this.emitter.fire(g))}unhook(b){b.listener&&b.listener.dispose(),b.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=f;class I{constructor(){this.buffers=[]}wrapEvent(b){return(g,o,s)=>b(t=>{const r=this.buffers[this.buffers.length-1];r?r.push(()=>g.call(o,t)):g.call(o,t)},void 0,s)}bufferEvents(b){const g=[];this.buffers.push(g);const o=b();return this.buffers.pop(),g.forEach(s=>s()),o}}e.EventBufferer=I;class D{constructor(){this.listening=!1,this.inputEvent=P.None,this.inputEventListener=L.Disposable.None,this.emitter=new h({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(b){this.inputEvent=b,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=b(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=D}),define(Z[29],ee([0,1,3]),function(H,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const R=Object.freeze(function(P,p){const S=setTimeout(P.bind(p),0);return{dispose(){clearTimeout(S)}}});var L;(function(P){function p(S){return S===P.None||S===P.Cancelled||S instanceof A?!0:!S||typeof S!="object"?!1:typeof S.isCancellationRequested=="boolean"&&typeof S.onCancellationRequested=="function"}P.isCancellationToken=p,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:y.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:R})})(L=e.CancellationToken||(e.CancellationToken={}));class A{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?R:(this._emitter||(this._emitter=new y.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class O{constructor(p){this._token=void 0,this._parentListener=void 0,this._parentListener=p&&p.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new A),this._token}cancel(){this._token?this._token instanceof A&&this._token.cancel():this._token=L.Cancelled}dispose(p=!1){p&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof A&&this._token.dispose():this._token=L.None}}e.CancellationTokenSource=O}),define(Z[54],ee([0,1,3]),function(H,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class R{constructor(){this._icons=new Map,this._onDidRegister=new y.Emitter}add(v){const h=this._icons.get(v.id);h?v.description?h.description=v.description:console.error(`Duplicate registration of codicon ${v.id}`):(this._icons.set(v.id,v),this._onDidRegister.fire(v))}get(v){return this._icons.get(v)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const L=new R;e.iconRegistry=L;function A(n,v){return new P(n,v)}e.registerCodicon=A;function O(n){return n?n.replace(/\$\((.*?)\)/g,(v,h)=>` ${h} `).trim():""}e.getCodiconAriaLabel=O;class P{constructor(v,h,C){this.id=v,this.definition=h,this.description=C,L.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=P;function p(n,v){const h=["codicon","codicon-"+n];return v&&h.push("codicon-modifier-"+v),h}e.getClassNamesArray=p;var S;(function(n){n.iconNameSegment="[A-Za-z0-9]+",n.iconNameExpression="[A-Za-z0-9\\-]+",n.iconModifierExpression="~[A-Za-z]+";const v=new RegExp(`^(${n.iconNameExpression})(${n.iconModifierExpression})?$`);function h(I){if(I instanceof P)return["codicon","codicon-"+I.id];const D=v.exec(I.id);if(!D)return h(P.error);let[,E,b]=D;const g=["codicon","codicon-"+E];return b&&g.push("codicon-modifier-"+b.substr(1)),g}n.asClassNameArray=h;function C(I){return h(I).join(" ")}n.asClassName=C;function f(I){return"."+h(I).join(".")}n.asCSSSelector=f})(S=e.CSSIcon||(e.CSSIcon={})),function(n){n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",{fontCharacter:"\\ea60"}),n.gistNew=new n("gist-new",{fontCharacter:"\\ea60"}),n.repoCreate=new n("repo-create",{fontCharacter:"\\ea60"}),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eb0a"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition)}(P=e.Codicon||(e.Codicon={}))}),define(Z[48],ee([0,1,11,2]),function(H,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function L(g){const o=g;return o?[o.on,o.pause,o.resume,o.destroy].every(s=>typeof s=="function"):!1}e.isReadableStream=L;function A(g){const o=g;return o?L(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}e.isReadableBufferedStream=A;function O(g,o){return new P(g,o)}e.newWriteableStream=O;class P{constructor(o,s){this.reducer=o,this.options=s,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(o){var s;if(!this.state.destroyed){if(this.state.flowing)this.emitData(o);else if(this.buffer.data.push(o),typeof((s=this.options)===null||s===void 0?void 0:s.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(o){this.state.destroyed||(this.state.flowing?this.emitError(o):this.buffer.error.push(o))}end(o){this.state.destroyed||(typeof o!="undefined"&&this.write(o),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(o){this.listeners.data.slice(0).forEach(s=>s(o))}emitError(o){this.listeners.error.length===0?y.onUnexpectedError(o):this.listeners.error.slice(0).forEach(s=>s(o))}emitEnd(){this.listeners.end.slice(0).forEach(o=>o())}on(o,s){if(!this.state.destroyed)switch(o){case"data":this.listeners.data.push(s),this.resume();break;case"end":this.listeners.end.push(s),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(s),this.state.flowing&&this.flowErrors();break}}removeListener(o,s){if(this.state.destroyed)return;let t;switch(o){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const r=t.indexOf(s);r>=0&&t.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const o=this.reducer(this.buffer.data);this.emitData(o),this.buffer.data.length=0;const s=[...this.pendingWritePromises];this.pendingWritePromises.length=0,s.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const o of this.buffer.error)this.emitError(o);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function p(g,o){const s=[];let t;for(;(t=g.read())!==null;)s.push(t);return o(s)}e.consumeReadable=p;function S(g,o,s){const t=[];let r;for(;(r=g.read())!==null&&t.length<s;)t.push(r);return r===null&&t.length>0?o(t):{read:()=>{if(t.length>0)return t.shift();if(typeof r!="undefined"){const i=r;return r=void 0,i}return g.read()}}}e.peekReadable=S;function n(g,o){return new Promise((s,t)=>{const r=[];v(g,{onData:i=>{o&&r.push(i)},onError:i=>{o?t(i):s(void 0)},onEnd:()=>{s(o?o(r):void 0)}})})}e.consumeStream=n;function v(g,o){g.on("error",s=>o.onError(s)),g.on("end",()=>o.onEnd()),g.on("data",s=>o.onData(s))}e.listenStream=v;function h(g,o){return new Promise((s,t)=>{const r=new R.DisposableStore,i=[],a=l=>{if(i.push(l),i.length>o)return r.dispose(),g.pause(),s({stream:g,buffer:i,ended:!1})},c=l=>t(l),u=()=>s({stream:g,buffer:i,ended:!0});r.add(R.toDisposable(()=>g.removeListener("error",c))),g.on("error",c),r.add(R.toDisposable(()=>g.removeListener("end",u))),g.on("end",u),r.add(R.toDisposable(()=>g.removeListener("data",a))),g.on("data",a)})}e.peekStream=h;function C(g,o){const s=O(o);return s.end(g),s}e.toStream=C;function f(){const g=O(()=>{throw new Error("not supported")});return g.end(),g}e.emptyStream=f;function I(g){let o=!1;return{read:()=>o?null:(o=!0,g)}}e.toReadable=I;function D(g,o,s){const t=O(s);return v(g,{onData:r=>t.write(o.data(r)),onError:r=>t.error(o.error?o.error(r):r),onEnd:()=>t.end()}),t}e.transform=D;function E(g,o,s){let t=!1;return{read:()=>{const r=o.read();return t?r:(t=!0,r!==null?s([g,r]):g)}}}e.prefixedReadable=E;function b(g,o,s){let t=!1;const r=O(s);return v(o,{onData:i=>t?r.write(i):(t=!0,r.write(s([g,i]))),onError:i=>r.error(i),onEnd:()=>{t||(t=!0,r.write(g)),r.end()}}),r}e.prefixedStream=b}),define(Z[22],ee([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function y(x){return!x||typeof x!="string"?!0:x.trim().length===0}e.isFalsyOrWhitespace=y;const R=/{(\d+)}/g;function L(x,...te){return te.length===0?x:x.replace(R,function(ae,oe){const he=parseInt(oe,10);return isNaN(he)||he<0||he>=te.length?ae:te[he]})}e.format=L;function A(x){return x.replace(/[<>&]/g,function(te){switch(te){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return te}})}e.escape=A;function O(x){return x.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=O;function P(x,te){let ae=0;const oe=te.charCodeAt(0);for(let he=x.length-1;he>=0;he--)x.charCodeAt(he)===oe&&ae++;return ae}e.count=P;function p(x,te,ae="\u2026"){return x.length<=te?x:`${x.substr(0,te)}${ae}`}e.truncate=p;function S(x,te=" "){const ae=n(x,te);return v(ae,te)}e.trim=S;function n(x,te){if(!x||!te)return x;const ae=te.length;if(ae===0||x.length===0)return x;let oe=0;for(;x.indexOf(te,oe)===oe;)oe=oe+ae;return x.substring(oe)}e.ltrim=n;function v(x,te){if(!x||!te)return x;const ae=te.length,oe=x.length;if(ae===0||oe===0)return x;let he=oe,ge=-1;for(;ge=x.lastIndexOf(te,he-1),!(ge===-1||ge+ae!==he);){if(ge===0)return"";he=ge}return x.substring(0,he)}e.rtrim=v;function h(x){return x.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=h;function C(x){return x.replace(/\*/g,"")}e.stripWildcards=C;function f(x,te,ae={}){if(!x)throw new Error("Cannot create regex from empty string");te||(x=O(x)),ae.wholeWord&&(/\B/.test(x.charAt(0))||(x="\\b"+x),/\B/.test(x.charAt(x.length-1))||(x=x+"\\b"));let oe="";return ae.global&&(oe+="g"),ae.matchCase||(oe+="i"),ae.multiline&&(oe+="m"),ae.unicode&&(oe+="u"),new RegExp(x,oe)}e.createRegExp=f;function I(x){return x.source==="^"||x.source==="^$"||x.source==="$"||x.source==="^\\s*$"?!1:!!(x.exec("")&&x.lastIndex===0)}e.regExpLeadsToEndlessLoop=I;function D(x){return!!x.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=D;function E(x){return(x.global?"g":"")+(x.ignoreCase?"i":"")+(x.multiline?"m":"")+(x.unicode?"u":"")}e.regExpFlags=E;function b(x){return x.split(/\r\n|\r|\n/)}e.splitLines=b;function g(x){for(let te=0,ae=x.length;te<ae;te++){const oe=x.charCodeAt(te);if(oe!==32&&oe!==9)return te}return-1}e.firstNonWhitespaceIndex=g;function o(x,te=0,ae=x.length){for(let oe=te;oe<ae;oe++){const he=x.charCodeAt(oe);if(he!==32&&he!==9)return x.substring(te,oe)}return x.substring(te,ae)}e.getLeadingWhitespace=o;function s(x,te=x.length-1){for(let ae=te;ae>=0;ae--){const oe=x.charCodeAt(ae);if(oe!==32&&oe!==9)return ae}return-1}e.lastNonWhitespaceIndex=s;function t(x,te){return x<te?-1:x>te?1:0}e.compare=t;function r(x,te,ae=0,oe=x.length,he=0,ge=te.length){for(;ae<oe&&he<ge;ae++,he++){let we=x.charCodeAt(ae),Ee=te.charCodeAt(he);if(we<Ee)return-1;if(we>Ee)return 1}const fe=oe-ae,ye=ge-he;return fe<ye?-1:fe>ye?1:0}e.compareSubstring=r;function i(x,te){return a(x,te,0,x.length,0,te.length)}e.compareIgnoreCase=i;function a(x,te,ae=0,oe=x.length,he=0,ge=te.length){for(;ae<oe&&he<ge;ae++,he++){let we=x.charCodeAt(ae),Ee=te.charCodeAt(he);if(we===Ee)continue;const ue=we-Ee;if(!(ue===32&&u(Ee))&&!(ue===-32&&u(we)))return c(we)&&c(Ee)?ue:r(x.toLowerCase(),te.toLowerCase(),ae,oe,he,ge)}const fe=oe-ae,ye=ge-he;return fe<ye?-1:fe>ye?1:0}e.compareSubstringIgnoreCase=a;function c(x){return x>=97&&x<=122}e.isLowerAsciiLetter=c;function u(x){return x>=65&&x<=90}e.isUpperAsciiLetter=u;function l(x){return c(x)||u(x)}function m(x,te){return x.length===te.length&&w(x,te)}e.equalsIgnoreCase=m;function w(x,te,ae=x.length){for(let oe=0;oe<ae;oe++){const he=x.charCodeAt(oe),ge=te.charCodeAt(oe);if(he!==ge){if(l(he)&&l(ge)){const fe=Math.abs(he-ge);if(fe!==0&&fe!==32)return!1}else if(String.fromCharCode(he).toLowerCase()!==String.fromCharCode(ge).toLowerCase())return!1}}return!0}function d(x,te){const ae=te.length;return te.length>x.length?!1:w(x,te,ae)}e.startsWithIgnoreCase=d;function T(x,te){let ae,oe=Math.min(x.length,te.length);for(ae=0;ae<oe;ae++)if(x.charCodeAt(ae)!==te.charCodeAt(ae))return ae;return oe}e.commonPrefixLength=T;function _(x,te){let ae,oe=Math.min(x.length,te.length);const he=x.length-1,ge=te.length-1;for(ae=0;ae<oe;ae++)if(x.charCodeAt(he-ae)!==te.charCodeAt(ge-ae))return ae;return oe}e.commonSuffixLength=_;function j(x){return 55296<=x&&x<=56319}e.isHighSurrogate=j;function $(x){return 56320<=x&&x<=57343}e.isLowSurrogate=$;function K(x,te){return(x-55296<<10)+(te-56320)+65536}e.computeCodePoint=K;function B(x,te,ae){const oe=x.charCodeAt(ae);if(j(oe)&&ae+1<te){const he=x.charCodeAt(ae+1);if($(he))return K(oe,he)}return oe}e.getNextCodePoint=B;function z(x,te){const ae=x.charCodeAt(te-1);if($(ae)&&te>1){const oe=x.charCodeAt(te-2);if(j(oe))return K(oe,ae)}return ae}function G(x,te){const ae=se.getInstance(),oe=te,he=x.length,ge=B(x,he,te);te+=ge>=65536?2:1;let fe=ae.getGraphemeBreakType(ge);for(;te<he;){const ye=B(x,he,te),we=ae.getGraphemeBreakType(ye);if(J(fe,we))break;te+=ye>=65536?2:1,fe=we}return te-oe}e.nextCharLength=G;function V(x,te){const ae=se.getInstance(),oe=te,he=z(x,te);te-=he>=65536?2:1;let ge=ae.getGraphemeBreakType(he);for(;te>0;){const fe=z(x,te),ye=ae.getGraphemeBreakType(fe);if(J(ye,ge))break;te-=fe>=65536?2:1,ge=ye}return oe-te}e.prevCharLength=V;function M(x,te){const ae=se.getInstance(),oe=x.length,he=te,ge=B(x,oe,te),fe=ae.getGraphemeBreakType(ge);te+=ge>=65536?2:1;let ye=fe;for(;te<oe;){const Ee=B(x,oe,te),ue=ae.getGraphemeBreakType(Ee);if(J(ye,ue))break;te+=Ee>=65536?2:1,ye=ue}const we=te;for(te=he,ye=fe;te>0;){const Ee=z(x,te),ue=ae.getGraphemeBreakType(Ee);if(J(ue,ye))break;te-=Ee>=65536?2:1,ye=ue}return[te,we]}function U(x,te){return te>0&&$(x.charCodeAt(te))?M(x,te-1):M(x,te)}e.getCharContainingOffset=U;function k(x){const te=x.length;let ae=0,oe=0;for(;oe<te;){const fe=B(x,te,oe);oe+=fe>=65536?2:1,fe<128?ae+=1:fe<2048?ae+=2:fe<65536?ae+=3:ae+=4}const he=new Uint8Array(ae);oe=0;let ge=0;for(;oe<te;){const fe=B(x,te,oe);oe+=fe>=65536?2:1,fe<128?he[ge++]=fe:fe<2048?(he[ge++]=192|(fe&1984)>>>6,he[ge++]=128|(fe&63)>>>0):fe<65536?(he[ge++]=224|(fe&61440)>>>12,he[ge++]=128|(fe&4032)>>>6,he[ge++]=128|(fe&63)>>>0):(he[ge++]=240|(fe&1835008)>>>18,he[ge++]=128|(fe&258048)>>>12,he[ge++]=128|(fe&4032)>>>6,he[ge++]=128|(fe&63)>>>0)}return he}e.encodeUTF8=k;function F(x){const te=x.byteLength,ae=[];let oe=0;for(;oe<te;){const he=x[oe];let ge;if(he>=240&&oe+3<te?ge=(x[oe++]&7)<<18>>>0|(x[oe++]&63)<<12>>>0|(x[oe++]&63)<<6>>>0|(x[oe++]&63)<<0>>>0:he>=224&&oe+2<te?ge=(x[oe++]&15)<<12>>>0|(x[oe++]&63)<<6>>>0|(x[oe++]&63)<<0>>>0:he>=192&&oe+1<te?ge=(x[oe++]&31)<<6>>>0|(x[oe++]&63)<<0>>>0:ge=x[oe++],ge>=0&&ge<=55295||ge>=57344&&ge<=65535)ae.push(String.fromCharCode(ge));else if(ge>=65536&&ge<=1114111){const fe=ge-65536,ye=55296+((fe&1047552)>>>10),we=56320+((fe&1023)>>>0);ae.push(String.fromCharCode(ye)),ae.push(String.fromCharCode(we))}else ae.push(String.fromCharCode(65533))}return ae.join("")}e.decodeUTF8=F;const N=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function q(x){return N.test(x)}e.containsRTL=q;const W=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function Q(x){return W.test(x)}e.containsEmoji=Q;const X=/^[\t\n\r\x20-\x7E]*$/;function ie(x){return X.test(x)}e.isBasicASCII=ie,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function ne(x){return e.UNUSUAL_LINE_TERMINATORS.test(x)}e.containsUnusualLineTerminators=ne;function ce(x){for(let te=0,ae=x.length;te<ae;te++)if(le(x.charCodeAt(te)))return!0;return!1}e.containsFullWidthCharacter=ce;function le(x){return x=+x,x>=11904&&x<=55215||x>=63744&&x<=64255||x>=65281&&x<=65374}e.isFullWidthCharacter=le;function ve(x){return x>=127462&&x<=127487||x===8986||x===8987||x===9200||x===9203||x>=9728&&x<=10175||x===11088||x===11093||x>=127744&&x<=128591||x>=128640&&x<=128764||x>=128992&&x<=129003||x>=129280&&x<=129535||x>=129648&&x<=129750}e.isEmojiImprecise=ve;function pe(x,te){if(x.length<te)return x;const ae=/\b/g;let oe=0;for(;ae.test(x)&&!(x.length-ae.lastIndex<te);)oe=ae.lastIndex,ae.lastIndex+=1;return x.substring(oe).replace(/^\s/,"")}e.lcut=pe;const Ce=/\x1B\x5B[12]?K/g,Ae=/\x1b\[\d+m/g,_e=/\x1b\[0?m/g;function Oe(x){return x&&(x=x.replace(Ce,""),x=x.replace(Ae,""),x=x.replace(_e,"")),x}e.removeAnsiEscapeCodes=Oe,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ke(x){return!!(x&&x.length>0&&x.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ke;function je(x){return ke(x)?x.substr(1):x}e.stripUTF8BOM=je;function Ie(x,te){if(!x||!te||x.length<te.length)return!1;const ae=te.length,oe=x.toLowerCase();let he=0,ge=-1;for(;he<ae;){const fe=oe.indexOf(te[he],ge+1);if(fe<0)return!1;ge=fe,he++}return!0}e.fuzzyContains=Ie;function Te(x,te=!1){return x?(te&&(x=x.replace(/\\./g,"")),x.toLowerCase()!==x):!1}e.containsUppercaseCharacter=Te;function Ke(x){return x.charAt(0).toUpperCase()+x.slice(1)}e.uppercaseFirstLetter=Ke;function Ye(x,te=1){if(te===0)return"";let ae=-1;do ae=x.indexOf(`
`,ae+1),te--;while(te>0&&ae>=0);return ae===-1?x:(x[ae-1]==="\r"&&ae--,x.substr(0,ae))}e.getNLines=Ye;function $e(x){const te=90-65+1;return x=x%(2*te),x<te?String.fromCharCode(97+x):String.fromCharCode(65+x-te)}e.singleLetterHash=$e;function qe(x){return se.getInstance().getGraphemeBreakType(x)}e.getGraphemeBreakType=qe;function J(x,te){return x===0?te!==5&&te!==7:x===2&&te===3?!1:x===4||x===2||x===3||te===4||te===2||te===3?!0:!(x===8&&(te===8||te===9||te===11||te===12)||(x===11||x===9)&&(te===9||te===10)||(x===12||x===10)&&te===10||te===5||te===13||te===7||x===1||x===13&&te===14||x===6&&te===6)}e.breakBetweenGraphemeBreakType=J;var re;(function(x){x[x.Other=0]="Other",x[x.Prepend=1]="Prepend",x[x.CR=2]="CR",x[x.LF=3]="LF",x[x.Control=4]="Control",x[x.Extend=5]="Extend",x[x.Regional_Indicator=6]="Regional_Indicator",x[x.SpacingMark=7]="SpacingMark",x[x.L=8]="L",x[x.V=9]="V",x[x.T=10]="T",x[x.LV=11]="LV",x[x.LVT=12]="LVT",x[x.ZWJ=13]="ZWJ",x[x.Extended_Pictographic=14]="Extended_Pictographic"})(re=e.GraphemeBreakType||(e.GraphemeBreakType={}));class se{constructor(){this._data=me()}static getInstance(){return se._INSTANCE||(se._INSTANCE=new se),se._INSTANCE}getGraphemeBreakType(te){if(te<32)return te===10?3:te===13?2:4;if(te<127)return 0;const ae=this._data,oe=ae.length/3;let he=1;for(;he<=oe;)if(te<ae[3*he])he=2*he;else if(te>ae[3*he+1])he=2*he+1;else return ae[3*he+2];return 0}}se._INSTANCE=null;function me(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function Se(x,te){if(x===0)return 0;const ae=Pe(x,te);if(ae!==void 0)return ae;const oe=z(te,x);return x-=be(oe),x}e.getLeftDeleteOffset=Se;function Pe(x,te){let ae=z(te,x);for(x-=be(ae);Ue(ae)||ae===65039||ae===8419;){if(x===0)return;ae=z(te,x),x-=be(ae)}if(!!ve(ae)){if(x>=0){const oe=z(te,x);oe===8205&&(x-=be(oe))}return x}}function be(x){return x>=65536?2:1}function Ue(x){return 127995<=x&&x<=127999}var De;(function(x){x[x.zwj=8205]="zwj",x[x.emojiVariantSelector=65039]="emojiVariantSelector",x[x.enclosingKeyCap=8419]="enclosingKeyCap"})(De||(De={}))}),define(Z[25],ee([0,1,22,48]),function(H,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const L=typeof Buffer!="undefined",A=typeof TextEncoder!="undefined",O=typeof TextDecoder!="undefined";let P,p;class S{constructor(l){this.buffer=l,this.byteLength=this.buffer.byteLength}static alloc(l){return L?new S(Buffer.allocUnsafe(l)):new S(new Uint8Array(l))}static wrap(l){return L&&!Buffer.isBuffer(l)&&(l=Buffer.from(l.buffer,l.byteOffset,l.byteLength)),new S(l)}static fromString(l,m){return!((m==null?void 0:m.dontUseNodeBuffer)||!1)&&L?new S(Buffer.from(l)):A?(P||(P=new TextEncoder),new S(P.encode(l))):new S(y.encodeUTF8(l))}static concat(l,m){if(typeof m=="undefined"){m=0;for(let T=0,_=l.length;T<_;T++)m+=l[T].byteLength}const w=S.alloc(m);let d=0;for(let T=0,_=l.length;T<_;T++){const j=l[T];w.set(j,d),d+=j.byteLength}return w}toString(){return L?this.buffer.toString():O?(p||(p=new TextDecoder),p.decode(this.buffer)):y.decodeUTF8(this.buffer)}slice(l,m){return new S(this.buffer.subarray(l,m))}set(l,m){l instanceof S?this.buffer.set(l.buffer,m):this.buffer.set(l,m)}readUInt32BE(l){return h(this.buffer,l)}writeUInt32BE(l,m){C(this.buffer,l,m)}readUInt32LE(l){return f(this.buffer,l)}writeUInt32LE(l,m){I(this.buffer,l,m)}readUInt8(l){return D(this.buffer,l)}writeUInt8(l,m){E(this.buffer,l,m)}}e.VSBuffer=S;function n(u,l){return u[l+0]<<0>>>0|u[l+1]<<8>>>0}e.readUInt16LE=n;function v(u,l,m){u[m+0]=l&255,l=l>>>8,u[m+1]=l&255}e.writeUInt16LE=v;function h(u,l){return u[l]*2**24+u[l+1]*2**16+u[l+2]*2**8+u[l+3]}e.readUInt32BE=h;function C(u,l,m){u[m+3]=l,l=l>>>8,u[m+2]=l,l=l>>>8,u[m+1]=l,l=l>>>8,u[m]=l}e.writeUInt32BE=C;function f(u,l){return u[l+0]<<0>>>0|u[l+1]<<8>>>0|u[l+2]<<16>>>0|u[l+3]<<24>>>0}e.readUInt32LE=f;function I(u,l,m){u[m+0]=l&255,l=l>>>8,u[m+1]=l&255,l=l>>>8,u[m+2]=l&255,l=l>>>8,u[m+3]=l&255}e.writeUInt32LE=I;function D(u,l){return u[l]}e.readUInt8=D;function E(u,l,m){u[m]=l}e.writeUInt8=E;function b(u){return R.consumeReadable(u,l=>S.concat(l))}e.readableToBuffer=b;function g(u){return R.toReadable(u)}e.bufferToReadable=g;function o(u){return R.consumeStream(u,l=>S.concat(l))}e.streamToBuffer=o;async function s(u){return u.ended?S.concat(u.buffer):S.concat([...u.buffer,await o(u.stream)])}e.bufferedStreamToBuffer=s;function t(u){return R.toStream(u,l=>S.concat(l))}e.bufferToStream=t;function r(u){return R.transform(u,{data:l=>typeof l=="string"?S.fromString(l):S.wrap(l)},l=>S.concat(l))}e.streamToBufferReadableStream=r;function i(u){return R.newWriteableStream(l=>S.concat(l),u)}e.newWriteableBufferStream=i;function a(u,l){return R.prefixedReadable(u,l,m=>S.concat(m))}e.prefixedBufferReadable=a;function c(u,l){return R.prefixedStream(u,l,m=>S.concat(m))}e.prefixedBufferStream=c}),define(Z[15],ee([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function y(l){return Array.isArray(l)}e.isArray=y;function R(l){return typeof l=="string"}e.isString=R;function L(l){return Array.isArray(l)&&l.every(m=>R(m))}e.isStringArray=L;function A(l){return typeof l=="object"&&l!==null&&!Array.isArray(l)&&!(l instanceof RegExp)&&!(l instanceof Date)}e.isObject=A;function O(l){return typeof l=="number"&&!isNaN(l)}e.isNumber=O;function P(l){return!!l&&typeof l[Symbol.iterator]=="function"}e.isIterable=P;function p(l){return l===!0||l===!1}e.isBoolean=p;function S(l){return typeof l=="undefined"}e.isUndefined=S;function n(l){return!v(l)}e.isDefined=n;function v(l){return S(l)||l===null}e.isUndefinedOrNull=v;function h(l,m){if(!l)throw new Error(m?`Unexpected type, expected '${m}'`:"Unexpected type")}e.assertType=h;function C(l){if(v(l))throw new Error("Assertion Failed: argument is undefined or null");return l}e.assertIsDefined=C;function f(...l){const m=[];for(let w=0;w<l.length;w++){const d=l[w];if(v(d))throw new Error(`Assertion Failed: argument at index ${w} is undefined or null`);m.push(d)}return m}e.assertAllDefined=f;const I=Object.prototype.hasOwnProperty;function D(l){if(!A(l))return!1;for(let m in l)if(I.call(l,m))return!1;return!0}e.isEmptyObject=D;function E(l){return typeof l=="function"}e.isFunction=E;function b(...l){return l.length>0&&l.every(E)}e.areFunctions=b;function g(l,m){const w=Math.min(l.length,m.length);for(let d=0;d<w;d++)o(l[d],m[d])}e.validateConstraints=g;function o(l,m){if(R(m)){if(typeof l!==m)throw new Error(`argument does not match constraint: typeof ${m}`)}else if(E(m)){try{if(l instanceof m)return}catch(w){}if(!v(l)&&l.constructor===m||m.length===1&&m.call(void 0,l)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=o;function s(l){let m=[],w=Object.getPrototypeOf(l);for(;Object.prototype!==w;)m=m.concat(Object.getOwnPropertyNames(w)),w=Object.getPrototypeOf(w);return m}e.getAllPropertyNames=s;function t(l){const m=[];for(const w of s(l))typeof l[w]=="function"&&m.push(w);return m}e.getAllMethodNames=t;function r(l,m){const w=T=>function(){const _=Array.prototype.slice.call(arguments,0);return m(T,_)};let d={};for(const T of l)d[T]=w(T);return d}e.createProxyObject=r;function i(l){return l===null?void 0:l}e.withNullAsUndefined=i;function a(l){return typeof l=="undefined"?null:l}e.withUndefinedAsNull=a;function c(l){return class{constructor(){return new Proxy({},{get(m,w){if(m[w])return m[w];throw new Error(`Not Implemented: ${l}->${String(w)}`)}})}}}e.NotImplementedProxy=c;function u(l){throw new Error("Unreachable")}e.assertNever=u}),define(Z[41],ee([0,1,6,22,7,15]),function(H,e,y,R,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function O(i){return i===47||i===92}e.isPathSeparator=O;function P(i){return i.replace(/[\\/]/g,L.posix.sep)}e.toSlashes=P;function p(i){return i.indexOf("/")===-1&&(i=P(i)),/^[a-zA-Z]:(\/|$)/.test(i)&&(i="/"+i),i}e.toPosixPath=p;function S(i,a=L.posix.sep){if(!i)return"";const c=i.length,u=i.charCodeAt(0);if(O(u)){if(O(i.charCodeAt(1))&&!O(i.charCodeAt(2))){let m=3;const w=m;for(;m<c&&!O(i.charCodeAt(m));m++);if(w!==m&&!O(i.charCodeAt(m+1))){for(m+=1;m<c;m++)if(O(i.charCodeAt(m)))return i.slice(0,m+1).replace(/[\\/]/g,a)}}return a}else if(E(u)&&i.charCodeAt(1)===58)return O(i.charCodeAt(2))?i.slice(0,2)+a:i.slice(0,2);let l=i.indexOf("://");if(l!==-1){for(l+=3;l<c;l++)if(O(i.charCodeAt(l)))return i.slice(0,l+1)}return""}e.getRoot=S;function n(i){if(!y.isWindows||!i||i.length<5)return!1;let a=i.charCodeAt(0);if(a!==92||(a=i.charCodeAt(1),a!==92))return!1;let c=2;const u=c;for(;c<i.length&&(a=i.charCodeAt(c),a!==92);c++);return!(u===c||(a=i.charCodeAt(c+1),isNaN(a)||a===92))}e.isUNC=n;const v=/[\\/:\*\?"<>\|]/g,h=/[\\/]/g,C=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(i,a=y.isWindows){const c=a?v:h;return!(!i||i.length===0||/^\s+$/.test(i)||(c.lastIndex=0,c.test(i))||a&&C.test(i)||i==="."||i===".."||a&&i[i.length-1]==="."||a&&i.length!==i.trim().length||i.length>255)}e.isValidBasename=f;function I(i,a,c){const u=i===a;return!c||u?u:!i||!a?!1:R.equalsIgnoreCase(i,a)}e.isEqual=I;function D(i,a,c,u=L.sep){if(i===a)return!0;if(!i||!a||a.length>i.length)return!1;if(c){if(!R.startsWithIgnoreCase(i,a))return!1;if(a.length===i.length)return!0;let m=a.length;return a.charAt(a.length-1)===u&&m--,i.charAt(m)===u}return a.charAt(a.length-1)!==u&&(a+=u),i.indexOf(a)===0}e.isEqualOrParent=D;function E(i){return i>=65&&i<=90||i>=97&&i<=122}e.isWindowsDriveLetter=E;function b(i,a){return y.isWindows&&i.endsWith(":")&&(i+=L.sep),L.isAbsolute(i)||(i=L.join(a,i)),i=L.normalize(i),y.isWindows?(i=R.rtrim(i,L.sep),i.endsWith(":")&&(i+=L.sep)):(i=R.rtrim(i,L.sep),i||(i=L.sep)),i}e.sanitizeFilePath=b;function g(i){const a=L.normalize(i);return y.isWindows?i.length>3?!1:o(a)&&(i.length===2||a.charCodeAt(2)===92):a===L.posix.sep}e.isRootOrDriveLetter=g;function o(i){return y.isWindows?E(i.charCodeAt(0))&&i.charCodeAt(1)===58:!1}e.hasDriveLetter=o;function s(i){return o(i)?i[0]:void 0}e.getDriveLetter=s;function t(i,a,c){return a.length>i.length?-1:i===a?0:(c&&(i=i.toLowerCase(),a=a.toLowerCase()),i.indexOf(a))}e.indexOfPath=t;function r(i){const a=i.split(":");let c,u,l;if(a.forEach(m=>{const w=Number(m);A.isNumber(w)?u===void 0?u=w:l===void 0&&(l=w):c=c?[c,m].join(":"):m}),!c)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:c,line:u!==void 0?u:void 0,column:l!==void 0?l:u!==void 0?1:void 0}}e.parseLineAndColumnAware=r}),define(Z[26],ee([0,1,15]),function(H,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function R(I){if(!I||typeof I!="object"||I instanceof RegExp)return I;const D=Array.isArray(I)?[]:{};return Object.keys(I).forEach(E=>{I[E]&&typeof I[E]=="object"?D[E]=R(I[E]):D[E]=I[E]}),D}e.deepClone=R;function L(I){if(!I||typeof I!="object")return I;const D=[I];for(;D.length>0;){const E=D.shift();Object.freeze(E);for(const b in E)if(A.call(E,b)){const g=E[b];typeof g=="object"&&!Object.isFrozen(g)&&D.push(g)}}return I}e.deepFreeze=L;const A=Object.prototype.hasOwnProperty;function O(I,D){return P(I,D,new Set)}e.cloneAndChange=O;function P(I,D,E){if(y.isUndefinedOrNull(I))return I;const b=D(I);if(typeof b!="undefined")return b;if(y.isArray(I)){const g=[];for(const o of I)g.push(P(o,D,E));return g}if(y.isObject(I)){if(E.has(I))throw new Error("Cannot clone recursive data-structure");E.add(I);const g={};for(let o in I)A.call(I,o)&&(g[o]=P(I[o],D,E));return E.delete(I),g}return I}function p(I,D,E=!0){return y.isObject(I)?(y.isObject(D)&&Object.keys(D).forEach(b=>{b in I?E&&(y.isObject(I[b])&&y.isObject(D[b])?p(I[b],D[b],E):I[b]=D[b]):I[b]=D[b]}),I):D}e.mixin=p;function S(I,D){if(I===D)return!0;if(I==null||D===null||D===void 0||typeof I!=typeof D||typeof I!="object"||Array.isArray(I)!==Array.isArray(D))return!1;let E,b;if(Array.isArray(I)){if(I.length!==D.length)return!1;for(E=0;E<I.length;E++)if(!S(I[E],D[E]))return!1}else{const g=[];for(b in I)g.push(b);g.sort();const o=[];for(b in D)o.push(b);if(o.sort(),!S(g,o))return!1;for(E=0;E<g.length;E++)if(!S(I[g[E]],D[g[E]]))return!1}return!0}e.equals=S;function n(I){const D=new Set;return JSON.stringify(I,(E,b)=>{if(y.isObject(b)||Array.isArray(b)){if(D.has(b))return"[Circular]";D.add(b)}return b})}e.safeStringify=n;function v(I,D,E){const b=D(I);return typeof b=="undefined"?E:b}e.getOrDefault=v;function h(I,D){const E=Object.create(null);return!I||!D||Object.keys(D).forEach(g=>{const o=I[g],s=D[g];S(o,s)||(E[g]=s)}),E}e.distinct=h;function C(I,D){const E=D.toLowerCase(),b=Object.keys(I).find(g=>g.toLowerCase()===E);return b?I[b]:I[D]}e.getCaseInsensitive=C;function f(I,D){const E=Object.create(null);for(const b of Object.keys(I))D(b,I[b])&&(E[b]=I[b]);return E}e.filter=f}),define(Z[5],ee([0,1,6,7]),function(H,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const L=/^\w[\w\d+.-]*$/,A=/^\//,O=/^\/\//;function P(i,a){if(!i.scheme&&a)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!L.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!A.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(O.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function p(i,a){return!i&&!a?"file":i}function S(i,a){switch(i){case"https":case"http":case"file":a?a[0]!==v&&(a=v+a):a=v;break}return a}const n="",v="/",h=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class C{constructor(a,c,u,l,m,w=!1){typeof a=="object"?(this.scheme=a.scheme||n,this.authority=a.authority||n,this.path=a.path||n,this.query=a.query||n,this.fragment=a.fragment||n):(this.scheme=p(a,w),this.authority=c||n,this.path=S(this.scheme,u||n),this.query=l||n,this.fragment=m||n,P(this,w))}static isUri(a){return a instanceof C?!0:a?typeof a.authority=="string"&&typeof a.fragment=="string"&&typeof a.path=="string"&&typeof a.query=="string"&&typeof a.scheme=="string"&&typeof a.fsPath=="string"&&typeof a.with=="function"&&typeof a.toString=="function":!1}get fsPath(){return g(this,!1)}with(a){if(!a)return this;let{scheme:c,authority:u,path:l,query:m,fragment:w}=a;return c===void 0?c=this.scheme:c===null&&(c=n),u===void 0?u=this.authority:u===null&&(u=n),l===void 0?l=this.path:l===null&&(l=n),m===void 0?m=this.query:m===null&&(m=n),w===void 0?w=this.fragment:w===null&&(w=n),c===this.scheme&&u===this.authority&&l===this.path&&m===this.query&&w===this.fragment?this:new I(c,u,l,m,w)}static parse(a,c=!1){const u=h.exec(a);return u?new I(u[2]||n,r(u[4]||n),r(u[5]||n),r(u[7]||n),r(u[9]||n),c):new I(n,n,n,n,n)}static file(a){let c=n;if(y.isWindows&&(a=a.replace(/\\/g,v)),a[0]===v&&a[1]===v){const u=a.indexOf(v,2);u===-1?(c=a.substring(2),a=v):(c=a.substring(2,u),a=a.substring(u)||v)}return new I("file",c,a,n,n)}static from(a){const c=new I(a.scheme,a.authority,a.path,a.query,a.fragment);return P(c,!0),c}static joinPath(a,...c){if(!a.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let u;return y.isWindows&&a.scheme==="file"?u=C.file(R.win32.join(g(a,!0),...c)).path:u=R.posix.join(a.path,...c),a.with({path:u})}toString(a=!1){return o(this,a)}toJSON(){return this}static revive(a){if(a){if(a instanceof C)return a;{const c=new I(a);return c._formatted=a.external,c._fsPath=a._sep===f?a.fsPath:null,c}}else return a}}e.URI=C;const f=y.isWindows?1:void 0;class I extends C{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=g(this,!1)),this._fsPath}toString(a=!1){return a?o(this,!0):(this._formatted||(this._formatted=o(this,!1)),this._formatted)}toJSON(){const a={$mid:1};return this._fsPath&&(a.fsPath=this._fsPath,a._sep=f),this._formatted&&(a.external=this._formatted),this.path&&(a.path=this.path),this.scheme&&(a.scheme=this.scheme),this.authority&&(a.authority=this.authority),this.query&&(a.query=this.query),this.fragment&&(a.fragment=this.fragment),a}}const D={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function E(i,a){let c,u=-1;for(let l=0;l<i.length;l++){const m=i.charCodeAt(l);if(m>=97&&m<=122||m>=65&&m<=90||m>=48&&m<=57||m===45||m===46||m===95||m===126||a&&m===47)u!==-1&&(c+=encodeURIComponent(i.substring(u,l)),u=-1),c!==void 0&&(c+=i.charAt(l));else{c===void 0&&(c=i.substr(0,l));const w=D[m];w!==void 0?(u!==-1&&(c+=encodeURIComponent(i.substring(u,l)),u=-1),c+=w):u===-1&&(u=l)}}return u!==-1&&(c+=encodeURIComponent(i.substring(u))),c!==void 0?c:i}function b(i){let a;for(let c=0;c<i.length;c++){const u=i.charCodeAt(c);u===35||u===63?(a===void 0&&(a=i.substr(0,c)),a+=D[u]):a!==void 0&&(a+=i[c])}return a!==void 0?a:i}function g(i,a){let c;return i.authority&&i.path.length>1&&i.scheme==="file"?c=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?a?c=i.path.substr(1):c=i.path[1].toLowerCase()+i.path.substr(2):c=i.path,y.isWindows&&(c=c.replace(/\//g,"\\")),c}e.uriToFsPath=g;function o(i,a){const c=a?b:E;let u="",{scheme:l,authority:m,path:w,query:d,fragment:T}=i;if(l&&(u+=l,u+=":"),(m||l==="file")&&(u+=v,u+=v),m){let _=m.indexOf("@");if(_!==-1){const j=m.substr(0,_);m=m.substr(_+1),_=j.indexOf(":"),_===-1?u+=c(j,!1):(u+=c(j.substr(0,_),!1),u+=":",u+=c(j.substr(_+1),!1)),u+="@"}m=m.toLowerCase(),_=m.indexOf(":"),_===-1?u+=c(m,!1):(u+=c(m.substr(0,_),!1),u+=m.substr(_))}if(w){if(w.length>=3&&w.charCodeAt(0)===47&&w.charCodeAt(2)===58){const _=w.charCodeAt(1);_>=65&&_<=90&&(w=`/${String.fromCharCode(_+32)}:${w.substr(3)}`)}else if(w.length>=2&&w.charCodeAt(1)===58){const _=w.charCodeAt(0);_>=65&&_<=90&&(w=`${String.fromCharCode(_+32)}:${w.substr(2)}`)}u+=c(w,!0)}return d&&(u+="?",u+=c(d,!1)),T&&(u+="#",u+=a?T:E(T,!1)),u}function s(i){try{return decodeURIComponent(i)}catch(a){return i.length>3?i.substr(0,3)+s(i.substr(3)):i}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(i){return i.match(t)?i.replace(t,a=>s(a)):i}}),define(Z[89],ee([0,1,5]),function(H,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function R(S){const n=S;return n&&typeof n.type=="string"&&typeof n.severity=="string"}e.isRemoteConsoleLog=R;function L(S){const n=[];let v;try{const h=JSON.parse(S.arguments),C=h[h.length-1];C&&C.__$stack&&(h.pop(),v=C.__$stack),n.push(...h)}catch(h){n.push("Unable to log remote console arguments",S.arguments)}return{args:n,stack:v}}e.parse=L;function A(S){if(typeof S!="string")return A(L(S).stack);const n=S;if(n){const v=O(n),h=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(v||"");if(h&&h.length===4)return{uri:y.URI.file(h[1]),line:Number(h[2]),column:Number(h[3])}}}e.getFirstFrame=A;function O(S){if(!S)return S;const n=S.indexOf(`
`);return n===-1?S:S.substring(0,n)}function P(S,n){const{args:v,stack:h}=L(S),C=typeof v[0]=="string"&&v.length===1;let f=O(h);f&&(f=`(${f.trim()})`);let I=[];if(typeof v[0]=="string"?f&&C?I=[`%c[${n}] %c${v[0]} %c${f}`,p("blue"),p(""),p("grey")]:I=[`%c[${n}] %c${v[0]}`,p("blue"),p(""),...v.slice(1)]:I=[`%c[${n}]%`,p("blue"),...v],f&&!C&&I.push(f),typeof console[S.severity]!="function")throw new Error("Unknown console method");console[S.severity].apply(console,I)}e.log=P;function p(S){return`color: ${S}`}});var ft=this&&this.__classPrivateFieldSet||function(H,e,y,R,L){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!L)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?H!==e||!L:!e.has(H))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?L.call(H,y):L?L.value=y:e.set(H,y),y},ze=this&&this.__classPrivateFieldGet||function(H,e,y,R){if(y==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?H!==e||!R:!e.has(H))throw new TypeError("Cannot read private member from an object whose class did not declare it");return y==="m"?R:y==="a"?R.call(H):R?R.value:e.get(H)};define(Z[38],ee([0,1,5,22]),function(H,e,y,R){"use strict";var L,A,O;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function P(t,r,i){let a=t.get(r);return a===void 0&&(a=i,t.set(r,a)),a}e.getOrSet=P;function p(t){const r=[];return t.forEach((i,a)=>{r.push(`${a} => ${i}`)}),`Map(${t.size}) {${r.join(", ")}}`}e.mapToString=p;function S(t){const r=[];return t.forEach(i=>{r.push(i)}),`Set(${t.size}) {${r.join(", ")}}`}e.setToString=S;class n{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const i=r.charCodeAt(0),a=this._value.charCodeAt(this._pos);return i-a}value(){return this._value[this._pos]}}e.StringIterator=n;class v{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?R.compareSubstring(r,this._value,0,r.length,this._from,this._to):R.compareSubstringIgnoreCase(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=v;class h{constructor(r=!0,i=!0){this._splitOnBackslash=r,this._caseSensitive=i}reset(r){return this._value=r.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++){const i=this._value.charCodeAt(this._to);if(i===47||this._splitOnBackslash&&i===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?R.compareSubstring(r,this._value,0,r.length,this._from,this._to):R.compareSubstringIgnoreCase(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=h;var C;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(C||(C={}));class f{constructor(r){this._ignorePathCasing=r,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new h(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return R.compareIgnoreCase(r,this._value.scheme);if(this._states[this._stateIdx]===2)return R.compareIgnoreCase(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return R.compare(r,this._value.query);if(this._states[this._stateIdx]===5)return R.compare(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=f;class I{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class D{constructor(r){this._iter=r}static forUris(r=()=>!1){return new D(new f(r))}static forPaths(){return new D(new h)}static forStrings(){return new D(new n)}static forConfigKeys(){return new D(new v)}clear(){this._root=void 0}set(r,i){const a=this._iter.reset(r);let c;for(this._root||(this._root=new I,this._root.segment=a.value()),c=this._root;;){const l=a.cmp(c.segment);if(l>0)c.left||(c.left=new I,c.left.segment=a.value()),c=c.left;else if(l<0)c.right||(c.right=new I,c.right.segment=a.value()),c=c.right;else if(a.hasNext())a.next(),c.mid||(c.mid=new I,c.mid.segment=a.value()),c=c.mid;else break}const u=c.value;return c.value=i,c.key=r,u}get(r){var i;return(i=this._getNode(r))===null||i===void 0?void 0:i.value}_getNode(r){const i=this._iter.reset(r);let a=this._root;for(;a;){const c=i.cmp(a.segment);if(c>0)a=a.left;else if(c<0)a=a.right;else if(i.hasNext())i.next(),a=a.mid;else break}return a}has(r){const i=this._getNode(r);return!((i==null?void 0:i.value)===void 0&&(i==null?void 0:i.mid)===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,i){const a=this._iter.reset(r),c=[];let u=this._root;for(;u;){const l=a.cmp(u.segment);if(l>0)c.push([1,u]),u=u.left;else if(l<0)c.push([-1,u]),u=u.right;else if(a.hasNext())a.next(),c.push([0,u]),u=u.mid;else{for(i?(u.left=void 0,u.mid=void 0,u.right=void 0):u.value=void 0;c.length>0&&u.isEmpty();){let[m,w]=c.pop();switch(m){case 1:w.left=void 0;break;case 0:w.mid=void 0;break;case-1:w.right=void 0;break}u=w}break}}}findSubstr(r){const i=this._iter.reset(r);let a=this._root,c;for(;a;){const u=i.cmp(a.segment);if(u>0)a=a.left;else if(u<0)a=a.right;else if(i.hasNext())i.next(),c=a.value||c,a=a.mid;else break}return a&&a.value||c}findSuperstr(r){const i=this._iter.reset(r);let a=this._root;for(;a;){const c=i.cmp(a.segment);if(c>0)a=a.left;else if(c<0)a=a.right;else if(i.hasNext())i.next(),a=a.mid;else return a.mid?this._entries(a.mid):void 0}}forEach(r){for(const[i,a]of this)r(a,i)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(r,i=0){if(i>5e3){console.log("potential CYCLE detected",new Error().stack);return}r&&(yield*this._entries(r.left,i++),r.value&&(yield[r.key,r.value]),yield*this._entries(r.mid,i++),yield*this._entries(r.right,i++))}}e.TernarySearchTree=D;class E{constructor(r,i){this[L]="ResourceMap",r instanceof E?(this.map=new Map(r.map),this.toKey=i??E.defaultToKey):(this.map=new Map,this.toKey=r??E.defaultToKey)}set(r,i){return this.map.set(this.toKey(r),i),this}get(r){return this.map.get(this.toKey(r))}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,i){typeof i!="undefined"&&(r=r.bind(i));for(let[a,c]of this.map)r(c,y.URI.parse(a),this)}values(){return this.map.values()}*keys(){for(let r of this.map.keys())yield y.URI.parse(r)}*entries(){for(let r of this.map.entries())yield[y.URI.parse(r[0]),r[1]]}*[(L=Symbol.toStringTag,Symbol.iterator)](){for(let r of this.map)yield[y.URI.parse(r[0]),r[1]]}}e.ResourceMap=E,E.defaultToKey=t=>t.toString();var b;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(b=e.Touch||(e.Touch={}));class g{constructor(){this[A]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var r;return(r=this._head)===null||r===void 0?void 0:r.value}get last(){var r;return(r=this._tail)===null||r===void 0?void 0:r.value}has(r){return this._map.has(r)}get(r,i=0){const a=this._map.get(r);if(!!a)return i!==0&&this.touch(a,i),a.value}set(r,i,a=0){let c=this._map.get(r);if(c)c.value=i,a!==0&&this.touch(c,a);else{switch(c={key:r,value:i,next:void 0,previous:void 0},a){case 0:this.addItemLast(c);break;case 1:this.addItemFirst(c);break;case 2:this.addItemLast(c);break;default:this.addItemLast(c);break}this._map.set(r,c),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const i=this._map.get(r);if(!!i)return this._map.delete(r),this.removeItem(i),this._size--,i.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,i){const a=this._state;let c=this._head;for(;c;){if(i?r.bind(i)(c.value,c.key,this):r(c.value,c.key,this),this._state!==a)throw new Error("LinkedMap got modified during iteration.");c=c.next}}keys(){const r=this,i=this._state;let a=this._head;const c={[Symbol.iterator](){return c},next(){if(r._state!==i)throw new Error("LinkedMap got modified during iteration.");if(a){const u={value:a.key,done:!1};return a=a.next,u}else return{value:void 0,done:!0}}};return c}values(){const r=this,i=this._state;let a=this._head;const c={[Symbol.iterator](){return c},next(){if(r._state!==i)throw new Error("LinkedMap got modified during iteration.");if(a){const u={value:a.value,done:!1};return a=a.next,u}else return{value:void 0,done:!0}}};return c}entries(){const r=this,i=this._state;let a=this._head;const c={[Symbol.iterator](){return c},next(){if(r._state!==i)throw new Error("LinkedMap got modified during iteration.");if(a){const u={value:[a.key,a.value],done:!1};return a=a.next,u}else return{value:void 0,done:!0}}};return c}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let i=this._head,a=this.size;for(;i&&a>r;)this._map.delete(i.key),i=i.next,a--;this._head=i,this._size=a,i&&(i.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const i=r.next,a=r.previous;if(!i||!a)throw new Error("Invalid list");i.previous=a,a.next=i}r.next=void 0,r.previous=void 0,this._state++}touch(r,i){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(i!==1&&i!==2)){if(i===1){if(r===this._head)return;const a=r.next,c=r.previous;r===this._tail?(c.next=void 0,this._tail=c):(a.previous=c,c.next=a),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(i===2){if(r===this._tail)return;const a=r.next,c=r.previous;r===this._head?(a.previous=void 0,this._head=a):(a.previous=c,c.next=a),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((i,a)=>{r.push([a,i])}),r}fromJSON(r){this.clear();for(const[i,a]of r)this.set(i,a)}}e.LinkedMap=g;class o extends g{constructor(r,i=1){super();this._limit=r,this._ratio=Math.min(Math.max(0,i),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,i=2){return super.get(r,i)}peek(r){return super.get(r,0)}set(r,i){return super.set(r,i,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=o;class s{constructor(r){O.set(this,void 0),ft(this,O,r,"f")}get size(){return ze(this,O,"f").size}forEach(r,i){ze(this,O,"f").forEach(r,i)}get(r){return ze(this,O,"f").get(r)}has(r){return ze(this,O,"f").has(r)}entries(){return ze(this,O,"f").entries()}keys(){return ze(this,O,"f").keys()}values(){return ze(this,O,"f").values()}[(O=new WeakMap,Symbol.iterator)](){return ze(this,O,"f").entries()}}e.ReadonlyMapView=s}),define(Z[90],ee([0,1,25,22,5]),function(H,e,y,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function A(S){return JSON.stringify(S,P)}e.stringify=A;function O(S){let n=JSON.parse(S);return n=p(n),n}e.parse=O;function P(S,n){return n instanceof RegExp?{$mid:2,source:n.source,flags:R.regExpFlags(n)}:n}function p(S,n=0){if(!S||n>200)return S;if(typeof S=="object"){switch(S.$mid){case 1:return L.URI.revive(S);case 2:return new RegExp(S.source,S.flags)}if(S instanceof y.VSBuffer||S instanceof Uint8Array)return S;if(Array.isArray(S))for(let v=0;v<S.length;++v)S[v]=p(S[v],n+1);else for(const v in S)Object.hasOwnProperty.call(S,v)&&(S[v]=p(S[v],n+1))}return S}e.revive=p}),define(Z[16],ee([0,1,5,6]),function(H,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var L;(function(P){P.inMemory="inmemory",P.vscode="vscode",P.internal="private",P.walkThrough="walkThrough",P.walkThroughSnippet="walkThroughSnippet",P.http="http",P.https="https",P.file="file",P.mailto="mailto",P.untitled="untitled",P.data="data",P.command="command",P.vscodeRemote="vscode-remote",P.vscodeRemoteResource="vscode-remote-resource",P.userData="vscode-userdata",P.vscodeCustomEditor="vscode-custom-editor",P.vscodeNotebook="vscode-notebook",P.vscodeNotebookCell="vscode-notebook-cell",P.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",P.vscodeNotebookCellOutput="vscode-notebook-cell-output",P.vscodeSettings="vscode-settings",P.vscodeWorkspaceTrust="vscode-workspace-trust",P.vscodeTerminal="vscode-terminal",P.webviewPanel="webview-panel",P.vscodeWebview="vscode-webview",P.extension="extension",P.vscodeFileResource="vscode-file",P.tmp="tmp"})(L=e.Schemas||(e.Schemas={}));class A{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(p){this._preferredWebSchema=p}setDelegate(p){this._delegate=p}set(p,S,n){this._hosts[p]=S,this._ports[p]=n}setConnectionToken(p,S){this._connectionTokens[p]=S}rewrite(p){if(this._delegate)return this._delegate(p);const S=p.authority;let n=this._hosts[S];n&&n.indexOf(":")!==-1&&(n=`[${n}]`);const v=this._ports[S],h=this._connectionTokens[S];let C=`path=${encodeURIComponent(p.path)}`;return typeof h=="string"&&(C+=`&tkn=${encodeURIComponent(h)}`),y.URI.from({scheme:R.isWeb?this._preferredWebSchema:L.vscodeRemoteResource,authority:`${n}:${v}`,path:"/vscode-remote-resource",query:C})}}e.RemoteAuthorities=new A;class O{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(p,S,n){const v=this.toUri(p,S);return v.scheme===L.vscodeRemote?e.RemoteAuthorities.rewrite(v):R.isNative&&(n||R.isPreferringBrowserCodeLoad)&&v.scheme===L.file?v.with({scheme:L.vscodeFileResource,authority:v.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):v}asFileUri(p,S){const n=this.toUri(p,S);return n.scheme===L.vscodeFileResource?n.with({scheme:L.file,authority:n.authority!==this.FALLBACK_AUTHORITY?n.authority:null,query:null,fragment:null}):n}toUri(p,S){return y.URI.isUri(p)?p:y.URI.parse(S.toUrl(p))}}e.FileAccess=new O}),define(Z[67],ee([0,1,38]),function(H,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=e.canNormalize=void 0,e.canNormalize=typeof String.prototype.normalize=="function";const R=new y.LRUCache(1e4);function L(S){return p(S,"NFC",R)}e.normalizeNFC=L;const A=new y.LRUCache(1e4);function O(S){return p(S,"NFD",A)}e.normalizeNFD=O;const P=/[^\u0000-\u0080]/;function p(S,n,v){if(!e.canNormalize||!S)return S;const h=v.get(S);if(h)return h;let C;return P.test(S)?C=S.normalize(n):C=S,v.set(S,C),C}e.removeAccents=function(){if(e.canNormalize){const S=/[\u0300-\u036f]/g;return function(n){return O(n).replace(S,"")}}else return function(S){return S}}()}),define(Z[14],ee([0,1,41,7,5,22,16,6]),function(H,e,y,R,L,A,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function p(C){return L.uriToFsPath(C,!0)}e.originalFSPath=p;class S{constructor(f){this._ignorePathCasing=f}compare(f,I,D=!1){return f===I?0:A.compare(this.getComparisonKey(f,D),this.getComparisonKey(I,D))}isEqual(f,I,D=!1){return f===I?!0:!f||!I?!1:this.getComparisonKey(f,D)===this.getComparisonKey(I,D)}getComparisonKey(f,I=!1){return f.with({path:this._ignorePathCasing(f)?f.path.toLowerCase():void 0,fragment:I?null:void 0}).toString()}ignorePathCasing(f){return this._ignorePathCasing(f)}isEqualOrParent(f,I,D=!1){if(f.scheme===I.scheme){if(f.scheme===O.Schemas.file)return y.isEqualOrParent(p(f),p(I),this._ignorePathCasing(f))&&f.query===I.query&&(D||f.fragment===I.fragment);if(e.isEqualAuthority(f.authority,I.authority))return y.isEqualOrParent(f.path,I.path,this._ignorePathCasing(f),"/")&&f.query===I.query&&(D||f.fragment===I.fragment)}return!1}joinPath(f,...I){return L.URI.joinPath(f,...I)}basenameOrAuthority(f){return e.basename(f)||f.authority}basename(f){return R.posix.basename(f.path)}extname(f){return R.posix.extname(f.path)}dirname(f){if(f.path.length===0)return f;let I;return f.scheme===O.Schemas.file?I=L.URI.file(R.dirname(p(f))).path:(I=R.posix.dirname(f.path),f.authority&&I.length&&I.charCodeAt(0)!==47&&(console.error(`dirname("${f.toString})) resulted in a relative path`),I="/")),f.with({path:I})}normalizePath(f){if(!f.path.length)return f;let I;return f.scheme===O.Schemas.file?I=L.URI.file(R.normalize(p(f))).path:I=R.posix.normalize(f.path),f.with({path:I})}relativePath(f,I){if(f.scheme!==I.scheme||!e.isEqualAuthority(f.authority,I.authority))return;if(f.scheme===O.Schemas.file){const b=R.relative(p(f),p(I));return P.isWindows?y.toSlashes(b):b}let D=f.path||"/",E=I.path||"/";if(this._ignorePathCasing(f)){let b=0;for(const g=Math.min(D.length,E.length);b<g&&!(D.charCodeAt(b)!==E.charCodeAt(b)&&D.charAt(b).toLowerCase()!==E.charAt(b).toLowerCase());b++);D=E.substr(0,b)+D.substr(b)}return R.posix.relative(D,E)}resolvePath(f,I){if(f.scheme===O.Schemas.file){const D=L.URI.file(R.resolve(p(f),I));return f.with({authority:D.authority,path:D.path})}return I=y.toPosixPath(I),f.with({path:R.posix.resolve(f.path,I)})}isAbsolutePath(f){return!!f.path&&f.path[0]==="/"}isEqualAuthority(f,I){return f===I||A.equalsIgnoreCase(f,I)}hasTrailingPathSeparator(f,I=R.sep){if(f.scheme===O.Schemas.file){const D=p(f);return D.length>y.getRoot(D).length&&D[D.length-1]===I}else{const D=f.path;return D.length>1&&D.charCodeAt(D.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(f.fsPath)}}removeTrailingPathSeparator(f,I=R.sep){return e.hasTrailingPathSeparator(f,I)?f.with({path:f.path.substr(0,f.path.length-1)}):f}addTrailingPathSeparator(f,I=R.sep){let D=!1;if(f.scheme===O.Schemas.file){const E=p(f);D=E!==void 0&&E.length===y.getRoot(E).length&&E[E.length-1]===I}else{I="/";const E=f.path;D=E.length===1&&E.charCodeAt(E.length-1)===47}return!D&&!e.hasTrailingPathSeparator(f,I)?f.with({path:f.path+"/"}):f}}e.ExtUri=S,e.extUri=new S(()=>!1),e.extUriBiasedIgnorePathCase=new S(C=>C.scheme===O.Schemas.file?!P.isLinux:!0),e.extUriIgnorePathCase=new S(C=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function n(C,f){const I=[];for(let D=0;D<C.length;D++){const E=f(C[D]);C.some((b,g)=>g===D?!1:e.isEqualOrParent(E,f(b)))||I.push(C[D])}return I}e.distinctParents=n;var v;(function(C){C.META_DATA_LABEL="label",C.META_DATA_DESCRIPTION="description",C.META_DATA_SIZE="size",C.META_DATA_MIME="mime";function f(I){const D=new Map;I.path.substring(I.path.indexOf(";")+1,I.path.lastIndexOf(";")).split(";").forEach(g=>{const[o,s]=g.split(":");o&&s&&D.set(o,s)});const b=I.path.substring(0,I.path.indexOf(";"));return b&&D.set(C.META_DATA_MIME,b),D}C.parseMetaData=f})(v=e.DataUri||(e.DataUri={}));function h(C,f,I){if(f){let D=C.path;return D&&D[0]!==R.posix.sep&&(D=R.posix.sep+D),C.with({scheme:I,authority:f,path:D})}return C.with({scheme:I})}e.toLocalResource=h}),define(Z[8],ee([0,1,29,11,3,2,66,14]),function(H,e,y,R,L,A,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function p(M){return!!M&&typeof M.then=="function"}e.isThenable=p;function S(M){const U=new y.CancellationTokenSource,k=M(U.token),F=new Promise((N,q)=>{U.token.onCancellationRequested(()=>{q(R.canceled())}),Promise.resolve(k).then(W=>{U.dispose(),N(W)},W=>{U.dispose(),q(W)})});return new class{cancel(){U.cancel()}then(N,q){return F.then(N,q)}catch(N){return this.then(void 0,N)}finally(N){return F.finally(N)}}}e.createCancelablePromise=S;function n(M,U,k){return Promise.race([M,new Promise(F=>U.onCancellationRequested(()=>F(k)))])}e.raceCancellation=n;async function v(M){let U=-1;const k=M.map((N,q)=>N.then(W=>(U=q,W))),F=await Promise.race(k);return M.forEach((N,q)=>{q!==U&&N.cancel()}),F}e.raceCancellablePromises=v;function h(M,U,k){let F;const N=setTimeout(()=>{F==null||F(void 0),k==null||k()},U);return Promise.race([M.finally(()=>clearTimeout(N)),new Promise(q=>F=q)])}e.raceTimeout=h;function C(M){return new Promise((U,k)=>{const F=M();p(F)?F.then(U,k):U(F)})}e.asPromise=C;class f{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(U){if(this.activePromise){if(this.queuedPromiseFactory=U,!this.queuedPromise){const k=()=>{this.queuedPromise=null;const F=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,F};this.queuedPromise=new Promise(F=>{this.activePromise.then(k,k).then(F)})}return new Promise((k,F)=>{this.queuedPromise.then(k,F)})}return this.activePromise=U(),new Promise((k,F)=>{this.activePromise.then(N=>{this.activePromise=null,k(N)},N=>{this.activePromise=null,F(N)})})}}e.Throttler=f;class I{constructor(){this.current=Promise.resolve(null)}queue(U){return this.current=this.current.then(()=>U(),()=>U())}}e.Sequencer=I;class D{constructor(){this.promiseMap=new Map}queue(U,k){var F;const q=((F=this.promiseMap.get(U))!==null&&F!==void 0?F:Promise.resolve()).catch(()=>{}).then(k).finally(()=>{this.promiseMap.get(U)===q&&this.promiseMap.delete(U)});return this.promiseMap.set(U,q),q}}e.SequencerByKey=D;class E{constructor(U){this.defaultDelay=U,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(U,k=this.defaultDelay){return this.task=U,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((F,N)=>{this.doResolve=F,this.doReject=N}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const F=this.task;return this.task=null,F()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},k),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(R.canceled()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=E;class b{constructor(U){this.delayer=new E(U),this.throttler=new f}trigger(U,k){return this.delayer.trigger(()=>this.throttler.queue(U),k)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=b;class g{constructor(){this._isOpen=!1,this._promise=new Promise((U,k)=>{this._completePromise=U})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=g;class o extends g{constructor(U){super();this._timeout=setTimeout(()=>this.open(),U)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=o;function s(M,U){return U?new Promise((k,F)=>{const N=setTimeout(k,M);U.onCancellationRequested(()=>{clearTimeout(N),F(R.canceled())})}):S(k=>s(M,k))}e.timeout=s;function t(M,U=0){const k=setTimeout(M,U);return A.toDisposable(()=>clearTimeout(k))}e.disposableTimeout=t;function r(M){return M.then(void 0,U=>{})}e.ignoreErrors=r;function i(M){const U=[];let k=0;const F=M.length;function N(){return k<F?M[k++]():null}function q(W){W!=null&&U.push(W);const Q=N();return Q?Q.then(q):Promise.resolve(U)}return Promise.resolve(null).then(q)}e.sequence=i;function a(M,U=F=>!!F,k=null){let F=0;const N=M.length,q=()=>{if(F>=N)return Promise.resolve(k);const W=M[F++];return Promise.resolve(W()).then(X=>U(X)?Promise.resolve(X):q())};return q()}e.first=a;function c(M,U=F=>!!F,k=null){if(M.length===0)return Promise.resolve(k);let F=M.length;const N=()=>{var q,W;F=-1;for(const Q of M)(W=(q=Q).cancel)===null||W===void 0||W.call(q)};return new Promise((q,W)=>{for(const Q of M)Q.then(X=>{--F>=0&&U(X)?(N(),q(X)):F===0&&q(k)}).catch(X=>{--F>=0&&(N(),W(X))})})}e.firstParallel=c;class u{constructor(U){this._size=0,this.maxDegreeOfParalellism=U,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new L.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(U){return this._size++,new Promise((k,F)=>{this.outstandingPromises.push({factory:U,c:k,e:F}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const U=this.outstandingPromises.shift();this.runningPromises++;const k=U.factory();k.then(U.c,U.e),k.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=u;class l extends u{constructor(){super(1)}}e.Queue=l;class m{constructor(){this.queues=new Map}queueFor(U,k=P.extUri){const F=k.getComparisonKey(U);let N=this.queues.get(F);return N||(N=new l,L.Event.once(N.onFinished)(()=>{N==null||N.dispose(),this.queues.delete(F)}),this.queues.set(F,N)),N}dispose(){this.queues.forEach(U=>U.dispose()),this.queues.clear()}}e.ResourceQueue=m;class w{constructor(U,k){this._token=-1,typeof U=="function"&&typeof k=="number"&&this.setIfNotSet(U,k)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(U,k){this.cancel(),this._token=setTimeout(()=>{this._token=-1,U()},k)}setIfNotSet(U,k){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,U()},k))}}e.TimeoutTimer=w;class d{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(U,k){this.cancel(),this._token=setInterval(()=>{U()},k)}}e.IntervalTimer=d;class T{constructor(U,k){this.timeoutToken=-1,this.runner=U,this.timeout=k,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(U=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,U)}get delay(){return this.timeout}set delay(U){this.timeout=U}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=T;class _ extends T{constructor(U,k){super(U,k);this.units=[]}work(U){this.units.push(U),this.isScheduled()||this.schedule()}doRun(){const U=this.units;this.units=[],this.runner&&this.runner(U)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=_,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const M=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=U=>{const k=setTimeout(()=>U(M));let F=!1;return{dispose(){F||(F=!0,clearTimeout(k))}}}}else e.runWhenIdle=(M,U)=>{const k=requestIdleCallback(M,typeof U=="number"?{timeout:U}:void 0);let F=!1;return{dispose(){F||(F=!0,cancelIdleCallback(k))}}}}();class j{constructor(U){this._didRun=!1,this._executor=()=>{try{this._value=U()}catch(k){this._error=k}finally{this._didRun=!0}},this._handle=e.runWhenIdle(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=j;async function $(M,U,k){let F;for(let N=0;N<k;N++)try{return await M()}catch(q){F=q,await s(U)}throw F}e.retry=$;class K{hasPending(U){return this._pending?typeof U=="number"?this._pending.taskId===U:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var U;(U=this._pending)===null||U===void 0||U.cancel()}setPending(U,k,F){return this._pending={taskId:U,cancel:()=>F==null?void 0:F(),promise:k},k.then(()=>this.donePending(U),()=>this.donePending(U)),k}donePending(U){this._pending&&U===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const U=this._next;this._next=void 0,U.run().then(U.promiseResolve,U.promiseReject)}}setNext(U){if(this._next)this._next.run=U;else{let k,F;const N=new Promise((q,W)=>{k=q,F=W});this._next={run:U,promise:N,promiseResolve:k,promiseReject:F}}return this._next.promise}}e.TaskSequentializer=K;class B{constructor(U){this.interval=U,this.lastIncrementTime=0,this.value=0}increment(){const U=Date.now();return U-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=U,this.value=0),this.value++,this.value}}e.IntervalCounter=B;class z{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((U,k)=>{this.completeCallback=U,this.errorCallback=k})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(U){return new Promise(k=>{this.completeCallback(U),this.resolved=!0,k()})}error(U){return new Promise(k=>{this.errorCallback(U),this.rejected=!0,k()})}cancel(){new Promise(U=>{this.errorCallback(R.canceled()),this.rejected=!0,U()})}}e.DeferredPromise=z;class G extends L.Emitter{async fireAsync(U,k,F){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new O.LinkedList);for(const N of this._listeners)this._asyncDeliveryQueue.push([N,U]);for(;this._asyncDeliveryQueue.size>0&&!k.isCancellationRequested;){const[N,q]=this._asyncDeliveryQueue.shift(),W=[],Q=Object.assign(Object.assign({},q),{waitUntil:X=>{if(Object.isFrozen(W))throw new Error("waitUntil can NOT be called asynchronous");F&&(X=F(X,typeof N=="function"?N:N[0])),W.push(X)}});try{typeof N=="function"?N.call(void 0,Q):N[0].call(N[1],Q)}catch(X){R.onUnexpectedError(X);continue}Object.freeze(W),await V.settled(W).catch(X=>R.onUnexpectedError(X))}}}}e.AsyncEmitter=G;var V;(function(M){async function U(q){return typeof Promise.allSettled=="function"?k(q):F(q)}M.allSettled=U;async function k(q){return Promise.allSettled(q)}async function F(q){return Promise.all(q.map(W=>W.then(Q=>({status:"fulfilled",value:Q}),Q=>({status:"rejected",reason:Q}))))}async function N(q){let W;const Q=await Promise.all(q.map(X=>X.then(ie=>ie,ie=>{W||(W=ie)})));if(typeof W!="undefined")throw W;return Q}M.settled=N})(V=e.Promises||(e.Promises={}))}),define(Z[91],ee([0,1,22,41,7,38,8]),function(H,e,y,R,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function P(){return Object.create(null)}e.getEmptyExpression=P;const p="**",S="/",n="[/\\\\]",v="[^/\\\\]",h=/\//g;function C(k){switch(k){case 0:return"";case 1:return`${v}*?`;default:return`(?:${n}|${v}+${n}|${n}${v}+)*?`}}function f(k,F){if(!k)return[];const N=[];let q=!1,W=!1,Q="";for(const X of k){switch(X){case F:if(!q&&!W){N.push(Q),Q="";continue}break;case"{":q=!0;break;case"}":q=!1;break;case"[":W=!0;break;case"]":W=!1;break}Q+=X}return Q&&N.push(Q),N}e.splitGlobAware=f;function I(k){if(!k)return"";let F="";const N=f(k,S);if(N.every(q=>q===p))F=".*";else{let q=!1;N.forEach((W,Q)=>{if(W===p){q||(F+=C(2),q=!0);return}let X=!1,ie="",ne=!1,ce="";for(const le of W){if(le!=="}"&&X){ie+=le;continue}if(ne&&(le!=="]"||!ce)){let ve;le==="-"?ve=le:(le==="^"||le==="!")&&!ce?ve="^":le===S?ve="":ve=y.escapeRegExpCharacters(le),ce+=ve;continue}switch(le){case"{":X=!0;continue;case"[":ne=!0;continue;case"}":F+=`(?:${f(ie,",").map(Ce=>I(Ce)).join("|")})`,X=!1,ie="";break;case"]":F+="["+ce+"]",ne=!1,ce="";break;case"?":F+=v;continue;case"*":F+=C(1);continue;default:F+=y.escapeRegExpCharacters(le)}}Q<N.length-1&&(N[Q+1]!==p||Q+2<N.length)&&(F+=n),q=!1})}return F}const D=/^\*\*\/\*\.[\w\.-]+$/,E=/^\*\*\/([\w\.-]+)\/?$/,b=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,g=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,s=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new A.LRUCache(1e4),r=function(){return!1},i=function(){return null};function a(k,F){if(!k)return i;let N;typeof k!="string"?N=k.pattern:N=k,N=N.trim();const q=`${N}_${!!F.trimForExclusions}`;let W=t.get(q);if(W)return c(W,k);let Q;if(D.test(N)){const X=N.substr(4);W=function(ie,ne){return typeof ie=="string"&&ie.endsWith(X)?N:null}}else(Q=E.exec(u(N,F)))?W=l(Q[1],N):(F.trimForExclusions?g:b).test(N)?W=m(N,F):(Q=o.exec(u(N,F)))?W=w(Q[1].substr(1),N,!0):(Q=s.exec(u(N,F)))?W=w(Q[1],N,!1):W=d(N);return t.set(q,W),c(W,k)}function c(k,F){return typeof F=="string"?k:function(N,q){return R.isEqualOrParent(N,F.base)?k(L.relative(F.base,N),q):null}}function u(k,F){return F.trimForExclusions&&k.endsWith("/**")?k.substr(0,k.length-2):k}function l(k,F){const N=`/${k}`,q=`\\${k}`,W=function(X,ie){return typeof X!="string"?null:ie?ie===k?F:null:X===k||X.endsWith(N)||X.endsWith(q)?F:null},Q=[k];return W.basenames=Q,W.patterns=[F],W.allBasenames=Q,W}function m(k,F){const N=U(k.slice(1,-1).split(",").map(ie=>a(ie,F)).filter(ie=>ie!==i),k),q=N.length;if(!q)return i;if(q===1)return N[0];const W=function(ie,ne){for(let ce=0,le=N.length;ce<le;ce++)if(N[ce](ie,ne))return k;return null},Q=N.find(ie=>!!ie.allBasenames);Q&&(W.allBasenames=Q.allBasenames);const X=N.reduce((ie,ne)=>ne.allPaths?ie.concat(ne.allPaths):ie,[]);return X.length&&(W.allPaths=X),W}function w(k,F,N){const q=L.sep===L.posix.sep,W=q?k:k.replace(h,L.sep),Q=L.sep+W,X=L.posix.sep+k,ie=N?function(ne,ce){return typeof ne=="string"&&(ne===W||ne.endsWith(Q)||!q&&(ne===k||ne.endsWith(X)))?F:null}:function(ne,ce){return typeof ne=="string"&&(ne===W||!q&&ne===k)?F:null};return ie.allPaths=[(N?"*/":"./")+k],ie}function d(k){try{const F=new RegExp(`^${I(k)}$`);return function(N){return F.lastIndex=0,typeof N=="string"&&F.test(N)?k:null}}catch(F){return i}}function T(k,F,N){return!k||typeof F!="string"?!1:_(k)(F,void 0,N)}e.match=T;function _(k,F={}){if(!k)return r;if(typeof k=="string"||B(k)){const N=a(k,F);if(N===i)return r;const q=function(W,Q){return!!N(W,Q)};return N.allBasenames&&(q.allBasenames=N.allBasenames),N.allPaths&&(q.allPaths=N.allPaths),q}return V(k,F)}e.parse=_;function j(k){if(!k)return;let F;return N=>(F||(F=(k()||Promise.resolve([])).then(q=>q?K(q):{})),F.then(q=>!!q[N]))}e.hasSiblingPromiseFn=j;function $(k){if(!k)return;let F;return N=>{if(!F){const q=k();F=q?K(q):{}}return!!F[N]}}e.hasSiblingFn=$;function K(k){const F={};for(const N of k)F[N]=!0;return F}function B(k){const F=k;return F&&typeof F.base=="string"&&typeof F.pattern=="string"}e.isRelativePattern=B;function z(k){return k.allBasenames||[]}e.getBasenameTerms=z;function G(k){return k.allPaths||[]}e.getPathTerms=G;function V(k,F){const N=U(Object.getOwnPropertyNames(k).map(ie=>M(ie,k[ie],F)).filter(ie=>ie!==i)),q=N.length;if(!q)return i;if(!N.some(ie=>!!ie.requiresSiblings)){if(q===1)return N[0];const ie=function(le,ve){for(let pe=0,Ce=N.length;pe<Ce;pe++){const Ae=N[pe](le,ve);if(Ae)return Ae}return null},ne=N.find(le=>!!le.allBasenames);ne&&(ie.allBasenames=ne.allBasenames);const ce=N.reduce((le,ve)=>ve.allPaths?le.concat(ve.allPaths):le,[]);return ce.length&&(ie.allPaths=ce),ie}const W=function(ie,ne,ce){let le;for(let ve=0,pe=N.length;ve<pe;ve++){const Ce=N[ve];Ce.requiresSiblings&&ce&&(ne||(ne=L.basename(ie)),le||(le=ne.substr(0,ne.length-L.extname(ie).length)));const Ae=Ce(ie,ne,le,ce);if(Ae)return Ae}return null},Q=N.find(ie=>!!ie.allBasenames);Q&&(W.allBasenames=Q.allBasenames);const X=N.reduce((ie,ne)=>ne.allPaths?ie.concat(ne.allPaths):ie,[]);return X.length&&(W.allPaths=X),W}function M(k,F,N){if(F===!1)return i;const q=a(k,N);if(q===i)return i;if(typeof F=="boolean")return q;if(F){const W=F.when;if(typeof W=="string"){const Q=(X,ie,ne,ce)=>{if(!ce||!q(X,ie))return null;const le=W.replace("$(basename)",ne),ve=ce(le);return O.isThenable(ve)?ve.then(pe=>pe?k:null):ve?k:null};return Q.requiresSiblings=!0,Q}}return q}function U(k,F){const N=k.filter(ie=>!!ie.basenames);if(N.length<2)return k;const q=N.reduce((ie,ne)=>{const ce=ne.basenames;return ce?ie.concat(ce):ie},[]);let W;if(F){W=[];for(let ie=0,ne=q.length;ie<ne;ie++)W.push(F)}else W=N.reduce((ie,ne)=>{const ce=ne.patterns;return ce?ie.concat(ce):ie},[]);const Q=function(ie,ne){if(typeof ie!="string")return null;if(!ne){let le;for(le=ie.length;le>0;le--){const ve=ie.charCodeAt(le-1);if(ve===47||ve===92)break}ne=ie.substr(le)}const ce=q.indexOf(ne);return ce!==-1?W[ce]:null};Q.basenames=q,Q.patterns=W,Q.allBasenames=q;const X=k.filter(ie=>!ie.basenames);return X.push(Q),X}}),define(Z[92],ee([0,1,5]),function(H,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function R(n){return n.toJSON()}class L{constructor(v){this._uriTransformer=v}transformIncoming(v){const h=this._uriTransformer.transformIncoming(v);return h===v?v:R(y.URI.from(h))}transformOutgoing(v){const h=this._uriTransformer.transformOutgoing(v);return h===v?v:R(y.URI.from(h))}transformOutgoingURI(v){const h=this._uriTransformer.transformOutgoing(v);return h===v?v:y.URI.from(h)}transformOutgoingScheme(v){return this._uriTransformer.transformOutgoingScheme(v)}}e.URITransformer=L,e.DefaultURITransformer=new class{transformIncoming(n){return n}transformOutgoing(n){return n}transformOutgoingURI(n){return n}transformOutgoingScheme(n){return n}};function A(n,v,h){if(!n||h>200)return null;if(typeof n=="object"){if(n instanceof y.URI)return v.transformOutgoing(n);for(let C in n)if(Object.hasOwnProperty.call(n,C)){const f=A(n[C],v,h+1);f!==null&&(n[C]=f)}}return null}function O(n,v){const h=A(n,v,0);return h===null?n:h}e.transformOutgoingURIs=O;function P(n,v,h,C){if(!n||C>200)return null;if(typeof n=="object"){if(n.$mid===1)return h?y.URI.revive(v.transformIncoming(n)):v.transformIncoming(n);for(let f in n)if(Object.hasOwnProperty.call(n,f)){const I=P(n[f],v,h,C+1);I!==null&&(n[f]=I)}}return null}function p(n,v){const h=P(n,v,!1,0);return h===null?n:h}e.transformIncomingURIs=p;function S(n,v){const h=P(n,v,!0,0);return h===null?n:h}e.transformAndReviveIncomingURIs=S}),define(Z[30],ee([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const y=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(p){return y.test(p)}e.isUUID=R;const L=new Uint8Array(16),A=[];for(let p=0;p<256;p++)A.push(p.toString(16).padStart(2,"0"));let O;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?O=crypto.getRandomValues.bind(crypto):O=function(p){for(let S=0;S<p.length;S++)p[S]=Math.floor(Math.random()*256);return p};function P(){O(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let p=0,S="";return S+=A[L[p++]],S+=A[L[p++]],S+=A[L[p++]],S+=A[L[p++]],S+="-",S+=A[L[p++]],S+=A[L[p++]],S+="-",S+=A[L[p++]],S+=A[L[p++]],S+="-",S+=A[L[p++]],S+=A[L[p++]],S+="-",S+=A[L[p++]],S+=A[L[p++]],S+=A[L[p++]],S+=A[L[p++]],S+=A[L[p++]],S+=A[L[p++]],S}e.generateUuid=P}),define(Z[68],ee([0,1,206]),function(H,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class R{constructor(A="utf8"){this.stringDecoder=new y.StringDecoder(A),this.remaining=null}write(A){const O=[],P=this.remaining?this.remaining+this.stringDecoder.write(A):this.stringDecoder.write(A);if(P.length<1)return O;let p=0,S,n=p;for(;n<P.length;)if(S=P.charCodeAt(n),S===13||S===10){if(O.push(P.substring(p,n)),n++,n<P.length){const v=S;S=P.charCodeAt(n),(v===13&&S===10||v===10&&S===13)&&n++}p=n}else n++;return this.remaining=p<P.length?P.substr(p):null,O}end(){return this.remaining}}e.LineDecoder=R}),define(Z[93],ee([0,1,35]),function(H,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const R=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function L(P){const p=P.replace(/\-/g,":").toLowerCase();return!R.has(p)}function A(){return new Promise(async(P,p)=>{const S=setTimeout(()=>p("Unable to retrieve mac address (timeout after 10s)"),1e4);try{P(await O())}catch(n){p(n)}finally{clearTimeout(S)}})}e.getMac=A;function O(){return new Promise((P,p)=>{try{const S=y.networkInterfaces();for(let n in S){const v=S[n];if(v){for(const{mac:h}of v)if(L(h))return P(h)}}p("Unable to retrieve mac address (unexpected format)")}catch(S){p(S)}})}}),define(Z[94],ee([0,1,11,30,35,38,93]),function(H,e,y,R,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAdress(n){return this._virtualMachineOUIs||(this._virtualMachineOUIs=A.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(n)}value(){if(this._value===void 0){let n=0,v=0;const h=L.networkInterfaces();for(let C in h){const f=h[C];if(f)for(const{mac:I,internal:D}of f)D||(v+=1,this._isVirtualMachineMacAdress(I.toUpperCase())&&(n+=1))}this._value=v>0?n/v:0}return this._value}};let P;async function p(){return P||(P=(async()=>await S()||R.generateUuid())()),P}e.getMachineId=p;async function S(){try{const n=await new Promise((h,C)=>{H(["crypto"],h,C)}),v=await O.getMac();return n.createHash("sha256").update(v,"utf8").digest("hex")}catch(n){y.onUnexpectedError(n);return}}}),define(Z[17],ee([0,1,42,35,207,7,8,6,41,30,67,14,5]),function(H,e,y,R,L,A,O,P,p,S,n,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.exists=e.copy=e.move=e.writeFileSync=e.writeFile=e.SymlinkSupport=e.whenDeleted=e.readDirsInDir=e.readdirSync=e.readdir=e.rimrafSync=e.rimraf=e.RimRafMode=void 0;var C;(function(V){V[V.UNLINK=0]="UNLINK",V[V.MOVE=1]="MOVE"})(C=e.RimRafMode||(e.RimRafMode={}));async function f(V,M=C.UNLINK){if(p.isRootOrDriveLetter(V))throw new Error("rimraf - will refuse to recursively delete root");return M===C.UNLINK?D(V):I(V)}e.rimraf=f;async function I(V){try{const M=A.join(R.tmpdir(),S.generateUuid());try{await G.rename(V,M)}catch(U){return D(V)}D(M).catch(U=>{})}catch(M){if(M.code!=="ENOENT")throw M}}async function D(V){return G.rmdir(V,{recursive:!0,maxRetries:3})}function E(V){if(p.isRootOrDriveLetter(V))throw new Error("rimraf - will refuse to recursively delete root");y.rmdirSync(V,{recursive:!0})}e.rimrafSync=E;async function b(V,M){return s(await(M?g(V):G.readdir(V)))}e.readdir=b;async function g(V){try{return await G.readdir(V,{withFileTypes:!0})}catch(k){console.warn("[node.js fs] readdir with filetypes failed with error: ",k)}const M=[],U=await b(V);for(const k of U){let F=!1,N=!1,q=!1;try{const W=await G.lstat(A.join(V,k));F=W.isFile(),N=W.isDirectory(),q=W.isSymbolicLink()}catch(W){console.warn("[node.js fs] unexpected error from lstat after readdir: ",W)}M.push({name:k,isFile:()=>F,isDirectory:()=>N,isSymbolicLink:()=>q})}return M}function o(V){return s(y.readdirSync(V))}e.readdirSync=o;function s(V){return V.map(M=>typeof M=="string"?P.isMacintosh?n.normalizeNFC(M):M:(M.name=P.isMacintosh?n.normalizeNFC(M.name):M.name,M))}async function t(V){const M=await b(V),U=[];for(const k of M)await i.existsDirectory(A.join(V,k))&&U.push(k);return U}e.readDirsInDir=t;function r(V,M=1e3){return new Promise(U=>{let k=!1;const F=setInterval(()=>{k||(k=!0,y.access(V,N=>{k=!1,N&&(clearInterval(F),U(void 0))}))},M)})}e.whenDeleted=r;var i;(function(V){async function M(F){let N;try{if(N=await G.lstat(F),!N.isSymbolicLink())return{stat:N}}catch(q){}try{return{stat:await G.stat(F),symbolicLink:(N==null?void 0:N.isSymbolicLink())?{dangling:!1}:void 0}}catch(q){if(q.code==="ENOENT"&&N)return{stat:N,symbolicLink:{dangling:!0}};if(P.isWindows&&q.code==="EACCES")try{return{stat:await G.stat(await G.readlink(F)),symbolicLink:{dangling:!1}}}catch(W){if(W.code==="ENOENT"&&N)return{stat:N,symbolicLink:{dangling:!0}};throw W}throw q}}V.stat=M;async function U(F){try{const{stat:N,symbolicLink:q}=await V.stat(F);return N.isFile()&&(q==null?void 0:q.dangling)!==!0}catch(N){}return!1}V.existsFile=U;async function k(F){try{const{stat:N,symbolicLink:q}=await V.stat(F);return N.isDirectory()&&(q==null?void 0:q.dangling)!==!0}catch(N){}return!1}V.existsDirectory=k})(i=e.SymlinkSupport||(e.SymlinkSupport={}));const a=new O.ResourceQueue;function c(V,M,U){return a.queueFor(h.URI.file(V),v.extUriBiasedIgnorePathCase).queue(()=>{const k=w(U);return new Promise((F,N)=>l(V,M,k,q=>q?N(q):F()))})}e.writeFile=c;let u=!0;function l(V,M,U,k){if(!u)return y.writeFile(V,M,{mode:U.mode,flag:U.flag},k);y.open(V,U.flag,U.mode,(F,N)=>{if(F)return k(F);y.writeFile(N,M,q=>{if(q)return y.close(N,()=>k(q));y.fdatasync(N,W=>(W&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",W),u=!1),y.close(N,Q=>k(Q))))})})}function m(V,M,U){const k=w(U);if(!u)return y.writeFileSync(V,M,{mode:k.mode,flag:k.flag});const F=y.openSync(V,k.flag,k.mode);try{y.writeFileSync(F,M);try{y.fdatasyncSync(F)}catch(N){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",N),u=!1}}finally{y.closeSync(F)}}e.writeFileSync=m;function w(V){return V?{mode:typeof V.mode=="number"?V.mode:438,flag:typeof V.flag=="string"?V.flag:"w"}:{mode:438,flag:"w"}}async function d(V,M){if(V===M)return;async function U(k){try{const F=await G.lstat(k);if(F.isDirectory()||F.isSymbolicLink())return;await G.utimes(k,F.atime,new Date)}catch(F){}}try{await G.rename(V,M),await U(M)}catch(k){if(V.toLowerCase()!==M.toLowerCase()&&k.code==="EXDEV"||V.endsWith("."))await T(V,M,{preserveSymlinks:!1}),await f(V,C.MOVE),await U(M);else throw k}}e.move=d;async function T(V,M,U){return j(V,M,{root:{source:V,target:M},options:U,handledSourcePaths:new Set})}e.copy=T;const _=511;async function j(V,M,U){if(U.handledSourcePaths.has(V))return;U.handledSourcePaths.add(V);const{stat:k,symbolicLink:F}=await i.stat(V);if(F){if(U.options.preserveSymlinks)try{return await B(V,M,U)}catch(N){console.warn("[node.js fs] copy of symlink failed: ",N)}if(F.dangling)return}return k.isDirectory()?$(V,M,k.mode&_,U):K(V,M,k.mode&_)}async function $(V,M,U,k){await G.mkdir(M,{recursive:!0,mode:U});const F=await b(V);for(const N of F)await j(A.join(V,N),A.join(M,N),k)}async function K(V,M,U){await G.copyFile(V,M),await G.chmod(M,U)}async function B(V,M,U){let k=await G.readlink(V);p.isEqualOrParent(k,U.root.source,!P.isLinux)&&(k=A.join(U.root.target,k.substr(U.root.source.length+1))),await G.symlink(k,M)}async function z(V){try{return await G.access(V),!0}catch(M){return!1}}e.exists=z;var G;(function(V){V.access=L.promisify(y.access),V.stat=L.promisify(y.stat),V.lstat=L.promisify(y.lstat),V.utimes=L.promisify(y.utimes),V.read=L.promisify(y.read),V.readFile=L.promisify(y.readFile),V.write=L.promisify(y.write),V.writeFile=L.promisify(y.writeFile),V.appendFile=L.promisify(y.appendFile),V.fdatasync=L.promisify(y.fdatasync),V.truncate=L.promisify(y.truncate),V.rename=L.promisify(y.rename),V.copyFile=L.promisify(y.copyFile),V.open=L.promisify(y.open),V.close=L.promisify(y.close),V.symlink=L.promisify(y.symlink),V.readlink=L.promisify(y.readlink),V.chmod=L.promisify(y.chmod),V.readdir=L.promisify(y.readdir),V.mkdir=L.promisify(y.mkdir),V.unlink=L.promisify(y.unlink),V.rmdir=L.promisify(y.rmdir),V.realpath=L.promisify(y.realpath)})(G=e.Promises||(e.Promises={}))}),define(Z[95],ee([0,1,42,22,7,17]),function(H,e,y,R,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function O(n){const v=L.dirname(n);if(n===v)return n;const h=(L.basename(n)||n).toLowerCase();try{const f=A.readdirSync(v).filter(I=>I.toLowerCase()===h);if(f.length===1){const I=O(v);if(I)return L.join(I,f[0])}else if(f.length>1){const I=f.indexOf(h);if(I>=0){const D=O(v);if(D)return L.join(D,f[I])}}}catch(C){}return null}e.realcaseSync=O;async function P(n){try{return await A.Promises.realpath(n)}catch(v){const h=S(n);return await A.Promises.access(h,y.constants.R_OK),h}}e.realpath=P;function p(n){try{return y.realpathSync(n)}catch(v){const h=S(n);return y.accessSync(h,y.constants.R_OK),h}}e.realpathSync=p;function S(n){return R.rtrim(L.normalize(n),L.sep)}});var Le=this&&this.__await||function(H){return this instanceof Le?(this.v=H,this):new Le(H)},lt=this&&this.__asyncGenerator||function(H,e,y){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var R=y.apply(H,e||[]),L,A=[];return L={},O("next"),O("throw"),O("return"),L[Symbol.asyncIterator]=function(){return this},L;function O(h){R[h]&&(L[h]=function(C){return new Promise(function(f,I){A.push([h,C,f,I])>1||P(h,C)})})}function P(h,C){try{p(R[h](C))}catch(f){v(A[0][3],f)}}function p(h){h.value instanceof Le?Promise.resolve(h.value.v).then(S,n):v(A[0][2],h)}function S(h){P("next",h)}function n(h){P("throw",h)}function v(h,C){h(C),A.shift(),A.length&&P(A[0][0],A[0][1])}},et=this&&this.__asyncValues||function(H){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var e=H[Symbol.asyncIterator],y;return e?e.call(H):(H=typeof __values=="function"?__values(H):H[Symbol.iterator](),y={},R("next"),R("throw"),R("return"),y[Symbol.asyncIterator]=function(){return this},y);function R(A){y[A]=H[A]&&function(O){return new Promise(function(P,p){O=H[A](O),L(P,p,O.done,O.value)})}}function L(A,O,P,p){Promise.resolve(p).then(function(S){A({value:S,done:P})},O)}};define(Z[96],ee([0,1,17,35,7]),function(H,e,y,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const A=/^\d+$/,O=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var p;(function(o){o[o.x64=0]="x64",o[o.x86=1]="x86",o[o.ARM=2]="ARM"})(p||(p={}));let S;switch(process.arch){case"ia32":case"x32":S=1;break;case"arm":case"arm64":S=2;break;default:S=0;break}let n;process.env.PROCESSOR_ARCHITEW6432?n=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?n=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?n=1:n=0;class v{constructor(s,t,r){this.exePath=s,this.displayName=t,this.knownToExist=r}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await y.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function h({useAlternateBitness:o=!1}={}){return o?S===0?process.env["ProgramFiles(x86)"]||null:n===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function C({useAlternateBitness:o=!1,findPreview:s=!1}={}){const t=h({useAlternateBitness:o});if(!t)return null;const r=L.join(t,"PowerShell");if(!await y.SymlinkSupport.existsDirectory(r))return null;let i=-1,a=null;for(const l of await y.readdir(r)){let m=-1;if(s){const d=l.indexOf("-");if(d<0)continue;const T=l.substring(0,d);if(!A.test(T)||l.substring(d+1)!=="preview")continue;m=parseInt(T,10)}else{if(!A.test(l))continue;m=parseInt(l,10)}if(m<=i)continue;const w=L.join(r,l,"pwsh.exe");!await y.SymlinkSupport.existsFile(w)||(a=w,i=m)}if(!a)return null;const c=t.includes("x86")?" (x86)":"",u=s?" Preview":"";return new v(a,`PowerShell${u}${c}`,!0)}async function f({findPreview:o}={}){if(!process.env.LOCALAPPDATA)return null;const s=L.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await y.SymlinkSupport.existsDirectory(s))return null;const{pwshMsixDirRegex:t,pwshMsixName:r}=o?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:O,pwshMsixName:"PowerShell (Store)"};for(const i of await y.readdir(s))if(t.test(i)){const a=L.join(s,i,"pwsh.exe");return new v(a,r)}return null}function I(){const o=L.join(R.homedir(),".dotnet","tools","pwsh.exe");return new v(o,".NET Core PowerShell Global Tool")}function D(){const o=L.join(process.env.windir,S===1&&n!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new v(o,"Windows PowerShell",!0)}function E(){return lt(this,arguments,function*(){let s=yield Le(C());s&&(yield yield Le(s)),s=yield Le(C({useAlternateBitness:!0})),s&&(yield yield Le(s)),s=yield Le(f()),s&&(yield yield Le(s)),s=I(),s&&(yield yield Le(s)),s=yield Le(C({findPreview:!0})),s&&(yield yield Le(s)),s=yield Le(f({findPreview:!0})),s&&(yield yield Le(s)),s=yield Le(C({useAlternateBitness:!0,findPreview:!0})),s&&(yield yield Le(s)),s=D(),s&&(yield yield Le(s))})}function b(){return lt(this,arguments,function*(){var s,t;try{for(var r=et(E()),i;i=yield Le(r.next()),!i.done;){const a=i.value;(yield Le(a.exists()))&&(yield yield Le(a))}}catch(a){s={error:a}}finally{try{i&&!i.done&&(t=r.return)&&(yield Le(t.call(r)))}finally{if(s)throw s.error}}})}e.enumeratePowerShellInstallations=b;async function g(){var o,s;try{for(var t=et(b()),r;r=await t.next(),!r.done;)return r.value}catch(i){o={error:i}}finally{try{r&&!r.done&&(s=t.return)&&await s.call(t)}finally{if(o)throw o.error}}return null}e.getFirstAvailablePowerShellInstallation=g}),define(Z[97],ee([0,1,43,16]),function(H,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function L(O){return new Promise((P,p)=>{let S;const n=new Map;function v(C,f,I,D,E){const b=n.get(f);if(C===O||b){const g={name:h(I),cmd:I,pid:C,ppid:f,load:D,mem:E};n.set(C,g),C===O&&(S=g),b&&(b.children||(b.children=[]),b.children.push(g),b.children.length>1&&(b.children=b.children.sort((o,s)=>o.pid-s.pid)))}}function h(C){const f=/--disable-blink-features=Auxclick/,I=/\\watcher\\win32\\CodeHelper\.exe/,D=/--crashes-directory/,E=/\\pipe\\winpty-control/,b=/conhost\.exe/,g=/--type=([a-zA-Z-]+)/;if(I.exec(C))return"watcherService ";if(D.exec(C))return"electron-crash-reporter";if(E.exec(C))return"winpty-process";if(b.exec(C))return"console-window-host (Windows internal process)";let o=g.exec(C);if(o&&o.length===2)return o[1]==="renderer"?f.exec(C)?"shared-process":"window":o[1];const s=/[a-zA-Z-]+\.js/g;let t="";do o=s.exec(C),o&&(t+=o+" ");while(o);return t&&C.indexOf("node ")<0&&C.indexOf("node.exe")<0?`electron_node ${t}`:C}if(process.platform==="win32"){const C=f=>f.indexOf("\\\\?\\")===0||f.indexOf("\\??\\")===0?f.substr(4):f.indexOf('"\\\\?\\')===0||f.indexOf('"\\??\\')===0?'"'+f.substr(5):f;new Promise((f,I)=>{H(["windows-process-tree"],f,I)}).then(f=>{f.getProcessList(O,I=>{f.getProcessCpuUsage(I,D=>{const E=new Map;D.forEach(b=>{const g=C(b.commandLine||"");E.set(b.pid,{name:h(g),cmd:g,pid:b.pid,ppid:b.ppid,load:b.cpu||0,mem:b.memory||0})}),S=E.get(O),S?(E.forEach(b=>{const g=E.get(b.ppid);g&&(g.children||(g.children=[]),g.children.push(b))}),E.forEach(b=>{b.children&&(b.children=b.children.sort((g,o)=>g.pid-o.pid))}),P(S)):p(new Error(`Root process ${O} not found`))})},f.ProcessDataFlag.CommandLine|f.ProcessDataFlag.Memory)})}else{let C=function(){let f=[S];const I=[];for(;f.length;){const E=f.shift();E&&(I.push(E.pid),E.children&&(f=f.concat(E.children)))}let D=JSON.stringify(R.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",H).fsPath);D+=" "+I.join(" "),y.exec(D,{},(E,b,g)=>{if(E||g)p(E||new Error(g.toString()));else{const o=b.toString().split(`
`);for(let s=0;s<I.length;s++){const t=n.get(I[s]);t.load=parseFloat(o[s])}if(!S){p(new Error(`Root process ${O} not found`));return}P(S)}})};y.exec("which ps",{},(f,I,D)=>{if(f||D)if(process.platform!=="linux")p(f||new Error(D.toString()));else{const E=JSON.stringify(R.FileAccess.asFileUri("vs/base/node/ps.sh",H).fsPath);y.exec(E,{},(b,g,o)=>{b||o?p(b||new Error(o.toString())):(A(g,v),C())})}else{const E=I.toString().trim(),b="-ax -o pid=,ppid=,pcpu=,pmem=,command=";y.exec(`${E} ${b}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(g,o,s)=>{g||s&&!s.includes("screen size is bogus")?p(g||new Error(s.toString())):(A(o,v),process.platform==="linux"?C():S?P(S):p(new Error(`Root process ${O} not found`)))})}})}})}e.listProcesses=L;function A(O,P){const p=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,S=O.toString().split(`
`);for(const n of S){const v=p.exec(n.trim());v&&v.length===6&&P(parseInt(v[1]),parseInt(v[2]),v[5],parseFloat(v[3]),parseFloat(v[4]))}}}),define(Z[98],ee([0,1,7,42,6,67,2,17]),function(H,e,y,R,L,A,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function p(v,h,C){return n({path:v,isDirectory:!1},h,C)}e.watchFile=p;function S(v,h,C){return n({path:v,isDirectory:!0},h,C)}e.watchFolder=S,e.CHANGE_BUFFER_DELAY=100;function n(v,h,C){const f=y.basename(v.path),I=new Map;let D=!1,E=[O.toDisposable(()=>{I.forEach(b=>O.dispose(b)),I.clear()})];try{const b=R.watch(v.path);E.push(O.toDisposable(()=>{b.removeAllListeners(),b.close()}));const g=new Set;v.isDirectory&&P.readdir(v.path).then(o=>o.forEach(s=>g.add(s))),b.on("error",(o,s)=>{D||C(`Failed to watch ${v.path} for changes using fs.watch() (${o}, ${s})`)}),b.on("change",(o,s)=>{if(D)return;let t="";if(s&&(t=s.toString(),L.isMacintosh&&(t=A.normalizeNFC(t))),!t||o!=="change"&&o!=="rename")return;const r=v.isDirectory?y.join(v.path,t):v.path;if(v.isDirectory)if(o==="rename"){const i=I.get(r);i&&O.dispose(i);const a=setTimeout(async()=>{I.delete(r);const c=await P.exists(r);if(D)return;let u;c?g.has(t)?u="changed":(u="added",g.add(t)):(g.delete(t),u="deleted"),h(u,r)},e.CHANGE_BUFFER_DELAY);I.set(r,O.toDisposable(()=>clearTimeout(a)))}else{let i;g.has(t)?i="changed":(i="added",g.add(t)),h(i,r)}else if(o==="rename"||t!==f){const i=setTimeout(async()=>{const a=await P.exists(r);D||(a?(h("changed",r),E=[n(v,h,C)]):h("deleted",r))},e.CHANGE_BUFFER_DELAY);O.dispose(E),E=[O.toDisposable(()=>clearTimeout(i))]}else h("changed",r)})}catch(b){P.exists(v.path).then(g=>{g&&!D&&C(`Failed to watch ${v.path} for changes using fs.watch() (${b.toString()})`)})}return O.toDisposable(()=>{D=!0,E=O.dispose(E)})}});var de=this&&this.__decorate||function(H,e,y,R){var L=arguments.length,A=L<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,y):R,O;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(H,e,y,R);else for(var P=H.length-1;P>=0;P--)(O=H[P])&&(A=(L<3?O(A):L>3?O(e,y,A):O(e,y))||A);return L>3&&A&&Object.defineProperty(e,y,A),A};define(Z[36],ee([0,1,3,2,8,29,11,25,19,15,90,22,64]),function(H,e,y,R,L,A,O,P,p,S,n,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var C;(function(U){U[U.Promise=100]="Promise",U[U.PromiseCancel=101]="PromiseCancel",U[U.EventListen=102]="EventListen",U[U.EventDispose=103]="EventDispose"})(C=e.RequestType||(e.RequestType={}));function f(U){switch(U){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var I;(function(U){U[U.Initialize=200]="Initialize",U[U.PromiseSuccess=201]="PromiseSuccess",U[U.PromiseError=202]="PromiseError",U[U.PromiseErrorObj=203]="PromiseErrorObj",U[U.EventFire=204]="EventFire"})(I=e.ResponseType||(e.ResponseType={}));function D(U){switch(U){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var E;(function(U){U[U.Uninitialized=0]="Uninitialized",U[U.Idle=1]="Idle"})(E||(E={}));class b{constructor(k){this.buffer=k,this.pos=0}read(k){const F=this.buffer.slice(this.pos,this.pos+k);return this.pos+=F.byteLength,F}}class g{constructor(){this.buffers=[]}get buffer(){return P.VSBuffer.concat(this.buffers)}write(k){this.buffers.push(k)}}var o;(function(U){U[U.Undefined=0]="Undefined",U[U.String=1]="String",U[U.Buffer=2]="Buffer",U[U.VSBuffer=3]="VSBuffer",U[U.Array=4]="Array",U[U.Object=5]="Object"})(o||(o={}));function s(U){const k=P.VSBuffer.alloc(4);return k.writeUInt32BE(U,0),k}function t(U){return U.read(4).readUInt32BE(0)}function r(U){const k=P.VSBuffer.alloc(1);return k.writeUInt8(U,0),k}const i={Undefined:r(o.Undefined),String:r(o.String),Buffer:r(o.Buffer),VSBuffer:r(o.VSBuffer),Array:r(o.Array),Object:r(o.Object)},a=typeof Buffer!="undefined";function c(U,k){if(typeof k=="undefined")U.write(i.Undefined);else if(typeof k=="string"){const F=P.VSBuffer.fromString(k);U.write(i.String),U.write(s(F.byteLength)),U.write(F)}else if(a&&Buffer.isBuffer(k)){const F=P.VSBuffer.wrap(k);U.write(i.Buffer),U.write(s(F.byteLength)),U.write(F)}else if(k instanceof P.VSBuffer)U.write(i.VSBuffer),U.write(s(k.byteLength)),U.write(k);else if(Array.isArray(k)){U.write(i.Array),U.write(s(k.length));for(const F of k)c(U,F)}else{const F=P.VSBuffer.fromString(JSON.stringify(k));U.write(i.Object),U.write(s(F.byteLength)),U.write(F)}}function u(U){switch(U.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return U.read(t(U)).toString();case o.Buffer:return U.read(t(U)).buffer;case o.VSBuffer:return U.read(t(U));case o.Array:{const F=t(U),N=[];for(let q=0;q<F;q++)N.push(u(U));return N}case o.Object:return JSON.parse(U.read(t(U)).toString())}}class l{constructor(k,F,N=null,q=1e3){this.protocol=k,this.ctx=F,this.logger=N,this.timeoutDelay=q,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(W=>this.onRawMessage(W)),this.sendResponse({type:200})}registerChannel(k,F){this.channels.set(k,F),setTimeout(()=>this.flushPendingRequests(k),0)}sendResponse(k){switch(k.type){case 200:{const F=this.send([k.type]);this.logger&&this.logger.logOutgoing(F,0,1,D(k.type));return}case 201:case 202:case 204:case 203:{const F=this.send([k.type,k.id],k.data);this.logger&&this.logger.logOutgoing(F,k.id,1,D(k.type),k.data);return}}}send(k,F=void 0){const N=new g;return c(N,k),c(N,F),this.sendBuffer(N.buffer)}sendBuffer(k){try{return this.protocol.send(k),k.byteLength}catch(F){return 0}}onRawMessage(k){const F=new b(k),N=u(F),q=u(F),W=N[0];switch(W){case 100:return this.logger&&this.logger.logIncoming(k.byteLength,N[1],1,`${f(W)}: ${N[2]}.${N[3]}`,q),this.onPromise({type:W,id:N[1],channelName:N[2],name:N[3],arg:q});case 102:return this.logger&&this.logger.logIncoming(k.byteLength,N[1],1,`${f(W)}: ${N[2]}.${N[3]}`,q),this.onEventListen({type:W,id:N[1],channelName:N[2],name:N[3],arg:q});case 101:return this.logger&&this.logger.logIncoming(k.byteLength,N[1],1,`${f(W)}`),this.disposeActiveRequest({type:W,id:N[1]});case 103:return this.logger&&this.logger.logIncoming(k.byteLength,N[1],1,`${f(W)}`),this.disposeActiveRequest({type:W,id:N[1]})}}onPromise(k){const F=this.channels.get(k.channelName);if(!F){this.collectPendingRequest(k);return}const N=new A.CancellationTokenSource;let q;try{q=F.call(this.ctx,k.name,k.arg,N.token)}catch(X){q=Promise.reject(X)}const W=k.id;q.then(X=>{this.sendResponse({id:W,data:X,type:201}),this.activeRequests.delete(k.id)},X=>{X instanceof Error?this.sendResponse({id:W,data:{message:X.message,name:X.name,stack:X.stack?X.stack.split?X.stack.split(`
`):X.stack:void 0},type:202}):this.sendResponse({id:W,data:X,type:203}),this.activeRequests.delete(k.id)});const Q=R.toDisposable(()=>N.cancel());this.activeRequests.set(k.id,Q)}onEventListen(k){const F=this.channels.get(k.channelName);if(!F){this.collectPendingRequest(k);return}const N=k.id,W=F.listen(this.ctx,k.name,k.arg)(Q=>this.sendResponse({id:N,data:Q,type:204}));this.activeRequests.set(k.id,W)}disposeActiveRequest(k){const F=this.activeRequests.get(k.id);F&&(F.dispose(),this.activeRequests.delete(k.id))}collectPendingRequest(k){let F=this.pendingRequests.get(k.channelName);F||(F=[],this.pendingRequests.set(k.channelName,F));const N=setTimeout(()=>{console.error(`Unknown channel: ${k.channelName}`),k.type===100&&this.sendResponse({id:k.id,data:{name:"Unknown channel",message:`Channel name '${k.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);F.push({request:k,timeoutTimer:N})}flushPendingRequests(k){const F=this.pendingRequests.get(k);if(F){for(const N of F)switch(clearTimeout(N.timeoutTimer),N.request.type){case 100:this.onPromise(N.request);break;case 102:this.onEventListen(N.request);break}this.pendingRequests.delete(k)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(k=>k.dispose()),this.activeRequests.clear()}}e.ChannelServer=l;var m;(function(U){U[U.LocalSide=0]="LocalSide",U[U.OtherSide=1]="OtherSide"})(m=e.RequestInitiator||(e.RequestInitiator={}));class w{constructor(k,F=null){this.protocol=k,this.isDisposed=!1,this.state=E.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new y.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(N=>this.onBuffer(N)),this.logger=F}getChannel(k){const F=this;return{call(N,q,W){return F.isDisposed?Promise.reject(O.canceled()):F.requestPromise(k,N,q,W)},listen(N,q){return F.isDisposed?Promise.reject(O.canceled()):F.requestEvent(k,N,q)}}}requestPromise(k,F,N,q=A.CancellationToken.None){const W=this.lastRequestId++,X={id:W,type:100,channelName:k,name:F,arg:N};if(q.isCancellationRequested)return Promise.reject(O.canceled());let ie;return new Promise((ce,le)=>{if(q.isCancellationRequested)return le(O.canceled());const ve=()=>{const _e=Oe=>{switch(Oe.type){case 201:this.handlers.delete(W),ce(Oe.data);break;case 202:this.handlers.delete(W);const ke=new Error(Oe.data.message);ke.stack=Oe.data.stack,ke.name=Oe.data.name,le(ke);break;case 203:this.handlers.delete(W),le(Oe.data);break}};this.handlers.set(W,_e),this.sendRequest(X)};let pe=null;this.state===E.Idle?ve():(pe=L.createCancelablePromise(_e=>this.whenInitialized()),pe.then(()=>{pe=null,ve()}));const Ce=()=>{pe?(pe.cancel(),pe=null):this.sendRequest({id:W,type:101}),le(O.canceled())},Ae=q.onCancellationRequested(Ce);ie=R.combinedDisposable(R.toDisposable(Ce),Ae),this.activeRequests.add(ie)}).finally(()=>{this.activeRequests.delete(ie)})}requestEvent(k,F,N){const q=this.lastRequestId++,Q={id:q,type:102,channelName:k,name:F,arg:N};let X=null;const ie=new y.Emitter({onFirstListenerAdd:()=>{X=L.createCancelablePromise(ce=>this.whenInitialized()),X.then(()=>{X=null,this.activeRequests.add(ie),this.sendRequest(Q)})},onLastListenerRemove:()=>{X?(X.cancel(),X=null):(this.activeRequests.delete(ie),this.sendRequest({id:q,type:103}))}}),ne=ce=>ie.fire(ce.data);return this.handlers.set(q,ne),ie.event}sendRequest(k){switch(k.type){case 100:case 102:{const F=this.send([k.type,k.id,k.channelName,k.name],k.arg);this.logger&&this.logger.logOutgoing(F,k.id,0,`${f(k.type)}: ${k.channelName}.${k.name}`,k.arg);return}case 101:case 103:{const F=this.send([k.type,k.id]);this.logger&&this.logger.logOutgoing(F,k.id,0,f(k.type));return}}}send(k,F=void 0){const N=new g;return c(N,k),c(N,F),this.sendBuffer(N.buffer)}sendBuffer(k){try{return this.protocol.send(k),k.byteLength}catch(F){return 0}}onBuffer(k){const F=new b(k),N=u(F),q=u(F),W=N[0];switch(W){case 200:return this.logger&&this.logger.logIncoming(k.byteLength,0,0,D(W)),this.onResponse({type:N[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(k.byteLength,N[1],0,D(W),q),this.onResponse({type:N[0],id:N[1],data:q})}}onResponse(k){if(k.type===200){this.state=E.Idle,this._onDidInitialize.fire();return}const F=this.handlers.get(k.id);F&&F(k)}get onDidInitializePromise(){return y.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===E.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(k=>k.dispose()),this.activeRequests.clear()}}de([h.memoize],w.prototype,"onDidInitializePromise",null),e.ChannelClient=w;class d{constructor(k){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new y.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new y.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,k(({protocol:F,onDidClientDisconnect:N})=>{y.Event.once(F.onMessage)(W=>{const Q=new b(W),X=u(Q),ie=new l(F,X),ne=new w(F);this.channels.forEach((le,ve)=>ie.registerChannel(ve,le));const ce={channelServer:ie,channelClient:ne,ctx:X};this._connections.add(ce),this._onDidAddConnection.fire(ce),N(()=>{ie.dispose(),ne.dispose(),this._connections.delete(ce),this._onDidRemoveConnection.fire(ce)})})})}get connections(){const k=[];return this._connections.forEach(F=>k.push(F)),k}getChannel(k,F){const N=this;return{call(q,W,Q){let X;if(S.isFunction(F)){let ne=p.getRandomElement(N.connections.filter(F));X=ne?Promise.resolve(ne):y.Event.toPromise(y.Event.filter(N.onDidAddConnection,F))}else X=F.routeCall(N,q,W);const ie=X.then(ne=>ne.channelClient.getChannel(k));return _(ie).call(q,W,Q)},listen(q,W){if(S.isFunction(F))return N.getMulticastEvent(k,F,q,W);const Q=F.routeEvent(N,q,W).then(X=>X.channelClient.getChannel(k));return _(Q).listen(q,W)}}}getMulticastEvent(k,F,N,q){const W=this;let Q=new R.DisposableStore;const X=new y.Emitter({onFirstListenerAdd:()=>{Q=new R.DisposableStore;const ie=new y.EventMultiplexer,ne=new Map,ce=ve=>{const Ce=ve.channelClient.getChannel(k).listen(N,q),Ae=ie.add(Ce);ne.set(ve,Ae)},le=ve=>{const pe=ne.get(ve);!pe||(pe.dispose(),ne.delete(ve))};W.connections.filter(F).forEach(ce),y.Event.filter(W.onDidAddConnection,F)(ce,void 0,Q),W.onDidRemoveConnection(le,void 0,Q),ie.event(X.fire,X,Q),Q.add(ie)},onLastListenerRemove:()=>{Q.dispose()}});return X.event}registerChannel(k,F){this.channels.set(k,F),this._connections.forEach(N=>{N.channelServer.registerChannel(k,F)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=d;class T{constructor(k,F,N=null){const q=new g;c(q,F),k.send(q.buffer),this.channelClient=new w(k,N),this.channelServer=new l(k,F,N)}getChannel(k){return this.channelClient.getChannel(k)}registerChannel(k,F){this.channelServer.registerChannel(k,F)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=T;function _(U){return{call(k,F,N){return U.then(q=>q.call(k,F,N))},listen(k,F){const N=new y.Relay;return U.then(q=>N.input=q.listen(k,F)),N.event}}}e.getDelayedChannel=_;function j(U){let k=!1;return{call(F,N,q){return k?U.call(F,N,q):L.timeout(0).then(()=>k=!0).then(()=>U.call(F,N,q))},listen(F,N){if(k)return U.listen(F,N);const q=new y.Relay;return L.timeout(0).then(()=>k=!0).then(()=>q.input=U.listen(F,N)),q.event}}}e.getNextTickChannel=j;class ${constructor(k){this.fn=k}routeCall(k){return this.route(k)}routeEvent(k){return this.route(k)}async route(k){for(const F of k.connections)if(await Promise.resolve(this.fn(F.ctx)))return Promise.resolve(F);return await y.Event.toPromise(k.onDidAddConnection),await this.route(k)}}e.StaticRouter=$;var K;(function(U){function k(q,W){const Q=q,X=W&&W.disableMarshalling,ie=new Map;for(const ne in Q)N(ne)&&ie.set(ne,y.Event.buffer(Q[ne],!0));return new class{listen(ne,ce){const le=ie.get(ce);if(le)return le;throw new Error(`Event not found: ${ce}`)}call(ne,ce,le){const ve=Q[ce];if(typeof ve=="function"){if(!X&&Array.isArray(le))for(let pe=0;pe<le.length;pe++)le[pe]=n.revive(le[pe]);return ve.apply(Q,le)}throw new Error(`Method not found: ${ce}`)}}}U.fromService=k;function F(q,W){const Q=W&&W.disableMarshalling;return new Proxy({},{get(X,ie){var ne;if(typeof ie=="string")return((ne=W==null?void 0:W.properties)===null||ne===void 0?void 0:ne.has(ie))?W.properties.get(ie):N(ie)?q.listen(ie):async function(...ce){let le;W&&!S.isUndefinedOrNull(W.context)?le=[W.context,...ce]:le=ce;const ve=await q.call(ie,le);return Q?ve:n.revive(ve)};throw new Error(`Property not found: ${String(ie)}`)}})}U.toService=F;function N(q){return q[0]==="o"&&q[1]==="n"&&v.isUpperAsciiLetter(q.charCodeAt(2))}})(K=e.ProxyChannel||(e.ProxyChannel={}));const B=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function z(U){if(Array.isArray(U))return U;if(U&&typeof U=="object"&&typeof U.toString=="function"){let k=U.toString();if(k!=="[object Object]")return k}return U}function G(U){return Array.isArray(U)?U.map(z):z(U)}function V(U,k,F,N,q,W,Q){Q=G(Q);const X=B[q],ie=X[N%X.length];let ne=[`%c[${U}]%c[${String(k).padStart(7," ")}]%c[len: ${String(F).padStart(5," ")}]%c${String(N).padStart(5," ")} - ${W}`,"color: darkgreen","color: grey","color: grey",`color: ${ie}`];/\($/.test(W)?(ne=ne.concat(Q),ne.push(")")):ne.push(Q),console.log.apply(console,ne)}e.logWithColors=V;class M{constructor(k,F){this._outgoingPrefix=k,this._incomingPrefix=F,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(k,F,N,q,W){this._totalOutgoing+=k,V(this._outgoingPrefix,this._totalOutgoing,k,F,N,q,W)}logIncoming(k,F,N,q,W){this._totalIncoming+=k,V(this._incomingPrefix,this._totalIncoming,k,F,N,q,W)}}e.IPCLogger=M}),define(Z[99],ee([0,1,3,36,25]),function(H,e,y,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class A{constructor(p){this.port=p,this.onMessage=y.Event.fromDOMEventEmitter(this.port,"message",S=>L.VSBuffer.wrap(S.data)),p.start()}send(p){this.port.postMessage(p.buffer)}disconnect(){this.port.close()}}e.Protocol=A;class O extends R.IPCClient{constructor(p,S){const n=new A(p);super(n,S);this.protocol=n}dispose(){this.protocol.disconnect()}}e.Client=O}),define(Z[100],ee([0,1,101,3,36,99]),function(H,e,y,R,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class O extends L.IPCServer{static getOnDidClientConnect(){const p=R.Event.fromNodeEventEmitter(y.ipcRenderer,"vscode:createMessageChannel",(S,n)=>n);return R.Event.map(p,S=>{const{port1:n,port2:v}=new MessageChannel,C={protocol:new A.Protocol(n),onDidClientDisconnect:R.Event.fromDOMEventEmitter(n,"close")};return y.ipcRenderer.postMessage("vscode:createMessageChannelResult",S,[v]),C})}constructor(){super(O.getOnDidClientConnect())}}e.Server=O}),define(Z[102],ee([0,1,11,25]),function(H,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function L(P,p){P.proxyAuthorization&&(P.headers=Object.assign(Object.assign({},P.headers||{}),{"Proxy-Authorization":P.proxyAuthorization}));const S=new XMLHttpRequest;return new Promise((n,v)=>{S.open(P.type||"GET",P.url||"",!0,P.user,P.password),A(S,P),S.responseType="arraybuffer",S.onerror=h=>v(new Error(S.statusText&&"XHR failed: "+S.statusText||"XHR failed")),S.onload=h=>{n({res:{statusCode:S.status,headers:O(S)},stream:R.bufferToStream(R.VSBuffer.wrap(new Uint8Array(S.response)))})},S.ontimeout=h=>v(new Error(`XHR timeout: ${P.timeout}ms`)),P.timeout&&(S.timeout=P.timeout),S.send(P.data),p.onCancellationRequested(()=>{S.abort(),v(y.canceled())})})}e.request=L;function A(P,p){if(p.headers){e:for(let S in p.headers){switch(S){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}P.setRequestHeader(S,p.headers[S])}}}function O(P){const p=Object.create(null);for(const S of P.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(S){const n=S.indexOf(":");p[S.substr(0,n).trim().toLowerCase()]=S.substr(n+1).trim()}return p}}),define(Z[69],ee([0,1,2,3,8,15]),function(H,e,y,R,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageHint=void 0;var O;(function(n){n[n.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(O=e.StorageHint||(e.StorageHint={}));var P;(function(n){n[n.None=0]="None",n[n.Initialized=1]="Initialized",n[n.Closed=2]="Closed"})(P||(P={}));class p extends y.Disposable{constructor(v,h=Object.create(null)){super();this.database=v,this.options=h,this._onDidChangeStorage=this._register(new R.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=P.None,this.cache=new Map,this.flushDelayer=new L.ThrottledDelayer(p.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(v=>this.onDidChangeItemsExternal(v)))}onDidChangeItemsExternal(v){var h,C;(h=v.changed)===null||h===void 0||h.forEach((f,I)=>this.accept(I,f)),(C=v.deleted)===null||C===void 0||C.forEach(f=>this.accept(f,void 0))}accept(v,h){if(this.state===P.Closed)return;let C=!1;A.isUndefinedOrNull(h)?C=this.cache.delete(v):this.cache.get(v)!==h&&(this.cache.set(v,h),C=!0),C&&this._onDidChangeStorage.fire(v)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===P.None&&(this.state=P.Initialized,this.options.hint!==O.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(v,h){const C=this.cache.get(v);return A.isUndefinedOrNull(C)?h:C}getBoolean(v,h){const C=this.get(v);return A.isUndefinedOrNull(C)?h:C==="true"}getNumber(v,h){const C=this.get(v);return A.isUndefinedOrNull(C)?h:parseInt(C,10)}async set(v,h){if(this.state===P.Closed)return;if(A.isUndefinedOrNull(h))return this.delete(v);const C=String(h);if(this.cache.get(v)!==C)return this.cache.set(v,C),this.pendingInserts.set(v,C),this.pendingDeletes.delete(v),this._onDidChangeStorage.fire(v),this.flushDelayer.trigger(()=>this.flushPending())}async delete(v){if(!(this.state===P.Closed||!this.cache.delete(v)))return this.pendingDeletes.has(v)||this.pendingDeletes.add(v),this.pendingInserts.delete(v),this._onDidChangeStorage.fire(v),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=P.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(v){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const v={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(v).finally(()=>{var h;if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)(h=this.whenFlushedCallbacks.pop())===null||h===void 0||h()})}async whenFlushed(){if(!!this.hasPending)return new Promise(v=>this.whenFlushedCallbacks.push(v))}dispose(){this.flushDelayer.cancel(),this.flushDelayer.dispose(),super.dispose()}}e.Storage=p,p.DEFAULT_FLUSH_DELAY=100;class S{constructor(){this.onDidChangeItemsExternal=R.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(v){v.insert&&v.insert.forEach((h,C)=>this.items.set(C,h)),v.delete&&v.delete.forEach(h=>this.items.delete(h))}async close(){}}e.InMemoryStorageDatabase=S}),define(Z[103],ee([12,13]),function(H,e){return H.create("vs/base/common/date",e)}),define(Z[55],ee([0,1,103]),function(H,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const R=60,L=R*60,A=L*24,O=A*7,P=A*30,p=A*365;function S(v,h){typeof v!="number"&&(v=v.getTime());const C=Math.round((new Date().getTime()-v)/1e3);if(C<-30)return y.localize(0,null,S(new Date().getTime()+C*1e3,!1));if(C<30)return y.localize(1,null);let f;return C<R?(f=C,h?f===1?y.localize(2,null,f):y.localize(3,null,f):f===1?y.localize(4,null,f):y.localize(5,null,f)):C<L?(f=Math.floor(C/R),h?f===1?y.localize(6,null,f):y.localize(7,null,f):f===1?y.localize(8,null,f):y.localize(9,null,f)):C<A?(f=Math.floor(C/L),h?f===1?y.localize(10,null,f):y.localize(11,null,f):f===1?y.localize(12,null,f):y.localize(13,null,f)):C<O?(f=Math.floor(C/A),h?f===1?y.localize(14,null,f):y.localize(15,null,f):f===1?y.localize(16,null,f):y.localize(17,null,f)):C<P?(f=Math.floor(C/O),h?f===1?y.localize(18,null,f):y.localize(19,null,f):f===1?y.localize(20,null,f):y.localize(21,null,f)):C<p?(f=Math.floor(C/P),h?f===1?y.localize(22,null,f):y.localize(23,null,f):f===1?y.localize(24,null,f):y.localize(25,null,f)):(f=Math.floor(C/p),h?f===1?y.localize(26,null,f):y.localize(27,null,f):f===1?y.localize(28,null,f):y.localize(29,null,f))}e.fromNow=S;function n(v){return v.getFullYear()+"-"+String(v.getMonth()+1).padStart(2,"0")+"-"+String(v.getDate()).padStart(2,"0")+"T"+String(v.getHours()).padStart(2,"0")+":"+String(v.getMinutes()).padStart(2,"0")+":"+String(v.getSeconds()).padStart(2,"0")+"."+(v.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=n}),define(Z[104],ee([12,13]),function(H,e){return H.create("vs/base/common/errorMessage",e)}),define(Z[44],ee([0,1,104,15,19]),function(H,e,y,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function A(S,n){return n&&(S.stack||S.stacktrace)?y.localize(0,null,P(S),O(S.stack)||O(S.stacktrace)):P(S)}function O(S){return Array.isArray(S)?S.join(`
`):S}function P(S){return typeof S.code=="string"&&typeof S.errno=="number"&&typeof S.syscall=="string"?y.localize(1,null,S.message):S.message||y.localize(2,null)}function p(S=null,n=!1){if(!S)return y.localize(3,null);if(Array.isArray(S)){const v=L.coalesce(S),h=p(v[0],n);return v.length>1?y.localize(4,null,h,v.length):h}if(R.isString(S))return S;if(S.detail){const v=S.detail;if(v.error)return A(v.error,n);if(v.exception)return A(v.exception,n)}return S.stack?A(S,n):S.message?S.message:y.localize(5,null)}e.toErrorMessage=p}),define(Z[105],ee([12,13]),function(H,e){return H.create("vs/base/node/processes",e)}),define(Z[106],ee([0,1,7,17,43,105,34,15,26,41,6,68,16]),function(H,e,y,R,L,A,O,P,p,S,n,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function C(o){switch(o){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function f(o,s){if(n.isWindows)try{const t={stdio:["pipe","pipe","ignore"]};s&&(t.cwd=s);const r=L.execFile("taskkill",["/T","/F","/PID",o.pid.toString()],t);return new Promise(i=>{r.once("error",a=>{i({success:!1,error:a})}),r.once("exit",(a,c)=>{i(a===0?{success:!0}:{success:!1,code:a!==null?a:1})})})}catch(t){return Promise.resolve({success:!1,error:t,code:t.status?C(t.status):1})}else if(n.isLinux||n.isMacintosh)try{const t=h.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",H).fsPath;return new Promise(r=>{L.execFile(t,[o.pid.toString()],{encoding:"utf8",shell:!0},(i,a,c)=>{r(i?{success:!1,error:i}:{success:!0})})})}catch(t){return Promise.resolve({success:!1,error:t})}else o.kill("SIGKILL");return Promise.resolve({success:!0})}function I(o=O.env){return o.comspec||"cmd.exe"}e.getWindowsShell=I;class D{constructor(s,t,r,i){if(t!==void 0&&r!==void 0&&i!==void 0)this.cmd=s,this.args=t,this.shell=r,this.options=i;else{const a=s;this.cmd=a.command,this.shell=a.isShellCommand,this.args=a.args.slice(0),this.options=a.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const a=Object.create(null);Object.keys(O.env).forEach(c=>{a[c]=O.env[c]}),Object.keys(this.options.env).forEach(c=>{a[c]=this.options.env[c]}),this.options.env=a}}getSanitizedCommand(){let s=this.cmd.toLowerCase();const t=s.lastIndexOf(y.sep);return t!==-1&&(s=s.substring(t+1)),D.WellKnowCommands[s]?s:"other"}start(s){return n.isWindows&&(this.options&&this.options.cwd&&S.isUNC(this.options.cwd)||!this.options&&S.isUNC(O.cwd()))?Promise.reject(new Error(A.localize(0,null))):this.useExec().then(t=>{let r,i;const a=new Promise((c,u)=>{r=c,i=u});if(t){let c=this.cmd;this.args&&(c=c+" "+this.args.join(" ")),this.childProcess=L.exec(c,this.options,(u,l,m)=>{this.childProcess=null;const w=u;w&&w.killed?i({killed:this.terminateRequested,stdout:l.toString(),stderr:m.toString()}):this.handleExec(r,s,u,l,m)})}else{let c=null;const u=l=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(l,r,s,i);const m={terminated:this.terminateRequested};P.isNumber(l)&&(m.cmdCode=l),r(m)};if(this.shell&&n.isWindows){const l=p.deepClone(this.options);l.windowsVerbatimArguments=!0,l.detached=!1;let m=!1,w=!1;const d=[];let T=this.ensureQuotes(this.cmd);d.push(T.value),m=T.quoted,this.args&&this.args.forEach(j=>{T=this.ensureQuotes(j),d.push(T.value),w=w&&T.quoted});const _=["/s","/c"];m?w?_.push('"'+d.join(" ")+'"'):d.length>1?_.push('"'+d[0]+'" '+d.slice(1).join(" ")):_.push('"'+d[0]+'"'):_.push(d.join(" ")),c=L.spawn(I(),_,l)}else this.cmd&&(c=L.spawn(this.cmd,this.args,this.options));c&&(this.childProcess=c,this.childProcessPromise=Promise.resolve(c),this.pidResolve&&(this.pidResolve(P.isNumber(c.pid)?c.pid:-1),this.pidResolve=void 0),c.on("error",l=>{this.childProcess=null,i({terminated:this.terminateRequested,error:l})}),c.pid&&(this.childProcess.on("close",u),this.handleSpawn(c,r,s,i,!0)))}return a})}handleClose(s,t,r,i){}ensureQuotes(s){return D.regexp.test(s)?{value:'"'+s+'"',quoted:!0}:{value:s,quoted:s.length>0&&s[0]==='"'&&s[s.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(s=>s.pid,s=>-1):new Promise(s=>{this.pidResolve=s})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(s=>(this.terminateRequested=!0,f(s,this.options.cwd).then(t=>(t.success&&(this.childProcess=null),t))),s=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(s=>{if(!this.shell||!n.isWindows)return s(!1);const t=L.spawn(I(),["/s","/c"]);t.on("error",r=>s(!0)),t.on("exit",r=>s(!1))})}}e.AbstractProcess=D,D.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},D.regexp=/^[^"].* .*[^"]/;class E extends D{constructor(s,t,r,i){super(s,t,r,i);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(s,t,r,i,a){[i,a].forEach((c,u)=>{const l=new v.LineDecoder;l.write(c).forEach(d=>{t({line:d,source:u===0?0:1})});const w=l.end();w&&t({line:w,source:u===0?0:1})}),s({terminated:this.terminateRequested,error:r})}handleSpawn(s,t,r,i,a){const c=new v.LineDecoder,u=new v.LineDecoder;s.stdout.on("data",l=>{c.write(l).forEach(w=>r({line:w,source:0}))}),s.stderr.on("data",l=>{u.write(l).forEach(w=>r({line:w,source:1}))}),this.stdoutLineDecoder=c,this.stderrLineDecoder=u}handleClose(s,t,r,i){const a=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;a&&r({line:a,source:0});const c=this.stderrLineDecoder?this.stderrLineDecoder.end():null;c&&r({line:c,source:1})}}e.LineProcess=E;function b(o){let s=[],t=!1;const r=function(i){if(t){s.push(i);return}(!o.send(i,c=>{if(c&&console.error(c),t=!1,s.length>0){const u=s.slice(0);s=[],u.forEach(l=>r(l))}})||n.isWindows)&&(t=!0)};return{send:r}}e.createQueuedSender=b;var g;(function(o){async function s(t,r,i){if(y.isAbsolute(t))return t;if(r===void 0&&(r=O.cwd()),y.dirname(t)!=="."||(i===void 0&&P.isString(O.env.PATH)&&(i=O.env.PATH.split(y.delimiter)),i===void 0||i.length===0))return y.join(r,t);async function c(u){return await R.exists(u)?!(await R.Promises.stat(u)).isDirectory():!1}for(let u of i){let l;if(y.isAbsolute(u)?l=y.join(u,t):l=y.join(r,u,t),await c(l))return l;let m=l+".com";if(await c(m)||(m=l+".exe",await c(m)))return m}return y.join(r,t)}o.findExecutable=s})(g=e.win32||(e.win32={}))}),define(Z[49],ee([0,1,43,2,8,26,3,106,36,89,29,11,25,6]),function(H,e,y,R,L,A,O,P,p,S,n,v,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class f extends p.ChannelServer{constructor(E){super({send:b=>{try{process.send&&process.send(b.buffer.toString("base64"))}catch(g){}},onMessage:O.Event.fromNodeEventEmitter(process,"message",b=>h.VSBuffer.wrap(Buffer.from(b,"base64")))},E);process.once("disconnect",()=>this.dispose())}}e.Server=f;class I{constructor(E,b){this.modulePath=E,this.options=b,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new O.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const g=b&&b.timeout?b.timeout:6e4;this.disposeDelayer=new L.Delayer(g),this.child=null,this._client=null}getChannel(E){const b=this;return{call(g,o,s){return b.requestPromise(E,g,o,s)},listen(g,o){return b.requestEvent(E,g,o)}}}requestPromise(E,b,g,o=n.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(o.isCancellationRequested)return Promise.reject(v.canceled());this.disposeDelayer.cancel();const s=this.getCachedChannel(E),t=L.createCancelablePromise(a=>s.call(b,g,a)),r=o.onCancellationRequested(()=>t.cancel()),i=R.toDisposable(()=>t.cancel());return this.activeRequests.add(i),t.finally(()=>{r.dispose(),this.activeRequests.delete(i),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(E,b,g){if(!this.disposeDelayer)return O.Event.None;this.disposeDelayer.cancel();let o;const s=new O.Emitter({onFirstListenerAdd:()=>{o=this.getCachedChannel(E).listen(b,g)(s.fire,s),this.activeRequests.add(o)},onLastListenerRemove:()=>{this.activeRequests.delete(o),o.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return s.event}get client(){if(!this._client){const E=this.options&&this.options.args?this.options.args:[],b=Object.create(null);b.env=Object.assign(Object.assign({},A.deepClone(process.env)),{VSCODE_PARENT_PID:String(process.pid)}),this.options&&this.options.env&&(b.env=Object.assign(Object.assign({},b.env),this.options.env)),this.options&&this.options.freshExecArgv&&(b.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(b.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(b.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),b.execArgv===void 0&&(b.execArgv=process.execArgv.filter(c=>!/^--inspect(-brk)?=/.test(c))),C.isMacintosh&&b.env&&delete b.env.DYLD_LIBRARY_PATH,this.child=y.fork(this.modulePath,E,b);const g=new O.Emitter;O.Event.fromNodeEventEmitter(this.child,"message",c=>c)(c=>{if(S.isRemoteConsoleLog(c)){S.log(c,`IPC Library: ${this.options.serverName}`);return}g.fire(h.VSBuffer.wrap(Buffer.from(c,"base64")))});const s=this.options.useQueue?P.createQueuedSender(this.child):this.child,t=c=>this.child&&this.child.connected&&s.send(c.buffer.toString("base64")),r=g.event,i={send:t,onMessage:r};this._client=new p.ChannelClient(i);const a=()=>this.disposeClient();process.once("exit",a),this.child.on("error",c=>console.warn('IPC "'+this.options.serverName+'" errored with '+c)),this.child.on("exit",(c,u)=>{process.removeListener("exit",a),this.activeRequests.forEach(l=>R.dispose(l)),this.activeRequests.clear(),c!==0&&u!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+c+" and signal "+u),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:c,signal:u})})}return this._client}getCachedChannel(E){let b=this.channels.get(E);return b||(b=this.client.getChannel(E),this.channels.set(E,b)),b}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=I}),define(Z[107],ee([12,13]),function(H,e){return H.create("vs/base/node/zip",e)}),define(Z[108],ee([12,13]),function(H,e){return H.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Z[109],ee([12,13]),function(H,e){return H.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Z[110],ee([12,13]),function(H,e){return H.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(Z[111],ee([12,13]),function(H,e){return H.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(Z[112],ee([12,13]),function(H,e){return H.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(Z[113],ee([12,13]),function(H,e){return H.create("vs/platform/extensionManagement/node/extensionsScanner",e)}),define(Z[114],ee([12,13]),function(H,e){return H.create("vs/platform/extensions/common/extensionValidator",e)}),define(Z[115],ee([12,13]),function(H,e){return H.create("vs/platform/files/common/fileService",e)}),define(Z[116],ee([12,13]),function(H,e){return H.create("vs/platform/files/common/files",e)}),define(Z[117],ee([12,13]),function(H,e){return H.create("vs/platform/files/common/io",e)}),define(Z[118],ee([12,13]),function(H,e){return H.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Z[119],ee([12,13]),function(H,e){return H.create("vs/platform/request/common/request",e)}),define(Z[120],ee([12,13]),function(H,e){return H.create("vs/platform/telemetry/common/telemetryService",e)}),define(Z[121],ee([12,13]),function(H,e){return H.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(Z[122],ee([12,13]),function(H,e){return H.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(Z[123],ee([12,13]),function(H,e){return H.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(Z[124],ee([12,13]),function(H,e){return H.create("vs/platform/userDataSync/common/settingsSync",e)}),define(Z[125],ee([12,13]),function(H,e){return H.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(Z[126],ee([12,13]),function(H,e){return H.create("vs/platform/userDataSync/common/userDataSync",e)}),define(Z[127],ee([12,13]),function(H,e){return H.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(Z[128],ee([0,1,7,14,64,55,16,5,34]),function(H,e,y,R,L,A,O,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class S{constructor(f,I,D){this._args=f,this.paths=I,this.productService=D}get appRoot(){return y.dirname(O.FileAccess.asFileUri("",H).fsPath)}get userHome(){return P.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return P.URI.file(y.join(this.userDataPath,"User"))}get tmpDir(){return P.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return R.joinPath(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return R.joinPath(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const f=A.toLocalISOString(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=y.join(this.userDataPath,"logs",f)}return this.args.logsPath}get userDataSyncLogResource(){return P.URI.file(y.join(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return R.joinPath(P.URI.file(y.join(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return P.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return P.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return R.joinPath(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return R.joinPath(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const f=p.env.VSCODE_PORTABLE;return f?P.URI.file(y.join(f,"argv.json")):R.joinPath(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return R.joinPath(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return P.URI.file(y.join(this.userDataPath,"Workspaces"))}get installSourcePath(){return y.join(this.userDataPath,"installSource")}get builtinExtensionsPath(){const f=this.args["builtin-extensions-dir"];return f?y.resolve(f):y.normalize(y.join(O.FileAccess.asFileUri("",H).fsPath,"..","extensions"))}get extensionsDownloadPath(){const f=this.args["extensions-download-dir"];return f?y.resolve(f):y.join(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const f=this.args["extensions-dir"];if(f)return y.resolve(f);const I=p.env.VSCODE_EXTENSIONS;if(I)return I;const D=p.env.VSCODE_PORTABLE;return D?y.join(D,"extensions"):R.joinPath(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const f=this.args.extensionDevelopmentPath;if(Array.isArray(f))return f.map(I=>/^[^:/?#]+?:\/\//.test(I)?P.URI.parse(I):P.URI.file(y.normalize(I)))}get extensionDevelopmentKind(){var f;return(f=this.args.extensionDevelopmentKind)===null||f===void 0?void 0:f.map(I=>I==="ui"||I==="workspace"||I==="web"?I:"workspace")}get extensionTestsLocationURI(){const f=this.args.extensionTestsPath;if(f)return/^[^:/?#]+?:\/\//.test(f)?P.URI.parse(f):P.URI.file(y.normalize(f))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const f=this.args["disable-extension"];if(f){if(typeof f=="string")return[f];if(Array.isArray(f)&&f.length>0)return f}return!1}get debugExtensionHost(){return n(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!p.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return R.joinPath(P.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return P.URI.file(y.join(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}de([L.memoize],S.prototype,"appRoot",null),de([L.memoize],S.prototype,"userHome",null),de([L.memoize],S.prototype,"userDataPath",null),de([L.memoize],S.prototype,"appSettingsHome",null),de([L.memoize],S.prototype,"tmpDir",null),de([L.memoize],S.prototype,"userRoamingDataHome",null),de([L.memoize],S.prototype,"settingsResource",null),de([L.memoize],S.prototype,"userDataSyncHome",null),de([L.memoize],S.prototype,"userDataSyncLogResource",null),de([L.memoize],S.prototype,"sync",null),de([L.memoize],S.prototype,"machineSettingsResource",null),de([L.memoize],S.prototype,"globalStorageHome",null),de([L.memoize],S.prototype,"workspaceStorageHome",null),de([L.memoize],S.prototype,"keybindingsResource",null),de([L.memoize],S.prototype,"keyboardLayoutResource",null),de([L.memoize],S.prototype,"argvResource",null),de([L.memoize],S.prototype,"snippetsHome",null),de([L.memoize],S.prototype,"isExtensionDevelopment",null),de([L.memoize],S.prototype,"untitledWorkspacesHome",null),de([L.memoize],S.prototype,"installSourcePath",null),de([L.memoize],S.prototype,"builtinExtensionsPath",null),de([L.memoize],S.prototype,"extensionsPath",null),de([L.memoize],S.prototype,"extensionDevelopmentLocationURI",null),de([L.memoize],S.prototype,"extensionDevelopmentKind",null),de([L.memoize],S.prototype,"extensionTestsLocationURI",null),de([L.memoize],S.prototype,"debugExtensionHost",null),de([L.memoize],S.prototype,"serviceMachineIdResource",null),de([L.memoize],S.prototype,"telemetryLogResource",null),de([L.memoize],S.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=S;function n(C,f){return h(C["inspect-extensions"],C["inspect-brk-extensions"],5870,f,C.debugId)}e.parseExtensionHostPort=n;function v(C,f){return h(C["inspect-search"],C["inspect-brk-search"],5876,f)}e.parseSearchPort=v;function h(C,f,I,D,E){const g=Number(f||C)||(D?null:I),o=g?Boolean(!!f):!1;return{port:g,break:o,debugId:E}}}),function(){"use strict";function H(e,y,R,L){function A(P){const p=O(P),S=[p];return e.isAbsolute(p)||S.unshift(L),e.resolve(...S)}function O(P){const p=process.env.VSCODE_PORTABLE;if(p)return e.join(p,"user-data");const S=P["user-data-dir"];if(S)return S;let n=process.env.VSCODE_APPDATA;if(!n)switch(process.platform){case"win32":if(n=process.env.APPDATA,!n){const v=process.env.USERPROFILE;if(typeof v!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");n=e.join(v,"AppData","Roaming")}break;case"darwin":n=e.join(y.homedir(),"Library","Application Support");break;case"linux":n=process.env.XDG_CONFIG_HOME||e.join(y.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(n,R)}return{getUserDataPath:A}}if(typeof define=="function")define(Z[129],ee([0,208,35,16,14,34]),function(e,y,R,L,A,O){const P=A.dirname(L.FileAccess.asFileUri("",e)),p=e.__$__nodeRequire(A.joinPath(P,"package.json").fsPath);return H(y,R,p.name,O.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),y=require("path"),R=require("os");module.exports=H(y,R,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Z[130],ee([0,1,35,129,128]),function(H,e,y,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class A extends L.AbstractNativeEnvironmentService{constructor(P,p){super(P,{homeDir:y.homedir(),tmpDir:y.tmpdir(),userDataDir:R.getUserDataPath(P)},p)}}e.NativeEnvironmentService=A}),define(Z[131],ee([0,1,5]),function(H,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const R=/^([^@:]+@)?([^:]+):/,L=/^([^@:]+@)?([^:]+):(.+)$/,A=/^([^@]+@)?([^:]+)(:\d+)?$/,O=/([^@:.]+\.[^@:.]+)(:\d+)?$/,P=/^\s*url\s*=\s*(.+\S)\s*$/mg,p=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function S(D){const E=D.match(O);return E?E[1]:null}function n(D){if(D.indexOf("://")===-1){const E=D.match(R);return E?S(E[2]):null}try{const E=y.URI.parse(D);if(E.authority)return S(E.authority)}catch(E){}return null}function v(D,E){const b=new Set;let g;for(;g=P.exec(D);){const s=n(g[1]);s&&b.add(s)}const o=new Set(E);return Array.from(b).map(s=>o.has(s)?s:s.replace(p,"a"))}e.getDomainsOfRemotes=v;function h(D){const E=D.match(A);return E?E[2]:null}function C(D,E,b){return D&&E?(b&&E.endsWith(".git")&&(E=E.substr(0,E.length-4)),E.indexOf("/")===0?`${D}${E}`:`${D}/${E}`):null}function f(D,E){if(D.indexOf("://")===-1){const b=D.match(L);if(b)return C(b[2],b[3],E)}try{const b=y.URI.parse(D);if(b.authority)return C(h(b.authority),b.path,E)}catch(b){}return null}function I(D,E=!1){const b=[];let g;for(;g=P.exec(D);){const o=f(g[1],E);o&&b.push(o)}return b}e.getRemotes=I}),define(Z[132],ee([0,1,3,5,92,26,2]),function(H,e,y,R,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function P(f,I){return R.URI.revive(I?I.transformIncoming(f):f)}function p(f,I){return I?I.transformOutgoingURI(f):f}function S(f,I){I=I||L.DefaultURITransformer;const D=f.manifest,E=L.transformAndReviveIncomingURIs(Object.assign(Object.assign({},f),{manifest:void 0}),I);return Object.assign(Object.assign({},E),{manifest:D})}function n(f,I){return I?A.cloneAndChange(f,D=>D instanceof R.URI?I.transformOutgoingURI(D):void 0):f}class v{constructor(I,D){this.service=I,this.getUriTransformer=D,this.onInstallExtension=y.Event.buffer(I.onInstallExtension,!0),this.onDidInstallExtension=y.Event.buffer(I.onDidInstallExtension,!0),this.onUninstallExtension=y.Event.buffer(I.onUninstallExtension,!0),this.onDidUninstallExtension=y.Event.buffer(I.onDidUninstallExtension,!0)}listen(I,D){const E=this.getUriTransformer(I);switch(D){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtension":return y.Event.map(this.onDidInstallExtension,b=>Object.assign(Object.assign({},b),{local:b.local?n(b.local,E):b.local}));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(I,D,E){const b=this.getUriTransformer(I);switch(D){case"zip":return this.service.zip(S(E[0],b)).then(g=>p(g,b));case"unzip":return this.service.unzip(P(E[0],b));case"install":return this.service.install(P(E[0],b),E[1]);case"getManifest":return this.service.getManifest(P(E[0],b));case"canInstall":return this.service.canInstall(E[0]);case"installFromGallery":return this.service.installFromGallery(E[0],E[1]);case"uninstall":return this.service.uninstall(S(E[0],b),E[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(S(E[0],b));case"getInstalled":return this.service.getInstalled(E[0]).then(g=>g.map(o=>n(o,b)));case"updateMetadata":return this.service.updateMetadata(S(E[0],b),E[1]).then(g=>n(g,b));case"updateExtensionScope":return this.service.updateExtensionScope(S(E[0],b),E[1]).then(g=>n(g,b));case"getExtensionsReport":return this.service.getExtensionsReport()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=v;class h extends O.Disposable{constructor(I){super();this.channel=I,this._onInstallExtension=this._register(new y.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtension=this._register(new y.Emitter),this.onDidInstallExtension=this._onDidInstallExtension.event,this._onUninstallExtension=this._register(new y.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new y.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(D=>this._onInstallExtension.fire(D))),this._register(this.channel.listen("onDidInstallExtension")(D=>this._onDidInstallExtension.fire(Object.assign(Object.assign({},D),{local:D.local?S(D.local,null):D.local})))),this._register(this.channel.listen("onUninstallExtension")(D=>this._onUninstallExtension.fire(D))),this._register(this.channel.listen("onDidUninstallExtension")(D=>this._onDidUninstallExtension.fire(D)))}zip(I){return Promise.resolve(this.channel.call("zip",[I]).then(D=>R.URI.revive(D)))}unzip(I){return Promise.resolve(this.channel.call("unzip",[I]))}install(I,D){return Promise.resolve(this.channel.call("install",[I,D])).then(E=>S(E,null))}getManifest(I){return Promise.resolve(this.channel.call("getManifest",[I]))}async canInstall(I){return!0}installFromGallery(I,D){return Promise.resolve(this.channel.call("installFromGallery",[I,D])).then(E=>S(E,null))}uninstall(I,D){return Promise.resolve(this.channel.call("uninstall",[I,D]))}reinstallFromGallery(I){return Promise.resolve(this.channel.call("reinstallFromGallery",[I]))}getInstalled(I=null){return Promise.resolve(this.channel.call("getInstalled",[I])).then(D=>D.map(E=>S(E,null)))}updateMetadata(I,D){return Promise.resolve(this.channel.call("updateMetadata",[I,D])).then(E=>S(E,null))}updateExtensionScope(I,D){return Promise.resolve(this.channel.call("updateExtensionScope",[I,D])).then(E=>S(E,null))}getExtensionsReport(){return Promise.resolve(this.channel.call("getExtensionsReport"))}}e.ExtensionManagementChannelClient=h;class C{constructor(I){this.service=I}listen(I,D){throw new Error("Invalid listen")}call(I,D,E){switch(D){case"getConfigBasedTips":return this.service.getConfigBasedTips(R.URI.revive(E[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=C}),define(Z[133],ee([0,1,26]),function(H,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;const R=/^%([\w\d.-]+)%$/i;function L(A,O){const P=p=>{if(typeof p!="string")return;const S=R.exec(p);if(!!S)return O[S[1]]||p};return y.cloneAndChange(A,P)}e.localizeManifest=L}),define(Z[134],ee([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class y{constructor(A){this.channel=A}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(A,O,P,p){return this.channel.call("promptImportantExtensionsInstallNotification",[A,O,P,p])}promptWorkspaceRecommendations(A){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=y;class R{constructor(A){this.service=A}listen(A,O){throw new Error(`Event not found: ${O}`)}call(A,O,P){switch(O){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(P[0],P[1],P[2],P[3])}throw new Error(`Call not found: ${O}`)}}e.ExtensionRecommendationNotificationServiceChannel=R}),define(Z[70],ee([0,1,114]),function(H,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,L=/^-(\d{4})(\d{2})(\d{2})$/;function A(h){return h=h.trim(),h==="*"||R.test(h)}e.isValidVersionStr=A;function O(h){if(!A(h))return null;if(h=h.trim(),h==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let C=h.match(R);return C?{hasCaret:C[1]==="^",hasGreaterEquals:C[1]===">=",majorBase:C[2]==="x"?0:parseInt(C[2],10),majorMustEqual:C[2]!=="x",minorBase:C[4]==="x"?0:parseInt(C[4],10),minorMustEqual:C[4]!=="x",patchBase:C[6]==="x"?0:parseInt(C[6],10),patchMustEqual:C[6]!=="x",preRelease:C[8]||null}:null}e.parseVersion=O;function P(h){if(!h)return null;let C=h.majorBase,f=h.majorMustEqual,I=h.minorBase,D=h.minorMustEqual,E=h.patchBase,b=h.patchMustEqual;h.hasCaret&&(C===0||(D=!1),b=!1);let g=0;if(h.preRelease){const o=L.exec(h.preRelease);if(o){const[,s,t,r]=o;g=Date.UTC(Number(s),Number(t)-1,Number(r))}}return{majorBase:C,majorMustEqual:f,minorBase:I,minorMustEqual:D,patchBase:E,patchMustEqual:b,isMinimum:h.hasGreaterEquals,notBefore:g}}e.normalizeVersion=P;function p(h,C,f){let I;typeof h=="string"?I=P(O(h)):I=h;let D;C instanceof Date?D=C.getTime():typeof C=="string"&&(D=new Date(C).getTime());let E;if(typeof f=="string"?E=P(O(f)):E=f,!I||!E)return!1;let b=I.majorBase,g=I.minorBase,o=I.patchBase,s=E.majorBase,t=E.minorBase,r=E.patchBase,i=E.notBefore,a=E.majorMustEqual,c=E.minorMustEqual,u=E.patchMustEqual;return E.isMinimum?b>s?!0:b<s?!1:g>t?!0:g<t||D&&D<i?!1:o>=r:(b===1&&s===0&&(!a||!c||!u)&&(s=1,t=0,r=0,a=!0,c=!1,u=!1),b<s?!1:b>s?!a:g<t?!1:g>t?!c:o<r?!1:o>r?!u:!(D&&D<i))}e.isValidVersion=p;function S(h,C,f,I){return f.isBuiltin||typeof f.main=="undefined"?!0:v(h,C,f.engines.vscode,I)}e.isValidExtensionVersion=S;function n(h,C,f){return h==="*"||v(C,f,h)}e.isEngineValid=n;function v(h,C,f,I=[]){let D=P(O(f));if(!D)return I.push(y.localize(0,null,f)),!1;if(D.majorBase===0){if(!D.majorMustEqual||!D.minorMustEqual)return I.push(y.localize(1,null,f)),!1}else if(!D.majorMustEqual)return I.push(y.localize(2,null,f)),!1;return p(h,C,D)?!0:(I.push(y.localize(3,null,h,f)),!1)}}),define(Z[135],ee([0,1,36,49,2,16]),function(H,e,y,R,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class O extends L.Disposable{constructor(p,S,n,v){super();this.folders=p,this.onDidFilesChange=S,this.onLogMessage=n,this.verboseLogging=v,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const p=this._register(new R.Client(A.FileAccess.asFileUri("bootstrap-fork",H).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(p.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=O.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=y.ProxyChannel.toService(y.getNextTickChannel(p.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(S=>!this.isDisposed&&this.onDidFilesChange(S))),this._register(this.service.onDidLogMessage(S=>this.onLogMessage(S))),this.setFolders(this.folders)}setVerboseLogging(p){this.verboseLogging=p,!this.isDisposed&&this.service&&this.service.setVerboseLogging(p)}error(p){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${p}`})}setFolders(p){this.folders=p,this.service&&this.service.setRoots(p)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=O,O.MAX_RESTARTS=5}),define(Z[136],ee([0,1,36,49,2,16]),function(H,e,y,R,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class O extends L.Disposable{constructor(p,S,n,v,h={}){super();this.folders=p,this.onDidFilesChange=S,this.onLogMessage=n,this.verboseLogging=v,this.watcherOptions=h,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const p=this._register(new R.Client(A.FileAccess.asFileUri("bootstrap-fork",H).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(p.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=O.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=y.ProxyChannel.toService(y.getNextTickChannel(p.getChannel("watcher"))),this.service.init(Object.assign(Object.assign({},this.watcherOptions),{verboseLogging:this.verboseLogging})),this._register(this.service.onDidChangeFile(S=>!this.isDisposed&&this.onDidFilesChange(S))),this._register(this.service.onDidLogMessage(S=>this.onLogMessage(S))),this.service.setRoots(this.folders)}error(p){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${p}`})}setVerboseLogging(p){this.verboseLogging=p,this.service&&this.service.setVerboseLogging(p)}setFolders(p){this.folders=p,this.service&&this.service.setRoots(p)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=O,O.MAX_RESTARTS=5}),define(Z[137],ee([0,1,43,68,91,16]),function(H,e,y,R,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutOfProcessWin32FolderWatcher=void 0;class O{constructor(p,S,n,v,h){this.watchedFolder=p,this.eventCallback=n,this.logCallback=v,this.verboseLogging=h,this.restartCounter=0,Array.isArray(S)?this.ignored=S.map(C=>L.parse(C)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${p}`),this.startWatcher()}startWatcher(){const p=[this.watchedFolder];this.verboseLogging&&p.push("-verbose"),this.handle=y.spawn(A.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",H).fsPath,p);const S=new R.LineDecoder;this.handle.stdout.on("data",n=>{const v=[];S.write(n).forEach(h=>{const C=h.split("|");if(C.length===2){const f=Number(C[0]),I=C[1];if(f>=0&&f<3){if(this.ignored&&this.ignored.some(D=>D(I))){this.verboseLogging&&this.log(I);return}v.push({type:O.changeTypeMap[f],path:I})}else this.log(C[1])}}),v.length>0&&this.eventCallback(v)}),this.handle.on("error",n=>this.onError(n)),this.handle.stderr.on("data",n=>this.onError(n)),this.handle.on("exit",(n,v)=>this.onExit(n,v))}onError(p){this.error("process error: "+p.toString())}onExit(p,S){this.handle&&(this.error(`terminated unexpectedly (code: ${p}, signal: ${S})`),this.restartCounter<=O.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(p){this.logCallback({type:"error",message:`[File Watcher (C#)] ${p}`})}log(p){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${p}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}e.OutOfProcessWin32FolderWatcher=O,O.MAX_RESTARTS=5,O.changeTypeMap=[0,1,2]}),define(Z[138],ee([0,1,137,7,22]),function(H,e,y,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class A{constructor(P,p,S,n){this.onDidFilesChange=p,this.onLogMessage=S,this.verboseLogging=n,this.service=void 0,this.folder=P[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(R.posix.sep)&&(this.folder.path=L.rtrim(this.folder.path,R.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new y.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,P=>this.onFileEvents(P),P=>this.onLogMessage(P),this.verboseLogging)}setVerboseLogging(P){this.verboseLogging=P,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(P){this.isDisposed||P.length>0&&this.onDidFilesChange(P)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}e.FileWatcher=A}),define(Z[50],ee([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class y{constructor(A,O=[],P=!1){this.ctor=A,this.staticArguments=O,this.supportsDelayedInstantiation=P}}e.SyncDescriptor=y;const R=(L,...A)=>new y(L,A);e.createSyncDescriptor=R}),define(Z[139],ee([0,1,50]),function(H,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const R=[];function L(O,P,p){P instanceof y.SyncDescriptor||(P=new y.SyncDescriptor(P,[],p)),R.push([O,P])}e.registerSingleton=L;function A(){return R}e.getSingletonServiceDescriptors=A}),define(Z[140],ee([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class y{constructor(A){this.incoming=new Map,this.outgoing=new Map,this.data=A}}e.Node=y;class R{constructor(A){this._hashFn=A,this._nodes=new Map}roots(){const A=[];for(let O of this._nodes.values())O.outgoing.size===0&&A.push(O);return A}insertEdge(A,O){const P=this.lookupOrInsertNode(A),p=this.lookupOrInsertNode(O);P.outgoing.set(this._hashFn(O),p),p.incoming.set(this._hashFn(A),P)}removeNode(A){const O=this._hashFn(A);this._nodes.delete(O);for(let P of this._nodes.values())P.outgoing.delete(O),P.incoming.delete(O)}lookupOrInsertNode(A){const O=this._hashFn(A);let P=this._nodes.get(O);return P||(P=new y(A),this._nodes.set(O,P)),P}lookup(A){return this._nodes.get(this._hashFn(A))}isEmpty(){return this._nodes.size===0}toString(){let A=[];for(let[O,P]of this._nodes)A.push(`${O}, (incoming)[${[...P.incoming.keys()].join(", ")}], (outgoing)[${[...P.outgoing.keys()].join(",")}]`);return A.join(`
`)}findCycleSlow(){for(let[A,O]of this._nodes){const P=new Set([A]),p=this._findCycle(O,P);if(p)return p}}_findCycle(A,O){for(let[P,p]of A.outgoing){if(O.has(P))return[...O,P].join(" -> ");O.add(P);const S=this._findCycle(p,O);if(S)return S;O.delete(P)}}}e.Graph=R}),define(Z[4],ee([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var y;(function(P){P.serviceIds=new Map,P.DI_TARGET="$di$target",P.DI_DEPENDENCIES="$di$dependencies";function p(S){return S[P.DI_DEPENDENCIES]||[]}P.getServiceDependencies=p})(y=e._util||(e._util={})),e.IInstantiationService=L("instantiationService");function R(P,p,S,n){p[y.DI_TARGET]===p?p[y.DI_DEPENDENCIES].push({id:P,index:S,optional:n}):(p[y.DI_DEPENDENCIES]=[{id:P,index:S,optional:n}],p[y.DI_TARGET]=p)}function L(P){if(y.serviceIds.has(P))return y.serviceIds.get(P);const p=function(S,n,v){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");R(p,S,v,!1)};return p.toString=()=>P,y.serviceIds.set(P,p),p}e.createDecorator=L;function A(P){return P}e.refineServiceDecorator=A;function O(P){return function(p,S,n){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");R(P,p,n,!0)}}e.optional=O}),define(Z[141],ee([0,1,4]),function(H,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=y.createDecorator("checksumService")}),define(Z[142],ee([0,1,22,4,6]),function(H,e,y,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let A=L.userAgent||"";const O=new Map;O.set("false",!1),O.set("true",!0),O.set("isMac",L.isMacintosh),O.set("isLinux",L.isLinux),O.set("isWindows",L.isWindows),O.set("isWeb",L.isWeb),O.set("isMacNative",L.isMacintosh&&!L.isWeb),O.set("isEdge",A.indexOf("Edg/")>=0),O.set("isFirefox",A.indexOf("Firefox")>=0),O.set("isChrome",A.indexOf("Chrome")>=0),O.set("isSafari",A.indexOf("Safari")>=0);const P=Object.prototype.hasOwnProperty;var p;(function(w){w[w.False=0]="False",w[w.True=1]="True",w[w.Defined=2]="Defined",w[w.Not=3]="Not",w[w.Equals=4]="Equals",w[w.NotEquals=5]="NotEquals",w[w.And=6]="And",w[w.Regex=7]="Regex",w[w.NotRegex=8]="NotRegex",w[w.Or=9]="Or",w[w.In=10]="In",w[w.NotIn=11]="NotIn",w[w.Greater=12]="Greater",w[w.GreaterEquals=13]="GreaterEquals",w[w.Smaller=14]="Smaller",w[w.SmallerEquals=15]="SmallerEquals"})(p=e.ContextKeyExprType||(e.ContextKeyExprType={}));class S{static false(){return v.INSTANCE}static true(){return h.INSTANCE}static has(d){return C.create(d)}static equals(d,T){return f.create(d,T)}static notEquals(d,T){return E.create(d,T)}static regex(d,T){return r.create(d,T)}static in(d,T){return I.create(d,T)}static not(d){return b.create(d)}static and(...d){return a.create(d)}static or(...d){return c.create(d)}static greater(d,T){return g.create(d,T)}static less(d,T){return s.create(d,T)}static deserialize(d,T=!1){if(!!d)return this._deserializeOrExpression(d,T)}static _deserializeOrExpression(d,T){let _=d.split("||");return c.create(_.map(j=>this._deserializeAndExpression(j,T)))}static _deserializeAndExpression(d,T){let _=d.split("&&");return a.create(_.map(j=>this._deserializeOne(j,T)))}static _deserializeOne(d,T){if(d=d.trim(),d.indexOf("!=")>=0){let _=d.split("!=");return E.create(_[0].trim(),this._deserializeValue(_[1],T))}if(d.indexOf("==")>=0){let _=d.split("==");return f.create(_[0].trim(),this._deserializeValue(_[1],T))}if(d.indexOf("=~")>=0){let _=d.split("=~");return r.create(_[0].trim(),this._deserializeRegexValue(_[1],T))}if(d.indexOf(" in ")>=0){let _=d.split(" in ");return I.create(_[0].trim(),_[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(d)){const _=d.split(">=");return o.create(_[0].trim(),_[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(d)){const _=d.split(">");return g.create(_[0].trim(),_[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(d)){const _=d.split("<=");return t.create(_[0].trim(),_[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(d)){const _=d.split("<");return s.create(_[0].trim(),_[1].trim())}return/^\!\s*/.test(d)?b.create(d.substr(1).trim()):C.create(d)}static _deserializeValue(d,T){if(d=d.trim(),d==="true")return!0;if(d==="false")return!1;let _=/^'([^']*)'$/.exec(d);return _?_[1].trim():d}static _deserializeRegexValue(d,T){if(y.isFalsyOrWhitespace(d)){if(T)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let _=d.indexOf("/"),j=d.lastIndexOf("/");if(_===j||_<0){if(T)throw new Error(`bad regexp-value '${d}', missing /-enclosure`);return console.warn(`bad regexp-value '${d}', missing /-enclosure`),null}let $=d.slice(_+1,j),K=d[j+1]==="i"?"i":"";try{return new RegExp($,K)}catch(B){if(T)throw new Error(`bad regexp-value '${d}', parse error: ${B}`);return console.warn(`bad regexp-value '${d}', parse error: ${B}`),null}}}e.ContextKeyExpr=S;function n(w,d){return w.cmp(d)}class v{constructor(){this.type=0}cmp(d){return this.type-d.type}equals(d){return d.type===this.type}evaluate(d){return!1}serialize(){return"false"}keys(){return[]}map(d){return this}negate(){return h.INSTANCE}}e.ContextKeyFalseExpr=v,v.INSTANCE=new v;class h{constructor(){this.type=1}cmp(d){return this.type-d.type}equals(d){return d.type===this.type}evaluate(d){return!0}serialize(){return"true"}keys(){return[]}map(d){return this}negate(){return v.INSTANCE}}e.ContextKeyTrueExpr=h,h.INSTANCE=new h;class C{constructor(d){this.key=d,this.type=2}static create(d){const T=O.get(d);return typeof T=="boolean"?T?h.INSTANCE:v.INSTANCE:new C(d)}cmp(d){return d.type!==this.type?this.type-d.type:l(this.key,d.key)}equals(d){return d.type===this.type?this.key===d.key:!1}evaluate(d){return!!d.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(d){return d.mapDefined(this.key)}negate(){return b.create(this.key)}}e.ContextKeyDefinedExpr=C;class f{constructor(d,T){this.key=d,this.value=T,this.type=4}static create(d,T){if(typeof T=="boolean")return T?C.create(d):b.create(d);const _=O.get(d);return typeof _=="boolean"?T===(_?"true":"false")?h.INSTANCE:v.INSTANCE:new f(d,T)}cmp(d){return d.type!==this.type?this.type-d.type:m(this.key,this.value,d.key,d.value)}equals(d){return d.type===this.type?this.key===d.key&&this.value===d.value:!1}evaluate(d){return d.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(d){return d.mapEquals(this.key,this.value)}negate(){return E.create(this.key,this.value)}}e.ContextKeyEqualsExpr=f;class I{constructor(d,T){this.key=d,this.valueKey=T,this.type=10}static create(d,T){return new I(d,T)}cmp(d){return d.type!==this.type?this.type-d.type:m(this.key,this.valueKey,d.key,d.valueKey)}equals(d){return d.type===this.type?this.key===d.key&&this.valueKey===d.valueKey:!1}evaluate(d){const T=d.getValue(this.valueKey),_=d.getValue(this.key);return Array.isArray(T)?T.indexOf(_)>=0:typeof _=="string"&&typeof T=="object"&&T!==null?P.call(T,_):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(d){return d.mapIn(this.key,this.valueKey)}negate(){return D.create(this)}}e.ContextKeyInExpr=I;class D{constructor(d){this._actual=d,this.type=11}static create(d){return new D(d)}cmp(d){return d.type!==this.type?this.type-d.type:this._actual.cmp(d._actual)}equals(d){return d.type===this.type?this._actual.equals(d._actual):!1}evaluate(d){return!this._actual.evaluate(d)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(d){return new D(this._actual.map(d))}negate(){return this._actual}}e.ContextKeyNotInExpr=D;class E{constructor(d,T){this.key=d,this.value=T,this.type=5}static create(d,T){if(typeof T=="boolean")return T?b.create(d):C.create(d);const _=O.get(d);return typeof _=="boolean"?T===(_?"true":"false")?v.INSTANCE:h.INSTANCE:new E(d,T)}cmp(d){return d.type!==this.type?this.type-d.type:m(this.key,this.value,d.key,d.value)}equals(d){return d.type===this.type?this.key===d.key&&this.value===d.value:!1}evaluate(d){return d.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(d){return d.mapNotEquals(this.key,this.value)}negate(){return f.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=E;class b{constructor(d){this.key=d,this.type=3}static create(d){const T=O.get(d);return typeof T=="boolean"?T?v.INSTANCE:h.INSTANCE:new b(d)}cmp(d){return d.type!==this.type?this.type-d.type:l(this.key,d.key)}equals(d){return d.type===this.type?this.key===d.key:!1}evaluate(d){return!d.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(d){return d.mapNot(this.key)}negate(){return C.create(this.key)}}e.ContextKeyNotExpr=b;class g{constructor(d,T){this.key=d,this.value=T,this.type=12}static create(d,T){return new g(d,T)}cmp(d){return d.type!==this.type?this.type-d.type:m(this.key,this.value,d.key,d.value)}equals(d){return d.type===this.type?this.key===d.key&&this.value===d.value:!1}evaluate(d){return parseFloat(d.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(d){return d.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=g;class o{constructor(d,T){this.key=d,this.value=T,this.type=13}static create(d,T){return new o(d,T)}cmp(d){return d.type!==this.type?this.type-d.type:m(this.key,this.value,d.key,d.value)}equals(d){return d.type===this.type?this.key===d.key&&this.value===d.value:!1}evaluate(d){return parseFloat(d.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(d){return d.mapGreaterEquals(this.key,this.value)}negate(){return s.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=o;class s{constructor(d,T){this.key=d,this.value=T,this.type=14}static create(d,T){return new s(d,T)}cmp(d){return d.type!==this.type?this.type-d.type:m(this.key,this.value,d.key,d.value)}equals(d){return d.type===this.type?this.key===d.key&&this.value===d.value:!1}evaluate(d){return parseFloat(d.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(d){return d.mapSmaller(this.key,this.value)}negate(){return o.create(this.key,this.value)}}e.ContextKeySmallerExpr=s;class t{constructor(d,T){this.key=d,this.value=T,this.type=15}static create(d,T){return new t(d,T)}cmp(d){return d.type!==this.type?this.type-d.type:m(this.key,this.value,d.key,d.value)}equals(d){return d.type===this.type?this.key===d.key&&this.value===d.value:!1}evaluate(d){return parseFloat(d.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(d){return d.mapSmallerEquals(this.key,this.value)}negate(){return g.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class r{constructor(d,T){this.key=d,this.regexp=T,this.type=7}static create(d,T){return new r(d,T)}cmp(d){if(d.type!==this.type)return this.type-d.type;if(this.key<d.key)return-1;if(this.key>d.key)return 1;const T=this.regexp?this.regexp.source:"",_=d.regexp?d.regexp.source:"";return T<_?-1:T>_?1:0}equals(d){if(d.type===this.type){const T=this.regexp?this.regexp.source:"",_=d.regexp?d.regexp.source:"";return this.key===d.key&&T===_}return!1}evaluate(d){let T=d.getValue(this.key);return this.regexp?this.regexp.test(T):!1}serialize(){const d=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${d}`}keys(){return[this.key]}map(d){return d.mapRegex(this.key,this.regexp)}negate(){return i.create(this)}}e.ContextKeyRegexExpr=r;class i{constructor(d){this._actual=d,this.type=8}static create(d){return new i(d)}cmp(d){return d.type!==this.type?this.type-d.type:this._actual.cmp(d._actual)}equals(d){return d.type===this.type?this._actual.equals(d._actual):!1}evaluate(d){return!this._actual.evaluate(d)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(d){return new i(this._actual.map(d))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=i;class a{constructor(d){this.expr=d,this.type=6}static create(d){return a._normalizeArr(d)}cmp(d){if(d.type!==this.type)return this.type-d.type;if(this.expr.length<d.expr.length)return-1;if(this.expr.length>d.expr.length)return 1;for(let T=0,_=this.expr.length;T<_;T++){const j=n(this.expr[T],d.expr[T]);if(j!==0)return j}return 0}equals(d){if(d.type===this.type){if(this.expr.length!==d.expr.length)return!1;for(let T=0,_=this.expr.length;T<_;T++)if(!this.expr[T].equals(d.expr[T]))return!1;return!0}return!1}evaluate(d){for(let T=0,_=this.expr.length;T<_;T++)if(!this.expr[T].evaluate(d))return!1;return!0}static _normalizeArr(d){const T=[];let _=!1;for(const j of d)if(!!j){if(j.type===1){_=!0;continue}if(j.type===0)return v.INSTANCE;if(j.type===6){T.push(...j.expr);continue}T.push(j)}if(T.length===0&&_)return h.INSTANCE;if(T.length!==0){if(T.length===1)return T[0];for(T.sort(n);T.length>1;){const j=T[T.length-1];if(j.type!==9)break;T.pop();const $=T.pop(),K=c.create(j.expr.map(B=>a.create([B,$])));K&&(T.push(K),T.sort(n))}return T.length===1?T[0]:new a(T)}}serialize(){return this.expr.map(d=>d.serialize()).join(" && ")}keys(){const d=[];for(let T of this.expr)d.push(...T.keys());return d}map(d){return new a(this.expr.map(T=>T.map(d)))}negate(){let d=[];for(let T of this.expr)d.push(T.negate());return c.create(d)}}e.ContextKeyAndExpr=a;class c{constructor(d){this.expr=d,this.type=9}static create(d){const T=c._normalizeArr(d);if(T.length!==0)return T.length===1?T[0]:new c(T)}cmp(d){if(d.type!==this.type)return this.type-d.type;if(this.expr.length<d.expr.length)return-1;if(this.expr.length>d.expr.length)return 1;for(let T=0,_=this.expr.length;T<_;T++){const j=n(this.expr[T],d.expr[T]);if(j!==0)return j}return 0}equals(d){if(d.type===this.type){if(this.expr.length!==d.expr.length)return!1;for(let T=0,_=this.expr.length;T<_;T++)if(!this.expr[T].equals(d.expr[T]))return!1;return!0}return!1}evaluate(d){for(let T=0,_=this.expr.length;T<_;T++)if(this.expr[T].evaluate(d))return!0;return!1}static _normalizeArr(d){let T=[],_=!1;if(d){for(let j=0,$=d.length;j<$;j++){const K=d[j];if(!!K){if(K.type===0){_=!0;continue}if(K.type===1)return[h.INSTANCE];if(K.type===9){T=T.concat(K.expr);continue}T.push(K)}}if(T.length===0&&_)return[v.INSTANCE];T.sort(n)}return T}serialize(){return this.expr.map(d=>d.serialize()).join(" || ")}keys(){const d=[];for(let T of this.expr)d.push(...T.keys());return d}map(d){return new c(this.expr.map(T=>T.map(d)))}negate(){let d=[];for(let _ of this.expr)d.push(_.negate());const T=_=>_.type===9?_.expr:[_];for(;d.length>1;){const _=d.shift(),j=d.shift(),$=[];for(const K of T(_))for(const B of T(j))$.push(S.and(K,B));d.unshift(S.or(...$))}return d[0]}}e.ContextKeyOrExpr=c;class u extends C{constructor(d,T,_){super(d);this._defaultValue=T,typeof _=="object"?u._info.push(Object.assign(Object.assign({},_),{key:d})):_!==!0&&u._info.push({key:d,description:_,type:T!=null?typeof T:void 0})}static all(){return u._info.values()}bindTo(d){return d.createKey(this.key,this._defaultValue)}getValue(d){return d.getContextKeyValue(this.key)}toNegated(){return S.not(this.key)}isEqualTo(d){return S.equals(this.key,d)}notEqualsTo(d){return S.notEquals(this.key,d)}}e.RawContextKey=u,u._info=[],e.IContextKeyService=R.createDecorator("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function l(w,d){return w<d?-1:w>d?1:0}function m(w,d,T,_){return w<T?-1:w>T?1:d<_?-1:d>_?1:0}}),define(Z[71],ee([0,1,4]),function(H,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=y.createDecorator(e.ID);function R(L){return!!L.hostName&&!!L.errorMessage}e.isRemoteDiagnosticError=R}),define(Z[72],ee([0,1,4]),function(H,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=y.createDecorator("downloadService")}),define(Z[9],ee([0,1,4]),function(H,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=y.createDecorator("environmentService"),e.INativeEnvironmentService=y.refineServiceDecorator(e.IEnvironmentService)});var Y=this&&this.__param||function(H,e){return function(y,R){e(y,R,H)}};define(Z[143],ee([0,1,9,7,17,11,2,8]),function(H,e,y,R,L,A,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let p=class extends O.Disposable{constructor(n){super();this.environmentService=n,this.cleanUpOldLogsSoon()}cleanUpOldLogsSoon(){let n=setTimeout(()=>{n=void 0;const v=R.basename(this.environmentService.logsPath),h=R.dirname(this.environmentService.logsPath);L.readdir(h).then(C=>{const I=C.filter(E=>/^\d{8}T\d{6}$/.test(E)).sort().filter((E,b)=>E!==v),D=I.slice(0,Math.max(0,I.length-9));return P.Promises.settled(D.map(E=>L.rimraf(R.join(h,E))))}).then(null,A.onUnexpectedError)},10*1e3);this._register(O.toDisposable(()=>{n&&(clearTimeout(n),n=void 0)}))}};p=de([Y(0,y.IEnvironmentService)],p),e.LogsDataCleaner=p}),define(Z[144],ee([0,1,9,7,17,11,2]),function(H,e,y,R,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDataCleaner=void 0;let P=class ht extends O.Disposable{constructor(S,n){super();this.backupWorkspacesPath=S,this.environmentService=n,this.cleanUpStorageSoon()}cleanUpStorageSoon(){let S=setTimeout(()=>{S=void 0,(async()=>{try{const n=await L.Promises.readFile(this.backupWorkspacesPath,"utf8"),h=JSON.parse(n).emptyWorkspaceInfos.map(I=>I.backupFolder),C=await L.readdir(this.environmentService.workspaceStorageHome.fsPath),f=[];C.forEach(I=>{I.length!==ht.NON_EMPTY_WORKSPACE_ID_LENGTH&&h.indexOf(I)===-1&&f.push(L.rimraf(R.join(this.environmentService.workspaceStorageHome.fsPath,I)))}),await Promise.all(f)}catch(n){A.onUnexpectedError(n)}})()},30*1e3);this._register(O.toDisposable(()=>{S&&(clearTimeout(S),S=void 0)}))}};P.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4,P=de([Y(1,y.INativeEnvironmentService)],P),e.StorageDataCleaner=P}),define(Z[28],ee([0,1,109,4,16]),function(H,e,y,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN);function A(v){return v&&typeof v=="object"&&typeof v.id=="string"&&(!v.uuid||typeof v.uuid=="string")}e.isIExtensionIdentifier=A;var O;(function(v){v[v.NoneOrRelevance=0]="NoneOrRelevance",v[v.LastUpdatedDate=1]="LastUpdatedDate",v[v.Title=2]="Title",v[v.PublisherName=3]="PublisherName",v[v.InstallCount=4]="InstallCount",v[v.PublishedDate=5]="PublishedDate",v[v.AverageRating=6]="AverageRating",v[v.WeightedRating=12]="WeightedRating"})(O=e.SortBy||(e.SortBy={}));var P;(function(v){v[v.Default=0]="Default",v[v.Ascending=1]="Ascending",v[v.Descending=2]="Descending"})(P=e.SortOrder||(e.SortOrder={}));var p;(function(v){v.Uninstall="uninstall"})(p=e.StatisticType||(e.StatisticType={}));var S;(function(v){v[v.None=0]="None",v[v.Install=1]="Install",v[v.Update=2]="Update"})(S=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=R.createDecorator("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class n extends Error{constructor(h,C){super(h);this.code=C}}e.ExtensionManagementError=n,e.IExtensionManagementService=R.createDecorator("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=R.createDecorator("IGlobalExtensionEnablementService"),e.IExtensionTipsService=R.createDecorator("IExtensionTipsService"),e.DefaultIconPath=L.FileAccess.asBrowserUri("./media/defaultIcon.png",H).toString(!0),e.ExtensionsLabel=y.localize(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=y.localize(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=R.createDecorator("IExtensionManagementCLIService")}),define(Z[145],ee([0,1,2,28]),function(H,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DeprecatedExtensionsCleaner=void 0;let L=class extends y.Disposable{constructor(O){super();this.extensionManagementService=O,this._register(O),this.cleanUpDeprecatedExtensions()}cleanUpDeprecatedExtensions(){this.extensionManagementService.removeDeprecatedExtensions()}};L=de([Y(0,R.IExtensionManagementService)],L),e.DeprecatedExtensionsCleaner=L}),define(Z[73],ee([0,1,4]),function(H,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var R;(function(O){O[O.FILE=1]="FILE",O[O.WORKSPACE=2]="WORKSPACE",O[O.EXE=3]="EXE"})(R=e.RecommendationSource||(e.RecommendationSource={}));function L(O){switch(O){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=L;var A;(function(O){O.Ignored="ignored",O.Cancelled="cancelled",O.TooMany="toomany",O.IncompatibleWindow="incompatibleWindow",O.Accepted="reacted"})(A=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=y.createDecorator("IExtensionRecommendationNotificationService")}),define(Z[74],ee([0,1,22,4]),function(H,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkpaceSupportTypeMessage=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function L(n){if(typeof n=="object"&&n!==null&&n.supported!==!0)return n.description}e.getWorkpaceSupportTypeMessage=L;function A(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.isIExtensionIdentifier=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var O;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(O=e.ExtensionType||(e.ExtensionType={}));class P{constructor(v){this.value=v,this._lower=v.toLowerCase()}static equals(v,h){if(typeof v=="undefined"||v===null)return typeof h=="undefined"||h===null;if(typeof h=="undefined"||h===null)return!1;if(typeof v=="string"||typeof h=="string"){let C=typeof v=="string"?v:v.value,f=typeof h=="string"?h:h.value;return y.equalsIgnoreCase(C,f)}return v._lower===h._lower}static toKey(v){return typeof v=="string"?v.toLowerCase():v._lower}}e.ExtensionIdentifier=P;function p(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}e.isLanguagePackExtension=p;function S(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=S,e.IBuiltinExtensionsScannerService=R.createDecorator("IBuiltinExtensionsScannerService")}),define(Z[33],ee([0,1,22,74]),function(H,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function L(C,f){return C.uuid&&f.uuid?C.uuid===f.uuid:C.id===f.id?!0:y.compareIgnoreCase(C.id,f.id)===0}e.areSameExtensions=L;class A{constructor(f,I){this.version=I,this.id=f.id,this.uuid=f.uuid}key(){return`${this.id}-${this.version}`}equals(f){return f instanceof A?L(this,f)&&this.version===f.version:!1}}e.ExtensionIdentifierWithVersion=A;function O(C,f){return`${C}.${f}`}e.getExtensionId=O;function P(C){return C.toLocaleLowerCase()}e.adoptToGalleryExtensionId=P;function p(C,f){return P(O(C,f))}e.getGalleryExtensionId=p;function S(C,f){const I=[],D=E=>{for(const b of I)if(b.some(g=>L(f(g),f(E))))return b;return null};for(const E of C){const b=D(E);b?b.push(E):I.push([E])}return I}e.groupByExtension=S;function n(C){return{id:C.identifier.id,name:C.manifest.name,galleryId:null,publisherId:C.publisherId,publisherName:C.manifest.publisher,publisherDisplayName:C.publisherDisplayName,dependencies:C.manifest.extensionDependencies&&C.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=n;function v(C){return Object.assign({id:C.identifier.id,name:C.name,galleryId:C.identifier.uuid,publisherId:C.publisherId,publisherName:C.publisher,publisherDisplayName:C.publisherDisplayName,dependencies:!!(C.properties.dependencies&&C.properties.dependencies.length>0)},C.telemetryData)}e.getGalleryExtensionTelemetryData=v,e.BetterMergeId=new R.ExtensionIdentifier("pprice.better-merge");function h(C){const f=new Set;for(const I of C)I.malicious&&f.add(I.id.id);return f}e.getMaliciousExtensionsSet=h}),define(Z[146],ee([0,1,2,7,74,17]),function(H,e,y,R,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class O extends y.Disposable{constructor(p,S){super();this.environmentService=p,this.extensionsManifestCache=R.join(this.environmentService.userDataPath,L.MANIFEST_CACHE_FOLDER,L.USER_MANIFEST_CACHE_FILE),this._register(S.onDidInstallExtension(n=>this.onDidInstallExtension(n))),this._register(S.onDidUninstallExtension(n=>this.onDidUnInstallExtension(n)))}onDidInstallExtension(p){p.error||this.invalidate()}onDidUnInstallExtension(p){p.error||this.invalidate()}invalidate(){A.rimraf(this.extensionsManifestCache,A.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=O}),define(Z[10],ee([0,1,116,7,5,4,22,15,38]),function(H,e,y,R,L,A,O,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=A.createDecorator("fileService");function S(z){return z.create===!0}e.isFileOpenForWriteOptions=S;var n;(function(z){z[z.Unknown=0]="Unknown",z[z.File=1]="File",z[z.Directory=2]="Directory",z[z.SymbolicLink=64]="SymbolicLink"})(n=e.FileType||(e.FileType={}));var v;(function(z){z[z.Readonly=1]="Readonly"})(v=e.FilePermission||(e.FilePermission={}));var h;(function(z){z[z.FileReadWrite=2]="FileReadWrite",z[z.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",z[z.FileReadStream=16]="FileReadStream",z[z.FileFolderCopy=8]="FileFolderCopy",z[z.PathCaseSensitive=1024]="PathCaseSensitive",z[z.Readonly=2048]="Readonly",z[z.Trash=4096]="Trash",z[z.FileWriteUnlock=8192]="FileWriteUnlock"})(h=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function C(z){return!!(z.capabilities&2)}e.hasReadWriteCapability=C;function f(z){return!!(z.capabilities&8)}e.hasFileFolderCopyCapability=f;function I(z){return!!(z.capabilities&4)}e.hasOpenReadWriteCloseCapability=I;function D(z){return!!(z.capabilities&16)}e.hasFileReadStreamCapability=D;var E;(function(z){z.FileExists="EntryExists",z.FileNotFound="EntryNotFound",z.FileNotADirectory="EntryNotADirectory",z.FileIsADirectory="EntryIsADirectory",z.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",z.FileTooLarge="EntryTooLarge",z.FileWriteLocked="EntryWriteLocked",z.NoPermissions="NoPermissions",z.Unavailable="Unavailable",z.Unknown="Unknown"})(E=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class b extends Error{constructor(G,V){super(G);this.code=V}}e.FileSystemProviderError=b;function g(z,G){const V=new b(z.toString(),G);return s(V,G),V}e.createFileSystemProviderError=g;function o(z){return z||g(y.localize(0,null),E.Unknown)}e.ensureFileSystemProviderError=o;function s(z,G){return z.name=G?`${G} (FileSystemError)`:"FileSystemError",z}e.markAsFileSystemProviderError=s;function t(z){if(!z)return E.Unknown;if(z instanceof b)return z.code;const G=/^(.+) \(FileSystemError\)$/.exec(z.name);if(!G)return E.Unknown;switch(G[1]){case E.FileExists:return E.FileExists;case E.FileIsADirectory:return E.FileIsADirectory;case E.FileNotADirectory:return E.FileNotADirectory;case E.FileNotFound:return E.FileNotFound;case E.FileExceedsMemoryLimit:return E.FileExceedsMemoryLimit;case E.FileTooLarge:return E.FileTooLarge;case E.FileWriteLocked:return E.FileWriteLocked;case E.NoPermissions:return E.NoPermissions;case E.Unavailable:return E.Unavailable}return E.Unknown}e.toFileSystemProviderErrorCode=t;function r(z){if(z instanceof m)return z.fileOperationResult;switch(t(z)){case E.FileNotFound:return 1;case E.FileIsADirectory:return 0;case E.FileNotADirectory:return 10;case E.FileWriteLocked:return 5;case E.NoPermissions:return 6;case E.FileExists:return 4;case E.FileExceedsMemoryLimit:return 9;case E.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var i;(function(z){z[z.CREATE=0]="CREATE",z[z.DELETE=1]="DELETE",z[z.MOVE=2]="MOVE",z[z.COPY=3]="COPY"})(i=e.FileOperation||(e.FileOperation={}));class a{constructor(G,V,M){this.resource=G,this.operation=V,this.target=M}isOperation(G){return this.operation===G}}e.FileOperationEvent=a;var c;(function(z){z[z.UPDATED=0]="UPDATED",z[z.ADDED=1]="ADDED",z[z.DELETED=2]="DELETED"})(c=e.FileChangeType||(e.FileChangeType={}));class u{constructor(G,V){this.ignorePathCasing=V,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=G;for(const M of G)switch(M.type){case 1:this.added||(this.added=p.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set(M.resource,M);break;case 0:this.updated||(this.updated=p.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set(M.resource,M);break;case 2:this.deleted||(this.deleted=p.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set(M.resource,M);break}}contains(G,...V){return this.doContains(G,{includeChildren:!1},...V)}affects(G,...V){return this.doContains(G,{includeChildren:!0},...V)}doContains(G,V,...M){var U,k,F,N,q,W;if(!G)return!1;const Q=M.length>0;return!!((!Q||M.includes(1))&&(((U=this.added)===null||U===void 0?void 0:U.get(G))||V.includeChildren&&((k=this.added)===null||k===void 0?void 0:k.findSuperstr(G)))||(!Q||M.includes(0))&&(((F=this.updated)===null||F===void 0?void 0:F.get(G))||V.includeChildren&&((N=this.updated)===null||N===void 0?void 0:N.findSuperstr(G)))||(!Q||M.includes(2))&&(((q=this.deleted)===null||q===void 0?void 0:q.findSubstr(G))||V.includeChildren&&((W=this.deleted)===null||W===void 0?void 0:W.findSuperstr(G))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType(G){const V=[],M=G===1?this.added:G===0?this.updated:this.deleted;if(M)for(const[,U]of M)V.push(U);return V}filter(G){return new u(this.changes.filter(V=>G(V)),this.ignorePathCasing)}}e.FileChangesEvent=u;function l(z,G,V){return!z||!G||z===G||G.length>z.length?!1:(G.charAt(G.length-1)!==R.sep&&(G+=R.sep),V?O.startsWithIgnoreCase(z,G):z.indexOf(G)===0)}e.isParent=l;class m extends Error{constructor(G,V,M){super(G);this.fileOperationResult=V,this.options=M}}e.FileOperationError=m;class w extends m{constructor(G,V,M){super(G,2,M);this.stat=V}}e.NotModifiedSinceFileOperationError=w;var d;(function(z){z[z.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",z[z.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",z[z.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",z[z.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",z[z.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",z[z.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",z[z.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",z[z.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",z[z.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",z[z.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",z[z.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",z[z.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(d=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var T;(function(z){z[z.FILE=0]="FILE",z[z.FOLDER=1]="FOLDER",z[z.ROOT_FOLDER=2]="ROOT_FOLDER"})(T=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function _(z){if(!(typeof z.size!="number"||typeof z.mtime!="number"))return z.mtime.toString(29)+z.size.toString(31)}e.etag=_;async function j(z,G){if(!G.canHandleResource(L.URI.from({scheme:z.scheme})))return new Promise(V=>{const M=G.onDidChangeFileSystemProviderRegistrations(U=>{U.scheme===z.scheme&&U.added&&(M.dispose(),V())})})}e.whenProviderRegistered=j,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ${static formatSize(G){return P.isNumber(G)||(G=0),G<$.KB?y.localize(1,null,G.toFixed(0)):G<$.MB?y.localize(2,null,(G/$.KB).toFixed(2)):G<$.GB?y.localize(3,null,(G/$.MB).toFixed(2)):G<$.TB?y.localize(4,null,(G/$.GB).toFixed(2)):y.localize(5,null,(G/$.TB).toFixed(2))}}e.ByteSize=$,$.KB=1024,$.MB=$.KB*$.KB,$.GB=$.MB*$.KB,$.TB=$.GB*$.KB;var K;(function(z){z[z.IA32=0]="IA32",z[z.OTHER=1]="OTHER"})(K=e.Arch||(e.Arch={}));function B(z){return{maxFileSize:z===0?300*$.MB:16*$.GB,maxHeapSize:z===0?700*$.MB:2*700*$.MB}}e.getPlatformLimits=B}),define(Z[147],ee([0,1,148,48,10]),function(H,e,y,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let A=class{constructor(P){this.fileService=P}checksum(P){return new Promise(async(p,S)=>{const n=y.createHash("md5"),v=(await this.fileService.readFileStream(P)).value;R.listenStream(v,{onData:h=>n.update(h.buffer),onError:h=>S(h),onEnd:()=>p(n.digest("base64").replace(/=+$/,""))})})}};A=de([Y(0,L.IFileService)],A),e.ChecksumService=A}),define(Z[75],ee([0,1,5,10,6]),function(H,e,y,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=void 0;function A(p){return p.map(S=>({type:S.type,resource:y.URI.file(S.path)}))}e.toFileChanges=A;function O(p){const S=new P;for(const n of p)S.processEvent(n);return S.normalize()}e.normalizeFileChanges=O;class P{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(S){const n=this.mapPathToChange.get(S.path);if(n){const v=n.type,h=S.type;v===1&&h===2?(this.mapPathToChange.delete(S.path),this.normalized.splice(this.normalized.indexOf(n),1)):v===2&&h===1?n.type=0:v===1&&h===0||(n.type=h)}else this.normalized.push(S),this.mapPathToChange.set(S.path,S)}normalize(){const S=[],n=[];return this.normalized.filter(v=>v.type!==2?(S.push(v),!1):!0).sort((v,h)=>v.path.length-h.path.length).filter(v=>n.some(h=>R.isParent(v.path,h,!L.isLinux))?!1:(n.push(v.path),!0)).concat(S)}}}),define(Z[149],ee([0,1,75,2,17,95,98,8,7]),function(H,e,y,R,L,A,O,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class S extends R.Disposable{constructor(v,h,C,f){super();this.path=v,this.onDidFilesChange=h,this.onLogMessage=C,this.verboseLogging=f,this.fileChangesDelayer=this._register(new P.ThrottledDelayer(O.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(v){this.verboseLogging=v}async startWatching(){try{const{stat:v,symbolicLink:h}=await L.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let C=this.path;if(h)try{C=await A.realpath(C)}catch(f){if(this.onError(f),h.dangling)return}v.isDirectory()?this._register(O.watchFolder(C,(f,I)=>{this.onFileChange({type:f==="changed"?0:f==="added"?1:2,path:p.join(this.path,p.basename(I))})},f=>this.onError(f))):this._register(O.watchFile(C,f=>{this.onFileChange({type:f==="changed"?0:2,path:this.path})},f=>this.onError(f)))}catch(v){v.code!=="ENOENT"&&this.onError(v)}}onFileChange(v){this.fileChangesBuffer.push(v),this.verboseLogging&&this.onVerbose(`${v.type===1?"[ADDED]":v.type===2?"[DELETED]":"[CHANGED]"} ${v.path}`),this.fileChangesDelayer.trigger(async()=>{const h=this.fileChangesBuffer;this.fileChangesBuffer=[];const C=y.normalizeFileChanges(h);this.verboseLogging&&C.forEach(f=>{this.onVerbose(`>> normalized ${f.type===1?"[ADDED]":f.type===2?"[DELETED]":"[CHANGED]"} ${f.path}`)}),C.length>0&&this.onDidFilesChange(C)})}onError(v){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${v}`})}onVerbose(v){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${v}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=S}),define(Z[76],ee([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class y{constructor(...L){this._entries=new Map;for(let[A,O]of L)this.set(A,O)}set(L,A){const O=this._entries.get(L);return this._entries.set(L,A),O}has(L){return this._entries.has(L)}get(L){return this._entries.get(L)}}e.ServiceCollection=y}),define(Z[150],ee([0,1,11,140,50,4,76,8]),function(H,e,y,R,L,A,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const p=!1;class S extends Error{constructor(f){var I;super("cyclic dependency between services");this.message=(I=f.findCycleSlow())!==null&&I!==void 0?I:`UNABLE to detect cycle, dumping graph: 
${f.toString()}`}}class n{constructor(f=new O.ServiceCollection,I=!1,D){this._activeInstantiations=new Set,this._services=f,this._strict=I,this._parent=D,this._services.set(A.IInstantiationService,this)}createChild(f){return new n(f,this._strict,this)}invokeFunction(f,...I){let D=h.traceInvocation(f),E=!1;try{return f({get:(g,o)=>{if(E)throw y.illegalState("service accessor is only valid during the invocation of its target method");const s=this._getOrCreateServiceInstance(g,D);if(!s&&o!==A.optional)throw new Error(`[invokeFunction] unknown service '${g}'`);return s}},...I)}finally{E=!0,D.stop()}}createInstance(f,...I){let D,E;return f instanceof L.SyncDescriptor?(D=h.traceCreation(f.ctor),E=this._createInstance(f.ctor,f.staticArguments.concat(I),D)):(D=h.traceCreation(f),E=this._createInstance(f,I,D)),D.stop(),E}_createInstance(f,I=[],D){let E=A._util.getServiceDependencies(f).sort((o,s)=>o.index-s.index),b=[];for(const o of E){let s=this._getOrCreateServiceInstance(o.id,D);if(!s&&this._strict&&!o.optional)throw new Error(`[createInstance] ${f.name} depends on UNKNOWN service ${o.id}.`);b.push(s)}let g=E.length>0?E[0].index:I.length;if(I.length!==g){console.warn(`[createInstance] First service dependency of ${f.name} at position ${g+1} conflicts with ${I.length} static arguments`);let o=g-I.length;o>0?I=I.concat(new Array(o)):I=I.slice(0,g)}return new f(...[...I,...b])}_setServiceInstance(f,I){if(this._services.get(f)instanceof L.SyncDescriptor)this._services.set(f,I);else if(this._parent)this._parent._setServiceInstance(f,I);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(f){let I=this._services.get(f);return!I&&this._parent?this._parent._getServiceInstanceOrDescriptor(f):I}_getOrCreateServiceInstance(f,I){let D=this._getServiceInstanceOrDescriptor(f);return D instanceof L.SyncDescriptor?this._safeCreateAndCacheServiceInstance(f,D,I.branch(f,!0)):(I.branch(f,!1),D)}_safeCreateAndCacheServiceInstance(f,I,D){if(this._activeInstantiations.has(f))throw new Error(`illegal state - RECURSIVELY instantiating service '${f}'`);this._activeInstantiations.add(f);try{return this._createAndCacheServiceInstance(f,I,D)}finally{this._activeInstantiations.delete(f)}}_createAndCacheServiceInstance(f,I,D){const E=new R.Graph(o=>o.id.toString());let b=0;const g=[{id:f,desc:I,_trace:D}];for(;g.length;){const o=g.pop();if(E.lookupOrInsertNode(o),b++>1e3)throw new S(E);for(let s of A._util.getServiceDependencies(o.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(s.id);if(!t&&!s.optional&&console.warn(`[createInstance] ${f} depends on ${s.id} which is NOT registered.`),t instanceof L.SyncDescriptor){const r={id:s.id,desc:t,_trace:o._trace.branch(s.id,!0)};E.insertEdge(o,r),g.push(r)}}}for(;;){const o=E.roots();if(o.length===0){if(!E.isEmpty())throw new S(E);break}for(const{data:s}of o){if(this._getServiceInstanceOrDescriptor(s.id)instanceof L.SyncDescriptor){const r=this._createServiceInstanceWithOwner(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this._setServiceInstance(s.id,r)}E.removeNode(s)}}return this._getServiceInstanceOrDescriptor(f)}_createServiceInstanceWithOwner(f,I,D=[],E,b){if(this._services.get(f)instanceof L.SyncDescriptor)return this._createServiceInstance(I,D,E,b);if(this._parent)return this._parent._createServiceInstanceWithOwner(f,I,D,E,b);throw new Error(`illegalState - creating UNKNOWN service instance ${I.name}`)}_createServiceInstance(f,I=[],D,E){if(D){const b=new P.IdleValue(()=>this._createInstance(f,I,E));return new Proxy(Object.create(null),{get(g,o){if(o in g)return g[o];let s=b.value,t=s[o];return typeof t!="function"||(t=t.bind(s),g[o]=t),t},set(g,o,s){return b.value[o]=s,!0}})}else return this._createInstance(f,I,E)}}e.InstantiationService=n;var v;(function(C){C[C.Creation=0]="Creation",C[C.Invocation=1]="Invocation",C[C.Branch=2]="Branch"})(v||(v={}));class h{constructor(f,I){this.type=f,this.name=I,this._start=Date.now(),this._dep=[]}static traceInvocation(f){return p?new h(1,f.name||f.toString().substring(0,42).replace(/\n/g,"")):h._None}static traceCreation(f){return p?new h(0,f.name):h._None}branch(f,I){let D=new h(2,f.toString());return this._dep.push([f,I,D]),D}stop(){let f=Date.now()-this._start;h._totals+=f;let I=!1;function D(b,g){let o=[],s=new Array(b+1).join("	");for(const[t,r,i]of g._dep)if(r&&i){I=!0,o.push(`${s}CREATES -> ${t}`);let a=D(b+1,i);a&&o.push(a)}else o.push(`${s}uses -> ${t}`);return o.join(`
`)}let E=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${D(1,this)}`,`DONE, took ${f.toFixed(2)}ms (grand total ${h._totals.toFixed(2)}ms)`];(f>2||I)&&console.log(E.join(`
`))}}h._None=new class extends h{constructor(){super(-1,null)}stop(){}branch(){return this}},h._totals=0}),define(Z[151],ee([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class y{constructor(L,A){this.server=L,this.router=A}getChannel(L){return this.server.getChannel(L,this.router)}registerChannel(L,A){this.server.registerChannel(L,A)}}e.MessagePortMainProcessService=y}),define(Z[152],ee([0,1,36,50,139,4]),function(H,e,y,R,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class O{constructor(C,f,I){const D=I.getChannel(C);return P(f)?new f.channelClientCtor(D):y.ProxyChannel.toService(D,f==null?void 0:f.proxyOptions)}}function P(h){const C=h;return!!(C==null?void 0:C.channelClientCtor)}e.IMainProcessService=A.createDecorator("mainProcessService");let p=class extends O{constructor(C,f,I){super(C,f,I)}};p=de([Y(2,e.IMainProcessService)],p);function S(h,C,f){L.registerSingleton(h,new R.SyncDescriptor(p,[C,f],f==null?void 0:f.supportsDelayedInstantiation))}e.registerMainProcessRemoteService=S,e.ISharedProcessService=A.createDecorator("sharedProcessService");let n=class extends O{constructor(C,f,I){super(C,f,I)}};n=de([Y(2,e.ISharedProcessService)],n);function v(h,C,f){L.registerSingleton(h,new R.SyncDescriptor(n,[C,f],f==null?void 0:f.supportsDelayedInstantiation))}e.registerSharedProcessRemoteService=v}),define(Z[56],ee([0,1,4]),function(H,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidLocalization=e.ILocalizationsService=void 0,e.ILocalizationsService=y.createDecorator("localizationsService");function R(L){if(typeof L.languageId!="string"||!Array.isArray(L.translations)||L.translations.length===0)return!1;for(const A of L.translations)if(typeof A.id!="string"||typeof A.path!="string")return!1;return!(L.languageName&&typeof L.languageName!="string"||L.localizedLanguageName&&typeof L.localizedLanguageName!="string")}e.isValidLocalization=R}),define(Z[153],ee([0,1,2,56]),function(H,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let L=class extends y.Disposable{constructor(O){super();this.localizationsService=O,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};L=de([Y(0,R.ILocalizationsService)],L),e.LocalizationsUpdater=L}),define(Z[18],ee([0,1,4,2,6,3,44]),function(H,e,y,R,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=y.createDecorator("logService"),e.ILoggerService=y.createDecorator("loggerService");function P(){return new Date().toISOString()}var p;(function(s){s[s.Trace=0]="Trace",s[s.Debug=1]="Debug",s[s.Info=2]="Info",s[s.Warning=3]="Warning",s[s.Error=4]="Error",s[s.Critical=5]="Critical",s[s.Off=6]="Off"})(p=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=p.Info;class S extends R.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new A.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=S;class n extends S{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...r){this.checkLogLevel(p.Trace)&&this.log(p.Trace,this.format([t,...r]))}debug(t,...r){this.checkLogLevel(p.Debug)&&this.log(p.Debug,this.format([t,...r]))}info(t,...r){this.checkLogLevel(p.Info)&&this.log(p.Info,this.format([t,...r]))}warn(t,...r){this.checkLogLevel(p.Warning)&&this.log(p.Warning,this.format([t,...r]))}error(t,...r){if(this.checkLogLevel(p.Error))if(t instanceof Error){const i=Array.prototype.slice.call(arguments);i[0]=t.stack,this.log(p.Error,this.format(i))}else this.log(p.Error,this.format([t,...r]))}critical(t,...r){this.checkLogLevel(p.Critical)&&this.log(p.Critical,this.format([t,...r]))}flush(){}format(t){let r="";for(let i=0;i<t.length;i++){let a=t[i];if(typeof a=="object")try{a=JSON.stringify(a)}catch(c){}r+=(i>0?" ":"")+a}return r}}e.AbstractMessageLogger=n;class v extends S{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!L.isWindows}trace(t,...r){this.getLevel()<=p.Trace&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...r):console.log(`[main ${P()}]`,t,...r))}debug(t,...r){this.getLevel()<=p.Debug&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...r):console.log(`[main ${P()}]`,t,...r))}info(t,...r){this.getLevel()<=p.Info&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...r):console.log(`[main ${P()}]`,t,...r))}warn(t,...r){this.getLevel()<=p.Warning&&(this.useColors?console.warn(`[93m[main ${P()}][0m`,t,...r):console.warn(`[main ${P()}]`,t,...r))}error(t,...r){this.getLevel()<=p.Error&&(this.useColors?console.error(`[91m[main ${P()}][0m`,t,...r):console.error(`[main ${P()}]`,t,...r))}critical(t,...r){this.getLevel()<=p.Critical&&(this.useColors?console.error(`[90m[main ${P()}][0m`,t,...r):console.error(`[main ${P()}]`,t,...r))}dispose(){}flush(){}}e.ConsoleMainLogger=v;class h extends S{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...r){this.getLevel()<=p.Trace&&console.log("%cTRACE","color: #888",t,...r)}debug(t,...r){this.getLevel()<=p.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...r)}info(t,...r){this.getLevel()<=p.Info&&console.log("%c INFO","color: #33f",t,...r)}warn(t,...r){this.getLevel()<=p.Warning&&console.log("%c WARN","color: #993",t,...r)}error(t,...r){this.getLevel()<=p.Error&&console.log("%c  ERR","color: #f33",t,...r)}critical(t,...r){this.getLevel()<=p.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...r)}dispose(){}flush(){}}e.ConsoleLogger=h;class C extends S{constructor(t,r=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(r)}trace(t,...r){this.getLevel()<=p.Trace&&this.adapter.log(p.Trace,[this.extractMessage(t),...r])}debug(t,...r){this.getLevel()<=p.Debug&&this.adapter.log(p.Debug,[this.extractMessage(t),...r])}info(t,...r){this.getLevel()<=p.Info&&this.adapter.log(p.Info,[this.extractMessage(t),...r])}warn(t,...r){this.getLevel()<=p.Warning&&this.adapter.log(p.Warning,[this.extractMessage(t),...r])}error(t,...r){this.getLevel()<=p.Error&&this.adapter.log(p.Error,[this.extractMessage(t),...r])}critical(t,...r){this.getLevel()<=p.Critical&&this.adapter.log(p.Critical,[this.extractMessage(t),...r])}extractMessage(t){return typeof t=="string"?t:O.toErrorMessage(t,this.getLevel()<=p.Trace)}dispose(){}flush(){}}e.AdapterLogger=C;class f extends S{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const r of this.logServices)r.setLevel(t);super.setLevel(t)}trace(t,...r){for(const i of this.logServices)i.trace(t,...r)}debug(t,...r){for(const i of this.logServices)i.debug(t,...r)}info(t,...r){for(const i of this.logServices)i.info(t,...r)}warn(t,...r){for(const i of this.logServices)i.warn(t,...r)}error(t,...r){for(const i of this.logServices)i.error(t,...r)}critical(t,...r){for(const i of this.logServices)i.critical(t,...r)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=f;class I extends R.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...r){this.logger.trace(t,...r)}debug(t,...r){this.logger.debug(t,...r)}info(t,...r){this.logger.info(t,...r)}warn(t,...r){this.logger.warn(t,...r)}error(t,...r){this.logger.error(t,...r)}critical(t,...r){this.logger.critical(t,...r)}flush(){this.logger.flush()}}e.LogService=I;class D extends R.Disposable{constructor(t,r){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(r(i=>{this.logLevel=i,this.logLevelChangeableLoggers.forEach(a=>a.setLevel(i))}))}createLogger(t,r){let i=this.loggers.get(t.toString());return i||(i=this.doCreateLogger(t,(r==null?void 0:r.always)?p.Trace:this.logLevel,r),this.loggers.set(t.toString(),i),(r==null?void 0:r.always)||this.logLevelChangeableLoggers.push(i)),i}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=D;class E{constructor(){this.onDidChangeLogLevel=new A.Emitter().event}setLevel(t){}getLevel(){return p.Info}trace(t,...r){}debug(t,...r){}info(t,...r){}warn(t,...r){}error(t,...r){}critical(t,...r){}dispose(){}flush(){}}e.NullLogService=E;function b(s){if(s.verbose)return p.Trace;if(typeof s.logLevel=="string"){const t=g(s.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=b;function g(s){switch(s){case"trace":return p.Trace;case"debug":return p.Debug;case"info":return p.Info;case"warn":return p.Warning;case"error":return p.Error;case"critical":return p.Critical;case"off":return p.Off}}e.parseLogLevel=g;function o(s){switch(s){case p.Trace:return"trace";case p.Debug:return"debug";case p.Info:return"info";case p.Warning:return"warn";case p.Error:return"error";case p.Critical:return"critical";case p.Off:return"off"}}e.LogLevelToString=o}),define(Z[154],ee([0,1,17,2,10,28,9,5,14,33,18,30,57,6,8,11]),function(H,e,y,R,L,A,O,P,p,S,n,v,h,C,f,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;const D=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let E=class extends R.Disposable{constructor(g,o,s,t){super();this.fileService=o,this.extensionGalleryService=s,this.logService=t,this.extensionsDownloadDir=P.URI.file(g.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(g,o){await this.cleanUpPromise;const s=this.getName(g),t=p.joinPath(this.extensionsDownloadDir,s);if(!await this.fileService.exists(t)){const r=p.joinPath(this.extensionsDownloadDir,`.${v.generateUuid()}`);await this.fileService.exists(r)||await this.extensionGalleryService.download(g,r,o);try{await this.rename(r,t,Date.now()+2*60*1e3)}catch(i){try{await this.fileService.del(r)}catch(a){}if(i.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",g.identifier.id);else throw this.logService.info(`Rename failed because of ${I.getErrorMessage(i)}. Deleted the vsix from downloaded location`,r.path),i}}return t}async delete(g){}async rename(g,o,s){try{await y.Promises.rename(g.fsPath,o.fsPath)}catch(t){if(C.isWindows&&t&&t.code==="EPERM"&&Date.now()<s)return this.logService.info(`Failed renaming ${g} to ${o} with 'EPERM' error. Trying again...`),this.rename(g,o,s);throw t}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const g=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(g.children){const o=[],s=[];for(const i of g.children){const a=this.parse(i.name);a&&s.push([a,i])}const t=S.groupByExtension(s,([i])=>i),r=[];for(const i of t)i.sort((a,c)=>h.rcompare(a[0].version,c[0].version)),o.push(...i.slice(1).map(a=>a[1].resource)),r.push(i[0][1]);r.sort((i,a)=>i.mtime-a.mtime),o.push(...r.slice(0,Math.max(0,r.length-this.cache)).map(i=>i.resource)),await f.Promises.settled(o.map(i=>(this.logService.trace("Deleting vsix from cache",i.path),this.fileService.del(i))))}}catch(g){this.logService.error(g)}}getName(g){return this.cache?new S.ExtensionIdentifierWithVersion(g.identifier,g.version).key().toLowerCase():v.generateUuid()}parse(g){const o=D.exec(g);return o&&o[1]&&o[2]?new S.ExtensionIdentifierWithVersion({id:o[1]},o[2]):null}};E=de([Y(0,O.INativeEnvironmentService),Y(1,L.IFileService),Y(2,A.IExtensionGalleryService),Y(3,n.ILogService)],E),e.ExtensionsDownloader=E}),define(Z[155],ee([0,1,2,18,43,44,7,8,3,16,17,9]),function(H,e,y,R,L,A,O,P,p,S,n,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let h=class extends y.Disposable{constructor(f,I){super();this.environmentService=f,this.logService=I,this.processesLimiter=new P.Limiter(5)}async postUninstall(f){const I=this.parseScript(f,"uninstall");return I&&(this.logService.info(f.identifier.id,f.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(I.script,"uninstall",I.args,!0,f).then(()=>this.logService.info(f.identifier.id,f.manifest.version,"Finished running post uninstall script"),D=>this.logService.error(f.identifier.id,f.manifest.version,`Failed to run post uninstall script: ${D}`)))),n.rimraf(this.getExtensionStoragePath(f)).then(void 0,D=>this.logService.error("Error while removing extension storage path",D))}parseScript(f,I){const D=`vscode:${I}`;if(f.location.scheme===S.Schemas.file&&f.manifest&&f.manifest.scripts&&typeof f.manifest.scripts[D]=="string"){const E=f.manifest.scripts[D].split(" ");return E.length<2||E[0]!=="node"||!E[1]?(this.logService.warn(f.identifier.id,f.manifest.version,`${D} should be a node script`),null):{script:O.join(f.location.fsPath,E[1]),args:E.slice(2)||[]}}return null}runLifecycleHook(f,I,D,E,b){return new Promise((g,o)=>{const s=this.start(f,I,D,b);let t;const r=i=>{t&&(clearTimeout(t),t=null),i?o(i):g(void 0)};s.on("error",i=>{r(A.toErrorMessage(i)||"Unknown")}),s.on("exit",(i,a)=>{r(i?`post-${I} process exited with code ${i}`:void 0)}),E&&(t=setTimeout(()=>{t=null,s.kill(),o("timed out")},5e3))})}start(f,I,D,E){const b={silent:!0,execArgv:void 0},g=L.fork(f,[`--type=extension-post-${I}`,...D],b);g.stdout.setEncoding("utf8"),g.stderr.setEncoding("utf8");const o=p.Event.fromNodeEventEmitter(g.stdout,"data"),s=p.Event.fromNodeEventEmitter(g.stderr,"data");o(i=>this.logService.info(E.identifier.id,E.manifest.version,`post-${I}`,i)),s(i=>this.logService.error(E.identifier.id,E.manifest.version,`post-${I}`,i));const t=p.Event.any(p.Event.map(o,i=>({data:`%c${i}`,format:[""]})),p.Event.map(s,i=>({data:`%c${i}`,format:["color: red"]})));return p.Event.debounce(t,(i,a)=>i?{data:i.data+a.data,format:[...i.format,...a.format]}:{data:a.data,format:a.format},100)(i=>{console.group(E.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),g}getExtensionStoragePath(f){return O.join(this.environmentService.globalStorageHome.fsPath,f.identifier.id.toLowerCase())}};h=de([Y(0,v.IEnvironmentService),Y(1,R.ILogService)],h),e.ExtensionsLifecycle=h}),define(Z[156],ee([0,1,2,9,3,10,5,33,14,18]),function(H,e,y,R,L,A,O,P,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let n=class extends y.Disposable{constructor(h,C,f,I){super();this.extensionsManagementService=h,this.logService=I,this._onDidChangeExtensionsByAnotherSource=this._register(new L.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(b=>{this.installedExtensions=b.map(g=>g.identifier),this.startTimestamp=Date.now()}),this._register(h.onInstallExtension(b=>this.onInstallExtension(b))),this._register(h.onDidInstallExtension(b=>this.onDidInstallExtension(b))),this._register(h.onDidUninstallExtension(b=>this.onDidUninstallExtension(b)));const D=O.URI.file(f.extensionsPath),E=new p.ExtUri(b=>!C.hasCapability(b,1024));this._register(C.watch(D)),this._register(L.Event.filter(C.onDidFilesChange,b=>b.changes.some(g=>this.doesChangeAffects(g,D,E)))(()=>this.onDidChange()))}doesChangeAffects(h,C,f){return f.isEqual(f.dirname(h.resource),C)?f.isEqual(h.resource,f.joinPath(C,".obsolete"))?!0:!(h.type!==1&&h.type!==2||f.basename(h.resource).startsWith(".")):!1}onInstallExtension(h){this.addInstallingExtension(h.identifier)}onDidInstallExtension(h){this.removeInstallingExtension(h.identifier),h.error||this.addInstalledExtension(h.identifier)}onDidUninstallExtension(h){h.error||this.removeInstalledExtension(h.identifier)}addInstallingExtension(h){this.removeInstallingExtension(h),this.installingExtensions.push(h)}removeInstallingExtension(h){this.installingExtensions=this.installingExtensions.filter(C=>!P.areSameExtensions(C,h))}addInstalledExtension(h){this.installedExtensions&&(this.removeInstalledExtension(h),this.installedExtensions.push(h))}removeInstalledExtension(h){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(C=>!P.areSameExtensions(C,h)))}async onDidChange(){if(this.installedExtensions){const h=await this.extensionsManagementService.getInstalled(1),C=h.filter(I=>[...this.installingExtensions,...this.installedExtensions].some(D=>P.areSameExtensions(D,I.identifier))?!1:I.installedTimestamp&&I.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",I.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",I.identifier.id),!1)),f=this.installedExtensions.filter(I=>this.installingExtensions.some(D=>P.areSameExtensions(D,I))?!1:h.every(D=>!P.areSameExtensions(D.identifier,I))?(this.logService.info("Detected extension removed from another source",I.id),!0):!1);this.installedExtensions=h.map(I=>I.identifier),(C.length||f.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:C,removed:f})}}};n=de([Y(1,A.IFileService),Y(2,R.INativeEnvironmentService),Y(3,S.ILogService)],n),e.ExtensionsWatcher=n}),define(Z[157],ee([0,1,17,148,28,2,9,8,33,18,56,19,3,16,7]),function(H,e,y,R,L,A,O,P,p,S,n,v,h,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsService=void 0;let I=class extends A.Disposable{constructor(b,g,o){super();this.extensionManagementService=b,this.logService=o,this._onDidLanguagesChange=this._register(new h.Emitter),this.onDidLanguagesChange=this._onDidLanguagesChange.event,this.cache=this._register(new D(g,o)),this._register(b.onDidInstallExtension(({local:s})=>this.onDidInstallExtension(s))),this._register(b.onDidUninstallExtension(({identifier:s})=>this.onDidUninstallExtension(s)))}getLanguageIds(){return this.cache.getLanguagePacks().then(b=>{const g=["en",...Object.keys(b)];return v.distinct(g)})}onDidInstallExtension(b){b&&b.manifest&&b.manifest.contributes&&b.manifest.contributes.localizations&&b.manifest.contributes.localizations.length&&(this.logService.debug("Adding language packs from the extension",b.identifier.id),this.update().then(g=>{g&&this._onDidLanguagesChange.fire()}))}onDidUninstallExtension(b){this.cache.getLanguagePacks().then(g=>{Object.keys(g).some(o=>g[o]&&g[o].extensions.some(s=>p.areSameExtensions(s.extensionIdentifier,b)))&&(this.logService.debug("Removing language packs from the extension",b.id),this.update().then(o=>{o&&this._onDidLanguagesChange.fire()}))})}async update(){const[b,g]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),o=await this.cache.update(g);return!v.equals(Object.keys(b),Object.keys(o))}};I=de([Y(0,L.IExtensionManagementService),Y(1,O.INativeEnvironmentService),Y(2,S.ILogService)],I),e.LocalizationsService=I;let D=class extends A.Disposable{constructor(b,g){super();this.logService=g,this.languagePacks={},this.languagePacksFilePath=f.join(b.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new P.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(b){return this.withLanguagePacks(g=>{Object.keys(g).forEach(o=>delete g[o]),this.createLanguagePacksFromExtensions(g,...b)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(b,...g){for(const o of g)o&&o.manifest&&o.manifest.contributes&&o.manifest.contributes.localizations&&o.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(b,o);Object.keys(b).forEach(o=>this.updateHash(b[o]))}createLanguagePacksFromExtension(b,g){const o=g.identifier,s=g.manifest.contributes&&g.manifest.contributes.localizations?g.manifest.contributes.localizations:[];for(const t of s)if(g.location.scheme===C.Schemas.file&&n.isValidLocalization(t)){let r=b[t.languageId];r||(r={hash:"",extensions:[],translations:{}},b[t.languageId]=r);let i=r.extensions.filter(a=>p.areSameExtensions(a.extensionIdentifier,o))[0];i?i.version=g.manifest.version:r.extensions.push({extensionIdentifier:o,version:g.manifest.version});for(const a of t.translations)r.translations[a.id]=f.join(g.location.fsPath,a.path)}}updateHash(b){if(b){const g=R.createHash("md5");for(const o of b.extensions)g.update(o.extensionIdentifier.uuid||o.extensionIdentifier.id).update(o.version);b.hash=g.digest("hex")}}withLanguagePacks(b=()=>null){return this.languagePacksFileLimiter.queue(()=>{let g=null;return y.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,o=>o.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(o)).then(o=>{try{return JSON.parse(o)}catch(s){return{}}}).then(o=>(g=b(o),o)).then(o=>{for(const t of Object.keys(o))o[t]||delete o[t];this.languagePacks=o,this.initializedCache=!0;const s=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",s),y.writeFile(this.languagePacksFilePath,s)}).then(()=>g,o=>this.logService.error(o))})}};D=de([Y(0,O.INativeEnvironmentService),Y(1,S.ILogService)],D)}),define(Z[77],ee([0,1,18,3,5]),function(H,e,y,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class A{constructor(h){this.service=h,this.onDidChangeLogLevel=R.Event.buffer(h.onDidChangeLogLevel,!0)}listen(h,C){switch(C){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${C}`)}async call(h,C,f){switch(C){case"setLevel":return this.service.setLevel(f)}throw new Error(`Call not found: ${C}`)}}e.LogLevelChannel=A;class O{constructor(h){this.channel=h}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(h){O.setLevel(this.channel,h)}static setLevel(h,C){return h.call("setLevel",C)}}e.LogLevelChannelClient=O;class P{constructor(h){this.loggerService=h,this.loggers=new Map}listen(h,C){throw new Error(`Event not found: ${C}`)}async call(h,C,f){switch(C){case"createLogger":this.createLogger(L.URI.revive(f[0]),f[1]);return;case"log":return this.log(L.URI.revive(f[0]),f[1]);case"consoleLog":return this.consoleLog(f[0],f[1])}throw new Error(`Call not found: ${C}`)}createLogger(h,C){this.loggers.set(h.toString(),this.loggerService.createLogger(h,C))}consoleLog(h,C){let f=console.log;switch(h){case y.LogLevel.Error:f=console.error;break;case y.LogLevel.Warning:f=console.warn;break;case y.LogLevel.Info:f=console.info;break}f.call(console,...C)}log(h,C){const f=this.loggers.get(h.toString());if(!f)throw new Error("Create the logger before logging");for(const[I,D]of C)switch(I){case y.LogLevel.Trace:f.trace(D);break;case y.LogLevel.Debug:f.debug(D);break;case y.LogLevel.Info:f.info(D);break;case y.LogLevel.Warning:f.warn(D);break;case y.LogLevel.Error:f.error(D);break;case y.LogLevel.Critical:f.critical(D);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=P;class p extends y.AbstractLoggerService{constructor(h,C,f){super(h,C);this.channel=f}createConsoleMainLogger(){return new y.AdapterLogger({log:(h,C)=>{this.channel.call("consoleLog",[h,C])}})}doCreateLogger(h,C,f){return new S(this.channel,h,C,f)}}e.LoggerChannelClient=p;class S extends y.AbstractMessageLogger{constructor(h,C,f,I){super(I==null?void 0:I.always);this.channel=h,this.file=C,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(f),this.channel.call("createLogger",[C,I]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(h,C){const f=[[h,C]];this.isLoggerCreated?this.doLog(f):this.buffer.push(...f)}doLog(h){this.channel.call("log",[this.file,h])}}class n extends y.LogService{constructor(h,C){super(C);this.parent=h,this._register(h.onDidChangeLogLevel(f=>C.setLevel(f)))}setLevel(h){super.setLevel(h),this.parent.setLevel(h)}}e.FollowerLogService=n}),define(Z[58],ee([0,1,4]),function(H,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=y.createDecorator("nativeHostService")}),define(Z[51],ee([0,1,16,6,34,14]),function(H,e,y,R,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let O;if(typeof R.globals.vscode!="undefined"&&typeof R.globals.vscode.context!="undefined"){const P=R.globals.vscode.context.configuration();if(P)O=P.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof(H==null?void 0:H.__$__nodeRequire)=="function"){const P=A.dirname(y.FileAccess.asFileUri("",H));O=H.__$__nodeRequire(A.joinPath(P,"product.json").fsPath);const p=H.__$__nodeRequire(A.joinPath(P,"package.json").fsPath);L.env.VSCODE_DEV&&Object.assign(O,{nameShort:`${O.nameShort} Dev`,nameLong:`${O.nameLong} Dev`,dataFolderName:`${O.dataFolderName}-dev`}),Object.assign(O,{version:p.version})}else O={},Object.keys(O).length===0&&Object.assign(O,{version:"1.57.0-dev",nameShort:R.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:R.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=O}),define(Z[78],ee([0,1,117,25,10,11,51]),function(H,e,y,R,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function P(v,h,C,f,I,D){let E;try{await p(v,h,C,f,I,D)}catch(b){E=b}finally{E&&I.errorTransformer&&(E=I.errorTransformer(E)),typeof E!="undefined"&&C.error(E),C.end()}}e.readFileIntoStream=P;async function p(v,h,C,f,I,D){S(D);const E=await v.open(h,{create:!1});try{S(D);let b=0,g=0,o=I&&typeof I.length=="number"?I.length:void 0,s=R.VSBuffer.alloc(Math.min(I.bufferSize,typeof o=="number"?o:I.bufferSize)),t=I&&typeof I.position=="number"?I.position:0,r=0;do g=await v.read(E,t,s.buffer,r,s.byteLength-r),t+=g,r+=g,b+=g,typeof o=="number"&&(o-=g),r===s.byteLength&&(await C.write(f(s)),s=R.VSBuffer.alloc(Math.min(I.bufferSize,typeof o=="number"?o:I.bufferSize)),r=0);while(g>0&&(typeof o!="number"||o>0)&&S(D)&&n(b,I));if(r>0){let i=r;typeof o=="number"&&(i=Math.min(r,o)),C.write(f(s.slice(0,i)))}}catch(b){throw L.ensureFileSystemProviderError(b)}finally{await v.close(E)}}function S(v){if(v.isCancellationRequested)throw A.canceled();return!0}function n(v,h){if(h==null?void 0:h.limits){if(typeof h.limits.memory=="number"&&v>h.limits.memory)throw L.createFileSystemProviderError(y.localize(0,null,O.default.nameShort),L.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof h.limits.size=="number"&&v>h.limits.size)throw L.createFileSystemProviderError(y.localize(1,null),L.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Z[158],ee([0,1,115,159,2,10,3,14,38,19,18,25,48,8,29,16,78,53]),function(H,e,y,R,L,A,O,P,p,S,n,v,h,C,f,I,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let b=class extends L.Disposable{constructor(o){super();this.logService=o,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new O.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new O.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new O.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new O.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new O.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new O.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this.activeWatchers=new Map,this.writeQueue=this._register(new C.ResourceQueue)}registerProvider(o,s){if(this.provider.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);R.mark(`code/registerFilesystem/${o}`),this.provider.set(o,s),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:o,provider:s});const t=new L.DisposableStore;return t.add(s.onDidChangeFile(r=>this._onDidFilesChange.fire(new A.FileChangesEvent(r,!this.isPathCaseSensitive(s))))),t.add(s.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:s,scheme:o}))),typeof s.onDidErrorOccur=="function"&&t.add(s.onDidErrorOccur(r=>this._onError.fire(new Error(r)))),L.toDisposable(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:o,provider:s}),this.provider.delete(o),L.dispose(t)})}getProvider(o){return this.provider.get(o)}async activateProvider(o){const s=[];this._onWillActivateFileSystemProvider.fire({scheme:o,join(t){s.push(t)}}),!this.provider.has(o)&&await C.Promises.settled(s)}canHandleResource(o){return this.provider.has(o.scheme)}hasCapability(o,s){const t=this.provider.get(o.scheme);return!!(t&&t.capabilities&s)}listCapabilities(){return E.Iterable.map(this.provider,([o,s])=>({scheme:o,capabilities:s.capabilities}))}async withProvider(o){if(!P.isAbsolutePath(o))throw new A.FileOperationError(y.localize(0,null,this.resourceForError(o)),8);await this.activateProvider(o.scheme);const s=this.provider.get(o.scheme);if(!s){const t=new Error;throw t.name="ENOPRO",t.message=y.localize(1,null,o.toString()),t}return s}async withReadProvider(o){const s=await this.withProvider(o);if(A.hasOpenReadWriteCloseCapability(s)||A.hasReadWriteCapability(s)||A.hasFileReadStreamCapability(s))return s;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(o){const s=await this.withProvider(o);if(A.hasOpenReadWriteCloseCapability(s)||A.hasReadWriteCapability(s))return s;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,s){try{return await this.doResolveFile(o,s)}catch(t){throw A.toFileSystemProviderErrorCode(t)===A.FileSystemProviderErrorCode.FileNotFound?new A.FileOperationError(y.localize(2,null,this.resourceForError(o)),1):A.ensureFileSystemProviderError(t)}}async doResolveFile(o,s){const t=await this.withProvider(o),r=this.isPathCaseSensitive(t),i=s==null?void 0:s.resolveTo,a=s==null?void 0:s.resolveSingleChildDescendants,c=s==null?void 0:s.resolveMetadata,u=await t.stat(o);let l;return this.toFileStat(t,o,u,void 0,!!c,(m,w)=>(l||(l=p.TernarySearchTree.forUris(()=>!r),l.set(o,!0),S.isNonEmptyArray(i)&&i.forEach(d=>l.set(d,!0))),Boolean(l.findSuperstr(m.resource)||l.get(m.resource))?!0:m.isDirectory&&a?w===1:!1))}async toFileStat(o,s,t,r,i,a){var c;const{providerExtUri:u}=this.getExtUri(o),l={resource:s,name:u.basename(s),isFile:(t.type&A.FileType.File)!=0,isDirectory:(t.type&A.FileType.Directory)!=0,isSymbolicLink:(t.type&A.FileType.SymbolicLink)!=0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:Boolean(((c=t.permissions)!==null&&c!==void 0?c:0)&A.FilePermission.Readonly)||Boolean(o.capabilities&2048),etag:A.etag({mtime:t.mtime,size:t.size})};if(l.isDirectory&&a(l,r)){try{const m=await o.readdir(s),w=await C.Promises.settled(m.map(async([d,T])=>{try{const _=u.joinPath(s,d),j=i?await o.stat(_):{type:T};return await this.toFileStat(o,_,j,m.length,i,a)}catch(_){return this.logService.trace(_),null}}));l.children=S.coalesce(w)}catch(m){this.logService.trace(m),l.children=[]}return l}return l}async resolveAll(o){return C.Promises.settled(o.map(async s=>{try{return{stat:await this.doResolveFile(s.resource,s.options),success:!0}}catch(t){return this.logService.trace(t),{stat:void 0,success:!1}}}))}async exists(o){const s=await this.withProvider(o);try{return!!await s.stat(o)}catch(t){return!1}}async canCreateFile(o,s){try{await this.doValidateCreateFile(o,s)}catch(t){return t}return!0}async doValidateCreateFile(o,s){if(!(s==null?void 0:s.overwrite)&&await this.exists(o))throw new A.FileOperationError(y.localize(3,null,this.resourceForError(o)),3,s)}async createFile(o,s=v.VSBuffer.fromString(""),t){await this.doValidateCreateFile(o,t);const r=await this.writeFile(o,s);return this._onDidRunOperation.fire(new A.FileOperationEvent(o,0,r)),r}async writeFile(o,s,t){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),{providerExtUri:i}=this.getExtUri(r);try{await this.validateWriteFile(r,o,t)||await this.mkdirp(r,i.dirname(o));let c;if(A.hasReadWriteCapability(r)&&!(s instanceof v.VSBuffer))if(h.isReadableStream(s)){const u=await h.peekStream(s,3);u.ended?c=v.VSBuffer.concat(u.buffer):c=u}else c=h.peekReadable(s,u=>v.VSBuffer.concat(u),3);else c=s;!A.hasOpenReadWriteCloseCapability(r)||A.hasReadWriteCapability(r)&&c instanceof v.VSBuffer?await this.doWriteUnbuffered(r,o,t,c):await this.doWriteBuffered(r,o,t,c instanceof v.VSBuffer?v.bufferToReadable(c):c)}catch(a){throw new A.FileOperationError(y.localize(4,null,this.resourceForError(o),A.ensureFileSystemProviderError(a).toString()),A.toFileOperationResult(a),t)}return this.resolve(o,{resolveMetadata:!0})}async validateWriteFile(o,s,t){if(!!(t==null?void 0:t.unlock)&&!(o.capabilities&8192))throw new Error(y.localize(5,null,this.resourceForError(s)));let i;try{i=await o.stat(s)}catch(a){return}if((i.type&A.FileType.Directory)!=0)throw new A.FileOperationError(y.localize(6,null,this.resourceForError(s)),0,t);if(this.throwIfFileIsReadonly(s,i),t&&typeof t.mtime=="number"&&typeof t.etag=="string"&&t.etag!==A.ETAG_DISABLED&&typeof i.mtime=="number"&&typeof i.size=="number"&&t.mtime<i.mtime&&t.etag!==A.etag({mtime:t.mtime,size:i.size}))throw new A.FileOperationError(y.localize(7,null),3,t);return i}async readFile(o,s){const t=await this.withReadProvider(o);return(s==null?void 0:s.atomic)?this.doReadFileAtomic(t,o,s):this.doReadFile(t,o,s)}async doReadFileAtomic(o,s,t){return new Promise((r,i)=>{this.writeQueue.queueFor(s,this.getExtUri(o).providerExtUri).queue(async()=>{try{const a=await this.doReadFile(o,s,t);r(a)}catch(a){i(a)}})})}async doReadFile(o,s,t){const r=await this.doReadFileStream(o,s,Object.assign(Object.assign({},t),{preferUnbuffered:!0}));return Object.assign(Object.assign({},r),{value:await v.streamToBuffer(r.value)})}async readFileStream(o,s){const t=await this.withReadProvider(o);return this.doReadFileStream(t,o,s)}async doReadFileStream(o,s,t){const r=new f.CancellationTokenSource,i=this.validateReadFile(s,t).then(c=>c,c=>{throw r.cancel(),c});let a;try{t&&typeof t.etag=="string"&&t.etag!==A.ETAG_DISABLED&&await i,!(A.hasOpenReadWriteCloseCapability(o)||A.hasFileReadStreamCapability(o))||A.hasReadWriteCapability(o)&&(t==null?void 0:t.preferUnbuffered)?a=this.readFileUnbuffered(o,s,t):A.hasFileReadStreamCapability(o)?a=this.readFileStreamed(o,s,r.token,t):a=this.readFileBuffered(o,s,r.token,t);const c=await i;return Object.assign(Object.assign({},c),{value:a})}catch(c){a&&await h.consumeStream(a);const u=y.localize(8,null,this.resourceForError(s),A.ensureFileSystemProviderError(c).toString());throw c instanceof A.NotModifiedSinceFileOperationError?new A.NotModifiedSinceFileOperationError(u,c.stat,t):new A.FileOperationError(u,A.toFileOperationResult(c),t)}}readFileStreamed(o,s,t,r=Object.create(null)){const i=o.readFileStream(s,r,t);return h.transform(i,{data:a=>a instanceof v.VSBuffer?a:v.VSBuffer.wrap(a),error:a=>new A.FileOperationError(y.localize(9,null,this.resourceForError(s),A.ensureFileSystemProviderError(a).toString()),A.toFileOperationResult(a),r)},a=>v.VSBuffer.concat(a))}readFileBuffered(o,s,t,r=Object.create(null)){const i=v.newWriteableBufferStream();return D.readFileIntoStream(o,s,i,a=>a,Object.assign(Object.assign({},r),{bufferSize:this.BUFFER_SIZE,errorTransformer:a=>new A.FileOperationError(y.localize(10,null,this.resourceForError(s),A.ensureFileSystemProviderError(a).toString()),A.toFileOperationResult(a),r)}),t),i}readFileUnbuffered(o,s,t){const r=h.newWriteableStream(i=>v.VSBuffer.concat(i));return(async()=>{try{let i=await o.readFile(s);t&&typeof t.position=="number"&&(i=i.slice(t.position)),t&&typeof t.length=="number"&&(i=i.slice(0,t.length)),this.validateReadFileLimits(s,i.byteLength,t),r.end(v.VSBuffer.wrap(i))}catch(i){r.error(i),r.end()}})(),r}async validateReadFile(o,s){const t=await this.resolve(o,{resolveMetadata:!0});if(t.isDirectory)throw new A.FileOperationError(y.localize(11,null,this.resourceForError(o)),0,s);if(s&&typeof s.etag=="string"&&s.etag!==A.ETAG_DISABLED&&s.etag===t.etag)throw new A.NotModifiedSinceFileOperationError(y.localize(12,null),t,s);return this.validateReadFileLimits(o,t.size,s),t}validateReadFileLimits(o,s,t){if(t==null?void 0:t.limits){let r;if(typeof t.limits.memory=="number"&&s>t.limits.memory&&(r=9),typeof t.limits.size=="number"&&s>t.limits.size&&(r=7),typeof r=="number")throw new A.FileOperationError(y.localize(13,null,this.resourceForError(o)),r)}}async canMove(o,s,t){return this.doCanMoveCopy(o,s,"move",t)}async canCopy(o,s,t){return this.doCanMoveCopy(o,s,"copy",t)}async doCanMoveCopy(o,s,t,r){if(o.toString()!==s.toString())try{const i=t==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o):await this.withReadProvider(o),a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s);await this.doValidateMoveCopy(i,o,a,s,t,r)}catch(i){return i}return!0}async move(o,s,t){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),a=await this.doMoveCopy(r,o,i,s,"move",!!t),c=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new A.FileOperationEvent(o,a==="move"?2:3,c)),c}async copy(o,s,t){const r=await this.withReadProvider(o),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),a=await this.doMoveCopy(r,o,i,s,"copy",!!t),c=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new A.FileOperationEvent(o,a==="copy"?3:2,c)),c}async doMoveCopy(o,s,t,r,i,a){if(s.toString()===r.toString())return i;const{exists:c,isSameResourceWithDifferentPathCase:u}=await this.doValidateMoveCopy(o,s,t,r,i,a);if(c&&!u&&a&&await this.del(r,{recursive:!0}),await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(r)),i==="copy"){if(o===t&&A.hasFileFolderCopyCapability(o))await o.copy(s,r,{overwrite:a});else{const l=await this.resolve(s);l.isDirectory?await this.doCopyFolder(o,l,t,r):await this.doCopyFile(o,s,t,r)}return i}else return o===t?(await o.rename(s,r,{overwrite:a}),i):(await this.doMoveCopy(o,s,t,r,"copy",a),await this.del(s,{recursive:!0}),"copy")}async doCopyFile(o,s,t,r){if(A.hasOpenReadWriteCloseCapability(o)&&A.hasOpenReadWriteCloseCapability(t))return this.doPipeBuffered(o,s,t,r);if(A.hasOpenReadWriteCloseCapability(o)&&A.hasReadWriteCapability(t))return this.doPipeBufferedToUnbuffered(o,s,t,r);if(A.hasReadWriteCapability(o)&&A.hasOpenReadWriteCloseCapability(t))return this.doPipeUnbufferedToBuffered(o,s,t,r);if(A.hasReadWriteCapability(o)&&A.hasReadWriteCapability(t))return this.doPipeUnbuffered(o,s,t,r)}async doCopyFolder(o,s,t,r){await t.mkdir(r),Array.isArray(s.children)&&await C.Promises.settled(s.children.map(async i=>{const a=this.getExtUri(t).providerExtUri.joinPath(r,i.name);return i.isDirectory?this.doCopyFolder(o,await this.resolve(i.resource),t,a):this.doCopyFile(o,i.resource,t,a)}))}async doValidateMoveCopy(o,s,t,r,i,a){let c=!1;if(o===t){const{providerExtUri:l,isPathCaseSensitive:m}=this.getExtUri(o);if(m||(c=l.isEqual(s,r)),c&&i==="copy")throw new Error(y.localize(14,null,this.resourceForError(s),this.resourceForError(r)));if(!c&&l.isEqualOrParent(r,s))throw new Error(y.localize(15,null,this.resourceForError(s),this.resourceForError(r)))}const u=await this.exists(r);if(u&&!c){if(!a)throw new A.FileOperationError(y.localize(16,null,this.resourceForError(s),this.resourceForError(r)),4);if(o===t){const{providerExtUri:l}=this.getExtUri(o);if(l.isEqualOrParent(s,r))throw new Error(y.localize(17,null,this.resourceForError(s),this.resourceForError(r)))}}return{exists:u,isSameResourceWithDifferentPathCase:c}}getExtUri(o){const s=this.isPathCaseSensitive(o);return{providerExtUri:s?P.extUri:P.extUriIgnorePathCase,isPathCaseSensitive:s}}isPathCaseSensitive(o){return!!(o.capabilities&1024)}async createFolder(o){const s=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);await this.mkdirp(s,o);const t=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new A.FileOperationEvent(o,0,t)),t}async mkdirp(o,s){const t=[],{providerExtUri:r}=this.getExtUri(o);for(;!r.isEqual(s,r.dirname(s));)try{if(((await o.stat(s)).type&A.FileType.Directory)==0)throw new Error(y.localize(18,null,this.resourceForError(s)));break}catch(i){if(A.toFileSystemProviderErrorCode(i)!==A.FileSystemProviderErrorCode.FileNotFound)throw i;t.push(r.basename(s)),s=r.dirname(s)}for(let i=t.length-1;i>=0;i--){s=r.joinPath(s,t[i]);try{await o.mkdir(s)}catch(a){if(A.toFileSystemProviderErrorCode(a)!==A.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(o,s){try{await this.doValidateDelete(o,s)}catch(t){return t}return!0}async doValidateDelete(o,s){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);if(!!(s==null?void 0:s.useTrash)&&!(t.capabilities&4096))throw new Error(y.localize(19,null,this.resourceForError(o)));let i;try{i=await t.stat(o)}catch(c){}if(i)this.throwIfFileIsReadonly(o,i);else throw new A.FileOperationError(y.localize(20,null,this.resourceForError(o)),1);if(!!!(s==null?void 0:s.recursive)){const c=await this.resolve(o);if(c.isDirectory&&Array.isArray(c.children)&&c.children.length>0)throw new Error(y.localize(21,null,this.resourceForError(o)))}return t}async del(o,s){const t=await this.doValidateDelete(o,s),r=!!(s==null?void 0:s.useTrash),i=!!(s==null?void 0:s.recursive);await t.delete(o,{recursive:i,useTrash:r}),this._onDidRunOperation.fire(new A.FileOperationEvent(o,1))}watch(o,s={recursive:!1,excludes:[]}){let t=!1,r=()=>{t=!0};return this.doWatch(o,s).then(i=>{t?L.dispose(i):r=()=>L.dispose(i)},i=>this.logService.error(i)),L.toDisposable(()=>r())}async doWatch(o,s){const t=await this.withProvider(o),r=this.toWatchKey(t,o,s),i=this.activeWatchers.get(r)||{count:0,disposable:t.watch(o,s)};return this.activeWatchers.has(r)||this.activeWatchers.set(r,i),i.count+=1,L.toDisposable(()=>{i.count--,i.count===0&&(L.dispose(i.disposable),this.activeWatchers.delete(r))})}toWatchKey(o,s,t){const{providerExtUri:r}=this.getExtUri(o);return[r.getComparisonKey(s),String(t.recursive),t.excludes.join()].join()}dispose(){super.dispose(),this.activeWatchers.forEach(o=>L.dispose(o.disposable)),this.activeWatchers.clear()}async doWriteBuffered(o,s,t,r){return this.writeQueue.queueFor(s,this.getExtUri(o).providerExtUri).queue(async()=>{var i;const a=await o.open(s,{create:!0,unlock:(i=t==null?void 0:t.unlock)!==null&&i!==void 0?i:!1});try{h.isReadableStream(r)||h.isReadableBufferedStream(r)?await this.doWriteStreamBufferedQueued(o,a,r):await this.doWriteReadableBufferedQueued(o,a,r)}catch(c){throw A.ensureFileSystemProviderError(c)}finally{await o.close(a)}})}async doWriteStreamBufferedQueued(o,s,t){let r=0,i;if(h.isReadableBufferedStream(t)){if(t.buffer.length>0){const a=v.VSBuffer.concat(t.buffer);await this.doWriteBuffer(o,s,a,a.byteLength,r,0),r+=a.byteLength}if(t.ended)return;i=t.stream}else i=t;return new Promise(async(a,c)=>{h.listenStream(i,{onData:async u=>{i.pause();try{await this.doWriteBuffer(o,s,u,u.byteLength,r,0)}catch(l){return c(l)}r+=u.byteLength,setTimeout(()=>i.resume())},onError:u=>c(u),onEnd:()=>a()})})}async doWriteReadableBufferedQueued(o,s,t){let r=0,i;for(;(i=t.read())!==null;)await this.doWriteBuffer(o,s,i,i.byteLength,r,0),r+=i.byteLength}async doWriteBuffer(o,s,t,r,i,a){let c=0;for(;c<r;)c+=await o.write(s,i+c,t.buffer,a+c,r-c)}async doWriteUnbuffered(o,s,t,r){return this.writeQueue.queueFor(s,this.getExtUri(o).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(o,s,t,r))}async doWriteUnbufferedQueued(o,s,t,r){var i;let a;r instanceof v.VSBuffer?a=r:h.isReadableStream(r)?a=await v.streamToBuffer(r):h.isReadableBufferedStream(r)?a=await v.bufferedStreamToBuffer(r):a=v.readableToBuffer(r),await o.writeFile(s,a.buffer,{create:!0,overwrite:!0,unlock:(i=t==null?void 0:t.unlock)!==null&&i!==void 0?i:!1})}async doPipeBuffered(o,s,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeBufferedQueued(o,s,t,r))}async doPipeBufferedQueued(o,s,t,r){let i,a;try{i=await o.open(s,{create:!1}),a=await t.open(r,{create:!0,unlock:!1});const c=v.VSBuffer.alloc(this.BUFFER_SIZE);let u=0,l=0,m=0;do m=await o.read(i,u,c.buffer,l,c.byteLength-l),await this.doWriteBuffer(t,a,c,m,u,l),u+=m,l+=m,l===c.byteLength&&(l=0);while(m>0)}catch(c){throw A.ensureFileSystemProviderError(c)}finally{await C.Promises.settled([typeof i=="number"?o.close(i):Promise.resolve(),typeof a=="number"?t.close(a):Promise.resolve()])}}async doPipeUnbuffered(o,s,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(o,s,t,r))}async doPipeUnbufferedQueued(o,s,t,r){return t.writeFile(r,await o.readFile(s),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(o,s,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(o,s,t,r))}async doPipeUnbufferedToBufferedQueued(o,s,t,r){const i=await t.open(r,{create:!0,unlock:!1});try{const a=await o.readFile(s);await this.doWriteBuffer(t,i,v.VSBuffer.wrap(a),a.byteLength,0,0)}catch(a){throw A.ensureFileSystemProviderError(a)}finally{await t.close(i)}}async doPipeBufferedToUnbuffered(o,s,t,r){const i=await v.streamToBuffer(this.readFileBuffered(o,s,f.CancellationToken.None));await this.doWriteUnbuffered(t,r,void 0,i)}throwIfFileSystemIsReadonly(o,s){if(o.capabilities&2048)throw new A.FileOperationError(y.localize(22,null,this.resourceForError(s)),6);return o}throwIfFileIsReadonly(o,s){var t;if(((t=s.permissions)!==null&&t!==void 0?t:0)&A.FilePermission.Readonly)throw new A.FileOperationError(y.localize(23,null,this.resourceForError(o)),6)}resourceForError(o){return o.scheme===I.Schemas.file?o.fsPath:o.toString(!0)}};b=de([Y(0,n.ILogService)],b),e.FileService=b}),define(Z[160],ee([0,1,2,10,3,6,17,7,14,41,8,18,118,75,136,138,135,149,48,78,19,25]),function(H,e,y,R,L,A,O,P,p,S,n,v,h,C,f,I,D,E,b,g,o,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class t extends y.Disposable{constructor(i,a){var c;super();this.logService=i,this.options=a,this.BUFFER_SIZE=((c=this.options)===null||c===void 0?void 0:c.bufferSize)||64*1024,this.onDidChangeCapabilities=L.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new L.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new L.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new n.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,A.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(i){try{const{stat:a,symbolicLink:c}=await O.SymlinkSupport.stat(this.toFilePath(i));return{type:this.toType(a,c),ctime:a.birthtime.getTime(),mtime:a.mtime.getTime(),size:a.size}}catch(a){throw this.toFileSystemProviderError(a)}}async readdir(i){try{const a=await O.readdir(this.toFilePath(i),{withFileTypes:!0}),c=[];return await Promise.all(a.map(async u=>{try{let l;u.isSymbolicLink()?l=(await this.stat(p.joinPath(i,u.name))).type:l=this.toType(u),c.push([u.name,l])}catch(l){this.logService.trace(l)}})),c}catch(a){throw this.toFileSystemProviderError(a)}}toType(i,a){let c;return(a==null?void 0:a.dangling)?c=R.FileType.Unknown:i.isFile()?c=R.FileType.File:i.isDirectory()?c=R.FileType.Directory:c=R.FileType.Unknown,a&&(c|=R.FileType.SymbolicLink),c}async readFile(i){try{const a=this.toFilePath(i);return await O.Promises.readFile(a)}catch(a){throw this.toFileSystemProviderError(a)}}readFileStream(i,a,c){const u=b.newWriteableStream(l=>s.VSBuffer.concat(l.map(m=>s.VSBuffer.wrap(m))).buffer);return g.readFileIntoStream(this,i,u,l=>l.buffer,Object.assign(Object.assign({},a),{bufferSize:this.BUFFER_SIZE}),c),u}async writeFile(i,a,c){let u;try{const l=this.toFilePath(i);if(!c.create||!c.overwrite){if(await O.exists(l)){if(!c.overwrite)throw R.createFileSystemProviderError(h.localize(0,null),R.FileSystemProviderErrorCode.FileExists)}else if(!c.create)throw R.createFileSystemProviderError(h.localize(1,null),R.FileSystemProviderErrorCode.FileNotFound)}u=await this.open(i,{create:!0,unlock:c.unlock}),await this.write(u,0,a,0,a.byteLength)}catch(l){throw await this.toFileSystemProviderWriteError(i,l)}finally{typeof u=="number"&&await this.close(u)}}async open(i,a){try{const c=this.toFilePath(i);if(R.isFileOpenForWriteOptions(a)&&a.unlock)try{const{stat:m}=await O.SymlinkSupport.stat(c);m.mode&128||await O.Promises.chmod(c,m.mode|128)}catch(m){this.logService.trace(m)}let u;if(R.isFileOpenForWriteOptions(a)){if(A.isWindows)try{await O.Promises.truncate(c,0),u="r+"}catch(m){m.code!=="ENOENT"&&this.logService.trace(m)}u||(u="w")}else u="r";const l=await O.Promises.open(c,u);return this.mapHandleToPos.set(l,0),R.isFileOpenForWriteOptions(a)&&this.writeHandles.set(l,i),l}catch(c){throw R.isFileOpenForWriteOptions(a)?await this.toFileSystemProviderWriteError(i,c):this.toFileSystemProviderError(c)}}async close(i){try{if(this.mapHandleToPos.delete(i),this.writeHandles.delete(i)&&this.canFlush)try{await O.Promises.fdatasync(i)}catch(a){this.canFlush=!1,this.logService.error(a)}return await O.Promises.close(i)}catch(a){throw this.toFileSystemProviderError(a)}}async read(i,a,c,u,l){const m=this.normalizePos(i,a);let w=null;try{const d=await O.Promises.read(i,c,u,l,m);return typeof d=="number"?w=d:w=d.bytesRead,w}catch(d){throw this.toFileSystemProviderError(d)}finally{this.updatePos(i,m,w)}}normalizePos(i,a){return a===this.mapHandleToPos.get(i)?null:a}updatePos(i,a,c){const u=this.mapHandleToPos.get(i);typeof u=="number"&&(typeof a=="number"||(typeof c=="number"?this.mapHandleToPos.set(i,u+c):this.mapHandleToPos.delete(i)))}async write(i,a,c,u,l){return n.retry(()=>this.doWrite(i,a,c,u,l),100,3)}async doWrite(i,a,c,u,l){const m=this.normalizePos(i,a);let w=null;try{const d=await O.Promises.write(i,c,u,l,m);return typeof d=="number"?w=d:w=d.bytesWritten,w}catch(d){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(i),d)}finally{this.updatePos(i,m,w)}}async mkdir(i){try{await O.Promises.mkdir(this.toFilePath(i))}catch(a){throw this.toFileSystemProviderError(a)}}async delete(i,a){try{const c=this.toFilePath(i);await this.doDelete(c,a)}catch(c){throw this.toFileSystemProviderError(c)}}async doDelete(i,a){a.recursive?await O.rimraf(i,O.RimRafMode.MOVE):await O.Promises.unlink(i)}async rename(i,a,c){const u=this.toFilePath(i),l=this.toFilePath(a);if(u!==l)try{await this.validateTargetDeleted(i,a,"move",c.overwrite),await O.move(u,l)}catch(m){throw(m.code==="EINVAL"||m.code==="EBUSY"||m.code==="ENAMETOOLONG")&&(m=new Error(h.localize(2,null,P.basename(u),P.basename(P.dirname(l)),m.toString()))),this.toFileSystemProviderError(m)}}async copy(i,a,c){const u=this.toFilePath(i),l=this.toFilePath(a);if(u!==l)try{await this.validateTargetDeleted(i,a,"copy",c.overwrite),await O.copy(u,l,{preserveSymlinks:!0})}catch(m){throw(m.code==="EINVAL"||m.code==="EBUSY"||m.code==="ENAMETOOLONG")&&(m=new Error(h.localize(3,null,P.basename(u),P.basename(P.dirname(l)),m.toString()))),this.toFileSystemProviderError(m)}}async validateTargetDeleted(i,a,c,u){const l=this.toFilePath(i),m=this.toFilePath(a);let w=!1;if(!!(this.capabilities&1024)||(w=S.isEqual(l,m,!0)),w&&c==="copy")throw R.createFileSystemProviderError(h.localize(4,null),R.FileSystemProviderErrorCode.FileExists);if(!w&&await O.exists(m)){if(!u)throw R.createFileSystemProviderError(h.localize(5,null),R.FileSystemProviderErrorCode.FileExists);await this.delete(a,{recursive:!0,useTrash:!1})}}watch(i,a){return a.recursive?this.watchRecursive(i,a.excludes):this.watchNonRecursive(i)}watchRecursive(i,a){const c={path:this.toFilePath(i),excludes:a},u=o.insert(this.recursiveFoldersToWatch,c);return this.refreshRecursiveWatchers(),y.toDisposable(()=>{u(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){var i,a,c;if(this.recursiveWatcher instanceof D.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if(y.dispose(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let u,l;((a=(i=this.options)===null||i===void 0?void 0:i.watcher)===null||a===void 0?void 0:a.usePolling)?(u=f.FileWatcher,l=(c=this.options)===null||c===void 0?void 0:c.watcher):this.recursiveFoldersToWatch.length===1?A.isWindows?u=I.FileWatcher:u=f.FileWatcher:u=D.FileWatcher,this.recursiveWatcher=new u(this.recursiveFoldersToWatch,m=>this._onDidChangeFile.fire(C.toFileChanges(m)),m=>{m.type==="error"&&this._onDidWatchErrorOccur.fire(m.message),this.logService[m.type](m.message)},this.logService.getLevel()===v.LogLevel.Trace,l),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===v.LogLevel.Trace)}))}}watchNonRecursive(i){const a=new E.FileWatcher(this.toFilePath(i),u=>this._onDidChangeFile.fire(C.toFileChanges(u)),u=>{u.type==="error"&&this._onDidWatchErrorOccur.fire(u.message),this.logService[u.type](u.message)},this.logService.getLevel()===v.LogLevel.Trace),c=this.logService.onDidChangeLogLevel(()=>{a.setVerboseLogging(this.logService.getLevel()===v.LogLevel.Trace)});return y.combinedDisposable(a,c)}toFilePath(i){return P.normalize(i.fsPath)}toFileSystemProviderError(i){if(i instanceof R.FileSystemProviderError)return i;let a;switch(i.code){case"ENOENT":a=R.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":a=R.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":a=R.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":a=R.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":a=R.FileSystemProviderErrorCode.NoPermissions;break;default:a=R.FileSystemProviderErrorCode.Unknown}return R.createFileSystemProviderError(i,a)}async toFileSystemProviderWriteError(i,a){let c=this.toFileSystemProviderError(a);if(i&&c.code===R.FileSystemProviderErrorCode.NoPermissions)try{const{stat:u}=await O.SymlinkSupport.stat(this.toFilePath(i));u.mode&128||(c=R.createFileSystemProviderError(a,R.FileSystemProviderErrorCode.FileWriteLocked))}catch(u){this.logService.trace(u)}return c}dispose(){super.dispose(),y.dispose(this.recursiveWatcher),this.recursiveWatcher=void 0,y.dispose(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}e.DiskFileSystemProvider=t}),define(Z[27],ee([0,1,4]),function(H,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=y.createDecorator("productService")}),define(Z[161],ee([0,1,7,17,27,2,11,18,9]),function(H,e,y,R,L,A,O,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let S=class extends A.Disposable{constructor(v,h,C){super();this._environmentService=v,this._logService=h,this._productService=C,this._DataMaxAge=this._productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this._environmentService.isBuilt&&this._manageCachedDataSoon()}_manageCachedDataSoon(){let v=setTimeout(async()=>{v=void 0,this._logService.info("Starting to clean up unused language packs.");try{const h=Object.create(null),C=JSON.parse(await R.Promises.readFile(y.join(this._environmentService.userDataPath,"languagepacks.json"),"utf8"));for(let E of Object.keys(C)){const b=C[E];h[`${b.hash}.${E}`]=!0}const f=y.join(this._environmentService.userDataPath,"clp");if(!await R.exists(f))return;for(let E of await R.readdir(f)){if(h[E]){this._logService.info(`Skipping directory ${E}. Language pack still in use.`);continue}this._logService.info("Removing unused language pack:",E),await R.rimraf(y.join(f,E))}const D=Date.now();for(let E of Object.keys(h)){const b=y.join(f,E);for(let g of await R.readdir(b)){if(g==="tcf.json")continue;const o=y.join(b,g),s=await R.Promises.stat(o);s.isDirectory()&&D-s.mtime.getTime()>this._DataMaxAge&&(this._logService.info("Removing language pack cache entry: ",y.join(E,g)),await R.rimraf(o))}}}catch(h){O.onUnexpectedError(h)}},40*1e3);this._register(A.toDisposable(()=>{v!==void 0&&clearTimeout(v)}))}};S=de([Y(0,p.INativeEnvironmentService),Y(1,P.ILogService),Y(2,L.IProductService)],S),e.LanguagePackCachedDataCleaner=S}),define(Z[162],ee([0,1,7,11,2,17,27]),function(H,e,y,R,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeCachedDataCleaner=void 0;let P=class{constructor(S,n){this.nodeCachedDataDir=S,this.productService=n,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this._disposables=new L.DisposableStore,this._manageCachedDataSoon()}dispose(){this._disposables.dispose()}_manageCachedDataSoon(){if(!this.nodeCachedDataDir)return;const S=y.dirname(this.nodeCachedDataDir),n=y.basename(this.nodeCachedDataDir);let v=setTimeout(()=>{v=void 0,A.readdir(S).then(h=>{const C=Date.now(),f=[];return h.forEach(I=>{if(I!==n){const D=y.join(S,I);f.push(A.Promises.stat(D).then(E=>{if(E.isDirectory()&&C-E.mtime.getTime()>this._DataMaxAge)return A.rimraf(D)}))}}),Promise.all(f)}).then(void 0,R.onUnexpectedError)},30*1e3);this._disposables.add(L.toDisposable(()=>{v&&(clearTimeout(v),v=void 0)}))}};P=de([Y(1,O.IProductService)],P),e.NodeCachedDataCleaner=P}),define(Z[31],ee([0,1,15,87]),function(H,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class L{constructor(){this.data=new Map}add(O,P){R.ok(y.isString(O)),R.ok(y.isObject(P)),R.ok(!this.data.has(O),"There is already an extension with this id"),this.data.set(O,P)}knows(O){return this.data.has(O)}as(O){return this.data.get(O)||null}}e.Registry=new L}),define(Z[79],ee([0,1,31,3]),function(H,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function L(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class A{constructor(){this._onDidChangeSchema=new R.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(p,S){this.schemasById[L(p)]=S,this._onDidChangeSchema.fire(p)}notifySchemaChanged(p){this._onDidChangeSchema.fire(p)}getSchemaContributions(){return{schemas:this.schemasById}}}const O=new A;y.Registry.add(e.Extensions.JSONContribution,O)}),define(Z[37],ee([0,1,108,3,31,15,79]),function(H,e,y,R,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var P;(function(D){D[D.APPLICATION=1]="APPLICATION",D[D.MACHINE=2]="MACHINE",D[D.WINDOW=3]="WINDOW",D[D.RESOURCE=4]="RESOURCE",D[D.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",D[D.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const p=L.Registry.as(O.Extensions.JSONContribution);class S{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new R.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new R.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:y.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},p.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(E,b=!0){this.registerConfigurations([E],b)}registerConfigurations(E,b=!0){const g=[];E.forEach(o=>{g.push(...this.validateAndRegisterProperties(o,b,o.extensionInfo)),this.configurationContributors.push(o),this.registerJSONConfiguration(o)}),p.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(g)}deregisterConfigurations(E){const b=[],g=o=>{if(o.properties)for(const s in o.properties)b.push(s),delete this.configurationProperties[s],this.removeFromSchema(s,o.properties[s]);o.allOf&&o.allOf.forEach(s=>g(s))};for(const o of E){g(o);const s=this.configurationContributors.indexOf(o);s!==-1&&this.configurationContributors.splice(s,1)}p.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(b)}registerDefaultConfigurations(E){const b=[],g=[];for(const o of E)for(const s in o)if(b.push(s),e.OVERRIDE_PROPERTY_PATTERN.test(s)){this.defaultValues[s]=Object.assign(Object.assign({},this.defaultValues[s]||{}),o[s]);const t={type:"object",default:this.defaultValues[s],description:y.localize(1,null,s),$ref:e.resourceLanguageSettingsSchemaId};g.push(v(s)),this.configurationProperties[s]=t,this.defaultLanguageConfigurationOverridesNode.properties[s]=t}else{this.defaultValues[s]=o[s];const t=this.configurationProperties[s];t&&(this.updatePropertyDefaultValue(s,t),this.updateSchema(s,t))}this.registerOverrideIdentifiers(g),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(b)}deregisterDefaultConfigurations(E){const b=[];for(const g of E)for(const o in g)if(b.push(o),delete this.defaultValues[o],e.OVERRIDE_PROPERTY_PATTERN.test(o))delete this.configurationProperties[o],delete this.defaultLanguageConfigurationOverridesNode.properties[o];else{const s=this.configurationProperties[o];s&&(this.updatePropertyDefaultValue(o,s),this.updateSchema(o,s))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(b)}notifyConfigurationSchemaUpdated(...E){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(E){for(const b of E)this.overrideIdentifiers.add(b);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(E,b=!0,g,o=3){var s;o=A.isUndefinedOrNull(E.scope)?o:E.scope;let t=[],r=E.properties;if(r)for(let a in r){if(b&&f(a)){delete r[a];continue}const c=r[a];if(this.updatePropertyDefaultValue(a,c),e.OVERRIDE_PROPERTY_PATTERN.test(a)?c.scope=void 0:(c.scope=A.isUndefinedOrNull(c.scope)?o:c.scope,c.restricted=A.isUndefinedOrNull(c.restricted)?!!((s=g==null?void 0:g.restrictedConfigurations)===null||s===void 0?void 0:s.includes(a)):c.restricted),r[a].hasOwnProperty("included")&&!r[a].included){this.excludedConfigurationProperties[a]=r[a],delete r[a];continue}else this.configurationProperties[a]=r[a];!r[a].deprecationMessage&&r[a].markdownDeprecationMessage&&(r[a].deprecationMessage=r[a].markdownDeprecationMessage),t.push(a)}let i=E.allOf;if(i)for(let a of i)t.push(...this.validateAndRegisterProperties(a,b,g,o));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(E){const b=g=>{let o=g.properties;if(o)for(const t in o)this.updateSchema(t,o[t]);let s=g.allOf;s&&s.forEach(b)};b(E)}updateSchema(E,b){switch(e.allSettings.properties[E]=b,b.scope){case 1:e.applicationSettings.properties[E]=b;break;case 2:e.machineSettings.properties[E]=b;break;case 6:e.machineOverridableSettings.properties[E]=b;break;case 3:e.windowSettings.properties[E]=b;break;case 4:e.resourceSettings.properties[E]=b;break;case 5:e.resourceSettings.properties[E]=b,this.resourceLanguageSettingsSchema.properties[E]=b;break}}removeFromSchema(E,b){switch(delete e.allSettings.properties[E],b.scope){case 1:delete e.applicationSettings.properties[E];break;case 2:delete e.machineSettings.properties[E];break;case 6:delete e.machineOverridableSettings.properties[E];break;case 3:delete e.windowSettings.properties[E];break;case 4:case 5:delete e.resourceSettings.properties[E];break}}updateOverridePropertyPatternKey(){for(const E of this.overrideIdentifiers.values()){const b=`[${E}]`,g={type:"object",description:y.localize(2,null),errorMessage:y.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(b,g),e.allSettings.properties[b]=g,e.applicationSettings.properties[b]=g,e.machineSettings.properties[b]=g,e.machineOverridableSettings.properties[b]=g,e.windowSettings.properties[b]=g,e.resourceSettings.properties[b]=g}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(E,b){let g=this.defaultValues[E];A.isUndefined(g)&&(g=b.default),A.isUndefined(g)&&(g=h(b.type)),b.default=g}}const n="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(n);function v(D){return D.substring(1,D.length-1)}e.overrideIdentifierFromKey=v;function h(D){switch(Array.isArray(D)?D[0]:D){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=h;const C=new S;L.Registry.add(e.Extensions.Configuration,C);function f(D){return D.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(D)?y.localize(5,null,D):C.getConfigurationProperties()[D]!==void 0?y.localize(6,null,D):null:y.localize(4,null)}e.validateProperty=f;function I(){const D=[],E=C.getConfigurationProperties();for(const b of Object.keys(E))D.push([b,E[b].scope]);return D.push(["launch",4]),D.push(["task",4]),D}e.getScopes=I}),define(Z[23],ee([0,1,26,15,5,31,4,37]),function(H,e,y,R,L,A,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=O.createDecorator("configurationService");function p(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof L.URI)}e.isConfigurationOverrides=p;var S;(function(r){r[r.USER=1]="USER",r[r.USER_LOCAL=2]="USER_LOCAL",r[r.USER_REMOTE=3]="USER_REMOTE",r[r.WORKSPACE=4]="WORKSPACE",r[r.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",r[r.DEFAULT=6]="DEFAULT",r[r.MEMORY=7]="MEMORY"})(S=e.ConfigurationTarget||(e.ConfigurationTarget={}));function n(r){switch(r){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=n;function v(r,i){const a=i?r?i.keys.filter(T=>r.keys.indexOf(T)===-1):[...i.keys]:[],c=r?i?r.keys.filter(T=>i.keys.indexOf(T)===-1):[...r.keys]:[],u=[];if(i&&r){for(const T of r.keys)if(i.keys.indexOf(T)!==-1){const _=E(r.contents,T),j=E(i.contents,T);y.equals(_,j)||u.push(T)}}const l=[],m=T=>{const _={};for(const j of T)for(const $ of j.identifiers)_[s($)]=j;return _},w=i?m(i.overrides):{},d=r?m(r.overrides):{};if(Object.keys(w).length)for(const T of a){const _=w[T];_&&l.push([P.overrideIdentifierFromKey(T),_.keys])}if(Object.keys(d).length)for(const T of c){const _=d[T];_&&l.push([P.overrideIdentifierFromKey(T),_.keys])}if(Object.keys(w).length&&Object.keys(d).length)for(const T of u){const _=d[T],j=w[T];if(_&&j){const $=v({contents:_.contents,keys:_.keys,overrides:[]},{contents:j.contents,keys:j.keys,overrides:[]});l.push([P.overrideIdentifierFromKey(T),[...$.added,...$.removed,...$.updated]])}}return{added:a,removed:c,updated:u,overrides:l}}e.compare=v;function h(r,i){const a=[];for(const c of Object.keys(r))if(P.OVERRIDE_PROPERTY_PATTERN.test(c)){const u={};for(const l in r[c])u[l]=r[c][l];a.push({identifiers:[P.overrideIdentifierFromKey(c).trim()],keys:Object.keys(u),contents:C(u,i)})}return a}e.toOverrides=h;function C(r,i){const a=Object.create(null);for(let c in r)f(a,c,r[c],i);return a}e.toValuesTree=C;function f(r,i,a,c){const u=i.split("."),l=u.pop();let m=r;for(let w=0;w<u.length;w++){let d=u[w],T=m[d];switch(typeof T){case"undefined":T=m[d]=Object.create(null);break;case"object":break;default:c(`Ignoring ${i} as ${u.slice(0,w+1).join(".")} is ${JSON.stringify(T)}`);return}m=T}if(typeof m=="object"&&m!==null)try{m[l]=a}catch(w){c(`Ignoring ${i} as ${u.join(".")} is ${JSON.stringify(m)}`)}else c(`Ignoring ${i} as ${u.join(".")} is ${JSON.stringify(m)}`)}e.addToValueTree=f;function I(r,i){const a=i.split(".");D(r,a)}e.removeFromValueTree=I;function D(r,i){const a=i.shift();if(i.length===0){delete r[a];return}if(Object.keys(r).indexOf(a)!==-1){const c=r[a];typeof c=="object"&&!Array.isArray(c)&&(D(c,i),Object.keys(c).length===0&&delete r[a])}}function E(r,i,a){function c(m,w){let d=m;for(const T of w){if(typeof d!="object"||d===null)return;d=d[T]}return d}const u=i.split("."),l=c(r,u);return typeof l=="undefined"?a:l}e.getConfigurationValue=E;function b(r,i,a){Object.keys(i).forEach(c=>{c!=="__proto__"&&(c in r?R.isObject(r[c])&&R.isObject(i[c])?b(r[c],i[c],a):a&&(r[c]=i[c]):r[c]=i[c])})}e.merge=b;function g(){const r=A.Registry.as(P.Extensions.Configuration).getConfigurationProperties();return Object.keys(r)}e.getConfigurationKeys=g;function o(){const r=Object.create(null),i=A.Registry.as(P.Extensions.Configuration).getConfigurationProperties();for(let a in i){let c=i[a].default;f(r,a,c,u=>console.error(`Conflict in default settings: ${u}`))}return r}e.getDefaultValues=o;function s(r){return`[${r}]`}e.keyFromOverrideIdentifier=s;function t(r,i,a){const c=r.inspect(i),u=r.inspect(a);return typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:typeof u.userValue!="undefined"||typeof u.workspaceValue!="undefined"||typeof u.workspaceFolderValue!="undefined"?u.value:c.defaultValue}e.getMigratedSettingValue=t}),define(Z[163],ee([0,1,32,38,19,15,26,5,37,23,31,2,3]),function(H,e,y,R,L,A,O,P,p,S,n,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class C{constructor(t={},r=[],i=[]){this._contents=t,this._keys=r,this._overrides=i,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?S.getConfigurationValue(this.contents,t):this.contents}getOverrideValue(t,r){const i=this.getContentsForOverrideIdentifer(r);return i?t?S.getConfigurationValue(i,t):i:void 0}getKeysForOverrideIdentifier(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.keys;return[]}override(t){const r=this.getContentsForOverrideIdentifer(t);if(!r||typeof r!="object"||!Object.keys(r).length)return this;let i={};for(const a of L.distinct([...Object.keys(this.contents),...Object.keys(r)])){let c=this.contents[a],u=r[a];u&&(typeof c=="object"&&typeof u=="object"?(c=O.deepClone(c),this.mergeContents(c,u)):c=u),i[a]=c}return new C(i,this.keys,this.overrides)}merge(...t){const r=O.deepClone(this.contents),i=O.deepClone(this.overrides),a=[...this.keys];for(const c of t){this.mergeContents(r,c.contents);for(const u of c.overrides){const[l]=i.filter(m=>L.equals(m.identifiers,u.identifiers));l?this.mergeContents(l.contents,u.contents):i.push(O.deepClone(u))}for(const u of c.keys)a.indexOf(u)===-1&&a.push(u)}return new C(r,a,i)}freeze(){return this.isFrozen=!0,this}mergeContents(t,r){for(const i of Object.keys(r)){if(i in t&&A.isObject(t[i])&&A.isObject(r[i])){this.mergeContents(t[i],r[i]);continue}t[i]=O.deepClone(r[i])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?O.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,r){this.addKey(t),S.addToValueTree(this.contents,t,r,i=>{throw new Error(i)})}removeValue(t){this.removeKey(t)&&S.removeFromValueTree(this.contents,t)}addKey(t){let r=this.keys.length;for(let i=0;i<r;i++)t.indexOf(this.keys[i])===0&&(r=i);this.keys.splice(r,1,t)}removeKey(t){let r=this.keys.indexOf(t);return r!==-1?(this.keys.splice(r,1),!0):!1}}e.ConfigurationModel=C;class f extends C{constructor(){const t=S.getDefaultValues(),r=S.getConfigurationKeys(),i=[];for(const a of Object.keys(t))p.OVERRIDE_PROPERTY_PATTERN.test(a)&&i.push({identifiers:[p.overrideIdentifierFromKey(a).trim()],keys:Object.keys(t[a]),contents:S.toValuesTree(t[a],c=>console.error(`Conflict in default settings file: ${c}`))});super(t,r,i)}}e.DefaultConfigurationModel=f;class I{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new C}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,r){if(!A.isUndefinedOrNull(t)){const i=this.doParseContent(t);this.parseRaw(i,r)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,r){this._raw=t;const{contents:i,keys:a,overrides:c,restricted:u}=this.doParseRaw(t,r);this._configurationModel=new C(i,a,c),this._restrictedConfigurations=u||[]}doParseContent(t){let r={},i=null,a=[],c=[],u=[];function l(w){Array.isArray(a)?a.push(w):i&&(a[i]=w)}let m={onObjectBegin:()=>{let w={};l(w),c.push(a),a=w,i=null},onObjectProperty:w=>{i=w},onObjectEnd:()=>{a=c.pop()},onArrayBegin:()=>{let w=[];l(w),c.push(a),a=w,i=null},onArrayEnd:()=>{a=c.pop()},onLiteralValue:l,onError:(w,d,T)=>{u.push({error:w,offset:d,length:T})}};if(t)try{y.visit(t,m),r=a[0]||{}}catch(w){console.error(`Error while parsing settings file ${this._name}: ${w}`),this._parseErrors=[w]}return r}doParseRaw(t,r){const i=n.Registry.as(p.Extensions.Configuration).getConfigurationProperties(),a=this.filter(t,i,!0,r);t=a.raw;const c=S.toValuesTree(t,m=>console.error(`Conflict in settings file ${this._name}: ${m}`)),u=Object.keys(t),l=S.toOverrides(t,m=>console.error(`Conflict in settings file ${this._name}: ${m}`));return{contents:c,keys:u,overrides:l,restricted:a.restricted}}filter(t,r,i,a){if(!(a==null?void 0:a.scopes)&&!(a==null?void 0:a.skipRestricted))return{raw:t,restricted:[]};const c={},u=[];for(let l in t)if(p.OVERRIDE_PROPERTY_PATTERN.test(l)&&i){const m=this.filter(t[l],r,!1,a);c[l]=m.raw,u.push(...m.restricted)}else{const m=r[l],w=m?typeof m.scope!="undefined"?m.scope:3:void 0;(m==null?void 0:m.restricted)&&u.push(l),(w===void 0||a.scopes===void 0||a.scopes.includes(w))&&(a.skipRestricted&&(m==null?void 0:m.restricted)||(c[l]=t[l]))}return{raw:c,restricted:u}}}e.ConfigurationModelParser=I;class D extends v.Disposable{constructor(t,r,i,a){super();this.userSettingsResource=t,this.scopes=r,this.fileService=a,this._onDidChange=this._register(new h.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new I(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(i.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(h.Event.filter(this.fileService.onDidFilesChange,c=>c.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new C}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=D;class E{constructor(t,r,i=new C,a=new C,c=new R.ResourceMap,u=new C,l=new R.ResourceMap,m=!0){this._defaultConfiguration=t,this._localUserConfiguration=r,this._remoteUserConfiguration=i,this._workspaceConfiguration=a,this._folderConfigurations=c,this._memoryConfiguration=u,this._memoryConfigurationByResource=l,this._freeze=m,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new R.ResourceMap,this._userConfiguration=null}getValue(t,r,i){return this.getConsolidateConfigurationModel(r,i).getValue(t)}updateValue(t,r,i={}){let a;i.resource?(a=this._memoryConfigurationByResource.get(i.resource),a||(a=new C,this._memoryConfigurationByResource.set(i.resource,a))):a=this._memoryConfiguration,r===void 0?a.removeValue(t):a.setValue(t,r),i.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,r,i){const a=this.getConsolidateConfigurationModel(r,i),c=this.getFolderConfigurationModelForResource(r.resource,i),u=r.resource?this._memoryConfigurationByResource.get(r.resource)||this._memoryConfiguration:this._memoryConfiguration,l=r.overrideIdentifier?this._defaultConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),m=r.overrideIdentifier?this.userConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),w=r.overrideIdentifier?this.localUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),d=r.overrideIdentifier?this.remoteUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),T=i?r.overrideIdentifier?this._workspaceConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,_=c?r.overrideIdentifier?c.freeze().override(r.overrideIdentifier).getValue(t):c.freeze().getValue(t):void 0,j=r.overrideIdentifier?u.override(r.overrideIdentifier).getValue(t):u.getValue(t),$=a.getValue(t),K=L.distinct(L.flatten(a.overrides.map(B=>B.identifiers))).filter(B=>a.getOverrideValue(t,B)!==void 0);return{defaultValue:l,userValue:m,userLocalValue:w,userRemoteValue:d,workspaceValue:T,workspaceFolderValue:_,memoryValue:j,value:$,default:l!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,user:m!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userLocal:w!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userRemote:d!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspace:T!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspaceFolder:_!==void 0?{value:c==null?void 0:c.freeze().getValue(t),override:r.overrideIdentifier?c==null?void 0:c.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,memory:j!==void 0?{value:u.getValue(t),override:r.overrideIdentifier?u.getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,overrideIdentifiers:K.length?K:void 0}}keys(t){const r=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:r?r.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,r){this._folderConfigurations.set(t,r),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,r){const i=r.filter(a=>p.OVERRIDE_PROPERTY_PATTERN.test(a)).map(a=>{const c=p.overrideIdentifierFromKey(a),u=this._defaultConfiguration.getKeysForOverrideIdentifier(c),l=t.getKeysForOverrideIdentifier(c),m=[...l.filter(w=>u.indexOf(w)===-1),...u.filter(w=>l.indexOf(w)===-1),...u.filter(w=>!O.equals(this._defaultConfiguration.override(c).getValue(w),t.override(c).getValue(w)))];return[c,m]});return this.updateDefaultConfiguration(t),{keys:r,overrides:i}}compareAndUpdateLocalUserConfiguration(t){const{added:r,updated:i,removed:a,overrides:c}=S.compare(this.localUserConfiguration,t),u=[...r,...i,...a];return u.length&&this.updateLocalUserConfiguration(t),{keys:u,overrides:c}}compareAndUpdateRemoteUserConfiguration(t){const{added:r,updated:i,removed:a,overrides:c}=S.compare(this.remoteUserConfiguration,t);let u=[...r,...i,...a];return u.length&&this.updateRemoteUserConfiguration(t),{keys:u,overrides:c}}compareAndUpdateWorkspaceConfiguration(t){const{added:r,updated:i,removed:a,overrides:c}=S.compare(this.workspaceConfiguration,t);let u=[...r,...i,...a];return u.length&&this.updateWorkspaceConfiguration(t),{keys:u,overrides:c}}compareAndUpdateFolderConfiguration(t,r){const i=this.folderConfigurations.get(t),{added:a,updated:c,removed:u,overrides:l}=S.compare(i,r);let m=[...a,...c,...u];return(m.length||!i)&&this.updateFolderConfiguration(t,r),{keys:m,overrides:l}}compareAndDeleteFolderConfiguration(t){const r=this.folderConfigurations.get(t);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:i,updated:a,removed:c,overrides:u}=S.compare(r,void 0);return{keys:[...i,...a,...c],overrides:u}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,r){let i=this.getConsolidatedConfigurationModelForResource(t,r);return t.overrideIdentifier?i.override(t.overrideIdentifier):i}getConsolidatedConfigurationModelForResource({resource:t},r){let i=this.getWorkspaceConsolidatedConfiguration();if(r&&t){const a=r.getFolder(t);a&&(i=this.getFolderConsolidatedConfiguration(a.uri)||i);const c=this._memoryConfigurationByResource.get(t);c&&(i=i.merge(c))}return i}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let r=this._foldersConsolidatedConfigurations.get(t);if(!r){const i=this.getWorkspaceConsolidatedConfiguration(),a=this._folderConfigurations.get(t);a?(r=i.merge(a),this._freeze&&(r=r.freeze()),this._foldersConsolidatedConfigurations.set(t,r)):r=i}return r}getFolderConfigurationModelForResource(t,r){if(r&&t){const i=r.getFolder(t);if(i)return this._folderConfigurations.get(i.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,r)=>{const{contents:i,overrides:a,keys:c}=this._folderConfigurations.get(r);return t.push([r,{contents:i,overrides:a,keys:c}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(r=>t.add(r)),this.userConfiguration.freeze().keys.forEach(r=>t.add(r)),this._workspaceConfiguration.freeze().keys.forEach(r=>t.add(r)),this._folderConfigurations.forEach(r=>r.freeze().keys.forEach(i=>t.add(i))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const r=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>r.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>r.add(i)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.getKeysForOverrideIdentifier(t).forEach(a=>r.add(a))),[...r.values()]}static parse(t){const r=this.parseConfigurationModel(t.defaults),i=this.parseConfigurationModel(t.user),a=this.parseConfigurationModel(t.workspace),c=t.folders.reduce((u,l)=>(u.set(P.URI.revive(l[0]),this.parseConfigurationModel(l[1])),u),new R.ResourceMap);return new E(r,i,new C,a,c,new C,new R.ResourceMap,!1)}static parseConfigurationModel(t){return new C(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=E;function b(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const t=new Set,r=new Map;for(const a of s)a.keys.forEach(c=>t.add(c)),a.overrides.forEach(([c,u])=>{const l=R.getOrSet(r,c,new Set);u.forEach(m=>l.add(m))});const i=[];return r.forEach((a,c)=>i.push([c,[...a.values()]])),{keys:[...t.values()],overrides:i}}e.mergeChanges=b;class g{constructor(t,r,i,a){this.change=t,this.previous=r,this.currentConfiguraiton=i,this.currentWorkspace=a,this._previousConfiguration=void 0;const c=new Set;t.keys.forEach(l=>c.add(l)),t.overrides.forEach(([,l])=>l.forEach(m=>c.add(m))),this.affectedKeys=[...c.values()];const u=new C;this.affectedKeys.forEach(l=>u.setValue(l,{})),this.affectedKeysTree=u.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=E.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,r){var i;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(r){const a=this.previousConfiguration?this.previousConfiguration.getValue(t,r,(i=this.previous)===null||i===void 0?void 0:i.workspace):void 0,c=this.currentConfiguraiton.getValue(t,r,this.currentWorkspace);return!O.equals(a,c)}return!0}return!1}doesAffectedKeysTreeContains(t,r){let i=S.toValuesTree({[r]:!0},()=>{}),a;for(;typeof i=="object"&&(a=Object.keys(i)[0]);){if(t=t[a],!t)return!1;i=i[a]}return!0}}e.ConfigurationChangeEvent=g;class o extends g{constructor(t,r,i,a){super({keys:t.allKeys(),overrides:[]},void 0,t,r);this.source=i,this.sourceConfig=a}}e.AllKeysConfigurationChangeEvent=o}),define(Z[164],ee([0,1,31,37,2,23,163,3,8,14]),function(H,e,y,R,L,A,O,P,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class n extends L.Disposable{constructor(h,C){super();this.settingsResource=h,this._onDidChangeConfiguration=this._register(new P.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new O.UserSettings(this.settingsResource,void 0,S.extUriBiasedIgnorePathCase,C)),this.configuration=new O.Configuration(new O.DefaultConfigurationModel,new O.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new p.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(y.Registry.as(R.Extensions.Configuration).onDidUpdateConfiguration(f=>this.onDidDefaultConfigurationChange(f))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const h=await this.userConfiguration.loadConfiguration();this.configuration=new O.Configuration(new O.DefaultConfigurationModel,h)}getConfigurationData(){return this.configuration.toData()}getValue(h,C){const f=typeof h=="string"?h:void 0,I=A.isConfigurationOverrides(h)?h:A.isConfigurationOverrides(C)?C:{};return this.configuration.getValue(f,I,void 0)}updateValue(h,C,f,I){return Promise.reject(new Error("not supported"))}inspect(h){return this.configuration.inspect(h,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const h=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(h)}onDidChangeUserConfiguration(h){const C=this.configuration.toData(),f=this.configuration.compareAndUpdateLocalUserConfiguration(h);this.trigger(f,C,1)}onDidDefaultConfigurationChange(h){const C=this.configuration.toData(),f=this.configuration.compareAndUpdateDefaultConfiguration(new O.DefaultConfigurationModel,h);this.trigger(f,C,6)}trigger(h,C,f){const I=new O.ConfigurationChangeEvent(h,{data:C},this.configuration);I.source=f,I.sourceConfig=this.getTargetConfiguration(f),this._onDidChangeConfiguration.fire(I)}getTargetConfiguration(h){switch(h){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=n}),define(Z[165],ee([0,1,23,18,102]),function(H,e,y,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let A=class{constructor(P,p){this.configurationService=P,this.logService=p}request(P,p){return this.logService.trace("RequestService#request",P.url),P.proxyAuthorization||(P.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization")),L.request(P,p)}async resolveProxy(P){}};A=de([Y(0,y.IConfigurationService),Y(1,R.ILogService)],A),e.RequestService=A}),define(Z[39],ee([0,1,119,4,37,31,25]),function(H,e,y,R,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=R.createDecorator("requestService");function P(f){return f.res.statusCode&&f.res.statusCode>=200&&f.res.statusCode<300||f.res.statusCode===1223}e.isSuccess=P;function p(f){return f.res.statusCode===204}async function S(f){if(!P(f))throw new Error("Server returned "+f.res.statusCode);return p(f)?null:(await O.streamToBuffer(f.stream)).toString()}e.asText=S;async function n(f){if(!P(f))throw new Error("Server returned "+f.res.statusCode);if(p(f))return null;const D=(await O.streamToBuffer(f.stream)).toString();try{return JSON.parse(D)}catch(E){throw E.message+=`:
`+D,E}}e.asJson=n;function v(f){C(f)}e.updateProxyConfigurationsScope=v;let h;function C(f){const I=A.Registry.as(L.Extensions.Configuration);h&&I.deregisterConfigurations([h]),h={id:"http",order:15,title:y.localize(0,null),type:"object",scope:f,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:y.localize(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:y.localize(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:y.localize(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[y.localize(4,null),y.localize(5,null),y.localize(6,null),y.localize(7,null)],default:"override",description:y.localize(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:y.localize(9,null),restricted:!0}}},I.registerConfiguration(h)}C(2)}),define(Z[166],ee([0,1,39,29,10,16]),function(H,e,y,R,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let O=class{constructor(p,S){this.requestService=p,this.fileService=S}async download(p,S,n=R.CancellationToken.None){if(p.scheme===A.Schemas.file||p.scheme===A.Schemas.vscodeRemote){await this.fileService.copy(p,S);return}const v={type:"GET",url:p.toString()},h=await this.requestService.request(v,n);if(h.res.statusCode===200)await this.fileService.writeFile(S,h.stream);else{const C=await y.asText(h);throw new Error(`Expected 200, got back ${h.res.statusCode} instead.

${C}`)}}};O=de([Y(0,y.IRequestService),Y(1,L.IFileService)],O),e.DownloadService=O}),define(Z[167],ee([0,1,27,10,19,63,39,29,18,14,131,2]),function(H,e,y,R,L,A,O,P,p,S,n,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let h=class extends v.Disposable{constructor(f,I,D,E){super();this.fileService=f,this.productService=I,this.requestService=D,this.logService=E,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&A.forEach(this.productService.configBasedExtensionTips,({value:b})=>this.allConfigBasedTips.set(b.configPath,b))}getConfigBasedTips(f){return this.getValidConfigBasedTips(f)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(f){const I=[];for(const[D,E]of this.allConfigBasedTips)try{const b=await this.fileService.readFile(S.joinPath(f,D)),g=new Map;A.forEach(E.recommendations,({key:s,value:t})=>{if(L.isNonEmptyArray(t.remotes))for(const r of t.remotes)g.set(r,{extensionId:s,extensionName:t.name,configName:E.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack});else I.push({extensionId:s,extensionName:t.name,configName:E.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack})});const o=n.getDomainsOfRemotes(b.value.toString(),[...g.keys()]);for(const s of o){const t=g.get(s);t&&I.push(t)}}catch(b){}return I}async fetchWorkspacesTips(){var f,I;if(!((f=this.productService.extensionsGallery)===null||f===void 0?void 0:f.recommendationsUrl))return[];try{const D=await this.requestService.request({type:"GET",url:(I=this.productService.extensionsGallery)===null||I===void 0?void 0:I.recommendationsUrl},P.CancellationToken.None);if(D.res.statusCode!==200)return[];const E=await O.asJson(D);return E?E.workspaceRecommendations||[]:[]}catch(D){return this.logService.error(D),[]}}};h=de([Y(0,R.IFileService),Y(1,y.IProductService),Y(2,O.IRequestService),Y(3,p.ILogService)],h),e.ExtensionTipsService=h}),define(Z[45],ee([0,1,30,25]),function(H,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function L(A,O,P){let p=P&&P.get("storage.serviceMachineId",0)||null;if(p)return p;try{const n=(await O.readFile(A.serviceMachineIdResource)).value.toString();p=y.isUUID(n)?n:null}catch(S){p=null}if(!p){p=y.generateUuid();try{await O.writeFile(A.serviceMachineIdResource,R.VSBuffer.fromString(p))}catch(S){}}return P&&P.store("storage.serviceMachineId",p,0,1),p}e.getServiceMachineId=L}),define(Z[20],ee([0,1,4,3,2,15,69,8]),function(H,e,y,R,L,A,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const p="__$__targetStorageMarker";e.IStorageService=y.createDecorator("storageService");var S;(function(I){I[I.NONE=0]="NONE",I[I.SHUTDOWN=1]="SHUTDOWN"})(S=e.WillSaveStateReason||(e.WillSaveStateReason={}));var n;(function(I){I[I.GLOBAL=0]="GLOBAL",I[I.WORKSPACE=1]="WORKSPACE"})(n=e.StorageScope||(e.StorageScope={}));var v;(function(I){I[I.USER=0]="USER",I[I.MACHINE=1]="MACHINE"})(v=e.StorageTarget||(e.StorageTarget={}));class h extends L.Disposable{constructor(D={flushInterval:h.DEFAULT_FLUSH_INTERVAL}){super();this.options=D,this._onDidChangeValue=this._register(new R.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new R.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new R.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new P.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new L.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=P.runWhenIdle(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){L.dispose([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(D,E){E===p?(D===0?this._globalKeyTargets=void 0:D===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:D})):this._onDidChangeValue.fire({scope:D,key:E,target:this.getKeyTargets(D)[E]})}emitWillSaveState(D){this._onWillSaveState.fire({reason:D})}get(D,E,b){var g;return(g=this.getStorage(E))===null||g===void 0?void 0:g.get(D,b)}getBoolean(D,E,b){var g;return(g=this.getStorage(E))===null||g===void 0?void 0:g.getBoolean(D,b)}getNumber(D,E,b){var g;return(g=this.getStorage(E))===null||g===void 0?void 0:g.getNumber(D,b)}store(D,E,b,g){if(A.isUndefinedOrNull(E)){this.remove(D,b);return}this.withPausedEmitters(()=>{var o;this.updateKeyTarget(D,b,g),(o=this.getStorage(b))===null||o===void 0||o.set(D,E)})}remove(D,E){this.withPausedEmitters(()=>{var b;this.updateKeyTarget(D,E,void 0),(b=this.getStorage(E))===null||b===void 0||b.delete(D)})}withPausedEmitters(D){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{D()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(D,E){const b=[],g=this.getKeyTargets(D);for(const o of Object.keys(g))g[o]===E&&b.push(o);return b}updateKeyTarget(D,E,b){var g,o;const s=this.getKeyTargets(E);typeof b=="number"?s[D]!==b&&(s[D]=b,(g=this.getStorage(E))===null||g===void 0||g.set(p,JSON.stringify(s))):typeof s[D]=="number"&&(delete s[D],(o=this.getStorage(E))===null||o===void 0||o.set(p,JSON.stringify(s)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(D){return D===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(D){const E=this.get(p,D);if(E)try{return JSON.parse(E)}catch(b){}return Object.create(null)}isNew(D){return this.getBoolean(e.IS_NEW_KEY,D)===!0}async flush(){var D,E,b,g;this._onWillSaveState.fire({reason:S.NONE}),await P.Promises.settled([(E=(D=this.getStorage(0))===null||D===void 0?void 0:D.whenFlushed())!==null&&E!==void 0?E:Promise.resolve(),(g=(b=this.getStorage(1))===null||b===void 0?void 0:b.whenFlushed())!==null&&g!==void 0?g:Promise.resolve()])}async logStorage(){var D,E,b,g,o,s;const t=(E=(D=this.getStorage(0))===null||D===void 0?void 0:D.items)!==null&&E!==void 0?E:new Map,r=(g=(b=this.getStorage(1))===null||b===void 0?void 0:b.items)!==null&&g!==void 0?g:new Map;return f(t,r,(o=this.getLogDetails(0))!==null&&o!==void 0?o:"",(s=this.getLogDetails(1))!==null&&s!==void 0?s:"")}}e.AbstractStorageService=h,h.DEFAULT_FLUSH_INTERVAL=60*1e3;class C extends h{constructor(){super();this.globalStorage=new O.Storage(new O.InMemoryStorageDatabase),this.workspaceStorage=new O.Storage(new O.InMemoryStorageDatabase),this._register(this.workspaceStorage.onDidChangeStorage(D=>this.emitDidChangeValue(1,D))),this._register(this.globalStorage.onDidChangeStorage(D=>this.emitDidChangeValue(0,D)))}getStorage(D){return D===0?this.globalStorage:this.workspaceStorage}getLogDetails(D){return D===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(D){}}e.InMemoryStorageService=C;async function f(I,D,E,b){const g=c=>{try{return JSON.parse(c)}catch(u){return c}},o=new Map,s=new Map;I.forEach((c,u)=>{o.set(u,c),s.set(u,g(c))});const t=new Map,r=new Map;D.forEach((c,u)=>{t.set(u,c),r.set(u,g(c))}),console.group(`Storage: Global (path: ${E})`);let i=[];o.forEach((c,u)=>{i.push({key:u,value:c})}),console.table(i),console.groupEnd(),console.log(s),console.group(`Storage: Workspace (path: ${b})`);let a=[];t.forEach((c,u)=>{a.push({key:u,value:c})}),console.table(a),console.groupEnd(),console.log(r)}e.logStorage=f}),define(Z[168],ee([0,1,3,2,28,33,20,15]),function(H,e,y,R,L,A,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let p=class extends R.Disposable{constructor(v){super();this._onDidChangeEnablement=new y.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new S(v)),this._register(this.storageManger.onDidChange(h=>this._onDidChangeEnablement.fire({extensions:h,source:"storage"})))}async enableExtension(v,h){return this._removeFromDisabledExtensions(v)?(this._onDidChangeEnablement.fire({extensions:[v],source:h}),!0):!1}async disableExtension(v,h){return this._addToDisabledExtensions(v)?(this._onDidChangeEnablement.fire({extensions:[v],source:h}),!0):!1}getDisabledExtensions(){return this._getExtensions(L.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(v){let h=this.getDisabledExtensions();return h.every(C=>!A.areSameExtensions(C,v))?(h.push(v),this._setDisabledExtensions(h),!0):!1}_removeFromDisabledExtensions(v){let h=this.getDisabledExtensions();for(let C=0;C<h.length;C++){const f=h[C];if(A.areSameExtensions(f,v))return h.splice(C,1),this._setDisabledExtensions(h),!0}return!1}_setDisabledExtensions(v){this._setExtensions(L.DISABLED_EXTENSIONS_STORAGE_PATH,v)}_getExtensions(v){return this.storageManger.get(v,0)}_setExtensions(v,h){this.storageManger.set(v,h,0)}};p=de([Y(0,O.IStorageService)],p),e.GlobalExtensionEnablementService=p;class S extends R.Disposable{constructor(v){super();this.storageService=v,this.storage=Object.create(null),this._onDidChange=this._register(new y.Emitter),this.onDidChange=this._onDidChange.event,this._register(v.onDidChangeValue(h=>this.onDidStorageChange(h)))}get(v,h){let C;return h===0?(P.isUndefinedOrNull(this.storage[v])&&(this.storage[v]=this._get(v,h)),C=this.storage[v]):C=this._get(v,h),JSON.parse(C)}set(v,h,C){let f=JSON.stringify(h.map(({id:D,uuid:E})=>({id:D,uuid:E})));this._get(v,C)!==f&&(C===0&&(h.length?this.storage[v]=f:delete this.storage[v]),this._set(v,h.length?f:void 0,C))}onDidStorageChange(v){if(v.scope===0&&!P.isUndefinedOrNull(this.storage[v.key])&&this._get(v.key,v.scope)!==this.storage[v.key]){const C=this.get(v.key,v.scope);delete this.storage[v.key];const f=this.get(v.key,v.scope),I=C.filter(E=>!f.some(b=>A.areSameExtensions(E,b))),D=f.filter(E=>!C.some(b=>A.areSameExtensions(b,E)));(I.length||D.length)&&this._onDidChange.fire([...I,...D])}}_get(v,h){return this.storageService.get(v,h,"[]")}_set(v,h,C){h?this.storageService.store(v,h,C,1):this.storageService.remove(v,C)}}e.StorageManager=S}),define(Z[169],ee([0,1,3,2]),function(H,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannelClient=void 0;class L extends R.Disposable{constructor(S,n){super();this.channel=S,this.workspace=n}async getItems(){const S={workspace:this.workspace},n=await this.channel.call("getItems",S);return new Map(n)}updateItems(S){const n={workspace:this.workspace};return S.insert&&(n.insert=Array.from(S.insert.entries())),S.delete&&(n.delete=Array.from(S.delete.values())),this.channel.call("updateItems",n)}}class A extends L{constructor(S){super(S,void 0);this._onDidChangeItemsExternal=this._register(new y.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeGlobalStorage")(S=>this.onDidChangeGlobalStorage(S)))}onDidChangeGlobalStorage(S){(Array.isArray(S.changed)||Array.isArray(S.deleted))&&this._onDidChangeItemsExternal.fire({changed:S.changed?new Map(S.changed):void 0,deleted:S.deleted?new Set(S.deleted):void 0})}async close(){this.dispose()}}class O extends L{constructor(S,n){super(S,n);this.onDidChangeItemsExternal=y.Event.None}async close(){const S={workspace:this.workspace};return this.channel.call("close",S)}}class P extends R.Disposable{constructor(S,n){super();this.channel=S,this.workspace=n,this._globalStorage=void 0,this._workspaceStorage=void 0}get globalStorage(){return this._globalStorage||(this._globalStorage=new A(this.channel)),this._globalStorage}get workspaceStorage(){return!this._workspaceStorage&&this.workspace&&(this._workspaceStorage=new O(this.channel,this.workspace)),this._workspaceStorage}}e.StorageDatabaseChannelClient=P}),define(Z[170],ee([0,1,2,20,69,8,159,169,14]),function(H,e,y,R,L,A,O,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class S extends R.AbstractStorageService{constructor(v,h,C){super();this.mainProcessService=h,this.environmentService=C,this.workspaceStorage=void 0,this.workspaceStorageId=void 0,this.workspaceStorageDisposable=this._register(new y.MutableDisposable),this.globalStorage=this.createGlobalStorage(),this.workspaceStorage=this.createWorkspaceStorage(v)}createGlobalStorage(){const v=new P.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),void 0),h=new L.Storage(v.globalStorage);return this._register(h.onDidChangeStorage(C=>this.emitDidChangeValue(0,C))),h}createWorkspaceStorage(v){const h=new P.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),v);if(h.workspaceStorage){const C=new L.Storage(h.workspaceStorage);return this.workspaceStorageDisposable.value=C.onDidChangeStorage(f=>this.emitDidChangeValue(1,f)),this.workspaceStorageId=v==null?void 0:v.id,C}else{this.workspaceStorageDisposable.clear(),this.workspaceStorageId=void 0;return}}async doInitialize(){var v,h;O.mark("code/willInitStorage");try{await A.Promises.settled([this.globalStorage.init(),(h=(v=this.workspaceStorage)===null||v===void 0?void 0:v.init())!==null&&h!==void 0?h:Promise.resolve()])}finally{O.mark("code/didInitStorage")}}getStorage(v){return v===0?this.globalStorage:this.workspaceStorage}getLogDetails(v){return v===0?this.environmentService.globalStorageHome.fsPath:this.workspaceStorageId?`${p.joinPath(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}async close(){var v,h;this.stopFlushWhenIdle(),this.emitWillSaveState(R.WillSaveStateReason.SHUTDOWN),await A.Promises.settled([this.globalStorage.close(),(h=(v=this.workspaceStorage)===null||v===void 0?void 0:v.close())!==null&&h!==void 0?h:Promise.resolve()])}async migrate(v){var h;const C=this.workspaceStorage,f=(h=C==null?void 0:C.items)!==null&&h!==void 0?h:new Map;C&&(await C.close(),C.dispose()),this.workspaceStorage=this.createWorkspaceStorage(v),await this.workspaceStorage.init();for(const[I,D]of f)this.workspaceStorage.set(I,D)}}e.NativeStorageService=S}),define(Z[171],ee([0,1,6,34,30,5]),function(H,e,y,R,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function O(S){if(y.platform===2&&/^penguin(\.|$)/i.test(S))return"chromebook"}async function P(S,n,v,h,C,f,I,D,E,b){const g=Object.create(null);g["common.machineId"]=I,g.sessionID=L.generateUuid()+Date.now(),g.commitHash=C,g.version=f,g["common.platformVersion"]=(n||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),g["common.platform"]=y.PlatformToString(y.platform),g["common.nodePlatform"]=R.platform,g["common.nodeArch"]=h,g["common.product"]=b||"desktop";const o=p(D||[]);o&&(g["common.msftInternal"]=o);let s=0;const t=Date.now();Object.defineProperties(g,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-t,enumerable:!0},"common.sequence":{get:()=>s++,enumerable:!0}}),y.isLinuxSnap&&(g["common.snap"]="true");const r=O(v);r&&(g["common.platformDetail"]=r);try{const i=await S.readFile(A.URI.file(E));g["common.source"]=i.value.toString().slice(0,30)}catch(i){}return g}e.resolveCommonProperties=P;function p(S){const n=R.env.USERDNSDOMAIN;if(!n)return!1;const v=n.toLowerCase();return S.some(h=>v===h)}e.verifyMicrosoftInternalDomain=p}),define(Z[24],ee([0,1,4]),function(H,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=y.createDecorator("telemetryService"),e.ICustomEndpointTelemetryService=y.createDecorator("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId"}),define(Z[172],ee([0,1,35,94,71,42,7,32,97,27,6,5,24,53,16,10,17]),function(H,e,y,R,L,A,O,P,p,S,n,v,h,C,f,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function E(t,r){const i=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],a=new Map,c=new Map,u=2e4;function l(d,T,_,j){const $=T.substring(d.length+1);return new Promise(async K=>{var B,z,G;let V;try{V=await D.readdir(T,{withFileTypes:!0})}catch(k){K();return}if(j.count>=u){j.count+=V.length,j.maxReached=!0,K();return}let M=V.length;if(M===0){K();return}let U=V;j.count+V.length>u&&(j.maxReached=!0,M=u-j.count,U=V.slice(0,M)),j.count+=V.length;for(const k of U)if(k.isDirectory()){if(_.includes(k.name)||await l(d,O.join(T,k.name),_,j),--M==0){K();return}}else{const F=k.name.lastIndexOf(".");if(F>=0){const N=k.name.substring(F+1);N&&a.set(N,((B=a.get(N))!==null&&B!==void 0?B:0)+1)}for(const N of i)((z=N.relativePathPattern)===null||z===void 0?void 0:z.test($))!==!1&&N.filePattern.test(k.name)&&c.set(N.tag,((G=c.get(N.tag))!==null&&G!==void 0?G:0)+1);if(--M==0){K();return}}})}const m={count:0,maxReached:!1};await l(t,t,r,m);const w=await o(t);return{configFiles:b(c),fileTypes:b(a),fileCount:m.count,maxFilesReached:m.maxReached,launchConfigFiles:w}}e.collectWorkspaceStats=E;function b(t){return[...C.Iterable.map(t.entries(),([r,i])=>({name:r,count:i}))].sort((r,i)=>i.count-r.count)}function g(){const t={os:`${y.type()} ${y.arch()} ${y.release()}`,memory:`${(y.totalmem()/I.ByteSize.GB).toFixed(2)}GB (${(y.freemem()/I.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(R.virtualMachineHint.value()*100)}%`},r=y.cpus();return r&&r.length>0&&(t.cpus=`${r[0].model} (${r.length} x ${r[0].speed})`),t}e.getMachineInfo=g;function o(t){let r=new Map,i=O.join(t,".vscode","launch.json");return new Promise((a,c)=>{A.exists(i,u=>{if(u)A.readFile(i,(l,m)=>{if(l)return a([]);const w=[],d=P.parse(m.toString(),w);if(w.length)return console.log(`Unable to parse ${i}`),a([]);if(P.getNodeType(d)==="object"&&d.configurations)for(const T of d.configurations){const _=T.type;_&&(r.has(_)?r.set(_,r.get(_)+1):r.set(_,1))}return a(b(r))});else return a([])})})}e.collectLaunchConfigs=o;let s=class{constructor(r,i){this.telemetryService=r,this.productService=i}formatMachineInfo(r){const i=[];return i.push(`OS Version:       ${r.os}`),i.push(`CPUs:             ${r.cpus}`),i.push(`Memory (System):  ${r.memory}`),i.push(`VM:               ${r.vmHint}`),i.join(`
`)}formatEnvironment(r){const i=[];i.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),i.push(`OS Version:       ${y.type()} ${y.arch()} ${y.release()}`);const a=y.cpus();return a&&a.length>0&&i.push(`CPUs:             ${a[0].model} (${a.length} x ${a[0].speed})`),i.push(`Memory (System):  ${(y.totalmem()/I.ByteSize.GB).toFixed(2)}GB (${(y.freemem()/I.ByteSize.GB).toFixed(2)}GB free)`),n.isWindows||i.push(`Load (avg):       ${y.loadavg().map(c=>Math.round(c)).join(", ")}`),i.push(`VM:               ${Math.round(R.virtualMachineHint.value()*100)}%`),i.push(`Screen Reader:    ${r.screenReader?"yes":"no"}`),i.push(`Process Argv:     ${r.mainArguments.join(" ")}`),i.push(`GPU Status:       ${this.expandGPUFeatures(r.gpuFeatureStatus)}`),i.join(`
`)}async getPerformanceInfo(r,i){return Promise.all([p.listProcesses(r.mainPID),this.formatWorkspaceMetadata(r)]).then(async a=>{let[c,u]=a,l=this.formatProcessList(r,c);return i.forEach(m=>{if(L.isRemoteDiagnosticError(m))l+=`
${m.errorMessage}`,u+=`
${m.errorMessage}`;else if(l+=`

Remote: ${m.hostName}`,m.processes&&(l+=`
${this.formatProcessList(r,m.processes)}`),m.workspaceMetadata){u+=`
|  Remote: ${m.hostName}`;for(const w of Object.keys(m.workspaceMetadata)){const d=m.workspaceMetadata[w];let T=`${d.fileCount} files`;d.maxFilesReached&&(T=`more than ${T}`),u+=`|    Folder (${w}): ${T}`,u+=this.formatWorkspaceStats(d)}}}),{processInfo:l,workspaceInfo:u}})}async getSystemInfo(r,i){const{memory:a,vmHint:c,os:u,cpus:l}=g(),m={os:u,memory:a,cpus:l,vmHint:c,processArgs:`${r.mainArguments.join(" ")}`,gpuStatus:r.gpuFeatureStatus,screenReader:`${r.screenReader?"yes":"no"}`,remoteData:i};return n.isWindows||(m.load=`${y.loadavg().map(w=>Math.round(w)).join(", ")}`),n.isLinux&&(m.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(m)}async getDiagnostics(r,i){const a=[];return p.listProcesses(r.mainPID).then(async c=>(a.push(""),a.push(this.formatEnvironment(r)),a.push(""),a.push(this.formatProcessList(r,c)),r.windows.some(u=>u.folderURIs&&u.folderURIs.length>0&&!u.remoteAuthority)&&(a.push(""),a.push("Workspace Stats: "),a.push(await this.formatWorkspaceMetadata(r))),i.forEach(u=>{if(L.isRemoteDiagnosticError(u))a.push(`
${u.errorMessage}`);else if(a.push(`

`),a.push(`Remote:           ${u.hostName}`),a.push(this.formatMachineInfo(u.machineInfo)),u.processes&&a.push(this.formatProcessList(r,u.processes)),u.workspaceMetadata)for(const l of Object.keys(u.workspaceMetadata)){const m=u.workspaceMetadata[l];let w=`${m.fileCount} files`;m.maxFilesReached&&(w=`more than ${w}`),a.push(`Folder (${l}): ${w}`),a.push(this.formatWorkspaceStats(m))}}),a.push(""),a.push(""),a.join(`
`)))}formatWorkspaceStats(r){const i=[],a=60;let c=0;const u=(d,T)=>{const _=` ${d}(${T})`;c+_.length>a?(i.push(l),l="|                 ",c=l.length):c+=_.length,l+=_};let l="|      File types:";const m=10;let w=r.fileTypes.length>m?m:r.fileTypes.length;for(let d=0;d<w;d++){const T=r.fileTypes[d];u(T.name,T.count)}if(i.push(l),r.configFiles.length>=0&&(l="|      Conf files:",c=0,r.configFiles.forEach(d=>{u(d.name,d.count)}),i.push(l)),r.launchConfigFiles.length>0){let d="|      Launch Configs:";r.launchConfigFiles.forEach(T=>{d+=T.count>1?` ${T.name}(${T.count})`:` ${T.name}`}),i.push(d)}return i.join(`
`)}expandGPUFeatures(r){const i=Math.max(...Object.keys(r).map(a=>a.length));return Object.keys(r).map(a=>`${a}:  ${" ".repeat(i-a.length)}  ${r[a]}`).join(`
                  `)}formatWorkspaceMetadata(r){const i=[],a=[];return r.windows.forEach(c=>{c.folderURIs.length===0||!!c.remoteAuthority||(i.push(`|  Window (${c.title})`),c.folderURIs.forEach(u=>{const l=v.URI.revive(u);if(l.scheme===f.Schemas.file){const m=l.fsPath;a.push(E(m,["node_modules",".git"]).then(w=>{let d=`${w.fileCount} files`;w.maxFilesReached&&(d=`more than ${d}`),i.push(`|    Folder (${O.basename(m)}): ${d}`),i.push(this.formatWorkspaceStats(w))}).catch(w=>{i.push(`|      Error: Unable to collect workspace stats for folder ${m} (${w.toString()})`)}))}else i.push(`|    Folder (${l.toString()}): Workspace stats not available.`)}))}),Promise.all(a).then(c=>i.join(`
`)).catch(c=>`Unable to collect workspace stats: ${c}`)}formatProcessList(r,i){const a=new Map;r.windows.forEach(u=>a.set(u.pid,u.title));const c=[];return c.push("CPU %	Mem MB	   PID	Process"),i&&this.formatProcessItem(r.mainPID,a,c,i,0),c.join(`
`)}formatProcessItem(r,i,a,c,u){const l=u===0;let m;l?m=c.pid===r?`${this.productService.applicationName} main`:"remote agent":(m=`${"  ".repeat(u)} ${c.name}`,c.name==="window"&&(m=`${m} (${i.get(c.pid)})`));const w=process.platform==="win32"?c.mem:y.totalmem()*(c.mem/100);a.push(`${c.load.toFixed(0).padStart(5," ")}	${(w/I.ByteSize.MB).toFixed(0).padStart(6," ")}	${c.pid.toFixed(0).padStart(6," ")}	${m}`),Array.isArray(c.children)&&c.children.forEach(d=>this.formatProcessItem(r,i,a,d,u+1))}async reportWorkspaceStats(r){for(const{uri:i}of r.folders){const a=v.URI.revive(i);if(a.scheme!==f.Schemas.file)continue;const c=a.fsPath;try{const u=await E(c,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":r.telemetryId,rendererSessionId:r.rendererSessionId}),u.fileTypes.forEach(l=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:r.rendererSessionId,type:l.name,count:l.count})}),u.launchConfigFiles.forEach(l=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:r.rendererSessionId,type:l.name,count:l.count})}),u.configFiles.forEach(l=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:r.rendererSessionId,type:l.name,count:l.count})})}catch(u){}}}};s=de([Y(0,h.ITelemetryService),Y(1,S.IProductService)],s),e.DiagnosticsService=s}),define(Z[173],ee([0,1,11,28,33,26,24,39,70,9,29,18,10,5,27,20,45,4,14]),function(H,e,y,R,L,A,O,P,p,S,n,v,h,C,f,I,D,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryService=void 0;var g;(function(U){U[U.None=0]="None",U[U.IncludeVersions=1]="IncludeVersions",U[U.IncludeFiles=2]="IncludeFiles",U[U.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",U[U.IncludeSharedAccounts=8]="IncludeSharedAccounts",U[U.IncludeVersionProperties=16]="IncludeVersionProperties",U[U.ExcludeNonValidated=32]="ExcludeNonValidated",U[U.IncludeInstallationTargets=64]="IncludeInstallationTargets",U[U.IncludeAssetUri=128]="IncludeAssetUri",U[U.IncludeStatistics=256]="IncludeStatistics",U[U.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",U[U.Unpublished=4096]="Unpublished"})(g||(g={}));function o(...U){return String(U.reduce((k,F)=>k|F,0))}var s;(function(U){U[U.Tag=1]="Tag",U[U.ExtensionId=4]="ExtensionId",U[U.Category=5]="Category",U[U.ExtensionName=7]="ExtensionName",U[U.Target=8]="Target",U[U.Featured=9]="Featured",U[U.SearchText=10]="SearchText",U[U.ExcludeWithFlags=12]="ExcludeWithFlags"})(s||(s={}));const t={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},r={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},a={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:g.None,criteria:[],assetTypes:[]};class c{constructor(k=a){this.state=k}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(k,F=this.state.pageSize){return new c(Object.assign(Object.assign({},this.state),{pageNumber:k,pageSize:F}))}withFilter(k,...F){const N=[...this.state.criteria,...F.length?F.map(q=>({filterType:k,value:q})):[{filterType:k}]];return new c(Object.assign(Object.assign({},this.state),{criteria:N}))}withSortBy(k){return new c(Object.assign(Object.assign({},this.state),{sortBy:k}))}withSortOrder(k){return new c(Object.assign(Object.assign({},this.state),{sortOrder:k}))}withFlags(...k){return new c(Object.assign(Object.assign({},this.state),{flags:k.reduce((F,N)=>F|N,0)}))}withAssetTypes(...k){return new c(Object.assign(Object.assign({},this.state),{assetTypes:k}))}get raw(){const{criteria:k,pageNumber:F,pageSize:N,sortBy:q,sortOrder:W,flags:Q,assetTypes:X}=this.state;return{filters:[{criteria:k,pageNumber:F,pageSize:N,sortBy:q,sortOrder:W}],assetTypes:X,flags:Q}}get searchText(){const k=this.state.criteria.filter(F=>F.filterType===s.SearchText)[0];return k&&k.value?k.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(k=>String(k.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function u(U,k){const F=(U||[]).filter(N=>N.statisticName===k)[0];return F?F.value:0}function l(U){const k="Microsoft.VisualStudio.Code.Translation.";return U.files.filter(N=>N.assetType.indexOf(k)===0).reduce((N,q)=>{const W=T(U,q.assetType);return W&&N.push([q.assetType.substring(k.length),W]),N},[])}function m(U){if(U.properties){const k=U.properties.filter(q=>q.key===t.Repository),F=new RegExp("((git|ssh|http(s)?)|(git@[w.]+))(:(//)?)([w.@:/-~]+)(.git)(/)?"),N=k.filter(q=>F.test(q.value))[0];return N?{uri:N.value,fallbackUri:N.value}:null}return T(U,t.Repository)}function w(U){return{uri:`${U.fallbackAssetUri}/${t.VSIX}?redirect=true`,fallbackUri:`${U.fallbackAssetUri}/${t.VSIX}`}}function d(U){const k=T(U,t.Icon);if(k)return k;const F=R.DefaultIconPath;return{uri:F,fallbackUri:F}}function T(U,k){return U.files.filter(N=>N.assetType===k)[0]?{uri:`${U.assetUri}/${k}`,fallbackUri:`${U.fallbackAssetUri}/${k}`}:null}function _(U,k){const F=U.properties?U.properties.filter(q=>q.key===k):[],N=F.length>0&&F[0].value;return N?N.split(",").map(q=>L.adoptToGalleryExtensionId(q)):[]}function j(U){const k=U.properties?U.properties.filter(F=>F.key===r.Engine):[];return k.length>0&&k[0].value||""}function $(U){const k=U.properties?U.properties.filter(N=>N.key===r.LocalizedLanguages):[],F=k.length>0&&k[0].value||"";return F?F.split(","):[]}function K(U){return U.indexOf("preview")!==-1}function B(U){const k=U.properties?U.properties.find(F=>F.key===r.WebExtension):void 0;return!!k&&k.value==="true"}function z(U){return U.files.some(k=>k.assetType.startsWith("Microsoft.VisualStudio.Code.WebResources"))?b.joinPath(C.URI.parse(U.assetUri),"Microsoft.VisualStudio.Code.WebResources","extension"):void 0}function G(U,k,F,N,q){const W={manifest:T(k,t.Manifest),readme:T(k,t.Details),changelog:T(k,t.Changelog),license:T(k,t.License),repository:m(k),download:w(k),icon:d(k),coreTranslations:l(k)};return{identifier:{id:L.getGalleryExtensionId(U.publisher.publisherName,U.extensionName),uuid:U.extensionId},name:U.extensionName,version:k.version,date:k.lastUpdated,displayName:U.displayName,publisherId:U.publisher.publisherId,publisher:U.publisher.publisherName,publisherDisplayName:U.publisher.displayName,description:U.shortDescription||"",installCount:u(U.statistics,"install"),rating:u(U.statistics,"averagerating"),ratingCount:u(U.statistics,"ratingcount"),assetUri:C.URI.parse(k.assetUri),webResource:z(k),assetTypes:k.files.map(({assetType:Q})=>Q),assets:W,properties:{dependencies:_(k,r.Dependency),extensionPack:_(k,r.ExtensionPack),engine:j(k),localizedLanguages:$(k),webExtension:B(k)},telemetryData:{index:(N.pageNumber-1)*N.pageSize+F,querySource:q},preview:K(U.flags)}}let V=class{constructor(k,F,N,q,W,Q,X){this.requestService=k,this.logService=F,this.environmentService=N,this.telemetryService=q,this.fileService=W,this.productService=Q;const ie=Q.extensionsGallery;this.extensionsGalleryUrl=ie&&ie.serviceUrl,this.extensionsControlUrl=ie&&ie.controlUrl,this.commonHeadersPromise=M(Q.version,this.environmentService,this.fileService,X)}api(k=""){return`${this.extensionsGalleryUrl}${k}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(k,F){const N=[];let{total:q,firstPage:W,getPage:Q}=await this.query({names:k,pageSize:k.length},F);N.push(...W);for(let X=1;N.length<q&&(W=await Q(X,F),W.length);X++)N.push(...W);return N}async getCompatibleExtension(k,F){const N=await this.getCompatibleExtensionByEngine(k,F);return(N==null?void 0:N.properties.webExtension)?N.webResource?N:null:N}async getCompatibleExtensionByEngine(k,F){const N=R.isIExtensionIdentifier(k)?null:k;if(N&&N.properties.engine&&p.isEngineValid(N.properties.engine,this.productService.version,this.productService.date))return N;const{id:q,uuid:W}=N?N.identifier:k;let Q=new c().withFlags(g.IncludeAssetUri,g.IncludeStatistics,g.IncludeFiles,g.IncludeVersionProperties).withPage(1,1).withFilter(s.Target,"Microsoft.VisualStudio.Code");W?Q=Q.withFilter(s.ExtensionId,W):Q=Q.withFilter(s.ExtensionName,q);const{galleryExtensions:X}=await this.queryGallery(Q,n.CancellationToken.None),[ie]=X;if(!ie||!ie.versions.length)return null;if(F){const ce=ie.versions.filter(le=>le.version===F)[0];if(ce){const le=G(ie,ce,0,Q);if(le.properties.engine&&p.isEngineValid(le.properties.engine,this.productService.version,this.productService.date))return le}return null}const ne=await this.getLastValidExtensionVersion(ie,ie.versions);return ne?G(ie,ne,0,Q):null}async query(k,F){const N=n.CancellationToken.isCancellationToken(k)?{}:k,q=n.CancellationToken.isCancellationToken(k)?k:F;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let W=N.text||"";const Q=A.getOrDefault(N,ve=>ve.pageSize,50);let X=new c().withFlags(g.IncludeLatestVersionOnly,g.IncludeAssetUri,g.IncludeStatistics,g.IncludeFiles,g.IncludeVersionProperties).withPage(1,Q).withFilter(s.Target,"Microsoft.VisualStudio.Code");W?(W=W.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ve,pe,Ce)=>(X=X.withFilter(s.Category,Ce||pe),"")),W=W.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ve,pe,Ce)=>(X=X.withFilter(s.Tag,Ce||pe),"")),W=W.replace(/\bfeatured(\s+|\b|$)/g,()=>(X=X.withFilter(s.Featured),"")),W=W.trim(),W&&(W=W.length<200?W:W.substring(0,200),X=X.withFilter(s.SearchText,W)),X=X.withSortBy(0)):N.ids?X=X.withFilter(s.ExtensionId,...N.ids):N.names?X=X.withFilter(s.ExtensionName,...N.names):X=X.withSortBy(4),typeof N.sortBy=="number"&&(X=X.withSortBy(N.sortBy)),typeof N.sortOrder=="number"&&(X=X.withSortOrder(N.sortOrder));const{galleryExtensions:ie,total:ne}=await this.queryGallery(X,q),ce=ie.map((ve,pe)=>G(ve,ve.versions[0],pe,X,N.source)),le=async(ve,pe)=>{if(pe.isCancellationRequested)throw y.canceled();const Ce=X.withPage(ve+1),{galleryExtensions:Ae}=await this.queryGallery(Ce,pe);return Ae.map((_e,Oe)=>G(_e,_e.versions[0],Oe,Ce,N.source))};return{firstPage:ce,total:ne,pageSize:X.pageSize,getPage:le}}async queryGallery(k,F){if(!this.isEnabled())throw new Error("No extension gallery service configured.");k=k.withFlags(k.flags,g.ExcludeNonValidated).withFilter(s.ExcludeWithFlags,o(g.Unpublished));const N=await this.commonHeadersPromise,q=JSON.stringify(k.raw),W=Object.assign(Object.assign({},N),{"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(q.length)}),Q=new Date().getTime();let X,ie,ne=0;try{if(X=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:q,headers:W},F),X.res.statusCode&&X.res.statusCode>=400&&X.res.statusCode<500)return{galleryExtensions:[],total:ne};const ce=await P.asJson(X);if(ce){const le=ce.results[0],ve=le.extensions,pe=le.resultMetadata&&le.resultMetadata.filter(Ce=>Ce.metadataType==="ResultCount")[0];return ne=pe&&pe.metadataItems.filter(Ce=>Ce.name==="TotalCount")[0].count||0,{galleryExtensions:ve,total:ne}}return{galleryExtensions:[],total:ne}}catch(ce){throw ie=ce,ce}finally{this.telemetryService.publicLog2("galleryService:query",Object.assign(Object.assign({},k.telemetryData),{requestBodySize:String(q.length),duration:new Date().getTime()-Q,success:!!X&&P.isSuccess(X),responseBodySize:X==null?void 0:X.res.headers["Content-Length"],statusCode:X?String(X.res.statusCode):void 0,errorCode:ie?y.isPromiseCanceledError(ie)?"canceled":y.getErrorMessage(ie).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ne)}))}}async reportStatistic(k,F,N,q){if(!this.isEnabled())return;const W=await this.commonHeadersPromise,Q=Object.assign(Object.assign({},W),{Accept:"*/*;api-version=4.0-preview.1"});try{await this.requestService.request({type:"POST",url:this.api(`/publishers/${k}/extensions/${F}/${N}/stats?statType=${q}`),headers:Q},n.CancellationToken.None)}catch(X){}}async download(k,F,N){this.logService.trace("ExtensionGalleryService#download",k.identifier.id);const q=L.getGalleryExtensionTelemetryData(k),W=new Date().getTime(),Q=ce=>this.telemetryService.publicLog("galleryService:downloadVSIX",Object.assign(Object.assign({},q),{duration:ce})),X=N===1?"install":N===2?"update":"",ie=X?{uri:`${k.assets.download.uri}&${X}=true`,fallbackUri:`${k.assets.download.fallbackUri}?${X}=true`}:k.assets.download,ne=await this.getAsset(ie);await this.fileService.writeFile(F,ne.stream),Q(new Date().getTime()-W)}async getReadme(k,F){if(k.assets.readme){const N=await this.getAsset(k.assets.readme,{},F);return await P.asText(N)||""}return""}async getManifest(k,F){if(k.assets.manifest){const N=await this.getAsset(k.assets.manifest,{},F),q=await P.asText(N);return q?JSON.parse(q):null}return null}async getCoreTranslation(k,F){const N=k.assets.coreTranslations.filter(q=>q[0]===F.toUpperCase())[0];if(N){const q=await this.getAsset(N[1]),W=await P.asText(q);return W?JSON.parse(W):null}return null}async getChangelog(k,F){if(k.assets.changelog){const N=await this.getAsset(k.assets.changelog,{},F);return await P.asText(N)||""}return""}async getAllVersions(k,F){let N=new c().withFlags(g.IncludeVersions,g.IncludeFiles,g.IncludeVersionProperties).withPage(1,1).withFilter(s.Target,"Microsoft.VisualStudio.Code");k.identifier.uuid?N=N.withFilter(s.ExtensionId,k.identifier.uuid):N=N.withFilter(s.ExtensionName,k.identifier.id);const q=[],{galleryExtensions:W}=await this.queryGallery(N,n.CancellationToken.None);return W.length&&(F?await Promise.all(W[0].versions.map(async Q=>{let X;try{X=await this.getEngine(Q)}catch(ie){}X&&p.isEngineValid(X,this.productService.version,this.productService.date)&&q.push({version:Q.version,date:Q.lastUpdated})})):q.push(...W[0].versions.map(Q=>({version:Q.version,date:Q.lastUpdated})))),q}async getAsset(k,F={},N=n.CancellationToken.None){const q=await this.commonHeadersPromise,W={type:"GET"},Q=Object.assign(Object.assign({},q),F.headers||{});F=Object.assign(Object.assign(Object.assign({},F),W),{headers:Q});const X=k.uri,ie=k.fallbackUri,ne=Object.assign(Object.assign({},F),{url:X});try{const ce=await this.requestService.request(ne,N);if(ce.res.statusCode===200)return ce;const le=await P.asText(ce);throw new Error(`Expected 200, got back ${ce.res.statusCode} instead.

${le}`)}catch(ce){if(y.isPromiseCanceledError(ce))throw ce;const le=y.getErrorMessage(ce);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:X,message:le});const ve=Object.assign(Object.assign({},F),{url:ie});return this.requestService.request(ve,N)}}async getLastValidExtensionVersion(k,F){const N=this.getLastValidExtensionVersionFromProperties(k,F);return N||this.getLastValidExtensionVersionRecursively(k,F)}getLastValidExtensionVersionFromProperties(k,F){for(const N of F){const q=j(N);if(!q)return null;if(p.isEngineValid(q,this.productService.version,this.productService.date))return N}return null}async getEngine(k){const F=j(k);if(F)return F;const N=T(k,t.Manifest);if(!N)throw new Error("Manifest was not found");const q={"Accept-Encoding":"gzip"},W=await this.getAsset(N,{headers:q}),Q=await P.asJson(W);if(Q)return Q.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively(k,F){if(!F.length)return null;const N=F[0],q=await this.getEngine(N);return p.isEngineValid(q,this.productService.version,this.productService.date)?Object.assign(Object.assign({},N),{properties:[...N.properties||[],{key:r.Engine,value:q}]}):this.getLastValidExtensionVersionRecursively(k,F.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const k=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},n.CancellationToken.None);if(k.res.statusCode!==200)throw new Error("Could not get extensions report.");const F=await P.asJson(k),N=new Map;if(F)for(const q of F.malicious){const W=N.get(q)||{id:{id:q},malicious:!0,slow:!1};W.malicious=!0,N.set(q,W)}return[...N.values()]}};V=de([Y(0,P.IRequestService),Y(1,v.ILogService),Y(2,S.IEnvironmentService),Y(3,O.ITelemetryService),Y(4,h.IFileService),Y(5,f.IProductService),Y(6,E.optional(I.IStorageService))],V),e.ExtensionGalleryService=V;async function M(U,k,F,N){const q={"X-Market-Client-Id":`VSCode ${U}`,"User-Agent":`VSCode ${U}`},W=await D.getServiceMachineId(k,F,N);return q["X-Market-User-Id"]=W,q}e.resolveMarketplaceHeaders=M}),define(Z[174],ee([0,1,5,7,27,9,34,10,6,19,28,63,39,18,167,8,24,73,110,20,3,58]),function(H,e,y,R,L,A,O,P,p,S,n,v,h,C,f,I,D,E,b,g,o,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const t="extensionTips/promptedExecutableTips",r="extensionTips/lastPromptedMediumImpExeTime";let i=class extends f.ExtensionTipsService{constructor(c,u,l,m,w,d,T,_,j,$){super(T,_,j,$);this.environmentService=c,this.telemetryService=u,this.extensionManagementService=l,this.storageService=m,this.nativeHostService=w,this.extensionRecommendationNotificationService=d,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,_.exeBasedExtensionTips&&v.forEach(_.exeBasedExtensionTips,({key:K,value:B})=>{const z=[],G=[],V=[];v.forEach(B.recommendations,({key:M,value:U})=>{U.important?B.important?z.push({extensionId:M,extensionName:U.name,isExtensionPack:!!U.isExtensionPack}):G.push({extensionId:M,extensionName:U.name,isExtensionPack:!!U.isExtensionPack}):V.push({extensionId:M,extensionName:U.name,isExtensionPack:!!U.isExtensionPack})}),z.length&&this.highImportanceExecutableTips.set(K,{exeFriendlyName:B.friendlyName,windowsPath:B.windowsPath,recommendations:z}),G.length&&this.mediumImportanceExecutableTips.set(K,{exeFriendlyName:B.friendlyName,windowsPath:B.windowsPath,recommendations:G}),V.length&&this.allOtherExecutableTips.set(K,{exeFriendlyName:B.friendlyName,windowsPath:B.windowsPath,recommendations:V})}),I.timeout(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const c=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),u=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...c,...u]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const c=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),u=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),l=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(c,l),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(u,l)}groupImportantTipsByExe(c,u){const l=new Map;c.forEach(_=>l.set(_.extensionId.toLowerCase(),_));const{installed:m,uninstalled:w}=this.groupByInstalled([...l.keys()],u);for(const _ of m){const j=l.get(_);j&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:_,exeName:R.basename(j.windowsPath)})}for(const _ of w){const j=l.get(_);j&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:_,exeName:R.basename(j.windowsPath)})}const d=this.getPromptedExecutableTips(),T=new Map;for(const _ of w){const j=l.get(_);if(j&&(!d[j.exeName]||!d[j.exeName].includes(j.extensionId))){let $=T.get(j.exeName);$||($=[],T.set(j.exeName,$)),$.push(j)}}return T}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[c,u]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(u).then(l=>{switch(l){case"reacted":this.addToRecommendedExecutables(u[0].exeName,u);break;case"ignored":this.highImportanceTipsByExe.delete(c);break;case"incompatibleWindow":const m=o.Event.once(o.Event.latch(o.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(m(()=>this.promptHighImportanceExeBasedTip()));break;case"toomany":const w=this._register(I.disposableTimeout(()=>{w.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3));break}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const c=this.getLastPromptedMediumExeTime(),u=Date.now()-c,l=7*24*60*60*1e3;if(u<l){const d=this._register(I.disposableTimeout(()=>{d.dispose(),this.promptMediumImportanceExeBasedTip()},l-u));return}const[m,w]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(w).then(d=>{switch(d){case"reacted":this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(m),this.addToRecommendedExecutables(w[0].exeName,w);const T=this._register(I.disposableTimeout(()=>{T.dispose(),this.promptMediumImportanceExeBasedTip()},l));break;case"ignored":this.mediumImportanceTipsByExe.delete(m),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":const _=o.Event.once(o.Event.latch(o.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(_(()=>this.promptMediumImportanceExeBasedTip()));break;case"toomany":const j=this._register(I.disposableTimeout(()=>{j.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3));break}})}promptExeRecommendations(c){const u=c.map(({extensionId:m})=>m.toLowerCase()),l=b.localize(0,null,c[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(u,l,`@exe:"${c[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let c=this.storageService.getNumber(r,0);return c||(c=Date.now(),this.updateLastPromptedMediumExeTime(c)),c}updateLastPromptedMediumExeTime(c){this.storageService.store(r,c,0,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(t,0,"{}"))}addToRecommendedExecutables(c,u){const l=this.getPromptedExecutableTips();l[c]=u.map(({extensionId:m})=>m.toLowerCase()),this.storageService.store(t,JSON.stringify(l),0,0)}groupByInstalled(c,u){const l=[],m=[],w=u.reduce((d,T)=>(d.add(T.identifier.id.toLowerCase()),d),new Set);return c.forEach(d=>{w.has(d.toLowerCase())?l.push(d):m.push(d)}),{installed:l,uninstalled:m}}async getValidExecutableBasedExtensionTips(c){const u=[],l=new Map;for(const m of c.keys()){const w=c.get(m);if(!w||!S.isNonEmptyArray(w.recommendations))continue;const d=[];p.isWindows?w.windowsPath&&d.push(w.windowsPath.replace("%USERPROFILE%",O.env.USERPROFILE).replace("%ProgramFiles(x86)%",O.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",O.env.ProgramFiles).replace("%APPDATA%",O.env.APPDATA).replace("%WINDIR%",O.env.WINDIR)):(d.push(R.join("/usr/local/bin",m)),d.push(R.join("/usr/bin",m)),d.push(R.join(this.environmentService.userHome.fsPath,m)));for(const T of d){let _=l.get(T);if(_===void 0&&(_=await this.fileService.exists(y.URI.file(T)),l.set(T,_)),_)for(const{extensionId:j,extensionName:$,isExtensionPack:K}of w.recommendations)u.push({extensionId:j,extensionName:$,isExtensionPack:K,exeName:m,exeFriendlyName:w.exeFriendlyName,windowsPath:w.windowsPath})}}return u}};i=de([Y(0,A.INativeEnvironmentService),Y(1,D.ITelemetryService),Y(2,n.IExtensionManagementService),Y(3,g.IStorageService),Y(4,s.INativeHostService),Y(5,E.IExtensionRecommendationNotificationService),Y(6,P.IFileService),Y(7,L.IProductService),Y(8,h.IRequestService),Y(9,C.ILogService)],i),e.ExtensionTipsService=i}),define(Z[80],ee([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class y{constructor(A){this.appender=A}listen(A,O){throw new Error(`Event not found: ${O}`)}call(A,O,{eventName:P,data:p}){return this.appender.log(P,p),Promise.resolve(null)}}e.TelemetryAppenderChannel=y;class R{constructor(A){this.channel=A}log(A,O){return this.channel.call("log",{eventName:A,data:O}).then(void 0,P=>`Failed to log telemetry: ${console.warn(P)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=R}),define(Z[81],ee([0,1,51,120,22,4,23,37,2,26,31]),function(H,e,y,R,L,A,O,P,p,S,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let v=class{constructor(f,I){this._configurationService=I,this._experimentProperties={},this._disposables=new p.DisposableStore,this._cleanupPatterns=[],this._appender=f.appender,this._commonProperties=f.commonProperties||Promise.resolve({}),this._piiPaths=f.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!f.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let D of this._piiPaths)this._cleanupPatterns.push(new RegExp(L.escapeRegExpCharacters(D),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(D=>{const E=/^[a-f0-9]+$/i.test(D["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!E})}))}setExperimentProperty(f,I){this._experimentProperties[f]=I}setEnabled(f){this._enabled=f}_updateUserOptIn(){var f;const I=(f=this._configurationService)===null||f===void 0?void 0:f.getValue(h);this._userOptIn=I?I.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const f=await this._commonProperties;let I=f.sessionID,D=f["common.instanceId"],E=f["common.machineId"],b=f["common.firstSessionDate"],g=f["common.msftInternal"];return{sessionId:I,instanceId:D,machineId:E,firstSessionDate:b,msftInternal:g}}dispose(){this._disposables.dispose()}publicLog(f,I,D){return this.isOptedIn?this._commonProperties.then(E=>{I=S.mixin(I,E),I=S.mixin(I,this._experimentProperties),I=S.cloneAndChange(I,b=>{if(typeof b=="string")return this._cleanupInfo(b,D)}),this._appender.log(f,I)},E=>{console.error(E)}):Promise.resolve(void 0)}publicLog2(f,I,D){return this.publicLog(f,I,D)}publicLogError(f,I){return this.sendErrorTelemetry?this.publicLog(f,I,!0):Promise.resolve(void 0)}publicLogError2(f,I){return this.publicLogError(f,I)}_cleanupInfo(f,I){let D=f;if(I){const E=[];for(let s of this._cleanupPatterns)for(;;){const t=s.exec(f);if(!t)break;E.push([t.index,s.lastIndex])}const b=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,g=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let o=0;for(D="";;){const s=g.exec(f);if(!s)break;!b.test(s[0])&&E.every(([t,r])=>s.index<t||s.index>=r)&&(D+=f.substring(o,s.index)+"<REDACTED: user-file-path>",o=g.lastIndex)}o<f.length&&(D+=f.substr(o))}for(let E of this._cleanupPatterns)D=D.replace(E,"");return D}};v.IDLE_START_EVENT_NAME="UserIdleStart",v.IDLE_STOP_EVENT_NAME="UserIdleStop",v=de([Y(1,A.optional(O.IConfigurationService))],v),e.TelemetryService=v;const h="telemetry";n.Registry.as(P.Extensions.Configuration).registerConfiguration({id:h,order:110,type:"object",title:R.localize(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:y.default.privacyStatementUrl?R.localize(2,null,y.default.privacyStatementUrl):R.localize(1,null),default:!0,restricted:!0,scope:1,tags:["usesOnlineServices"]}}})}),define(Z[59],ee([0,1,23,26,15,8]),function(H,e,y,R,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.configurationTelemetry=e.NullAppender=e.combinedAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=void 0,e.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(f,I){return Promise.resolve(void 0)}publicLog2(f,I){return this.publicLog(f,I)}publicLogError(f,I){return Promise.resolve(void 0)}publicLogError2(f,I){return this.publicLogError(f,I)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class O{async publicLog(I,D,E){}async publicLogError(I,D,E){}}e.NullEndpointTelemetryService=O;function P(...f){return{log:(I,D)=>f.forEach(E=>E.log(I,D)),flush:()=>A.Promises.settled(f.map(I=>I.flush()))}}e.combinedAppender=P,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function p(f,I){return I.onDidChangeConfiguration(D=>{D.source!==6&&f.publicLog2("updateConfiguration",{configurationSource:y.ConfigurationTargetToString(D.source),configurationKeys:h(D.sourceConfig)})})}e.configurationTelemetry=p;function S(f){const I=Object.create(null),D=Object.create(null),E=Object.create(null);v(f,E);for(let b in E){b=b.length>150?b.substr(b.length-149):b;const g=E[b];typeof g=="number"?D[b]=g:typeof g=="boolean"?D[b]=g?1:0:typeof g=="string"?I[b]=g.substring(0,1023):typeof g!="undefined"&&g!==null&&(I[b]=g)}return{properties:I,measurements:D}}e.validateTelemetryData=S;function n(f){if(!f)return"none";let I="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(E=>{f.indexOf(`${E}+`)===0&&(I=E)}),I}e.cleanRemoteAuthority=n;function v(f,I,D=0,E){if(!!f)for(let b of Object.getOwnPropertyNames(f)){const g=f[b],o=E?E+b:b;Array.isArray(g)?I[o]=R.safeStringify(g):g instanceof Date?I[o]=g.toISOString():L.isObject(g)?D<2?v(g,I,D+1,o+"."):I[o]=R.safeStringify(g):I[o]=g}}function h(f){if(!f)return[];const I=[];return C(I,"",f),I}function C(f,I,D){D&&typeof D=="object"&&!Array.isArray(D)?Object.keys(D).forEach(E=>C(f,I?`${I}.${E}`:E,D[E])):f.push(I)}}),define(Z[175],ee([0,1,2,9,18,59]),function(H,e,y,R,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let O=class extends y.Disposable{constructor(p,S){super();this.logger=this._register(p.createLogger(S.telemetryLogResource)),this.logger.info("The below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("===========================================================")}flush(){return Promise.resolve(void 0)}log(p,S){this.logger.trace(`telemetry/${p}`,A.validateTelemetryData(S))}};O=de([Y(0,L.ILoggerService),Y(1,R.IEnvironmentService)],O),e.TelemetryLogAppender=O}),define(Z[176],ee([0,1,11,26,59]),function(H,e,y,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function A(P){const p=await new Promise((n,v)=>{H(["applicationinsights"],n,v)});let S;return p.defaultClient?(S=new p.TelemetryClient(P),S.channel.setUseDiskRetryCaching(!0)):(p.setup(P).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),S=p.defaultClient),P.indexOf("AIF-")===0&&(S.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),S}class O{constructor(p,S,n){this._eventPrefix=p,this._defaultData=S,this._defaultData||(this._defaultData=Object.create(null)),typeof n=="function"?this._aiClient=n():this._aiClient=n,this._asyncAIClient=null}_withAIClient(p){if(!!this._aiClient){if(typeof this._aiClient!="string"){p(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=A(this._aiClient)),this._asyncAIClient.then(S=>{p(S)},S=>{y.onUnexpectedError(S),console.error(S)})}}log(p,S){!this._aiClient||(S=R.mixin(S,this._defaultData),S=L.validateTelemetryData(S),this._withAIClient(n=>n.trackEvent({name:this._eventPrefix+"/"+p,properties:S.properties,measurements:S.measurements})))}flush(){return this._aiClient?new Promise(p=>{this._withAIClient(S=>{S.flush({callback:()=>{this._aiClient=void 0,p(void 0)}})})}):Promise.resolve(void 0)}}e.AppInsightsAppender=O}),define(Z[177],ee([0,1,49,80,16,81,23,24]),function(H,e,y,R,L,A,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let p=class{constructor(n,v){this.configurationService=n,this.telemetryService=v,this.customTelemetryServices=new Map}async getCustomTelemetryService(n){if(!this.customTelemetryServices.has(n.id)){const{machineId:v,sessionId:h}=await this.telemetryService.getTelemetryInfo(),C=Object.create(null);C["common.vscodemachineid"]=v,C["common.vscodesessionid"]=h;const f=[n.id,JSON.stringify(C),n.aiKey],D=new y.Client(L.FileAccess.asFileUri("bootstrap-fork",H).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:f,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),E=new R.TelemetryAppenderClient(D);this.customTelemetryServices.set(n.id,new A.TelemetryService({appender:E,sendErrorTelemetry:n.sendErrorTelemetry},this.configurationService))}return this.customTelemetryServices.get(n.id)}async publicLog(n,v,h){await(await this.getCustomTelemetryService(n)).publicLog(v,h)}async publicLogError(n,v,h){await(await this.getCustomTelemetryService(n)).publicLogError(v,h)}};p=de([Y(0,O.IConfigurationService),Y(1,P.ITelemetryService)],p),e.CustomEndpointTelemetryService=p}),define(Z[82],ee([0,1,4]),function(H,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.HeartbeatConstants=e.IPtyService=e.ILocalTerminalService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var R;(function(h){h.Shell="terminal.integrated.shell.",h.ShellArgs="terminal.integrated.shellArgs.",h.DefaultProfile="terminal.integrated.defaultProfile.",h.Profiles="terminal.integrated.profiles."})(R=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var L;(function(h){h.ShellLinux="terminal.integrated.shell.linux",h.ShellMacOs="terminal.integrated.shell.osx",h.ShellWindows="terminal.integrated.shell.windows",h.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",h.AutomationShellLinux="terminal.integrated.automationShell.linux",h.AutomationShellMacOs="terminal.integrated.automationShell.osx",h.AutomationShellWindows="terminal.integrated.automationShell.windows",h.ShellArgsLinux="terminal.integrated.shellArgs.linux",h.ShellArgsMacOs="terminal.integrated.shellArgs.osx",h.ShellArgsWindows="terminal.integrated.shellArgs.windows",h.ProfilesWindows="terminal.integrated.profiles.windows",h.ProfilesMacOs="terminal.integrated.profiles.osx",h.ProfilesLinux="terminal.integrated.profiles.linux",h.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",h.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",h.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",h.UseWslProfiles="terminal.integrated.useWslProfiles",h.TabsEnabled="terminal.integrated.tabs.enabled",h.TabsHideCondition="terminal.integrated.tabs.hideCondition",h.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",h.TabsLocation="terminal.integrated.tabs.location",h.TabsFocusMode="terminal.integrated.tabs.focusMode",h.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",h.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",h.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",h.CopyOnSelection="terminal.integrated.copyOnSelection",h.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",h.FontFamily="terminal.integrated.fontFamily",h.FontSize="terminal.integrated.fontSize",h.LetterSpacing="terminal.integrated.letterSpacing",h.LineHeight="terminal.integrated.lineHeight",h.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",h.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",h.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",h.BellDuration="terminal.integrated.bellDuration",h.FontWeight="terminal.integrated.fontWeight",h.FontWeightBold="terminal.integrated.fontWeightBold",h.CursorBlinking="terminal.integrated.cursorBlinking",h.CursorStyle="terminal.integrated.cursorStyle",h.CursorWidth="terminal.integrated.cursorWidth",h.Scrollback="terminal.integrated.scrollback",h.DetectLocale="terminal.integrated.detectLocale",h.GpuAcceleration="terminal.integrated.gpuAcceleration",h.RightClickBehavior="terminal.integrated.rightClickBehavior",h.Cwd="terminal.integrated.cwd",h.ConfirmOnExit="terminal.integrated.confirmOnExit",h.EnableBell="terminal.integrated.enableBell",h.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",h.AllowChords="terminal.integrated.allowChords",h.AllowMnemonics="terminal.integrated.allowMnemonics",h.EnvMacOs="terminal.integrated.env.osx",h.EnvLinux="terminal.integrated.env.linux",h.EnvWindows="terminal.integrated.env.windows",h.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",h.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",h.ShowExitAlert="terminal.integrated.showExitAlert",h.SplitCwd="terminal.integrated.splitCwd",h.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",h.WordSeparators="terminal.integrated.wordSeparators",h.TitleMode="terminal.integrated.titleMode",h.EnableFileLinks="terminal.integrated.enableFileLinks",h.UnicodeVersion="terminal.integrated.unicodeVersion",h.ExperimentalLinkProvider="terminal.integrated.experimentalLinkProvider",h.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",h.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",h.LocalEchoStyle="terminal.integrated.localEchoStyle",h.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",h.InheritEnv="terminal.integrated.inheritEnv"})(L=e.TerminalSettingId||(e.TerminalSettingId={}));var A;(function(h){h.CommandPrompt="cmd",h.PowerShell="pwsh",h.Wsl="wsl",h.GitBash="gitbash"})(A=e.WindowsShellType||(e.WindowsShellType={}));var O;(function(h){h[h.Api=0]="Api",h[h.Process=1]="Process",h[h.Sequence=2]="Sequence"})(O=e.TitleEventSource||(e.TitleEventSource={}));var P;(function(h){h.LocalPty="localPty",h.PtyHost="ptyHost",h.Log="log",h.Heartbeat="heartbeat"})(P=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.ILocalTerminalService=y.createDecorator("localTerminalService"),e.IPtyService=y.createDecorator("ptyService");var p;(function(h){h[h.BeatInterval=5e3]="BeatInterval",h[h.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",h[h.SecondWaitMultiplier=1]="SecondWaitMultiplier",h[h.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(p=e.HeartbeatConstants||(e.HeartbeatConstants={}));var S;(function(h){h[h.GraceTime=6e4]="GraceTime",h[h.ShortGraceTime=6e3]="ShortGraceTime"})(S=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var n;(function(h){h[h.HighWatermarkChars=1e5]="HighWatermarkChars",h[h.LowWatermarkChars=5e3]="LowWatermarkChars",h[h.CharCountAckSize=5e3]="CharCountAckSize"})(n=e.FlowControlConstants||(e.FlowControlConstants={}));var v;(function(h){h.GitBash="Git Bash",h.Pwsh="PowerShell"})(v=e.ProfileSource||(e.ProfileSource={}))}),define(Z[178],ee([0,1,4]),function(H,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=y.createDecorator("localPtyService")}),define(Z[179],ee([0,1,35,7,34,17,15,26,6]),function(H,e,y,R,L,A,O,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getWindowsBuildNumber=void 0;function S(){const v=/(\d+)\.(\d+)\.(\d+)/g.exec(y.release());let h=0;return v&&v.length===4&&(h=parseInt(v[3])),h}e.getWindowsBuildNumber=S;async function n(v,h,C,f=L.env,I=A.exists){if(R.isAbsolute(v))return await I(v)?v:void 0;if(h===void 0&&(h=L.cwd()),R.dirname(v)!=="."){const g=R.join(h,v);return await I(g)?g:void 0}const E=P.getCaseInsensitive(f,"PATH");if(C===void 0&&O.isString(E)&&(C=E.split(R.delimiter)),C===void 0||C.length===0){const g=R.join(h,v);return await I(g)?g:void 0}for(let g of C){let o;if(R.isAbsolute(g)?o=R.join(g,v):o=R.join(h,g,v),await I(o))return o;if(p.isWindows){let s=o+".com";if(await I(s)||(s=o+".exe",await I(s)))return s}}const b=R.join(h,v);return await I(b)?b:void 0}e.findExecutable=n}),define(Z[180],ee([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var y;(function(R){R.DARK="dark",R.LIGHT="light",R.HIGH_CONTRAST="hc"})(y=e.ColorScheme||(e.ColorScheme={}))}),define(Z[83],ee([0,1,4,2,31,3,180,54]),function(H,e,y,R,L,A,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=y.createDecorator("themeService");var p;(function(D){function E(b){return b&&typeof b=="object"&&typeof b.id=="string"}D.isThemeColor=E})(p=e.ThemeColor||(e.ThemeColor={}));function S(D){return{id:D}}e.themeColorFromId=S;var n;(function(D){function E(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color=="undefined"||p.isThemeColor(r.color))}D.isThemeIcon=E;const b=new RegExp(`^\\$\\((${P.CSSIcon.iconNameExpression}(?:${P.CSSIcon.iconModifierExpression})?)\\)$`);function g(r){const i=b.exec(r);if(!i)return;let[,a]=i;return{id:a}}D.fromString=g;function o(r,i){let a=r.id;const c=a.lastIndexOf("~");return c!==-1&&(a=a.substring(0,c)),i&&(a=`${a}~${i}`),{id:a}}D.modify=o;function s(r,i){var a,c;return r.id===i.id&&((a=r.color)===null||a===void 0?void 0:a.id)===((c=i.color)===null||c===void 0?void 0:c.id)}D.isEqual=s;function t(r){return{id:r.id}}D.asThemeIcon=t,D.asClassNameArray=P.CSSIcon.asClassNameArray,D.asClassName=P.CSSIcon.asClassName,D.asCSSSelector=P.CSSIcon.asCSSSelector})(n=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=P.Codicon.file,e.FolderThemeIcon=P.Codicon.folder;function v(D){switch(D){case O.ColorScheme.DARK:return"vs-dark";case O.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=v,e.Extensions={ThemingContribution:"base.contributions.theming"};class h{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new A.Emitter}onColorThemeChange(E){return this.themingParticipants.push(E),this.onThemingParticipantAddedEmitter.fire(E),R.toDisposable(()=>{const b=this.themingParticipants.indexOf(E);this.themingParticipants.splice(b,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let C=new h;L.Registry.add(e.Extensions.ThemingContribution,C);function f(D){return C.onColorThemeChange(D)}e.registerThemingParticipant=f;class I extends R.Disposable{constructor(E){super();this.themeService=E,this.theme=E.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(b=>this.onThemeChange(b)))}onThemeChange(E){this.theme=E,this.updateStyles()}updateStyles(){}getColor(E,b){let g=this.theme.getColor(E);return g&&b&&(g=b(g,this.theme)),g?g.toString():null}}e.Themable=I}),define(Z[181],ee([0,1,37,121,31,54,83]),function(H,e,y,R,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=void 0;const P={args:{description:R.localize(0,null),type:"array",items:{type:"string"}},overrideName:{description:R.localize(1,null),type:"boolean"},icon:{description:R.localize(2,null),type:"string",enum:Array.from(A.iconRegistry.all,E=>E.id),markdownEnumDescriptions:Array.from(A.iconRegistry.all,E=>`$(${E.id})`)},color:{description:R.localize(3,null),type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},env:{markdownDescription:R.localize(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},p={type:"object",required:["path"],properties:Object.assign({path:{description:R.localize(5,null),type:["string","array"],items:{type:"string"}}},P)},S=R.localize(6,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),n=R.localize(7,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),v=R.localize(8,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),h={id:"terminal",order:100,title:R.localize(9,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:R.localize(10,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:R.localize(11,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:R.localize(12,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:R.localize(13,null),type:["string","null"],default:null,markdownDeprecationMessage:S},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:R.localize(14,null),type:["string","null"],default:null,markdownDeprecationMessage:n},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:R.localize(15,null),type:["string","null"],default:null,markdownDeprecationMessage:v},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:R.localize(16,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:S},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:R.localize(17,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:n},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:R.localize(18,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:R.localize(19,null)}},{type:"string",markdownDescription:R.localize(20,null)}],default:[],markdownDeprecationMessage:v},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:R.localize(21,null,"`source`","`path`","`args`."),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:Object.assign({source:{description:R.localize(22,null),enum:["PowerShell","Git Bash"]}},P)},{type:"null"},p]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:R.localize(23,null,"`path`","`args`."),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"null"},p]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:R.localize(24,null,"`path`","`args`."),type:"object",default:{bash:{path:"bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"null"},p]}},["terminal.integrated.useWslProfiles"]:{description:R.localize(25,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:R.localize(26,null),type:"boolean",default:!0}}};function C(){L.Registry.as(y.Extensions.Configuration).registerConfiguration(h),I()}e.registerTerminalPlatformConfiguration=C;let f;function I(E){const b=L.Registry.as(y.Extensions.Configuration);f&&b.deregisterConfigurations([f]);let g,o;if(E){const s=E.profiles.map(t=>({name:t.profileName,description:D(t)}));g=s.map(t=>t.name),o=s.map(t=>t.description)}f={id:"terminal",order:100,title:R.localize(27,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:R.localize(28,null,"`#terminal.integrated.shell.linux#`","`#terminal.integrated.shellArgs.linux#`"),type:["string","null"],default:null,enum:(E==null?void 0:E.os)===3?g:void 0,markdownEnumDescriptions:(E==null?void 0:E.os)===3?o:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:R.localize(29,null,"`#terminal.integrated.shell.osx#`","`#terminal.integrated.shellArgs.osx#`"),type:["string","null"],default:null,enum:(E==null?void 0:E.os)===2?g:void 0,markdownEnumDescriptions:(E==null?void 0:E.os)===2?o:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:R.localize(30,null,"`#terminal.integrated.shell.windows#`","`#terminal.integrated.shellArgs.windows#`"),type:["string","null"],default:null,enum:(E==null?void 0:E.os)===1?g:void 0,markdownEnumDescriptions:(E==null?void 0:E.os)===1?o:void 0}}},b.registerConfiguration(f)}e.registerTerminalDefaultProfileConfiguration=I;function D(E){let b=`$(${O.ThemeIcon.isThemeIcon(E.icon)?E.icon.id:E.icon?E.icon:A.Codicon.terminal.id}) ${E.profileName}
- path: ${E.path}`;return E.args&&(typeof E.args=="string"?b+=`
- args: "${E.args}"`:b+=`
- args: [${E.args.length===0?"":E.args.join("','")}]`),E.overrideName!==void 0&&(b+=`
- overrideName: ${E.overrideName}`),E.color&&(b+=`
- color: ${E.color}`),E.env&&(b+=`
- env: ${JSON.stringify(E.env)}`),b}});var et=this&&this.__asyncValues||function(H){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var e=H[Symbol.asyncIterator],y;return e?e.call(H):(H=typeof __values=="function"?__values(H):H[Symbol.iterator](),y={},R("next"),R("throw"),R("return"),y[Symbol.asyncIterator]=function(){return this},y);function R(A){y[A]=H[A]&&function(O){return new Promise(function(P,p){O=H[A](O),L(P,p,O.done,O.value)})}}function L(A,O,P,p){Promise.resolve(p).then(function(S){A({value:S,done:P})},O)}};define(Z[182],ee([0,1,7,96,179,43,17,54,6,83]),function(H,e,y,R,L,A,O,P,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let n;function v(s,t,r,i,a,c,u,l){return a=a||{existsFile:O.SymlinkSupport.existsFile,readFile:O.Promises.readFile},p.isWindows?h(r,a,c,i.getValue("terminal.integrated.useWslProfiles")!==!1,s&&typeof s=="object"?Object.assign({},s):i.getValue("terminal.integrated.profiles.windows"),typeof t=="string"?t:i.getValue("terminal.integrated.defaultProfile.windows"),l,u):b(a,c,r,s&&typeof s=="object"?Object.assign({},s):i.getValue(p.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof t=="string"?t:i.getValue(p.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),l,u)}e.detectAvailableProfiles=v;async function h(s,t,r,i,a,c,u,l){const m=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),w=`${process.env.windir}\\${m?"Sysnative":"System32"}`;let d=!1;L.getWindowsBuildNumber()>=16299&&(d=!0),await f(u);const T=new Map;s&&(T.set("PowerShell",{source:"PowerShell",icon:P.Codicon.terminalPowershell,isAutoDetected:!0}),T.set("Windows PowerShell",{path:`${w}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:P.Codicon.terminalPowershell,isAutoDetected:!0}),T.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),T.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),T.set("Command Prompt",{path:`${w}\\cmd.exe`,icon:P.Codicon.terminalCmd,isAutoDetected:!0})),g(a,T);const _=await C(T.entries(),c,t,r,l);if(s||!s&&i)try{const j=await D(`${w}\\${d?"wsl":"bash"}.exe`,c);for(const $ of j)(!a||!($.profileName in a))&&_.push($)}catch(j){r==null||r.info("WSL is not installed, so could not detect WSL profiles")}return _}async function C(s,t,r,i,a){const c=[];for(const[u,l]of s){if(l===null)continue;let m,w,d;if("source"in l){const j=n==null?void 0:n.get(l.source);if(!j)continue;m=j.paths,w=l.args||j.args,l.icon?d=l.icon:j.icon&&(d=j.icon)}else m=Array.isArray(l.path)?l.path:[l.path],w=p.isWindows||Array.isArray(l.args)?l.args:void 0,d=l.icon||void 0;const T=await(a==null?void 0:a(m))||m.slice(),_=await o(u,t,T,r,w,l.env,l.overrideName,l.isAutoDetected,i);_?(_.isAutoDetected=l.isAutoDetected,_.icon=d,_.color=l.color,c.push(_)):i==null||i.trace("profile not validated",u,m)}return c}async function f(s){n||(n=new Map,n.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`,`${process.env.AllUsersProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),n.set("PowerShell",{profileName:"PowerShell",paths:s||await I(),icon:S.ThemeIcon.asThemeIcon(P.Codicon.terminalPowershell)}))}async function I(){var s,t;const r=[];try{for(var i=et(R.enumeratePowerShellInstallations()),a;a=await i.next(),!a.done;){const c=a.value;r.push(c.exePath)}}catch(c){s={error:c}}finally{try{a&&!a.done&&(t=i.return)&&await t.call(i)}finally{if(s)throw s.error}}return r}async function D(s,t){const r=[],i=await new Promise((u,l)=>{A.exec("wsl.exe -l -q",{encoding:"utf16le"},(m,w)=>{if(m)return l("Problem occurred when getting wsl distros");u(w)})});if(!i)return[];const a=new RegExp(/[\r?\n]/),c=i.split(a).filter(u=>u.trim().length>0&&u!=="");for(const u of c){if(u===""||u.startsWith("docker-desktop"))continue;const l=`${u} (WSL)`,m={profileName:l,path:s,args:["-d",`${u}`],isDefault:l===t,icon:E(u)};r.push(m)}return r}function E(s){return s.includes("Ubuntu")?S.ThemeIcon.asThemeIcon(P.Codicon.terminalUbuntu):s.includes("Debian")?S.ThemeIcon.asThemeIcon(P.Codicon.terminalDebian):S.ThemeIcon.asThemeIcon(P.Codicon.terminalLinux)}async function b(s,t,r,i,a,c,u){const l=new Map;if(r){const m=(await s.readFile("/etc/shells")).toString(),w=c||m.split(`
`).filter(T=>T.trim().indexOf("#")!==0&&T.trim().length>0),d=new Map;for(const T of w){let _=y.basename(T),j=d.get(_)||0;j++,j>1&&(_=`${_} (${j})`),d.set(_,j),l.set(_,{path:T,isAutoDetected:!0})}}return g(i,l),await C(l.entries(),a,s,t,u)}function g(s,t){if(!!s)for(const[r,i]of Object.entries(s))i===null||!("path"in i)&&!("source"in i)?t.delete(r):t.set(r,i)}async function o(s,t,r,i,a,c,u,l,m){if(r.length===0)return Promise.resolve(void 0);const w=r.shift();if(w==="")return o(s,t,r,i,a,c,u,l);const d={profileName:s,path:w,args:a,env:c,overrideName:u,isAutoDetected:l,isDefault:s===t};if(y.basename(w)===w){const _=process.env.PATH?process.env.PATH.split(y.delimiter):void 0;return await L.findExecutable(w,void 0,_,void 0,i.existsFile)?d:o(s,t,r,i,a)}return await i.existsFile(y.normalize(w))?d:o(s,t,r,i,a,c,u,l)}}),define(Z[183],ee([0,1,2,18,82,49,16,36,3,77,24,182,23,181]),function(H,e,y,R,L,A,O,P,p,S,n,v,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var f;(function(b){b[b.MaxRestarts=5]="MaxRestarts"})(f||(f={}));let I=0,D=0,E=class extends y.Disposable{constructor(g,o,s,t){super();this._reconnectConstants=g,this._configurationService=o,this._logService=s,this._telemetryService=t,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new p.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new p.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new p.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new p.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new p.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new p.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessExit=this._register(new p.Emitter),this.onProcessExit=this._onProcessExit.event,this._onProcessReady=this._register(new p.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new p.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessTitleChanged=this._register(new p.Emitter),this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessShellTypeChanged=this._register(new p.Emitter),this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event,this._onProcessOverrideDimensions=this._register(new p.Emitter),this.onProcessOverrideDimensions=this._onProcessOverrideDimensions.event,this._onProcessResolvedShellLaunchConfig=this._register(new p.Emitter),this.onProcessResolvedShellLaunchConfig=this._onProcessResolvedShellLaunchConfig.event,this._onProcessOrphanQuestion=this._register(new p.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._pendingResolveVariablesRequests=new Map,C.registerTerminalPlatformConfiguration(),this._register(y.toDisposable(()=>this._disposePtyHost())),[this._client,this._proxy]=this._startPtyHost()}_startPtyHost(){const g=new A.Client(O.FileAccess.asFileUri("bootstrap-fork",H).fsPath,{serverName:"Pty Host",args:["--type=ptyHost"],env:{VSCODE_LAST_PTY_ID:I,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.GraceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.ShortGraceTime}});this._onPtyHostStart.fire(),P.ProxyChannel.toService(g.getChannel(L.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(g.onDidProcessExit(r=>{this._telemetryService.publicLog("ptyHost/exit"),this._onPtyHostExit.fire(r.code),this._isDisposed||(this._restartCount<=f.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${r.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${r.code}, giving up`))}));const s=g.getChannel(L.TerminalIpcChannels.Log);S.LogLevelChannelClient.setLevel(s,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{S.LogLevelChannelClient.setLevel(s,this._logService.getLevel())}));const t=P.ProxyChannel.toService(g.getChannel(L.TerminalIpcChannels.PtyHost));return this._register(t.onProcessData(r=>this._onProcessData.fire(r))),this._register(t.onProcessExit(r=>this._onProcessExit.fire(r))),this._register(t.onProcessReady(r=>this._onProcessReady.fire(r))),this._register(t.onProcessTitleChanged(r=>this._onProcessTitleChanged.fire(r))),this._register(t.onProcessShellTypeChanged(r=>this._onProcessShellTypeChanged.fire(r))),this._register(t.onProcessOverrideDimensions(r=>this._onProcessOverrideDimensions.fire(r))),this._register(t.onProcessResolvedShellLaunchConfig(r=>this._onProcessResolvedShellLaunchConfig.fire(r))),this._register(t.onProcessReplay(r=>this._onProcessReplay.fire(r))),this._register(t.onProcessOrphanQuestion(r=>this._onProcessOrphanQuestion.fire(r))),[g,t]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(g,o,s,t,r,i,a,c,u,l){const m=setTimeout(()=>this._handleUnresponsiveCreateProcess(),L.HeartbeatConstants.CreateProcessTimeout),w=await this._proxy.createProcess(g,o,s,t,r,i,a,c,u,l);return clearTimeout(m),I=Math.max(I,w),w}updateTitle(g,o,s){return this._proxy.updateTitle(g,o,s)}updateIcon(g,o,s){return this._proxy.updateIcon(g,o,s)}attachToProcess(g){return this._proxy.attachToProcess(g)}detachFromProcess(g){return this._proxy.detachFromProcess(g)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(g){return this._proxy.start(g)}shutdown(g,o){return this._proxy.shutdown(g,o)}input(g,o){return this._proxy.input(g,o)}processBinary(g,o){return this._proxy.processBinary(g,o)}resize(g,o,s){return this._proxy.resize(g,o,s)}acknowledgeDataEvent(g,o){return this._proxy.acknowledgeDataEvent(g,o)}getInitialCwd(g){return this._proxy.getInitialCwd(g)}getCwd(g){return this._proxy.getCwd(g)}getLatency(g){return this._proxy.getLatency(g)}orphanQuestionReply(g){return this._proxy.orphanQuestionReply(g)}getDefaultSystemShell(g){return this._proxy.getDefaultSystemShell(g)}async getProfiles(g,o,s=!1){return v.detectAvailableProfiles(g,o,s,this._configurationService,void 0,this._logService,this._resolveVariables.bind(this))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(g){return this._proxy.getWslPath(g)}setTerminalLayoutInfo(g){return this._proxy.setTerminalLayoutInfo(g)}async getTerminalLayoutInfo(g){return await this._proxy.getTerminalLayoutInfo(g)}async restartPtyHost(){this._telemetryService.publicLog("ptyHost/restart"),this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll&&this._proxy.shutdownAll(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),L.HeartbeatConstants.BeatInterval*L.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._telemetryService.publicLog("ptyHost/responsive"),this._isResponsive=!0),this._onPtyHostResponsive.fire()}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${L.HeartbeatConstants.BeatInterval*L.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),L.HeartbeatConstants.BeatInterval*L.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(L.HeartbeatConstants.BeatInterval*L.HeartbeatConstants.FirstWaitMultiplier+L.HeartbeatConstants.BeatInterval*L.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._telemetryService.publicLog("ptyHost/unresponsive"),this._isResponsive=!1),this._onPtyHostUnresponsive.fire()}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${L.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._telemetryService.publicLog("ptyHost/responsive"),this._onPtyHostUnresponsive.fire()}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(g){return new Promise(o=>{const s=++D;this._pendingResolveVariablesRequests.set(s,o),this._onPtyHostRequestResolveVariables.fire({id:s,originalText:g})})}async acceptPtyHostResolvedVariables(g,o){const s=this._pendingResolveVariablesRequests.get(g);s?(s(o),this._pendingResolveVariablesRequests.delete(g)):this._logService.warn(`Resolved variables received without matching request ${g}`)}};E=de([Y(1,h.IConfigurationService),Y(2,R.ILogService),Y(3,n.ITelemetryService)],E),e.PtyHostService=E}),define(Z[52],ee([0,1,40]),function(H,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function R(O,P,p,S){const n=y.setProperty(O,P,p,S)[0];return n&&(O=O.substring(0,n.offset)+n.content+O.substring(n.offset+n.length)),O}e.edit=R;function L(O,P,p){let S=p;for(;S>=0;){if(O.charAt(S)===P.charAt(P.length-1)&&P.length===1)return S+1;if(S--,P.length===2&&S>=0&&O.charAt(S)===P.charAt(0))return S+2}return 0}e.getLineStartOffset=L;function A(O,P,p){let S=p;for(;S>=0;)if(O.charAt(S)===P.charAt(P.length-1)&&P.length===1||(S++,P.length===2&&S>=0&&O.charAt(S)===P.charAt(1)))return S;return O.length-1}e.getLineEndOffset=A}),define(Z[184],ee([0,1,26,57]),function(H,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function L(v,h,C,f,I){var D,E;const b=[],g=[],o=[];if(!h){const j=v.filter(({identifier:$})=>I.every(K=>K.toLowerCase()!==$.id.toLowerCase()));return{added:b,removed:g,updated:o,remote:j.length>0?j:null}}v=v.map(S),h=h.map(S),C=C?C.map(S):null;const s=new Map,t=j=>{j.uuid&&s.set(j.id.toLowerCase(),j.uuid)};v.forEach(({identifier:j})=>t(j)),h.forEach(({identifier:j})=>t(j)),C&&C.forEach(({identifier:j})=>t(j));const r=j=>{const $=j.identifier.uuid||s.get(j.identifier.id.toLowerCase());return $?`uuid:${$}`:`id:${j.identifier.id.toLowerCase()}`},i=(j,$)=>(j.set(r($),$),j),a=v.reduce(i,new Map),c=h.reduce(i,new Map),u=h.reduce((j,$)=>{const K=r($);$=y.deepClone($);const B=a.get(K);return B&&(B.installed&&($.installed=!0),$.version||($.version=B.version)),i(j,$)},new Map),l=C?C.reduce(i,new Map):null,m=f.reduce(i,new Map),w=I.reduce((j,$)=>{const K=s.get($.toLowerCase());return j.add(K?`uuid:${K}`:`id:${$.toLowerCase()}`)},new Set),d=A(a,c,w);if(d.added.size>0||d.removed.size>0||d.updated.size>0){const j=A(l,a,w),$=A(l,c,w),K=(B,z)=>{const G=a.get(B);if(G){const V=c.get(B);return Object.assign(Object.assign({},z?V:G),{version:(V.version&&R.gt(V.version,G.version),G.version),state:O(G,V,l==null?void 0:l.get(B))})}};for(const B of $.removed.values()){const z=a.get(B);z&&g.push(z.identifier)}for(const B of $.added.values())if(j.added.has(B)){if(d.updated.has(B)){const z=K(B,!0);z&&(o.push(n(z,B)),u.set(B,z))}}else{const z=c.get(B);z.installed&&b.push(n(z,B))}for(const B of $.updated.values()){const z=K(B,!0);z&&(o.push(n(z,B)),u.set(B,z))}for(const B of j.added.values())$.added.has(B)||u.set(B,a.get(B));for(const B of j.updated.values())if(!$.removed.has(B)&&!$.updated.has(B)){const z=K(B,!1);z&&(((D=u.get(B))===null||D===void 0?void 0:D.installed)&&(z.installed=!0),u.set(B,z))}for(const B of j.removed.values())!m.has(B)&&!$.updated.has(B)&&((E=l==null?void 0:l.get(B))===null||E===void 0?void 0:E.installed)&&u.delete(B)}const T=[],_=A(c,u,new Set,{checkInstalledProperty:!0,checkVersionProperty:!0});return(_.added.size>0||_.updated.size>0||_.removed.size>0)&&u.forEach((j,$)=>T.push(n(j,$))),{added:b,removed:g,updated:o,remote:T.length?T:null}}e.merge=L;function A(v,h,C,{checkInstalledProperty:f,checkVersionProperty:I}={checkInstalledProperty:!1,checkVersionProperty:!1}){const D=v?[...v.keys()].filter(s=>!C.has(s)):[],E=[...h.keys()].filter(s=>!C.has(s)),b=E.filter(s=>D.indexOf(s)===-1).reduce((s,t)=>(s.add(t),s),new Set),g=D.filter(s=>E.indexOf(s)===-1).reduce((s,t)=>(s.add(t),s),new Set),o=new Set;for(const s of D){if(g.has(s))continue;const t=v.get(s),r=h.get(s);(!r||t.disabled!==r.disabled||!p(t.state,r.state)||I&&t.version!==r.version||f&&t.installed!==r.installed)&&o.add(s)}return{added:b,removed:g,updated:o}}function O(v,h,C){const f=v.state,I=h.state,D=C==null?void 0:C.state;if(!h.version||f&&R.gt(v.version,h.version))return f;if(I&&R.gt(h.version,v.version)||!f)return I;if(!I)return f;const E=y.deepClone(f),b=D?P(D,I):{added:Object.keys(I).reduce((o,s)=>(o.add(s),o),new Set),removed:new Set,updated:new Set},g=D?P(D,f):{added:Object.keys(f).reduce((o,s)=>(o.add(s),o),new Set),removed:new Set,updated:new Set};for(const o of[...b.added.values(),...b.updated.values()])E[o]=I[o];for(const o of b.removed.values())g.updated.has(o)||delete E[o];return E}function P(v,h){const C=Object.keys(v),f=Object.keys(h),I=f.filter(b=>C.indexOf(b)===-1).reduce((b,g)=>(b.add(g),b),new Set),D=C.filter(b=>f.indexOf(b)===-1).reduce((b,g)=>(b.add(g),b),new Set),E=new Set;for(const b of C){if(D.has(b))continue;const g=v[b],o=h[b];y.equals(g,o)||E.add(b)}return{added:I,removed:D,updated:E}}function p(v={},h={}){const{added:C,removed:f,updated:I}=P(v,h);return C.size===0&&f.size===0&&I.size===0}function S(v){return Object.assign(Object.assign({},v),{disabled:!!v.disabled,installed:!!v.installed})}function n(v,h){const C={identifier:{id:v.identifier.id,uuid:h.startsWith("uuid:")?h.substring("uuid:".length):void 0}};return v.version&&(C.version=v.version),v.disabled&&(C.disabled=!0),v.installed&&(C.installed=!0),v.state&&(C.state=v.state),C}}),define(Z[84],ee([0,1,19,3,2,33,4,27,20]),function(H,e,y,R,L,A,O,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsStorageSyncService=e.IExtensionsStorageSyncService=void 0,e.IExtensionsStorageSyncService=O.createDecorator("IExtensionsStorageSyncService");const S=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let n=class Ze extends L.Disposable{constructor(h,C){super();this.storageService=h,this.productService=C,this._onDidChangeExtensionsStorage=this._register(new R.Emitter),this.onDidChangeExtensionsStorage=this._onDidChangeExtensionsStorage.event,this.extensionsWithKeysForSync=new Set,this.initialize(),this._register(this.storageService.onDidChangeValue(f=>this.onDidChangeStorageValue(f)))}static toKey(h){return`extensionKeys/${A.adoptToGalleryExtensionId(h.id)}@${h.version}`}static fromKey(h){const C=S.exec(h);if(C&&C[1])return{id:C[1],version:C[2]}}initialize(){const h=this.storageService.keys(0,1);for(const C of h){const f=Ze.fromKey(C);f&&this.extensionsWithKeysForSync.add(f.id.toLowerCase())}}onDidChangeStorageValue(h){if(h.scope!==0)return;if(this.extensionsWithKeysForSync.has(h.key.toLowerCase())){this._onDidChangeExtensionsStorage.fire();return}const C=Ze.fromKey(h.key);if(C){this.extensionsWithKeysForSync.add(C.id.toLowerCase()),this._onDidChangeExtensionsStorage.fire();return}}setKeysForSync(h,C){this.storageService.store(Ze.toKey(h),JSON.stringify(C),0,1)}getKeysForSync(h){var C;const f=(C=this.productService.extensionSyncedKeys)===null||C===void 0?void 0:C[h.id.toLowerCase()],I=this.storageService.get(Ze.toKey(h),0),D=I?JSON.parse(I):void 0;return D&&f?y.distinct([...D,...f]):D||f}};n=de([Y(0,p.IStorageService),Y(1,P.IProductService)],n),e.ExtensionsStorageSyncService=n}),define(Z[85],ee([0,1,19,23,4]),function(H,e,y,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=L.createDecorator("IIgnoredExtensionsManagementService");let A=class{constructor(P){this.configurationService=P}hasToNeverSyncExtension(P){return this.getConfiguredIgnoredExtensions().includes(P.toLowerCase())}hasToAlwaysSyncExtension(P){return this.getConfiguredIgnoredExtensions().includes(`-${P.toLowerCase()}`)}updateIgnoredExtensions(P,p){let S=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(n=>n.toLowerCase());return S=S.filter(n=>n!==P&&n!==`-${P}`),p&&S.push(P.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",S.length?S:void 0,1)}updateSynchronizedExtensions(P,p){let S=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(n=>n.toLowerCase());return S=S.filter(n=>n!==P&&n!==`-${P}`),p&&S.push(`-${P.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",S.length?S:void 0,1)}getIgnoredExtensions(P){const p=P.filter(h=>h.isMachineScoped).map(h=>h.identifier.id.toLowerCase()),S=this.getConfiguredIgnoredExtensions().map(h=>h.toLowerCase()),n=[],v=[];if(Array.isArray(S))for(const h of S)h.startsWith("-")?v.push(h.substring(1)):n.push(h);return y.distinct([...p,...n].filter(h=>v.indexOf(h)===-1))}getConfiguredIgnoredExtensions(){let P=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return P!==void 0||(P=this.configurationService.inspect("sync.ignoredExtensions").userValue,P!==void 0)?P:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(p=>p.toLowerCase())}};A=de([Y(0,R.IConfigurationService)],A),e.IgnoredExtensionsManagementService=A}),define(Z[185],ee([0,1,26,32,19,142,52]),function(H,e,y,R,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function P(o){return R.parse(o)||[]}e.parseKeybindings=P;async function p(o,s,t,r,i){const a=P(o),c=P(s),u=t?P(t):null,l=[...a,...c,...u||[]].map(G=>G.key),m=await i.resolveUserBindings(l);let w=n(a,c,u,m);if(!w.hasLocalForwarded&&!w.hasRemoteForwarded)return{mergeContent:o,hasChanges:!1,hasConflicts:!1};if(!w.hasLocalForwarded&&w.hasRemoteForwarded)return{mergeContent:s,hasChanges:!0,hasConflicts:!1};if(w.hasLocalForwarded&&!w.hasRemoteForwarded)return{mergeContent:o,hasChanges:!0,hasConflicts:!1};const d=h(a),T=h(c),_=u?h(u):null,j=f(d,T,m),$=_?f(_,d,m):{added:[...d.keys()].reduce((G,V)=>(G.add(V),G),new Set),removed:new Set,updated:new Set},K=_?f(_,T,m):{added:[...T.keys()].reduce((G,V)=>(G.add(V),G),new Set),removed:new Set,updated:new Set},B=S(j,$,K);let z=o;for(const G of B.removed.values())B.conflicts.has(G)||(z=b(z,G,r));for(const G of B.added.values()){if(B.conflicts.has(G))continue;const V=T.get(G);if(V.some(M=>M.command!==`-${G}`&&w.conflicts.has(m[M.key]))){B.conflicts.add(G);continue}z=E(z,V,r)}for(const G of B.updated.values()){if(B.conflicts.has(G))continue;const V=T.get(G);if(V.some(M=>M.command!==`-${G}`&&w.conflicts.has(m[M.key]))){B.conflicts.add(G);continue}z=g(z,G,V,r)}return{mergeContent:z,hasChanges:!0,hasConflicts:B.conflicts.size>0}}e.merge=p;function S(o,s,t){const r=new Set,i=new Set,a=new Set,c=new Set;for(const u of s.removed.values())t.updated.has(u)&&c.add(u);for(const u of t.removed.values())c.has(u)||(s.updated.has(u)?c.add(u):i.add(u));for(const u of s.added.values())c.has(u)||t.added.has(u)&&o.updated.has(u)&&c.add(u);for(const u of t.added.values())c.has(u)||(s.added.has(u)?o.updated.has(u)&&c.add(u):r.add(u));for(const u of s.updated.values())c.has(u)||t.updated.has(u)&&o.updated.has(u)&&c.add(u);for(const u of t.updated.values())c.has(u)||(s.updated.has(u)?o.updated.has(u)&&c.add(u):a.add(u));return{added:r,removed:i,updated:a,conflicts:c}}function n(o,s,t,r){const i=new Set,a=v(o,r),c=v(s,r),u=t?v(t,r):null,l=C(a,c);if(l.added.size===0&&l.removed.size===0&&l.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:i,removed:i,updated:i,conflicts:i};const m=u?C(u,a):{added:[...a.keys()].reduce(($,K)=>($.add(K),$),new Set),removed:new Set,updated:new Set};if(m.added.size===0&&m.removed.size===0&&m.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:i,removed:i,updated:i,conflicts:i};const w=u?C(u,c):{added:[...c.keys()].reduce(($,K)=>($.add(K),$),new Set),removed:new Set,updated:new Set};if(w.added.size===0&&w.removed.size===0&&w.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:i,removed:i,updated:i,conflicts:i};const{added:d,removed:T,updated:_,conflicts:j}=S(l,m,w);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:d,removed:T,updated:_,conflicts:j}}function v(o,s){const t=new Map;for(const r of o){const i=s[r.key];let a=t.get(i);a||(a=[],t.set(i,a)),a.push(r)}return t}function h(o){const s=new Map;for(const t of o){const r=t.command[0]==="-"?t.command.substring(1):t.command;let i=s.get(r);i||(i=[],s.set(r,i)),i.push(t)}return s}function C(o,s){const t=[...o.keys()],r=[...s.keys()],i=r.filter(u=>t.indexOf(u)===-1).reduce((u,l)=>(u.add(l),u),new Set),a=t.filter(u=>r.indexOf(u)===-1).reduce((u,l)=>(u.add(l),u),new Set),c=new Set;for(const u of t){if(a.has(u))continue;const l=o.get(u).map(w=>Object.assign(Object.assign({},w),{key:u})),m=s.get(u).map(w=>Object.assign(Object.assign({},w),{key:u}));L.equals(l,m,(w,d)=>D(w,d))||c.add(u)}return{added:i,removed:a,updated:c}}function f(o,s,t){const r=[...o.keys()],i=[...s.keys()],a=i.filter(l=>r.indexOf(l)===-1).reduce((l,m)=>(l.add(m),l),new Set),c=r.filter(l=>i.indexOf(l)===-1).reduce((l,m)=>(l.add(m),l),new Set),u=new Set;for(const l of r){if(c.has(l))continue;const m=o.get(l).map(d=>Object.assign(Object.assign({},d),{key:t[d.key]})),w=s.get(l).map(d=>Object.assign(Object.assign({},d),{key:t[d.key]}));I(m,w)||u.add(l)}return{added:a,removed:c,updated:u}}function I(o,s){return!(!L.equals(o.filter(({command:t})=>t[0]!=="-"),s.filter(({command:t})=>t[0]!=="-"),(t,r)=>D(t,r))||!L.equals(o.filter(({command:t})=>t[0]==="-"),s.filter(({command:t})=>t[0]==="-"),(t,r)=>D(t,r)))}function D(o,s){if(o.command!==s.command||o.key!==s.key)return!1;const t=A.ContextKeyExpr.deserialize(o.when),r=A.ContextKeyExpr.deserialize(s.when);return!(t&&!r||!t&&r||t&&r&&!t.equals(r)||!y.equals(o.args,s.args))}function E(o,s,t){for(const r of s)o=O.edit(o,[-1],r,t);return o}function b(o,s,t){const r=P(o);for(let i=r.length-1;i>=0;i--)(r[i].command===s||r[i].command===`-${s}`)&&(o=O.edit(o,[i],void 0,t));return o}function g(o,s,t,r){const i=P(o),a=i.findIndex(c=>c.command===s||c.command===`-${s}`);for(let c=i.length-1;c>=0;c--)(i[c].command===s||i[c].command===`-${s}`)&&(o=O.edit(o,[c],void 0,r));for(let c=t.length-1;c>=0;c--)o=O.edit(o,[a],t[c],r);return o}}),define(Z[186],ee([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function y(A,O,P){const p={},S={},n=new Set;if(!O)return{local:{added:p,updated:S,removed:[...n.values()]},remote:{added:A,updated:{},removed:[]},conflicts:[]};const v=R(A,O);if(v.added.size===0&&v.removed.size===0&&v.updated.size===0)return{local:{added:p,updated:S,removed:[...n.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const h=R(P,A),C=R(P,O),f={},I={},D=new Set,E=new Set;for(const b of h.removed.values())C.updated.has(b)?p[b]=O[b]:D.add(b);for(const b of C.removed.values())E.has(b)||(h.updated.has(b)?E.add(b):n.add(b));for(const b of h.updated.values())E.has(b)||(C.updated.has(b)?v.updated.has(b)&&E.add(b):I[b]=A[b]);for(const b of C.updated.values())E.has(b)||(h.updated.has(b)?v.updated.has(b)&&E.add(b):A[b]!==void 0&&(S[b]=O[b]));for(const b of h.added.values())E.has(b)||(C.added.has(b)?v.updated.has(b)&&E.add(b):f[b]=A[b]);for(const b of C.added.values())E.has(b)||(h.added.has(b)?v.updated.has(b)&&E.add(b):p[b]=O[b]);return{local:{added:p,removed:[...n.values()],updated:S},remote:{added:f,removed:[...D.values()],updated:I},conflicts:[...E.values()]}}e.merge=y;function R(A,O){const P=A?Object.keys(A):[],p=O?Object.keys(O):[],S=p.filter(h=>P.indexOf(h)===-1).reduce((h,C)=>(h.add(C),h),new Set),n=P.filter(h=>p.indexOf(h)===-1).reduce((h,C)=>(h.add(C),h),new Set),v=new Set;for(const h of P){if(n.has(h))continue;const C=A[h],f=O[h];C!==f&&v.add(h)}return{added:S,removed:n,updated:v}}function L(A,O){const{added:P,removed:p,updated:S}=R(A,O);return P.size===0&&p.size===0&&S.size===0}e.areSame=L}),define(Z[21],ee([0,1,4,28,31,37,126,79,14,19,15]),function(H,e,y,R,L,A,O,P,p,S,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSyncResourceFromLocalPreview=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataAutoSyncEnablementService=e.IUserDataSyncService=e.IUserDataSyncResourceEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function v(){const c=L.Registry.as(A.Extensions.Configuration).getConfigurationProperties();return Object.keys(c).filter(u=>!!c[u].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=v;function h(){const c=L.Registry.as(A.Extensions.Configuration).getConfigurationProperties(),u=Object.keys(c).filter(w=>!!c[w].ignoreSync),l=Object.keys(c).filter(w=>c[w].scope===2||c[w].scope===6),m=v();return S.distinct([e.CONFIGURATION_SYNC_STORE_KEY,...u,...l,...m])}e.getDefaultIgnoredSettings=h;function C(){const c="vscode://schemas/ignoredSettings",u=L.Registry.as(A.Extensions.Configuration);u.registerConfiguration({id:"settingsSync",order:30,title:O.localize(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:O.localize(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:O.localize(2,null),items:[{type:"string",pattern:R.EXTENSION_IDENTIFIER_PATTERN,errorMessage:O.localize(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:O.localize(4,null),default:[],scope:1,$ref:c,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const l=L.Registry.as(P.Extensions.JSONContribution),m=()=>{const w=v(),d=h().filter($=>$!==e.CONFIGURATION_SYNC_STORE_KEY),T=Object.keys(A.allSettings.properties).filter($=>d.indexOf($)===-1),_=d.filter($=>w.indexOf($)===-1),j={items:{type:"string",enum:[...T,..._.map($=>`-${$}`)]}};l.registerSchema(c,j)};return u.onDidUpdateConfiguration(()=>m())}e.registerConfiguration=C;function f(c){return c&&n.isObject(c)&&n.isString(c.id)&&n.isArray(c.scopes)}e.isAuthenticationProvider=f;var I;(function(c){c.Settings="settings",c.Keybindings="keybindings",c.Snippets="snippets",c.Extensions="extensions",c.GlobalState="globalState"})(I=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","extensions","globalState"],e.IUserDataSyncStoreManagementService=y.createDecorator("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=y.createDecorator("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=y.createDecorator("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function D(c){const u={};return u[e.HEADER_EXECUTION_ID]=c,u}e.createSyncHeaders=D;var E;(function(c){c.Unauthorized="Unauthorized",c.Conflict="Conflict",c.Gone="Gone",c.PreconditionFailed="PreconditionFailed",c.TooLarge="TooLarge",c.UpgradeRequired="UpgradeRequired",c.PreconditionRequired="PreconditionRequired",c.TooManyRequests="RemoteTooManyRequests",c.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",c.RequestFailed="RequestFailed",c.RequestCanceled="RequestCanceled",c.RequestTimeout="RequestTimeout",c.NoRef="NoRef",c.TurnedOff="TurnedOff",c.SessionExpired="SessionExpired",c.ServiceChanged="ServiceChanged",c.DefaultServiceChanged="DefaultServiceChanged",c.LocalTooManyRequests="LocalTooManyRequests",c.LocalPreconditionFailed="LocalPreconditionFailed",c.LocalInvalidContent="LocalInvalidContent",c.LocalError="LocalError",c.IncompatibleLocalContent="IncompatibleLocalContent",c.IncompatibleRemoteContent="IncompatibleRemoteContent",c.UnresolvedConflicts="UnresolvedConflicts",c.Unknown="Unknown"})(E=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class b extends Error{constructor(u,l,m,w){super(u);this.code=l,this.resource=m,this.operationId=w,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=b;class g extends b{constructor(u,l,m,w){super(u,m,void 0,w);this.url=l}}e.UserDataSyncStoreError=g;class o extends b{constructor(u,l){super(u,l)}}e.UserDataAutoSyncError=o,function(c){function u(l){if(l instanceof c)return l;const m=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(l.name);if(m&&m[1]){const w=m[2]==="unknown"?void 0:m[2],d=m[3]==="unknown"?void 0:m[3];return new c(l.message,m[1],w,d)}return new c(l.message,E.Unknown)}c.toUserDataSyncError=u}(b=e.UserDataSyncError||(e.UserDataSyncError={}));var s;(function(c){c.Uninitialized="uninitialized",c.Idle="idle",c.Syncing="syncing",c.HasConflicts="hasConflicts"})(s=e.SyncStatus||(e.SyncStatus={}));var t;(function(c){c[c.None=0]="None",c[c.Added=1]="Added",c[c.Modified=2]="Modified",c[c.Deleted=3]="Deleted"})(t=e.Change||(e.Change={}));var r;(function(c){c.Preview="preview",c.Conflict="conflict",c.Accepted="accepted"})(r=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function i(c){return`sync.enable.${c}`}e.getEnablementKey=i,e.IUserDataSyncResourceEnablementService=y.createDecorator("IUserDataSyncResourceEnablementService"),e.IUserDataSyncService=y.createDecorator("IUserDataSyncService"),e.IUserDataAutoSyncEnablementService=y.createDecorator("IUserDataAutoSyncEnablementService"),e.IUserDataAutoSyncService=y.createDecorator("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=y.createDecorator("IUserDataSyncUtilService"),e.IUserDataSyncLogService=y.createDecorator("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview";function a(c,u){if(c.scheme!==e.USER_DATA_SYNC_SCHEME)return c=c.with({scheme:u.userDataSyncHome.scheme}),e.ALL_SYNC_RESOURCES.filter(l=>p.isEqualOrParent(c,p.joinPath(u.userDataSyncHome,l,e.PREVIEW_DIR_NAME)))[0]}e.getSyncResourceFromLocalPreview=a}),define(Z[46],ee([0,1,2,10,25,5,21,9,14,8,3,24,32,122,23,15,22,19,45,20,29]),function(H,e,y,R,L,A,O,P,p,S,n,v,h,C,f,I,D,E,b,g,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.isSyncData=void 0;function s(u){return!!(u&&u.version!==void 0&&typeof u.version=="number"&&u.content!==void 0&&typeof u.content=="string"&&(Object.keys(u).length===2||Object.keys(u).length===3&&u.machineId!==void 0&&typeof u.machineId=="string"))}e.isSyncData=s;function t(u,l,m){return m.joinPath(l.userDataSyncHome,u,`lastSync${u}.json`)}let r=class extends y.Disposable{constructor(l,m,w,d,T,_,j,$,K,B){super();this.resource=l,this.fileService=m,this.environmentService=w,this.userDataSyncStoreService=T,this.userDataSyncBackupStoreService=_,this.userDataSyncResourceEnablementService=j,this.telemetryService=$,this.logService=K,this.configurationService=B,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new n.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new n.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerScheduler=new S.RunOnceScheduler(()=>this.doTriggerLocalChange(),50),this._onDidChangeLocal=this._register(new n.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.syncResourceLogLabel=D.uppercaseFirstLetter(this.resource),this.extUri=this.fileService.hasCapability(w.userDataSyncHome,1024)?p.extUri:p.extUriIgnorePathCase,this.syncFolder=this.extUri.joinPath(w.userDataSyncHome,l),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,O.PREVIEW_DIR_NAME),this.lastSyncResource=t(l,w,this.extUri),this.currentMachineIdPromise=b.getServiceMachineId(w,m,d)}get status(){return this._status}get conflicts(){return this._conflicts}isEnabled(){return this.userDataSyncResourceEnablementService.isResourceEnabled(this.resource)}async triggerLocalChange(){this.isEnabled()&&this.localChangeTriggerScheduler.schedule()}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const l=await this.syncPreviewPromise;this.syncPreviewPromise=null;const m=await this.performSync(l.remoteUserData,l.lastSyncUserData,!0);this.setStatus(m)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const l=await this.getLastSyncUserData();(l?(await this.doGenerateSyncResourcePreview(l,l,!0,o.CancellationToken.None)).resourcePreviews.some(({remoteChange:w})=>w!==0):!0)&&this._onDidChangeLocal.fire()}}setStatus(l){if(this._status!==l){const m=this._status;l==="hasConflicts"&&this.telemetryService.publicLog2("sync/conflictsDetected",{source:this.resource}),m==="hasConflicts"&&l==="idle"&&this.telemetryService.publicLog2("sync/conflictsResolved",{source:this.resource}),this._status=l,this._onDidChangStatus.fire(l)}}async sync(l,m={}){await this._sync(l,!0,m)}async preview(l,m={}){return this._sync(l,!1,m)}async apply(l,m={}){try{this.syncHeaders=Object.assign({},m);const w=await this.doApply(l);return this.setStatus(w),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(l,m,w){try{if(this.syncHeaders=Object.assign({},w),!this.isEnabled())return this.status!=="idle"&&await this.stop(),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is disabled.`),null;if(this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let d="idle";try{const T=await this.getLastSyncUserData(),_=await this.getLatestRemoteUserData(l,T);return d=await this.performSync(_,T,m),d==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):d==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(d)}}finally{this.syncHeaders={}}}async replace(l){const m=await this.resolveContent(l);if(!m)return!1;const w=this.parseSyncData(m);if(!w)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const d=await this.getLastSyncUserData(),T=await this.getLatestRemoteUserData(null,d),_=await this.generateSyncPreview({ref:T.ref,syncData:w},d,o.CancellationToken.None),j=[];for(const $ of _){const K=await this.getAcceptResult($,$.remoteResource,void 0,o.CancellationToken.None),{remoteChange:B}=await this.getAcceptResult($,$.previewResource,$.remoteContent,o.CancellationToken.None);j.push([$,Object.assign(Object.assign({},K),{remoteChange:B!==0?B:2})])}await this.applyResult(T,d,j,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async getLatestRemoteUserData(l,m){if(m){const w=l&&l.latest?l.latest[this.resource]:void 0;if(m.ref===w||w===void 0&&m.syncData===null)return m}return this.getRemoteUserData(m)}async performSync(l,m,w){if(l.syncData&&l.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new O.UserDataSyncError(C.localize(0,null,this.resource,this.version,l.syncData.version),O.UserDataSyncErrorCode.IncompatibleLocalContent,this.resource);try{return await this.doSync(l,m,w)}catch(d){if(d instanceof O.UserDataSyncError)switch(d.code){case O.UserDataSyncErrorCode.LocalPreconditionFailed:return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(l,m,w);case O.UserDataSyncErrorCode.Conflict:case O.UserDataSyncErrorCode.PreconditionFailed:return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),l=await this.getRemoteUserData(null),m=await this.getLastSyncUserData(),this.performSync(l,m,w)}throw d}}async doSync(l,m,w){try{this.syncPreviewPromise||(this.syncPreviewPromise=S.createCancelablePromise(T=>this.doGenerateSyncResourcePreview(l,m,w,T)));const d=await this.syncPreviewPromise;return this.updateConflicts(d.resourcePreviews),d.resourcePreviews.some(({mergeState:T})=>T==="conflict")?"hasConflicts":w?await this.doApply(!1):"syncing"}catch(d){throw this.syncPreviewPromise=null,d}}async merge(l){return await this.updateSyncResourcePreview(l,async m=>{const w=await this.getMergeResult(m,o.CancellationToken.None);await this.fileService.writeFile(m.previewResource,L.VSBuffer.fromString((w==null?void 0:w.content)||""));const d=w&&!w.hasConflicts?await this.getAcceptResult(m,m.previewResource,void 0,o.CancellationToken.None):void 0;return m.acceptResult=d,m.mergeState=w.hasConflicts?"conflict":d?"accepted":"preview",m.localChange=d?d.localChange:w.localChange,m.remoteChange=d?d.remoteChange:w.remoteChange,m}),this.syncPreviewPromise}async accept(l,m){return await this.updateSyncResourcePreview(l,async w=>{const d=await this.getAcceptResult(w,l,m,o.CancellationToken.None);return w.acceptResult=d,w.mergeState="accepted",w.localChange=d.localChange,w.remoteChange=d.remoteChange,w}),this.syncPreviewPromise}async discard(l){return await this.updateSyncResourcePreview(l,async m=>{const w=await this.getMergeResult(m,o.CancellationToken.None);return await this.fileService.writeFile(m.previewResource,L.VSBuffer.fromString(w.content||"")),m.acceptResult=void 0,m.mergeState="preview",m.localChange=w.localChange,m.remoteChange=w.remoteChange,m}),this.syncPreviewPromise}async updateSyncResourcePreview(l,m){if(!this.syncPreviewPromise)return;let w=await this.syncPreviewPromise;const d=w.resourcePreviews.findIndex(({localResource:T,remoteResource:_,previewResource:j})=>this.extUri.isEqual(T,l)||this.extUri.isEqual(_,l)||this.extUri.isEqual(j,l));d!==-1&&(this.syncPreviewPromise=S.createCancelablePromise(async T=>{const _=[...w.resourcePreviews];return _[d]=await m(_[d]),Object.assign(Object.assign({},w),{resourcePreviews:_})}),w=await this.syncPreviewPromise,this.updateConflicts(w.resourcePreviews),w.resourcePreviews.some(({mergeState:T})=>T==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(l){if(!this.syncPreviewPromise)return"idle";const m=await this.syncPreviewPromise;return m.resourcePreviews.some(({mergeState:w})=>w==="conflict")?"hasConflicts":m.resourcePreviews.some(({mergeState:w})=>w!=="accepted")?"syncing":(await this.applyResult(m.remoteUserData,m.lastSyncUserData,m.resourcePreviews.map(w=>[w,w.acceptResult]),l),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch(l){}}updateConflicts(l){const m=l.filter(({mergeState:w})=>w==="conflict");E.equals(this._conflicts,m,(w,d)=>this.extUri.isEqual(w.previewResource,d.previewResource))||(this._conflicts=m,this._onDidChangeConflicts.fire(m))}async hasPreviouslySynced(){return!!await this.getLastSyncUserData()}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllRefs(this.resource)).map(({created:m,ref:w})=>({created:m,uri:this.toRemoteBackupResource(w)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.resource)).map(({created:m,ref:w})=>({created:m,uri:this.toLocalBackupResource(w)}))}toRemoteBackupResource(l){return A.URI.from({scheme:O.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.resource}/${l}`})}toLocalBackupResource(l){return A.URI.from({scheme:O.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.resource}/${l}`})}async getMachineId({uri:l}){const m=this.extUri.basename(l);if(this.extUri.isEqual(l,this.toRemoteBackupResource(m))){const{content:w}=await this.getUserData(m);if(w){const d=this.parseSyncData(w);return d==null?void 0:d.machineId}}}async resolveContent(l){const m=this.extUri.basename(l);if(this.extUri.isEqual(l,this.toRemoteBackupResource(m))){const{content:w}=await this.getUserData(m);return w}return this.extUri.isEqual(l,this.toLocalBackupResource(m))?this.userDataSyncBackupStoreService.resolveContent(this.resource,m):null}async resolvePreviewContent(l){const m=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(m)for(const w of m.resourcePreviews){if(this.extUri.isEqual(w.acceptedResource,l))return w.acceptResult?w.acceptResult.content:null;if(this.extUri.isEqual(w.remoteResource,l))return w.remoteContent;if(this.extUri.isEqual(w.localResource,l))return w.localContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch(l){}}async doGenerateSyncResourcePreview(l,m,w,d){var T;const _=await this.currentMachineIdPromise,j=!!((T=l.syncData)===null||T===void 0?void 0:T.machineId)&&l.syncData.machineId===_,$=m===null&&j&&!this.hasSyncResourceStateVersionChanged?l:m,K=await this.generateSyncPreview(l,$,d),B=[];for(const z of K){const G=z.previewResource.with({scheme:O.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(z.localChange===0&&z.remoteChange===0)B.push(Object.assign(Object.assign({},z),{acceptedResource:G,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"}));else{const V=w?await this.getMergeResult(z,d):void 0;if(d.isCancellationRequested)break;await this.fileService.writeFile(z.previewResource,L.VSBuffer.fromString((V==null?void 0:V.content)||""));const M=V&&!V.hasConflicts?await this.getAcceptResult(z,z.previewResource,void 0,d):void 0;B.push(Object.assign(Object.assign({},z),{acceptResult:M,mergeState:(V==null?void 0:V.hasConflicts)?"conflict":M?"accepted":"preview",localChange:M?M.localChange:V?V.localChange:z.localChange,remoteChange:M?M.remoteChange:V?V.remoteChange:z.remoteChange}))}}return{remoteUserData:l,lastSyncUserData:m,resourcePreviews:B,isLastSyncFromCurrentMachine:j}}async getLastSyncUserData(){try{const l=await this.fileService.readFile(this.lastSyncResource),m=JSON.parse(l.value.toString()),w=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=m.version&&w&&m.version!==w,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${m.version} is not compatible with current sync state version ${w}.`),await this.resetLocal(),null;const d=m;if(d.content===null)return{ref:m.ref,syncData:null};const T=JSON.parse(d.content);if(s(T))return Object.assign(Object.assign({},m),{syncData:T,content:void 0})}catch(l){l instanceof R.FileOperationError&&l.fileOperationResult===1||this.logService.error(l)}return null}async updateLastSyncUserData(l,m={}){if(m.ref||m.content||m.version)throw new Error("Cannot have core properties as additional");const w=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource),d=Object.assign({ref:l.ref,content:l.syncData?JSON.stringify(l.syncData):null,version:w},m);await this.fileService.writeFile(this.lastSyncResource,L.VSBuffer.fromString(JSON.stringify(d)))}async getRemoteUserData(l){const{ref:m,content:w}=await this.getUserData(l);let d=null;return w!==null&&(d=this.parseSyncData(w)),{ref:m,syncData:d}}parseSyncData(l){try{const m=JSON.parse(l);if(s(m))return m}catch(m){this.logService.error(m)}throw new O.UserDataSyncError(C.localize(1,null),O.UserDataSyncErrorCode.IncompatibleRemoteContent,this.resource)}async getUserData(l){if(I.isString(l)){const m=await this.userDataSyncStoreService.resolveContent(this.resource,l);return{ref:l,content:m}}else{const m=l?{ref:l.ref,content:l.syncData?JSON.stringify(l.syncData):null}:null;return this.userDataSyncStoreService.read(this.resource,m,this.syncHeaders)}}async updateRemoteUserData(l,m){const w=await this.currentMachineIdPromise,d={version:this.version,machineId:w,content:l};return m=await this.userDataSyncStoreService.write(this.resource,JSON.stringify(d),m,this.syncHeaders),{ref:m,syncData:d}}async backupLocal(l){const m={version:this.version,content:l};return this.userDataSyncBackupStoreService.backup(this.resource,JSON.stringify(m))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}};r=de([Y(1,R.IFileService),Y(2,P.IEnvironmentService),Y(3,g.IStorageService),Y(4,O.IUserDataSyncStoreService),Y(5,O.IUserDataSyncBackupStoreService),Y(6,O.IUserDataSyncResourceEnablementService),Y(7,v.ITelemetryService),Y(8,O.IUserDataSyncLogService),Y(9,f.IConfigurationService)],r),e.AbstractSynchroniser=r;let i=class extends r{constructor(l,m,w,d,T,_,j,$,K,B,z){super(m,w,d,T,_,j,$,K,B,z);this.file=l,this._register(this.fileService.watch(this.extUri.dirname(l))),this._register(this.fileService.onDidFilesChange(G=>this.onFileChanges(G)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch(l){return null}}async updateLocalFileContent(l,m,w){try{m?await this.fileService.writeFile(this.file,L.VSBuffer.fromString(l),w?void 0:m):await this.fileService.createFile(this.file,L.VSBuffer.fromString(l),{overwrite:w})}catch(d){throw d instanceof R.FileOperationError&&d.fileOperationResult===1||d instanceof R.FileOperationError&&d.fileOperationResult===3?new O.UserDataSyncError(d.message,O.UserDataSyncErrorCode.LocalPreconditionFailed):d}}onFileChanges(l){!l.contains(this.file)||this.triggerLocalChange()}};i=de([Y(2,R.IFileService),Y(3,P.IEnvironmentService),Y(4,g.IStorageService),Y(5,O.IUserDataSyncStoreService),Y(6,O.IUserDataSyncBackupStoreService),Y(7,O.IUserDataSyncResourceEnablementService),Y(8,v.ITelemetryService),Y(9,O.IUserDataSyncLogService),Y(10,f.IConfigurationService)],i),e.AbstractFileSynchroniser=i;let a=class extends i{constructor(l,m,w,d,T,_,j,$,K,B,z,G){super(l,m,w,d,T,_,j,$,K,B,G);this.userDataSyncUtilService=z,this._formattingOptions=void 0}hasErrors(l){const m=[];return h.parse(l,m,{allowEmptyContent:!0,allowTrailingComma:!0}),m.length>0}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};a=de([Y(2,R.IFileService),Y(3,P.IEnvironmentService),Y(4,g.IStorageService),Y(5,O.IUserDataSyncStoreService),Y(6,O.IUserDataSyncBackupStoreService),Y(7,O.IUserDataSyncResourceEnablementService),Y(8,v.ITelemetryService),Y(9,O.IUserDataSyncLogService),Y(10,O.IUserDataSyncUtilService),Y(11,f.IConfigurationService)],a),e.AbstractJsonFileSynchroniser=a;let c=class{constructor(l,m,w,d){this.resource=l,this.environmentService=m,this.logService=w,this.fileService=d,this.extUri=this.fileService.hasCapability(m.userDataSyncHome,1024)?p.extUri:p.extUriIgnorePathCase,this.lastSyncResource=t(this.resource,m,p.extUri)}async initialize({ref:l,content:m}){if(!m){this.logService.info("Remote content does not exist.",this.resource);return}const w=this.parseSyncData(m);if(!w)return;if(await this.fileService.exists(this.lastSyncResource)){this.logService.info("Remote content does not exist.",this.resource);return}try{await this.doInitialize({ref:l,syncData:w})}catch(T){this.logService.error(T)}}parseSyncData(l){try{const m=JSON.parse(l);if(s(m))return m}catch(m){this.logService.error(m)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(l,m={}){const w=Object.assign({ref:l.ref,content:l.syncData?JSON.stringify(l.syncData):null},m);await this.fileService.writeFile(this.lastSyncResource,L.VSBuffer.fromString(JSON.stringify(w)))}};c=de([Y(1,P.IEnvironmentService),Y(2,O.IUserDataSyncLogService),Y(3,R.IFileService)],c),e.AbstractInitializer=c}),define(Z[187],ee([0,1,21,3,9,28,33,10,23,184,46,24,5,47,40,22,20,85,11,84,8]),function(H,e,y,R,L,A,O,P,p,S,n,v,h,C,f,I,D,E,b,g,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.ExtensionsSynchroniser=e.storeExtensionStorageState=e.getExtensionStorageState=void 0;async function s(c,u){const l=JSON.parse(c.content);if(c.version===1||c.version===2){const m=(await u.getInstalled(0)).filter(w=>w.isBuiltin);for(const w of l)c.version===1&&(w.enabled===!1&&(w.disabled=!0),delete w.enabled),c.version===2&&m.every(d=>!O.areSameExtensions(d.identifier,w.identifier))&&(w.installed=!0)}return l}function t(c,u,l){const m=l.get(O.getExtensionId(c,u),0)||"{}";return JSON.parse(m)}e.getExtensionStorageState=t;function r(c,u,l,m){m.store(O.getExtensionId(c,u),JSON.stringify(l),0,1)}e.storeExtensionStorageState=r;let i=class ot extends n.AbstractSynchroniser{constructor(u,l,m,w,d,T,_,j,$,K,B,z,G,V){super("extensions",l,u,m,w,d,z,G,$,B);this.storageService=m,this.extensionManagementService=T,this.extensionEnablementService=_,this.ignoredExtensionsManagementService=j,this.extensionGalleryService=K,this.extensionsStorageSyncService=V,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.localResource=this.previewResource.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(R.Event.debounce(R.Event.any(R.Event.filter(this.extensionManagementService.onDidInstallExtension,M=>!!M.gallery),R.Event.filter(this.extensionManagementService.onDidUninstallExtension,M=>!M.error),this.extensionEnablementService.onDidChangeEnablement,this.extensionsStorageSyncService.onDidChangeExtensionsStorage),()=>{},500)(()=>this.triggerLocalChange()))}isEnabled(){return super.isEnabled()&&this.extensionGalleryService.isEnabled()}async generateSyncPreview(u,l){const m=u.syncData?await s(u.syncData,this.extensionManagementService):null,w=(l==null?void 0:l.skippedExtensions)||[],d=(l==null?void 0:l.syncData)?await s(l.syncData,this.extensionManagementService):null,T=await this.extensionManagementService.getInstalled(),_=this.getLocalExtensions(T),j=this.ignoredExtensionsManagementService.getIgnoredExtensions(T);m?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{added:$,removed:K,updated:B,remote:z}=S.merge(_,m,d,w,j),G={added:$,removed:K,updated:B,remote:z,content:this.getPreviewContent(_,$,B,K),localChange:$.length>0||K.length>0||B.length>0?2:0,remoteChange:z!==null?2:0};return[{skippedExtensions:w,localResource:this.localResource,localContent:this.format(_),localExtensions:_,remoteResource:this.remoteResource,remoteContent:m?this.format(m):null,previewResource:this.previewResource,previewResult:G,localChange:G.localChange,remoteChange:G.remoteChange,acceptedResource:this.acceptedResource}]}getPreviewContent(u,l,m,w){const d=[...l,...m],T=new Set,_=j=>{T.add(j.id.toLowerCase()),j.uuid&&T.add(j.uuid)};d.forEach(({identifier:j})=>_(j)),w.forEach(_);for(const j of u)T.has(j.identifier.id.toLowerCase())||j.identifier.uuid&&T.has(j.identifier.uuid)||d.push(j);return this.format(d)}async getMergeResult(u,l){return Object.assign(Object.assign({},u.previewResult),{hasConflicts:!1})}async getAcceptResult(u,l,m,w){if(this.extUri.isEqual(l,this.localResource))return this.acceptLocal(u);if(this.extUri.isEqual(l,this.remoteResource))return this.acceptRemote(u);if(this.extUri.isEqual(l,this.previewResource))return u.previewResult;throw new Error(`Invalid Resource: ${l.toString()}`)}async acceptLocal(u){const l=await this.extensionManagementService.getInstalled(),m=this.ignoredExtensionsManagementService.getIgnoredExtensions(l),w=S.merge(u.localExtensions,null,null,u.skippedExtensions,m),{added:d,removed:T,updated:_,remote:j}=w;return{content:u.localContent,added:d,removed:T,updated:_,remote:j,localChange:d.length>0||T.length>0||_.length>0?2:0,remoteChange:j!==null?2:0}}async acceptRemote(u){const l=await this.extensionManagementService.getInstalled(),m=this.ignoredExtensionsManagementService.getIgnoredExtensions(l),w=u.remoteContent?JSON.parse(u.remoteContent):null;if(w!==null){const d=S.merge(u.localExtensions,w,u.localExtensions,[],m),{added:T,removed:_,updated:j,remote:$}=d;return{content:u.remoteContent,added:T,removed:_,updated:j,remote:$,localChange:T.length>0||_.length>0||j.length>0?2:0,remoteChange:$!==null?2:0}}else return{content:u.remoteContent,added:[],removed:[],updated:[],remote:null,localChange:0,remoteChange:0}}async applyResult(u,l,m,w){let{skippedExtensions:d,localExtensions:T}=m[0][0],{added:_,removed:j,updated:$,remote:K,localChange:B,remoteChange:z}=m[0][1];if(B===0&&z===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),B!==0&&(await this.backupLocal(JSON.stringify(T)),d=await this.updateLocalExtensions(_,j,$,d)),K){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const G=JSON.stringify(K);u=await this.updateRemoteUserData(G,w?null:u.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions`)}(l==null?void 0:l.ref)!==u.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),await this.updateLastSyncUserData(u,{skippedExtensions:d}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions`))}async getAssociatedResources({uri:u}){return[{resource:this.extUri.joinPath(u,"extensions.json"),comparableResource:ot.EXTENSIONS_DATA_URI}]}async resolveContent(u){if(this.extUri.isEqual(u,ot.EXTENSIONS_DATA_URI)){const m=await this.extensionManagementService.getInstalled(),w=this.ignoredExtensionsManagementService.getIgnoredExtensions(m),d=this.getLocalExtensions(m).filter(T=>!w.some(_=>O.areSameExtensions({id:_},T.identifier)));return this.format(d)}if(this.extUri.isEqual(this.remoteResource,u)||this.extUri.isEqual(this.localResource,u)||this.extUri.isEqual(this.acceptedResource,u))return this.resolvePreviewContent(u);let l=await super.resolveContent(u);if(l)return l;if(l=await super.resolveContent(this.extUri.dirname(u)),l){const m=this.parseSyncData(l);if(m)switch(this.extUri.basename(u)){case"extensions.json":return this.format(this.parseExtensions(m))}}return null}format(u){u.sort((w,d)=>!w.identifier.uuid&&d.identifier.uuid?-1:w.identifier.uuid&&!d.identifier.uuid?1:I.compare(w.identifier.id,d.identifier.id));const l=JSON.stringify(u),m=C.format(l,void 0,{});return f.applyEdits(l,m)}async hasLocalData(){try{const u=await this.extensionManagementService.getInstalled();if(this.getLocalExtensions(u).some(m=>m.installed||m.disabled))return!0}catch(u){}return!1}async updateLocalExtensions(u,l,m,w){const d=[],T=[],_=await this.extensionManagementService.getInstalled();if(l.length){const $=_.filter(({identifier:K,isBuiltin:B})=>!B&&l.some(z=>O.areSameExtensions(K,z)));await o.Promises.settled($.map(async K=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,K.identifier.id),await this.extensionManagementService.uninstall(K,{donotIncludePack:!0,donotCheckDependents:!0}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,K.identifier.id),d.push(K.identifier)}))}(u.length||m.length)&&await o.Promises.settled([...u,...m].map(async $=>{const K=_.find(z=>O.areSameExtensions(z.identifier,$.identifier));if(K&&K.isBuiltin){$.state&&K.manifest.version===$.version&&this.updateExtensionState($.state,K.manifest.publisher,K.manifest.name,K.manifest.version),$.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,$.identifier.id),await this.extensionEnablementService.disableExtension($.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,$.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,$.identifier.id),await this.extensionEnablementService.enableExtension($.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,$.identifier.id)),d.push($.identifier);return}const B=await this.extensionGalleryService.getCompatibleExtension($.identifier);if($.state&&(K?K.manifest.version===$.version:!!B)){const z=K?K.manifest.publisher:B.publisher,G=K?K.manifest.name:B.name;this.updateExtensionState($.state,z,G,K==null?void 0:K.manifest.version)}if(B)try{$.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,$.identifier.id,B.version),await this.extensionEnablementService.disableExtension(B.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,$.identifier.id,B.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,$.identifier.id,B.version),await this.extensionEnablementService.enableExtension(B.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,$.identifier.id,B.version)),K||(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,$.identifier.id,B.version),await this.extensionManagementService.installFromGallery(B,{isMachineScoped:!1,donotIncludePackAndDependencies:!0}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,$.identifier.id,B.version),d.push(B.identifier))}catch(z){T.push($),this.logService.error(z),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,B.displayName||B.identifier.id)}else T.push($)}));const j=[];for(const $ of w)d.some(K=>O.areSameExtensions(K,$.identifier))||j.push($);for(const $ of T)j.some(K=>O.areSameExtensions(K.identifier,$.identifier))||j.push($);return j}updateExtensionState(u,l,m,w){const d=t(l,m,this.storageService),T=w?this.extensionsStorageSyncService.getKeysForSync({id:O.getGalleryExtensionId(l,m),version:w}):void 0;T?T.forEach(_=>{d[_]=u[_]}):Object.keys(u).forEach(_=>d[_]=u[_]),r(l,m,d,this.storageService)}parseExtensions(u){return JSON.parse(u.content)}getLocalExtensions(u){const l=this.extensionEnablementService.getDisabledExtensions();return u.map(({identifier:m,isBuiltin:w,manifest:d})=>{const T={identifier:m,version:d.version};l.some(_=>O.areSameExtensions(_,m))&&(T.disabled=!0),w||(T.installed=!0);try{const _=this.extensionsStorageSyncService.getKeysForSync({id:m.id,version:d.version});if(_){const j=t(d.publisher,d.name,this.storageService);T.state=Object.keys(j).reduce(($,K)=>(_.includes(K)&&($[K]=j[K]),$),{})}}catch(_){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,b.getErrorMessage(_))}return T})}};i.EXTENSIONS_DATA_URI=h.URI.from({scheme:y.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),i=de([Y(0,L.IEnvironmentService),Y(1,P.IFileService),Y(2,D.IStorageService),Y(3,y.IUserDataSyncStoreService),Y(4,y.IUserDataSyncBackupStoreService),Y(5,A.IExtensionManagementService),Y(6,A.IGlobalExtensionEnablementService),Y(7,E.IIgnoredExtensionsManagementService),Y(8,y.IUserDataSyncLogService),Y(9,A.IExtensionGalleryService),Y(10,p.IConfigurationService),Y(11,y.IUserDataSyncResourceEnablementService),Y(12,v.ITelemetryService),Y(13,g.IExtensionsStorageSyncService)],i),e.ExtensionsSynchroniser=i;let a=class extends n.AbstractInitializer{constructor(u,l,m,w,d){super("extensions",w,d,m);this.extensionManagementService=u,this.ignoredExtensionsManagementService=l}async parseExtensions(u){return u.syncData?await s(u.syncData,this.extensionManagementService):null}generatePreview(u,l){const m=[],w=[],d=[];for(const T of u){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(T.identifier.id))continue;const _=l.find(j=>O.areSameExtensions(j.identifier,T.identifier));_?(m.push(_),T.disabled&&d.push(T.identifier)):T.installed&&(w.push(T.identifier),T.disabled&&d.push(T.identifier))}return{installedExtensions:m,newExtensions:w,disabledExtensions:d,remoteExtensions:u}}};a=de([Y(0,A.IExtensionManagementService),Y(1,E.IIgnoredExtensionsManagementService),Y(2,P.IFileService),Y(3,L.IEnvironmentService),Y(4,y.IUserDataSyncLogService)],a),e.AbstractExtensionsInitializer=a}),define(Z[188],ee([0,1,26,21]),function(H,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function L(P,p,S,n,v){if(!p)return{remote:Object.keys(P).length>0?P:null,local:{added:{},removed:[],updated:{}}};const h=A(P,p);if(h.added.size===0&&h.removed.size===0&&h.updated.size===0)return{remote:null,local:{added:{},removed:[],updated:{}}};const C=S?A(S,p):{added:Object.keys(p).reduce((b,g)=>(b.add(g),b),new Set),removed:new Set,updated:new Set},f=S?A(S,P):{added:Object.keys(P).reduce((b,g)=>(b.add(g),b),new Set),removed:new Set,updated:new Set},I={added:{},removed:[],updated:{}},D=y.deepClone(p),E=!S;for(const b of f.added.values())b!==R.SYNC_SERVICE_URL_TYPE&&E&&C.added.has(b)||(D[b]=P[b]);for(const b of f.updated.values())D[b]=P[b];for(const b of f.removed.values())n.unregistered.includes(b)||delete D[b];for(const b of C.added.values()){const g=p[b];if(n.machine.includes(b)){v.info(`GlobalState: Skipped adding ${b} in local storage because it is declared as machine scoped.`);continue}if(S&&f.added.has(b))continue;const o=P[b];o&&o.value===g.value||b===R.SYNC_SERVICE_URL_TYPE&&E&&f.added.has(b)||(o?I.updated[b]=g:I.added[b]=g)}for(const b of C.updated.values()){const g=p[b];if(n.machine.includes(b)){v.info(`GlobalState: Skipped updating ${b} in local storage because it is declared as machine scoped.`);continue}if(f.updated.has(b)||f.removed.has(b))continue;const o=P[b];o&&o.value===g.value||(I.updated[b]=g)}for(const b of C.removed.values()){if(n.machine.includes(b)){v.trace(`GlobalState: Skipped removing ${b} in local storage because it is declared as machine scoped.`);continue}f.updated.has(b)||f.removed.has(b)||I.removed.push(b)}return{local:I,remote:O(D,p)?null:D}}e.merge=L;function A(P,p){const S=Object.keys(P),n=Object.keys(p),v=n.filter(f=>S.indexOf(f)===-1).reduce((f,I)=>(f.add(I),f),new Set),h=S.filter(f=>n.indexOf(f)===-1).reduce((f,I)=>(f.add(I),f),new Set),C=new Set;for(const f of S){if(h.has(f))continue;const I=P[f],D=p[f];y.equals(I,D)||C.add(f)}return{added:v,removed:h,updated:C}}function O(P,p){const{added:S,removed:n,updated:v}=A(P,p);return S.size===0&&n.size===0&&v.size===0}}),define(Z[189],ee([0,1,21,25,3,9,10,52,188,32,46,24,23,5,47,40,20,6,45,30,18]),function(H,e,y,R,L,A,O,P,p,S,n,v,h,C,f,I,D,E,b,g,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const s="globalState.argv.",t=["locale"];function r(l){const m=l.storage?Object.keys(l.storage).sort():[],w={};m.forEach(_=>w[_]=l.storage[_]),l.storage=w;const d=JSON.stringify(l),T=f.format(d,void 0,{});return I.applyEdits(d,T)}const i=1;let a=class ct extends n.AbstractSynchroniser{constructor(m,w,d,T,_,j,$,K,B){super("globalState",m,_,B,w,d,j,$,T,K);this.storageService=B,this.version=i,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.localResource=this.previewResource.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(m.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(L.Event.any(L.Event.filter(m.onDidFilesChange,z=>z.contains(this.environmentService.argvResource)),L.Event.filter(B.onDidChangeValue,z=>z.scope===0&&z.target!==void 0?z.target===0:B.keys(0,0).includes(z.key)),this.storageService.onDidChangeTarget)(()=>this.triggerLocalChange()))}async generateSyncPreview(m,w,d){const T=m.syncData?JSON.parse(m.syncData.content):null,_=w&&w.syncData?JSON.parse(w.syncData.content):null,j=await this.getLocalGlobalState();T?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const $=this.getStorageKeys(_),{local:K,remote:B}=p.merge(j.storage,T?T.storage:null,_?_.storage:null,$,this.logService),z={content:null,local:K,remote:B,localChange:Object.keys(K.added).length>0||Object.keys(K.updated).length>0||K.removed.length>0?2:0,remoteChange:B!==null?2:0};return[{localResource:this.localResource,localContent:r(j),localUserData:j,remoteResource:this.remoteResource,remoteContent:T?r(T):null,previewResource:this.previewResource,previewResult:z,localChange:z.localChange,remoteChange:z.remoteChange,acceptedResource:this.acceptedResource,storageKeys:$}]}async getMergeResult(m,w){return Object.assign(Object.assign({},m.previewResult),{hasConflicts:!1})}async getAcceptResult(m,w,d,T){if(this.extUri.isEqual(w,this.localResource))return this.acceptLocal(m);if(this.extUri.isEqual(w,this.remoteResource))return this.acceptRemote(m);if(this.extUri.isEqual(w,this.previewResource))return m.previewResult;throw new Error(`Invalid Resource: ${w.toString()}`)}async acceptLocal(m){return{content:m.localContent,local:{added:{},removed:[],updated:{}},remote:m.localUserData.storage,localChange:0,remoteChange:2}}async acceptRemote(m){if(m.remoteContent!==null){const w=JSON.parse(m.remoteContent),{local:d,remote:T}=p.merge(m.localUserData.storage,w.storage,null,m.storageKeys,this.logService);return{content:m.remoteContent,local:d,remote:T,localChange:Object.keys(d.added).length>0||Object.keys(d.updated).length>0||d.removed.length>0?2:0,remoteChange:T!==null?2:0}}else return{content:m.remoteContent,local:{added:{},removed:[],updated:{}},remote:null,localChange:0,remoteChange:0}}async applyResult(m,w,d,T){let{localUserData:_}=d[0][0],{local:j,remote:$,localChange:K,remoteChange:B}=d[0][1];if(K===0&&B===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),K!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(_)),await this.writeLocalGlobalState(j),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),B!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const z=JSON.stringify({storage:$});m=await this.updateRemoteUserData(z,T?null:m.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state`)}(w==null?void 0:w.ref)!==m.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(m),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:m}){return[{resource:this.extUri.joinPath(m,"globalState.json"),comparableResource:ct.GLOBAL_STATE_DATA_URI}]}async resolveContent(m){if(this.extUri.isEqual(m,ct.GLOBAL_STATE_DATA_URI)){const d=await this.getLocalGlobalState();return r(d)}if(this.extUri.isEqual(this.remoteResource,m)||this.extUri.isEqual(this.localResource,m)||this.extUri.isEqual(this.acceptedResource,m))return this.resolvePreviewContent(m);let w=await super.resolveContent(m);if(w)return w;if(w=await super.resolveContent(this.extUri.dirname(m)),w){const d=this.parseSyncData(w);if(d)switch(this.extUri.basename(m)){case"globalState.json":return r(JSON.parse(d.content))}}return null}async hasLocalData(){var m;try{const{storage:w}=await this.getLocalGlobalState();if(Object.keys(w).length>1||((m=w[`${s}.locale`])===null||m===void 0?void 0:m.value)!=="en")return!0}catch(w){}return!1}async getLocalGlobalState(){const m={},w=await this.getLocalArgvContent(),d=S.parse(w);for(const T of t)d[T]!==void 0&&(m[`${s}${T}`]={version:1,value:d[T]});for(const T of this.storageService.keys(0,0)){const _=this.storageService.get(T,0);_&&(m[T]={version:1,value:_})}return{storage:m}}async getLocalArgvContent(){try{return(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch(m){}return"{}"}async writeLocalGlobalState({added:m,removed:w,updated:d}){const T={},_={},j=(K,B)=>{for(const z of K){if(z.startsWith(s)){T[z.substring(s.length)]=B?B[z].value:void 0;continue}if(B){const G=B[z];G.value!==String(this.storageService.get(z,0))&&(_[z]=G.value)}else this.storageService.get(z,0)!==void 0&&(_[z]=void 0)}};if(j(Object.keys(m),m),j(Object.keys(d),d),j(w),Object.keys(T).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(T),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),Object.keys(_).length){this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`);for(const K of Object.keys(_))this.storageService.store(K,_[K],0,0);this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,Object.keys(_))}}async updateArgv(m){const w=await this.getLocalArgvContent();let d=w;for(const T of Object.keys(m))d=P.edit(d,[T],m[T],{});w!==d&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,R.VSBuffer.fromString(d)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}getStorageKeys(m){const w=this.storageService.keys(0,0),d=this.storageService.keys(0,1),T=[...w,...d],_=(m==null?void 0:m.storage)?Object.keys(m.storage).filter(j=>!j.startsWith(s)&&!T.includes(j)&&this.storageService.get(j,0)!==void 0):[];if(!E.isWeb){const j=[...y.ALL_SYNC_RESOURCES.map($=>y.getEnablementKey($)),y.SYNC_SERVICE_URL_TYPE];_.push(...j),d.push(...j)}return{user:w,machine:d,unregistered:_}}};a.GLOBAL_STATE_DATA_URI=C.URI.from({scheme:y.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),a=de([Y(0,O.IFileService),Y(1,y.IUserDataSyncStoreService),Y(2,y.IUserDataSyncBackupStoreService),Y(3,y.IUserDataSyncLogService),Y(4,A.IEnvironmentService),Y(5,y.IUserDataSyncResourceEnablementService),Y(6,v.ITelemetryService),Y(7,h.IConfigurationService),Y(8,D.IStorageService)],a),e.GlobalStateSynchroniser=a;let c=class extends n.AbstractInitializer{constructor(m,w,d,T){super("globalState",d,T,w);this.storageService=m}async doInitialize(m){const w=m.syncData?JSON.parse(m.syncData.content):null;if(!w){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const d={},T={};for(const _ of Object.keys(w.storage))_.startsWith(s)?d[_.substring(s.length)]=w.storage[_].value:this.storageService.get(_,0)===void 0&&(T[_]=w.storage[_].value);if(Object.keys(d).length){let _="{}";try{_=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch(j){}for(const j of Object.keys(d))_=P.edit(_,[j],d[j],{});await this.fileService.writeFile(this.environmentService.argvResource,R.VSBuffer.fromString(_))}if(Object.keys(T).length)for(const _ of Object.keys(T))this.storageService.store(_,T[_],0,0)}};c=de([Y(0,D.IStorageService),Y(1,O.IFileService),Y(2,A.IEnvironmentService),Y(3,y.IUserDataSyncLogService)],c),e.GlobalStateInitializer=c;let u=class{constructor(m,w,d,T,_){this.userDataSyncStoreClient=m,this.storageService=w,this.environmentService=d,this.fileService=T,this.logService=_}getSyncStoreType(m){var w;const d=this.parseGlobalState(m);return(w=d==null?void 0:d.storage[y.SYNC_SERVICE_URL_TYPE])===null||w===void 0?void 0:w.value}async sync(m){const w=y.createSyncHeaders(g.generateUuid());try{return await this.doSync(m,w)}catch(d){if(d instanceof y.UserDataSyncError)switch(d.code){case y.UserDataSyncErrorCode.PreconditionFailed:return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(m,w)}throw d}}async doSync(m,w){const d=await this.userDataSyncStoreClient.read("globalState",null,w),T=this.parseGlobalState(d)||{storage:{}};T.storage[y.SYNC_SERVICE_URL_TYPE]={value:m,version:i};const _=await b.getServiceMachineId(this.environmentService,this.fileService,this.storageService),j={version:i,machineId:_,content:r(T)};await this.userDataSyncStoreClient.write("globalState",JSON.stringify(j),d.ref,w)}parseGlobalState({content:m}){if(!m)return null;const w=JSON.parse(m);if(n.isSyncData(w))return w?JSON.parse(w.content):null;throw new Error("Invalid remote data")}};u=de([Y(1,D.IStorageService),Y(2,A.IEnvironmentService),Y(3,O.IFileService),Y(4,o.ILogService)],u),e.UserDataSyncStoreTypeSynchronizer=u}),define(Z[190],ee([0,1,10,21,185,32,123,9,23,6,15,19,46,24,20,25,3]),function(H,e,y,R,L,A,O,P,p,S,n,v,h,C,f,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function E(o,s){const t=JSON.parse(o);if(!s)return n.isUndefined(t.all)?null:t.all;switch(S.OS){case 2:return n.isUndefined(t.mac)?null:t.mac;case 3:return n.isUndefined(t.linux)?null:t.linux;case 1:return n.isUndefined(t.windows)?null:t.windows}}e.getKeybindingsContentFromSyncContent=E;let b=class extends h.AbstractJsonFileSynchroniser{constructor(s,t,r,i,a,c,u,l,m,w){super(u.keybindingsResource,"keybindings",c,u,l,s,t,a,w,r,m,i);this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.localResource=this.previewResource.with({scheme:R.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:R.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:R.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(D.Event.filter(i.onDidChangeConfiguration,d=>d.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(s,t,r){const i=s.syncData?this.getKeybindingsContentFromSyncContent(s.syncData.content):null,a=t?this.getKeybindingsContentFromLastSyncUserData(t):null,c=await this.getLocalFileContent(),u=await this.getFormattingOptions();let l=null,m=!1,w=!1,d=!1;if(i){let _=c?c.value.toString():"[]";if(_=_||"[]",this.hasErrors(_))throw new R.UserDataSyncError(O.localize(0,null),R.UserDataSyncErrorCode.LocalInvalidContent,this.resource);if(!a||a!==_||a!==i){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const j=await L.merge(_,i,a,u,this.userDataSyncUtilService);j.hasChanges&&(l=j.mergeContent,d=j.hasConflicts,m=d||j.mergeContent!==_,w=d||j.mergeContent!==i)}}else c&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),l=c.value.toString(),w=!0);const T={content:l,localChange:m?c?2:1:0,remoteChange:w?2:0,hasConflicts:d};return[{fileContent:c,localResource:this.localResource,localContent:c?c.value.toString():null,localChange:T.localChange,remoteResource:this.remoteResource,remoteContent:i,remoteChange:T.remoteChange,previewResource:this.previewResource,previewResult:T,acceptedResource:this.acceptedResource}]}async getMergeResult(s,t){return s.previewResult}async getAcceptResult(s,t,r,i){if(this.extUri.isEqual(t,this.localResource))return{content:s.fileContent?s.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(t,this.remoteResource))return{content:s.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(t,this.previewResource))return r===void 0?{content:s.previewResult.content,localChange:s.previewResult.localChange,remoteChange:s.previewResult.remoteChange}:{content:r,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async applyResult(s,t,r,i){var a;const{fileContent:c}=r[0][0];let{content:u,localChange:l,remoteChange:m}=r[0][1];if(l===0&&m===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),u!==null&&(u=u.trim(),u=u||"[]",this.hasErrors(u)))throw new R.UserDataSyncError(O.localize(1,null),R.UserDataSyncErrorCode.LocalInvalidContent,this.resource);if(l!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),c&&await this.backupLocal(this.toSyncContent(c.value.toString())),await this.updateLocalFileContent(u||"[]",c,i),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),m!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const w=this.toSyncContent(u||"[]",(a=s.syncData)===null||a===void 0?void 0:a.content);s=await this.updateRemoteUserData(w,i?null:s.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch(w){}(t==null?void 0:t.ref)!==s.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(s,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const s=await this.getLocalFileContent();if(s){const t=A.parse(s.value.toString());if(v.isNonEmptyArray(t))return!0}}catch(s){if(s.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:s}){const t=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(s,"keybindings.json"),comparableResource:t}]}async resolveContent(s){if(this.extUri.isEqual(this.remoteResource,s)||this.extUri.isEqual(this.localResource,s)||this.extUri.isEqual(this.acceptedResource,s))return this.resolvePreviewContent(s);let t=await super.resolveContent(s);if(t)return t;if(t=await super.resolveContent(this.extUri.dirname(s)),t){const r=this.parseSyncData(t);if(r)switch(this.extUri.basename(s)){case"keybindings.json":return this.getKeybindingsContentFromSyncContent(r.content)}}return null}getKeybindingsContentFromLastSyncUserData(s){return!s.syncData||s.platformSpecific!==void 0&&s.platformSpecific!==this.syncKeybindingsPerPlatform()?null:this.getKeybindingsContentFromSyncContent(s.syncData.content)}getKeybindingsContentFromSyncContent(s){try{return E(s,this.syncKeybindingsPerPlatform())}catch(t){return this.logService.error(t),null}}toSyncContent(s,t){let r={};try{r=JSON.parse(t||"{}")}catch(i){this.logService.error(i)}switch(this.syncKeybindingsPerPlatform()?delete r.all:r.all=s,S.OS){case 2:r.mac=s;break;case 3:r.linux=s;break;case 1:r.windows=s;break}return JSON.stringify(r)}syncKeybindingsPerPlatform(){let s=this.configurationService.inspect("settingsSync.keybindingsPerPlatform").userValue;return s!==void 0||(s=this.configurationService.inspect("sync.keybindingsPerPlatform").userValue,s!==void 0)?s:this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};b=de([Y(0,R.IUserDataSyncStoreService),Y(1,R.IUserDataSyncBackupStoreService),Y(2,R.IUserDataSyncLogService),Y(3,p.IConfigurationService),Y(4,R.IUserDataSyncResourceEnablementService),Y(5,y.IFileService),Y(6,P.IEnvironmentService),Y(7,f.IStorageService),Y(8,R.IUserDataSyncUtilService),Y(9,C.ITelemetryService)],b),e.KeybindingsSynchroniser=b;let g=class extends h.AbstractInitializer{constructor(s,t,r){super("keybindings",t,r,s)}async doInitialize(s){const t=s.syncData?this.getKeybindingsContentFromSyncContent(s.syncData.content):null;if(!t){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.environmentService.keybindingsResource,I.VSBuffer.fromString(t)),await this.updateLastSyncUserData(s)}async isEmpty(){try{const s=await this.fileService.readFile(this.environmentService.settingsResource),t=A.parse(s.value.toString());return!v.isNonEmptyArray(t)}catch(s){return s.fileOperationResult===1}}getKeybindingsContentFromSyncContent(s){try{return E(s,!0)}catch(t){return this.logService.error(t),null}}};g=de([Y(0,y.IFileService),Y(1,P.IEnvironmentService),Y(2,R.IUserDataSyncLogService)],g),e.KeybindingsInitializer=g}),define(Z[191],ee([0,1,26,32,40,47,52,21,19]),function(H,e,y,R,L,A,O,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.getIgnoredSettings=void 0;function S(u,l,m){let w=[];m?w=v(m):w=n(l);const d=[],T=[...P.getDisallowedIgnoredSettings()];if(Array.isArray(w))for(const _ of w)_.startsWith("-")?T.push(_.substring(1)):d.push(_);return p.distinct([...u,...d].filter(_=>T.indexOf(_)===-1))}e.getIgnoredSettings=S;function n(u){let l=u.inspect("settingsSync.ignoredSettings").userValue;return l!==void 0||(l=u.inspect("sync.ignoredSettings").userValue,l!==void 0)?l:u.getValue("settingsSync.ignoredSettings")||[]}function v(u){const l=R.parse(u);return l?l["settingsSync.ignoredSettings"]||l["sync.ignoredSettings"]||[]:[]}function h(u,l,m,w){if(m.length){const d=c(l),T=R.parse(l),_=R.parse(u),j=[];for(const $ of m){const K=T[$],B=_[$];K===void 0?u=O.edit(u,[$],void 0,w):B!==void 0?u=O.edit(u,[$],K,w):j.push(s($,d))}j.sort(($,K)=>$.startOffset-K.startOffset),j.forEach($=>u=E($.setting.key,l,u,w))}return u}e.updateIgnoredSettings=h;function C(u,l,m,w,d,T){const _=h(u,l,w,T),j=m!==_,$=m!==l;if(!j&&!$)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(j&&!$)return{conflictsSettings:[],localContent:null,remoteContent:_,hasConflicts:!1};if($&&!j)return{conflictsSettings:[],localContent:h(l,u,w,T),remoteContent:null,hasConflicts:!1};if(m===null&&I(u)){const ne=f(u,l,w)?null:h(l,u,w,T);return{conflictsSettings:[],localContent:ne,remoteContent:null,hasConflicts:!1}}let K=u,B=l;const z=R.parse(u),G=R.parse(l),V=m?R.parse(m):null,M=w.reduce((ne,ce)=>(ne.add(ce),ne),new Set),U=D(z,G,M),k=D(V,z,M),F=D(V,G,M),N=new Map,q=new Set,W=ne=>{q.add(ne);const ce=d.filter(({key:le})=>le===ne)[0];ce?(K=O.edit(K,[ne],ce.value,T),B=O.edit(B,[ne],ce.value,T)):N.set(ne,{key:ne,localValue:z[ne],remoteValue:G[ne]})};for(const ne of k.removed.values())F.updated.has(ne)?W(ne):B=O.edit(B,[ne],void 0,T);for(const ne of F.removed.values())q.has(ne)||(k.updated.has(ne)?W(ne):K=O.edit(K,[ne],void 0,T));for(const ne of k.updated.values())q.has(ne)||(F.updated.has(ne)?U.updated.has(ne)&&W(ne):B=O.edit(B,[ne],z[ne],T));for(const ne of F.updated.values())q.has(ne)||(k.updated.has(ne)?U.updated.has(ne)&&W(ne):K=O.edit(K,[ne],G[ne],T));for(const ne of k.added.values())q.has(ne)||(F.added.has(ne)?U.updated.has(ne)&&W(ne):B=E(ne,K,B,T));for(const ne of F.added.values())q.has(ne)||(k.added.has(ne)?U.updated.has(ne)&&W(ne):K=E(ne,B,K,T));const Q=N.size>0||!f(K,B,w),X=Q||!f(K,u,[]),ie=Q||!f(B,l,[]);return{localContent:X?K:null,remoteContent:ie?B:null,conflictsSettings:[...N.values()],hasConflicts:Q}}e.merge=C;function f(u,l,m){if(u===l)return!0;const w=R.parse(u),d=R.parse(l),T=m.reduce(($,K)=>($.add(K),$),new Set),_=c(u).filter($=>!($.setting&&T.has($.setting.key))),j=c(l).filter($=>!($.setting&&T.has($.setting.key)));if(_.length!==j.length)return!1;for(let $=0;$<_.length;$++){const K=_[$],B=j[$];if(K.setting&&B.setting){if(K.setting.key!==B.setting.key||!y.equals(w[K.setting.key],d[K.setting.key]))return!1}else if(!K.setting&&!B.setting){if(K.value!==B.value)return!1}else return!1}return!0}e.areSame=f;function I(u){return u?c(u).length===0:!0}e.isEmpty=I;function D(u,l,m){const w=u?Object.keys(u).filter($=>!m.has($)):[],d=Object.keys(l).filter($=>!m.has($)),T=d.filter($=>w.indexOf($)===-1).reduce(($,K)=>($.add(K),$),new Set),_=w.filter($=>d.indexOf($)===-1).reduce(($,K)=>($.add(K),$),new Set),j=new Set;if(u)for(const $ of w){if(_.has($))continue;const K=u[$],B=l[$];y.equals(K,B)||j.add($)}return{added:T,removed:_,updated:j}}function E(u,l,m,w){const d=R.parse(l),T=c(l),_=c(m),j=b(u,T,_);return g(m,u,d[u],j,_,w)}e.addSetting=E;function b(u,l,m){const w=l.findIndex(T=>{var _;return((_=T.setting)===null||_===void 0?void 0:_.key)===u}),d=l[w-1];if(d){if(d.setting){const _=s(d.setting.key,m);if(_)return{index:m.indexOf(_),insertAfter:!0}}else{const _=t(w,l);if(_){const j=s(_.setting.key,m);if(j){const $=r(m.indexOf(j),m),K=i(l,_,l[w]);if($){const B=i(m,j,$),z=a(K,B);return z?{index:m.indexOf(z),insertAfter:!0}:{index:m.indexOf($),insertAfter:!1}}else{const B=i(m,j,m[m.length-1]),z=a(K,B);return z?{index:m.indexOf(z),insertAfter:!0}:{index:m.length-1,insertAfter:!0}}}}}const T=l[w+1];if(T)if(T.setting){const _=s(T.setting.key,m);if(_)return{index:m.indexOf(_),insertAfter:!1}}else{const _=r(w,l);if(_){const j=s(_.setting.key,m);if(j){const $=t(m.indexOf(j),m),K=i(l,l[w],_);if($){const B=i(m,$,j),z=a(K.reverse(),B.reverse());return z?{index:m.indexOf(z),insertAfter:!1}:{index:m.indexOf($),insertAfter:!0}}else{const B=i(m,m[0],j),z=a(K.reverse(),B.reverse());return z?{index:m.indexOf(z),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:m.length-1,insertAfter:!0}}function g(u,l,m,w,d,T){let _;return w.index===-1?_=L.setProperty(u,[l],m,T):_=o(u,l,m,w,d,T).map(j=>L.withFormatting(u,j,T)[0]),L.applyEdits(u,_)}function o(u,l,m,w,d,T){var _;const j=`${JSON.stringify(l)}: ${JSON.stringify(m)}`,$=A.getEOL(T,u),K=d[w.index];if(w.insertAfter){const B=[];if(K.setting)B.push({offset:K.endOffset,length:0,content:","+j});else{const z=r(w.index,d),G=t(w.index,d),V=(_=G==null?void 0:G.setting)===null||_===void 0?void 0:_.commaOffset;G&&V===void 0&&B.push({offset:G.endOffset,length:0,content:","});const M=V!==void 0&&V>K.endOffset;B.push({offset:M?V+1:K.endOffset,length:0,content:z?$+j+",":$+j})}return B}else{if(K.setting)return[{offset:K.startOffset,length:0,content:j+","}];const B=(d[w.index-1]&&!d[w.index-1].setting?$:"")+j+(r(w.index,d)?",":"")+$;return[{offset:K.startOffset,length:0,content:B}]}}function s(u,l){return l.filter(m=>{var w;return((w=m.setting)===null||w===void 0?void 0:w.key)===u})[0]}function t(u,l){for(let m=u-1;m>=0;m--)if(l[m].setting)return l[m]}function r(u,l){for(let m=u+1;m<l.length;m++)if(l[m].setting)return l[m]}function i(u,l,m){const w=u.indexOf(l),d=u.indexOf(m);return u.filter((T,_)=>w<_&&_<d)}function a(u,l){if(u.length&&l.length){let m=0;for(;m<l.length&&m<u.length;m++)if(u[m].value!==l[m].value)return l[m-1];return l[m-1]}}function c(u){const l=[];let m=-1,w,d;const T={onObjectBegin:_=>{m++},onObjectProperty:(_,j,$)=>{m===0&&(w=j,d=_)},onObjectEnd:(_,j)=>{m--,m===0&&l.push({startOffset:w,endOffset:_+j,value:u.substring(w,_+j),setting:{key:d,commaOffset:void 0}})},onArrayBegin:(_,j)=>{m++},onArrayEnd:(_,j)=>{m--,m===0&&l.push({startOffset:w,endOffset:_+j,value:u.substring(w,_+j),setting:{key:d,commaOffset:void 0}})},onLiteralValue:(_,j,$)=>{m===0&&l.push({startOffset:w,endOffset:j+$,value:u.substring(w,j+$),setting:{key:d,commaOffset:void 0}})},onSeparator:(_,j,$)=>{if(m===0&&_===","){let K=l.length-1;for(;K>=0&&!l[K].setting;K--);const B=l[K];B&&l.splice(K,1,{startOffset:B.startOffset,endOffset:B.endOffset,value:B.value,setting:{key:B.setting.key,commaOffset:j}})}},onComment:(_,j)=>{m===0&&l.push({startOffset:_,endOffset:_+j,value:u.substring(_,_+j)})}};return R.visit(u,T),l}}),define(Z[192],ee([0,1,10,21,25,124,3,9,23,191,52,46,24,28,20,40]),function(H,e,y,R,L,A,O,P,p,S,n,v,h,C,f,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function D(s){return s&&s.settings&&typeof s.settings=="string"&&Object.keys(s).length===1}function E(s){const t=JSON.parse(s);return D(t)?t:{settings:s}}e.parseSettingsSyncContent=E;let b=class extends v.AbstractJsonFileSynchroniser{constructor(t,r,i,a,c,u,l,m,w,d,T){super(r.settingsResource,"settings",t,r,i,a,c,w,d,u,l,m);this.extensionManagementService=T,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.localResource=this.previewResource.with({scheme:R.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:R.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:R.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async generateSyncPreview(t,r,i){const a=await this.getLocalFileContent(),c=await this.getFormattingOptions(),u=this.getSettingsSyncContent(t),l=r?this.getSettingsSyncContent(r):null,m=await this.getIgnoredSettings();let w=null,d=!1,T=!1,_=!1;if(u){let $=a?a.value.toString().trim():"{}";$=$||"{}",this.validateContent($),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const K=S.merge($,u.settings,l?l.settings:null,m,[],c);w=K.localContent||K.remoteContent,d=K.localContent!==null,T=K.remoteContent!==null,_=K.hasConflicts}else a&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),w=a.value.toString(),T=!0);const j={content:w,localChange:d?2:0,remoteChange:T?2:0,hasConflicts:_};return[{fileContent:a,localResource:this.localResource,localContent:a?a.value.toString():null,localChange:j.localChange,remoteResource:this.remoteResource,remoteContent:u?u.settings:null,remoteChange:j.remoteChange,previewResource:this.previewResource,previewResult:j,acceptedResource:this.acceptedResource}]}async getMergeResult(t,r){const i=await this.getFormattingOptions(),a=await this.getIgnoredSettings();return Object.assign(Object.assign({},t.previewResult),{content:t.previewResult.content?S.updateIgnoredSettings(t.previewResult.content,"{}",a,i):null})}async getAcceptResult(t,r,i,a){const c=await this.getFormattingOptions(),u=await this.getIgnoredSettings();if(this.extUri.isEqual(r,this.localResource))return{content:t.fileContent?S.updateIgnoredSettings(t.fileContent.value.toString(),"{}",u,c):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(r,this.remoteResource))return{content:t.remoteContent!==null?S.updateIgnoredSettings(t.remoteContent,t.fileContent?t.fileContent.value.toString():"{}",u,c):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(r,this.previewResource))return i===void 0?{content:t.previewResult.content,localChange:t.previewResult.localChange,remoteChange:t.previewResult.remoteChange}:{content:i!==null?S.updateIgnoredSettings(i,t.fileContent?t.fileContent.value.toString():"{}",u,c):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${r.toString()}`)}async applyResult(t,r,i,a){const{fileContent:c}=i[0][0];let{content:u,localChange:l,remoteChange:m}=i[0][1];if(l===0&&m===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),u=u?u.trim():"{}",u=u||"{}",this.validateContent(u),l!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),c&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(c.value.toString()))),await this.updateLocalFileContent(u,c,a),await this.configurationService.reloadConfiguration(2),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),m!==0){const w=await this.getFormattingOptions(),d=this.getSettingsSyncContent(t),T=await this.getIgnoredSettings(u);u=S.updateIgnoredSettings(u,d?d.settings:"{}",T,w),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),t=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(u)),a?null:t.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch(w){}(r==null?void 0:r.ref)!==t.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(t),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const t=await this.getLocalFileContent();if(t){const r=await this.getFormattingOptions(),i=n.edit(t.value.toString(),[R.CONFIGURATION_SYNC_STORE_KEY],void 0,r);return!S.isEmpty(i)}}catch(t){if(t.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:t}){const r=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(t,"settings.json"),comparableResource:r}]}async resolveContent(t){if(this.extUri.isEqual(this.remoteResource,t)||this.extUri.isEqual(this.localResource,t)||this.extUri.isEqual(this.acceptedResource,t))return this.resolvePreviewContent(t);let r=await super.resolveContent(t);if(r)return r;if(r=await super.resolveContent(this.extUri.dirname(t)),r){const i=this.parseSyncData(r);if(i){const a=this.parseSettingsSyncContent(i.content);if(a)switch(this.extUri.basename(t)){case"settings.json":return a.settings}}}return null}async resolvePreviewContent(t){let r=await super.resolvePreviewContent(t);if(r){const i=await this.getFormattingOptions(),a=await this.getIgnoredSettings();r=S.updateIgnoredSettings(r,"{}",a,i)}return r}getSettingsSyncContent(t){return t.syncData?this.parseSettingsSyncContent(t.syncData.content):null}parseSettingsSyncContent(t){try{return E(t)}catch(r){this.logService.error(r)}return null}toSettingsSyncContent(t){return{settings:t}}async getIgnoredSettings(t){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const i=O.Event.any(O.Event.filter(this.extensionManagementService.onDidInstallExtension,a=>!!a.gallery),O.Event.filter(this.extensionManagementService.onDidUninstallExtension,a=>!a.error))(()=>{i.dispose(),this._defaultIgnoredSettings=void 0})}const r=await this._defaultIgnoredSettings;return S.getIgnoredSettings(r,this.configurationService,t)}validateContent(t){if(this.hasErrors(t))throw new R.UserDataSyncError(A.localize(0,null),R.UserDataSyncErrorCode.LocalInvalidContent,this.resource)}async recoverSettings(){try{const t=await this.getLocalFileContent();if(!t)return;const r=JSON.parse(t.value.toString());if(!o(r))return;this.telemetryService.publicLog2("sync/settingsCorrupted");const i=this.parseSettingsSyncContent(r.content);if(!i||!i.settings)return;let a=i.settings;const c=await this.getFormattingOptions();for(const u in r)if(["version","content","machineId"].indexOf(u)===-1&&r[u]!==void 0){const l=I.setProperty(a,[u],r[u],c);l.length&&(a=I.applyEdits(a,l))}await this.fileService.writeFile(this.file,L.VSBuffer.fromString(a))}catch(t){}}};b=de([Y(0,y.IFileService),Y(1,P.IEnvironmentService),Y(2,f.IStorageService),Y(3,R.IUserDataSyncStoreService),Y(4,R.IUserDataSyncBackupStoreService),Y(5,R.IUserDataSyncLogService),Y(6,R.IUserDataSyncUtilService),Y(7,p.IConfigurationService),Y(8,R.IUserDataSyncResourceEnablementService),Y(9,h.ITelemetryService),Y(10,C.IExtensionManagementService)],b),e.SettingsSynchroniser=b;let g=class extends v.AbstractInitializer{constructor(t,r,i){super("settings",r,i,t)}async doInitialize(t){const r=t.syncData?this.parseSettingsSyncContent(t.syncData.content):null;if(!r){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.environmentService.settingsResource,L.VSBuffer.fromString(r.settings)),await this.updateLastSyncUserData(t)}async isEmpty(){try{const t=await this.fileService.readFile(this.environmentService.settingsResource);return S.isEmpty(t.value.toString().trim())}catch(t){return t.fileOperationResult===1}}parseSettingsSyncContent(t){try{return E(t)}catch(r){this.logService.error(r)}return null}};g=de([Y(0,y.IFileService),Y(1,P.IEnvironmentService),Y(2,R.IUserDataSyncLogService)],g),e.SettingsInitializer=g;function o(s){return!!(s&&s.version!==void 0&&typeof s.version=="number"&&s.content!==void 0&&typeof s.content=="string"&&s.machineId!==void 0&&typeof s.machineId=="string")}}),define(Z[193],ee([0,1,21,9,10,23,46,24,25,186,20,26,3]),function(H,e,y,R,L,A,O,P,p,S,n,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let C=class extends O.AbstractSynchroniser{constructor(D,E,b,g,o,s,t,r,i){super("snippets",E,D,b,g,o,r,i,s,t);this.version=1,this.snippetsFolder=D.snippetsHome,this._register(this.fileService.watch(D.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(h.Event.filter(this.fileService.onDidFilesChange,a=>a.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(D,E,b){const g=await this.getSnippetsFileContents(),o=this.toSnippetsContents(g),s=D.syncData?this.parseSnippets(D.syncData):null,t=E&&E.syncData?this.parseSnippets(E.syncData):null;s?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const r=S.merge(o,s,t);return this.getResourcePreviews(r,g,s||{})}async getMergeResult(D,E){return D.previewResult}async getAcceptResult(D,E,b,g){if(this.extUri.isEqualOrParent(E,this.syncPreviewFolder.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:D.fileContent?D.fileContent.value.toString():null,localChange:0,remoteChange:D.fileContent?D.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(E,this.syncPreviewFolder.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:D.remoteContent,localChange:D.remoteContent!==null?D.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(E,this.syncPreviewFolder))return b===void 0?{content:D.previewResult.content,localChange:D.previewResult.localChange,remoteChange:D.previewResult.remoteChange}:{content:b,localChange:b===null?D.fileContent!==null?3:0:2,remoteChange:b===null?D.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${E.toString()}`)}async applyResult(D,E,b,g){const o=b.map(([s,t])=>Object.assign(Object.assign({},s),{acceptResult:t}));o.every(({localChange:s,remoteChange:t})=>s===0&&t===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),o.some(({localChange:s})=>s!==0)&&(await this.updateLocalBackup(o),await this.updateLocalSnippets(o,g)),o.some(({remoteChange:s})=>s!==0)&&(D=await this.updateRemoteSnippets(o,D,g)),(E==null?void 0:E.ref)!==D.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(D),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:s}of o)try{await this.fileService.del(s)}catch(t){}}getResourcePreviews(D,E,b){const g=new Map;for(const o of Object.keys(D.local.added)){const s={content:D.local.added[o],hasConflicts:!1,localChange:1,remoteChange:0};g.set(o,{fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:b[o],previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of Object.keys(D.local.updated)){const s={content:D.local.updated[o],hasConflicts:!1,localChange:2,remoteChange:0};g.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:E[o],localContent:E[o].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:b[o],previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of D.local.removed){const s={content:null,hasConflicts:!1,localChange:3,remoteChange:0};g.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:E[o],localContent:E[o].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of Object.keys(D.remote.added)){const s={content:D.remote.added[o],hasConflicts:!1,localChange:0,remoteChange:1};g.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:E[o],localContent:E[o].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of Object.keys(D.remote.updated)){const s={content:D.remote.updated[o],hasConflicts:!1,localChange:0,remoteChange:2};g.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:E[o],localContent:E[o].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:b[o],previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of D.remote.removed){const s={content:null,hasConflicts:!1,localChange:0,remoteChange:3};g.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:b[o],previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of D.conflicts){const s={content:E[o]?E[o].value.toString():null,hasConflicts:!0,localChange:E[o]?2:1,remoteChange:b[o]?2:1};g.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:E[o]||null,localContent:E[o]?E[o].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:b[o]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of Object.keys(E))if(!g.has(o)){const s={content:E[o]?E[o].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0};g.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:E[o]||null,localContent:E[o]?E[o].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:b[o]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...g.values()]}async getAssociatedResources({uri:D}){let E=await super.resolveContent(D);if(E){const b=this.parseSyncData(E);if(b){const g=this.parseSnippets(b),o=[];for(const s of Object.keys(g)){const t=this.extUri.joinPath(D,s),r=this.extUri.joinPath(this.snippetsFolder,s),i=await this.fileService.exists(r);o.push({resource:t,comparableResource:i?r:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"})})}return o}}return[]}async resolveContent(D){if(this.extUri.isEqualOrParent(D,this.syncPreviewFolder.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(D,this.syncPreviewFolder.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(D,this.syncPreviewFolder.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(D);let E=await super.resolveContent(D);if(E)return E;if(E=await super.resolveContent(this.extUri.dirname(D)),E){const b=this.parseSyncData(E);if(b)return this.parseSnippets(b)[this.extUri.basename(D)]||null}return null}async hasLocalData(){try{const D=await this.getSnippetsFileContents();if(Object.keys(D).length)return!0}catch(D){}return!1}async updateLocalBackup(D){const E={};for(const b of D)b.fileContent&&(E[this.extUri.basename(b.localResource)]=b.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(E)))}async updateLocalSnippets(D,E){for(const{fileContent:b,acceptResult:g,localResource:o,remoteResource:s,localChange:t}of D)if(t!==0){const r=s?this.extUri.basename(s):this.extUri.basename(o),i=this.extUri.joinPath(this.snippetsFolder,r);t===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(i)),await this.fileService.del(i),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(i))):t===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(i)),await this.fileService.createFile(i,p.VSBuffer.fromString(g.content),{overwrite:E}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(i))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(i)),await this.fileService.writeFile(i,p.VSBuffer.fromString(g.content),E?void 0:b),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(i)))}}async updateRemoteSnippets(D,E,b){const g=E.syncData?this.parseSnippets(E.syncData):{},o=v.deepClone(g);for(const{acceptResult:s,localResource:t,remoteResource:r,remoteChange:i}of D)if(i!==0){const a=t?this.extUri.basename(t):this.extUri.basename(r);i===3?delete o[a]:o[a]=s.content}return S.areSame(g,o)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),E=await this.updateRemoteUserData(JSON.stringify(o),b?null:E.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),E}parseSnippets(D){return JSON.parse(D.content)}toSnippetsContents(D){const E={};for(const b of Object.keys(D))E[b]=D[b].value.toString();return E}async getSnippetsFileContents(){const D={};let E;try{E=await this.fileService.resolve(this.snippetsFolder)}catch(b){if(b instanceof L.FileOperationError&&b.fileOperationResult===1)return D;throw b}for(const b of E.children||[]){const g=b.resource,o=this.extUri.extname(g);if(o===".json"||o===".code-snippets"){const s=this.extUri.relativePath(this.snippetsFolder,g),t=await this.fileService.readFile(g);D[s]=t}}return D}};C=de([Y(0,R.IEnvironmentService),Y(1,L.IFileService),Y(2,n.IStorageService),Y(3,y.IUserDataSyncStoreService),Y(4,y.IUserDataSyncBackupStoreService),Y(5,y.IUserDataSyncLogService),Y(6,A.IConfigurationService),Y(7,y.IUserDataSyncResourceEnablementService),Y(8,P.ITelemetryService)],C),e.SnippetsSynchroniser=C;let f=class extends O.AbstractInitializer{constructor(D,E,b){super("snippets",E,b,D)}async doInitialize(D){const E=D.syncData?JSON.parse(D.syncData.content):null;if(!E){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const g of Object.keys(E)){const o=E[g];if(o){const s=this.extUri.joinPath(this.environmentService.snippetsHome,g);await this.fileService.createFile(s,p.VSBuffer.fromString(o)),this.logService.info("Created snippet",this.extUri.basename(s))}}await this.updateLastSyncUserData(D)}async isEmpty(){var D;try{return!((D=(await this.fileService.resolve(this.environmentService.snippetsHome)).children)===null||D===void 0?void 0:D.length)}catch(E){return E.fileOperationResult===1}}};f=de([Y(0,L.IFileService),Y(1,R.IEnvironmentService),Y(2,y.IUserDataSyncLogService)],f),e.SnippetsInitializer=f}),define(Z[60],ee([0,1,4,3,2,21]),function(H,e,y,R,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=y.createDecorator("IUserDataSyncAccountService");let O=class extends L.Disposable{constructor(p){super();this.userDataSyncStoreService=p,this._onDidChangeAccount=this._register(new R.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new R.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(p.onTokenFailed(()=>{this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(p.onTokenSucceed(()=>this.wasTokenFailed=!1))}get account(){return this._account}async updateAccount(p){(p&&this._account?p.token!==this._account.token||p.authenticationProviderId!==this._account.authenticationProviderId:p!==this._account)&&(this._account=p,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(p))}};O=de([Y(0,A.IUserDataSyncStoreService)],O),e.UserDataSyncAccountService=O}),define(Z[194],ee([0,1,2,21,14,23,10,9,55,25,8]),function(H,e,y,R,L,A,O,P,p,S,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let v=class extends y.Disposable{constructor(C,f,I,D){super();this.environmentService=C,this.fileService=f,this.configurationService=I,this.logService=D,R.ALL_SYNC_RESOURCES.forEach(E=>this.cleanUpBackup(E))}async getAllRefs(C){const f=L.joinPath(this.environmentService.userDataSyncHome,C),I=await this.fileService.resolve(f);return I.children?I.children.filter(E=>E.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(E.name)).sort().reverse().map(E=>({ref:E.name,created:this.getCreationTime(E)})):[]}async resolveContent(C,f){if(!f){const I=await this.getAllRefs(C);I.length&&(f=I[I.length-1].ref)}if(f){const I=L.joinPath(this.environmentService.userDataSyncHome,C,f);return(await this.fileService.readFile(I)).value.toString()}return null}async backup(C,f){const I=L.joinPath(this.environmentService.userDataSyncHome,C),D=L.joinPath(I,`${p.toLocalISOString(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(D,S.VSBuffer.fromString(f))}catch(E){this.logService.error(E)}try{this.cleanUpBackup(C)}catch(E){}}async cleanUpBackup(C){const f=L.joinPath(this.environmentService.userDataSyncHome,C);try{try{if(!await this.fileService.exists(f))return}catch(D){return}const I=await this.fileService.resolve(f);if(I.children){const D=I.children.filter(o=>o.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(o.name)).sort(),E=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let b=D.filter(o=>Date.now()-this.getCreationTime(o)>E);const g=D.length-b.length;g<10&&(b=b.slice(10-g)),await n.Promises.settled(b.map(async o=>{this.logService.info("Deleting from backup",o.resource.path),await this.fileService.del(o.resource)}))}}catch(I){this.logService.error(I)}}getCreationTime(C){return C.ctime||new Date(parseInt(C.name.substring(0,4)),parseInt(C.name.substring(4,6))-1,parseInt(C.name.substring(6,8)),parseInt(C.name.substring(9,11)),parseInt(C.name.substring(11,13)),parseInt(C.name.substring(13,15))).getTime()}};v=de([Y(0,P.IEnvironmentService),Y(1,O.IFileService),Y(2,A.IConfigurationService),Y(3,R.IUserDataSyncLogService)],v),e.UserDataSyncBackupStoreService=v}),define(Z[195],ee([0,1,5,2]),function(H,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class L{constructor(h){this.service=h}listen(h,C){switch(C){case"onError":return this.service.onError}throw new Error(`Event not found: ${C}`)}call(h,C,f){switch(C){case"triggerSync":return this.service.triggerSync(f[0],f[1],f[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(f[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=L;class A{constructor(h){this.service=h}listen(h,C){throw new Error(`Event not found: ${C}`)}call(h,C,f){switch(C){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(f[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(y.URI.revive(f[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=A;class O{constructor(h){this.channel=h}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(h){return this.channel.call("resolveUserKeybindings",[h])}async resolveFormattingOptions(h){return this.channel.call("resolveFormattingOptions",[h])}}e.UserDataSyncUtilServiceClient=O;class P{constructor(h){this.service=h}listen(h,C){switch(C){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${C}`)}async call(h,C,f){switch(C){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(f[0],f[1]);case"setEnablement":return this.service.setEnablement(f[0],f[1])}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=P;class p{constructor(h){this.service=h}listen(h,C){switch(C){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${C}`)}call(h,C,f){switch(C){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(f)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=p;class S{constructor(h){this.service=h}listen(h,C){switch(C){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${C}`)}call(h,C,f){switch(C){case"switch":return this.service.switch(f[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=S;class n extends R.Disposable{constructor(h){super();this.channel=h,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(h){return this.channel.call("switch",[h])}async getPreviousUserDataSyncStore(){const h=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(h)}revive(h){return{url:y.URI.revive(h.url),type:h.type,defaultUrl:y.URI.revive(h.defaultUrl),insidersUrl:y.URI.revive(h.insidersUrl),stableUrl:y.URI.revive(h.stableUrl),canSwitch:h.canSwitch,authenticationProviders:h.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=n}),define(Z[196],ee([0,1,18,9]),function(H,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let L=class extends y.AbstractLogger{constructor(O,P){super();this.logger=this._register(O.createLogger(P.userDataSyncLogResource,{name:"settingssync"}))}trace(O,...P){this.logger.trace(O,...P)}debug(O,...P){this.logger.debug(O,...P)}info(O,...P){this.logger.info(O,...P)}warn(O,...P){this.logger.warn(O,...P)}error(O,...P){this.logger.error(O,...P)}critical(O,...P){this.logger.critical(O,...P)}flush(){this.logger.flush()}};L=de([Y(0,y.ILoggerService),Y(1,R.IEnvironmentService)],L),e.UserDataSyncLogService=L}),define(Z[61],ee([0,1,4,2,45,9,10,20,21,127,27,6,22,3]),function(H,e,y,R,L,A,O,P,p,S,n,v,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=y.createDecorator("IUserDataSyncMachinesService");const f="sync.currentMachineName";let I=class Ge extends R.Disposable{constructor(E,b,g,o,s,t){super();this.storageService=g,this.userDataSyncStoreService=o,this.logService=s,this.productService=t,this._onDidChange=this._register(new C.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=L.getServiceMachineId(E,b,g)}async getMachines(E){const b=await this.currentMachineIdPromise;return(await this.readMachinesData(E)).machines.map(o=>Object.assign(Object.assign({},o),{isCurrent:o.id===b}))}async addCurrentMachine(E){const b=await this.currentMachineIdPromise,g=await this.readMachinesData(E);g.machines.some(({id:o})=>o===b)||(g.machines.push({id:b,name:this.computeCurrentMachineName(g.machines)}),await this.writeMachinesData(g))}async removeCurrentMachine(E){const b=await this.currentMachineIdPromise,g=await this.readMachinesData(E),o=g.machines.filter(({id:s})=>s!==b);o.length!==g.machines.length&&(g.machines=o,await this.writeMachinesData(g))}async renameMachine(E,b,g){const o=await this.currentMachineIdPromise,s=await this.readMachinesData(g),t=s.machines.find(({id:r})=>r===E);t&&(t.name=b,await this.writeMachinesData(s),s.machines.some(({id:r})=>r===o)&&this.storageService.store(f,b,0,1))}async setEnablement(E,b){const g=await this.readMachinesData(),o=g.machines.find(({id:s})=>s===E);o&&(o.disabled=b?void 0:!0,await this.writeMachinesData(g))}computeCurrentMachineName(E){const b=this.storageService.get(f,0);if(b)return b;const g=`${this.productService.nameLong} (${v.PlatformToString(v.isWeb?0:v.platform)})`,o=new RegExp(`${h.escapeRegExpCharacters(g)}\\s#(\\d+)`);let s=0;for(const t of E){const r=o.exec(t.name),i=r?parseInt(r[1]):0;s=i>s?i:s}return`${g} #${s+1}`}async readMachinesData(E){this.userData=await this.readUserData(E);const b=this.parse(this.userData);if(b.version!==Ge.VERSION)throw new Error(S.localize(0,null,this.productService.nameLong));return b}async writeMachinesData(E){var b;const g=JSON.stringify(E),o=await this.userDataSyncStoreService.write(Ge.RESOURCE,g,((b=this.userData)===null||b===void 0?void 0:b.ref)||null);this.userData={ref:o,content:g},this._onDidChange.fire()}async readUserData(E){if(this.userData){const b=E&&E.latest?E.latest[Ge.RESOURCE]:void 0;if(this.userData.ref===b)return this.userData;if(b===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.read(Ge.RESOURCE,this.userData)}parse(E){if(E.content!==null)try{return JSON.parse(E.content)}catch(b){this.logService.error(b)}return{version:Ge.VERSION,machines:[]}}};I.VERSION=1,I.RESOURCE="machines",I=de([Y(0,A.IEnvironmentService),Y(1,O.IFileService),Y(2,P.IStorageService),Y(3,p.IUserDataSyncStoreService),Y(4,p.IUserDataSyncLogService),Y(5,n.IProductService)],I),e.UserDataSyncMachinesService=I}),define(Z[86],ee([0,1,8,3,2,21,60,24,11,20,9,61,125,55,5,14,6,27]),function(H,e,y,R,L,A,O,P,p,S,n,v,h,C,f,I,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=e.UserDataAutoSyncEnablementService=void 0;const b="sync.enable",g="sync.disableMachineEventually",o="sync.sessionId",s="sync.storeUrl",t="sync.productQuality";let r=class extends L.Disposable{constructor(u,l,m){super();this.storageService=u,this.environmentService=l,this.userDataSyncStoreManagementService=m,this._onDidChangeEnablement=new R.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._register(u.onDidChangeValue(w=>this.onDidStorageChange(w)))}isEnabled(u){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(b,0,!!u)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(u){u&&!this.canToggleEnablement()||this.storageService.store(b,u,0,1)}onDidStorageChange(u){if(u.scope===0&&b===u.key){this._onDidChangeEnablement.fire(this.isEnabled());return}}};r=de([Y(0,S.IStorageService),Y(1,n.IEnvironmentService),Y(2,A.IUserDataSyncStoreManagementService)],r),e.UserDataAutoSyncEnablementService=r;let i=class extends L.Disposable{constructor(u,l,m,w,d,T,_,j,$,K,B){var z;super();this.userDataSyncStoreManagementService=l,this.userDataSyncStoreService=m,this.userDataSyncResourceEnablementService=w,this.userDataSyncService=d,this.logService=T,this.userDataSyncAccountService=_,this.telemetryService=j,this.userDataSyncMachinesService=$,this.storageService=K,this.autoSync=this._register(new L.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this.sources=[],this.userDataAutoSyncEnablementService=B,this.syncTriggerDelayer=this._register(new y.Delayer(0)),this.lastSyncUrl=this.syncUrl,this.syncUrl=(z=l.userDataSyncStore)===null||z===void 0?void 0:z.url,this.previousProductQuality=this.productQuality,this.productQuality=u.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(l.onDidChangeUserDataSyncStore(()=>{var G,V;I.isEqual(this.syncUrl,(G=l.userDataSyncStore)===null||G===void 0?void 0:G.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=(V=l.userDataSyncStore)===null||V===void 0?void 0:V.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataAutoSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(_.onDidChangeAccount(()=>this.updateAutoSync())),this._register(m.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(R.Event.debounce(d.onDidChangeLocal,(G,V)=>G?[...G,V]:[V],1e3)(G=>this.triggerSync(G,!1,!1))),this._register(R.Event.filter(this.userDataSyncResourceEnablementService.onDidChangeResourceEnablement,([,G])=>G)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}get syncUrl(){const u=this.storageService.get(s,0);return u?f.URI.parse(u):void 0}set syncUrl(u){u?this.storageService.store(s,u.toString(),0,1):this.storageService.remove(s,0)}get productQuality(){return this.storageService.get(t,0)}set productQuality(u){u?this.storageService.store(t,u,0,1):this.storageService.remove(t,0)}updateAutoSync(){const{enabled:u,message:l}=this.isAutoSyncEnabled();u?this.autoSync.value===void 0&&(this.autoSync.value=new a(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(m=>this.onDidFinishSync(m))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(l&&this.logService.info(l),this.autoSync.clear()):l&&this.userDataAutoSyncEnablementService.isEnabled()&&this.logService.info(l))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataAutoSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${C.toLocalISOString(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(u,l,m){try{this.userDataSyncAccountService.account&&!m&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(o,0),u?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(w){if(l)this.logService.error(w),this.updateEnablement(!1);else throw w}}updateEnablement(u){this.userDataAutoSyncEnablementService.isEnabled()!==u&&(this.telemetryService.publicLog2(b,{enabled:u}),this.userDataAutoSyncEnablementService.setEnablement(u),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(u){if(!u){this.successiveFailures=0;return}const l=A.UserDataSyncError.toUserDataSyncError(u);l instanceof A.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:l.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),l.code===A.UserDataSyncErrorCode.SessionExpired?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):l.code===A.UserDataSyncErrorCode.TurnedOff?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):l.code===A.UserDataSyncErrorCode.LocalTooManyRequests||l.code===A.UserDataSyncErrorCode.TooManyRequests?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):l.code===A.UserDataSyncErrorCode.UpgradeRequired||l.code===A.UserDataSyncErrorCode.Gone?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):l.code===A.UserDataSyncErrorCode.IncompatibleLocalContent?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${l.resource} content with newer version than of client. Requires client upgrade.`)):l.code===A.UserDataSyncErrorCode.IncompatibleRemoteContent?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${l.resource} content with older version than of client. Requires server reset.`)):l.code===A.UserDataSyncErrorCode.ServiceChanged||l.code===A.UserDataSyncErrorCode.DefaultServiceChanged?D.isWeb&&l.code===A.UserDataSyncErrorCode.DefaultServiceChanged&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(l),this.successiveFailures++),this._onError.fire(l)}async disableMachineEventually(){this.storageService.store(g,!0,0,1),await y.timeout(1e3*60*10),!!this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataAutoSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(g,0,!1)}stopDisableMachineEventually(){this.storageService.remove(g,0)}async triggerSync(u,l,m){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(l&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...u),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",m)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 1e3}};i=de([Y(0,E.IProductService),Y(1,A.IUserDataSyncStoreManagementService),Y(2,A.IUserDataSyncStoreService),Y(3,A.IUserDataSyncResourceEnablementService),Y(4,A.IUserDataSyncService),Y(5,A.IUserDataSyncLogService),Y(6,O.IUserDataSyncAccountService),Y(7,P.ITelemetryService),Y(8,v.IUserDataSyncMachinesService),Y(9,S.IStorageService),Y(10,A.IUserDataAutoSyncEnablementService)],i),e.UserDataAutoSyncService=i;class a extends L.Disposable{constructor(u,l,m,w,d,T,_,j){super();this.lastSyncUrl=u,this.interval=l,this.userDataSyncStoreManagementService=m,this.userDataSyncStoreService=w,this.userDataSyncService=d,this.userDataSyncMachinesService=T,this.logService=_,this.storageService=j,this.intervalHandler=this._register(new L.MutableDisposable),this._onDidStartSync=this._register(new R.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new R.Emitter),this.onDidFinishSync=this._onDidFinishSync.event}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register(L.toDisposable(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask&&this.syncTask.stop(),this.logService.info("Auto Sync: Stopped")})),this.logService.info("Auto Sync: Started"),this.sync(a.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=y.disposableTimeout(()=>this.sync(a.INTERVAL_SYNCING,!1),this.interval)}sync(u,l){const m=y.createCancelablePromise(async w=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(d){if(p.isPromiseCanceledError(d))return}return this.doSync(u,l,w)});return this.syncPromise=m,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){var u;return this.lastSyncUrl!==void 0&&!I.isEqual(this.lastSyncUrl,(u=this.userDataSyncStoreManagementService.userDataSyncStore)===null||u===void 0?void 0:u.url)}async hasDefaultServiceChanged(){const u=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),l=this.userDataSyncStoreManagementService.userDataSyncStore;return!!l&&!!u&&(!I.isEqual(l.defaultUrl,u.defaultUrl)||!I.isEqual(l.insidersUrl,u.insidersUrl)||!I.isEqual(l.stableUrl,u.stableUrl))}async doSync(u,l,m){this.logService.info(`Auto Sync: Triggered by ${u}`),this._onDidStartSync.fire();let w;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(l),m.isCancellationRequested)return;let d=this.syncTask.manifest;if(d===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new A.UserDataAutoSyncError(h.localize(0,null),A.UserDataSyncErrorCode.DefaultServiceChanged):new A.UserDataAutoSyncError(h.localize(1,null),A.UserDataSyncErrorCode.ServiceChanged):new A.UserDataAutoSyncError(h.localize(2,null),A.UserDataSyncErrorCode.TurnedOff);const T=this.storageService.get(o,0);if(T&&d&&T!==d.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new A.UserDataAutoSyncError(h.localize(3,null),A.UserDataSyncErrorCode.DefaultServiceChanged):new A.UserDataAutoSyncError(h.localize(4,null),A.UserDataSyncErrorCode.ServiceChanged):new A.UserDataAutoSyncError(h.localize(5,null),A.UserDataSyncErrorCode.SessionExpired);const _=await this.userDataSyncMachinesService.getMachines(d||void 0);if(m.isCancellationRequested)return;const j=_.find($=>$.isCurrent);if(j==null?void 0:j.disabled)throw new A.UserDataAutoSyncError(h.localize(6,null),A.UserDataSyncErrorCode.TurnedOff);if(await this.syncTask.run(),d===null&&(d=await this.userDataSyncStoreService.manifest()),d&&d.session!==T&&this.storageService.store(o,d.session,0,1),m.isCancellationRequested)return;j||await this.userDataSyncMachinesService.addCurrentMachine(d||void 0)}catch(d){this.logService.error(d),w=d}this._onDidFinishSync.fire(w)}register(u){return super._register(u)}}a.INTERVAL_SYNCING="Interval"}),define(Z[197],ee([0,1,21,2,3,20,24,6]),function(H,e,y,R,L,A,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceEnablementService=void 0;let p=class extends R.Disposable{constructor(n,v){super();this.storageService=n,this.telemetryService=v,this._onDidChangeResourceEnablement=new L.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(n.onDidChangeValue(h=>this.onDidStorageChange(h)))}isResourceEnabled(n){return this.storageService.getBoolean(y.getEnablementKey(n),0,!0)}setResourceEnablement(n,v){if(this.isResourceEnabled(n)!==v){const h=y.getEnablementKey(n);this.telemetryService.publicLog2(h,{enabled:v}),this.storeResourceEnablement(h,v)}}getResourceSyncStateVersion(n){}storeResourceEnablement(n,v){this.storageService.store(n,v,0,P.isWeb?0:1)}onDidStorageChange(n){if(n.scope===0){const v=y.ALL_SYNC_RESOURCES.filter(h=>y.getEnablementKey(h)===n.key)[0];if(v){this._onDidChangeResourceEnablement.fire([v,this.isResourceEnabled(v)]);return}}}};p=de([Y(0,A.IStorageService),Y(1,O.ITelemetryService)],p),e.UserDataSyncResourceEnablementService=p}),define(Z[198],ee([0,1,21,2,4,3,187,190,189,44,24,19,20,192,14,193,30,8,11]),function(H,e,y,R,L,A,O,P,p,S,n,v,h,C,f,I,D,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const g="sync.lastSyncTime";let o=class extends R.Disposable{constructor(i,a,c,u,l,m){super();this.userDataSyncStoreService=i,this.userDataSyncStoreManagementService=a,this.instantiationService=c,this.logService=u,this.telemetryService=l,this.storageService=m,this._status="uninitialized",this._onDidChangeStatus=this._register(new A.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new A.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new A.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new A.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new A.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new A.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.recoveredSettings=!1,this.settingsSynchroniser=this._register(this.instantiationService.createInstance(C.SettingsSynchroniser)),this.keybindingsSynchroniser=this._register(this.instantiationService.createInstance(P.KeybindingsSynchroniser)),this.snippetsSynchroniser=this._register(this.instantiationService.createInstance(I.SnippetsSynchroniser)),this.globalStateSynchroniser=this._register(this.instantiationService.createInstance(p.GlobalStateSynchroniser)),this.extensionsSynchroniser=this._register(this.instantiationService.createInstance(O.ExtensionsSynchroniser)),this.synchronisers=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.globalStateSynchroniser,this.extensionsSynchroniser],this.updateStatus(),this.userDataSyncStoreManagementService.userDataSyncStore&&(this._register(A.Event.any(...this.synchronisers.map(w=>A.Event.map(w.onDidChangeStatus,()=>{})))(()=>this.updateStatus())),this._register(A.Event.any(...this.synchronisers.map(w=>A.Event.map(w.onDidChangeConflicts,()=>{})))(()=>this.updateConflicts()))),this._lastSyncTime=this.storageService.getNumber(g,0,void 0),this.onDidChangeLocal=A.Event.any(...this.synchronisers.map(w=>A.Event.map(w.onDidChangeLocal,()=>w.resource)))}get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}async createSyncTask(i){await this.checkEnablement();const a=D.generateUuid();let c;try{const w=y.createSyncHeaders(a);i&&(w["Cache-Control"]="no-cache"),c=await this.userDataSyncStoreService.manifest(w)}catch(w){const d=y.UserDataSyncError.toUserDataSyncError(w);throw this.reportUserDataSyncError(d,a),d}let u=!1;const l=this;let m;return{manifest:c,run(){if(u)throw new Error("Can run a task only once");return m=E.createCancelablePromise(w=>l.sync(c,a,w)),m.finally(()=>m=void 0)},async stop(){if(m&&m.cancel(),l.status!=="idle")return l.stop()}}}async createManualSyncTask(){await this.checkEnablement();const i=D.generateUuid(),a=y.createSyncHeaders(i);let c;try{c=await this.userDataSyncStoreService.manifest(a)}catch(u){const l=y.UserDataSyncError.toUserDataSyncError(u);throw this.reportUserDataSyncError(l,i),l}return new s(i,c,a,this.synchronisers,this.logService)}async sync(i,a,c){if(this.recoveredSettings||(await this.settingsSynchroniser.recoverSettings(),this.recoveredSettings=!0),c.isCancellationRequested)return;const u=new Date().getTime();this._syncErrors=[];try{this.logService.trace("Sync started."),this.status!=="hasConflicts"&&this.setStatus("syncing");const l=y.createSyncHeaders(a);for(const m of this.synchronisers){if(c.isCancellationRequested)return;try{await m.sync(i,l)}catch(w){if(w instanceof y.UserDataSyncError)switch(w.code){case y.UserDataSyncErrorCode.TooLarge:throw new y.UserDataSyncError(w.message,w.code,m.resource);case y.UserDataSyncErrorCode.TooManyRequests:case y.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter:case y.UserDataSyncErrorCode.LocalTooManyRequests:case y.UserDataSyncErrorCode.Gone:case y.UserDataSyncErrorCode.UpgradeRequired:case y.UserDataSyncErrorCode.IncompatibleRemoteContent:case y.UserDataSyncErrorCode.IncompatibleLocalContent:throw w}const d=y.UserDataSyncError.toUserDataSyncError(w);this.reportUserDataSyncError(d,a),this.logService.error(w),this.logService.error(`${m.resource}: ${S.toErrorMessage(w)}`),this._syncErrors.push([m.resource,d])}}this.logService.info(`Sync done. Took ${new Date().getTime()-u}ms`),this.updateLastSyncTime()}catch(l){const m=y.UserDataSyncError.toUserDataSyncError(l);throw this.reportUserDataSyncError(m,a),m}finally{this.updateStatus(),this._onSyncErrors.fire(this._syncErrors)}}async stop(){if(this.status!=="idle")for(const i of this.synchronisers)try{i.status!=="idle"&&await i.stop()}catch(a){this.logService.error(a)}}async replace(i){await this.checkEnablement();for(const a of this.synchronisers)if(await a.replace(i))return}async accept(i,a,c,u){await this.checkEnablement();const l=this.getSynchroniser(i);await l.accept(a,c),u&&await l.apply(!1,y.createSyncHeaders(D.generateUuid()))}async resolveContent(i){for(const a of this.synchronisers){const c=await a.resolveContent(i);if(c)return c}return null}getRemoteSyncResourceHandles(i){return this.getSynchroniser(i).getRemoteSyncResourceHandles()}getLocalSyncResourceHandles(i){return this.getSynchroniser(i).getLocalSyncResourceHandles()}getAssociatedResources(i,a){return this.getSynchroniser(i).getAssociatedResources(a)}getMachineId(i,a){return this.getSynchroniser(i).getMachineId(a)}async hasLocalData(){const i=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.extensionsSynchroniser];for(const a of i)if(await a.hasLocalData())return!0;return!1}async reset(){await this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){await this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(i){this.logService.error(i)}this._onDidResetRemote.fire()}async resetLocal(){await this.checkEnablement(),this.storageService.remove(g,0);for(const i of this.synchronisers)try{await i.resetLocal()}catch(a){this.logService.error(`${i.resource}: ${S.toErrorMessage(a)}`),this.logService.error(a)}this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async hasPreviouslySynced(){for(const i of this.synchronisers)if(await i.hasPreviouslySynced())return!0;return!1}setStatus(i){const a=this._status;this._status!==i&&(this._status=i,this._onDidChangeStatus.fire(i),a==="hasConflicts"&&this.updateLastSyncTime())}updateStatus(){this.updateConflicts();const i=this.computeStatus();this.setStatus(i)}updateConflicts(){const i=this.computeConflicts();v.equals(this._conflicts,i,([a,c],[u,l])=>a===a&&v.equals(c,l,(m,w)=>f.isEqual(m.previewResource,w.previewResource)))||(this._conflicts=this.computeConflicts(),this._onDidChangeConflicts.fire(i))}computeStatus(){return this.userDataSyncStoreManagementService.userDataSyncStore?this.synchronisers.some(i=>i.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(i=>i.status==="syncing")?"syncing":"idle":"uninitialized"}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(g,this._lastSyncTime,0,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}reportUserDataSyncError(i,a){this.telemetryService.publicLog2("sync/error",{code:i.code,url:i instanceof y.UserDataSyncStoreError?i.url:void 0,resource:i.resource,executionId:a,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()})}computeConflicts(){return this.synchronisers.filter(i=>i.status==="hasConflicts").map(i=>[i.resource,i.conflicts.map(t)])}getSynchroniser(i){return this.synchronisers.find(a=>a.resource===i)}async checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};o=de([Y(0,y.IUserDataSyncStoreService),Y(1,y.IUserDataSyncStoreManagementService),Y(2,L.IInstantiationService),Y(3,y.IUserDataSyncLogService),Y(4,n.ITelemetryService),Y(5,h.IStorageService)],o),e.UserDataSyncService=o;class s extends R.Disposable{constructor(i,a,c,u,l){super();this.id=i,this.manifest=a,this.syncHeaders=c,this.synchronisers=u,this.logService=l,this.synchronizingResources=[],this._onSynchronizeResources=this._register(new A.Emitter),this.onSynchronizeResources=this._onSynchronizeResources.event,this.isDisposed=!1}get status(){return this.synchronisers.some(i=>i.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(i=>i.status==="syncing")?"syncing":"idle"}async preview(){try{if(this.isDisposed)throw new Error("Disposed");return this.previewsPromise||(this.previewsPromise=E.createCancelablePromise(i=>this.getPreviews(i))),this.previews||(this.previews=await this.previewsPromise),this.previews}catch(i){throw this.logService.error(i),i}}async accept(i,a){try{return await this.performAction(i,c=>c.accept(i,a))}catch(c){throw this.logService.error(c),c}}async merge(i){try{return i?await this.performAction(i,a=>a.merge(i)):await this.mergeAll()}catch(a){throw this.logService.error(a),a}}async discard(i){try{return await this.performAction(i,a=>a.discard(i))}catch(a){throw this.logService.error(a),a}}async discardConflicts(){try{if(!this.previews)throw new Error("Missing preview. Create preview and try again.");if(this.synchronizingResources.length)throw new Error("Cannot discard while synchronizing resources");const i=[];for(const[,a]of this.previews)for(const c of a.resourcePreviews)c.mergeState==="conflict"&&i.push(c.previewResource);for(const a of i)await this.discard(a);return this.previews}catch(i){throw this.logService.error(i),i}}async apply(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");const i=[];for(const[a,c]of this.previews){this.synchronizingResources.push([a,c.resourcePreviews.map(m=>m.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const u=this.synchronisers.find(m=>m.resource===a);for(const m of c.resourcePreviews)(m.localChange!==0||m.remoteChange!==0)&&m.mergeState==="preview"&&await u.merge(m.previewResource);const l=await u.apply(!1,this.syncHeaders);l&&i.push(this.toSyncResourcePreview(u.resource,l)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(m=>m[0]===a),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=i,this.previews}catch(i){throw this.logService.error(i),i}}async pull(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[i,a]of this.previews){this.synchronizingResources.push([i,a.resourcePreviews.map(u=>u.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const c=this.synchronisers.find(u=>u.resource===i);for(const u of a.resourcePreviews)await c.accept(u.remoteResource);await c.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(u=>u[0]===i),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(i){throw this.logService.error(i),i}}async push(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[i,a]of this.previews){this.synchronizingResources.push([i,a.resourcePreviews.map(u=>u.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const c=this.synchronisers.find(u=>u.resource===i);for(const u of a.resourcePreviews)await c.accept(u.localResource);await c.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(u=>u[0]===i),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(i){throw this.logService.error(i),i}}async stop(){for(const i of this.synchronisers)try{await i.stop()}catch(a){b.isPromiseCanceledError(a)||this.logService.error(a)}this.reset()}async performAction(i,a){if(!this.previews)throw new Error("Missing preview. Create preview and try again.");const c=this.previews.findIndex(([,j])=>j.resourcePreviews.some(({localResource:$,previewResource:K,remoteResource:B})=>f.isEqual(i,$)||f.isEqual(i,K)||f.isEqual(i,B)));if(c===-1)return this.previews;const[u,l]=this.previews[c],m=l.resourcePreviews.find(({localResource:j,remoteResource:$,previewResource:K})=>f.isEqual(j,i)||f.isEqual($,i)||f.isEqual(K,i));if(!m)return this.previews;let w=this.synchronizingResources.find(j=>j[0]===u);w||(w=[u,[]],this.synchronizingResources.push(w)),w[1].some(j=>f.isEqual(j,m.localResource))||(w[1].push(m.localResource),this._onSynchronizeResources.fire(this.synchronizingResources));const d=this.synchronisers.find(j=>j.resource===this.previews[c][0]),T=await a(d);T?this.previews.splice(c,1,this.toSyncResourcePreview(d.resource,T)):this.previews.splice(c,1);const _=this.synchronizingResources.findIndex(j=>j[0]===u);return this.synchronizingResources[_][1].splice(w[1].findIndex(j=>f.isEqual(j,m.localResource)),1),w[1].length||(this.synchronizingResources.splice(_,1),this._onSynchronizeResources.fire(this.synchronizingResources)),this.previews}async mergeAll(){if(!this.previews)throw new Error("You need to create preview before merging or applying");if(this.synchronizingResources.length)throw new Error("Cannot merge or apply while synchronizing resources");const i=[];for(const[a,c]of this.previews){this.synchronizingResources.push([a,c.resourcePreviews.map(m=>m.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const u=this.synchronisers.find(m=>m.resource===a);let l=c;for(const m of c.resourcePreviews)(m.localChange!==0||m.remoteChange!==0)&&m.mergeState==="preview"&&(l=await u.merge(m.previewResource));l&&i.push(this.toSyncResourcePreview(u.resource,l)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(m=>m[0]===a),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=i,this.previews}async getPreviews(i){const a=[];for(const c of this.synchronisers){if(i.isCancellationRequested)return[];const u=await c.preview(this.manifest,this.syncHeaders);u&&a.push(this.toSyncResourcePreview(c.resource,u))}return a}toSyncResourcePreview(i,a){return[i,{isLastSyncFromCurrentMachine:a.isLastSyncFromCurrentMachine,resourcePreviews:a.resourcePreviews.map(t)}]}reset(){this.previewsPromise&&(this.previewsPromise.cancel(),this.previewsPromise=void 0),this.previews=void 0,this.synchronizingResources=[]}dispose(){this.reset(),this.isDisposed=!0}}function t(r){return{localResource:r.localResource,previewResource:r.previewResource,remoteResource:r.remoteResource,acceptedResource:r.acceptedResource,localChange:r.localChange,remoteChange:r.remoteChange,mergeState:r.mergeState}}}),define(Z[199],ee([0,1,3,21,5,2,15]),function(H,e,y,R,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;class P{constructor(v,h){this.service=v,this.logService=h,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new y.Emitter}listen(v,h){switch(h){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${h}`)}async call(v,h,C){try{return await this._call(v,h,C)}catch(f){throw this.logService.error(f),f}}async _call(v,h,C){switch(h){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"replace":return this.service.replace(L.URI.revive(C[0]));case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"accept":return this.service.accept(C[0],L.URI.revive(C[1]),C[2],C[3]);case"resolveContent":return this.service.resolveContent(L.URI.revive(C[0]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(C[0]);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(C[0]);case"getAssociatedResources":return this.service.getAssociatedResources(C[0],{created:C[1].created,uri:L.URI.revive(C[1].uri)});case"getMachineId":return this.service.getMachineId(C[0],{created:C[1].created,uri:L.URI.revive(C[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(h.startsWith("manualSync/")){const f=h.substring("manualSync/".length),I=C[0],D=this.getManualSyncTask(I);switch(C=C.slice(1),f){case"preview":return D.preview();case"accept":return D.accept(L.URI.revive(C[0]),C[1]);case"merge":return D.merge(L.URI.revive(C[0]));case"discard":return D.discard(L.URI.revive(C[0]));case"discardConflicts":return D.discardConflicts();case"apply":return D.apply();case"pull":return D.pull();case"push":return D.push();case"stop":return D.stop();case"_getStatus":return D.status;case"dispose":return this.disposeManualSyncTask(D)}}throw new Error("Invalid call")}getManualSyncTask(v){const h=this.manualSyncTasks.get(this.createKey(v));if(!h)throw new Error(`Manual sync taks not found: ${v}`);return h.manualSyncTask}async createManualSyncTask(){const v=new A.DisposableStore,h=v.add(await this.service.createManualSyncTask());return v.add(h.onSynchronizeResources(C=>this.onManualSynchronizeResources.fire({manualSyncTaskId:h.id,data:C}))),this.manualSyncTasks.set(this.createKey(h.id),{manualSyncTask:h,disposables:v}),{id:h.id,manifest:h.manifest,status:h.status}}disposeManualSyncTask(v){var h;v.dispose();const C=this.createKey(v.id);(h=this.manualSyncTasks.get(C))===null||h===void 0||h.disposables.dispose(),this.manualSyncTasks.delete(C)}createKey(v){return`manualSyncTask-${v}`}}e.UserDataSyncChannel=P;class p extends A.Disposable{constructor(v){super();this._status="uninitialized",this._onDidChangeStatus=this._register(new y.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new y.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new y.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new y.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(h,C,f){return v.call(h,C,f).then(null,I=>{throw R.UserDataSyncError.toUserDataSyncError(I)})},listen(h,C){return v.listen(h,C)}},this.channel.call("_getInitialData").then(([h,C,f])=>{this.updateStatus(h),this.updateConflicts(C),f&&this.updateLastSyncTime(f),this._register(this.channel.listen("onDidChangeStatus")(I=>this.updateStatus(I))),this._register(this.channel.listen("onDidChangeLastSyncTime")(I=>this.updateLastSyncTime(I)))}),this._register(this.channel.listen("onDidChangeConflicts")(h=>this.updateConflicts(h))),this._register(this.channel.listen("onSyncErrors")(h=>this._onSyncErrors.fire(h.map(([C,f])=>[C,R.UserDataSyncError.toUserDataSyncError(f)]))))}get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const{id:v,manifest:h,status:C}=await this.channel.call("createManualSyncTask"),f=this,I=new S(v,h,C,{async call(D,E,b){return f.channel.call(`manualSync/${D}`,[v,...O.isArray(E)?E:[E]],b)},listen(D,E){return y.Event.map(y.Event.filter(f.channel.listen(`manualSync/${D}`,E),b=>!I.isDiposed()&&b.manualSyncTaskId===v),b=>b.data)}});return I}replace(v){return this.channel.call("replace",[v])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(v,h,C,f){return this.channel.call("accept",[v,h,C,f])}resolveContent(v){return this.channel.call("resolveContent",[v])}async getLocalSyncResourceHandles(v){return(await this.channel.call("getLocalSyncResourceHandles",[v])).map(({created:C,uri:f})=>({created:C,uri:L.URI.revive(f)}))}async getRemoteSyncResourceHandles(v){return(await this.channel.call("getRemoteSyncResourceHandles",[v])).map(({created:C,uri:f})=>({created:C,uri:L.URI.revive(f)}))}async getAssociatedResources(v,h){return(await this.channel.call("getAssociatedResources",[v,h])).map(({resource:f,comparableResource:I})=>({resource:L.URI.revive(f),comparableResource:L.URI.revive(I)}))}async getMachineId(v,h){return this.channel.call("getMachineId",[v,h])}async updateStatus(v){this._status=v,this._onDidChangeStatus.fire(v)}async updateConflicts(v){this._conflicts=v.map(([h,C])=>[h,C.map(f=>Object.assign(Object.assign({},f),{localResource:L.URI.revive(f.localResource),remoteResource:L.URI.revive(f.remoteResource),previewResource:L.URI.revive(f.previewResource)}))]),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(v){this._lastSyncTime!==v&&(this._lastSyncTime=v,this._onDidChangeLastSyncTime.fire(v))}}e.UserDataSyncChannelClient=p;class S extends A.Disposable{constructor(v,h,C,f){super();this.id=v,this.manifest=h,this._disposed=!1,this._status=C;const I=this;this.channel={async call(D,E,b){try{const g=await f.call(D,E,b);return I.isDiposed()||(I._status=await f.call("_getStatus")),g}catch(g){throw R.UserDataSyncError.toUserDataSyncError(g)}},listen(D,E){return f.listen(D,E)}}}get onSynchronizeResources(){return this.channel.listen("onSynchronizeResources")}get status(){return this._status}async preview(){const v=await this.channel.call("preview");return this.deserializePreviews(v)}async accept(v,h){const C=await this.channel.call("accept",[v,h]);return this.deserializePreviews(C)}async merge(v){const h=await this.channel.call("merge",[v]);return this.deserializePreviews(h)}async discard(v){const h=await this.channel.call("discard",[v]);return this.deserializePreviews(h)}async discardConflicts(){const v=await this.channel.call("discardConflicts");return this.deserializePreviews(v)}async apply(){const v=await this.channel.call("apply");return this.deserializePreviews(v)}pull(){return this.channel.call("pull")}push(){return this.channel.call("push")}stop(){return this.channel.call("stop")}isDiposed(){return this._disposed}dispose(){this._disposed=!0,this.channel.call("dispose")}deserializePreviews(v){return v.map(([h,C])=>[h,{isLastSyncFromCurrentMachine:C.isLastSyncFromCurrentMachine,resourcePreviews:C.resourcePreviews.map(f=>Object.assign(Object.assign({},f),{localResource:L.URI.revive(f.localResource),remoteResource:L.URI.revive(f.remoteResource),previewResource:L.URI.revive(f.previewResource),acceptedResource:L.URI.revive(f.acceptedResource)}))}])}}}),define(Z[200],ee([0,1,2,21,39,14,29,23,27,45,9,10,20,30,6,3,8,15,5,11]),function(H,e,y,R,L,A,O,P,p,S,n,v,h,C,f,I,D,E,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const o="sync.previous.store",s="sync.donot-make-requests-until",t="sync.user-session-id",r="sync.machine-session-id",i=100,a=1e3*60*5;let c=class extends y.Disposable{constructor(T,_,j){super();this.productService=T,this.configurationService=_,this.storageService=j,this._onDidChangeUserDataSyncStore=this._register(new I.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(I.Event.filter(j.onDidChangeValue,$=>{var K;return $.key===R.SYNC_SERVICE_URL_TYPE&&$.scope===0&&this.userDataSyncStoreType!==((K=this.userDataSyncStore)===null||K===void 0?void 0:K.type)})(()=>this.updateUserDataSyncStore()))}get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(R.SYNC_SERVICE_URL_TYPE,0)}set userDataSyncStoreType(T){this.storageService.store(R.SYNC_SERVICE_URL_TYPE,T,0,f.isWeb?0:1)}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[R.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(R.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(T,_){T=f.isWeb&&(T==null?void 0:T.web)?Object.assign(Object.assign({},T),T.web):T;const j=Object.assign(Object.assign({},T||{}),_||{});if(j&&E.isString(j.url)&&E.isObject(j.authenticationProviders)&&Object.keys(j.authenticationProviders).every($=>E.isArray(j.authenticationProviders[$].scopes))){const $=j,K=!!$.canSwitch&&!(_==null?void 0:_.url),B=$.url===$.insidersUrl?"insiders":"stable",z=(K?this.userDataSyncStoreType:void 0)||B,G=(_==null?void 0:_.url)||(z==="insiders"?$.insidersUrl:z==="stable"?$.stableUrl:$.url);return{url:b.URI.parse(G),type:z,defaultType:B,defaultUrl:b.URI.parse($.url),stableUrl:b.URI.parse($.stableUrl),insidersUrl:b.URI.parse($.insidersUrl),canSwitch:K,authenticationProviders:Object.keys($.authenticationProviders).reduce((V,M)=>(V.push({id:M,scopes:$.authenticationProviders[M].scopes}),V),[])}}}};c=de([Y(0,p.IProductService),Y(1,P.IConfigurationService),Y(2,h.IStorageService)],c),e.AbstractUserDataSyncStoreManagementService=c;let u=class extends c{constructor(T,_,j){super(T,_,j);const $=this.storageService.get(o,0);$&&(this.previousConfigurationSyncStore=JSON.parse($));const K=this.productService[R.CONFIGURATION_SYNC_STORE_KEY];K?this.storageService.store(o,JSON.stringify(K),0,1):this.storageService.remove(o,0)}async switch(T){T!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=T,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};u=de([Y(0,p.IProductService),Y(1,P.IConfigurationService),Y(2,h.IStorageService)],u),e.UserDataSyncStoreManagementService=u;let l=class extends y.Disposable{constructor(T,_,j,$,K,B,z){super();this.requestService=j,this.logService=$,this.storageService=z,this._onTokenFailed=this._register(new I.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new I.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new I.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(T),this.commonHeadersPromise=S.getServiceMachineId(K,B,z).then(G=>{const V={"X-Client-Name":`${_.applicationName}${f.isWeb?"-web":""}`,"X-Client-Version":_.version,"X-Machine-Id":G};return _.commit&&(V["X-Client-Commit"]=_.commit),V}),this.session=new w(i,a,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register(y.toDisposable(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}setAuthToken(T,_){this.authToken={token:T,type:_}}updateUserDataSyncStoreUrl(T){this.userDataSyncStoreUrl=T?A.joinPath(T,"v1"):void 0}initDonotMakeRequestsUntil(){const T=this.storageService.getNumber(s,0);T&&Date.now()<T&&this.setDonotMakeRequestsUntil(new Date(T))}setDonotMakeRequestsUntil(T){var _;((_=this._donotMakeRequestsUntil)===null||_===void 0?void 0:_.getTime())!==(T==null?void 0:T.getTime())&&(this._donotMakeRequestsUntil=T,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(s,this._donotMakeRequestsUntil.getTime(),0,1),this.resetDonotMakeRequestsUntilPromise=D.createCancelablePromise(j=>D.timeout(this._donotMakeRequestsUntil.getTime()-Date.now(),j).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,j=>null)):this.storageService.remove(s,0),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllRefs(T){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const _=A.joinPath(this.userDataSyncStoreUrl,"resource",T),j={},$=await this.request(_.toString(),{type:"GET",headers:j},[],O.CancellationToken.None);return(await L.asJson($)||[]).map(({url:B,created:z})=>({ref:A.relativePath(_,_.with({path:B})),created:z*1e3}))}async resolveContent(T,_){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const j=A.joinPath(this.userDataSyncStoreUrl,"resource",T,_).toString(),$={};$["Cache-Control"]="no-cache";const K=await this.request(j,{type:"GET",headers:$},[],O.CancellationToken.None);return await L.asText(K)}async delete(T){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const _=A.joinPath(this.userDataSyncStoreUrl,"resource",T).toString(),j={};await this.request(_,{type:"DELETE",headers:j},[],O.CancellationToken.None)}async read(T,_,j={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const $=A.joinPath(this.userDataSyncStoreUrl,"resource",T,"latest").toString();j=Object.assign({},j),j["Cache-Control"]="no-cache",_&&(j["If-None-Match"]=_.ref);const K=await this.request($,{type:"GET",headers:j},[304],O.CancellationToken.None);if(K.res.statusCode===304)return _;const B=K.res.headers.etag;if(!B)throw new R.UserDataSyncStoreError("Server did not return the ref",$,R.UserDataSyncErrorCode.NoRef,K.res.headers[R.HEADER_OPERATION_ID]);const z=await L.asText(K);return{ref:B,content:z}}async write(T,_,j,$={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const K=A.joinPath(this.userDataSyncStoreUrl,"resource",T).toString();$=Object.assign({},$),$["Content-Type"]="text/plain",j&&($["If-Match"]=j);const B=await this.request(K,{type:"POST",data:_,headers:$},[],O.CancellationToken.None),z=B.res.headers.etag;if(!z)throw new R.UserDataSyncStoreError("Server did not return the ref",K,R.UserDataSyncErrorCode.NoRef,B.res.headers[R.HEADER_OPERATION_ID]);return z}async manifest(T={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const _=A.joinPath(this.userDataSyncStoreUrl,"manifest").toString();T=Object.assign({},T),T["Content-Type"]="application/json";const j=await this.request(_,{type:"GET",headers:T},[],O.CancellationToken.None),$=await L.asJson(j),K=this.storageService.get(t,0);return K&&$&&K!==$.session&&this.clearSession(),$===null&&K&&this.clearSession(),$&&this.storageService.store(t,$.session,0,1),$}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const T=A.joinPath(this.userDataSyncStoreUrl,"resource").toString(),_={"Content-Type":"text/plain"};await this.request(T,{type:"DELETE",headers:_},[],O.CancellationToken.None),this.clearSession()}clearSession(){this.storageService.remove(t,0),this.storageService.remove(r,0)}async request(T,_,j,$){if(!this.authToken)throw new R.UserDataSyncStoreError("No Auth Token Available",T,R.UserDataSyncErrorCode.Unauthorized,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new R.UserDataSyncStoreError(`${_.type} request '${T}' failed because of too many requests (429).`,T,R.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter,void 0);this.setDonotMakeRequestsUntil(void 0);const K=await this.commonHeadersPromise;_.headers=Object.assign(Object.assign(Object.assign({},_.headers||{}),K),{"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`}),this.addSessionHeaders(_.headers),this.logService.trace("Sending request to server",{url:T,type:_.type,headers:Object.assign(Object.assign({},_.headers),{authorization:void 0})});let B;try{B=await this.session.request(T,_,$)}catch(M){if(!(M instanceof R.UserDataSyncStoreError)){const U=g.isPromiseCanceledError(M)?R.UserDataSyncErrorCode.RequestCanceled:g.getErrorMessage(M).startsWith("XHR timeout")?R.UserDataSyncErrorCode.RequestTimeout:R.UserDataSyncErrorCode.RequestFailed;M=new R.UserDataSyncStoreError(`Connection refused for the request '${T}'.`,T,U,void 0)}throw this.logService.info("Request failed",T),M}const z=B.res.headers[R.HEADER_OPERATION_ID],G={url:T,status:B.res.statusCode,"execution-id":_.headers[R.HEADER_EXECUTION_ID],"operation-id":z},V=L.isSuccess(B)||B.res.statusCode&&j.indexOf(B.res.statusCode)!==-1;if(V?this.logService.trace("Request succeeded",G):this.logService.info("Request failed",G),B.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new R.UserDataSyncStoreError(`Request '${T}' failed because of Unauthorized (401).`,T,R.UserDataSyncErrorCode.Unauthorized,z);if(this._onTokenSucceed.fire(),B.res.statusCode===409)throw new R.UserDataSyncStoreError(`${_.type} request '${T}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,T,R.UserDataSyncErrorCode.Conflict,z);if(B.res.statusCode===410)throw new R.UserDataSyncStoreError(`${_.type} request '${T}' failed because the requested resource is not longer available (410).`,T,R.UserDataSyncErrorCode.Gone,z);if(B.res.statusCode===412)throw new R.UserDataSyncStoreError(`${_.type} request '${T}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,T,R.UserDataSyncErrorCode.PreconditionFailed,z);if(B.res.statusCode===413)throw new R.UserDataSyncStoreError(`${_.type} request '${T}' failed because of too large payload (413).`,T,R.UserDataSyncErrorCode.TooLarge,z);if(B.res.statusCode===426)throw new R.UserDataSyncStoreError(`${_.type} request '${T}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,T,R.UserDataSyncErrorCode.UpgradeRequired,z);if(B.res.statusCode===429){const M=B.res.headers["retry-after"];throw M?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(M)*1e3)),new R.UserDataSyncStoreError(`${_.type} request '${T}' failed because of too many requests (429).`,T,R.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter,z)):new R.UserDataSyncStoreError(`${_.type} request '${T}' failed because of too many requests (429).`,T,R.UserDataSyncErrorCode.TooManyRequests,z)}if(!V)throw new R.UserDataSyncStoreError("Server returned "+B.res.statusCode,T,R.UserDataSyncErrorCode.Unknown,z);return B}addSessionHeaders(T){let _=this.storageService.get(r,0);_===void 0&&(_=C.generateUuid(),this.storageService.store(r,_,0,1)),T["X-Machine-Session-Id"]=_;const j=this.storageService.get(t,0);j!==void 0&&(T["X-User-Session-Id"]=j)}};l=de([Y(1,p.IProductService),Y(2,L.IRequestService),Y(3,R.IUserDataSyncLogService),Y(4,n.IEnvironmentService),Y(5,v.IFileService),Y(6,h.IStorageService)],l),e.UserDataSyncStoreClient=l;let m=class extends l{constructor(T,_,j,$,K,B,z){var G;super((G=T.userDataSyncStore)===null||G===void 0?void 0:G.url,_,j,$,K,B,z);this._register(T.onDidChangeUserDataSyncStore(()=>{var V;return this.updateUserDataSyncStoreUrl((V=T.userDataSyncStore)===null||V===void 0?void 0:V.url)}))}};m=de([Y(0,R.IUserDataSyncStoreManagementService),Y(1,p.IProductService),Y(2,L.IRequestService),Y(3,R.IUserDataSyncLogService),Y(4,n.IEnvironmentService),Y(5,v.IFileService),Y(6,h.IStorageService)],m),e.UserDataSyncStoreService=m;class w{constructor(T,_,j,$){this.limit=T,this.interval=_,this.requestService=j,this.logService=$,this.requests=[],this.startTime=void 0}request(T,_,j){if(this.isExpired()&&this.reset(),_.url=T,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new R.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,T,R.UserDataSyncErrorCode.LocalTooManyRequests,void 0);return this.startTime=this.startTime||new Date,this.requests.push(T),this.requestService.request(_,j)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=w}),define(Z[201],ee([0,1,21,3,58,86,60,24,20,61,27]),function(H,e,y,R,L,A,O,P,p,S,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let v=class extends A.UserDataAutoSyncService{constructor(C,f,I,D,E,b,g,o,s,t,r,i){super(C,f,I,D,E,g,o,s,t,r,i);this._register(R.Event.debounce(R.Event.any(R.Event.map(b.onDidFocusWindow,()=>"windowFocus"),R.Event.map(b.onDidOpenWindow,()=>"windowOpen")),(a,c)=>a?[...a,c]:[c],1e3)(a=>this.triggerSync(a,!0,!1)))}};v=de([Y(0,n.IProductService),Y(1,y.IUserDataSyncStoreManagementService),Y(2,y.IUserDataSyncStoreService),Y(3,y.IUserDataSyncResourceEnablementService),Y(4,y.IUserDataSyncService),Y(5,L.INativeHostService),Y(6,y.IUserDataSyncLogService),Y(7,O.IUserDataSyncAccountService),Y(8,P.ITelemetryService),Y(9,S.IUserDataSyncMachinesService),Y(10,p.IStorageService),Y(11,y.IUserDataAutoSyncEnablementService)],v),e.UserDataAutoSyncService=v}),define(Z[202],ee([0,1,3,2,8]),function(H,e,y,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class A extends R.Disposable{constructor({onDidOpenWindow:P,onDidFocusWindow:p,getActiveWindowId:S}){super();this.disposables=this._register(new R.DisposableStore),y.Event.latch(y.Event.any(P,p))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=L.createCancelablePromise(()=>S()),(async()=>{try{const v=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:v}catch(v){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(P){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=P}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=A}),define(Z[62],ee([0,1,107,7,42,8,17,209,210,15]),function(H,e,y,R,L,A,O,P,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class n extends Error{constructor(t,r){let i=r.message;switch(t){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i);this.type=t,this.cause=r}}e.ExtractError=n;function v(s){const t=s.externalFileAttributes>>16||33188;return[448,56,7].map(r=>t&r).reduce((r,i)=>r+i,t&61440)}function h(s){if(s instanceof n)return s;let t;return/end of central directory record signature not found/.test(s.message)&&(t="CorruptZip"),new n(t,s)}function C(s,t,r,i,a,c){const u=R.dirname(t),l=R.join(i,u);if(!l.startsWith(i))return Promise.reject(new Error(y.localize(0,null,t)));const m=R.join(i,t);let w;return c.onCancellationRequested(()=>{w&&w.destroy()}),Promise.resolve(O.Promises.mkdir(l,{recursive:!0})).then(()=>new Promise((d,T)=>{if(!c.isCancellationRequested)try{w=L.createWriteStream(m,{mode:r}),w.once("close",()=>d()),w.once("error",T),s.once("error",T),s.pipe(w)}catch(_){T(_)}}))}function f(s,t,r,i){let a=A.createCancelablePromise(()=>Promise.resolve()),c=0;return i.onCancellationRequested(()=>{a.cancel(),s.close()}),new Promise((u,l)=>{const m=new A.Sequencer,w=d=>{d.isCancellationRequested||(c++,s.readEntry())};s.once("error",l),s.once("close",()=>a.then(()=>{i.isCancellationRequested||s.entryCount===c?u():l(new n("Incomplete",new Error(y.localize(1,null,c,s.entryCount))))},l)),s.readEntry(),s.on("entry",d=>{if(i.isCancellationRequested)return;if(!r.sourcePathRegex.test(d.fileName)){w(i);return}const T=d.fileName.replace(r.sourcePathRegex,"");if(/\/$/.test(T)){const $=R.join(t,T);a=A.createCancelablePromise(K=>O.Promises.mkdir($,{recursive:!0}).then(()=>w(K)).then(void 0,l));return}const _=D(s,d),j=v(d);a=A.createCancelablePromise($=>m.queue(()=>_.then(K=>C(K,T,j,t,r,$).then(()=>w($)))).then(null,l))})})}function I(s,t=!1){return new Promise((r,i)=>{P.open(s,t?{lazyEntries:!0}:void 0,(a,c)=>{a?i(h(a)):r(S.assertIsDefined(c))})})}function D(s,t){return new Promise((r,i)=>{s.openReadStream(t,(a,c)=>{a?i(h(a)):r(S.assertIsDefined(c))})})}function E(s,t){return new Promise((r,i)=>{const a=new p.ZipFile;t.forEach(u=>{u.contents?a.addBuffer(typeof u.contents=="string"?Buffer.from(u.contents,"utf8"):u.contents,u.path):u.localPath&&a.addFile(u.localPath,u.path)}),a.end();const c=L.createWriteStream(s);a.outputStream.pipe(c),a.outputStream.once("error",i),c.once("error",i),c.once("finish",()=>r(s))})}e.zip=E;function b(s,t,r={},i){const a=new RegExp(r.sourcePath?`^${r.sourcePath}`:"");let c=I(s,!0);return r.overwrite&&(c=c.then(u=>O.rimraf(t).then(()=>u))),c.then(u=>f(u,t,{sourcePathRegex:a},i))}e.extract=b;function g(s,t){return I(s).then(r=>new Promise((i,a)=>{r.on("entry",c=>{c.fileName===t&&D(r,c).then(u=>i(u),u=>a(u))}),r.once("close",()=>a(new Error(y.localize(2,null,t))))}))}function o(s,t){return g(s,t).then(r=>new Promise((i,a)=>{const c=[];r.once("error",a),r.on("data",u=>c.push(u)),r.on("end",()=>i(Buffer.concat(c)))}))}e.buffer=o}),define(Z[203],ee([0,1,62,112]),function(H,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function L(A){return y.buffer(A,"extension/package.json").then(O=>{try{return JSON.parse(O.toString("utf8"))}catch(P){throw new Error(R.localize(0,null))}})}e.getManifest=L}),define(Z[204],ee([0,1,57,2,17,7,18,28,33,8,5,9,133,113,27,62,6,19,16,10,14,30,11]),function(H,e,y,R,L,A,O,P,p,S,n,v,h,C,f,I,D,E,b,g,o,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=void 0;const r="scanningSystem",i="scanningUser",a="extracting",c="deleting",u="renaming";let l=class extends R.Disposable{constructor(w,d,T,_,j){super();this.beforeRemovingExtension=w,this.fileService=d,this.logService=T,this.environmentService=_,this.productService=j,this._devSystemExtensionsPath=null,this.systemExtensionsPath=_.builtinExtensionsPath,this.extensionsPath=_.extensionsPath,this.uninstalledPath=A.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new S.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(w){const d=[];(w===null||w===0)&&d.push(this.scanSystemExtensions().then(null,T=>Promise.reject(new P.ExtensionManagementError(this.joinErrors(T).message,r)))),(w===null||w===1)&&d.push(this.scanUserExtensions(!0).then(null,T=>Promise.reject(new P.ExtensionManagementError(this.joinErrors(T).message,i))));try{const T=await Promise.all(d);return E.flatten(T)}catch(T){throw this.joinErrors(T)}}async scanUserExtensions(w){this.logService.trace("Started scanning user extensions");let[d,T]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return T=T.filter(_=>!d[new p.ExtensionIdentifierWithVersion(_.identifier,_.manifest.version).key()]),w&&(T=p.groupByExtension(T,j=>j.identifier).map(j=>j.sort(($,K)=>y.rcompare($.manifest.version,K.manifest.version))[0])),this.logService.trace("Scanned user extensions:",T.length),T}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(w,d,T){const _=w.key(),j=A.join(this.extensionsPath,`.${s.generateUuid()}`),$=A.join(this.extensionsPath,_);try{await L.rimraf($)}catch(B){try{await L.rimraf($)}catch(z){}throw new P.ExtensionManagementError(C.localize(0,null,$,w.id),c)}await this.extractAtLocation(w,d,j,T);let K=await this.scanExtension(n.URI.file(j),1);if(!K)throw new Error(C.localize(1,null,j));await this.storeMetadata(K,{installedTimestamp:Date.now()});try{await this.rename(w,j,$,Date.now()+2*60*1e3),this.logService.info("Renamed to",$)}catch(B){try{await L.rimraf(j)}catch(z){}if(B.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",w.id);else throw this.logService.info(`Rename failed because of ${t.getErrorMessage(B)}. Deleted from extracted location`,j),B}try{K=await this.scanExtension(n.URI.file($),1)}catch(B){}if(K)return K;throw new Error(C.localize(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(w,d){return this.setMetadata(w,d),await this.storeMetadata(w,Object.assign(Object.assign({},d),{installedTimestamp:w.installedTimestamp})),w}async storeMetadata(w,d){d.isMachineScoped=d.isMachineScoped||void 0,d.isBuiltin=d.isBuiltin||void 0,d.installedTimestamp=d.installedTimestamp||void 0;const T=A.join(w.location.fsPath,"package.json"),_=await L.Promises.readFile(T,"utf8"),{manifest:j}=await this.parseManifest(_);return j.__metadata=d,await L.writeFile(T,JSON.stringify(j,null,"	")),w}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...w){const d=w.map(T=>new p.ExtensionIdentifierWithVersion(T.identifier,T.manifest.version));await this.withUninstalledExtensions(T=>{d.forEach(_=>T[_.key()]=!0)})}async setInstalled(w){await this.withUninstalledExtensions(_=>delete _[w.key()]);const T=(await this.scanExtensions(1)).find(_=>new p.ExtensionIdentifierWithVersion(_.identifier,_.manifest.version).equals(w))||null;return T?(await this.storeMetadata(T,{installedTimestamp:Date.now()}),this.scanExtension(T.location,1)):null}async withUninstalledExtensions(w){return this.uninstalledFileLimiter.queue(async()=>{let d;try{d=await L.Promises.readFile(this.uninstalledPath,"utf8")}catch(_){if(_.code!=="ENOENT")throw _}let T={};if(d)try{T=JSON.parse(d)}catch(_){}return w&&(w(T),Object.keys(T).length?await L.writeFile(this.uninstalledPath,JSON.stringify(T)):await L.rimraf(this.uninstalledPath)),T})}async removeExtension(w,d){this.logService.trace(`Deleting ${d} extension from disk`,w.identifier.id,w.location.fsPath),await L.rimraf(w.location.fsPath),this.logService.info("Deleted from disk",w.identifier.id,w.location.fsPath)}async removeUninstalledExtension(w){await this.removeExtension(w,"uninstalled"),await this.withUninstalledExtensions(d=>delete d[new p.ExtensionIdentifierWithVersion(w.identifier,w.manifest.version).key()])}async extractAtLocation(w,d,T,_){this.logService.trace(`Started extracting the extension from ${d} to ${T}`);try{await L.rimraf(T)}catch(j){throw new P.ExtensionManagementError(this.joinErrors(j).message,c)}try{await I.extract(d,T,{sourcePath:"extension",overwrite:!0},_),this.logService.info(`Extracted extension to ${T}:`,w.id)}catch(j){try{await L.rimraf(T)}catch($){}throw new P.ExtensionManagementError(j.message,j instanceof I.ExtractError&&j.type?j.type:a)}}async rename(w,d,T,_){try{await L.Promises.rename(d,T)}catch(j){if(D.isWindows&&j&&j.code==="EPERM"&&Date.now()<_)return this.logService.info(`Failed renaming ${d} to ${T} with 'EPERM' error. Trying again...`,w.id),this.rename(w,d,T,_);throw new P.ExtensionManagementError(j.message||C.localize(3,null,d,T),j.code||u)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const w=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return w;const d=this.scanDevSystemExtensions(),[T,_]=await Promise.all([w,d]);return[...T,..._]}async scanExtensionsInDir(w,d){const T=new S.Limiter(10),_=await this.fileService.resolve(n.URI.file(w));return _.children?(await Promise.all(_.children.filter($=>$.isDirectory).map($=>T.queue(async()=>d===1&&o.basename($.resource).indexOf(".")===0?null:this.scanExtension($.resource,d))))).filter($=>$&&$.identifier):[]}async scanExtension(w,d){var T,_;try{const j=await this.fileService.resolve(w);if(j.children){const{manifest:$,metadata:K}=await this.readManifest(w.fsPath),B=(T=j.children.find(({name:M})=>/^readme(\.txt|\.md|)$/i.test(M)))===null||T===void 0?void 0:T.resource,z=(_=j.children.find(({name:M})=>/^changelog(\.txt|\.md|)$/i.test(M)))===null||_===void 0?void 0:_.resource,G={id:p.getGalleryExtensionId($.publisher,$.name)},V={type:d,identifier:G,manifest:$,location:w,readmeUrl:B,changelogUrl:z,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:d===0};return K&&(this.setMetadata(V,K),V.installedTimestamp=K.installedTimestamp),V}}catch(j){d!==0&&this.logService.trace(j)}return null}async scanDefaultSystemExtensions(){const w=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",w.length),w}async scanDevSystemExtensions(){const w=this.getDevSystemExtensionsList();if(w.length){const d=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",d.length),d.filter(T=>w.some(_=>p.areSameExtensions(T.identifier,{id:_})))}else return[]}setMetadata(w,d){w.publisherDisplayName=d.publisherDisplayName||null,w.publisherId=d.publisherId||null,w.identifier.uuid=d.id,w.isMachineScoped=!!d.isMachineScoped,w.isBuiltin=w.type===0||!!d.isBuiltin}async removeUninstalledExtensions(){const w=await this.getUninstalledExtensions(),d=await this.scanAllUserExtensions(),T=new Set;for(const $ of d)w[new p.ExtensionIdentifierWithVersion($.identifier,$.manifest.version).key()]||T.add($.identifier.id.toLowerCase());const _=p.groupByExtension(d,$=>$.identifier);await S.Promises.settled(_.map(async $=>{const K=$.sort((B,z)=>y.rcompare(B.manifest.version,z.manifest.version))[0];T.has(K.identifier.id.toLowerCase())||await this.beforeRemovingExtension(K)}));const j=d.filter($=>w[new p.ExtensionIdentifierWithVersion($.identifier,$.manifest.version).key()]);await S.Promises.settled(j.map($=>this.removeUninstalledExtension($)))}async removeOutdatedExtensions(){const w=await this.scanAllUserExtensions(),d=[],T=p.groupByExtension(w,_=>_.identifier);d.push(...E.flatten(T.map(_=>_.sort((j,$)=>y.rcompare(j.manifest.version,$.manifest.version)).slice(1)))),await S.Promises.settled(d.map(_=>this.removeExtension(_,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(w=>w.name)}joinErrors(w){const d=Array.isArray(w)?w:[w];return d.length===1?d[0]instanceof Error?d[0]:new Error(d[0]):d.reduce((T,_)=>new Error(`${T.message}${T.message?",":""}${_ instanceof Error?_.message:_}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=A.normalize(A.join(b.FileAccess.asFileUri("",H).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(w){const d=[L.Promises.readFile(A.join(w,"package.json"),"utf8").then($=>this.parseManifest($)),L.Promises.readFile(A.join(w,"package.nls.json"),"utf8").then(void 0,$=>$.code!=="ENOENT"?Promise.reject($):"{}").then($=>JSON.parse($))],[{manifest:T,metadata:_},j]=await Promise.all(d);return{manifest:h.localizeManifest(T,j),metadata:_}}parseManifest(w){return new Promise((d,T)=>{try{const _=JSON.parse(w),j=_.__metadata||null;d({manifest:_,metadata:j})}catch(_){T(new Error(C.localize(4,null)))}})}};l=de([Y(1,g.IFileService),Y(2,O.ILogService),Y(3,v.INativeEnvironmentService),Y(4,f.IProductService)],l),e.ExtensionsScanner=l}),define(Z[205],ee([0,1,111,7,17,2,19,62,28,33,9,8,3,57,5,51,6,18,146,44,24,70,14,30,72,4,16,29,203,154,204,155,156,10]),function(H,e,y,R,L,A,O,P,p,S,n,v,h,C,f,I,D,E,b,g,o,s,t,r,i,a,c,u,l,m,w,d,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;const j="unsetUninstalled",$="downloading",K="validating",B="local",z="unknown";let G=class extends A.Disposable{constructor(M,U,k,F,N,q,W){super();this.environmentService=M,this.galleryService=U,this.logService=k,this.downloadService=F,this.telemetryService=N,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new h.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtension=this._register(new h.Emitter),this.onDidInstallExtension=this._onDidInstallExtension.event,this._onUninstallExtension=this._register(new h.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new h.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event;const Q=this._register(q.createInstance(d.ExtensionsLifecycle));this.extensionsScanner=this._register(q.createInstance(w.ExtensionsScanner,ie=>Q.postUninstall(ie))),this.manifestCache=this._register(new b.ExtensionsManifestCache(M,this)),this.extensionsDownloader=this._register(q.createInstance(m.ExtensionsDownloader));const X=this._register(new T.ExtensionsWatcher(this,W,M,k));this._register(X.onDidChangeExtensionsByAnotherSource(({added:ie,removed:ne})=>{ie.forEach(ce=>this._onDidInstallExtension.fire({identifier:ce.identifier,operation:0,local:ce})),ne.forEach(ce=>this._onDidUninstallExtension.fire({identifier:ce}))})),this._register(A.toDisposable(()=>{this.installingExtensions.forEach(ie=>ie.cancel()),this.uninstallingExtensions.forEach(ie=>ie.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async zip(M){this.logService.trace("ExtensionManagementService#zip",M.identifier.id);const U=await this.collectFiles(M),k=await P.zip(t.joinPath(this.environmentService.tmpDir,r.generateUuid()).fsPath,U);return f.URI.file(k)}async unzip(M){return this.logService.trace("ExtensionManagementService#unzip",M.toString()),(await this.install(M)).identifier}async getManifest(M){const U=await this.downloadVsix(M),k=R.resolve(U.fsPath);return l.getManifest(k)}async collectFiles(M){const U=async F=>{let N=await L.readdir(F);N=N.map(Q=>R.join(F,Q));const q=await Promise.all(N.map(Q=>L.Promises.stat(Q)));let W=Promise.resolve([]);return q.forEach((Q,X)=>{const ie=N[X];Q.isFile()&&(W=W.then(ne=>[...ne,ie])),Q.isDirectory()&&(W=W.then(ne=>U(ie).then(ce=>[...ne,...ce])))}),W};return(await U(M.location.fsPath)).map(F=>({path:`extension/${R.relative(M.location.fsPath,F)}`,localPath:F}))}async install(M,U={}){return this.logService.trace("ExtensionManagementService#install",M.toString()),v.createCancelablePromise(async k=>{const F=await this.downloadVsix(M),N=R.resolve(F.fsPath),q=await l.getManifest(N),W={id:S.getGalleryExtensionId(q.publisher,q.name)};let Q=1;if(q.engines&&q.engines.vscode&&!s.isEngineValid(q.engines.vscode,I.default.version,I.default.date))throw new Error(y.localize(0,null,W.id,I.default.version));const X=new S.ExtensionIdentifierWithVersion(W,q.version),ne=(await this.getInstalled(1)).find(le=>S.areSameExtensions(W,le.identifier));if(ne)if(U.isMachineScoped=U.isMachineScoped||ne.isMachineScoped,U.isBuiltin=U.isBuiltin||ne.isBuiltin,Q=2,X.equals(new S.ExtensionIdentifierWithVersion(ne.identifier,ne.manifest.version)))try{await this.extensionsScanner.removeExtension(ne,"existing")}catch(le){throw new Error(y.localize(1,null,q.displayName||q.name))}else C.gt(ne.manifest.version,q.version)&&await this.uninstallExtension(ne);else{const le=await this.unsetUninstalledAndGetLocal(X);if(le)try{await this.extensionsScanner.removeExtension(le,"existing")}catch(ve){throw new Error(y.localize(2,null,q.displayName||q.name))}}this.logService.info("Installing the extension:",W.id),this._onInstallExtension.fire({identifier:W,zipPath:N});let ce;try{ce=await this.getGalleryMetadata(S.getGalleryExtensionId(q.publisher,q.name))}catch(le){}try{const le=await this.installFromZipPath(X,N,U.installOnlyNewlyAddedFromExtensionPack?ne:void 0,Object.assign(Object.assign({},ce||{}),U),U,Q,k);return this.logService.info("Successfully installed the extension:",W.id),le}catch(le){throw this.logService.error("Failed to install the extension:",W.id,le.message),le}})}async downloadVsix(M){if(M.scheme===c.Schemas.file)return M;if(!this.downloadService)throw new Error("Download service is not available");const U=t.joinPath(this.environmentService.tmpDir,r.generateUuid());return await this.downloadService.download(M,U),U}async installFromZipPath(M,U,k,F,N,q,W){try{const Q=await this.installExtension({zipPath:U,identifierWithVersion:M,metadata:F},W);try{N.donotIncludePackAndDependencies||await this.installDependenciesAndPackExtensions(Q,k,N)}catch(X){O.isNonEmptyArray(Q.manifest.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",Q.identifier.id,X.message),O.isNonEmptyArray(Q.manifest.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",Q.identifier.id,X.message)}return this._onDidInstallExtension.fire({identifier:M,zipPath:U,local:Q,operation:q}),Q}catch(Q){throw this._onDidInstallExtension.fire({identifier:M,zipPath:U,operation:q,error:Q}),Q}}async canInstall(M){return!0}async installFromGallery(M,U={}){if(!this.galleryService.isEnabled())throw new Error(y.localize(3,null));try{M=await this.checkAndGetCompatibleVersion(M)}catch(N){const q=N&&N.code?N.code:z;throw this.logService.error("Failed to install extension:",M.identifier.id,N?N.message:q),this.reportTelemetry(this.getTelemetryEvent(1),S.getGalleryExtensionTelemetryData(M),void 0,N),N instanceof Error&&(N.name=q),N}const k=new S.ExtensionIdentifierWithVersion(M.identifier,M.version).key();let F=this.installingExtensions.get(k);return F||(F=v.createCancelablePromise(N=>this.doInstallFromGallery(M,U,N)),this.installingExtensions.set(k,F),F.finally(()=>this.installingExtensions.delete(k))),F}async doInstallFromGallery(M,U,k){const F=new Date().getTime();let N=1;this.logService.info("Installing extension:",M.identifier.id),this._onInstallExtension.fire({identifier:M.identifier,gallery:M});try{const W=(await this.getInstalled(1)).find(ie=>S.areSameExtensions(ie.identifier,M.identifier));W&&(N=2);const Q=await this.downloadInstallableExtension(M,N);Q.metadata.isMachineScoped=U.isMachineScoped||(W==null?void 0:W.isMachineScoped),Q.metadata.isBuiltin=U.isBuiltin||(W==null?void 0:W.isBuiltin);const X=await this.installExtension(Q,k);try{await this.extensionsDownloader.delete(f.URI.file(Q.zipPath))}catch(ie){}if(!U.donotIncludePackAndDependencies)try{await this.installDependenciesAndPackExtensions(X,W,U)}catch(ie){try{await this.uninstall(X)}catch(ne){}throw ie}return W&&C.neq(W.manifest.version,M.version)&&await this.extensionsScanner.setUninstalled(W),this.logService.info("Extensions installed successfully:",M.identifier.id),this._onDidInstallExtension.fire({identifier:M.identifier,gallery:M,local:X,operation:N}),this.reportTelemetry(this.getTelemetryEvent(N),S.getGalleryExtensionTelemetryData(M),new Date().getTime()-F,void 0),X}catch(q){const W=q&&q.code?q.code:z;throw this.logService.error("Failed to install extension:",M.identifier.id,q?q.message:W),this._onDidInstallExtension.fire({identifier:M.identifier,gallery:M,operation:N,error:W}),this.reportTelemetry(this.getTelemetryEvent(N),S.getGalleryExtensionTelemetryData(M),new Date().getTime()-F,q),q instanceof Error&&(q.name=W),q}}async checkAndGetCompatibleVersion(M){if(await this.isMalicious(M))throw new p.ExtensionManagementError(y.localize(4,null),p.INSTALL_ERROR_MALICIOUS);const U=await this.galleryService.getCompatibleExtension(M);if(!U)throw new p.ExtensionManagementError(y.localize(5,null,M.identifier.id,I.default.version),p.INSTALL_ERROR_INCOMPATIBLE);return U}async reinstallFromGallery(M){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",M.identifier.id),!this.galleryService.isEnabled())throw new Error(y.localize(6,null));const U=await this.findGalleryExtension(M);if(!U)throw new Error(y.localize(7,null));await this.extensionsScanner.setUninstalled(M);try{await this.extensionsScanner.removeUninstalledExtension(M)}catch(k){throw new Error(y.localize(8,null,g.toErrorMessage(k)))}await this.installFromGallery(U)}getTelemetryEvent(M){return M===2?"extensionGallery:update":"extensionGallery:install"}async isMalicious(M){const U=await this.getExtensionsReport();return S.getMaliciousExtensionsSet(U).has(M.identifier.id)}async downloadInstallableExtension(M,U){const k={id:M.identifier.uuid,publisherId:M.publisherId,publisherDisplayName:M.publisherDisplayName};let F;try{this.logService.trace("Started downloading extension:",M.identifier.id),F=(await this.extensionsDownloader.downloadExtension(M,U)).fsPath,this.logService.info("Downloaded extension:",M.identifier.id,F)}catch(N){throw new p.ExtensionManagementError(this.joinErrors(N).message,$)}try{const N=await l.getManifest(F);return{zipPath:F,identifierWithVersion:new S.ExtensionIdentifierWithVersion(M.identifier,N.version),metadata:k}}catch(N){throw new p.ExtensionManagementError(this.joinErrors(N).message,K)}}async installExtension(M,U){try{const k=await this.unsetUninstalledAndGetLocal(M.identifierWithVersion);if(k)return M.metadata?this.extensionsScanner.saveMetadataForLocalExtension(k,M.metadata):k}catch(k){throw D.isMacintosh?new p.ExtensionManagementError(y.localize(9,null),j):new p.ExtensionManagementError(y.localize(10,null),j)}return this.extractAndInstall(M,U)}async unsetUninstalledAndGetLocal(M){if(!await this.isUninstalled(M))return null;this.logService.trace("Removing the extension from uninstalled list:",M.id);const k=await this.extensionsScanner.setInstalled(M);return this.logService.info("Removed the extension from uninstalled list:",M.id),k}async extractAndInstall({zipPath:M,identifierWithVersion:U,metadata:k},F){let N=await this.extensionsScanner.extractUserExtension(U,M,F);return this.logService.info("Installation completed.",U.id),k&&(N=await this.extensionsScanner.saveMetadataForLocalExtension(N,k)),N}async installDependenciesAndPackExtensions(M,U,k){if(!this.galleryService.isEnabled())return;const F=M.manifest.extensionDependencies||[];if(M.manifest.extensionPack)for(const N of M.manifest.extensionPack)U&&U.manifest.extensionPack&&U.manifest.extensionPack.some(q=>S.areSameExtensions({id:q},{id:N}))||F.every(q=>!S.areSameExtensions({id:q},{id:N}))&&F.push(N);if(F.length){const N=await this.getInstalled(),q=F.filter(W=>N.every(({identifier:Q})=>!S.areSameExtensions(Q,{id:W})));if(q.length){const Q=(await this.galleryService.query({names:q,pageSize:F.length},u.CancellationToken.None)).firstPage;try{await v.Promises.settled(Q.map(X=>this.installFromGallery(X,k)))}catch(X){try{await this.rollback(Q)}catch(ie){}throw X}}}}async rollback(M){const k=(await this.getInstalled(1)).filter(F=>M.some(N=>new S.ExtensionIdentifierWithVersion(F.identifier,F.manifest.version).equals(new S.ExtensionIdentifierWithVersion(N.identifier,N.version))));await v.Promises.settled(k.map(F=>this.uninstall(F)))}async uninstall(M,U={}){this.logService.trace("ExtensionManagementService#uninstall",M.identifier.id);const k=await this.getInstalled(1),F=k.find(N=>S.areSameExtensions(N.identifier,M.identifier));if(!F)throw new Error(y.localize(11,null,M.manifest.displayName||M.manifest.name));try{await this.checkForDependenciesAndUninstall(F,k,U)}catch(N){throw this.joinErrors(N)}}async updateMetadata(M,U){return this.logService.trace("ExtensionManagementService#updateMetadata",M.identifier.id),M=await this.extensionsScanner.saveMetadataForLocalExtension(M,Object.assign(Object.assign({},M.manifest.__metadata||{}),U)),this.manifestCache.invalidate(),M}async updateExtensionScope(M,U){return this.logService.trace("ExtensionManagementService#updateExtensionScope",M.identifier.id),M=await this.extensionsScanner.saveMetadataForLocalExtension(M,Object.assign(Object.assign({},M.manifest.__metadata||{}),{isMachineScoped:U})),this.manifestCache.invalidate(),M}async getGalleryMetadata(M){const U=await this.findGalleryExtensionByName(M);return U?{id:U.identifier.uuid,publisherDisplayName:U.publisherDisplayName,publisherId:U.publisherId}:void 0}async findGalleryExtension(M){if(M.identifier.uuid){const U=await this.findGalleryExtensionById(M.identifier.uuid);return U||this.findGalleryExtensionByName(M.identifier.id)}return this.findGalleryExtensionByName(M.identifier.id)}async findGalleryExtensionById(M){return(await this.galleryService.query({ids:[M],pageSize:1},u.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(M){return(await this.galleryService.query({names:[M],pageSize:1},u.CancellationToken.None)).firstPage[0]}joinErrors(M){const U=Array.isArray(M)?M:[M];return U.length===1?U[0]instanceof Error?U[0]:new Error(U[0]):U.reduce((k,F)=>new Error(`${k.message}${k.message?",":""}${F instanceof Error?F.message:F}`),new Error(""))}async checkForDependenciesAndUninstall(M,U,k){try{await this.preUninstallExtension(M);const F=k.donotIncludePack?[]:this.getAllPackExtensionsToUninstall(M,U);await this.uninstallExtensions(M,F,U,k)}catch(F){throw await this.postUninstallExtension(M,new p.ExtensionManagementError(F instanceof Error?F.message:F,B)),F}await this.postUninstallExtension(M)}async uninstallExtensions(M,U,k,F){const N=[M,...U];if(!F.donotCheckDependents)for(const q of N)this.checkForDependents(q,N,k,M);await v.Promises.settled([this.uninstallExtension(M),...U.map(q=>this.doUninstall(q))])}checkForDependents(M,U,k,F){const N=this.getDependents(M,k);if(N.length){const q=N.filter(W=>U.indexOf(W)===-1);if(q.length)throw new Error(this.getDependentsErrorMessage(M,q,F))}}getDependentsErrorMessage(M,U,k){return k===M?U.length===1?y.localize(12,null,k.manifest.displayName||k.manifest.name,U[0].manifest.displayName||U[0].manifest.name):U.length===2?y.localize(13,null,k.manifest.displayName||k.manifest.name,U[0].manifest.displayName||U[0].manifest.name,U[1].manifest.displayName||U[1].manifest.name):y.localize(14,null,k.manifest.displayName||k.manifest.name,U[0].manifest.displayName||U[0].manifest.name,U[1].manifest.displayName||U[1].manifest.name):U.length===1?y.localize(15,null,k.manifest.displayName||k.manifest.name,M.manifest.displayName||M.manifest.name,U[0].manifest.displayName||U[0].manifest.name):U.length===2?y.localize(16,null,k.manifest.displayName||k.manifest.name,M.manifest.displayName||M.manifest.name,U[0].manifest.displayName||U[0].manifest.name,U[1].manifest.displayName||U[1].manifest.name):y.localize(17,null,k.manifest.displayName||k.manifest.name,M.manifest.displayName||M.manifest.name,U[0].manifest.displayName||U[0].manifest.name,U[1].manifest.displayName||U[1].manifest.name)}getAllPackExtensionsToUninstall(M,U,k=[]){if(k.indexOf(M)!==-1)return[];k.push(M);const F=M.manifest.extensionPack?M.manifest.extensionPack:[];if(F.length){const N=U.filter(W=>!W.isBuiltin&&F.some(Q=>S.areSameExtensions({id:Q},W.identifier))),q=[];for(const W of N)q.push(...this.getAllPackExtensionsToUninstall(W,U,k));return[...N,...q]}return[]}getDependents(M,U){return U.filter(k=>k.manifest.extensionDependencies&&k.manifest.extensionDependencies.some(F=>S.areSameExtensions({id:F},M.identifier)))}async doUninstall(M){try{await this.preUninstallExtension(M),await this.uninstallExtension(M)}catch(U){throw await this.postUninstallExtension(M,new p.ExtensionManagementError(U instanceof Error?U.message:U,B)),U}await this.postUninstallExtension(M)}async preUninstallExtension(M){if(!await L.exists(M.location.fsPath))throw new Error(y.localize(18,null));this.logService.info("Uninstalling extension:",M.identifier.id),this._onUninstallExtension.fire(M.identifier)}async uninstallExtension(M){let U=this.uninstallingExtensions.get(M.identifier.id);return U||(U=v.createCancelablePromise(async()=>{const k=await this.extensionsScanner.scanUserExtensions(!1);await this.extensionsScanner.setUninstalled(...k.filter(F=>S.areSameExtensions(F.identifier,M.identifier)))}),this.uninstallingExtensions.set(M.identifier.id,U),U.finally(()=>this.uninstallingExtensions.delete(M.identifier.id))),U}async postUninstallExtension(M,U){if(U)this.logService.error("Failed to uninstall extension:",M.identifier.id,U.message);else if(this.logService.info("Successfully uninstalled extension:",M.identifier.id),M.identifier.uuid)try{await this.galleryService.reportStatistic(M.manifest.publisher,M.manifest.name,M.manifest.version,"uninstall")}catch(F){}this.reportTelemetry("extensionGallery:uninstall",S.getLocalExtensionTelemetryData(M),void 0,U);const k=U?U instanceof p.ExtensionManagementError?U.code:z:void 0;this._onDidUninstallExtension.fire({identifier:M.identifier,error:k})}getInstalled(M=null){return this.extensionsScanner.scanExtensions(M)}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async isUninstalled(M){return(await this.filterUninstalled(M)).length===1}async filterUninstalled(...M){const U=[],k=await this.extensionsScanner.getUninstalledExtensions();for(const F of M)k[F.key()]&&U.push(F.key());return U}getExtensionsReport(){const M=new Date().getTime();return(!this.reportedExtensions||M-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=M),this.reportedExtensions}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const M=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${M.length} reported extensions from service`),M}catch(M){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}reportTelemetry(M,U,k,F){const N=F?F instanceof p.ExtensionManagementError?F.code:z:void 0;this.telemetryService.publicLogError(M,Object.assign(Object.assign({},U),{success:!F,duration:k,errorcode:N}))}};G=de([Y(0,n.INativeEnvironmentService),Y(1,p.IExtensionGalleryService),Y(2,E.ILogService),Y(3,a.optional(i.IDownloadService)),Y(4,o.ITelemetryService),Y(5,a.IInstantiationService),Y(6,_.IFileService)],G),e.ExtensionManagementService=G}),define(Z[211],ee([0,1,42,35,212,101,51,100,36,76,50,150,9,130,132,28,205,173,23,164,39,165,24,59,171,80,81,176,18,77,157,56,2,166,72,162,161,144,143,152,151,172,71,158,10,160,16,27,21,198,200,195,58,196,201,170,20,168,197,60,194,174,61,73,134,202,175,86,85,84,4,153,145,11,44,82,183,178,199,141,147,177,5,14]),function(H,e,y,R,L,A,O,P,p,S,n,v,h,C,f,I,D,E,b,g,o,s,t,r,i,a,c,u,l,m,w,d,T,_,j,$,K,B,z,G,V,M,U,k,F,N,q,W,Q,X,ie,ne,ce,le,ve,pe,Ce,Ae,_e,Oe,ke,je,Ie,Te,Ke,Ye,$e,qe,J,re,se,me,Se,Pe,be,Ue,De,x,te,ae,oe,he,ge,fe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class ye extends T.Disposable{constructor(ue){super();this.configuration=ue,this.server=this._register(new P.Server),L.gracefulify(y),this.registerListeners()}registerListeners(){const ue=()=>this.dispose();process.once("exit",ue),A.ipcRenderer.once("vscode:electron-main->shared-process=exit",ue)}async open(){const ue=await this.initServices();Q.registerConfiguration(),ue.invokeFunction(Re=>{const Fe=Re.get(l.ILogService);Fe.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Re),this.registerErrorHandler(Fe)}),this._register(T.combinedDisposable(ue.createInstance($.NodeCachedDataCleaner,this.configuration.nodeCachedDataDir),ue.createInstance(K.LanguagePackCachedDataCleaner),ue.createInstance(B.StorageDataCleaner,this.configuration.backupWorkspacesPath),ue.createInstance(z.LogsDataCleaner),ue.createInstance(me.LocalizationsUpdater),ue.createInstance(Se.DeprecatedExtensionsCleaner)))}async initServices(){const ue=new S.ServiceCollection,Re=Object.assign({_serviceBrand:void 0},O.default);ue.set(W.IProductService,Re);const Fe=new p.StaticRouter(Be=>Be==="main"),Me=new V.MessagePortMainProcessService(this.server,Fe);ue.set(G.IMainProcessService,Me);const Ne=new C.NativeEnvironmentService(this.configuration.args,Re);ue.set(h.INativeEnvironmentService,Ne);const tt=new m.LogLevelChannelClient(this.server.getChannel("logLevel",Fe)),Je=new m.LoggerChannelClient(this.configuration.logLevel,tt.onDidChangeLogLevel,Me.getChannel("logger"));ue.set(l.ILoggerService,Je);const it=this._register(new l.MultiplexLogService([this._register(new l.ConsoleLogger(this.configuration.logLevel)),this._register(Je.createLogger(fe.joinPath(ge.URI.file(Ne.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),We=this._register(new m.FollowerLogService(tt,it));ue.set(l.ILogService,We);const Ve=this._register(new k.FileService(We));ue.set(F.IFileService,Ve);const rt=this._register(new N.DiskFileSystemProvider(We));Ve.registerProvider(q.Schemas.file,rt);const xe=this._register(new g.ConfigurationService(Ne.settingsResource,Ve));ue.set(b.IConfigurationService,xe),await xe.initialize();const Xe=new pe.NativeStorageService(void 0,Me,Ne);ue.set(Ce.IStorageService,Xe),await Xe.initialize(),this._register(T.toDisposable(()=>Xe.flush())),ue.set(o.IRequestService,new n.SyncDescriptor(s.RequestService)),ue.set(ae.IChecksumService,new n.SyncDescriptor(oe.ChecksumService));const nt=p.ProxyChannel.toService(Me.getChannel("nativeHost"),{context:this.configuration.windowId});ue.set(ce.INativeHostService,nt),ue.set(j.IDownloadService,new n.SyncDescriptor(_.DownloadService));const st=this._register(new Ye.ActiveWindowManager(nt)),dt=new p.StaticRouter(Be=>st.getActiveClientId().then(at=>Be===at));ue.set(Te.IExtensionRecommendationNotificationService,new Ke.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",dt)));let Qe,He;if(!Ne.isExtensionDevelopment&&!Ne.disableTelemetry&&Re.enableTelemetry){He=new $e.TelemetryLogAppender(Je,Ne);const{appRoot:Be,extensionsPath:at,isBuilt:mt,installSourcePath:vt}=Ne;if(Re.aiConfig&&Re.aiConfig.asimovKey&&mt){const ut=new u.AppInsightsAppender("monacoworkbench",null,Re.aiConfig.asimovKey);this._register(T.toDisposable(()=>ut.flush())),He=r.combinedAppender(ut,He)}Qe=new c.TelemetryService({appender:He,commonProperties:i.resolveCommonProperties(Ve,R.release(),R.hostname(),process.arch,Re.commit,Re.version,this.configuration.machineId,Re.msftInternalDomains,vt),sendErrorTelemetry:!0,piiPaths:[Be,at]},xe)}else Qe=r.NullTelemetryService,He=r.NullAppender;this.server.registerChannel("telemetryAppender",new a.TelemetryAppenderChannel(He)),ue.set(t.ITelemetryService,Qe);const gt=new he.CustomEndpointTelemetryService(xe,Qe);return ue.set(t.ICustomEndpointTelemetryService,gt),ue.set(I.IExtensionManagementService,new n.SyncDescriptor(D.ExtensionManagementService)),ue.set(I.IExtensionGalleryService,new n.SyncDescriptor(E.ExtensionGalleryService)),ue.set(I.IExtensionTipsService,new n.SyncDescriptor(je.ExtensionTipsService)),ue.set(d.ILocalizationsService,new n.SyncDescriptor(w.LocalizationsService)),ue.set(U.IDiagnosticsService,new n.SyncDescriptor(M.DiagnosticsService)),ue.set(Oe.IUserDataSyncAccountService,new n.SyncDescriptor(Oe.UserDataSyncAccountService)),ue.set(Q.IUserDataSyncLogService,new n.SyncDescriptor(le.UserDataSyncLogService)),ue.set(Q.IUserDataSyncUtilService,new ne.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",Be=>Be.ctx!=="main"))),ue.set(I.IGlobalExtensionEnablementService,new n.SyncDescriptor(Ae.GlobalExtensionEnablementService)),ue.set(J.IIgnoredExtensionsManagementService,new n.SyncDescriptor(J.IgnoredExtensionsManagementService)),ue.set(re.IExtensionsStorageSyncService,new n.SyncDescriptor(re.ExtensionsStorageSyncService)),ue.set(Q.IUserDataSyncStoreManagementService,new n.SyncDescriptor(ie.UserDataSyncStoreManagementService)),ue.set(Q.IUserDataSyncStoreService,new n.SyncDescriptor(ie.UserDataSyncStoreService)),ue.set(Ie.IUserDataSyncMachinesService,new n.SyncDescriptor(Ie.UserDataSyncMachinesService)),ue.set(Q.IUserDataSyncBackupStoreService,new n.SyncDescriptor(ke.UserDataSyncBackupStoreService)),ue.set(Q.IUserDataAutoSyncEnablementService,new n.SyncDescriptor(qe.UserDataAutoSyncEnablementService)),ue.set(Q.IUserDataSyncResourceEnablementService,new n.SyncDescriptor(_e.UserDataSyncResourceEnablementService)),ue.set(Q.IUserDataSyncService,new n.SyncDescriptor(X.UserDataSyncService)),ue.set(x.ILocalPtyService,this._register(new De.PtyHostService({GraceTime:6e4,ShortGraceTime:6e3},xe,We,Qe))),new v.InstantiationService(ue)}initChannels(ue){const Re=new f.ExtensionManagementChannel(ue.get(I.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Re);const Fe=p.ProxyChannel.fromService(ue.get(d.ILocalizationsService));this.server.registerChannel("localizations",Fe);const Me=p.ProxyChannel.fromService(ue.get(U.IDiagnosticsService));this.server.registerChannel("diagnostics",Me);const Ne=new f.ExtensionTipsChannel(ue.get(I.IExtensionTipsService));this.server.registerChannel("extensionTipsService",Ne);const tt=p.ProxyChannel.fromService(ue.get(ae.IChecksumService));this.server.registerChannel("checksum",tt);const Je=new ne.UserDataSyncMachinesServiceChannel(ue.get(Ie.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",Je);const it=p.ProxyChannel.fromService(ue.get(t.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",it);const We=new ne.UserDataSyncAccountServiceChannel(ue.get(Oe.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",We);const Ve=new ne.UserDataSyncStoreManagementServiceChannel(ue.get(Q.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",Ve);const rt=new te.UserDataSyncChannel(ue.get(Q.IUserDataSyncService),ue.get(l.ILogService));this.server.registerChannel("userDataSync",rt);const xe=this._register(ue.get(se.IInstantiationService).createInstance(ve.UserDataAutoSyncService)),Xe=new ne.UserDataAutoSyncChannel(xe);this.server.registerChannel("userDataAutoSync",Xe);const nt=ue.get(x.ILocalPtyService),st=p.ProxyChannel.fromService(nt);this.server.registerChannel(Ue.TerminalIpcChannels.LocalPty,st)}registerErrorHandler(ue){window.addEventListener("unhandledrejection",Re=>{Pe.onUnexpectedError(Re.reason),Re.preventDefault()}),Pe.setUnexpectedErrorHandler(Re=>{const Fe=be.toErrorMessage(Re,!0);!Fe||ue.error(`[uncaught exception in sharedProcess]: ${Fe}`)})}}async function we(Ee){const ue=new ye(Ee);A.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await ue.open(),A.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=we})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/b4c1bd0a9b03c749ea011b06c6d2676c8091a70c/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
