/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var J=["require","exports","vs/base/common/lifecycle","vs/base/common/path","vs/base/common/async","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/base/common/uri","vs/base/common/network","vs/base/node/pfs","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/types","vs/base/common/errors","vs/base/common/platform","vs/platform/log/common/log","vs/base/common/buffer","vs/base/common/resources","vs/platform/files/common/files","vs/base/common/strings","vs/base/common/objects","vs/platform/environment/common/environment","vs/base/common/arrays","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/registry/common/platform","vs/platform/configuration/common/configuration","vs/base/common/cancellation","vs/base/common/errorMessage","vs/base/common/uuid","vs/platform/configuration/common/configurationRegistry","fs","os","child_process","vs/base/common/process","vs/base/common/stream","vs/base/common/extpath","vs/base/parts/ipc/common/ipc","vs/platform/extensions/common/extensions","vs/base/common/semver/semver","vs/platform/product/common/product","vs/platform/product/common/productService","vs/platform/telemetry/common/telemetry","vs/base/node/zip","vs/base/common/decorators","vs/base/common/map","vs/base/node/decoder","vs/base/node/processes","vs/base/parts/ipc/node/ipc.cp","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/files/node/watcher/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/localizations/common/localizations","vs/platform/files/common/io","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/base/common/assert","vs/base/common/json","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/labels","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/watcher","vs/base/parts/storage/common/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/graph","vs/platform/download/common/download","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/localizations/node/localizations","vs/platform/log/node/spdlogLog","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/storage/common/storage","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/telemetry","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","string_decoder","vs/base/common/normalization","vs/platform/environment/node/argvHelper","crypto","vs/base/common/performance","vs/base/common/iterator","yauzl","yazl","zlib","vs/code/node/cliProcessMain","graceful-fs"],Y=function(_){for(var t=[],g=0,A=_.length;g<A;g++)t[g]=J[_[g]];return t};define(J[57],Y([0,1]),function(_,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=void 0;function g(A,I){if(!A)throw new Error(I?`Assertion failed (${I})`:"Assertion Failed")}t.ok=g}),define(J[44],Y([0,1]),function(_,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.throttle=t.debounce=t.memoize=t.createDecorator=void 0;function g(F){return(D,c,f)=>{let C=null,w=null;if(typeof f.value=="function"?(C="value",w=f.value):typeof f.get=="function"&&(C="get",w=f.get),!w)throw new Error("not supported");f[C]=F(w,c)}}t.createDecorator=g;function A(F,D,c){let f=null,C=null;if(typeof c.value=="function"?(f="value",C=c.value,C.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof c.get=="function"&&(f="get",C=c.get),!C)throw new Error("not supported");const w=`$memoize$${D}`;c[f]=function(...y){return this.hasOwnProperty(w)||Object.defineProperty(this,w,{configurable:!1,enumerable:!1,writable:!1,value:C.apply(this,y)}),this[w]}}t.memoize=A;function I(F,D,c){return g((f,C)=>{const w=`$debounce$${C}`,y=`$debounce$result$${C}`;return function(...O){this[y]||(this[y]=c?c():void 0),clearTimeout(this[w]),D&&(this[y]=D(this[y],...O),O=[this[y]]),this[w]=setTimeout(()=>{f.apply(this,O),this[y]=c?c():void 0},F)}})}t.debounce=I;function L(F,D,c){return g((f,C)=>{const w=`$throttle$timer$${C}`,y=`$throttle$result$${C}`,O=`$throttle$lastRun$${C}`,u=`$throttle$pending$${C}`;return function(...h){if(this[y]||(this[y]=c?c():void 0),(this[O]===null||this[O]===void 0)&&(this[O]=-Number.MAX_VALUE),D&&(this[y]=D(this[y],...h)),this[u])return;const b=this[O]+F;b<=Date.now()?(this[O]=Date.now(),f.apply(this,[this[y]]),this[y]=c?c():void 0):(this[u]=!0,this[w]=setTimeout(()=>{this[u]=!1,this[O]=Date.now(),f.apply(this,[this[y]]),this[y]=c?c():void 0},b-Date.now()))}})}t.throttle=L}),define(J[22],Y([0,1,13]),function(_,t,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.maxIndex=t.minIndex=t.mapFind=t.getRandomElement=t.asArray=t.mapArrayOrNot=t.pushToEnd=t.pushToStart=t.shuffle=t.arrayInsert=t.remove=t.insert=t.index=t.range=t.flatten=t.commonPrefixLength=t.firstOrDefault=t.lastIndex=t.uniqueFilter=t.distinctES6=t.distinct=t.isNonEmptyArray=t.isFalsyOrEmpty=t.move=t.coalesceInPlace=t.coalesce=t.topAsync=t.top=t.delta=t.sortedDiff=t.groupBy=t.quickSelect=t.findFirstInSorted=t.binarySearch=t.equals=t.tail2=t.tail=void 0;function A(T,d=0){return T[T.length-(1+d)]}t.tail=A;function I(T){if(T.length===0)throw new Error("Invalid tail call");return[T.slice(0,T.length-1),T[T.length-1]]}t.tail2=I;function L(T,d,a=(m,p)=>m===p){if(T===d)return!0;if(!T||!d||T.length!==d.length)return!1;for(let m=0,p=T.length;m<p;m++)if(!a(T[m],d[m]))return!1;return!0}t.equals=L;function F(T,d,a){let m=0,p=T.length-1;for(;m<=p;){const N=(m+p)/2|0,M=a(T[N],d);if(M<0)m=N+1;else if(M>0)p=N-1;else return N}return-(m+1)}t.binarySearch=F;function D(T,d){let a=0,m=T.length;if(m===0)return 0;for(;a<m;){const p=Math.floor((a+m)/2);d(T[p])?m=p:a=p+1}return a}t.findFirstInSorted=D;function c(T,d,a){if(T=T|0,T>=d.length)throw new TypeError("invalid index");let m=d[Math.floor(d.length*Math.random())],p=[],N=[],M=[];for(let W of d){const B=a(W,m);B<0?p.push(W):B>0?N.push(W):M.push(W)}return T<p.length?c(T,p,a):T<p.length+M.length?M[0]:c(T-(p.length+M.length),N,a)}t.quickSelect=c;function f(T,d){const a=[];let m;for(const p of T.slice(0).sort(d))!m||d(m[0],p)!==0?(m=[p],a.push(m)):m.push(p);return a}t.groupBy=f;function C(T,d,a){const m=[];function p(W,B,x){if(B===0&&x.length===0)return;const H=m[m.length-1];H&&H.start+H.deleteCount===W?(H.deleteCount+=B,H.toInsert.push(...x)):m.push({start:W,deleteCount:B,toInsert:x})}let N=0,M=0;for(;;){if(N===T.length){p(N,0,d.slice(M));break}if(M===d.length){p(N,T.length-N,[]);break}const W=T[N],B=d[M],x=a(W,B);x===0?(N+=1,M+=1):x<0?(p(N,1,[]),N+=1):x>0&&(p(N,0,[B]),M+=1)}return m}t.sortedDiff=C;function w(T,d,a){const m=C(T,d,a),p=[],N=[];for(const M of m)p.push(...T.slice(M.start,M.start+M.deleteCount)),N.push(...M.toInsert);return{removed:p,added:N}}t.delta=w;function y(T,d,a){if(a===0)return[];const m=T.slice(0,a).sort(d);return u(T,d,m,a,T.length),m}t.top=y;function O(T,d,a,m,p){return a===0?Promise.resolve([]):new Promise((N,M)=>{(async()=>{const W=T.length,B=T.slice(0,a).sort(d);for(let x=a,H=Math.min(a+m,W);x<W;x=H,H=Math.min(H+m,W)){if(x>a&&await new Promise(X=>setTimeout(X)),p&&p.isCancellationRequested)throw g.canceled();u(T,d,B,x,H)}return B})().then(N,M)})}t.topAsync=O;function u(T,d,a,m,p){for(const N=a.length;m<p;m++){const M=T[m];if(d(M,a[N-1])<0){a.pop();const W=D(a,B=>d(M,B)<0);a.splice(W,0,M)}}}function h(T){return T.filter(d=>!!d)}t.coalesce=h;function b(T){let d=0;for(let a=0;a<T.length;a++)T[a]&&(T[d]=T[a],d+=1);T.length=d}t.coalesceInPlace=b;function R(T,d,a){T.splice(a,0,T.splice(d,1)[0])}t.move=R;function P(T){return!Array.isArray(T)||T.length===0}t.isFalsyOrEmpty=P;function v(T){return Array.isArray(T)&&T.length>0}t.isNonEmptyArray=v;function o(T,d){if(!d)return T.filter((m,p)=>T.indexOf(m)===p);const a=Object.create(null);return T.filter(m=>{const p=d(m);return a[p]?!1:(a[p]=!0,!0)})}t.distinct=o;function r(T){const d=new Set;return T.filter(a=>d.has(a)?!1:(d.add(a),!0))}t.distinctES6=r;function e(T){const d=Object.create(null);return a=>{const m=T(a);return d[m]?!1:(d[m]=!0,!0)}}t.uniqueFilter=e;function i(T,d){for(let a=T.length-1;a>=0;a--){const m=T[a];if(d(m))return a}return-1}t.lastIndex=i;function n(T,d){return T.length>0?T[0]:d}t.firstOrDefault=n;function s(T,d,a=(m,p)=>m===p){let m=0;for(let p=0,N=Math.min(T.length,d.length);p<N&&a(T[p],d[p]);p++)m++;return m}t.commonPrefixLength=s;function l(T){return[].concat(...T)}t.flatten=l;function E(T,d){let a=typeof d=="number"?T:0;typeof d=="number"?a=T:(a=0,d=T);const m=[];if(a<=d)for(let p=a;p<d;p++)m.push(p);else for(let p=a;p>d;p--)m.push(p);return m}t.range=E;function S(T,d,a){return T.reduce((m,p)=>(m[d(p)]=a?a(p):p,m),Object.create(null))}t.index=S;function U(T,d){return T.push(d),()=>k(T,d)}t.insert=U;function k(T,d){const a=T.indexOf(d);if(a>-1)return T.splice(a,1),d}t.remove=k;function j(T,d,a){const m=T.slice(0,d),p=T.slice(d);return m.concat(a,p)}t.arrayInsert=j;function V(T,d){let a;if(typeof d=="number"){let m=d;a=()=>{const p=Math.sin(m++)*179426549;return p-Math.floor(p)}}else a=Math.random;for(let m=T.length-1;m>0;m-=1){const p=Math.floor(a()*(m+1)),N=T[m];T[m]=T[p],T[p]=N}}t.shuffle=V;function $(T,d){const a=T.indexOf(d);a>-1&&(T.splice(a,1),T.unshift(d))}t.pushToStart=$;function K(T,d){const a=T.indexOf(d);a>-1&&(T.splice(a,1),T.push(d))}t.pushToEnd=K;function ee(T,d){return Array.isArray(T)?T.map(d):d(T)}t.mapArrayOrNot=ee;function te(T){return Array.isArray(T)?T:[T]}t.asArray=te;function Z(T){return T[Math.floor(Math.random()*T.length)]}t.getRandomElement=Z;function ae(T,d){for(const a of T){const m=d(a);if(m!==void 0)return m}}t.mapFind=ae;function se(T,d){let a=Number.MAX_SAFE_INTEGER,m=0;return T.forEach((p,N)=>{const M=d(p);M<a&&(a=M,m=N)}),m}t.minIndex=se;function re(T,d){let a=Number.MIN_SAFE_INTEGER,m=0;return T.forEach((p,N)=>{const M=d(p);M>a&&(a=M,m=N)}),m}t.maxIndex=re}),define(J[58],Y([0,1]),function(_,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getNodeType=t.stripComments=t.visit=t.findNodeAtOffset=t.contains=t.getNodeValue=t.getNodePath=t.findNodeAtLocation=t.parseTree=t.parse=t.getLocation=t.createScanner=t.ParseOptions=t.ParseErrorCode=t.SyntaxKind=t.ScanError=void 0;var g;(function(e){e[e.None=0]="None",e[e.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=2]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",e[e.InvalidUnicode=4]="InvalidUnicode",e[e.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",e[e.InvalidCharacter=6]="InvalidCharacter"})(g=t.ScanError||(t.ScanError={}));var A;(function(e){e[e.OpenBraceToken=1]="OpenBraceToken",e[e.CloseBraceToken=2]="CloseBraceToken",e[e.OpenBracketToken=3]="OpenBracketToken",e[e.CloseBracketToken=4]="CloseBracketToken",e[e.CommaToken=5]="CommaToken",e[e.ColonToken=6]="ColonToken",e[e.NullKeyword=7]="NullKeyword",e[e.TrueKeyword=8]="TrueKeyword",e[e.FalseKeyword=9]="FalseKeyword",e[e.StringLiteral=10]="StringLiteral",e[e.NumericLiteral=11]="NumericLiteral",e[e.LineCommentTrivia=12]="LineCommentTrivia",e[e.BlockCommentTrivia=13]="BlockCommentTrivia",e[e.LineBreakTrivia=14]="LineBreakTrivia",e[e.Trivia=15]="Trivia",e[e.Unknown=16]="Unknown",e[e.EOF=17]="EOF"})(A=t.SyntaxKind||(t.SyntaxKind={}));var I;(function(e){e[e.InvalidSymbol=1]="InvalidSymbol",e[e.InvalidNumberFormat=2]="InvalidNumberFormat",e[e.PropertyNameExpected=3]="PropertyNameExpected",e[e.ValueExpected=4]="ValueExpected",e[e.ColonExpected=5]="ColonExpected",e[e.CommaExpected=6]="CommaExpected",e[e.CloseBraceExpected=7]="CloseBraceExpected",e[e.CloseBracketExpected=8]="CloseBracketExpected",e[e.EndOfFileExpected=9]="EndOfFileExpected",e[e.InvalidCommentToken=10]="InvalidCommentToken",e[e.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=12]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",e[e.InvalidUnicode=14]="InvalidUnicode",e[e.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",e[e.InvalidCharacter=16]="InvalidCharacter"})(I=t.ParseErrorCode||(t.ParseErrorCode={}));var L;(function(e){e.DEFAULT={allowTrailingComma:!0}})(L=t.ParseOptions||(t.ParseOptions={}));function F(e,i=!1){let n=0,s=e.length,l="",E=0,S=16,U=0;function k(Z){let ae=0,se=0;for(;ae<Z;){const re=e.charCodeAt(n);if(re>=48&&re<=57)se=se*16+re-48;else if(re>=65&&re<=70)se=se*16+re-65+10;else if(re>=97&&re<=102)se=se*16+re-97+10;else break;n++,ae++}return ae<Z&&(se=-1),se}function j(Z){n=Z,l="",E=0,S=16,U=0}function V(){const Z=n;if(e.charCodeAt(n)===48)n++;else for(n++;n<e.length&&f(e.charCodeAt(n));)n++;if(n<e.length&&e.charCodeAt(n)===46)if(n++,n<e.length&&f(e.charCodeAt(n)))for(n++;n<e.length&&f(e.charCodeAt(n));)n++;else return U=3,e.substring(Z,n);let ae=n;if(n<e.length&&(e.charCodeAt(n)===69||e.charCodeAt(n)===101))if(n++,(n<e.length&&e.charCodeAt(n)===43||e.charCodeAt(n)===45)&&n++,n<e.length&&f(e.charCodeAt(n))){for(n++;n<e.length&&f(e.charCodeAt(n));)n++;ae=n}else U=3;return e.substring(Z,ae)}function $(){let Z="",ae=n;for(;;){if(n>=s){Z+=e.substring(ae,n),U=2;break}const se=e.charCodeAt(n);if(se===34){Z+=e.substring(ae,n),n++;break}if(se===92){if(Z+=e.substring(ae,n),n++,n>=s){U=2;break}switch(e.charCodeAt(n++)){case 34:Z+='"';break;case 92:Z+="\\";break;case 47:Z+="/";break;case 98:Z+="\b";break;case 102:Z+="\f";break;case 110:Z+=`
`;break;case 114:Z+="\r";break;case 116:Z+="	";break;case 117:const T=k(4);T>=0?Z+=String.fromCharCode(T):U=4;break;default:U=5}ae=n;continue}if(se>=0&&se<=31)if(c(se)){Z+=e.substring(ae,n),U=2;break}else U=6;n++}return Z}function K(){if(l="",U=0,E=n,n>=s)return E=s,S=17;let Z=e.charCodeAt(n);if(D(Z)){do n++,l+=String.fromCharCode(Z),Z=e.charCodeAt(n);while(D(Z));return S=15}if(c(Z))return n++,l+=String.fromCharCode(Z),Z===13&&e.charCodeAt(n)===10&&(n++,l+=`
`),S=14;switch(Z){case 123:return n++,S=1;case 125:return n++,S=2;case 91:return n++,S=3;case 93:return n++,S=4;case 58:return n++,S=6;case 44:return n++,S=5;case 34:return n++,l=$(),S=10;case 47:const ae=n-1;if(e.charCodeAt(n+1)===47){for(n+=2;n<s&&!c(e.charCodeAt(n));)n++;return l=e.substring(ae,n),S=12}if(e.charCodeAt(n+1)===42){n+=2;const se=s-1;let re=!1;for(;n<se;){if(e.charCodeAt(n)===42&&e.charCodeAt(n+1)===47){n+=2,re=!0;break}n++}return re||(n++,U=1),l=e.substring(ae,n),S=13}return l+=String.fromCharCode(Z),n++,S=16;case 45:if(l+=String.fromCharCode(Z),n++,n===s||!f(e.charCodeAt(n)))return S=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return l+=V(),S=11;default:for(;n<s&&ee(Z);)n++,Z=e.charCodeAt(n);if(E!==n){switch(l=e.substring(E,n),l){case"true":return S=8;case"false":return S=9;case"null":return S=7}return S=16}return l+=String.fromCharCode(Z),n++,S=16}}function ee(Z){if(D(Z)||c(Z))return!1;switch(Z){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function te(){let Z;do Z=K();while(Z>=12&&Z<=15);return Z}return{setPosition:j,getPosition:()=>n,scan:i?te:K,getToken:()=>S,getTokenValue:()=>l,getTokenOffset:()=>E,getTokenLength:()=>n-E,getTokenError:()=>U}}t.createScanner=F;function D(e){return e===32||e===9||e===11||e===12||e===160||e===5760||e>=8192&&e<=8203||e===8239||e===8287||e===12288||e===65279}function c(e){return e===10||e===13||e===8232||e===8233}function f(e){return e>=48&&e<=57}var C;(function(e){e[e.nullCharacter=0]="nullCharacter",e[e.maxAsciiCharacter=127]="maxAsciiCharacter",e[e.lineFeed=10]="lineFeed",e[e.carriageReturn=13]="carriageReturn",e[e.lineSeparator=8232]="lineSeparator",e[e.paragraphSeparator=8233]="paragraphSeparator",e[e.nextLine=133]="nextLine",e[e.space=32]="space",e[e.nonBreakingSpace=160]="nonBreakingSpace",e[e.enQuad=8192]="enQuad",e[e.emQuad=8193]="emQuad",e[e.enSpace=8194]="enSpace",e[e.emSpace=8195]="emSpace",e[e.threePerEmSpace=8196]="threePerEmSpace",e[e.fourPerEmSpace=8197]="fourPerEmSpace",e[e.sixPerEmSpace=8198]="sixPerEmSpace",e[e.figureSpace=8199]="figureSpace",e[e.punctuationSpace=8200]="punctuationSpace",e[e.thinSpace=8201]="thinSpace",e[e.hairSpace=8202]="hairSpace",e[e.zeroWidthSpace=8203]="zeroWidthSpace",e[e.narrowNoBreakSpace=8239]="narrowNoBreakSpace",e[e.ideographicSpace=12288]="ideographicSpace",e[e.mathematicalSpace=8287]="mathematicalSpace",e[e.ogham=5760]="ogham",e[e._=95]="_",e[e.$=36]="$",e[e._0=48]="_0",e[e._1=49]="_1",e[e._2=50]="_2",e[e._3=51]="_3",e[e._4=52]="_4",e[e._5=53]="_5",e[e._6=54]="_6",e[e._7=55]="_7",e[e._8=56]="_8",e[e._9=57]="_9",e[e.a=97]="a",e[e.b=98]="b",e[e.c=99]="c",e[e.d=100]="d",e[e.e=101]="e",e[e.f=102]="f",e[e.g=103]="g",e[e.h=104]="h",e[e.i=105]="i",e[e.j=106]="j",e[e.k=107]="k",e[e.l=108]="l",e[e.m=109]="m",e[e.n=110]="n",e[e.o=111]="o",e[e.p=112]="p",e[e.q=113]="q",e[e.r=114]="r",e[e.s=115]="s",e[e.t=116]="t",e[e.u=117]="u",e[e.v=118]="v",e[e.w=119]="w",e[e.x=120]="x",e[e.y=121]="y",e[e.z=122]="z",e[e.A=65]="A",e[e.B=66]="B",e[e.C=67]="C",e[e.D=68]="D",e[e.E=69]="E",e[e.F=70]="F",e[e.G=71]="G",e[e.H=72]="H",e[e.I=73]="I",e[e.J=74]="J",e[e.K=75]="K",e[e.L=76]="L",e[e.M=77]="M",e[e.N=78]="N",e[e.O=79]="O",e[e.P=80]="P",e[e.Q=81]="Q",e[e.R=82]="R",e[e.S=83]="S",e[e.T=84]="T",e[e.U=85]="U",e[e.V=86]="V",e[e.W=87]="W",e[e.X=88]="X",e[e.Y=89]="Y",e[e.Z=90]="Z",e[e.ampersand=38]="ampersand",e[e.asterisk=42]="asterisk",e[e.at=64]="at",e[e.backslash=92]="backslash",e[e.bar=124]="bar",e[e.caret=94]="caret",e[e.closeBrace=125]="closeBrace",e[e.closeBracket=93]="closeBracket",e[e.closeParen=41]="closeParen",e[e.colon=58]="colon",e[e.comma=44]="comma",e[e.dot=46]="dot",e[e.doubleQuote=34]="doubleQuote",e[e.equals=61]="equals",e[e.exclamation=33]="exclamation",e[e.greaterThan=62]="greaterThan",e[e.lessThan=60]="lessThan",e[e.minus=45]="minus",e[e.openBrace=123]="openBrace",e[e.openBracket=91]="openBracket",e[e.openParen=40]="openParen",e[e.percent=37]="percent",e[e.plus=43]="plus",e[e.question=63]="question",e[e.semicolon=59]="semicolon",e[e.singleQuote=39]="singleQuote",e[e.slash=47]="slash",e[e.tilde=126]="tilde",e[e.backspace=8]="backspace",e[e.formFeed=12]="formFeed",e[e.byteOrderMark=65279]="byteOrderMark",e[e.tab=9]="tab",e[e.verticalTab=11]="verticalTab"})(C||(C={}));function w(e,i){const n=[],s=new Object;let l;const E={value:{},offset:0,length:0,type:"object",parent:void 0};let S=!1;function U(k,j,V,$){E.value=k,E.offset=j,E.length=V,E.type=$,E.colonOffset=void 0,l=E}try{v(e,{onObjectBegin:(k,j)=>{if(i<=k)throw s;l=void 0,S=i>k,n.push("")},onObjectProperty:(k,j,V)=>{if(i<j||(U(k,j,V,"property"),n[n.length-1]=k,i<=j+V))throw s},onObjectEnd:(k,j)=>{if(i<=k)throw s;l=void 0,n.pop()},onArrayBegin:(k,j)=>{if(i<=k)throw s;l=void 0,n.push(0)},onArrayEnd:(k,j)=>{if(i<=k)throw s;l=void 0,n.pop()},onLiteralValue:(k,j,V)=>{if(i<j||(U(k,j,V,r(k)),i<=j+V))throw s},onSeparator:(k,j,V)=>{if(i<=j)throw s;if(k===":"&&l&&l.type==="property")l.colonOffset=j,S=!1,l=void 0;else if(k===","){const $=n[n.length-1];typeof $=="number"?n[n.length-1]=$+1:(S=!0,n[n.length-1]=""),l=void 0}}})}catch(k){if(k!==s)throw k}return{path:n,previousNode:l,isAtPropertyKey:S,matches:k=>{let j=0;for(let V=0;j<k.length&&V<n.length;V++)if(k[j]===n[V]||k[j]==="*")j++;else if(k[j]!=="**")return!1;return j===k.length}}}t.getLocation=w;function y(e,i=[],n=L.DEFAULT){let s=null,l=[];const E=[];function S(k){Array.isArray(l)?l.push(k):s!==null&&(l[s]=k)}return v(e,{onObjectBegin:()=>{const k={};S(k),E.push(l),l=k,s=null},onObjectProperty:k=>{s=k},onObjectEnd:()=>{l=E.pop()},onArrayBegin:()=>{const k=[];S(k),E.push(l),l=k,s=null},onArrayEnd:()=>{l=E.pop()},onLiteralValue:S,onError:(k,j,V)=>{i.push({error:k,offset:j,length:V})}},n),l[0]}t.parse=y;function O(e,i=[],n=L.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function l(k){s.type==="property"&&(s.length=k-s.offset,s=s.parent)}function E(k){return s.children.push(k),k}v(e,{onObjectBegin:k=>{s=E({type:"object",offset:k,length:-1,parent:s,children:[]})},onObjectProperty:(k,j,V)=>{s=E({type:"property",offset:j,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:k,offset:j,length:V,parent:s})},onObjectEnd:(k,j)=>{s.length=k+j-s.offset,s=s.parent,l(k+j)},onArrayBegin:(k,j)=>{s=E({type:"array",offset:k,length:-1,parent:s,children:[]})},onArrayEnd:(k,j)=>{s.length=k+j-s.offset,s=s.parent,l(k+j)},onLiteralValue:(k,j,V)=>{E({type:r(k),offset:j,length:V,parent:s,value:k}),l(j+V)},onSeparator:(k,j,V)=>{s.type==="property"&&(k===":"?s.colonOffset=j:k===","&&l(j))},onError:(k,j,V)=>{i.push({error:k,offset:j,length:V})}},n);const U=s.children[0];return U&&delete U.parent,U}t.parseTree=O;function u(e,i){if(!e)return;let n=e;for(let s of i)if(typeof s=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let l=!1;for(const E of n.children)if(Array.isArray(E.children)&&E.children[0].value===s){n=E.children[1],l=!0;break}if(!l)return}else{const l=s;if(n.type!=="array"||l<0||!Array.isArray(n.children)||l>=n.children.length)return;n=n.children[l]}return n}t.findNodeAtLocation=u;function h(e){if(!e.parent||!e.parent.children)return[];const i=h(e.parent);if(e.parent.type==="property"){const n=e.parent.children[0].value;i.push(n)}else if(e.parent.type==="array"){const n=e.parent.children.indexOf(e);n!==-1&&i.push(n)}return i}t.getNodePath=h;function b(e){switch(e.type){case"array":return e.children.map(b);case"object":const i=Object.create(null);for(let n of e.children){const s=n.children[1];s&&(i[n.children[0].value]=b(s))}return i;case"null":case"string":case"number":case"boolean":return e.value;default:return}}t.getNodeValue=b;function R(e,i,n=!1){return i>=e.offset&&i<e.offset+e.length||n&&i===e.offset+e.length}t.contains=R;function P(e,i,n=!1){if(R(e,i,n)){const s=e.children;if(Array.isArray(s))for(let l=0;l<s.length&&s[l].offset<=i;l++){const E=P(s[l],i,n);if(E)return E}return e}}t.findNodeAtOffset=P;function v(e,i,n=L.DEFAULT){const s=F(e,!1);function l(M){return M?()=>M(s.getTokenOffset(),s.getTokenLength()):()=>!0}function E(M){return M?W=>M(W,s.getTokenOffset(),s.getTokenLength()):()=>!0}const S=l(i.onObjectBegin),U=E(i.onObjectProperty),k=l(i.onObjectEnd),j=l(i.onArrayBegin),V=l(i.onArrayEnd),$=E(i.onLiteralValue),K=E(i.onSeparator),ee=l(i.onComment),te=E(i.onError),Z=n&&n.disallowComments,ae=n&&n.allowTrailingComma;function se(){for(;;){const M=s.scan();switch(s.getTokenError()){case 4:re(14);break;case 5:re(15);break;case 3:re(13);break;case 1:Z||re(11);break;case 2:re(12);break;case 6:re(16);break}switch(M){case 12:case 13:Z?re(10):ee();break;case 16:re(1);break;case 15:case 14:break;default:return M}}}function re(M,W=[],B=[]){if(te(M),W.length+B.length>0){let x=s.getToken();for(;x!==17;){if(W.indexOf(x)!==-1){se();break}else if(B.indexOf(x)!==-1)break;x=se()}}}function T(M){const W=s.getTokenValue();return M?$(W):U(W),se(),!0}function d(){switch(s.getToken()){case 11:let M=0;try{M=JSON.parse(s.getTokenValue()),typeof M!="number"&&(re(2),M=0)}catch(W){re(2)}$(M);break;case 7:$(null);break;case 8:$(!0);break;case 9:$(!1);break;default:return!1}return se(),!0}function a(){return s.getToken()!==10?(re(3,[],[2,5]),!1):(T(!1),s.getToken()===6?(K(":"),se(),N()||re(4,[],[2,5])):re(5,[],[2,5]),!0)}function m(){S(),se();let M=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(M||re(4,[],[]),K(","),se(),s.getToken()===2&&ae)break}else M&&re(6,[],[]);a()||re(4,[],[2,5]),M=!0}return k(),s.getToken()!==2?re(7,[2],[]):se(),!0}function p(){j(),se();let M=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(M||re(4,[],[]),K(","),se(),s.getToken()===4&&ae)break}else M&&re(6,[],[]);N()||re(4,[],[4,5]),M=!0}return V(),s.getToken()!==4?re(8,[4],[]):se(),!0}function N(){switch(s.getToken()){case 3:return p();case 1:return m();case 10:return T(!0);default:return d()}}return se(),s.getToken()===17?n.allowEmptyContent?!0:(re(4,[],[]),!1):N()?(s.getToken()!==17&&re(9,[],[]),!0):(re(4,[],[]),!1)}t.visit=v;function o(e,i){let n=F(e),s=[],l,E=0,S;do switch(S=n.getPosition(),l=n.scan(),l){case 12:case 13:case 17:E!==S&&s.push(e.substring(E,S)),i!==void 0&&s.push(n.getTokenValue().replace(/[^\r\n]/g,i)),E=n.getPosition();break}while(l!==17);return s.join("")}t.stripComments=o;function r(e){switch(typeof e){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(e){if(Array.isArray(e))return"array"}else return"null";return"object"}default:return"null"}}t.getNodeType=r}),function(){function _(I){const L=[];typeof I=="number"&&L.push("code/timeOrigin",I);function F(c){L.push(c,Date.now())}function D(){const c=[];for(let f=0;f<L.length;f+=2)c.push({name:L[f],startTime:L[f+1]});return c}return{mark:F,getMarks:D}}function t(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?_():{mark(I){performance.mark(I)},getMarks(){let I=performance.timeOrigin;typeof I!="number"&&(I=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(I)}];for(const F of performance.getEntriesByType("mark"))L.push({name:F.name,startTime:Math.round(I+F.startTime)});return L}};if(typeof process=="object"){const I=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return _(I)}else return console.trace("perf-util loaded in UNKNOWN environment"),_()}function g(I){return I.MonacoPerformanceMarks||(I.MonacoPerformanceMarks=t()),I.MonacoPerformanceMarks}var A;typeof global=="object"?A=global:typeof self=="object"?A=self:A={},typeof define=="function"?define("vs/base/common/performance",[],function(){return g(A)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=g(A):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),A.perf=g(A))}(),function(_,t){if(typeof exports=="object"&&typeof module=="object")module.exports=t();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],t);else{var g=t();for(var A in g)(typeof exports=="object"?exports:_)[A]=g[A]}}(typeof self!="undefined"?self:this,function(){return function(_){var t={};function g(A){if(t[A])return t[A].exports;var I=t[A]={i:A,l:!1,exports:{}};return _[A].call(I.exports,I,I.exports,g),I.l=!0,I.exports}return g.m=_,g.c=t,g.d=function(A,I,L){g.o(A,I)||Object.defineProperty(A,I,{enumerable:!0,get:L})},g.r=function(A){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(A,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(A,"__esModule",{value:!0})},g.t=function(A,I){if(1&I&&(A=g(A)),8&I||4&I&&typeof A=="object"&&A&&A.__esModule)return A;var L=Object.create(null);if(g.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:A}),2&I&&typeof A!="string")for(var F in A)g.d(L,F,function(D){return A[D]}.bind(null,F));return L},g.n=function(A){var I=A&&A.__esModule?function(){return A.default}:function(){return A};return g.d(I,"a",I),I},g.o=function(A,I){return Object.prototype.hasOwnProperty.call(A,I)},g.p="",g(g.s=0)}([function(_,t,g){(function(A){var I;t=_.exports=B,I=typeof A=="object"&&A.env&&A.env.NODE_DEBUG&&/\bsemver\b/i.test(A.env.NODE_DEBUG)?function(){var z=Array.prototype.slice.call(arguments,0);z.unshift("SEMVER"),console.log.apply(console,z)}:function(){},t.SEMVER_SPEC_VERSION="2.0.0";var L=256,F=Number.MAX_SAFE_INTEGER||9007199254740991,D=t.re=[],c=t.src=[],f=0,C=f++;c[C]="0|[1-9]\\d*";var w=f++;c[w]="[0-9]+";var y=f++;c[y]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var O=f++;c[O]="("+c[C]+")\\.("+c[C]+")\\.("+c[C]+")";var u=f++;c[u]="("+c[w]+")\\.("+c[w]+")\\.("+c[w]+")";var h=f++;c[h]="(?:"+c[C]+"|"+c[y]+")";var b=f++;c[b]="(?:"+c[w]+"|"+c[y]+")";var R=f++;c[R]="(?:-("+c[h]+"(?:\\."+c[h]+")*))";var P=f++;c[P]="(?:-?("+c[b]+"(?:\\."+c[b]+")*))";var v=f++;c[v]="[0-9A-Za-z-]+";var o=f++;c[o]="(?:\\+("+c[v]+"(?:\\."+c[v]+")*))";var r=f++,e="v?"+c[O]+c[R]+"?"+c[o]+"?";c[r]="^"+e+"$";var i="[v=\\s]*"+c[u]+c[P]+"?"+c[o]+"?",n=f++;c[n]="^"+i+"$";var s=f++;c[s]="((?:<|>)?=?)";var l=f++;c[l]=c[w]+"|x|X|\\*";var E=f++;c[E]=c[C]+"|x|X|\\*";var S=f++;c[S]="[v=\\s]*("+c[E]+")(?:\\.("+c[E]+")(?:\\.("+c[E]+")(?:"+c[R]+")?"+c[o]+"?)?)?";var U=f++;c[U]="[v=\\s]*("+c[l]+")(?:\\.("+c[l]+")(?:\\.("+c[l]+")(?:"+c[P]+")?"+c[o]+"?)?)?";var k=f++;c[k]="^"+c[s]+"\\s*"+c[S]+"$";var j=f++;c[j]="^"+c[s]+"\\s*"+c[U]+"$";var V=f++;c[V]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var $=f++;c[$]="(?:~>?)";var K=f++;c[K]="(\\s*)"+c[$]+"\\s+",D[K]=new RegExp(c[K],"g");var ee=f++;c[ee]="^"+c[$]+c[S]+"$";var te=f++;c[te]="^"+c[$]+c[U]+"$";var Z=f++;c[Z]="(?:\\^)";var ae=f++;c[ae]="(\\s*)"+c[Z]+"\\s+",D[ae]=new RegExp(c[ae],"g");var se=f++;c[se]="^"+c[Z]+c[S]+"$";var re=f++;c[re]="^"+c[Z]+c[U]+"$";var T=f++;c[T]="^"+c[s]+"\\s*("+i+")$|^$";var d=f++;c[d]="^"+c[s]+"\\s*("+e+")$|^$";var a=f++;c[a]="(\\s*)"+c[s]+"\\s*("+i+"|"+c[S]+")",D[a]=new RegExp(c[a],"g");var m=f++;c[m]="^\\s*("+c[S]+")\\s+-\\s+("+c[S]+")\\s*$";var p=f++;c[p]="^\\s*("+c[U]+")\\s+-\\s+("+c[U]+")\\s*$";var N=f++;c[N]="(<|>)?=?\\s*\\*";for(var M=0;M<35;M++)I(M,c[M]),D[M]||(D[M]=new RegExp(c[M]));function W(z,q){if(z instanceof B)return z;if(typeof z!="string"||z.length>L||!(q?D[n]:D[r]).test(z))return null;try{return new B(z,q)}catch(G){return null}}function B(z,q){if(z instanceof B){if(z.loose===q)return z;z=z.version}else if(typeof z!="string")throw new TypeError("Invalid Version: "+z);if(z.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof B))return new B(z,q);I("SemVer",z,q),this.loose=q;var G=z.trim().match(q?D[n]:D[r]);if(!G)throw new TypeError("Invalid Version: "+z);if(this.raw=z,this.major=+G[1],this.minor=+G[2],this.patch=+G[3],this.major>F||this.major<0)throw new TypeError("Invalid major version");if(this.minor>F||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>F||this.patch<0)throw new TypeError("Invalid patch version");G[4]?this.prerelease=G[4].split(".").map(function(ne){if(/^[0-9]+$/.test(ne)){var oe=+ne;if(oe>=0&&oe<F)return oe}return ne}):this.prerelease=[],this.build=G[5]?G[5].split("."):[],this.format()}t.parse=W,t.valid=function(z,q){var G=W(z,q);return G?G.version:null},t.clean=function(z,q){var G=W(z.trim().replace(/^[=v]+/,""),q);return G?G.version:null},t.SemVer=B,B.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},B.prototype.toString=function(){return this.version},B.prototype.compare=function(z){return I("SemVer.compare",this.version,this.loose,z),z instanceof B||(z=new B(z,this.loose)),this.compareMain(z)||this.comparePre(z)},B.prototype.compareMain=function(z){return z instanceof B||(z=new B(z,this.loose)),H(this.major,z.major)||H(this.minor,z.minor)||H(this.patch,z.patch)},B.prototype.comparePre=function(z){if(z instanceof B||(z=new B(z,this.loose)),this.prerelease.length&&!z.prerelease.length)return-1;if(!this.prerelease.length&&z.prerelease.length)return 1;if(!this.prerelease.length&&!z.prerelease.length)return 0;var q=0;do{var G=this.prerelease[q],ne=z.prerelease[q];if(I("prerelease compare",q,G,ne),G===void 0&&ne===void 0)return 0;if(ne===void 0)return 1;if(G===void 0)return-1;if(G!==ne)return H(G,ne)}while(++q)},B.prototype.inc=function(z,q){switch(z){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",q);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",q);break;case"prepatch":this.prerelease.length=0,this.inc("patch",q),this.inc("pre",q);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",q),this.inc("pre",q);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var G=this.prerelease.length;--G>=0;)typeof this.prerelease[G]=="number"&&(this.prerelease[G]++,G=-2);G===-1&&this.prerelease.push(0)}q&&(this.prerelease[0]===q?isNaN(this.prerelease[1])&&(this.prerelease=[q,0]):this.prerelease=[q,0]);break;default:throw new Error("invalid increment argument: "+z)}return this.format(),this.raw=this.version,this},t.inc=function(z,q,G,ne){typeof G=="string"&&(ne=G,G=void 0);try{return new B(z,G).inc(q,ne).version}catch(oe){return null}},t.diff=function(z,q){if(ce(z,q))return null;var G=W(z),ne=W(q);if(G.prerelease.length||ne.prerelease.length){for(var oe in G)if((oe==="major"||oe==="minor"||oe==="patch")&&G[oe]!==ne[oe])return"pre"+oe;return"prerelease"}for(var oe in G)if((oe==="major"||oe==="minor"||oe==="patch")&&G[oe]!==ne[oe])return oe},t.compareIdentifiers=H;var x=/^[0-9]+$/;function H(z,q){var G=x.test(z),ne=x.test(q);return G&&ne&&(z=+z,q=+q),G&&!ne?-1:ne&&!G?1:z<q?-1:z>q?1:0}function X(z,q,G){return new B(z,G).compare(new B(q,G))}function Q(z,q,G){return X(z,q,G)>0}function ie(z,q,G){return X(z,q,G)<0}function ce(z,q,G){return X(z,q,G)===0}function ge(z,q,G){return X(z,q,G)!==0}function Ie(z,q,G){return X(z,q,G)>=0}function Fe(z,q,G){return X(z,q,G)<=0}function Oe(z,q,G,ne){var oe;switch(q){case"===":typeof z=="object"&&(z=z.version),typeof G=="object"&&(G=G.version),oe=z===G;break;case"!==":typeof z=="object"&&(z=z.version),typeof G=="object"&&(G=G.version),oe=z!==G;break;case"":case"=":case"==":oe=ce(z,G,ne);break;case"!=":oe=ge(z,G,ne);break;case">":oe=Q(z,G,ne);break;case">=":oe=Ie(z,G,ne);break;case"<":oe=ie(z,G,ne);break;case"<=":oe=Fe(z,G,ne);break;default:throw new TypeError("Invalid operator: "+q)}return oe}function Se(z,q){if(z instanceof Se){if(z.loose===q)return z;z=z.value}if(!(this instanceof Se))return new Se(z,q);I("comparator",z,q),this.loose=q,this.parse(z),this.semver===ke?this.value="":this.value=this.operator+this.semver.version,I("comp",this)}t.rcompareIdentifiers=function(z,q){return H(q,z)},t.major=function(z,q){return new B(z,q).major},t.minor=function(z,q){return new B(z,q).minor},t.patch=function(z,q){return new B(z,q).patch},t.compare=X,t.compareLoose=function(z,q){return X(z,q,!0)},t.rcompare=function(z,q,G){return X(q,z,G)},t.sort=function(z,q){return z.sort(function(G,ne){return t.compare(G,ne,q)})},t.rsort=function(z,q){return z.sort(function(G,ne){return t.rcompare(G,ne,q)})},t.gt=Q,t.lt=ie,t.eq=ce,t.neq=ge,t.gte=Ie,t.lte=Fe,t.cmp=Oe,t.Comparator=Se;var ke={};function pe(z,q){if(z instanceof pe)return z.loose===q?z:new pe(z.raw,q);if(z instanceof Se)return new pe(z.value,q);if(!(this instanceof pe))return new pe(z,q);if(this.loose=q,this.raw=z,this.set=z.split(/\s*\|\|\s*/).map(function(G){return this.parseRange(G.trim())},this).filter(function(G){return G.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+z);this.format()}function Re(z){return!z||z.toLowerCase()==="x"||z==="*"}function xe(z,q,G,ne,oe,be,de,Ce,Ee,Le,Ne,we,Pe){return((q=Re(G)?"":Re(ne)?">="+G+".0.0":Re(oe)?">="+G+"."+ne+".0":">="+q)+" "+(Ce=Re(Ee)?"":Re(Le)?"<"+(+Ee+1)+".0.0":Re(Ne)?"<"+Ee+"."+(+Le+1)+".0":we?"<="+Ee+"."+Le+"."+Ne+"-"+we:"<="+Ce)).trim()}function _e(z,q){for(var G=0;G<z.length;G++)if(!z[G].test(q))return!1;if(q.prerelease.length){for(G=0;G<z.length;G++)if(I(z[G].semver),z[G].semver!==ke&&z[G].semver.prerelease.length>0){var ne=z[G].semver;if(ne.major===q.major&&ne.minor===q.minor&&ne.patch===q.patch)return!0}return!1}return!0}function Ue(z,q,G){try{q=new pe(q,G)}catch(ne){return!1}return q.test(z)}function ze(z,q,G,ne){var oe,be,de,Ce,Ee;switch(z=new B(z,ne),q=new pe(q,ne),G){case">":oe=Q,be=Fe,de=ie,Ce=">",Ee=">=";break;case"<":oe=ie,be=Ie,de=Q,Ce="<",Ee="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ue(z,q,ne))return!1;for(var Le=0;Le<q.set.length;++Le){var Ne=q.set[Le],we=null,Pe=null;if(Ne.forEach(function(Te){Te.semver===ke&&(Te=new Se(">=0.0.0")),we=we||Te,Pe=Pe||Te,oe(Te.semver,we.semver,ne)?we=Te:de(Te.semver,Pe.semver,ne)&&(Pe=Te)}),we.operator===Ce||we.operator===Ee||(!Pe.operator||Pe.operator===Ce)&&be(z,Pe.semver)||Pe.operator===Ee&&de(z,Pe.semver))return!1}return!0}Se.prototype.parse=function(z){var q=this.loose?D[T]:D[d],G=z.match(q);if(!G)throw new TypeError("Invalid comparator: "+z);this.operator=G[1],this.operator==="="&&(this.operator=""),G[2]?this.semver=new B(G[2],this.loose):this.semver=ke},Se.prototype.toString=function(){return this.value},Se.prototype.test=function(z){return I("Comparator.test",z,this.loose),this.semver===ke||(typeof z=="string"&&(z=new B(z,this.loose)),Oe(z,this.operator,this.semver,this.loose))},Se.prototype.intersects=function(z,q){if(!(z instanceof Se))throw new TypeError("a Comparator is required");var G;if(this.operator==="")return G=new pe(z.value,q),Ue(this.value,G,q);if(z.operator==="")return G=new pe(this.value,q),Ue(z.semver,G,q);var ne=!(this.operator!==">="&&this.operator!==">"||z.operator!==">="&&z.operator!==">"),oe=!(this.operator!=="<="&&this.operator!=="<"||z.operator!=="<="&&z.operator!=="<"),be=this.semver.version===z.semver.version,de=!(this.operator!==">="&&this.operator!=="<="||z.operator!==">="&&z.operator!=="<="),Ce=Oe(this.semver,"<",z.semver,q)&&(this.operator===">="||this.operator===">")&&(z.operator==="<="||z.operator==="<"),Ee=Oe(this.semver,">",z.semver,q)&&(this.operator==="<="||this.operator==="<")&&(z.operator===">="||z.operator===">");return ne||oe||be&&de||Ce||Ee},t.Range=pe,pe.prototype.format=function(){return this.range=this.set.map(function(z){return z.join(" ").trim()}).join("||").trim(),this.range},pe.prototype.toString=function(){return this.range},pe.prototype.parseRange=function(z){var q=this.loose;z=z.trim(),I("range",z,q);var G=q?D[p]:D[m];z=z.replace(G,xe),I("hyphen replace",z),z=z.replace(D[a],"$1$2$3"),I("comparator trim",z,D[a]),z=(z=(z=z.replace(D[K],"$1~")).replace(D[ae],"$1^")).split(/\s+/).join(" ");var ne=q?D[T]:D[d],oe=z.split(" ").map(function(be){return function(de,Ce){return I("comp",de),de=function(Ee,Le){return Ee.trim().split(/\s+/).map(function(Ne){return function(we,Pe){I("caret",we,Pe);var Te=Pe?D[re]:D[se];return we.replace(Te,function(Ae,le,he,me,ve){var De;return I("caret",we,Ae,le,he,me,ve),Re(le)?De="":Re(he)?De=">="+le+".0.0 <"+(+le+1)+".0.0":Re(me)?De=le==="0"?">="+le+"."+he+".0 <"+le+"."+(+he+1)+".0":">="+le+"."+he+".0 <"+(+le+1)+".0.0":ve?(I("replaceCaret pr",ve),ve.charAt(0)!=="-"&&(ve="-"+ve),De=le==="0"?he==="0"?">="+le+"."+he+"."+me+ve+" <"+le+"."+he+"."+(+me+1):">="+le+"."+he+"."+me+ve+" <"+le+"."+(+he+1)+".0":">="+le+"."+he+"."+me+ve+" <"+(+le+1)+".0.0"):(I("no pr"),De=le==="0"?he==="0"?">="+le+"."+he+"."+me+" <"+le+"."+he+"."+(+me+1):">="+le+"."+he+"."+me+" <"+le+"."+(+he+1)+".0":">="+le+"."+he+"."+me+" <"+(+le+1)+".0.0"),I("caret return",De),De})}(Ne,Le)}).join(" ")}(de,Ce),I("caret",de),de=function(Ee,Le){return Ee.trim().split(/\s+/).map(function(Ne){return function(we,Pe){var Te=Pe?D[te]:D[ee];return we.replace(Te,function(Ae,le,he,me,ve){var De;return I("tilde",we,Ae,le,he,me,ve),Re(le)?De="":Re(he)?De=">="+le+".0.0 <"+(+le+1)+".0.0":Re(me)?De=">="+le+"."+he+".0 <"+le+"."+(+he+1)+".0":ve?(I("replaceTilde pr",ve),ve.charAt(0)!=="-"&&(ve="-"+ve),De=">="+le+"."+he+"."+me+ve+" <"+le+"."+(+he+1)+".0"):De=">="+le+"."+he+"."+me+" <"+le+"."+(+he+1)+".0",I("tilde return",De),De})}(Ne,Le)}).join(" ")}(de,Ce),I("tildes",de),de=function(Ee,Le){return I("replaceXRanges",Ee,Le),Ee.split(/\s+/).map(function(Ne){return function(we,Pe){we=we.trim();var Te=Pe?D[j]:D[k];return we.replace(Te,function(Ae,le,he,me,ve,De){I("xRange",we,Ae,le,he,me,ve,De);var We=Re(he),Me=We||Re(me),je=Me||Re(ve);return le==="="&&je&&(le=""),We?Ae=le===">"||le==="<"?"<0.0.0":"*":le&&je?(Me&&(me=0),je&&(ve=0),le===">"?(le=">=",Me?(he=+he+1,me=0,ve=0):je&&(me=+me+1,ve=0)):le==="<="&&(le="<",Me?he=+he+1:me=+me+1),Ae=le+he+"."+me+"."+ve):Me?Ae=">="+he+".0.0 <"+(+he+1)+".0.0":je&&(Ae=">="+he+"."+me+".0 <"+he+"."+(+me+1)+".0"),I("xRange return",Ae),Ae})}(Ne,Le)}).join(" ")}(de,Ce),I("xrange",de),de=function(Ee,Le){return I("replaceStars",Ee,Le),Ee.trim().replace(D[N],"")}(de,Ce),I("stars",de),de}(be,q)}).join(" ").split(/\s+/);return this.loose&&(oe=oe.filter(function(be){return!!be.match(ne)})),oe=oe.map(function(be){return new Se(be,q)})},pe.prototype.intersects=function(z,q){if(!(z instanceof pe))throw new TypeError("a Range is required");return this.set.some(function(G){return G.every(function(ne){return z.set.some(function(oe){return oe.every(function(be){return ne.intersects(be,q)})})})})},t.toComparators=function(z,q){return new pe(z,q).set.map(function(G){return G.map(function(ne){return ne.value}).join(" ").trim().split(" ")})},pe.prototype.test=function(z){if(!z)return!1;typeof z=="string"&&(z=new B(z,this.loose));for(var q=0;q<this.set.length;q++)if(_e(this.set[q],z))return!0;return!1},t.satisfies=Ue,t.maxSatisfying=function(z,q,G){var ne=null,oe=null;try{var be=new pe(q,G)}catch(de){return null}return z.forEach(function(de){be.test(de)&&(ne&&oe.compare(de)!==-1||(oe=new B(ne=de,G)))}),ne},t.minSatisfying=function(z,q,G){var ne=null,oe=null;try{var be=new pe(q,G)}catch(de){return null}return z.forEach(function(de){be.test(de)&&(ne&&oe.compare(de)!==1||(oe=new B(ne=de,G)))}),ne},t.validRange=function(z,q){try{return new pe(z,q).range||"*"}catch(G){return null}},t.ltr=function(z,q,G){return ze(z,q,"<",G)},t.gtr=function(z,q,G){return ze(z,q,">",G)},t.outside=ze,t.prerelease=function(z,q){var G=W(z,q);return G&&G.prerelease.length?G.prerelease:null},t.intersects=function(z,q,G){return z=new pe(z,G),q=new pe(q,G),z.intersects(q)},t.coerce=function(z){if(z instanceof B)return z;if(typeof z!="string")return null;var q=z.match(D[V]);return q==null?null:W((q[1]||"0")+"."+(q[2]||"0")+"."+(q[3]||"0"))}}).call(this,g(1))},function(_,t){var g,A,I=_.exports={};function L(){throw new Error("setTimeout has not been defined")}function F(){throw new Error("clearTimeout has not been defined")}function D(b){if(g===setTimeout)return setTimeout(b,0);if((g===L||!g)&&setTimeout)return g=setTimeout,setTimeout(b,0);try{return g(b,0)}catch(R){try{return g.call(null,b,0)}catch(P){return g.call(this,b,0)}}}(function(){try{g=typeof setTimeout=="function"?setTimeout:L}catch(b){g=L}try{A=typeof clearTimeout=="function"?clearTimeout:F}catch(b){A=F}})();var c,f=[],C=!1,w=-1;function y(){C&&c&&(C=!1,c.length?f=c.concat(f):w=-1,f.length&&O())}function O(){if(!C){var b=D(y);C=!0;for(var R=f.length;R;){for(c=f,f=[];++w<R;)c&&c[w].run();w=-1,R=f.length}c=null,C=!1,function(P){if(A===clearTimeout)return clearTimeout(P);if((A===F||!A)&&clearTimeout)return A=clearTimeout,clearTimeout(P);try{A(P)}catch(v){try{return A.call(null,P)}catch(o){return A.call(this,P)}}}(b)}}function u(b,R){this.fun=b,this.array=R}function h(){}I.nextTick=function(b){var R=new Array(arguments.length-1);if(arguments.length>1)for(var P=1;P<arguments.length;P++)R[P-1]=arguments[P];f.push(new u(b,R)),f.length!==1||C||D(O)},u.prototype.run=function(){this.fun.apply(null,this.array)},I.title="browser",I.browser=!0,I.env={},I.argv=[],I.version="",I.versions={},I.on=h,I.addListener=h,I.once=h,I.off=h,I.removeListener=h,I.removeAllListeners=h,I.emit=h,I.prependListener=h,I.prependOnceListener=h,I.listeners=function(b){return[]},I.binding=function(b){throw new Error("process.binding is not supported")},I.cwd=function(){return"/"},I.chdir=function(b){throw new Error("process.chdir is not supported")},I.umask=function(){return 0}}])}),define(J[35],Y([0,1,13,2]),function(_,t,g,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedStream=t.prefixedReadable=t.transform=t.toReadable=t.emptyStream=t.toStream=t.peekStream=t.listenStream=t.consumeStream=t.peekReadable=t.consumeReadable=t.newWriteableStream=t.isReadableBufferedStream=t.isReadableStream=void 0;function I(v){const o=v;return o?[o.on,o.pause,o.resume,o.destroy].every(r=>typeof r=="function"):!1}t.isReadableStream=I;function L(v){const o=v;return o?I(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}t.isReadableBufferedStream=L;function F(v,o){return new D(v,o)}t.newWriteableStream=F;class D{constructor(o,r){this.reducer=o,this.options=r,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(o){var r;if(!this.state.destroyed){if(this.state.flowing)this.emitData(o);else if(this.buffer.data.push(o),typeof((r=this.options)===null||r===void 0?void 0:r.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(e=>this.pendingWritePromises.push(e))}}error(o){this.state.destroyed||(this.state.flowing?this.emitError(o):this.buffer.error.push(o))}end(o){this.state.destroyed||(typeof o!="undefined"&&this.write(o),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(o){this.listeners.data.slice(0).forEach(r=>r(o))}emitError(o){this.listeners.error.length===0?g.onUnexpectedError(o):this.listeners.error.slice(0).forEach(r=>r(o))}emitEnd(){this.listeners.end.slice(0).forEach(o=>o())}on(o,r){if(!this.state.destroyed)switch(o){case"data":this.listeners.data.push(r),this.resume();break;case"end":this.listeners.end.push(r),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(r),this.state.flowing&&this.flowErrors();break}}removeListener(o,r){if(this.state.destroyed)return;let e;switch(o){case"data":e=this.listeners.data;break;case"end":e=this.listeners.end;break;case"error":e=this.listeners.error;break}if(e){const i=e.indexOf(r);i>=0&&e.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const o=this.reducer(this.buffer.data);this.emitData(o),this.buffer.data.length=0;const r=[...this.pendingWritePromises];this.pendingWritePromises.length=0,r.forEach(e=>e())}}flowErrors(){if(this.listeners.error.length>0){for(const o of this.buffer.error)this.emitError(o);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function c(v,o){const r=[];let e;for(;(e=v.read())!==null;)r.push(e);return o(r)}t.consumeReadable=c;function f(v,o,r){const e=[];let i;for(;(i=v.read())!==null&&e.length<r;)e.push(i);return i===null&&e.length>0?o(e):{read:()=>{if(e.length>0)return e.shift();if(typeof i!="undefined"){const n=i;return i=void 0,n}return v.read()}}}t.peekReadable=f;function C(v,o){return new Promise((r,e)=>{const i=[];w(v,{onData:n=>{o&&i.push(n)},onError:n=>{o?e(n):r(void 0)},onEnd:()=>{r(o?o(i):void 0)}})})}t.consumeStream=C;function w(v,o){v.on("error",r=>o.onError(r)),v.on("end",()=>o.onEnd()),v.on("data",r=>o.onData(r))}t.listenStream=w;function y(v,o){return new Promise((r,e)=>{const i=new A.DisposableStore,n=[],s=S=>{if(n.push(S),n.length>o)return i.dispose(),v.pause(),r({stream:v,buffer:n,ended:!1})},l=S=>e(S),E=()=>r({stream:v,buffer:n,ended:!0});i.add(A.toDisposable(()=>v.removeListener("error",l))),v.on("error",l),i.add(A.toDisposable(()=>v.removeListener("end",E))),v.on("end",E),i.add(A.toDisposable(()=>v.removeListener("data",s))),v.on("data",s)})}t.peekStream=y;function O(v,o){const r=F(o);return r.end(v),r}t.toStream=O;function u(){const v=F(()=>{throw new Error("not supported")});return v.end(),v}t.emptyStream=u;function h(v){let o=!1;return{read:()=>o?null:(o=!0,v)}}t.toReadable=h;function b(v,o,r){const e=F(r);return w(v,{onData:i=>e.write(o.data(i)),onError:i=>e.error(o.error?o.error(i):i),onEnd:()=>e.end()}),e}t.transform=b;function R(v,o,r){let e=!1;return{read:()=>{const i=o.read();return e?i:(e=!0,i!==null?r([v,i]):v)}}}t.prefixedReadable=R;function P(v,o,r){let e=!1;const i=F(r);return w(o,{onData:n=>e?i.write(n):(e=!0,i.write(r([v,n]))),onError:n=>i.error(n),onEnd:()=>{e||(e=!0,i.write(v)),i.end()}}),i}t.prefixedStream=P}),define(J[16],Y([0,1,19,35]),function(_,t,g,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedBufferStream=t.prefixedBufferReadable=t.newWriteableBufferStream=t.streamToBufferReadableStream=t.bufferToStream=t.bufferedStreamToBuffer=t.streamToBuffer=t.bufferToReadable=t.readableToBuffer=t.writeUInt8=t.readUInt8=t.writeUInt32LE=t.readUInt32LE=t.writeUInt32BE=t.readUInt32BE=t.writeUInt16LE=t.readUInt16LE=t.VSBuffer=void 0;const I=typeof Buffer!="undefined",L=typeof TextEncoder!="undefined",F=typeof TextDecoder!="undefined";let D,c;class f{constructor(S){this.buffer=S,this.byteLength=this.buffer.byteLength}static alloc(S){return I?new f(Buffer.allocUnsafe(S)):new f(new Uint8Array(S))}static wrap(S){return I&&!Buffer.isBuffer(S)&&(S=Buffer.from(S.buffer,S.byteOffset,S.byteLength)),new f(S)}static fromString(S,U){return!((U==null?void 0:U.dontUseNodeBuffer)||!1)&&I?new f(Buffer.from(S)):L?(D||(D=new TextEncoder),new f(D.encode(S))):new f(g.encodeUTF8(S))}static concat(S,U){if(typeof U=="undefined"){U=0;for(let V=0,$=S.length;V<$;V++)U+=S[V].byteLength}const k=f.alloc(U);let j=0;for(let V=0,$=S.length;V<$;V++){const K=S[V];k.set(K,j),j+=K.byteLength}return k}toString(){return I?this.buffer.toString():F?(c||(c=new TextDecoder),c.decode(this.buffer)):g.decodeUTF8(this.buffer)}slice(S,U){return new f(this.buffer.subarray(S,U))}set(S,U){S instanceof f?this.buffer.set(S.buffer,U):this.buffer.set(S,U)}readUInt32BE(S){return y(this.buffer,S)}writeUInt32BE(S,U){O(this.buffer,S,U)}readUInt32LE(S){return u(this.buffer,S)}writeUInt32LE(S,U){h(this.buffer,S,U)}readUInt8(S){return b(this.buffer,S)}writeUInt8(S,U){R(this.buffer,S,U)}}t.VSBuffer=f;function C(E,S){return E[S+0]<<0>>>0|E[S+1]<<8>>>0}t.readUInt16LE=C;function w(E,S,U){E[U+0]=S&255,S=S>>>8,E[U+1]=S&255}t.writeUInt16LE=w;function y(E,S){return E[S]*2**24+E[S+1]*2**16+E[S+2]*2**8+E[S+3]}t.readUInt32BE=y;function O(E,S,U){E[U+3]=S,S=S>>>8,E[U+2]=S,S=S>>>8,E[U+1]=S,S=S>>>8,E[U]=S}t.writeUInt32BE=O;function u(E,S){return E[S+0]<<0>>>0|E[S+1]<<8>>>0|E[S+2]<<16>>>0|E[S+3]<<24>>>0}t.readUInt32LE=u;function h(E,S,U){E[U+0]=S&255,S=S>>>8,E[U+1]=S&255,S=S>>>8,E[U+2]=S&255,S=S>>>8,E[U+3]=S&255}t.writeUInt32LE=h;function b(E,S){return E[S]}t.readUInt8=b;function R(E,S,U){E[U]=S}t.writeUInt8=R;function P(E){return A.consumeReadable(E,S=>f.concat(S))}t.readableToBuffer=P;function v(E){return A.toReadable(E)}t.bufferToReadable=v;function o(E){return A.consumeStream(E,S=>f.concat(S))}t.streamToBuffer=o;async function r(E){return E.ended?f.concat(E.buffer):f.concat([...E.buffer,await o(E.stream)])}t.bufferedStreamToBuffer=r;function e(E){return A.toStream(E,S=>f.concat(S))}t.bufferToStream=e;function i(E){return A.transform(E,{data:S=>typeof S=="string"?f.fromString(S):f.wrap(S)},S=>f.concat(S))}t.streamToBufferReadableStream=i;function n(E){return A.newWriteableStream(S=>f.concat(S),E)}t.newWriteableBufferStream=n;function s(E,S){return A.prefixedReadable(E,S,U=>f.concat(U))}t.prefixedBufferReadable=s;function l(E,S){return A.prefixedStream(E,S,U=>f.concat(U))}t.prefixedBufferStream=l}),define(J[20],Y([0,1,12]),function(_,t,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.filter=t.getCaseInsensitive=t.distinct=t.getOrDefault=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function A(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const b=Array.isArray(h)?[]:{};return Object.keys(h).forEach(R=>{h[R]&&typeof h[R]=="object"?b[R]=A(h[R]):b[R]=h[R]}),b}t.deepClone=A;function I(h){if(!h||typeof h!="object")return h;const b=[h];for(;b.length>0;){const R=b.shift();Object.freeze(R);for(const P in R)if(L.call(R,P)){const v=R[P];typeof v=="object"&&!Object.isFrozen(v)&&b.push(v)}}return h}t.deepFreeze=I;const L=Object.prototype.hasOwnProperty;function F(h,b){return D(h,b,new Set)}t.cloneAndChange=F;function D(h,b,R){if(g.isUndefinedOrNull(h))return h;const P=b(h);if(typeof P!="undefined")return P;if(g.isArray(h)){const v=[];for(const o of h)v.push(D(o,b,R));return v}if(g.isObject(h)){if(R.has(h))throw new Error("Cannot clone recursive data-structure");R.add(h);const v={};for(let o in h)L.call(h,o)&&(v[o]=D(h[o],b,R));return R.delete(h),v}return h}function c(h,b,R=!0){return g.isObject(h)?(g.isObject(b)&&Object.keys(b).forEach(P=>{P in h?R&&(g.isObject(h[P])&&g.isObject(b[P])?c(h[P],b[P],R):h[P]=b[P]):h[P]=b[P]}),h):b}t.mixin=c;function f(h,b){if(h===b)return!0;if(h==null||b===null||b===void 0||typeof h!=typeof b||typeof h!="object"||Array.isArray(h)!==Array.isArray(b))return!1;let R,P;if(Array.isArray(h)){if(h.length!==b.length)return!1;for(R=0;R<h.length;R++)if(!f(h[R],b[R]))return!1}else{const v=[];for(P in h)v.push(P);v.sort();const o=[];for(P in b)o.push(P);if(o.sort(),!f(v,o))return!1;for(R=0;R<v.length;R++)if(!f(h[v[R]],b[v[R]]))return!1}return!0}t.equals=f;function C(h){const b=new Set;return JSON.stringify(h,(R,P)=>{if(g.isObject(P)||Array.isArray(P)){if(b.has(P))return"[Circular]";b.add(P)}return P})}t.safeStringify=C;function w(h,b,R){const P=b(h);return typeof P=="undefined"?R:P}t.getOrDefault=w;function y(h,b){const R=Object.create(null);return!h||!b||Object.keys(b).forEach(v=>{const o=h[v],r=b[v];f(o,r)||(R[v]=r)}),R}t.distinct=y;function O(h,b){const R=b.toLowerCase(),P=Object.keys(h).find(v=>v.toLowerCase()===R);return P?h[P]:h[b]}t.getCaseInsensitive=O;function u(h,b){const R=Object.create(null);for(const P of Object.keys(h))b(P,h[P])&&(R[P]=h[P]);return R}t.filter=u}),define(J[59],Y([0,1,7]),function(_,t,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.log=t.getFirstFrame=t.parse=t.isRemoteConsoleLog=void 0;function A(f){const C=f;return C&&typeof C.type=="string"&&typeof C.severity=="string"}t.isRemoteConsoleLog=A;function I(f){const C=[];let w;try{const y=JSON.parse(f.arguments),O=y[y.length-1];O&&O.__$stack&&(y.pop(),w=O.__$stack),C.push(...y)}catch(y){C.push("Unable to log remote console arguments",f.arguments)}return{args:C,stack:w}}t.parse=I;function L(f){if(typeof f!="string")return L(I(f).stack);const C=f;if(C){const w=F(C),y=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(w||"");if(y&&y.length===4)return{uri:g.URI.file(y[1]),line:Number(y[2]),column:Number(y[3])}}}t.getFirstFrame=L;function F(f){if(!f)return f;const C=f.indexOf(`
`);return C===-1?f:f.substring(0,C)}function D(f,C){const{args:w,stack:y}=I(f),O=typeof w[0]=="string"&&w.length===1;let u=F(y);u&&(u=`(${u.trim()})`);let h=[];if(typeof w[0]=="string"?u&&O?h=[`%c[${C}] %c${w[0]} %c${u}`,c("blue"),c(""),c("grey")]:h=[`%c[${C}] %c${w[0]}`,c("blue"),c(""),...w.slice(1)]:h=[`%c[${C}]%`,c("blue"),...w],u&&!O&&h.push(u),typeof console[f.severity]!="function")throw new Error("Unknown console method");console[f.severity].apply(console,h)}t.log=D;function c(f){return`color: ${f}`}}),define(J[60],Y([0,1,16,19,7]),function(_,t,g,A,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.revive=t.parse=t.stringify=void 0;function L(f){return JSON.stringify(f,D)}t.stringify=L;function F(f){let C=JSON.parse(f);return C=c(C),C}t.parse=F;function D(f,C){return C instanceof RegExp?{$mid:2,source:C.source,flags:A.regExpFlags(C)}:C}function c(f,C=0){if(!f||C>200)return f;if(typeof f=="object"){switch(f.$mid){case 1:return I.URI.revive(f);case 2:return new RegExp(f.source,f.flags)}if(f instanceof g.VSBuffer||f instanceof Uint8Array)return f;if(Array.isArray(f))for(let w=0;w<f.length;++w)f[w]=c(f[w],C+1);else for(const w in f)Object.hasOwnProperty.call(f,w)&&(f[w]=c(f[w],C+1))}return f}t.revive=c}),define(J[61],Y([0,1,19,36,3,45,4]),function(_,t,g,A,I,L,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getPathTerms=t.getBasenameTerms=t.isRelativePattern=t.hasSiblingFn=t.hasSiblingPromiseFn=t.parse=t.match=t.splitGlobAware=t.getEmptyExpression=void 0;function D(){return Object.create(null)}t.getEmptyExpression=D;const c="**",f="/",C="[/\\\\]",w="[^/\\\\]",y=/\//g;function O(a){switch(a){case 0:return"";case 1:return`${w}*?`;default:return`(?:${C}|${w}+${C}|${C}${w}+)*?`}}function u(a,m){if(!a)return[];const p=[];let N=!1,M=!1,W="";for(const B of a){switch(B){case m:if(!N&&!M){p.push(W),W="";continue}break;case"{":N=!0;break;case"}":N=!1;break;case"[":M=!0;break;case"]":M=!1;break}W+=B}return W&&p.push(W),p}t.splitGlobAware=u;function h(a){if(!a)return"";let m="";const p=u(a,f);if(p.every(N=>N===c))m=".*";else{let N=!1;p.forEach((M,W)=>{if(M===c){N||(m+=O(2),N=!0);return}let B=!1,x="",H=!1,X="";for(const Q of M){if(Q!=="}"&&B){x+=Q;continue}if(H&&(Q!=="]"||!X)){let ie;Q==="-"?ie=Q:(Q==="^"||Q==="!")&&!X?ie="^":Q===f?ie="":ie=g.escapeRegExpCharacters(Q),X+=ie;continue}switch(Q){case"{":B=!0;continue;case"[":H=!0;continue;case"}":m+=`(?:${u(x,",").map(ge=>h(ge)).join("|")})`,B=!1,x="";break;case"]":m+="["+X+"]",H=!1,X="";break;case"?":m+=w;continue;case"*":m+=O(1);continue;default:m+=g.escapeRegExpCharacters(Q)}}W<p.length-1&&(p[W+1]!==c||W+2<p.length)&&(m+=C),N=!1})}return m}const b=/^\*\*\/\*\.[\w\.-]+$/,R=/^\*\*\/([\w\.-]+)\/?$/,P=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,v=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,r=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,e=new L.LRUCache(1e4),i=function(){return!1},n=function(){return null};function s(a,m){if(!a)return n;let p;typeof a!="string"?p=a.pattern:p=a,p=p.trim();const N=`${p}_${!!m.trimForExclusions}`;let M=e.get(N);if(M)return l(M,a);let W;if(b.test(p)){const B=p.substr(4);M=function(x,H){return typeof x=="string"&&x.endsWith(B)?p:null}}else(W=R.exec(E(p,m)))?M=S(W[1],p):(m.trimForExclusions?v:P).test(p)?M=U(p,m):(W=o.exec(E(p,m)))?M=k(W[1].substr(1),p,!0):(W=r.exec(E(p,m)))?M=k(W[1],p,!1):M=j(p);return e.set(N,M),l(M,a)}function l(a,m){return typeof m=="string"?a:function(p,N){return A.isEqualOrParent(p,m.base)?a(I.relative(m.base,p),N):null}}function E(a,m){return m.trimForExclusions&&a.endsWith("/**")?a.substr(0,a.length-2):a}function S(a,m){const p=`/${a}`,N=`\\${a}`,M=function(B,x){return typeof B!="string"?null:x?x===a?m:null:B===a||B.endsWith(p)||B.endsWith(N)?m:null},W=[a];return M.basenames=W,M.patterns=[m],M.allBasenames=W,M}function U(a,m){const p=d(a.slice(1,-1).split(",").map(x=>s(x,m)).filter(x=>x!==n),a),N=p.length;if(!N)return n;if(N===1)return p[0];const M=function(x,H){for(let X=0,Q=p.length;X<Q;X++)if(p[X](x,H))return a;return null},W=p.find(x=>!!x.allBasenames);W&&(M.allBasenames=W.allBasenames);const B=p.reduce((x,H)=>H.allPaths?x.concat(H.allPaths):x,[]);return B.length&&(M.allPaths=B),M}function k(a,m,p){const N=I.sep===I.posix.sep,M=N?a:a.replace(y,I.sep),W=I.sep+M,B=I.posix.sep+a,x=p?function(H,X){return typeof H=="string"&&(H===M||H.endsWith(W)||!N&&(H===a||H.endsWith(B)))?m:null}:function(H,X){return typeof H=="string"&&(H===M||!N&&H===a)?m:null};return x.allPaths=[(p?"*/":"./")+a],x}function j(a){try{const m=new RegExp(`^${h(a)}$`);return function(p){return m.lastIndex=0,typeof p=="string"&&m.test(p)?a:null}}catch(m){return n}}function V(a,m,p){return!a||typeof m!="string"?!1:$(a)(m,void 0,p)}t.match=V;function $(a,m={}){if(!a)return i;if(typeof a=="string"||Z(a)){const p=s(a,m);if(p===n)return i;const N=function(M,W){return!!p(M,W)};return p.allBasenames&&(N.allBasenames=p.allBasenames),p.allPaths&&(N.allPaths=p.allPaths),N}return re(a,m)}t.parse=$;function K(a){if(!a)return;let m;return p=>(m||(m=(a()||Promise.resolve([])).then(N=>N?te(N):{})),m.then(N=>!!N[p]))}t.hasSiblingPromiseFn=K;function ee(a){if(!a)return;let m;return p=>{if(!m){const N=a();m=N?te(N):{}}return!!m[p]}}t.hasSiblingFn=ee;function te(a){const m={};for(const p of a)m[p]=!0;return m}function Z(a){const m=a;return m&&typeof m.base=="string"&&typeof m.pattern=="string"}t.isRelativePattern=Z;function ae(a){return a.allBasenames||[]}t.getBasenameTerms=ae;function se(a){return a.allPaths||[]}t.getPathTerms=se;function re(a,m){const p=d(Object.getOwnPropertyNames(a).map(x=>T(x,a[x],m)).filter(x=>x!==n)),N=p.length;if(!N)return n;if(!p.some(x=>!!x.requiresSiblings)){if(N===1)return p[0];const x=function(Q,ie){for(let ce=0,ge=p.length;ce<ge;ce++){const Ie=p[ce](Q,ie);if(Ie)return Ie}return null},H=p.find(Q=>!!Q.allBasenames);H&&(x.allBasenames=H.allBasenames);const X=p.reduce((Q,ie)=>ie.allPaths?Q.concat(ie.allPaths):Q,[]);return X.length&&(x.allPaths=X),x}const M=function(x,H,X){let Q;for(let ie=0,ce=p.length;ie<ce;ie++){const ge=p[ie];ge.requiresSiblings&&X&&(H||(H=I.basename(x)),Q||(Q=H.substr(0,H.length-I.extname(x).length)));const Ie=ge(x,H,Q,X);if(Ie)return Ie}return null},W=p.find(x=>!!x.allBasenames);W&&(M.allBasenames=W.allBasenames);const B=p.reduce((x,H)=>H.allPaths?x.concat(H.allPaths):x,[]);return B.length&&(M.allPaths=B),M}function T(a,m,p){if(m===!1)return n;const N=s(a,p);if(N===n)return n;if(typeof m=="boolean")return N;if(m){const M=m.when;if(typeof M=="string"){const W=(B,x,H,X)=>{if(!X||!N(B,x))return null;const Q=M.replace("$(basename)",H),ie=X(Q);return F.isThenable(ie)?ie.then(ce=>ce?a:null):ie?a:null};return W.requiresSiblings=!0,W}}return N}function d(a,m){const p=a.filter(x=>!!x.basenames);if(p.length<2)return a;const N=p.reduce((x,H)=>{const X=H.basenames;return X?x.concat(X):x},[]);let M;if(m){M=[];for(let x=0,H=N.length;x<H;x++)M.push(m)}else M=p.reduce((x,H)=>{const X=H.patterns;return X?x.concat(X):x},[]);const W=function(x,H){if(typeof x!="string")return null;if(!H){let Q;for(Q=x.length;Q>0;Q--){const ie=x.charCodeAt(Q-1);if(ie===47||ie===92)break}H=x.substr(Q)}const X=N.indexOf(H);return X!==-1?M[X]:null};W.basenames=N,W.patterns=M,W.allBasenames=N;const B=a.filter(x=>!x.basenames);return B.push(W),B}}),define(J[62],Y([0,1,7,3,19,8,14,17,36]),function(_,t,g,A,I,L,F,D,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.splitName=t.unmnemonicLabel=t.mnemonicButtonLabel=t.mnemonicMenuLabel=t.template=t.shorten=t.untildify=t.tildify=t.normalizeDriveLetter=t.getBaseLabel=t.getPathLabel=void 0;function f(s,l,E){if(typeof s=="string"&&(s=g.URI.file(s)),E){const U=E.getWorkspaceFolder(s);if(U){const k=E.getWorkspace().folders.length>1;let j;if(D.isEqual(U.uri,s)?j="":j=D.relativePath(U.uri,s),k){const V=U.name?U.name:D.basename(U.uri);j=j?V+" \u2022 "+j:V}return j}}if(s.scheme!==L.Schemas.file&&s.scheme!==L.Schemas.untitled)return s.with({query:null,fragment:null}).toString(!0);if(c.hasDriveLetter(s.fsPath))return A.normalize(w(s.fsPath));let S=A.normalize(s.fsPath);return!F.isWindows&&(l==null?void 0:l.userHome)&&(S=O(S,l.userHome.fsPath)),S}t.getPathLabel=f;function C(s){if(!s)return;typeof s=="string"&&(s=g.URI.file(s));const l=D.basename(s)||(s.scheme===L.Schemas.file?s.fsPath:s.path);return F.isWindows&&c.isRootOrDriveLetter(l)?w(l):l}t.getBaseLabel=C;function w(s){return c.hasDriveLetter(s)?s.charAt(0).toUpperCase()+s.slice(1):s}t.normalizeDriveLetter=w;let y=Object.create(null);function O(s,l){if(F.isWindows||!s||!l)return s;let E=y.original===l?y.normalized:void 0;return E||(E=`${I.rtrim(l,A.posix.sep)}${A.posix.sep}`,y={original:l,normalized:E}),(F.isLinux?s.startsWith(E):I.startsWithIgnoreCase(s,E))&&(s=`~/${s.substr(E.length)}`),s}t.tildify=O;function u(s,l){return s.replace(/^~($|\/|\\)/,`${l}$1`)}t.untildify=u;const h="\u2026",b="\\\\",R="~";function P(s,l=A.sep){const E=new Array(s.length);let S=!1;for(let U=0;U<s.length;U++){let k=s[U];if(k===""){E[U]=`.${l}`;continue}if(!k){E[U]=k;continue}S=!0;let j="";k.indexOf(b)===0?(j=k.substr(0,k.indexOf(b)+b.length),k=k.substr(k.indexOf(b)+b.length)):k.indexOf(l)===0?(j=k.substr(0,k.indexOf(l)+l.length),k=k.substr(k.indexOf(l)+l.length)):k.indexOf(R)===0&&(j=k.substr(0,k.indexOf(R)+R.length),k=k.substr(k.indexOf(R)+R.length));const V=k.split(l);for(let $=1;S&&$<=V.length;$++)for(let K=V.length-$;S&&K>=0;K--){S=!1;let ee=V.slice(K,K+$).join(l);for(let te=0;!S&&te<s.length;te++)if(te!==U&&s[te]&&s[te].indexOf(ee)>-1){const Z=K+$===V.length,ae=K>0&&s[te].indexOf(l)>-1?l+ee:ee,se=s[te].endsWith(ae);S=!Z||se}if(!S){let te="";(V[0].endsWith(":")||j!=="")&&(K===1&&(K=0,$++,ee=V[0]+l+ee),K>0&&(te=V[0]+l),te=j+te),K>0&&(te=te+h+l),te=te+ee,K+$<V.length&&(te=te+l+h),E[U]=te}}S&&(E[U]=k)}return E}t.shorten=P;var v;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})(v||(v={}));function o(s,l=Object.create(null)){const E=[];let S=!1,U="";for(const k of s)if(k==="$"||S&&k==="{")U&&E.push({value:U,type:v.TEXT}),U="",S=!0;else if(k==="}"&&S){const j=l[U];if(typeof j=="string")j.length&&E.push({value:j,type:v.VARIABLE});else if(j){const V=E[E.length-1];(!V||V.type!==v.SEPARATOR)&&E.push({value:j.label,type:v.SEPARATOR})}U="",S=!1}else U+=k;return U&&!S&&E.push({value:U,type:v.TEXT}),E.filter((k,j)=>{if(k.type===v.SEPARATOR){const V=E[j-1],$=E[j+1];return[V,$].every(K=>K&&(K.type===v.VARIABLE||K.type===v.TEXT)&&K.value.length>0)}return!0}).map(k=>k.value).join("")}t.template=o;function r(s,l){return F.isMacintosh||l?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,F.isMacintosh?"&":"&&"):s.replace(/&&|&/g,E=>E==="&"?"&&":"&")}t.mnemonicMenuLabel=r;function e(s,l){return F.isMacintosh||l?s.replace(/\(&&\w\)|&&/g,""):F.isWindows?s.replace(/&&|&/g,E=>E==="&"?"&&":"&"):s.replace(/&&/g,"_")}t.mnemonicButtonLabel=e;function i(s){return s.replace(/&/g,"&&")}t.unmnemonicLabel=i;function n(s){const l=s.indexOf("/")!==-1?A.posix:A.win32,E=l.basename(s),S=l.dirname(s);return E.length?{name:E,parentPath:S}:{name:S,parentPath:""}}t.splitName=n}),define(J[46],Y([0,1,124]),function(_,t,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineDecoder=void 0;class A{constructor(L="utf8"){this.stringDecoder=new g.StringDecoder(L),this.remaining=null}write(L){const F=[],D=this.remaining?this.remaining+this.stringDecoder.write(L):this.stringDecoder.write(L);if(D.length<1)return F;let c=0,f,C=c;for(;C<D.length;)if(f=D.charCodeAt(C),f===13||f===10){if(F.push(D.substring(c,C)),C++,C<D.length){const w=f;f=D.charCodeAt(C),(w===13&&f===10||w===10&&f===13)&&C++}c=C}else C++;return this.remaining=c<D.length?D.substr(c):null,F}end(){return this.remaining}}t.LineDecoder=A}),define(J[63],Y([0,1,31,19,3,9]),function(_,t,g,A,I,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.realpathSync=t.realpath=t.realcaseSync=void 0;function F(C){const w=I.dirname(C);if(C===w)return C;const y=(I.basename(C)||C).toLowerCase();try{const u=L.readdirSync(w).filter(h=>h.toLowerCase()===y);if(u.length===1){const h=F(w);if(h)return I.join(h,u[0])}else if(u.length>1){const h=u.indexOf(y);if(h>=0){const b=F(w);if(b)return I.join(b,u[h])}}}catch(O){}return null}t.realcaseSync=F;async function D(C){try{return await L.Promises.realpath(C)}catch(w){const y=f(C);return await L.Promises.access(y,g.constants.R_OK),y}}t.realpath=D;function c(C){try{return g.realpathSync(C)}catch(w){const y=f(C);return g.accessSync(y,g.constants.R_OK),y}}t.realpathSync=c;function f(C){return A.rtrim(I.normalize(C),I.sep)}});var ye=this&&this.__await||function(_){return this instanceof ye?(this.v=_,this):new ye(_)},Ve=this&&this.__asyncGenerator||function(_,t,g){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var A=g.apply(_,t||[]),I,L=[];return I={},F("next"),F("throw"),F("return"),I[Symbol.asyncIterator]=function(){return this},I;function F(y){A[y]&&(I[y]=function(O){return new Promise(function(u,h){L.push([y,O,u,h])>1||D(y,O)})})}function D(y,O){try{c(A[y](O))}catch(u){w(L[0][3],u)}}function c(y){y.value instanceof ye?Promise.resolve(y.value.v).then(f,C):w(L[0][2],y)}function f(y){D("next",y)}function C(y){D("throw",y)}function w(y,O){y(O),L.shift(),L.length&&D(L[0][0],L[0][1])}},Be=this&&this.__asyncValues||function(_){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var t=_[Symbol.asyncIterator],g;return t?t.call(_):(_=typeof __values=="function"?__values(_):_[Symbol.iterator](),g={},A("next"),A("throw"),A("return"),g[Symbol.asyncIterator]=function(){return this},g);function A(L){g[L]=_[L]&&function(F){return new Promise(function(D,c){F=_[L](F),I(D,c,F.done,F.value)})}}function I(L,F,D,c){Promise.resolve(c).then(function(f){L({value:f,done:D})},F)}};define(J[64],Y([0,1,9,32,3]),function(_,t,g,A,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getFirstAvailablePowerShellInstallation=t.enumeratePowerShellInstallations=void 0;const L=/^\d+$/,F=/^Microsoft.PowerShell_.*/,D=/^Microsoft.PowerShellPreview_.*/;var c;(function(o){o[o.x64=0]="x64",o[o.x86=1]="x86",o[o.ARM=2]="ARM"})(c||(c={}));let f;switch(process.arch){case"ia32":case"x32":f=1;break;case"arm":case"arm64":f=2;break;default:f=0;break}let C;process.env.PROCESSOR_ARCHITEW6432?C=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?C=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?C=1:C=0;class w{constructor(r,e,i){this.exePath=r,this.displayName=e,this.knownToExist=i}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await g.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function y({useAlternateBitness:o=!1}={}){return o?f===0?process.env["ProgramFiles(x86)"]||null:C===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function O({useAlternateBitness:o=!1,findPreview:r=!1}={}){const e=y({useAlternateBitness:o});if(!e)return null;const i=I.join(e,"PowerShell");if(!await g.SymlinkSupport.existsDirectory(i))return null;let n=-1,s=null;for(const S of await g.readdir(i)){let U=-1;if(r){const j=S.indexOf("-");if(j<0)continue;const V=S.substring(0,j);if(!L.test(V)||S.substring(j+1)!=="preview")continue;U=parseInt(V,10)}else{if(!L.test(S))continue;U=parseInt(S,10)}if(U<=n)continue;const k=I.join(i,S,"pwsh.exe");!await g.SymlinkSupport.existsFile(k)||(s=k,n=U)}if(!s)return null;const l=e.includes("x86")?" (x86)":"",E=r?" Preview":"";return new w(s,`PowerShell${E}${l}`,!0)}async function u({findPreview:o}={}){if(!process.env.LOCALAPPDATA)return null;const r=I.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await g.SymlinkSupport.existsDirectory(r))return null;const{pwshMsixDirRegex:e,pwshMsixName:i}=o?{pwshMsixDirRegex:D,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:F,pwshMsixName:"PowerShell (Store)"};for(const n of await g.readdir(r))if(e.test(n)){const s=I.join(r,n,"pwsh.exe");return new w(s,i)}return null}function h(){const o=I.join(A.homedir(),".dotnet","tools","pwsh.exe");return new w(o,".NET Core PowerShell Global Tool")}function b(){const o=I.join(process.env.windir,f===1&&C!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new w(o,"Windows PowerShell",!0)}function R(){return Ve(this,arguments,function*(){let r=yield ye(O());r&&(yield yield ye(r)),r=yield ye(O({useAlternateBitness:!0})),r&&(yield yield ye(r)),r=yield ye(u()),r&&(yield yield ye(r)),r=h(),r&&(yield yield ye(r)),r=yield ye(O({findPreview:!0})),r&&(yield yield ye(r)),r=yield ye(u({findPreview:!0})),r&&(yield yield ye(r)),r=yield ye(O({useAlternateBitness:!0,findPreview:!0})),r&&(yield yield ye(r)),r=b(),r&&(yield yield ye(r))})}function P(){return Ve(this,arguments,function*(){var r,e;try{for(var i=Be(R()),n;n=yield ye(i.next()),!n.done;){const s=n.value;(yield ye(s.exists()))&&(yield yield ye(s))}}catch(s){r={error:s}}finally{try{n&&!n.done&&(e=i.return)&&(yield ye(e.call(i)))}finally{if(r)throw r.error}}})}t.enumeratePowerShellInstallations=P;async function v(){var o,r;try{for(var e=Be(P()),i;i=await e.next(),!i.done;)return i.value}catch(n){o={error:n}}finally{try{i&&!i.done&&(r=e.return)&&await r.call(e)}finally{if(o)throw o.error}}return null}t.getFirstAvailablePowerShellInstallation=v}),define(J[65],Y([0,1,3,31,14,125,2,9]),function(_,t,g,A,I,L,F,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CHANGE_BUFFER_DELAY=t.watchFolder=t.watchFile=void 0;function c(w,y,O){return C({path:w,isDirectory:!1},y,O)}t.watchFile=c;function f(w,y,O){return C({path:w,isDirectory:!0},y,O)}t.watchFolder=f,t.CHANGE_BUFFER_DELAY=100;function C(w,y,O){const u=g.basename(w.path),h=new Map;let b=!1,R=[F.toDisposable(()=>{h.forEach(P=>F.dispose(P)),h.clear()})];try{const P=A.watch(w.path);R.push(F.toDisposable(()=>{P.removeAllListeners(),P.close()}));const v=new Set;w.isDirectory&&D.readdir(w.path).then(o=>o.forEach(r=>v.add(r))),P.on("error",(o,r)=>{b||O(`Failed to watch ${w.path} for changes using fs.watch() (${o}, ${r})`)}),P.on("change",(o,r)=>{if(b)return;let e="";if(r&&(e=r.toString(),I.isMacintosh&&(e=L.normalizeNFC(e))),!e||o!=="change"&&o!=="rename")return;const i=w.isDirectory?g.join(w.path,e):w.path;if(w.isDirectory)if(o==="rename"){const n=h.get(i);n&&F.dispose(n);const s=setTimeout(async()=>{h.delete(i);const l=await D.exists(i);if(b)return;let E;l?v.has(e)?E="changed":(E="added",v.add(e)):(v.delete(e),E="deleted"),y(E,i)},t.CHANGE_BUFFER_DELAY);h.set(i,F.toDisposable(()=>clearTimeout(s)))}else{let n;v.has(e)?n="changed":(n="added",v.add(e)),y(n,i)}else if(o==="rename"||e!==u){const n=setTimeout(async()=>{const s=await D.exists(i);b||(s?(y("changed",i),R=[C(w,y,O)]):y("deleted",i))},t.CHANGE_BUFFER_DELAY);F.dispose(R),R=[F.toDisposable(()=>clearTimeout(n))]}else y("changed",i)})}catch(P){D.exists(w.path).then(v=>{v&&!b&&O(`Failed to watch ${w.path} for changes using fs.watch() (${P.toString()})`)})}return F.toDisposable(()=>{b=!0,R=F.dispose(R)})}});var ue=this&&this.__decorate||function(_,t,g,A){var I=arguments.length,L=I<3?t:A===null?A=Object.getOwnPropertyDescriptor(t,g):A,F;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(_,t,g,A);else for(var D=_.length-1;D>=0;D--)(F=_[D])&&(L=(I<3?F(L):I>3?F(t,g,L):F(t,g))||L);return I>3&&L&&Object.defineProperty(t,g,L),L};define(J[37],Y([0,1,10,2,4,27,13,16,22,12,60,19,44]),function(_,t,g,A,I,L,F,D,c,f,C,w,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.logWithColors=t.ProxyChannel=t.StaticRouter=t.getNextTickChannel=t.getDelayedChannel=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=t.ResponseType=t.RequestType=void 0;var O;(function(d){d[d.Promise=100]="Promise",d[d.PromiseCancel=101]="PromiseCancel",d[d.EventListen=102]="EventListen",d[d.EventDispose=103]="EventDispose"})(O=t.RequestType||(t.RequestType={}));function u(d){switch(d){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var h;(function(d){d[d.Initialize=200]="Initialize",d[d.PromiseSuccess=201]="PromiseSuccess",d[d.PromiseError=202]="PromiseError",d[d.PromiseErrorObj=203]="PromiseErrorObj",d[d.EventFire=204]="EventFire"})(h=t.ResponseType||(t.ResponseType={}));function b(d){switch(d){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var R;(function(d){d[d.Uninitialized=0]="Uninitialized",d[d.Idle=1]="Idle"})(R||(R={}));class P{constructor(a){this.buffer=a,this.pos=0}read(a){const m=this.buffer.slice(this.pos,this.pos+a);return this.pos+=m.byteLength,m}}class v{constructor(){this.buffers=[]}get buffer(){return D.VSBuffer.concat(this.buffers)}write(a){this.buffers.push(a)}}var o;(function(d){d[d.Undefined=0]="Undefined",d[d.String=1]="String",d[d.Buffer=2]="Buffer",d[d.VSBuffer=3]="VSBuffer",d[d.Array=4]="Array",d[d.Object=5]="Object"})(o||(o={}));function r(d){const a=D.VSBuffer.alloc(4);return a.writeUInt32BE(d,0),a}function e(d){return d.read(4).readUInt32BE(0)}function i(d){const a=D.VSBuffer.alloc(1);return a.writeUInt8(d,0),a}const n={Undefined:i(o.Undefined),String:i(o.String),Buffer:i(o.Buffer),VSBuffer:i(o.VSBuffer),Array:i(o.Array),Object:i(o.Object)},s=typeof Buffer!="undefined";function l(d,a){if(typeof a=="undefined")d.write(n.Undefined);else if(typeof a=="string"){const m=D.VSBuffer.fromString(a);d.write(n.String),d.write(r(m.byteLength)),d.write(m)}else if(s&&Buffer.isBuffer(a)){const m=D.VSBuffer.wrap(a);d.write(n.Buffer),d.write(r(m.byteLength)),d.write(m)}else if(a instanceof D.VSBuffer)d.write(n.VSBuffer),d.write(r(a.byteLength)),d.write(a);else if(Array.isArray(a)){d.write(n.Array),d.write(r(a.length));for(const m of a)l(d,m)}else{const m=D.VSBuffer.fromString(JSON.stringify(a));d.write(n.Object),d.write(r(m.byteLength)),d.write(m)}}function E(d){switch(d.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return d.read(e(d)).toString();case o.Buffer:return d.read(e(d)).buffer;case o.VSBuffer:return d.read(e(d));case o.Array:{const m=e(d),p=[];for(let N=0;N<m;N++)p.push(E(d));return p}case o.Object:return JSON.parse(d.read(e(d)).toString())}}class S{constructor(a,m,p=null,N=1e3){this.protocol=a,this.ctx=m,this.logger=p,this.timeoutDelay=N,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(M=>this.onRawMessage(M)),this.sendResponse({type:200})}registerChannel(a,m){this.channels.set(a,m),setTimeout(()=>this.flushPendingRequests(a),0)}sendResponse(a){switch(a.type){case 200:{const m=this.send([a.type]);this.logger&&this.logger.logOutgoing(m,0,1,b(a.type));return}case 201:case 202:case 204:case 203:{const m=this.send([a.type,a.id],a.data);this.logger&&this.logger.logOutgoing(m,a.id,1,b(a.type),a.data);return}}}send(a,m=void 0){const p=new v;return l(p,a),l(p,m),this.sendBuffer(p.buffer)}sendBuffer(a){try{return this.protocol.send(a),a.byteLength}catch(m){return 0}}onRawMessage(a){const m=new P(a),p=E(m),N=E(m),M=p[0];switch(M){case 100:return this.logger&&this.logger.logIncoming(a.byteLength,p[1],1,`${u(M)}: ${p[2]}.${p[3]}`,N),this.onPromise({type:M,id:p[1],channelName:p[2],name:p[3],arg:N});case 102:return this.logger&&this.logger.logIncoming(a.byteLength,p[1],1,`${u(M)}: ${p[2]}.${p[3]}`,N),this.onEventListen({type:M,id:p[1],channelName:p[2],name:p[3],arg:N});case 101:return this.logger&&this.logger.logIncoming(a.byteLength,p[1],1,`${u(M)}`),this.disposeActiveRequest({type:M,id:p[1]});case 103:return this.logger&&this.logger.logIncoming(a.byteLength,p[1],1,`${u(M)}`),this.disposeActiveRequest({type:M,id:p[1]})}}onPromise(a){const m=this.channels.get(a.channelName);if(!m){this.collectPendingRequest(a);return}const p=new L.CancellationTokenSource;let N;try{N=m.call(this.ctx,a.name,a.arg,p.token)}catch(B){N=Promise.reject(B)}const M=a.id;N.then(B=>{this.sendResponse({id:M,data:B,type:201}),this.activeRequests.delete(a.id)},B=>{B instanceof Error?this.sendResponse({id:M,data:{message:B.message,name:B.name,stack:B.stack?B.stack.split?B.stack.split(`
`):B.stack:void 0},type:202}):this.sendResponse({id:M,data:B,type:203}),this.activeRequests.delete(a.id)});const W=A.toDisposable(()=>p.cancel());this.activeRequests.set(a.id,W)}onEventListen(a){const m=this.channels.get(a.channelName);if(!m){this.collectPendingRequest(a);return}const p=a.id,M=m.listen(this.ctx,a.name,a.arg)(W=>this.sendResponse({id:p,data:W,type:204}));this.activeRequests.set(a.id,M)}disposeActiveRequest(a){const m=this.activeRequests.get(a.id);m&&(m.dispose(),this.activeRequests.delete(a.id))}collectPendingRequest(a){let m=this.pendingRequests.get(a.channelName);m||(m=[],this.pendingRequests.set(a.channelName,m));const p=setTimeout(()=>{console.error(`Unknown channel: ${a.channelName}`),a.type===100&&this.sendResponse({id:a.id,data:{name:"Unknown channel",message:`Channel name '${a.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);m.push({request:a,timeoutTimer:p})}flushPendingRequests(a){const m=this.pendingRequests.get(a);if(m){for(const p of m)switch(clearTimeout(p.timeoutTimer),p.request.type){case 100:this.onPromise(p.request);break;case 102:this.onEventListen(p.request);break}this.pendingRequests.delete(a)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(a=>a.dispose()),this.activeRequests.clear()}}t.ChannelServer=S;var U;(function(d){d[d.LocalSide=0]="LocalSide",d[d.OtherSide=1]="OtherSide"})(U=t.RequestInitiator||(t.RequestInitiator={}));class k{constructor(a,m=null){this.protocol=a,this.isDisposed=!1,this.state=R.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new g.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(p=>this.onBuffer(p)),this.logger=m}getChannel(a){const m=this;return{call(p,N,M){return m.isDisposed?Promise.reject(F.canceled()):m.requestPromise(a,p,N,M)},listen(p,N){return m.isDisposed?Promise.reject(F.canceled()):m.requestEvent(a,p,N)}}}requestPromise(a,m,p,N=L.CancellationToken.None){const M=this.lastRequestId++,B={id:M,type:100,channelName:a,name:m,arg:p};if(N.isCancellationRequested)return Promise.reject(F.canceled());let x;return new Promise((X,Q)=>{if(N.isCancellationRequested)return Q(F.canceled());const ie=()=>{const Fe=Oe=>{switch(Oe.type){case 201:this.handlers.delete(M),X(Oe.data);break;case 202:this.handlers.delete(M);const Se=new Error(Oe.data.message);Se.stack=Oe.data.stack,Se.name=Oe.data.name,Q(Se);break;case 203:this.handlers.delete(M),Q(Oe.data);break}};this.handlers.set(M,Fe),this.sendRequest(B)};let ce=null;this.state===R.Idle?ie():(ce=I.createCancelablePromise(Fe=>this.whenInitialized()),ce.then(()=>{ce=null,ie()}));const ge=()=>{ce?(ce.cancel(),ce=null):this.sendRequest({id:M,type:101}),Q(F.canceled())},Ie=N.onCancellationRequested(ge);x=A.combinedDisposable(A.toDisposable(ge),Ie),this.activeRequests.add(x)}).finally(()=>{this.activeRequests.delete(x)})}requestEvent(a,m,p){const N=this.lastRequestId++,W={id:N,type:102,channelName:a,name:m,arg:p};let B=null;const x=new g.Emitter({onFirstListenerAdd:()=>{B=I.createCancelablePromise(X=>this.whenInitialized()),B.then(()=>{B=null,this.activeRequests.add(x),this.sendRequest(W)})},onLastListenerRemove:()=>{B?(B.cancel(),B=null):(this.activeRequests.delete(x),this.sendRequest({id:N,type:103}))}}),H=X=>x.fire(X.data);return this.handlers.set(N,H),x.event}sendRequest(a){switch(a.type){case 100:case 102:{const m=this.send([a.type,a.id,a.channelName,a.name],a.arg);this.logger&&this.logger.logOutgoing(m,a.id,0,`${u(a.type)}: ${a.channelName}.${a.name}`,a.arg);return}case 101:case 103:{const m=this.send([a.type,a.id]);this.logger&&this.logger.logOutgoing(m,a.id,0,u(a.type));return}}}send(a,m=void 0){const p=new v;return l(p,a),l(p,m),this.sendBuffer(p.buffer)}sendBuffer(a){try{return this.protocol.send(a),a.byteLength}catch(m){return 0}}onBuffer(a){const m=new P(a),p=E(m),N=E(m),M=p[0];switch(M){case 200:return this.logger&&this.logger.logIncoming(a.byteLength,0,0,b(M)),this.onResponse({type:p[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(a.byteLength,p[1],0,b(M),N),this.onResponse({type:p[0],id:p[1],data:N})}}onResponse(a){if(a.type===200){this.state=R.Idle,this._onDidInitialize.fire();return}const m=this.handlers.get(a.id);m&&m(a)}get onDidInitializePromise(){return g.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===R.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(a=>a.dispose()),this.activeRequests.clear()}}ue([y.memoize],k.prototype,"onDidInitializePromise",null),t.ChannelClient=k;class j{constructor(a){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new g.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new g.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,a(({protocol:m,onDidClientDisconnect:p})=>{g.Event.once(m.onMessage)(M=>{const W=new P(M),B=E(W),x=new S(m,B),H=new k(m);this.channels.forEach((Q,ie)=>x.registerChannel(ie,Q));const X={channelServer:x,channelClient:H,ctx:B};this._connections.add(X),this._onDidAddConnection.fire(X),p(()=>{x.dispose(),H.dispose(),this._connections.delete(X),this._onDidRemoveConnection.fire(X)})})})}get connections(){const a=[];return this._connections.forEach(m=>a.push(m)),a}getChannel(a,m){const p=this;return{call(N,M,W){let B;if(f.isFunction(m)){let H=c.getRandomElement(p.connections.filter(m));B=H?Promise.resolve(H):g.Event.toPromise(g.Event.filter(p.onDidAddConnection,m))}else B=m.routeCall(p,N,M);const x=B.then(H=>H.channelClient.getChannel(a));return $(x).call(N,M,W)},listen(N,M){if(f.isFunction(m))return p.getMulticastEvent(a,m,N,M);const W=m.routeEvent(p,N,M).then(B=>B.channelClient.getChannel(a));return $(W).listen(N,M)}}}getMulticastEvent(a,m,p,N){const M=this;let W=new A.DisposableStore;const B=new g.Emitter({onFirstListenerAdd:()=>{W=new A.DisposableStore;const x=new g.EventMultiplexer,H=new Map,X=ie=>{const ge=ie.channelClient.getChannel(a).listen(p,N),Ie=x.add(ge);H.set(ie,Ie)},Q=ie=>{const ce=H.get(ie);!ce||(ce.dispose(),H.delete(ie))};M.connections.filter(m).forEach(X),g.Event.filter(M.onDidAddConnection,m)(X,void 0,W),M.onDidRemoveConnection(Q,void 0,W),x.event(B.fire,B,W),W.add(x)},onLastListenerRemove:()=>{W.dispose()}});return B.event}registerChannel(a,m){this.channels.set(a,m),this._connections.forEach(p=>{p.channelServer.registerChannel(a,m)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}t.IPCServer=j;class V{constructor(a,m,p=null){const N=new v;l(N,m),a.send(N.buffer),this.channelClient=new k(a,p),this.channelServer=new S(a,m,p)}getChannel(a){return this.channelClient.getChannel(a)}registerChannel(a,m){this.channelServer.registerChannel(a,m)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}t.IPCClient=V;function $(d){return{call(a,m,p){return d.then(N=>N.call(a,m,p))},listen(a,m){const p=new g.Relay;return d.then(N=>p.input=N.listen(a,m)),p.event}}}t.getDelayedChannel=$;function K(d){let a=!1;return{call(m,p,N){return a?d.call(m,p,N):I.timeout(0).then(()=>a=!0).then(()=>d.call(m,p,N))},listen(m,p){if(a)return d.listen(m,p);const N=new g.Relay;return I.timeout(0).then(()=>a=!0).then(()=>N.input=d.listen(m,p)),N.event}}}t.getNextTickChannel=K;class ee{constructor(a){this.fn=a}routeCall(a){return this.route(a)}routeEvent(a){return this.route(a)}async route(a){for(const m of a.connections)if(await Promise.resolve(this.fn(m.ctx)))return Promise.resolve(m);return await g.Event.toPromise(a.onDidAddConnection),await this.route(a)}}t.StaticRouter=ee;var te;(function(d){function a(N,M){const W=N,B=M&&M.disableMarshalling,x=new Map;for(const H in W)p(H)&&x.set(H,g.Event.buffer(W[H],!0));return new class{listen(H,X){const Q=x.get(X);if(Q)return Q;throw new Error(`Event not found: ${X}`)}call(H,X,Q){const ie=W[X];if(typeof ie=="function"){if(!B&&Array.isArray(Q))for(let ce=0;ce<Q.length;ce++)Q[ce]=C.revive(Q[ce]);return ie.apply(W,Q)}throw new Error(`Method not found: ${X}`)}}}d.fromService=a;function m(N,M){const W=M&&M.disableMarshalling;return new Proxy({},{get(B,x){var H;if(typeof x=="string")return((H=M==null?void 0:M.properties)===null||H===void 0?void 0:H.has(x))?M.properties.get(x):p(x)?N.listen(x):async function(...X){let Q;M&&!f.isUndefinedOrNull(M.context)?Q=[M.context,...X]:Q=X;const ie=await N.call(x,Q);return W?ie:C.revive(ie)};throw new Error(`Property not found: ${String(x)}`)}})}d.toService=m;function p(N){return N[0]==="o"&&N[1]==="n"&&w.isUpperAsciiLetter(N.charCodeAt(2))}})(te=t.ProxyChannel||(t.ProxyChannel={}));const Z=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ae(d){if(Array.isArray(d))return d;if(d&&typeof d=="object"&&typeof d.toString=="function"){let a=d.toString();if(a!=="[object Object]")return a}return d}function se(d){return Array.isArray(d)?d.map(ae):ae(d)}function re(d,a,m,p,N,M,W){W=se(W);const B=Z[N],x=B[p%B.length];let H=[`%c[${d}]%c[${String(a).padStart(7," ")}]%c[len: ${String(m).padStart(5," ")}]%c${String(p).padStart(5," ")} - ${M}`,"color: darkgreen","color: grey","color: grey",`color: ${x}`];/\($/.test(M)?(H=H.concat(W),H.push(")")):H.push(W),console.log.apply(console,H)}t.logWithColors=re;class T{constructor(a,m){this._outgoingPrefix=a,this._incomingPrefix=m,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(a,m,p,N,M){this._totalOutgoing+=a,re(this._outgoingPrefix,this._totalOutgoing,a,m,p,N,M)}logIncoming(a,m,p,N,M){this._totalIncoming+=a,re(this._incomingPrefix,this._totalIncoming,a,m,p,N,M)}}t.IPCLogger=T}),define(J[66],Y([0,1,2,10,4,12]),function(_,t,g,A,I,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InMemoryStorageDatabase=t.Storage=t.StorageHint=void 0;var F;(function(C){C[C.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(F=t.StorageHint||(t.StorageHint={}));var D;(function(C){C[C.None=0]="None",C[C.Initialized=1]="Initialized",C[C.Closed=2]="Closed"})(D||(D={}));class c extends g.Disposable{constructor(w,y=Object.create(null)){super();this.database=w,this.options=y,this._onDidChangeStorage=this._register(new A.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=D.None,this.cache=new Map,this.flushDelayer=new I.ThrottledDelayer(c.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(w=>this.onDidChangeItemsExternal(w)))}onDidChangeItemsExternal(w){var y,O;(y=w.changed)===null||y===void 0||y.forEach((u,h)=>this.accept(h,u)),(O=w.deleted)===null||O===void 0||O.forEach(u=>this.accept(u,void 0))}accept(w,y){if(this.state===D.Closed)return;let O=!1;L.isUndefinedOrNull(y)?O=this.cache.delete(w):this.cache.get(w)!==y&&(this.cache.set(w,y),O=!0),O&&this._onDidChangeStorage.fire(w)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===D.None&&(this.state=D.Initialized,this.options.hint!==F.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(w,y){const O=this.cache.get(w);return L.isUndefinedOrNull(O)?y:O}getBoolean(w,y){const O=this.get(w);return L.isUndefinedOrNull(O)?y:O==="true"}getNumber(w,y){const O=this.get(w);return L.isUndefinedOrNull(O)?y:parseInt(O,10)}async set(w,y){if(this.state===D.Closed)return;if(L.isUndefinedOrNull(y))return this.delete(w);const O=String(y);if(this.cache.get(w)!==O)return this.cache.set(w,O),this.pendingInserts.set(w,O),this.pendingDeletes.delete(w),this._onDidChangeStorage.fire(w),this.flushDelayer.trigger(()=>this.flushPending())}async delete(w){if(!(this.state===D.Closed||!this.cache.delete(w)))return this.pendingDeletes.has(w)||this.pendingDeletes.add(w),this.pendingInserts.delete(w),this._onDidChangeStorage.fire(w),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=D.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(w){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const w={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(w).finally(()=>{var y;if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)(y=this.whenFlushedCallbacks.pop())===null||y===void 0||y()})}async whenFlushed(){if(!!this.hasPending)return new Promise(w=>this.whenFlushedCallbacks.push(w))}dispose(){this.flushDelayer.cancel(),this.flushDelayer.dispose(),super.dispose()}}t.Storage=c,c.DEFAULT_FLUSH_DELAY=100;class f{constructor(){this.onDidChangeItemsExternal=A.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(w){w.insert&&w.insert.forEach((y,O)=>this.items.set(O,y)),w.delete&&w.delete.forEach(y=>this.items.delete(y))}async close(){}}t.InMemoryStorageDatabase=f}),define(J[67],Y([5,6]),function(_,t){return _.create("vs/base/common/date",t)}),define(J[68],Y([0,1,67]),function(_,t,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toLocalISOString=t.fromNow=void 0;const A=60,I=A*60,L=I*24,F=L*7,D=L*30,c=L*365;function f(w,y){typeof w!="number"&&(w=w.getTime());const O=Math.round((new Date().getTime()-w)/1e3);if(O<-30)return g.localize(0,null,f(new Date().getTime()+O*1e3,!1));if(O<30)return g.localize(1,null);let u;return O<A?(u=O,y?u===1?g.localize(2,null,u):g.localize(3,null,u):u===1?g.localize(4,null,u):g.localize(5,null,u)):O<I?(u=Math.floor(O/A),y?u===1?g.localize(6,null,u):g.localize(7,null,u):u===1?g.localize(8,null,u):g.localize(9,null,u)):O<L?(u=Math.floor(O/I),y?u===1?g.localize(10,null,u):g.localize(11,null,u):u===1?g.localize(12,null,u):g.localize(13,null,u)):O<F?(u=Math.floor(O/L),y?u===1?g.localize(14,null,u):g.localize(15,null,u):u===1?g.localize(16,null,u):g.localize(17,null,u)):O<D?(u=Math.floor(O/F),y?u===1?g.localize(18,null,u):g.localize(19,null,u):u===1?g.localize(20,null,u):g.localize(21,null,u)):O<c?(u=Math.floor(O/D),y?u===1?g.localize(22,null,u):g.localize(23,null,u):u===1?g.localize(24,null,u):g.localize(25,null,u)):(u=Math.floor(O/c),y?u===1?g.localize(26,null,u):g.localize(27,null,u):u===1?g.localize(28,null,u):g.localize(29,null,u))}t.fromNow=f;function C(w){return w.getFullYear()+"-"+String(w.getMonth()+1).padStart(2,"0")+"-"+String(w.getDate()).padStart(2,"0")+"T"+String(w.getHours()).padStart(2,"0")+":"+String(w.getMinutes()).padStart(2,"0")+":"+String(w.getSeconds()).padStart(2,"0")+"."+(w.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}t.toLocalISOString=C}),define(J[69],Y([5,6]),function(_,t){return _.create("vs/base/common/errorMessage",t)}),define(J[28],Y([0,1,69,12,22]),function(_,t,g,A,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toErrorMessage=void 0;function L(f,C){return C&&(f.stack||f.stacktrace)?g.localize(0,null,D(f),F(f.stack)||F(f.stacktrace)):D(f)}function F(f){return Array.isArray(f)?f.join(`
`):f}function D(f){return typeof f.code=="string"&&typeof f.errno=="number"&&typeof f.syscall=="string"?g.localize(1,null,f.message):f.message||g.localize(2,null)}function c(f=null,C=!1){if(!f)return g.localize(3,null);if(Array.isArray(f)){const w=I.coalesce(f),y=c(w[0],C);return w.length>1?g.localize(4,null,y,w.length):y}if(A.isString(f))return f;if(f.detail){const w=f.detail;if(w.error)return L(w.error,C);if(w.exception)return L(w.exception,C)}return f.stack?L(f,C):f.message?f.message:g.localize(5,null)}t.toErrorMessage=c}),define(J[70],Y([5,6]),function(_,t){return _.create("vs/base/node/processes",t)}),define(J[47],Y([0,1,3,9,33,70,34,12,20,36,14,46,8]),function(_,t,g,A,I,L,F,D,c,f,C,w,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.win32=t.createQueuedSender=t.LineProcess=t.AbstractProcess=t.getWindowsShell=t.TerminateResponseCode=t.Source=void 0;function O(o){switch(o){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function u(o,r){if(C.isWindows)try{const e={stdio:["pipe","pipe","ignore"]};r&&(e.cwd=r);const i=I.execFile("taskkill",["/T","/F","/PID",o.pid.toString()],e);return new Promise(n=>{i.once("error",s=>{n({success:!1,error:s})}),i.once("exit",(s,l)=>{n(s===0?{success:!0}:{success:!1,code:s!==null?s:1})})})}catch(e){return Promise.resolve({success:!1,error:e,code:e.status?O(e.status):1})}else if(C.isLinux||C.isMacintosh)try{const e=y.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",_).fsPath;return new Promise(i=>{I.execFile(e,[o.pid.toString()],{encoding:"utf8",shell:!0},(n,s,l)=>{i(n?{success:!1,error:n}:{success:!0})})})}catch(e){return Promise.resolve({success:!1,error:e})}else o.kill("SIGKILL");return Promise.resolve({success:!0})}function h(o=F.env){return o.comspec||"cmd.exe"}t.getWindowsShell=h;class b{constructor(r,e,i,n){if(e!==void 0&&i!==void 0&&n!==void 0)this.cmd=r,this.args=e,this.shell=i,this.options=n;else{const s=r;this.cmd=s.command,this.shell=s.isShellCommand,this.args=s.args.slice(0),this.options=s.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const s=Object.create(null);Object.keys(F.env).forEach(l=>{s[l]=F.env[l]}),Object.keys(this.options.env).forEach(l=>{s[l]=this.options.env[l]}),this.options.env=s}}getSanitizedCommand(){let r=this.cmd.toLowerCase();const e=r.lastIndexOf(g.sep);return e!==-1&&(r=r.substring(e+1)),b.WellKnowCommands[r]?r:"other"}start(r){return C.isWindows&&(this.options&&this.options.cwd&&f.isUNC(this.options.cwd)||!this.options&&f.isUNC(F.cwd()))?Promise.reject(new Error(L.localize(0,null))):this.useExec().then(e=>{let i,n;const s=new Promise((l,E)=>{i=l,n=E});if(e){let l=this.cmd;this.args&&(l=l+" "+this.args.join(" ")),this.childProcess=I.exec(l,this.options,(E,S,U)=>{this.childProcess=null;const k=E;k&&k.killed?n({killed:this.terminateRequested,stdout:S.toString(),stderr:U.toString()}):this.handleExec(i,r,E,S,U)})}else{let l=null;const E=S=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(S,i,r,n);const U={terminated:this.terminateRequested};D.isNumber(S)&&(U.cmdCode=S),i(U)};if(this.shell&&C.isWindows){const S=c.deepClone(this.options);S.windowsVerbatimArguments=!0,S.detached=!1;let U=!1,k=!1;const j=[];let V=this.ensureQuotes(this.cmd);j.push(V.value),U=V.quoted,this.args&&this.args.forEach(K=>{V=this.ensureQuotes(K),j.push(V.value),k=k&&V.quoted});const $=["/s","/c"];U?k?$.push('"'+j.join(" ")+'"'):j.length>1?$.push('"'+j[0]+'" '+j.slice(1).join(" ")):$.push('"'+j[0]+'"'):$.push(j.join(" ")),l=I.spawn(h(),$,S)}else this.cmd&&(l=I.spawn(this.cmd,this.args,this.options));l&&(this.childProcess=l,this.childProcessPromise=Promise.resolve(l),this.pidResolve&&(this.pidResolve(D.isNumber(l.pid)?l.pid:-1),this.pidResolve=void 0),l.on("error",S=>{this.childProcess=null,n({terminated:this.terminateRequested,error:S})}),l.pid&&(this.childProcess.on("close",E),this.handleSpawn(l,i,r,n,!0)))}return s})}handleClose(r,e,i,n){}ensureQuotes(r){return b.regexp.test(r)?{value:'"'+r+'"',quoted:!0}:{value:r,quoted:r.length>0&&r[0]==='"'&&r[r.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(r=>r.pid,r=>-1):new Promise(r=>{this.pidResolve=r})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(r=>(this.terminateRequested=!0,u(r,this.options.cwd).then(e=>(e.success&&(this.childProcess=null),e))),r=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(r=>{if(!this.shell||!C.isWindows)return r(!1);const e=I.spawn(h(),["/s","/c"]);e.on("error",i=>r(!0)),e.on("exit",i=>r(!1))})}}t.AbstractProcess=b,b.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},b.regexp=/^[^"].* .*[^"]/;class R extends b{constructor(r,e,i,n){super(r,e,i,n);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(r,e,i,n,s){[n,s].forEach((l,E)=>{const S=new w.LineDecoder;S.write(l).forEach(j=>{e({line:j,source:E===0?0:1})});const k=S.end();k&&e({line:k,source:E===0?0:1})}),r({terminated:this.terminateRequested,error:i})}handleSpawn(r,e,i,n,s){const l=new w.LineDecoder,E=new w.LineDecoder;r.stdout.on("data",S=>{l.write(S).forEach(k=>i({line:k,source:0}))}),r.stderr.on("data",S=>{E.write(S).forEach(k=>i({line:k,source:1}))}),this.stdoutLineDecoder=l,this.stderrLineDecoder=E}handleClose(r,e,i,n){const s=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;s&&i({line:s,source:0});const l=this.stderrLineDecoder?this.stderrLineDecoder.end():null;l&&i({line:l,source:1})}}t.LineProcess=R;function P(o){let r=[],e=!1;const i=function(n){if(e){r.push(n);return}(!o.send(n,l=>{if(l&&console.error(l),e=!1,r.length>0){const E=r.slice(0);r=[],E.forEach(S=>i(S))}})||C.isWindows)&&(e=!0)};return{send:i}}t.createQueuedSender=P;var v;(function(o){async function r(e,i,n){if(g.isAbsolute(e))return e;if(i===void 0&&(i=F.cwd()),g.dirname(e)!=="."||(n===void 0&&D.isString(F.env.PATH)&&(n=F.env.PATH.split(g.delimiter)),n===void 0||n.length===0))return g.join(i,e);async function l(E){return await A.exists(E)?!(await A.Promises.stat(E)).isDirectory():!1}for(let E of n){let S;if(g.isAbsolute(E)?S=g.join(E,e):S=g.join(i,E,e),await l(S))return S;let U=S+".com";if(await l(U)||(U=S+".exe",await l(U)))return U}return g.join(i,e)}o.findExecutable=r})(v=t.win32||(t.win32={}))}),define(J[71],Y([0,1,32,14,64,47]),function(_,t,g,A,I,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getSystemShellSync=t.getSystemShell=void 0;async function F(O,u){return O===1?A.isWindows?w():L.getWindowsShell(u):f(O,u)}t.getSystemShell=F;function D(O,u){return O===1?A.isWindows?y(u):L.getWindowsShell(u):f(O,u)}t.getSystemShellSync=D;let c=null;function f(O,u){if(A.isLinux&&O===2||A.isMacintosh&&O===3)return"/bin/bash";if(!c){let h;if(A.isWindows)h="/bin/bash";else{if(h=u.SHELL,!h)try{h=g.userInfo().shell}catch(b){}h||(h="sh"),h==="/bin/false"&&(h="/bin/bash")}c=h}return c}let C=null;async function w(){return C||(C=(await I.getFirstAvailablePowerShellInstallation()).exePath),C}function y(O){if(C)return C;const u=A.isWindows&&parseFloat(g.release())>=10,h=O.hasOwnProperty("PROCESSOR_ARCHITEW6432"),b=`${O.windir}\\${h?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return u?b:L.getWindowsShell(O)}}),define(J[48],Y([0,1,33,2,4,20,10,47,37,59,27,13,16,14]),function(_,t,g,A,I,L,F,D,c,f,C,w,y,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=t.Server=void 0;class u extends c.ChannelServer{constructor(R){super({send:P=>{try{process.send&&process.send(P.buffer.toString("base64"))}catch(v){}},onMessage:F.Event.fromNodeEventEmitter(process,"message",P=>y.VSBuffer.wrap(Buffer.from(P,"base64")))},R);process.once("disconnect",()=>this.dispose())}}t.Server=u;class h{constructor(R,P){this.modulePath=R,this.options=P,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new F.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const v=P&&P.timeout?P.timeout:6e4;this.disposeDelayer=new I.Delayer(v),this.child=null,this._client=null}getChannel(R){const P=this;return{call(v,o,r){return P.requestPromise(R,v,o,r)},listen(v,o){return P.requestEvent(R,v,o)}}}requestPromise(R,P,v,o=C.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(o.isCancellationRequested)return Promise.reject(w.canceled());this.disposeDelayer.cancel();const r=this.getCachedChannel(R),e=I.createCancelablePromise(s=>r.call(P,v,s)),i=o.onCancellationRequested(()=>e.cancel()),n=A.toDisposable(()=>e.cancel());return this.activeRequests.add(n),e.finally(()=>{i.dispose(),this.activeRequests.delete(n),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),e}requestEvent(R,P,v){if(!this.disposeDelayer)return F.Event.None;this.disposeDelayer.cancel();let o;const r=new F.Emitter({onFirstListenerAdd:()=>{o=this.getCachedChannel(R).listen(P,v)(r.fire,r),this.activeRequests.add(o)},onLastListenerRemove:()=>{this.activeRequests.delete(o),o.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return r.event}get client(){if(!this._client){const R=this.options&&this.options.args?this.options.args:[],P=Object.create(null);P.env=Object.assign(Object.assign({},L.deepClone(process.env)),{VSCODE_PARENT_PID:String(process.pid)}),this.options&&this.options.env&&(P.env=Object.assign(Object.assign({},P.env),this.options.env)),this.options&&this.options.freshExecArgv&&(P.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(P.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(P.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),P.execArgv===void 0&&(P.execArgv=process.execArgv.filter(l=>!/^--inspect(-brk)?=/.test(l))),O.isMacintosh&&P.env&&delete P.env.DYLD_LIBRARY_PATH,this.child=g.fork(this.modulePath,R,P);const v=new F.Emitter;F.Event.fromNodeEventEmitter(this.child,"message",l=>l)(l=>{if(f.isRemoteConsoleLog(l)){f.log(l,`IPC Library: ${this.options.serverName}`);return}v.fire(y.VSBuffer.wrap(Buffer.from(l,"base64")))});const r=this.options.useQueue?D.createQueuedSender(this.child):this.child,e=l=>this.child&&this.child.connected&&r.send(l.buffer.toString("base64")),i=v.event,n={send:e,onMessage:i};this._client=new c.ChannelClient(n);const s=()=>this.disposeClient();process.once("exit",s),this.child.on("error",l=>console.warn('IPC "'+this.options.serverName+'" errored with '+l)),this.child.on("exit",(l,E)=>{process.removeListener("exit",s),this.activeRequests.forEach(S=>A.dispose(S)),this.activeRequests.clear(),l!==0&&E!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+l+" and signal "+E),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:l,signal:E})})}return this._client}getCachedChannel(R){let P=this.channels.get(R);return P||(P=this.client.getChannel(R),this.channels.set(R,P)),P}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}t.Client=h}),define(J[72],Y([5,6]),function(_,t){return _.create("vs/base/node/zip",t)}),define(J[73],Y([5,6]),function(_,t){return _.create("vs/platform/configuration/common/configurationRegistry",t)}),define(J[74],Y([5,6]),function(_,t){return _.create("vs/platform/extensionManagement/common/extensionManagement",t)}),define(J[75],Y([5,6]),function(_,t){return _.create("vs/platform/extensionManagement/common/extensionManagementCLIService",t)}),define(J[76],Y([5,6]),function(_,t){return _.create("vs/platform/extensionManagement/node/extensionManagementService",t)}),define(J[77],Y([5,6]),function(_,t){return _.create("vs/platform/extensionManagement/node/extensionManagementUtil",t)}),define(J[78],Y([5,6]),function(_,t){return _.create("vs/platform/extensionManagement/node/extensionsScanner",t)}),define(J[79],Y([5,6]),function(_,t){return _.create("vs/platform/extensions/common/extensionValidator",t)}),define(J[80],Y([5,6]),function(_,t){return _.create("vs/platform/files/common/fileService",t)}),define(J[81],Y([5,6]),function(_,t){return _.create("vs/platform/files/common/io",t)}),define(J[82],Y([5,6]),function(_,t){return _.create("vs/platform/files/node/diskFileSystemProvider",t)}),define(J[83],Y([5,6]),function(_,t){return _.create("vs/platform/request/common/request",t)}),define(J[84],Y([5,6]),function(_,t){return _.create("vs/platform/telemetry/common/telemetryService",t)}),define(J[85],Y([0,1,3,17,44,68,8,7,34]),function(_,t,g,A,I,L,F,D,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parseSearchPort=t.parseExtensionHostPort=t.AbstractNativeEnvironmentService=void 0;class f{constructor(u,h,b){this._args=u,this.paths=h,this.productService=b}get appRoot(){return g.dirname(F.FileAccess.asFileUri("",_).fsPath)}get userHome(){return D.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return D.URI.file(g.join(this.userDataPath,"User"))}get tmpDir(){return D.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return A.joinPath(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return A.joinPath(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const u=L.toLocalISOString(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=g.join(this.userDataPath,"logs",u)}return this.args.logsPath}get userDataSyncLogResource(){return D.URI.file(g.join(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return A.joinPath(D.URI.file(g.join(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return D.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return D.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return A.joinPath(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return A.joinPath(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const u=c.env.VSCODE_PORTABLE;return u?D.URI.file(g.join(u,"argv.json")):A.joinPath(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return A.joinPath(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return D.URI.file(g.join(this.userDataPath,"Workspaces"))}get installSourcePath(){return g.join(this.userDataPath,"installSource")}get builtinExtensionsPath(){const u=this.args["builtin-extensions-dir"];return u?g.resolve(u):g.normalize(g.join(F.FileAccess.asFileUri("",_).fsPath,"..","extensions"))}get extensionsDownloadPath(){const u=this.args["extensions-download-dir"];return u?g.resolve(u):g.join(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const u=this.args["extensions-dir"];if(u)return g.resolve(u);const h=c.env.VSCODE_EXTENSIONS;if(h)return h;const b=c.env.VSCODE_PORTABLE;return b?g.join(b,"extensions"):A.joinPath(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const u=this.args.extensionDevelopmentPath;if(Array.isArray(u))return u.map(h=>/^[^:/?#]+?:\/\//.test(h)?D.URI.parse(h):D.URI.file(g.normalize(h)))}get extensionDevelopmentKind(){var u;return(u=this.args.extensionDevelopmentKind)===null||u===void 0?void 0:u.map(h=>h==="ui"||h==="workspace"||h==="web"?h:"workspace")}get extensionTestsLocationURI(){const u=this.args.extensionTestsPath;if(u)return/^[^:/?#]+?:\/\//.test(u)?D.URI.parse(u):D.URI.file(g.normalize(u))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const u=this.args["disable-extension"];if(u){if(typeof u=="string")return[u];if(Array.isArray(u)&&u.length>0)return u}return!1}get debugExtensionHost(){return C(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!c.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return A.joinPath(D.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return D.URI.file(g.join(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}ue([I.memoize],f.prototype,"appRoot",null),ue([I.memoize],f.prototype,"userHome",null),ue([I.memoize],f.prototype,"userDataPath",null),ue([I.memoize],f.prototype,"appSettingsHome",null),ue([I.memoize],f.prototype,"tmpDir",null),ue([I.memoize],f.prototype,"userRoamingDataHome",null),ue([I.memoize],f.prototype,"settingsResource",null),ue([I.memoize],f.prototype,"userDataSyncHome",null),ue([I.memoize],f.prototype,"userDataSyncLogResource",null),ue([I.memoize],f.prototype,"sync",null),ue([I.memoize],f.prototype,"machineSettingsResource",null),ue([I.memoize],f.prototype,"globalStorageHome",null),ue([I.memoize],f.prototype,"workspaceStorageHome",null),ue([I.memoize],f.prototype,"keybindingsResource",null),ue([I.memoize],f.prototype,"keyboardLayoutResource",null),ue([I.memoize],f.prototype,"argvResource",null),ue([I.memoize],f.prototype,"snippetsHome",null),ue([I.memoize],f.prototype,"isExtensionDevelopment",null),ue([I.memoize],f.prototype,"untitledWorkspacesHome",null),ue([I.memoize],f.prototype,"installSourcePath",null),ue([I.memoize],f.prototype,"builtinExtensionsPath",null),ue([I.memoize],f.prototype,"extensionsPath",null),ue([I.memoize],f.prototype,"extensionDevelopmentLocationURI",null),ue([I.memoize],f.prototype,"extensionDevelopmentKind",null),ue([I.memoize],f.prototype,"extensionTestsLocationURI",null),ue([I.memoize],f.prototype,"debugExtensionHost",null),ue([I.memoize],f.prototype,"serviceMachineIdResource",null),ue([I.memoize],f.prototype,"telemetryLogResource",null),ue([I.memoize],f.prototype,"disableWorkspaceTrust",null),t.AbstractNativeEnvironmentService=f;function C(O,u){return y(O["inspect-extensions"],O["inspect-brk-extensions"],5870,u,O.debugId)}t.parseExtensionHostPort=C;function w(O,u){return y(O["inspect-search"],O["inspect-brk-search"],5876,u)}t.parseSearchPort=w;function y(O,u,h,b,R){const v=Number(u||O)||(b?null:h),o=v?Boolean(!!u):!1;return{port:v,break:o,debugId:R}}}),function(){"use strict";function _(t,g,A,I){function L(D){const c=F(D),f=[c];return t.isAbsolute(c)||f.unshift(I),t.resolve(...f)}function F(D){const c=process.env.VSCODE_PORTABLE;if(c)return t.join(c,"user-data");const f=D["user-data-dir"];if(f)return f;let C=process.env.VSCODE_APPDATA;if(!C)switch(process.platform){case"win32":if(C=process.env.APPDATA,!C){const w=process.env.USERPROFILE;if(typeof w!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");C=t.join(w,"AppData","Roaming")}break;case"darwin":C=t.join(g.homedir(),"Library","Application Support");break;case"linux":C=process.env.XDG_CONFIG_HOME||t.join(g.homedir(),".config");break;default:throw new Error("Platform not supported")}return t.join(C,A)}return{getUserDataPath:L}}if(typeof define=="function")define(J[86],Y([0,87,32,8,17,34]),function(t,g,A,I,L,F){const D=L.dirname(I.FileAccess.asFileUri("",t)),c=t.__$__nodeRequire(L.joinPath(D,"package.json").fsPath);return _(g,A,c.name,F.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const t=require("../../../../../package.json"),g=require("path"),A=require("os");module.exports=_(g,A,t.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(J[88],Y([0,1,32,86,85]),function(_,t,g,A,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeEnvironmentService=void 0;class L extends I.AbstractNativeEnvironmentService{constructor(D,c){super(D,{homeDir:g.homedir(),tmpDir:g.tmpdir(),userDataDir:A.getUserDataPath(D)},c)}}t.NativeEnvironmentService=L}),define(J[89],Y([0,1,20]),function(_,t,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.localizeManifest=void 0;const A=/^%([\w\d.-]+)%$/i;function I(L,F){const D=c=>{if(typeof c!="string")return;const f=A.exec(c);if(!!f)return F[f[1]]||c};return g.cloneAndChange(L,D)}t.localizeManifest=I}),define(J[49],Y([0,1,79]),function(_,t,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isEngineValid=t.isValidExtensionVersion=t.isValidVersion=t.normalizeVersion=t.parseVersion=t.isValidVersionStr=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,I=/^-(\d{4})(\d{2})(\d{2})$/;function L(y){return y=y.trim(),y==="*"||A.test(y)}t.isValidVersionStr=L;function F(y){if(!L(y))return null;if(y=y.trim(),y==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let O=y.match(A);return O?{hasCaret:O[1]==="^",hasGreaterEquals:O[1]===">=",majorBase:O[2]==="x"?0:parseInt(O[2],10),majorMustEqual:O[2]!=="x",minorBase:O[4]==="x"?0:parseInt(O[4],10),minorMustEqual:O[4]!=="x",patchBase:O[6]==="x"?0:parseInt(O[6],10),patchMustEqual:O[6]!=="x",preRelease:O[8]||null}:null}t.parseVersion=F;function D(y){if(!y)return null;let O=y.majorBase,u=y.majorMustEqual,h=y.minorBase,b=y.minorMustEqual,R=y.patchBase,P=y.patchMustEqual;y.hasCaret&&(O===0||(b=!1),P=!1);let v=0;if(y.preRelease){const o=I.exec(y.preRelease);if(o){const[,r,e,i]=o;v=Date.UTC(Number(r),Number(e)-1,Number(i))}}return{majorBase:O,majorMustEqual:u,minorBase:h,minorMustEqual:b,patchBase:R,patchMustEqual:P,isMinimum:y.hasGreaterEquals,notBefore:v}}t.normalizeVersion=D;function c(y,O,u){let h;typeof y=="string"?h=D(F(y)):h=y;let b;O instanceof Date?b=O.getTime():typeof O=="string"&&(b=new Date(O).getTime());let R;if(typeof u=="string"?R=D(F(u)):R=u,!h||!R)return!1;let P=h.majorBase,v=h.minorBase,o=h.patchBase,r=R.majorBase,e=R.minorBase,i=R.patchBase,n=R.notBefore,s=R.majorMustEqual,l=R.minorMustEqual,E=R.patchMustEqual;return R.isMinimum?P>r?!0:P<r?!1:v>e?!0:v<e||b&&b<n?!1:o>=i:(P===1&&r===0&&(!s||!l||!E)&&(r=1,e=0,i=0,s=!0,l=!1,E=!1),P<r?!1:P>r?!s:v<e?!1:v>e?!l:o<i?!1:o>i?!E:!(b&&b<n))}t.isValidVersion=c;function f(y,O,u,h){return u.isBuiltin||typeof u.main=="undefined"?!0:w(y,O,u.engines.vscode,h)}t.isValidExtensionVersion=f;function C(y,O,u){return y==="*"||w(O,u,y)}t.isEngineValid=C;function w(y,O,u,h=[]){let b=D(F(u));if(!b)return h.push(g.localize(0,null,u)),!1;if(b.majorBase===0){if(!b.majorMustEqual||!b.minorMustEqual)return h.push(g.localize(1,null,u)),!1}else if(!b.majorMustEqual)return h.push(g.localize(2,null,u)),!1;return c(y,O,b)?!0:(h.push(g.localize(3,null,y,u)),!1)}}),define(J[90],Y([0,1,37,48,2,8]),function(_,t,g,A,I,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class F extends I.Disposable{constructor(c,f,C,w){super();this.folders=c,this.onDidFilesChange=f,this.onLogMessage=C,this.verboseLogging=w,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const c=this._register(new A.Client(L.FileAccess.asFileUri("bootstrap-fork",_).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(c.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=F.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=g.ProxyChannel.toService(g.getNextTickChannel(c.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(f=>!this.isDisposed&&this.onDidFilesChange(f))),this._register(this.service.onDidLogMessage(f=>this.onLogMessage(f))),this.setFolders(this.folders)}setVerboseLogging(c){this.verboseLogging=c,!this.isDisposed&&this.service&&this.service.setVerboseLogging(c)}error(c){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${c}`})}setFolders(c){this.folders=c,this.service&&this.service.setRoots(c)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=F,F.MAX_RESTARTS=5}),define(J[91],Y([0,1,37,48,2,8]),function(_,t,g,A,I,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class F extends I.Disposable{constructor(c,f,C,w,y={}){super();this.folders=c,this.onDidFilesChange=f,this.onLogMessage=C,this.verboseLogging=w,this.watcherOptions=y,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const c=this._register(new A.Client(L.FileAccess.asFileUri("bootstrap-fork",_).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(c.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=F.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=g.ProxyChannel.toService(g.getNextTickChannel(c.getChannel("watcher"))),this.service.init(Object.assign(Object.assign({},this.watcherOptions),{verboseLogging:this.verboseLogging})),this._register(this.service.onDidChangeFile(f=>!this.isDisposed&&this.onDidFilesChange(f))),this._register(this.service.onDidLogMessage(f=>this.onLogMessage(f))),this.service.setRoots(this.folders)}error(c){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${c}`})}setVerboseLogging(c){this.verboseLogging=c,this.service&&this.service.setVerboseLogging(c)}setFolders(c){this.folders=c,this.service&&this.service.setRoots(c)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=F,F.MAX_RESTARTS=5}),define(J[92],Y([0,1,33,46,61,8]),function(_,t,g,A,I,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OutOfProcessWin32FolderWatcher=void 0;class F{constructor(c,f,C,w,y){this.watchedFolder=c,this.eventCallback=C,this.logCallback=w,this.verboseLogging=y,this.restartCounter=0,Array.isArray(f)?this.ignored=f.map(O=>I.parse(O)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${c}`),this.startWatcher()}startWatcher(){const c=[this.watchedFolder];this.verboseLogging&&c.push("-verbose"),this.handle=g.spawn(L.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",_).fsPath,c);const f=new A.LineDecoder;this.handle.stdout.on("data",C=>{const w=[];f.write(C).forEach(y=>{const O=y.split("|");if(O.length===2){const u=Number(O[0]),h=O[1];if(u>=0&&u<3){if(this.ignored&&this.ignored.some(b=>b(h))){this.verboseLogging&&this.log(h);return}w.push({type:F.changeTypeMap[u],path:h})}else this.log(O[1])}}),w.length>0&&this.eventCallback(w)}),this.handle.on("error",C=>this.onError(C)),this.handle.stderr.on("data",C=>this.onError(C)),this.handle.on("exit",(C,w)=>this.onExit(C,w))}onError(c){this.error("process error: "+c.toString())}onExit(c,f){this.handle&&(this.error(`terminated unexpectedly (code: ${c}, signal: ${f})`),this.restartCounter<=F.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(c){this.logCallback({type:"error",message:`[File Watcher (C#)] ${c}`})}log(c){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${c}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}t.OutOfProcessWin32FolderWatcher=F,F.MAX_RESTARTS=5,F.changeTypeMap=[0,1,2]}),define(J[93],Y([0,1,92,3,19]),function(_,t,g,A,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class L{constructor(D,c,f,C){this.onDidFilesChange=c,this.onLogMessage=f,this.verboseLogging=C,this.service=void 0,this.folder=D[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(A.posix.sep)&&(this.folder.path=I.rtrim(this.folder.path,A.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new g.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,D=>this.onFileEvents(D),D=>this.onLogMessage(D),this.verboseLogging)}setVerboseLogging(D){this.verboseLogging=D,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(D){this.isDisposed||D.length>0&&this.onDidFilesChange(D)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}t.FileWatcher=L}),define(J[50],Y([0,1]),function(_,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createSyncDescriptor=t.SyncDescriptor=void 0;class g{constructor(L,F=[],D=!1){this.ctor=L,this.staticArguments=F,this.supportsDelayedInstantiation=D}}t.SyncDescriptor=g;const A=(I,...L)=>new g(I,L);t.createSyncDescriptor=A}),define(J[94],Y([0,1]),function(_,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Graph=t.Node=void 0;class g{constructor(L){this.incoming=new Map,this.outgoing=new Map,this.data=L}}t.Node=g;class A{constructor(L){this._hashFn=L,this._nodes=new Map}roots(){const L=[];for(let F of this._nodes.values())F.outgoing.size===0&&L.push(F);return L}insertEdge(L,F){const D=this.lookupOrInsertNode(L),c=this.lookupOrInsertNode(F);D.outgoing.set(this._hashFn(F),c),c.incoming.set(this._hashFn(L),D)}removeNode(L){const F=this._hashFn(L);this._nodes.delete(F);for(let D of this._nodes.values())D.outgoing.delete(F),D.incoming.delete(F)}lookupOrInsertNode(L){const F=this._hashFn(L);let D=this._nodes.get(F);return D||(D=new g(L),this._nodes.set(F,D)),D}lookup(L){return this._nodes.get(this._hashFn(L))}isEmpty(){return this._nodes.size===0}toString(){let L=[];for(let[F,D]of this._nodes)L.push(`${F}, (incoming)[${[...D.incoming.keys()].join(", ")}], (outgoing)[${[...D.outgoing.keys()].join(",")}]`);return L.join(`
`)}findCycleSlow(){for(let[L,F]of this._nodes){const D=new Set([L]),c=this._findCycle(F,D);if(c)return c}}_findCycle(L,F){for(let[D,c]of L.outgoing){if(F.has(D))return[...F,D].join(" -> ");F.add(D);const f=this._findCycle(c,F);if(f)return f;F.delete(D)}}}t.Graph=A}),define(J[95],Y([0,1,11]),function(_,t,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IDownloadService=void 0,t.IDownloadService=g.createDecorator("downloadService")}),define(J[21],Y([0,1,11]),function(_,t,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.INativeEnvironmentService=t.IEnvironmentService=void 0,t.IEnvironmentService=g.createDecorator("environmentService"),t.INativeEnvironmentService=g.refineServiceDecorator(t.IEnvironmentService)}),define(J[23],Y([0,1,74,11,8]),function(_,t,g,A,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IExtensionManagementCLIService=t.PreferencesLocalizedLabel=t.PreferencesLabel=t.ExtensionsChannelId=t.ExtensionsLocalizedLabel=t.ExtensionsLabel=t.DefaultIconPath=t.IExtensionTipsService=t.IGlobalExtensionEnablementService=t.ENABLED_EXTENSIONS_STORAGE_PATH=t.DISABLED_EXTENSIONS_STORAGE_PATH=t.IExtensionManagementService=t.ExtensionManagementError=t.INSTALL_ERROR_INCOMPATIBLE=t.INSTALL_ERROR_MALICIOUS=t.INSTALL_ERROR_NOT_SUPPORTED=t.IExtensionGalleryService=t.InstallOperation=t.StatisticType=t.SortOrder=t.SortBy=t.isIExtensionIdentifier=t.EXTENSION_IDENTIFIER_REGEX=t.EXTENSION_IDENTIFIER_PATTERN=void 0,t.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",t.EXTENSION_IDENTIFIER_REGEX=new RegExp(t.EXTENSION_IDENTIFIER_PATTERN);function L(w){return w&&typeof w=="object"&&typeof w.id=="string"&&(!w.uuid||typeof w.uuid=="string")}t.isIExtensionIdentifier=L;var F;(function(w){w[w.NoneOrRelevance=0]="NoneOrRelevance",w[w.LastUpdatedDate=1]="LastUpdatedDate",w[w.Title=2]="Title",w[w.PublisherName=3]="PublisherName",w[w.InstallCount=4]="InstallCount",w[w.PublishedDate=5]="PublishedDate",w[w.AverageRating=6]="AverageRating",w[w.WeightedRating=12]="WeightedRating"})(F=t.SortBy||(t.SortBy={}));var D;(function(w){w[w.Default=0]="Default",w[w.Ascending=1]="Ascending",w[w.Descending=2]="Descending"})(D=t.SortOrder||(t.SortOrder={}));var c;(function(w){w.Uninstall="uninstall"})(c=t.StatisticType||(t.StatisticType={}));var f;(function(w){w[w.None=0]="None",w[w.Install=1]="Install",w[w.Update=2]="Update"})(f=t.InstallOperation||(t.InstallOperation={})),t.IExtensionGalleryService=A.createDecorator("extensionGalleryService"),t.INSTALL_ERROR_NOT_SUPPORTED="notsupported",t.INSTALL_ERROR_MALICIOUS="malicious",t.INSTALL_ERROR_INCOMPATIBLE="incompatible";class C extends Error{constructor(y,O){super(y);this.code=O}}t.ExtensionManagementError=C,t.IExtensionManagementService=A.createDecorator("extensionManagementService"),t.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",t.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",t.IGlobalExtensionEnablementService=A.createDecorator("IGlobalExtensionEnablementService"),t.IExtensionTipsService=A.createDecorator("IExtensionTipsService"),t.DefaultIconPath=I.FileAccess.asBrowserUri("./media/defaultIcon.png",_).toString(!0),t.ExtensionsLabel=g.localize(0,null),t.ExtensionsLocalizedLabel={value:t.ExtensionsLabel,original:"Extensions"},t.ExtensionsChannelId="extensions",t.PreferencesLabel=g.localize(1,null),t.PreferencesLocalizedLabel={value:t.PreferencesLabel,original:"Preferences"},t.IExtensionManagementCLIService=A.createDecorator("IExtensionManagementCLIService")}),define(J[38],Y([0,1,19,11]),function(_,t,g,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IBuiltinExtensionsScannerService=t.isAuthenticaionProviderExtension=t.isLanguagePackExtension=t.ExtensionIdentifier=t.ExtensionType=t.EXTENSION_CATEGORIES=t.isIExtensionIdentifier=t.getWorkpaceSupportTypeMessage=t.BUILTIN_MANIFEST_CACHE_FILE=t.USER_MANIFEST_CACHE_FILE=t.MANIFEST_CACHE_FOLDER=void 0,t.MANIFEST_CACHE_FOLDER="CachedExtensions",t.USER_MANIFEST_CACHE_FILE="user",t.BUILTIN_MANIFEST_CACHE_FILE="builtin";function I(C){if(typeof C=="object"&&C!==null&&C.supported!==!0)return C.description}t.getWorkpaceSupportTypeMessage=I;function L(C){return C&&typeof C=="object"&&typeof C.id=="string"&&(!C.uuid||typeof C.uuid=="string")}t.isIExtensionIdentifier=L,t.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var F;(function(C){C[C.System=0]="System",C[C.User=1]="User"})(F=t.ExtensionType||(t.ExtensionType={}));class D{constructor(w){this.value=w,this._lower=w.toLowerCase()}static equals(w,y){if(typeof w=="undefined"||w===null)return typeof y=="undefined"||y===null;if(typeof y=="undefined"||y===null)return!1;if(typeof w=="string"||typeof y=="string"){let O=typeof w=="string"?w:w.value,u=typeof y=="string"?y:y.value;return g.equalsIgnoreCase(O,u)}return w._lower===y._lower}static toKey(w){return typeof w=="string"?w.toLowerCase():w._lower}}t.ExtensionIdentifier=D;function c(C){return C.contributes&&C.contributes.localizations?C.contributes.localizations.length>0:!1}t.isLanguagePackExtension=c;function f(C){return C.contributes&&C.contributes.authentication?C.contributes.authentication.length>0:!1}t.isAuthenticaionProviderExtension=f,t.IBuiltinExtensionsScannerService=A.createDecorator("IBuiltinExtensionsScannerService")}),define(J[24],Y([0,1,19,38]),function(_,t,g,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMaliciousExtensionsSet=t.BetterMergeId=t.getGalleryExtensionTelemetryData=t.getLocalExtensionTelemetryData=t.groupByExtension=t.getGalleryExtensionId=t.adoptToGalleryExtensionId=t.getExtensionId=t.ExtensionIdentifierWithVersion=t.areSameExtensions=void 0;function I(O,u){return O.uuid&&u.uuid?O.uuid===u.uuid:O.id===u.id?!0:g.compareIgnoreCase(O.id,u.id)===0}t.areSameExtensions=I;class L{constructor(u,h){this.version=h,this.id=u.id,this.uuid=u.uuid}key(){return`${this.id}-${this.version}`}equals(u){return u instanceof L?I(this,u)&&this.version===u.version:!1}}t.ExtensionIdentifierWithVersion=L;function F(O,u){return`${O}.${u}`}t.getExtensionId=F;function D(O){return O.toLocaleLowerCase()}t.adoptToGalleryExtensionId=D;function c(O,u){return D(F(O,u))}t.getGalleryExtensionId=c;function f(O,u){const h=[],b=R=>{for(const P of h)if(P.some(v=>I(u(v),u(R))))return P;return null};for(const R of O){const P=b(R);P?P.push(R):h.push([R])}return h}t.groupByExtension=f;function C(O){return{id:O.identifier.id,name:O.manifest.name,galleryId:null,publisherId:O.publisherId,publisherName:O.manifest.publisher,publisherDisplayName:O.publisherDisplayName,dependencies:O.manifest.extensionDependencies&&O.manifest.extensionDependencies.length>0}}t.getLocalExtensionTelemetryData=C;function w(O){return Object.assign({id:O.identifier.id,name:O.name,galleryId:O.identifier.uuid,publisherId:O.publisherId,publisherName:O.publisher,publisherDisplayName:O.publisherDisplayName,dependencies:!!(O.properties.dependencies&&O.properties.dependencies.length>0)},O.telemetryData)}t.getGalleryExtensionTelemetryData=w,t.BetterMergeId=new A.ExtensionIdentifier("pprice.better-merge");function y(O){const u=new Set;for(const h of O)h.malicious&&u.add(h.id.id);return u}t.getMaliciousExtensionsSet=y});var fe=this&&this.__param||function(_,t){return function(g,A){t(g,A,_)}};define(J[96],Y([0,1,75,13,7,39,23,24,38,62,27,8]),function(_,t,g,A,I,L,F,D,c,f,C,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementCLIService=t.getIdAndVersion=void 0;const y=P=>g.localize(0,null,P),O=g.localize(1,null,"ms-dotnettools.csharp");function u(P,v){return v?`${P.publisher}.${P.name}@${P.version}`:`${P.publisher}.${P.name}`}const h=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function b(P){const v=h.exec(P);return v&&v[1]?[D.adoptToGalleryExtensionId(v[1]),v[2]]:[D.adoptToGalleryExtensionId(P),void 0]}t.getIdAndVersion=b;let R=class{constructor(v,o){this.extensionManagementService=v,this.extensionGalleryService=o}get location(){}async listExtensions(v,o,r=console){let e=await this.extensionManagementService.getInstalled(1);const i=c.EXTENSION_CATEGORIES.map(s=>s.toLowerCase());if(o&&o!==""){if(i.indexOf(o.toLowerCase())<0){r.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}e=e.filter(s=>s.manifest.categories?s.manifest.categories.map(E=>E.toLowerCase()).indexOf(o.toLowerCase())>-1:!1)}else if(o===""){r.log("Possible Categories: "),i.forEach(s=>{r.log(s)});return}this.location&&r.log(g.localize(2,null,this.location)),e=e.sort((s,l)=>s.identifier.id.localeCompare(l.identifier.id));let n;for(let s of e)n!==s.identifier.id&&(n=s.identifier.id,r.log(u(s.manifest,v)))}async installExtensions(v,o,r,e,i=console){const n=[],s=[];v.length&&i.log(this.location?g.localize(3,null,this.location):g.localize(4,null));const l=await this.extensionManagementService.getInstalled(1),E=(k,j)=>{const V=l.find($=>D.areSameExtensions($.identifier,{id:k}));if(V){if(!j&&!e)return i.log(g.localize(5,null,k,V.manifest.version,k)),!1;if(j&&V.manifest.version===j)return i.log(g.localize(6,null,`${k}@${j}`)),!1}return!0},S=[],U=[];for(const k of v)if(k instanceof I.URI)S.push(k);else{const[j,V]=b(k);E(j,V)&&U.push({id:j,version:V,installOptions:{isBuiltin:!1,isMachineScoped:r}})}for(const k of o){const[j,V]=b(k);E(j,V)&&U.push({id:j,version:V,installOptions:{isBuiltin:!0,isMachineScoped:!1}})}if(S.length&&await Promise.all(S.map(async k=>{try{const j=await this.installVSIX(k,{isBuiltin:!1,isMachineScoped:r},e,i);j&&s.push(j)}catch(j){i.error(j.message||j.stack||j),n.push(k.toString())}})),U.length){const k=await this.getGalleryExtensions(U);await Promise.all(U.map(async j=>{const V=k.get(j.id.toLowerCase());if(V)try{const $=await this.installFromGallery(j,V,l,e,i);$&&s.push($)}catch($){i.error($.message||$.stack||$),n.push(j.id)}else i.error(`${y(j.version?`${j.id}@${j.version}`:j.id)}
${O}`),n.push(j.id)}))}if(n.length)throw new Error(g.localize(7,null,n.join(", ")))}async installVSIX(v,o,r,e){const i=await this.extensionManagementService.getManifest(v);if(!i)throw new Error("Invalid vsix");if(await this.validateVSIX(i,r,e))try{return await this.extensionManagementService.install(v,o),e.log(g.localize(8,null,f.getBaseLabel(v))),i}catch(s){if(A.isPromiseCanceledError(s))return e.log(g.localize(9,null,f.getBaseLabel(v))),null;throw s}return null}async getGalleryExtensions(v){const o=v.filter(({version:i})=>i===void 0).map(({id:i})=>i),r=v.filter(({version:i})=>i!==void 0),e=new Map;return await Promise.all([(async()=>{(await this.extensionGalleryService.getExtensions(o,C.CancellationToken.None)).forEach(n=>e.set(n.identifier.id.toLowerCase(),n))})(),Promise.all(r.map(async({id:i,version:n})=>{const s=await this.extensionGalleryService.getCompatibleExtension({id:i},n);s&&e.set(s.identifier.id.toLowerCase(),s)}))]),e}async installFromGallery({id:v,version:o,installOptions:r},e,i,n,s){const l=await this.extensionGalleryService.getManifest(e,C.CancellationToken.None);if(l&&!this.validateExtensionKind(l,s))return null;const E=i.find(S=>D.areSameExtensions(S.identifier,e.identifier));if(E){if(e.version===E.manifest.version)return s.log(g.localize(10,null,o?`${v}@${o}`:v)),null;s.log(g.localize(11,null,v,e.version))}try{return r.isBuiltin?s.log(g.localize(12,null,v,e.version)):s.log(g.localize(13,null,v,e.version)),await this.extensionManagementService.installFromGallery(e,r),s.log(g.localize(14,null,v,e.version)),l}catch(S){if(A.isPromiseCanceledError(S))return s.log(g.localize(15,null,v)),null;throw S}}validateExtensionKind(v,o){return!0}async validateVSIX(v,o,r){const e={id:D.getGalleryExtensionId(v.publisher,v.name)},n=(await this.extensionManagementService.getInstalled(1)).find(s=>D.areSameExtensions(e,s.identifier)&&L.gt(s.manifest.version,v.version));return n&&!o?(r.log(g.localize(16,null,n.identifier.id,n.manifest.version,v.version)),!1):this.validateExtensionKind(v,r)}async uninstallExtensions(v,o,r=console){const e=async n=>{if(n instanceof I.URI){const s=await this.extensionManagementService.getManifest(n);return u(s)}return n},i=[];for(const n of v){const s=await e(n),E=(await this.extensionManagementService.getInstalled()).filter(S=>D.areSameExtensions(S.identifier,{id:s}));if(!E.length)throw new Error(`${this.notInstalled(s)}
${O}`);if(E.some(S=>S.type===0)){r.log(g.localize(17,null,s));return}if(!o&&E.some(S=>S.isBuiltin)){r.log(g.localize(18,null,s));return}r.log(g.localize(19,null,s));for(const S of E)await this.extensionManagementService.uninstall(S),i.push(S);this.location?r.log(g.localize(20,null,s,this.location)):r.log(g.localize(21,null,s))}}async locateExtension(v,o=console){const r=await this.extensionManagementService.getInstalled();v.forEach(e=>{r.forEach(i=>{if(i.identifier.id===e&&i.location.scheme===w.Schemas.file){o.log(i.location.fsPath);return}})})}notInstalled(v){return this.location?g.localize(22,null,v,this.location):g.localize(23,null,v)}};R=ue([fe(0,F.IExtensionManagementService),fe(1,F.IExtensionGalleryService)],R),t.ExtensionManagementCLIService=R}),define(J[97],Y([0,1,2,3,38,9]),function(_,t,g,A,I,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsManifestCache=void 0;class F extends g.Disposable{constructor(c,f){super();this.environmentService=c,this.extensionsManifestCache=A.join(this.environmentService.userDataPath,I.MANIFEST_CACHE_FOLDER,I.USER_MANIFEST_CACHE_FILE),this._register(f.onDidInstallExtension(C=>this.onDidInstallExtension(C))),this._register(f.onDidUninstallExtension(C=>this.onDidUnInstallExtension(C)))}onDidInstallExtension(c){c.error||this.invalidate()}onDidUnInstallExtension(c){c.error||this.invalidate()}invalidate(){L.rimraf(this.extensionsManifestCache,L.RimRafMode.MOVE).then(()=>{},()=>{})}}t.ExtensionsManifestCache=F}),define(J[98],Y([0,1,87,33,29,14,126,28,71]),function(_,t,g,A,I,L,F,D,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveShellEnv=void 0;async function f(y,O,u){return O["force-disable-user-env"]?(y.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):L.isWindows?(y.trace("resolveShellEnv(): skipped (Windows)"),{}):F.isLaunchedFromCli(u)&&!O["force-user-env"]?(y.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):(F.isLaunchedFromCli(u)?y.trace("resolveShellEnv(): running (--force-user-env)"):y.trace("resolveShellEnv(): running (macOS/Linux)"),C||(C=w(y)),C)}t.resolveShellEnv=f;let C;async function w(y){const O=new Promise(async(u,h)=>{const b=process.env.ELECTRON_RUN_AS_NODE;y.trace("getUnixShellEnvironment#runAsNode",b);const R=process.env.ELECTRON_NO_ATTACH_CONSOLE;y.trace("getUnixShellEnvironment#noAttach",R);const P=I.generateUuid().replace(/-/g,"").substr(0,12),v=new RegExp(P+"(.*)"+P),o=Object.assign(Object.assign({},process.env),{ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"});y.trace("getUnixShellEnvironment#env",o);const r=await c.getSystemShell(L.OS,o);y.trace("getUnixShellEnvironment#shell",r);const e=g.basename(r);let i,n;/^pwsh(-preview)?$/.test(e)?(i=`& '${process.execPath}' -p '''${P}'' + JSON.stringify(process.env) + ''${P}'''`,n=["-Login","-Command"]):(i=`'${process.execPath}' -p '"${P}" + JSON.stringify(process.env) + "${P}"'`,n=["-ilc"]),y.trace("getUnixShellEnvironment#spawn",JSON.stringify(n),i);const s=A.spawn(r,[...n,i],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});s.on("error",S=>{y.error("getUnixShellEnvironment#errorChildProcess",D.toErrorMessage(S)),u({})});const l=[];s.stdout.on("data",S=>l.push(S));const E=[];s.stderr.on("data",S=>E.push(S)),s.on("close",(S,U)=>{const k=Buffer.concat(l).toString("utf8");y.trace("getUnixShellEnvironment#raw",k);const j=Buffer.concat(E).toString("utf8");if(j.trim()&&y.trace("getUnixShellEnvironment#stderr",j),S||U)return h(new Error(`Failed to get environment (code ${S}, signal ${U})`));const V=v.exec(k),$=V?V[1]:"{}";try{const K=JSON.parse($);b?K.ELECTRON_RUN_AS_NODE=b:delete K.ELECTRON_RUN_AS_NODE,R?K.ELECTRON_NO_ATTACH_CONSOLE=R:delete K.ELECTRON_NO_ATTACH_CONSOLE,delete K.XDG_RUNTIME_DIR,y.trace("getUnixShellEnvironment#result",K),u(K)}catch(K){y.error("getUnixShellEnvironment#errorCaught",D.toErrorMessage(K)),h(K)}})});try{return await O}catch(u){return y.error("getUnixShellEnvironment#error",D.toErrorMessage(u)),{}}}}),define(J[51],Y([0,1,7,18,14]),function(_,t,g,A,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.normalizeFileChanges=t.toFileChanges=void 0;function L(c){return c.map(f=>({type:f.type,resource:g.URI.file(f.path)}))}t.toFileChanges=L;function F(c){const f=new D;for(const C of c)f.processEvent(C);return f.normalize()}t.normalizeFileChanges=F;class D{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(f){const C=this.mapPathToChange.get(f.path);if(C){const w=C.type,y=f.type;w===1&&y===2?(this.mapPathToChange.delete(f.path),this.normalized.splice(this.normalized.indexOf(C),1)):w===2&&y===1?C.type=0:w===1&&y===0||(C.type=y)}else this.normalized.push(f),this.mapPathToChange.set(f.path,f)}normalize(){const f=[],C=[];return this.normalized.filter(w=>w.type!==2?(f.push(w),!1):!0).sort((w,y)=>w.path.length-y.path.length).filter(w=>C.some(y=>A.isParent(w.path,y,!I.isLinux))?!1:(C.push(w.path),!0)).concat(f)}}}),define(J[99],Y([0,1,51,2,9,63,65,4,3]),function(_,t,g,A,I,L,F,D,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class f extends A.Disposable{constructor(w,y,O,u){super();this.path=w,this.onDidFilesChange=y,this.onLogMessage=O,this.verboseLogging=u,this.fileChangesDelayer=this._register(new D.ThrottledDelayer(F.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(w){this.verboseLogging=w}async startWatching(){try{const{stat:w,symbolicLink:y}=await I.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let O=this.path;if(y)try{O=await L.realpath(O)}catch(u){if(this.onError(u),y.dangling)return}w.isDirectory()?this._register(F.watchFolder(O,(u,h)=>{this.onFileChange({type:u==="changed"?0:u==="added"?1:2,path:c.join(this.path,c.basename(h))})},u=>this.onError(u))):this._register(F.watchFile(O,u=>{this.onFileChange({type:u==="changed"?0:2,path:this.path})},u=>this.onError(u)))}catch(w){w.code!=="ENOENT"&&this.onError(w)}}onFileChange(w){this.fileChangesBuffer.push(w),this.verboseLogging&&this.onVerbose(`${w.type===1?"[ADDED]":w.type===2?"[DELETED]":"[CHANGED]"} ${w.path}`),this.fileChangesDelayer.trigger(async()=>{const y=this.fileChangesBuffer;this.fileChangesBuffer=[];const O=g.normalizeFileChanges(y);this.verboseLogging&&O.forEach(u=>{this.onVerbose(`>> normalized ${u.type===1?"[ADDED]":u.type===2?"[DELETED]":"[CHANGED]"} ${u.path}`)}),O.length>0&&this.onDidFilesChange(O)})}onError(w){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${w}`})}onVerbose(w){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${w}`})}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=f}),define(J[52],Y([0,1]),function(_,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ServiceCollection=void 0;class g{constructor(...I){this._entries=new Map;for(let[L,F]of I)this.set(L,F)}set(I,L){const F=this._entries.get(I);return this._entries.set(I,L),F}has(I){return this._entries.has(I)}get(I){return this._entries.get(I)}}t.ServiceCollection=g}),define(J[100],Y([0,1,13,94,50,11,52,4]),function(_,t,g,A,I,L,F,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InstantiationService=void 0;const c=!1;class f extends Error{constructor(u){var h;super("cyclic dependency between services");this.message=(h=u.findCycleSlow())!==null&&h!==void 0?h:`UNABLE to detect cycle, dumping graph: 
${u.toString()}`}}class C{constructor(u=new F.ServiceCollection,h=!1,b){this._activeInstantiations=new Set,this._services=u,this._strict=h,this._parent=b,this._services.set(L.IInstantiationService,this)}createChild(u){return new C(u,this._strict,this)}invokeFunction(u,...h){let b=y.traceInvocation(u),R=!1;try{return u({get:(v,o)=>{if(R)throw g.illegalState("service accessor is only valid during the invocation of its target method");const r=this._getOrCreateServiceInstance(v,b);if(!r&&o!==L.optional)throw new Error(`[invokeFunction] unknown service '${v}'`);return r}},...h)}finally{R=!0,b.stop()}}createInstance(u,...h){let b,R;return u instanceof I.SyncDescriptor?(b=y.traceCreation(u.ctor),R=this._createInstance(u.ctor,u.staticArguments.concat(h),b)):(b=y.traceCreation(u),R=this._createInstance(u,h,b)),b.stop(),R}_createInstance(u,h=[],b){let R=L._util.getServiceDependencies(u).sort((o,r)=>o.index-r.index),P=[];for(const o of R){let r=this._getOrCreateServiceInstance(o.id,b);if(!r&&this._strict&&!o.optional)throw new Error(`[createInstance] ${u.name} depends on UNKNOWN service ${o.id}.`);P.push(r)}let v=R.length>0?R[0].index:h.length;if(h.length!==v){console.warn(`[createInstance] First service dependency of ${u.name} at position ${v+1} conflicts with ${h.length} static arguments`);let o=v-h.length;o>0?h=h.concat(new Array(o)):h=h.slice(0,v)}return new u(...[...h,...P])}_setServiceInstance(u,h){if(this._services.get(u)instanceof I.SyncDescriptor)this._services.set(u,h);else if(this._parent)this._parent._setServiceInstance(u,h);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(u){let h=this._services.get(u);return!h&&this._parent?this._parent._getServiceInstanceOrDescriptor(u):h}_getOrCreateServiceInstance(u,h){let b=this._getServiceInstanceOrDescriptor(u);return b instanceof I.SyncDescriptor?this._safeCreateAndCacheServiceInstance(u,b,h.branch(u,!0)):(h.branch(u,!1),b)}_safeCreateAndCacheServiceInstance(u,h,b){if(this._activeInstantiations.has(u))throw new Error(`illegal state - RECURSIVELY instantiating service '${u}'`);this._activeInstantiations.add(u);try{return this._createAndCacheServiceInstance(u,h,b)}finally{this._activeInstantiations.delete(u)}}_createAndCacheServiceInstance(u,h,b){const R=new A.Graph(o=>o.id.toString());let P=0;const v=[{id:u,desc:h,_trace:b}];for(;v.length;){const o=v.pop();if(R.lookupOrInsertNode(o),P++>1e3)throw new f(R);for(let r of L._util.getServiceDependencies(o.desc.ctor)){let e=this._getServiceInstanceOrDescriptor(r.id);if(!e&&!r.optional&&console.warn(`[createInstance] ${u} depends on ${r.id} which is NOT registered.`),e instanceof I.SyncDescriptor){const i={id:r.id,desc:e,_trace:o._trace.branch(r.id,!0)};R.insertEdge(o,i),v.push(i)}}}for(;;){const o=R.roots();if(o.length===0){if(!R.isEmpty())throw new f(R);break}for(const{data:r}of o){if(this._getServiceInstanceOrDescriptor(r.id)instanceof I.SyncDescriptor){const i=this._createServiceInstanceWithOwner(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this._setServiceInstance(r.id,i)}R.removeNode(r)}}return this._getServiceInstanceOrDescriptor(u)}_createServiceInstanceWithOwner(u,h,b=[],R,P){if(this._services.get(u)instanceof I.SyncDescriptor)return this._createServiceInstance(h,b,R,P);if(this._parent)return this._parent._createServiceInstanceWithOwner(u,h,b,R,P);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}_createServiceInstance(u,h=[],b,R){if(b){const P=new D.IdleValue(()=>this._createInstance(u,h,R));return new Proxy(Object.create(null),{get(v,o){if(o in v)return v[o];let r=P.value,e=r[o];return typeof e!="function"||(e=e.bind(r),v[o]=e),e},set(v,o,r){return P.value[o]=r,!0}})}else return this._createInstance(u,h,R)}}t.InstantiationService=C;var w;(function(O){O[O.Creation=0]="Creation",O[O.Invocation=1]="Invocation",O[O.Branch=2]="Branch"})(w||(w={}));class y{constructor(u,h){this.type=u,this.name=h,this._start=Date.now(),this._dep=[]}static traceInvocation(u){return c?new y(1,u.name||u.toString().substring(0,42).replace(/\n/g,"")):y._None}static traceCreation(u){return c?new y(0,u.name):y._None}branch(u,h){let b=new y(2,u.toString());return this._dep.push([u,h,b]),b}stop(){let u=Date.now()-this._start;y._totals+=u;let h=!1;function b(P,v){let o=[],r=new Array(P+1).join("	");for(const[e,i,n]of v._dep)if(i&&n){h=!0,o.push(`${r}CREATES -> ${e}`);let s=b(P+1,n);s&&o.push(s)}else o.push(`${r}uses -> ${e}`);return o.join(`
`)}let R=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${b(1,this)}`,`DONE, took ${u.toFixed(2)}ms (grand total ${y._totals.toFixed(2)}ms)`];(u>2||h)&&console.log(R.join(`
`))}}y._None=new class extends y{constructor(){super(-1,null)}stop(){}branch(){return this}},y._totals=0}),define(J[53],Y([0,1,11]),function(_,t,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isValidLocalization=t.ILocalizationsService=void 0,t.ILocalizationsService=g.createDecorator("localizationsService");function A(I){if(typeof I.languageId!="string"||!Array.isArray(I.translations)||I.translations.length===0)return!1;for(const L of I.translations)if(typeof L.id!="string"||typeof L.path!="string")return!1;return!(I.languageName&&typeof I.languageName!="string"||I.localizedLanguageName&&typeof I.localizedLanguageName!="string")}t.isValidLocalization=A}),define(J[15],Y([0,1,11,2,14,10,28]),function(_,t,g,A,I,L,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LogLevelToString=t.parseLogLevel=t.getLogLevel=t.NullLogService=t.AbstractLoggerService=t.LogService=t.MultiplexLogService=t.AdapterLogger=t.ConsoleLogger=t.ConsoleMainLogger=t.AbstractMessageLogger=t.AbstractLogger=t.DEFAULT_LOG_LEVEL=t.LogLevel=t.ILoggerService=t.ILogService=void 0,t.ILogService=g.createDecorator("logService"),t.ILoggerService=g.createDecorator("loggerService");function D(){return new Date().toISOString()}var c;(function(r){r[r.Trace=0]="Trace",r[r.Debug=1]="Debug",r[r.Info=2]="Info",r[r.Warning=3]="Warning",r[r.Error=4]="Error",r[r.Critical=5]="Critical",r[r.Off=6]="Off"})(c=t.LogLevel||(t.LogLevel={})),t.DEFAULT_LOG_LEVEL=c.Info;class f extends A.Disposable{constructor(){super(...arguments);this.level=t.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(e){this.level!==e&&(this.level=e,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}t.AbstractLogger=f;class C extends f{constructor(e){super();this.logAlways=e}checkLogLevel(e){return this.logAlways||this.getLevel()<=e}trace(e,...i){this.checkLogLevel(c.Trace)&&this.log(c.Trace,this.format([e,...i]))}debug(e,...i){this.checkLogLevel(c.Debug)&&this.log(c.Debug,this.format([e,...i]))}info(e,...i){this.checkLogLevel(c.Info)&&this.log(c.Info,this.format([e,...i]))}warn(e,...i){this.checkLogLevel(c.Warning)&&this.log(c.Warning,this.format([e,...i]))}error(e,...i){if(this.checkLogLevel(c.Error))if(e instanceof Error){const n=Array.prototype.slice.call(arguments);n[0]=e.stack,this.log(c.Error,this.format(n))}else this.log(c.Error,this.format([e,...i]))}critical(e,...i){this.checkLogLevel(c.Critical)&&this.log(c.Critical,this.format([e,...i]))}flush(){}format(e){let i="";for(let n=0;n<e.length;n++){let s=e[n];if(typeof s=="object")try{s=JSON.stringify(s)}catch(l){}i+=(n>0?" ":"")+s}return i}}t.AbstractMessageLogger=C;class w extends f{constructor(e=t.DEFAULT_LOG_LEVEL){super();this.setLevel(e),this.useColors=!I.isWindows}trace(e,...i){this.getLevel()<=c.Trace&&(this.useColors?console.log(`[90m[main ${D()}][0m`,e,...i):console.log(`[main ${D()}]`,e,...i))}debug(e,...i){this.getLevel()<=c.Debug&&(this.useColors?console.log(`[90m[main ${D()}][0m`,e,...i):console.log(`[main ${D()}]`,e,...i))}info(e,...i){this.getLevel()<=c.Info&&(this.useColors?console.log(`[90m[main ${D()}][0m`,e,...i):console.log(`[main ${D()}]`,e,...i))}warn(e,...i){this.getLevel()<=c.Warning&&(this.useColors?console.warn(`[93m[main ${D()}][0m`,e,...i):console.warn(`[main ${D()}]`,e,...i))}error(e,...i){this.getLevel()<=c.Error&&(this.useColors?console.error(`[91m[main ${D()}][0m`,e,...i):console.error(`[main ${D()}]`,e,...i))}critical(e,...i){this.getLevel()<=c.Critical&&(this.useColors?console.error(`[90m[main ${D()}][0m`,e,...i):console.error(`[main ${D()}]`,e,...i))}dispose(){}flush(){}}t.ConsoleMainLogger=w;class y extends f{constructor(e=t.DEFAULT_LOG_LEVEL){super();this.setLevel(e)}trace(e,...i){this.getLevel()<=c.Trace&&console.log("%cTRACE","color: #888",e,...i)}debug(e,...i){this.getLevel()<=c.Debug&&console.log("%cDEBUG","background: #eee; color: #888",e,...i)}info(e,...i){this.getLevel()<=c.Info&&console.log("%c INFO","color: #33f",e,...i)}warn(e,...i){this.getLevel()<=c.Warning&&console.log("%c WARN","color: #993",e,...i)}error(e,...i){this.getLevel()<=c.Error&&console.log("%c  ERR","color: #f33",e,...i)}critical(e,...i){this.getLevel()<=c.Critical&&console.log("%cCRITI","background: #f33; color: white",e,...i)}dispose(){}flush(){}}t.ConsoleLogger=y;class O extends f{constructor(e,i=t.DEFAULT_LOG_LEVEL){super();this.adapter=e,this.setLevel(i)}trace(e,...i){this.getLevel()<=c.Trace&&this.adapter.log(c.Trace,[this.extractMessage(e),...i])}debug(e,...i){this.getLevel()<=c.Debug&&this.adapter.log(c.Debug,[this.extractMessage(e),...i])}info(e,...i){this.getLevel()<=c.Info&&this.adapter.log(c.Info,[this.extractMessage(e),...i])}warn(e,...i){this.getLevel()<=c.Warning&&this.adapter.log(c.Warning,[this.extractMessage(e),...i])}error(e,...i){this.getLevel()<=c.Error&&this.adapter.log(c.Error,[this.extractMessage(e),...i])}critical(e,...i){this.getLevel()<=c.Critical&&this.adapter.log(c.Critical,[this.extractMessage(e),...i])}extractMessage(e){return typeof e=="string"?e:F.toErrorMessage(e,this.getLevel()<=c.Trace)}dispose(){}flush(){}}t.AdapterLogger=O;class u extends f{constructor(e){super();this.logServices=e,e.length&&this.setLevel(e[0].getLevel())}setLevel(e){for(const i of this.logServices)i.setLevel(e);super.setLevel(e)}trace(e,...i){for(const n of this.logServices)n.trace(e,...i)}debug(e,...i){for(const n of this.logServices)n.debug(e,...i)}info(e,...i){for(const n of this.logServices)n.info(e,...i)}warn(e,...i){for(const n of this.logServices)n.warn(e,...i)}error(e,...i){for(const n of this.logServices)n.error(e,...i)}critical(e,...i){for(const n of this.logServices)n.critical(e,...i)}flush(){for(const e of this.logServices)e.flush()}dispose(){for(const e of this.logServices)e.dispose()}}t.MultiplexLogService=u;class h extends A.Disposable{constructor(e){super();this.logger=e,this._register(e)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(e){this.logger.setLevel(e)}getLevel(){return this.logger.getLevel()}trace(e,...i){this.logger.trace(e,...i)}debug(e,...i){this.logger.debug(e,...i)}info(e,...i){this.logger.info(e,...i)}warn(e,...i){this.logger.warn(e,...i)}error(e,...i){this.logger.error(e,...i)}critical(e,...i){this.logger.critical(e,...i)}flush(){this.logger.flush()}}t.LogService=h;class b extends A.Disposable{constructor(e,i){super();this.logLevel=e,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(n=>{this.logLevel=n,this.logLevelChangeableLoggers.forEach(s=>s.setLevel(n))}))}createLogger(e,i){let n=this.loggers.get(e.toString());return n||(n=this.doCreateLogger(e,(i==null?void 0:i.always)?c.Trace:this.logLevel,i),this.loggers.set(e.toString(),n),(i==null?void 0:i.always)||this.logLevelChangeableLoggers.push(n)),n}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(e=>e.dispose()),this.loggers.clear(),super.dispose()}}t.AbstractLoggerService=b;class R{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(e){}getLevel(){return c.Info}trace(e,...i){}debug(e,...i){}info(e,...i){}warn(e,...i){}error(e,...i){}critical(e,...i){}dispose(){}flush(){}}t.NullLogService=R;function P(r){if(r.verbose)return c.Trace;if(typeof r.logLevel=="string"){const e=v(r.logLevel.toLowerCase());if(e!==void 0)return e}return t.DEFAULT_LOG_LEVEL}t.getLogLevel=P;function v(r){switch(r){case"trace":return c.Trace;case"debug":return c.Debug;case"info":return c.Info;case"warn":return c.Warning;case"error":return c.Error;case"critical":return c.Critical;case"off":return c.Off}}t.parseLogLevel=v;function o(r){switch(r){case c.Trace:return"trace";case c.Debug:return"debug";case c.Info:return"info";case c.Warning:return"warn";case c.Error:return"error";case c.Critical:return"critical";case c.Off:return"off"}}t.LogLevelToString=o}),define(J[101],Y([0,1,9,2,18,23,21,7,17,24,15,29,39,14,4,13]),function(_,t,g,A,I,L,F,D,c,f,C,w,y,O,u,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsDownloader=void 0;const b=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let R=class extends A.Disposable{constructor(v,o,r,e){super();this.fileService=o,this.extensionGalleryService=r,this.logService=e,this.extensionsDownloadDir=D.URI.file(v.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(v,o){await this.cleanUpPromise;const r=this.getName(v),e=c.joinPath(this.extensionsDownloadDir,r);if(!await this.fileService.exists(e)){const i=c.joinPath(this.extensionsDownloadDir,`.${w.generateUuid()}`);await this.fileService.exists(i)||await this.extensionGalleryService.download(v,i,o);try{await this.rename(i,e,Date.now()+2*60*1e3)}catch(n){try{await this.fileService.del(i)}catch(s){}if(n.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",v.identifier.id);else throw this.logService.info(`Rename failed because of ${h.getErrorMessage(n)}. Deleted the vsix from downloaded location`,i.path),n}}return e}async delete(v){}async rename(v,o,r){try{await g.Promises.rename(v.fsPath,o.fsPath)}catch(e){if(O.isWindows&&e&&e.code==="EPERM"&&Date.now()<r)return this.logService.info(`Failed renaming ${v} to ${o} with 'EPERM' error. Trying again...`),this.rename(v,o,r);throw e}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const v=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(v.children){const o=[],r=[];for(const n of v.children){const s=this.parse(n.name);s&&r.push([s,n])}const e=f.groupByExtension(r,([n])=>n),i=[];for(const n of e)n.sort((s,l)=>y.rcompare(s[0].version,l[0].version)),o.push(...n.slice(1).map(s=>s[1].resource)),i.push(n[0][1]);i.sort((n,s)=>n.mtime-s.mtime),o.push(...i.slice(0,Math.max(0,i.length-this.cache)).map(n=>n.resource)),await u.Promises.settled(o.map(n=>(this.logService.trace("Deleting vsix from cache",n.path),this.fileService.del(n))))}}catch(v){this.logService.error(v)}}getName(v){return this.cache?new f.ExtensionIdentifierWithVersion(v.identifier,v.version).key().toLowerCase():w.generateUuid()}parse(v){const o=b.exec(v);return o&&o[1]&&o[2]?new f.ExtensionIdentifierWithVersion({id:o[1]},o[2]):null}};R=ue([fe(0,F.INativeEnvironmentService),fe(1,I.IFileService),fe(2,L.IExtensionGalleryService),fe(3,C.ILogService)],R),t.ExtensionsDownloader=R}),define(J[102],Y([0,1,2,15,33,28,3,4,10,8,9,21]),function(_,t,g,A,I,L,F,D,c,f,C,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsLifecycle=void 0;let y=class extends g.Disposable{constructor(u,h){super();this.environmentService=u,this.logService=h,this.processesLimiter=new D.Limiter(5)}async postUninstall(u){const h=this.parseScript(u,"uninstall");return h&&(this.logService.info(u.identifier.id,u.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(h.script,"uninstall",h.args,!0,u).then(()=>this.logService.info(u.identifier.id,u.manifest.version,"Finished running post uninstall script"),b=>this.logService.error(u.identifier.id,u.manifest.version,`Failed to run post uninstall script: ${b}`)))),C.rimraf(this.getExtensionStoragePath(u)).then(void 0,b=>this.logService.error("Error while removing extension storage path",b))}parseScript(u,h){const b=`vscode:${h}`;if(u.location.scheme===f.Schemas.file&&u.manifest&&u.manifest.scripts&&typeof u.manifest.scripts[b]=="string"){const R=u.manifest.scripts[b].split(" ");return R.length<2||R[0]!=="node"||!R[1]?(this.logService.warn(u.identifier.id,u.manifest.version,`${b} should be a node script`),null):{script:F.join(u.location.fsPath,R[1]),args:R.slice(2)||[]}}return null}runLifecycleHook(u,h,b,R,P){return new Promise((v,o)=>{const r=this.start(u,h,b,P);let e;const i=n=>{e&&(clearTimeout(e),e=null),n?o(n):v(void 0)};r.on("error",n=>{i(L.toErrorMessage(n)||"Unknown")}),r.on("exit",(n,s)=>{i(n?`post-${h} process exited with code ${n}`:void 0)}),R&&(e=setTimeout(()=>{e=null,r.kill(),o("timed out")},5e3))})}start(u,h,b,R){const P={silent:!0,execArgv:void 0},v=I.fork(u,[`--type=extension-post-${h}`,...b],P);v.stdout.setEncoding("utf8"),v.stderr.setEncoding("utf8");const o=c.Event.fromNodeEventEmitter(v.stdout,"data"),r=c.Event.fromNodeEventEmitter(v.stderr,"data");o(n=>this.logService.info(R.identifier.id,R.manifest.version,`post-${h}`,n)),r(n=>this.logService.error(R.identifier.id,R.manifest.version,`post-${h}`,n));const e=c.Event.any(c.Event.map(o,n=>({data:`%c${n}`,format:[""]})),c.Event.map(r,n=>({data:`%c${n}`,format:["color: red"]})));return c.Event.debounce(e,(n,s)=>n?{data:n.data+s.data,format:[...n.format,...s.format]}:{data:s.data,format:s.format},100)(n=>{console.group(R.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),v}getExtensionStoragePath(u){return F.join(this.environmentService.globalStorageHome.fsPath,u.identifier.id.toLowerCase())}};y=ue([fe(0,w.IEnvironmentService),fe(1,A.ILogService)],y),t.ExtensionsLifecycle=y}),define(J[103],Y([0,1,2,21,10,18,7,24,17,15]),function(_,t,g,A,I,L,F,D,c,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsWatcher=void 0;let C=class extends g.Disposable{constructor(y,O,u,h){super();this.extensionsManagementService=y,this.logService=h,this._onDidChangeExtensionsByAnotherSource=this._register(new I.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(P=>{this.installedExtensions=P.map(v=>v.identifier),this.startTimestamp=Date.now()}),this._register(y.onInstallExtension(P=>this.onInstallExtension(P))),this._register(y.onDidInstallExtension(P=>this.onDidInstallExtension(P))),this._register(y.onDidUninstallExtension(P=>this.onDidUninstallExtension(P)));const b=F.URI.file(u.extensionsPath),R=new c.ExtUri(P=>!O.hasCapability(P,1024));this._register(O.watch(b)),this._register(I.Event.filter(O.onDidFilesChange,P=>P.changes.some(v=>this.doesChangeAffects(v,b,R)))(()=>this.onDidChange()))}doesChangeAffects(y,O,u){return u.isEqual(u.dirname(y.resource),O)?u.isEqual(y.resource,u.joinPath(O,".obsolete"))?!0:!(y.type!==1&&y.type!==2||u.basename(y.resource).startsWith(".")):!1}onInstallExtension(y){this.addInstallingExtension(y.identifier)}onDidInstallExtension(y){this.removeInstallingExtension(y.identifier),y.error||this.addInstalledExtension(y.identifier)}onDidUninstallExtension(y){y.error||this.removeInstalledExtension(y.identifier)}addInstallingExtension(y){this.removeInstallingExtension(y),this.installingExtensions.push(y)}removeInstallingExtension(y){this.installingExtensions=this.installingExtensions.filter(O=>!D.areSameExtensions(O,y))}addInstalledExtension(y){this.installedExtensions&&(this.removeInstalledExtension(y),this.installedExtensions.push(y))}removeInstalledExtension(y){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(O=>!D.areSameExtensions(O,y)))}async onDidChange(){if(this.installedExtensions){const y=await this.extensionsManagementService.getInstalled(1),O=y.filter(h=>[...this.installingExtensions,...this.installedExtensions].some(b=>D.areSameExtensions(b,h.identifier))?!1:h.installedTimestamp&&h.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",h.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",h.identifier.id),!1)),u=this.installedExtensions.filter(h=>this.installingExtensions.some(b=>D.areSameExtensions(b,h))?!1:y.every(b=>!D.areSameExtensions(b.identifier,h))?(this.logService.info("Detected extension removed from another source",h.id),!0):!1);this.installedExtensions=y.map(h=>h.identifier),(O.length||u.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:O,removed:u})}}};C=ue([fe(1,L.IFileService),fe(2,A.INativeEnvironmentService),fe(3,f.ILogService)],C),t.ExtensionsWatcher=C}),define(J[104],Y([0,1,9,127,23,2,21,4,24,15,53,22,10,8,3]),function(_,t,g,A,I,L,F,D,c,f,C,w,y,O,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LocalizationsService=void 0;let h=class extends L.Disposable{constructor(P,v,o){super();this.extensionManagementService=P,this.logService=o,this._onDidLanguagesChange=this._register(new y.Emitter),this.onDidLanguagesChange=this._onDidLanguagesChange.event,this.cache=this._register(new b(v,o)),this._register(P.onDidInstallExtension(({local:r})=>this.onDidInstallExtension(r))),this._register(P.onDidUninstallExtension(({identifier:r})=>this.onDidUninstallExtension(r)))}getLanguageIds(){return this.cache.getLanguagePacks().then(P=>{const v=["en",...Object.keys(P)];return w.distinct(v)})}onDidInstallExtension(P){P&&P.manifest&&P.manifest.contributes&&P.manifest.contributes.localizations&&P.manifest.contributes.localizations.length&&(this.logService.debug("Adding language packs from the extension",P.identifier.id),this.update().then(v=>{v&&this._onDidLanguagesChange.fire()}))}onDidUninstallExtension(P){this.cache.getLanguagePacks().then(v=>{Object.keys(v).some(o=>v[o]&&v[o].extensions.some(r=>c.areSameExtensions(r.extensionIdentifier,P)))&&(this.logService.debug("Removing language packs from the extension",P.id),this.update().then(o=>{o&&this._onDidLanguagesChange.fire()}))})}async update(){const[P,v]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),o=await this.cache.update(v);return!w.equals(Object.keys(P),Object.keys(o))}};h=ue([fe(0,I.IExtensionManagementService),fe(1,F.INativeEnvironmentService),fe(2,f.ILogService)],h),t.LocalizationsService=h;let b=class extends L.Disposable{constructor(P,v){super();this.logService=v,this.languagePacks={},this.languagePacksFilePath=u.join(P.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new D.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(P){return this.withLanguagePacks(v=>{Object.keys(v).forEach(o=>delete v[o]),this.createLanguagePacksFromExtensions(v,...P)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(P,...v){for(const o of v)o&&o.manifest&&o.manifest.contributes&&o.manifest.contributes.localizations&&o.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(P,o);Object.keys(P).forEach(o=>this.updateHash(P[o]))}createLanguagePacksFromExtension(P,v){const o=v.identifier,r=v.manifest.contributes&&v.manifest.contributes.localizations?v.manifest.contributes.localizations:[];for(const e of r)if(v.location.scheme===O.Schemas.file&&C.isValidLocalization(e)){let i=P[e.languageId];i||(i={hash:"",extensions:[],translations:{}},P[e.languageId]=i);let n=i.extensions.filter(s=>c.areSameExtensions(s.extensionIdentifier,o))[0];n?n.version=v.manifest.version:i.extensions.push({extensionIdentifier:o,version:v.manifest.version});for(const s of e.translations)i.translations[s.id]=u.join(v.location.fsPath,s.path)}}updateHash(P){if(P){const v=A.createHash("md5");for(const o of P.extensions)v.update(o.extensionIdentifier.uuid||o.extensionIdentifier.id).update(o.version);P.hash=v.digest("hex")}}withLanguagePacks(P=()=>null){return this.languagePacksFileLimiter.queue(()=>{let v=null;return g.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,o=>o.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(o)).then(o=>{try{return JSON.parse(o)}catch(r){return{}}}).then(o=>(v=P(o),o)).then(o=>{for(const e of Object.keys(o))o[e]||delete o[e];this.languagePacks=o,this.initializedCache=!0;const r=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",r),g.writeFile(this.languagePacksFilePath,r)}).then(()=>v,o=>this.logService.error(o))})}};b=ue([fe(0,F.INativeEnvironmentService),fe(1,f.ILogService)],b)}),define(J[105],Y([0,1,15,18]),function(_,t,g,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SpdLogLogger=t.createRotatingLogger=void 0;async function I(c,f,C,w){try{const y=await new Promise((O,u)=>{_(["spdlog"],O,u)});return y.setFlushOn(g.LogLevel.Trace),y.createAsyncRotatingLogger(c,f,C,w)}catch(y){console.error(y)}return null}function L(c,f,C,w){const y=_.__$__nodeRequire("spdlog");return y.setFlushOn(g.LogLevel.Trace),y.createRotatingLogger(c,f,C,w)}t.createRotatingLogger=L;function F(c,f,C){switch(f){case g.LogLevel.Trace:c.trace(C);break;case g.LogLevel.Debug:c.debug(C);break;case g.LogLevel.Info:c.info(C);break;case g.LogLevel.Warning:c.warn(C);break;case g.LogLevel.Error:c.error(C);break;case g.LogLevel.Critical:c.critical(C);break;default:throw new Error("Invalid log level")}}class D extends g.AbstractMessageLogger{constructor(f,C,w,y){super();this.name=f,this.filepath=C,this.rotating=w,this.buffer=[],this.setLevel(y),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(O=>{this._logger&&this._logger.setLevel(O)}))}_createSpdLogLogger(){const f=this.rotating?6:1,C=30/f*A.ByteSize.MB;return I(this.name,this.filepath,C,f).then(w=>{if(w){this._logger=w,this._logger.setLevel(this.getLevel());for(const{level:y,message:O}of this.buffer)F(this._logger,y,O);this.buffer=[]}})}log(f,C){this._logger?F(this._logger,f,C):this.getLevel()<=f&&this.buffer.push({level:f,message:C})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}t.SpdLogLogger=D}),define(J[54],Y([0,1,81,16,18,13,40]),function(_,t,g,A,I,L,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.readFileIntoStream=void 0;async function D(w,y,O,u,h,b){let R;try{await c(w,y,O,u,h,b)}catch(P){R=P}finally{R&&h.errorTransformer&&(R=h.errorTransformer(R)),typeof R!="undefined"&&O.error(R),O.end()}}t.readFileIntoStream=D;async function c(w,y,O,u,h,b){f(b);const R=await w.open(y,{create:!1});try{f(b);let P=0,v=0,o=h&&typeof h.length=="number"?h.length:void 0,r=A.VSBuffer.alloc(Math.min(h.bufferSize,typeof o=="number"?o:h.bufferSize)),e=h&&typeof h.position=="number"?h.position:0,i=0;do v=await w.read(R,e,r.buffer,i,r.byteLength-i),e+=v,i+=v,P+=v,typeof o=="number"&&(o-=v),i===r.byteLength&&(await O.write(u(r)),r=A.VSBuffer.alloc(Math.min(h.bufferSize,typeof o=="number"?o:h.bufferSize)),i=0);while(v>0&&(typeof o!="number"||o>0)&&f(b)&&C(P,h));if(i>0){let n=i;typeof o=="number"&&(n=Math.min(i,o)),O.write(u(r.slice(0,n)))}}catch(P){throw I.ensureFileSystemProviderError(P)}finally{await w.close(R)}}function f(w){if(w.isCancellationRequested)throw L.canceled();return!0}function C(w,y){if(y==null?void 0:y.limits){if(typeof y.limits.memory=="number"&&w>y.limits.memory)throw I.createFileSystemProviderError(g.localize(0,null,F.default.nameShort),I.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof y.limits.size=="number"&&w>y.limits.size)throw I.createFileSystemProviderError(g.localize(1,null),I.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(J[106],Y([0,1,80,128,2,18,10,17,45,22,15,16,35,4,27,8,54,129]),function(_,t,g,A,I,L,F,D,c,f,C,w,y,O,u,h,b,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileService=void 0;let P=class extends I.Disposable{constructor(o){super();this.logService=o,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new F.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new F.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new F.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new F.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new F.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new F.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this.activeWatchers=new Map,this.writeQueue=this._register(new O.ResourceQueue)}registerProvider(o,r){if(this.provider.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);A.mark(`code/registerFilesystem/${o}`),this.provider.set(o,r),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:o,provider:r});const e=new I.DisposableStore;return e.add(r.onDidChangeFile(i=>this._onDidFilesChange.fire(new L.FileChangesEvent(i,!this.isPathCaseSensitive(r))))),e.add(r.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:r,scheme:o}))),typeof r.onDidErrorOccur=="function"&&e.add(r.onDidErrorOccur(i=>this._onError.fire(new Error(i)))),I.toDisposable(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:o,provider:r}),this.provider.delete(o),I.dispose(e)})}getProvider(o){return this.provider.get(o)}async activateProvider(o){const r=[];this._onWillActivateFileSystemProvider.fire({scheme:o,join(e){r.push(e)}}),!this.provider.has(o)&&await O.Promises.settled(r)}canHandleResource(o){return this.provider.has(o.scheme)}hasCapability(o,r){const e=this.provider.get(o.scheme);return!!(e&&e.capabilities&r)}listCapabilities(){return R.Iterable.map(this.provider,([o,r])=>({scheme:o,capabilities:r.capabilities}))}async withProvider(o){if(!D.isAbsolutePath(o))throw new L.FileOperationError(g.localize(0,null,this.resourceForError(o)),8);await this.activateProvider(o.scheme);const r=this.provider.get(o.scheme);if(!r){const e=new Error;throw e.name="ENOPRO",e.message=g.localize(1,null,o.toString()),e}return r}async withReadProvider(o){const r=await this.withProvider(o);if(L.hasOpenReadWriteCloseCapability(r)||L.hasReadWriteCapability(r)||L.hasFileReadStreamCapability(r))return r;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(o){const r=await this.withProvider(o);if(L.hasOpenReadWriteCloseCapability(r)||L.hasReadWriteCapability(r))return r;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,r){try{return await this.doResolveFile(o,r)}catch(e){throw L.toFileSystemProviderErrorCode(e)===L.FileSystemProviderErrorCode.FileNotFound?new L.FileOperationError(g.localize(2,null,this.resourceForError(o)),1):L.ensureFileSystemProviderError(e)}}async doResolveFile(o,r){const e=await this.withProvider(o),i=this.isPathCaseSensitive(e),n=r==null?void 0:r.resolveTo,s=r==null?void 0:r.resolveSingleChildDescendants,l=r==null?void 0:r.resolveMetadata,E=await e.stat(o);let S;return this.toFileStat(e,o,E,void 0,!!l,(U,k)=>(S||(S=c.TernarySearchTree.forUris(()=>!i),S.set(o,!0),f.isNonEmptyArray(n)&&n.forEach(j=>S.set(j,!0))),Boolean(S.findSuperstr(U.resource)||S.get(U.resource))?!0:U.isDirectory&&s?k===1:!1))}async toFileStat(o,r,e,i,n,s){var l;const{providerExtUri:E}=this.getExtUri(o),S={resource:r,name:E.basename(r),isFile:(e.type&L.FileType.File)!=0,isDirectory:(e.type&L.FileType.Directory)!=0,isSymbolicLink:(e.type&L.FileType.SymbolicLink)!=0,mtime:e.mtime,ctime:e.ctime,size:e.size,readonly:Boolean(((l=e.permissions)!==null&&l!==void 0?l:0)&L.FilePermission.Readonly)||Boolean(o.capabilities&2048),etag:L.etag({mtime:e.mtime,size:e.size})};if(S.isDirectory&&s(S,i)){try{const U=await o.readdir(r),k=await O.Promises.settled(U.map(async([j,V])=>{try{const $=E.joinPath(r,j),K=n?await o.stat($):{type:V};return await this.toFileStat(o,$,K,U.length,n,s)}catch($){return this.logService.trace($),null}}));S.children=f.coalesce(k)}catch(U){this.logService.trace(U),S.children=[]}return S}return S}async resolveAll(o){return O.Promises.settled(o.map(async r=>{try{return{stat:await this.doResolveFile(r.resource,r.options),success:!0}}catch(e){return this.logService.trace(e),{stat:void 0,success:!1}}}))}async exists(o){const r=await this.withProvider(o);try{return!!await r.stat(o)}catch(e){return!1}}async canCreateFile(o,r){try{await this.doValidateCreateFile(o,r)}catch(e){return e}return!0}async doValidateCreateFile(o,r){if(!(r==null?void 0:r.overwrite)&&await this.exists(o))throw new L.FileOperationError(g.localize(3,null,this.resourceForError(o)),3,r)}async createFile(o,r=w.VSBuffer.fromString(""),e){await this.doValidateCreateFile(o,e);const i=await this.writeFile(o,r);return this._onDidRunOperation.fire(new L.FileOperationEvent(o,0,i)),i}async writeFile(o,r,e){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),{providerExtUri:n}=this.getExtUri(i);try{await this.validateWriteFile(i,o,e)||await this.mkdirp(i,n.dirname(o));let l;if(L.hasReadWriteCapability(i)&&!(r instanceof w.VSBuffer))if(y.isReadableStream(r)){const E=await y.peekStream(r,3);E.ended?l=w.VSBuffer.concat(E.buffer):l=E}else l=y.peekReadable(r,E=>w.VSBuffer.concat(E),3);else l=r;!L.hasOpenReadWriteCloseCapability(i)||L.hasReadWriteCapability(i)&&l instanceof w.VSBuffer?await this.doWriteUnbuffered(i,o,e,l):await this.doWriteBuffered(i,o,e,l instanceof w.VSBuffer?w.bufferToReadable(l):l)}catch(s){throw new L.FileOperationError(g.localize(4,null,this.resourceForError(o),L.ensureFileSystemProviderError(s).toString()),L.toFileOperationResult(s),e)}return this.resolve(o,{resolveMetadata:!0})}async validateWriteFile(o,r,e){if(!!(e==null?void 0:e.unlock)&&!(o.capabilities&8192))throw new Error(g.localize(5,null,this.resourceForError(r)));let n;try{n=await o.stat(r)}catch(s){return}if((n.type&L.FileType.Directory)!=0)throw new L.FileOperationError(g.localize(6,null,this.resourceForError(r)),0,e);if(this.throwIfFileIsReadonly(r,n),e&&typeof e.mtime=="number"&&typeof e.etag=="string"&&e.etag!==L.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&e.mtime<n.mtime&&e.etag!==L.etag({mtime:e.mtime,size:n.size}))throw new L.FileOperationError(g.localize(7,null),3,e);return n}async readFile(o,r){const e=await this.withReadProvider(o);return(r==null?void 0:r.atomic)?this.doReadFileAtomic(e,o,r):this.doReadFile(e,o,r)}async doReadFileAtomic(o,r,e){return new Promise((i,n)=>{this.writeQueue.queueFor(r,this.getExtUri(o).providerExtUri).queue(async()=>{try{const s=await this.doReadFile(o,r,e);i(s)}catch(s){n(s)}})})}async doReadFile(o,r,e){const i=await this.doReadFileStream(o,r,Object.assign(Object.assign({},e),{preferUnbuffered:!0}));return Object.assign(Object.assign({},i),{value:await w.streamToBuffer(i.value)})}async readFileStream(o,r){const e=await this.withReadProvider(o);return this.doReadFileStream(e,o,r)}async doReadFileStream(o,r,e){const i=new u.CancellationTokenSource,n=this.validateReadFile(r,e).then(l=>l,l=>{throw i.cancel(),l});let s;try{e&&typeof e.etag=="string"&&e.etag!==L.ETAG_DISABLED&&await n,!(L.hasOpenReadWriteCloseCapability(o)||L.hasFileReadStreamCapability(o))||L.hasReadWriteCapability(o)&&(e==null?void 0:e.preferUnbuffered)?s=this.readFileUnbuffered(o,r,e):L.hasFileReadStreamCapability(o)?s=this.readFileStreamed(o,r,i.token,e):s=this.readFileBuffered(o,r,i.token,e);const l=await n;return Object.assign(Object.assign({},l),{value:s})}catch(l){s&&await y.consumeStream(s);const E=g.localize(8,null,this.resourceForError(r),L.ensureFileSystemProviderError(l).toString());throw l instanceof L.NotModifiedSinceFileOperationError?new L.NotModifiedSinceFileOperationError(E,l.stat,e):new L.FileOperationError(E,L.toFileOperationResult(l),e)}}readFileStreamed(o,r,e,i=Object.create(null)){const n=o.readFileStream(r,i,e);return y.transform(n,{data:s=>s instanceof w.VSBuffer?s:w.VSBuffer.wrap(s),error:s=>new L.FileOperationError(g.localize(9,null,this.resourceForError(r),L.ensureFileSystemProviderError(s).toString()),L.toFileOperationResult(s),i)},s=>w.VSBuffer.concat(s))}readFileBuffered(o,r,e,i=Object.create(null)){const n=w.newWriteableBufferStream();return b.readFileIntoStream(o,r,n,s=>s,Object.assign(Object.assign({},i),{bufferSize:this.BUFFER_SIZE,errorTransformer:s=>new L.FileOperationError(g.localize(10,null,this.resourceForError(r),L.ensureFileSystemProviderError(s).toString()),L.toFileOperationResult(s),i)}),e),n}readFileUnbuffered(o,r,e){const i=y.newWriteableStream(n=>w.VSBuffer.concat(n));return(async()=>{try{let n=await o.readFile(r);e&&typeof e.position=="number"&&(n=n.slice(e.position)),e&&typeof e.length=="number"&&(n=n.slice(0,e.length)),this.validateReadFileLimits(r,n.byteLength,e),i.end(w.VSBuffer.wrap(n))}catch(n){i.error(n),i.end()}})(),i}async validateReadFile(o,r){const e=await this.resolve(o,{resolveMetadata:!0});if(e.isDirectory)throw new L.FileOperationError(g.localize(11,null,this.resourceForError(o)),0,r);if(r&&typeof r.etag=="string"&&r.etag!==L.ETAG_DISABLED&&r.etag===e.etag)throw new L.NotModifiedSinceFileOperationError(g.localize(12,null),e,r);return this.validateReadFileLimits(o,e.size,r),e}validateReadFileLimits(o,r,e){if(e==null?void 0:e.limits){let i;if(typeof e.limits.memory=="number"&&r>e.limits.memory&&(i=9),typeof e.limits.size=="number"&&r>e.limits.size&&(i=7),typeof i=="number")throw new L.FileOperationError(g.localize(13,null,this.resourceForError(o)),i)}}async canMove(o,r,e){return this.doCanMoveCopy(o,r,"move",e)}async canCopy(o,r,e){return this.doCanMoveCopy(o,r,"copy",e)}async doCanMoveCopy(o,r,e,i){if(o.toString()!==r.toString())try{const n=e==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o):await this.withReadProvider(o),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r);await this.doValidateMoveCopy(n,o,s,r,e,i)}catch(n){return n}return!0}async move(o,r,e){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),s=await this.doMoveCopy(i,o,n,r,"move",!!e),l=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new L.FileOperationEvent(o,s==="move"?2:3,l)),l}async copy(o,r,e){const i=await this.withReadProvider(o),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),s=await this.doMoveCopy(i,o,n,r,"copy",!!e),l=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new L.FileOperationEvent(o,s==="copy"?3:2,l)),l}async doMoveCopy(o,r,e,i,n,s){if(r.toString()===i.toString())return n;const{exists:l,isSameResourceWithDifferentPathCase:E}=await this.doValidateMoveCopy(o,r,e,i,n,s);if(l&&!E&&s&&await this.del(i,{recursive:!0}),await this.mkdirp(e,this.getExtUri(e).providerExtUri.dirname(i)),n==="copy"){if(o===e&&L.hasFileFolderCopyCapability(o))await o.copy(r,i,{overwrite:s});else{const S=await this.resolve(r);S.isDirectory?await this.doCopyFolder(o,S,e,i):await this.doCopyFile(o,r,e,i)}return n}else return o===e?(await o.rename(r,i,{overwrite:s}),n):(await this.doMoveCopy(o,r,e,i,"copy",s),await this.del(r,{recursive:!0}),"copy")}async doCopyFile(o,r,e,i){if(L.hasOpenReadWriteCloseCapability(o)&&L.hasOpenReadWriteCloseCapability(e))return this.doPipeBuffered(o,r,e,i);if(L.hasOpenReadWriteCloseCapability(o)&&L.hasReadWriteCapability(e))return this.doPipeBufferedToUnbuffered(o,r,e,i);if(L.hasReadWriteCapability(o)&&L.hasOpenReadWriteCloseCapability(e))return this.doPipeUnbufferedToBuffered(o,r,e,i);if(L.hasReadWriteCapability(o)&&L.hasReadWriteCapability(e))return this.doPipeUnbuffered(o,r,e,i)}async doCopyFolder(o,r,e,i){await e.mkdir(i),Array.isArray(r.children)&&await O.Promises.settled(r.children.map(async n=>{const s=this.getExtUri(e).providerExtUri.joinPath(i,n.name);return n.isDirectory?this.doCopyFolder(o,await this.resolve(n.resource),e,s):this.doCopyFile(o,n.resource,e,s)}))}async doValidateMoveCopy(o,r,e,i,n,s){let l=!1;if(o===e){const{providerExtUri:S,isPathCaseSensitive:U}=this.getExtUri(o);if(U||(l=S.isEqual(r,i)),l&&n==="copy")throw new Error(g.localize(14,null,this.resourceForError(r),this.resourceForError(i)));if(!l&&S.isEqualOrParent(i,r))throw new Error(g.localize(15,null,this.resourceForError(r),this.resourceForError(i)))}const E=await this.exists(i);if(E&&!l){if(!s)throw new L.FileOperationError(g.localize(16,null,this.resourceForError(r),this.resourceForError(i)),4);if(o===e){const{providerExtUri:S}=this.getExtUri(o);if(S.isEqualOrParent(r,i))throw new Error(g.localize(17,null,this.resourceForError(r),this.resourceForError(i)))}}return{exists:E,isSameResourceWithDifferentPathCase:l}}getExtUri(o){const r=this.isPathCaseSensitive(o);return{providerExtUri:r?D.extUri:D.extUriIgnorePathCase,isPathCaseSensitive:r}}isPathCaseSensitive(o){return!!(o.capabilities&1024)}async createFolder(o){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);await this.mkdirp(r,o);const e=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new L.FileOperationEvent(o,0,e)),e}async mkdirp(o,r){const e=[],{providerExtUri:i}=this.getExtUri(o);for(;!i.isEqual(r,i.dirname(r));)try{if(((await o.stat(r)).type&L.FileType.Directory)==0)throw new Error(g.localize(18,null,this.resourceForError(r)));break}catch(n){if(L.toFileSystemProviderErrorCode(n)!==L.FileSystemProviderErrorCode.FileNotFound)throw n;e.push(i.basename(r)),r=i.dirname(r)}for(let n=e.length-1;n>=0;n--){r=i.joinPath(r,e[n]);try{await o.mkdir(r)}catch(s){if(L.toFileSystemProviderErrorCode(s)!==L.FileSystemProviderErrorCode.FileExists)throw s}}}async canDelete(o,r){try{await this.doValidateDelete(o,r)}catch(e){return e}return!0}async doValidateDelete(o,r){const e=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);if(!!(r==null?void 0:r.useTrash)&&!(e.capabilities&4096))throw new Error(g.localize(19,null,this.resourceForError(o)));let n;try{n=await e.stat(o)}catch(l){}if(n)this.throwIfFileIsReadonly(o,n);else throw new L.FileOperationError(g.localize(20,null,this.resourceForError(o)),1);if(!!!(r==null?void 0:r.recursive)){const l=await this.resolve(o);if(l.isDirectory&&Array.isArray(l.children)&&l.children.length>0)throw new Error(g.localize(21,null,this.resourceForError(o)))}return e}async del(o,r){const e=await this.doValidateDelete(o,r),i=!!(r==null?void 0:r.useTrash),n=!!(r==null?void 0:r.recursive);await e.delete(o,{recursive:n,useTrash:i}),this._onDidRunOperation.fire(new L.FileOperationEvent(o,1))}watch(o,r={recursive:!1,excludes:[]}){let e=!1,i=()=>{e=!0};return this.doWatch(o,r).then(n=>{e?I.dispose(n):i=()=>I.dispose(n)},n=>this.logService.error(n)),I.toDisposable(()=>i())}async doWatch(o,r){const e=await this.withProvider(o),i=this.toWatchKey(e,o,r),n=this.activeWatchers.get(i)||{count:0,disposable:e.watch(o,r)};return this.activeWatchers.has(i)||this.activeWatchers.set(i,n),n.count+=1,I.toDisposable(()=>{n.count--,n.count===0&&(I.dispose(n.disposable),this.activeWatchers.delete(i))})}toWatchKey(o,r,e){const{providerExtUri:i}=this.getExtUri(o);return[i.getComparisonKey(r),String(e.recursive),e.excludes.join()].join()}dispose(){super.dispose(),this.activeWatchers.forEach(o=>I.dispose(o.disposable)),this.activeWatchers.clear()}async doWriteBuffered(o,r,e,i){return this.writeQueue.queueFor(r,this.getExtUri(o).providerExtUri).queue(async()=>{var n;const s=await o.open(r,{create:!0,unlock:(n=e==null?void 0:e.unlock)!==null&&n!==void 0?n:!1});try{y.isReadableStream(i)||y.isReadableBufferedStream(i)?await this.doWriteStreamBufferedQueued(o,s,i):await this.doWriteReadableBufferedQueued(o,s,i)}catch(l){throw L.ensureFileSystemProviderError(l)}finally{await o.close(s)}})}async doWriteStreamBufferedQueued(o,r,e){let i=0,n;if(y.isReadableBufferedStream(e)){if(e.buffer.length>0){const s=w.VSBuffer.concat(e.buffer);await this.doWriteBuffer(o,r,s,s.byteLength,i,0),i+=s.byteLength}if(e.ended)return;n=e.stream}else n=e;return new Promise(async(s,l)=>{y.listenStream(n,{onData:async E=>{n.pause();try{await this.doWriteBuffer(o,r,E,E.byteLength,i,0)}catch(S){return l(S)}i+=E.byteLength,setTimeout(()=>n.resume())},onError:E=>l(E),onEnd:()=>s()})})}async doWriteReadableBufferedQueued(o,r,e){let i=0,n;for(;(n=e.read())!==null;)await this.doWriteBuffer(o,r,n,n.byteLength,i,0),i+=n.byteLength}async doWriteBuffer(o,r,e,i,n,s){let l=0;for(;l<i;)l+=await o.write(r,n+l,e.buffer,s+l,i-l)}async doWriteUnbuffered(o,r,e,i){return this.writeQueue.queueFor(r,this.getExtUri(o).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(o,r,e,i))}async doWriteUnbufferedQueued(o,r,e,i){var n;let s;i instanceof w.VSBuffer?s=i:y.isReadableStream(i)?s=await w.streamToBuffer(i):y.isReadableBufferedStream(i)?s=await w.bufferedStreamToBuffer(i):s=w.readableToBuffer(i),await o.writeFile(r,s.buffer,{create:!0,overwrite:!0,unlock:(n=e==null?void 0:e.unlock)!==null&&n!==void 0?n:!1})}async doPipeBuffered(o,r,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeBufferedQueued(o,r,e,i))}async doPipeBufferedQueued(o,r,e,i){let n,s;try{n=await o.open(r,{create:!1}),s=await e.open(i,{create:!0,unlock:!1});const l=w.VSBuffer.alloc(this.BUFFER_SIZE);let E=0,S=0,U=0;do U=await o.read(n,E,l.buffer,S,l.byteLength-S),await this.doWriteBuffer(e,s,l,U,E,S),E+=U,S+=U,S===l.byteLength&&(S=0);while(U>0)}catch(l){throw L.ensureFileSystemProviderError(l)}finally{await O.Promises.settled([typeof n=="number"?o.close(n):Promise.resolve(),typeof s=="number"?e.close(s):Promise.resolve()])}}async doPipeUnbuffered(o,r,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(o,r,e,i))}async doPipeUnbufferedQueued(o,r,e,i){return e.writeFile(i,await o.readFile(r),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(o,r,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(o,r,e,i))}async doPipeUnbufferedToBufferedQueued(o,r,e,i){const n=await e.open(i,{create:!0,unlock:!1});try{const s=await o.readFile(r);await this.doWriteBuffer(e,n,w.VSBuffer.wrap(s),s.byteLength,0,0)}catch(s){throw L.ensureFileSystemProviderError(s)}finally{await e.close(n)}}async doPipeBufferedToUnbuffered(o,r,e,i){const n=await w.streamToBuffer(this.readFileBuffered(o,r,u.CancellationToken.None));await this.doWriteUnbuffered(e,i,void 0,n)}throwIfFileSystemIsReadonly(o,r){if(o.capabilities&2048)throw new L.FileOperationError(g.localize(22,null,this.resourceForError(r)),6);return o}throwIfFileIsReadonly(o,r){var e;if(((e=r.permissions)!==null&&e!==void 0?e:0)&L.FilePermission.Readonly)throw new L.FileOperationError(g.localize(23,null,this.resourceForError(o)),6)}resourceForError(o){return o.scheme===h.Schemas.file?o.fsPath:o.toString(!0)}};P=ue([fe(0,C.ILogService)],P),t.FileService=P}),define(J[107],Y([0,1,2,18,10,14,9,3,17,36,4,15,82,51,91,93,90,99,35,54,22,16]),function(_,t,g,A,I,L,F,D,c,f,C,w,y,O,u,h,b,R,P,v,o,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiskFileSystemProvider=void 0;class e extends g.Disposable{constructor(n,s){var l;super();this.logService=n,this.options=s,this.BUFFER_SIZE=((l=this.options)===null||l===void 0?void 0:l.bufferSize)||64*1024,this.onDidChangeCapabilities=I.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new I.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new I.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new C.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,L.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(n){try{const{stat:s,symbolicLink:l}=await F.SymlinkSupport.stat(this.toFilePath(n));return{type:this.toType(s,l),ctime:s.birthtime.getTime(),mtime:s.mtime.getTime(),size:s.size}}catch(s){throw this.toFileSystemProviderError(s)}}async readdir(n){try{const s=await F.readdir(this.toFilePath(n),{withFileTypes:!0}),l=[];return await Promise.all(s.map(async E=>{try{let S;E.isSymbolicLink()?S=(await this.stat(c.joinPath(n,E.name))).type:S=this.toType(E),l.push([E.name,S])}catch(S){this.logService.trace(S)}})),l}catch(s){throw this.toFileSystemProviderError(s)}}toType(n,s){let l;return(s==null?void 0:s.dangling)?l=A.FileType.Unknown:n.isFile()?l=A.FileType.File:n.isDirectory()?l=A.FileType.Directory:l=A.FileType.Unknown,s&&(l|=A.FileType.SymbolicLink),l}async readFile(n){try{const s=this.toFilePath(n);return await F.Promises.readFile(s)}catch(s){throw this.toFileSystemProviderError(s)}}readFileStream(n,s,l){const E=P.newWriteableStream(S=>r.VSBuffer.concat(S.map(U=>r.VSBuffer.wrap(U))).buffer);return v.readFileIntoStream(this,n,E,S=>S.buffer,Object.assign(Object.assign({},s),{bufferSize:this.BUFFER_SIZE}),l),E}async writeFile(n,s,l){let E;try{const S=this.toFilePath(n);if(!l.create||!l.overwrite){if(await F.exists(S)){if(!l.overwrite)throw A.createFileSystemProviderError(y.localize(0,null),A.FileSystemProviderErrorCode.FileExists)}else if(!l.create)throw A.createFileSystemProviderError(y.localize(1,null),A.FileSystemProviderErrorCode.FileNotFound)}E=await this.open(n,{create:!0,unlock:l.unlock}),await this.write(E,0,s,0,s.byteLength)}catch(S){throw await this.toFileSystemProviderWriteError(n,S)}finally{typeof E=="number"&&await this.close(E)}}async open(n,s){try{const l=this.toFilePath(n);if(A.isFileOpenForWriteOptions(s)&&s.unlock)try{const{stat:U}=await F.SymlinkSupport.stat(l);U.mode&128||await F.Promises.chmod(l,U.mode|128)}catch(U){this.logService.trace(U)}let E;if(A.isFileOpenForWriteOptions(s)){if(L.isWindows)try{await F.Promises.truncate(l,0),E="r+"}catch(U){U.code!=="ENOENT"&&this.logService.trace(U)}E||(E="w")}else E="r";const S=await F.Promises.open(l,E);return this.mapHandleToPos.set(S,0),A.isFileOpenForWriteOptions(s)&&this.writeHandles.set(S,n),S}catch(l){throw A.isFileOpenForWriteOptions(s)?await this.toFileSystemProviderWriteError(n,l):this.toFileSystemProviderError(l)}}async close(n){try{if(this.mapHandleToPos.delete(n),this.writeHandles.delete(n)&&this.canFlush)try{await F.Promises.fdatasync(n)}catch(s){this.canFlush=!1,this.logService.error(s)}return await F.Promises.close(n)}catch(s){throw this.toFileSystemProviderError(s)}}async read(n,s,l,E,S){const U=this.normalizePos(n,s);let k=null;try{const j=await F.Promises.read(n,l,E,S,U);return typeof j=="number"?k=j:k=j.bytesRead,k}catch(j){throw this.toFileSystemProviderError(j)}finally{this.updatePos(n,U,k)}}normalizePos(n,s){return s===this.mapHandleToPos.get(n)?null:s}updatePos(n,s,l){const E=this.mapHandleToPos.get(n);typeof E=="number"&&(typeof s=="number"||(typeof l=="number"?this.mapHandleToPos.set(n,E+l):this.mapHandleToPos.delete(n)))}async write(n,s,l,E,S){return C.retry(()=>this.doWrite(n,s,l,E,S),100,3)}async doWrite(n,s,l,E,S){const U=this.normalizePos(n,s);let k=null;try{const j=await F.Promises.write(n,l,E,S,U);return typeof j=="number"?k=j:k=j.bytesWritten,k}catch(j){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(n),j)}finally{this.updatePos(n,U,k)}}async mkdir(n){try{await F.Promises.mkdir(this.toFilePath(n))}catch(s){throw this.toFileSystemProviderError(s)}}async delete(n,s){try{const l=this.toFilePath(n);await this.doDelete(l,s)}catch(l){throw this.toFileSystemProviderError(l)}}async doDelete(n,s){s.recursive?await F.rimraf(n,F.RimRafMode.MOVE):await F.Promises.unlink(n)}async rename(n,s,l){const E=this.toFilePath(n),S=this.toFilePath(s);if(E!==S)try{await this.validateTargetDeleted(n,s,"move",l.overwrite),await F.move(E,S)}catch(U){throw(U.code==="EINVAL"||U.code==="EBUSY"||U.code==="ENAMETOOLONG")&&(U=new Error(y.localize(2,null,D.basename(E),D.basename(D.dirname(S)),U.toString()))),this.toFileSystemProviderError(U)}}async copy(n,s,l){const E=this.toFilePath(n),S=this.toFilePath(s);if(E!==S)try{await this.validateTargetDeleted(n,s,"copy",l.overwrite),await F.copy(E,S,{preserveSymlinks:!0})}catch(U){throw(U.code==="EINVAL"||U.code==="EBUSY"||U.code==="ENAMETOOLONG")&&(U=new Error(y.localize(3,null,D.basename(E),D.basename(D.dirname(S)),U.toString()))),this.toFileSystemProviderError(U)}}async validateTargetDeleted(n,s,l,E){const S=this.toFilePath(n),U=this.toFilePath(s);let k=!1;if(!!(this.capabilities&1024)||(k=f.isEqual(S,U,!0)),k&&l==="copy")throw A.createFileSystemProviderError(y.localize(4,null),A.FileSystemProviderErrorCode.FileExists);if(!k&&await F.exists(U)){if(!E)throw A.createFileSystemProviderError(y.localize(5,null),A.FileSystemProviderErrorCode.FileExists);await this.delete(s,{recursive:!0,useTrash:!1})}}watch(n,s){return s.recursive?this.watchRecursive(n,s.excludes):this.watchNonRecursive(n)}watchRecursive(n,s){const l={path:this.toFilePath(n),excludes:s},E=o.insert(this.recursiveFoldersToWatch,l);return this.refreshRecursiveWatchers(),g.toDisposable(()=>{E(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){var n,s,l;if(this.recursiveWatcher instanceof b.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if(g.dispose(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let E,S;((s=(n=this.options)===null||n===void 0?void 0:n.watcher)===null||s===void 0?void 0:s.usePolling)?(E=u.FileWatcher,S=(l=this.options)===null||l===void 0?void 0:l.watcher):this.recursiveFoldersToWatch.length===1?L.isWindows?E=h.FileWatcher:E=u.FileWatcher:E=b.FileWatcher,this.recursiveWatcher=new E(this.recursiveFoldersToWatch,U=>this._onDidChangeFile.fire(O.toFileChanges(U)),U=>{U.type==="error"&&this._onDidWatchErrorOccur.fire(U.message),this.logService[U.type](U.message)},this.logService.getLevel()===w.LogLevel.Trace,S),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===w.LogLevel.Trace)}))}}watchNonRecursive(n){const s=new R.FileWatcher(this.toFilePath(n),E=>this._onDidChangeFile.fire(O.toFileChanges(E)),E=>{E.type==="error"&&this._onDidWatchErrorOccur.fire(E.message),this.logService[E.type](E.message)},this.logService.getLevel()===w.LogLevel.Trace),l=this.logService.onDidChangeLogLevel(()=>{s.setVerboseLogging(this.logService.getLevel()===w.LogLevel.Trace)});return g.combinedDisposable(s,l)}toFilePath(n){return D.normalize(n.fsPath)}toFileSystemProviderError(n){if(n instanceof A.FileSystemProviderError)return n;let s;switch(n.code){case"ENOENT":s=A.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=A.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=A.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=A.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=A.FileSystemProviderErrorCode.NoPermissions;break;default:s=A.FileSystemProviderErrorCode.Unknown}return A.createFileSystemProviderError(n,s)}async toFileSystemProviderWriteError(n,s){let l=this.toFileSystemProviderError(s);if(n&&l.code===A.FileSystemProviderErrorCode.NoPermissions)try{const{stat:E}=await F.SymlinkSupport.stat(this.toFilePath(n));E.mode&128||(l=A.createFileSystemProviderError(s,A.FileSystemProviderErrorCode.FileWriteLocked))}catch(E){this.logService.trace(E)}return l}dispose(){super.dispose(),g.dispose(this.recursiveWatcher),this.recursiveWatcher=void 0,g.dispose(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}t.DiskFileSystemProvider=e}),define(J[41],Y([0,1,11]),function(_,t,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IProductService=void 0,t.IProductService=g.createDecorator("productService")}),define(J[25],Y([0,1,12,57]),function(_,t,g,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0;class I{constructor(){this.data=new Map}add(F,D){A.ok(g.isString(F)),A.ok(g.isObject(D)),A.ok(!this.data.has(F),"There is already an extension with this id"),this.data.set(F,D)}knows(F){return this.data.has(F)}as(F){return this.data.get(F)||null}}t.Registry=new I}),define(J[108],Y([0,1,25,10]),function(_,t,g,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,t.Extensions={JSONContribution:"base.contributions.json"};function I(D){return D.length>0&&D.charAt(D.length-1)==="#"?D.substring(0,D.length-1):D}class L{constructor(){this._onDidChangeSchema=new A.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(c,f){this.schemasById[I(c)]=f,this._onDidChangeSchema.fire(c)}notifySchemaChanged(c){this._onDidChangeSchema.fire(c)}getSchemaContributions(){return{schemas:this.schemasById}}}const F=new L;g.Registry.add(t.Extensions.JSONContribution,F)}),define(J[30],Y([0,1,73,10,25,12,108]),function(_,t,g,A,I,L,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getScopes=t.validateProperty=t.getDefaultValue=t.overrideIdentifierFromKey=t.OVERRIDE_PROPERTY_PATTERN=t.resourceLanguageSettingsSchemaId=t.resourceSettings=t.windowSettings=t.machineOverridableSettings=t.machineSettings=t.applicationSettings=t.allSettings=t.ConfigurationScope=t.Extensions=void 0,t.Extensions={Configuration:"base.contributions.configuration"};var D;(function(b){b[b.APPLICATION=1]="APPLICATION",b[b.MACHINE=2]="MACHINE",b[b.WINDOW=3]="WINDOW",b[b.RESOURCE=4]="RESOURCE",b[b.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",b[b.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(D=t.ConfigurationScope||(t.ConfigurationScope={})),t.allSettings={properties:{},patternProperties:{}},t.applicationSettings={properties:{},patternProperties:{}},t.machineSettings={properties:{},patternProperties:{}},t.machineOverridableSettings={properties:{},patternProperties:{}},t.windowSettings={properties:{},patternProperties:{}},t.resourceSettings={properties:{},patternProperties:{}},t.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const c=I.Registry.as(F.Extensions.JSONContribution);class f{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new A.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new A.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:g.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},c.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(R,P=!0){this.registerConfigurations([R],P)}registerConfigurations(R,P=!0){const v=[];R.forEach(o=>{v.push(...this.validateAndRegisterProperties(o,P,o.extensionInfo)),this.configurationContributors.push(o),this.registerJSONConfiguration(o)}),c.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(v)}deregisterConfigurations(R){const P=[],v=o=>{if(o.properties)for(const r in o.properties)P.push(r),delete this.configurationProperties[r],this.removeFromSchema(r,o.properties[r]);o.allOf&&o.allOf.forEach(r=>v(r))};for(const o of R){v(o);const r=this.configurationContributors.indexOf(o);r!==-1&&this.configurationContributors.splice(r,1)}c.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(P)}registerDefaultConfigurations(R){const P=[],v=[];for(const o of R)for(const r in o)if(P.push(r),t.OVERRIDE_PROPERTY_PATTERN.test(r)){this.defaultValues[r]=Object.assign(Object.assign({},this.defaultValues[r]||{}),o[r]);const e={type:"object",default:this.defaultValues[r],description:g.localize(1,null,r),$ref:t.resourceLanguageSettingsSchemaId};v.push(w(r)),this.configurationProperties[r]=e,this.defaultLanguageConfigurationOverridesNode.properties[r]=e}else{this.defaultValues[r]=o[r];const e=this.configurationProperties[r];e&&(this.updatePropertyDefaultValue(r,e),this.updateSchema(r,e))}this.registerOverrideIdentifiers(v),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(P)}deregisterDefaultConfigurations(R){const P=[];for(const v of R)for(const o in v)if(P.push(o),delete this.defaultValues[o],t.OVERRIDE_PROPERTY_PATTERN.test(o))delete this.configurationProperties[o],delete this.defaultLanguageConfigurationOverridesNode.properties[o];else{const r=this.configurationProperties[o];r&&(this.updatePropertyDefaultValue(o,r),this.updateSchema(o,r))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(P)}notifyConfigurationSchemaUpdated(...R){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(R){for(const P of R)this.overrideIdentifiers.add(P);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(R,P=!0,v,o=3){var r;o=L.isUndefinedOrNull(R.scope)?o:R.scope;let e=[],i=R.properties;if(i)for(let s in i){if(P&&u(s)){delete i[s];continue}const l=i[s];if(this.updatePropertyDefaultValue(s,l),t.OVERRIDE_PROPERTY_PATTERN.test(s)?l.scope=void 0:(l.scope=L.isUndefinedOrNull(l.scope)?o:l.scope,l.restricted=L.isUndefinedOrNull(l.restricted)?!!((r=v==null?void 0:v.restrictedConfigurations)===null||r===void 0?void 0:r.includes(s)):l.restricted),i[s].hasOwnProperty("included")&&!i[s].included){this.excludedConfigurationProperties[s]=i[s],delete i[s];continue}else this.configurationProperties[s]=i[s];!i[s].deprecationMessage&&i[s].markdownDeprecationMessage&&(i[s].deprecationMessage=i[s].markdownDeprecationMessage),e.push(s)}let n=R.allOf;if(n)for(let s of n)e.push(...this.validateAndRegisterProperties(s,P,v,o));return e}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(R){const P=v=>{let o=v.properties;if(o)for(const e in o)this.updateSchema(e,o[e]);let r=v.allOf;r&&r.forEach(P)};P(R)}updateSchema(R,P){switch(t.allSettings.properties[R]=P,P.scope){case 1:t.applicationSettings.properties[R]=P;break;case 2:t.machineSettings.properties[R]=P;break;case 6:t.machineOverridableSettings.properties[R]=P;break;case 3:t.windowSettings.properties[R]=P;break;case 4:t.resourceSettings.properties[R]=P;break;case 5:t.resourceSettings.properties[R]=P,this.resourceLanguageSettingsSchema.properties[R]=P;break}}removeFromSchema(R,P){switch(delete t.allSettings.properties[R],P.scope){case 1:delete t.applicationSettings.properties[R];break;case 2:delete t.machineSettings.properties[R];break;case 6:delete t.machineOverridableSettings.properties[R];break;case 3:delete t.windowSettings.properties[R];break;case 4:case 5:delete t.resourceSettings.properties[R];break}}updateOverridePropertyPatternKey(){for(const R of this.overrideIdentifiers.values()){const P=`[${R}]`,v={type:"object",description:g.localize(2,null),errorMessage:g.localize(3,null),$ref:t.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(P,v),t.allSettings.properties[P]=v,t.applicationSettings.properties[P]=v,t.machineSettings.properties[P]=v,t.machineOverridableSettings.properties[P]=v,t.windowSettings.properties[P]=v,t.resourceSettings.properties[P]=v}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(R,P){let v=this.defaultValues[R];L.isUndefined(v)&&(v=P.default),L.isUndefined(v)&&(v=y(P.type)),P.default=v}}const C="\\[.*\\]$";t.OVERRIDE_PROPERTY_PATTERN=new RegExp(C);function w(b){return b.substring(1,b.length-1)}t.overrideIdentifierFromKey=w;function y(b){switch(Array.isArray(b)?b[0]:b){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}t.getDefaultValue=y;const O=new f;I.Registry.add(t.Extensions.Configuration,O);function u(b){return b.trim()?t.OVERRIDE_PROPERTY_PATTERN.test(b)?g.localize(5,null,b):O.getConfigurationProperties()[b]!==void 0?g.localize(6,null,b):null:g.localize(4,null)}t.validateProperty=u;function h(){const b=[],R=O.getConfigurationProperties();for(const P of Object.keys(R))b.push([P,R[P].scope]);return b.push(["launch",4]),b.push(["task",4]),b}t.getScopes=h}),define(J[26],Y([0,1,20,12,7,25,11,30]),function(_,t,g,A,I,L,F,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMigratedSettingValue=t.keyFromOverrideIdentifier=t.getDefaultValues=t.getConfigurationKeys=t.merge=t.getConfigurationValue=t.removeFromValueTree=t.addToValueTree=t.toValuesTree=t.toOverrides=t.compare=t.ConfigurationTargetToString=t.ConfigurationTarget=t.isConfigurationOverrides=t.IConfigurationService=void 0,t.IConfigurationService=F.createDecorator("configurationService");function c(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof I.URI)}t.isConfigurationOverrides=c;var f;(function(i){i[i.USER=1]="USER",i[i.USER_LOCAL=2]="USER_LOCAL",i[i.USER_REMOTE=3]="USER_REMOTE",i[i.WORKSPACE=4]="WORKSPACE",i[i.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",i[i.DEFAULT=6]="DEFAULT",i[i.MEMORY=7]="MEMORY"})(f=t.ConfigurationTarget||(t.ConfigurationTarget={}));function C(i){switch(i){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}t.ConfigurationTargetToString=C;function w(i,n){const s=n?i?n.keys.filter(V=>i.keys.indexOf(V)===-1):[...n.keys]:[],l=i?n?i.keys.filter(V=>n.keys.indexOf(V)===-1):[...i.keys]:[],E=[];if(n&&i){for(const V of i.keys)if(n.keys.indexOf(V)!==-1){const $=R(i.contents,V),K=R(n.contents,V);g.equals($,K)||E.push(V)}}const S=[],U=V=>{const $={};for(const K of V)for(const ee of K.identifiers)$[r(ee)]=K;return $},k=n?U(n.overrides):{},j=i?U(i.overrides):{};if(Object.keys(k).length)for(const V of s){const $=k[V];$&&S.push([D.overrideIdentifierFromKey(V),$.keys])}if(Object.keys(j).length)for(const V of l){const $=j[V];$&&S.push([D.overrideIdentifierFromKey(V),$.keys])}if(Object.keys(k).length&&Object.keys(j).length)for(const V of E){const $=j[V],K=k[V];if($&&K){const ee=w({contents:$.contents,keys:$.keys,overrides:[]},{contents:K.contents,keys:K.keys,overrides:[]});S.push([D.overrideIdentifierFromKey(V),[...ee.added,...ee.removed,...ee.updated]])}}return{added:s,removed:l,updated:E,overrides:S}}t.compare=w;function y(i,n){const s=[];for(const l of Object.keys(i))if(D.OVERRIDE_PROPERTY_PATTERN.test(l)){const E={};for(const S in i[l])E[S]=i[l][S];s.push({identifiers:[D.overrideIdentifierFromKey(l).trim()],keys:Object.keys(E),contents:O(E,n)})}return s}t.toOverrides=y;function O(i,n){const s=Object.create(null);for(let l in i)u(s,l,i[l],n);return s}t.toValuesTree=O;function u(i,n,s,l){const E=n.split("."),S=E.pop();let U=i;for(let k=0;k<E.length;k++){let j=E[k],V=U[j];switch(typeof V){case"undefined":V=U[j]=Object.create(null);break;case"object":break;default:l(`Ignoring ${n} as ${E.slice(0,k+1).join(".")} is ${JSON.stringify(V)}`);return}U=V}if(typeof U=="object"&&U!==null)try{U[S]=s}catch(k){l(`Ignoring ${n} as ${E.join(".")} is ${JSON.stringify(U)}`)}else l(`Ignoring ${n} as ${E.join(".")} is ${JSON.stringify(U)}`)}t.addToValueTree=u;function h(i,n){const s=n.split(".");b(i,s)}t.removeFromValueTree=h;function b(i,n){const s=n.shift();if(n.length===0){delete i[s];return}if(Object.keys(i).indexOf(s)!==-1){const l=i[s];typeof l=="object"&&!Array.isArray(l)&&(b(l,n),Object.keys(l).length===0&&delete i[s])}}function R(i,n,s){function l(U,k){let j=U;for(const V of k){if(typeof j!="object"||j===null)return;j=j[V]}return j}const E=n.split("."),S=l(i,E);return typeof S=="undefined"?s:S}t.getConfigurationValue=R;function P(i,n,s){Object.keys(n).forEach(l=>{l!=="__proto__"&&(l in i?A.isObject(i[l])&&A.isObject(n[l])?P(i[l],n[l],s):s&&(i[l]=n[l]):i[l]=n[l])})}t.merge=P;function v(){const i=L.Registry.as(D.Extensions.Configuration).getConfigurationProperties();return Object.keys(i)}t.getConfigurationKeys=v;function o(){const i=Object.create(null),n=L.Registry.as(D.Extensions.Configuration).getConfigurationProperties();for(let s in n){let l=n[s].default;u(i,s,l,E=>console.error(`Conflict in default settings: ${E}`))}return i}t.getDefaultValues=o;function r(i){return`[${i}]`}t.keyFromOverrideIdentifier=r;function e(i,n,s){const l=i.inspect(n),E=i.inspect(s);return typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:typeof E.userValue!="undefined"||typeof E.workspaceValue!="undefined"||typeof E.workspaceFolderValue!="undefined"?E.value:l.defaultValue}t.getMigratedSettingValue=e}),define(J[109],Y([0,1,58,45,22,12,20,7,30,26,25,2,10]),function(_,t,g,A,I,L,F,D,c,f,C,w,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AllKeysConfigurationChangeEvent=t.ConfigurationChangeEvent=t.mergeChanges=t.Configuration=t.UserSettings=t.ConfigurationModelParser=t.DefaultConfigurationModel=t.ConfigurationModel=void 0;class O{constructor(e={},i=[],n=[]){this._contents=e,this._keys=i,this._overrides=n,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(e){return e?f.getConfigurationValue(this.contents,e):this.contents}getOverrideValue(e,i){const n=this.getContentsForOverrideIdentifer(i);return n?e?f.getConfigurationValue(n,e):n:void 0}getKeysForOverrideIdentifier(e){for(const i of this.overrides)if(i.identifiers.indexOf(e)!==-1)return i.keys;return[]}override(e){const i=this.getContentsForOverrideIdentifer(e);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let n={};for(const s of I.distinct([...Object.keys(this.contents),...Object.keys(i)])){let l=this.contents[s],E=i[s];E&&(typeof l=="object"&&typeof E=="object"?(l=F.deepClone(l),this.mergeContents(l,E)):l=E),n[s]=l}return new O(n,this.keys,this.overrides)}merge(...e){const i=F.deepClone(this.contents),n=F.deepClone(this.overrides),s=[...this.keys];for(const l of e){this.mergeContents(i,l.contents);for(const E of l.overrides){const[S]=n.filter(U=>I.equals(U.identifiers,E.identifiers));S?this.mergeContents(S.contents,E.contents):n.push(F.deepClone(E))}for(const E of l.keys)s.indexOf(E)===-1&&s.push(E)}return new O(i,s,n)}freeze(){return this.isFrozen=!0,this}mergeContents(e,i){for(const n of Object.keys(i)){if(n in e&&L.isObject(e[n])&&L.isObject(i[n])){this.mergeContents(e[n],i[n]);continue}e[n]=F.deepClone(i[n])}}checkAndFreeze(e){return this.isFrozen&&!Object.isFrozen(e)?F.deepFreeze(e):e}getContentsForOverrideIdentifer(e){for(const i of this.overrides)if(i.identifiers.indexOf(e)!==-1)return i.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(e,i){this.addKey(e),f.addToValueTree(this.contents,e,i,n=>{throw new Error(n)})}removeValue(e){this.removeKey(e)&&f.removeFromValueTree(this.contents,e)}addKey(e){let i=this.keys.length;for(let n=0;n<i;n++)e.indexOf(this.keys[n])===0&&(i=n);this.keys.splice(i,1,e)}removeKey(e){let i=this.keys.indexOf(e);return i!==-1?(this.keys.splice(i,1),!0):!1}}t.ConfigurationModel=O;class u extends O{constructor(){const e=f.getDefaultValues(),i=f.getConfigurationKeys(),n=[];for(const s of Object.keys(e))c.OVERRIDE_PROPERTY_PATTERN.test(s)&&n.push({identifiers:[c.overrideIdentifierFromKey(s).trim()],keys:Object.keys(e[s]),contents:f.toValuesTree(e[s],l=>console.error(`Conflict in default settings file: ${l}`))});super(e,i,n)}}t.DefaultConfigurationModel=u;class h{constructor(e){this._name=e,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new O}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(e,i){if(!L.isUndefinedOrNull(e)){const n=this.doParseContent(e);this.parseRaw(n,i)}}reparse(e){this._raw&&this.parseRaw(this._raw,e)}parseRaw(e,i){this._raw=e;const{contents:n,keys:s,overrides:l,restricted:E}=this.doParseRaw(e,i);this._configurationModel=new O(n,s,l),this._restrictedConfigurations=E||[]}doParseContent(e){let i={},n=null,s=[],l=[],E=[];function S(k){Array.isArray(s)?s.push(k):n&&(s[n]=k)}let U={onObjectBegin:()=>{let k={};S(k),l.push(s),s=k,n=null},onObjectProperty:k=>{n=k},onObjectEnd:()=>{s=l.pop()},onArrayBegin:()=>{let k=[];S(k),l.push(s),s=k,n=null},onArrayEnd:()=>{s=l.pop()},onLiteralValue:S,onError:(k,j,V)=>{E.push({error:k,offset:j,length:V})}};if(e)try{g.visit(e,U),i=s[0]||{}}catch(k){console.error(`Error while parsing settings file ${this._name}: ${k}`),this._parseErrors=[k]}return i}doParseRaw(e,i){const n=C.Registry.as(c.Extensions.Configuration).getConfigurationProperties(),s=this.filter(e,n,!0,i);e=s.raw;const l=f.toValuesTree(e,U=>console.error(`Conflict in settings file ${this._name}: ${U}`)),E=Object.keys(e),S=f.toOverrides(e,U=>console.error(`Conflict in settings file ${this._name}: ${U}`));return{contents:l,keys:E,overrides:S,restricted:s.restricted}}filter(e,i,n,s){if(!(s==null?void 0:s.scopes)&&!(s==null?void 0:s.skipRestricted))return{raw:e,restricted:[]};const l={},E=[];for(let S in e)if(c.OVERRIDE_PROPERTY_PATTERN.test(S)&&n){const U=this.filter(e[S],i,!1,s);l[S]=U.raw,E.push(...U.restricted)}else{const U=i[S],k=U?typeof U.scope!="undefined"?U.scope:3:void 0;(U==null?void 0:U.restricted)&&E.push(S),(k===void 0||s.scopes===void 0||s.scopes.includes(k))&&(s.skipRestricted&&(U==null?void 0:U.restricted)||(l[S]=e[S]))}return{raw:l,restricted:E}}}t.ConfigurationModelParser=h;class b extends w.Disposable{constructor(e,i,n,s){super();this.userSettingsResource=e,this.scopes=i,this.fileService=s,this._onDidChange=this._register(new y.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new h(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(n.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(y.Event.filter(this.fileService.onDidFilesChange,l=>l.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const e=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(e.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(e){return new O}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}t.UserSettings=b;class R{constructor(e,i,n=new O,s=new O,l=new A.ResourceMap,E=new O,S=new A.ResourceMap,U=!0){this._defaultConfiguration=e,this._localUserConfiguration=i,this._remoteUserConfiguration=n,this._workspaceConfiguration=s,this._folderConfigurations=l,this._memoryConfiguration=E,this._memoryConfigurationByResource=S,this._freeze=U,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new A.ResourceMap,this._userConfiguration=null}getValue(e,i,n){return this.getConsolidateConfigurationModel(i,n).getValue(e)}updateValue(e,i,n={}){let s;n.resource?(s=this._memoryConfigurationByResource.get(n.resource),s||(s=new O,this._memoryConfigurationByResource.set(n.resource,s))):s=this._memoryConfiguration,i===void 0?s.removeValue(e):s.setValue(e,i),n.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(e,i,n){const s=this.getConsolidateConfigurationModel(i,n),l=this.getFolderConfigurationModelForResource(i.resource,n),E=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,S=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this._defaultConfiguration.freeze().getValue(e),U=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.userConfiguration.freeze().getValue(e),k=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.localUserConfiguration.freeze().getValue(e),j=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.remoteUserConfiguration.freeze().getValue(e),V=n?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this._workspaceConfiguration.freeze().getValue(e):void 0,$=l?i.overrideIdentifier?l.freeze().override(i.overrideIdentifier).getValue(e):l.freeze().getValue(e):void 0,K=i.overrideIdentifier?E.override(i.overrideIdentifier).getValue(e):E.getValue(e),ee=s.getValue(e),te=I.distinct(I.flatten(s.overrides.map(Z=>Z.identifiers))).filter(Z=>s.getOverrideValue(e,Z)!==void 0);return{defaultValue:S,userValue:U,userLocalValue:k,userRemoteValue:j,workspaceValue:V,workspaceFolderValue:$,memoryValue:K,value:ee,default:S!==void 0?{value:this._defaultConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,user:U!==void 0?{value:this.userConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,userLocal:k!==void 0?{value:this.localUserConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,userRemote:j!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,workspace:V!==void 0?{value:this._workspaceConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,workspaceFolder:$!==void 0?{value:l==null?void 0:l.freeze().getValue(e),override:i.overrideIdentifier?l==null?void 0:l.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,memory:K!==void 0?{value:E.getValue(e),override:i.overrideIdentifier?E.getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:te.length?te:void 0}}keys(e){const i=this.getFolderConfigurationModelForResource(void 0,e);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(e){this._defaultConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(e){this._localUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(e){this._remoteUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(e){this._workspaceConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(e,i){this._folderConfigurations.set(e,i),this._foldersConsolidatedConfigurations.delete(e)}deleteFolderConfiguration(e){this.folderConfigurations.delete(e),this._foldersConsolidatedConfigurations.delete(e)}compareAndUpdateDefaultConfiguration(e,i){const n=i.filter(s=>c.OVERRIDE_PROPERTY_PATTERN.test(s)).map(s=>{const l=c.overrideIdentifierFromKey(s),E=this._defaultConfiguration.getKeysForOverrideIdentifier(l),S=e.getKeysForOverrideIdentifier(l),U=[...S.filter(k=>E.indexOf(k)===-1),...E.filter(k=>S.indexOf(k)===-1),...E.filter(k=>!F.equals(this._defaultConfiguration.override(l).getValue(k),e.override(l).getValue(k)))];return[l,U]});return this.updateDefaultConfiguration(e),{keys:i,overrides:n}}compareAndUpdateLocalUserConfiguration(e){const{added:i,updated:n,removed:s,overrides:l}=f.compare(this.localUserConfiguration,e),E=[...i,...n,...s];return E.length&&this.updateLocalUserConfiguration(e),{keys:E,overrides:l}}compareAndUpdateRemoteUserConfiguration(e){const{added:i,updated:n,removed:s,overrides:l}=f.compare(this.remoteUserConfiguration,e);let E=[...i,...n,...s];return E.length&&this.updateRemoteUserConfiguration(e),{keys:E,overrides:l}}compareAndUpdateWorkspaceConfiguration(e){const{added:i,updated:n,removed:s,overrides:l}=f.compare(this.workspaceConfiguration,e);let E=[...i,...n,...s];return E.length&&this.updateWorkspaceConfiguration(e),{keys:E,overrides:l}}compareAndUpdateFolderConfiguration(e,i){const n=this.folderConfigurations.get(e),{added:s,updated:l,removed:E,overrides:S}=f.compare(n,i);let U=[...s,...l,...E];return(U.length||!n)&&this.updateFolderConfiguration(e,i),{keys:U,overrides:S}}compareAndDeleteFolderConfiguration(e){const i=this.folderConfigurations.get(e);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(e);const{added:n,updated:s,removed:l,overrides:E}=f.compare(i,void 0);return{keys:[...n,...s,...l],overrides:E}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(e,i){let n=this.getConsolidatedConfigurationModelForResource(e,i);return e.overrideIdentifier?n.override(e.overrideIdentifier):n}getConsolidatedConfigurationModelForResource({resource:e},i){let n=this.getWorkspaceConsolidatedConfiguration();if(i&&e){const s=i.getFolder(e);s&&(n=this.getFolderConsolidatedConfiguration(s.uri)||n);const l=this._memoryConfigurationByResource.get(e);l&&(n=n.merge(l))}return n}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(e){let i=this._foldersConsolidatedConfigurations.get(e);if(!i){const n=this.getWorkspaceConsolidatedConfiguration(),s=this._folderConfigurations.get(e);s?(i=n.merge(s),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(e,i)):i=n}return i}getFolderConfigurationModelForResource(e,i){if(i&&e){const n=i.getFolder(e);if(n)return this._folderConfigurations.get(n.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((e,i)=>{const{contents:n,overrides:s,keys:l}=this._folderConfigurations.get(i);return e.push([i,{contents:n,overrides:s,keys:l}]),e},[])}}allKeys(){const e=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>e.add(i)),this.userConfiguration.freeze().keys.forEach(i=>e.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>e.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(n=>e.add(n))),[...e.values()]}getAllKeysForOverrideIdentifier(e){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(e).forEach(n=>i.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(e).forEach(n=>i.add(n)),this._workspaceConfiguration.getKeysForOverrideIdentifier(e).forEach(n=>i.add(n)),this._folderConfigurations.forEach(n=>n.getKeysForOverrideIdentifier(e).forEach(s=>i.add(s))),[...i.values()]}static parse(e){const i=this.parseConfigurationModel(e.defaults),n=this.parseConfigurationModel(e.user),s=this.parseConfigurationModel(e.workspace),l=e.folders.reduce((E,S)=>(E.set(D.URI.revive(S[0]),this.parseConfigurationModel(S[1])),E),new A.ResourceMap);return new R(i,n,new O,s,l,new O,new A.ResourceMap,!1)}static parseConfigurationModel(e){return new O(e.contents,e.keys,e.overrides).freeze()}}t.Configuration=R;function P(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const e=new Set,i=new Map;for(const s of r)s.keys.forEach(l=>e.add(l)),s.overrides.forEach(([l,E])=>{const S=A.getOrSet(i,l,new Set);E.forEach(U=>S.add(U))});const n=[];return i.forEach((s,l)=>n.push([l,[...s.values()]])),{keys:[...e.values()],overrides:n}}t.mergeChanges=P;class v{constructor(e,i,n,s){this.change=e,this.previous=i,this.currentConfiguraiton=n,this.currentWorkspace=s,this._previousConfiguration=void 0;const l=new Set;e.keys.forEach(S=>l.add(S)),e.overrides.forEach(([,S])=>S.forEach(U=>l.add(U))),this.affectedKeys=[...l.values()];const E=new O;this.affectedKeys.forEach(S=>E.setValue(S,{})),this.affectedKeysTree=E.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=R.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(e,i){var n;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,e)){if(i){const s=this.previousConfiguration?this.previousConfiguration.getValue(e,i,(n=this.previous)===null||n===void 0?void 0:n.workspace):void 0,l=this.currentConfiguraiton.getValue(e,i,this.currentWorkspace);return!F.equals(s,l)}return!0}return!1}doesAffectedKeysTreeContains(e,i){let n=f.toValuesTree({[i]:!0},()=>{}),s;for(;typeof n=="object"&&(s=Object.keys(n)[0]);){if(e=e[s],!e)return!1;n=n[s]}return!0}}t.ConfigurationChangeEvent=v;class o extends v{constructor(e,i,n,s){super({keys:e.allKeys(),overrides:[]},void 0,e,i);this.source=n,this.sourceConfig=s}}t.AllKeysConfigurationChangeEvent=o}),define(J[110],Y([0,1,25,30,2,26,109,10,4,17]),function(_,t,g,A,I,L,F,D,c,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConfigurationService=void 0;class C extends I.Disposable{constructor(y,O){super();this.settingsResource=y,this._onDidChangeConfiguration=this._register(new D.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new F.UserSettings(this.settingsResource,void 0,f.extUriBiasedIgnorePathCase,O)),this.configuration=new F.Configuration(new F.DefaultConfigurationModel,new F.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new c.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(g.Registry.as(A.Extensions.Configuration).onDidUpdateConfiguration(u=>this.onDidDefaultConfigurationChange(u))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const y=await this.userConfiguration.loadConfiguration();this.configuration=new F.Configuration(new F.DefaultConfigurationModel,y)}getConfigurationData(){return this.configuration.toData()}getValue(y,O){const u=typeof y=="string"?y:void 0,h=L.isConfigurationOverrides(y)?y:L.isConfigurationOverrides(O)?O:{};return this.configuration.getValue(u,h,void 0)}updateValue(y,O,u,h){return Promise.reject(new Error("not supported"))}inspect(y){return this.configuration.inspect(y,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const y=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(y)}onDidChangeUserConfiguration(y){const O=this.configuration.toData(),u=this.configuration.compareAndUpdateLocalUserConfiguration(y);this.trigger(u,O,1)}onDidDefaultConfigurationChange(y){const O=this.configuration.toData(),u=this.configuration.compareAndUpdateDefaultConfiguration(new F.DefaultConfigurationModel,y);this.trigger(u,O,6)}trigger(y,O,u){const h=new F.ConfigurationChangeEvent(y,{data:O},this.configuration);h.source=u,h.sourceConfig=this.getTargetConfiguration(u),this._onDidChangeConfiguration.fire(h)}getTargetConfiguration(y){switch(y){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}t.ConfigurationService=C}),define(J[55],Y([0,1,83,11,30,25,16]),function(_,t,g,A,I,L,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.updateProxyConfigurationsScope=t.asJson=t.asText=t.isSuccess=t.IRequestService=void 0,t.IRequestService=A.createDecorator("requestService");function D(u){return u.res.statusCode&&u.res.statusCode>=200&&u.res.statusCode<300||u.res.statusCode===1223}t.isSuccess=D;function c(u){return u.res.statusCode===204}async function f(u){if(!D(u))throw new Error("Server returned "+u.res.statusCode);return c(u)?null:(await F.streamToBuffer(u.stream)).toString()}t.asText=f;async function C(u){if(!D(u))throw new Error("Server returned "+u.res.statusCode);if(c(u))return null;const b=(await F.streamToBuffer(u.stream)).toString();try{return JSON.parse(b)}catch(R){throw R.message+=`:
`+b,R}}t.asJson=C;function w(u){O(u)}t.updateProxyConfigurationsScope=w;let y;function O(u){const h=L.Registry.as(I.Extensions.Configuration);y&&h.deregisterConfigurations([y]),y={id:"http",order:15,title:g.localize(0,null),type:"object",scope:u,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:g.localize(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:g.localize(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:g.localize(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[g.localize(4,null),g.localize(5,null),g.localize(6,null),g.localize(7,null)],default:"override",description:g.localize(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:g.localize(9,null),restricted:!0}}},h.registerConfiguration(y)}O(2)}),define(J[111],Y([0,1,112,12]),function(_,t,g,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getProxyAgent=void 0;function I(F,D){return F.protocol==="http:"?D.HTTP_PROXY||D.http_proxy||null:F.protocol==="https:"&&(D.HTTPS_PROXY||D.https_proxy||D.HTTP_PROXY||D.http_proxy)||null}async function L(F,D,c={}){const f=g.parse(F),C=c.proxyUrl||I(f,D);if(!C)return null;const w=g.parse(C);if(!/^https?:$/.test(w.protocol||""))return null;const y={host:w.hostname||"",port:w.port||(w.protocol==="https"?"443":"80"),auth:w.auth,rejectUnauthorized:A.isBoolean(c.strictSSL)?c.strictSSL:!0};return f.protocol==="http:"?new(await new Promise((O,u)=>{_(["http-proxy-agent"],O,u)}))(y):new(await new Promise((O,u)=>{_(["https-proxy-agent"],O,u)}))(y)}t.getProxyAgent=L}),define(J[113],Y([0,1,29,16]),function(_,t,g,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getServiceMachineId=void 0;async function I(L,F,D){let c=D&&D.get("storage.serviceMachineId",0)||null;if(c)return c;try{const C=(await F.readFile(L.serviceMachineIdResource)).value.toString();c=g.isUUID(C)?C:null}catch(f){c=null}if(!c){c=g.generateUuid();try{await F.writeFile(L.serviceMachineIdResource,A.VSBuffer.fromString(c))}catch(f){}}return D&&D.store("storage.serviceMachineId",c,0,1),c}t.getServiceMachineId=I}),define(J[114],Y([0,1,11,10,2,12,66,4]),function(_,t,g,A,I,L,F,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.logStorage=t.InMemoryStorageService=t.AbstractStorageService=t.StorageTarget=t.StorageScope=t.WillSaveStateReason=t.IStorageService=t.IS_NEW_KEY=void 0,t.IS_NEW_KEY="__$__isNewStorageMarker";const c="__$__targetStorageMarker";t.IStorageService=g.createDecorator("storageService");var f;(function(h){h[h.NONE=0]="NONE",h[h.SHUTDOWN=1]="SHUTDOWN"})(f=t.WillSaveStateReason||(t.WillSaveStateReason={}));var C;(function(h){h[h.GLOBAL=0]="GLOBAL",h[h.WORKSPACE=1]="WORKSPACE"})(C=t.StorageScope||(t.StorageScope={}));var w;(function(h){h[h.USER=0]="USER",h[h.MACHINE=1]="MACHINE"})(w=t.StorageTarget||(t.StorageTarget={}));class y extends I.Disposable{constructor(b={flushInterval:y.DEFAULT_FLUSH_INTERVAL}){super();this.options=b,this._onDidChangeValue=this._register(new A.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new A.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new A.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new D.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new I.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=D.runWhenIdle(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){I.dispose([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(b,R){R===c?(b===0?this._globalKeyTargets=void 0:b===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:b})):this._onDidChangeValue.fire({scope:b,key:R,target:this.getKeyTargets(b)[R]})}emitWillSaveState(b){this._onWillSaveState.fire({reason:b})}get(b,R,P){var v;return(v=this.getStorage(R))===null||v===void 0?void 0:v.get(b,P)}getBoolean(b,R,P){var v;return(v=this.getStorage(R))===null||v===void 0?void 0:v.getBoolean(b,P)}getNumber(b,R,P){var v;return(v=this.getStorage(R))===null||v===void 0?void 0:v.getNumber(b,P)}store(b,R,P,v){if(L.isUndefinedOrNull(R)){this.remove(b,P);return}this.withPausedEmitters(()=>{var o;this.updateKeyTarget(b,P,v),(o=this.getStorage(P))===null||o===void 0||o.set(b,R)})}remove(b,R){this.withPausedEmitters(()=>{var P;this.updateKeyTarget(b,R,void 0),(P=this.getStorage(R))===null||P===void 0||P.delete(b)})}withPausedEmitters(b){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{b()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(b,R){const P=[],v=this.getKeyTargets(b);for(const o of Object.keys(v))v[o]===R&&P.push(o);return P}updateKeyTarget(b,R,P){var v,o;const r=this.getKeyTargets(R);typeof P=="number"?r[b]!==P&&(r[b]=P,(v=this.getStorage(R))===null||v===void 0||v.set(c,JSON.stringify(r))):typeof r[b]=="number"&&(delete r[b],(o=this.getStorage(R))===null||o===void 0||o.set(c,JSON.stringify(r)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(b){return b===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(b){const R=this.get(c,b);if(R)try{return JSON.parse(R)}catch(P){}return Object.create(null)}isNew(b){return this.getBoolean(t.IS_NEW_KEY,b)===!0}async flush(){var b,R,P,v;this._onWillSaveState.fire({reason:f.NONE}),await D.Promises.settled([(R=(b=this.getStorage(0))===null||b===void 0?void 0:b.whenFlushed())!==null&&R!==void 0?R:Promise.resolve(),(v=(P=this.getStorage(1))===null||P===void 0?void 0:P.whenFlushed())!==null&&v!==void 0?v:Promise.resolve()])}async logStorage(){var b,R,P,v,o,r;const e=(R=(b=this.getStorage(0))===null||b===void 0?void 0:b.items)!==null&&R!==void 0?R:new Map,i=(v=(P=this.getStorage(1))===null||P===void 0?void 0:P.items)!==null&&v!==void 0?v:new Map;return u(e,i,(o=this.getLogDetails(0))!==null&&o!==void 0?o:"",(r=this.getLogDetails(1))!==null&&r!==void 0?r:"")}}t.AbstractStorageService=y,y.DEFAULT_FLUSH_INTERVAL=60*1e3;class O extends y{constructor(){super();this.globalStorage=new F.Storage(new F.InMemoryStorageDatabase),this.workspaceStorage=new F.Storage(new F.InMemoryStorageDatabase),this._register(this.workspaceStorage.onDidChangeStorage(b=>this.emitDidChangeValue(1,b))),this._register(this.globalStorage.onDidChangeStorage(b=>this.emitDidChangeValue(0,b)))}getStorage(b){return b===0?this.globalStorage:this.workspaceStorage}getLogDetails(b){return b===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(b){}}t.InMemoryStorageService=O;async function u(h,b,R,P){const v=l=>{try{return JSON.parse(l)}catch(E){return l}},o=new Map,r=new Map;h.forEach((l,E)=>{o.set(E,l),r.set(E,v(l))});const e=new Map,i=new Map;b.forEach((l,E)=>{e.set(E,l),i.set(E,v(l))}),console.group(`Storage: Global (path: ${R})`);let n=[];o.forEach((l,E)=>{n.push({key:E,value:l})}),console.table(n),console.groupEnd(),console.log(r),console.group(`Storage: Workspace (path: ${P})`);let s=[];e.forEach((l,E)=>{s.push({key:E,value:l})}),console.table(s),console.groupEnd(),console.log(i)}t.logStorage=u}),define(J[115],Y([0,1,14,34,29,7]),function(_,t,g,A,I,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.verifyMicrosoftInternalDomain=t.resolveCommonProperties=void 0;function F(f){if(g.platform===2&&/^penguin(\.|$)/i.test(f))return"chromebook"}async function D(f,C,w,y,O,u,h,b,R,P){const v=Object.create(null);v["common.machineId"]=h,v.sessionID=I.generateUuid()+Date.now(),v.commitHash=O,v.version=u,v["common.platformVersion"]=(C||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),v["common.platform"]=g.PlatformToString(g.platform),v["common.nodePlatform"]=A.platform,v["common.nodeArch"]=y,v["common.product"]=P||"desktop";const o=c(b||[]);o&&(v["common.msftInternal"]=o);let r=0;const e=Date.now();Object.defineProperties(v,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-e,enumerable:!0},"common.sequence":{get:()=>r++,enumerable:!0}}),g.isLinuxSnap&&(v["common.snap"]="true");const i=F(w);i&&(v["common.platformDetail"]=i);try{const n=await f.readFile(L.URI.file(R));v["common.source"]=n.value.toString().slice(0,30)}catch(n){}return v}t.resolveCommonProperties=D;function c(f){const C=A.env.USERDNSDOMAIN;if(!C)return!1;const w=C.toLowerCase();return f.some(y=>w===y)}t.verifyMicrosoftInternalDomain=c}),define(J[42],Y([0,1,11]),function(_,t,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.machineIdKey=t.lastSessionDateStorageKey=t.firstSessionDateStorageKey=t.currentSessionDateStorageKey=t.instanceStorageKey=t.ICustomEndpointTelemetryService=t.ITelemetryService=void 0,t.ITelemetryService=g.createDecorator("telemetryService"),t.ICustomEndpointTelemetryService=g.createDecorator("customEndpointTelemetryService"),t.instanceStorageKey="telemetry.instanceId",t.currentSessionDateStorageKey="telemetry.currentSessionDate",t.firstSessionDateStorageKey="telemetry.firstSessionDate",t.lastSessionDateStorageKey="telemetry.lastSessionDate",t.machineIdKey="telemetry.machineId"}),define(J[116],Y([0,1,13,23,24,20,42,55,49,21,27,15,18,7,41,114,113,11,17]),function(_,t,g,A,I,L,F,D,c,f,C,w,y,O,u,h,b,R,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveMarketplaceHeaders=t.ExtensionGalleryService=void 0;var v;(function(d){d[d.None=0]="None",d[d.IncludeVersions=1]="IncludeVersions",d[d.IncludeFiles=2]="IncludeFiles",d[d.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",d[d.IncludeSharedAccounts=8]="IncludeSharedAccounts",d[d.IncludeVersionProperties=16]="IncludeVersionProperties",d[d.ExcludeNonValidated=32]="ExcludeNonValidated",d[d.IncludeInstallationTargets=64]="IncludeInstallationTargets",d[d.IncludeAssetUri=128]="IncludeAssetUri",d[d.IncludeStatistics=256]="IncludeStatistics",d[d.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",d[d.Unpublished=4096]="Unpublished"})(v||(v={}));function o(...d){return String(d.reduce((a,m)=>a|m,0))}var r;(function(d){d[d.Tag=1]="Tag",d[d.ExtensionId=4]="ExtensionId",d[d.Category=5]="Category",d[d.ExtensionName=7]="ExtensionName",d[d.Target=8]="Target",d[d.Featured=9]="Featured",d[d.SearchText=10]="SearchText",d[d.ExcludeWithFlags=12]="ExcludeWithFlags"})(r||(r={}));const e={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},i={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},s={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:v.None,criteria:[],assetTypes:[]};class l{constructor(a=s){this.state=a}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(a,m=this.state.pageSize){return new l(Object.assign(Object.assign({},this.state),{pageNumber:a,pageSize:m}))}withFilter(a,...m){const p=[...this.state.criteria,...m.length?m.map(N=>({filterType:a,value:N})):[{filterType:a}]];return new l(Object.assign(Object.assign({},this.state),{criteria:p}))}withSortBy(a){return new l(Object.assign(Object.assign({},this.state),{sortBy:a}))}withSortOrder(a){return new l(Object.assign(Object.assign({},this.state),{sortOrder:a}))}withFlags(...a){return new l(Object.assign(Object.assign({},this.state),{flags:a.reduce((m,p)=>m|p,0)}))}withAssetTypes(...a){return new l(Object.assign(Object.assign({},this.state),{assetTypes:a}))}get raw(){const{criteria:a,pageNumber:m,pageSize:p,sortBy:N,sortOrder:M,flags:W,assetTypes:B}=this.state;return{filters:[{criteria:a,pageNumber:m,pageSize:p,sortBy:N,sortOrder:M}],assetTypes:B,flags:W}}get searchText(){const a=this.state.criteria.filter(m=>m.filterType===r.SearchText)[0];return a&&a.value?a.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(a=>String(a.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function E(d,a){const m=(d||[]).filter(p=>p.statisticName===a)[0];return m?m.value:0}function S(d){const a="Microsoft.VisualStudio.Code.Translation.";return d.files.filter(p=>p.assetType.indexOf(a)===0).reduce((p,N)=>{const M=V(d,N.assetType);return M&&p.push([N.assetType.substring(a.length),M]),p},[])}function U(d){if(d.properties){const a=d.properties.filter(N=>N.key===e.Repository),m=new RegExp("((git|ssh|http(s)?)|(git@[w.]+))(:(//)?)([w.@:/-~]+)(.git)(/)?"),p=a.filter(N=>m.test(N.value))[0];return p?{uri:p.value,fallbackUri:p.value}:null}return V(d,e.Repository)}function k(d){return{uri:`${d.fallbackAssetUri}/${e.VSIX}?redirect=true`,fallbackUri:`${d.fallbackAssetUri}/${e.VSIX}`}}function j(d){const a=V(d,e.Icon);if(a)return a;const m=A.DefaultIconPath;return{uri:m,fallbackUri:m}}function V(d,a){return d.files.filter(p=>p.assetType===a)[0]?{uri:`${d.assetUri}/${a}`,fallbackUri:`${d.fallbackAssetUri}/${a}`}:null}function $(d,a){const m=d.properties?d.properties.filter(N=>N.key===a):[],p=m.length>0&&m[0].value;return p?p.split(",").map(N=>I.adoptToGalleryExtensionId(N)):[]}function K(d){const a=d.properties?d.properties.filter(m=>m.key===i.Engine):[];return a.length>0&&a[0].value||""}function ee(d){const a=d.properties?d.properties.filter(p=>p.key===i.LocalizedLanguages):[],m=a.length>0&&a[0].value||"";return m?m.split(","):[]}function te(d){return d.indexOf("preview")!==-1}function Z(d){const a=d.properties?d.properties.find(m=>m.key===i.WebExtension):void 0;return!!a&&a.value==="true"}function ae(d){return d.files.some(a=>a.assetType.startsWith("Microsoft.VisualStudio.Code.WebResources"))?P.joinPath(O.URI.parse(d.assetUri),"Microsoft.VisualStudio.Code.WebResources","extension"):void 0}function se(d,a,m,p,N){const M={manifest:V(a,e.Manifest),readme:V(a,e.Details),changelog:V(a,e.Changelog),license:V(a,e.License),repository:U(a),download:k(a),icon:j(a),coreTranslations:S(a)};return{identifier:{id:I.getGalleryExtensionId(d.publisher.publisherName,d.extensionName),uuid:d.extensionId},name:d.extensionName,version:a.version,date:a.lastUpdated,displayName:d.displayName,publisherId:d.publisher.publisherId,publisher:d.publisher.publisherName,publisherDisplayName:d.publisher.displayName,description:d.shortDescription||"",installCount:E(d.statistics,"install"),rating:E(d.statistics,"averagerating"),ratingCount:E(d.statistics,"ratingcount"),assetUri:O.URI.parse(a.assetUri),webResource:ae(a),assetTypes:a.files.map(({assetType:W})=>W),assets:M,properties:{dependencies:$(a,i.Dependency),extensionPack:$(a,i.ExtensionPack),engine:K(a),localizedLanguages:ee(a),webExtension:Z(a)},telemetryData:{index:(p.pageNumber-1)*p.pageSize+m,querySource:N},preview:te(d.flags)}}let re=class{constructor(a,m,p,N,M,W,B){this.requestService=a,this.logService=m,this.environmentService=p,this.telemetryService=N,this.fileService=M,this.productService=W;const x=W.extensionsGallery;this.extensionsGalleryUrl=x&&x.serviceUrl,this.extensionsControlUrl=x&&x.controlUrl,this.commonHeadersPromise=T(W.version,this.environmentService,this.fileService,B)}api(a=""){return`${this.extensionsGalleryUrl}${a}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(a,m){const p=[];let{total:N,firstPage:M,getPage:W}=await this.query({names:a,pageSize:a.length},m);p.push(...M);for(let B=1;p.length<N&&(M=await W(B,m),M.length);B++)p.push(...M);return p}async getCompatibleExtension(a,m){const p=await this.getCompatibleExtensionByEngine(a,m);return(p==null?void 0:p.properties.webExtension)?p.webResource?p:null:p}async getCompatibleExtensionByEngine(a,m){const p=A.isIExtensionIdentifier(a)?null:a;if(p&&p.properties.engine&&c.isEngineValid(p.properties.engine,this.productService.version,this.productService.date))return p;const{id:N,uuid:M}=p?p.identifier:a;let W=new l().withFlags(v.IncludeAssetUri,v.IncludeStatistics,v.IncludeFiles,v.IncludeVersionProperties).withPage(1,1).withFilter(r.Target,"Microsoft.VisualStudio.Code");M?W=W.withFilter(r.ExtensionId,M):W=W.withFilter(r.ExtensionName,N);const{galleryExtensions:B}=await this.queryGallery(W,C.CancellationToken.None),[x]=B;if(!x||!x.versions.length)return null;if(m){const X=x.versions.filter(Q=>Q.version===m)[0];if(X){const Q=se(x,X,0,W);if(Q.properties.engine&&c.isEngineValid(Q.properties.engine,this.productService.version,this.productService.date))return Q}return null}const H=await this.getLastValidExtensionVersion(x,x.versions);return H?se(x,H,0,W):null}async query(a,m){const p=C.CancellationToken.isCancellationToken(a)?{}:a,N=C.CancellationToken.isCancellationToken(a)?a:m;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let M=p.text||"";const W=L.getOrDefault(p,ie=>ie.pageSize,50);let B=new l().withFlags(v.IncludeLatestVersionOnly,v.IncludeAssetUri,v.IncludeStatistics,v.IncludeFiles,v.IncludeVersionProperties).withPage(1,W).withFilter(r.Target,"Microsoft.VisualStudio.Code");M?(M=M.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ie,ce,ge)=>(B=B.withFilter(r.Category,ge||ce),"")),M=M.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ie,ce,ge)=>(B=B.withFilter(r.Tag,ge||ce),"")),M=M.replace(/\bfeatured(\s+|\b|$)/g,()=>(B=B.withFilter(r.Featured),"")),M=M.trim(),M&&(M=M.length<200?M:M.substring(0,200),B=B.withFilter(r.SearchText,M)),B=B.withSortBy(0)):p.ids?B=B.withFilter(r.ExtensionId,...p.ids):p.names?B=B.withFilter(r.ExtensionName,...p.names):B=B.withSortBy(4),typeof p.sortBy=="number"&&(B=B.withSortBy(p.sortBy)),typeof p.sortOrder=="number"&&(B=B.withSortOrder(p.sortOrder));const{galleryExtensions:x,total:H}=await this.queryGallery(B,N),X=x.map((ie,ce)=>se(ie,ie.versions[0],ce,B,p.source)),Q=async(ie,ce)=>{if(ce.isCancellationRequested)throw g.canceled();const ge=B.withPage(ie+1),{galleryExtensions:Ie}=await this.queryGallery(ge,ce);return Ie.map((Fe,Oe)=>se(Fe,Fe.versions[0],Oe,ge,p.source))};return{firstPage:X,total:H,pageSize:B.pageSize,getPage:Q}}async queryGallery(a,m){if(!this.isEnabled())throw new Error("No extension gallery service configured.");a=a.withFlags(a.flags,v.ExcludeNonValidated).withFilter(r.ExcludeWithFlags,o(v.Unpublished));const p=await this.commonHeadersPromise,N=JSON.stringify(a.raw),M=Object.assign(Object.assign({},p),{"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(N.length)}),W=new Date().getTime();let B,x,H=0;try{if(B=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:N,headers:M},m),B.res.statusCode&&B.res.statusCode>=400&&B.res.statusCode<500)return{galleryExtensions:[],total:H};const X=await D.asJson(B);if(X){const Q=X.results[0],ie=Q.extensions,ce=Q.resultMetadata&&Q.resultMetadata.filter(ge=>ge.metadataType==="ResultCount")[0];return H=ce&&ce.metadataItems.filter(ge=>ge.name==="TotalCount")[0].count||0,{galleryExtensions:ie,total:H}}return{galleryExtensions:[],total:H}}catch(X){throw x=X,X}finally{this.telemetryService.publicLog2("galleryService:query",Object.assign(Object.assign({},a.telemetryData),{requestBodySize:String(N.length),duration:new Date().getTime()-W,success:!!B&&D.isSuccess(B),responseBodySize:B==null?void 0:B.res.headers["Content-Length"],statusCode:B?String(B.res.statusCode):void 0,errorCode:x?g.isPromiseCanceledError(x)?"canceled":g.getErrorMessage(x).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(H)}))}}async reportStatistic(a,m,p,N){if(!this.isEnabled())return;const M=await this.commonHeadersPromise,W=Object.assign(Object.assign({},M),{Accept:"*/*;api-version=4.0-preview.1"});try{await this.requestService.request({type:"POST",url:this.api(`/publishers/${a}/extensions/${m}/${p}/stats?statType=${N}`),headers:W},C.CancellationToken.None)}catch(B){}}async download(a,m,p){this.logService.trace("ExtensionGalleryService#download",a.identifier.id);const N=I.getGalleryExtensionTelemetryData(a),M=new Date().getTime(),W=X=>this.telemetryService.publicLog("galleryService:downloadVSIX",Object.assign(Object.assign({},N),{duration:X})),B=p===1?"install":p===2?"update":"",x=B?{uri:`${a.assets.download.uri}&${B}=true`,fallbackUri:`${a.assets.download.fallbackUri}?${B}=true`}:a.assets.download,H=await this.getAsset(x);await this.fileService.writeFile(m,H.stream),W(new Date().getTime()-M)}async getReadme(a,m){if(a.assets.readme){const p=await this.getAsset(a.assets.readme,{},m);return await D.asText(p)||""}return""}async getManifest(a,m){if(a.assets.manifest){const p=await this.getAsset(a.assets.manifest,{},m),N=await D.asText(p);return N?JSON.parse(N):null}return null}async getCoreTranslation(a,m){const p=a.assets.coreTranslations.filter(N=>N[0]===m.toUpperCase())[0];if(p){const N=await this.getAsset(p[1]),M=await D.asText(N);return M?JSON.parse(M):null}return null}async getChangelog(a,m){if(a.assets.changelog){const p=await this.getAsset(a.assets.changelog,{},m);return await D.asText(p)||""}return""}async getAllVersions(a,m){let p=new l().withFlags(v.IncludeVersions,v.IncludeFiles,v.IncludeVersionProperties).withPage(1,1).withFilter(r.Target,"Microsoft.VisualStudio.Code");a.identifier.uuid?p=p.withFilter(r.ExtensionId,a.identifier.uuid):p=p.withFilter(r.ExtensionName,a.identifier.id);const N=[],{galleryExtensions:M}=await this.queryGallery(p,C.CancellationToken.None);return M.length&&(m?await Promise.all(M[0].versions.map(async W=>{let B;try{B=await this.getEngine(W)}catch(x){}B&&c.isEngineValid(B,this.productService.version,this.productService.date)&&N.push({version:W.version,date:W.lastUpdated})})):N.push(...M[0].versions.map(W=>({version:W.version,date:W.lastUpdated})))),N}async getAsset(a,m={},p=C.CancellationToken.None){const N=await this.commonHeadersPromise,M={type:"GET"},W=Object.assign(Object.assign({},N),m.headers||{});m=Object.assign(Object.assign(Object.assign({},m),M),{headers:W});const B=a.uri,x=a.fallbackUri,H=Object.assign(Object.assign({},m),{url:B});try{const X=await this.requestService.request(H,p);if(X.res.statusCode===200)return X;const Q=await D.asText(X);throw new Error(`Expected 200, got back ${X.res.statusCode} instead.

${Q}`)}catch(X){if(g.isPromiseCanceledError(X))throw X;const Q=g.getErrorMessage(X);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:B,message:Q});const ie=Object.assign(Object.assign({},m),{url:x});return this.requestService.request(ie,p)}}async getLastValidExtensionVersion(a,m){const p=this.getLastValidExtensionVersionFromProperties(a,m);return p||this.getLastValidExtensionVersionRecursively(a,m)}getLastValidExtensionVersionFromProperties(a,m){for(const p of m){const N=K(p);if(!N)return null;if(c.isEngineValid(N,this.productService.version,this.productService.date))return p}return null}async getEngine(a){const m=K(a);if(m)return m;const p=V(a,e.Manifest);if(!p)throw new Error("Manifest was not found");const N={"Accept-Encoding":"gzip"},M=await this.getAsset(p,{headers:N}),W=await D.asJson(M);if(W)return W.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively(a,m){if(!m.length)return null;const p=m[0],N=await this.getEngine(p);return c.isEngineValid(N,this.productService.version,this.productService.date)?Object.assign(Object.assign({},p),{properties:[...p.properties||[],{key:i.Engine,value:N}]}):this.getLastValidExtensionVersionRecursively(a,m.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const a=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},C.CancellationToken.None);if(a.res.statusCode!==200)throw new Error("Could not get extensions report.");const m=await D.asJson(a),p=new Map;if(m)for(const N of m.malicious){const M=p.get(N)||{id:{id:N},malicious:!0,slow:!1};M.malicious=!0,p.set(N,M)}return[...p.values()]}};re=ue([fe(0,D.IRequestService),fe(1,w.ILogService),fe(2,f.IEnvironmentService),fe(3,F.ITelemetryService),fe(4,y.IFileService),fe(5,u.IProductService),fe(6,R.optional(h.IStorageService))],re),t.ExtensionGalleryService=re;async function T(d,a,m,p){const N={"X-Market-Client-Id":`VSCode ${d}`,"User-Agent":`VSCode ${d}`},M=await b.getServiceMachineId(a,m,p);return N["X-Market-User-Id"]=M,N}t.resolveMarketplaceHeaders=T}),define(J[117],Y([0,1,40,84,19,11,26,30,2,20,25]),function(_,t,g,A,I,L,F,D,c,f,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryService=void 0;let w=class{constructor(u,h){this._configurationService=h,this._experimentProperties={},this._disposables=new c.DisposableStore,this._cleanupPatterns=[],this._appender=u.appender,this._commonProperties=u.commonProperties||Promise.resolve({}),this._piiPaths=u.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!u.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let b of this._piiPaths)this._cleanupPatterns.push(new RegExp(I.escapeRegExpCharacters(b),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(b=>{const R=/^[a-f0-9]+$/i.test(b["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!R})}))}setExperimentProperty(u,h){this._experimentProperties[u]=h}setEnabled(u){this._enabled=u}_updateUserOptIn(){var u;const h=(u=this._configurationService)===null||u===void 0?void 0:u.getValue(y);this._userOptIn=h?h.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const u=await this._commonProperties;let h=u.sessionID,b=u["common.instanceId"],R=u["common.machineId"],P=u["common.firstSessionDate"],v=u["common.msftInternal"];return{sessionId:h,instanceId:b,machineId:R,firstSessionDate:P,msftInternal:v}}dispose(){this._disposables.dispose()}publicLog(u,h,b){return this.isOptedIn?this._commonProperties.then(R=>{h=f.mixin(h,R),h=f.mixin(h,this._experimentProperties),h=f.cloneAndChange(h,P=>{if(typeof P=="string")return this._cleanupInfo(P,b)}),this._appender.log(u,h)},R=>{console.error(R)}):Promise.resolve(void 0)}publicLog2(u,h,b){return this.publicLog(u,h,b)}publicLogError(u,h){return this.sendErrorTelemetry?this.publicLog(u,h,!0):Promise.resolve(void 0)}publicLogError2(u,h){return this.publicLogError(u,h)}_cleanupInfo(u,h){let b=u;if(h){const R=[];for(let r of this._cleanupPatterns)for(;;){const e=r.exec(u);if(!e)break;R.push([e.index,r.lastIndex])}const P=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,v=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let o=0;for(b="";;){const r=v.exec(u);if(!r)break;!P.test(r[0])&&R.every(([e,i])=>r.index<e||r.index>=i)&&(b+=u.substring(o,r.index)+"<REDACTED: user-file-path>",o=v.lastIndex)}o<u.length&&(b+=u.substr(o))}for(let R of this._cleanupPatterns)b=b.replace(R,"");return b}};w.IDLE_START_EVENT_NAME="UserIdleStart",w.IDLE_STOP_EVENT_NAME="UserIdleStop",w=ue([fe(1,L.optional(F.IConfigurationService))],w),t.TelemetryService=w;const y="telemetry";C.Registry.as(D.Extensions.Configuration).registerConfiguration({id:y,order:110,type:"object",title:A.localize(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:g.default.privacyStatementUrl?A.localize(2,null,g.default.privacyStatementUrl):A.localize(1,null),default:!0,restricted:!0,scope:1,tags:["usesOnlineServices"]}}})}),define(J[56],Y([0,1,26,20,12,4]),function(_,t,g,A,I,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.cleanRemoteAuthority=t.validateTelemetryData=t.configurationTelemetry=t.NullAppender=t.combinedAppender=t.NullEndpointTelemetryService=t.NullTelemetryService=void 0,t.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(u,h){return Promise.resolve(void 0)}publicLog2(u,h){return this.publicLog(u,h)}publicLogError(u,h){return Promise.resolve(void 0)}publicLogError2(u,h){return this.publicLogError(u,h)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class F{async publicLog(h,b,R){}async publicLogError(h,b,R){}}t.NullEndpointTelemetryService=F;function D(...u){return{log:(h,b)=>u.forEach(R=>R.log(h,b)),flush:()=>L.Promises.settled(u.map(h=>h.flush()))}}t.combinedAppender=D,t.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function c(u,h){return h.onDidChangeConfiguration(b=>{b.source!==6&&u.publicLog2("updateConfiguration",{configurationSource:g.ConfigurationTargetToString(b.source),configurationKeys:y(b.sourceConfig)})})}t.configurationTelemetry=c;function f(u){const h=Object.create(null),b=Object.create(null),R=Object.create(null);w(u,R);for(let P in R){P=P.length>150?P.substr(P.length-149):P;const v=R[P];typeof v=="number"?b[P]=v:typeof v=="boolean"?b[P]=v?1:0:typeof v=="string"?h[P]=v.substring(0,1023):typeof v!="undefined"&&v!==null&&(h[P]=v)}return{properties:h,measurements:b}}t.validateTelemetryData=f;function C(u){if(!u)return"none";let h="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(R=>{u.indexOf(`${R}+`)===0&&(h=R)}),h}t.cleanRemoteAuthority=C;function w(u,h,b=0,R){if(!!u)for(let P of Object.getOwnPropertyNames(u)){const v=u[P],o=R?R+P:P;Array.isArray(v)?h[o]=A.safeStringify(v):v instanceof Date?h[o]=v.toISOString():I.isObject(v)?b<2?w(v,h,b+1,o+"."):h[o]=A.safeStringify(v):h[o]=v}}function y(u){if(!u)return[];const h=[];return O(h,"",u),h}function O(u,h,b){b&&typeof b=="object"&&!Array.isArray(b)?Object.keys(b).forEach(R=>O(u,h?`${h}.${R}`:R,b[R])):u.push(h)}}),define(J[118],Y([0,1,13,20,56]),function(_,t,g,A,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AppInsightsAppender=void 0;async function L(D){const c=await new Promise((C,w)=>{_(["applicationinsights"],C,w)});let f;return c.defaultClient?(f=new c.TelemetryClient(D),f.channel.setUseDiskRetryCaching(!0)):(c.setup(D).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),f=c.defaultClient),D.indexOf("AIF-")===0&&(f.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),f}class F{constructor(c,f,C){this._eventPrefix=c,this._defaultData=f,this._defaultData||(this._defaultData=Object.create(null)),typeof C=="function"?this._aiClient=C():this._aiClient=C,this._asyncAIClient=null}_withAIClient(c){if(!!this._aiClient){if(typeof this._aiClient!="string"){c(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=L(this._aiClient)),this._asyncAIClient.then(f=>{c(f)},f=>{g.onUnexpectedError(f),console.error(f)})}}log(c,f){!this._aiClient||(f=A.mixin(f,this._defaultData),f=I.validateTelemetryData(f),this._withAIClient(C=>C.trackEvent({name:this._eventPrefix+"/"+c,properties:f.properties,measurements:f.measurements})))}flush(){return this._aiClient?new Promise(c=>{this._withAIClient(f=>{f.flush({callback:()=>{this._aiClient=void 0,c(void 0)}})})}):Promise.resolve(void 0)}}t.AppInsightsAppender=F}),define(J[119],Y([0,1,9,31,3]),function(_,t,g,A,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buildTelemetryMessage=void 0;function L(F,D){const c=Object.create(null),f=(w,y)=>{const O=JSON.parse(w);c[y]=O};if(D){const w=g.readdirSync(D).filter(O=>{try{return A.statSync(I.join(D,O)).isDirectory()}catch(u){return!1}}),y=[];w.forEach(O=>{g.readdirSync(I.join(D,O)).filter(h=>h==="telemetry.json").length===1&&y.push(O)}),y.forEach(O=>{const u=A.readFileSync(I.join(D,O,"telemetry.json")).toString();f(u,O)})}let C=A.readFileSync(I.join(F,"telemetry-core.json")).toString();return f(C,"vscode-core"),C=A.readFileSync(I.join(F,"telemetry-extensions.json")).toString(),f(C,"vscode-extensions"),JSON.stringify(c,null,4)}t.buildTelemetryMessage=L}),define(J[43],Y([0,1,72,3,31,4,9,130,131,12]),function(_,t,g,A,I,L,F,D,c,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buffer=t.extract=t.zip=t.ExtractError=void 0;class C extends Error{constructor(e,i){let n=i.message;switch(e){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n);this.type=e,this.cause=i}}t.ExtractError=C;function w(r){const e=r.externalFileAttributes>>16||33188;return[448,56,7].map(i=>e&i).reduce((i,n)=>i+n,e&61440)}function y(r){if(r instanceof C)return r;let e;return/end of central directory record signature not found/.test(r.message)&&(e="CorruptZip"),new C(e,r)}function O(r,e,i,n,s,l){const E=A.dirname(e),S=A.join(n,E);if(!S.startsWith(n))return Promise.reject(new Error(g.localize(0,null,e)));const U=A.join(n,e);let k;return l.onCancellationRequested(()=>{k&&k.destroy()}),Promise.resolve(F.Promises.mkdir(S,{recursive:!0})).then(()=>new Promise((j,V)=>{if(!l.isCancellationRequested)try{k=I.createWriteStream(U,{mode:i}),k.once("close",()=>j()),k.once("error",V),r.once("error",V),r.pipe(k)}catch($){V($)}}))}function u(r,e,i,n){let s=L.createCancelablePromise(()=>Promise.resolve()),l=0;return n.onCancellationRequested(()=>{s.cancel(),r.close()}),new Promise((E,S)=>{const U=new L.Sequencer,k=j=>{j.isCancellationRequested||(l++,r.readEntry())};r.once("error",S),r.once("close",()=>s.then(()=>{n.isCancellationRequested||r.entryCount===l?E():S(new C("Incomplete",new Error(g.localize(1,null,l,r.entryCount))))},S)),r.readEntry(),r.on("entry",j=>{if(n.isCancellationRequested)return;if(!i.sourcePathRegex.test(j.fileName)){k(n);return}const V=j.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(V)){const ee=A.join(e,V);s=L.createCancelablePromise(te=>F.Promises.mkdir(ee,{recursive:!0}).then(()=>k(te)).then(void 0,S));return}const $=b(r,j),K=w(j);s=L.createCancelablePromise(ee=>U.queue(()=>$.then(te=>O(te,V,K,e,i,ee).then(()=>k(ee)))).then(null,S))})})}function h(r,e=!1){return new Promise((i,n)=>{D.open(r,e?{lazyEntries:!0}:void 0,(s,l)=>{s?n(y(s)):i(f.assertIsDefined(l))})})}function b(r,e){return new Promise((i,n)=>{r.openReadStream(e,(s,l)=>{s?n(y(s)):i(f.assertIsDefined(l))})})}function R(r,e){return new Promise((i,n)=>{const s=new c.ZipFile;e.forEach(E=>{E.contents?s.addBuffer(typeof E.contents=="string"?Buffer.from(E.contents,"utf8"):E.contents,E.path):E.localPath&&s.addFile(E.localPath,E.path)}),s.end();const l=I.createWriteStream(r);s.outputStream.pipe(l),s.outputStream.once("error",n),l.once("error",n),l.once("finish",()=>i(r))})}t.zip=R;function P(r,e,i={},n){const s=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let l=h(r,!0);return i.overwrite&&(l=l.then(E=>F.rimraf(e).then(()=>E))),l.then(E=>u(E,e,{sourcePathRegex:s},n))}t.extract=P;function v(r,e){return h(r).then(i=>new Promise((n,s)=>{i.on("entry",l=>{l.fileName===e&&b(i,l).then(E=>n(E),E=>s(E))}),i.once("close",()=>s(new Error(g.localize(2,null,e))))}))}function o(r,e){return v(r,e).then(i=>new Promise((n,s)=>{const l=[];i.once("error",s),i.on("data",E=>l.push(E)),i.on("end",()=>n(Buffer.concat(l)))}))}t.buffer=o}),define(J[120],Y([0,1,43,77]),function(_,t,g,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getManifest=void 0;function I(L){return g.buffer(L,"extension/package.json").then(F=>{try{return JSON.parse(F.toString("utf8"))}catch(D){throw new Error(A.localize(0,null))}})}t.getManifest=I}),define(J[121],Y([0,1,39,2,9,3,15,23,24,4,7,21,89,78,41,43,14,22,8,18,17,29,13]),function(_,t,g,A,I,L,F,D,c,f,C,w,y,O,u,h,b,R,P,v,o,r,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsScanner=void 0;const i="scanningSystem",n="scanningUser",s="extracting",l="deleting",E="renaming";let S=class extends A.Disposable{constructor(k,j,V,$,K){super();this.beforeRemovingExtension=k,this.fileService=j,this.logService=V,this.environmentService=$,this.productService=K,this._devSystemExtensionsPath=null,this.systemExtensionsPath=$.builtinExtensionsPath,this.extensionsPath=$.extensionsPath,this.uninstalledPath=L.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new f.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(k){const j=[];(k===null||k===0)&&j.push(this.scanSystemExtensions().then(null,V=>Promise.reject(new D.ExtensionManagementError(this.joinErrors(V).message,i)))),(k===null||k===1)&&j.push(this.scanUserExtensions(!0).then(null,V=>Promise.reject(new D.ExtensionManagementError(this.joinErrors(V).message,n))));try{const V=await Promise.all(j);return R.flatten(V)}catch(V){throw this.joinErrors(V)}}async scanUserExtensions(k){this.logService.trace("Started scanning user extensions");let[j,V]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return V=V.filter($=>!j[new c.ExtensionIdentifierWithVersion($.identifier,$.manifest.version).key()]),k&&(V=c.groupByExtension(V,K=>K.identifier).map(K=>K.sort((ee,te)=>g.rcompare(ee.manifest.version,te.manifest.version))[0])),this.logService.trace("Scanned user extensions:",V.length),V}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(k,j,V){const $=k.key(),K=L.join(this.extensionsPath,`.${r.generateUuid()}`),ee=L.join(this.extensionsPath,$);try{await I.rimraf(ee)}catch(Z){try{await I.rimraf(ee)}catch(ae){}throw new D.ExtensionManagementError(O.localize(0,null,ee,k.id),l)}await this.extractAtLocation(k,j,K,V);let te=await this.scanExtension(C.URI.file(K),1);if(!te)throw new Error(O.localize(1,null,K));await this.storeMetadata(te,{installedTimestamp:Date.now()});try{await this.rename(k,K,ee,Date.now()+2*60*1e3),this.logService.info("Renamed to",ee)}catch(Z){try{await I.rimraf(K)}catch(ae){}if(Z.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",k.id);else throw this.logService.info(`Rename failed because of ${e.getErrorMessage(Z)}. Deleted from extracted location`,K),Z}try{te=await this.scanExtension(C.URI.file(ee),1)}catch(Z){}if(te)return te;throw new Error(O.localize(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(k,j){return this.setMetadata(k,j),await this.storeMetadata(k,Object.assign(Object.assign({},j),{installedTimestamp:k.installedTimestamp})),k}async storeMetadata(k,j){j.isMachineScoped=j.isMachineScoped||void 0,j.isBuiltin=j.isBuiltin||void 0,j.installedTimestamp=j.installedTimestamp||void 0;const V=L.join(k.location.fsPath,"package.json"),$=await I.Promises.readFile(V,"utf8"),{manifest:K}=await this.parseManifest($);return K.__metadata=j,await I.writeFile(V,JSON.stringify(K,null,"	")),k}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...k){const j=k.map(V=>new c.ExtensionIdentifierWithVersion(V.identifier,V.manifest.version));await this.withUninstalledExtensions(V=>{j.forEach($=>V[$.key()]=!0)})}async setInstalled(k){await this.withUninstalledExtensions($=>delete $[k.key()]);const V=(await this.scanExtensions(1)).find($=>new c.ExtensionIdentifierWithVersion($.identifier,$.manifest.version).equals(k))||null;return V?(await this.storeMetadata(V,{installedTimestamp:Date.now()}),this.scanExtension(V.location,1)):null}async withUninstalledExtensions(k){return this.uninstalledFileLimiter.queue(async()=>{let j;try{j=await I.Promises.readFile(this.uninstalledPath,"utf8")}catch($){if($.code!=="ENOENT")throw $}let V={};if(j)try{V=JSON.parse(j)}catch($){}return k&&(k(V),Object.keys(V).length?await I.writeFile(this.uninstalledPath,JSON.stringify(V)):await I.rimraf(this.uninstalledPath)),V})}async removeExtension(k,j){this.logService.trace(`Deleting ${j} extension from disk`,k.identifier.id,k.location.fsPath),await I.rimraf(k.location.fsPath),this.logService.info("Deleted from disk",k.identifier.id,k.location.fsPath)}async removeUninstalledExtension(k){await this.removeExtension(k,"uninstalled"),await this.withUninstalledExtensions(j=>delete j[new c.ExtensionIdentifierWithVersion(k.identifier,k.manifest.version).key()])}async extractAtLocation(k,j,V,$){this.logService.trace(`Started extracting the extension from ${j} to ${V}`);try{await I.rimraf(V)}catch(K){throw new D.ExtensionManagementError(this.joinErrors(K).message,l)}try{await h.extract(j,V,{sourcePath:"extension",overwrite:!0},$),this.logService.info(`Extracted extension to ${V}:`,k.id)}catch(K){try{await I.rimraf(V)}catch(ee){}throw new D.ExtensionManagementError(K.message,K instanceof h.ExtractError&&K.type?K.type:s)}}async rename(k,j,V,$){try{await I.Promises.rename(j,V)}catch(K){if(b.isWindows&&K&&K.code==="EPERM"&&Date.now()<$)return this.logService.info(`Failed renaming ${j} to ${V} with 'EPERM' error. Trying again...`,k.id),this.rename(k,j,V,$);throw new D.ExtensionManagementError(K.message||O.localize(3,null,j,V),K.code||E)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const k=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return k;const j=this.scanDevSystemExtensions(),[V,$]=await Promise.all([k,j]);return[...V,...$]}async scanExtensionsInDir(k,j){const V=new f.Limiter(10),$=await this.fileService.resolve(C.URI.file(k));return $.children?(await Promise.all($.children.filter(ee=>ee.isDirectory).map(ee=>V.queue(async()=>j===1&&o.basename(ee.resource).indexOf(".")===0?null:this.scanExtension(ee.resource,j))))).filter(ee=>ee&&ee.identifier):[]}async scanExtension(k,j){var V,$;try{const K=await this.fileService.resolve(k);if(K.children){const{manifest:ee,metadata:te}=await this.readManifest(k.fsPath),Z=(V=K.children.find(({name:T})=>/^readme(\.txt|\.md|)$/i.test(T)))===null||V===void 0?void 0:V.resource,ae=($=K.children.find(({name:T})=>/^changelog(\.txt|\.md|)$/i.test(T)))===null||$===void 0?void 0:$.resource,se={id:c.getGalleryExtensionId(ee.publisher,ee.name)},re={type:j,identifier:se,manifest:ee,location:k,readmeUrl:Z,changelogUrl:ae,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:j===0};return te&&(this.setMetadata(re,te),re.installedTimestamp=te.installedTimestamp),re}}catch(K){j!==0&&this.logService.trace(K)}return null}async scanDefaultSystemExtensions(){const k=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",k.length),k}async scanDevSystemExtensions(){const k=this.getDevSystemExtensionsList();if(k.length){const j=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",j.length),j.filter(V=>k.some($=>c.areSameExtensions(V.identifier,{id:$})))}else return[]}setMetadata(k,j){k.publisherDisplayName=j.publisherDisplayName||null,k.publisherId=j.publisherId||null,k.identifier.uuid=j.id,k.isMachineScoped=!!j.isMachineScoped,k.isBuiltin=k.type===0||!!j.isBuiltin}async removeUninstalledExtensions(){const k=await this.getUninstalledExtensions(),j=await this.scanAllUserExtensions(),V=new Set;for(const ee of j)k[new c.ExtensionIdentifierWithVersion(ee.identifier,ee.manifest.version).key()]||V.add(ee.identifier.id.toLowerCase());const $=c.groupByExtension(j,ee=>ee.identifier);await f.Promises.settled($.map(async ee=>{const te=ee.sort((Z,ae)=>g.rcompare(Z.manifest.version,ae.manifest.version))[0];V.has(te.identifier.id.toLowerCase())||await this.beforeRemovingExtension(te)}));const K=j.filter(ee=>k[new c.ExtensionIdentifierWithVersion(ee.identifier,ee.manifest.version).key()]);await f.Promises.settled(K.map(ee=>this.removeUninstalledExtension(ee)))}async removeOutdatedExtensions(){const k=await this.scanAllUserExtensions(),j=[],V=c.groupByExtension(k,$=>$.identifier);j.push(...R.flatten(V.map($=>$.sort((K,ee)=>g.rcompare(K.manifest.version,ee.manifest.version)).slice(1)))),await f.Promises.settled(j.map($=>this.removeExtension($,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(k=>k.name)}joinErrors(k){const j=Array.isArray(k)?k:[k];return j.length===1?j[0]instanceof Error?j[0]:new Error(j[0]):j.reduce((V,$)=>new Error(`${V.message}${V.message?",":""}${$ instanceof Error?$.message:$}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=L.normalize(L.join(P.FileAccess.asFileUri("",_).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(k){const j=[I.Promises.readFile(L.join(k,"package.json"),"utf8").then(ee=>this.parseManifest(ee)),I.Promises.readFile(L.join(k,"package.nls.json"),"utf8").then(void 0,ee=>ee.code!=="ENOENT"?Promise.reject(ee):"{}").then(ee=>JSON.parse(ee))],[{manifest:V,metadata:$},K]=await Promise.all(j);return{manifest:y.localizeManifest(V,K),metadata:$}}parseManifest(k){return new Promise((j,V)=>{try{const $=JSON.parse(k),K=$.__metadata||null;j({manifest:$,metadata:K})}catch($){V(new Error(O.localize(4,null)))}})}};S=ue([fe(1,v.IFileService),fe(2,F.ILogService),fe(3,w.INativeEnvironmentService),fe(4,u.IProductService)],S),t.ExtensionsScanner=S}),define(J[122],Y([0,1,76,3,9,2,22,43,23,24,21,4,10,39,7,40,14,15,97,28,42,49,17,29,95,11,8,27,120,101,121,102,103,18]),function(_,t,g,A,I,L,F,D,c,f,C,w,y,O,u,h,b,R,P,v,o,r,e,i,n,s,l,E,S,U,k,j,V,$){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementService=void 0;const K="unsetUninstalled",ee="downloading",te="validating",Z="local",ae="unknown";let se=class extends L.Disposable{constructor(T,d,a,m,p,N,M){super();this.environmentService=T,this.galleryService=d,this.logService=a,this.downloadService=m,this.telemetryService=p,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new y.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtension=this._register(new y.Emitter),this.onDidInstallExtension=this._onDidInstallExtension.event,this._onUninstallExtension=this._register(new y.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new y.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event;const W=this._register(N.createInstance(j.ExtensionsLifecycle));this.extensionsScanner=this._register(N.createInstance(k.ExtensionsScanner,x=>W.postUninstall(x))),this.manifestCache=this._register(new P.ExtensionsManifestCache(T,this)),this.extensionsDownloader=this._register(N.createInstance(U.ExtensionsDownloader));const B=this._register(new V.ExtensionsWatcher(this,M,T,a));this._register(B.onDidChangeExtensionsByAnotherSource(({added:x,removed:H})=>{x.forEach(X=>this._onDidInstallExtension.fire({identifier:X.identifier,operation:0,local:X})),H.forEach(X=>this._onDidUninstallExtension.fire({identifier:X}))})),this._register(L.toDisposable(()=>{this.installingExtensions.forEach(x=>x.cancel()),this.uninstallingExtensions.forEach(x=>x.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async zip(T){this.logService.trace("ExtensionManagementService#zip",T.identifier.id);const d=await this.collectFiles(T),a=await D.zip(e.joinPath(this.environmentService.tmpDir,i.generateUuid()).fsPath,d);return u.URI.file(a)}async unzip(T){return this.logService.trace("ExtensionManagementService#unzip",T.toString()),(await this.install(T)).identifier}async getManifest(T){const d=await this.downloadVsix(T),a=A.resolve(d.fsPath);return S.getManifest(a)}async collectFiles(T){const d=async m=>{let p=await I.readdir(m);p=p.map(W=>A.join(m,W));const N=await Promise.all(p.map(W=>I.Promises.stat(W)));let M=Promise.resolve([]);return N.forEach((W,B)=>{const x=p[B];W.isFile()&&(M=M.then(H=>[...H,x])),W.isDirectory()&&(M=M.then(H=>d(x).then(X=>[...H,...X])))}),M};return(await d(T.location.fsPath)).map(m=>({path:`extension/${A.relative(T.location.fsPath,m)}`,localPath:m}))}async install(T,d={}){return this.logService.trace("ExtensionManagementService#install",T.toString()),w.createCancelablePromise(async a=>{const m=await this.downloadVsix(T),p=A.resolve(m.fsPath),N=await S.getManifest(p),M={id:f.getGalleryExtensionId(N.publisher,N.name)};let W=1;if(N.engines&&N.engines.vscode&&!r.isEngineValid(N.engines.vscode,h.default.version,h.default.date))throw new Error(g.localize(0,null,M.id,h.default.version));const B=new f.ExtensionIdentifierWithVersion(M,N.version),H=(await this.getInstalled(1)).find(Q=>f.areSameExtensions(M,Q.identifier));if(H)if(d.isMachineScoped=d.isMachineScoped||H.isMachineScoped,d.isBuiltin=d.isBuiltin||H.isBuiltin,W=2,B.equals(new f.ExtensionIdentifierWithVersion(H.identifier,H.manifest.version)))try{await this.extensionsScanner.removeExtension(H,"existing")}catch(Q){throw new Error(g.localize(1,null,N.displayName||N.name))}else O.gt(H.manifest.version,N.version)&&await this.uninstallExtension(H);else{const Q=await this.unsetUninstalledAndGetLocal(B);if(Q)try{await this.extensionsScanner.removeExtension(Q,"existing")}catch(ie){throw new Error(g.localize(2,null,N.displayName||N.name))}}this.logService.info("Installing the extension:",M.id),this._onInstallExtension.fire({identifier:M,zipPath:p});let X;try{X=await this.getGalleryMetadata(f.getGalleryExtensionId(N.publisher,N.name))}catch(Q){}try{const Q=await this.installFromZipPath(B,p,d.installOnlyNewlyAddedFromExtensionPack?H:void 0,Object.assign(Object.assign({},X||{}),d),d,W,a);return this.logService.info("Successfully installed the extension:",M.id),Q}catch(Q){throw this.logService.error("Failed to install the extension:",M.id,Q.message),Q}})}async downloadVsix(T){if(T.scheme===l.Schemas.file)return T;if(!this.downloadService)throw new Error("Download service is not available");const d=e.joinPath(this.environmentService.tmpDir,i.generateUuid());return await this.downloadService.download(T,d),d}async installFromZipPath(T,d,a,m,p,N,M){try{const W=await this.installExtension({zipPath:d,identifierWithVersion:T,metadata:m},M);try{p.donotIncludePackAndDependencies||await this.installDependenciesAndPackExtensions(W,a,p)}catch(B){F.isNonEmptyArray(W.manifest.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",W.identifier.id,B.message),F.isNonEmptyArray(W.manifest.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",W.identifier.id,B.message)}return this._onDidInstallExtension.fire({identifier:T,zipPath:d,local:W,operation:N}),W}catch(W){throw this._onDidInstallExtension.fire({identifier:T,zipPath:d,operation:N,error:W}),W}}async canInstall(T){return!0}async installFromGallery(T,d={}){if(!this.galleryService.isEnabled())throw new Error(g.localize(3,null));try{T=await this.checkAndGetCompatibleVersion(T)}catch(p){const N=p&&p.code?p.code:ae;throw this.logService.error("Failed to install extension:",T.identifier.id,p?p.message:N),this.reportTelemetry(this.getTelemetryEvent(1),f.getGalleryExtensionTelemetryData(T),void 0,p),p instanceof Error&&(p.name=N),p}const a=new f.ExtensionIdentifierWithVersion(T.identifier,T.version).key();let m=this.installingExtensions.get(a);return m||(m=w.createCancelablePromise(p=>this.doInstallFromGallery(T,d,p)),this.installingExtensions.set(a,m),m.finally(()=>this.installingExtensions.delete(a))),m}async doInstallFromGallery(T,d,a){const m=new Date().getTime();let p=1;this.logService.info("Installing extension:",T.identifier.id),this._onInstallExtension.fire({identifier:T.identifier,gallery:T});try{const M=(await this.getInstalled(1)).find(x=>f.areSameExtensions(x.identifier,T.identifier));M&&(p=2);const W=await this.downloadInstallableExtension(T,p);W.metadata.isMachineScoped=d.isMachineScoped||(M==null?void 0:M.isMachineScoped),W.metadata.isBuiltin=d.isBuiltin||(M==null?void 0:M.isBuiltin);const B=await this.installExtension(W,a);try{await this.extensionsDownloader.delete(u.URI.file(W.zipPath))}catch(x){}if(!d.donotIncludePackAndDependencies)try{await this.installDependenciesAndPackExtensions(B,M,d)}catch(x){try{await this.uninstall(B)}catch(H){}throw x}return M&&O.neq(M.manifest.version,T.version)&&await this.extensionsScanner.setUninstalled(M),this.logService.info("Extensions installed successfully:",T.identifier.id),this._onDidInstallExtension.fire({identifier:T.identifier,gallery:T,local:B,operation:p}),this.reportTelemetry(this.getTelemetryEvent(p),f.getGalleryExtensionTelemetryData(T),new Date().getTime()-m,void 0),B}catch(N){const M=N&&N.code?N.code:ae;throw this.logService.error("Failed to install extension:",T.identifier.id,N?N.message:M),this._onDidInstallExtension.fire({identifier:T.identifier,gallery:T,operation:p,error:M}),this.reportTelemetry(this.getTelemetryEvent(p),f.getGalleryExtensionTelemetryData(T),new Date().getTime()-m,N),N instanceof Error&&(N.name=M),N}}async checkAndGetCompatibleVersion(T){if(await this.isMalicious(T))throw new c.ExtensionManagementError(g.localize(4,null),c.INSTALL_ERROR_MALICIOUS);const d=await this.galleryService.getCompatibleExtension(T);if(!d)throw new c.ExtensionManagementError(g.localize(5,null,T.identifier.id,h.default.version),c.INSTALL_ERROR_INCOMPATIBLE);return d}async reinstallFromGallery(T){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",T.identifier.id),!this.galleryService.isEnabled())throw new Error(g.localize(6,null));const d=await this.findGalleryExtension(T);if(!d)throw new Error(g.localize(7,null));await this.extensionsScanner.setUninstalled(T);try{await this.extensionsScanner.removeUninstalledExtension(T)}catch(a){throw new Error(g.localize(8,null,v.toErrorMessage(a)))}await this.installFromGallery(d)}getTelemetryEvent(T){return T===2?"extensionGallery:update":"extensionGallery:install"}async isMalicious(T){const d=await this.getExtensionsReport();return f.getMaliciousExtensionsSet(d).has(T.identifier.id)}async downloadInstallableExtension(T,d){const a={id:T.identifier.uuid,publisherId:T.publisherId,publisherDisplayName:T.publisherDisplayName};let m;try{this.logService.trace("Started downloading extension:",T.identifier.id),m=(await this.extensionsDownloader.downloadExtension(T,d)).fsPath,this.logService.info("Downloaded extension:",T.identifier.id,m)}catch(p){throw new c.ExtensionManagementError(this.joinErrors(p).message,ee)}try{const p=await S.getManifest(m);return{zipPath:m,identifierWithVersion:new f.ExtensionIdentifierWithVersion(T.identifier,p.version),metadata:a}}catch(p){throw new c.ExtensionManagementError(this.joinErrors(p).message,te)}}async installExtension(T,d){try{const a=await this.unsetUninstalledAndGetLocal(T.identifierWithVersion);if(a)return T.metadata?this.extensionsScanner.saveMetadataForLocalExtension(a,T.metadata):a}catch(a){throw b.isMacintosh?new c.ExtensionManagementError(g.localize(9,null),K):new c.ExtensionManagementError(g.localize(10,null),K)}return this.extractAndInstall(T,d)}async unsetUninstalledAndGetLocal(T){if(!await this.isUninstalled(T))return null;this.logService.trace("Removing the extension from uninstalled list:",T.id);const a=await this.extensionsScanner.setInstalled(T);return this.logService.info("Removed the extension from uninstalled list:",T.id),a}async extractAndInstall({zipPath:T,identifierWithVersion:d,metadata:a},m){let p=await this.extensionsScanner.extractUserExtension(d,T,m);return this.logService.info("Installation completed.",d.id),a&&(p=await this.extensionsScanner.saveMetadataForLocalExtension(p,a)),p}async installDependenciesAndPackExtensions(T,d,a){if(!this.galleryService.isEnabled())return;const m=T.manifest.extensionDependencies||[];if(T.manifest.extensionPack)for(const p of T.manifest.extensionPack)d&&d.manifest.extensionPack&&d.manifest.extensionPack.some(N=>f.areSameExtensions({id:N},{id:p}))||m.every(N=>!f.areSameExtensions({id:N},{id:p}))&&m.push(p);if(m.length){const p=await this.getInstalled(),N=m.filter(M=>p.every(({identifier:W})=>!f.areSameExtensions(W,{id:M})));if(N.length){const W=(await this.galleryService.query({names:N,pageSize:m.length},E.CancellationToken.None)).firstPage;try{await w.Promises.settled(W.map(B=>this.installFromGallery(B,a)))}catch(B){try{await this.rollback(W)}catch(x){}throw B}}}}async rollback(T){const a=(await this.getInstalled(1)).filter(m=>T.some(p=>new f.ExtensionIdentifierWithVersion(m.identifier,m.manifest.version).equals(new f.ExtensionIdentifierWithVersion(p.identifier,p.version))));await w.Promises.settled(a.map(m=>this.uninstall(m)))}async uninstall(T,d={}){this.logService.trace("ExtensionManagementService#uninstall",T.identifier.id);const a=await this.getInstalled(1),m=a.find(p=>f.areSameExtensions(p.identifier,T.identifier));if(!m)throw new Error(g.localize(11,null,T.manifest.displayName||T.manifest.name));try{await this.checkForDependenciesAndUninstall(m,a,d)}catch(p){throw this.joinErrors(p)}}async updateMetadata(T,d){return this.logService.trace("ExtensionManagementService#updateMetadata",T.identifier.id),T=await this.extensionsScanner.saveMetadataForLocalExtension(T,Object.assign(Object.assign({},T.manifest.__metadata||{}),d)),this.manifestCache.invalidate(),T}async updateExtensionScope(T,d){return this.logService.trace("ExtensionManagementService#updateExtensionScope",T.identifier.id),T=await this.extensionsScanner.saveMetadataForLocalExtension(T,Object.assign(Object.assign({},T.manifest.__metadata||{}),{isMachineScoped:d})),this.manifestCache.invalidate(),T}async getGalleryMetadata(T){const d=await this.findGalleryExtensionByName(T);return d?{id:d.identifier.uuid,publisherDisplayName:d.publisherDisplayName,publisherId:d.publisherId}:void 0}async findGalleryExtension(T){if(T.identifier.uuid){const d=await this.findGalleryExtensionById(T.identifier.uuid);return d||this.findGalleryExtensionByName(T.identifier.id)}return this.findGalleryExtensionByName(T.identifier.id)}async findGalleryExtensionById(T){return(await this.galleryService.query({ids:[T],pageSize:1},E.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(T){return(await this.galleryService.query({names:[T],pageSize:1},E.CancellationToken.None)).firstPage[0]}joinErrors(T){const d=Array.isArray(T)?T:[T];return d.length===1?d[0]instanceof Error?d[0]:new Error(d[0]):d.reduce((a,m)=>new Error(`${a.message}${a.message?",":""}${m instanceof Error?m.message:m}`),new Error(""))}async checkForDependenciesAndUninstall(T,d,a){try{await this.preUninstallExtension(T);const m=a.donotIncludePack?[]:this.getAllPackExtensionsToUninstall(T,d);await this.uninstallExtensions(T,m,d,a)}catch(m){throw await this.postUninstallExtension(T,new c.ExtensionManagementError(m instanceof Error?m.message:m,Z)),m}await this.postUninstallExtension(T)}async uninstallExtensions(T,d,a,m){const p=[T,...d];if(!m.donotCheckDependents)for(const N of p)this.checkForDependents(N,p,a,T);await w.Promises.settled([this.uninstallExtension(T),...d.map(N=>this.doUninstall(N))])}checkForDependents(T,d,a,m){const p=this.getDependents(T,a);if(p.length){const N=p.filter(M=>d.indexOf(M)===-1);if(N.length)throw new Error(this.getDependentsErrorMessage(T,N,m))}}getDependentsErrorMessage(T,d,a){return a===T?d.length===1?g.localize(12,null,a.manifest.displayName||a.manifest.name,d[0].manifest.displayName||d[0].manifest.name):d.length===2?g.localize(13,null,a.manifest.displayName||a.manifest.name,d[0].manifest.displayName||d[0].manifest.name,d[1].manifest.displayName||d[1].manifest.name):g.localize(14,null,a.manifest.displayName||a.manifest.name,d[0].manifest.displayName||d[0].manifest.name,d[1].manifest.displayName||d[1].manifest.name):d.length===1?g.localize(15,null,a.manifest.displayName||a.manifest.name,T.manifest.displayName||T.manifest.name,d[0].manifest.displayName||d[0].manifest.name):d.length===2?g.localize(16,null,a.manifest.displayName||a.manifest.name,T.manifest.displayName||T.manifest.name,d[0].manifest.displayName||d[0].manifest.name,d[1].manifest.displayName||d[1].manifest.name):g.localize(17,null,a.manifest.displayName||a.manifest.name,T.manifest.displayName||T.manifest.name,d[0].manifest.displayName||d[0].manifest.name,d[1].manifest.displayName||d[1].manifest.name)}getAllPackExtensionsToUninstall(T,d,a=[]){if(a.indexOf(T)!==-1)return[];a.push(T);const m=T.manifest.extensionPack?T.manifest.extensionPack:[];if(m.length){const p=d.filter(M=>!M.isBuiltin&&m.some(W=>f.areSameExtensions({id:W},M.identifier))),N=[];for(const M of p)N.push(...this.getAllPackExtensionsToUninstall(M,d,a));return[...p,...N]}return[]}getDependents(T,d){return d.filter(a=>a.manifest.extensionDependencies&&a.manifest.extensionDependencies.some(m=>f.areSameExtensions({id:m},T.identifier)))}async doUninstall(T){try{await this.preUninstallExtension(T),await this.uninstallExtension(T)}catch(d){throw await this.postUninstallExtension(T,new c.ExtensionManagementError(d instanceof Error?d.message:d,Z)),d}await this.postUninstallExtension(T)}async preUninstallExtension(T){if(!await I.exists(T.location.fsPath))throw new Error(g.localize(18,null));this.logService.info("Uninstalling extension:",T.identifier.id),this._onUninstallExtension.fire(T.identifier)}async uninstallExtension(T){let d=this.uninstallingExtensions.get(T.identifier.id);return d||(d=w.createCancelablePromise(async()=>{const a=await this.extensionsScanner.scanUserExtensions(!1);await this.extensionsScanner.setUninstalled(...a.filter(m=>f.areSameExtensions(m.identifier,T.identifier)))}),this.uninstallingExtensions.set(T.identifier.id,d),d.finally(()=>this.uninstallingExtensions.delete(T.identifier.id))),d}async postUninstallExtension(T,d){if(d)this.logService.error("Failed to uninstall extension:",T.identifier.id,d.message);else if(this.logService.info("Successfully uninstalled extension:",T.identifier.id),T.identifier.uuid)try{await this.galleryService.reportStatistic(T.manifest.publisher,T.manifest.name,T.manifest.version,"uninstall")}catch(m){}this.reportTelemetry("extensionGallery:uninstall",f.getLocalExtensionTelemetryData(T),void 0,d);const a=d?d instanceof c.ExtensionManagementError?d.code:ae:void 0;this._onDidUninstallExtension.fire({identifier:T.identifier,error:a})}getInstalled(T=null){return this.extensionsScanner.scanExtensions(T)}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async isUninstalled(T){return(await this.filterUninstalled(T)).length===1}async filterUninstalled(...T){const d=[],a=await this.extensionsScanner.getUninstalledExtensions();for(const m of T)a[m.key()]&&d.push(m.key());return d}getExtensionsReport(){const T=new Date().getTime();return(!this.reportedExtensions||T-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=T),this.reportedExtensions}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const T=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${T.length} reported extensions from service`),T}catch(T){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}reportTelemetry(T,d,a,m){const p=m?m instanceof c.ExtensionManagementError?m.code:ae:void 0;this.telemetryService.publicLogError(T,Object.assign(Object.assign({},d),{success:!m,duration:a,errorcode:p}))}};se=ue([fe(0,C.INativeEnvironmentService),fe(1,c.IExtensionGalleryService),fe(2,R.ILogService),fe(3,s.optional(n.IDownloadService)),fe(4,o.ITelemetryService),fe(5,s.IInstantiationService),fe(6,$.IFileService)],se),t.ExtensionManagementService=se}),define(J[123],Y([0,1,132,112,2,12,13,111,26,15,16,21,98]),function(_,t,g,A,I,L,F,D,c,f,C,w,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RequestService=void 0;let O=class extends I.Disposable{constructor(h,b,R){super();this.environmentService=b,this.logService=R,this.configure(h.getValue()),this._register(h.onDidChangeConfiguration(()=>this.configure(h.getValue()),this))}configure(h){this.proxyUrl=h.http&&h.http.proxy,this.strictSSL=!!(h.http&&h.http.proxyStrictSSL),this.authorization=h.http&&h.http.proxyAuthorization}async request(h,b){this.logService.trace("RequestService#request",h.url);const{proxyUrl:R,strictSSL:P}=this,v=Object.assign(Object.assign({},process.env),await y.resolveShellEnv(this.logService,this.environmentService.args,process.env)),o=h.agent?h.agent:await D.getProxyAgent(h.url||"",v,{proxyUrl:R,strictSSL:P});return h.agent=o,h.strictSSL=P,this.authorization&&(h.headers=Object.assign(Object.assign({},h.headers||{}),{"Proxy-Authorization":this.authorization})),this._request(h,b)}async getNodeRequest(h){return(A.parse(h.url).protocol==="https:"?await new Promise((P,v)=>{_(["https"],P,v)}):await new Promise((P,v)=>{_(["http"],P,v)})).request}_request(h,b){return new Promise(async(R,P)=>{let v;const o=A.parse(h.url),r=h.getRawRequest?h.getRawRequest(h):await this.getNodeRequest(h),e={hostname:o.hostname,port:o.port?parseInt(o.port):o.protocol==="https:"?443:80,protocol:o.protocol,path:o.path,method:h.type||"GET",headers:h.headers,agent:h.agent,rejectUnauthorized:L.isBoolean(h.strictSSL)?h.strictSSL:!0};h.user&&h.password&&(e.auth=h.user+":"+h.password),v=r(e,i=>{const n=L.isNumber(h.followRedirects)?h.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)this._request(Object.assign(Object.assign({},h),{url:i.headers.location,followRedirects:n-1}),b).then(R,P);else{let s=i;i.headers["content-encoding"]==="gzip"&&(s=i.pipe(g.createGunzip())),R({res:i,stream:C.streamToBufferReadableStream(s)})}}),v.on("error",P),h.timeout&&v.setTimeout(h.timeout),h.data&&typeof h.data=="string"&&v.write(h.data),v.end(),b.onCancellationRequested(()=>{v.abort(),P(F.canceled())})})}async resolveProxy(h){}};O=ue([fe(0,c.IConfigurationService),fe(1,w.INativeEnvironmentService),fe(2,f.ILogService)],O),t.RequestService=O}),define(J[133],Y([0,1,32,31,134,9,3,4,40,52,50,100,21,88,23,122,116,42,56,117,115,55,123,26,110,118,15,8,105,119,106,18,107,2,41,96,7,104,53,13,28,16,34]),function(_,t,g,A,I,L,F,D,c,f,C,w,y,O,u,h,b,R,P,v,o,r,e,i,n,s,l,E,S,U,k,j,V,$,K,ee,te,Z,ae,se,re,T,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.main=void 0;class a extends $.Disposable{constructor(N){super();this.argv=N,I.gracefulify(A),this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[N,M]=await this.initServices();return N.invokeFunction(async W=>{const B=W.get(l.ILogService),x=W.get(j.IFileService),H=W.get(y.INativeEnvironmentService),X=W.get(u.IExtensionManagementCLIService);return B.info("CLI main",this.argv),this.registerErrorHandler(B),await this.doRun(H,X,x),D.raceTimeout(P.combinedAppender(...M).flush(),1e3)})}async initServices(){const N=new f.ServiceCollection,M=Object.assign({_serviceBrand:void 0},c.default);N.set(K.IProductService,M);const W=new O.NativeEnvironmentService(this.argv,M);N.set(y.INativeEnvironmentService,W),await Promise.all([W.appSettingsHome.fsPath,W.extensionsPath].map(ge=>ge?L.Promises.mkdir(ge,{recursive:!0}):void 0));const B=l.getLogLevel(W),x=[];x.push(new S.SpdLogLogger("cli",F.join(W.logsPath,"cli.log"),!0,B)),B===l.LogLevel.Trace&&x.push(new l.ConsoleLogger(B));const H=this._register(new l.MultiplexLogService(x));N.set(l.ILogService,H);const X=this._register(new k.FileService(H));N.set(j.IFileService,X);const Q=this._register(new V.DiskFileSystemProvider(H));X.registerProvider(E.Schemas.file,Q);const ie=this._register(new n.ConfigurationService(W.settingsResource,X));N.set(i.IConfigurationService,ie),await ie.initialize(),N.set(r.IRequestService,new C.SyncDescriptor(e.RequestService)),N.set(u.IExtensionManagementService,new C.SyncDescriptor(h.ExtensionManagementService)),N.set(u.IExtensionGalleryService,new C.SyncDescriptor(b.ExtensionGalleryService)),N.set(u.IExtensionManagementCLIService,new C.SyncDescriptor(ee.ExtensionManagementCLIService)),N.set(ae.ILocalizationsService,new C.SyncDescriptor(Z.LocalizationsService));const ce=[];if(W.isBuilt&&!W.isExtensionDevelopment&&!W.disableTelemetry&&M.enableTelemetry){M.aiConfig&&M.aiConfig.asimovKey&&ce.push(new s.AppInsightsAppender("monacoworkbench",null,M.aiConfig.asimovKey));const{appRoot:ge,extensionsPath:Ie,installSourcePath:Fe}=W,Oe={appender:P.combinedAppender(...ce),sendErrorTelemetry:!1,commonProperties:(async()=>{let Se;try{const ke=await L.Promises.readFile(F.join(W.userDataPath,"storage.json"));Se=JSON.parse(ke.toString())[R.machineIdKey]}catch(ke){ke.code!=="ENOENT"&&H.error(ke)}return o.resolveCommonProperties(X,g.release(),g.hostname(),process.arch,M.commit,M.version,Se,M.msftInternalDomains,Fe)})(),piiPaths:[ge,Ie]};N.set(R.ITelemetryService,new C.SyncDescriptor(v.TelemetryService,[Oe]))}else N.set(R.ITelemetryService,P.NullTelemetryService);return[new w.InstantiationService(N),ce]}registerErrorHandler(N){se.setUnexpectedErrorHandler(M=>{const W=re.toErrorMessage(M,!0);!W||N.error(`[uncaught exception in CLI]: ${W}`)})}async doRun(N,M,W){if(this.argv["install-source"])return this.setInstallSource(N,W,this.argv["install-source"]);if(this.argv["list-extensions"])return M.listExtensions(!!this.argv["show-versions"],this.argv.category);if(this.argv["install-extension"]||this.argv["install-builtin-extension"])return M.installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.argv["install-builtin-extension"]||[],!!this.argv["do-not-sync"],!!this.argv.force);if(this.argv["uninstall-extension"])return M.uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force);if(this.argv["locate-extension"])return M.locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(U.buildTelemetryMessage(N.appRoot,N.extensionsPath))}asExtensionIdOrVSIX(N){return N.map(M=>/\.vsix$/i.test(M)?te.URI.file(F.isAbsolute(M)?M:F.join(d.cwd(),M)):M)}async setInstallSource(N,M,W){await M.writeFile(te.URI.file(N.installSourcePath),T.VSBuffer.fromString(W.slice(0,30)))}}async function m(p){const N=new a(p);try{await N.run()}finally{N.dispose()}}t.main=m})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/b4c1bd0a9b03c749ea011b06c6d2676c8091a70c/core/vs/code/node/cliProcessMain.js.map
