/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ge=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/path","vs/base/common/network","vs/base/common/platform","vs/workbench/api/common/extHostRpcService","vs/base/common/types","vs/base/common/async","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/arrays","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/services/extensions/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/map","vs/base/common/resources","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/node/pfs","vs/base/common/extpath","vs/base/common/glob","vs/workbench/services/search/common/search","vs/base/common/uuid","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWorkspace","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostConfiguration","vs/base/common/process","child_process","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/range","vs/platform/files/common/files","vs/base/common/stopwatch","vs/editor/common/core/position","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostDebugService","vs/base/common/assert","vs/base/common/decorators","vs/base/common/json","vs/base/common/severity","vs/base/common/marshalling","fs","vs/base/common/errorMessage","vs/platform/registry/common/platform","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/collections","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/numbers","vs/base/common/hash","vs/base/common/normalization","vs/base/common/labels","vs/editor/common/modes/languageSelector","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/platform/configuration/common/configuration","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/shared/webview","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/codicons","vs/base/common/stream","vs/base/common/uint","vs/base/common/filters","vs/base/common/htmlContent","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","string_decoder","os","vs/base/node/extpath","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/contextkey/common/contextkey","vs/platform/log/node/spdlogLog","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/testing/common/testCollection","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/processes","vs/base/common/iconLabels","vs/base/common/mime","vs/base/node/decoder","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/externalTerminal/common/externalTerminal","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/extHostCodeInsets","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/node/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostOutputService","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/api/common/extHostTesting","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/textfile/common/encoding","vs/workbench/services/extensions/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepFileSearch","vscode-ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","vs/workbench/services/extensions/node/extensionHostProcessSetup","util","vs/base/common/marked/marked","https","tls","vscode-proxy-agent","events","vscode-regexpp","graceful-fs","crypto","zlib","minimist","vs/workbench/services/extensions/node/extensionHostProcess"],pe=function(X){for(var e=[],v=0,R=X.length;v<R;v++)e[v]=ge[X[v]];return e};define(ge[49],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function v(R,k){if(!R)throw new Error(k?`Assertion failed (${k})`:"Assertion Failed")}e.ok=v}),define(ge[68],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const v=Object.prototype.hasOwnProperty;function R(s){const I=[];for(let l in s)v.call(s,l)&&I.push(s[l]);return I}e.values=R;function k(s,I){for(let l in s)if(v.call(s,l)&&I({key:l,value:s[l]},function(){delete s[l]})===!1)return}e.forEach=k;function y(s,I){const l=Object.create(null);for(const g of s){const c=I(g);let f=l[c];f||(f=l[c]=[]),f.push(g)}return l}e.groupBy=y;function A(s){const I=Object.create(null);return s&&s.forEach((l,g)=>{I[g]=l}),I}e.fromMap=A;function C(s,I){const l=[],g=[];for(let c of s)I.has(c)||l.push(c);for(let c of I)s.has(c)||g.push(c);return{removed:l,added:g}}e.diffSets=C;function D(s,I){const l=[],g=[];for(let[c,f]of s)I.has(c)||l.push(f);for(let[c,f]of I)s.has(c)||g.push(f);return{removed:l,added:g}}e.diffMaps=D;class P{constructor(){this.map=new Map}add(I,l){let g=this.map.get(I);g||(g=new Set,this.map.set(I,g)),g.add(l)}delete(I,l){const g=this.map.get(I);!g||(g.delete(l),g.size===0&&this.map.delete(I))}forEach(I,l){const g=this.map.get(I);!g||g.forEach(l)}}e.SetMap=P}),define(ge[50],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function v(A){return(C,D,P)=>{let s=null,I=null;if(typeof P.value=="function"?(s="value",I=P.value):typeof P.get=="function"&&(s="get",I=P.get),!I)throw new Error("not supported");P[s]=A(I,D)}}e.createDecorator=v;function R(A,C,D){let P=null,s=null;if(typeof D.value=="function"?(P="value",s=D.value,s.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof D.get=="function"&&(P="get",s=D.get),!s)throw new Error("not supported");const I=`$memoize$${C}`;D[P]=function(...l){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:s.apply(this,l)}),this[I]}}e.memoize=R;function k(A,C,D){return v((P,s)=>{const I=`$debounce$${s}`,l=`$debounce$result$${s}`;return function(...g){this[l]||(this[l]=D?D():void 0),clearTimeout(this[I]),C&&(this[l]=C(this[l],...g),g=[this[l]]),this[I]=setTimeout(()=>{P.apply(this,g),this[l]=D?D():void 0},A)}})}e.debounce=k;function y(A,C,D){return v((P,s)=>{const I=`$throttle$timer$${s}`,l=`$throttle$result$${s}`,g=`$throttle$lastRun$${s}`,c=`$throttle$pending$${s}`;return function(...f){if(this[l]||(this[l]=D?D():void 0),(this[g]===null||this[g]===void 0)&&(this[g]=-Number.MAX_VALUE),C&&(this[l]=C(this[l],...f)),this[c])return;const _=this[g]+A;_<=Date.now()?(this[g]=Date.now(),P.apply(this,[this[l]]),this[l]=D?D():void 0):(this[c]=!0,this[I]=setTimeout(()=>{this[c]=!1,this[g]=Date.now(),P.apply(this,[this[l]]),this[l]=D?D():void 0},_-Date.now()))}})}e.throttle=y}),define(ge[16],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class v{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(r=>{r(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=v,e.errorHandler=new v;function R(m){e.errorHandler.setUnexpectedErrorHandler(m)}e.setUnexpectedErrorHandler=R;function k(m){D(m)||e.errorHandler.onUnexpectedError(m)}e.onUnexpectedError=k;function y(m){D(m)||e.errorHandler.onUnexpectedExternalError(m)}e.onUnexpectedExternalError=y;function A(m){if(m instanceof Error){let{name:t,message:r}=m;const i=m.stacktrace||m.stack;return{$isError:!0,name:t,message:r,stack:i}}return m}e.transformErrorForSerialization=A;const C="Canceled";function D(m){return m instanceof Error&&m.name===C&&m.message===C}e.isPromiseCanceledError=D;class P extends Error{constructor(){super(C);this.name=this.message}}e.CancellationError=P;function s(){const m=new Error(C);return m.name=m.message,m}e.canceled=s;function I(m){return m?new Error(`Illegal argument: ${m}`):new Error("Illegal argument")}e.illegalArgument=I;function l(m){return m?new Error(`Illegal state: ${m}`):new Error("Illegal state")}e.illegalState=l;function g(m){return m?new Error(`readonly property '${m} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=g;function c(m){const t=new Error(`${m} has been disposed`);return t.name="DISPOSED",t}e.disposed=c;function f(m){return m?m.message?m.message:m.stack?m.stack.split(`
`)[0]:String(m):"Error"}e.getErrorMessage=f;class _ extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=_;class w extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=w;class E extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=E;function u(m){const t=m;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=u;function h(m,t=Object.create(null)){const r=new Error(m);return t.actions&&(r.actions=t.actions),r}e.createErrorWithActions=h}),define(ge[17],pe([0,1,16]),function(X,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.maxIndex=e.minIndex=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function R(N,F=0){return N[N.length-(1+F)]}e.tail=R;function k(N){if(N.length===0)throw new Error("Invalid tail call");return[N.slice(0,N.length-1),N[N.length-1]]}e.tail2=k;function y(N,F,M=(U,B)=>U===B){if(N===F)return!0;if(!N||!F||N.length!==F.length)return!1;for(let U=0,B=N.length;U<B;U++)if(!M(N[U],F[U]))return!1;return!0}e.equals=y;function A(N,F,M){let U=0,B=N.length-1;for(;U<=B;){const K=(U+B)/2|0,ie=M(N[K],F);if(ie<0)U=K+1;else if(ie>0)B=K-1;else return K}return-(U+1)}e.binarySearch=A;function C(N,F){let M=0,U=N.length;if(U===0)return 0;for(;M<U;){const B=Math.floor((M+U)/2);F(N[B])?U=B:M=B+1}return M}e.findFirstInSorted=C;function D(N,F,M){if(N=N|0,N>=F.length)throw new TypeError("invalid index");let U=F[Math.floor(F.length*Math.random())],B=[],K=[],ie=[];for(let we of F){const Te=M(we,U);Te<0?B.push(we):Te>0?K.push(we):ie.push(we)}return N<B.length?D(N,B,M):N<B.length+ie.length?ie[0]:D(N-(B.length+ie.length),K,M)}e.quickSelect=D;function P(N,F){const M=[];let U;for(const B of N.slice(0).sort(F))!U||F(U[0],B)!==0?(U=[B],M.push(U)):U.push(B);return M}e.groupBy=P;function s(N,F,M){const U=[];function B(we,Te,ye){if(Te===0&&ye.length===0)return;const Oe=U[U.length-1];Oe&&Oe.start+Oe.deleteCount===we?(Oe.deleteCount+=Te,Oe.toInsert.push(...ye)):U.push({start:we,deleteCount:Te,toInsert:ye})}let K=0,ie=0;for(;;){if(K===N.length){B(K,0,F.slice(ie));break}if(ie===F.length){B(K,N.length-K,[]);break}const we=N[K],Te=F[ie],ye=M(we,Te);ye===0?(K+=1,ie+=1):ye<0?(B(K,1,[]),K+=1):ye>0&&(B(K,0,[Te]),ie+=1)}return U}e.sortedDiff=s;function I(N,F,M){const U=s(N,F,M),B=[],K=[];for(const ie of U)B.push(...N.slice(ie.start,ie.start+ie.deleteCount)),K.push(...ie.toInsert);return{removed:B,added:K}}e.delta=I;function l(N,F,M){if(M===0)return[];const U=N.slice(0,M).sort(F);return c(N,F,U,M,N.length),U}e.top=l;function g(N,F,M,U,B){return M===0?Promise.resolve([]):new Promise((K,ie)=>{(async()=>{const we=N.length,Te=N.slice(0,M).sort(F);for(let ye=M,Oe=Math.min(M+U,we);ye<we;ye=Oe,Oe=Math.min(Oe+U,we)){if(ye>M&&await new Promise(je=>setTimeout(je)),B&&B.isCancellationRequested)throw v.canceled();c(N,F,Te,ye,Oe)}return Te})().then(K,ie)})}e.topAsync=g;function c(N,F,M,U,B){for(const K=M.length;U<B;U++){const ie=N[U];if(F(ie,M[K-1])<0){M.pop();const we=C(M,Te=>F(ie,Te)<0);M.splice(we,0,ie)}}}function f(N){return N.filter(F=>!!F)}e.coalesce=f;function _(N){let F=0;for(let M=0;M<N.length;M++)N[M]&&(N[F]=N[M],F+=1);N.length=F}e.coalesceInPlace=_;function w(N,F,M){N.splice(M,0,N.splice(F,1)[0])}e.move=w;function E(N){return!Array.isArray(N)||N.length===0}e.isFalsyOrEmpty=E;function u(N){return Array.isArray(N)&&N.length>0}e.isNonEmptyArray=u;function h(N,F){if(!F)return N.filter((U,B)=>N.indexOf(U)===B);const M=Object.create(null);return N.filter(U=>{const B=F(U);return M[B]?!1:(M[B]=!0,!0)})}e.distinct=h;function m(N){const F=new Set;return N.filter(M=>F.has(M)?!1:(F.add(M),!0))}e.distinctES6=m;function t(N){const F=Object.create(null);return M=>{const U=N(M);return F[U]?!1:(F[U]=!0,!0)}}e.uniqueFilter=t;function r(N,F){for(let M=N.length-1;M>=0;M--){const U=N[M];if(F(U))return M}return-1}e.lastIndex=r;function i(N,F){return N.length>0?N[0]:F}e.firstOrDefault=i;function n(N,F,M=(U,B)=>U===B){let U=0;for(let B=0,K=Math.min(N.length,F.length);B<K&&M(N[B],F[B]);B++)U++;return U}e.commonPrefixLength=n;function a(N){return[].concat(...N)}e.flatten=a;function p(N,F){let M=typeof F=="number"?N:0;typeof F=="number"?M=N:(M=0,F=N);const U=[];if(M<=F)for(let B=M;B<F;B++)U.push(B);else for(let B=M;B>F;B--)U.push(B);return U}e.range=p;function d(N,F,M){return N.reduce((U,B)=>(U[F(B)]=M?M(B):B,U),Object.create(null))}e.index=d;function b(N,F){return N.push(F),()=>S(N,F)}e.insert=b;function S(N,F){const M=N.indexOf(F);if(M>-1)return N.splice(M,1),F}e.remove=S;function o(N,F,M){const U=N.slice(0,F),B=N.slice(F);return U.concat(M,B)}e.arrayInsert=o;function L(N,F){let M;if(typeof F=="number"){let U=F;M=()=>{const B=Math.sin(U++)*179426549;return B-Math.floor(B)}}else M=Math.random;for(let U=N.length-1;U>0;U-=1){const B=Math.floor(M()*(U+1)),K=N[U];N[U]=N[B],N[B]=K}}e.shuffle=L;function O(N,F){const M=N.indexOf(F);M>-1&&(N.splice(M,1),N.unshift(F))}e.pushToStart=O;function W(N,F){const M=N.indexOf(F);M>-1&&(N.splice(M,1),N.push(F))}e.pushToEnd=W;function J(N,F){return Array.isArray(N)?N.map(F):F(N)}e.mapArrayOrNot=J;function oe(N){return Array.isArray(N)?N:[N]}e.asArray=oe;function q(N){return N[Math.floor(Math.random()*N.length)]}e.getRandomElement=q;function x(N,F){for(const M of N){const U=F(M);if(U!==void 0)return U}}e.mapFind=x;function V(N,F){let M=Number.MAX_SAFE_INTEGER,U=0;return N.forEach((B,K)=>{const ie=F(B);ie<M&&(M=ie,U=K)}),U}e.minIndex=V;function T(N,F){let M=Number.MIN_SAFE_INTEGER,U=0;return N.forEach((B,K)=>{const ie=F(B);ie>M&&(M=ie,U=K)}),U}e.maxIndex=T}),define(ge[69],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function v(R){const k=this;let y=!1,A;return function(){return y||(y=!0,A=R.apply(k,arguments)),A}}e.once=v}),define(ge[70],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class v{constructor(k){this._prefix=k,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=v,e.defaultGenerator=new v("id#")}),define(ge[71],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var v;(function(R){function k(m){return m&&typeof m=="object"&&typeof m[Symbol.iterator]=="function"}R.is=k;const y=Object.freeze([]);function A(){return y}R.empty=A;function*C(m){yield m}R.single=C;function D(m){return m||y}R.from=D;function P(m){return!m||m[Symbol.iterator]().next().done===!0}R.isEmpty=P;function s(m){return m[Symbol.iterator]().next().value}R.first=s;function I(m,t){for(const r of m)if(t(r))return!0;return!1}R.some=I;function l(m,t){for(const r of m)if(t(r))return r}R.find=l;function*g(m,t){for(const r of m)t(r)&&(yield r)}R.filter=g;function*c(m,t){let r=0;for(const i of m)yield t(i,r++)}R.map=c;function*f(...m){for(const t of m)for(const r of t)yield r}R.concat=f;function*_(m){for(const t of m)for(const r of t)yield r}R.concatNested=_;function w(m,t,r){let i=r;for(const n of m)i=t(i,n);return i}R.reduce=w;function*E(m,t,r=m.length){for(t<0&&(t+=m.length),r<0?r+=m.length:r>m.length&&(r=m.length);t<r;t++)yield m[t]}R.slice=E;function u(m,t=Number.POSITIVE_INFINITY){const r=[];if(t===0)return[r,m];const i=m[Symbol.iterator]();for(let n=0;n<t;n++){const a=i.next();if(a.done)return[r,R.empty()];r.push(a.value)}return[r,{[Symbol.iterator](){return i}}]}R.consume=u;function h(m,t,r=(i,n)=>i===n){const i=m[Symbol.iterator](),n=t[Symbol.iterator]();for(;;){const a=i.next(),p=n.next();if(a.done!==p.done)return!1;if(a.done)return!0;if(!r(a.value,p.value))return!1}}R.equals=h})(v=e.Iterable||(e.Iterable={}))}),define(ge[51],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var v;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(v=e.ScanError||(e.ScanError={}));var R;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(R=e.SyntaxKind||(e.SyntaxKind={}));var k;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(k=e.ParseErrorCode||(e.ParseErrorCode={}));var y;(function(t){t.DEFAULT={allowTrailingComma:!0}})(y=e.ParseOptions||(e.ParseOptions={}));function A(t,r=!1){let i=0,n=t.length,a="",p=0,d=16,b=0;function S(q){let x=0,V=0;for(;x<q;){const T=t.charCodeAt(i);if(T>=48&&T<=57)V=V*16+T-48;else if(T>=65&&T<=70)V=V*16+T-65+10;else if(T>=97&&T<=102)V=V*16+T-97+10;else break;i++,x++}return x<q&&(V=-1),V}function o(q){i=q,a="",p=0,d=16,b=0}function L(){const q=i;if(t.charCodeAt(i)===48)i++;else for(i++;i<t.length&&P(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===46)if(i++,i<t.length&&P(t.charCodeAt(i)))for(i++;i<t.length&&P(t.charCodeAt(i));)i++;else return b=3,t.substring(q,i);let x=i;if(i<t.length&&(t.charCodeAt(i)===69||t.charCodeAt(i)===101))if(i++,(i<t.length&&t.charCodeAt(i)===43||t.charCodeAt(i)===45)&&i++,i<t.length&&P(t.charCodeAt(i))){for(i++;i<t.length&&P(t.charCodeAt(i));)i++;x=i}else b=3;return t.substring(q,x)}function O(){let q="",x=i;for(;;){if(i>=n){q+=t.substring(x,i),b=2;break}const V=t.charCodeAt(i);if(V===34){q+=t.substring(x,i),i++;break}if(V===92){if(q+=t.substring(x,i),i++,i>=n){b=2;break}switch(t.charCodeAt(i++)){case 34:q+='"';break;case 92:q+="\\";break;case 47:q+="/";break;case 98:q+="\b";break;case 102:q+="\f";break;case 110:q+=`
`;break;case 114:q+="\r";break;case 116:q+="	";break;case 117:const N=S(4);N>=0?q+=String.fromCharCode(N):b=4;break;default:b=5}x=i;continue}if(V>=0&&V<=31)if(D(V)){q+=t.substring(x,i),b=2;break}else b=6;i++}return q}function W(){if(a="",b=0,p=i,i>=n)return p=n,d=17;let q=t.charCodeAt(i);if(C(q)){do i++,a+=String.fromCharCode(q),q=t.charCodeAt(i);while(C(q));return d=15}if(D(q))return i++,a+=String.fromCharCode(q),q===13&&t.charCodeAt(i)===10&&(i++,a+=`
`),d=14;switch(q){case 123:return i++,d=1;case 125:return i++,d=2;case 91:return i++,d=3;case 93:return i++,d=4;case 58:return i++,d=6;case 44:return i++,d=5;case 34:return i++,a=O(),d=10;case 47:const x=i-1;if(t.charCodeAt(i+1)===47){for(i+=2;i<n&&!D(t.charCodeAt(i));)i++;return a=t.substring(x,i),d=12}if(t.charCodeAt(i+1)===42){i+=2;const V=n-1;let T=!1;for(;i<V;){if(t.charCodeAt(i)===42&&t.charCodeAt(i+1)===47){i+=2,T=!0;break}i++}return T||(i++,b=1),a=t.substring(x,i),d=13}return a+=String.fromCharCode(q),i++,d=16;case 45:if(a+=String.fromCharCode(q),i++,i===n||!P(t.charCodeAt(i)))return d=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=L(),d=11;default:for(;i<n&&J(q);)i++,q=t.charCodeAt(i);if(p!==i){switch(a=t.substring(p,i),a){case"true":return d=8;case"false":return d=9;case"null":return d=7}return d=16}return a+=String.fromCharCode(q),i++,d=16}}function J(q){if(C(q)||D(q))return!1;switch(q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function oe(){let q;do q=W();while(q>=12&&q<=15);return q}return{setPosition:o,getPosition:()=>i,scan:r?oe:W,getToken:()=>d,getTokenValue:()=>a,getTokenOffset:()=>p,getTokenLength:()=>i-p,getTokenError:()=>b}}e.createScanner=A;function C(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function D(t){return t===10||t===13||t===8232||t===8233}function P(t){return t>=48&&t<=57}var s;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(s||(s={}));function I(t,r){const i=[],n=new Object;let a;const p={value:{},offset:0,length:0,type:"object",parent:void 0};let d=!1;function b(S,o,L,O){p.value=S,p.offset=o,p.length=L,p.type=O,p.colonOffset=void 0,a=p}try{u(t,{onObjectBegin:(S,o)=>{if(r<=S)throw n;a=void 0,d=r>S,i.push("")},onObjectProperty:(S,o,L)=>{if(r<o||(b(S,o,L,"property"),i[i.length-1]=S,r<=o+L))throw n},onObjectEnd:(S,o)=>{if(r<=S)throw n;a=void 0,i.pop()},onArrayBegin:(S,o)=>{if(r<=S)throw n;a=void 0,i.push(0)},onArrayEnd:(S,o)=>{if(r<=S)throw n;a=void 0,i.pop()},onLiteralValue:(S,o,L)=>{if(r<o||(b(S,o,L,m(S)),r<=o+L))throw n},onSeparator:(S,o,L)=>{if(r<=o)throw n;if(S===":"&&a&&a.type==="property")a.colonOffset=o,d=!1,a=void 0;else if(S===","){const O=i[i.length-1];typeof O=="number"?i[i.length-1]=O+1:(d=!0,i[i.length-1]=""),a=void 0}}})}catch(S){if(S!==n)throw S}return{path:i,previousNode:a,isAtPropertyKey:d,matches:S=>{let o=0;for(let L=0;o<S.length&&L<i.length;L++)if(S[o]===i[L]||S[o]==="*")o++;else if(S[o]!=="**")return!1;return o===S.length}}}e.getLocation=I;function l(t,r=[],i=y.DEFAULT){let n=null,a=[];const p=[];function d(S){Array.isArray(a)?a.push(S):n!==null&&(a[n]=S)}return u(t,{onObjectBegin:()=>{const S={};d(S),p.push(a),a=S,n=null},onObjectProperty:S=>{n=S},onObjectEnd:()=>{a=p.pop()},onArrayBegin:()=>{const S=[];d(S),p.push(a),a=S,n=null},onArrayEnd:()=>{a=p.pop()},onLiteralValue:d,onError:(S,o,L)=>{r.push({error:S,offset:o,length:L})}},i),a[0]}e.parse=l;function g(t,r=[],i=y.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(S){n.type==="property"&&(n.length=S-n.offset,n=n.parent)}function p(S){return n.children.push(S),S}u(t,{onObjectBegin:S=>{n=p({type:"object",offset:S,length:-1,parent:n,children:[]})},onObjectProperty:(S,o,L)=>{n=p({type:"property",offset:o,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:S,offset:o,length:L,parent:n})},onObjectEnd:(S,o)=>{n.length=S+o-n.offset,n=n.parent,a(S+o)},onArrayBegin:(S,o)=>{n=p({type:"array",offset:S,length:-1,parent:n,children:[]})},onArrayEnd:(S,o)=>{n.length=S+o-n.offset,n=n.parent,a(S+o)},onLiteralValue:(S,o,L)=>{p({type:m(S),offset:o,length:L,parent:n,value:S}),a(o+L)},onSeparator:(S,o,L)=>{n.type==="property"&&(S===":"?n.colonOffset=o:S===","&&a(o))},onError:(S,o,L)=>{r.push({error:S,offset:o,length:L})}},i);const b=n.children[0];return b&&delete b.parent,b}e.parseTree=g;function c(t,r){if(!t)return;let i=t;for(let n of r)if(typeof n=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let a=!1;for(const p of i.children)if(Array.isArray(p.children)&&p.children[0].value===n){i=p.children[1],a=!0;break}if(!a)return}else{const a=n;if(i.type!=="array"||a<0||!Array.isArray(i.children)||a>=i.children.length)return;i=i.children[a]}return i}e.findNodeAtLocation=c;function f(t){if(!t.parent||!t.parent.children)return[];const r=f(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;r.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&r.push(i)}return r}e.getNodePath=f;function _(t){switch(t.type){case"array":return t.children.map(_);case"object":const r=Object.create(null);for(let i of t.children){const n=i.children[1];n&&(r[i.children[0].value]=_(n))}return r;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=_;function w(t,r,i=!1){return r>=t.offset&&r<t.offset+t.length||i&&r===t.offset+t.length}e.contains=w;function E(t,r,i=!1){if(w(t,r,i)){const n=t.children;if(Array.isArray(n))for(let a=0;a<n.length&&n[a].offset<=r;a++){const p=E(n[a],r,i);if(p)return p}return t}}e.findNodeAtOffset=E;function u(t,r,i=y.DEFAULT){const n=A(t,!1);function a(ie){return ie?()=>ie(n.getTokenOffset(),n.getTokenLength()):()=>!0}function p(ie){return ie?we=>ie(we,n.getTokenOffset(),n.getTokenLength()):()=>!0}const d=a(r.onObjectBegin),b=p(r.onObjectProperty),S=a(r.onObjectEnd),o=a(r.onArrayBegin),L=a(r.onArrayEnd),O=p(r.onLiteralValue),W=p(r.onSeparator),J=a(r.onComment),oe=p(r.onError),q=i&&i.disallowComments,x=i&&i.allowTrailingComma;function V(){for(;;){const ie=n.scan();switch(n.getTokenError()){case 4:T(14);break;case 5:T(15);break;case 3:T(13);break;case 1:q||T(11);break;case 2:T(12);break;case 6:T(16);break}switch(ie){case 12:case 13:q?T(10):J();break;case 16:T(1);break;case 15:case 14:break;default:return ie}}}function T(ie,we=[],Te=[]){if(oe(ie),we.length+Te.length>0){let ye=n.getToken();for(;ye!==17;){if(we.indexOf(ye)!==-1){V();break}else if(Te.indexOf(ye)!==-1)break;ye=V()}}}function N(ie){const we=n.getTokenValue();return ie?O(we):b(we),V(),!0}function F(){switch(n.getToken()){case 11:let ie=0;try{ie=JSON.parse(n.getTokenValue()),typeof ie!="number"&&(T(2),ie=0)}catch(we){T(2)}O(ie);break;case 7:O(null);break;case 8:O(!0);break;case 9:O(!1);break;default:return!1}return V(),!0}function M(){return n.getToken()!==10?(T(3,[],[2,5]),!1):(N(!1),n.getToken()===6?(W(":"),V(),K()||T(4,[],[2,5])):T(5,[],[2,5]),!0)}function U(){d(),V();let ie=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(ie||T(4,[],[]),W(","),V(),n.getToken()===2&&x)break}else ie&&T(6,[],[]);M()||T(4,[],[2,5]),ie=!0}return S(),n.getToken()!==2?T(7,[2],[]):V(),!0}function B(){o(),V();let ie=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(ie||T(4,[],[]),W(","),V(),n.getToken()===4&&x)break}else ie&&T(6,[],[]);K()||T(4,[],[4,5]),ie=!0}return L(),n.getToken()!==4?T(8,[4],[]):V(),!0}function K(){switch(n.getToken()){case 3:return B();case 1:return U();case 10:return N(!0);default:return F()}}return V(),n.getToken()===17?i.allowEmptyContent?!0:(T(4,[],[]),!1):K()?(n.getToken()!==17&&T(9,[],[]),!0):(T(4,[],[]),!1)}e.visit=u;function h(t,r){let i=A(t),n=[],a,p=0,d;do switch(d=i.getPosition(),a=i.scan(),a){case 12:case 13:case 17:p!==d&&n.push(t.substring(p,d)),r!==void 0&&n.push(i.getTokenValue().replace(/[^\r\n]/g,r)),p=i.getPosition();break}while(a!==17);return n.join("")}e.stripComments=h;function m(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=m}),define(ge[131],pe([0,1,51]),function(X,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function R(D,P,s){let I,l,g,c,f;if(P){for(c=P.offset,f=c+P.length,g=c;g>0&&!C(D,g-1);)g--;let p=f;for(;p<D.length&&!C(D,p);)p++;l=D.substring(g,p),I=y(l,s)}else l=D,I=0,g=0,c=0,f=D.length;const _=A(s,D);let w=!1,E=0,u;s.insertSpaces?u=k(" ",s.tabSize||4):u="	";const h=v.createScanner(l,!1);let m=!1;function t(){return _+k(u,I+E)}function r(){let p=h.scan();for(w=!1;p===15||p===14;)w=w||p===14,p=h.scan();return m=p===16||h.getTokenError()!==0,p}const i=[];function n(p,d,b){!m&&d<f&&b>c&&D.substring(d,b)!==p&&i.push({offset:d,length:b-d,content:p})}let a=r();if(a!==17){const p=h.getTokenOffset()+g,d=k(u,I);n(d,g,p)}for(;a!==17;){let p=h.getTokenOffset()+h.getTokenLength()+g,d=r(),b="";for(;!w&&(d===12||d===13);){const o=h.getTokenOffset()+g;n(" ",p,o),p=h.getTokenOffset()+h.getTokenLength()+g,b=d===12?t():"",d=r()}if(d===2)a!==1&&(E--,b=t());else if(d===4)a!==3&&(E--,b=t());else{switch(a){case 3:case 1:E++,b=t();break;case 5:case 12:b=t();break;case 13:w?b=t():b=" ";break;case 6:b=" ";break;case 10:if(d===6){b="";break}case 7:case 8:case 9:case 11:case 2:case 4:d===12||d===13?b=" ":d!==5&&d!==17&&(m=!0);break;case 16:m=!0;break}w&&(d===12||d===13)&&(b=t())}const S=h.getTokenOffset()+g;n(b,p,S),a=d}return i}e.format=R;function k(D,P){let s="";for(let I=0;I<P;I++)s+=D;return s}function y(D,P){let s=0,I=0;const l=P.tabSize||4;for(;s<D.length;){const g=D.charAt(s);if(g===" ")I++;else if(g==="	")I+=l;else break;s++}return Math.floor(I/l)}function A(D,P){for(let s=0;s<P.length;s++){const I=P.charAt(s);if(I==="\r")return s+1<P.length&&P.charAt(s+1)===`
`?`\r
`:"\r";if(I===`
`)return`
`}return D&&D.eol||`
`}e.getEOL=A;function C(D,P){return`\r
`.indexOf(D.charAt(P))!==-1}e.isEOL=C}),define(ge[132],pe([0,1,51,131]),function(X,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function k(P,s,I){return y(P,s,void 0,I)}e.removeProperty=k;function y(P,s,I,l,g){const c=s.slice(),f=[],_=v.parseTree(P,f);let w,E;for(;c.length>0&&(E=c.pop(),w=v.findNodeAtLocation(_,c),w===void 0&&I!==void 0);)typeof E=="string"?I={[E]:I}:I=[I];if(w)if(w.type==="object"&&typeof E=="string"&&Array.isArray(w.children)){const u=v.findNodeAtLocation(w,[E]);if(u!==void 0)if(I===void 0){if(!u.parent)throw new Error("Malformed AST");const h=w.children.indexOf(u.parent);let m,t=u.parent.offset+u.parent.length;if(h>0){const r=w.children[h-1];m=r.offset+r.length}else m=w.offset+1,w.children.length>1&&(t=w.children[1].offset);return A(P,{offset:m,length:t-m,content:""},l)}else return A(P,{offset:u.offset,length:u.length,content:JSON.stringify(I)},l);else{if(I===void 0)return[];const h=`${JSON.stringify(E)}: ${JSON.stringify(I)}`,m=g?g(w.children.map(r=>r.children[0].value)):w.children.length;let t;if(m>0){const r=w.children[m-1];t={offset:r.offset+r.length,length:0,content:","+h}}else w.children.length===0?t={offset:w.offset+1,length:0,content:h}:t={offset:w.offset+1,length:0,content:h+","};return A(P,t,l)}}else if(w.type==="array"&&typeof E=="number"&&Array.isArray(w.children))if(I!==void 0){const u=`${JSON.stringify(I)}`;let h;if(w.children.length===0||E===0)h={offset:w.offset+1,length:0,content:w.children.length===0?u:u+","};else{const m=E===-1||E>w.children.length?w.children.length:E,t=w.children[m-1];h={offset:t.offset+t.length,length:0,content:","+u}}return A(P,h,l)}else{const u=E,h=w.children[u];let m;if(w.children.length===1)m={offset:w.offset+1,length:w.length-2,content:""};else if(w.children.length-1===u){const t=w.children[u-1],r=t.offset+t.length,i=w.offset+w.length;m={offset:r,length:i-2-r,content:""}}else m={offset:h.offset,length:w.children[u+1].offset-h.offset,content:""};return A(P,m,l)}else throw new Error(`Can not add ${typeof E!="number"?"index":"property"} to parent of type ${w.type}`);else{if(I===void 0)throw new Error("Can not delete in empty document");return A(P,{offset:_?_.offset:0,length:_?_.length:0,content:JSON.stringify(I)},l)}}e.setProperty=y;function A(P,s,I){let l=C(P,s),g=s.offset,c=s.offset+s.content.length;if(s.length===0||s.content.length===0){for(;g>0&&!R.isEOL(l,g-1);)g--;for(;c<l.length&&!R.isEOL(l,c);)c++}const f=R.format(l,{offset:g,length:c-g},I);for(let w=f.length-1;w>=0;w--){const E=f[w];l=C(l,E),g=Math.min(g,E.offset),c=Math.max(c,E.offset+E.length),c+=E.content.length-E.length}const _=P.length-(l.length-c)-g;return[{offset:g,length:_,content:l.substring(g,c)}]}e.withFormatting=A;function C(P,s){return P.substring(0,s.offset)+s.content+P.substring(s.offset+s.length)}e.applyEdit=C;function D(P,s){let I=s.slice(0).sort((g,c)=>{const f=g.offset-c.offset;return f===0?g.length-c.length:f}),l=P.length;for(let g=I.length-1;g>=0;g--){let c=I[g];if(c.offset+c.length<=l)P=C(P,c);else throw new Error("Overlapping edit");l=c.offset}return P}e.applyEdits=D}),define(ge[133],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class v{constructor(k){this.executor=k,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(k){this._error=k}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(k){return new v(()=>k(this.getValue()))}}e.Lazy=v}),define(ge[6],pe([0,1,69,71]),function(X,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const k=!1;let y=null;function A(u){y=u}if(e.setDisposableTracker=A,k){const u="__is_disposable_tracked__";y=new class{trackDisposable(h){const m=new Error("Potentially leaked disposable").stack;setTimeout(()=>{h[u]||console.log(m)},3e3)}markTracked(h){if(h&&h!==f.None)try{h[u]=!0}catch(m){}}}}function C(u){!y||y.markTracked(u)}function D(u){return y&&y.trackDisposable(u),u}e.trackDisposable=D;class P extends Error{constructor(h){super(`Encountered errors while disposing of store. Errors: [${h.join(", ")}]`);this.errors=h}}e.MultiDisposeError=P;function s(u){return typeof u.dispose=="function"&&u.dispose.length===0}e.isDisposable=s;function I(u){if(R.Iterable.is(u)){let h=[];for(const m of u)if(m){C(m);try{m.dispose()}catch(t){h.push(t)}}if(h.length===1)throw h[0];if(h.length>1)throw new P(h);return Array.isArray(u)?[]:u}else if(u)return C(u),u.dispose(),u}e.dispose=I;function l(...u){return u.forEach(C),g(()=>I(u))}e.combinedDisposable=l;function g(u){const h=D({dispose:()=>{C(h),u()}});return h}e.toDisposable=g;class c{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(C(this),this._isDisposed=!0,this.clear())}clear(){try{I(this._toDispose.values())}finally{this._toDispose.clear()}}add(h){if(!h)return h;if(h===this)throw new Error("Cannot register a disposable on itself!");return C(h),this._isDisposed?c.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(h),h}}e.DisposableStore=c,c.DISABLE_DISPOSED_WARNING=!1;class f{constructor(){this._store=new c,D(this)}dispose(){C(this),this._store.dispose()}_register(h){if(h===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(h)}}e.Disposable=f,f.None=Object.freeze({dispose(){}});class _{constructor(){this._isDisposed=!1,D(this)}get value(){return this._isDisposed?void 0:this._value}set value(h){var m;this._isDisposed||h===this._value||((m=this._value)===null||m===void 0||m.dispose(),h&&C(h),this._value=h)}clear(){this.value=void 0}dispose(){var h;this._isDisposed=!0,C(this),(h=this._value)===null||h===void 0||h.dispose(),this._value=void 0}}e.MutableDisposable=_;class w{constructor(){this.references=new Map}acquire(h,...m){let t=this.references.get(h);t||(t={counter:0,object:this.createReferencedObject(h,...m)},this.references.set(h,t));const{object:r}=t,i=v.once(()=>{--t.counter==0&&(this.destroyReferencedObject(h,t.object),this.references.delete(h))});return t.counter++,{object:r,dispose:i}}}e.ReferenceCollection=w;class E{constructor(h){this.object=h}dispose(){}}e.ImmortalReference=E}),define(ge[72],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class v{constructor(y){this.element=y,this.next=v.Undefined,this.prev=v.Undefined}}v.Undefined=new v(void 0);class R{constructor(){this._first=v.Undefined,this._last=v.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===v.Undefined}clear(){let y=this._first;for(;y!==v.Undefined;){const A=y.next;y.prev=v.Undefined,y.next=v.Undefined,y=A}this._first=v.Undefined,this._last=v.Undefined,this._size=0}unshift(y){return this._insert(y,!1)}push(y){return this._insert(y,!0)}_insert(y,A){const C=new v(y);if(this._first===v.Undefined)this._first=C,this._last=C;else if(A){const P=this._last;this._last=C,C.prev=P,P.next=C}else{const P=this._first;this._first=C,C.next=P,P.prev=C}this._size+=1;let D=!1;return()=>{D||(D=!0,this._remove(C))}}shift(){if(this._first!==v.Undefined){const y=this._first.element;return this._remove(this._first),y}}pop(){if(this._last!==v.Undefined){const y=this._last.element;return this._remove(this._last),y}}_remove(y){if(y.prev!==v.Undefined&&y.next!==v.Undefined){const A=y.prev;A.next=y.next,y.next.prev=A}else y.prev===v.Undefined&&y.next===v.Undefined?(this._first=v.Undefined,this._last=v.Undefined):y.next===v.Undefined?(this._last=this._last.prev,this._last.next=v.Undefined):y.prev===v.Undefined&&(this._first=this._first.next,this._first.prev=v.Undefined);this._size-=1}*[Symbol.iterator](){let y=this._first;for(;y!==v.Undefined;)yield y.element,y=y.next}}e.LinkedList=R}),function(X,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(X=typeof globalThis!="undefined"?globalThis:X||self,X.marked=e())}(this,function(){"use strict";function X(Se,_e){for(var ke=0;ke<_e.length;ke++){var le=_e[ke];le.enumerable=le.enumerable||!1,le.configurable=!0,"value"in le&&(le.writable=!0),Object.defineProperty(Se,le.key,le)}}function e(Se,_e,ke){return _e&&X(Se.prototype,_e),ke&&X(Se,ke),Se}function v(Se,_e){if(!!Se){if(typeof Se=="string")return R(Se,_e);var ke=Object.prototype.toString.call(Se).slice(8,-1);if(ke==="Object"&&Se.constructor&&(ke=Se.constructor.name),ke==="Map"||ke==="Set")return Array.from(Se);if(ke==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ke))return R(Se,_e)}}function R(Se,_e){(_e==null||_e>Se.length)&&(_e=Se.length);for(var ke=0,le=new Array(_e);ke<_e;ke++)le[ke]=Se[ke];return le}function k(Se,_e){var ke;if(typeof Symbol=="undefined"||Se[Symbol.iterator]==null){if(Array.isArray(Se)||(ke=v(Se))||_e&&Se&&typeof Se.length=="number"){ke&&(Se=ke);var le=0;return function(){return le>=Se.length?{done:!0}:{done:!1,value:Se[le++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return ke=Se[Symbol.iterator](),ke.next.bind(ke)}function y(Se){var _e={exports:{}};return Se(_e,_e.exports),_e.exports}var A=y(function(Se){function _e(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function ke(le){Se.exports.defaults=le}Se.exports={defaults:_e(),getDefaults:_e,changeDefaults:ke}}),C=/[&<>"']/,D=/[&<>"']/g,P=/[<>"']|&(?!#?\w+;)/,s=/[<>"']|&(?!#?\w+;)/g,I={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},l=function(_e){return I[_e]};function g(Se,_e){if(_e){if(C.test(Se))return Se.replace(D,l)}else if(P.test(Se))return Se.replace(s,l);return Se}var c=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function f(Se){return Se.replace(c,function(_e,ke){return ke=ke.toLowerCase(),ke==="colon"?":":ke.charAt(0)==="#"?ke.charAt(1)==="x"?String.fromCharCode(parseInt(ke.substring(2),16)):String.fromCharCode(+ke.substring(1)):""})}var _=/(^|[^\[])\^/g;function w(Se,_e){Se=Se.source||Se,_e=_e||"";var ke={replace:function(fe,H){return H=H.source||H,H=H.replace(_,"$1"),Se=Se.replace(fe,H),ke},getRegex:function(){return new RegExp(Se,_e)}};return ke}var E=/[^\w:]/g,u=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function h(Se,_e,ke){if(Se){var le;try{le=decodeURIComponent(f(ke)).replace(E,"").toLowerCase()}catch(fe){return null}if(le.indexOf("javascript:")===0||le.indexOf("vbscript:")===0||le.indexOf("data:")===0)return null}_e&&!u.test(ke)&&(ke=n(_e,ke));try{ke=encodeURI(ke).replace(/%25/g,"%")}catch(fe){return null}return ke}var m={},t=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function n(Se,_e){m[" "+Se]||(t.test(Se)?m[" "+Se]=Se+"/":m[" "+Se]=b(Se,"/",!0)),Se=m[" "+Se];var ke=Se.indexOf(":")===-1;return _e.substring(0,2)==="//"?ke?_e:Se.replace(r,"$1")+_e:_e.charAt(0)==="/"?ke?_e:Se.replace(i,"$1")+_e:Se+_e}var a={exec:function(){}};function p(Se){for(var _e=1,ke,le;_e<arguments.length;_e++){ke=arguments[_e];for(le in ke)Object.prototype.hasOwnProperty.call(ke,le)&&(Se[le]=ke[le])}return Se}function d(Se,_e){var ke=Se.replace(/\|/g,function(H,ee,ue){for(var Pe=!1,Ae=ee;--Ae>=0&&ue[Ae]==="\\";)Pe=!Pe;return Pe?"|":" |"}),le=ke.split(/ \|/),fe=0;if(le.length>_e)le.splice(_e);else for(;le.length<_e;)le.push("");for(;fe<le.length;fe++)le[fe]=le[fe].trim().replace(/\\\|/g,"|");return le}function b(Se,_e,ke){var le=Se.length;if(le===0)return"";for(var fe=0;fe<le;){var H=Se.charAt(le-fe-1);if(H===_e&&!ke)fe++;else if(H!==_e&&ke)fe++;else break}return Se.substr(0,le-fe)}function S(Se,_e){if(Se.indexOf(_e[1])===-1)return-1;for(var ke=Se.length,le=0,fe=0;fe<ke;fe++)if(Se[fe]==="\\")fe++;else if(Se[fe]===_e[0])le++;else if(Se[fe]===_e[1]&&(le--,le<0))return fe;return-1}function o(Se){Se&&Se.sanitize&&!Se.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function L(Se,_e){if(_e<1)return"";for(var ke="";_e>1;)_e&1&&(ke+=Se),_e>>=1,Se+=Se;return ke+Se}var O={escape:g,unescape:f,edit:w,cleanUrl:h,resolveUrl:n,noopTest:a,merge:p,splitCells:d,rtrim:b,findClosingBracket:S,checkSanitizeDeprecation:o,repeatString:L},W=A.defaults,J=O.rtrim,oe=O.splitCells,q=O.escape,x=O.findClosingBracket;function V(Se,_e,ke){var le=_e.href,fe=_e.title?q(_e.title):null,H=Se[1].replace(/\\([\[\]])/g,"$1");return Se[0].charAt(0)!=="!"?{type:"link",raw:ke,href:le,title:fe,text:H}:{type:"image",raw:ke,href:le,title:fe,text:q(H)}}function T(Se,_e){var ke=Se.match(/^(\s+)(?:```)/);if(ke===null)return _e;var le=ke[1];return _e.split(`
`).map(function(fe){var H=fe.match(/^\s+/);if(H===null)return fe;var ee=H[0];return ee.length>=le.length?fe.slice(le.length):fe}).join(`
`)}var N=function(){function Se(ke){this.options=ke||W}var _e=Se.prototype;return _e.space=function(le){var fe=this.rules.block.newline.exec(le);if(fe)return fe[0].length>1?{type:"space",raw:fe[0]}:{raw:`
`}},_e.code=function(le){var fe=this.rules.block.code.exec(le);if(fe){var H=fe[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:fe[0],codeBlockStyle:"indented",text:this.options.pedantic?H:J(H,`
`)}}},_e.fences=function(le){var fe=this.rules.block.fences.exec(le);if(fe){var H=fe[0],ee=T(H,fe[3]||"");return{type:"code",raw:H,lang:fe[2]?fe[2].trim():fe[2],text:ee}}},_e.heading=function(le){var fe=this.rules.block.heading.exec(le);if(fe){var H=fe[2].trim();if(/#$/.test(H)){var ee=J(H,"#");(this.options.pedantic||!ee||/ $/.test(ee))&&(H=ee.trim())}return{type:"heading",raw:fe[0],depth:fe[1].length,text:H}}},_e.nptable=function(le){var fe=this.rules.block.nptable.exec(le);if(fe){var H={type:"table",header:oe(fe[1].replace(/^ *| *\| *$/g,"")),align:fe[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:fe[3]?fe[3].replace(/\n$/,"").split(`
`):[],raw:fe[0]};if(H.header.length===H.align.length){var ee=H.align.length,ue;for(ue=0;ue<ee;ue++)/^ *-+: *$/.test(H.align[ue])?H.align[ue]="right":/^ *:-+: *$/.test(H.align[ue])?H.align[ue]="center":/^ *:-+ *$/.test(H.align[ue])?H.align[ue]="left":H.align[ue]=null;for(ee=H.cells.length,ue=0;ue<ee;ue++)H.cells[ue]=oe(H.cells[ue],H.header.length);return H}}},_e.hr=function(le){var fe=this.rules.block.hr.exec(le);if(fe)return{type:"hr",raw:fe[0]}},_e.blockquote=function(le){var fe=this.rules.block.blockquote.exec(le);if(fe){var H=fe[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:fe[0],text:H}}},_e.list=function(le){var fe=this.rules.block.list.exec(le);if(fe){var H=fe[0],ee=fe[2],ue=ee.length>1,Pe={type:"list",raw:H,ordered:ue,start:ue?+ee.slice(0,-1):"",loose:!1,items:[]},Ae=fe[0].match(this.rules.block.item),xe=!1,Be,Qe,rt,nt,Ze,ot,Ee,De,de=Ae.length;rt=this.rules.block.listItemStart.exec(Ae[0]);for(var G=0;G<de;G++){if(Be=Ae[G],H=Be,G!==de-1){if(nt=this.rules.block.listItemStart.exec(Ae[G+1]),this.options.pedantic?nt[1].length>rt[1].length:nt[1].length>rt[0].length||nt[1].length>3){Ae.splice(G,2,Ae[G]+`
`+Ae[G+1]),G--,de--;continue}else(!this.options.pedantic||this.options.smartLists?nt[2][nt[2].length-1]!==ee[ee.length-1]:ue===(nt[2].length===1))&&(Ze=Ae.slice(G+1).join(`
`),Pe.raw=Pe.raw.substring(0,Pe.raw.length-Ze.length),G=de-1);rt=nt}Qe=Be.length,Be=Be.replace(/^ *([*+-]|\d+[.)]) ?/,""),~Be.indexOf(`
 `)&&(Qe-=Be.length,Be=this.options.pedantic?Be.replace(/^ {1,4}/gm,""):Be.replace(new RegExp("^ {1,"+Qe+"}","gm"),"")),ot=xe||/\n\n(?!\s*$)/.test(Be),G!==de-1&&(xe=Be.charAt(Be.length-1)===`
`,ot||(ot=xe)),ot&&(Pe.loose=!0),this.options.gfm&&(Ee=/^\[[ xX]\] /.test(Be),De=void 0,Ee&&(De=Be[1]!==" ",Be=Be.replace(/^\[[ xX]\] +/,""))),Pe.items.push({type:"list_item",raw:H,task:Ee,checked:De,loose:ot,text:Be})}return Pe}},_e.html=function(le){var fe=this.rules.block.html.exec(le);if(fe)return{type:this.options.sanitize?"paragraph":"html",raw:fe[0],pre:!this.options.sanitizer&&(fe[1]==="pre"||fe[1]==="script"||fe[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(fe[0]):q(fe[0]):fe[0]}},_e.def=function(le){var fe=this.rules.block.def.exec(le);if(fe){fe[3]&&(fe[3]=fe[3].substring(1,fe[3].length-1));var H=fe[1].toLowerCase().replace(/\s+/g," ");return{tag:H,raw:fe[0],href:fe[2],title:fe[3]}}},_e.table=function(le){var fe=this.rules.block.table.exec(le);if(fe){var H={type:"table",header:oe(fe[1].replace(/^ *| *\| *$/g,"")),align:fe[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:fe[3]?fe[3].replace(/\n$/,"").split(`
`):[]};if(H.header.length===H.align.length){H.raw=fe[0];var ee=H.align.length,ue;for(ue=0;ue<ee;ue++)/^ *-+: *$/.test(H.align[ue])?H.align[ue]="right":/^ *:-+: *$/.test(H.align[ue])?H.align[ue]="center":/^ *:-+ *$/.test(H.align[ue])?H.align[ue]="left":H.align[ue]=null;for(ee=H.cells.length,ue=0;ue<ee;ue++)H.cells[ue]=oe(H.cells[ue].replace(/^ *\| *| *\| *$/g,""),H.header.length);return H}}},_e.lheading=function(le){var fe=this.rules.block.lheading.exec(le);if(fe)return{type:"heading",raw:fe[0],depth:fe[2].charAt(0)==="="?1:2,text:fe[1]}},_e.paragraph=function(le){var fe=this.rules.block.paragraph.exec(le);if(fe)return{type:"paragraph",raw:fe[0],text:fe[1].charAt(fe[1].length-1)===`
`?fe[1].slice(0,-1):fe[1]}},_e.text=function(le){var fe=this.rules.block.text.exec(le);if(fe)return{type:"text",raw:fe[0],text:fe[0]}},_e.escape=function(le){var fe=this.rules.inline.escape.exec(le);if(fe)return{type:"escape",raw:fe[0],text:q(fe[1])}},_e.tag=function(le,fe,H){var ee=this.rules.inline.tag.exec(le);if(ee)return!fe&&/^<a /i.test(ee[0])?fe=!0:fe&&/^<\/a>/i.test(ee[0])&&(fe=!1),!H&&/^<(pre|code|kbd|script)(\s|>)/i.test(ee[0])?H=!0:H&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ee[0])&&(H=!1),{type:this.options.sanitize?"text":"html",raw:ee[0],inLink:fe,inRawBlock:H,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ee[0]):q(ee[0]):ee[0]}},_e.link=function(le){var fe=this.rules.inline.link.exec(le);if(fe){var H=fe[2].trim();if(!this.options.pedantic&&/^</.test(H)){if(!/>$/.test(H))return;var ee=J(H.slice(0,-1),"\\");if((H.length-ee.length)%2==0)return}else{var ue=x(fe[2],"()");if(ue>-1){var Pe=fe[0].indexOf("!")===0?5:4,Ae=Pe+fe[1].length+ue;fe[2]=fe[2].substring(0,ue),fe[0]=fe[0].substring(0,Ae).trim(),fe[3]=""}}var xe=fe[2],Be="";if(this.options.pedantic){var Qe=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(xe);Qe&&(xe=Qe[1],Be=Qe[3])}else Be=fe[3]?fe[3].slice(1,-1):"";return xe=xe.trim(),/^</.test(xe)&&(this.options.pedantic&&!/>$/.test(H)?xe=xe.slice(1):xe=xe.slice(1,-1)),V(fe,{href:xe&&xe.replace(this.rules.inline._escapes,"$1"),title:Be&&Be.replace(this.rules.inline._escapes,"$1")},fe[0])}},_e.reflink=function(le,fe){var H;if((H=this.rules.inline.reflink.exec(le))||(H=this.rules.inline.nolink.exec(le))){var ee=(H[2]||H[1]).replace(/\s+/g," ");if(ee=fe[ee.toLowerCase()],!ee||!ee.href){var ue=H[0].charAt(0);return{type:"text",raw:ue,text:ue}}return V(H,ee,H[0])}},_e.emStrong=function(le,fe,H){H===void 0&&(H="");var ee=this.rules.inline.emStrong.lDelim.exec(le);if(!!ee&&!(ee[3]&&H.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var ue=ee[1]||ee[2]||"";if(!ue||ue&&(H===""||this.rules.inline.punctuation.exec(H))){var Pe=ee[0].length-1,Ae,xe,Be=Pe,Qe=0,rt=ee[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(rt.lastIndex=0,fe=fe.slice(-1*le.length+Pe);(ee=rt.exec(fe))!=null;)if(Ae=ee[1]||ee[2]||ee[3]||ee[4]||ee[5]||ee[6],!!Ae){if(xe=Ae.length,ee[3]||ee[4]){Be+=xe;continue}else if((ee[5]||ee[6])&&Pe%3&&!((Pe+xe)%3)){Qe+=xe;continue}if(Be-=xe,!(Be>0)){if(Be+Qe-xe<=0&&!fe.slice(rt.lastIndex).match(rt)&&(xe=Math.min(xe,xe+Be+Qe)),Math.min(Pe,xe)%2)return{type:"em",raw:le.slice(0,Pe+ee.index+xe+1),text:le.slice(1,Pe+ee.index+xe)};if(Math.min(Pe,xe)%2==0)return{type:"strong",raw:le.slice(0,Pe+ee.index+xe+1),text:le.slice(2,Pe+ee.index+xe-1)}}}}}},_e.codespan=function(le){var fe=this.rules.inline.code.exec(le);if(fe){var H=fe[2].replace(/\n/g," "),ee=/[^ ]/.test(H),ue=/^ /.test(H)&&/ $/.test(H);return ee&&ue&&(H=H.substring(1,H.length-1)),H=q(H,!0),{type:"codespan",raw:fe[0],text:H}}},_e.br=function(le){var fe=this.rules.inline.br.exec(le);if(fe)return{type:"br",raw:fe[0]}},_e.del=function(le){var fe=this.rules.inline.del.exec(le);if(fe)return{type:"del",raw:fe[0],text:fe[2]}},_e.autolink=function(le,fe){var H=this.rules.inline.autolink.exec(le);if(H){var ee,ue;return H[2]==="@"?(ee=q(this.options.mangle?fe(H[1]):H[1]),ue="mailto:"+ee):(ee=q(H[1]),ue=ee),{type:"link",raw:H[0],text:ee,href:ue,tokens:[{type:"text",raw:ee,text:ee}]}}},_e.url=function(le,fe){var H;if(H=this.rules.inline.url.exec(le)){var ee,ue;if(H[2]==="@")ee=q(this.options.mangle?fe(H[0]):H[0]),ue="mailto:"+ee;else{var Pe;do Pe=H[0],H[0]=this.rules.inline._backpedal.exec(H[0])[0];while(Pe!==H[0]);ee=q(H[0]),H[1]==="www."?ue="http://"+ee:ue=ee}return{type:"link",raw:H[0],text:ee,href:ue,tokens:[{type:"text",raw:ee,text:ee}]}}},_e.inlineText=function(le,fe,H){var ee=this.rules.inline.text.exec(le);if(ee){var ue;return fe?ue=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ee[0]):q(ee[0]):ee[0]:ue=q(this.options.smartypants?H(ee[0]):ee[0]),{type:"text",raw:ee[0],text:ue}}},Se}(),F=O.noopTest,M=O.edit,U=O.merge,B={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:F,table:F,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};B._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,B._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,B.def=M(B.def).replace("label",B._label).replace("title",B._title).getRegex(),B.bullet=/(?:[*+-]|\d{1,9}[.)])/,B.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,B.item=M(B.item,"gm").replace(/bull/g,B.bullet).getRegex(),B.listItemStart=M(/^( *)(bull)/).replace("bull",B.bullet).getRegex(),B.list=M(B.list).replace(/bull/g,B.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+B.def.source+")").getRegex(),B._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",B._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,B.html=M(B.html,"i").replace("comment",B._comment).replace("tag",B._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),B.paragraph=M(B._paragraph).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",B._tag).getRegex(),B.blockquote=M(B.blockquote).replace("paragraph",B.paragraph).getRegex(),B.normal=U({},B),B.gfm=U({},B.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),B.gfm.nptable=M(B.gfm.nptable).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",B._tag).getRegex(),B.gfm.table=M(B.gfm.table).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",B._tag).getRegex(),B.pedantic=U({},B.normal,{html:M(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",B._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:F,paragraph:M(B.normal._paragraph).replace("hr",B.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",B.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var K={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:F,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:F,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};K._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",K.punctuation=M(K.punctuation).replace(/punctuation/g,K._punctuation).getRegex(),K.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,K.escapedEmSt=/\\\*|\\_/g,K._comment=M(B._comment).replace("(?:-->|$)","-->").getRegex(),K.emStrong.lDelim=M(K.emStrong.lDelim).replace(/punct/g,K._punctuation).getRegex(),K.emStrong.rDelimAst=M(K.emStrong.rDelimAst,"g").replace(/punct/g,K._punctuation).getRegex(),K.emStrong.rDelimUnd=M(K.emStrong.rDelimUnd,"g").replace(/punct/g,K._punctuation).getRegex(),K._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,K._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,K._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,K.autolink=M(K.autolink).replace("scheme",K._scheme).replace("email",K._email).getRegex(),K._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,K.tag=M(K.tag).replace("comment",K._comment).replace("attribute",K._attribute).getRegex(),K._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,K._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,K._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,K.link=M(K.link).replace("label",K._label).replace("href",K._href).replace("title",K._title).getRegex(),K.reflink=M(K.reflink).replace("label",K._label).getRegex(),K.reflinkSearch=M(K.reflinkSearch,"g").replace("reflink",K.reflink).replace("nolink",K.nolink).getRegex(),K.normal=U({},K),K.pedantic=U({},K.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:M(/^!?\[(label)\]\((.*?)\)/).replace("label",K._label).getRegex(),reflink:M(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",K._label).getRegex()}),K.gfm=U({},K.normal,{escape:M(K.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),K.gfm.url=M(K.gfm.url,"i").replace("email",K.gfm._extended_email).getRegex(),K.breaks=U({},K.gfm,{br:M(K.br).replace("{2,}","*").getRegex(),text:M(K.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var ie={block:B,inline:K},we=A.defaults,Te=ie.block,ye=ie.inline,Oe=O.repeatString;function je(Se){return Se.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function ze(Se){var _e="",ke,le,fe=Se.length;for(ke=0;ke<fe;ke++)le=Se.charCodeAt(ke),Math.random()>.5&&(le="x"+le.toString(16)),_e+="&#"+le+";";return _e}var qe=function(){function Se(ke){this.tokens=[],this.tokens.links=Object.create(null),this.options=ke||we,this.options.tokenizer=this.options.tokenizer||new N,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var le={block:Te.normal,inline:ye.normal};this.options.pedantic?(le.block=Te.pedantic,le.inline=ye.pedantic):this.options.gfm&&(le.block=Te.gfm,this.options.breaks?le.inline=ye.breaks:le.inline=ye.gfm),this.tokenizer.rules=le}Se.lex=function(le,fe){var H=new Se(fe);return H.lex(le)},Se.lexInline=function(le,fe){var H=new Se(fe);return H.inlineTokens(le)};var _e=Se.prototype;return _e.lex=function(le){return le=le.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(le,this.tokens,!0),this.inline(this.tokens),this.tokens},_e.blockTokens=function(le,fe,H){fe===void 0&&(fe=[]),H===void 0&&(H=!0),this.options.pedantic&&(le=le.replace(/^ +$/gm,""));for(var ee,ue,Pe,Ae;le;){if(ee=this.tokenizer.space(le)){le=le.substring(ee.raw.length),ee.type&&fe.push(ee);continue}if(ee=this.tokenizer.code(le)){le=le.substring(ee.raw.length),Ae=fe[fe.length-1],Ae&&Ae.type==="paragraph"?(Ae.raw+=`
`+ee.raw,Ae.text+=`
`+ee.text):fe.push(ee);continue}if(ee=this.tokenizer.fences(le)){le=le.substring(ee.raw.length),fe.push(ee);continue}if(ee=this.tokenizer.heading(le)){le=le.substring(ee.raw.length),fe.push(ee);continue}if(ee=this.tokenizer.nptable(le)){le=le.substring(ee.raw.length),fe.push(ee);continue}if(ee=this.tokenizer.hr(le)){le=le.substring(ee.raw.length),fe.push(ee);continue}if(ee=this.tokenizer.blockquote(le)){le=le.substring(ee.raw.length),ee.tokens=this.blockTokens(ee.text,[],H),fe.push(ee);continue}if(ee=this.tokenizer.list(le)){for(le=le.substring(ee.raw.length),Pe=ee.items.length,ue=0;ue<Pe;ue++)ee.items[ue].tokens=this.blockTokens(ee.items[ue].text,[],!1);fe.push(ee);continue}if(ee=this.tokenizer.html(le)){le=le.substring(ee.raw.length),fe.push(ee);continue}if(H&&(ee=this.tokenizer.def(le))){le=le.substring(ee.raw.length),this.tokens.links[ee.tag]||(this.tokens.links[ee.tag]={href:ee.href,title:ee.title});continue}if(ee=this.tokenizer.table(le)){le=le.substring(ee.raw.length),fe.push(ee);continue}if(ee=this.tokenizer.lheading(le)){le=le.substring(ee.raw.length),fe.push(ee);continue}if(H&&(ee=this.tokenizer.paragraph(le))){le=le.substring(ee.raw.length),fe.push(ee);continue}if(ee=this.tokenizer.text(le)){le=le.substring(ee.raw.length),Ae=fe[fe.length-1],Ae&&Ae.type==="text"?(Ae.raw+=`
`+ee.raw,Ae.text+=`
`+ee.text):fe.push(ee);continue}if(le){var xe="Infinite loop on byte: "+le.charCodeAt(0);if(this.options.silent){console.error(xe);break}else throw new Error(xe)}}return fe},_e.inline=function(le){var fe,H,ee,ue,Pe,Ae,xe=le.length;for(fe=0;fe<xe;fe++)switch(Ae=le[fe],Ae.type){case"paragraph":case"text":case"heading":{Ae.tokens=[],this.inlineTokens(Ae.text,Ae.tokens);break}case"table":{for(Ae.tokens={header:[],cells:[]},ue=Ae.header.length,H=0;H<ue;H++)Ae.tokens.header[H]=[],this.inlineTokens(Ae.header[H],Ae.tokens.header[H]);for(ue=Ae.cells.length,H=0;H<ue;H++)for(Pe=Ae.cells[H],Ae.tokens.cells[H]=[],ee=0;ee<Pe.length;ee++)Ae.tokens.cells[H][ee]=[],this.inlineTokens(Pe[ee],Ae.tokens.cells[H][ee]);break}case"blockquote":{this.inline(Ae.tokens);break}case"list":{for(ue=Ae.items.length,H=0;H<ue;H++)this.inline(Ae.items[H].tokens);break}}return le},_e.inlineTokens=function(le,fe,H,ee){fe===void 0&&(fe=[]),H===void 0&&(H=!1),ee===void 0&&(ee=!1);var ue,Pe,Ae=le,xe,Be,Qe;if(this.tokens.links){var rt=Object.keys(this.tokens.links);if(rt.length>0)for(;(xe=this.tokenizer.rules.inline.reflinkSearch.exec(Ae))!=null;)rt.includes(xe[0].slice(xe[0].lastIndexOf("[")+1,-1))&&(Ae=Ae.slice(0,xe.index)+"["+Oe("a",xe[0].length-2)+"]"+Ae.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(xe=this.tokenizer.rules.inline.blockSkip.exec(Ae))!=null;)Ae=Ae.slice(0,xe.index)+"["+Oe("a",xe[0].length-2)+"]"+Ae.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(xe=this.tokenizer.rules.inline.escapedEmSt.exec(Ae))!=null;)Ae=Ae.slice(0,xe.index)+"++"+Ae.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;le;){if(Be||(Qe=""),Be=!1,ue=this.tokenizer.escape(le)){le=le.substring(ue.raw.length),fe.push(ue);continue}if(ue=this.tokenizer.tag(le,H,ee)){le=le.substring(ue.raw.length),H=ue.inLink,ee=ue.inRawBlock;var nt=fe[fe.length-1];nt&&ue.type==="text"&&nt.type==="text"?(nt.raw+=ue.raw,nt.text+=ue.text):fe.push(ue);continue}if(ue=this.tokenizer.link(le)){le=le.substring(ue.raw.length),ue.type==="link"&&(ue.tokens=this.inlineTokens(ue.text,[],!0,ee)),fe.push(ue);continue}if(ue=this.tokenizer.reflink(le,this.tokens.links)){le=le.substring(ue.raw.length);var Ze=fe[fe.length-1];ue.type==="link"?(ue.tokens=this.inlineTokens(ue.text,[],!0,ee),fe.push(ue)):Ze&&ue.type==="text"&&Ze.type==="text"?(Ze.raw+=ue.raw,Ze.text+=ue.text):fe.push(ue);continue}if(ue=this.tokenizer.emStrong(le,Ae,Qe)){le=le.substring(ue.raw.length),ue.tokens=this.inlineTokens(ue.text,[],H,ee),fe.push(ue);continue}if(ue=this.tokenizer.codespan(le)){le=le.substring(ue.raw.length),fe.push(ue);continue}if(ue=this.tokenizer.br(le)){le=le.substring(ue.raw.length),fe.push(ue);continue}if(ue=this.tokenizer.del(le)){le=le.substring(ue.raw.length),ue.tokens=this.inlineTokens(ue.text,[],H,ee),fe.push(ue);continue}if(ue=this.tokenizer.autolink(le,ze)){le=le.substring(ue.raw.length),fe.push(ue);continue}if(!H&&(ue=this.tokenizer.url(le,ze))){le=le.substring(ue.raw.length),fe.push(ue);continue}if(ue=this.tokenizer.inlineText(le,ee,je)){le=le.substring(ue.raw.length),ue.raw.slice(-1)!=="_"&&(Qe=ue.raw.slice(-1)),Be=!0,Pe=fe[fe.length-1],Pe&&Pe.type==="text"?(Pe.raw+=ue.raw,Pe.text+=ue.text):fe.push(ue);continue}if(le){var ot="Infinite loop on byte: "+le.charCodeAt(0);if(this.options.silent){console.error(ot);break}else throw new Error(ot)}}return fe},e(Se,null,[{key:"rules",get:function(){return{block:Te,inline:ye}}}]),Se}(),j=A.defaults,Z=O.cleanUrl,ne=O.escape,ae=function(){function Se(ke){this.options=ke||j}var _e=Se.prototype;return _e.code=function(le,fe,H){var ee=(fe||"").match(/\S*/)[0];if(this.options.highlight){var ue=this.options.highlight(le,ee);ue!=null&&ue!==le&&(H=!0,le=ue)}return le=le.replace(/\n$/,"")+`
`,ee?'<pre><code class="'+this.options.langPrefix+ne(ee,!0)+'">'+(H?le:ne(le,!0))+`</code></pre>
`:"<pre><code>"+(H?le:ne(le,!0))+`</code></pre>
`},_e.blockquote=function(le){return`<blockquote>
`+le+`</blockquote>
`},_e.html=function(le){return le},_e.heading=function(le,fe,H,ee){return this.options.headerIds?"<h"+fe+' id="'+this.options.headerPrefix+ee.slug(H)+'">'+le+"</h"+fe+`>
`:"<h"+fe+">"+le+"</h"+fe+`>
`},_e.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},_e.list=function(le,fe,H){var ee=fe?"ol":"ul",ue=fe&&H!==1?' start="'+H+'"':"";return"<"+ee+ue+`>
`+le+"</"+ee+`>
`},_e.listitem=function(le){return"<li>"+le+`</li>
`},_e.checkbox=function(le){return"<input "+(le?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},_e.paragraph=function(le){return"<p>"+le+`</p>
`},_e.table=function(le,fe){return fe&&(fe="<tbody>"+fe+"</tbody>"),`<table>
<thead>
`+le+`</thead>
`+fe+`</table>
`},_e.tablerow=function(le){return`<tr>
`+le+`</tr>
`},_e.tablecell=function(le,fe){var H=fe.header?"th":"td",ee=fe.align?"<"+H+' align="'+fe.align+'">':"<"+H+">";return ee+le+"</"+H+`>
`},_e.strong=function(le){return"<strong>"+le+"</strong>"},_e.em=function(le){return"<em>"+le+"</em>"},_e.codespan=function(le){return"<code>"+le+"</code>"},_e.br=function(){return this.options.xhtml?"<br/>":"<br>"},_e.del=function(le){return"<del>"+le+"</del>"},_e.link=function(le,fe,H){if(le=Z(this.options.sanitize,this.options.baseUrl,le),le===null)return H;var ee='<a href="'+ne(le)+'"';return fe&&(ee+=' title="'+fe+'"'),ee+=">"+H+"</a>",ee},_e.image=function(le,fe,H){if(le=Z(this.options.sanitize,this.options.baseUrl,le),le===null)return H;var ee='<img src="'+le+'" alt="'+H+'"';return fe&&(ee+=' title="'+fe+'"'),ee+=this.options.xhtml?"/>":">",ee},_e.text=function(le){return le},Se}(),Y=function(){function Se(){}var _e=Se.prototype;return _e.strong=function(le){return le},_e.em=function(le){return le},_e.codespan=function(le){return le},_e.del=function(le){return le},_e.html=function(le){return le},_e.text=function(le){return le},_e.link=function(le,fe,H){return""+H},_e.image=function(le,fe,H){return""+H},_e.br=function(){return""},Se}(),ce=function(){function Se(){this.seen={}}var _e=Se.prototype;return _e.serialize=function(le){return le.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},_e.getNextSafeSlug=function(le,fe){var H=le,ee=0;if(this.seen.hasOwnProperty(H)){ee=this.seen[le];do ee++,H=le+"-"+ee;while(this.seen.hasOwnProperty(H))}return fe||(this.seen[le]=ee,this.seen[H]=0),H},_e.slug=function(le,fe){fe===void 0&&(fe={});var H=this.serialize(le);return this.getNextSafeSlug(H,fe.dryrun)},Se}(),me=A.defaults,Re=O.unescape,He=function(){function Se(ke){this.options=ke||me,this.options.renderer=this.options.renderer||new ae,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Y,this.slugger=new ce}Se.parse=function(le,fe){var H=new Se(fe);return H.parse(le)},Se.parseInline=function(le,fe){var H=new Se(fe);return H.parseInline(le)};var _e=Se.prototype;return _e.parse=function(le,fe){fe===void 0&&(fe=!0);var H="",ee,ue,Pe,Ae,xe,Be,Qe,rt,nt,Ze,ot,Ee,De,de,G,Ue,Le,Ge,Je=le.length;for(ee=0;ee<Je;ee++)switch(Ze=le[ee],Ze.type){case"space":continue;case"hr":{H+=this.renderer.hr();continue}case"heading":{H+=this.renderer.heading(this.parseInline(Ze.tokens),Ze.depth,Re(this.parseInline(Ze.tokens,this.textRenderer)),this.slugger);continue}case"code":{H+=this.renderer.code(Ze.text,Ze.lang,Ze.escaped);continue}case"table":{for(rt="",Qe="",Ae=Ze.header.length,ue=0;ue<Ae;ue++)Qe+=this.renderer.tablecell(this.parseInline(Ze.tokens.header[ue]),{header:!0,align:Ze.align[ue]});for(rt+=this.renderer.tablerow(Qe),nt="",Ae=Ze.cells.length,ue=0;ue<Ae;ue++){for(Be=Ze.tokens.cells[ue],Qe="",xe=Be.length,Pe=0;Pe<xe;Pe++)Qe+=this.renderer.tablecell(this.parseInline(Be[Pe]),{header:!1,align:Ze.align[Pe]});nt+=this.renderer.tablerow(Qe)}H+=this.renderer.table(rt,nt);continue}case"blockquote":{nt=this.parse(Ze.tokens),H+=this.renderer.blockquote(nt);continue}case"list":{for(ot=Ze.ordered,Ee=Ze.start,De=Ze.loose,Ae=Ze.items.length,nt="",ue=0;ue<Ae;ue++)G=Ze.items[ue],Ue=G.checked,Le=G.task,de="",G.task&&(Ge=this.renderer.checkbox(Ue),De?G.tokens.length>0&&G.tokens[0].type==="text"?(G.tokens[0].text=Ge+" "+G.tokens[0].text,G.tokens[0].tokens&&G.tokens[0].tokens.length>0&&G.tokens[0].tokens[0].type==="text"&&(G.tokens[0].tokens[0].text=Ge+" "+G.tokens[0].tokens[0].text)):G.tokens.unshift({type:"text",text:Ge}):de+=Ge),de+=this.parse(G.tokens,De),nt+=this.renderer.listitem(de,Le,Ue);H+=this.renderer.list(nt,ot,Ee);continue}case"html":{H+=this.renderer.html(Ze.text);continue}case"paragraph":{H+=this.renderer.paragraph(this.parseInline(Ze.tokens));continue}case"text":{for(nt=Ze.tokens?this.parseInline(Ze.tokens):Ze.text;ee+1<Je&&le[ee+1].type==="text";)Ze=le[++ee],nt+=`
`+(Ze.tokens?this.parseInline(Ze.tokens):Ze.text);H+=fe?this.renderer.paragraph(nt):nt;continue}default:{var lt='Token with "'+Ze.type+'" type was not found.';if(this.options.silent){console.error(lt);return}else throw new Error(lt)}}return H},_e.parseInline=function(le,fe){fe=fe||this.renderer;var H="",ee,ue,Pe=le.length;for(ee=0;ee<Pe;ee++)switch(ue=le[ee],ue.type){case"escape":{H+=fe.text(ue.text);break}case"html":{H+=fe.html(ue.text);break}case"link":{H+=fe.link(ue.href,ue.title,this.parseInline(ue.tokens,fe));break}case"image":{H+=fe.image(ue.href,ue.title,ue.text);break}case"strong":{H+=fe.strong(this.parseInline(ue.tokens,fe));break}case"em":{H+=fe.em(this.parseInline(ue.tokens,fe));break}case"codespan":{H+=fe.codespan(ue.text);break}case"br":{H+=fe.br();break}case"del":{H+=fe.del(this.parseInline(ue.tokens,fe));break}case"text":{H+=fe.text(ue.text);break}default:{var Ae='Token with "'+ue.type+'" type was not found.';if(this.options.silent){console.error(Ae);return}else throw new Error(Ae)}}return H},Se}(),be=O.merge,Xe=O.checkSanitizeDeprecation,Q=O.escape,re=A.getDefaults,ve=A.changeDefaults,Me=A.defaults;function Ne(Se,_e,ke){if(typeof Se=="undefined"||Se===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Se!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Se)+", string expected");if(typeof _e=="function"&&(ke=_e,_e=null),_e=be({},Ne.defaults,_e||{}),Xe(_e),ke){var le=_e.highlight,fe;try{fe=qe.lex(Se,_e)}catch(Pe){return ke(Pe)}var H=function(Ae){var xe;if(!Ae)try{xe=He.parse(fe,_e)}catch(Be){Ae=Be}return _e.highlight=le,Ae?ke(Ae):ke(null,xe)};if(!le||le.length<3||(delete _e.highlight,!fe.length))return H();var ee=0;Ne.walkTokens(fe,function(Pe){Pe.type==="code"&&(ee++,setTimeout(function(){le(Pe.text,Pe.lang,function(Ae,xe){if(Ae)return H(Ae);xe!=null&&xe!==Pe.text&&(Pe.text=xe,Pe.escaped=!0),ee--,ee===0&&H()})},0))}),ee===0&&H();return}try{var ue=qe.lex(Se,_e);return _e.walkTokens&&Ne.walkTokens(ue,_e.walkTokens),He.parse(ue,_e)}catch(Pe){if(Pe.message+=`
Please report this to https://github.com/markedjs/marked.`,_e.silent)return"<p>An error occurred:</p><pre>"+Q(Pe.message+"",!0)+"</pre>";throw Pe}}Ne.options=Ne.setOptions=function(Se){return be(Ne.defaults,Se),ve(Ne.defaults),Ne},Ne.getDefaults=re,Ne.defaults=Me,Ne.use=function(Se){var _e=be({},Se);if(Se.renderer&&function(){var le=Ne.defaults.renderer||new ae,fe=function(ue){var Pe=le[ue];le[ue]=function(){for(var Ae=arguments.length,xe=new Array(Ae),Be=0;Be<Ae;Be++)xe[Be]=arguments[Be];var Qe=Se.renderer[ue].apply(le,xe);return Qe===!1&&(Qe=Pe.apply(le,xe)),Qe}};for(var H in Se.renderer)fe(H);_e.renderer=le}(),Se.tokenizer&&function(){var le=Ne.defaults.tokenizer||new N,fe=function(ue){var Pe=le[ue];le[ue]=function(){for(var Ae=arguments.length,xe=new Array(Ae),Be=0;Be<Ae;Be++)xe[Be]=arguments[Be];var Qe=Se.tokenizer[ue].apply(le,xe);return Qe===!1&&(Qe=Pe.apply(le,xe)),Qe}};for(var H in Se.tokenizer)fe(H);_e.tokenizer=le}(),Se.walkTokens){var ke=Ne.defaults.walkTokens;_e.walkTokens=function(le){Se.walkTokens(le),ke&&ke(le)}}Ne.setOptions(_e)},Ne.walkTokens=function(Se,_e){for(var ke=k(Se),le;!(le=ke()).done;){var fe=le.value;switch(_e(fe),fe.type){case"table":{for(var H=k(fe.tokens.header),ee;!(ee=H()).done;){var ue=ee.value;Ne.walkTokens(ue,_e)}for(var Pe=k(fe.tokens.cells),Ae;!(Ae=Pe()).done;)for(var xe=Ae.value,Be=k(xe),Qe;!(Qe=Be()).done;){var rt=Qe.value;Ne.walkTokens(rt,_e)}break}case"list":{Ne.walkTokens(fe.items,_e);break}default:fe.tokens&&Ne.walkTokens(fe.tokens,_e)}}},Ne.parseInline=function(Se,_e){if(typeof Se=="undefined"||Se===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Se!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Se)+", string expected");_e=be({},Ne.defaults,_e||{}),Xe(_e);try{var ke=qe.lexInline(Se,_e);return _e.walkTokens&&Ne.walkTokens(ke,_e.walkTokens),He.parseInline(ke,_e)}catch(le){if(le.message+=`
Please report this to https://github.com/markedjs/marked.`,_e.silent)return"<p>An error occurred:</p><pre>"+Q(le.message+"",!0)+"</pre>";throw le}},Ne.Parser=He,Ne.parser=He.parse,Ne.Renderer=ae,Ne.TextRenderer=Y,Ne.Lexer=qe,Ne.lexer=qe.lex,Ne.Tokenizer=N,Ne.Slugger=ce,Ne.parse=Ne;var Ye=Ne;return Ye}),define(ge[73],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function v(A,C,D){return Math.min(Math.max(A,C),D)}e.clamp=v;function R(A,C){return(C+A%C)%C}e.rot=R;class k{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=k;class y{constructor(){this._n=1,this._val=0}update(C){return this._val=this._val+(C-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=y}),function(){function X(k){const y=[];typeof k=="number"&&y.push("code/timeOrigin",k);function A(D){y.push(D,Date.now())}function C(){const D=[];for(let P=0;P<y.length;P+=2)D.push({name:y[P],startTime:y[P+1]});return D}return{mark:A,getMarks:C}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?X():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const y=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const A of performance.getEntriesByType("mark"))y.push({name:A.name,startTime:Math.round(k+A.startTime)});return y}};if(typeof process=="object"){const k=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return X(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),X()}function v(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return v(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=v(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=v(R))}(),define(ge[11],pe([0,1]),function(X,e){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const R="en";let k=!1,y=!1,A=!1,C=!1,D=!1,P=!1,s=!1,I,l=R,g,c;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let f;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?f=e.globals.vscode.process:typeof process!="undefined"&&(f=process);const _=typeof((v=f==null?void 0:f.versions)===null||v===void 0?void 0:v.electron)=="string"&&f.type==="renderer";if(e.isElectronSandboxed=_&&(f==null?void 0:f.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const n=f==null?void 0:f.env.VSCODE_BROWSER_CODE_LOADING;if(typeof n=="string")return n==="none"||n==="code"||n==="bypassHeatCheck"||n==="bypassHeatCheckAndEagerCompile"?n:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!_)c=navigator.userAgent,k=c.indexOf("Windows")>=0,y=c.indexOf("Macintosh")>=0,s=(c.indexOf("Macintosh")>=0||c.indexOf("iPad")>=0||c.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=c.indexOf("Linux")>=0,P=!0,I=navigator.language,l=I;else if(typeof f=="object"){k=f.platform==="win32",y=f.platform==="darwin",A=f.platform==="linux",C=A&&!!f.env.SNAP&&!!f.env.SNAP_REVISION,I=R,l=R;const n=f.env.VSCODE_NLS_CONFIG;if(n)try{const a=JSON.parse(n),p=a.availableLanguages["*"];I=a.locale,l=p||R,g=a._translationsConfigFile}catch(a){}D=!0}else console.error("Unable to resolve platform.");var w;(function(n){n[n.Web=0]="Web",n[n.Mac=1]="Mac",n[n.Linux=2]="Linux",n[n.Windows=3]="Windows"})(w=e.Platform||(e.Platform={}));function E(n){switch(n){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=E;let u=0;y?u=1:k?u=3:A&&(u=2),e.isWindows=k,e.isMacintosh=y,e.isLinux=A,e.isLinuxSnap=C,e.isNative=D,e.isWeb=P,e.isIOS=s,e.platform=u,e.userAgent=c,e.language=l;var h;(function(n){function a(){return e.language}n.value=a;function p(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}n.isDefaultVariant=p;function d(){return e.language==="en"}n.isDefault=d})(h=e.Language||(e.Language={})),e.locale=I,e.translationsConfigFile=g,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let p=[];e.globals.addEventListener("message",b=>{if(b.data&&b.data.vscodeSetImmediateId)for(let S=0,o=p.length;S<o;S++){const L=p[S];if(L.id===b.data.vscodeSetImmediateId){p.splice(S,1),L.callback();return}}});let d=0;return b=>{const S=++d;p.push({id:S,callback:b}),e.globals.postMessage({vscodeSetImmediateId:S},"*")}}if(typeof(f==null?void 0:f.nextTick)=="function")return f.nextTick.bind(f);const a=Promise.resolve();return p=>a.then(p)}();var m;(function(n){n[n.Windows=1]="Windows",n[n.Macintosh=2]="Macintosh",n[n.Linux=3]="Linux"})(m=e.OperatingSystem||(e.OperatingSystem={})),e.OS=y||s?2:k?1:3;let t=!0,r=!1;function i(){if(!r){r=!0;const n=new Uint8Array(2);n[0]=1,n[1]=2,t=new Uint16Array(n.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=i}),define(ge[37],pe([0,1,11]),function(X,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let R;if(typeof v.globals.vscode!="undefined"&&typeof v.globals.vscode.process!="undefined"){const k=v.globals.vscode.process;R={get platform(){return k.platform},get env(){return k.env},cwd(){return k.cwd()},nextTick(y){return v.setImmediate(y)}}}else typeof process!="undefined"?R={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(k){return process.nextTick(k)}}:R={get platform(){return v.isWindows?"win32":v.isMacintosh?"darwin":"linux"},nextTick(k){return v.setImmediate(k)},get env(){return{}},cwd(){return"/"}};e.cwd=R.cwd,e.env=R.env,e.platform=R.platform,e.nextTick=R.nextTick}),define(ge[9],pe([0,1,37]),function(X,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const R=65,k=97,y=90,A=122,C=46,D=47,P=92,s=58,I=63;class l extends Error{constructor(h,m,t){let r;typeof m=="string"&&m.indexOf("not ")===0?(r="must not be",m=m.replace(/^not /,"")):r="must be";const i=h.indexOf(".")!==-1?"property":"argument";let n=`The "${h}" ${i} ${r} of type ${m}`;n+=`. Received type ${typeof t}`,super(n),this.code="ERR_INVALID_ARG_TYPE"}}function g(u,h){if(typeof u!="string")throw new l(h,"string",u)}function c(u){return u===D||u===P}function f(u){return u===D}function _(u){return u>=R&&u<=y||u>=k&&u<=A}function w(u,h,m,t){let r="",i=0,n=-1,a=0,p=0;for(let d=0;d<=u.length;++d){if(d<u.length)p=u.charCodeAt(d);else{if(t(p))break;p=D}if(t(p)){if(!(n===d-1||a===1))if(a===2){if(r.length<2||i!==2||r.charCodeAt(r.length-1)!==C||r.charCodeAt(r.length-2)!==C){if(r.length>2){const b=r.lastIndexOf(m);b===-1?(r="",i=0):(r=r.slice(0,b),i=r.length-1-r.lastIndexOf(m)),n=d,a=0;continue}else if(r.length!==0){r="",i=0,n=d,a=0;continue}}h&&(r+=r.length>0?`${m}..`:"..",i=2)}else r.length>0?r+=`${m}${u.slice(n+1,d)}`:r=u.slice(n+1,d),i=d-n-1;n=d,a=0}else p===C&&a!==-1?++a:a=-1}return r}function E(u,h){if(h===null||typeof h!="object")throw new l("pathObject","Object",h);const m=h.dir||h.root,t=h.base||`${h.name||""}${h.ext||""}`;return m?m===h.root?`${m}${t}`:`${m}${u}${t}`:t}e.win32={resolve(...u){let h="",m="",t=!1;for(let r=u.length-1;r>=-1;r--){let i;if(r>=0){if(i=u[r],g(i,"path"),i.length===0)continue}else h.length===0?i=v.cwd():(i=v.env[`=${h}`]||v.cwd(),(i===void 0||i.slice(0,2).toLowerCase()!==h.toLowerCase()&&i.charCodeAt(2)===P)&&(i=`${h}\\`));const n=i.length;let a=0,p="",d=!1;const b=i.charCodeAt(0);if(n===1)c(b)&&(a=1,d=!0);else if(c(b))if(d=!0,c(i.charCodeAt(1))){let S=2,o=S;for(;S<n&&!c(i.charCodeAt(S));)S++;if(S<n&&S!==o){const L=i.slice(o,S);for(o=S;S<n&&c(i.charCodeAt(S));)S++;if(S<n&&S!==o){for(o=S;S<n&&!c(i.charCodeAt(S));)S++;(S===n||S!==o)&&(p=`\\\\${L}\\${i.slice(o,S)}`,a=S)}}}else a=1;else _(b)&&i.charCodeAt(1)===s&&(p=i.slice(0,2),a=2,n>2&&c(i.charCodeAt(2))&&(d=!0,a=3));if(p.length>0)if(h.length>0){if(p.toLowerCase()!==h.toLowerCase())continue}else h=p;if(t){if(h.length>0)break}else if(m=`${i.slice(a)}\\${m}`,t=d,d&&h.length>0)break}return m=w(m,!t,"\\",c),t?`${h}\\${m}`:`${h}${m}`||"."},normalize(u){g(u,"path");const h=u.length;if(h===0)return".";let m=0,t,r=!1;const i=u.charCodeAt(0);if(h===1)return f(i)?"\\":u;if(c(i))if(r=!0,c(u.charCodeAt(1))){let a=2,p=a;for(;a<h&&!c(u.charCodeAt(a));)a++;if(a<h&&a!==p){const d=u.slice(p,a);for(p=a;a<h&&c(u.charCodeAt(a));)a++;if(a<h&&a!==p){for(p=a;a<h&&!c(u.charCodeAt(a));)a++;if(a===h)return`\\\\${d}\\${u.slice(p)}\\`;a!==p&&(t=`\\\\${d}\\${u.slice(p,a)}`,m=a)}}}else m=1;else _(i)&&u.charCodeAt(1)===s&&(t=u.slice(0,2),m=2,h>2&&c(u.charCodeAt(2))&&(r=!0,m=3));let n=m<h?w(u.slice(m),!r,"\\",c):"";return n.length===0&&!r&&(n="."),n.length>0&&c(u.charCodeAt(h-1))&&(n+="\\"),t===void 0?r?`\\${n}`:n:r?`${t}\\${n}`:`${t}${n}`},isAbsolute(u){g(u,"path");const h=u.length;if(h===0)return!1;const m=u.charCodeAt(0);return c(m)||h>2&&_(m)&&u.charCodeAt(1)===s&&c(u.charCodeAt(2))},join(...u){if(u.length===0)return".";let h,m;for(let i=0;i<u.length;++i){const n=u[i];g(n,"path"),n.length>0&&(h===void 0?h=m=n:h+=`\\${n}`)}if(h===void 0)return".";let t=!0,r=0;if(typeof m=="string"&&c(m.charCodeAt(0))){++r;const i=m.length;i>1&&c(m.charCodeAt(1))&&(++r,i>2&&(c(m.charCodeAt(2))?++r:t=!1))}if(t){for(;r<h.length&&c(h.charCodeAt(r));)r++;r>=2&&(h=`\\${h.slice(r)}`)}return e.win32.normalize(h)},relative(u,h){if(g(u,"from"),g(h,"to"),u===h)return"";const m=e.win32.resolve(u),t=e.win32.resolve(h);if(m===t||(u=m.toLowerCase(),h=t.toLowerCase(),u===h))return"";let r=0;for(;r<u.length&&u.charCodeAt(r)===P;)r++;let i=u.length;for(;i-1>r&&u.charCodeAt(i-1)===P;)i--;const n=i-r;let a=0;for(;a<h.length&&h.charCodeAt(a)===P;)a++;let p=h.length;for(;p-1>a&&h.charCodeAt(p-1)===P;)p--;const d=p-a,b=n<d?n:d;let S=-1,o=0;for(;o<b;o++){const O=u.charCodeAt(r+o);if(O!==h.charCodeAt(a+o))break;O===P&&(S=o)}if(o!==b){if(S===-1)return t}else{if(d>b){if(h.charCodeAt(a+o)===P)return t.slice(a+o+1);if(o===2)return t.slice(a+o)}n>b&&(u.charCodeAt(r+o)===P?S=o:o===2&&(S=3)),S===-1&&(S=0)}let L="";for(o=r+S+1;o<=i;++o)(o===i||u.charCodeAt(o)===P)&&(L+=L.length===0?"..":"\\..");return a+=S,L.length>0?`${L}${t.slice(a,p)}`:(t.charCodeAt(a)===P&&++a,t.slice(a,p))},toNamespacedPath(u){if(typeof u!="string")return u;if(u.length===0)return"";const h=e.win32.resolve(u);if(h.length<=2)return u;if(h.charCodeAt(0)===P){if(h.charCodeAt(1)===P){const m=h.charCodeAt(2);if(m!==I&&m!==C)return`\\\\?\\UNC\\${h.slice(2)}`}}else if(_(h.charCodeAt(0))&&h.charCodeAt(1)===s&&h.charCodeAt(2)===P)return`\\\\?\\${h}`;return u},dirname(u){g(u,"path");const h=u.length;if(h===0)return".";let m=-1,t=0;const r=u.charCodeAt(0);if(h===1)return c(r)?u:".";if(c(r)){if(m=t=1,c(u.charCodeAt(1))){let a=2,p=a;for(;a<h&&!c(u.charCodeAt(a));)a++;if(a<h&&a!==p){for(p=a;a<h&&c(u.charCodeAt(a));)a++;if(a<h&&a!==p){for(p=a;a<h&&!c(u.charCodeAt(a));)a++;if(a===h)return u;a!==p&&(m=t=a+1)}}}}else _(r)&&u.charCodeAt(1)===s&&(m=h>2&&c(u.charCodeAt(2))?3:2,t=m);let i=-1,n=!0;for(let a=h-1;a>=t;--a)if(c(u.charCodeAt(a))){if(!n){i=a;break}}else n=!1;if(i===-1){if(m===-1)return".";i=m}return u.slice(0,i)},basename(u,h){h!==void 0&&g(h,"ext"),g(u,"path");let m=0,t=-1,r=!0,i;if(u.length>=2&&_(u.charCodeAt(0))&&u.charCodeAt(1)===s&&(m=2),h!==void 0&&h.length>0&&h.length<=u.length){if(h===u)return"";let n=h.length-1,a=-1;for(i=u.length-1;i>=m;--i){const p=u.charCodeAt(i);if(c(p)){if(!r){m=i+1;break}}else a===-1&&(r=!1,a=i+1),n>=0&&(p===h.charCodeAt(n)?--n==-1&&(t=i):(n=-1,t=a))}return m===t?t=a:t===-1&&(t=u.length),u.slice(m,t)}for(i=u.length-1;i>=m;--i)if(c(u.charCodeAt(i))){if(!r){m=i+1;break}}else t===-1&&(r=!1,t=i+1);return t===-1?"":u.slice(m,t)},extname(u){g(u,"path");let h=0,m=-1,t=0,r=-1,i=!0,n=0;u.length>=2&&u.charCodeAt(1)===s&&_(u.charCodeAt(0))&&(h=t=2);for(let a=u.length-1;a>=h;--a){const p=u.charCodeAt(a);if(c(p)){if(!i){t=a+1;break}continue}r===-1&&(i=!1,r=a+1),p===C?m===-1?m=a:n!==1&&(n=1):m!==-1&&(n=-1)}return m===-1||r===-1||n===0||n===1&&m===r-1&&m===t+1?"":u.slice(m,r)},format:E.bind(null,"\\"),parse(u){g(u,"path");const h={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return h;const m=u.length;let t=0,r=u.charCodeAt(0);if(m===1)return c(r)?(h.root=h.dir=u,h):(h.base=h.name=u,h);if(c(r)){if(t=1,c(u.charCodeAt(1))){let S=2,o=S;for(;S<m&&!c(u.charCodeAt(S));)S++;if(S<m&&S!==o){for(o=S;S<m&&c(u.charCodeAt(S));)S++;if(S<m&&S!==o){for(o=S;S<m&&!c(u.charCodeAt(S));)S++;S===m?t=S:S!==o&&(t=S+1)}}}}else if(_(r)&&u.charCodeAt(1)===s){if(m<=2)return h.root=h.dir=u,h;if(t=2,c(u.charCodeAt(2))){if(m===3)return h.root=h.dir=u,h;t=3}}t>0&&(h.root=u.slice(0,t));let i=-1,n=t,a=-1,p=!0,d=u.length-1,b=0;for(;d>=t;--d){if(r=u.charCodeAt(d),c(r)){if(!p){n=d+1;break}continue}a===-1&&(p=!1,a=d+1),r===C?i===-1?i=d:b!==1&&(b=1):i!==-1&&(b=-1)}return a!==-1&&(i===-1||b===0||b===1&&i===a-1&&i===n+1?h.base=h.name=u.slice(n,a):(h.name=u.slice(n,i),h.base=u.slice(n,a),h.ext=u.slice(i,a))),n>0&&n!==t?h.dir=u.slice(0,n-1):h.dir=h.root,h},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...u){let h="",m=!1;for(let t=u.length-1;t>=-1&&!m;t--){const r=t>=0?u[t]:v.cwd();g(r,"path"),r.length!==0&&(h=`${r}/${h}`,m=r.charCodeAt(0)===D)}return h=w(h,!m,"/",f),m?`/${h}`:h.length>0?h:"."},normalize(u){if(g(u,"path"),u.length===0)return".";const h=u.charCodeAt(0)===D,m=u.charCodeAt(u.length-1)===D;return u=w(u,!h,"/",f),u.length===0?h?"/":m?"./":".":(m&&(u+="/"),h?`/${u}`:u)},isAbsolute(u){return g(u,"path"),u.length>0&&u.charCodeAt(0)===D},join(...u){if(u.length===0)return".";let h;for(let m=0;m<u.length;++m){const t=u[m];g(t,"path"),t.length>0&&(h===void 0?h=t:h+=`/${t}`)}return h===void 0?".":e.posix.normalize(h)},relative(u,h){if(g(u,"from"),g(h,"to"),u===h||(u=e.posix.resolve(u),h=e.posix.resolve(h),u===h))return"";const m=1,t=u.length,r=t-m,i=1,n=h.length-i,a=r<n?r:n;let p=-1,d=0;for(;d<a;d++){const S=u.charCodeAt(m+d);if(S!==h.charCodeAt(i+d))break;S===D&&(p=d)}if(d===a)if(n>a){if(h.charCodeAt(i+d)===D)return h.slice(i+d+1);if(d===0)return h.slice(i+d)}else r>a&&(u.charCodeAt(m+d)===D?p=d:d===0&&(p=0));let b="";for(d=m+p+1;d<=t;++d)(d===t||u.charCodeAt(d)===D)&&(b+=b.length===0?"..":"/..");return`${b}${h.slice(i+p)}`},toNamespacedPath(u){return u},dirname(u){if(g(u,"path"),u.length===0)return".";const h=u.charCodeAt(0)===D;let m=-1,t=!0;for(let r=u.length-1;r>=1;--r)if(u.charCodeAt(r)===D){if(!t){m=r;break}}else t=!1;return m===-1?h?"/":".":h&&m===1?"//":u.slice(0,m)},basename(u,h){h!==void 0&&g(h,"ext"),g(u,"path");let m=0,t=-1,r=!0,i;if(h!==void 0&&h.length>0&&h.length<=u.length){if(h===u)return"";let n=h.length-1,a=-1;for(i=u.length-1;i>=0;--i){const p=u.charCodeAt(i);if(p===D){if(!r){m=i+1;break}}else a===-1&&(r=!1,a=i+1),n>=0&&(p===h.charCodeAt(n)?--n==-1&&(t=i):(n=-1,t=a))}return m===t?t=a:t===-1&&(t=u.length),u.slice(m,t)}for(i=u.length-1;i>=0;--i)if(u.charCodeAt(i)===D){if(!r){m=i+1;break}}else t===-1&&(r=!1,t=i+1);return t===-1?"":u.slice(m,t)},extname(u){g(u,"path");let h=-1,m=0,t=-1,r=!0,i=0;for(let n=u.length-1;n>=0;--n){const a=u.charCodeAt(n);if(a===D){if(!r){m=n+1;break}continue}t===-1&&(r=!1,t=n+1),a===C?h===-1?h=n:i!==1&&(i=1):h!==-1&&(i=-1)}return h===-1||t===-1||i===0||i===1&&h===t-1&&h===m+1?"":u.slice(h,t)},format:E.bind(null,"/"),parse(u){g(u,"path");const h={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return h;const m=u.charCodeAt(0)===D;let t;m?(h.root="/",t=1):t=0;let r=-1,i=0,n=-1,a=!0,p=u.length-1,d=0;for(;p>=t;--p){const b=u.charCodeAt(p);if(b===D){if(!a){i=p+1;break}continue}n===-1&&(a=!1,n=p+1),b===C?r===-1?r=p:d!==1&&(d=1):r!==-1&&(d=-1)}if(n!==-1){const b=i===0&&m?1:i;r===-1||d===0||d===1&&r===n-1&&r===i+1?h.base=h.name=u.slice(b,n):(h.name=u.slice(b,r),h.base=u.slice(b,n),h.ext=u.slice(r,n))}return i>0?h.dir=u.slice(0,i-1):m&&(h.dir="/"),h},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=v.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=v.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=v.platform==="win32"?e.win32.join:e.posix.join,e.resolve=v.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=v.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=v.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=v.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=v.platform==="win32"?e.win32.extname:e.posix.extname,e.format=v.platform==="win32"?e.win32.format:e.posix.format,e.parse=v.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=v.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=v.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=v.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(ge[134],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var v;(function(y){y[y.stdout=0]="stdout",y[y.stderr=1]="stderr"})(v=e.Source||(e.Source={}));var R;(function(y){y[y.Success=0]="Success",y[y.Unknown=1]="Unknown",y[y.AccessDenied=2]="AccessDenied",y[y.ProcessNotFound=3]="ProcessNotFound"})(R=e.TerminateResponseCode||(e.TerminateResponseCode={}));function k(y,...A){const C=A.reduce((s,I)=>(s[I]=!0,s),{}),D=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(y).filter(s=>!C[s]).forEach(s=>{for(let I=0;I<D.length;I++)if(s.search(D[I])!==-1){delete y[s];break}})}e.sanitizeProcessEnvironment=k}),define(ge[43],pe([0,1,11]),function(X,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const R=v.globals.performance&&typeof v.globals.performance.now=="function";class k{constructor(A){this._highResolution=R&&A,this._startTime=this._now(),this._stopTime=-1}static create(A=!0){return new k(A)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?v.globals.performance.now():Date.now()}}e.StopWatch=k}),define(ge[3],pe([0,1,16,69,6,72,43]),function(X,e,v,R,k,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var C;(function(w){w.None=()=>k.Disposable.None;function E(q){return(x,V=null,T)=>{let N=!1,F;return F=q(M=>{if(!N)return F?F.dispose():N=!0,x.call(V,M)},null,T),N&&F.dispose(),F}}w.once=E;function u(q,x){return n((V,T=null,N)=>q(F=>V.call(T,x(F)),null,N))}w.map=u;function h(q,x){return n((V,T=null,N)=>q(F=>{x(F),V.call(T,F)},null,N))}w.forEach=h;function m(q,x){return n((V,T=null,N)=>q(F=>x(F)&&V.call(T,F),null,N))}w.filter=m;function t(q){return q}w.signal=t;function r(...q){return(x,V=null,T)=>k.combinedDisposable(...q.map(N=>N(F=>x.call(V,F),null,T)))}w.any=r;function i(q,x,V){let T=V;return u(q,N=>(T=x(T,N),T))}w.reduce=i;function n(q){let x;const V=new l({onFirstListenerAdd(){x=q(V.fire,V)},onLastListenerRemove(){x.dispose()}});return V.event}w.snapshot=n;function a(q,x,V=100,T=!1,N){let F,M,U,B=0;const K=new l({leakWarningThreshold:N,onFirstListenerAdd(){F=q(ie=>{B++,M=x(M,ie),T&&!U&&(K.fire(M),M=void 0),clearTimeout(U),U=setTimeout(()=>{const we=M;M=void 0,U=void 0,(!T||B>1)&&K.fire(we),B=0},V)})},onLastListenerRemove(){F.dispose()}});return K.event}w.debounce=a;function p(q){const x=new Date().getTime();return u(E(q),V=>new Date().getTime()-x)}w.stopwatch=p;function d(q,x=(V,T)=>V===T){let V=!0,T;return m(q,N=>{const F=V||!x(N,T);return V=!1,T=N,F})}w.latch=d;function b(q,x){return[w.filter(q,x),w.filter(q,V=>!x(V))]}w.split=b;function S(q,x=!1,V=[]){let T=V.slice(),N=q(U=>{T?T.push(U):M.fire(U)});const F=()=>{T&&T.forEach(U=>M.fire(U)),T=null},M=new l({onFirstListenerAdd(){N||(N=q(U=>M.fire(U)))},onFirstListenerDidAdd(){T&&(x?setTimeout(F):F())},onLastListenerRemove(){N&&N.dispose(),N=null}});return M.event}w.buffer=S;class o{constructor(x){this.event=x}map(x){return new o(u(this.event,x))}forEach(x){return new o(h(this.event,x))}filter(x){return new o(m(this.event,x))}reduce(x,V){return new o(i(this.event,x,V))}latch(){return new o(d(this.event))}debounce(x,V=100,T=!1,N){return new o(a(this.event,x,V,T,N))}on(x,V,T){return this.event(x,V,T)}once(x,V,T){return E(this.event)(x,V,T)}}function L(q){return new o(q)}w.chain=L;function O(q,x,V=T=>T){const T=(...U)=>M.fire(V(...U)),N=()=>q.on(x,T),F=()=>q.removeListener(x,T),M=new l({onFirstListenerAdd:N,onLastListenerRemove:F});return M.event}w.fromNodeEventEmitter=O;function W(q,x,V=T=>T){const T=(...U)=>M.fire(V(...U)),N=()=>q.addEventListener(x,T),F=()=>q.removeEventListener(x,T),M=new l({onFirstListenerAdd:N,onLastListenerRemove:F});return M.event}w.fromDOMEventEmitter=W;function J(q){const x=new l;let V=!1;return q.then(void 0,()=>null).then(()=>{V?x.fire(void 0):setTimeout(()=>x.fire(void 0),0)}),V=!0,x.event}w.fromPromise=J;function oe(q){return new Promise(x=>E(q)(x))}w.toPromise=oe})(C=e.Event||(e.Event={}));class D{constructor(E){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${E}_${D._idPool++}`}start(E){this._stopWatch=new A.StopWatch(!0),this._listenerCount=E}stop(){if(this._stopWatch){const E=this._stopWatch.elapsed();this._elapsedOverall+=E,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${E.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}D._idPool=0;let P=-1;function s(w){const E=P;return P=w,{dispose(){P=E}}}e.setGlobalLeakWarningThreshold=s;class I{constructor(E,u=Math.random().toString(18).slice(2,5)){this.customThreshold=E,this.name=u,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(E){let u=P;if(typeof this.customThreshold=="number"&&(u=this.customThreshold),u<=0||E<u)return;this._stacks||(this._stacks=new Map);const h=new Error().stack.split(`
`).slice(3).join(`
`),m=this._stacks.get(h)||0;if(this._stacks.set(h,m+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=u*.5;let t,r=0;for(const[i,n]of this._stacks)(!t||r<n)&&(t=i,r=n);console.warn(`[${this.name}] potential listener LEAK detected, having ${E} listeners already. MOST frequent listener (${r}):`),console.warn(t)}return()=>{const t=this._stacks.get(h)||0;this._stacks.set(h,t-1)}}}class l{constructor(E){var u;this._disposed=!1,this._options=E,this._leakageMon=P>0?new I(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((u=this._options)===null||u===void 0?void 0:u._profName)?new D(this._options._profName):void 0}get event(){return this._event||(this._event=(E,u,h)=>{var m;this._listeners||(this._listeners=new y.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const r=this._listeners.push(u?[E,u]:E);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,E,u);const i=(m=this._leakageMon)===null||m===void 0?void 0:m.check(this._listeners.size);let n;return n={dispose:()=>{i&&i(),n.dispose=l._noop,this._disposed||(r(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},h instanceof k.DisposableStore?h.add(n):Array.isArray(h)&&h.push(n),n}),this._event}fire(E){var u,h;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new y.LinkedList);for(let m of this._listeners)this._deliveryQueue.push([m,E]);for((u=this._perfMon)===null||u===void 0||u.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[m,t]=this._deliveryQueue.shift();try{typeof m=="function"?m.call(void 0,t):m[0].call(m[1],t)}catch(r){v.onUnexpectedError(r)}}(h=this._perfMon)===null||h===void 0||h.stop()}}dispose(){var E,u,h,m,t;this._disposed||(this._disposed=!0,(E=this._listeners)===null||E===void 0||E.clear(),(u=this._deliveryQueue)===null||u===void 0||u.clear(),(m=(h=this._options)===null||h===void 0?void 0:h.onLastListenerRemove)===null||m===void 0||m.call(h),(t=this._leakageMon)===null||t===void 0||t.dispose())}}e.Emitter=l,l._noop=function(){};class g extends l{constructor(E){super(E);this._isPaused=0,this._eventQueue=new y.LinkedList,this._mergeFn=E==null?void 0:E.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const E=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(E))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(E){this._listeners&&(this._isPaused!==0?this._eventQueue.push(E):super.fire(E))}}e.PauseableEmitter=g;class c{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new l({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(E){const u={event:E,listener:null};this.events.push(u),this.hasListeners&&this.hook(u);const h=()=>{this.hasListeners&&this.unhook(u);const m=this.events.indexOf(u);this.events.splice(m,1)};return k.toDisposable(R.once(h))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(E=>this.hook(E))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(E=>this.unhook(E))}hook(E){E.listener=E.event(u=>this.emitter.fire(u))}unhook(E){E.listener&&E.listener.dispose(),E.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=c;class f{constructor(){this.buffers=[]}wrapEvent(E){return(u,h,m)=>E(t=>{const r=this.buffers[this.buffers.length-1];r?r.push(()=>u.call(h,t)):u.call(h,t)},void 0,m)}bufferEvents(E){const u=[];this.buffers.push(u);const h=E();return this.buffers.pop(),u.forEach(m=>m()),h}}e.EventBufferer=f;class _{constructor(){this.listening=!1,this.inputEvent=C.None,this.inputEventListener=k.Disposable.None,this.emitter=new l({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(E){this.inputEvent=E,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=E(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=_}),define(ge[21],pe([0,1,3]),function(X,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const R=Object.freeze(function(C,D){const P=setTimeout(C.bind(D),0);return{dispose(){clearTimeout(P)}}});var k;(function(C){function D(P){return P===C.None||P===C.Cancelled||P instanceof y?!0:!P||typeof P!="object"?!1:typeof P.isCancellationRequested=="boolean"&&typeof P.onCancellationRequested=="function"}C.isCancellationToken=D,C.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:v.Event.None}),C.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:R})})(k=e.CancellationToken||(e.CancellationToken={}));class y{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?R:(this._emitter||(this._emitter=new v.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class A{constructor(D){this._token=void 0,this._parentListener=void 0,this._parentListener=D&&D.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new y),this._token}cancel(){this._token?this._token instanceof y&&this._token.cancel():this._token=k.Cancelled}dispose(D=!1){D&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof y&&this._token.dispose():this._token=k.None}}e.CancellationTokenSource=A}),define(ge[91],pe([0,1,3]),function(X,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class R{constructor(){this._icons=new Map,this._onDidRegister=new v.Emitter}add(I){const l=this._icons.get(I.id);l?I.description?l.description=I.description:console.error(`Duplicate registration of codicon ${I.id}`):(this._icons.set(I.id,I),this._onDidRegister.fire(I))}get(I){return this._icons.get(I)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const k=new R;e.iconRegistry=k;function y(s,I){return new C(s,I)}e.registerCodicon=y;function A(s){return s?s.replace(/\$\((.*?)\)/g,(I,l)=>` ${l} `).trim():""}e.getCodiconAriaLabel=A;class C{constructor(I,l,g){this.id=I,this.definition=l,this.description=g,k.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=C;function D(s,I){const l=["codicon","codicon-"+s];return I&&l.push("codicon-modifier-"+I),l}e.getClassNamesArray=D;var P;(function(s){s.iconNameSegment="[A-Za-z0-9]+",s.iconNameExpression="[A-Za-z0-9\\-]+",s.iconModifierExpression="~[A-Za-z]+";const I=new RegExp(`^(${s.iconNameExpression})(${s.iconModifierExpression})?$`);function l(f){if(f instanceof C)return["codicon","codicon-"+f.id];const _=I.exec(f.id);if(!_)return l(C.error);let[,w,E]=_;const u=["codicon","codicon-"+w];return E&&u.push("codicon-modifier-"+E.substr(1)),u}s.asClassNameArray=l;function g(f){return l(f).join(" ")}s.asClassName=g;function c(f){return"."+l(f).join(".")}s.asCSSSelector=c})(P=e.CSSIcon||(e.CSSIcon={})),function(s){s.add=new s("add",{fontCharacter:"\\ea60"}),s.plus=new s("plus",{fontCharacter:"\\ea60"}),s.gistNew=new s("gist-new",{fontCharacter:"\\ea60"}),s.repoCreate=new s("repo-create",{fontCharacter:"\\ea60"}),s.lightbulb=new s("lightbulb",{fontCharacter:"\\ea61"}),s.lightBulb=new s("light-bulb",{fontCharacter:"\\ea61"}),s.repo=new s("repo",{fontCharacter:"\\ea62"}),s.repoDelete=new s("repo-delete",{fontCharacter:"\\ea62"}),s.gistFork=new s("gist-fork",{fontCharacter:"\\ea63"}),s.repoForked=new s("repo-forked",{fontCharacter:"\\ea63"}),s.gitPullRequest=new s("git-pull-request",{fontCharacter:"\\ea64"}),s.gitPullRequestAbandoned=new s("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),s.recordKeys=new s("record-keys",{fontCharacter:"\\ea65"}),s.keyboard=new s("keyboard",{fontCharacter:"\\ea65"}),s.tag=new s("tag",{fontCharacter:"\\ea66"}),s.tagAdd=new s("tag-add",{fontCharacter:"\\ea66"}),s.tagRemove=new s("tag-remove",{fontCharacter:"\\ea66"}),s.person=new s("person",{fontCharacter:"\\ea67"}),s.personFollow=new s("person-follow",{fontCharacter:"\\ea67"}),s.personOutline=new s("person-outline",{fontCharacter:"\\ea67"}),s.personFilled=new s("person-filled",{fontCharacter:"\\ea67"}),s.gitBranch=new s("git-branch",{fontCharacter:"\\ea68"}),s.gitBranchCreate=new s("git-branch-create",{fontCharacter:"\\ea68"}),s.gitBranchDelete=new s("git-branch-delete",{fontCharacter:"\\ea68"}),s.sourceControl=new s("source-control",{fontCharacter:"\\ea68"}),s.mirror=new s("mirror",{fontCharacter:"\\ea69"}),s.mirrorPublic=new s("mirror-public",{fontCharacter:"\\ea69"}),s.star=new s("star",{fontCharacter:"\\ea6a"}),s.starAdd=new s("star-add",{fontCharacter:"\\ea6a"}),s.starDelete=new s("star-delete",{fontCharacter:"\\ea6a"}),s.starEmpty=new s("star-empty",{fontCharacter:"\\ea6a"}),s.comment=new s("comment",{fontCharacter:"\\ea6b"}),s.commentAdd=new s("comment-add",{fontCharacter:"\\ea6b"}),s.alert=new s("alert",{fontCharacter:"\\ea6c"}),s.warning=new s("warning",{fontCharacter:"\\ea6c"}),s.search=new s("search",{fontCharacter:"\\ea6d"}),s.searchSave=new s("search-save",{fontCharacter:"\\ea6d"}),s.logOut=new s("log-out",{fontCharacter:"\\ea6e"}),s.signOut=new s("sign-out",{fontCharacter:"\\ea6e"}),s.logIn=new s("log-in",{fontCharacter:"\\ea6f"}),s.signIn=new s("sign-in",{fontCharacter:"\\ea6f"}),s.eye=new s("eye",{fontCharacter:"\\ea70"}),s.eyeUnwatch=new s("eye-unwatch",{fontCharacter:"\\ea70"}),s.eyeWatch=new s("eye-watch",{fontCharacter:"\\ea70"}),s.circleFilled=new s("circle-filled",{fontCharacter:"\\ea71"}),s.primitiveDot=new s("primitive-dot",{fontCharacter:"\\ea71"}),s.closeDirty=new s("close-dirty",{fontCharacter:"\\ea71"}),s.debugBreakpoint=new s("debug-breakpoint",{fontCharacter:"\\ea71"}),s.debugBreakpointDisabled=new s("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),s.debugHint=new s("debug-hint",{fontCharacter:"\\ea71"}),s.primitiveSquare=new s("primitive-square",{fontCharacter:"\\ea72"}),s.edit=new s("edit",{fontCharacter:"\\ea73"}),s.pencil=new s("pencil",{fontCharacter:"\\ea73"}),s.info=new s("info",{fontCharacter:"\\ea74"}),s.issueOpened=new s("issue-opened",{fontCharacter:"\\ea74"}),s.gistPrivate=new s("gist-private",{fontCharacter:"\\ea75"}),s.gitForkPrivate=new s("git-fork-private",{fontCharacter:"\\ea75"}),s.lock=new s("lock",{fontCharacter:"\\ea75"}),s.mirrorPrivate=new s("mirror-private",{fontCharacter:"\\ea75"}),s.close=new s("close",{fontCharacter:"\\ea76"}),s.removeClose=new s("remove-close",{fontCharacter:"\\ea76"}),s.x=new s("x",{fontCharacter:"\\ea76"}),s.repoSync=new s("repo-sync",{fontCharacter:"\\ea77"}),s.sync=new s("sync",{fontCharacter:"\\ea77"}),s.clone=new s("clone",{fontCharacter:"\\ea78"}),s.desktopDownload=new s("desktop-download",{fontCharacter:"\\ea78"}),s.beaker=new s("beaker",{fontCharacter:"\\ea79"}),s.microscope=new s("microscope",{fontCharacter:"\\ea79"}),s.vm=new s("vm",{fontCharacter:"\\ea7a"}),s.deviceDesktop=new s("device-desktop",{fontCharacter:"\\ea7a"}),s.file=new s("file",{fontCharacter:"\\ea7b"}),s.fileText=new s("file-text",{fontCharacter:"\\ea7b"}),s.more=new s("more",{fontCharacter:"\\ea7c"}),s.ellipsis=new s("ellipsis",{fontCharacter:"\\ea7c"}),s.kebabHorizontal=new s("kebab-horizontal",{fontCharacter:"\\ea7c"}),s.mailReply=new s("mail-reply",{fontCharacter:"\\ea7d"}),s.reply=new s("reply",{fontCharacter:"\\ea7d"}),s.organization=new s("organization",{fontCharacter:"\\ea7e"}),s.organizationFilled=new s("organization-filled",{fontCharacter:"\\ea7e"}),s.organizationOutline=new s("organization-outline",{fontCharacter:"\\ea7e"}),s.newFile=new s("new-file",{fontCharacter:"\\ea7f"}),s.fileAdd=new s("file-add",{fontCharacter:"\\ea7f"}),s.newFolder=new s("new-folder",{fontCharacter:"\\ea80"}),s.fileDirectoryCreate=new s("file-directory-create",{fontCharacter:"\\ea80"}),s.trash=new s("trash",{fontCharacter:"\\ea81"}),s.trashcan=new s("trashcan",{fontCharacter:"\\ea81"}),s.history=new s("history",{fontCharacter:"\\ea82"}),s.clock=new s("clock",{fontCharacter:"\\ea82"}),s.folder=new s("folder",{fontCharacter:"\\ea83"}),s.fileDirectory=new s("file-directory",{fontCharacter:"\\ea83"}),s.symbolFolder=new s("symbol-folder",{fontCharacter:"\\ea83"}),s.logoGithub=new s("logo-github",{fontCharacter:"\\ea84"}),s.markGithub=new s("mark-github",{fontCharacter:"\\ea84"}),s.github=new s("github",{fontCharacter:"\\ea84"}),s.terminal=new s("terminal",{fontCharacter:"\\ea85"}),s.console=new s("console",{fontCharacter:"\\ea85"}),s.repl=new s("repl",{fontCharacter:"\\ea85"}),s.zap=new s("zap",{fontCharacter:"\\ea86"}),s.symbolEvent=new s("symbol-event",{fontCharacter:"\\ea86"}),s.error=new s("error",{fontCharacter:"\\ea87"}),s.stop=new s("stop",{fontCharacter:"\\ea87"}),s.variable=new s("variable",{fontCharacter:"\\ea88"}),s.symbolVariable=new s("symbol-variable",{fontCharacter:"\\ea88"}),s.array=new s("array",{fontCharacter:"\\ea8a"}),s.symbolArray=new s("symbol-array",{fontCharacter:"\\ea8a"}),s.symbolModule=new s("symbol-module",{fontCharacter:"\\ea8b"}),s.symbolPackage=new s("symbol-package",{fontCharacter:"\\ea8b"}),s.symbolNamespace=new s("symbol-namespace",{fontCharacter:"\\ea8b"}),s.symbolObject=new s("symbol-object",{fontCharacter:"\\ea8b"}),s.symbolMethod=new s("symbol-method",{fontCharacter:"\\ea8c"}),s.symbolFunction=new s("symbol-function",{fontCharacter:"\\ea8c"}),s.symbolConstructor=new s("symbol-constructor",{fontCharacter:"\\ea8c"}),s.symbolBoolean=new s("symbol-boolean",{fontCharacter:"\\ea8f"}),s.symbolNull=new s("symbol-null",{fontCharacter:"\\ea8f"}),s.symbolNumeric=new s("symbol-numeric",{fontCharacter:"\\ea90"}),s.symbolNumber=new s("symbol-number",{fontCharacter:"\\ea90"}),s.symbolStructure=new s("symbol-structure",{fontCharacter:"\\ea91"}),s.symbolStruct=new s("symbol-struct",{fontCharacter:"\\ea91"}),s.symbolParameter=new s("symbol-parameter",{fontCharacter:"\\ea92"}),s.symbolTypeParameter=new s("symbol-type-parameter",{fontCharacter:"\\ea92"}),s.symbolKey=new s("symbol-key",{fontCharacter:"\\ea93"}),s.symbolText=new s("symbol-text",{fontCharacter:"\\ea93"}),s.symbolReference=new s("symbol-reference",{fontCharacter:"\\ea94"}),s.goToFile=new s("go-to-file",{fontCharacter:"\\ea94"}),s.symbolEnum=new s("symbol-enum",{fontCharacter:"\\ea95"}),s.symbolValue=new s("symbol-value",{fontCharacter:"\\ea95"}),s.symbolRuler=new s("symbol-ruler",{fontCharacter:"\\ea96"}),s.symbolUnit=new s("symbol-unit",{fontCharacter:"\\ea96"}),s.activateBreakpoints=new s("activate-breakpoints",{fontCharacter:"\\ea97"}),s.archive=new s("archive",{fontCharacter:"\\ea98"}),s.arrowBoth=new s("arrow-both",{fontCharacter:"\\ea99"}),s.arrowDown=new s("arrow-down",{fontCharacter:"\\ea9a"}),s.arrowLeft=new s("arrow-left",{fontCharacter:"\\ea9b"}),s.arrowRight=new s("arrow-right",{fontCharacter:"\\ea9c"}),s.arrowSmallDown=new s("arrow-small-down",{fontCharacter:"\\ea9d"}),s.arrowSmallLeft=new s("arrow-small-left",{fontCharacter:"\\ea9e"}),s.arrowSmallRight=new s("arrow-small-right",{fontCharacter:"\\ea9f"}),s.arrowSmallUp=new s("arrow-small-up",{fontCharacter:"\\eaa0"}),s.arrowUp=new s("arrow-up",{fontCharacter:"\\eaa1"}),s.bell=new s("bell",{fontCharacter:"\\eaa2"}),s.bold=new s("bold",{fontCharacter:"\\eaa3"}),s.book=new s("book",{fontCharacter:"\\eaa4"}),s.bookmark=new s("bookmark",{fontCharacter:"\\eaa5"}),s.debugBreakpointConditionalUnverified=new s("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),s.debugBreakpointConditional=new s("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),s.debugBreakpointConditionalDisabled=new s("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),s.debugBreakpointDataUnverified=new s("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),s.debugBreakpointData=new s("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),s.debugBreakpointDataDisabled=new s("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),s.debugBreakpointLogUnverified=new s("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),s.debugBreakpointLog=new s("debug-breakpoint-log",{fontCharacter:"\\eaab"}),s.debugBreakpointLogDisabled=new s("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),s.briefcase=new s("briefcase",{fontCharacter:"\\eaac"}),s.broadcast=new s("broadcast",{fontCharacter:"\\eaad"}),s.browser=new s("browser",{fontCharacter:"\\eaae"}),s.bug=new s("bug",{fontCharacter:"\\eaaf"}),s.calendar=new s("calendar",{fontCharacter:"\\eab0"}),s.caseSensitive=new s("case-sensitive",{fontCharacter:"\\eab1"}),s.check=new s("check",{fontCharacter:"\\eab2"}),s.checklist=new s("checklist",{fontCharacter:"\\eab3"}),s.chevronDown=new s("chevron-down",{fontCharacter:"\\eab4"}),s.chevronLeft=new s("chevron-left",{fontCharacter:"\\eab5"}),s.chevronRight=new s("chevron-right",{fontCharacter:"\\eab6"}),s.chevronUp=new s("chevron-up",{fontCharacter:"\\eab7"}),s.chromeClose=new s("chrome-close",{fontCharacter:"\\eab8"}),s.chromeMaximize=new s("chrome-maximize",{fontCharacter:"\\eab9"}),s.chromeMinimize=new s("chrome-minimize",{fontCharacter:"\\eaba"}),s.chromeRestore=new s("chrome-restore",{fontCharacter:"\\eabb"}),s.circleOutline=new s("circle-outline",{fontCharacter:"\\eabc"}),s.debugBreakpointUnverified=new s("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),s.circleSlash=new s("circle-slash",{fontCharacter:"\\eabd"}),s.circuitBoard=new s("circuit-board",{fontCharacter:"\\eabe"}),s.clearAll=new s("clear-all",{fontCharacter:"\\eabf"}),s.clippy=new s("clippy",{fontCharacter:"\\eac0"}),s.closeAll=new s("close-all",{fontCharacter:"\\eac1"}),s.cloudDownload=new s("cloud-download",{fontCharacter:"\\eac2"}),s.cloudUpload=new s("cloud-upload",{fontCharacter:"\\eac3"}),s.code=new s("code",{fontCharacter:"\\eac4"}),s.collapseAll=new s("collapse-all",{fontCharacter:"\\eac5"}),s.colorMode=new s("color-mode",{fontCharacter:"\\eac6"}),s.commentDiscussion=new s("comment-discussion",{fontCharacter:"\\eac7"}),s.compareChanges=new s("compare-changes",{fontCharacter:"\\eafd"}),s.creditCard=new s("credit-card",{fontCharacter:"\\eac9"}),s.dash=new s("dash",{fontCharacter:"\\eacc"}),s.dashboard=new s("dashboard",{fontCharacter:"\\eacd"}),s.database=new s("database",{fontCharacter:"\\eace"}),s.debugContinue=new s("debug-continue",{fontCharacter:"\\eacf"}),s.debugDisconnect=new s("debug-disconnect",{fontCharacter:"\\ead0"}),s.debugPause=new s("debug-pause",{fontCharacter:"\\ead1"}),s.debugRestart=new s("debug-restart",{fontCharacter:"\\ead2"}),s.debugStart=new s("debug-start",{fontCharacter:"\\ead3"}),s.debugStepInto=new s("debug-step-into",{fontCharacter:"\\ead4"}),s.debugStepOut=new s("debug-step-out",{fontCharacter:"\\ead5"}),s.debugStepOver=new s("debug-step-over",{fontCharacter:"\\ead6"}),s.debugStop=new s("debug-stop",{fontCharacter:"\\ead7"}),s.debug=new s("debug",{fontCharacter:"\\ead8"}),s.deviceCameraVideo=new s("device-camera-video",{fontCharacter:"\\ead9"}),s.deviceCamera=new s("device-camera",{fontCharacter:"\\eada"}),s.deviceMobile=new s("device-mobile",{fontCharacter:"\\eadb"}),s.diffAdded=new s("diff-added",{fontCharacter:"\\eadc"}),s.diffIgnored=new s("diff-ignored",{fontCharacter:"\\eadd"}),s.diffModified=new s("diff-modified",{fontCharacter:"\\eade"}),s.diffRemoved=new s("diff-removed",{fontCharacter:"\\eadf"}),s.diffRenamed=new s("diff-renamed",{fontCharacter:"\\eae0"}),s.diff=new s("diff",{fontCharacter:"\\eae1"}),s.discard=new s("discard",{fontCharacter:"\\eae2"}),s.editorLayout=new s("editor-layout",{fontCharacter:"\\eae3"}),s.emptyWindow=new s("empty-window",{fontCharacter:"\\eae4"}),s.exclude=new s("exclude",{fontCharacter:"\\eae5"}),s.extensions=new s("extensions",{fontCharacter:"\\eae6"}),s.eyeClosed=new s("eye-closed",{fontCharacter:"\\eae7"}),s.fileBinary=new s("file-binary",{fontCharacter:"\\eae8"}),s.fileCode=new s("file-code",{fontCharacter:"\\eae9"}),s.fileMedia=new s("file-media",{fontCharacter:"\\eaea"}),s.filePdf=new s("file-pdf",{fontCharacter:"\\eaeb"}),s.fileSubmodule=new s("file-submodule",{fontCharacter:"\\eaec"}),s.fileSymlinkDirectory=new s("file-symlink-directory",{fontCharacter:"\\eaed"}),s.fileSymlinkFile=new s("file-symlink-file",{fontCharacter:"\\eaee"}),s.fileZip=new s("file-zip",{fontCharacter:"\\eaef"}),s.files=new s("files",{fontCharacter:"\\eaf0"}),s.filter=new s("filter",{fontCharacter:"\\eaf1"}),s.flame=new s("flame",{fontCharacter:"\\eaf2"}),s.foldDown=new s("fold-down",{fontCharacter:"\\eaf3"}),s.foldUp=new s("fold-up",{fontCharacter:"\\eaf4"}),s.fold=new s("fold",{fontCharacter:"\\eaf5"}),s.folderActive=new s("folder-active",{fontCharacter:"\\eaf6"}),s.folderOpened=new s("folder-opened",{fontCharacter:"\\eaf7"}),s.gear=new s("gear",{fontCharacter:"\\eaf8"}),s.gift=new s("gift",{fontCharacter:"\\eaf9"}),s.gistSecret=new s("gist-secret",{fontCharacter:"\\eafa"}),s.gist=new s("gist",{fontCharacter:"\\eafb"}),s.gitCommit=new s("git-commit",{fontCharacter:"\\eafc"}),s.gitCompare=new s("git-compare",{fontCharacter:"\\eafd"}),s.gitMerge=new s("git-merge",{fontCharacter:"\\eafe"}),s.githubAction=new s("github-action",{fontCharacter:"\\eaff"}),s.githubAlt=new s("github-alt",{fontCharacter:"\\eb00"}),s.globe=new s("globe",{fontCharacter:"\\eb01"}),s.grabber=new s("grabber",{fontCharacter:"\\eb02"}),s.graph=new s("graph",{fontCharacter:"\\eb03"}),s.gripper=new s("gripper",{fontCharacter:"\\eb04"}),s.heart=new s("heart",{fontCharacter:"\\eb05"}),s.home=new s("home",{fontCharacter:"\\eb06"}),s.horizontalRule=new s("horizontal-rule",{fontCharacter:"\\eb07"}),s.hubot=new s("hubot",{fontCharacter:"\\eb08"}),s.inbox=new s("inbox",{fontCharacter:"\\eb09"}),s.issueClosed=new s("issue-closed",{fontCharacter:"\\eb0a"}),s.issueReopened=new s("issue-reopened",{fontCharacter:"\\eb0b"}),s.issues=new s("issues",{fontCharacter:"\\eb0c"}),s.italic=new s("italic",{fontCharacter:"\\eb0d"}),s.jersey=new s("jersey",{fontCharacter:"\\eb0e"}),s.json=new s("json",{fontCharacter:"\\eb0f"}),s.kebabVertical=new s("kebab-vertical",{fontCharacter:"\\eb10"}),s.key=new s("key",{fontCharacter:"\\eb11"}),s.law=new s("law",{fontCharacter:"\\eb12"}),s.lightbulbAutofix=new s("lightbulb-autofix",{fontCharacter:"\\eb13"}),s.linkExternal=new s("link-external",{fontCharacter:"\\eb14"}),s.link=new s("link",{fontCharacter:"\\eb15"}),s.listOrdered=new s("list-ordered",{fontCharacter:"\\eb16"}),s.listUnordered=new s("list-unordered",{fontCharacter:"\\eb17"}),s.liveShare=new s("live-share",{fontCharacter:"\\eb18"}),s.loading=new s("loading",{fontCharacter:"\\eb19"}),s.location=new s("location",{fontCharacter:"\\eb1a"}),s.mailRead=new s("mail-read",{fontCharacter:"\\eb1b"}),s.mail=new s("mail",{fontCharacter:"\\eb1c"}),s.markdown=new s("markdown",{fontCharacter:"\\eb1d"}),s.megaphone=new s("megaphone",{fontCharacter:"\\eb1e"}),s.mention=new s("mention",{fontCharacter:"\\eb1f"}),s.milestone=new s("milestone",{fontCharacter:"\\eb20"}),s.mortarBoard=new s("mortar-board",{fontCharacter:"\\eb21"}),s.move=new s("move",{fontCharacter:"\\eb22"}),s.multipleWindows=new s("multiple-windows",{fontCharacter:"\\eb23"}),s.mute=new s("mute",{fontCharacter:"\\eb24"}),s.noNewline=new s("no-newline",{fontCharacter:"\\eb25"}),s.note=new s("note",{fontCharacter:"\\eb26"}),s.octoface=new s("octoface",{fontCharacter:"\\eb27"}),s.openPreview=new s("open-preview",{fontCharacter:"\\eb28"}),s.package_=new s("package",{fontCharacter:"\\eb29"}),s.paintcan=new s("paintcan",{fontCharacter:"\\eb2a"}),s.pin=new s("pin",{fontCharacter:"\\eb2b"}),s.play=new s("play",{fontCharacter:"\\eb2c"}),s.run=new s("run",{fontCharacter:"\\eb2c"}),s.plug=new s("plug",{fontCharacter:"\\eb2d"}),s.preserveCase=new s("preserve-case",{fontCharacter:"\\eb2e"}),s.preview=new s("preview",{fontCharacter:"\\eb2f"}),s.project=new s("project",{fontCharacter:"\\eb30"}),s.pulse=new s("pulse",{fontCharacter:"\\eb31"}),s.question=new s("question",{fontCharacter:"\\eb32"}),s.quote=new s("quote",{fontCharacter:"\\eb33"}),s.radioTower=new s("radio-tower",{fontCharacter:"\\eb34"}),s.reactions=new s("reactions",{fontCharacter:"\\eb35"}),s.references=new s("references",{fontCharacter:"\\eb36"}),s.refresh=new s("refresh",{fontCharacter:"\\eb37"}),s.regex=new s("regex",{fontCharacter:"\\eb38"}),s.remoteExplorer=new s("remote-explorer",{fontCharacter:"\\eb39"}),s.remote=new s("remote",{fontCharacter:"\\eb3a"}),s.remove=new s("remove",{fontCharacter:"\\eb3b"}),s.replaceAll=new s("replace-all",{fontCharacter:"\\eb3c"}),s.replace=new s("replace",{fontCharacter:"\\eb3d"}),s.repoClone=new s("repo-clone",{fontCharacter:"\\eb3e"}),s.repoForcePush=new s("repo-force-push",{fontCharacter:"\\eb3f"}),s.repoPull=new s("repo-pull",{fontCharacter:"\\eb40"}),s.repoPush=new s("repo-push",{fontCharacter:"\\eb41"}),s.report=new s("report",{fontCharacter:"\\eb42"}),s.requestChanges=new s("request-changes",{fontCharacter:"\\eb43"}),s.rocket=new s("rocket",{fontCharacter:"\\eb44"}),s.rootFolderOpened=new s("root-folder-opened",{fontCharacter:"\\eb45"}),s.rootFolder=new s("root-folder",{fontCharacter:"\\eb46"}),s.rss=new s("rss",{fontCharacter:"\\eb47"}),s.ruby=new s("ruby",{fontCharacter:"\\eb48"}),s.saveAll=new s("save-all",{fontCharacter:"\\eb49"}),s.saveAs=new s("save-as",{fontCharacter:"\\eb4a"}),s.save=new s("save",{fontCharacter:"\\eb4b"}),s.screenFull=new s("screen-full",{fontCharacter:"\\eb4c"}),s.screenNormal=new s("screen-normal",{fontCharacter:"\\eb4d"}),s.searchStop=new s("search-stop",{fontCharacter:"\\eb4e"}),s.server=new s("server",{fontCharacter:"\\eb50"}),s.settingsGear=new s("settings-gear",{fontCharacter:"\\eb51"}),s.settings=new s("settings",{fontCharacter:"\\eb52"}),s.shield=new s("shield",{fontCharacter:"\\eb53"}),s.smiley=new s("smiley",{fontCharacter:"\\eb54"}),s.sortPrecedence=new s("sort-precedence",{fontCharacter:"\\eb55"}),s.splitHorizontal=new s("split-horizontal",{fontCharacter:"\\eb56"}),s.splitVertical=new s("split-vertical",{fontCharacter:"\\eb57"}),s.squirrel=new s("squirrel",{fontCharacter:"\\eb58"}),s.starFull=new s("star-full",{fontCharacter:"\\eb59"}),s.starHalf=new s("star-half",{fontCharacter:"\\eb5a"}),s.symbolClass=new s("symbol-class",{fontCharacter:"\\eb5b"}),s.symbolColor=new s("symbol-color",{fontCharacter:"\\eb5c"}),s.symbolConstant=new s("symbol-constant",{fontCharacter:"\\eb5d"}),s.symbolEnumMember=new s("symbol-enum-member",{fontCharacter:"\\eb5e"}),s.symbolField=new s("symbol-field",{fontCharacter:"\\eb5f"}),s.symbolFile=new s("symbol-file",{fontCharacter:"\\eb60"}),s.symbolInterface=new s("symbol-interface",{fontCharacter:"\\eb61"}),s.symbolKeyword=new s("symbol-keyword",{fontCharacter:"\\eb62"}),s.symbolMisc=new s("symbol-misc",{fontCharacter:"\\eb63"}),s.symbolOperator=new s("symbol-operator",{fontCharacter:"\\eb64"}),s.symbolProperty=new s("symbol-property",{fontCharacter:"\\eb65"}),s.wrench=new s("wrench",{fontCharacter:"\\eb65"}),s.wrenchSubaction=new s("wrench-subaction",{fontCharacter:"\\eb65"}),s.symbolSnippet=new s("symbol-snippet",{fontCharacter:"\\eb66"}),s.tasklist=new s("tasklist",{fontCharacter:"\\eb67"}),s.telescope=new s("telescope",{fontCharacter:"\\eb68"}),s.textSize=new s("text-size",{fontCharacter:"\\eb69"}),s.threeBars=new s("three-bars",{fontCharacter:"\\eb6a"}),s.thumbsdown=new s("thumbsdown",{fontCharacter:"\\eb6b"}),s.thumbsup=new s("thumbsup",{fontCharacter:"\\eb6c"}),s.tools=new s("tools",{fontCharacter:"\\eb6d"}),s.triangleDown=new s("triangle-down",{fontCharacter:"\\eb6e"}),s.triangleLeft=new s("triangle-left",{fontCharacter:"\\eb6f"}),s.triangleRight=new s("triangle-right",{fontCharacter:"\\eb70"}),s.triangleUp=new s("triangle-up",{fontCharacter:"\\eb71"}),s.twitter=new s("twitter",{fontCharacter:"\\eb72"}),s.unfold=new s("unfold",{fontCharacter:"\\eb73"}),s.unlock=new s("unlock",{fontCharacter:"\\eb74"}),s.unmute=new s("unmute",{fontCharacter:"\\eb75"}),s.unverified=new s("unverified",{fontCharacter:"\\eb76"}),s.verified=new s("verified",{fontCharacter:"\\eb77"}),s.versions=new s("versions",{fontCharacter:"\\eb78"}),s.vmActive=new s("vm-active",{fontCharacter:"\\eb79"}),s.vmOutline=new s("vm-outline",{fontCharacter:"\\eb7a"}),s.vmRunning=new s("vm-running",{fontCharacter:"\\eb7b"}),s.watch=new s("watch",{fontCharacter:"\\eb7c"}),s.whitespace=new s("whitespace",{fontCharacter:"\\eb7d"}),s.wholeWord=new s("whole-word",{fontCharacter:"\\eb7e"}),s.window=new s("window",{fontCharacter:"\\eb7f"}),s.wordWrap=new s("word-wrap",{fontCharacter:"\\eb80"}),s.zoomIn=new s("zoom-in",{fontCharacter:"\\eb81"}),s.zoomOut=new s("zoom-out",{fontCharacter:"\\eb82"}),s.listFilter=new s("list-filter",{fontCharacter:"\\eb83"}),s.listFlat=new s("list-flat",{fontCharacter:"\\eb84"}),s.listSelection=new s("list-selection",{fontCharacter:"\\eb85"}),s.selection=new s("selection",{fontCharacter:"\\eb85"}),s.listTree=new s("list-tree",{fontCharacter:"\\eb86"}),s.debugBreakpointFunctionUnverified=new s("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),s.debugBreakpointFunction=new s("debug-breakpoint-function",{fontCharacter:"\\eb88"}),s.debugBreakpointFunctionDisabled=new s("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),s.debugStackframeActive=new s("debug-stackframe-active",{fontCharacter:"\\eb89"}),s.debugStackframeDot=new s("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),s.debugStackframe=new s("debug-stackframe",{fontCharacter:"\\eb8b"}),s.debugStackframeFocused=new s("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),s.debugBreakpointUnsupported=new s("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),s.symbolString=new s("symbol-string",{fontCharacter:"\\eb8d"}),s.debugReverseContinue=new s("debug-reverse-continue",{fontCharacter:"\\eb8e"}),s.debugStepBack=new s("debug-step-back",{fontCharacter:"\\eb8f"}),s.debugRestartFrame=new s("debug-restart-frame",{fontCharacter:"\\eb90"}),s.callIncoming=new s("call-incoming",{fontCharacter:"\\eb92"}),s.callOutgoing=new s("call-outgoing",{fontCharacter:"\\eb93"}),s.menu=new s("menu",{fontCharacter:"\\eb94"}),s.expandAll=new s("expand-all",{fontCharacter:"\\eb95"}),s.feedback=new s("feedback",{fontCharacter:"\\eb96"}),s.groupByRefType=new s("group-by-ref-type",{fontCharacter:"\\eb97"}),s.ungroupByRefType=new s("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),s.account=new s("account",{fontCharacter:"\\eb99"}),s.bellDot=new s("bell-dot",{fontCharacter:"\\eb9a"}),s.debugConsole=new s("debug-console",{fontCharacter:"\\eb9b"}),s.library=new s("library",{fontCharacter:"\\eb9c"}),s.output=new s("output",{fontCharacter:"\\eb9d"}),s.runAll=new s("run-all",{fontCharacter:"\\eb9e"}),s.syncIgnored=new s("sync-ignored",{fontCharacter:"\\eb9f"}),s.pinned=new s("pinned",{fontCharacter:"\\eba0"}),s.githubInverted=new s("github-inverted",{fontCharacter:"\\eba1"}),s.debugAlt=new s("debug-alt",{fontCharacter:"\\eb91"}),s.serverProcess=new s("server-process",{fontCharacter:"\\eba2"}),s.serverEnvironment=new s("server-environment",{fontCharacter:"\\eba3"}),s.pass=new s("pass",{fontCharacter:"\\eba4"}),s.stopCircle=new s("stop-circle",{fontCharacter:"\\eba5"}),s.playCircle=new s("play-circle",{fontCharacter:"\\eba6"}),s.record=new s("record",{fontCharacter:"\\eba7"}),s.debugAltSmall=new s("debug-alt-small",{fontCharacter:"\\eba8"}),s.vmConnect=new s("vm-connect",{fontCharacter:"\\eba9"}),s.cloud=new s("cloud",{fontCharacter:"\\ebaa"}),s.merge=new s("merge",{fontCharacter:"\\ebab"}),s.exportIcon=new s("export",{fontCharacter:"\\ebac"}),s.graphLeft=new s("graph-left",{fontCharacter:"\\ebad"}),s.magnet=new s("magnet",{fontCharacter:"\\ebae"}),s.notebook=new s("notebook",{fontCharacter:"\\ebaf"}),s.redo=new s("redo",{fontCharacter:"\\ebb0"}),s.checkAll=new s("check-all",{fontCharacter:"\\ebb1"}),s.pinnedDirty=new s("pinned-dirty",{fontCharacter:"\\ebb2"}),s.passFilled=new s("pass-filled",{fontCharacter:"\\ebb3"}),s.circleLargeFilled=new s("circle-large-filled",{fontCharacter:"\\ebb4"}),s.circleLargeOutline=new s("circle-large-outline",{fontCharacter:"\\ebb5"}),s.combine=new s("combine",{fontCharacter:"\\ebb6"}),s.gather=new s("gather",{fontCharacter:"\\ebb6"}),s.table=new s("table",{fontCharacter:"\\ebb7"}),s.variableGroup=new s("variable-group",{fontCharacter:"\\ebb8"}),s.typeHierarchy=new s("type-hierarchy",{fontCharacter:"\\ebb9"}),s.typeHierarchySub=new s("type-hierarchy-sub",{fontCharacter:"\\ebba"}),s.typeHierarchySuper=new s("type-hierarchy-super",{fontCharacter:"\\ebbb"}),s.gitPullRequestCreate=new s("git-pull-request-create",{fontCharacter:"\\ebbc"}),s.runAbove=new s("run-above",{fontCharacter:"\\ebbd"}),s.runBelow=new s("run-below",{fontCharacter:"\\ebbe"}),s.notebookTemplate=new s("notebook-template",{fontCharacter:"\\ebbf"}),s.debugRerun=new s("debug-rerun",{fontCharacter:"\\ebc0"}),s.workspaceTrusted=new s("workspace-trusted",{fontCharacter:"\\ebc1"}),s.workspaceUntrusted=new s("workspace-untrusted",{fontCharacter:"\\ebc2"}),s.workspaceUnspecified=new s("workspace-unspecified",{fontCharacter:"\\ebc3"}),s.terminalCmd=new s("terminal-cmd",{fontCharacter:"\\ebc4"}),s.terminalDebian=new s("terminal-debian",{fontCharacter:"\\ebc5"}),s.terminalLinux=new s("terminal-linux",{fontCharacter:"\\ebc6"}),s.terminalPowershell=new s("terminal-powershell",{fontCharacter:"\\ebc7"}),s.terminalTmux=new s("terminal-tmux",{fontCharacter:"\\ebc8"}),s.terminalUbuntu=new s("terminal-ubuntu",{fontCharacter:"\\ebc9"}),s.terminalBash=new s("terminal-bash",{fontCharacter:"\\ebca"}),s.arrowSwap=new s("arrow-swap",{fontCharacter:"\\ebcb"}),s.copy=new s("copy",{fontCharacter:"\\ebcc"}),s.personAdd=new s("person-add",{fontCharacter:"\\ebcd"}),s.filterFilled=new s("filter-filled",{fontCharacter:"\\ebce"}),s.wand=new s("wand",{fontCharacter:"\\ebcf"}),s.debugLineByLine=new s("debug-line-by-line",{fontCharacter:"\\ebd0"}),s.inspect=new s("inspect",{fontCharacter:"\\ebd1"}),s.dropDownButton=new s("drop-down-button",s.chevronDown.definition)}(C=e.Codicon||(e.Codicon={}))}),define(ge[92],pe([0,1,16,6]),function(X,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function k(u){const h=u;return h?[h.on,h.pause,h.resume,h.destroy].every(m=>typeof m=="function"):!1}e.isReadableStream=k;function y(u){const h=u;return h?k(h.stream)&&Array.isArray(h.buffer)&&typeof h.ended=="boolean":!1}e.isReadableBufferedStream=y;function A(u,h){return new C(u,h)}e.newWriteableStream=A;class C{constructor(h,m){this.reducer=h,this.options=m,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(h){var m;if(!this.state.destroyed){if(this.state.flowing)this.emitData(h);else if(this.buffer.data.push(h),typeof((m=this.options)===null||m===void 0?void 0:m.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(h){this.state.destroyed||(this.state.flowing?this.emitError(h):this.buffer.error.push(h))}end(h){this.state.destroyed||(typeof h!="undefined"&&this.write(h),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(h){this.listeners.data.slice(0).forEach(m=>m(h))}emitError(h){this.listeners.error.length===0?v.onUnexpectedError(h):this.listeners.error.slice(0).forEach(m=>m(h))}emitEnd(){this.listeners.end.slice(0).forEach(h=>h())}on(h,m){if(!this.state.destroyed)switch(h){case"data":this.listeners.data.push(m),this.resume();break;case"end":this.listeners.end.push(m),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(m),this.state.flowing&&this.flowErrors();break}}removeListener(h,m){if(this.state.destroyed)return;let t;switch(h){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const r=t.indexOf(m);r>=0&&t.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const h=this.reducer(this.buffer.data);this.emitData(h),this.buffer.data.length=0;const m=[...this.pendingWritePromises];this.pendingWritePromises.length=0,m.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const h of this.buffer.error)this.emitError(h);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function D(u,h){const m=[];let t;for(;(t=u.read())!==null;)m.push(t);return h(m)}e.consumeReadable=D;function P(u,h,m){const t=[];let r;for(;(r=u.read())!==null&&t.length<m;)t.push(r);return r===null&&t.length>0?h(t):{read:()=>{if(t.length>0)return t.shift();if(typeof r!="undefined"){const i=r;return r=void 0,i}return u.read()}}}e.peekReadable=P;function s(u,h){return new Promise((m,t)=>{const r=[];I(u,{onData:i=>{h&&r.push(i)},onError:i=>{h?t(i):m(void 0)},onEnd:()=>{m(h?h(r):void 0)}})})}e.consumeStream=s;function I(u,h){u.on("error",m=>h.onError(m)),u.on("end",()=>h.onEnd()),u.on("data",m=>h.onData(m))}e.listenStream=I;function l(u,h){return new Promise((m,t)=>{const r=new R.DisposableStore,i=[],n=d=>{if(i.push(d),i.length>h)return r.dispose(),u.pause(),m({stream:u,buffer:i,ended:!1})},a=d=>t(d),p=()=>m({stream:u,buffer:i,ended:!0});r.add(R.toDisposable(()=>u.removeListener("error",a))),u.on("error",a),r.add(R.toDisposable(()=>u.removeListener("end",p))),u.on("end",p),r.add(R.toDisposable(()=>u.removeListener("data",n))),u.on("data",n)})}e.peekStream=l;function g(u,h){const m=A(h);return m.end(u),m}e.toStream=g;function c(){const u=A(()=>{throw new Error("not supported")});return u.end(),u}e.emptyStream=c;function f(u){let h=!1;return{read:()=>h?null:(h=!0,u)}}e.toReadable=f;function _(u,h,m){const t=A(m);return I(u,{onData:r=>t.write(h.data(r)),onError:r=>t.error(h.error?h.error(r):r),onEnd:()=>t.end()}),t}e.transform=_;function w(u,h,m){let t=!1;return{read:()=>{const r=h.read();return t?r:(t=!0,r!==null?m([u,r]):u)}}}e.prefixedReadable=w;function E(u,h,m){let t=!1;const r=A(m);return I(h,{onData:i=>t?r.write(i):(t=!0,r.write(m([u,i]))),onError:i=>r.error(i),onEnd:()=>{t||(t=!0,r.write(u)),r.end()}}),r}e.prefixedStream=E}),define(ge[8],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function v(H){return!H||typeof H!="string"?!0:H.trim().length===0}e.isFalsyOrWhitespace=v;const R=/{(\d+)}/g;function k(H,...ee){return ee.length===0?H:H.replace(R,function(ue,Pe){const Ae=parseInt(Pe,10);return isNaN(Ae)||Ae<0||Ae>=ee.length?ue:ee[Ae]})}e.format=k;function y(H){return H.replace(/[<>&]/g,function(ee){switch(ee){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ee}})}e.escape=y;function A(H){return H.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=A;function C(H,ee){let ue=0;const Pe=ee.charCodeAt(0);for(let Ae=H.length-1;Ae>=0;Ae--)H.charCodeAt(Ae)===Pe&&ue++;return ue}e.count=C;function D(H,ee,ue="\u2026"){return H.length<=ee?H:`${H.substr(0,ee)}${ue}`}e.truncate=D;function P(H,ee=" "){const ue=s(H,ee);return I(ue,ee)}e.trim=P;function s(H,ee){if(!H||!ee)return H;const ue=ee.length;if(ue===0||H.length===0)return H;let Pe=0;for(;H.indexOf(ee,Pe)===Pe;)Pe=Pe+ue;return H.substring(Pe)}e.ltrim=s;function I(H,ee){if(!H||!ee)return H;const ue=ee.length,Pe=H.length;if(ue===0||Pe===0)return H;let Ae=Pe,xe=-1;for(;xe=H.lastIndexOf(ee,Ae-1),!(xe===-1||xe+ue!==Ae);){if(xe===0)return"";Ae=xe}return H.substring(0,Ae)}e.rtrim=I;function l(H){return H.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=l;function g(H){return H.replace(/\*/g,"")}e.stripWildcards=g;function c(H,ee,ue={}){if(!H)throw new Error("Cannot create regex from empty string");ee||(H=A(H)),ue.wholeWord&&(/\B/.test(H.charAt(0))||(H="\\b"+H),/\B/.test(H.charAt(H.length-1))||(H=H+"\\b"));let Pe="";return ue.global&&(Pe+="g"),ue.matchCase||(Pe+="i"),ue.multiline&&(Pe+="m"),ue.unicode&&(Pe+="u"),new RegExp(H,Pe)}e.createRegExp=c;function f(H){return H.source==="^"||H.source==="^$"||H.source==="$"||H.source==="^\\s*$"?!1:!!(H.exec("")&&H.lastIndex===0)}e.regExpLeadsToEndlessLoop=f;function _(H){return!!H.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=_;function w(H){return(H.global?"g":"")+(H.ignoreCase?"i":"")+(H.multiline?"m":"")+(H.unicode?"u":"")}e.regExpFlags=w;function E(H){return H.split(/\r\n|\r|\n/)}e.splitLines=E;function u(H){for(let ee=0,ue=H.length;ee<ue;ee++){const Pe=H.charCodeAt(ee);if(Pe!==32&&Pe!==9)return ee}return-1}e.firstNonWhitespaceIndex=u;function h(H,ee=0,ue=H.length){for(let Pe=ee;Pe<ue;Pe++){const Ae=H.charCodeAt(Pe);if(Ae!==32&&Ae!==9)return H.substring(ee,Pe)}return H.substring(ee,ue)}e.getLeadingWhitespace=h;function m(H,ee=H.length-1){for(let ue=ee;ue>=0;ue--){const Pe=H.charCodeAt(ue);if(Pe!==32&&Pe!==9)return ue}return-1}e.lastNonWhitespaceIndex=m;function t(H,ee){return H<ee?-1:H>ee?1:0}e.compare=t;function r(H,ee,ue=0,Pe=H.length,Ae=0,xe=ee.length){for(;ue<Pe&&Ae<xe;ue++,Ae++){let rt=H.charCodeAt(ue),nt=ee.charCodeAt(Ae);if(rt<nt)return-1;if(rt>nt)return 1}const Be=Pe-ue,Qe=xe-Ae;return Be<Qe?-1:Be>Qe?1:0}e.compareSubstring=r;function i(H,ee){return n(H,ee,0,H.length,0,ee.length)}e.compareIgnoreCase=i;function n(H,ee,ue=0,Pe=H.length,Ae=0,xe=ee.length){for(;ue<Pe&&Ae<xe;ue++,Ae++){let rt=H.charCodeAt(ue),nt=ee.charCodeAt(Ae);if(rt===nt)continue;const Ze=rt-nt;if(!(Ze===32&&p(nt))&&!(Ze===-32&&p(rt)))return a(rt)&&a(nt)?Ze:r(H.toLowerCase(),ee.toLowerCase(),ue,Pe,Ae,xe)}const Be=Pe-ue,Qe=xe-Ae;return Be<Qe?-1:Be>Qe?1:0}e.compareSubstringIgnoreCase=n;function a(H){return H>=97&&H<=122}e.isLowerAsciiLetter=a;function p(H){return H>=65&&H<=90}e.isUpperAsciiLetter=p;function d(H){return a(H)||p(H)}function b(H,ee){return H.length===ee.length&&S(H,ee)}e.equalsIgnoreCase=b;function S(H,ee,ue=H.length){for(let Pe=0;Pe<ue;Pe++){const Ae=H.charCodeAt(Pe),xe=ee.charCodeAt(Pe);if(Ae!==xe){if(d(Ae)&&d(xe)){const Be=Math.abs(Ae-xe);if(Be!==0&&Be!==32)return!1}else if(String.fromCharCode(Ae).toLowerCase()!==String.fromCharCode(xe).toLowerCase())return!1}}return!0}function o(H,ee){const ue=ee.length;return ee.length>H.length?!1:S(H,ee,ue)}e.startsWithIgnoreCase=o;function L(H,ee){let ue,Pe=Math.min(H.length,ee.length);for(ue=0;ue<Pe;ue++)if(H.charCodeAt(ue)!==ee.charCodeAt(ue))return ue;return Pe}e.commonPrefixLength=L;function O(H,ee){let ue,Pe=Math.min(H.length,ee.length);const Ae=H.length-1,xe=ee.length-1;for(ue=0;ue<Pe;ue++)if(H.charCodeAt(Ae-ue)!==ee.charCodeAt(xe-ue))return ue;return Pe}e.commonSuffixLength=O;function W(H){return 55296<=H&&H<=56319}e.isHighSurrogate=W;function J(H){return 56320<=H&&H<=57343}e.isLowSurrogate=J;function oe(H,ee){return(H-55296<<10)+(ee-56320)+65536}e.computeCodePoint=oe;function q(H,ee,ue){const Pe=H.charCodeAt(ue);if(W(Pe)&&ue+1<ee){const Ae=H.charCodeAt(ue+1);if(J(Ae))return oe(Pe,Ae)}return Pe}e.getNextCodePoint=q;function x(H,ee){const ue=H.charCodeAt(ee-1);if(J(ue)&&ee>1){const Pe=H.charCodeAt(ee-2);if(W(Pe))return oe(Pe,ue)}return ue}function V(H,ee){const ue=Ne.getInstance(),Pe=ee,Ae=H.length,xe=q(H,Ae,ee);ee+=xe>=65536?2:1;let Be=ue.getGraphemeBreakType(xe);for(;ee<Ae;){const Qe=q(H,Ae,ee),rt=ue.getGraphemeBreakType(Qe);if(ve(Be,rt))break;ee+=Qe>=65536?2:1,Be=rt}return ee-Pe}e.nextCharLength=V;function T(H,ee){const ue=Ne.getInstance(),Pe=ee,Ae=x(H,ee);ee-=Ae>=65536?2:1;let xe=ue.getGraphemeBreakType(Ae);for(;ee>0;){const Be=x(H,ee),Qe=ue.getGraphemeBreakType(Be);if(ve(Qe,xe))break;ee-=Be>=65536?2:1,xe=Qe}return Pe-ee}e.prevCharLength=T;function N(H,ee){const ue=Ne.getInstance(),Pe=H.length,Ae=ee,xe=q(H,Pe,ee),Be=ue.getGraphemeBreakType(xe);ee+=xe>=65536?2:1;let Qe=Be;for(;ee<Pe;){const nt=q(H,Pe,ee),Ze=ue.getGraphemeBreakType(nt);if(ve(Qe,Ze))break;ee+=nt>=65536?2:1,Qe=Ze}const rt=ee;for(ee=Ae,Qe=Be;ee>0;){const nt=x(H,ee),Ze=ue.getGraphemeBreakType(nt);if(ve(Ze,Qe))break;ee-=nt>=65536?2:1,Qe=Ze}return[ee,rt]}function F(H,ee){return ee>0&&J(H.charCodeAt(ee))?N(H,ee-1):N(H,ee)}e.getCharContainingOffset=F;function M(H){const ee=H.length;let ue=0,Pe=0;for(;Pe<ee;){const Be=q(H,ee,Pe);Pe+=Be>=65536?2:1,Be<128?ue+=1:Be<2048?ue+=2:Be<65536?ue+=3:ue+=4}const Ae=new Uint8Array(ue);Pe=0;let xe=0;for(;Pe<ee;){const Be=q(H,ee,Pe);Pe+=Be>=65536?2:1,Be<128?Ae[xe++]=Be:Be<2048?(Ae[xe++]=192|(Be&1984)>>>6,Ae[xe++]=128|(Be&63)>>>0):Be<65536?(Ae[xe++]=224|(Be&61440)>>>12,Ae[xe++]=128|(Be&4032)>>>6,Ae[xe++]=128|(Be&63)>>>0):(Ae[xe++]=240|(Be&1835008)>>>18,Ae[xe++]=128|(Be&258048)>>>12,Ae[xe++]=128|(Be&4032)>>>6,Ae[xe++]=128|(Be&63)>>>0)}return Ae}e.encodeUTF8=M;function U(H){const ee=H.byteLength,ue=[];let Pe=0;for(;Pe<ee;){const Ae=H[Pe];let xe;if(Ae>=240&&Pe+3<ee?xe=(H[Pe++]&7)<<18>>>0|(H[Pe++]&63)<<12>>>0|(H[Pe++]&63)<<6>>>0|(H[Pe++]&63)<<0>>>0:Ae>=224&&Pe+2<ee?xe=(H[Pe++]&15)<<12>>>0|(H[Pe++]&63)<<6>>>0|(H[Pe++]&63)<<0>>>0:Ae>=192&&Pe+1<ee?xe=(H[Pe++]&31)<<6>>>0|(H[Pe++]&63)<<0>>>0:xe=H[Pe++],xe>=0&&xe<=55295||xe>=57344&&xe<=65535)ue.push(String.fromCharCode(xe));else if(xe>=65536&&xe<=1114111){const Be=xe-65536,Qe=55296+((Be&1047552)>>>10),rt=56320+((Be&1023)>>>0);ue.push(String.fromCharCode(Qe)),ue.push(String.fromCharCode(rt))}else ue.push(String.fromCharCode(65533))}return ue.join("")}e.decodeUTF8=U;const B=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function K(H){return B.test(H)}e.containsRTL=K;const ie=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function we(H){return ie.test(H)}e.containsEmoji=we;const Te=/^[\t\n\r\x20-\x7E]*$/;function ye(H){return Te.test(H)}e.isBasicASCII=ye,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Oe(H){return e.UNUSUAL_LINE_TERMINATORS.test(H)}e.containsUnusualLineTerminators=Oe;function je(H){for(let ee=0,ue=H.length;ee<ue;ee++)if(ze(H.charCodeAt(ee)))return!0;return!1}e.containsFullWidthCharacter=je;function ze(H){return H=+H,H>=11904&&H<=55215||H>=63744&&H<=64255||H>=65281&&H<=65374}e.isFullWidthCharacter=ze;function qe(H){return H>=127462&&H<=127487||H===8986||H===8987||H===9200||H===9203||H>=9728&&H<=10175||H===11088||H===11093||H>=127744&&H<=128591||H>=128640&&H<=128764||H>=128992&&H<=129003||H>=129280&&H<=129535||H>=129648&&H<=129750}e.isEmojiImprecise=qe;function j(H,ee){if(H.length<ee)return H;const ue=/\b/g;let Pe=0;for(;ue.test(H)&&!(H.length-ue.lastIndex<ee);)Pe=ue.lastIndex,ue.lastIndex+=1;return H.substring(Pe).replace(/^\s/,"")}e.lcut=j;const Z=/\x1B\x5B[12]?K/g,ne=/\x1b\[\d+m/g,ae=/\x1b\[0?m/g;function Y(H){return H&&(H=H.replace(Z,""),H=H.replace(ne,""),H=H.replace(ae,"")),H}e.removeAnsiEscapeCodes=Y,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ce(H){return!!(H&&H.length>0&&H.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ce;function me(H){return ce(H)?H.substr(1):H}e.stripUTF8BOM=me;function Re(H,ee){if(!H||!ee||H.length<ee.length)return!1;const ue=ee.length,Pe=H.toLowerCase();let Ae=0,xe=-1;for(;Ae<ue;){const Be=Pe.indexOf(ee[Ae],xe+1);if(Be<0)return!1;xe=Be,Ae++}return!0}e.fuzzyContains=Re;function He(H,ee=!1){return H?(ee&&(H=H.replace(/\\./g,"")),H.toLowerCase()!==H):!1}e.containsUppercaseCharacter=He;function be(H){return H.charAt(0).toUpperCase()+H.slice(1)}e.uppercaseFirstLetter=be;function Xe(H,ee=1){if(ee===0)return"";let ue=-1;do ue=H.indexOf(`
`,ue+1),ee--;while(ee>0&&ue>=0);return ue===-1?H:(H[ue-1]==="\r"&&ue--,H.substr(0,ue))}e.getNLines=Xe;function Q(H){const ee=90-65+1;return H=H%(2*ee),H<ee?String.fromCharCode(97+H):String.fromCharCode(65+H-ee)}e.singleLetterHash=Q;function re(H){return Ne.getInstance().getGraphemeBreakType(H)}e.getGraphemeBreakType=re;function ve(H,ee){return H===0?ee!==5&&ee!==7:H===2&&ee===3?!1:H===4||H===2||H===3||ee===4||ee===2||ee===3?!0:!(H===8&&(ee===8||ee===9||ee===11||ee===12)||(H===11||H===9)&&(ee===9||ee===10)||(H===12||H===10)&&ee===10||ee===5||ee===13||ee===7||H===1||H===13&&ee===14||H===6&&ee===6)}e.breakBetweenGraphemeBreakType=ve;var Me;(function(H){H[H.Other=0]="Other",H[H.Prepend=1]="Prepend",H[H.CR=2]="CR",H[H.LF=3]="LF",H[H.Control=4]="Control",H[H.Extend=5]="Extend",H[H.Regional_Indicator=6]="Regional_Indicator",H[H.SpacingMark=7]="SpacingMark",H[H.L=8]="L",H[H.V=9]="V",H[H.T=10]="T",H[H.LV=11]="LV",H[H.LVT=12]="LVT",H[H.ZWJ=13]="ZWJ",H[H.Extended_Pictographic=14]="Extended_Pictographic"})(Me=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ne{constructor(){this._data=Ye()}static getInstance(){return Ne._INSTANCE||(Ne._INSTANCE=new Ne),Ne._INSTANCE}getGraphemeBreakType(ee){if(ee<32)return ee===10?3:ee===13?2:4;if(ee<127)return 0;const ue=this._data,Pe=ue.length/3;let Ae=1;for(;Ae<=Pe;)if(ee<ue[3*Ae])Ae=2*Ae;else if(ee>ue[3*Ae+1])Ae=2*Ae+1;else return ue[3*Ae+2];return 0}}Ne._INSTANCE=null;function Ye(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function Se(H,ee){if(H===0)return 0;const ue=_e(H,ee);if(ue!==void 0)return ue;const Pe=x(ee,H);return H-=ke(Pe),H}e.getLeftDeleteOffset=Se;function _e(H,ee){let ue=x(ee,H);for(H-=ke(ue);le(ue)||ue===65039||ue===8419;){if(H===0)return;ue=x(ee,H),H-=ke(ue)}if(!!qe(ue)){if(H>=0){const Pe=x(ee,H);Pe===8205&&(H-=ke(Pe))}return H}}function ke(H){return H>=65536?2:1}function le(H){return 127995<=H&&H<=127999}var fe;(function(H){H[H.zwj=8205]="zwj",H[H.emojiVariantSelector=65039]="emojiVariantSelector",H[H.enclosingKeyCap=8419]="enclosingKeyCap"})(fe||(fe={}))}),define(ge[22],pe([0,1,8,92]),function(X,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const k=typeof Buffer!="undefined",y=typeof TextEncoder!="undefined",A=typeof TextDecoder!="undefined";let C,D;class P{constructor(d){this.buffer=d,this.byteLength=this.buffer.byteLength}static alloc(d){return k?new P(Buffer.allocUnsafe(d)):new P(new Uint8Array(d))}static wrap(d){return k&&!Buffer.isBuffer(d)&&(d=Buffer.from(d.buffer,d.byteOffset,d.byteLength)),new P(d)}static fromString(d,b){return!((b==null?void 0:b.dontUseNodeBuffer)||!1)&&k?new P(Buffer.from(d)):y?(C||(C=new TextEncoder),new P(C.encode(d))):new P(v.encodeUTF8(d))}static concat(d,b){if(typeof b=="undefined"){b=0;for(let L=0,O=d.length;L<O;L++)b+=d[L].byteLength}const S=P.alloc(b);let o=0;for(let L=0,O=d.length;L<O;L++){const W=d[L];S.set(W,o),o+=W.byteLength}return S}toString(){return k?this.buffer.toString():A?(D||(D=new TextDecoder),D.decode(this.buffer)):v.decodeUTF8(this.buffer)}slice(d,b){return new P(this.buffer.subarray(d,b))}set(d,b){d instanceof P?this.buffer.set(d.buffer,b):this.buffer.set(d,b)}readUInt32BE(d){return l(this.buffer,d)}writeUInt32BE(d,b){g(this.buffer,d,b)}readUInt32LE(d){return c(this.buffer,d)}writeUInt32LE(d,b){f(this.buffer,d,b)}readUInt8(d){return _(this.buffer,d)}writeUInt8(d,b){w(this.buffer,d,b)}}e.VSBuffer=P;function s(p,d){return p[d+0]<<0>>>0|p[d+1]<<8>>>0}e.readUInt16LE=s;function I(p,d,b){p[b+0]=d&255,d=d>>>8,p[b+1]=d&255}e.writeUInt16LE=I;function l(p,d){return p[d]*2**24+p[d+1]*2**16+p[d+2]*2**8+p[d+3]}e.readUInt32BE=l;function g(p,d,b){p[b+3]=d,d=d>>>8,p[b+2]=d,d=d>>>8,p[b+1]=d,d=d>>>8,p[b]=d}e.writeUInt32BE=g;function c(p,d){return p[d+0]<<0>>>0|p[d+1]<<8>>>0|p[d+2]<<16>>>0|p[d+3]<<24>>>0}e.readUInt32LE=c;function f(p,d,b){p[b+0]=d&255,d=d>>>8,p[b+1]=d&255,d=d>>>8,p[b+2]=d&255,d=d>>>8,p[b+3]=d&255}e.writeUInt32LE=f;function _(p,d){return p[d]}e.readUInt8=_;function w(p,d,b){p[b]=d}e.writeUInt8=w;function E(p){return R.consumeReadable(p,d=>P.concat(d))}e.readableToBuffer=E;function u(p){return R.toReadable(p)}e.bufferToReadable=u;function h(p){return R.consumeStream(p,d=>P.concat(d))}e.streamToBuffer=h;async function m(p){return p.ended?P.concat(p.buffer):P.concat([...p.buffer,await h(p.stream)])}e.bufferedStreamToBuffer=m;function t(p){return R.toStream(p,d=>P.concat(d))}e.bufferToStream=t;function r(p){return R.transform(p,{data:d=>typeof d=="string"?P.fromString(d):P.wrap(d)},d=>P.concat(d))}e.streamToBufferReadableStream=r;function i(p){return R.newWriteableStream(d=>P.concat(d),p)}e.newWriteableBufferStream=i;function n(p,d){return R.prefixedReadable(p,d,b=>P.concat(b))}e.prefixedBufferReadable=n;function a(p,d){return R.prefixedStream(p,d,b=>P.concat(b))}e.prefixedBufferStream=a}),define(ge[74],pe([0,1,8]),function(X,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function R(w){return k(w,0)}e.hash=R;function k(w,E){switch(typeof w){case"object":return w===null?y(349,E):Array.isArray(w)?D(w,E):P(w,E);case"string":return C(w,E);case"boolean":return A(w,E);case"number":return y(w,E);case"undefined":return y(937,E);default:return y(617,E)}}e.doHash=k;function y(w,E){return(E<<5)-E+w|0}function A(w,E){return y(w?433:863,E)}function C(w,E){E=y(149417,E);for(let u=0,h=w.length;u<h;u++)E=y(w.charCodeAt(u),E);return E}e.stringHash=C;function D(w,E){return E=y(104579,E),w.reduce((u,h)=>k(h,u),E)}function P(w,E){return E=y(181387,E),Object.keys(w).sort().reduce((u,h)=>(u=C(h,u),k(w[h],u)),E)}class s{constructor(){this._value=0}get value(){return this._value}hash(E){return this._value=k(E,this._value),this._value}}e.Hasher=s;var I;(function(w){w[w.BLOCK_SIZE=64]="BLOCK_SIZE",w[w.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function l(w,E,u=32){const h=u-E,m=~((1<<h)-1);return(w<<E|(m&w)>>>h)>>>0}function g(w,E=0,u=w.byteLength,h=0){for(let m=0;m<u;m++)w[E+m]=h}function c(w,E,u="0"){for(;w.length<E;)w=u+w;return w}function f(w,E=32){return w instanceof ArrayBuffer?Array.from(new Uint8Array(w)).map(u=>u.toString(16).padStart(2,"0")).join(""):c((w>>>0).toString(16),E/4)}e.toHexString=f;class _{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(E){const u=E.length;if(u===0)return;const h=this._buff;let m=this._buffLen,t=this._leftoverHighSurrogate,r,i;for(t!==0?(r=t,i=-1,t=0):(r=E.charCodeAt(0),i=0);;){let n=r;if(v.isHighSurrogate(r))if(i+1<u){const a=E.charCodeAt(i+1);v.isLowSurrogate(a)?(i++,n=v.computeCodePoint(r,a)):n=65533}else{t=r;break}else v.isLowSurrogate(r)&&(n=65533);if(m=this._push(h,m,n),i++,i<u)r=E.charCodeAt(i);else break}this._buffLen=m,this._leftoverHighSurrogate=t}_push(E,u,h){return h<128?E[u++]=h:h<2048?(E[u++]=192|(h&1984)>>>6,E[u++]=128|(h&63)>>>0):h<65536?(E[u++]=224|(h&61440)>>>12,E[u++]=128|(h&4032)>>>6,E[u++]=128|(h&63)>>>0):(E[u++]=240|(h&1835008)>>>18,E[u++]=128|(h&258048)>>>12,E[u++]=128|(h&4032)>>>6,E[u++]=128|(h&63)>>>0),u>=64&&(this._step(),u-=64,this._totalLen+=64,E[0]=E[64+0],E[1]=E[64+1],E[2]=E[64+2]),u}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),f(this._h0)+f(this._h1)+f(this._h2)+f(this._h3)+f(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,g(this._buff,this._buffLen),this._buffLen>56&&(this._step(),g(this._buff));const E=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(E/4294967296),!1),this._buffDV.setUint32(60,E%4294967296,!1),this._step()}_step(){const E=_._bigBlock32,u=this._buffDV;for(let d=0;d<64;d+=4)E.setUint32(d,u.getUint32(d,!1),!1);for(let d=64;d<320;d+=4)E.setUint32(d,l(E.getUint32(d-12,!1)^E.getUint32(d-32,!1)^E.getUint32(d-56,!1)^E.getUint32(d-64,!1),1),!1);let h=this._h0,m=this._h1,t=this._h2,r=this._h3,i=this._h4,n,a,p;for(let d=0;d<80;d++)d<20?(n=m&t|~m&r,a=1518500249):d<40?(n=m^t^r,a=1859775393):d<60?(n=m&t|m&r|t&r,a=2400959708):(n=m^t^r,a=3395469782),p=l(h,5)+n+i+a+E.getUint32(d*4,!1)&4294967295,i=r,r=t,t=l(m,30),m=h,h=p;this._h0=this._h0+h&4294967295,this._h1=this._h1+m&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+r&4294967295,this._h4=this._h4+i&4294967295}}e.StringSHA1=_,_._bigBlock32=new DataView(new ArrayBuffer(320))}),define(ge[52],pe([0,1,8]),function(X,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var R;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(R||(R={})),function(k){const y="error",A="warning",C="warn",D="info",P="ignore";function s(l){return l?v.equalsIgnoreCase(y,l)?k.Error:v.equalsIgnoreCase(A,l)||v.equalsIgnoreCase(C,l)?k.Warning:v.equalsIgnoreCase(D,l)?k.Info:k.Ignore:k.Ignore}k.fromValue=s;function I(l){switch(l){case k.Error:return y;case k.Warning:return A;case k.Info:return D;default:return P}}k.toString=I}(R||(R={})),e.default=R}),define(ge[13],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function v(d){return Array.isArray(d)}e.isArray=v;function R(d){return typeof d=="string"}e.isString=R;function k(d){return Array.isArray(d)&&d.every(b=>R(b))}e.isStringArray=k;function y(d){return typeof d=="object"&&d!==null&&!Array.isArray(d)&&!(d instanceof RegExp)&&!(d instanceof Date)}e.isObject=y;function A(d){return typeof d=="number"&&!isNaN(d)}e.isNumber=A;function C(d){return!!d&&typeof d[Symbol.iterator]=="function"}e.isIterable=C;function D(d){return d===!0||d===!1}e.isBoolean=D;function P(d){return typeof d=="undefined"}e.isUndefined=P;function s(d){return!I(d)}e.isDefined=s;function I(d){return P(d)||d===null}e.isUndefinedOrNull=I;function l(d,b){if(!d)throw new Error(b?`Unexpected type, expected '${b}'`:"Unexpected type")}e.assertType=l;function g(d){if(I(d))throw new Error("Assertion Failed: argument is undefined or null");return d}e.assertIsDefined=g;function c(...d){const b=[];for(let S=0;S<d.length;S++){const o=d[S];if(I(o))throw new Error(`Assertion Failed: argument at index ${S} is undefined or null`);b.push(o)}return b}e.assertAllDefined=c;const f=Object.prototype.hasOwnProperty;function _(d){if(!y(d))return!1;for(let b in d)if(f.call(d,b))return!1;return!0}e.isEmptyObject=_;function w(d){return typeof d=="function"}e.isFunction=w;function E(...d){return d.length>0&&d.every(w)}e.areFunctions=E;function u(d,b){const S=Math.min(d.length,b.length);for(let o=0;o<S;o++)h(d[o],b[o])}e.validateConstraints=u;function h(d,b){if(R(b)){if(typeof d!==b)throw new Error(`argument does not match constraint: typeof ${b}`)}else if(w(b)){try{if(d instanceof b)return}catch(S){}if(!I(d)&&d.constructor===b||b.length===1&&b.call(void 0,d)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=h;function m(d){let b=[],S=Object.getPrototypeOf(d);for(;Object.prototype!==S;)b=b.concat(Object.getOwnPropertyNames(S)),S=Object.getPrototypeOf(S);return b}e.getAllPropertyNames=m;function t(d){const b=[];for(const S of m(d))typeof d[S]=="function"&&b.push(S);return b}e.getAllMethodNames=t;function r(d,b){const S=L=>function(){const O=Array.prototype.slice.call(arguments,0);return b(L,O)};let o={};for(const L of d)o[L]=S(L);return o}e.createProxyObject=r;function i(d){return d===null?void 0:d}e.withNullAsUndefined=i;function n(d){return typeof d=="undefined"?null:d}e.withUndefinedAsNull=n;function a(d){return class{constructor(){return new Proxy({},{get(b,S){if(b[S])return b[S];throw new Error(`Not Implemented: ${d}->${String(S)}`)}})}}}e.NotImplementedProxy=a;function p(d){throw new Error("Unreachable")}e.assertNever=p}),define(ge[29],pe([0,1,11,8,9,13]),function(X,e,v,R,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function A(i){return i===47||i===92}e.isPathSeparator=A;function C(i){return i.replace(/[\\/]/g,k.posix.sep)}e.toSlashes=C;function D(i){return i.indexOf("/")===-1&&(i=C(i)),/^[a-zA-Z]:(\/|$)/.test(i)&&(i="/"+i),i}e.toPosixPath=D;function P(i,n=k.posix.sep){if(!i)return"";const a=i.length,p=i.charCodeAt(0);if(A(p)){if(A(i.charCodeAt(1))&&!A(i.charCodeAt(2))){let b=3;const S=b;for(;b<a&&!A(i.charCodeAt(b));b++);if(S!==b&&!A(i.charCodeAt(b+1))){for(b+=1;b<a;b++)if(A(i.charCodeAt(b)))return i.slice(0,b+1).replace(/[\\/]/g,n)}}return n}else if(w(p)&&i.charCodeAt(1)===58)return A(i.charCodeAt(2))?i.slice(0,2)+n:i.slice(0,2);let d=i.indexOf("://");if(d!==-1){for(d+=3;d<a;d++)if(A(i.charCodeAt(d)))return i.slice(0,d+1)}return""}e.getRoot=P;function s(i){if(!v.isWindows||!i||i.length<5)return!1;let n=i.charCodeAt(0);if(n!==92||(n=i.charCodeAt(1),n!==92))return!1;let a=2;const p=a;for(;a<i.length&&(n=i.charCodeAt(a),n!==92);a++);return!(p===a||(n=i.charCodeAt(a+1),isNaN(n)||n===92))}e.isUNC=s;const I=/[\\/:\*\?"<>\|]/g,l=/[\\/]/g,g=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function c(i,n=v.isWindows){const a=n?I:l;return!(!i||i.length===0||/^\s+$/.test(i)||(a.lastIndex=0,a.test(i))||n&&g.test(i)||i==="."||i===".."||n&&i[i.length-1]==="."||n&&i.length!==i.trim().length||i.length>255)}e.isValidBasename=c;function f(i,n,a){const p=i===n;return!a||p?p:!i||!n?!1:R.equalsIgnoreCase(i,n)}e.isEqual=f;function _(i,n,a,p=k.sep){if(i===n)return!0;if(!i||!n||n.length>i.length)return!1;if(a){if(!R.startsWithIgnoreCase(i,n))return!1;if(n.length===i.length)return!0;let b=n.length;return n.charAt(n.length-1)===p&&b--,i.charAt(b)===p}return n.charAt(n.length-1)!==p&&(n+=p),i.indexOf(n)===0}e.isEqualOrParent=_;function w(i){return i>=65&&i<=90||i>=97&&i<=122}e.isWindowsDriveLetter=w;function E(i,n){return v.isWindows&&i.endsWith(":")&&(i+=k.sep),k.isAbsolute(i)||(i=k.join(n,i)),i=k.normalize(i),v.isWindows?(i=R.rtrim(i,k.sep),i.endsWith(":")&&(i+=k.sep)):(i=R.rtrim(i,k.sep),i||(i=k.sep)),i}e.sanitizeFilePath=E;function u(i){const n=k.normalize(i);return v.isWindows?i.length>3?!1:h(n)&&(i.length===2||n.charCodeAt(2)===92):n===k.posix.sep}e.isRootOrDriveLetter=u;function h(i){return v.isWindows?w(i.charCodeAt(0))&&i.charCodeAt(1)===58:!1}e.hasDriveLetter=h;function m(i){return h(i)?i[0]:void 0}e.getDriveLetter=m;function t(i,n,a){return n.length>i.length?-1:i===n?0:(a&&(i=i.toLowerCase(),n=n.toLowerCase()),i.indexOf(n))}e.indexOfPath=t;function r(i){const n=i.split(":");let a,p,d;if(n.forEach(b=>{const S=Number(b);y.isNumber(S)?p===void 0?p=S:d===void 0&&(d=S):a=a?[a,b].join(":"):b}),!a)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:a,line:p!==void 0?p:void 0,column:d!==void 0?d:p!==void 0?1:void 0}}e.parseLineAndColumnAware=r}),define(ge[25],pe([0,1,13]),function(X,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function R(f){if(!f||typeof f!="object"||f instanceof RegExp)return f;const _=Array.isArray(f)?[]:{};return Object.keys(f).forEach(w=>{f[w]&&typeof f[w]=="object"?_[w]=R(f[w]):_[w]=f[w]}),_}e.deepClone=R;function k(f){if(!f||typeof f!="object")return f;const _=[f];for(;_.length>0;){const w=_.shift();Object.freeze(w);for(const E in w)if(y.call(w,E)){const u=w[E];typeof u=="object"&&!Object.isFrozen(u)&&_.push(u)}}return f}e.deepFreeze=k;const y=Object.prototype.hasOwnProperty;function A(f,_){return C(f,_,new Set)}e.cloneAndChange=A;function C(f,_,w){if(v.isUndefinedOrNull(f))return f;const E=_(f);if(typeof E!="undefined")return E;if(v.isArray(f)){const u=[];for(const h of f)u.push(C(h,_,w));return u}if(v.isObject(f)){if(w.has(f))throw new Error("Cannot clone recursive data-structure");w.add(f);const u={};for(let h in f)y.call(f,h)&&(u[h]=C(f[h],_,w));return w.delete(f),u}return f}function D(f,_,w=!0){return v.isObject(f)?(v.isObject(_)&&Object.keys(_).forEach(E=>{E in f?w&&(v.isObject(f[E])&&v.isObject(_[E])?D(f[E],_[E],w):f[E]=_[E]):f[E]=_[E]}),f):_}e.mixin=D;function P(f,_){if(f===_)return!0;if(f==null||_===null||_===void 0||typeof f!=typeof _||typeof f!="object"||Array.isArray(f)!==Array.isArray(_))return!1;let w,E;if(Array.isArray(f)){if(f.length!==_.length)return!1;for(w=0;w<f.length;w++)if(!P(f[w],_[w]))return!1}else{const u=[];for(E in f)u.push(E);u.sort();const h=[];for(E in _)h.push(E);if(h.sort(),!P(u,h))return!1;for(w=0;w<u.length;w++)if(!P(f[u[w]],_[u[w]]))return!1}return!0}e.equals=P;function s(f){const _=new Set;return JSON.stringify(f,(w,E)=>{if(v.isObject(E)||Array.isArray(E)){if(_.has(E))return"[Circular]";_.add(E)}return E})}e.safeStringify=s;function I(f,_,w){const E=_(f);return typeof E=="undefined"?w:E}e.getOrDefault=I;function l(f,_){const w=Object.create(null);return!f||!_||Object.keys(_).forEach(u=>{const h=f[u],m=_[u];P(h,m)||(w[u]=m)}),w}e.distinct=l;function g(f,_){const w=_.toLowerCase(),E=Object.keys(f).find(u=>u.toLowerCase()===w);return E?f[E]:f[_]}e.getCaseInsensitive=g;function c(f,_){const w=Object.create(null);for(const E of Object.keys(f))_(E,f[E])&&(w[E]=f[E]);return w}e.filter=c}),define(ge[93],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var v;(function(y){y[y.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",y[y.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",y[y.MAX_UINT_8=255]="MAX_UINT_8",y[y.MAX_UINT_16=65535]="MAX_UINT_16",y[y.MAX_UINT_32=4294967295]="MAX_UINT_32",y[y.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(v=e.Constants||(e.Constants={}));function R(y){return y<0?0:y>255?255:y|0}e.toUint8=R;function k(y){return y<0?0:y>4294967295?4294967295:y|0}e.toUint32=k}),define(ge[2],pe([0,1,11,9]),function(X,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const k=/^\w[\w\d+.-]*$/,y=/^\//,A=/^\/\//;function C(i,n){if(!i.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!k.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!y.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function D(i,n){return!i&&!n?"file":i}function P(i,n){switch(i){case"https":case"http":case"file":n?n[0]!==I&&(n=I+n):n=I;break}return n}const s="",I="/",l=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class g{constructor(n,a,p,d,b,S=!1){typeof n=="object"?(this.scheme=n.scheme||s,this.authority=n.authority||s,this.path=n.path||s,this.query=n.query||s,this.fragment=n.fragment||s):(this.scheme=D(n,S),this.authority=a||s,this.path=P(this.scheme,p||s),this.query=d||s,this.fragment=b||s,C(this,S))}static isUri(n){return n instanceof g?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}get fsPath(){return u(this,!1)}with(n){if(!n)return this;let{scheme:a,authority:p,path:d,query:b,fragment:S}=n;return a===void 0?a=this.scheme:a===null&&(a=s),p===void 0?p=this.authority:p===null&&(p=s),d===void 0?d=this.path:d===null&&(d=s),b===void 0?b=this.query:b===null&&(b=s),S===void 0?S=this.fragment:S===null&&(S=s),a===this.scheme&&p===this.authority&&d===this.path&&b===this.query&&S===this.fragment?this:new f(a,p,d,b,S)}static parse(n,a=!1){const p=l.exec(n);return p?new f(p[2]||s,r(p[4]||s),r(p[5]||s),r(p[7]||s),r(p[9]||s),a):new f(s,s,s,s,s)}static file(n){let a=s;if(v.isWindows&&(n=n.replace(/\\/g,I)),n[0]===I&&n[1]===I){const p=n.indexOf(I,2);p===-1?(a=n.substring(2),n=I):(a=n.substring(2,p),n=n.substring(p)||I)}return new f("file",a,n,s,s)}static from(n){const a=new f(n.scheme,n.authority,n.path,n.query,n.fragment);return C(a,!0),a}static joinPath(n,...a){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let p;return v.isWindows&&n.scheme==="file"?p=g.file(R.win32.join(u(n,!0),...a)).path:p=R.posix.join(n.path,...a),n.with({path:p})}toString(n=!1){return h(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof g)return n;{const a=new f(n);return a._formatted=n.external,a._fsPath=n._sep===c?n.fsPath:null,a}}else return n}}e.URI=g;const c=v.isWindows?1:void 0;class f extends g{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=u(this,!1)),this._fsPath}toString(n=!1){return n?h(this,!0):(this._formatted||(this._formatted=h(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=c),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const _={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function w(i,n){let a,p=-1;for(let d=0;d<i.length;d++){const b=i.charCodeAt(d);if(b>=97&&b<=122||b>=65&&b<=90||b>=48&&b<=57||b===45||b===46||b===95||b===126||n&&b===47)p!==-1&&(a+=encodeURIComponent(i.substring(p,d)),p=-1),a!==void 0&&(a+=i.charAt(d));else{a===void 0&&(a=i.substr(0,d));const S=_[b];S!==void 0?(p!==-1&&(a+=encodeURIComponent(i.substring(p,d)),p=-1),a+=S):p===-1&&(p=d)}}return p!==-1&&(a+=encodeURIComponent(i.substring(p))),a!==void 0?a:i}function E(i){let n;for(let a=0;a<i.length;a++){const p=i.charCodeAt(a);p===35||p===63?(n===void 0&&(n=i.substr(0,a)),n+=_[p]):n!==void 0&&(n+=i[a])}return n!==void 0?n:i}function u(i,n){let a;return i.authority&&i.path.length>1&&i.scheme==="file"?a=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?n?a=i.path.substr(1):a=i.path[1].toLowerCase()+i.path.substr(2):a=i.path,v.isWindows&&(a=a.replace(/\//g,"\\")),a}e.uriToFsPath=u;function h(i,n){const a=n?E:w;let p="",{scheme:d,authority:b,path:S,query:o,fragment:L}=i;if(d&&(p+=d,p+=":"),(b||d==="file")&&(p+=I,p+=I),b){let O=b.indexOf("@");if(O!==-1){const W=b.substr(0,O);b=b.substr(O+1),O=W.indexOf(":"),O===-1?p+=a(W,!1):(p+=a(W.substr(0,O),!1),p+=":",p+=a(W.substr(O+1),!1)),p+="@"}b=b.toLowerCase(),O=b.indexOf(":"),O===-1?p+=a(b,!1):(p+=a(b.substr(0,O),!1),p+=b.substr(O))}if(S){if(S.length>=3&&S.charCodeAt(0)===47&&S.charCodeAt(2)===58){const O=S.charCodeAt(1);O>=65&&O<=90&&(S=`/${String.fromCharCode(O+32)}:${S.substr(3)}`)}else if(S.length>=2&&S.charCodeAt(1)===58){const O=S.charCodeAt(0);O>=65&&O<=90&&(S=`${String.fromCharCode(O+32)}:${S.substr(2)}`)}p+=a(S,!0)}return o&&(p+="?",p+=a(o,!1)),L&&(p+="#",p+=n?L:w(L,!1)),p}function m(i){try{return decodeURIComponent(i)}catch(n){return i.length>3?i.substr(0,3)+m(i.substr(3)):i}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(i){return i.match(t)?i.replace(t,n=>m(n)):i}});var tt=this&&this.__classPrivateFieldSet||function(X,e,v,R,k){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!k:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?k.call(X,v):k?k.value=v:e.set(X,v),v},$e=this&&this.__classPrivateFieldGet||function(X,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!R:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(X):R?R.value:e.get(X)};define(ge[23],pe([0,1,2,8]),function(X,e,v,R){"use strict";var k,y,A;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function C(t,r,i){let n=t.get(r);return n===void 0&&(n=i,t.set(r,n)),n}e.getOrSet=C;function D(t){const r=[];return t.forEach((i,n)=>{r.push(`${n} => ${i}`)}),`Map(${t.size}) {${r.join(", ")}}`}e.mapToString=D;function P(t){const r=[];return t.forEach(i=>{r.push(i)}),`Set(${t.size}) {${r.join(", ")}}`}e.setToString=P;class s{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const i=r.charCodeAt(0),n=this._value.charCodeAt(this._pos);return i-n}value(){return this._value[this._pos]}}e.StringIterator=s;class I{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?R.compareSubstring(r,this._value,0,r.length,this._from,this._to):R.compareSubstringIgnoreCase(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=I;class l{constructor(r=!0,i=!0){this._splitOnBackslash=r,this._caseSensitive=i}reset(r){return this._value=r.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++){const i=this._value.charCodeAt(this._to);if(i===47||this._splitOnBackslash&&i===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?R.compareSubstring(r,this._value,0,r.length,this._from,this._to):R.compareSubstringIgnoreCase(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=l;var g;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(g||(g={}));class c{constructor(r){this._ignorePathCasing=r,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new l(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return R.compareIgnoreCase(r,this._value.scheme);if(this._states[this._stateIdx]===2)return R.compareIgnoreCase(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return R.compare(r,this._value.query);if(this._states[this._stateIdx]===5)return R.compare(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=c;class f{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class _{constructor(r){this._iter=r}static forUris(r=()=>!1){return new _(new c(r))}static forPaths(){return new _(new l)}static forStrings(){return new _(new s)}static forConfigKeys(){return new _(new I)}clear(){this._root=void 0}set(r,i){const n=this._iter.reset(r);let a;for(this._root||(this._root=new f,this._root.segment=n.value()),a=this._root;;){const d=n.cmp(a.segment);if(d>0)a.left||(a.left=new f,a.left.segment=n.value()),a=a.left;else if(d<0)a.right||(a.right=new f,a.right.segment=n.value()),a=a.right;else if(n.hasNext())n.next(),a.mid||(a.mid=new f,a.mid.segment=n.value()),a=a.mid;else break}const p=a.value;return a.value=i,a.key=r,p}get(r){var i;return(i=this._getNode(r))===null||i===void 0?void 0:i.value}_getNode(r){const i=this._iter.reset(r);let n=this._root;for(;n;){const a=i.cmp(n.segment);if(a>0)n=n.left;else if(a<0)n=n.right;else if(i.hasNext())i.next(),n=n.mid;else break}return n}has(r){const i=this._getNode(r);return!((i==null?void 0:i.value)===void 0&&(i==null?void 0:i.mid)===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,i){const n=this._iter.reset(r),a=[];let p=this._root;for(;p;){const d=n.cmp(p.segment);if(d>0)a.push([1,p]),p=p.left;else if(d<0)a.push([-1,p]),p=p.right;else if(n.hasNext())n.next(),a.push([0,p]),p=p.mid;else{for(i?(p.left=void 0,p.mid=void 0,p.right=void 0):p.value=void 0;a.length>0&&p.isEmpty();){let[b,S]=a.pop();switch(b){case 1:S.left=void 0;break;case 0:S.mid=void 0;break;case-1:S.right=void 0;break}p=S}break}}}findSubstr(r){const i=this._iter.reset(r);let n=this._root,a;for(;n;){const p=i.cmp(n.segment);if(p>0)n=n.left;else if(p<0)n=n.right;else if(i.hasNext())i.next(),a=n.value||a,n=n.mid;else break}return n&&n.value||a}findSuperstr(r){const i=this._iter.reset(r);let n=this._root;for(;n;){const a=i.cmp(n.segment);if(a>0)n=n.left;else if(a<0)n=n.right;else if(i.hasNext())i.next(),n=n.mid;else return n.mid?this._entries(n.mid):void 0}}forEach(r){for(const[i,n]of this)r(n,i)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(r,i=0){if(i>5e3){console.log("potential CYCLE detected",new Error().stack);return}r&&(yield*this._entries(r.left,i++),r.value&&(yield[r.key,r.value]),yield*this._entries(r.mid,i++),yield*this._entries(r.right,i++))}}e.TernarySearchTree=_;class w{constructor(r,i){this[k]="ResourceMap",r instanceof w?(this.map=new Map(r.map),this.toKey=i??w.defaultToKey):(this.map=new Map,this.toKey=r??w.defaultToKey)}set(r,i){return this.map.set(this.toKey(r),i),this}get(r){return this.map.get(this.toKey(r))}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,i){typeof i!="undefined"&&(r=r.bind(i));for(let[n,a]of this.map)r(a,v.URI.parse(n),this)}values(){return this.map.values()}*keys(){for(let r of this.map.keys())yield v.URI.parse(r)}*entries(){for(let r of this.map.entries())yield[v.URI.parse(r[0]),r[1]]}*[(k=Symbol.toStringTag,Symbol.iterator)](){for(let r of this.map)yield[v.URI.parse(r[0]),r[1]]}}e.ResourceMap=w,w.defaultToKey=t=>t.toString();var E;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(E=e.Touch||(e.Touch={}));class u{constructor(){this[y]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var r;return(r=this._head)===null||r===void 0?void 0:r.value}get last(){var r;return(r=this._tail)===null||r===void 0?void 0:r.value}has(r){return this._map.has(r)}get(r,i=0){const n=this._map.get(r);if(!!n)return i!==0&&this.touch(n,i),n.value}set(r,i,n=0){let a=this._map.get(r);if(a)a.value=i,n!==0&&this.touch(a,n);else{switch(a={key:r,value:i,next:void 0,previous:void 0},n){case 0:this.addItemLast(a);break;case 1:this.addItemFirst(a);break;case 2:this.addItemLast(a);break;default:this.addItemLast(a);break}this._map.set(r,a),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const i=this._map.get(r);if(!!i)return this._map.delete(r),this.removeItem(i),this._size--,i.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,i){const n=this._state;let a=this._head;for(;a;){if(i?r.bind(i)(a.value,a.key,this):r(a.value,a.key,this),this._state!==n)throw new Error("LinkedMap got modified during iteration.");a=a.next}}keys(){const r=this,i=this._state;let n=this._head;const a={[Symbol.iterator](){return a},next(){if(r._state!==i)throw new Error("LinkedMap got modified during iteration.");if(n){const p={value:n.key,done:!1};return n=n.next,p}else return{value:void 0,done:!0}}};return a}values(){const r=this,i=this._state;let n=this._head;const a={[Symbol.iterator](){return a},next(){if(r._state!==i)throw new Error("LinkedMap got modified during iteration.");if(n){const p={value:n.value,done:!1};return n=n.next,p}else return{value:void 0,done:!0}}};return a}entries(){const r=this,i=this._state;let n=this._head;const a={[Symbol.iterator](){return a},next(){if(r._state!==i)throw new Error("LinkedMap got modified during iteration.");if(n){const p={value:[n.key,n.value],done:!1};return n=n.next,p}else return{value:void 0,done:!0}}};return a}[(y=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let i=this._head,n=this.size;for(;i&&n>r;)this._map.delete(i.key),i=i.next,n--;this._head=i,this._size=n,i&&(i.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const i=r.next,n=r.previous;if(!i||!n)throw new Error("Invalid list");i.previous=n,n.next=i}r.next=void 0,r.previous=void 0,this._state++}touch(r,i){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(i!==1&&i!==2)){if(i===1){if(r===this._head)return;const n=r.next,a=r.previous;r===this._tail?(a.next=void 0,this._tail=a):(n.previous=a,a.next=n),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(i===2){if(r===this._tail)return;const n=r.next,a=r.previous;r===this._head?(n.previous=void 0,this._head=n):(n.previous=a,a.next=n),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((i,n)=>{r.push([n,i])}),r}fromJSON(r){this.clear();for(const[i,n]of r)this.set(i,n)}}e.LinkedMap=u;class h extends u{constructor(r,i=1){super();this._limit=r,this._ratio=Math.min(Math.max(0,i),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,i=2){return super.get(r,i)}peek(r){return super.get(r,0)}set(r,i){return super.set(r,i,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=h;class m{constructor(r){A.set(this,void 0),tt(this,A,r,"f")}get size(){return $e(this,A,"f").size}forEach(r,i){$e(this,A,"f").forEach(r,i)}get(r){return $e(this,A,"f").get(r)}has(r){return $e(this,A,"f").has(r)}entries(){return $e(this,A,"f").entries()}keys(){return $e(this,A,"f").keys()}values(){return $e(this,A,"f").values()}[(A=new WeakMap,Symbol.iterator)](){return $e(this,A,"f").entries()}}e.ReadonlyMapView=m}),define(ge[94],pe([0,1,23,8]),function(X,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function k(...Y){return function(ce,me){for(let Re=0,He=Y.length;Re<He;Re++){const be=Y[Re](ce,me);if(be)return be}return null}}e.or=k,e.matchesStrictPrefix=y.bind(void 0,!1),e.matchesPrefix=y.bind(void 0,!0);function y(Y,ce,me){if(!me||me.length<ce.length)return null;let Re;return Y?Re=R.startsWithIgnoreCase(me,ce):Re=me.indexOf(ce)===0,Re?ce.length>0?[{start:0,end:ce.length}]:[]:null}function A(Y,ce){const me=ce.toLowerCase().indexOf(Y.toLowerCase());return me===-1?null:[{start:me,end:me+Y.length}]}e.matchesContiguousSubString=A;function C(Y,ce){return D(Y.toLowerCase(),ce.toLowerCase(),0,0)}e.matchesSubString=C;function D(Y,ce,me,Re){if(me===Y.length)return[];if(Re===ce.length)return null;if(Y[me]===ce[Re]){let He=null;return(He=D(Y,ce,me+1,Re+1))?w({start:Re,end:Re+1},He):null}return D(Y,ce,me,Re+1)}function P(Y){return 97<=Y&&Y<=122}function s(Y){return 65<=Y&&Y<=90}e.isUpper=s;function I(Y){return 48<=Y&&Y<=57}function l(Y){return Y===32||Y===9||Y===10||Y===13}const g=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(Y=>g.add(Y.charCodeAt(0)));function c(Y){return l(Y)||g.has(Y)}function f(Y,ce){return Y===ce||c(Y)&&c(ce)}function _(Y){return P(Y)||s(Y)||I(Y)}function w(Y,ce){return ce.length===0?ce=[Y]:Y.end===ce[0].start?ce[0].start=Y.start:ce.unshift(Y),ce}function E(Y,ce){for(let me=ce;me<Y.length;me++){const Re=Y.charCodeAt(me);if(s(Re)||I(Re)||me>0&&!_(Y.charCodeAt(me-1)))return me}return Y.length}function u(Y,ce,me,Re){if(me===Y.length)return[];if(Re===ce.length)return null;if(Y[me]!==ce[Re].toLowerCase())return null;{let He=null,be=Re+1;for(He=u(Y,ce,me+1,Re+1);!He&&(be=E(ce,be))<ce.length;)He=u(Y,ce,me+1,be),be++;return He===null?null:w({start:Re,end:Re+1},He)}}function h(Y){let ce=0,me=0,Re=0,He=0,be=0;for(let Me=0;Me<Y.length;Me++)be=Y.charCodeAt(Me),s(be)&&ce++,P(be)&&me++,_(be)&&Re++,I(be)&&He++;const Xe=ce/Y.length,Q=me/Y.length,re=Re/Y.length,ve=He/Y.length;return{upperPercent:Xe,lowerPercent:Q,alphaPercent:re,numericPercent:ve}}function m(Y){const{upperPercent:ce,lowerPercent:me}=Y;return me===0&&ce>.6}function t(Y){const{upperPercent:ce,lowerPercent:me,alphaPercent:Re,numericPercent:He}=Y;return me>.2&&ce<.8&&Re>.6&&He<.2}function r(Y){let ce=0,me=0,Re=0,He=0;for(let be=0;be<Y.length;be++)Re=Y.charCodeAt(be),s(Re)&&ce++,P(Re)&&me++,l(Re)&&He++;return(ce===0||me===0)&&He===0?Y.length<=30:ce<=5}function i(Y,ce){if(!ce||(ce=ce.trim(),ce.length===0)||!r(Y)||ce.length>60)return null;const me=h(ce);if(!t(me)){if(!m(me))return null;ce=ce.toLowerCase()}let Re=null,He=0;for(Y=Y.toLowerCase();He<ce.length&&(Re=u(Y,ce,0,He))===null;)He=E(ce,He+1);return Re}e.matchesCamelCase=i;function n(Y,ce,me=!1){if(!ce||ce.length===0)return null;let Re=null,He=0;for(Y=Y.toLowerCase(),ce=ce.toLowerCase();He<ce.length&&(Re=a(Y,ce,0,He,me))===null;)He=p(ce,He+1);return Re}e.matchesWords=n;function a(Y,ce,me,Re,He){if(me===Y.length)return[];if(Re===ce.length)return null;if(f(Y.charCodeAt(me),ce.charCodeAt(Re))){let be=null,Xe=Re+1;if(be=a(Y,ce,me+1,Re+1,He),!He)for(;!be&&(Xe=p(ce,Xe))<ce.length;)be=a(Y,ce,me+1,Xe,He),Xe++;return be===null?null:w({start:Re,end:Re+1},be)}else return null}function p(Y,ce){for(let me=ce;me<Y.length;me++)if(c(Y.charCodeAt(me))||me>0&&c(Y.charCodeAt(me-1)))return me;return Y.length}const d=k(e.matchesPrefix,i,A),b=k(e.matchesPrefix,i,C),S=new v.LRUCache(1e4);function o(Y,ce,me=!1){if(typeof Y!="string"||typeof ce!="string")return null;let Re=S.get(Y);Re||(Re=new RegExp(R.convertSimple2RegExpPattern(Y),"i"),S.set(Y,Re));const He=Re.exec(ce);return He?[{start:He.index,end:He.index+He[0].length}]:me?b(Y,ce):d(Y,ce)}e.matchesFuzzy=o;function L(Y,ce){const me=je(Y,Y.toLowerCase(),0,ce,ce.toLowerCase(),0,!0);return me?W(me):null}e.matchesFuzzy2=L;function O(Y,ce,me,Re,He,be){const Xe=Math.min(13,Y.length);for(;me<Xe;me++){const Q=je(Y,ce,me,Re,He,be,!1);if(Q)return Q}return[0,be]}e.anyScore=O;function W(Y){if(typeof Y=="undefined")return[];const ce=[],me=Y[1];for(let Re=Y.length-1;Re>1;Re--){const He=Y[Re]+me,be=ce[ce.length-1];be&&be.end===He?be.end=He+1:ce.push({start:He,end:He+1})}return ce}e.createMatches=W;const J=128;function oe(){const Y=[],ce=[];for(let me=0;me<=J;me++)ce[me]=0;for(let me=0;me<=J;me++)Y.push(ce.slice(0));return Y}function q(Y){const ce=[];for(let me=0;me<=Y;me++)ce[me]=0;return ce}const x=q(2*J),V=q(2*J),T=oe(),N=oe(),F=oe(),M=!1;function U(Y,ce,me,Re,He){function be(Q,re,ve=" "){for(;Q.length<re;)Q=ve+Q;return Q}let Xe=` |   |${Re.split("").map(Q=>be(Q,3)).join("|")}
`;for(let Q=0;Q<=me;Q++)Q===0?Xe+=" |":Xe+=`${ce[Q-1]}|`,Xe+=Y[Q].slice(0,He+1).map(re=>be(re.toString(),3)).join("|")+`
`;return Xe}function B(Y,ce,me,Re){Y=Y.substr(ce),me=me.substr(Re),console.log(U(N,Y,Y.length,me,me.length)),console.log(U(F,Y,Y.length,me,me.length)),console.log(U(T,Y,Y.length,me,me.length))}function K(Y,ce){if(ce<0||ce>=Y.length)return!1;const me=Y.codePointAt(ce);switch(me){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!R.isEmojiImprecise(me)}}function ie(Y,ce){if(ce<0||ce>=Y.length)return!1;switch(Y.charCodeAt(ce)){case 32:case 9:return!0;default:return!1}}function we(Y,ce,me){return ce[Y]!==me[Y]}function Te(Y,ce,me,Re,He,be,Xe=!1){for(;ce<me&&He<be;)Y[ce]===Re[He]&&(Xe&&(x[ce]=He),ce+=1),He+=1;return ce===me}e.isPatternInWord=Te;var ye;(function(Y){Y[Y.Diag=1]="Diag",Y[Y.Left=2]="Left",Y[Y.LeftLeft=3]="LeftLeft"})(ye||(ye={}));var Oe;(function(Y){Y.Default=[-100,0];function ce(me){return!me||me.length===2&&me[0]===-100&&me[1]===0}Y.isDefault=ce})(Oe=e.FuzzyScore||(e.FuzzyScore={}));function je(Y,ce,me,Re,He,be,Xe){const Q=Y.length>J?J:Y.length,re=Re.length>J?J:Re.length;if(me>=Q||be>=re||Q-me>re-be||!Te(ce,me,Q,He,be,re,!0))return;ze(Q,re,me,be,ce,He);let ve=1,Me=1,Ne=me,Ye=be;const Se=[!1];for(ve=1,Ne=me;Ne<Q;ve++,Ne++){const H=x[Ne],ee=V[Ne],ue=Ne+1<Q?V[Ne+1]:re;for(Me=H-be+1,Ye=H;Ye<ue;Me++,Ye++){let Pe=Number.MIN_SAFE_INTEGER,Ae=!1;Ye<=ee&&(Pe=qe(Y,ce,Ne,me,Re,He,Ye,re,be,T[ve-1][Me-1]===0,Se));let xe=0;Pe!==Number.MAX_SAFE_INTEGER&&(Ae=!0,xe=Pe+N[ve-1][Me-1]);const Be=Ye>H,Qe=Be?N[ve][Me-1]+(T[ve][Me-1]>0?-5:0):0,rt=Ye>H+1&&T[ve][Me-1]>0,nt=rt?N[ve][Me-2]+(T[ve][Me-2]>0?-5:0):0;if(rt&&(!Be||nt>=Qe)&&(!Ae||nt>=xe))N[ve][Me]=nt,F[ve][Me]=3,T[ve][Me]=0;else if(Be&&(!Ae||Qe>=xe))N[ve][Me]=Qe,F[ve][Me]=2,T[ve][Me]=0;else if(Ae)N[ve][Me]=xe,F[ve][Me]=1,T[ve][Me]=T[ve-1][Me-1]+1;else throw new Error("not possible")}}if(M&&B(Y,me,Re,be),!Se[0]&&!Xe)return;ve--,Me--;const _e=[N[ve][Me],be];let ke=0,le=0;for(;ve>=1;){let H=Me;do{const ee=F[ve][H];if(ee===3)H=H-2;else if(ee===2)H=H-1;else break}while(H>=1);ke>1&&ce[me+ve-1]===He[be+Me-1]&&!we(H+be-1,Re,He)&&ke+1>T[ve][H]&&(H=Me),H===Me?ke++:ke=1,le||(le=H),ve--,Me=H-1,_e.push(Me)}re===Q&&(_e[0]+=2);const fe=le-Q;return _e[0]-=fe,_e}e.fuzzyScore=je;function ze(Y,ce,me,Re,He,be){let Xe=Y-1,Q=ce-1;for(;Xe>=me&&Q>=Re;)He[Xe]===be[Q]&&(V[Xe]=Q,Xe--),Q--}function qe(Y,ce,me,Re,He,be,Xe,Q,re,ve,Me){if(ce[me]!==be[Xe])return Number.MIN_SAFE_INTEGER;let Ne=1,Ye=!1;return Xe===me-Re?Ne=Y[me]===He[Xe]?7:5:we(Xe,He,be)&&(Xe===0||!we(Xe-1,He,be))?(Ne=Y[me]===He[Xe]?7:5,Ye=!0):K(be,Xe)&&(Xe===0||!K(be,Xe-1))?Ne=5:(K(be,Xe-1)||ie(be,Xe-1))&&(Ne=5,Ye=!0),Ne>1&&me===Re&&(Me[0]=!0),Ye||(Ye=we(Xe,He,be)||K(be,Xe-1)||ie(be,Xe-1)),me===Re?Xe>re&&(Ne-=Ye?3:5):ve?Ne+=Ye?2:0:Ne+=Ye?0:1,Xe+1===Q&&(Ne-=Ye?3:5),Ne}function j(Y,ce,me,Re,He,be,Xe){return ne(Y,ce,me,Re,He,be,!0,Xe)}e.fuzzyScoreGracefulAggressive=j;function Z(Y,ce,me,Re,He,be,Xe){return ne(Y,ce,me,Re,He,be,!1,Xe)}e.fuzzyScoreGraceful=Z;function ne(Y,ce,me,Re,He,be,Xe,Q){let re=je(Y,ce,me,Re,He,be,Q);if(re&&!Xe)return re;if(Y.length>=3){const ve=Math.min(7,Y.length-1);for(let Me=me+1;Me<ve;Me++){const Ne=ae(Y,Me);if(Ne){const Ye=je(Ne,Ne.toLowerCase(),me,Re,He,be,Q);Ye&&(Ye[0]-=3,(!re||Ye[0]>re[0])&&(re=Ye))}}}return re}function ae(Y,ce){if(ce+1>=Y.length)return;const me=Y[ce],Re=Y[ce+1];if(me!==Re)return Y.slice(0,ce)+Re+me+Y.slice(ce+2)}}),define(ge[135],pe([0,1,91,94,8]),function(X,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const y=new RegExp(`\\$\\(${v.CSSIcon.iconNameExpression}(?:${v.CSSIcon.iconModifierExpression})?\\)`,"g"),A=new RegExp(`(\\\\)?${y.source}`,"g");function C(f){return f.replace(A,(_,w)=>w?_:`\\${_}`)}e.escapeIcons=C;const D=new RegExp(`\\\\${y.source}`,"g");function P(f){return f.replace(D,_=>`\\${_}`)}e.markdownEscapeEscapedIcons=P;const s=new RegExp(`(\\s)?(\\\\)?${y.source}(\\s)?`,"g");function I(f){return f.indexOf(e.iconStartMarker)===-1?f:f.replace(s,(_,w,E,u)=>E?_:w||u||"")}e.stripIcons=I;function l(f){const _=f.indexOf(e.iconStartMarker);return _===-1?{text:f}:g(f,_)}e.parseLabelWithIcons=l;function g(f,_){const w=[];let E="";function u(p){if(p){E+=p;for(const d of p)w.push(t)}}let h=-1,m="",t=0,r,i,n=_;const a=f.length;for(u(f.substr(0,_));n<a;)r=f[n],i=f[n+1],r===e.iconStartMarker[0]&&i===e.iconStartMarker[1]?(h=n,u(m),m=e.iconStartMarker,n++):r===")"&&h!==-1?(t+=n-h+1,h=-1,m=""):h!==-1?/^[a-z0-9\-]$/i.test(r)?m+=r:(u(m),h=-1,m=""):u(r),n++;return u(m),{text:E,iconOffsets:w}}function c(f,_,w=!1){const{text:E,iconOffsets:u}=_;if(!u||u.length===0)return R.matchesFuzzy(f,E,w);const h=k.ltrim(E," "),m=E.length-h.length,t=R.matchesFuzzy(f,h,w);if(t)for(const r of t){const i=u[r.start+m]+m;r.start+=i,r.end+=i}return t}e.matchesFuzzyIconAware=c}),define(ge[95],pe([0,1,135,16]),function(X,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var k;(function(l){l[l.Paragraph=0]="Paragraph",l[l.Break=1]="Break"})(k=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class y{constructor(g="",c=!1){var f,_;if(this.value=g,typeof this.value!="string")throw R.illegalArgument("value");typeof c=="boolean"?(this.isTrusted=c,this.supportThemeIcons=!1):(this.isTrusted=(f=c.isTrusted)!==null&&f!==void 0?f:void 0,this.supportThemeIcons=(_=c.supportThemeIcons)!==null&&_!==void 0?_:!1)}appendText(g,c=0){return this.value+=P(this.supportThemeIcons?v.escapeIcons(g):g).replace(/([ \t]+)/g,(f,_)=>"&nbsp;".repeat(_.length)).replace(/^>/gm,"\\>").replace(/\n/g,c===1?`\\
`:`

`),this}appendMarkdown(g){return this.value+=g,this}appendCodeblock(g,c){return this.value+="\n```",this.value+=g,this.value+=`
`,this.value+=c,this.value+="\n```\n",this}}e.MarkdownString=y;function A(l){return C(l)?!l.value:Array.isArray(l)?l.every(A):!0}e.isEmptyMarkdownString=A;function C(l){return l instanceof y?!0:l&&typeof l=="object"?typeof l.value=="string"&&(typeof l.isTrusted=="boolean"||l.isTrusted===void 0)&&(typeof l.supportThemeIcons=="boolean"||l.supportThemeIcons===void 0):!1}e.isMarkdownString=C;function D(l,g){return l===g?!0:!l||!g?!1:l.value===g.value&&l.isTrusted===g.isTrusted&&l.supportThemeIcons===g.supportThemeIcons}e.markdownStringEqual=D;function P(l){return l.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=P;function s(l){return l&&l.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=s;function I(l){const g=[],c=l.split("|").map(_=>_.trim());l=c[0];const f=c[1];if(f){const _=/height=(\d+)/.exec(f),w=/width=(\d+)/.exec(f),E=_?_[1]:"",u=w?w[1]:"",h=isFinite(parseInt(u)),m=isFinite(parseInt(E));h&&g.push(`width="${u}"`),m&&g.push(`height="${E}"`)}return{href:l,dimensions:g}}e.parseHrefAndDimensions=I}),define(ge[53],pe([0,1,22,8,2]),function(X,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function y(P){return JSON.stringify(P,C)}e.stringify=y;function A(P){let s=JSON.parse(P);return s=D(s),s}e.parse=A;function C(P,s){return s instanceof RegExp?{$mid:2,source:s.source,flags:R.regExpFlags(s)}:s}function D(P,s=0){if(!P||s>200)return P;if(typeof P=="object"){switch(P.$mid){case 1:return k.URI.revive(P);case 2:return new RegExp(P.source,P.flags)}if(P instanceof v.VSBuffer||P instanceof Uint8Array)return P;if(Array.isArray(P))for(let I=0;I<P.length;++I)P[I]=D(P[I],s+1);else for(const I in P)Object.hasOwnProperty.call(P,I)&&(P[I]=D(P[I],s+1))}return P}e.revive=D}),define(ge[10],pe([0,1,2,11]),function(X,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var k;(function(C){C.inMemory="inmemory",C.vscode="vscode",C.internal="private",C.walkThrough="walkThrough",C.walkThroughSnippet="walkThroughSnippet",C.http="http",C.https="https",C.file="file",C.mailto="mailto",C.untitled="untitled",C.data="data",C.command="command",C.vscodeRemote="vscode-remote",C.vscodeRemoteResource="vscode-remote-resource",C.userData="vscode-userdata",C.vscodeCustomEditor="vscode-custom-editor",C.vscodeNotebook="vscode-notebook",C.vscodeNotebookCell="vscode-notebook-cell",C.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",C.vscodeNotebookCellOutput="vscode-notebook-cell-output",C.vscodeSettings="vscode-settings",C.vscodeWorkspaceTrust="vscode-workspace-trust",C.vscodeTerminal="vscode-terminal",C.webviewPanel="webview-panel",C.vscodeWebview="vscode-webview",C.extension="extension",C.vscodeFileResource="vscode-file",C.tmp="tmp"})(k=e.Schemas||(e.Schemas={}));class y{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(D){this._preferredWebSchema=D}setDelegate(D){this._delegate=D}set(D,P,s){this._hosts[D]=P,this._ports[D]=s}setConnectionToken(D,P){this._connectionTokens[D]=P}rewrite(D){if(this._delegate)return this._delegate(D);const P=D.authority;let s=this._hosts[P];s&&s.indexOf(":")!==-1&&(s=`[${s}]`);const I=this._ports[P],l=this._connectionTokens[P];let g=`path=${encodeURIComponent(D.path)}`;return typeof l=="string"&&(g+=`&tkn=${encodeURIComponent(l)}`),v.URI.from({scheme:R.isWeb?this._preferredWebSchema:k.vscodeRemoteResource,authority:`${s}:${I}`,path:"/vscode-remote-resource",query:g})}}e.RemoteAuthorities=new y;class A{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(D,P,s){const I=this.toUri(D,P);return I.scheme===k.vscodeRemote?e.RemoteAuthorities.rewrite(I):R.isNative&&(s||R.isPreferringBrowserCodeLoad)&&I.scheme===k.file?I.with({scheme:k.vscodeFileResource,authority:I.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):I}asFileUri(D,P){const s=this.toUri(D,P);return s.scheme===k.vscodeFileResource?s.with({scheme:k.file,authority:s.authority!==this.FALLBACK_AUTHORITY?s.authority:null,query:null,fragment:null}):s}toUri(D,P){return v.URI.isUri(D)?D:v.URI.parse(P.toUrl(D))}}e.FileAccess=new A}),define(ge[75],pe([0,1,23]),function(X,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=e.canNormalize=void 0,e.canNormalize=typeof String.prototype.normalize=="function";const R=new v.LRUCache(1e4);function k(P){return D(P,"NFC",R)}e.normalizeNFC=k;const y=new v.LRUCache(1e4);function A(P){return D(P,"NFD",y)}e.normalizeNFD=A;const C=/[^\u0000-\u0080]/;function D(P,s,I){if(!e.canNormalize||!P)return P;const l=I.get(P);if(l)return l;let g;return C.test(P)?g=P.normalize(s):g=P,I.set(P,g),g}e.removeAccents=function(){if(e.canNormalize){const P=/[\u0300-\u036f]/g;return function(s){return A(s).replace(P,"")}}else return function(P){return P}}()}),define(ge[24],pe([0,1,29,9,2,8,10,11]),function(X,e,v,R,k,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function D(g){return k.uriToFsPath(g,!0)}e.originalFSPath=D;class P{constructor(c){this._ignorePathCasing=c}compare(c,f,_=!1){return c===f?0:y.compare(this.getComparisonKey(c,_),this.getComparisonKey(f,_))}isEqual(c,f,_=!1){return c===f?!0:!c||!f?!1:this.getComparisonKey(c,_)===this.getComparisonKey(f,_)}getComparisonKey(c,f=!1){return c.with({path:this._ignorePathCasing(c)?c.path.toLowerCase():void 0,fragment:f?null:void 0}).toString()}ignorePathCasing(c){return this._ignorePathCasing(c)}isEqualOrParent(c,f,_=!1){if(c.scheme===f.scheme){if(c.scheme===A.Schemas.file)return v.isEqualOrParent(D(c),D(f),this._ignorePathCasing(c))&&c.query===f.query&&(_||c.fragment===f.fragment);if(e.isEqualAuthority(c.authority,f.authority))return v.isEqualOrParent(c.path,f.path,this._ignorePathCasing(c),"/")&&c.query===f.query&&(_||c.fragment===f.fragment)}return!1}joinPath(c,...f){return k.URI.joinPath(c,...f)}basenameOrAuthority(c){return e.basename(c)||c.authority}basename(c){return R.posix.basename(c.path)}extname(c){return R.posix.extname(c.path)}dirname(c){if(c.path.length===0)return c;let f;return c.scheme===A.Schemas.file?f=k.URI.file(R.dirname(D(c))).path:(f=R.posix.dirname(c.path),c.authority&&f.length&&f.charCodeAt(0)!==47&&(console.error(`dirname("${c.toString})) resulted in a relative path`),f="/")),c.with({path:f})}normalizePath(c){if(!c.path.length)return c;let f;return c.scheme===A.Schemas.file?f=k.URI.file(R.normalize(D(c))).path:f=R.posix.normalize(c.path),c.with({path:f})}relativePath(c,f){if(c.scheme!==f.scheme||!e.isEqualAuthority(c.authority,f.authority))return;if(c.scheme===A.Schemas.file){const E=R.relative(D(c),D(f));return C.isWindows?v.toSlashes(E):E}let _=c.path||"/",w=f.path||"/";if(this._ignorePathCasing(c)){let E=0;for(const u=Math.min(_.length,w.length);E<u&&!(_.charCodeAt(E)!==w.charCodeAt(E)&&_.charAt(E).toLowerCase()!==w.charAt(E).toLowerCase());E++);_=w.substr(0,E)+_.substr(E)}return R.posix.relative(_,w)}resolvePath(c,f){if(c.scheme===A.Schemas.file){const _=k.URI.file(R.resolve(D(c),f));return c.with({authority:_.authority,path:_.path})}return f=v.toPosixPath(f),c.with({path:R.posix.resolve(c.path,f)})}isAbsolutePath(c){return!!c.path&&c.path[0]==="/"}isEqualAuthority(c,f){return c===f||y.equalsIgnoreCase(c,f)}hasTrailingPathSeparator(c,f=R.sep){if(c.scheme===A.Schemas.file){const _=D(c);return _.length>v.getRoot(_).length&&_[_.length-1]===f}else{const _=c.path;return _.length>1&&_.charCodeAt(_.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(c.fsPath)}}removeTrailingPathSeparator(c,f=R.sep){return e.hasTrailingPathSeparator(c,f)?c.with({path:c.path.substr(0,c.path.length-1)}):c}addTrailingPathSeparator(c,f=R.sep){let _=!1;if(c.scheme===A.Schemas.file){const w=D(c);_=w!==void 0&&w.length===v.getRoot(w).length&&w[w.length-1]===f}else{f="/";const w=c.path;_=w.length===1&&w.charCodeAt(w.length-1)===47}return!_&&!e.hasTrailingPathSeparator(c,f)?c.with({path:c.path+"/"}):c}}e.ExtUri=P,e.extUri=new P(()=>!1),e.extUriBiasedIgnorePathCase=new P(g=>g.scheme===A.Schemas.file?!C.isLinux:!0),e.extUriIgnorePathCase=new P(g=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function s(g,c){const f=[];for(let _=0;_<g.length;_++){const w=c(g[_]);g.some((E,u)=>u===_?!1:e.isEqualOrParent(w,c(E)))||f.push(g[_])}return f}e.distinctParents=s;var I;(function(g){g.META_DATA_LABEL="label",g.META_DATA_DESCRIPTION="description",g.META_DATA_SIZE="size",g.META_DATA_MIME="mime";function c(f){const _=new Map;f.path.substring(f.path.indexOf(";")+1,f.path.lastIndexOf(";")).split(";").forEach(u=>{const[h,m]=u.split(":");h&&m&&_.set(h,m)});const E=f.path.substring(0,f.path.indexOf(";"));return E&&_.set(g.META_DATA_MIME,E),_}g.parseMetaData=c})(I=e.DataUri||(e.DataUri={}));function l(g,c,f){if(c){let _=g.path;return _&&_[0]!==R.posix.sep&&(_=R.posix.sep+_),g.with({scheme:f,authority:c,path:_})}return g.with({scheme:f})}e.toLocalResource=l}),define(ge[14],pe([0,1,21,16,3,6,72,24]),function(X,e,v,R,k,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function D(N){return!!N&&typeof N.then=="function"}e.isThenable=D;function P(N){const F=new v.CancellationTokenSource,M=N(F.token),U=new Promise((B,K)=>{F.token.onCancellationRequested(()=>{K(R.canceled())}),Promise.resolve(M).then(ie=>{F.dispose(),B(ie)},ie=>{F.dispose(),K(ie)})});return new class{cancel(){F.cancel()}then(B,K){return U.then(B,K)}catch(B){return this.then(void 0,B)}finally(B){return U.finally(B)}}}e.createCancelablePromise=P;function s(N,F,M){return Promise.race([N,new Promise(U=>F.onCancellationRequested(()=>U(M)))])}e.raceCancellation=s;async function I(N){let F=-1;const M=N.map((B,K)=>B.then(ie=>(F=K,ie))),U=await Promise.race(M);return N.forEach((B,K)=>{K!==F&&B.cancel()}),U}e.raceCancellablePromises=I;function l(N,F,M){let U;const B=setTimeout(()=>{U==null||U(void 0),M==null||M()},F);return Promise.race([N.finally(()=>clearTimeout(B)),new Promise(K=>U=K)])}e.raceTimeout=l;function g(N){return new Promise((F,M)=>{const U=N();D(U)?U.then(F,M):F(U)})}e.asPromise=g;class c{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(F){if(this.activePromise){if(this.queuedPromiseFactory=F,!this.queuedPromise){const M=()=>{this.queuedPromise=null;const U=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,U};this.queuedPromise=new Promise(U=>{this.activePromise.then(M,M).then(U)})}return new Promise((M,U)=>{this.queuedPromise.then(M,U)})}return this.activePromise=F(),new Promise((M,U)=>{this.activePromise.then(B=>{this.activePromise=null,M(B)},B=>{this.activePromise=null,U(B)})})}}e.Throttler=c;class f{constructor(){this.current=Promise.resolve(null)}queue(F){return this.current=this.current.then(()=>F(),()=>F())}}e.Sequencer=f;class _{constructor(){this.promiseMap=new Map}queue(F,M){var U;const K=((U=this.promiseMap.get(F))!==null&&U!==void 0?U:Promise.resolve()).catch(()=>{}).then(M).finally(()=>{this.promiseMap.get(F)===K&&this.promiseMap.delete(F)});return this.promiseMap.set(F,K),K}}e.SequencerByKey=_;class w{constructor(F){this.defaultDelay=F,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(F,M=this.defaultDelay){return this.task=F,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((U,B)=>{this.doResolve=U,this.doReject=B}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const U=this.task;return this.task=null,U()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},M),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(R.canceled()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=w;class E{constructor(F){this.delayer=new w(F),this.throttler=new c}trigger(F,M){return this.delayer.trigger(()=>this.throttler.queue(F),M)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=E;class u{constructor(){this._isOpen=!1,this._promise=new Promise((F,M)=>{this._completePromise=F})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=u;class h extends u{constructor(F){super();this._timeout=setTimeout(()=>this.open(),F)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=h;function m(N,F){return F?new Promise((M,U)=>{const B=setTimeout(M,N);F.onCancellationRequested(()=>{clearTimeout(B),U(R.canceled())})}):P(M=>m(N,M))}e.timeout=m;function t(N,F=0){const M=setTimeout(N,F);return y.toDisposable(()=>clearTimeout(M))}e.disposableTimeout=t;function r(N){return N.then(void 0,F=>{})}e.ignoreErrors=r;function i(N){const F=[];let M=0;const U=N.length;function B(){return M<U?N[M++]():null}function K(ie){ie!=null&&F.push(ie);const we=B();return we?we.then(K):Promise.resolve(F)}return Promise.resolve(null).then(K)}e.sequence=i;function n(N,F=U=>!!U,M=null){let U=0;const B=N.length,K=()=>{if(U>=B)return Promise.resolve(M);const ie=N[U++];return Promise.resolve(ie()).then(Te=>F(Te)?Promise.resolve(Te):K())};return K()}e.first=n;function a(N,F=U=>!!U,M=null){if(N.length===0)return Promise.resolve(M);let U=N.length;const B=()=>{var K,ie;U=-1;for(const we of N)(ie=(K=we).cancel)===null||ie===void 0||ie.call(K)};return new Promise((K,ie)=>{for(const we of N)we.then(Te=>{--U>=0&&F(Te)?(B(),K(Te)):U===0&&K(M)}).catch(Te=>{--U>=0&&(B(),ie(Te))})})}e.firstParallel=a;class p{constructor(F){this._size=0,this.maxDegreeOfParalellism=F,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new k.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(F){return this._size++,new Promise((M,U)=>{this.outstandingPromises.push({factory:F,c:M,e:U}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const F=this.outstandingPromises.shift();this.runningPromises++;const M=F.factory();M.then(F.c,F.e),M.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=p;class d extends p{constructor(){super(1)}}e.Queue=d;class b{constructor(){this.queues=new Map}queueFor(F,M=C.extUri){const U=M.getComparisonKey(F);let B=this.queues.get(U);return B||(B=new d,k.Event.once(B.onFinished)(()=>{B==null||B.dispose(),this.queues.delete(U)}),this.queues.set(U,B)),B}dispose(){this.queues.forEach(F=>F.dispose()),this.queues.clear()}}e.ResourceQueue=b;class S{constructor(F,M){this._token=-1,typeof F=="function"&&typeof M=="number"&&this.setIfNotSet(F,M)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(F,M){this.cancel(),this._token=setTimeout(()=>{this._token=-1,F()},M)}setIfNotSet(F,M){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,F()},M))}}e.TimeoutTimer=S;class o{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(F,M){this.cancel(),this._token=setInterval(()=>{F()},M)}}e.IntervalTimer=o;class L{constructor(F,M){this.timeoutToken=-1,this.runner=F,this.timeout=M,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(F=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,F)}get delay(){return this.timeout}set delay(F){this.timeout=F}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=L;class O extends L{constructor(F,M){super(F,M);this.units=[]}work(F){this.units.push(F),this.isScheduled()||this.schedule()}doRun(){const F=this.units;this.units=[],this.runner&&this.runner(F)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=O,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const N=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=F=>{const M=setTimeout(()=>F(N));let U=!1;return{dispose(){U||(U=!0,clearTimeout(M))}}}}else e.runWhenIdle=(N,F)=>{const M=requestIdleCallback(N,typeof F=="number"?{timeout:F}:void 0);let U=!1;return{dispose(){U||(U=!0,cancelIdleCallback(M))}}}}();class W{constructor(F){this._didRun=!1,this._executor=()=>{try{this._value=F()}catch(M){this._error=M}finally{this._didRun=!0}},this._handle=e.runWhenIdle(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=W;async function J(N,F,M){let U;for(let B=0;B<M;B++)try{return await N()}catch(K){U=K,await m(F)}throw U}e.retry=J;class oe{hasPending(F){return this._pending?typeof F=="number"?this._pending.taskId===F:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var F;(F=this._pending)===null||F===void 0||F.cancel()}setPending(F,M,U){return this._pending={taskId:F,cancel:()=>U==null?void 0:U(),promise:M},M.then(()=>this.donePending(F),()=>this.donePending(F)),M}donePending(F){this._pending&&F===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const F=this._next;this._next=void 0,F.run().then(F.promiseResolve,F.promiseReject)}}setNext(F){if(this._next)this._next.run=F;else{let M,U;const B=new Promise((K,ie)=>{M=K,U=ie});this._next={run:F,promise:B,promiseResolve:M,promiseReject:U}}return this._next.promise}}e.TaskSequentializer=oe;class q{constructor(F){this.interval=F,this.lastIncrementTime=0,this.value=0}increment(){const F=Date.now();return F-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=F,this.value=0),this.value++,this.value}}e.IntervalCounter=q;class x{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((F,M)=>{this.completeCallback=F,this.errorCallback=M})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(F){return new Promise(M=>{this.completeCallback(F),this.resolved=!0,M()})}error(F){return new Promise(M=>{this.errorCallback(F),this.rejected=!0,M()})}cancel(){new Promise(F=>{this.errorCallback(R.canceled()),this.rejected=!0,F()})}}e.DeferredPromise=x;class V extends k.Emitter{async fireAsync(F,M,U){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new A.LinkedList);for(const B of this._listeners)this._asyncDeliveryQueue.push([B,F]);for(;this._asyncDeliveryQueue.size>0&&!M.isCancellationRequested;){const[B,K]=this._asyncDeliveryQueue.shift(),ie=[],we=Object.assign(Object.assign({},K),{waitUntil:Te=>{if(Object.isFrozen(ie))throw new Error("waitUntil can NOT be called asynchronous");U&&(Te=U(Te,typeof B=="function"?B:B[0])),ie.push(Te)}});try{typeof B=="function"?B.call(void 0,we):B[0].call(B[1],we)}catch(Te){R.onUnexpectedError(Te);continue}Object.freeze(ie),await T.settled(ie).catch(Te=>R.onUnexpectedError(Te))}}}}e.AsyncEmitter=V;var T;(function(N){async function F(K){return typeof Promise.allSettled=="function"?M(K):U(K)}N.allSettled=F;async function M(K){return Promise.allSettled(K)}async function U(K){return Promise.all(K.map(ie=>ie.then(we=>({status:"fulfilled",value:we}),we=>({status:"rejected",reason:we}))))}async function B(K){let ie;const we=await Promise.all(K.map(Te=>Te.then(ye=>ye,ye=>{ie||(ie=ye)})));if(typeof ie!="undefined")throw ie;return we}N.settled=B})(T=e.Promises||(e.Promises={}))}),define(ge[96],pe([0,1,9,14]),function(X,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const k=new R.IdleValue(()=>{const S=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:S,collatorIsNumeric:S.resolvedOptions().numeric}}),y=new R.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new R.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function C(S,o,L=!1){const O=S||"",W=o||"",J=k.value.collator.compare(O,W);return k.value.collatorIsNumeric&&J===0&&O!==W?O<W?-1:1:J}e.compareFileNames=C;function D(S,o){const L=y.value.collator;return S=S||"",o=o||"",m(L,S,o)}e.compareFileNamesDefault=D;function P(S,o){const L=y.value.collator;return S=S||"",o=o||"",n(S,o)||m(L,S,o)}e.compareFileNamesUpper=P;function s(S,o){const L=y.value.collator;return S=S||"",o=o||"",i(S,o)||m(L,S,o)}e.compareFileNamesLower=s;function I(S,o){return S=S||"",o=o||"",S===o?0:S<o?-1:1}e.compareFileNamesUnicode=I;function l(S,o,L=!1){L||(S=S&&S.toLowerCase(),o=o&&o.toLowerCase());const[O,W]=u(S),[J,oe]=u(o);return O!==J?O<J?-1:1:W===oe?0:W<oe?-1:1}e.noIntlCompareFileNames=l;function g(S,o){const[L,O]=u(S),[W,J]=u(o);let oe=k.value.collator.compare(O,J);if(oe===0){if(k.value.collatorIsNumeric&&O!==J)return O<J?-1:1;if(oe=k.value.collator.compare(L,W),k.value.collatorIsNumeric&&oe===0&&L!==W)return L<W?-1:1}return oe}e.compareFileExtensions=g;function c(S,o){S=S||"",o=o||"";const L=h(S),O=h(o),W=y.value.collator,J=A.value.collator;return m(J,L,O)||m(W,S,o)}e.compareFileExtensionsDefault=c;function f(S,o){S=S||"",o=o||"";const L=h(S),O=h(o),W=y.value.collator,J=A.value.collator;return m(J,L,O)||n(S,o)||m(W,S,o)}e.compareFileExtensionsUpper=f;function _(S,o){S=S||"",o=o||"";const L=h(S),O=h(o),W=y.value.collator,J=A.value.collator;return m(J,L,O)||i(S,o)||m(W,S,o)}e.compareFileExtensionsLower=_;function w(S,o){S=S||"",o=o||"";const L=h(S).toLowerCase(),O=h(o).toLowerCase();return L!==O?L<O?-1:1:S!==o?S<o?-1:1:0}e.compareFileExtensionsUnicode=w;const E=/^(.*?)(\.([^.]*))?$/;function u(S,o=!1){const L=S?E.exec(S):[];let O=[L&&L[1]||"",L&&L[3]||""];return o&&(!O[0]&&O[1]||O[0]&&O[0].charAt(0)===".")&&(O=[O[0]+"."+O[1],""]),O}function h(S){const o=S?E.exec(S):[];return o&&o[1]&&o[1].charAt(0)!=="."&&o[3]||""}function m(S,o,L){let O=S.compare(o,L);return O!==0?O:o.length!==L.length?o.length<L.length?-1:1:0}function t(S){const o=S.charAt(0);return o.toLocaleUpperCase()!==o}function r(S){const o=S.charAt(0);return o.toLocaleLowerCase()!==o}function i(S,o){return t(S)&&r(o)?-1:r(S)&&t(o)?1:0}function n(S,o){return r(S)&&t(o)?-1:t(S)&&r(o)?1:0}function a(S,o,L=!1){return L||(S=S&&S.toLowerCase(),o=o&&o.toLowerCase()),S===o?0:S<o?-1:1}function p(S,o,L=!1){const O=S.split(v.sep),W=o.split(v.sep),J=O.length-1,oe=W.length-1;let q,x;for(let V=0;;V++){if(q=J===V,x=oe===V,q&&x)return C(O[V],W[V],L);if(q)return-1;if(x)return 1;const T=a(O[V],W[V],L);if(T!==0)return T}}e.comparePaths=p;function d(S,o,L){const O=S.toLowerCase(),W=o.toLowerCase(),J=b(S,o,L);if(J)return J;const oe=O.endsWith(L),q=W.endsWith(L);if(oe!==q)return oe?-1:1;const x=C(O,W);return x!==0?x:O.localeCompare(W)}e.compareAnything=d;function b(S,o,L){const O=S.toLowerCase(),W=o.toLowerCase(),J=O.startsWith(L),oe=W.startsWith(L);if(J!==oe)return J?-1:1;if(J&&oe){if(O.length<W.length)return-1;if(O.length>W.length)return 1}return 0}e.compareByPrefix=b}),define(ge[97],pe([0,1,96,94,9,11,8]),function(X,e,v,R,k,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const C=0,D=[C,[]];function P(q,x,V,T){if(!q||!x)return D;const N=q.length,F=x.length;if(N<F)return D;const M=q.toLowerCase();return!T&&!M.includes(V)?D:s(x,V,F,q,M,N)}e.scoreFuzzy=P;function s(q,x,V,T,N,F){const M=[],U=[];for(let we=0;we<V;we++){const Te=we*F,ye=Te-F,Oe=we>0,je=q[we],ze=x[we];for(let qe=0;qe<F;qe++){const j=qe>0,Z=Te+qe,ne=Z-1,ae=ye+qe-1,Y=j?M[ne]:0,ce=Oe&&j?M[ae]:0,me=Oe&&j?U[ae]:0;let Re;!ce&&Oe?Re=0:Re=I(je,ze,T,N,qe,me),Re&&ce+Re>=Y?(U[Z]=me+1,M[Z]=ce+Re):(U[Z]=C,M[Z]=Y)}}const B=[];let K=V-1,ie=F-1;for(;K>=0&&ie>=0;){const we=K*F+ie;U[we]===C||(B.push(ie),K--),ie--}return[M[V*F-1],B.reverse()]}function I(q,x,V,T,N,F){let M=0;if(!l(x,T[N]))return M;if(M+=1,F>0&&(M+=F*5),q===V[N]&&(M+=1),N===0)M+=8;else{const U=g(V.charCodeAt(N-1));U?M+=U:R.isUpper(V.charCodeAt(N))&&(M+=2)}return M}function l(q,x){return q===x?!0:q==="/"||q==="\\"?x==="/"||x==="\\":!1}function g(q){switch(q){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const c=[void 0,[]];function f(q,x,V=0,T=0){const N=x;return N.values&&N.values.length>1?_(q,N.values,V,T):w(q,x,V,T)}e.scoreFuzzy2=f;function _(q,x,V,T){let N=0;const F=[];for(const M of x){const[U,B]=w(q,M,V,T);if(typeof U!="number")return c;N+=U,F.push(...B)}return[N,p(F)]}function w(q,x,V,T){const N=R.fuzzyScore(x.original,x.originalLowercase,V,q,q.toLowerCase(),T,!0);return N?[N[0],R.createMatches(N)]:c}const E=Object.freeze({score:0}),u=1<<18,h=1<<17,m=1<<16;function t(q,x,V,T,N){if(!q||!x.normalized)return E;const F=T.getItemLabel(q);if(!F)return E;const M=T.getItemDescription(q);let U;M?U=`${F}${M}${x.normalized}${Array.isArray(x.values)?x.values.length:""}${V}`:U=`${F}${x.normalized}${Array.isArray(x.values)?x.values.length:""}${V}`;const B=N[U];if(B)return B;const K=r(F,M,T.getItemPath(q),x,V);return N[U]=K,K}e.scoreItemFuzzy=t;function r(q,x,V,T,N){const F=!V||!T.containsPathSeparator;return V&&(y.isLinux?T.pathNormalized===V:A.equalsIgnoreCase(T.pathNormalized,V))?{score:u,labelMatch:[{start:0,end:q.length}],descriptionMatch:x?[{start:0,end:x.length}]:void 0}:T.values&&T.values.length>1?i(q,x,V,T.values,F,N):n(q,x,V,T,F,N)}function i(q,x,V,T,N,F){let M=0;const U=[],B=[];for(const K of T){const{score:ie,labelMatch:we,descriptionMatch:Te}=n(q,x,V,K,N,F);if(ie===C)return E;M+=ie,we&&U.push(...we),Te&&B.push(...Te)}return{score:M,labelMatch:p(U),descriptionMatch:p(B)}}function n(q,x,V,T,N,F){if(N||!x){const[M,U]=P(q,T.normalized,T.normalizedLowercase,F);if(M){const B=R.matchesPrefix(T.normalized,q);let K;return B?(K=h,K+=Math.round(T.normalized.length/q.length*100)):K=m,{score:K+M,labelMatch:B||a(U)}}}if(x){let M=x;V&&(M=`${x}${k.sep}`);const U=M.length,B=`${M}${q}`,[K,ie]=P(B,T.normalized,T.normalizedLowercase,F);if(K){const we=a(ie),Te=[],ye=[];return we.forEach(Oe=>{Oe.start<U&&Oe.end>U?(Te.push({start:0,end:Oe.end-U}),ye.push({start:Oe.start,end:U})):Oe.start>=U?Te.push({start:Oe.start-U,end:Oe.end-U}):ye.push(Oe)}),{score:K,labelMatch:Te,descriptionMatch:ye}}}return E}function a(q){const x=[];if(!q)return x;let V;for(const T of q)V&&V.end===T?V.end+=1:(V={start:T,end:T+1},x.push(V));return x}function p(q){const x=q.sort((N,F)=>N.start-F.start),V=[];let T;for(const N of x)!T||!d(T,N)?(T=N,V.push(N)):(T.start=Math.min(T.start,N.start),T.end=Math.max(T.end,N.end));return V}function d(q,x){return!(q.end<x.start||x.end<q.start)}function b(q,x,V,T,N,F){const M=t(q,V,T,N,F),U=t(x,V,T,N,F),B=M.score,K=U.score;if((B===u||K===u)&&B!==K)return B===u?-1:1;if(B>m||K>m){if(B!==K)return B>K?-1:1;if(B<h&&K<h){const ze=o(M.labelMatch,U.labelMatch);if(ze!==0)return ze}const Oe=N.getItemLabel(q)||"",je=N.getItemLabel(x)||"";if(Oe.length!==je.length)return Oe.length-je.length}if(B!==K)return B>K?-1:1;const ie=Array.isArray(M.labelMatch)&&M.labelMatch.length>0,we=Array.isArray(U.labelMatch)&&U.labelMatch.length>0;if(ie&&!we)return-1;if(we&&!ie)return 1;const Te=S(q,M,N),ye=S(x,U,N);return Te&&ye&&Te!==ye?ye>Te?-1:1:L(q,x,V,N)}e.compareItemsByFuzzyScore=b;function S(q,x,V){let T=-1,N=-1;if(x.descriptionMatch&&x.descriptionMatch.length?T=x.descriptionMatch[0].start:x.labelMatch&&x.labelMatch.length&&(T=x.labelMatch[0].start),x.labelMatch&&x.labelMatch.length){if(N=x.labelMatch[x.labelMatch.length-1].end,x.descriptionMatch&&x.descriptionMatch.length){const F=V.getItemDescription(q);F&&(N+=F.length)}}else x.descriptionMatch&&x.descriptionMatch.length&&(N=x.descriptionMatch[x.descriptionMatch.length-1].end);return N-T}function o(q,x){if(!q&&!x||(!q||!q.length)&&(!x||!x.length))return 0;if(!x||!x.length)return-1;if(!q||!q.length)return 1;const V=q[0].start,N=q[q.length-1].end-V,F=x[0].start,U=x[x.length-1].end-F;return N===U?0:U<N?1:-1}function L(q,x,V,T){const N=T.getItemLabel(q)||"",F=T.getItemLabel(x)||"",M=T.getItemDescription(q),U=T.getItemDescription(x),B=N.length+(M?M.length:0),K=F.length+(U?U.length:0);if(B!==K)return B-K;const ie=T.getItemPath(q),we=T.getItemPath(x);return ie&&we&&ie.length!==we.length?ie.length-we.length:N!==F?v.compareAnything(N,F,V.normalized):M&&U&&M!==U?v.compareAnything(M,U,V.normalized):ie&&we&&ie!==we?v.compareAnything(ie,we,V.normalized):0}const O=" ";function W(q){typeof q!="string"&&(q="");const x=q.toLowerCase(),{pathNormalized:V,normalized:T,normalizedLowercase:N}=J(q),F=V.indexOf(k.sep)>=0;let M;const U=q.split(O);if(U.length>1)for(const B of U){const{pathNormalized:K,normalized:ie,normalizedLowercase:we}=J(B);ie&&(M||(M=[]),M.push({original:B,originalLowercase:B.toLowerCase(),pathNormalized:K,normalized:ie,normalizedLowercase:we}))}return{original:q,originalLowercase:x,pathNormalized:V,normalized:T,normalizedLowercase:N,values:M,containsPathSeparator:F}}e.prepareQuery=W;function J(q){let x;y.isWindows?x=q.replace(/\//g,k.sep):x=q.replace(/\\/g,k.sep);const V=A.stripWildcards(x).replace(/\s/g,"");return{pathNormalized:x,normalized:V,normalizedLowercase:V.toLowerCase()}}function oe(q){return Array.isArray(q)?W(q.map(x=>x.original).join(O)):W(q.original)}e.pieceToQuery=oe}),define(ge[30],pe([0,1,8,29,9,23,14]),function(X,e,v,R,k,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function C(){return Object.create(null)}e.getEmptyExpression=C;const D="**",P="/",s="[/\\\\]",I="[^/\\\\]",l=/\//g;function g(M){switch(M){case 0:return"";case 1:return`${I}*?`;default:return`(?:${s}|${I}+${s}|${s}${I}+)*?`}}function c(M,U){if(!M)return[];const B=[];let K=!1,ie=!1,we="";for(const Te of M){switch(Te){case U:if(!K&&!ie){B.push(we),we="";continue}break;case"{":K=!0;break;case"}":K=!1;break;case"[":ie=!0;break;case"]":ie=!1;break}we+=Te}return we&&B.push(we),B}e.splitGlobAware=c;function f(M){if(!M)return"";let U="";const B=c(M,P);if(B.every(K=>K===D))U=".*";else{let K=!1;B.forEach((ie,we)=>{if(ie===D){K||(U+=g(2),K=!0);return}let Te=!1,ye="",Oe=!1,je="";for(const ze of ie){if(ze!=="}"&&Te){ye+=ze;continue}if(Oe&&(ze!=="]"||!je)){let qe;ze==="-"?qe=ze:(ze==="^"||ze==="!")&&!je?qe="^":ze===P?qe="":qe=v.escapeRegExpCharacters(ze),je+=qe;continue}switch(ze){case"{":Te=!0;continue;case"[":Oe=!0;continue;case"}":U+=`(?:${c(ye,",").map(Z=>f(Z)).join("|")})`,Te=!1,ye="";break;case"]":U+="["+je+"]",Oe=!1,je="";break;case"?":U+=I;continue;case"*":U+=g(1);continue;default:U+=v.escapeRegExpCharacters(ze)}}we<B.length-1&&(B[we+1]!==D||we+2<B.length)&&(U+=s),K=!1})}return U}const _=/^\*\*\/\*\.[\w\.-]+$/,w=/^\*\*\/([\w\.-]+)\/?$/,E=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,u=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,h=/^\*\*((\/[\w\.-]+)+)\/?$/,m=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new y.LRUCache(1e4),r=function(){return!1},i=function(){return null};function n(M,U){if(!M)return i;let B;typeof M!="string"?B=M.pattern:B=M,B=B.trim();const K=`${B}_${!!U.trimForExclusions}`;let ie=t.get(K);if(ie)return a(ie,M);let we;if(_.test(B)){const Te=B.substr(4);ie=function(ye,Oe){return typeof ye=="string"&&ye.endsWith(Te)?B:null}}else(we=w.exec(p(B,U)))?ie=d(we[1],B):(U.trimForExclusions?u:E).test(B)?ie=b(B,U):(we=h.exec(p(B,U)))?ie=S(we[1].substr(1),B,!0):(we=m.exec(p(B,U)))?ie=S(we[1],B,!1):ie=o(B);return t.set(K,ie),a(ie,M)}function a(M,U){return typeof U=="string"?M:function(B,K){return R.isEqualOrParent(B,U.base)?M(k.relative(U.base,B),K):null}}function p(M,U){return U.trimForExclusions&&M.endsWith("/**")?M.substr(0,M.length-2):M}function d(M,U){const B=`/${M}`,K=`\\${M}`,ie=function(Te,ye){return typeof Te!="string"?null:ye?ye===M?U:null:Te===M||Te.endsWith(B)||Te.endsWith(K)?U:null},we=[M];return ie.basenames=we,ie.patterns=[U],ie.allBasenames=we,ie}function b(M,U){const B=F(M.slice(1,-1).split(",").map(ye=>n(ye,U)).filter(ye=>ye!==i),M),K=B.length;if(!K)return i;if(K===1)return B[0];const ie=function(ye,Oe){for(let je=0,ze=B.length;je<ze;je++)if(B[je](ye,Oe))return M;return null},we=B.find(ye=>!!ye.allBasenames);we&&(ie.allBasenames=we.allBasenames);const Te=B.reduce((ye,Oe)=>Oe.allPaths?ye.concat(Oe.allPaths):ye,[]);return Te.length&&(ie.allPaths=Te),ie}function S(M,U,B){const K=k.sep===k.posix.sep,ie=K?M:M.replace(l,k.sep),we=k.sep+ie,Te=k.posix.sep+M,ye=B?function(Oe,je){return typeof Oe=="string"&&(Oe===ie||Oe.endsWith(we)||!K&&(Oe===M||Oe.endsWith(Te)))?U:null}:function(Oe,je){return typeof Oe=="string"&&(Oe===ie||!K&&Oe===M)?U:null};return ye.allPaths=[(B?"*/":"./")+M],ye}function o(M){try{const U=new RegExp(`^${f(M)}$`);return function(B){return U.lastIndex=0,typeof B=="string"&&U.test(B)?M:null}}catch(U){return i}}function L(M,U,B){return!M||typeof U!="string"?!1:O(M)(U,void 0,B)}e.match=L;function O(M,U={}){if(!M)return r;if(typeof M=="string"||q(M)){const B=n(M,U);if(B===i)return r;const K=function(ie,we){return!!B(ie,we)};return B.allBasenames&&(K.allBasenames=B.allBasenames),B.allPaths&&(K.allPaths=B.allPaths),K}return T(M,U)}e.parse=O;function W(M){if(!M)return;let U;return B=>(U||(U=(M()||Promise.resolve([])).then(K=>K?oe(K):{})),U.then(K=>!!K[B]))}e.hasSiblingPromiseFn=W;function J(M){if(!M)return;let U;return B=>{if(!U){const K=M();U=K?oe(K):{}}return!!U[B]}}e.hasSiblingFn=J;function oe(M){const U={};for(const B of M)U[B]=!0;return U}function q(M){const U=M;return U&&typeof U.base=="string"&&typeof U.pattern=="string"}e.isRelativePattern=q;function x(M){return M.allBasenames||[]}e.getBasenameTerms=x;function V(M){return M.allPaths||[]}e.getPathTerms=V;function T(M,U){const B=F(Object.getOwnPropertyNames(M).map(ye=>N(ye,M[ye],U)).filter(ye=>ye!==i)),K=B.length;if(!K)return i;if(!B.some(ye=>!!ye.requiresSiblings)){if(K===1)return B[0];const ye=function(ze,qe){for(let j=0,Z=B.length;j<Z;j++){const ne=B[j](ze,qe);if(ne)return ne}return null},Oe=B.find(ze=>!!ze.allBasenames);Oe&&(ye.allBasenames=Oe.allBasenames);const je=B.reduce((ze,qe)=>qe.allPaths?ze.concat(qe.allPaths):ze,[]);return je.length&&(ye.allPaths=je),ye}const ie=function(ye,Oe,je){let ze;for(let qe=0,j=B.length;qe<j;qe++){const Z=B[qe];Z.requiresSiblings&&je&&(Oe||(Oe=k.basename(ye)),ze||(ze=Oe.substr(0,Oe.length-k.extname(ye).length)));const ne=Z(ye,Oe,ze,je);if(ne)return ne}return null},we=B.find(ye=>!!ye.allBasenames);we&&(ie.allBasenames=we.allBasenames);const Te=B.reduce((ye,Oe)=>Oe.allPaths?ye.concat(Oe.allPaths):ye,[]);return Te.length&&(ie.allPaths=Te),ie}function N(M,U,B){if(U===!1)return i;const K=n(M,B);if(K===i)return i;if(typeof U=="boolean")return K;if(U){const ie=U.when;if(typeof ie=="string"){const we=(Te,ye,Oe,je)=>{if(!je||!K(Te,ye))return null;const ze=ie.replace("$(basename)",Oe),qe=je(ze);return A.isThenable(qe)?qe.then(j=>j?M:null):qe?M:null};return we.requiresSiblings=!0,we}}return K}function F(M,U){const B=M.filter(ye=>!!ye.basenames);if(B.length<2)return M;const K=B.reduce((ye,Oe)=>{const je=Oe.basenames;return je?ye.concat(je):ye},[]);let ie;if(U){ie=[];for(let ye=0,Oe=K.length;ye<Oe;ye++)ie.push(U)}else ie=B.reduce((ye,Oe)=>{const je=Oe.patterns;return je?ye.concat(je):ye},[]);const we=function(ye,Oe){if(typeof ye!="string")return null;if(!Oe){let ze;for(ze=ye.length;ze>0;ze--){const qe=ye.charCodeAt(ze-1);if(qe===47||qe===92)break}Oe=ye.substr(ze)}const je=K.indexOf(Oe);return je!==-1?ie[je]:null};we.basenames=K,we.patterns=ie,we.allBasenames=K;const Te=M.filter(ye=>!ye.basenames);return Te.push(we),Te}}),define(ge[76],pe([0,1,2,9,8,10,11,24,29]),function(X,e,v,R,k,y,A,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function P(n,a,p){if(typeof n=="string"&&(n=v.URI.file(n)),p){const b=p.getWorkspaceFolder(n);if(b){const S=p.getWorkspace().folders.length>1;let o;if(C.isEqual(b.uri,n)?o="":o=C.relativePath(b.uri,n),S){const L=b.name?b.name:C.basename(b.uri);o=o?L+" \u2022 "+o:L}return o}}if(n.scheme!==y.Schemas.file&&n.scheme!==y.Schemas.untitled)return n.with({query:null,fragment:null}).toString(!0);if(D.hasDriveLetter(n.fsPath))return R.normalize(I(n.fsPath));let d=R.normalize(n.fsPath);return!A.isWindows&&(a==null?void 0:a.userHome)&&(d=g(d,a.userHome.fsPath)),d}e.getPathLabel=P;function s(n){if(!n)return;typeof n=="string"&&(n=v.URI.file(n));const a=C.basename(n)||(n.scheme===y.Schemas.file?n.fsPath:n.path);return A.isWindows&&D.isRootOrDriveLetter(a)?I(a):a}e.getBaseLabel=s;function I(n){return D.hasDriveLetter(n)?n.charAt(0).toUpperCase()+n.slice(1):n}e.normalizeDriveLetter=I;let l=Object.create(null);function g(n,a){if(A.isWindows||!n||!a)return n;let p=l.original===a?l.normalized:void 0;return p||(p=`${k.rtrim(a,R.posix.sep)}${R.posix.sep}`,l={original:a,normalized:p}),(A.isLinux?n.startsWith(p):k.startsWithIgnoreCase(n,p))&&(n=`~/${n.substr(p.length)}`),n}e.tildify=g;function c(n,a){return n.replace(/^~($|\/|\\)/,`${a}$1`)}e.untildify=c;const f="\u2026",_="\\\\",w="~";function E(n,a=R.sep){const p=new Array(n.length);let d=!1;for(let b=0;b<n.length;b++){let S=n[b];if(S===""){p[b]=`.${a}`;continue}if(!S){p[b]=S;continue}d=!0;let o="";S.indexOf(_)===0?(o=S.substr(0,S.indexOf(_)+_.length),S=S.substr(S.indexOf(_)+_.length)):S.indexOf(a)===0?(o=S.substr(0,S.indexOf(a)+a.length),S=S.substr(S.indexOf(a)+a.length)):S.indexOf(w)===0&&(o=S.substr(0,S.indexOf(w)+w.length),S=S.substr(S.indexOf(w)+w.length));const L=S.split(a);for(let O=1;d&&O<=L.length;O++)for(let W=L.length-O;d&&W>=0;W--){d=!1;let J=L.slice(W,W+O).join(a);for(let oe=0;!d&&oe<n.length;oe++)if(oe!==b&&n[oe]&&n[oe].indexOf(J)>-1){const q=W+O===L.length,x=W>0&&n[oe].indexOf(a)>-1?a+J:J,V=n[oe].endsWith(x);d=!q||V}if(!d){let oe="";(L[0].endsWith(":")||o!=="")&&(W===1&&(W=0,O++,J=L[0]+a+J),W>0&&(oe=L[0]+a),oe=o+oe),W>0&&(oe=oe+f+a),oe=oe+J,W+O<L.length&&(oe=oe+a+f),p[b]=oe}}d&&(p[b]=S)}return p}e.shorten=E;var u;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(u||(u={}));function h(n,a=Object.create(null)){const p=[];let d=!1,b="";for(const S of n)if(S==="$"||d&&S==="{")b&&p.push({value:b,type:u.TEXT}),b="",d=!0;else if(S==="}"&&d){const o=a[b];if(typeof o=="string")o.length&&p.push({value:o,type:u.VARIABLE});else if(o){const L=p[p.length-1];(!L||L.type!==u.SEPARATOR)&&p.push({value:o.label,type:u.SEPARATOR})}b="",d=!1}else b+=S;return b&&!d&&p.push({value:b,type:u.TEXT}),p.filter((S,o)=>{if(S.type===u.SEPARATOR){const L=p[o-1],O=p[o+1];return[L,O].every(W=>W&&(W.type===u.VARIABLE||W.type===u.TEXT)&&W.value.length>0)}return!0}).map(S=>S.value).join("")}e.template=h;function m(n,a){return A.isMacintosh||a?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,A.isMacintosh?"&":"&&"):n.replace(/&&|&/g,p=>p==="&"?"&&":"&")}e.mnemonicMenuLabel=m;function t(n,a){return A.isMacintosh||a?n.replace(/\(&&\w\)|&&/g,""):A.isWindows?n.replace(/&&|&/g,p=>p==="&"?"&&":"&"):n.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function r(n){return n.replace(/&/g,"&&")}e.unmnemonicLabel=r;function i(n){const a=n.indexOf("/")!==-1?R.posix:R.win32,p=a.basename(n),d=a.dirname(n);return p.length?{name:p,parentPath:d}:{name:d,parentPath:""}}e.splitName=i}),define(ge[136],pe([0,1,9,8,30,10,24]),function(X,e,v,R,k,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.MIME_UNKNOWN=e.MIME_BINARY=e.MIME_TEXT=void 0,e.MIME_TEXT="text/plain",e.MIME_BINARY="application/octet-stream",e.MIME_UNKNOWN="application/unknown";let C=[],D=[],P=[];function s(t,r=!1){const i=I(t);C.push(i),i.userConfigured?P.push(i):D.push(i),r&&!i.userConfigured&&C.forEach(n=>{n.mime===i.mime||n.userConfigured||(i.extension&&n.extension===i.extension&&console.warn(`Overwriting extension <<${i.extension}>> to now point to mime <<${i.mime}>>`),i.filename&&n.filename===i.filename&&console.warn(`Overwriting filename <<${i.filename}>> to now point to mime <<${i.mime}>>`),i.filepattern&&n.filepattern===i.filepattern&&console.warn(`Overwriting filepattern <<${i.filepattern}>> to now point to mime <<${i.mime}>>`),i.firstline&&n.firstline===i.firstline&&console.warn(`Overwriting firstline <<${i.firstline}>> to now point to mime <<${i.mime}>>`))})}e.registerTextMime=s;function I(t){return{id:t.id,mime:t.mime,filename:t.filename,extension:t.extension,filepattern:t.filepattern,firstline:t.firstline,userConfigured:t.userConfigured,filenameLowercase:t.filename?t.filename.toLowerCase():void 0,extensionLowercase:t.extension?t.extension.toLowerCase():void 0,filepatternLowercase:t.filepattern?t.filepattern.toLowerCase():void 0,filepatternOnPath:t.filepattern?t.filepattern.indexOf(v.posix.sep)>=0:!1}}function l(t){t?(C=C.filter(r=>!r.userConfigured),P=[]):(C=[],D=[],P=[])}e.clearTextMimes=l;function g(t,r){let i;if(t)switch(t.scheme){case y.Schemas.file:i=t.fsPath;break;case y.Schemas.data:i=A.DataUri.parseMetaData(t).get(A.DataUri.META_DATA_LABEL);break;default:i=t.path}if(!i)return[e.MIME_UNKNOWN];i=i.toLowerCase();const n=v.basename(i),a=c(i,n,P);if(a)return[a,e.MIME_TEXT];const p=c(i,n,D);if(p)return[p,e.MIME_TEXT];if(r){const d=f(r);if(d)return[d,e.MIME_TEXT]}return[e.MIME_UNKNOWN]}e.guessMimeTypes=g;function c(t,r,i){let n=null,a=null,p=null;for(let d=i.length-1;d>=0;d--){const b=i[d];if(r===b.filenameLowercase){n=b;break}if(b.filepattern&&(!a||b.filepattern.length>a.filepattern.length)){const S=b.filepatternOnPath?t:r;k.match(b.filepatternLowercase,S)&&(a=b)}b.extension&&(!p||b.extension.length>p.extension.length)&&r.endsWith(b.extensionLowercase)&&(p=b)}return n?n.mime:a?a.mime:p?p.mime:null}function f(t){if(R.startsWithUTF8BOM(t)&&(t=t.substr(1)),t.length>0)for(let r=C.length-1;r>=0;r--){const i=C[r];if(!i.firstline)continue;const n=t.match(i.firstline);if(n&&n.length>0)return i.mime}return null}function _(t){return t?typeof t=="string"?t===e.MIME_BINARY||t===e.MIME_TEXT||t===e.MIME_UNKNOWN:t.length===1&&_(t[0]):!0}e.isUnspecific=_;const w={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function E(t){const r=v.extname(t);return w[r.toLowerCase()]}e.getMediaMime=E;function u(t){for(const r in w)if(w[r]===t)return r}e.getExtensionForMimeType=u;const h=/^(.+)\/(.+?)(;.+)?$/;function m(t,r){var i;const n=h.exec(t);return n?`${n[1].toLowerCase()}/${n[2].toLowerCase()}${(i=n[3])!==null&&i!==void 0?i:""}`:r?void 0:t}e.normalizeMimeType=m}),define(ge[98],pe([0,1,2]),function(X,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function R(s){return s.toJSON()}class k{constructor(I){this._uriTransformer=I}transformIncoming(I){const l=this._uriTransformer.transformIncoming(I);return l===I?I:R(v.URI.from(l))}transformOutgoing(I){const l=this._uriTransformer.transformOutgoing(I);return l===I?I:R(v.URI.from(l))}transformOutgoingURI(I){const l=this._uriTransformer.transformOutgoing(I);return l===I?I:v.URI.from(l)}transformOutgoingScheme(I){return this._uriTransformer.transformOutgoingScheme(I)}}e.URITransformer=k,e.DefaultURITransformer=new class{transformIncoming(s){return s}transformOutgoing(s){return s}transformOutgoingURI(s){return s}transformOutgoingScheme(s){return s}};function y(s,I,l){if(!s||l>200)return null;if(typeof s=="object"){if(s instanceof v.URI)return I.transformOutgoing(s);for(let g in s)if(Object.hasOwnProperty.call(s,g)){const c=y(s[g],I,l+1);c!==null&&(s[g]=c)}}return null}function A(s,I){const l=y(s,I,0);return l===null?s:l}e.transformOutgoingURIs=A;function C(s,I,l,g){if(!s||g>200)return null;if(typeof s=="object"){if(s.$mid===1)return l?v.URI.revive(I.transformIncoming(s)):I.transformIncoming(s);for(let c in s)if(Object.hasOwnProperty.call(s,c)){const f=C(s[c],I,l,g+1);f!==null&&(s[c]=f)}}return null}function D(s,I){const l=C(s,I,!1,0);return l===null?s:l}e.transformIncomingURIs=D;function P(s,I){const l=C(s,I,!0,0);return l===null?s:l}e.transformAndReviveIncomingURIs=P}),define(ge[32],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const v=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(D){return v.test(D)}e.isUUID=R;const k=new Uint8Array(16),y=[];for(let D=0;D<256;D++)y.push(D.toString(16).padStart(2,"0"));let A;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?A=crypto.getRandomValues.bind(crypto):A=function(D){for(let P=0;P<D.length;P++)D[P]=Math.floor(Math.random()*256);return D};function C(){A(k),k[6]=k[6]&15|64,k[8]=k[8]&63|128;let D=0,P="";return P+=y[k[D++]],P+=y[k[D++]],P+=y[k[D++]],P+=y[k[D++]],P+="-",P+=y[k[D++]],P+=y[k[D++]],P+="-",P+=y[k[D++]],P+=y[k[D++]],P+="-",P+=y[k[D++]],P+=y[k[D++]],P+="-",P+=y[k[D++]],P+=y[k[D++]],P+=y[k[D++]],P+=y[k[D++]],P+=y[k[D++]],P+=y[k[D++]],P}e.generateUuid=C}),define(ge[137],pe([0,1,99]),function(X,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class R{constructor(y="utf8"){this.stringDecoder=new v.StringDecoder(y),this.remaining=null}write(y){const A=[],C=this.remaining?this.remaining+this.stringDecoder.write(y):this.stringDecoder.write(y);if(C.length<1)return A;let D=0,P,s=D;for(;s<C.length;)if(P=C.charCodeAt(s),P===13||P===10){if(A.push(C.substring(D,s)),s++,s<C.length){const I=P;P=C.charCodeAt(s),(I===13&&P===10||I===10&&P===13)&&s++}D=s}else s++;return this.remaining=D<C.length?C.substr(D):null,A}end(){return this.remaining}}e.LineDecoder=R}),define(ge[28],pe([0,1,54,100,272,9,14,11,29,32,75,24,2]),function(X,e,v,R,k,y,A,C,D,P,s,I,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.exists=e.copy=e.move=e.writeFileSync=e.writeFile=e.SymlinkSupport=e.whenDeleted=e.readDirsInDir=e.readdirSync=e.readdir=e.rimrafSync=e.rimraf=e.RimRafMode=void 0;var g;(function(T){T[T.UNLINK=0]="UNLINK",T[T.MOVE=1]="MOVE"})(g=e.RimRafMode||(e.RimRafMode={}));async function c(T,N=g.UNLINK){if(D.isRootOrDriveLetter(T))throw new Error("rimraf - will refuse to recursively delete root");return N===g.UNLINK?_(T):f(T)}e.rimraf=c;async function f(T){try{const N=y.join(R.tmpdir(),P.generateUuid());try{await V.rename(T,N)}catch(F){return _(T)}_(N).catch(F=>{})}catch(N){if(N.code!=="ENOENT")throw N}}async function _(T){return V.rmdir(T,{recursive:!0,maxRetries:3})}function w(T){if(D.isRootOrDriveLetter(T))throw new Error("rimraf - will refuse to recursively delete root");v.rmdirSync(T,{recursive:!0})}e.rimrafSync=w;async function E(T,N){return m(await(N?u(T):V.readdir(T)))}e.readdir=E;async function u(T){try{return await V.readdir(T,{withFileTypes:!0})}catch(M){console.warn("[node.js fs] readdir with filetypes failed with error: ",M)}const N=[],F=await E(T);for(const M of F){let U=!1,B=!1,K=!1;try{const ie=await V.lstat(y.join(T,M));U=ie.isFile(),B=ie.isDirectory(),K=ie.isSymbolicLink()}catch(ie){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ie)}N.push({name:M,isFile:()=>U,isDirectory:()=>B,isSymbolicLink:()=>K})}return N}function h(T){return m(v.readdirSync(T))}e.readdirSync=h;function m(T){return T.map(N=>typeof N=="string"?C.isMacintosh?s.normalizeNFC(N):N:(N.name=C.isMacintosh?s.normalizeNFC(N.name):N.name,N))}async function t(T){const N=await E(T),F=[];for(const M of N)await i.existsDirectory(y.join(T,M))&&F.push(M);return F}e.readDirsInDir=t;function r(T,N=1e3){return new Promise(F=>{let M=!1;const U=setInterval(()=>{M||(M=!0,v.access(T,B=>{M=!1,B&&(clearInterval(U),F(void 0))}))},N)})}e.whenDeleted=r;var i;(function(T){async function N(U){let B;try{if(B=await V.lstat(U),!B.isSymbolicLink())return{stat:B}}catch(K){}try{return{stat:await V.stat(U),symbolicLink:(B==null?void 0:B.isSymbolicLink())?{dangling:!1}:void 0}}catch(K){if(K.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};if(C.isWindows&&K.code==="EACCES")try{return{stat:await V.stat(await V.readlink(U)),symbolicLink:{dangling:!1}}}catch(ie){if(ie.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};throw ie}throw K}}T.stat=N;async function F(U){try{const{stat:B,symbolicLink:K}=await T.stat(U);return B.isFile()&&(K==null?void 0:K.dangling)!==!0}catch(B){}return!1}T.existsFile=F;async function M(U){try{const{stat:B,symbolicLink:K}=await T.stat(U);return B.isDirectory()&&(K==null?void 0:K.dangling)!==!0}catch(B){}return!1}T.existsDirectory=M})(i=e.SymlinkSupport||(e.SymlinkSupport={}));const n=new A.ResourceQueue;function a(T,N,F){return n.queueFor(l.URI.file(T),I.extUriBiasedIgnorePathCase).queue(()=>{const M=S(F);return new Promise((U,B)=>d(T,N,M,K=>K?B(K):U()))})}e.writeFile=a;let p=!0;function d(T,N,F,M){if(!p)return v.writeFile(T,N,{mode:F.mode,flag:F.flag},M);v.open(T,F.flag,F.mode,(U,B)=>{if(U)return M(U);v.writeFile(B,N,K=>{if(K)return v.close(B,()=>M(K));v.fdatasync(B,ie=>(ie&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ie),p=!1),v.close(B,we=>M(we))))})})}function b(T,N,F){const M=S(F);if(!p)return v.writeFileSync(T,N,{mode:M.mode,flag:M.flag});const U=v.openSync(T,M.flag,M.mode);try{v.writeFileSync(U,N);try{v.fdatasyncSync(U)}catch(B){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",B),p=!1}}finally{v.closeSync(U)}}e.writeFileSync=b;function S(T){return T?{mode:typeof T.mode=="number"?T.mode:438,flag:typeof T.flag=="string"?T.flag:"w"}:{mode:438,flag:"w"}}async function o(T,N){if(T===N)return;async function F(M){try{const U=await V.lstat(M);if(U.isDirectory()||U.isSymbolicLink())return;await V.utimes(M,U.atime,new Date)}catch(U){}}try{await V.rename(T,N),await F(N)}catch(M){if(T.toLowerCase()!==N.toLowerCase()&&M.code==="EXDEV"||T.endsWith("."))await L(T,N,{preserveSymlinks:!1}),await c(T,g.MOVE),await F(N);else throw M}}e.move=o;async function L(T,N,F){return W(T,N,{root:{source:T,target:N},options:F,handledSourcePaths:new Set})}e.copy=L;const O=511;async function W(T,N,F){if(F.handledSourcePaths.has(T))return;F.handledSourcePaths.add(T);const{stat:M,symbolicLink:U}=await i.stat(T);if(U){if(F.options.preserveSymlinks)try{return await q(T,N,F)}catch(B){console.warn("[node.js fs] copy of symlink failed: ",B)}if(U.dangling)return}return M.isDirectory()?J(T,N,M.mode&O,F):oe(T,N,M.mode&O)}async function J(T,N,F,M){await V.mkdir(N,{recursive:!0,mode:F});const U=await E(T);for(const B of U)await W(y.join(T,B),y.join(N,B),M)}async function oe(T,N,F){await V.copyFile(T,N),await V.chmod(N,F)}async function q(T,N,F){let M=await V.readlink(T);D.isEqualOrParent(M,F.root.source,!C.isLinux)&&(M=y.join(F.root.target,M.substr(F.root.source.length+1))),await V.symlink(M,N)}async function x(T){try{return await V.access(T),!0}catch(N){return!1}}e.exists=x;var V;(function(T){T.access=k.promisify(v.access),T.stat=k.promisify(v.stat),T.lstat=k.promisify(v.lstat),T.utimes=k.promisify(v.utimes),T.read=k.promisify(v.read),T.readFile=k.promisify(v.readFile),T.write=k.promisify(v.write),T.writeFile=k.promisify(v.writeFile),T.appendFile=k.promisify(v.appendFile),T.fdatasync=k.promisify(v.fdatasync),T.truncate=k.promisify(v.truncate),T.rename=k.promisify(v.rename),T.copyFile=k.promisify(v.copyFile),T.open=k.promisify(v.open),T.close=k.promisify(v.close),T.symlink=k.promisify(v.symlink),T.readlink=k.promisify(v.readlink),T.chmod=k.promisify(v.chmod),T.readdir=k.promisify(v.readdir),T.mkdir=k.promisify(v.mkdir),T.unlink=k.promisify(v.unlink),T.rmdir=k.promisify(v.rmdir),T.realpath=k.promisify(v.realpath)})(V=e.Promises||(e.Promises={}))}),define(ge[101],pe([0,1,54,8,9,28]),function(X,e,v,R,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function A(s){const I=k.dirname(s);if(s===I)return s;const l=(k.basename(s)||s).toLowerCase();try{const c=y.readdirSync(I).filter(f=>f.toLowerCase()===l);if(c.length===1){const f=A(I);if(f)return k.join(f,c[0])}else if(c.length>1){const f=c.indexOf(l);if(f>=0){const _=A(I);if(_)return k.join(_,c[f])}}}catch(g){}return null}e.realcaseSync=A;async function C(s){try{return await y.Promises.realpath(s)}catch(I){const l=P(s);return await y.Promises.access(l,v.constants.R_OK),l}}e.realpath=C;function D(s){try{return v.realpathSync(s)}catch(I){const l=P(s);return v.accessSync(l,v.constants.R_OK),l}}e.realpathSync=D;function P(s){return R.rtrim(k.normalize(s),k.sep)}});var Ve=this&&this.__decorate||function(X,e,v,R){var k=arguments.length,y=k<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,v):R,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")y=Reflect.decorate(X,e,v,R);else for(var C=X.length-1;C>=0;C--)(A=X[C])&&(y=(k<3?A(y):k>3?A(e,v,y):A(e,v))||y);return k>3&&y&&Object.defineProperty(e,v,y),y};define(ge[102],pe([0,1,3,6,14,21,16,22,17,13,53,8,50]),function(X,e,v,R,k,y,A,C,D,P,s,I,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var g;(function(F){F[F.Promise=100]="Promise",F[F.PromiseCancel=101]="PromiseCancel",F[F.EventListen=102]="EventListen",F[F.EventDispose=103]="EventDispose"})(g=e.RequestType||(e.RequestType={}));function c(F){switch(F){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var f;(function(F){F[F.Initialize=200]="Initialize",F[F.PromiseSuccess=201]="PromiseSuccess",F[F.PromiseError=202]="PromiseError",F[F.PromiseErrorObj=203]="PromiseErrorObj",F[F.EventFire=204]="EventFire"})(f=e.ResponseType||(e.ResponseType={}));function _(F){switch(F){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var w;(function(F){F[F.Uninitialized=0]="Uninitialized",F[F.Idle=1]="Idle"})(w||(w={}));class E{constructor(M){this.buffer=M,this.pos=0}read(M){const U=this.buffer.slice(this.pos,this.pos+M);return this.pos+=U.byteLength,U}}class u{constructor(){this.buffers=[]}get buffer(){return C.VSBuffer.concat(this.buffers)}write(M){this.buffers.push(M)}}var h;(function(F){F[F.Undefined=0]="Undefined",F[F.String=1]="String",F[F.Buffer=2]="Buffer",F[F.VSBuffer=3]="VSBuffer",F[F.Array=4]="Array",F[F.Object=5]="Object"})(h||(h={}));function m(F){const M=C.VSBuffer.alloc(4);return M.writeUInt32BE(F,0),M}function t(F){return F.read(4).readUInt32BE(0)}function r(F){const M=C.VSBuffer.alloc(1);return M.writeUInt8(F,0),M}const i={Undefined:r(h.Undefined),String:r(h.String),Buffer:r(h.Buffer),VSBuffer:r(h.VSBuffer),Array:r(h.Array),Object:r(h.Object)},n=typeof Buffer!="undefined";function a(F,M){if(typeof M=="undefined")F.write(i.Undefined);else if(typeof M=="string"){const U=C.VSBuffer.fromString(M);F.write(i.String),F.write(m(U.byteLength)),F.write(U)}else if(n&&Buffer.isBuffer(M)){const U=C.VSBuffer.wrap(M);F.write(i.Buffer),F.write(m(U.byteLength)),F.write(U)}else if(M instanceof C.VSBuffer)F.write(i.VSBuffer),F.write(m(M.byteLength)),F.write(M);else if(Array.isArray(M)){F.write(i.Array),F.write(m(M.length));for(const U of M)a(F,U)}else{const U=C.VSBuffer.fromString(JSON.stringify(M));F.write(i.Object),F.write(m(U.byteLength)),F.write(U)}}function p(F){switch(F.read(1).readUInt8(0)){case h.Undefined:return;case h.String:return F.read(t(F)).toString();case h.Buffer:return F.read(t(F)).buffer;case h.VSBuffer:return F.read(t(F));case h.Array:{const U=t(F),B=[];for(let K=0;K<U;K++)B.push(p(F));return B}case h.Object:return JSON.parse(F.read(t(F)).toString())}}class d{constructor(M,U,B=null,K=1e3){this.protocol=M,this.ctx=U,this.logger=B,this.timeoutDelay=K,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(ie=>this.onRawMessage(ie)),this.sendResponse({type:200})}registerChannel(M,U){this.channels.set(M,U),setTimeout(()=>this.flushPendingRequests(M),0)}sendResponse(M){switch(M.type){case 200:{const U=this.send([M.type]);this.logger&&this.logger.logOutgoing(U,0,1,_(M.type));return}case 201:case 202:case 204:case 203:{const U=this.send([M.type,M.id],M.data);this.logger&&this.logger.logOutgoing(U,M.id,1,_(M.type),M.data);return}}}send(M,U=void 0){const B=new u;return a(B,M),a(B,U),this.sendBuffer(B.buffer)}sendBuffer(M){try{return this.protocol.send(M),M.byteLength}catch(U){return 0}}onRawMessage(M){const U=new E(M),B=p(U),K=p(U),ie=B[0];switch(ie){case 100:return this.logger&&this.logger.logIncoming(M.byteLength,B[1],1,`${c(ie)}: ${B[2]}.${B[3]}`,K),this.onPromise({type:ie,id:B[1],channelName:B[2],name:B[3],arg:K});case 102:return this.logger&&this.logger.logIncoming(M.byteLength,B[1],1,`${c(ie)}: ${B[2]}.${B[3]}`,K),this.onEventListen({type:ie,id:B[1],channelName:B[2],name:B[3],arg:K});case 101:return this.logger&&this.logger.logIncoming(M.byteLength,B[1],1,`${c(ie)}`),this.disposeActiveRequest({type:ie,id:B[1]});case 103:return this.logger&&this.logger.logIncoming(M.byteLength,B[1],1,`${c(ie)}`),this.disposeActiveRequest({type:ie,id:B[1]})}}onPromise(M){const U=this.channels.get(M.channelName);if(!U){this.collectPendingRequest(M);return}const B=new y.CancellationTokenSource;let K;try{K=U.call(this.ctx,M.name,M.arg,B.token)}catch(Te){K=Promise.reject(Te)}const ie=M.id;K.then(Te=>{this.sendResponse({id:ie,data:Te,type:201}),this.activeRequests.delete(M.id)},Te=>{Te instanceof Error?this.sendResponse({id:ie,data:{message:Te.message,name:Te.name,stack:Te.stack?Te.stack.split?Te.stack.split(`
`):Te.stack:void 0},type:202}):this.sendResponse({id:ie,data:Te,type:203}),this.activeRequests.delete(M.id)});const we=R.toDisposable(()=>B.cancel());this.activeRequests.set(M.id,we)}onEventListen(M){const U=this.channels.get(M.channelName);if(!U){this.collectPendingRequest(M);return}const B=M.id,ie=U.listen(this.ctx,M.name,M.arg)(we=>this.sendResponse({id:B,data:we,type:204}));this.activeRequests.set(M.id,ie)}disposeActiveRequest(M){const U=this.activeRequests.get(M.id);U&&(U.dispose(),this.activeRequests.delete(M.id))}collectPendingRequest(M){let U=this.pendingRequests.get(M.channelName);U||(U=[],this.pendingRequests.set(M.channelName,U));const B=setTimeout(()=>{console.error(`Unknown channel: ${M.channelName}`),M.type===100&&this.sendResponse({id:M.id,data:{name:"Unknown channel",message:`Channel name '${M.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);U.push({request:M,timeoutTimer:B})}flushPendingRequests(M){const U=this.pendingRequests.get(M);if(U){for(const B of U)switch(clearTimeout(B.timeoutTimer),B.request.type){case 100:this.onPromise(B.request);break;case 102:this.onEventListen(B.request);break}this.pendingRequests.delete(M)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(M=>M.dispose()),this.activeRequests.clear()}}e.ChannelServer=d;var b;(function(F){F[F.LocalSide=0]="LocalSide",F[F.OtherSide=1]="OtherSide"})(b=e.RequestInitiator||(e.RequestInitiator={}));class S{constructor(M,U=null){this.protocol=M,this.isDisposed=!1,this.state=w.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new v.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(B=>this.onBuffer(B)),this.logger=U}getChannel(M){const U=this;return{call(B,K,ie){return U.isDisposed?Promise.reject(A.canceled()):U.requestPromise(M,B,K,ie)},listen(B,K){return U.isDisposed?Promise.reject(A.canceled()):U.requestEvent(M,B,K)}}}requestPromise(M,U,B,K=y.CancellationToken.None){const ie=this.lastRequestId++,Te={id:ie,type:100,channelName:M,name:U,arg:B};if(K.isCancellationRequested)return Promise.reject(A.canceled());let ye;return new Promise((je,ze)=>{if(K.isCancellationRequested)return ze(A.canceled());const qe=()=>{const ae=Y=>{switch(Y.type){case 201:this.handlers.delete(ie),je(Y.data);break;case 202:this.handlers.delete(ie);const ce=new Error(Y.data.message);ce.stack=Y.data.stack,ce.name=Y.data.name,ze(ce);break;case 203:this.handlers.delete(ie),ze(Y.data);break}};this.handlers.set(ie,ae),this.sendRequest(Te)};let j=null;this.state===w.Idle?qe():(j=k.createCancelablePromise(ae=>this.whenInitialized()),j.then(()=>{j=null,qe()}));const Z=()=>{j?(j.cancel(),j=null):this.sendRequest({id:ie,type:101}),ze(A.canceled())},ne=K.onCancellationRequested(Z);ye=R.combinedDisposable(R.toDisposable(Z),ne),this.activeRequests.add(ye)}).finally(()=>{this.activeRequests.delete(ye)})}requestEvent(M,U,B){const K=this.lastRequestId++,we={id:K,type:102,channelName:M,name:U,arg:B};let Te=null;const ye=new v.Emitter({onFirstListenerAdd:()=>{Te=k.createCancelablePromise(je=>this.whenInitialized()),Te.then(()=>{Te=null,this.activeRequests.add(ye),this.sendRequest(we)})},onLastListenerRemove:()=>{Te?(Te.cancel(),Te=null):(this.activeRequests.delete(ye),this.sendRequest({id:K,type:103}))}}),Oe=je=>ye.fire(je.data);return this.handlers.set(K,Oe),ye.event}sendRequest(M){switch(M.type){case 100:case 102:{const U=this.send([M.type,M.id,M.channelName,M.name],M.arg);this.logger&&this.logger.logOutgoing(U,M.id,0,`${c(M.type)}: ${M.channelName}.${M.name}`,M.arg);return}case 101:case 103:{const U=this.send([M.type,M.id]);this.logger&&this.logger.logOutgoing(U,M.id,0,c(M.type));return}}}send(M,U=void 0){const B=new u;return a(B,M),a(B,U),this.sendBuffer(B.buffer)}sendBuffer(M){try{return this.protocol.send(M),M.byteLength}catch(U){return 0}}onBuffer(M){const U=new E(M),B=p(U),K=p(U),ie=B[0];switch(ie){case 200:return this.logger&&this.logger.logIncoming(M.byteLength,0,0,_(ie)),this.onResponse({type:B[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(M.byteLength,B[1],0,_(ie),K),this.onResponse({type:B[0],id:B[1],data:K})}}onResponse(M){if(M.type===200){this.state=w.Idle,this._onDidInitialize.fire();return}const U=this.handlers.get(M.id);U&&U(M)}get onDidInitializePromise(){return v.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===w.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(M=>M.dispose()),this.activeRequests.clear()}}Ve([l.memoize],S.prototype,"onDidInitializePromise",null),e.ChannelClient=S;class o{constructor(M){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new v.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new v.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,M(({protocol:U,onDidClientDisconnect:B})=>{v.Event.once(U.onMessage)(ie=>{const we=new E(ie),Te=p(we),ye=new d(U,Te),Oe=new S(U);this.channels.forEach((ze,qe)=>ye.registerChannel(qe,ze));const je={channelServer:ye,channelClient:Oe,ctx:Te};this._connections.add(je),this._onDidAddConnection.fire(je),B(()=>{ye.dispose(),Oe.dispose(),this._connections.delete(je),this._onDidRemoveConnection.fire(je)})})})}get connections(){const M=[];return this._connections.forEach(U=>M.push(U)),M}getChannel(M,U){const B=this;return{call(K,ie,we){let Te;if(P.isFunction(U)){let Oe=D.getRandomElement(B.connections.filter(U));Te=Oe?Promise.resolve(Oe):v.Event.toPromise(v.Event.filter(B.onDidAddConnection,U))}else Te=U.routeCall(B,K,ie);const ye=Te.then(Oe=>Oe.channelClient.getChannel(M));return O(ye).call(K,ie,we)},listen(K,ie){if(P.isFunction(U))return B.getMulticastEvent(M,U,K,ie);const we=U.routeEvent(B,K,ie).then(Te=>Te.channelClient.getChannel(M));return O(we).listen(K,ie)}}}getMulticastEvent(M,U,B,K){const ie=this;let we=new R.DisposableStore;const Te=new v.Emitter({onFirstListenerAdd:()=>{we=new R.DisposableStore;const ye=new v.EventMultiplexer,Oe=new Map,je=qe=>{const Z=qe.channelClient.getChannel(M).listen(B,K),ne=ye.add(Z);Oe.set(qe,ne)},ze=qe=>{const j=Oe.get(qe);!j||(j.dispose(),Oe.delete(qe))};ie.connections.filter(U).forEach(je),v.Event.filter(ie.onDidAddConnection,U)(je,void 0,we),ie.onDidRemoveConnection(ze,void 0,we),ye.event(Te.fire,Te,we),we.add(ye)},onLastListenerRemove:()=>{we.dispose()}});return Te.event}registerChannel(M,U){this.channels.set(M,U),this._connections.forEach(B=>{B.channelServer.registerChannel(M,U)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=o;class L{constructor(M,U,B=null){const K=new u;a(K,U),M.send(K.buffer),this.channelClient=new S(M,B),this.channelServer=new d(M,U,B)}getChannel(M){return this.channelClient.getChannel(M)}registerChannel(M,U){this.channelServer.registerChannel(M,U)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=L;function O(F){return{call(M,U,B){return F.then(K=>K.call(M,U,B))},listen(M,U){const B=new v.Relay;return F.then(K=>B.input=K.listen(M,U)),B.event}}}e.getDelayedChannel=O;function W(F){let M=!1;return{call(U,B,K){return M?F.call(U,B,K):k.timeout(0).then(()=>M=!0).then(()=>F.call(U,B,K))},listen(U,B){if(M)return F.listen(U,B);const K=new v.Relay;return k.timeout(0).then(()=>M=!0).then(()=>K.input=F.listen(U,B)),K.event}}}e.getNextTickChannel=W;class J{constructor(M){this.fn=M}routeCall(M){return this.route(M)}routeEvent(M){return this.route(M)}async route(M){for(const U of M.connections)if(await Promise.resolve(this.fn(U.ctx)))return Promise.resolve(U);return await v.Event.toPromise(M.onDidAddConnection),await this.route(M)}}e.StaticRouter=J;var oe;(function(F){function M(K,ie){const we=K,Te=ie&&ie.disableMarshalling,ye=new Map;for(const Oe in we)B(Oe)&&ye.set(Oe,v.Event.buffer(we[Oe],!0));return new class{listen(Oe,je){const ze=ye.get(je);if(ze)return ze;throw new Error(`Event not found: ${je}`)}call(Oe,je,ze){const qe=we[je];if(typeof qe=="function"){if(!Te&&Array.isArray(ze))for(let j=0;j<ze.length;j++)ze[j]=s.revive(ze[j]);return qe.apply(we,ze)}throw new Error(`Method not found: ${je}`)}}}F.fromService=M;function U(K,ie){const we=ie&&ie.disableMarshalling;return new Proxy({},{get(Te,ye){var Oe;if(typeof ye=="string")return((Oe=ie==null?void 0:ie.properties)===null||Oe===void 0?void 0:Oe.has(ye))?ie.properties.get(ye):B(ye)?K.listen(ye):async function(...je){let ze;ie&&!P.isUndefinedOrNull(ie.context)?ze=[ie.context,...je]:ze=je;const qe=await K.call(ye,ze);return we?qe:s.revive(qe)};throw new Error(`Property not found: ${String(ye)}`)}})}F.toService=U;function B(K){return K[0]==="o"&&K[1]==="n"&&I.isUpperAsciiLetter(K.charCodeAt(2))}})(oe=e.ProxyChannel||(e.ProxyChannel={}));const q=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function x(F){if(Array.isArray(F))return F;if(F&&typeof F=="object"&&typeof F.toString=="function"){let M=F.toString();if(M!=="[object Object]")return M}return F}function V(F){return Array.isArray(F)?F.map(x):x(F)}function T(F,M,U,B,K,ie,we){we=V(we);const Te=q[K],ye=Te[B%Te.length];let Oe=[`%c[${F}]%c[${String(M).padStart(7," ")}]%c[len: ${String(U).padStart(5," ")}]%c${String(B).padStart(5," ")} - ${ie}`,"color: darkgreen","color: grey","color: grey",`color: ${ye}`];/\($/.test(ie)?(Oe=Oe.concat(we),Oe.push(")")):Oe.push(we),console.log.apply(console,Oe)}e.logWithColors=T;class N{constructor(M,U){this._outgoingPrefix=M,this._incomingPrefix=U,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(M,U,B,K,ie){this._totalOutgoing+=M,T(this._outgoingPrefix,this._totalOutgoing,M,U,B,K,ie)}logIncoming(M,U,B,K,ie){this._totalIncoming+=M,T(this._incomingPrefix,this._totalIncoming,M,U,B,K,ie)}}e.IPCLogger=N}),define(ge[103],pe([0,1,3,102,6,22,11,37]),function(X,e,v,R,k,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=void 0;let D=null;function P(){return D||(D=y.VSBuffer.alloc(0)),D}class s{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(i){this._chunks.push(i),this._totalLength+=i.byteLength}read(i){return this._read(i,!0)}peek(i){return this._read(i,!1)}_read(i,n){if(i===0)return P();if(i>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===i){const b=this._chunks[0];return n&&(this._chunks.shift(),this._totalLength-=i),b}if(this._chunks[0].byteLength>i){const b=this._chunks[0].slice(0,i);return n&&(this._chunks[0]=this._chunks[0].slice(i),this._totalLength-=i),b}let a=y.VSBuffer.alloc(i),p=0,d=0;for(;i>0;){const b=this._chunks[d];if(b.byteLength>i){const S=b.slice(0,i);a.set(S,p),p+=i,n&&(this._chunks[d]=b.slice(i),this._totalLength-=i),i-=i}else a.set(b,p),p+=b.byteLength,n?(this._chunks.shift(),this._totalLength-=b.byteLength):d++,i-=b.byteLength}return a}}e.ChunkStream=s;var I;(function(r){r[r.None=0]="None",r[r.Regular=1]="Regular",r[r.Control=2]="Control",r[r.Ack=3]="Ack",r[r.KeepAlive=4]="KeepAlive",r[r.Disconnect=5]="Disconnect",r[r.ReplayRequest=6]="ReplayRequest"})(I||(I={}));var l;(function(r){r[r.HeaderLength=13]="HeaderLength",r[r.AcknowledgeTime=2e3]="AcknowledgeTime",r[r.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",r[r.KeepAliveTime=5e3]="KeepAliveTime",r[r.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",r[r.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",r[r.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(l=e.ProtocolConstants||(e.ProtocolConstants={}));class g{constructor(i,n,a,p){this.type=i,this.id=n,this.ack=a,this.data=p,this.writtenTime=0}get size(){return this.data.byteLength}}class c extends k.Disposable{constructor(i){super();this._onMessage=this._register(new v.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=i,this._isDisposed=!1,this._incomingData=new s,this._register(this._socket.onData(n=>this.acceptChunk(n))),this.lastReadTime=Date.now()}acceptChunk(i){if(!(!i||i.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(i);this._incomingData.byteLength>=this._state.readLen;){const n=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=n.readUInt32BE(9),this._state.messageType=n.readUInt8(0),this._state.id=n.readUInt32BE(1),this._state.ack=n.readUInt32BE(5);else{const a=this._state.messageType,p=this._state.id,d=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new g(a,p,d,n)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class f{constructor(i){this._isDisposed=!1,this._socket=i,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(i){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(i){if(this._isDisposed)return;i.writtenTime=Date.now(),this.lastWriteTime=Date.now();const n=y.VSBuffer.alloc(13);n.writeUInt8(i.type,0),n.writeUInt32BE(i.id,1),n.writeUInt32BE(i.ack,5),n.writeUInt32BE(i.data.byteLength,9),this._writeSoon(n,i.data)}_bufferAdd(i,n){const a=this._totalLength===0;return this._data.push(i,n),this._totalLength+=i.byteLength+n.byteLength,a}_bufferTake(){const i=y.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,i}_writeSoon(i,n){this._bufferAdd(i,n)&&A.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class _ extends k.Disposable{constructor(i){super();this._onMessage=new v.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new v.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=i,this._socketWriter=this._register(new f(this._socket)),this._socketReader=this._register(new c(this._socket)),this._register(this._socketReader.onMessage(n=>{n.type===1&&this._onMessage.fire(n.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(i){this._socketWriter.write(new g(1,0,0,i))}}e.Protocol=_;class w extends R.IPCClient{constructor(i,n,a=null){super(i,n,a);this.protocol=i}static fromSocket(i,n){return new w(new _(i),n)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const i=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),i.end()}}e.Client=w;class E{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new v.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,C.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(i){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(i):this._emitter.fire(i):this._bufferedMessages.push(i)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=E;class u{constructor(i){this.data=i,this.next=null}}class h{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let i=[],n=0,a=this._first;for(;a;)i[n++]=a.data,a=a.next;return i}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(i){const n=new u(i);if(!this._first){this._first=n,this._last=n;return}this._last.next=n,this._last=n}}class m{constructor(){this.lastRuns=[];const i=Date.now();for(let n=0;n<m._HISTORY_LENGTH;n++)this.lastRuns[n]=i-1e3*n;setInterval(()=>{for(let n=m._HISTORY_LENGTH;n>=1;n--)this.lastRuns[n]=this.lastRuns[n-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return m._INSTANCE||(m._INSTANCE=new m),m._INSTANCE}load(){const i=Date.now(),n=(1+m._HISTORY_LENGTH)*1e3;let a=0;for(let p=0;p<m._HISTORY_LENGTH;p++)i-this.lastRuns[p]<=n&&a++;return 1-a/m._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}m._HISTORY_LENGTH=10,m._INSTANCE=null;class t{constructor(i,n=null){this._loadEstimator=m.getInstance(),this._onControlMessage=new E,this.onControlMessage=this._onControlMessage.event,this._onMessage=new E,this.onMessage=this._onMessage.event,this._onDidDispose=new E,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new E,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new E,this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new h,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=i,this._socketWriter=new f(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new c(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(a=>this._receiveMessage(a))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),n&&this._socketReader.acceptChunk(n),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=k.dispose(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const i=new g(5,0,0,P());this._socketWriter.write(i),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const i=Date.now()-this._socketWriter.lastWriteTime;if(i>=5e3){const n=new g(4,0,0,P());this._socketWriter.write(n),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-i+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const i=Date.now()-this._socketReader.lastReadTime;if(i>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-i,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(i,n){this._isReconnecting=!0,this._socketDisposables=k.dispose(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=i,this._socketWriter=new f(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new c(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(a=>this._receiveMessage(a))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),this._socketReader.acceptChunk(n)}endAcceptReconnection(){this._isReconnecting=!1;const i=this._outgoingUnackMsg.toArray();for(let n=0,a=i.length;n<a;n++)this._socketWriter.write(i[n]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(i){if(i.ack>this._outgoingAckId){this._outgoingAckId=i.ack;do{const n=this._outgoingUnackMsg.peek();if(n&&n.id<=i.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(i.type===1){if(i.id>this._incomingMsgId)if(i.id!==this._incomingMsgId+1){const n=Date.now();n-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=n,this._socketWriter.write(new g(6,0,0,P())))}else this._incomingMsgId=i.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(i.data)}else if(i.type===2)this._onControlMessage.fire(i.data);else if(i.type===5)this._onDidDispose.fire();else if(i.type===6){const n=this._outgoingUnackMsg.toArray();for(let a=0,p=n.length;a<p;a++)this._socketWriter.write(n[a]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(i){const n=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const a=new g(1,n,this._incomingAckId,i);this._outgoingUnackMsg.push(a),this._isReconnecting||(this._socketWriter.write(a),this._recvAckCheck())}sendControl(i){const n=new g(2,0,0,i);this._socketWriter.write(n)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const i=Date.now()-this._incomingMsgLastTime;if(i>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-i+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout)return;const i=this._outgoingUnackMsg.peek(),n=Date.now()-i.writtenTime;if(n>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-n,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const i=new g(3,0,this._incomingAckId,P());this._socketWriter.write(i)}}e.PersistentProtocol=t}),define(ge[104],pe([0,1,93]),function(X,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class R{constructor(C){let D=v.toUint8(C);this._defaultValue=D,this._asciiMap=R._createAsciiMap(D),this._map=new Map}static _createAsciiMap(C){let D=new Uint8Array(256);for(let P=0;P<256;P++)D[P]=C;return D}set(C,D){let P=v.toUint8(D);C>=0&&C<256?this._asciiMap[C]=P:this._map.set(C,P)}get(C){return C>=0&&C<256?this._asciiMap[C]:this._map.get(C)||this._defaultValue}}e.CharacterClassifier=R;var k;(function(A){A[A.False=0]="False",A[A.True=1]="True"})(k||(k={}));class y{constructor(){this._actual=new R(0)}add(C){this._actual.set(C,1)}has(C){return this._actual.get(C)===1}}e.CharacterSet=y}),define(ge[138],pe([0,1,104]),function(X,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var R;(function(A){A[A.Regular=0]="Regular",A[A.Whitespace=1]="Whitespace",A[A.WordSeparator=2]="WordSeparator"})(R=e.WordCharacterClass||(e.WordCharacterClass={}));class k extends v.CharacterClassifier{constructor(C){super(0);for(let D=0,P=C.length;D<P;D++)this.set(C.charCodeAt(D),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=k;function y(A){let C={};return D=>(C.hasOwnProperty(D)||(C[D]=A(D)),C[D])}e.getMapForWordSeparators=y(A=>new k(A))}),define(ge[44],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class v{constructor(k,y){this.lineNumber=k,this.column=y}with(k=this.lineNumber,y=this.column){return k===this.lineNumber&&y===this.column?this:new v(k,y)}delta(k=0,y=0){return this.with(this.lineNumber+k,this.column+y)}equals(k){return v.equals(this,k)}static equals(k,y){return!k&&!y?!0:!!k&&!!y&&k.lineNumber===y.lineNumber&&k.column===y.column}isBefore(k){return v.isBefore(this,k)}static isBefore(k,y){return k.lineNumber<y.lineNumber?!0:y.lineNumber<k.lineNumber?!1:k.column<y.column}isBeforeOrEqual(k){return v.isBeforeOrEqual(this,k)}static isBeforeOrEqual(k,y){return k.lineNumber<y.lineNumber?!0:y.lineNumber<k.lineNumber?!1:k.column<=y.column}static compare(k,y){let A=k.lineNumber|0,C=y.lineNumber|0;if(A===C){let D=k.column|0,P=y.column|0;return D-P}return A-C}clone(){return new v(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(k){return new v(k.lineNumber,k.column)}static isIPosition(k){return k&&typeof k.lineNumber=="number"&&typeof k.column=="number"}}e.Position=v}),define(ge[41],pe([0,1,44]),function(X,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class R{constructor(y,A,C,D){y>C||y===C&&A>D?(this.startLineNumber=C,this.startColumn=D,this.endLineNumber=y,this.endColumn=A):(this.startLineNumber=y,this.startColumn=A,this.endLineNumber=C,this.endColumn=D)}isEmpty(){return R.isEmpty(this)}static isEmpty(y){return y.startLineNumber===y.endLineNumber&&y.startColumn===y.endColumn}containsPosition(y){return R.containsPosition(this,y)}static containsPosition(y,A){return!(A.lineNumber<y.startLineNumber||A.lineNumber>y.endLineNumber||A.lineNumber===y.startLineNumber&&A.column<y.startColumn||A.lineNumber===y.endLineNumber&&A.column>y.endColumn)}containsRange(y){return R.containsRange(this,y)}static containsRange(y,A){return!(A.startLineNumber<y.startLineNumber||A.endLineNumber<y.startLineNumber||A.startLineNumber>y.endLineNumber||A.endLineNumber>y.endLineNumber||A.startLineNumber===y.startLineNumber&&A.startColumn<y.startColumn||A.endLineNumber===y.endLineNumber&&A.endColumn>y.endColumn)}strictContainsRange(y){return R.strictContainsRange(this,y)}static strictContainsRange(y,A){return!(A.startLineNumber<y.startLineNumber||A.endLineNumber<y.startLineNumber||A.startLineNumber>y.endLineNumber||A.endLineNumber>y.endLineNumber||A.startLineNumber===y.startLineNumber&&A.startColumn<=y.startColumn||A.endLineNumber===y.endLineNumber&&A.endColumn>=y.endColumn)}plusRange(y){return R.plusRange(this,y)}static plusRange(y,A){let C,D,P,s;return A.startLineNumber<y.startLineNumber?(C=A.startLineNumber,D=A.startColumn):A.startLineNumber===y.startLineNumber?(C=A.startLineNumber,D=Math.min(A.startColumn,y.startColumn)):(C=y.startLineNumber,D=y.startColumn),A.endLineNumber>y.endLineNumber?(P=A.endLineNumber,s=A.endColumn):A.endLineNumber===y.endLineNumber?(P=A.endLineNumber,s=Math.max(A.endColumn,y.endColumn)):(P=y.endLineNumber,s=y.endColumn),new R(C,D,P,s)}intersectRanges(y){return R.intersectRanges(this,y)}static intersectRanges(y,A){let C=y.startLineNumber,D=y.startColumn,P=y.endLineNumber,s=y.endColumn,I=A.startLineNumber,l=A.startColumn,g=A.endLineNumber,c=A.endColumn;return C<I?(C=I,D=l):C===I&&(D=Math.max(D,l)),P>g?(P=g,s=c):P===g&&(s=Math.min(s,c)),C>P||C===P&&D>s?null:new R(C,D,P,s)}equalsRange(y){return R.equalsRange(this,y)}static equalsRange(y,A){return!!y&&!!A&&y.startLineNumber===A.startLineNumber&&y.startColumn===A.startColumn&&y.endLineNumber===A.endLineNumber&&y.endColumn===A.endColumn}getEndPosition(){return R.getEndPosition(this)}static getEndPosition(y){return new v.Position(y.endLineNumber,y.endColumn)}getStartPosition(){return R.getStartPosition(this)}static getStartPosition(y){return new v.Position(y.startLineNumber,y.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(y,A){return new R(this.startLineNumber,this.startColumn,y,A)}setStartPosition(y,A){return new R(y,A,this.endLineNumber,this.endColumn)}collapseToStart(){return R.collapseToStart(this)}static collapseToStart(y){return new R(y.startLineNumber,y.startColumn,y.startLineNumber,y.startColumn)}static fromPositions(y,A=y){return new R(y.lineNumber,y.column,A.lineNumber,A.column)}static lift(y){return y?new R(y.startLineNumber,y.startColumn,y.endLineNumber,y.endColumn):null}static isIRange(y){return y&&typeof y.startLineNumber=="number"&&typeof y.startColumn=="number"&&typeof y.endLineNumber=="number"&&typeof y.endColumn=="number"}static areIntersectingOrTouching(y,A){return!(y.endLineNumber<A.startLineNumber||y.endLineNumber===A.startLineNumber&&y.endColumn<A.startColumn||A.endLineNumber<y.startLineNumber||A.endLineNumber===y.startLineNumber&&A.endColumn<y.startColumn)}static areIntersecting(y,A){return!(y.endLineNumber<A.startLineNumber||y.endLineNumber===A.startLineNumber&&y.endColumn<=A.startColumn||A.endLineNumber<y.startLineNumber||A.endLineNumber===y.startLineNumber&&A.endColumn<=y.startColumn)}static compareRangesUsingStarts(y,A){if(y&&A){const P=y.startLineNumber|0,s=A.startLineNumber|0;if(P===s){const I=y.startColumn|0,l=A.startColumn|0;if(I===l){const g=y.endLineNumber|0,c=A.endLineNumber|0;if(g===c){const f=y.endColumn|0,_=A.endColumn|0;return f-_}return g-c}return I-l}return P-s}return(y?1:0)-(A?1:0)}static compareRangesUsingEnds(y,A){return y.endLineNumber===A.endLineNumber?y.endColumn===A.endColumn?y.startLineNumber===A.startLineNumber?y.startColumn-A.startColumn:y.startLineNumber-A.startLineNumber:y.endColumn-A.endColumn:y.endLineNumber-A.endLineNumber}static spansMultipleLines(y){return y.endLineNumber>y.startLineNumber}}e.Range=R}),define(ge[139],pe([0,1,44,41]),function(X,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var k;(function(A){A[A.LTR=0]="LTR",A[A.RTL=1]="RTL"})(k=e.SelectionDirection||(e.SelectionDirection={}));class y extends R.Range{constructor(C,D,P,s){super(C,D,P,s);this.selectionStartLineNumber=C,this.selectionStartColumn=D,this.positionLineNumber=P,this.positionColumn=s}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(C){return y.selectionsEqual(this,C)}static selectionsEqual(C,D){return C.selectionStartLineNumber===D.selectionStartLineNumber&&C.selectionStartColumn===D.selectionStartColumn&&C.positionLineNumber===D.positionLineNumber&&C.positionColumn===D.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(C,D){return this.getDirection()===0?new y(this.startLineNumber,this.startColumn,C,D):new y(C,D,this.startLineNumber,this.startColumn)}getPosition(){return new v.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(C,D){return this.getDirection()===0?new y(C,D,this.endLineNumber,this.endColumn):new y(this.endLineNumber,this.endColumn,C,D)}static fromPositions(C,D=C){return new y(C.lineNumber,C.column,D.lineNumber,D.column)}static liftSelection(C){return new y(C.selectionStartLineNumber,C.selectionStartColumn,C.positionLineNumber,C.positionColumn)}static selectionsArrEqual(C,D){if(C&&!D||!C&&D)return!1;if(!C&&!D)return!0;if(C.length!==D.length)return!1;for(let P=0,s=C.length;P<s;P++)if(!this.selectionsEqual(C[P],D[P]))return!1;return!0}static isISelection(C){return C&&typeof C.selectionStartLineNumber=="number"&&typeof C.selectionStartColumn=="number"&&typeof C.positionLineNumber=="number"&&typeof C.positionColumn=="number"}static createWithDirection(C,D,P,s,I){return I===0?new y(C,D,P,s):new y(P,s,C,D)}}e.Selection=y}),define(ge[105],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionNormalizationAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var v;(function(c){c[c.Left=1]="Left",c[c.Center=2]="Center",c[c.Right=4]="Right",c[c.Full=7]="Full"})(v=e.OverviewRulerLane||(e.OverviewRulerLane={}));var R;(function(c){c[c.Inline=1]="Inline",c[c.Gutter=2]="Gutter"})(R=e.MinimapPosition||(e.MinimapPosition={}));var k;(function(c){c[c.TextDefined=0]="TextDefined",c[c.LF=1]="LF",c[c.CRLF=2]="CRLF"})(k=e.EndOfLinePreference||(e.EndOfLinePreference={}));var y;(function(c){c[c.LF=1]="LF",c[c.CRLF=2]="CRLF"})(y=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var A;(function(c){c[c.LF=0]="LF",c[c.CRLF=1]="CRLF"})(A=e.EndOfLineSequence||(e.EndOfLineSequence={}));class C{constructor(f){this.tabSize=Math.max(1,f.tabSize|0),this.indentSize=f.tabSize|0,this.insertSpaces=Boolean(f.insertSpaces),this.defaultEOL=f.defaultEOL|0,this.trimAutoWhitespace=Boolean(f.trimAutoWhitespace)}equals(f){return this.tabSize===f.tabSize&&this.indentSize===f.indentSize&&this.insertSpaces===f.insertSpaces&&this.defaultEOL===f.defaultEOL&&this.trimAutoWhitespace===f.trimAutoWhitespace}createChangeEvent(f){return{tabSize:this.tabSize!==f.tabSize,indentSize:this.indentSize!==f.indentSize,insertSpaces:this.insertSpaces!==f.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==f.trimAutoWhitespace}}}e.TextModelResolvedOptions=C;class D{constructor(f,_){this.range=f,this.matches=_}}e.FindMatch=D;var P;(function(c){c[c.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",c[c.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",c[c.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",c[c.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(P=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var s;(function(c){c[c.Left=0]="Left",c[c.Right=1]="Right"})(s=e.PositionNormalizationAffinity||(e.PositionNormalizationAffinity={}));var I;(function(c){c[c.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(I=e.ModelConstants||(e.ModelConstants={}));class l{constructor(f,_,w,E,u,h){this.identifier=f,this.range=_,this.text=w,this.forceMoveMarkers=E,this.isAutoWhitespaceEdit=u,this._isTracked=h}}e.ValidAnnotatedEditOperation=l;class g{constructor(f,_,w){this.reverseEdits=f,this.changes=_,this.trimAutoWhitespaceLineNumbers=w}}e.ApplyEditsResult=g}),define(ge[140],pe([0,1,8,138,44,41,105]),function(X,e,v,R,k,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const C=999;class D{constructor(u,h,m,t){this.searchString=u,this.isRegex=h,this.matchCase=m,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let u;this.isRegex?u=P(this.searchString):u=this.searchString.indexOf(`
`)>=0;let h=null;try{h=v.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:u,global:!0,unicode:!0})}catch(t){return null}if(!h)return null;let m=!this.isRegex&&!u;return m&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(m=this.matchCase),new s(h,this.wordSeparators?R.getMapForWordSeparators(this.wordSeparators):null,m?this.searchString:null)}}e.SearchParams=D;function P(E){if(!E||E.length===0)return!1;for(let u=0,h=E.length;u<h;u++)if(E.charCodeAt(u)===92){if(u++,u>=h)break;const t=E.charCodeAt(u);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=P;class s{constructor(u,h,m){this.regex=u,this.wordSeparators=h,this.simpleSearch=m}}e.SearchData=s;function I(E,u,h){if(!h)return new A.FindMatch(E,null);let m=[];for(let t=0,r=u.length;t<r;t++)m[t]=u[t];return new A.FindMatch(E,m)}e.createFindMatch=I;class l{constructor(u){let h=[],m=0;for(let t=0,r=u.length;t<r;t++)u.charCodeAt(t)===10&&(h[m++]=t);this._lineFeedsOffsets=h}findLineFeedCountBeforeOffset(u){const h=this._lineFeedsOffsets;let m=0,t=h.length-1;if(t===-1||u<=h[0])return 0;for(;m<t;){const r=m+((t-m)/2>>0);h[r]>=u?t=r-1:h[r+1]>=u?(m=r,t=r):m=r+1}return m+1}}class g{static findMatches(u,h,m,t,r){const i=h.parseSearchRequest();return i?i.regex.multiline?this._doFindMatchesMultiline(u,m,new w(i.wordSeparators,i.regex),t,r):this._doFindMatchesLineByLine(u,m,i,t,r):[]}static _getMultilineMatchRange(u,h,m,t,r,i){let n,a=0;t?(a=t.findLineFeedCountBeforeOffset(r),n=h+r+a):n=h+r;let p;if(t){let o=t.findLineFeedCountBeforeOffset(r+i.length)-a;p=n+i.length+o}else p=n+i.length;const d=u.getPositionAt(n),b=u.getPositionAt(p);return new y.Range(d.lineNumber,d.column,b.lineNumber,b.column)}static _doFindMatchesMultiline(u,h,m,t,r){const i=u.getOffsetAt(h.getStartPosition()),n=u.getValueInRange(h,1),a=u.getEOL()===`\r
`?new l(n):null,p=[];let d=0,b;for(m.reset(0);b=m.next(n);)if(p[d++]=I(this._getMultilineMatchRange(u,i,n,a,b.index,b[0]),b,t),d>=r)return p;return p}static _doFindMatchesLineByLine(u,h,m,t,r){const i=[];let n=0;if(h.startLineNumber===h.endLineNumber){const p=u.getLineContent(h.startLineNumber).substring(h.startColumn-1,h.endColumn-1);return n=this._findMatchesInLine(m,p,h.startLineNumber,h.startColumn-1,n,i,t,r),i}const a=u.getLineContent(h.startLineNumber).substring(h.startColumn-1);n=this._findMatchesInLine(m,a,h.startLineNumber,h.startColumn-1,n,i,t,r);for(let p=h.startLineNumber+1;p<h.endLineNumber&&n<r;p++)n=this._findMatchesInLine(m,u.getLineContent(p),p,0,n,i,t,r);if(n<r){const p=u.getLineContent(h.endLineNumber).substring(0,h.endColumn-1);n=this._findMatchesInLine(m,p,h.endLineNumber,0,n,i,t,r)}return i}static _findMatchesInLine(u,h,m,t,r,i,n,a){const p=u.wordSeparators;if(!n&&u.simpleSearch){const S=u.simpleSearch,o=S.length,L=h.length;let O=-o;for(;(O=h.indexOf(S,O+o))!==-1;)if((!p||_(p,h,L,O,o))&&(i[r++]=new A.FindMatch(new y.Range(m,O+1+t,m,O+1+o+t),null),r>=a))return r;return r}const d=new w(u.wordSeparators,u.regex);let b;d.reset(0);do if(b=d.next(h),b&&(i[r++]=I(new y.Range(m,b.index+1+t,m,b.index+1+b[0].length+t),b,n),r>=a))return r;while(b);return r}static findNextMatch(u,h,m,t){const r=h.parseSearchRequest();if(!r)return null;const i=new w(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindNextMatchMultiline(u,m,i,t):this._doFindNextMatchLineByLine(u,m,i,t)}static _doFindNextMatchMultiline(u,h,m,t){const r=new k.Position(h.lineNumber,1),i=u.getOffsetAt(r),n=u.getLineCount(),a=u.getValueInRange(new y.Range(r.lineNumber,r.column,n,u.getLineMaxColumn(n)),1),p=u.getEOL()===`\r
`?new l(a):null;m.reset(h.column-1);let d=m.next(a);return d?I(this._getMultilineMatchRange(u,i,a,p,d.index,d[0]),d,t):h.lineNumber!==1||h.column!==1?this._doFindNextMatchMultiline(u,new k.Position(1,1),m,t):null}static _doFindNextMatchLineByLine(u,h,m,t){const r=u.getLineCount(),i=h.lineNumber,n=u.getLineContent(i),a=this._findFirstMatchInLine(m,n,i,h.column,t);if(a)return a;for(let p=1;p<=r;p++){const d=(i+p-1)%r,b=u.getLineContent(d+1),S=this._findFirstMatchInLine(m,b,d+1,1,t);if(S)return S}return null}static _findFirstMatchInLine(u,h,m,t,r){u.reset(t-1);const i=u.next(h);return i?I(new y.Range(m,i.index+1,m,i.index+1+i[0].length),i,r):null}static findPreviousMatch(u,h,m,t){const r=h.parseSearchRequest();if(!r)return null;const i=new w(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindPreviousMatchMultiline(u,m,i,t):this._doFindPreviousMatchLineByLine(u,m,i,t)}static _doFindPreviousMatchMultiline(u,h,m,t){const r=this._doFindMatchesMultiline(u,new y.Range(1,1,h.lineNumber,h.column),m,t,10*C);if(r.length>0)return r[r.length-1];const i=u.getLineCount();return h.lineNumber!==i||h.column!==u.getLineMaxColumn(i)?this._doFindPreviousMatchMultiline(u,new k.Position(i,u.getLineMaxColumn(i)),m,t):null}static _doFindPreviousMatchLineByLine(u,h,m,t){const r=u.getLineCount(),i=h.lineNumber,n=u.getLineContent(i).substring(0,h.column-1),a=this._findLastMatchInLine(m,n,i,t);if(a)return a;for(let p=1;p<=r;p++){const d=(r+i-p-1)%r,b=u.getLineContent(d+1),S=this._findLastMatchInLine(m,b,d+1,t);if(S)return S}return null}static _findLastMatchInLine(u,h,m,t){let r=null,i;for(u.reset(0);i=u.next(h);)r=I(new y.Range(m,i.index+1,m,i.index+1+i[0].length),i,t);return r}}e.TextModelSearch=g;function c(E,u,h,m,t){if(m===0)return!0;const r=u.charCodeAt(m-1);if(E.get(r)!==0||r===13||r===10)return!0;if(t>0){const i=u.charCodeAt(m);if(E.get(i)!==0)return!0}return!1}function f(E,u,h,m,t){if(m+t===h)return!0;const r=u.charCodeAt(m+t);if(E.get(r)!==0||r===13||r===10)return!0;if(t>0){const i=u.charCodeAt(m+t-1);if(E.get(i)!==0)return!0}return!1}function _(E,u,h,m,t){return c(E,u,h,m,t)&&f(E,u,h,m,t)}e.isValidMatch=_;class w{constructor(u,h){this._wordSeparators=u,this._searchRegex=h,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(u){this._searchRegex.lastIndex=u,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(u){const h=u.length;let m;do{if(this._prevMatchStartIndex+this._prevMatchLength===h||(m=this._searchRegex.exec(u),!m))return null;const t=m.index,r=m[0].length;if(t===this._prevMatchStartIndex&&r===this._prevMatchLength){if(r===0){v.getNextCodePoint(u,h,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=r,!this._wordSeparators||_(this._wordSeparators,u,h,t,r))return m}while(m);return null}}e.Searcher=w}),define(ge[106],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function v(C=""){let D="(-?\\d*\\.\\d\\w*)|([^";for(const P of e.USUAL_WORD_SEPARATORS)C.indexOf(P)>=0||(D+="\\"+P);return D+="\\s]+)",new RegExp(D,"g")}e.DEFAULT_WORD_REGEXP=v();function R(C){let D=e.DEFAULT_WORD_REGEXP;if(C&&C instanceof RegExp)if(C.global)D=C;else{let P="g";C.ignoreCase&&(P+="i"),C.multiline&&(P+="m"),C.unicode&&(P+="u"),D=new RegExp(C.source,P)}return D.lastIndex=0,D}e.ensureValidWordDefinition=R;const k={maxLen:1e3,windowSize:15,timeBudget:150};function y(C,D,P,s,I=k){if(P.length>I.maxLen){let _=C-I.maxLen/2;return _<0?_=0:s+=_,P=P.substring(_,C+I.maxLen/2),y(C,D,P,s,I)}const l=Date.now(),g=C-1-s;let c=-1,f=null;for(let _=1;!(Date.now()-l>=I.timeBudget);_++){const w=g-I.windowSize*_;D.lastIndex=Math.max(0,w);const E=A(D,P,g,c);if(!E&&f||(f=E,w<=0))break;c=w}if(f){let _={word:f[0],startColumn:s+1+f.index,endColumn:s+1+f.index+f[0].length};return D.lastIndex=0,_}return null}e.getWordAtText=y;function A(C,D,P,s){let I;for(;I=C.exec(D);){const l=I.index||0;if(l<=P&&C.lastIndex>=P)return I;if(s>0&&l>s)return null}return null}}),define(ge[141],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var v;(function(A){A[A.None=0]="None",A[A.Indent=1]="Indent",A[A.IndentOutdent=2]="IndentOutdent",A[A.Outdent=3]="Outdent"})(v=e.IndentAction||(e.IndentAction={}));class R{constructor(C){if(this.open=C.open,this.close=C.close,this._standardTokenMask=0,Array.isArray(C.notIn))for(let D=0,P=C.notIn.length;D<P;D++)switch(C.notIn[D]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(C){return(this._standardTokenMask&C)==0}}e.StandardAutoClosingPairConditional=R;class k{constructor(C){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const D of C)y(this.autoClosingPairsOpenByStart,D.open.charAt(0),D),y(this.autoClosingPairsOpenByEnd,D.open.charAt(D.open.length-1),D),y(this.autoClosingPairsCloseByStart,D.close.charAt(0),D),y(this.autoClosingPairsCloseByEnd,D.close.charAt(D.close.length-1),D),D.close.length===1&&D.open.length===1&&y(this.autoClosingPairsCloseSingleChar,D.close,D)}}e.AutoClosingPairs=k;function y(A,C,D){A.has(C)?A.get(C).push(D):A.set(C,[D])}}),define(ge[77],pe([0,1,30,9]),function(X,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function k(y,A,C,D){if(Array.isArray(y)){let P=0;for(const s of y){const I=k(s,A,C,D);if(I===10)return I;I>P&&(P=I)}return P}else{if(typeof y=="string")return D?y==="*"?5:y===C?10:0:0;if(y){const{language:P,pattern:s,scheme:I,hasAccessToAllModels:l}=y;if(!D&&!l)return 0;let g=0;if(I)if(I===A.scheme)g=10;else if(I==="*")g=5;else return 0;if(P)if(P===C)g=10;else if(P==="*")g=Math.max(g,5);else return 0;if(s){let c;if(typeof s=="string"?c=s:c=Object.assign(Object.assign({},s),{base:R.normalize(s.base)}),c===A.fsPath||v.match(c,A.fsPath))g=10;else return 0}return g}else return 0}}e.score=k}),define(ge[142],pe([0,1,104]),function(X,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var R;(function(g){g[g.Invalid=0]="Invalid",g[g.Start=1]="Start",g[g.H=2]="H",g[g.HT=3]="HT",g[g.HTT=4]="HTT",g[g.HTTP=5]="HTTP",g[g.F=6]="F",g[g.FI=7]="FI",g[g.FIL=8]="FIL",g[g.BeforeColon=9]="BeforeColon",g[g.AfterColon=10]="AfterColon",g[g.AlmostThere=11]="AlmostThere",g[g.End=12]="End",g[g.Accept=13]="Accept",g[g.LastKnownState=14]="LastKnownState"})(R=e.State||(e.State={}));class k{constructor(c,f,_){const w=new Uint8Array(c*f);for(let E=0,u=c*f;E<u;E++)w[E]=_;this._data=w,this.rows=c,this.cols=f}get(c,f){return this._data[c*this.cols+f]}set(c,f,_){this._data[c*this.cols+f]=_}}e.Uint8Matrix=k;class y{constructor(c){let f=0,_=0;for(let E=0,u=c.length;E<u;E++){let[h,m,t]=c[E];m>f&&(f=m),h>_&&(_=h),t>_&&(_=t)}f++,_++;let w=new k(_,f,0);for(let E=0,u=c.length;E<u;E++){let[h,m,t]=c[E];w.set(h,m,t)}this._states=w,this._maxCharCode=f}nextState(c,f){return f<0||f>=this._maxCharCode?0:this._states.get(c,f)}}e.StateMachine=y;let A=null;function C(){return A===null&&(A=new y([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),A}var D;(function(g){g[g.None=0]="None",g[g.ForceTermination=1]="ForceTermination",g[g.CannotEndIn=2]="CannotEndIn"})(D||(D={}));let P=null;function s(){if(P===null){P=new v.CharacterClassifier(0);const g=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let f=0;f<g.length;f++)P.set(g.charCodeAt(f),1);const c=".,;";for(let f=0;f<c.length;f++)P.set(c.charCodeAt(f),2)}return P}class I{static _createLink(c,f,_,w,E){let u=E-1;do{const h=f.charCodeAt(u);if(c.get(h)!==2)break;u--}while(u>w);if(w>0){const h=f.charCodeAt(w-1),m=f.charCodeAt(u);(h===40&&m===41||h===91&&m===93||h===123&&m===125)&&u--}return{range:{startLineNumber:_,startColumn:w+1,endLineNumber:_,endColumn:u+2},url:f.substring(w,u+1)}}static computeLinks(c,f=C()){const _=s();let w=[];for(let E=1,u=c.getLineCount();E<=u;E++){const h=c.getLineContent(E),m=h.length;let t=0,r=0,i=0,n=1,a=!1,p=!1,d=!1,b=!1;for(;t<m;){let S=!1;const o=h.charCodeAt(t);if(n===13){let L;switch(o){case 40:a=!0,L=0;break;case 41:L=a?0:1;break;case 91:d=!0,p=!0,L=0;break;case 93:d=!1,L=p?0:1;break;case 123:b=!0,L=0;break;case 125:L=b?0:1;break;case 39:L=i===34||i===96?0:1;break;case 34:L=i===39||i===96?0:1;break;case 96:L=i===39||i===34?0:1;break;case 42:L=i===42?1:0;break;case 124:L=i===124?1:0;break;case 32:L=d?0:1;break;default:L=_.get(o)}L===1&&(w.push(I._createLink(_,h,E,r,t)),S=!0)}else if(n===12){let L;o===91?(p=!0,L=0):L=_.get(o),L===1?S=!0:n=13}else n=f.nextState(n,o),n===0&&(S=!0);S&&(n=1,a=!1,p=!1,b=!1,r=t+1,i=o),t++}n===13&&w.push(I._createLink(_,h,E,r,m))}return w}}e.LinkComputer=I;function l(g){return!g||typeof g.getLineCount!="function"||typeof g.getLineContent!="function"?[]:I.computeLinks(g)}e.computeLinks=l}),define(ge[143],pe([0,1,3,6]),function(X,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class k{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new v.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(A){this._onDidChange.fire({changedLanguages:A,changedColorMap:!1})}register(A,C){return this._map.set(A,C),this.fire([A]),R.toDisposable(()=>{this._map.get(A)===C&&(this._map.delete(A),this.fire([A]))})}registerPromise(A,C){let D=null,P=!1;return this._promises.set(A,C.then(s=>{this._promises.delete(A),!(P||!s)&&(D=this.register(A,s))})),R.toDisposable(()=>{P=!0,D&&D.dispose()})}getPromise(A){const C=this.get(A);if(C)return Promise.resolve(C);const D=this._promises.get(A);return D?D.then(P=>this.get(A)):null}get(A){return this._map.get(A)||null}setColorMap(A){this._colorMap=A,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=k}),define(ge[107],pe([0,1,22,11]),function(X,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var k;(function(I){I[I.Full=1]="Full",I[I.Delta=2]="Delta"})(k||(k={}));function y(I){for(let l=0,g=I.length;l<g;l+=4){const c=I[l+0],f=I[l+1],_=I[l+2],w=I[l+3];I[l+0]=w,I[l+1]=_,I[l+2]=f,I[l+3]=c}}function A(I){const l=new Uint8Array(I.buffer,I.byteOffset,I.length*4);return R.isLittleEndian()||y(l),v.VSBuffer.wrap(l)}function C(I){const l=I.buffer;if(R.isLittleEndian()||y(l),l.byteOffset%4==0)return new Uint32Array(l.buffer,l.byteOffset,l.length/4);{const g=new Uint8Array(l.byteLength);return g.set(l),new Uint32Array(g.buffer,g.byteOffset,g.length/4)}}function D(I){const l=new Uint32Array(P(I));let g=0;if(l[g++]=I.id,I.type==="full")l[g++]=1,l[g++]=I.data.length,l.set(I.data,g),g+=I.data.length;else{l[g++]=2,l[g++]=I.deltas.length;for(const c of I.deltas)l[g++]=c.start,l[g++]=c.deleteCount,c.data?(l[g++]=c.data.length,l.set(c.data,g),g+=c.data.length):l[g++]=0}return A(l)}e.encodeSemanticTokensDto=D;function P(I){let l=0;if(l+=1+1,I.type==="full")l+=1+I.data.length;else{l+=1,l+=(1+1+1)*I.deltas.length;for(const g of I.deltas)g.data&&(l+=g.data.length)}return l}function s(I){const l=C(I);let g=0;const c=l[g++];if(l[g++]===1){const E=l[g++],u=l.subarray(g,g+E);return g+=E,{id:c,type:"full",data:u}}const _=l[g++];let w=[];for(let E=0;E<_;E++){const u=l[g++],h=l[g++],m=l[g++];let t;m>0&&(t=l.subarray(g,g+m),g+=m),w[E]={start:u,deleteCount:h,data:t}}return{id:c,type:"delta",deltas:w}}e.decodeSemanticTokensDto=s}),define(ge[108],pe([0,1,93]),function(X,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class R{constructor(A,C){this.index=A,this.remainder=C}}e.PrefixSumIndexOfResult=R;class k{constructor(A){this.values=A,this.prefixSum=new Uint32Array(A.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(A,C){A=v.toUint32(A);const D=this.values,P=this.prefixSum,s=C.length;return s===0?!1:(this.values=new Uint32Array(D.length+s),this.values.set(D.subarray(0,A),0),this.values.set(D.subarray(A),A+s),this.values.set(C,A),A-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=A-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(P.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(A,C){return A=v.toUint32(A),C=v.toUint32(C),this.values[A]===C?!1:(this.values[A]=C,A-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=A-1),!0)}removeValues(A,C){A=v.toUint32(A),C=v.toUint32(C);const D=this.values,P=this.prefixSum;if(A>=D.length)return!1;let s=D.length-A;return C>=s&&(C=s),C===0?!1:(this.values=new Uint32Array(D.length-C),this.values.set(D.subarray(0,A),0),this.values.set(D.subarray(A+C),A),this.prefixSum=new Uint32Array(this.values.length),A-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=A-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(P.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalValue(){return this.values.length===0?0:this._getAccumulatedValue(this.values.length-1)}getAccumulatedValue(A){return A<0?0:(A=v.toUint32(A),this._getAccumulatedValue(A))}_getAccumulatedValue(A){if(A<=this.prefixSumValidIndex[0])return this.prefixSum[A];let C=this.prefixSumValidIndex[0]+1;C===0&&(this.prefixSum[0]=this.values[0],C++),A>=this.values.length&&(A=this.values.length-1);for(let D=C;D<=A;D++)this.prefixSum[D]=this.prefixSum[D-1]+this.values[D];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],A),this.prefixSum[A]}getIndexOf(A){A=Math.floor(A),this.getTotalValue();let C=0,D=this.values.length-1,P=0,s=0,I=0;for(;C<=D;)if(P=C+(D-C)/2|0,s=this.prefixSum[P],I=s-this.values[P],A<I)D=P-1;else if(A>=s)C=P+1;else break;return new R(P,A-I)}}e.PrefixSumComputer=k}),define(ge[144],pe([0,1,8,44,108]),function(X,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class y{constructor(C,D,P,s){this._uri=C,this._lines=D,this._eol=P,this._versionId=s,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(C){C.eol&&C.eol!==this._eol&&(this._eol=C.eol,this._lineStarts=null);const D=C.changes;for(const P of D)this._acceptDeleteRange(P.range),this._acceptInsertText(new R.Position(P.range.startLineNumber,P.range.startColumn),P.text);this._versionId=C.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const C=this._eol.length,D=this._lines.length,P=new Uint32Array(D);for(let s=0;s<D;s++)P[s]=this._lines[s].length+C;this._lineStarts=new k.PrefixSumComputer(P)}}_setLineText(C,D){this._lines[C]=D,this._lineStarts&&this._lineStarts.changeValue(C,this._lines[C].length+this._eol.length)}_acceptDeleteRange(C){if(C.startLineNumber===C.endLineNumber){if(C.startColumn===C.endColumn)return;this._setLineText(C.startLineNumber-1,this._lines[C.startLineNumber-1].substring(0,C.startColumn-1)+this._lines[C.startLineNumber-1].substring(C.endColumn-1));return}this._setLineText(C.startLineNumber-1,this._lines[C.startLineNumber-1].substring(0,C.startColumn-1)+this._lines[C.endLineNumber-1].substring(C.endColumn-1)),this._lines.splice(C.startLineNumber,C.endLineNumber-C.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(C.startLineNumber,C.endLineNumber-C.startLineNumber)}_acceptInsertText(C,D){if(D.length===0)return;let P=v.splitLines(D);if(P.length===1){this._setLineText(C.lineNumber-1,this._lines[C.lineNumber-1].substring(0,C.column-1)+P[0]+this._lines[C.lineNumber-1].substring(C.column-1));return}P[P.length-1]+=this._lines[C.lineNumber-1].substring(C.column-1),this._setLineText(C.lineNumber-1,this._lines[C.lineNumber-1].substring(0,C.column-1)+P[0]);let s=new Uint32Array(P.length-1);for(let I=1;I<P.length;I++)this._lines.splice(C.lineNumber+I-1,0,P[I]),s[I-1]=P[I].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(C.lineNumber,s)}}e.MirrorTextModel=y}),define(ge[145],pe([19,20]),function(X,e){return X.create("vs/base/common/date",e)}),define(ge[146],pe([0,1,145]),function(X,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const R=60,k=R*60,y=k*24,A=y*7,C=y*30,D=y*365;function P(I,l){typeof I!="number"&&(I=I.getTime());const g=Math.round((new Date().getTime()-I)/1e3);if(g<-30)return v.localize(0,null,P(new Date().getTime()+g*1e3,!1));if(g<30)return v.localize(1,null);let c;return g<R?(c=g,l?c===1?v.localize(2,null,c):v.localize(3,null,c):c===1?v.localize(4,null,c):v.localize(5,null,c)):g<k?(c=Math.floor(g/R),l?c===1?v.localize(6,null,c):v.localize(7,null,c):c===1?v.localize(8,null,c):v.localize(9,null,c)):g<y?(c=Math.floor(g/k),l?c===1?v.localize(10,null,c):v.localize(11,null,c):c===1?v.localize(12,null,c):v.localize(13,null,c)):g<A?(c=Math.floor(g/y),l?c===1?v.localize(14,null,c):v.localize(15,null,c):c===1?v.localize(16,null,c):v.localize(17,null,c)):g<C?(c=Math.floor(g/A),l?c===1?v.localize(18,null,c):v.localize(19,null,c):c===1?v.localize(20,null,c):v.localize(21,null,c)):g<D?(c=Math.floor(g/C),l?c===1?v.localize(22,null,c):v.localize(23,null,c):c===1?v.localize(24,null,c):v.localize(25,null,c)):(c=Math.floor(g/D),l?c===1?v.localize(26,null,c):v.localize(27,null,c):c===1?v.localize(28,null,c):v.localize(29,null,c))}e.fromNow=P;function s(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=s}),define(ge[147],pe([19,20]),function(X,e){return X.create("vs/base/common/errorMessage",e)}),define(ge[55],pe([0,1,147,13,17]),function(X,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function y(P,s){return s&&(P.stack||P.stacktrace)?v.localize(0,null,C(P),A(P.stack)||A(P.stacktrace)):C(P)}function A(P){return Array.isArray(P)?P.join(`
`):P}function C(P){return typeof P.code=="string"&&typeof P.errno=="number"&&typeof P.syscall=="string"?v.localize(1,null,P.message):P.message||v.localize(2,null)}function D(P=null,s=!1){if(!P)return v.localize(3,null);if(Array.isArray(P)){const I=k.coalesce(P),l=D(I[0],s);return I.length>1?v.localize(4,null,l,I.length):l}if(R.isString(P))return P;if(P.detail){const I=P.detail;if(I.error)return y(I.error,s);if(I.exception)return y(I.exception,s)}return P.stack?y(P,s):P.message?P.message:v.localize(5,null)}e.toErrorMessage=D}),define(ge[148],pe([19,20]),function(X,e){return X.create("vs/base/node/processes",e)}),define(ge[109],pe([0,1,9,28,38,148,37,13,25,29,11,137,10]),function(X,e,v,R,k,y,A,C,D,P,s,I,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function g(h){switch(h){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function c(h,m){if(s.isWindows)try{const t={stdio:["pipe","pipe","ignore"]};m&&(t.cwd=m);const r=k.execFile("taskkill",["/T","/F","/PID",h.pid.toString()],t);return new Promise(i=>{r.once("error",n=>{i({success:!1,error:n})}),r.once("exit",(n,a)=>{i(n===0?{success:!0}:{success:!1,code:n!==null?n:1})})})}catch(t){return Promise.resolve({success:!1,error:t,code:t.status?g(t.status):1})}else if(s.isLinux||s.isMacintosh)try{const t=l.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",X).fsPath;return new Promise(r=>{k.execFile(t,[h.pid.toString()],{encoding:"utf8",shell:!0},(i,n,a)=>{r(i?{success:!1,error:i}:{success:!0})})})}catch(t){return Promise.resolve({success:!1,error:t})}else h.kill("SIGKILL");return Promise.resolve({success:!0})}function f(h=A.env){return h.comspec||"cmd.exe"}e.getWindowsShell=f;class _{constructor(m,t,r,i){if(t!==void 0&&r!==void 0&&i!==void 0)this.cmd=m,this.args=t,this.shell=r,this.options=i;else{const n=m;this.cmd=n.command,this.shell=n.isShellCommand,this.args=n.args.slice(0),this.options=n.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const n=Object.create(null);Object.keys(A.env).forEach(a=>{n[a]=A.env[a]}),Object.keys(this.options.env).forEach(a=>{n[a]=this.options.env[a]}),this.options.env=n}}getSanitizedCommand(){let m=this.cmd.toLowerCase();const t=m.lastIndexOf(v.sep);return t!==-1&&(m=m.substring(t+1)),_.WellKnowCommands[m]?m:"other"}start(m){return s.isWindows&&(this.options&&this.options.cwd&&P.isUNC(this.options.cwd)||!this.options&&P.isUNC(A.cwd()))?Promise.reject(new Error(y.localize(0,null))):this.useExec().then(t=>{let r,i;const n=new Promise((a,p)=>{r=a,i=p});if(t){let a=this.cmd;this.args&&(a=a+" "+this.args.join(" ")),this.childProcess=k.exec(a,this.options,(p,d,b)=>{this.childProcess=null;const S=p;S&&S.killed?i({killed:this.terminateRequested,stdout:d.toString(),stderr:b.toString()}):this.handleExec(r,m,p,d,b)})}else{let a=null;const p=d=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(d,r,m,i);const b={terminated:this.terminateRequested};C.isNumber(d)&&(b.cmdCode=d),r(b)};if(this.shell&&s.isWindows){const d=D.deepClone(this.options);d.windowsVerbatimArguments=!0,d.detached=!1;let b=!1,S=!1;const o=[];let L=this.ensureQuotes(this.cmd);o.push(L.value),b=L.quoted,this.args&&this.args.forEach(W=>{L=this.ensureQuotes(W),o.push(L.value),S=S&&L.quoted});const O=["/s","/c"];b?S?O.push('"'+o.join(" ")+'"'):o.length>1?O.push('"'+o[0]+'" '+o.slice(1).join(" ")):O.push('"'+o[0]+'"'):O.push(o.join(" ")),a=k.spawn(f(),O,d)}else this.cmd&&(a=k.spawn(this.cmd,this.args,this.options));a&&(this.childProcess=a,this.childProcessPromise=Promise.resolve(a),this.pidResolve&&(this.pidResolve(C.isNumber(a.pid)?a.pid:-1),this.pidResolve=void 0),a.on("error",d=>{this.childProcess=null,i({terminated:this.terminateRequested,error:d})}),a.pid&&(this.childProcess.on("close",p),this.handleSpawn(a,r,m,i,!0)))}return n})}handleClose(m,t,r,i){}ensureQuotes(m){return _.regexp.test(m)?{value:'"'+m+'"',quoted:!0}:{value:m,quoted:m.length>0&&m[0]==='"'&&m[m.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(m=>m.pid,m=>-1):new Promise(m=>{this.pidResolve=m})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(m=>(this.terminateRequested=!0,c(m,this.options.cwd).then(t=>(t.success&&(this.childProcess=null),t))),m=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(m=>{if(!this.shell||!s.isWindows)return m(!1);const t=k.spawn(f(),["/s","/c"]);t.on("error",r=>m(!0)),t.on("exit",r=>m(!1))})}}e.AbstractProcess=_,_.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},_.regexp=/^[^"].* .*[^"]/;class w extends _{constructor(m,t,r,i){super(m,t,r,i);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(m,t,r,i,n){[i,n].forEach((a,p)=>{const d=new I.LineDecoder;d.write(a).forEach(o=>{t({line:o,source:p===0?0:1})});const S=d.end();S&&t({line:S,source:p===0?0:1})}),m({terminated:this.terminateRequested,error:r})}handleSpawn(m,t,r,i,n){const a=new I.LineDecoder,p=new I.LineDecoder;m.stdout.on("data",d=>{a.write(d).forEach(S=>r({line:S,source:0}))}),m.stderr.on("data",d=>{p.write(d).forEach(S=>r({line:S,source:1}))}),this.stdoutLineDecoder=a,this.stderrLineDecoder=p}handleClose(m,t,r,i){const n=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;n&&r({line:n,source:0});const a=this.stderrLineDecoder?this.stderrLineDecoder.end():null;a&&r({line:a,source:1})}}e.LineProcess=w;function E(h){let m=[],t=!1;const r=function(i){if(t){m.push(i);return}(!h.send(i,a=>{if(a&&console.error(a),t=!1,m.length>0){const p=m.slice(0);m=[],p.forEach(d=>r(d))}})||s.isWindows)&&(t=!0)};return{send:r}}e.createQueuedSender=E;var u;(function(h){async function m(t,r,i){if(v.isAbsolute(t))return t;if(r===void 0&&(r=A.cwd()),v.dirname(t)!=="."||(i===void 0&&C.isString(A.env.PATH)&&(i=A.env.PATH.split(v.delimiter)),i===void 0||i.length===0))return v.join(r,t);async function a(p){return await R.exists(p)?!(await R.Promises.stat(p)).isDirectory():!1}for(let p of i){let d;if(v.isAbsolute(p)?d=v.join(p,t):d=v.join(r,p,t),await a(d))return d;let b=d+".com";if(await a(b)||(b=d+".exe",await a(b)))return b}return v.join(r,t)}h.findExecutable=m})(u=e.win32||(e.win32={}))}),define(ge[149],pe([19,20]),function(X,e){return X.create("vs/editor/common/config/editorOptions",e)}),define(ge[150],pe([0,1,149,11,106]),function(X,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var y;(function(Q){Q[Q.None=0]="None",Q[Q.Keep=1]="Keep",Q[Q.Brackets=2]="Brackets",Q[Q.Advanced=3]="Advanced",Q[Q.Full=4]="Full"})(y=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class A{constructor(re){this._values=re}hasChanged(re){return this._values[re]}}e.ConfigurationChangedEvent=A;class C{constructor(){this._values=[]}_read(re){return this._values[re]}get(re){return this._values[re]}_write(re,ve){this._values[re]=ve}}e.ValidatedEditorOptions=C;class D{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=D;class P{constructor(re,ve,Me,Ne){this.id=re,this.name=ve,this.defaultValue=Me,this.schema=Ne}compute(re,ve,Me){return Me}}class s{constructor(re,ve=null){this.schema=void 0,this.id=re,this.name="_never_",this.defaultValue=void 0,this.deps=ve}validate(re){return this.defaultValue}}class I{constructor(re,ve,Me,Ne){this.id=re,this.name=ve,this.defaultValue=Me,this.schema=Ne}validate(re){return typeof re=="undefined"?this.defaultValue:re}compute(re,ve,Me){return Me}}function l(Q,re){return typeof Q=="undefined"?re:Q==="false"?!1:Boolean(Q)}e.boolean=l;class g extends I{constructor(re,ve,Me,Ne=void 0){typeof Ne!="undefined"&&(Ne.type="boolean",Ne.default=Me),super(re,ve,Me,Ne)}validate(re){return l(re,this.defaultValue)}}class c extends I{constructor(re,ve,Me,Ne,Ye,Se=void 0){typeof Se!="undefined"&&(Se.type="integer",Se.default=Me,Se.minimum=Ne,Se.maximum=Ye),super(re,ve,Me,Se),this.minimum=Ne,this.maximum=Ye}static clampedInt(re,ve,Me,Ne){if(typeof re=="undefined")return ve;let Ye=parseInt(re,10);return isNaN(Ye)?ve:(Ye=Math.max(Me,Ye),Ye=Math.min(Ne,Ye),Ye|0)}validate(re){return c.clampedInt(re,this.defaultValue,this.minimum,this.maximum)}}class f extends I{constructor(re,ve,Me,Ne,Ye){typeof Ye!="undefined"&&(Ye.type="number",Ye.default=Me),super(re,ve,Me,Ye),this.validationFn=Ne}static clamp(re,ve,Me){return re<ve?ve:re>Me?Me:re}static float(re,ve){if(typeof re=="number")return re;if(typeof re=="undefined")return ve;const Me=parseFloat(re);return isNaN(Me)?ve:Me}validate(re){return this.validationFn(f.float(re,this.defaultValue))}}class _ extends I{static string(re,ve){return typeof re!="string"?ve:re}constructor(re,ve,Me,Ne=void 0){typeof Ne!="undefined"&&(Ne.type="string",Ne.default=Me),super(re,ve,Me,Ne)}validate(re){return _.string(re,this.defaultValue)}}function w(Q,re,ve){return typeof Q!="string"||ve.indexOf(Q)===-1?re:Q}e.stringSet=w;class E extends I{constructor(re,ve,Me,Ne,Ye=void 0){typeof Ye!="undefined"&&(Ye.type="string",Ye.enum=Ne,Ye.default=Me),super(re,ve,Me,Ye),this._allowedValues=Ne}validate(re){return w(re,this.defaultValue,this._allowedValues)}}class u extends P{constructor(re,ve,Me,Ne,Ye,Se,_e=void 0){typeof _e!="undefined"&&(_e.type="string",_e.enum=Ye,_e.default=Ne),super(re,ve,Me,_e),this._allowedValues=Ye,this._convert=Se}validate(re){return typeof re!="string"?this.defaultValue:this._allowedValues.indexOf(re)===-1?this.defaultValue:this._convert(re)}}function h(Q){switch(Q){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class m extends P{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[v.localize(0,null),v.localize(1,null),v.localize(2,null)],default:"auto",description:v.localize(3,null)})}validate(re){switch(re){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(re,ve,Me){return Me===0?re.accessibilitySupport:Me}}class t extends P{constructor(){const re={insertSpace:!0,ignoreEmptyLines:!0};super(17,"comments",re,{"editor.comments.insertSpace":{type:"boolean",default:re.insertSpace,description:v.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:re.ignoreEmptyLines,description:v.localize(5,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const ve=re;return{insertSpace:l(ve.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:l(ve.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var r;(function(Q){Q[Q.Hidden=0]="Hidden",Q[Q.Blink=1]="Blink",Q[Q.Smooth=2]="Smooth",Q[Q.Phase=3]="Phase",Q[Q.Expand=4]="Expand",Q[Q.Solid=5]="Solid"})(r=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function i(Q){switch(Q){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var n;(function(Q){Q[Q.Line=1]="Line",Q[Q.Block=2]="Block",Q[Q.Underline=3]="Underline",Q[Q.LineThin=4]="LineThin",Q[Q.BlockOutline=5]="BlockOutline",Q[Q.UnderlineThin=6]="UnderlineThin"})(n=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function a(Q){switch(Q){case n.Line:return"line";case n.Block:return"block";case n.Underline:return"underline";case n.LineThin:return"line-thin";case n.BlockOutline:return"block-outline";case n.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=a;function p(Q){switch(Q){case"line":return n.Line;case"block":return n.Block;case"underline":return n.Underline;case"line-thin":return n.LineThin;case"block-outline":return n.BlockOutline;case"underline-thin":return n.UnderlineThin}}class d extends s{constructor(){super(125,[63,31])}compute(re,ve,Me){const Ne=["monaco-editor"];return ve.get(31)&&Ne.push(ve.get(31)),re.extraEditorClassName&&Ne.push(re.extraEditorClassName),ve.get(63)==="default"?Ne.push("mouse-default"):ve.get(63)==="copy"&&Ne.push("mouse-copy"),ve.get(98)&&Ne.push("showUnused"),ve.get(123)&&Ne.push("showDeprecated"),Ne.join(" ")}}class b extends g{constructor(){super(30,"emptySelectionClipboard",!0,{description:v.localize(6,null)})}compute(re,ve,Me){return Me&&re.emptySelectionClipboard}}class S extends P{constructor(){const re={cursorMoveOnType:!0,seedSearchStringFromSelection:!0,autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(33,"find",re,{"editor.find.cursorMoveOnType":{type:"boolean",default:re.cursorMoveOnType,description:v.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"boolean",default:re.seedSearchStringFromSelection,description:v.localize(8,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:re.autoFindInSelection,enumDescriptions:[v.localize(9,null),v.localize(10,null),v.localize(11,null)],description:v.localize(12,null)},"editor.find.globalFindClipboard":{type:"boolean",default:re.globalFindClipboard,description:v.localize(13,null),included:R.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:re.addExtraSpaceOnTop,description:v.localize(14,null)},"editor.find.loop":{type:"boolean",default:re.loop,description:v.localize(15,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const ve=re;return{cursorMoveOnType:l(ve.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:l(ve.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection),autoFindInSelection:typeof re.autoFindInSelection=="boolean"?re.autoFindInSelection?"always":"never":w(ve.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:l(ve.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:l(ve.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:l(ve.loop,this.defaultValue.loop)}}}class o extends P{constructor(){super(41,"fontLigatures",o.OFF,{anyOf:[{type:"boolean",description:v.localize(16,null)},{type:"string",description:v.localize(17,null)}],description:v.localize(18,null),default:!1})}validate(re){return typeof re=="undefined"?this.defaultValue:typeof re=="string"?re==="false"?o.OFF:re==="true"?o.ON:re:Boolean(re)?o.ON:o.OFF}}e.EditorFontLigatures=o,o.OFF='"liga" off, "calt" off',o.ON='"liga" on, "calt" on';class L extends s{constructor(){super(40)}compute(re,ve,Me){return re.fontInfo}}class O extends I{constructor(){super(42,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:v.localize(19,null)})}validate(re){let ve=f.float(re,this.defaultValue);return ve===0?e.EDITOR_FONT_DEFAULTS.fontSize:f.clamp(ve,6,100)}compute(re,ve,Me){return re.fontInfo.fontSize}}class W extends P{constructor(){super(43,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:W.MINIMUM_VALUE,maximum:W.MAXIMUM_VALUE,errorMessage:v.localize(20,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:W.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:v.localize(21,null)})}validate(re){return re==="normal"||re==="bold"?re:String(c.clampedInt(re,e.EDITOR_FONT_DEFAULTS.fontWeight,W.MINIMUM_VALUE,W.MAXIMUM_VALUE))}}W.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],W.MINIMUM_VALUE=1,W.MAXIMUM_VALUE=1e3;class J extends P{constructor(){const re={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ve={type:"string",enum:["peek","gotoAndPeek","goto"],default:re.multiple,enumDescriptions:[v.localize(22,null),v.localize(23,null),v.localize(24,null)]},Me=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(47,"gotoLocation",re,{"editor.gotoLocation.multiple":{deprecationMessage:v.localize(25,null)},"editor.gotoLocation.multipleDefinitions":Object.assign({description:v.localize(26,null)},ve),"editor.gotoLocation.multipleTypeDefinitions":Object.assign({description:v.localize(27,null)},ve),"editor.gotoLocation.multipleDeclarations":Object.assign({description:v.localize(28,null)},ve),"editor.gotoLocation.multipleImplementations":Object.assign({description:v.localize(29,null)},ve),"editor.gotoLocation.multipleReferences":Object.assign({description:v.localize(30,null)},ve),"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:re.alternativeDefinitionCommand,enum:Me,description:v.localize(31,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:re.alternativeTypeDefinitionCommand,enum:Me,description:v.localize(32,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:re.alternativeDeclarationCommand,enum:Me,description:v.localize(33,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:re.alternativeImplementationCommand,enum:Me,description:v.localize(34,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:re.alternativeReferenceCommand,enum:Me,description:v.localize(35,null)}})}validate(re){var ve,Me,Ne,Ye,Se;if(!re||typeof re!="object")return this.defaultValue;const _e=re;return{multiple:w(_e.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:(ve=_e.multipleDefinitions)!==null&&ve!==void 0?ve:w(_e.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:(Me=_e.multipleTypeDefinitions)!==null&&Me!==void 0?Me:w(_e.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:(Ne=_e.multipleDeclarations)!==null&&Ne!==void 0?Ne:w(_e.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:(Ye=_e.multipleImplementations)!==null&&Ye!==void 0?Ye:w(_e.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:(Se=_e.multipleReferences)!==null&&Se!==void 0?Se:w(_e.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:_.string(_e.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:_.string(_e.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:_.string(_e.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:_.string(_e.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:_.string(_e.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class oe extends P{constructor(){const re={enabled:!0,delay:300,sticky:!0};super(50,"hover",re,{"editor.hover.enabled":{type:"boolean",default:re.enabled,description:v.localize(36,null)},"editor.hover.delay":{type:"number",default:re.delay,description:v.localize(37,null)},"editor.hover.sticky":{type:"boolean",default:re.sticky,description:v.localize(38,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const ve=re;return{enabled:l(ve.enabled,this.defaultValue.enabled),delay:c.clampedInt(ve.delay,this.defaultValue.delay,0,1e4),sticky:l(ve.sticky,this.defaultValue.sticky)}}}var q;(function(Q){Q[Q.None=0]="None",Q[Q.Text=1]="Text",Q[Q.Blocks=2]="Blocks"})(q=e.RenderMinimap||(e.RenderMinimap={}));class x extends s{constructor(){super(128,[46,55,35,62,90,57,58,92,115,118,119,120,2])}compute(re,ve,Me){return x.computeLayout(ve,{memory:re.memory,outerWidth:re.outerWidth,outerHeight:re.outerHeight,isDominatedByLongLines:re.isDominatedByLongLines,lineHeight:re.fontInfo.lineHeight,viewLineCount:re.viewLineCount,lineNumbersDigitCount:re.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:re.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:re.fontInfo.maxDigitWidth,pixelRatio:re.pixelRatio})}static computeContainedMinimapLineCount(re){const ve=re.height/re.lineHeight,Me=re.scrollBeyondLastLine?ve-1:0,Ne=(re.viewLineCount+Me)/(re.pixelRatio*re.height),Ye=Math.floor(re.viewLineCount/Ne);return{typicalViewportLineCount:ve,extraLinesBeyondLastLine:Me,desiredRatio:Ne,minimapLineCount:Ye}}static _computeMinimapLayout(re,ve){const Me=re.outerWidth,Ne=re.outerHeight,Ye=re.pixelRatio;if(!re.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ye*Ne),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ne};const Se=ve.stableMinimapLayoutInput,_e=Se&&re.outerHeight===Se.outerHeight&&re.lineHeight===Se.lineHeight&&re.typicalHalfwidthCharacterWidth===Se.typicalHalfwidthCharacterWidth&&re.pixelRatio===Se.pixelRatio&&re.scrollBeyondLastLine===Se.scrollBeyondLastLine&&re.minimap.enabled===Se.minimap.enabled&&re.minimap.side===Se.minimap.side&&re.minimap.size===Se.minimap.size&&re.minimap.showSlider===Se.minimap.showSlider&&re.minimap.renderCharacters===Se.minimap.renderCharacters&&re.minimap.maxColumn===Se.minimap.maxColumn&&re.minimap.scale===Se.minimap.scale&&re.verticalScrollbarWidth===Se.verticalScrollbarWidth&&re.isViewportWrapping===Se.isViewportWrapping,ke=re.lineHeight,le=re.typicalHalfwidthCharacterWidth,fe=re.scrollBeyondLastLine,H=re.minimap.renderCharacters;let ee=Ye>=2?Math.round(re.minimap.scale*2):re.minimap.scale;const ue=re.minimap.maxColumn,Pe=re.minimap.size,Ae=re.minimap.side,xe=re.verticalScrollbarWidth,Be=re.viewLineCount,Qe=re.remainingWidth,rt=re.isViewportWrapping,nt=H?2:3;let Ze=Math.floor(Ye*Ne);const ot=Ze/Ye;let Ee=!1,De=!1,de=nt*ee,G=ee/Ye,Ue=1;if(Pe==="fill"||Pe==="fit"){const{typicalViewportLineCount:mt,extraLinesBeyondLastLine:St,desiredRatio:vt,minimapLineCount:bt}=x.computeContainedMinimapLineCount({viewLineCount:Be,scrollBeyondLastLine:fe,height:Ne,lineHeight:ke,pixelRatio:Ye});if(Be/bt>1)Ee=!0,De=!0,ee=1,de=1,G=ee/Ye;else{let ht=!1,kt=ee+1;if(Pe==="fit"){const _t=Math.ceil((Be+St)*de);rt&&_e&&Qe<=ve.stableFitRemainingWidth?(ht=!0,kt=ve.stableFitMaxMinimapScale):(ht=_t>Ze,rt&&ht?(ve.stableMinimapLayoutInput=re,ve.stableFitRemainingWidth=Qe):(ve.stableMinimapLayoutInput=null,ve.stableFitRemainingWidth=0))}if(Pe==="fill"||ht){Ee=!0;const _t=ee;de=Math.min(ke*Ye,Math.max(1,Math.floor(1/vt))),ee=Math.min(kt,Math.max(1,Math.floor(de/nt))),ee>_t&&(Ue=Math.min(2,ee/_t)),G=ee/Ye/Ue,Ze=Math.ceil(Math.max(mt,Be+St)*de),rt&&ht&&(ve.stableFitMaxMinimapScale=ee)}}}const Le=Math.floor(ue*G),Ge=Math.min(Le,Math.max(0,Math.floor((Qe-xe-2)*G/(le+G)))+e.MINIMAP_GUTTER_WIDTH);let Je=Math.floor(Ye*Ge);const lt=Je/Ye;Je=Math.floor(Je*Ue);const ct=H?1:2,it=Ae==="left"?0:Me-Ge-xe;return{renderMinimap:ct,minimapLeft:it,minimapWidth:Ge,minimapHeightIsEditorHeight:Ee,minimapIsSampling:De,minimapScale:ee,minimapLineHeight:de,minimapCanvasInnerWidth:Je,minimapCanvasInnerHeight:Ze,minimapCanvasOuterWidth:lt,minimapCanvasOuterHeight:ot}}static computeLayout(re,ve){const Me=ve.outerWidth|0,Ne=ve.outerHeight|0,Ye=ve.lineHeight|0,Se=ve.lineNumbersDigitCount|0,_e=ve.typicalHalfwidthCharacterWidth,ke=ve.maxDigitWidth,le=ve.pixelRatio,fe=ve.viewLineCount,H=re.get(120),ee=H==="inherit"?re.get(119):H,ue=ee==="inherit"?re.get(115):ee,Pe=re.get(118),Ae=re.get(2),xe=ve.isDominatedByLongLines,Be=re.get(46),Qe=re.get(57).renderType!==0,rt=re.get(58),nt=re.get(92),Ze=re.get(62),ot=re.get(90),Ee=ot.verticalScrollbarSize,De=ot.verticalHasArrows,de=ot.arrowSize,G=ot.horizontalScrollbarSize,Ue=re.get(55),Le=re.get(35);let Ge;if(typeof Ue=="string"&&/^\d+(\.\d+)?ch$/.test(Ue)){const Et=parseFloat(Ue.substr(0,Ue.length-2));Ge=c.clampedInt(Et*_e,0,0,1e3)}else Ge=c.clampedInt(Ue,0,0,1e3);Le&&(Ge+=16);let Je=0;if(Qe){const Et=Math.max(Se,rt);Je=Math.round(Et*ke)}let lt=0;Be&&(lt=Ye);let ct=0,it=ct+lt,mt=it+Je,St=mt+Ge;const vt=Me-lt-Je-Ge;let bt=!1,gt=!1,ht=-1;Ae!==2&&(ee==="inherit"&&xe?(bt=!0,gt=!0):ue==="on"||ue==="bounded"?gt=!0:ue==="wordWrapColumn"&&(ht=Pe));const kt=x._computeMinimapLayout({outerWidth:Me,outerHeight:Ne,lineHeight:Ye,typicalHalfwidthCharacterWidth:_e,pixelRatio:le,scrollBeyondLastLine:nt,minimap:Ze,verticalScrollbarWidth:Ee,viewLineCount:fe,remainingWidth:vt,isViewportWrapping:gt},ve.memory||new D);kt.renderMinimap!==0&&kt.minimapLeft===0&&(ct+=kt.minimapWidth,it+=kt.minimapWidth,mt+=kt.minimapWidth,St+=kt.minimapWidth);const _t=vt-kt.minimapWidth,It=Math.max(1,Math.floor((_t-Ee-2)/_e)),Lt=De?de:0;return gt&&(ht=Math.max(1,It),ue==="bounded"&&(ht=Math.min(ht,Pe))),{width:Me,height:Ne,glyphMarginLeft:ct,glyphMarginWidth:lt,lineNumbersLeft:it,lineNumbersWidth:Je,decorationsLeft:mt,decorationsWidth:Ge,contentLeft:St,contentWidth:_t,minimap:kt,viewportColumn:It,isWordWrapMinified:bt,isViewportWrapping:gt,wrappingColumn:ht,verticalScrollbarWidth:Ee,horizontalScrollbarHeight:G,overviewRuler:{top:Lt,width:Ee,height:Ne-2*Lt,right:0}}}}e.EditorLayoutInfoComputer=x;class V extends P{constructor(){const re={enabled:!0};super(54,"lightbulb",re,{"editor.lightbulb.enabled":{type:"boolean",default:re.enabled,description:v.localize(39,null)}})}validate(re){return!re||typeof re!="object"?this.defaultValue:{enabled:l(re.enabled,this.defaultValue.enabled)}}}class T extends P{constructor(){const re={enabled:!0,fontSize:0,fontFamily:e.EDITOR_FONT_DEFAULTS.fontFamily};super(124,"inlayHints",re,{"editor.inlayHints.enabled":{type:"boolean",default:re.enabled,description:v.localize(40,null)},"editor.inlayHints.fontSize":{type:"number",default:re.fontSize,description:v.localize(41,null)},"editor.inlayHints.fontFamily":{type:"string",default:re.fontFamily,description:v.localize(42,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const ve=re;return{enabled:l(ve.enabled,this.defaultValue.enabled),fontSize:c.clampedInt(ve.fontSize,this.defaultValue.fontSize,0,100),fontFamily:_.string(ve.fontFamily,this.defaultValue.fontFamily)}}}class N extends c{constructor(){super(56,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,0,150,{description:v.localize(43,null)})}compute(re,ve,Me){return re.fontInfo.lineHeight}}class F extends P{constructor(){const re={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(62,"minimap",re,{"editor.minimap.enabled":{type:"boolean",default:re.enabled,description:v.localize(44,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[v.localize(45,null),v.localize(46,null),v.localize(47,null)],default:re.size,description:v.localize(48,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:re.side,description:v.localize(49,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:re.showSlider,description:v.localize(50,null)},"editor.minimap.scale":{type:"number",default:re.scale,minimum:1,maximum:3,enum:[1,2,3],description:v.localize(51,null)},"editor.minimap.renderCharacters":{type:"boolean",default:re.renderCharacters,description:v.localize(52,null)},"editor.minimap.maxColumn":{type:"number",default:re.maxColumn,description:v.localize(53,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const ve=re;return{enabled:l(ve.enabled,this.defaultValue.enabled),size:w(ve.size,this.defaultValue.size,["proportional","fill","fit"]),side:w(ve.side,this.defaultValue.side,["right","left"]),showSlider:w(ve.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:l(ve.renderCharacters,this.defaultValue.renderCharacters),scale:c.clampedInt(ve.scale,1,1,3),maxColumn:c.clampedInt(ve.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function M(Q){return Q==="ctrlCmd"?R.isMacintosh?"metaKey":"ctrlKey":"altKey"}class U extends P{constructor(){super(72,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:v.localize(54,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:v.localize(55,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const ve=re;return{top:c.clampedInt(ve.top,0,0,1e3),bottom:c.clampedInt(ve.bottom,0,0,1e3)}}}class B extends P{constructor(){const re={enabled:!0,cycle:!1};super(73,"parameterHints",re,{"editor.parameterHints.enabled":{type:"boolean",default:re.enabled,description:v.localize(56,null)},"editor.parameterHints.cycle":{type:"boolean",default:re.cycle,description:v.localize(57,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const ve=re;return{enabled:l(ve.enabled,this.defaultValue.enabled),cycle:l(ve.cycle,this.defaultValue.cycle)}}}class K extends s{constructor(){super(126)}compute(re,ve,Me){return re.pixelRatio}}class ie extends P{constructor(){const re={other:!0,comments:!1,strings:!1};super(76,"quickSuggestions",re,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:re.strings,description:v.localize(58,null)},comments:{type:"boolean",default:re.comments,description:v.localize(59,null)},other:{type:"boolean",default:re.other,description:v.localize(60,null)}}}],default:re,description:v.localize(61,null)});this.defaultValue=re}validate(re){if(typeof re=="boolean")return re;if(re&&typeof re=="object"){const ve=re,Me={other:l(ve.other,this.defaultValue.other),comments:l(ve.comments,this.defaultValue.comments),strings:l(ve.strings,this.defaultValue.strings)};return Me.other&&Me.comments&&Me.strings?!0:!Me.other&&!Me.comments&&!Me.strings?!1:Me}return this.defaultValue}}var we;(function(Q){Q[Q.Off=0]="Off",Q[Q.On=1]="On",Q[Q.Relative=2]="Relative",Q[Q.Interval=3]="Interval",Q[Q.Custom=4]="Custom"})(we=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Te extends P{constructor(){super(57,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[v.localize(62,null),v.localize(63,null),v.localize(64,null),v.localize(65,null)],default:"on",description:v.localize(66,null)})}validate(re){let ve=this.defaultValue.renderType,Me=this.defaultValue.renderFn;return typeof re!="undefined"&&(typeof re=="function"?(ve=4,Me=re):re==="interval"?ve=3:re==="relative"?ve=2:re==="on"?ve=1:ve=0),{renderType:ve,renderFn:Me}}}function ye(Q){const re=Q.get(85);return re==="editable"?Q.get(78):re!=="on"}e.filterValidationDecorations=ye;class Oe extends P{constructor(){const re=[],ve={type:"number",description:v.localize(67,null)};super(89,"rulers",re,{type:"array",items:{anyOf:[ve,{type:["object"],properties:{column:ve,color:{type:"string",description:v.localize(68,null),format:"color-hex"}}}]},default:re,description:v.localize(69,null)})}validate(re){if(Array.isArray(re)){let ve=[];for(let Me of re)if(typeof Me=="number")ve.push({column:c.clampedInt(Me,0,0,1e4),color:null});else if(Me&&typeof Me=="object"){const Ne=Me;ve.push({column:c.clampedInt(Ne.column,0,0,1e4),color:Ne.color})}return ve.sort((Me,Ne)=>Me.column-Ne.column),ve}return this.defaultValue}}function je(Q,re){if(typeof Q!="string")return re;switch(Q){case"hidden":return 2;case"visible":return 3;default:return 1}}class ze extends P{constructor(){super(90,"scrollbar",{vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const ve=re,Me=c.clampedInt(ve.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ne=c.clampedInt(ve.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:c.clampedInt(ve.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:je(ve.vertical,this.defaultValue.vertical),horizontal:je(ve.horizontal,this.defaultValue.horizontal),useShadows:l(ve.useShadows,this.defaultValue.useShadows),verticalHasArrows:l(ve.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:l(ve.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:l(ve.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:l(ve.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Me,horizontalSliderSize:c.clampedInt(ve.horizontalSliderSize,Me,0,1e3),verticalScrollbarSize:Ne,verticalSliderSize:c.clampedInt(ve.verticalSliderSize,Ne,0,1e3),scrollByPage:l(ve.scrollByPage,this.defaultValue.scrollByPage)}}}class qe extends P{constructor(){const re={enabled:!1};super(52,"inlineSuggest",re,{"editor.inlineSuggest.enabled":{type:"boolean",default:re.enabled,description:v.localize(70,null)}})}validate(re){return!re||typeof re!="object"?this.defaultValue:{enabled:l(re.enabled,this.defaultValue.enabled)}}}class j extends P{constructor(){const re={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(104,"suggest",re,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[v.localize(71,null),v.localize(72,null)],default:re.insertMode,description:v.localize(73,null)},"editor.suggest.filterGraceful":{type:"boolean",default:re.filterGraceful,description:v.localize(74,null)},"editor.suggest.localityBonus":{type:"boolean",default:re.localityBonus,description:v.localize(75,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:re.shareSuggestSelections,markdownDescription:v.localize(76,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:re.snippetsPreventQuickSuggestions,description:v.localize(77,null)},"editor.suggest.showIcons":{type:"boolean",default:re.showIcons,description:v.localize(78,null)},"editor.suggest.showStatusBar":{type:"boolean",default:re.showStatusBar,description:v.localize(79,null)},"editor.suggest.preview":{type:"boolean",default:re.preview,description:v.localize(80,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:re.showInlineDetails,description:v.localize(81,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:v.localize(82,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:v.localize(83,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:v.localize(84,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:v.localize(85,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:v.localize(86,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:v.localize(87,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:v.localize(88,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:v.localize(89,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:v.localize(90,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:v.localize(91,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:v.localize(92,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:v.localize(93,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:v.localize(94,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:v.localize(95,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:v.localize(96,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:v.localize(97,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:v.localize(98,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:v.localize(99,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:v.localize(100,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:v.localize(101,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:v.localize(102,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:v.localize(103,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:v.localize(104,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:v.localize(105,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:v.localize(106,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:v.localize(107,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:v.localize(108,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:v.localize(109,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:v.localize(110,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:v.localize(111,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:v.localize(112,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const ve=re;return{insertMode:w(ve.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:l(ve.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:l(ve.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:l(ve.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:l(ve.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:l(ve.showIcons,this.defaultValue.showIcons),showStatusBar:l(ve.showStatusBar,this.defaultValue.showStatusBar),preview:l(ve.preview,this.defaultValue.preview),showInlineDetails:l(ve.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:l(ve.showMethods,this.defaultValue.showMethods),showFunctions:l(ve.showFunctions,this.defaultValue.showFunctions),showConstructors:l(ve.showConstructors,this.defaultValue.showConstructors),showDeprecated:l(ve.showDeprecated,this.defaultValue.showDeprecated),showFields:l(ve.showFields,this.defaultValue.showFields),showVariables:l(ve.showVariables,this.defaultValue.showVariables),showClasses:l(ve.showClasses,this.defaultValue.showClasses),showStructs:l(ve.showStructs,this.defaultValue.showStructs),showInterfaces:l(ve.showInterfaces,this.defaultValue.showInterfaces),showModules:l(ve.showModules,this.defaultValue.showModules),showProperties:l(ve.showProperties,this.defaultValue.showProperties),showEvents:l(ve.showEvents,this.defaultValue.showEvents),showOperators:l(ve.showOperators,this.defaultValue.showOperators),showUnits:l(ve.showUnits,this.defaultValue.showUnits),showValues:l(ve.showValues,this.defaultValue.showValues),showConstants:l(ve.showConstants,this.defaultValue.showConstants),showEnums:l(ve.showEnums,this.defaultValue.showEnums),showEnumMembers:l(ve.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:l(ve.showKeywords,this.defaultValue.showKeywords),showWords:l(ve.showWords,this.defaultValue.showWords),showColors:l(ve.showColors,this.defaultValue.showColors),showFiles:l(ve.showFiles,this.defaultValue.showFiles),showReferences:l(ve.showReferences,this.defaultValue.showReferences),showFolders:l(ve.showFolders,this.defaultValue.showFolders),showTypeParameters:l(ve.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:l(ve.showSnippets,this.defaultValue.showSnippets),showUsers:l(ve.showUsers,this.defaultValue.showUsers),showIssues:l(ve.showIssues,this.defaultValue.showIssues)}}}class Z extends P{constructor(){super(100,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:v.localize(113,null),default:!0,type:"boolean"}})}validate(re){return!re||typeof re!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:l(re.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class ne extends s{constructor(){super(127,[78])}compute(re,ve,Me){return ve.get(78)?!0:re.tabFocusMode}}var ae;(function(Q){Q[Q.None=0]="None",Q[Q.Same=1]="Same",Q[Q.Indent=2]="Indent",Q[Q.DeepIndent=3]="DeepIndent"})(ae=e.WrappingIndent||(e.WrappingIndent={}));function Y(Q){switch(Q){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class ce extends s{constructor(){super(129,[128])}compute(re,ve,Me){const Ne=ve.get(128);return{isDominatedByLongLines:re.isDominatedByLongLines,isWordWrapMinified:Ne.isWordWrapMinified,isViewportWrapping:Ne.isViewportWrapping,wrappingColumn:Ne.wrappingColumn}}}const me="Consolas, 'Courier New', monospace",Re="Menlo, Monaco, 'Courier New', monospace",He="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:R.isMacintosh?Re:R.isLinux?He:me,fontWeight:"normal",fontSize:R.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0},e.editorOptionsRegistry=[];function be(Q){return e.editorOptionsRegistry[Q.id]=Q,Q}var Xe;(function(Q){Q[Q.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Q[Q.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Q[Q.accessibilitySupport=2]="accessibilitySupport",Q[Q.accessibilityPageSize=3]="accessibilityPageSize",Q[Q.ariaLabel=4]="ariaLabel",Q[Q.autoClosingBrackets=5]="autoClosingBrackets",Q[Q.autoClosingDelete=6]="autoClosingDelete",Q[Q.autoClosingOvertype=7]="autoClosingOvertype",Q[Q.autoClosingQuotes=8]="autoClosingQuotes",Q[Q.autoIndent=9]="autoIndent",Q[Q.automaticLayout=10]="automaticLayout",Q[Q.autoSurround=11]="autoSurround",Q[Q.codeLens=12]="codeLens",Q[Q.codeLensFontFamily=13]="codeLensFontFamily",Q[Q.codeLensFontSize=14]="codeLensFontSize",Q[Q.colorDecorators=15]="colorDecorators",Q[Q.columnSelection=16]="columnSelection",Q[Q.comments=17]="comments",Q[Q.contextmenu=18]="contextmenu",Q[Q.copyWithSyntaxHighlighting=19]="copyWithSyntaxHighlighting",Q[Q.cursorBlinking=20]="cursorBlinking",Q[Q.cursorSmoothCaretAnimation=21]="cursorSmoothCaretAnimation",Q[Q.cursorStyle=22]="cursorStyle",Q[Q.cursorSurroundingLines=23]="cursorSurroundingLines",Q[Q.cursorSurroundingLinesStyle=24]="cursorSurroundingLinesStyle",Q[Q.cursorWidth=25]="cursorWidth",Q[Q.disableLayerHinting=26]="disableLayerHinting",Q[Q.disableMonospaceOptimizations=27]="disableMonospaceOptimizations",Q[Q.domReadOnly=28]="domReadOnly",Q[Q.dragAndDrop=29]="dragAndDrop",Q[Q.emptySelectionClipboard=30]="emptySelectionClipboard",Q[Q.extraEditorClassName=31]="extraEditorClassName",Q[Q.fastScrollSensitivity=32]="fastScrollSensitivity",Q[Q.find=33]="find",Q[Q.fixedOverflowWidgets=34]="fixedOverflowWidgets",Q[Q.folding=35]="folding",Q[Q.foldingStrategy=36]="foldingStrategy",Q[Q.foldingHighlight=37]="foldingHighlight",Q[Q.unfoldOnClickAfterEndOfLine=38]="unfoldOnClickAfterEndOfLine",Q[Q.fontFamily=39]="fontFamily",Q[Q.fontInfo=40]="fontInfo",Q[Q.fontLigatures=41]="fontLigatures",Q[Q.fontSize=42]="fontSize",Q[Q.fontWeight=43]="fontWeight",Q[Q.formatOnPaste=44]="formatOnPaste",Q[Q.formatOnType=45]="formatOnType",Q[Q.glyphMargin=46]="glyphMargin",Q[Q.gotoLocation=47]="gotoLocation",Q[Q.hideCursorInOverviewRuler=48]="hideCursorInOverviewRuler",Q[Q.highlightActiveIndentGuide=49]="highlightActiveIndentGuide",Q[Q.hover=50]="hover",Q[Q.inDiffEditor=51]="inDiffEditor",Q[Q.inlineSuggest=52]="inlineSuggest",Q[Q.letterSpacing=53]="letterSpacing",Q[Q.lightbulb=54]="lightbulb",Q[Q.lineDecorationsWidth=55]="lineDecorationsWidth",Q[Q.lineHeight=56]="lineHeight",Q[Q.lineNumbers=57]="lineNumbers",Q[Q.lineNumbersMinChars=58]="lineNumbersMinChars",Q[Q.linkedEditing=59]="linkedEditing",Q[Q.links=60]="links",Q[Q.matchBrackets=61]="matchBrackets",Q[Q.minimap=62]="minimap",Q[Q.mouseStyle=63]="mouseStyle",Q[Q.mouseWheelScrollSensitivity=64]="mouseWheelScrollSensitivity",Q[Q.mouseWheelZoom=65]="mouseWheelZoom",Q[Q.multiCursorMergeOverlapping=66]="multiCursorMergeOverlapping",Q[Q.multiCursorModifier=67]="multiCursorModifier",Q[Q.multiCursorPaste=68]="multiCursorPaste",Q[Q.occurrencesHighlight=69]="occurrencesHighlight",Q[Q.overviewRulerBorder=70]="overviewRulerBorder",Q[Q.overviewRulerLanes=71]="overviewRulerLanes",Q[Q.padding=72]="padding",Q[Q.parameterHints=73]="parameterHints",Q[Q.peekWidgetDefaultFocus=74]="peekWidgetDefaultFocus",Q[Q.definitionLinkOpensInPeek=75]="definitionLinkOpensInPeek",Q[Q.quickSuggestions=76]="quickSuggestions",Q[Q.quickSuggestionsDelay=77]="quickSuggestionsDelay",Q[Q.readOnly=78]="readOnly",Q[Q.renameOnType=79]="renameOnType",Q[Q.renderControlCharacters=80]="renderControlCharacters",Q[Q.renderIndentGuides=81]="renderIndentGuides",Q[Q.renderFinalNewline=82]="renderFinalNewline",Q[Q.renderLineHighlight=83]="renderLineHighlight",Q[Q.renderLineHighlightOnlyWhenFocus=84]="renderLineHighlightOnlyWhenFocus",Q[Q.renderValidationDecorations=85]="renderValidationDecorations",Q[Q.renderWhitespace=86]="renderWhitespace",Q[Q.revealHorizontalRightPadding=87]="revealHorizontalRightPadding",Q[Q.roundedSelection=88]="roundedSelection",Q[Q.rulers=89]="rulers",Q[Q.scrollbar=90]="scrollbar",Q[Q.scrollBeyondLastColumn=91]="scrollBeyondLastColumn",Q[Q.scrollBeyondLastLine=92]="scrollBeyondLastLine",Q[Q.scrollPredominantAxis=93]="scrollPredominantAxis",Q[Q.selectionClipboard=94]="selectionClipboard",Q[Q.selectionHighlight=95]="selectionHighlight",Q[Q.selectOnLineNumbers=96]="selectOnLineNumbers",Q[Q.showFoldingControls=97]="showFoldingControls",Q[Q.showUnused=98]="showUnused",Q[Q.snippetSuggestions=99]="snippetSuggestions",Q[Q.smartSelect=100]="smartSelect",Q[Q.smoothScrolling=101]="smoothScrolling",Q[Q.stickyTabStops=102]="stickyTabStops",Q[Q.stopRenderingLineAfter=103]="stopRenderingLineAfter",Q[Q.suggest=104]="suggest",Q[Q.suggestFontSize=105]="suggestFontSize",Q[Q.suggestLineHeight=106]="suggestLineHeight",Q[Q.suggestOnTriggerCharacters=107]="suggestOnTriggerCharacters",Q[Q.suggestSelection=108]="suggestSelection",Q[Q.tabCompletion=109]="tabCompletion",Q[Q.tabIndex=110]="tabIndex",Q[Q.unusualLineTerminators=111]="unusualLineTerminators",Q[Q.useShadowDOM=112]="useShadowDOM",Q[Q.useTabStops=113]="useTabStops",Q[Q.wordSeparators=114]="wordSeparators",Q[Q.wordWrap=115]="wordWrap",Q[Q.wordWrapBreakAfterCharacters=116]="wordWrapBreakAfterCharacters",Q[Q.wordWrapBreakBeforeCharacters=117]="wordWrapBreakBeforeCharacters",Q[Q.wordWrapColumn=118]="wordWrapColumn",Q[Q.wordWrapOverride1=119]="wordWrapOverride1",Q[Q.wordWrapOverride2=120]="wordWrapOverride2",Q[Q.wrappingIndent=121]="wrappingIndent",Q[Q.wrappingStrategy=122]="wrappingStrategy",Q[Q.showDeprecated=123]="showDeprecated",Q[Q.inlayHints=124]="inlayHints",Q[Q.editorClassName=125]="editorClassName",Q[Q.pixelRatio=126]="pixelRatio",Q[Q.tabFocusMode=127]="tabFocusMode",Q[Q.layoutInfo=128]="layoutInfo",Q[Q.wrappingInfo=129]="wrappingInfo"})(Xe=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:be(new g(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:v.localize(114,null)})),acceptSuggestionOnEnter:be(new E(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",v.localize(115,null),""],markdownDescription:v.localize(116,null)})),accessibilitySupport:be(new m),accessibilityPageSize:be(new c(3,"accessibilityPageSize",10,1,1073741824,{description:v.localize(117,null)})),ariaLabel:be(new _(4,"ariaLabel",v.localize(118,null))),autoClosingBrackets:be(new E(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",v.localize(119,null),v.localize(120,null),""],description:v.localize(121,null)})),autoClosingDelete:be(new E(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",v.localize(122,null),""],description:v.localize(123,null)})),autoClosingOvertype:be(new E(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",v.localize(124,null),""],description:v.localize(125,null)})),autoClosingQuotes:be(new E(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",v.localize(126,null),v.localize(127,null),""],description:v.localize(128,null)})),autoIndent:be(new u(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],h,{enumDescriptions:[v.localize(129,null),v.localize(130,null),v.localize(131,null),v.localize(132,null),v.localize(133,null)],description:v.localize(134,null)})),automaticLayout:be(new g(10,"automaticLayout",!1)),autoSurround:be(new E(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[v.localize(135,null),v.localize(136,null),v.localize(137,null),""],description:v.localize(138,null)})),stickyTabStops:be(new g(102,"stickyTabStops",!1,{description:v.localize(139,null)})),codeLens:be(new g(12,"codeLens",!0,{description:v.localize(140,null)})),codeLensFontFamily:be(new _(13,"codeLensFontFamily","",{description:v.localize(141,null)})),codeLensFontSize:be(new c(14,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,description:v.localize(142,null)})),colorDecorators:be(new g(15,"colorDecorators",!0,{description:v.localize(143,null)})),columnSelection:be(new g(16,"columnSelection",!1,{description:v.localize(144,null)})),comments:be(new t),contextmenu:be(new g(18,"contextmenu",!0)),copyWithSyntaxHighlighting:be(new g(19,"copyWithSyntaxHighlighting",!0,{description:v.localize(145,null)})),cursorBlinking:be(new u(20,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],i,{description:v.localize(146,null)})),cursorSmoothCaretAnimation:be(new g(21,"cursorSmoothCaretAnimation",!1,{description:v.localize(147,null)})),cursorStyle:be(new u(22,"cursorStyle",n.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],p,{description:v.localize(148,null)})),cursorSurroundingLines:be(new c(23,"cursorSurroundingLines",0,0,1073741824,{description:v.localize(149,null)})),cursorSurroundingLinesStyle:be(new E(24,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[v.localize(150,null),v.localize(151,null)],description:v.localize(152,null)})),cursorWidth:be(new c(25,"cursorWidth",0,0,1073741824,{markdownDescription:v.localize(153,null)})),disableLayerHinting:be(new g(26,"disableLayerHinting",!1)),disableMonospaceOptimizations:be(new g(27,"disableMonospaceOptimizations",!1)),domReadOnly:be(new g(28,"domReadOnly",!1)),dragAndDrop:be(new g(29,"dragAndDrop",!0,{description:v.localize(154,null)})),emptySelectionClipboard:be(new b),extraEditorClassName:be(new _(31,"extraEditorClassName","")),fastScrollSensitivity:be(new f(32,"fastScrollSensitivity",5,Q=>Q<=0?5:Q,{markdownDescription:v.localize(155,null)})),find:be(new S),fixedOverflowWidgets:be(new g(34,"fixedOverflowWidgets",!1)),folding:be(new g(35,"folding",!0,{description:v.localize(156,null)})),foldingStrategy:be(new E(36,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[v.localize(157,null),v.localize(158,null)],description:v.localize(159,null)})),foldingHighlight:be(new g(37,"foldingHighlight",!0,{description:v.localize(160,null)})),unfoldOnClickAfterEndOfLine:be(new g(38,"unfoldOnClickAfterEndOfLine",!1,{description:v.localize(161,null)})),fontFamily:be(new _(39,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:v.localize(162,null)})),fontInfo:be(new L),fontLigatures2:be(new o),fontSize:be(new O),fontWeight:be(new W),formatOnPaste:be(new g(44,"formatOnPaste",!1,{description:v.localize(163,null)})),formatOnType:be(new g(45,"formatOnType",!1,{description:v.localize(164,null)})),glyphMargin:be(new g(46,"glyphMargin",!0,{description:v.localize(165,null)})),gotoLocation:be(new J),hideCursorInOverviewRuler:be(new g(48,"hideCursorInOverviewRuler",!1,{description:v.localize(166,null)})),highlightActiveIndentGuide:be(new g(49,"highlightActiveIndentGuide",!0,{description:v.localize(167,null)})),hover:be(new oe),inDiffEditor:be(new g(51,"inDiffEditor",!1)),letterSpacing:be(new f(53,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Q=>f.clamp(Q,-5,20),{description:v.localize(168,null)})),lightbulb:be(new V),lineDecorationsWidth:be(new I(55,"lineDecorationsWidth",10)),lineHeight:be(new N),lineNumbers:be(new Te),lineNumbersMinChars:be(new c(58,"lineNumbersMinChars",5,1,300)),linkedEditing:be(new g(59,"linkedEditing",!1,{description:v.localize(169,null)})),links:be(new g(60,"links",!0,{description:v.localize(170,null)})),matchBrackets:be(new E(61,"matchBrackets","always",["always","near","never"],{description:v.localize(171,null)})),minimap:be(new F),mouseStyle:be(new E(63,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:be(new f(64,"mouseWheelScrollSensitivity",1,Q=>Q===0?1:Q,{markdownDescription:v.localize(172,null)})),mouseWheelZoom:be(new g(65,"mouseWheelZoom",!1,{markdownDescription:v.localize(173,null)})),multiCursorMergeOverlapping:be(new g(66,"multiCursorMergeOverlapping",!0,{description:v.localize(174,null)})),multiCursorModifier:be(new u(67,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],M,{markdownEnumDescriptions:[v.localize(175,null),v.localize(176,null)],markdownDescription:v.localize(177,null)})),multiCursorPaste:be(new E(68,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[v.localize(178,null),v.localize(179,null)],markdownDescription:v.localize(180,null)})),occurrencesHighlight:be(new g(69,"occurrencesHighlight",!0,{description:v.localize(181,null)})),overviewRulerBorder:be(new g(70,"overviewRulerBorder",!0,{description:v.localize(182,null)})),overviewRulerLanes:be(new c(71,"overviewRulerLanes",3,0,3)),padding:be(new U),parameterHints:be(new B),peekWidgetDefaultFocus:be(new E(74,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[v.localize(183,null),v.localize(184,null)],description:v.localize(185,null)})),definitionLinkOpensInPeek:be(new g(75,"definitionLinkOpensInPeek",!1,{description:v.localize(186,null)})),quickSuggestions:be(new ie),quickSuggestionsDelay:be(new c(77,"quickSuggestionsDelay",10,0,1073741824,{description:v.localize(187,null)})),readOnly:be(new g(78,"readOnly",!1)),renameOnType:be(new g(79,"renameOnType",!1,{description:v.localize(188,null),markdownDeprecationMessage:v.localize(189,null)})),renderControlCharacters:be(new g(80,"renderControlCharacters",!1,{description:v.localize(190,null)})),renderIndentGuides:be(new g(81,"renderIndentGuides",!0,{description:v.localize(191,null)})),renderFinalNewline:be(new g(82,"renderFinalNewline",!0,{description:v.localize(192,null)})),renderLineHighlight:be(new E(83,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",v.localize(193,null)],description:v.localize(194,null)})),renderLineHighlightOnlyWhenFocus:be(new g(84,"renderLineHighlightOnlyWhenFocus",!1,{description:v.localize(195,null)})),renderValidationDecorations:be(new E(85,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:be(new E(86,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",v.localize(196,null),v.localize(197,null),v.localize(198,null),""],description:v.localize(199,null)})),revealHorizontalRightPadding:be(new c(87,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:be(new g(88,"roundedSelection",!0,{description:v.localize(200,null)})),rulers:be(new Oe),scrollbar:be(new ze),scrollBeyondLastColumn:be(new c(91,"scrollBeyondLastColumn",5,0,1073741824,{description:v.localize(201,null)})),scrollBeyondLastLine:be(new g(92,"scrollBeyondLastLine",!0,{description:v.localize(202,null)})),scrollPredominantAxis:be(new g(93,"scrollPredominantAxis",!0,{description:v.localize(203,null)})),selectionClipboard:be(new g(94,"selectionClipboard",!0,{description:v.localize(204,null),included:R.isLinux})),selectionHighlight:be(new g(95,"selectionHighlight",!0,{description:v.localize(205,null)})),selectOnLineNumbers:be(new g(96,"selectOnLineNumbers",!0)),showFoldingControls:be(new E(97,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[v.localize(206,null),v.localize(207,null)],description:v.localize(208,null)})),showUnused:be(new g(98,"showUnused",!0,{description:v.localize(209,null)})),showDeprecated:be(new g(123,"showDeprecated",!0,{description:v.localize(210,null)})),inlayHints:be(new T),snippetSuggestions:be(new E(99,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[v.localize(211,null),v.localize(212,null),v.localize(213,null),v.localize(214,null)],description:v.localize(215,null)})),smartSelect:be(new Z),smoothScrolling:be(new g(101,"smoothScrolling",!1,{description:v.localize(216,null)})),stopRenderingLineAfter:be(new c(103,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:be(new j),inlineSuggest:be(new qe),suggestFontSize:be(new c(105,"suggestFontSize",0,0,1e3,{markdownDescription:v.localize(217,null)})),suggestLineHeight:be(new c(106,"suggestLineHeight",0,0,1e3,{markdownDescription:v.localize(218,null)})),suggestOnTriggerCharacters:be(new g(107,"suggestOnTriggerCharacters",!0,{description:v.localize(219,null)})),suggestSelection:be(new E(108,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[v.localize(220,null),v.localize(221,null),v.localize(222,null)],description:v.localize(223,null)})),tabCompletion:be(new E(109,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[v.localize(224,null),v.localize(225,null),v.localize(226,null)],description:v.localize(227,null)})),tabIndex:be(new c(110,"tabIndex",0,-1,1073741824)),unusualLineTerminators:be(new E(111,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[v.localize(228,null),v.localize(229,null),v.localize(230,null)],description:v.localize(231,null)})),useShadowDOM:be(new g(112,"useShadowDOM",!0)),useTabStops:be(new g(113,"useTabStops",!0,{description:v.localize(232,null)})),wordSeparators:be(new _(114,"wordSeparators",k.USUAL_WORD_SEPARATORS,{description:v.localize(233,null)})),wordWrap:be(new E(115,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[v.localize(234,null),v.localize(235,null),v.localize(236,null),v.localize(237,null)],description:v.localize(238,null)})),wordWrapBreakAfterCharacters:be(new _(116,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:be(new _(117,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:be(new c(118,"wordWrapColumn",80,1,1073741824,{markdownDescription:v.localize(239,null)})),wordWrapOverride1:be(new E(119,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:be(new E(120,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:be(new u(121,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Y,{enumDescriptions:[v.localize(240,null),v.localize(241,null),v.localize(242,null),v.localize(243,null)],description:v.localize(244,null)})),wrappingStrategy:be(new E(122,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[v.localize(245,null),v.localize(246,null)],description:v.localize(247,null)})),editorClassName:be(new d),pixelRatio:be(new K),tabFocusMode:be(new ne),layoutInfo:be(new x),wrappingInfo:be(new ce)}}),define(ge[151],pe([19,20]),function(X,e){return X.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ge[152],pe([19,20]),function(X,e){return X.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ge[153],pe([19,20]),function(X,e){return X.create("vs/platform/extensions/common/extensionValidator",e)}),define(ge[154],pe([19,20]),function(X,e){return X.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ge[155],pe([19,20]),function(X,e){return X.create("vs/platform/files/common/files",e)}),define(ge[156],pe([19,20]),function(X,e){return X.create("vs/platform/markers/common/markers",e)}),define(ge[157],pe([19,20]),function(X,e){return X.create("vs/platform/workspaces/common/workspaces",e)}),define(ge[158],pe([19,20]),function(X,e){return X.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ge[159],pe([19,20]),function(X,e){return X.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ge[160],pe([19,20]),function(X,e){return X.create("vs/workbench/api/common/extHostProgress",e)}),define(ge[161],pe([19,20]),function(X,e){return X.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ge[162],pe([19,20]),function(X,e){return X.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ge[163],pe([19,20]),function(X,e){return X.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ge[164],pe([19,20]),function(X,e){return X.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ge[165],pe([19,20]),function(X,e){return X.create("vs/workbench/api/node/extHostDebugService",e)}),define(ge[166],pe([19,20]),function(X,e){return X.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ge[167],pe([19,20]),function(X,e){return X.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(ge[168],pe([19,20]),function(X,e){return X.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(ge[169],pe([19,20]),function(X,e){return X.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(ge[170],pe([19,20]),function(X,e){return X.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ge[171],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorOverride=e.EditorActivation=void 0;var v;(function(A){A[A.ACTIVATE=0]="ACTIVATE",A[A.RESTORE=1]="RESTORE",A[A.PRESERVE=2]="PRESERVE"})(v=e.EditorActivation||(e.EditorActivation={}));var R;(function(A){A[A.PICK=1]="PICK",A[A.DISABLED=2]="DISABLED"})(R=e.EditorOverride||(e.EditorOverride={}));var k;(function(A){A[A.API=0]="API",A[A.USER=1]="USER"})(k=e.EditorOpenContext||(e.EditorOpenContext={}));var y;(function(A){A[A.Center=0]="Center",A[A.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",A[A.NearTop=2]="NearTop",A[A.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(y=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(ge[172],pe([0,1,153]),function(X,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,k=/^-(\d{4})(\d{2})(\d{2})$/;function y(l){return l=l.trim(),l==="*"||R.test(l)}e.isValidVersionStr=y;function A(l){if(!y(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let g=l.match(R);return g?{hasCaret:g[1]==="^",hasGreaterEquals:g[1]===">=",majorBase:g[2]==="x"?0:parseInt(g[2],10),majorMustEqual:g[2]!=="x",minorBase:g[4]==="x"?0:parseInt(g[4],10),minorMustEqual:g[4]!=="x",patchBase:g[6]==="x"?0:parseInt(g[6],10),patchMustEqual:g[6]!=="x",preRelease:g[8]||null}:null}e.parseVersion=A;function C(l){if(!l)return null;let g=l.majorBase,c=l.majorMustEqual,f=l.minorBase,_=l.minorMustEqual,w=l.patchBase,E=l.patchMustEqual;l.hasCaret&&(g===0||(_=!1),E=!1);let u=0;if(l.preRelease){const h=k.exec(l.preRelease);if(h){const[,m,t,r]=h;u=Date.UTC(Number(m),Number(t)-1,Number(r))}}return{majorBase:g,majorMustEqual:c,minorBase:f,minorMustEqual:_,patchBase:w,patchMustEqual:E,isMinimum:l.hasGreaterEquals,notBefore:u}}e.normalizeVersion=C;function D(l,g,c){let f;typeof l=="string"?f=C(A(l)):f=l;let _;g instanceof Date?_=g.getTime():typeof g=="string"&&(_=new Date(g).getTime());let w;if(typeof c=="string"?w=C(A(c)):w=c,!f||!w)return!1;let E=f.majorBase,u=f.minorBase,h=f.patchBase,m=w.majorBase,t=w.minorBase,r=w.patchBase,i=w.notBefore,n=w.majorMustEqual,a=w.minorMustEqual,p=w.patchMustEqual;return w.isMinimum?E>m?!0:E<m?!1:u>t?!0:u<t||_&&_<i?!1:h>=r:(E===1&&m===0&&(!n||!a||!p)&&(m=1,t=0,r=0,n=!0,a=!1,p=!1),E<m?!1:E>m?!n:u<t?!1:u>t?!a:h<r?!1:h>r?!p:!(_&&_<i))}e.isValidVersion=D;function P(l,g,c,f){return c.isBuiltin||typeof c.main=="undefined"?!0:I(l,g,c.engines.vscode,f)}e.isValidExtensionVersion=P;function s(l,g,c){return l==="*"||I(g,c,l)}e.isEngineValid=s;function I(l,g,c,f=[]){let _=C(A(c));if(!_)return f.push(v.localize(0,null,c)),!1;if(_.majorBase===0){if(!_.majorMustEqual||!_.minorMustEqual)return f.push(v.localize(1,null,c)),!1}else if(!_.majorMustEqual)return f.push(v.localize(2,null,c)),!1;return D(l,g,_)?!0:(f.push(v.localize(3,null,l,c)),!1)}}),define(ge[110],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class v{constructor(y,A=[],C=!1){this.ctor=y,this.staticArguments=A,this.supportsDelayedInstantiation=C}}e.SyncDescriptor=v;const R=(k,...y)=>new v(k,y);e.createSyncDescriptor=R}),define(ge[78],pe([0,1,110]),function(X,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const R=[];function k(A,C,D){C instanceof v.SyncDescriptor||(C=new v.SyncDescriptor(C,[],D)),R.push([A,C])}e.registerSingleton=k;function y(){return R}e.getSingletonServiceDescriptors=y}),define(ge[173],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class v{constructor(y){this.incoming=new Map,this.outgoing=new Map,this.data=y}}e.Node=v;class R{constructor(y){this._hashFn=y,this._nodes=new Map}roots(){const y=[];for(let A of this._nodes.values())A.outgoing.size===0&&y.push(A);return y}insertEdge(y,A){const C=this.lookupOrInsertNode(y),D=this.lookupOrInsertNode(A);C.outgoing.set(this._hashFn(A),D),D.incoming.set(this._hashFn(y),C)}removeNode(y){const A=this._hashFn(y);this._nodes.delete(A);for(let C of this._nodes.values())C.outgoing.delete(A),C.incoming.delete(A)}lookupOrInsertNode(y){const A=this._hashFn(y);let C=this._nodes.get(A);return C||(C=new v(y),this._nodes.set(A,C)),C}lookup(y){return this._nodes.get(this._hashFn(y))}isEmpty(){return this._nodes.size===0}toString(){let y=[];for(let[A,C]of this._nodes)y.push(`${A}, (incoming)[${[...C.incoming.keys()].join(", ")}], (outgoing)[${[...C.outgoing.keys()].join(",")}]`);return y.join(`
`)}findCycleSlow(){for(let[y,A]of this._nodes){const C=new Set([y]),D=this._findCycle(A,C);if(D)return D}}_findCycle(y,A){for(let[C,D]of y.outgoing){if(A.has(C))return[...A,C].join(" -> ");A.add(C);const P=this._findCycle(D,A);if(P)return P;A.delete(C)}}}e.Graph=R}),define(ge[4],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var v;(function(C){C.serviceIds=new Map,C.DI_TARGET="$di$target",C.DI_DEPENDENCIES="$di$dependencies";function D(P){return P[C.DI_DEPENDENCIES]||[]}C.getServiceDependencies=D})(v=e._util||(e._util={})),e.IInstantiationService=k("instantiationService");function R(C,D,P,s){D[v.DI_TARGET]===D?D[v.DI_DEPENDENCIES].push({id:C,index:P,optional:s}):(D[v.DI_DEPENDENCIES]=[{id:C,index:P,optional:s}],D[v.DI_TARGET]=D)}function k(C){if(v.serviceIds.has(C))return v.serviceIds.get(C);const D=function(P,s,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");R(D,P,I,!1)};return D.toString=()=>C,v.serviceIds.set(C,D),D}e.createDecorator=k;function y(C){return C}e.refineServiceDecorator=y;function A(C){return function(D,P,s){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");R(C,D,s,!0)}}e.optional=A}),define(ge[174],pe([0,1,4]),function(X,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=v.createDecorator("modelService");function R(k){return!k.isTooLargeForSyncing()&&!k.isForSimpleWidget}e.shouldSynchronizeModel=R}),define(ge[175],pe([0,1,3,74,6,23,73,77,174]),function(X,e,v,R,k,y,A,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function P(l){return typeof l=="string"?!1:Array.isArray(l)?l.every(P):!!l.exclusive}class s{constructor(){this._clock=0,this._entries=[],this._onDidChange=new v.Emitter}get onDidChange(){return this._onDidChange.event}register(g,c){let f={selector:g,provider:c,_score:-1,_time:this._clock++};return this._entries.push(f),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),k.toDisposable(()=>{if(f){let _=this._entries.indexOf(f);_>=0&&(this._entries.splice(_,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),f=void 0)}})}has(g){return this.all(g).length>0}all(g){if(!g)return[];this._updateScores(g);const c=[];for(let f of this._entries)f._score>0&&c.push(f.provider);return c}ordered(g){const c=[];return this._orderedForEach(g,f=>c.push(f.provider)),c}orderedGroups(g){const c=[];let f,_;return this._orderedForEach(g,w=>{f&&_===w._score?f.push(w.provider):(_=w._score,f=[w.provider],c.push(f))}),c}_orderedForEach(g,c){if(!!g){this._updateScores(g);for(const f of this._entries)f._score>0&&c(f)}}_updateScores(g){let c={uri:g.uri.toString(),language:g.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===c.language&&this._lastCandidate.uri===c.uri)){this._lastCandidate=c;for(let f of this._entries)if(f._score=C.score(f.selector,g.uri,g.getLanguageIdentifier().language,D.shouldSynchronizeModel(g)),P(f.selector)&&f._score>0){for(let _ of this._entries)_._score=0;f._score=1e3;break}this._entries.sort(s._compareByScoreAndTime)}}static _compareByScoreAndTime(g,c){return g._score<c._score?1:g._score>c._score?-1:g._time<c._time?1:g._time>c._time?-1:0}}e.LanguageFeatureRegistry=s;class I{constructor(g,c,f=Number.MAX_SAFE_INTEGER){this._registry=g,this.min=c,this.max=f,this._cache=new y.LRUCache(50,.7)}_key(g){return g.id+R.hash(this._registry.all(g))}_clamp(g){return g===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(g*1.3)))}get(g){const c=this._key(g),f=this._cache.get(c);return this._clamp(f==null?void 0:f.value)}update(g,c){const f=this._key(g);let _=this._cache.get(f);return _||(_=new A.MovingAverage,this._cache.set(f,_)),_.update(c),this.get(g)}}e.LanguageFeatureRequestDelays=I}),define(ge[79],pe([0,1,2,41,175,143,91]),function(X,e,v,R,k,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var C;(function(o){o[o.Null=0]="Null",o[o.PlainText=1]="PlainText"})(C=e.LanguageId||(e.LanguageId={}));class D{constructor(L,O){this.language=L,this.id=O}}e.LanguageIdentifier=D;var P;(function(o){o[o.NotSet=-1]="NotSet",o[o.None=0]="None",o[o.Italic=1]="Italic",o[o.Bold=2]="Bold",o[o.Underline=4]="Underline"})(P=e.FontStyle||(e.FontStyle={}));var s;(function(o){o[o.None=0]="None",o[o.DefaultForeground=1]="DefaultForeground",o[o.DefaultBackground=2]="DefaultBackground"})(s=e.ColorId||(e.ColorId={}));var I;(function(o){o[o.Other=0]="Other",o[o.Comment=1]="Comment",o[o.String=2]="String",o[o.RegEx=4]="RegEx"})(I=e.StandardTokenType||(e.StandardTokenType={}));var l;(function(o){o[o.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",o[o.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",o[o.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",o[o.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",o[o.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",o[o.ITALIC_MASK=2048]="ITALIC_MASK",o[o.BOLD_MASK=4096]="BOLD_MASK",o[o.UNDERLINE_MASK=8192]="UNDERLINE_MASK",o[o.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",o[o.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",o[o.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",o[o.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",o[o.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",o[o.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",o[o.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",o[o.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",o[o.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",o[o.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(l=e.MetadataConsts||(e.MetadataConsts={}));class g{static getLanguageId(L){return(L&255)>>>0}static getTokenType(L){return(L&1792)>>>8}static getFontStyle(L){return(L&14336)>>>11}static getForeground(L){return(L&8372224)>>>14}static getBackground(L){return(L&4286578688)>>>23}static getClassNameFromMetadata(L){let O=this.getForeground(L),W="mtk"+O,J=this.getFontStyle(L);return J&1&&(W+=" mtki"),J&2&&(W+=" mtkb"),J&4&&(W+=" mtku"),W}static getInlineStyleFromMetadata(L,O){const W=this.getForeground(L),J=this.getFontStyle(L);let oe=`color: ${O[W]};`;return J&1&&(oe+="font-style: italic;"),J&2&&(oe+="font-weight: bold;"),J&4&&(oe+="text-decoration: underline;"),oe}}e.TokenMetadata=g;var c;(function(o){o[o.Method=0]="Method",o[o.Function=1]="Function",o[o.Constructor=2]="Constructor",o[o.Field=3]="Field",o[o.Variable=4]="Variable",o[o.Class=5]="Class",o[o.Struct=6]="Struct",o[o.Interface=7]="Interface",o[o.Module=8]="Module",o[o.Property=9]="Property",o[o.Event=10]="Event",o[o.Operator=11]="Operator",o[o.Unit=12]="Unit",o[o.Value=13]="Value",o[o.Constant=14]="Constant",o[o.Enum=15]="Enum",o[o.EnumMember=16]="EnumMember",o[o.Keyword=17]="Keyword",o[o.Text=18]="Text",o[o.Color=19]="Color",o[o.File=20]="File",o[o.Reference=21]="Reference",o[o.Customcolor=22]="Customcolor",o[o.Folder=23]="Folder",o[o.TypeParameter=24]="TypeParameter",o[o.User=25]="User",o[o.Issue=26]="Issue",o[o.Snippet=27]="Snippet"})(c=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let o=Object.create(null);return o[0]="symbol-method",o[1]="symbol-function",o[2]="symbol-constructor",o[3]="symbol-field",o[4]="symbol-variable",o[5]="symbol-class",o[6]="symbol-struct",o[7]="symbol-interface",o[8]="symbol-module",o[9]="symbol-property",o[10]="symbol-event",o[11]="symbol-operator",o[12]="symbol-unit",o[13]="symbol-value",o[14]="symbol-constant",o[15]="symbol-enum",o[16]="symbol-enum-member",o[17]="symbol-keyword",o[27]="symbol-snippet",o[18]="symbol-text",o[19]="symbol-color",o[20]="symbol-file",o[21]="symbol-reference",o[22]="symbol-customcolor",o[23]="symbol-folder",o[24]="symbol-type-parameter",o[25]="account",o[26]="issues",function(L){const O=o[L];let W=O&&A.iconRegistry.get(O);return W||(console.info("No codicon found for CompletionItemKind "+L),W=A.Codicon.symbolProperty),W.classNames}}(),e.completionKindFromString=function(){let o=Object.create(null);return o.method=0,o.function=1,o.constructor=2,o.field=3,o.variable=4,o.class=5,o.struct=6,o.interface=7,o.module=8,o.property=9,o.event=10,o.operator=11,o.unit=12,o.value=13,o.constant=14,o.enum=15,o["enum-member"]=16,o.enumMember=16,o.keyword=17,o.snippet=27,o.text=18,o.color=19,o.file=20,o.reference=21,o.customcolor=22,o.folder=23,o["type-parameter"]=24,o.typeParameter=24,o.account=25,o.issue=26,function(L,O){let W=o[L];return typeof W=="undefined"&&!O&&(W=9),W}}();var f;(function(o){o[o.Deprecated=1]="Deprecated"})(f=e.CompletionItemTag||(e.CompletionItemTag={}));var _;(function(o){o[o.KeepWhitespace=1]="KeepWhitespace",o[o.InsertAsSnippet=4]="InsertAsSnippet"})(_=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var w;(function(o){o[o.Invoke=0]="Invoke",o[o.TriggerCharacter=1]="TriggerCharacter",o[o.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(w=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var E;(function(o){o[o.Automatic=0]="Automatic",o[o.Explicit=1]="Explicit"})(E=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var u;(function(o){o[o.Invoke=1]="Invoke",o[o.Auto=2]="Auto"})(u=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var h;(function(o){o[o.Invoke=1]="Invoke",o[o.TriggerCharacter=2]="TriggerCharacter",o[o.ContentChange=3]="ContentChange"})(h=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var m;(function(o){o[o.Text=0]="Text",o[o.Read=1]="Read",o[o.Write=2]="Write"})(m=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function t(o){return o&&v.URI.isUri(o.uri)&&R.Range.isIRange(o.range)&&(R.Range.isIRange(o.originSelectionRange)||R.Range.isIRange(o.targetSelectionRange))}e.isLocationLink=t;var r;(function(o){o[o.File=0]="File",o[o.Module=1]="Module",o[o.Namespace=2]="Namespace",o[o.Package=3]="Package",o[o.Class=4]="Class",o[o.Method=5]="Method",o[o.Property=6]="Property",o[o.Field=7]="Field",o[o.Constructor=8]="Constructor",o[o.Enum=9]="Enum",o[o.Interface=10]="Interface",o[o.Function=11]="Function",o[o.Variable=12]="Variable",o[o.Constant=13]="Constant",o[o.String=14]="String",o[o.Number=15]="Number",o[o.Boolean=16]="Boolean",o[o.Array=17]="Array",o[o.Object=18]="Object",o[o.Key=19]="Key",o[o.Null=20]="Null",o[o.EnumMember=21]="EnumMember",o[o.Struct=22]="Struct",o[o.Event=23]="Event",o[o.Operator=24]="Operator",o[o.TypeParameter=25]="TypeParameter"})(r=e.SymbolKind||(e.SymbolKind={}));var i;(function(o){o[o.Deprecated=1]="Deprecated"})(i=e.SymbolTag||(e.SymbolTag={}));var n;(function(o){const L=new Map;L.set("file",0),L.set("module",1),L.set("namespace",2),L.set("package",3),L.set("class",4),L.set("method",5),L.set("property",6),L.set("field",7),L.set("constructor",8),L.set("enum",9),L.set("interface",10),L.set("function",11),L.set("variable",12),L.set("constant",13),L.set("string",14),L.set("number",15),L.set("boolean",16),L.set("array",17),L.set("object",18),L.set("key",19),L.set("null",20),L.set("enum-member",21),L.set("struct",22),L.set("event",23),L.set("operator",24),L.set("type-parameter",25);const O=new Map;O.set(0,"file"),O.set(1,"module"),O.set(2,"namespace"),O.set(3,"package"),O.set(4,"class"),O.set(5,"method"),O.set(6,"property"),O.set(7,"field"),O.set(8,"constructor"),O.set(9,"enum"),O.set(10,"interface"),O.set(11,"function"),O.set(12,"variable"),O.set(13,"constant"),O.set(14,"string"),O.set(15,"number"),O.set(16,"boolean"),O.set(17,"array"),O.set(18,"object"),O.set(19,"key"),O.set(20,"null"),O.set(21,"enum-member"),O.set(22,"struct"),O.set(23,"event"),O.set(24,"operator"),O.set(25,"type-parameter");function W(q){return L.get(q)}o.fromString=W;function J(q){return O.get(q)}o.toString=J;function oe(q,x){const V=O.get(q);let T=V&&A.iconRegistry.get("symbol-"+V);return T||(console.info("No codicon found for SymbolKind "+q),T=A.Codicon.symbolProperty),`${x?"inline":"block"} ${T.classNames}`}o.toCssClassName=oe})(n=e.SymbolKinds||(e.SymbolKinds={}));class a{constructor(L){this.value=L}}e.FoldingRangeKind=a,a.Comment=new a("comment"),a.Imports=new a("imports"),a.Region=new a("region");var p;(function(o){o[o.Collapsed=0]="Collapsed",o[o.Expanded=1]="Expanded"})(p=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var d;(function(o){o[o.Editing=0]="Editing",o[o.Preview=1]="Preview"})(d=e.CommentMode||(e.CommentMode={}));var b;(function(o){o[o.Other=0]="Other",o[o.Type=1]="Type",o[o.Parameter=2]="Parameter"})(b=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new k.LanguageFeatureRegistry,e.RenameProviderRegistry=new k.LanguageFeatureRegistry,e.CompletionProviderRegistry=new k.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new k.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new k.LanguageFeatureRegistry,e.HoverProviderRegistry=new k.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new k.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new k.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new k.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new k.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new k.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new k.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new k.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new k.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new k.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new k.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new k.LanguageFeatureRegistry,e.LinkProviderRegistry=new k.LanguageFeatureRegistry,e.ColorProviderRegistry=new k.LanguageFeatureRegistry,e.SelectionRangeRegistry=new k.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new k.LanguageFeatureRegistry,e.TokenizationRegistry=new y.TokenizationRegistryImpl;var S;(function(o){o[o.None=0]="None",o[o.Option=1]="Option",o[o.Default=2]="Default",o[o.Preferred=3]="Preferred"})(S=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(ge[111],pe([0,1,8,4,11]),function(X,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let y=k.userAgent||"";const A=new Map;A.set("false",!1),A.set("true",!0),A.set("isMac",k.isMacintosh),A.set("isLinux",k.isLinux),A.set("isWindows",k.isWindows),A.set("isWeb",k.isWeb),A.set("isMacNative",k.isMacintosh&&!k.isWeb),A.set("isEdge",y.indexOf("Edg/")>=0),A.set("isFirefox",y.indexOf("Firefox")>=0),A.set("isChrome",y.indexOf("Chrome")>=0),A.set("isSafari",y.indexOf("Safari")>=0);const C=Object.prototype.hasOwnProperty;var D;(function(S){S[S.False=0]="False",S[S.True=1]="True",S[S.Defined=2]="Defined",S[S.Not=3]="Not",S[S.Equals=4]="Equals",S[S.NotEquals=5]="NotEquals",S[S.And=6]="And",S[S.Regex=7]="Regex",S[S.NotRegex=8]="NotRegex",S[S.Or=9]="Or",S[S.In=10]="In",S[S.NotIn=11]="NotIn",S[S.Greater=12]="Greater",S[S.GreaterEquals=13]="GreaterEquals",S[S.Smaller=14]="Smaller",S[S.SmallerEquals=15]="SmallerEquals"})(D=e.ContextKeyExprType||(e.ContextKeyExprType={}));class P{static false(){return I.INSTANCE}static true(){return l.INSTANCE}static has(o){return g.create(o)}static equals(o,L){return c.create(o,L)}static notEquals(o,L){return w.create(o,L)}static regex(o,L){return r.create(o,L)}static in(o,L){return f.create(o,L)}static not(o){return E.create(o)}static and(...o){return n.create(o)}static or(...o){return a.create(o)}static greater(o,L){return u.create(o,L)}static less(o,L){return m.create(o,L)}static deserialize(o,L=!1){if(!!o)return this._deserializeOrExpression(o,L)}static _deserializeOrExpression(o,L){let O=o.split("||");return a.create(O.map(W=>this._deserializeAndExpression(W,L)))}static _deserializeAndExpression(o,L){let O=o.split("&&");return n.create(O.map(W=>this._deserializeOne(W,L)))}static _deserializeOne(o,L){if(o=o.trim(),o.indexOf("!=")>=0){let O=o.split("!=");return w.create(O[0].trim(),this._deserializeValue(O[1],L))}if(o.indexOf("==")>=0){let O=o.split("==");return c.create(O[0].trim(),this._deserializeValue(O[1],L))}if(o.indexOf("=~")>=0){let O=o.split("=~");return r.create(O[0].trim(),this._deserializeRegexValue(O[1],L))}if(o.indexOf(" in ")>=0){let O=o.split(" in ");return f.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(o)){const O=o.split(">=");return h.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(o)){const O=o.split(">");return u.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(o)){const O=o.split("<=");return t.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(o)){const O=o.split("<");return m.create(O[0].trim(),O[1].trim())}return/^\!\s*/.test(o)?E.create(o.substr(1).trim()):g.create(o)}static _deserializeValue(o,L){if(o=o.trim(),o==="true")return!0;if(o==="false")return!1;let O=/^'([^']*)'$/.exec(o);return O?O[1].trim():o}static _deserializeRegexValue(o,L){if(v.isFalsyOrWhitespace(o)){if(L)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let O=o.indexOf("/"),W=o.lastIndexOf("/");if(O===W||O<0){if(L)throw new Error(`bad regexp-value '${o}', missing /-enclosure`);return console.warn(`bad regexp-value '${o}', missing /-enclosure`),null}let J=o.slice(O+1,W),oe=o[W+1]==="i"?"i":"";try{return new RegExp(J,oe)}catch(q){if(L)throw new Error(`bad regexp-value '${o}', parse error: ${q}`);return console.warn(`bad regexp-value '${o}', parse error: ${q}`),null}}}e.ContextKeyExpr=P;function s(S,o){return S.cmp(o)}class I{constructor(){this.type=0}cmp(o){return this.type-o.type}equals(o){return o.type===this.type}evaluate(o){return!1}serialize(){return"false"}keys(){return[]}map(o){return this}negate(){return l.INSTANCE}}e.ContextKeyFalseExpr=I,I.INSTANCE=new I;class l{constructor(){this.type=1}cmp(o){return this.type-o.type}equals(o){return o.type===this.type}evaluate(o){return!0}serialize(){return"true"}keys(){return[]}map(o){return this}negate(){return I.INSTANCE}}e.ContextKeyTrueExpr=l,l.INSTANCE=new l;class g{constructor(o){this.key=o,this.type=2}static create(o){const L=A.get(o);return typeof L=="boolean"?L?l.INSTANCE:I.INSTANCE:new g(o)}cmp(o){return o.type!==this.type?this.type-o.type:d(this.key,o.key)}equals(o){return o.type===this.type?this.key===o.key:!1}evaluate(o){return!!o.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(o){return o.mapDefined(this.key)}negate(){return E.create(this.key)}}e.ContextKeyDefinedExpr=g;class c{constructor(o,L){this.key=o,this.value=L,this.type=4}static create(o,L){if(typeof L=="boolean")return L?g.create(o):E.create(o);const O=A.get(o);return typeof O=="boolean"?L===(O?"true":"false")?l.INSTANCE:I.INSTANCE:new c(o,L)}cmp(o){return o.type!==this.type?this.type-o.type:b(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return o.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(o){return o.mapEquals(this.key,this.value)}negate(){return w.create(this.key,this.value)}}e.ContextKeyEqualsExpr=c;class f{constructor(o,L){this.key=o,this.valueKey=L,this.type=10}static create(o,L){return new f(o,L)}cmp(o){return o.type!==this.type?this.type-o.type:b(this.key,this.valueKey,o.key,o.valueKey)}equals(o){return o.type===this.type?this.key===o.key&&this.valueKey===o.valueKey:!1}evaluate(o){const L=o.getValue(this.valueKey),O=o.getValue(this.key);return Array.isArray(L)?L.indexOf(O)>=0:typeof O=="string"&&typeof L=="object"&&L!==null?C.call(L,O):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(o){return o.mapIn(this.key,this.valueKey)}negate(){return _.create(this)}}e.ContextKeyInExpr=f;class _{constructor(o){this._actual=o,this.type=11}static create(o){return new _(o)}cmp(o){return o.type!==this.type?this.type-o.type:this._actual.cmp(o._actual)}equals(o){return o.type===this.type?this._actual.equals(o._actual):!1}evaluate(o){return!this._actual.evaluate(o)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(o){return new _(this._actual.map(o))}negate(){return this._actual}}e.ContextKeyNotInExpr=_;class w{constructor(o,L){this.key=o,this.value=L,this.type=5}static create(o,L){if(typeof L=="boolean")return L?E.create(o):g.create(o);const O=A.get(o);return typeof O=="boolean"?L===(O?"true":"false")?I.INSTANCE:l.INSTANCE:new w(o,L)}cmp(o){return o.type!==this.type?this.type-o.type:b(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return o.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(o){return o.mapNotEquals(this.key,this.value)}negate(){return c.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=w;class E{constructor(o){this.key=o,this.type=3}static create(o){const L=A.get(o);return typeof L=="boolean"?L?I.INSTANCE:l.INSTANCE:new E(o)}cmp(o){return o.type!==this.type?this.type-o.type:d(this.key,o.key)}equals(o){return o.type===this.type?this.key===o.key:!1}evaluate(o){return!o.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(o){return o.mapNot(this.key)}negate(){return g.create(this.key)}}e.ContextKeyNotExpr=E;class u{constructor(o,L){this.key=o,this.value=L,this.type=12}static create(o,L){return new u(o,L)}cmp(o){return o.type!==this.type?this.type-o.type:b(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return parseFloat(o.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(o){return o.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=u;class h{constructor(o,L){this.key=o,this.value=L,this.type=13}static create(o,L){return new h(o,L)}cmp(o){return o.type!==this.type?this.type-o.type:b(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return parseFloat(o.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(o){return o.mapGreaterEquals(this.key,this.value)}negate(){return m.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=h;class m{constructor(o,L){this.key=o,this.value=L,this.type=14}static create(o,L){return new m(o,L)}cmp(o){return o.type!==this.type?this.type-o.type:b(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return parseFloat(o.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(o){return o.mapSmaller(this.key,this.value)}negate(){return h.create(this.key,this.value)}}e.ContextKeySmallerExpr=m;class t{constructor(o,L){this.key=o,this.value=L,this.type=15}static create(o,L){return new t(o,L)}cmp(o){return o.type!==this.type?this.type-o.type:b(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return parseFloat(o.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(o){return o.mapSmallerEquals(this.key,this.value)}negate(){return u.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class r{constructor(o,L){this.key=o,this.regexp=L,this.type=7}static create(o,L){return new r(o,L)}cmp(o){if(o.type!==this.type)return this.type-o.type;if(this.key<o.key)return-1;if(this.key>o.key)return 1;const L=this.regexp?this.regexp.source:"",O=o.regexp?o.regexp.source:"";return L<O?-1:L>O?1:0}equals(o){if(o.type===this.type){const L=this.regexp?this.regexp.source:"",O=o.regexp?o.regexp.source:"";return this.key===o.key&&L===O}return!1}evaluate(o){let L=o.getValue(this.key);return this.regexp?this.regexp.test(L):!1}serialize(){const o=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${o}`}keys(){return[this.key]}map(o){return o.mapRegex(this.key,this.regexp)}negate(){return i.create(this)}}e.ContextKeyRegexExpr=r;class i{constructor(o){this._actual=o,this.type=8}static create(o){return new i(o)}cmp(o){return o.type!==this.type?this.type-o.type:this._actual.cmp(o._actual)}equals(o){return o.type===this.type?this._actual.equals(o._actual):!1}evaluate(o){return!this._actual.evaluate(o)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(o){return new i(this._actual.map(o))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=i;class n{constructor(o){this.expr=o,this.type=6}static create(o){return n._normalizeArr(o)}cmp(o){if(o.type!==this.type)return this.type-o.type;if(this.expr.length<o.expr.length)return-1;if(this.expr.length>o.expr.length)return 1;for(let L=0,O=this.expr.length;L<O;L++){const W=s(this.expr[L],o.expr[L]);if(W!==0)return W}return 0}equals(o){if(o.type===this.type){if(this.expr.length!==o.expr.length)return!1;for(let L=0,O=this.expr.length;L<O;L++)if(!this.expr[L].equals(o.expr[L]))return!1;return!0}return!1}evaluate(o){for(let L=0,O=this.expr.length;L<O;L++)if(!this.expr[L].evaluate(o))return!1;return!0}static _normalizeArr(o){const L=[];let O=!1;for(const W of o)if(!!W){if(W.type===1){O=!0;continue}if(W.type===0)return I.INSTANCE;if(W.type===6){L.push(...W.expr);continue}L.push(W)}if(L.length===0&&O)return l.INSTANCE;if(L.length!==0){if(L.length===1)return L[0];for(L.sort(s);L.length>1;){const W=L[L.length-1];if(W.type!==9)break;L.pop();const J=L.pop(),oe=a.create(W.expr.map(q=>n.create([q,J])));oe&&(L.push(oe),L.sort(s))}return L.length===1?L[0]:new n(L)}}serialize(){return this.expr.map(o=>o.serialize()).join(" && ")}keys(){const o=[];for(let L of this.expr)o.push(...L.keys());return o}map(o){return new n(this.expr.map(L=>L.map(o)))}negate(){let o=[];for(let L of this.expr)o.push(L.negate());return a.create(o)}}e.ContextKeyAndExpr=n;class a{constructor(o){this.expr=o,this.type=9}static create(o){const L=a._normalizeArr(o);if(L.length!==0)return L.length===1?L[0]:new a(L)}cmp(o){if(o.type!==this.type)return this.type-o.type;if(this.expr.length<o.expr.length)return-1;if(this.expr.length>o.expr.length)return 1;for(let L=0,O=this.expr.length;L<O;L++){const W=s(this.expr[L],o.expr[L]);if(W!==0)return W}return 0}equals(o){if(o.type===this.type){if(this.expr.length!==o.expr.length)return!1;for(let L=0,O=this.expr.length;L<O;L++)if(!this.expr[L].equals(o.expr[L]))return!1;return!0}return!1}evaluate(o){for(let L=0,O=this.expr.length;L<O;L++)if(this.expr[L].evaluate(o))return!0;return!1}static _normalizeArr(o){let L=[],O=!1;if(o){for(let W=0,J=o.length;W<J;W++){const oe=o[W];if(!!oe){if(oe.type===0){O=!0;continue}if(oe.type===1)return[l.INSTANCE];if(oe.type===9){L=L.concat(oe.expr);continue}L.push(oe)}}if(L.length===0&&O)return[I.INSTANCE];L.sort(s)}return L}serialize(){return this.expr.map(o=>o.serialize()).join(" || ")}keys(){const o=[];for(let L of this.expr)o.push(...L.keys());return o}map(o){return new a(this.expr.map(L=>L.map(o)))}negate(){let o=[];for(let O of this.expr)o.push(O.negate());const L=O=>O.type===9?O.expr:[O];for(;o.length>1;){const O=o.shift(),W=o.shift(),J=[];for(const oe of L(O))for(const q of L(W))J.push(P.and(oe,q));o.unshift(P.or(...J))}return o[0]}}e.ContextKeyOrExpr=a;class p extends g{constructor(o,L,O){super(o);this._defaultValue=L,typeof O=="object"?p._info.push(Object.assign(Object.assign({},O),{key:o})):O!==!0&&p._info.push({key:o,description:O,type:L!=null?typeof L:void 0})}static all(){return p._info.values()}bindTo(o){return o.createKey(this.key,this._defaultValue)}getValue(o){return o.getContextKeyValue(this.key)}toNegated(){return P.not(this.key)}isEqualTo(o){return P.equals(this.key,o)}notEqualsTo(o){return P.notEquals(this.key,o)}}e.RawContextKey=p,p._info=[],e.IContextKeyService=R.createDecorator("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function d(S,o){return S<o?-1:S>o?1:0}function b(S,o,L,O){return S<L?-1:S>L?1:o<O?-1:o>O?1:0}}),define(ge[176],pe([0,1,152,4,10]),function(X,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN);function y(I){return I&&typeof I=="object"&&typeof I.id=="string"&&(!I.uuid||typeof I.uuid=="string")}e.isIExtensionIdentifier=y;var A;(function(I){I[I.NoneOrRelevance=0]="NoneOrRelevance",I[I.LastUpdatedDate=1]="LastUpdatedDate",I[I.Title=2]="Title",I[I.PublisherName=3]="PublisherName",I[I.InstallCount=4]="InstallCount",I[I.PublishedDate=5]="PublishedDate",I[I.AverageRating=6]="AverageRating",I[I.WeightedRating=12]="WeightedRating"})(A=e.SortBy||(e.SortBy={}));var C;(function(I){I[I.Default=0]="Default",I[I.Ascending=1]="Ascending",I[I.Descending=2]="Descending"})(C=e.SortOrder||(e.SortOrder={}));var D;(function(I){I.Uninstall="uninstall"})(D=e.StatisticType||(e.StatisticType={}));var P;(function(I){I[I.None=0]="None",I[I.Install=1]="Install",I[I.Update=2]="Update"})(P=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=R.createDecorator("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class s extends Error{constructor(l,g){super(l);this.code=g}}e.ExtensionManagementError=s,e.IExtensionManagementService=R.createDecorator("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=R.createDecorator("IGlobalExtensionEnablementService"),e.IExtensionTipsService=R.createDecorator("IExtensionTipsService"),e.DefaultIconPath=k.FileAccess.asBrowserUri("./media/defaultIcon.png",X).toString(!0),e.ExtensionsLabel=v.localize(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=v.localize(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=R.createDecorator("IExtensionManagementCLIService")}),define(ge[26],pe([0,1,8,4]),function(X,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkpaceSupportTypeMessage=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function k(s){if(typeof s=="object"&&s!==null&&s.supported!==!0)return s.description}e.getWorkpaceSupportTypeMessage=k;function y(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(!s.uuid||typeof s.uuid=="string")}e.isIExtensionIdentifier=y,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(s){s[s.System=0]="System",s[s.User=1]="User"})(A=e.ExtensionType||(e.ExtensionType={}));class C{constructor(I){this.value=I,this._lower=I.toLowerCase()}static equals(I,l){if(typeof I=="undefined"||I===null)return typeof l=="undefined"||l===null;if(typeof l=="undefined"||l===null)return!1;if(typeof I=="string"||typeof l=="string"){let g=typeof I=="string"?I:I.value,c=typeof l=="string"?l:l.value;return v.equalsIgnoreCase(g,c)}return I._lower===l._lower}static toKey(I){return typeof I=="string"?I.toLowerCase():I._lower}}e.ExtensionIdentifier=C;function D(s){return s.contributes&&s.contributes.localizations?s.contributes.localizations.length>0:!1}e.isLanguagePackExtension=D;function P(s){return s.contributes&&s.contributes.authentication?s.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=P,e.IBuiltinExtensionsScannerService=R.createDecorator("IBuiltinExtensionsScannerService")}),define(ge[177],pe([0,1,8,26]),function(X,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function k(g,c){return g.uuid&&c.uuid?g.uuid===c.uuid:g.id===c.id?!0:v.compareIgnoreCase(g.id,c.id)===0}e.areSameExtensions=k;class y{constructor(c,f){this.version=f,this.id=c.id,this.uuid=c.uuid}key(){return`${this.id}-${this.version}`}equals(c){return c instanceof y?k(this,c)&&this.version===c.version:!1}}e.ExtensionIdentifierWithVersion=y;function A(g,c){return`${g}.${c}`}e.getExtensionId=A;function C(g){return g.toLocaleLowerCase()}e.adoptToGalleryExtensionId=C;function D(g,c){return C(A(g,c))}e.getGalleryExtensionId=D;function P(g,c){const f=[],_=w=>{for(const E of f)if(E.some(u=>k(c(u),c(w))))return E;return null};for(const w of g){const E=_(w);E?E.push(w):f.push([w])}return f}e.groupByExtension=P;function s(g){return{id:g.identifier.id,name:g.manifest.name,galleryId:null,publisherId:g.publisherId,publisherName:g.manifest.publisher,publisherDisplayName:g.publisherDisplayName,dependencies:g.manifest.extensionDependencies&&g.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=s;function I(g){return Object.assign({id:g.identifier.id,name:g.name,galleryId:g.identifier.uuid,publisherId:g.publisherId,publisherName:g.publisher,publisherDisplayName:g.publisherDisplayName,dependencies:!!(g.properties.dependencies&&g.properties.dependencies.length>0)},g.telemetryData)}e.getGalleryExtensionTelemetryData=I,e.BetterMergeId=new R.ExtensionIdentifier("pprice.better-merge");function l(g){const c=new Set;for(const f of g)f.malicious&&c.add(f.id.id);return c}e.getMaliciousExtensionsSet=l}),define(ge[178],pe([0,1,4]),function(X,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=v.createDecorator("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=v.createDecorator("externalTerminal")}),define(ge[42],pe([0,1,155,9,2,4,8,13,23]),function(X,e,v,R,k,y,A,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=y.createDecorator("fileService");function P(x){return x.create===!0}e.isFileOpenForWriteOptions=P;var s;(function(x){x[x.Unknown=0]="Unknown",x[x.File=1]="File",x[x.Directory=2]="Directory",x[x.SymbolicLink=64]="SymbolicLink"})(s=e.FileType||(e.FileType={}));var I;(function(x){x[x.Readonly=1]="Readonly"})(I=e.FilePermission||(e.FilePermission={}));var l;(function(x){x[x.FileReadWrite=2]="FileReadWrite",x[x.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",x[x.FileReadStream=16]="FileReadStream",x[x.FileFolderCopy=8]="FileFolderCopy",x[x.PathCaseSensitive=1024]="PathCaseSensitive",x[x.Readonly=2048]="Readonly",x[x.Trash=4096]="Trash",x[x.FileWriteUnlock=8192]="FileWriteUnlock"})(l=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function g(x){return!!(x.capabilities&2)}e.hasReadWriteCapability=g;function c(x){return!!(x.capabilities&8)}e.hasFileFolderCopyCapability=c;function f(x){return!!(x.capabilities&4)}e.hasOpenReadWriteCloseCapability=f;function _(x){return!!(x.capabilities&16)}e.hasFileReadStreamCapability=_;var w;(function(x){x.FileExists="EntryExists",x.FileNotFound="EntryNotFound",x.FileNotADirectory="EntryNotADirectory",x.FileIsADirectory="EntryIsADirectory",x.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",x.FileTooLarge="EntryTooLarge",x.FileWriteLocked="EntryWriteLocked",x.NoPermissions="NoPermissions",x.Unavailable="Unavailable",x.Unknown="Unknown"})(w=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class E extends Error{constructor(V,T){super(V);this.code=T}}e.FileSystemProviderError=E;function u(x,V){const T=new E(x.toString(),V);return m(T,V),T}e.createFileSystemProviderError=u;function h(x){return x||u(v.localize(0,null),w.Unknown)}e.ensureFileSystemProviderError=h;function m(x,V){return x.name=V?`${V} (FileSystemError)`:"FileSystemError",x}e.markAsFileSystemProviderError=m;function t(x){if(!x)return w.Unknown;if(x instanceof E)return x.code;const V=/^(.+) \(FileSystemError\)$/.exec(x.name);if(!V)return w.Unknown;switch(V[1]){case w.FileExists:return w.FileExists;case w.FileIsADirectory:return w.FileIsADirectory;case w.FileNotADirectory:return w.FileNotADirectory;case w.FileNotFound:return w.FileNotFound;case w.FileExceedsMemoryLimit:return w.FileExceedsMemoryLimit;case w.FileTooLarge:return w.FileTooLarge;case w.FileWriteLocked:return w.FileWriteLocked;case w.NoPermissions:return w.NoPermissions;case w.Unavailable:return w.Unavailable}return w.Unknown}e.toFileSystemProviderErrorCode=t;function r(x){if(x instanceof b)return x.fileOperationResult;switch(t(x)){case w.FileNotFound:return 1;case w.FileIsADirectory:return 0;case w.FileNotADirectory:return 10;case w.FileWriteLocked:return 5;case w.NoPermissions:return 6;case w.FileExists:return 4;case w.FileExceedsMemoryLimit:return 9;case w.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var i;(function(x){x[x.CREATE=0]="CREATE",x[x.DELETE=1]="DELETE",x[x.MOVE=2]="MOVE",x[x.COPY=3]="COPY"})(i=e.FileOperation||(e.FileOperation={}));class n{constructor(V,T,N){this.resource=V,this.operation=T,this.target=N}isOperation(V){return this.operation===V}}e.FileOperationEvent=n;var a;(function(x){x[x.UPDATED=0]="UPDATED",x[x.ADDED=1]="ADDED",x[x.DELETED=2]="DELETED"})(a=e.FileChangeType||(e.FileChangeType={}));class p{constructor(V,T){this.ignorePathCasing=T,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=V;for(const N of V)switch(N.type){case 1:this.added||(this.added=D.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set(N.resource,N);break;case 0:this.updated||(this.updated=D.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set(N.resource,N);break;case 2:this.deleted||(this.deleted=D.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set(N.resource,N);break}}contains(V,...T){return this.doContains(V,{includeChildren:!1},...T)}affects(V,...T){return this.doContains(V,{includeChildren:!0},...T)}doContains(V,T,...N){var F,M,U,B,K,ie;if(!V)return!1;const we=N.length>0;return!!((!we||N.includes(1))&&(((F=this.added)===null||F===void 0?void 0:F.get(V))||T.includeChildren&&((M=this.added)===null||M===void 0?void 0:M.findSuperstr(V)))||(!we||N.includes(0))&&(((U=this.updated)===null||U===void 0?void 0:U.get(V))||T.includeChildren&&((B=this.updated)===null||B===void 0?void 0:B.findSuperstr(V)))||(!we||N.includes(2))&&(((K=this.deleted)===null||K===void 0?void 0:K.findSubstr(V))||T.includeChildren&&((ie=this.deleted)===null||ie===void 0?void 0:ie.findSuperstr(V))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType(V){const T=[],N=V===1?this.added:V===0?this.updated:this.deleted;if(N)for(const[,F]of N)T.push(F);return T}filter(V){return new p(this.changes.filter(T=>V(T)),this.ignorePathCasing)}}e.FileChangesEvent=p;function d(x,V,T){return!x||!V||x===V||V.length>x.length?!1:(V.charAt(V.length-1)!==R.sep&&(V+=R.sep),T?A.startsWithIgnoreCase(x,V):x.indexOf(V)===0)}e.isParent=d;class b extends Error{constructor(V,T,N){super(V);this.fileOperationResult=T,this.options=N}}e.FileOperationError=b;class S extends b{constructor(V,T,N){super(V,2,N);this.stat=T}}e.NotModifiedSinceFileOperationError=S;var o;(function(x){x[x.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",x[x.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",x[x.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",x[x.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",x[x.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",x[x.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",x[x.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",x[x.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",x[x.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",x[x.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",x[x.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",x[x.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(o=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var L;(function(x){x[x.FILE=0]="FILE",x[x.FOLDER=1]="FOLDER",x[x.ROOT_FOLDER=2]="ROOT_FOLDER"})(L=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function O(x){if(!(typeof x.size!="number"||typeof x.mtime!="number"))return x.mtime.toString(29)+x.size.toString(31)}e.etag=O;async function W(x,V){if(!V.canHandleResource(k.URI.from({scheme:x.scheme})))return new Promise(T=>{const N=V.onDidChangeFileSystemProviderRegistrations(F=>{F.scheme===x.scheme&&F.added&&(N.dispose(),T())})})}e.whenProviderRegistered=W,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class J{static formatSize(V){return C.isNumber(V)||(V=0),V<J.KB?v.localize(1,null,V.toFixed(0)):V<J.MB?v.localize(2,null,(V/J.KB).toFixed(2)):V<J.GB?v.localize(3,null,(V/J.MB).toFixed(2)):V<J.TB?v.localize(4,null,(V/J.GB).toFixed(2)):v.localize(5,null,(V/J.TB).toFixed(2))}}e.ByteSize=J,J.KB=1024,J.MB=J.KB*J.KB,J.GB=J.MB*J.KB,J.TB=J.GB*J.KB;var oe;(function(x){x[x.IA32=0]="IA32",x[x.OTHER=1]="OTHER"})(oe=e.Arch||(e.Arch={}));function q(x){return{maxFileSize:x===0?300*J.MB:16*J.GB,maxHeapSize:x===0?700*J.MB:2*700*J.MB}}e.getPlatformLimits=q}),define(ge[80],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class v{constructor(...k){this._entries=new Map;for(let[y,A]of k)this.set(y,A)}set(k,y){const A=this._entries.get(k);return this._entries.set(k,y),A}has(k){return this._entries.has(k)}get(k){return this._entries.get(k)}}e.ServiceCollection=v}),define(ge[179],pe([0,1,16,173,110,4,80,14]),function(X,e,v,R,k,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const D=!1;class P extends Error{constructor(c){var f;super("cyclic dependency between services");this.message=(f=c.findCycleSlow())!==null&&f!==void 0?f:`UNABLE to detect cycle, dumping graph: 
${c.toString()}`}}class s{constructor(c=new A.ServiceCollection,f=!1,_){this._activeInstantiations=new Set,this._services=c,this._strict=f,this._parent=_,this._services.set(y.IInstantiationService,this)}createChild(c){return new s(c,this._strict,this)}invokeFunction(c,...f){let _=l.traceInvocation(c),w=!1;try{return c({get:(u,h)=>{if(w)throw v.illegalState("service accessor is only valid during the invocation of its target method");const m=this._getOrCreateServiceInstance(u,_);if(!m&&h!==y.optional)throw new Error(`[invokeFunction] unknown service '${u}'`);return m}},...f)}finally{w=!0,_.stop()}}createInstance(c,...f){let _,w;return c instanceof k.SyncDescriptor?(_=l.traceCreation(c.ctor),w=this._createInstance(c.ctor,c.staticArguments.concat(f),_)):(_=l.traceCreation(c),w=this._createInstance(c,f,_)),_.stop(),w}_createInstance(c,f=[],_){let w=y._util.getServiceDependencies(c).sort((h,m)=>h.index-m.index),E=[];for(const h of w){let m=this._getOrCreateServiceInstance(h.id,_);if(!m&&this._strict&&!h.optional)throw new Error(`[createInstance] ${c.name} depends on UNKNOWN service ${h.id}.`);E.push(m)}let u=w.length>0?w[0].index:f.length;if(f.length!==u){console.warn(`[createInstance] First service dependency of ${c.name} at position ${u+1} conflicts with ${f.length} static arguments`);let h=u-f.length;h>0?f=f.concat(new Array(h)):f=f.slice(0,u)}return new c(...[...f,...E])}_setServiceInstance(c,f){if(this._services.get(c)instanceof k.SyncDescriptor)this._services.set(c,f);else if(this._parent)this._parent._setServiceInstance(c,f);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(c){let f=this._services.get(c);return!f&&this._parent?this._parent._getServiceInstanceOrDescriptor(c):f}_getOrCreateServiceInstance(c,f){let _=this._getServiceInstanceOrDescriptor(c);return _ instanceof k.SyncDescriptor?this._safeCreateAndCacheServiceInstance(c,_,f.branch(c,!0)):(f.branch(c,!1),_)}_safeCreateAndCacheServiceInstance(c,f,_){if(this._activeInstantiations.has(c))throw new Error(`illegal state - RECURSIVELY instantiating service '${c}'`);this._activeInstantiations.add(c);try{return this._createAndCacheServiceInstance(c,f,_)}finally{this._activeInstantiations.delete(c)}}_createAndCacheServiceInstance(c,f,_){const w=new R.Graph(h=>h.id.toString());let E=0;const u=[{id:c,desc:f,_trace:_}];for(;u.length;){const h=u.pop();if(w.lookupOrInsertNode(h),E++>1e3)throw new P(w);for(let m of y._util.getServiceDependencies(h.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(m.id);if(!t&&!m.optional&&console.warn(`[createInstance] ${c} depends on ${m.id} which is NOT registered.`),t instanceof k.SyncDescriptor){const r={id:m.id,desc:t,_trace:h._trace.branch(m.id,!0)};w.insertEdge(h,r),u.push(r)}}}for(;;){const h=w.roots();if(h.length===0){if(!w.isEmpty())throw new P(w);break}for(const{data:m}of h){if(this._getServiceInstanceOrDescriptor(m.id)instanceof k.SyncDescriptor){const r=this._createServiceInstanceWithOwner(m.id,m.desc.ctor,m.desc.staticArguments,m.desc.supportsDelayedInstantiation,m._trace);this._setServiceInstance(m.id,r)}w.removeNode(m)}}return this._getServiceInstanceOrDescriptor(c)}_createServiceInstanceWithOwner(c,f,_=[],w,E){if(this._services.get(c)instanceof k.SyncDescriptor)return this._createServiceInstance(f,_,w,E);if(this._parent)return this._parent._createServiceInstanceWithOwner(c,f,_,w,E);throw new Error(`illegalState - creating UNKNOWN service instance ${f.name}`)}_createServiceInstance(c,f=[],_,w){if(_){const E=new C.IdleValue(()=>this._createInstance(c,f,w));return new Proxy(Object.create(null),{get(u,h){if(h in u)return u[h];let m=E.value,t=m[h];return typeof t!="function"||(t=t.bind(m),u[h]=t),t},set(u,h,m){return E.value[h]=m,!0}})}else return this._createInstance(c,f,w)}}e.InstantiationService=s;var I;(function(g){g[g.Creation=0]="Creation",g[g.Invocation=1]="Invocation",g[g.Branch=2]="Branch"})(I||(I={}));class l{constructor(c,f){this.type=c,this.name=f,this._start=Date.now(),this._dep=[]}static traceInvocation(c){return D?new l(1,c.name||c.toString().substring(0,42).replace(/\n/g,"")):l._None}static traceCreation(c){return D?new l(0,c.name):l._None}branch(c,f){let _=new l(2,c.toString());return this._dep.push([c,f,_]),_}stop(){let c=Date.now()-this._start;l._totals+=c;let f=!1;function _(E,u){let h=[],m=new Array(E+1).join("	");for(const[t,r,i]of u._dep)if(r&&i){f=!0,h.push(`${m}CREATES -> ${t}`);let n=_(E+1,i);n&&h.push(n)}else h.push(`${m}uses -> ${t}`);return h.join(`
`)}let w=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${_(1,this)}`,`DONE, took ${c.toFixed(2)}ms (grand total ${l._totals.toFixed(2)}ms)`];(c>2||f)&&console.log(w.join(`
`))}}l._None=new class extends l{constructor(){super(-1,null)}stop(){}branch(){return this}},l._totals=0}),define(ge[15],pe([0,1,4,6,11,3,55]),function(X,e,v,R,k,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=v.createDecorator("logService"),e.ILoggerService=v.createDecorator("loggerService");function C(){return new Date().toISOString()}var D;(function(m){m[m.Trace=0]="Trace",m[m.Debug=1]="Debug",m[m.Info=2]="Info",m[m.Warning=3]="Warning",m[m.Error=4]="Error",m[m.Critical=5]="Critical",m[m.Off=6]="Off"})(D=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=D.Info;class P extends R.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new y.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=P;class s extends P{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...r){this.checkLogLevel(D.Trace)&&this.log(D.Trace,this.format([t,...r]))}debug(t,...r){this.checkLogLevel(D.Debug)&&this.log(D.Debug,this.format([t,...r]))}info(t,...r){this.checkLogLevel(D.Info)&&this.log(D.Info,this.format([t,...r]))}warn(t,...r){this.checkLogLevel(D.Warning)&&this.log(D.Warning,this.format([t,...r]))}error(t,...r){if(this.checkLogLevel(D.Error))if(t instanceof Error){const i=Array.prototype.slice.call(arguments);i[0]=t.stack,this.log(D.Error,this.format(i))}else this.log(D.Error,this.format([t,...r]))}critical(t,...r){this.checkLogLevel(D.Critical)&&this.log(D.Critical,this.format([t,...r]))}flush(){}format(t){let r="";for(let i=0;i<t.length;i++){let n=t[i];if(typeof n=="object")try{n=JSON.stringify(n)}catch(a){}r+=(i>0?" ":"")+n}return r}}e.AbstractMessageLogger=s;class I extends P{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!k.isWindows}trace(t,...r){this.getLevel()<=D.Trace&&(this.useColors?console.log(`[90m[main ${C()}][0m`,t,...r):console.log(`[main ${C()}]`,t,...r))}debug(t,...r){this.getLevel()<=D.Debug&&(this.useColors?console.log(`[90m[main ${C()}][0m`,t,...r):console.log(`[main ${C()}]`,t,...r))}info(t,...r){this.getLevel()<=D.Info&&(this.useColors?console.log(`[90m[main ${C()}][0m`,t,...r):console.log(`[main ${C()}]`,t,...r))}warn(t,...r){this.getLevel()<=D.Warning&&(this.useColors?console.warn(`[93m[main ${C()}][0m`,t,...r):console.warn(`[main ${C()}]`,t,...r))}error(t,...r){this.getLevel()<=D.Error&&(this.useColors?console.error(`[91m[main ${C()}][0m`,t,...r):console.error(`[main ${C()}]`,t,...r))}critical(t,...r){this.getLevel()<=D.Critical&&(this.useColors?console.error(`[90m[main ${C()}][0m`,t,...r):console.error(`[main ${C()}]`,t,...r))}dispose(){}flush(){}}e.ConsoleMainLogger=I;class l extends P{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...r){this.getLevel()<=D.Trace&&console.log("%cTRACE","color: #888",t,...r)}debug(t,...r){this.getLevel()<=D.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...r)}info(t,...r){this.getLevel()<=D.Info&&console.log("%c INFO","color: #33f",t,...r)}warn(t,...r){this.getLevel()<=D.Warning&&console.log("%c WARN","color: #993",t,...r)}error(t,...r){this.getLevel()<=D.Error&&console.log("%c  ERR","color: #f33",t,...r)}critical(t,...r){this.getLevel()<=D.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...r)}dispose(){}flush(){}}e.ConsoleLogger=l;class g extends P{constructor(t,r=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(r)}trace(t,...r){this.getLevel()<=D.Trace&&this.adapter.log(D.Trace,[this.extractMessage(t),...r])}debug(t,...r){this.getLevel()<=D.Debug&&this.adapter.log(D.Debug,[this.extractMessage(t),...r])}info(t,...r){this.getLevel()<=D.Info&&this.adapter.log(D.Info,[this.extractMessage(t),...r])}warn(t,...r){this.getLevel()<=D.Warning&&this.adapter.log(D.Warning,[this.extractMessage(t),...r])}error(t,...r){this.getLevel()<=D.Error&&this.adapter.log(D.Error,[this.extractMessage(t),...r])}critical(t,...r){this.getLevel()<=D.Critical&&this.adapter.log(D.Critical,[this.extractMessage(t),...r])}extractMessage(t){return typeof t=="string"?t:A.toErrorMessage(t,this.getLevel()<=D.Trace)}dispose(){}flush(){}}e.AdapterLogger=g;class c extends P{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const r of this.logServices)r.setLevel(t);super.setLevel(t)}trace(t,...r){for(const i of this.logServices)i.trace(t,...r)}debug(t,...r){for(const i of this.logServices)i.debug(t,...r)}info(t,...r){for(const i of this.logServices)i.info(t,...r)}warn(t,...r){for(const i of this.logServices)i.warn(t,...r)}error(t,...r){for(const i of this.logServices)i.error(t,...r)}critical(t,...r){for(const i of this.logServices)i.critical(t,...r)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=c;class f extends R.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...r){this.logger.trace(t,...r)}debug(t,...r){this.logger.debug(t,...r)}info(t,...r){this.logger.info(t,...r)}warn(t,...r){this.logger.warn(t,...r)}error(t,...r){this.logger.error(t,...r)}critical(t,...r){this.logger.critical(t,...r)}flush(){this.logger.flush()}}e.LogService=f;class _ extends R.Disposable{constructor(t,r){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(r(i=>{this.logLevel=i,this.logLevelChangeableLoggers.forEach(n=>n.setLevel(i))}))}createLogger(t,r){let i=this.loggers.get(t.toString());return i||(i=this.doCreateLogger(t,(r==null?void 0:r.always)?D.Trace:this.logLevel,r),this.loggers.set(t.toString(),i),(r==null?void 0:r.always)||this.logLevelChangeableLoggers.push(i)),i}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=_;class w{constructor(){this.onDidChangeLogLevel=new y.Emitter().event}setLevel(t){}getLevel(){return D.Info}trace(t,...r){}debug(t,...r){}info(t,...r){}warn(t,...r){}error(t,...r){}critical(t,...r){}dispose(){}flush(){}}e.NullLogService=w;function E(m){if(m.verbose)return D.Trace;if(typeof m.logLevel=="string"){const t=u(m.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=E;function u(m){switch(m){case"trace":return D.Trace;case"debug":return D.Debug;case"info":return D.Info;case"warn":return D.Warning;case"error":return D.Error;case"critical":return D.Critical;case"off":return D.Off}}e.parseLogLevel=u;function h(m){switch(m){case D.Trace:return"trace";case D.Debug:return"debug";case D.Info:return"info";case D.Warning:return"warn";case D.Error:return"error";case D.Critical:return"critical";case D.Off:return"off"}}e.LogLevelToString=h}),define(ge[112],pe([0,1,15,42]),function(X,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function k(D,P,s,I){try{const l=await new Promise((g,c)=>{X(["spdlog"],g,c)});return l.setFlushOn(v.LogLevel.Trace),l.createAsyncRotatingLogger(D,P,s,I)}catch(l){console.error(l)}return null}function y(D,P,s,I){const l=X.__$__nodeRequire("spdlog");return l.setFlushOn(v.LogLevel.Trace),l.createRotatingLogger(D,P,s,I)}e.createRotatingLogger=y;function A(D,P,s){switch(P){case v.LogLevel.Trace:D.trace(s);break;case v.LogLevel.Debug:D.debug(s);break;case v.LogLevel.Info:D.info(s);break;case v.LogLevel.Warning:D.warn(s);break;case v.LogLevel.Error:D.error(s);break;case v.LogLevel.Critical:D.critical(s);break;default:throw new Error("Invalid log level")}}class C extends v.AbstractMessageLogger{constructor(P,s,I,l){super();this.name=P,this.filepath=s,this.rotating=I,this.buffer=[],this.setLevel(l),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(g=>{this._logger&&this._logger.setLevel(g)}))}_createSpdLogLogger(){const P=this.rotating?6:1,s=30/P*R.ByteSize.MB;return k(this.name,this.filepath,s,P).then(I=>{if(I){this._logger=I,this._logger.setLevel(this.getLevel());for(const{level:l,message:g}of this.buffer)A(this._logger,l,g);this.buffer=[]}})}log(P,s){this._logger?A(this._logger,P,s):this.getLevel()<=P&&this.buffer.push({level:P,message:s})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=C}),define(ge[113],pe([0,1,4,156,52]),function(X,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var y;(function(D){D[D.Unnecessary=1]="Unnecessary",D[D.Deprecated=2]="Deprecated"})(y=e.MarkerTag||(e.MarkerTag={}));var A;(function(D){D[D.Hint=1]="Hint",D[D.Info=2]="Info",D[D.Warning=4]="Warning",D[D.Error=8]="Error"})(A=e.MarkerSeverity||(e.MarkerSeverity={})),function(D){function P(c,f){return f-c}D.compare=P;const s=Object.create(null);s[D.Error]=R.localize(0,null),s[D.Warning]=R.localize(1,null),s[D.Info]=R.localize(2,null);function I(c){return s[c]||""}D.toString=I;function l(c){switch(c){case k.default.Error:return D.Error;case k.default.Warning:return D.Warning;case k.default.Info:return D.Info;case k.default.Ignore:return D.Hint}}D.fromSeverity=l;function g(c){switch(c){case D.Error:return k.default.Error;case D.Warning:return k.default.Warning;case D.Info:return k.default.Info;case D.Hint:return k.default.Ignore}}D.toSeverity=g}(A=e.MarkerSeverity||(e.MarkerSeverity={}));var C;(function(D){const P="";function s(l){return I(l,!0)}D.makeKey=s;function I(l,g){let c=[P];return l.source?c.push(l.source.replace("\xA6","\\\xA6")):c.push(P),l.code?typeof l.code=="string"?c.push(l.code.replace("\xA6","\\\xA6")):c.push(l.code.value.replace("\xA6","\\\xA6")):c.push(P),l.severity!==void 0&&l.severity!==null?c.push(A.toString(l.severity)):c.push(P),l.message&&g?c.push(l.message.replace("\xA6","\\\xA6")):c.push(P),l.startLineNumber!==void 0&&l.startLineNumber!==null?c.push(l.startLineNumber.toString()):c.push(P),l.startColumn!==void 0&&l.startColumn!==null?c.push(l.startColumn.toString()):c.push(P),l.endLineNumber!==void 0&&l.endLineNumber!==null?c.push(l.endLineNumber.toString()):c.push(P),l.endColumn!==void 0&&l.endColumn!==null?c.push(l.endColumn.toString()):c.push(P),c.push(P),c.join("\xA6")}D.makeKeyOptionalMessage=I})(C=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=v.createDecorator("markerService")}),define(ge[180],pe([0,1,52,4,3]),function(X,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=v.default,e.INotificationService=R.createDecorator("notificationService");var y;(function(P){P[P.WORKSPACE=0]="WORKSPACE",P[P.GLOBAL=1]="GLOBAL"})(y=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var A;(function(P){P[P.OFF=0]="OFF",P[P.SILENT=1]="SILENT",P[P.ERROR=2]="ERROR"})(A=e.NotificationsFilter||(e.NotificationsFilter={}));class C{constructor(){this.progress=new D,this.onDidClose=k.Event.None,this.onDidChangeVisibility=k.Event.None}updateSeverity(s){}updateMessage(s){}updateActions(s){}close(){}}e.NoOpNotification=C;class D{infinite(){}done(){}total(s){}worked(s){}}e.NoOpProgress=D}),define(ge[181],pe([0,1,6,8,2,4]),function(X,e,v,R,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=y.createDecorator("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return v.Disposable.None},registerValidator(){return v.Disposable.None},registerExternalUriResolver(){return v.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return v.Disposable.None},async open(){return!1},async resolveExternalUri(C){return{resolved:C,dispose(){}}}});function A(C,D){return k.URI.isUri(C)?R.equalsIgnoreCase(C.scheme,D):R.startsWithIgnoreCase(C,D+":")}e.matchesScheme=A}),define(ge[182],pe([0,1,10,11,37,24]),function(X,e,v,R,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let A;if(typeof R.globals.vscode!="undefined"&&typeof R.globals.vscode.context!="undefined"){const C=R.globals.vscode.context.configuration();if(C)A=C.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof(X==null?void 0:X.__$__nodeRequire)=="function"){const C=y.dirname(v.FileAccess.asFileUri("",X));A=X.__$__nodeRequire(y.joinPath(C,"product.json").fsPath);const D=X.__$__nodeRequire(y.joinPath(C,"package.json").fsPath);k.env.VSCODE_DEV&&Object.assign(A,{nameShort:`${A.nameShort} Dev`,nameLong:`${A.nameLong} Dev`,dataFolderName:`${A.dataFolderName}-dev`}),Object.assign(A,{version:D.version})}else A={},Object.keys(A).length===0&&Object.assign(A,{version:"1.57.0-dev",nameShort:R.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:R.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=A});var We=this&&this.__param||function(X,e){return function(v,R){e(v,R,X)}};define(ge[114],pe([0,1,4,21,6,14]),function(X,e,v,R,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=v.createDecorator("progressService");var A;(function(s){s[s.Explorer=1]="Explorer",s[s.Scm=3]="Scm",s[s.Extensions=5]="Extensions",s[s.Window=10]="Window",s[s.Notification=15]="Notification",s[s.Dialog=20]="Dialog"})(A=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class C{constructor(I){this.callback=I}get value(){return this._value}report(I){this._value=I,this.callback(this._value)}}e.Progress=C,C.None=Object.freeze({report(){}});let D=class extends k.Disposable{constructor(I,l){super();this.deferred=new y.DeferredPromise,l.withProgress(I,g=>(this.reporter=g,this.lastStep&&g.report(this.lastStep),this.deferred.p)),this._register(k.toDisposable(()=>this.deferred.complete()))}report(I){this.reporter?this.reporter.report(I):this.lastStep=I}};D=Ve([We(1,e.IProgressService)],D),e.UnmanagedProgress=D;class P extends k.Disposable{constructor(I){super();this.progressIndicator=I,this.currentOperationId=0,this.currentOperationDisposables=this._register(new k.DisposableStore)}start(I){this.stop();const l=++this.currentOperationId,g=new R.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{l===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},I),this.currentOperationDisposables.add(k.toDisposable(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add(k.toDisposable(()=>g.cancel())),this.currentOperationDisposables.add(k.toDisposable(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:l,token:g.token,stop:()=>this.doStop(l),isCurrent:()=>this.currentOperationId===l}}stop(){this.doStop(this.currentOperationId)}doStop(I){this.currentOperationId===I&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=P,e.IEditorProgressService=v.createDecorator("editorProgressService")}),define(ge[56],pe([0,1,13,49]),function(X,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.data=new Map}add(A,C){R.ok(v.isString(A)),R.ok(v.isObject(C)),R.ok(!this.data.has(A),"There is already an extension with this id"),this.data.set(A,C)}knows(A){return this.data.has(A)}as(A){return this.data.get(A)||null}}e.Registry=new k}),define(ge[183],pe([0,1,56,3]),function(X,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(C){return C.length>0&&C.charAt(C.length-1)==="#"?C.substring(0,C.length-1):C}class y{constructor(){this._onDidChangeSchema=new R.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(D,P){this.schemasById[k(D)]=P,this._onDidChangeSchema.fire(D)}notifySchemaChanged(D){this._onDidChangeSchema.fire(D)}getSchemaContributions(){return{schemas:this.schemasById}}}const A=new y;v.Registry.add(e.Extensions.JSONContribution,A)}),define(ge[81],pe([0,1,151,3,56,13,183]),function(X,e,v,R,k,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var C;(function(_){_[_.APPLICATION=1]="APPLICATION",_[_.MACHINE=2]="MACHINE",_[_.WINDOW=3]="WINDOW",_[_.RESOURCE=4]="RESOURCE",_[_.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",_[_.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(C=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const D=k.Registry.as(A.Extensions.JSONContribution);class P{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new R.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new R.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:v.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(w,E=!0){this.registerConfigurations([w],E)}registerConfigurations(w,E=!0){const u=[];w.forEach(h=>{u.push(...this.validateAndRegisterProperties(h,E,h.extensionInfo)),this.configurationContributors.push(h),this.registerJSONConfiguration(h)}),D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(u)}deregisterConfigurations(w){const E=[],u=h=>{if(h.properties)for(const m in h.properties)E.push(m),delete this.configurationProperties[m],this.removeFromSchema(m,h.properties[m]);h.allOf&&h.allOf.forEach(m=>u(m))};for(const h of w){u(h);const m=this.configurationContributors.indexOf(h);m!==-1&&this.configurationContributors.splice(m,1)}D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(E)}registerDefaultConfigurations(w){const E=[],u=[];for(const h of w)for(const m in h)if(E.push(m),e.OVERRIDE_PROPERTY_PATTERN.test(m)){this.defaultValues[m]=Object.assign(Object.assign({},this.defaultValues[m]||{}),h[m]);const t={type:"object",default:this.defaultValues[m],description:v.localize(1,null,m),$ref:e.resourceLanguageSettingsSchemaId};u.push(I(m)),this.configurationProperties[m]=t,this.defaultLanguageConfigurationOverridesNode.properties[m]=t}else{this.defaultValues[m]=h[m];const t=this.configurationProperties[m];t&&(this.updatePropertyDefaultValue(m,t),this.updateSchema(m,t))}this.registerOverrideIdentifiers(u),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(E)}deregisterDefaultConfigurations(w){const E=[];for(const u of w)for(const h in u)if(E.push(h),delete this.defaultValues[h],e.OVERRIDE_PROPERTY_PATTERN.test(h))delete this.configurationProperties[h],delete this.defaultLanguageConfigurationOverridesNode.properties[h];else{const m=this.configurationProperties[h];m&&(this.updatePropertyDefaultValue(h,m),this.updateSchema(h,m))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(E)}notifyConfigurationSchemaUpdated(...w){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(w){for(const E of w)this.overrideIdentifiers.add(E);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(w,E=!0,u,h=3){var m;h=y.isUndefinedOrNull(w.scope)?h:w.scope;let t=[],r=w.properties;if(r)for(let n in r){if(E&&c(n)){delete r[n];continue}const a=r[n];if(this.updatePropertyDefaultValue(n,a),e.OVERRIDE_PROPERTY_PATTERN.test(n)?a.scope=void 0:(a.scope=y.isUndefinedOrNull(a.scope)?h:a.scope,a.restricted=y.isUndefinedOrNull(a.restricted)?!!((m=u==null?void 0:u.restrictedConfigurations)===null||m===void 0?void 0:m.includes(n)):a.restricted),r[n].hasOwnProperty("included")&&!r[n].included){this.excludedConfigurationProperties[n]=r[n],delete r[n];continue}else this.configurationProperties[n]=r[n];!r[n].deprecationMessage&&r[n].markdownDeprecationMessage&&(r[n].deprecationMessage=r[n].markdownDeprecationMessage),t.push(n)}let i=w.allOf;if(i)for(let n of i)t.push(...this.validateAndRegisterProperties(n,E,u,h));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(w){const E=u=>{let h=u.properties;if(h)for(const t in h)this.updateSchema(t,h[t]);let m=u.allOf;m&&m.forEach(E)};E(w)}updateSchema(w,E){switch(e.allSettings.properties[w]=E,E.scope){case 1:e.applicationSettings.properties[w]=E;break;case 2:e.machineSettings.properties[w]=E;break;case 6:e.machineOverridableSettings.properties[w]=E;break;case 3:e.windowSettings.properties[w]=E;break;case 4:e.resourceSettings.properties[w]=E;break;case 5:e.resourceSettings.properties[w]=E,this.resourceLanguageSettingsSchema.properties[w]=E;break}}removeFromSchema(w,E){switch(delete e.allSettings.properties[w],E.scope){case 1:delete e.applicationSettings.properties[w];break;case 2:delete e.machineSettings.properties[w];break;case 6:delete e.machineOverridableSettings.properties[w];break;case 3:delete e.windowSettings.properties[w];break;case 4:case 5:delete e.resourceSettings.properties[w];break}}updateOverridePropertyPatternKey(){for(const w of this.overrideIdentifiers.values()){const E=`[${w}]`,u={type:"object",description:v.localize(2,null),errorMessage:v.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(E,u),e.allSettings.properties[E]=u,e.applicationSettings.properties[E]=u,e.machineSettings.properties[E]=u,e.machineOverridableSettings.properties[E]=u,e.windowSettings.properties[E]=u,e.resourceSettings.properties[E]=u}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(w,E){let u=this.defaultValues[w];y.isUndefined(u)&&(u=E.default),y.isUndefined(u)&&(u=l(E.type)),E.default=u}}const s="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(s);function I(_){return _.substring(1,_.length-1)}e.overrideIdentifierFromKey=I;function l(_){switch(Array.isArray(_)?_[0]:_){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=l;const g=new P;k.Registry.add(e.Extensions.Configuration,g);function c(_){return _.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(_)?v.localize(5,null,_):g.getConfigurationProperties()[_]!==void 0?v.localize(6,null,_):null:v.localize(4,null)}e.validateProperty=c;function f(){const _=[],w=g.getConfigurationProperties();for(const E of Object.keys(w))_.push([E,w[E].scope]);return _.push(["launch",4]),_.push(["task",4]),_}e.getScopes=f}),define(ge[82],pe([0,1,25,13,2,56,4,81]),function(X,e,v,R,k,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=A.createDecorator("configurationService");function D(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof k.URI)}e.isConfigurationOverrides=D;var P;(function(r){r[r.USER=1]="USER",r[r.USER_LOCAL=2]="USER_LOCAL",r[r.USER_REMOTE=3]="USER_REMOTE",r[r.WORKSPACE=4]="WORKSPACE",r[r.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",r[r.DEFAULT=6]="DEFAULT",r[r.MEMORY=7]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function s(r){switch(r){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=s;function I(r,i){const n=i?r?i.keys.filter(L=>r.keys.indexOf(L)===-1):[...i.keys]:[],a=r?i?r.keys.filter(L=>i.keys.indexOf(L)===-1):[...r.keys]:[],p=[];if(i&&r){for(const L of r.keys)if(i.keys.indexOf(L)!==-1){const O=w(r.contents,L),W=w(i.contents,L);v.equals(O,W)||p.push(L)}}const d=[],b=L=>{const O={};for(const W of L)for(const J of W.identifiers)O[m(J)]=W;return O},S=i?b(i.overrides):{},o=r?b(r.overrides):{};if(Object.keys(S).length)for(const L of n){const O=S[L];O&&d.push([C.overrideIdentifierFromKey(L),O.keys])}if(Object.keys(o).length)for(const L of a){const O=o[L];O&&d.push([C.overrideIdentifierFromKey(L),O.keys])}if(Object.keys(S).length&&Object.keys(o).length)for(const L of p){const O=o[L],W=S[L];if(O&&W){const J=I({contents:O.contents,keys:O.keys,overrides:[]},{contents:W.contents,keys:W.keys,overrides:[]});d.push([C.overrideIdentifierFromKey(L),[...J.added,...J.removed,...J.updated]])}}return{added:n,removed:a,updated:p,overrides:d}}e.compare=I;function l(r,i){const n=[];for(const a of Object.keys(r))if(C.OVERRIDE_PROPERTY_PATTERN.test(a)){const p={};for(const d in r[a])p[d]=r[a][d];n.push({identifiers:[C.overrideIdentifierFromKey(a).trim()],keys:Object.keys(p),contents:g(p,i)})}return n}e.toOverrides=l;function g(r,i){const n=Object.create(null);for(let a in r)c(n,a,r[a],i);return n}e.toValuesTree=g;function c(r,i,n,a){const p=i.split("."),d=p.pop();let b=r;for(let S=0;S<p.length;S++){let o=p[S],L=b[o];switch(typeof L){case"undefined":L=b[o]=Object.create(null);break;case"object":break;default:a(`Ignoring ${i} as ${p.slice(0,S+1).join(".")} is ${JSON.stringify(L)}`);return}b=L}if(typeof b=="object"&&b!==null)try{b[d]=n}catch(S){a(`Ignoring ${i} as ${p.join(".")} is ${JSON.stringify(b)}`)}else a(`Ignoring ${i} as ${p.join(".")} is ${JSON.stringify(b)}`)}e.addToValueTree=c;function f(r,i){const n=i.split(".");_(r,n)}e.removeFromValueTree=f;function _(r,i){const n=i.shift();if(i.length===0){delete r[n];return}if(Object.keys(r).indexOf(n)!==-1){const a=r[n];typeof a=="object"&&!Array.isArray(a)&&(_(a,i),Object.keys(a).length===0&&delete r[n])}}function w(r,i,n){function a(b,S){let o=b;for(const L of S){if(typeof o!="object"||o===null)return;o=o[L]}return o}const p=i.split("."),d=a(r,p);return typeof d=="undefined"?n:d}e.getConfigurationValue=w;function E(r,i,n){Object.keys(i).forEach(a=>{a!=="__proto__"&&(a in r?R.isObject(r[a])&&R.isObject(i[a])?E(r[a],i[a],n):n&&(r[a]=i[a]):r[a]=i[a])})}e.merge=E;function u(){const r=y.Registry.as(C.Extensions.Configuration).getConfigurationProperties();return Object.keys(r)}e.getConfigurationKeys=u;function h(){const r=Object.create(null),i=y.Registry.as(C.Extensions.Configuration).getConfigurationProperties();for(let n in i){let a=i[n].default;c(r,n,a,p=>console.error(`Conflict in default settings: ${p}`))}return r}e.getDefaultValues=h;function m(r){return`[${r}]`}e.keyFromOverrideIdentifier=m;function t(r,i,n){const a=r.inspect(i),p=r.inspect(n);return typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:typeof p.userValue!="undefined"||typeof p.workspaceValue!="undefined"||typeof p.workspaceFolderValue!="undefined"?p.value:a.defaultValue}e.getMigratedSettingValue=t}),define(ge[184],pe([0,1,51,23,17,13,25,2,81,82,56,6,3]),function(X,e,v,R,k,y,A,C,D,P,s,I,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class g{constructor(t={},r=[],i=[]){this._contents=t,this._keys=r,this._overrides=i,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?P.getConfigurationValue(this.contents,t):this.contents}getOverrideValue(t,r){const i=this.getContentsForOverrideIdentifer(r);return i?t?P.getConfigurationValue(i,t):i:void 0}getKeysForOverrideIdentifier(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.keys;return[]}override(t){const r=this.getContentsForOverrideIdentifer(t);if(!r||typeof r!="object"||!Object.keys(r).length)return this;let i={};for(const n of k.distinct([...Object.keys(this.contents),...Object.keys(r)])){let a=this.contents[n],p=r[n];p&&(typeof a=="object"&&typeof p=="object"?(a=A.deepClone(a),this.mergeContents(a,p)):a=p),i[n]=a}return new g(i,this.keys,this.overrides)}merge(...t){const r=A.deepClone(this.contents),i=A.deepClone(this.overrides),n=[...this.keys];for(const a of t){this.mergeContents(r,a.contents);for(const p of a.overrides){const[d]=i.filter(b=>k.equals(b.identifiers,p.identifiers));d?this.mergeContents(d.contents,p.contents):i.push(A.deepClone(p))}for(const p of a.keys)n.indexOf(p)===-1&&n.push(p)}return new g(r,n,i)}freeze(){return this.isFrozen=!0,this}mergeContents(t,r){for(const i of Object.keys(r)){if(i in t&&y.isObject(t[i])&&y.isObject(r[i])){this.mergeContents(t[i],r[i]);continue}t[i]=A.deepClone(r[i])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?A.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,r){this.addKey(t),P.addToValueTree(this.contents,t,r,i=>{throw new Error(i)})}removeValue(t){this.removeKey(t)&&P.removeFromValueTree(this.contents,t)}addKey(t){let r=this.keys.length;for(let i=0;i<r;i++)t.indexOf(this.keys[i])===0&&(r=i);this.keys.splice(r,1,t)}removeKey(t){let r=this.keys.indexOf(t);return r!==-1?(this.keys.splice(r,1),!0):!1}}e.ConfigurationModel=g;class c extends g{constructor(){const t=P.getDefaultValues(),r=P.getConfigurationKeys(),i=[];for(const n of Object.keys(t))D.OVERRIDE_PROPERTY_PATTERN.test(n)&&i.push({identifiers:[D.overrideIdentifierFromKey(n).trim()],keys:Object.keys(t[n]),contents:P.toValuesTree(t[n],a=>console.error(`Conflict in default settings file: ${a}`))});super(t,r,i)}}e.DefaultConfigurationModel=c;class f{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new g}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,r){if(!y.isUndefinedOrNull(t)){const i=this.doParseContent(t);this.parseRaw(i,r)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,r){this._raw=t;const{contents:i,keys:n,overrides:a,restricted:p}=this.doParseRaw(t,r);this._configurationModel=new g(i,n,a),this._restrictedConfigurations=p||[]}doParseContent(t){let r={},i=null,n=[],a=[],p=[];function d(S){Array.isArray(n)?n.push(S):i&&(n[i]=S)}let b={onObjectBegin:()=>{let S={};d(S),a.push(n),n=S,i=null},onObjectProperty:S=>{i=S},onObjectEnd:()=>{n=a.pop()},onArrayBegin:()=>{let S=[];d(S),a.push(n),n=S,i=null},onArrayEnd:()=>{n=a.pop()},onLiteralValue:d,onError:(S,o,L)=>{p.push({error:S,offset:o,length:L})}};if(t)try{v.visit(t,b),r=n[0]||{}}catch(S){console.error(`Error while parsing settings file ${this._name}: ${S}`),this._parseErrors=[S]}return r}doParseRaw(t,r){const i=s.Registry.as(D.Extensions.Configuration).getConfigurationProperties(),n=this.filter(t,i,!0,r);t=n.raw;const a=P.toValuesTree(t,b=>console.error(`Conflict in settings file ${this._name}: ${b}`)),p=Object.keys(t),d=P.toOverrides(t,b=>console.error(`Conflict in settings file ${this._name}: ${b}`));return{contents:a,keys:p,overrides:d,restricted:n.restricted}}filter(t,r,i,n){if(!(n==null?void 0:n.scopes)&&!(n==null?void 0:n.skipRestricted))return{raw:t,restricted:[]};const a={},p=[];for(let d in t)if(D.OVERRIDE_PROPERTY_PATTERN.test(d)&&i){const b=this.filter(t[d],r,!1,n);a[d]=b.raw,p.push(...b.restricted)}else{const b=r[d],S=b?typeof b.scope!="undefined"?b.scope:3:void 0;(b==null?void 0:b.restricted)&&p.push(d),(S===void 0||n.scopes===void 0||n.scopes.includes(S))&&(n.skipRestricted&&(b==null?void 0:b.restricted)||(a[d]=t[d]))}return{raw:a,restricted:p}}}e.ConfigurationModelParser=f;class _ extends I.Disposable{constructor(t,r,i,n){super();this.userSettingsResource=t,this.scopes=r,this.fileService=n,this._onDidChange=this._register(new l.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new f(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(i.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(l.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new g}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=_;class w{constructor(t,r,i=new g,n=new g,a=new R.ResourceMap,p=new g,d=new R.ResourceMap,b=!0){this._defaultConfiguration=t,this._localUserConfiguration=r,this._remoteUserConfiguration=i,this._workspaceConfiguration=n,this._folderConfigurations=a,this._memoryConfiguration=p,this._memoryConfigurationByResource=d,this._freeze=b,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new R.ResourceMap,this._userConfiguration=null}getValue(t,r,i){return this.getConsolidateConfigurationModel(r,i).getValue(t)}updateValue(t,r,i={}){let n;i.resource?(n=this._memoryConfigurationByResource.get(i.resource),n||(n=new g,this._memoryConfigurationByResource.set(i.resource,n))):n=this._memoryConfiguration,r===void 0?n.removeValue(t):n.setValue(t,r),i.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,r,i){const n=this.getConsolidateConfigurationModel(r,i),a=this.getFolderConfigurationModelForResource(r.resource,i),p=r.resource?this._memoryConfigurationByResource.get(r.resource)||this._memoryConfiguration:this._memoryConfiguration,d=r.overrideIdentifier?this._defaultConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),b=r.overrideIdentifier?this.userConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),S=r.overrideIdentifier?this.localUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),o=r.overrideIdentifier?this.remoteUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),L=i?r.overrideIdentifier?this._workspaceConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,O=a?r.overrideIdentifier?a.freeze().override(r.overrideIdentifier).getValue(t):a.freeze().getValue(t):void 0,W=r.overrideIdentifier?p.override(r.overrideIdentifier).getValue(t):p.getValue(t),J=n.getValue(t),oe=k.distinct(k.flatten(n.overrides.map(q=>q.identifiers))).filter(q=>n.getOverrideValue(t,q)!==void 0);return{defaultValue:d,userValue:b,userLocalValue:S,userRemoteValue:o,workspaceValue:L,workspaceFolderValue:O,memoryValue:W,value:J,default:d!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,user:b!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userLocal:S!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userRemote:o!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspace:L!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspaceFolder:O!==void 0?{value:a==null?void 0:a.freeze().getValue(t),override:r.overrideIdentifier?a==null?void 0:a.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,memory:W!==void 0?{value:p.getValue(t),override:r.overrideIdentifier?p.getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,overrideIdentifiers:oe.length?oe:void 0}}keys(t){const r=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:r?r.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,r){this._folderConfigurations.set(t,r),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,r){const i=r.filter(n=>D.OVERRIDE_PROPERTY_PATTERN.test(n)).map(n=>{const a=D.overrideIdentifierFromKey(n),p=this._defaultConfiguration.getKeysForOverrideIdentifier(a),d=t.getKeysForOverrideIdentifier(a),b=[...d.filter(S=>p.indexOf(S)===-1),...p.filter(S=>d.indexOf(S)===-1),...p.filter(S=>!A.equals(this._defaultConfiguration.override(a).getValue(S),t.override(a).getValue(S)))];return[a,b]});return this.updateDefaultConfiguration(t),{keys:r,overrides:i}}compareAndUpdateLocalUserConfiguration(t){const{added:r,updated:i,removed:n,overrides:a}=P.compare(this.localUserConfiguration,t),p=[...r,...i,...n];return p.length&&this.updateLocalUserConfiguration(t),{keys:p,overrides:a}}compareAndUpdateRemoteUserConfiguration(t){const{added:r,updated:i,removed:n,overrides:a}=P.compare(this.remoteUserConfiguration,t);let p=[...r,...i,...n];return p.length&&this.updateRemoteUserConfiguration(t),{keys:p,overrides:a}}compareAndUpdateWorkspaceConfiguration(t){const{added:r,updated:i,removed:n,overrides:a}=P.compare(this.workspaceConfiguration,t);let p=[...r,...i,...n];return p.length&&this.updateWorkspaceConfiguration(t),{keys:p,overrides:a}}compareAndUpdateFolderConfiguration(t,r){const i=this.folderConfigurations.get(t),{added:n,updated:a,removed:p,overrides:d}=P.compare(i,r);let b=[...n,...a,...p];return(b.length||!i)&&this.updateFolderConfiguration(t,r),{keys:b,overrides:d}}compareAndDeleteFolderConfiguration(t){const r=this.folderConfigurations.get(t);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:i,updated:n,removed:a,overrides:p}=P.compare(r,void 0);return{keys:[...i,...n,...a],overrides:p}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,r){let i=this.getConsolidatedConfigurationModelForResource(t,r);return t.overrideIdentifier?i.override(t.overrideIdentifier):i}getConsolidatedConfigurationModelForResource({resource:t},r){let i=this.getWorkspaceConsolidatedConfiguration();if(r&&t){const n=r.getFolder(t);n&&(i=this.getFolderConsolidatedConfiguration(n.uri)||i);const a=this._memoryConfigurationByResource.get(t);a&&(i=i.merge(a))}return i}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let r=this._foldersConsolidatedConfigurations.get(t);if(!r){const i=this.getWorkspaceConsolidatedConfiguration(),n=this._folderConfigurations.get(t);n?(r=i.merge(n),this._freeze&&(r=r.freeze()),this._foldersConsolidatedConfigurations.set(t,r)):r=i}return r}getFolderConfigurationModelForResource(t,r){if(r&&t){const i=r.getFolder(t);if(i)return this._folderConfigurations.get(i.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,r)=>{const{contents:i,overrides:n,keys:a}=this._folderConfigurations.get(r);return t.push([r,{contents:i,overrides:n,keys:a}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(r=>t.add(r)),this.userConfiguration.freeze().keys.forEach(r=>t.add(r)),this._workspaceConfiguration.freeze().keys.forEach(r=>t.add(r)),this._folderConfigurations.forEach(r=>r.freeze().keys.forEach(i=>t.add(i))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const r=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>r.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>r.add(i)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.getKeysForOverrideIdentifier(t).forEach(n=>r.add(n))),[...r.values()]}static parse(t){const r=this.parseConfigurationModel(t.defaults),i=this.parseConfigurationModel(t.user),n=this.parseConfigurationModel(t.workspace),a=t.folders.reduce((p,d)=>(p.set(C.URI.revive(d[0]),this.parseConfigurationModel(d[1])),p),new R.ResourceMap);return new w(r,i,new g,n,a,new g,new R.ResourceMap,!1)}static parseConfigurationModel(t){return new g(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=w;function E(...m){if(m.length===0)return{keys:[],overrides:[]};if(m.length===1)return m[0];const t=new Set,r=new Map;for(const n of m)n.keys.forEach(a=>t.add(a)),n.overrides.forEach(([a,p])=>{const d=R.getOrSet(r,a,new Set);p.forEach(b=>d.add(b))});const i=[];return r.forEach((n,a)=>i.push([a,[...n.values()]])),{keys:[...t.values()],overrides:i}}e.mergeChanges=E;class u{constructor(t,r,i,n){this.change=t,this.previous=r,this.currentConfiguraiton=i,this.currentWorkspace=n,this._previousConfiguration=void 0;const a=new Set;t.keys.forEach(d=>a.add(d)),t.overrides.forEach(([,d])=>d.forEach(b=>a.add(b))),this.affectedKeys=[...a.values()];const p=new g;this.affectedKeys.forEach(d=>p.setValue(d,{})),this.affectedKeysTree=p.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=w.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,r){var i;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(r){const n=this.previousConfiguration?this.previousConfiguration.getValue(t,r,(i=this.previous)===null||i===void 0?void 0:i.workspace):void 0,a=this.currentConfiguraiton.getValue(t,r,this.currentWorkspace);return!A.equals(n,a)}return!0}return!1}doesAffectedKeysTreeContains(t,r){let i=P.toValuesTree({[r]:!0},()=>{}),n;for(;typeof i=="object"&&(n=Object.keys(i)[0]);){if(t=t[n],!t)return!1;i=i[n]}return!0}}e.ConfigurationChangeEvent=u;class h extends u{constructor(t,r,i,n){super({keys:t.allKeys(),overrides:[]},void 0,t,r);this.source=i,this.sourceConfig=n}}e.AllKeysConfigurationChangeEvent=h}),define(ge[185],pe([0,1,38,9,109,154,28,11,178,82,4,10,134]),function(X,e,v,R,k,y,A,C,D,P,s,I,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const g=y.localize(0,null);class c{async getDefaultTerminalForPlatforms(){const t=await w.getDefaultTerminalLinuxReady();return{windows:f.getDefaultTerminalWindows(),linux:t,osx:"xterm"}}}let f=class zt extends c{constructor(t){super();this._configurationService=t}openTerminal(t){const r=this._configurationService.getValue();return this.spawnTerminal(v,r,k.getWindowsShell(),t)}spawnTerminal(t,r,i,n){const a=r.terminal.external,p=(a==null?void 0:a.windowsExec)||zt.getDefaultTerminalWindows();n&&n[1]===":"&&(n=n[0].toUpperCase()+n.substr(1));const d=R.basename(p).toLowerCase();if(d==="cmder"||d==="cmder.exe")return t.spawn(p,n?[n]:void 0),Promise.resolve(void 0);const b=["/c","start","/wait"];return p.indexOf(" ")>=0&&b.push('""'),b.push(p),(d==="wt"||d==="wt.exe")&&b.push("-d ."),new Promise((S,o)=>{const L=E(process),O=t.spawn(i,b,{cwd:n,env:L});O.on("error",o),O.on("exit",()=>S())})}runInTerminal(t,r,i,n,a){const p="windowsExec"in a&&a.windowsExec?a.windowsExec:zt.getDefaultTerminalWindows();return new Promise((d,b)=>{const S=`"${r} - ${g}"`,o=`""${i.join('" "')}" & pause"`,L=["/c","start",S,"/wait",p,"/c",o],O=Object.assign({},E(process),n);Object.keys(O).filter(oe=>O[oe]===null).forEach(oe=>delete O[oe]);const W={cwd:r,env:O,windowsVerbatimArguments:!0};v.spawn(zt.CMD,L,W).on("error",oe=>{b(u(oe))}),d(void 0)})}static getDefaultTerminalWindows(){if(!zt._DEFAULT_TERMINAL_WINDOWS){const t=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");zt._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${t?"Sysnative":"System32"}\\cmd.exe`}return zt._DEFAULT_TERMINAL_WINDOWS}};f.CMD="cmd.exe",f=Ve([We(0,s.optional(P.IConfigurationService))],f),e.WindowsExternalTerminalService=f;let _=class On extends c{constructor(t){super();this._configurationService=t}openTerminal(t){const r=this._configurationService.getValue();return this.spawnTerminal(v,r,t)}runInTerminal(t,r,i,n,a){const p=a.osxExec||D.DEFAULT_TERMINAL_OSX;return new Promise((d,b)=>{if(p===D.DEFAULT_TERMINAL_OSX||p==="iTerm.app"){const S=p===D.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",L=[I.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${S}.scpt`,X).fsPath,"-t",t||g,"-w",r];for(let J of i)L.push("-a"),L.push(J);if(n)for(let J in n){const oe=n[J];oe===null?(L.push("-u"),L.push(J)):(L.push("-e"),L.push(`${J}=${oe}`))}let O="";const W=v.spawn(On.OSASCRIPT,L);W.on("error",J=>{b(u(J))}),W.stderr.on("data",J=>{O+=J.toString()}),W.on("exit",J=>{if(J===0)d(void 0);else if(O){const oe=O.split(`
`,1);b(new Error(oe[0]))}else b(new Error(y.localize(1,null,S,J)))})}else b(new Error(y.localize(2,null,p)))})}spawnTerminal(t,r,i){const n=r.terminal.external,a=(n==null?void 0:n.osxExec)||D.DEFAULT_TERMINAL_OSX;return new Promise((p,d)=>{const b=["-a",a];i&&b.push(i);const S=t.spawn("/usr/bin/open",b);S.on("error",d),S.on("exit",()=>p())})}};_.OSASCRIPT="/usr/bin/osascript",_=Ve([We(0,s.optional(P.IConfigurationService))],_),e.MacExternalTerminalService=_;let w=class Vt extends c{constructor(t){super();this._configurationService=t}openTerminal(t){const r=this._configurationService.getValue();return this.spawnTerminal(v,r,t)}runInTerminal(t,r,i,n,a){const p=a.linuxExec?Promise.resolve(a.linuxExec):Vt.getDefaultTerminalLinuxReady();return new Promise((d,b)=>{let S=[];p.then(o=>{o.indexOf("gnome-terminal")>=0?S.push("-x"):S.push("-e"),S.push("bash"),S.push("-c");const L=`${h(i)}; echo; read -p "${Vt.WAIT_MESSAGE}" -n1;`;S.push(`''${L}''`);const O=Object.assign({},process.env,n);Object.keys(O).filter(q=>O[q]===null).forEach(q=>delete O[q]);const W={cwd:r,env:O};let J="";const oe=v.spawn(o,S,W);oe.on("error",q=>{b(u(q))}),oe.stderr.on("data",q=>{J+=q.toString()}),oe.on("exit",q=>{if(q===0)d(void 0);else if(J){const x=J.split(`
`,1);b(new Error(x[0]))}else b(new Error(y.localize(4,null,o,q)))})})})}static async getDefaultTerminalLinuxReady(){return Vt._DEFAULT_TERMINAL_LINUX_READY||(Vt._DEFAULT_TERMINAL_LINUX_READY=new Promise(async t=>{C.isLinux?await A.exists("/etc/debian_version")?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm"):t("xterm")})),Vt._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(t,r,i){const n=r.terminal.external,a=(n==null?void 0:n.linuxExec)?Promise.resolve(n.linuxExec):Vt.getDefaultTerminalLinuxReady();return new Promise((p,d)=>{a.then(b=>{const S=E(process),o=t.spawn(b,[],{cwd:i,env:S});o.on("error",d),o.on("exit",()=>p())})})}};w.WAIT_MESSAGE=y.localize(3,null),w=Ve([We(0,s.optional(P.IConfigurationService))],w),e.LinuxExternalTerminalService=w;function E(m){const t=m.env;return l.sanitizeProcessEnvironment(t),t}function u(m){return"errno"in m&&m.errno==="ENOENT"&&"path"in m&&typeof m.path=="string"?new Error(y.localize(5,null,m.path)):m}function h(m){let t="";for(let r of m)r.indexOf(" ")>=0?t+='"'+r+'"':t+=r,t+=" ";return t}}),define(ge[115],pe([0,1,4]),function(X,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=v.createDecorator("remoteAuthorityResolverService");var R;(function(y){y.Unknown="Unknown",y.NotAvailable="NotAvailable",y.TemporarilyNotAvailable="TemporarilyNotAvailable",y.NoResolverFound="NoResolverFound"})(R=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class k extends Error{constructor(A,C=R.Unknown,D){super(A);this._message=A,this._code=C,this._detail=D,this.isHandled=C===R.NotAvailable&&D===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,k.prototype)}static isTemporarilyNotAvailable(A){return A instanceof k&&A._code===R.TemporarilyNotAvailable}static isNoResolverFound(A){return A instanceof k&&A._code===R.NoResolverFound}static isHandled(A){return A instanceof k&&A.isHandled}}e.RemoteAuthorityResolverError=k}),define(ge[116],pe([0,1,10]),function(X,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function R(P){return P.scheme===v.Schemas.vscodeRemote?P.authority:void 0}e.getRemoteAuthority=R;function k(P){if(!P)return;const s=P.indexOf("+");return s<0?P:P.substr(0,s)}e.getRemoteName=k;function y(P){return P.scheme!==v.Schemas.file&&P.scheme!==v.Schemas.vscodeRemote}e.isVirtualResource=y;function A(P){if(P.folders.length)return P.folders.every(s=>y(s.uri))?P.folders[0].uri:void 0;if(P.configuration&&y(P.configuration))return P.configuration}e.getVirtualWorkspaceLocation=A;function C(P){var s;return(s=A(P))===null||s===void 0?void 0:s.scheme}e.getVirtualWorkspaceScheme=C;function D(P){return A(P)!==void 0}e.isVirtualWorkspace=D}),define(ge[186],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class v{vsda(){return new Promise((k,y)=>X(["vsda"],k,y))}async sign(k){try{const y=await this.vsda(),A=new y.signer;if(A)return A.sign(k)}catch(y){}return k}}e.SignService=v}),define(ge[187],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class v{constructor(k){this._callback=k,this._terminalBufferMap=new Map}dispose(){for(const k of this._terminalBufferMap.values())k.dispose()}startBuffering(k,y,A=5){let C;return C=y(D=>{const P=typeof D=="string"?D:D.data;let s=this._terminalBufferMap.get(k);if(s){s.data.push(P);return}const I=setTimeout(()=>this.flushBuffer(k),A);s={data:[P],timeoutId:I,dispose:()=>{clearTimeout(I),this.flushBuffer(k),C.dispose()}},this._terminalBufferMap.set(k,s)}),C}stopBuffering(k){const y=this._terminalBufferMap.get(k);y&&y.dispose()}flushBuffer(k){const y=this._terminalBufferMap.get(k);y&&(this._terminalBufferMap.delete(k),this._callback(k,y.data.join("")))}}e.TerminalDataBufferer=v}),define(ge[57],pe([0,1,2,24,4,23]),function(X,e,v,R,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=k.createDecorator("contextService");var A;(function(l){l[l.EMPTY=1]="EMPTY",l[l.FOLDER=2]="FOLDER",l[l.WORKSPACE=3]="WORKSPACE"})(A=e.WorkbenchState||(e.WorkbenchState={}));function C(l){const g=l;return!!(g&&typeof g=="object"&&typeof g.id=="string"&&Array.isArray(g.folders))}e.isWorkspace=C;function D(l){const g=l;return!!(g&&typeof g=="object"&&v.URI.isUri(g.uri)&&typeof g.name=="string"&&typeof g.toResource=="function")}e.isWorkspaceFolder=D;class P{constructor(g,c,f,_){this._id=g,this._configuration=f,this._ignorePathCasing=_,this._foldersMap=y.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=c}update(g){this._id=g.id,this._configuration=g.configuration,this._ignorePathCasing=g._ignorePathCasing,this.folders=g.folders}get folders(){return this._folders}set folders(g){this._folders=g,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(g){this._configuration=g}getFolder(g){return g&&this._foldersMap.findSubstr(g.with({scheme:g.scheme,authority:g.authority,path:g.path}))||null}updateFoldersMap(){this._foldersMap=y.TernarySearchTree.forUris(this._ignorePathCasing);for(const g of this.folders)this._foldersMap.set(g.uri,g)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=P;class s{constructor(g,c){this.raw=c,this.uri=g.uri,this.index=g.index,this.name=g.name}toResource(g){return R.joinPath(this.uri,g)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=s;function I(l){return new s({uri:l,index:0,name:R.basenameOrAuthority(l)},{uri:l.toString()})}e.toWorkspaceFolder=I}),define(ge[188],pe([0,1,4,157,57,2,11,9,24,132,51,10,76,29,116]),function(X,e,v,R,k,y,A,C,D,P,s,I,l,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const f=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:R.localize(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function _(x){return(typeof x=="string"?C.extname(x):D.extname(x))===f}e.hasWorkspaceFileExtension=_,e.IWorkspacesService=v.createDecorator("workspacesService");function w(x){return x.hasOwnProperty("workspace")}e.isRecentWorkspace=w;function E(x){return x.hasOwnProperty("folderUri")}e.isRecentFolder=E;function u(x){return x.hasOwnProperty("fileUri")}e.isRecentFile=u;function h(x){const V=x;return typeof(V==null?void 0:V.id)=="string"&&y.URI.isUri(V.uri)}e.isSingleFolderWorkspaceIdentifier=h;function m(x){if(x.configuration)return{id:x.id,configPath:x.configuration};if(x.folders.length===1)return{id:x.id,uri:x.folders[0].uri}}e.toWorkspaceIdentifier=m;function t(x){const V=x;return typeof(V==null?void 0:V.id)=="string"&&y.URI.isUri(V.configPath)}e.isWorkspaceIdentifier=t;function r(x){const V=x;if(V==null?void 0:V.uri)return{id:V.id,uri:y.URI.revive(V.uri)};const T=x;if(T==null?void 0:T.configPath)return{id:T.id,configPath:y.URI.revive(T.configPath)};if(x==null?void 0:x.id)return{id:x.id}}e.reviveIdentifier=r;function i(x,V){return D.extUriBiasedIgnorePathCase.isEqualOrParent(x,V.untitledWorkspacesHome)}e.isUntitledWorkspace=i;function n(x){return a(x)||p(x)}e.isStoredWorkspaceFolder=n;function a(x){const V=x;return typeof(V==null?void 0:V.path)=="string"&&(!V.name||typeof V.name=="string")}e.isRawFileWorkspaceFolder=a;function p(x){const V=x;return typeof(V==null?void 0:V.uri)=="string"&&(!V.name||typeof V.name=="string")}e.isRawUriWorkspaceFolder=p;function d(x,V,T,N,F=!A.isWindows,M){if(x.scheme!==N.scheme)return{name:T,uri:x.toString(!0)};let U=V?void 0:M.relativePath(N,x);if(U!==void 0)U.length===0?U=".":A.isWindows&&x.scheme===I.Schemas.file&&!F&&(U=U.replace(/\//g,"\\"));else if(x.scheme===I.Schemas.file)U=x.fsPath,A.isWindows&&(U=l.normalizeDriveLetter(U),F&&(U=g.toSlashes(U)));else{if(!M.isEqualAuthority(x.authority,N.authority))return{name:T,uri:x.toString(!0)};U=x.path}return{name:T,path:U}}e.getStoredWorkspaceFolder=d;function b(x,V,T){let N=[],F=new Set;const M=T.dirname(V);for(let U of x){let B;if(a(U))U.path&&(B=T.resolvePath(M,U.path));else if(p(U))try{B=y.URI.parse(U.uri),B.path[0]!=="/"&&(B=B.with({path:"/"+B.path}))}catch(K){console.warn(K)}if(B){let K=T.getComparisonKey(B);if(!F.has(K)){F.add(K);const ie=U.name||T.basenameOrAuthority(B);N.push(new k.WorkspaceFolder({uri:B,name:ie,index:N.length},U))}}}return N}e.toWorkspaceFolders=b;function S(x,V,T,N,F){let M=o(V,x);const U=F.dirname(V),B=F.dirname(N),K=[],ie=L(M.folders);for(const Oe of M.folders){const je=a(Oe)?F.resolvePath(U,Oe.path):y.URI.parse(Oe.uri);let ze;T?ze=!1:ze=!a(Oe)||C.isAbsolute(Oe.path),K.push(d(je,ze,Oe.name,B,ie,F))}const we={insertSpaces:!1,tabSize:4,eol:A.isLinux||A.isMacintosh?`
`:`\r
`},Te=P.setProperty(x,["folders"],K,we);let ye=P.applyEdits(x,Te);return M.remoteAuthority===c.getRemoteAuthority(N)&&(ye=P.applyEdits(ye,P.removeProperty(ye,["remoteAuthority"],we))),ye}e.rewriteWorkspaceFileForNewLocation=S;function o(x,V){let T=s.parse(V);if(T&&Array.isArray(T.folders))T.folders=T.folders.filter(N=>n(N));else throw new Error(`${x} looks like an invalid workspace file.`);return T}function L(x){return A.isWindows?x.some(V=>a(V)&&V.path.indexOf("/")>=0):!0}e.useSlashForPath=L;function O(x){return x.workspace&&typeof x.workspace=="object"&&typeof x.workspace.id=="string"&&typeof x.workspace.configPath=="string"}function W(x){return typeof x.folderUri=="string"}function J(x){return typeof x.fileUri=="string"}function oe(x,V){const T={workspaces:[],files:[]};if(x){const N=function(M,U){for(let B=0;B<M.length;B++)try{U(M[B],B)}catch(K){V.warn(`Error restoring recent entry ${JSON.stringify(M[B])}: ${K.toString()}. Skip entry.`)}},F=x;if(Array.isArray(F.entries))N(F.entries,M=>{const U=M.label,B=M.remoteAuthority;O(M)?T.workspaces.push({label:U,remoteAuthority:B,workspace:{id:M.workspace.id,configPath:y.URI.parse(M.workspace.configPath)}}):W(M)?T.workspaces.push({label:U,remoteAuthority:B,folderUri:y.URI.parse(M.folderUri)}):J(M)&&T.files.push({label:U,remoteAuthority:B,fileUri:y.URI.parse(M.fileUri)})});else{const M=x;Array.isArray(M.workspaces3)&&N(M.workspaces3,(U,B)=>{const K=Array.isArray(M.workspaceLabels)&&M.workspaceLabels[B]||void 0;typeof U=="object"&&typeof U.id=="string"&&typeof U.configURIPath=="string"?T.workspaces.push({label:K,workspace:{id:U.id,configPath:y.URI.parse(U.configURIPath)}}):typeof U=="string"&&T.workspaces.push({label:K,folderUri:y.URI.parse(U)})}),Array.isArray(M.files2)&&N(M.files2,(U,B)=>{const K=Array.isArray(M.fileLabels)&&M.fileLabels[B]||void 0;typeof U=="string"&&T.files.push({label:K,fileUri:y.URI.parse(U)})})}}return T}e.restoreRecentlyOpened=oe;function q(x){const V={entries:[]};for(const T of x.workspaces)E(T)?V.entries.push({folderUri:T.folderUri.toString(),label:T.label,remoteAuthority:T.remoteAuthority}):V.entries.push({workspace:{id:T.workspace.id,configPath:T.workspace.configPath.toString()},label:T.label,remoteAuthority:T.remoteAuthority});for(const T of x.files)V.entries.push({fileUri:T.fileUri.toString(),label:T.label,remoteAuthority:T.remoteAuthority});return V}e.toStoreData=q}),define(ge[83],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class v{constructor(k){this.id=k,this._data=new Map,this._idPool=1}add(k){const y=this._idPool++;return this._data.set(y,k),this.logDebugInfo(),y}get(k,y){return this._data.has(k)?this._data.get(k)[y]:void 0}delete(k){this._data.delete(k),this.logDebugInfo()}logDebugInfo(){!v.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=v,v.enableDebugLogging=!1}),define(ge[45],pe([0,1,2,3,4]),function(X,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=k.createDecorator("IExtHostEditorTabs");class y{constructor(){this._onDidChangeTabs=new R.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(C){this._tabs=C.map(D=>({name:D.name,group:D.group,resource:v.URI.revive(D.resource),isActive:D.isActive})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=y}),define(ge[58],pe([0,1,10,4]),function(X,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class k{constructor(){this._systemSchemes=new Set(Object.keys(v.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(A,C){C===null?this._providerInfo.delete(A):this._providerInfo.set(A,C)}isFreeScheme(A){return!this._providerInfo.has(A)&&!this._systemSchemes.has(A)}getCapabilities(A){return this._providerInfo.get(A)}}e.ExtHostFileSystemInfo=k,e.IExtHostFileSystemInfo=R.createDecorator("IExtHostFileSystemInfo")}),define(ge[27],pe([0,1,4]),function(X,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=v.createDecorator("IExtHostInitDataService")}),define(ge[189],pe([0,1,14]),function(X,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class R{constructor(A,C,D){this._deferredPromises=new Map,this._id=A,this._shared=C,this._storage=D,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(P=>(this._value=P,this)),this._storageListener=this._storage.onDidChangeStorage(P=>{P.shared===this._shared&&P.key===this._id&&(this._value=P.value)}),this._scheduler=new v.RunOnceScheduler(()=>{const P=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const s of P.values())s.complete()}catch(s){for(const I of P.values())I.error(s)}})()},0)}get keys(){var A;return Object.entries((A=this._value)!==null&&A!==void 0?A:{}).filter(([,C])=>C!==void 0).map(([C])=>C)}get whenReady(){return this._init}get(A,C){let D=this._value[A];return typeof D=="undefined"&&(D=C),D}update(A,C){this._value[A]=C;let D=this._deferredPromises.get(A);if(D!==void 0)return D.p;const P=new v.DeferredPromise;return this._deferredPromises.set(A,P),this._scheduler.isScheduled()||this._scheduler.schedule(),P.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=R;class k extends R{constructor(A,C){super(A.identifier.value,!0,C);this._extension=A}setKeysForSync(A){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},A)}}e.ExtensionGlobalMemento=k}),define(ge[12],pe([0,1,4]),function(X,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=v.createDecorator("IExtHostRpcService");class R{constructor(y){this.getProxy=y.getProxy.bind(y),this.set=y.set.bind(y),this.assertRegistered=y.assertRegistered.bind(y),this.drain=y.drain.bind(y)}}e.ExtHostRpcService=R});var tt=this&&this.__classPrivateFieldSet||function(X,e,v,R,k){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!k:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?k.call(X,v):k?k.value=v:e.set(X,v),v},$e=this&&this.__classPrivateFieldGet||function(X,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!R:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(X):R?R.value:e.get(X)};define(ge[190],pe([0,1,26,3]),function(X,e,v,R){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class y{constructor(C,D){k.set(this,void 0),this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this._id=v.ExtensionIdentifier.toKey(C.identifier),tt(this,k,D,"f"),$e(this,k,"f").onDidChangePassword(P=>{P.extensionId===this._id&&this._onDidChange.fire({key:P.key})})}get(C){return $e(this,k,"f").get(this._id,C)}store(C,D){return $e(this,k,"f").store(this._id,C,D)}delete(C){return $e(this,k,"f").delete(this._id,C)}}e.ExtensionSecrets=y,k=new WeakMap}),define(ge[117],pe([0,1,4,3]),function(X,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class k{constructor(){this._onDidChangeTelemetryEnabled=new R.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(A){this._enabled=A}$onDidChangeTelemetryEnabled(A){this._enabled=A,this._onDidChangeTelemetryEnabled.fire(A)}}e.ExtHostTelemetry=k,e.IExtHostTelemetry=v.createDecorator("IExtHostTelemetry")}),define(ge[84],pe([0,1,3]),function(X,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.ExtHostTestItemEventType=void 0;var R;(function(A){A[A.NewChild=0]="NewChild",A[A.Disposed=1]="Disposed",A[A.Invalidated=2]="Invalidated",A[A.SetProp=3]="SetProp"})(R=e.ExtHostTestItemEventType||(e.ExtHostTestItemEventType={}));const k=new WeakMap,y=A=>{let C=k.get(A);return C||(C={children:new Map,bus:new v.Emitter},k.set(A,C)),C};e.getPrivateApiFor=y}),define(ge[46],pe([0,1,4,3,12]),function(X,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var y;(function(C){function D(s){return{remoteAddress:s.remoteAddress,localAddress:s.localAddress,public:!!s.public}}C.fromApiTunnel=D;function P(s){return{remoteAddress:{host:s.tunnelRemoteHost,port:s.tunnelRemotePort},localAddress:s.localAddress,public:s.public}}C.fromServiceTunnel=P})(y=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=v.createDecorator("IExtHostTunnelService");let A=class{constructor(D){this.onDidChangeTunnels=new R.Emitter().event}async $applyCandidateFilter(D){return D}async openTunnel(D,P){}async getTunnels(){return[]}async setTunnelExtensionFunctions(D){return{dispose:()=>{}}}registerPortsAttributesProvider(D,P){return{dispose:()=>{}}}async $providePortAttributes(D,P,s,I,l){return[]}async $forwardPort(D,P){}async $closeTunnel(D){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};A=Ve([We(0,k.IExtHostRpcService)],A),e.ExtHostTunnelService=A});var tt=this&&this.__classPrivateFieldSet||function(X,e,v,R,k){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!k:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?k.call(X,v):k?k.value=v:e.set(X,v),v},$e=this&&this.__classPrivateFieldGet||function(X,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!R:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(X):R?R.value:e.get(X)};define(ge[7],pe([0,1,17,16,95,23,136,13,2,32,42,115,84]),function(X,e,v,R,k,y,A,C,D,P,s,I,l){"use strict";var g,c,f,_,w,E,u,h,m,t,r,i,n,a,p,d,b,S;Object.defineProperty(e,"__esModule",{value:!0}),e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.TestMessage=e.TestItemImpl=e.TestItemStatus=e.TestMessageSeverity=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function o(z){function $(){return Reflect.construct(z,arguments,this.constructor)}return Object.defineProperty($,"name",Object.getOwnPropertyDescriptor(z,"name")),Object.setPrototypeOf($,z),Object.setPrototypeOf($.prototype,z.prototype),$}let L=w=class{constructor($){g.set(this,void 0),tt(this,g,$,"f")}static from(...$){let se=$;return new w(function(){if(se){for(const Ce of se)Ce&&typeof Ce.dispose=="function"&&Ce.dispose();se=void 0}})}dispose(){typeof $e(this,g,"f")=="function"&&($e(this,g,"f").call(this),tt(this,g,void 0,"f"))}};g=new WeakMap,L=w=Ve([o],L),e.Disposable=L;let O=E=class{constructor($,se){if($<0)throw R.illegalArgument("line must be non-negative");if(se<0)throw R.illegalArgument("character must be non-negative");this._line=$,this._character=se}static Min(...$){if($.length===0)throw new TypeError;let se=$[0];for(let Ce=1;Ce<$.length;Ce++){const Ke=$[Ce];Ke.isBefore(se)&&(se=Ke)}return se}static Max(...$){if($.length===0)throw new TypeError;let se=$[0];for(let Ce=1;Ce<$.length;Ce++){const Ke=$[Ce];Ke.isAfter(se)&&(se=Ke)}return se}static isPosition($){if(!$)return!1;if($ instanceof E)return!0;let{line:se,character:Ce}=$;return typeof se=="number"&&typeof Ce=="number"}get line(){return this._line}get character(){return this._character}isBefore($){return this._line<$._line?!0:$._line<this._line?!1:this._character<$._character}isBeforeOrEqual($){return this._line<$._line?!0:$._line<this._line?!1:this._character<=$._character}isAfter($){return!this.isBeforeOrEqual($)}isAfterOrEqual($){return!this.isBefore($)}isEqual($){return this._line===$._line&&this._character===$._character}compareTo($){return this._line<$._line?-1:this._line>$.line?1:this._character<$._character?-1:this._character>$._character?1:0}translate($,se=0){if($===null||se===null)throw R.illegalArgument();let Ce;return typeof $=="undefined"?Ce=0:typeof $=="number"?Ce=$:(Ce=typeof $.lineDelta=="number"?$.lineDelta:0,se=typeof $.characterDelta=="number"?$.characterDelta:0),Ce===0&&se===0?this:new E(this.line+Ce,this.character+se)}with($,se=this.character){if($===null||se===null)throw R.illegalArgument();let Ce;return typeof $=="undefined"?Ce=this.line:typeof $=="number"?Ce=$:(Ce=typeof $.line=="number"?$.line:this.line,se=typeof $.character=="number"?$.character:this.character),Ce===this.line&&se===this.character?this:new E(Ce,se)}toJSON(){return{line:this.line,character:this.character}}};O=E=Ve([o],O),e.Position=O;let W=u=class{constructor($,se,Ce,Ke){let et,at;if(typeof $=="number"&&typeof se=="number"&&typeof Ce=="number"&&typeof Ke=="number"?(et=new O($,se),at=new O(Ce,Ke)):$ instanceof O&&se instanceof O&&(et=$,at=se),!et||!at)throw new Error("Invalid arguments");et.isBefore(at)?(this._start=et,this._end=at):(this._start=at,this._end=et)}static isRange($){return $ instanceof u?!0:$?O.isPosition($.start)&&O.isPosition($.end):!1}get start(){return this._start}get end(){return this._end}contains($){return $ instanceof u?this.contains($._start)&&this.contains($._end):$ instanceof O?!($.isBefore(this._start)||this._end.isBefore($)):!1}isEqual($){return this._start.isEqual($._start)&&this._end.isEqual($._end)}intersection($){const se=O.Max($.start,this._start),Ce=O.Min($.end,this._end);if(!se.isAfter(Ce))return new u(se,Ce)}union($){if(this.contains($))return this;if($.contains(this))return $;const se=O.Min($.start,this._start),Ce=O.Max($.end,this.end);return new u(se,Ce)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with($,se=this.end){if($===null||se===null)throw R.illegalArgument();let Ce;return $?O.isPosition($)?Ce=$:(Ce=$.start||this.start,se=$.end||this.end):Ce=this.start,Ce.isEqual(this._start)&&se.isEqual(this.end)?this:new u(Ce,se)}toJSON(){return[this.start,this.end]}};W=u=Ve([o],W),e.Range=W;let J=h=class extends W{constructor($,se,Ce,Ke){let et,at;if(typeof $=="number"&&typeof se=="number"&&typeof Ce=="number"&&typeof Ke=="number"?(et=new O($,se),at=new O(Ce,Ke)):$ instanceof O&&se instanceof O&&(et=$,at=se),!et||!at)throw new Error("Invalid arguments");super(et,at);this._anchor=et,this._active=at}static isSelection($){return $ instanceof h?!0:$?W.isRange($)&&O.isPosition($.anchor)&&O.isPosition($.active)&&typeof $.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};J=h=Ve([o],J),e.Selection=J;class oe{constructor($,se,Ce){if(typeof $!="string"||$.length===0)throw R.illegalArgument("host");if(typeof se!="number"||se===0||Math.round(se)!==se)throw R.illegalArgument("port");if(typeof Ce!="undefined"&&(typeof Ce!="string"||Ce.length===0||!/^[0-9A-Za-z\-]+$/.test(Ce)))throw R.illegalArgument("connectionToken");this.host=$,this.port=Math.round(se),this.connectionToken=Ce}}e.ResolvedAuthority=oe;class q extends Error{constructor($,se=I.RemoteAuthorityResolverErrorCode.Unknown,Ce){super($);this._message=$,this._code=se,this._detail=Ce,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,q.prototype)}static NotAvailable($,se){return new q($,I.RemoteAuthorityResolverErrorCode.NotAvailable,se)}static TemporarilyNotAvailable($){return new q($,I.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=q;var x;(function(z){z[z.LF=1]="LF",z[z.CRLF=2]="CRLF"})(x=e.EndOfLine||(e.EndOfLine={}));var V;(function(z){z[z.Replace=1]="Replace",z[z.Append=2]="Append",z[z.Prepend=3]="Prepend"})(V=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let T=m=class{constructor($,se){this._range=$,this._newText=se}static isTextEdit($){return $ instanceof m?!0:$?W.isRange($)&&typeof $.newText=="string":!1}static replace($,se){return new m($,se)}static insert($,se){return m.replace(new W($,$),se)}static delete($){return m.replace($,"")}static setEndOfLine($){const se=new m(new W(new O(0,0),new O(0,0)),"");return se.newEol=$,se}get range(){return this._range}set range($){if($&&!W.isRange($))throw R.illegalArgument("range");this._range=$}get newText(){return this._newText||""}set newText($){if($&&typeof $!="string")throw R.illegalArgument("newText");this._newText=$}get newEol(){return this._newEol}set newEol($){if($&&typeof $!="number")throw R.illegalArgument("newEol");this._newEol=$}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};T=m=Ve([o],T),e.TextEdit=T;var N;(function(z){z[z.File=1]="File",z[z.Text=2]="Text",z[z.Cell=3]="Cell",z[z.CellOutput=4]="CellOutput",z[z.CellReplace=5]="CellReplace",z[z.CellOutputItem=6]="CellOutputItem"})(N=e.FileEditType||(e.FileEditType={}));let F=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile($,se,Ce,Ke){this._edits.push({_type:1,from:$,to:se,options:Ce,metadata:Ke})}createFile($,se,Ce){this._edits.push({_type:1,from:void 0,to:$,options:se,metadata:Ce})}deleteFile($,se,Ce){this._edits.push({_type:1,from:$,to:void 0,options:se,metadata:Ce})}replaceNotebookMetadata($,se,Ce){this._edits.push({_type:3,metadata:Ce,uri:$,edit:{editType:5,metadata:se},notebookMetadata:se})}replaceNotebookCells($,se,Ce,Ke,et){let at,dt,yt=[],Pt;if($t.isNotebookRange(se)&&Tt.isNotebookCellDataArray(Ce)&&!Tt.isNotebookCellDataArray(Ke)?(at=se.start,dt=se.end,yt=Ce,Pt=Ke):typeof se=="number"&&typeof Ce=="number"&&Tt.isNotebookCellDataArray(Ke)&&(at=se,dt=Ce,yt=Ke,Pt=et),at===void 0||dt===void 0)throw new Error("Invalid arguments");(at!==dt||yt.length>0)&&this._edits.push({_type:5,uri:$,index:at,count:dt-at,cells:yt,metadata:Pt})}replaceNotebookCellMetadata($,se,Ce,Ke){this._edits.push({_type:3,metadata:Ke,uri:$,edit:{editType:8,index:se,metadata:Ce}})}replace($,se,Ce,Ke){this._edits.push({_type:2,uri:$,edit:new T(se,Ce),metadata:Ke})}insert($,se,Ce,Ke){this.replace($,new W(se,se),Ce,Ke)}delete($,se,Ce){this.replace($,se,"",Ce)}has($){return this._edits.some(se=>se._type===2&&se.uri.toString()===$.toString())}set($,se){if(se)for(const Ce of se)Ce&&this._edits.push({_type:2,uri:$,edit:Ce});else{for(let Ce=0;Ce<this._edits.length;Ce++){const Ke=this._edits[Ce];Ke._type===2&&Ke.uri.toString()===$.toString()&&(this._edits[Ce]=void 0)}v.coalesceInPlace(this._edits)}}get($){const se=[];for(let Ce of this._edits)Ce._type===2&&Ce.uri.toString()===$.toString()&&se.push(Ce.edit);return se}entries(){const $=new y.ResourceMap;for(let se of this._edits)if(se._type===2){let Ce=$.get(se.uri);Ce||(Ce=[se.uri,[]],$.set(se.uri,Ce)),Ce[1].push(se.edit)}return[...$.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};F=Ve([o],F),e.WorkspaceEdit=F;let M=t=class{constructor($){this._tabstop=1,this.value=$||""}static isSnippetString($){return $ instanceof t?!0:$?typeof $.value=="string":!1}static _escape($){return $.replace(/\$|}|\\/g,"\\$&")}appendText($){return this.value+=t._escape($),this}appendTabstop($=this._tabstop++){return this.value+="$",this.value+=$,this}appendPlaceholder($,se=this._tabstop++){if(typeof $=="function"){const Ce=new t;Ce._tabstop=this._tabstop,$(Ce),this._tabstop=Ce._tabstop,$=Ce.value}else $=t._escape($);return this.value+="${",this.value+=se,this.value+=":",this.value+=$,this.value+="}",this}appendChoice($,se=this._tabstop++){const Ce=$.map(Ke=>Ke.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=se,this.value+="|",this.value+=Ce,this.value+="|}",this}appendVariable($,se){if(typeof se=="function"){const Ce=new t;Ce._tabstop=this._tabstop,se(Ce),this._tabstop=Ce._tabstop,se=Ce.value}else typeof se=="string"&&(se=se.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=$,se&&(this.value+=":",this.value+=se),this.value+="}",this}};M=t=Ve([o],M),e.SnippetString=M;var U;(function(z){z[z.Unnecessary=1]="Unnecessary",z[z.Deprecated=2]="Deprecated"})(U=e.DiagnosticTag||(e.DiagnosticTag={}));var B;(function(z){z[z.Hint=3]="Hint",z[z.Information=2]="Information",z[z.Warning=1]="Warning",z[z.Error=0]="Error"})(B=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let K=r=class{constructor($,se){if(this.uri=$,se)if(se instanceof W)this.range=se;else if(se instanceof O)this.range=new W(se,se);else throw new Error("Illegal argument")}static isLocation($){return $ instanceof r?!0:$?W.isRange($.range)&&D.URI.isUri($.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};K=r=Ve([o],K),e.Location=K;let ie=class{constructor($,se){this.location=$,this.message=se}static is($){return $?typeof $.message=="string"&&$.location&&W.isRange($.location.range)&&D.URI.isUri($.location.uri):!1}static isEqual($,se){return $===se?!0:!$||!se?!1:$.message===se.message&&$.location.range.isEqual(se.location.range)&&$.location.uri.toString()===se.location.uri.toString()}};ie=Ve([o],ie),e.DiagnosticRelatedInformation=ie;let we=class{constructor($,se,Ce=B.Error){if(!W.isRange($))throw new TypeError("range must be set");if(!se)throw new TypeError("message must be set");this.range=$,this.message=se,this.severity=Ce}toJSON(){return{severity:B[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual($,se){return $===se?!0:!$||!se?!1:$.message===se.message&&$.severity===se.severity&&$.code===se.code&&$.severity===se.severity&&$.source===se.source&&$.range.isEqual(se.range)&&v.equals($.tags,se.tags)&&v.equals($.relatedInformation,se.relatedInformation,ie.isEqual)}};we=Ve([o],we),e.Diagnostic=we;let Te=class{constructor($,se){if(!$)throw new Error("Illegal argument, contents must be defined");Array.isArray($)?this.contents=$:k.isMarkdownString($)?this.contents=[$]:this.contents=[$],this.range=se}};Te=Ve([o],Te),e.Hover=Te;var ye;(function(z){z[z.Text=0]="Text",z[z.Read=1]="Read",z[z.Write=2]="Write"})(ye=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Oe=class{constructor($,se=ye.Text){this.range=$,this.kind=se}toJSON(){return{range:this.range,kind:ye[this.kind]}}};Oe=Ve([o],Oe),e.DocumentHighlight=Oe;var je;(function(z){z[z.File=0]="File",z[z.Module=1]="Module",z[z.Namespace=2]="Namespace",z[z.Package=3]="Package",z[z.Class=4]="Class",z[z.Method=5]="Method",z[z.Property=6]="Property",z[z.Field=7]="Field",z[z.Constructor=8]="Constructor",z[z.Enum=9]="Enum",z[z.Interface=10]="Interface",z[z.Function=11]="Function",z[z.Variable=12]="Variable",z[z.Constant=13]="Constant",z[z.String=14]="String",z[z.Number=15]="Number",z[z.Boolean=16]="Boolean",z[z.Array=17]="Array",z[z.Object=18]="Object",z[z.Key=19]="Key",z[z.Null=20]="Null",z[z.EnumMember=21]="EnumMember",z[z.Struct=22]="Struct",z[z.Event=23]="Event",z[z.Operator=24]="Operator",z[z.TypeParameter=25]="TypeParameter"})(je=e.SymbolKind||(e.SymbolKind={}));var ze;(function(z){z[z.Deprecated=1]="Deprecated"})(ze=e.SymbolTag||(e.SymbolTag={}));let qe=i=class{constructor($,se,Ce,Ke,et){this.name=$,this.kind=se,this.containerName=et,typeof Ce=="string"&&(this.containerName=Ce),Ke instanceof K?this.location=Ke:Ce instanceof W&&(this.location=new K(Ke,Ce)),i.validate(this)}static validate($){if(!$.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:je[this.kind],location:this.location,containerName:this.containerName}}};qe=i=Ve([o],qe),e.SymbolInformation=qe;let j=n=class{constructor($,se,Ce,Ke,et){this.name=$,this.detail=se,this.kind=Ce,this.range=Ke,this.selectionRange=et,this.children=[],n.validate(this)}static validate($){if(!$.name)throw new Error("name must not be falsy");if(!$.range.contains($.selectionRange))throw new Error("selectionRange must be contained in fullRange");$.children&&$.children.forEach(n.validate)}};j=n=Ve([o],j),e.DocumentSymbol=j;var Z;(function(z){z[z.Invoke=1]="Invoke",z[z.Automatic=2]="Automatic"})(Z=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let ne=class{constructor($,se){this.title=$,this.kind=se}};ne=Ve([o],ne),e.CodeAction=ne;let ae=a=class{constructor($){this.value=$}append($){return new a(this.value?this.value+a.sep+$:$)}intersects($){return this.contains($)||$.contains(this)}contains($){return this.value===$.value||$.value.startsWith(this.value+a.sep)}};ae.sep=".",ae=a=Ve([o],ae),e.CodeActionKind=ae,ae.Empty=new ae(""),ae.QuickFix=ae.Empty.append("quickfix"),ae.Refactor=ae.Empty.append("refactor"),ae.RefactorExtract=ae.Refactor.append("extract"),ae.RefactorInline=ae.Refactor.append("inline"),ae.RefactorRewrite=ae.Refactor.append("rewrite"),ae.Source=ae.Empty.append("source"),ae.SourceOrganizeImports=ae.Source.append("organizeImports"),ae.SourceFixAll=ae.Source.append("fixAll");let Y=class{constructor($,se){if(this.range=$,this.parent=se,se&&!se.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};Y=Ve([o],Y),e.SelectionRange=Y;class ce{constructor($,se,Ce,Ke,et,at){this.kind=$,this.name=se,this.detail=Ce,this.uri=Ke,this.range=et,this.selectionRange=at}}e.CallHierarchyItem=ce;class me{constructor($,se){this.fromRanges=se,this.from=$}}e.CallHierarchyIncomingCall=me;class Re{constructor($,se){this.fromRanges=se,this.to=$}}e.CallHierarchyOutgoingCall=Re;let He=class{constructor($,se){this.range=$,this.command=se}get isResolved(){return!!this.command}};He=Ve([o],He),e.CodeLens=He;let be=p=class{constructor($,se=!1){c.set(this,void 0),tt(this,c,new k.MarkdownString($,{supportThemeIcons:se}),"f")}static isMarkdownString($){return $ instanceof p?!0:$&&$.appendCodeblock&&$.appendMarkdown&&$.appendText&&$.value!==void 0}get value(){return $e(this,c,"f").value}set value($){$e(this,c,"f").value=$}get isTrusted(){return $e(this,c,"f").isTrusted}set isTrusted($){$e(this,c,"f").isTrusted=$}get supportThemeIcons(){return $e(this,c,"f").supportThemeIcons}appendText($){return $e(this,c,"f").appendText($),this}appendMarkdown($){return $e(this,c,"f").appendMarkdown($),this}appendCodeblock($,se){return $e(this,c,"f").appendCodeblock(se??"",$),this}};c=new WeakMap,be=p=Ve([o],be),e.MarkdownString=be;let Xe=class{constructor($,se){this.label=$,this.documentation=se}};Xe=Ve([o],Xe),e.ParameterInformation=Xe;let Q=class{constructor($,se){this.label=$,this.documentation=se,this.parameters=[]}};Q=Ve([o],Q),e.SignatureInformation=Q;let re=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};re=Ve([o],re),e.SignatureHelp=re;var ve;(function(z){z[z.Invoke=1]="Invoke",z[z.TriggerCharacter=2]="TriggerCharacter",z[z.ContentChange=3]="ContentChange"})(ve=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Me;(function(z){z[z.Other=0]="Other",z[z.Type=1]="Type",z[z.Parameter=2]="Parameter"})(Me=e.InlayHintKind||(e.InlayHintKind={}));let Ne=class{constructor($,se,Ce){this.text=$,this.position=se,this.kind=Ce}};Ne=Ve([o],Ne),e.InlayHint=Ne;var Ye;(function(z){z[z.Invoke=0]="Invoke",z[z.TriggerCharacter=1]="TriggerCharacter",z[z.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ye=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Se;(function(z){z[z.Text=0]="Text",z[z.Method=1]="Method",z[z.Function=2]="Function",z[z.Constructor=3]="Constructor",z[z.Field=4]="Field",z[z.Variable=5]="Variable",z[z.Class=6]="Class",z[z.Interface=7]="Interface",z[z.Module=8]="Module",z[z.Property=9]="Property",z[z.Unit=10]="Unit",z[z.Value=11]="Value",z[z.Enum=12]="Enum",z[z.Keyword=13]="Keyword",z[z.Snippet=14]="Snippet",z[z.Color=15]="Color",z[z.File=16]="File",z[z.Reference=17]="Reference",z[z.Folder=18]="Folder",z[z.EnumMember=19]="EnumMember",z[z.Constant=20]="Constant",z[z.Struct=21]="Struct",z[z.Event=22]="Event",z[z.Operator=23]="Operator",z[z.TypeParameter=24]="TypeParameter",z[z.User=25]="User",z[z.Issue=26]="Issue"})(Se=e.CompletionItemKind||(e.CompletionItemKind={}));var _e;(function(z){z[z.Deprecated=1]="Deprecated"})(_e=e.CompletionItemTag||(e.CompletionItemTag={}));let ke=class{constructor($,se){this.label=$,this.kind=se}toJSON(){return{label:this.label,label2:this.label2,kind:this.kind&&Se[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};ke=Ve([o],ke),e.CompletionItem=ke;let le=class{constructor($=[],se=!1){this.items=$,this.isIncomplete=se}};le=Ve([o],le),e.CompletionList=le;let fe=class{constructor($,se,Ce){this.text=$,this.range=se,this.command=Ce}};fe=Ve([o],fe),e.InlineSuggestion=fe;let H=class{constructor($){this.items=$}};H=Ve([o],H),e.InlineSuggestions=H;var ee;(function(z){z[z.Active=-1]="Active",z[z.Beside=-2]="Beside",z[z.One=1]="One",z[z.Two=2]="Two",z[z.Three=3]="Three",z[z.Four=4]="Four",z[z.Five=5]="Five",z[z.Six=6]="Six",z[z.Seven=7]="Seven",z[z.Eight=8]="Eight",z[z.Nine=9]="Nine"})(ee=e.ViewColumn||(e.ViewColumn={}));var ue;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(ue=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Pe;(function(z){z[z.Off=0]="Off",z[z.On=1]="On",z[z.Relative=2]="Relative"})(Pe=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Ae;(function(z){z[z.Manual=1]="Manual",z[z.AfterDelay=2]="AfterDelay",z[z.FocusOut=3]="FocusOut"})(Ae=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var xe;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(xe=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Be;(function(z){z[z.Keyboard=1]="Keyboard",z[z.Mouse=2]="Mouse",z[z.Command=3]="Command"})(Be=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Qe;(function(z){z[z.OpenOpen=0]="OpenOpen",z[z.ClosedClosed=1]="ClosedClosed",z[z.OpenClosed=2]="OpenClosed",z[z.ClosedOpen=3]="ClosedOpen"})(Qe=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(z){function $(se){switch(se){case"keyboard":return z.Keyboard;case"mouse":return z.Mouse;case"api":return z.Command}}z.fromValue=$}(Be=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let rt=class{constructor($,se){if(se&&!D.URI.isUri(se))throw R.illegalArgument("target");if(!W.isRange($)||$.isEmpty)throw R.illegalArgument("range");this.range=$,this.target=se}};rt=Ve([o],rt),e.DocumentLink=rt;let nt=class{constructor($,se,Ce,Ke){this.red=$,this.green=se,this.blue=Ce,this.alpha=Ke}};nt=Ve([o],nt),e.Color=nt;let Ze=class{constructor($,se){if(se&&!(se instanceof nt))throw R.illegalArgument("color");if(!W.isRange($)||$.isEmpty)throw R.illegalArgument("range");this.range=$,this.color=se}};Ze=Ve([o],Ze),e.ColorInformation=Ze;let ot=class{constructor($){if(!$||typeof $!="string")throw R.illegalArgument("label");this.label=$}};ot=Ve([o],ot),e.ColorPresentation=ot;var Ee;(function(z){z[z.RGB=0]="RGB",z[z.HEX=1]="HEX",z[z.HSL=2]="HSL"})(Ee=e.ColorFormat||(e.ColorFormat={}));var De;(function(z){z[z.Error=0]="Error",z[z.Warning=1]="Warning",z[z.Information=2]="Information"})(De=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var de;(function(z){z[z.Always=1]="Always",z[z.Silent=2]="Silent",z[z.Never=3]="Never"})(de=e.TaskRevealKind||(e.TaskRevealKind={}));var G;(function(z){z[z.Shared=1]="Shared",z[z.Dedicated=2]="Dedicated",z[z.New=3]="New"})(G=e.TaskPanelKind||(e.TaskPanelKind={}));let Ue=d=class{constructor($,se){if(typeof $!="string"||typeof se!="string")throw R.illegalArgument("name");this._id=$}static from($){switch($){case"clean":return d.Clean;case"build":return d.Build;case"rebuild":return d.Rebuild;case"test":return d.Test;default:return}}get id(){return this._id}};Ue.Clean=new d("clean","Clean"),Ue.Build=new d("build","Build"),Ue.Rebuild=new d("rebuild","Rebuild"),Ue.Test=new d("test","Test"),Ue=d=Ve([o],Ue),e.TaskGroup=Ue;function Le(z){let $="";for(let se=0;se<z.length;se++)$+=z[se].replace(/,/g,",,")+",";return $}let Ge=class{constructor($,se,Ce){if(typeof $!="string")throw R.illegalArgument("process");this._args=[],this._process=$,se!==void 0&&(Array.isArray(se)?(this._args=se,this._options=Ce):this._options=se)}get process(){return this._process}set process($){if(typeof $!="string")throw R.illegalArgument("process");this._process=$}get args(){return this._args}set args($){Array.isArray($)||($=[]),this._args=$}get options(){return this._options}set options($){this._options=$}computeId(){const $=[];if($.push("process"),this._process!==void 0&&$.push(this._process),this._args&&this._args.length>0)for(let se of this._args)$.push(se);return Le($)}};Ge=Ve([o],Ge),e.ProcessExecution=Ge;let Je=class{constructor($,se,Ce){if(this._args=[],Array.isArray(se)){if(!$)throw R.illegalArgument("command can't be undefined or null");if(typeof $!="string"&&typeof $.value!="string")throw R.illegalArgument("command");this._command=$,this._args=se,this._options=Ce}else{if(typeof $!="string")throw R.illegalArgument("commandLine");this._commandLine=$,this._options=se}}get commandLine(){return this._commandLine}set commandLine($){if(typeof $!="string")throw R.illegalArgument("commandLine");this._commandLine=$}get command(){return this._command?this._command:""}set command($){if(typeof $!="string"&&typeof $.value!="string")throw R.illegalArgument("command");this._command=$}get args(){return this._args}set args($){this._args=$||[]}get options(){return this._options}set options($){this._options=$}computeId(){const $=[];if($.push("shell"),this._commandLine!==void 0&&$.push(this._commandLine),this._command!==void 0&&$.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let se of this._args)$.push(typeof se=="string"?se:se.value);return Le($)}};Je=Ve([o],Je),e.ShellExecution=Je;var lt;(function(z){z[z.Escape=1]="Escape",z[z.Strong=2]="Strong",z[z.Weak=3]="Weak"})(lt=e.ShellQuoting||(e.ShellQuoting={}));var ct;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace"})(ct=e.TaskScope||(e.TaskScope={}));class it{constructor($){this._callback=$}computeId(){return"customExecution"+P.generateUuid()}set callback($){this._callback=$}get callback(){return this._callback}}e.CustomExecution=it;let mt=b=class{constructor($,se,Ce,Ke,et,at){this.__deprecated=!1,this._definition=this.definition=$;let dt;typeof se=="string"?(this._name=this.name=se,this._source=this.source=Ce,this.execution=Ke,dt=et,this.__deprecated=!0):se===ct.Global||se===ct.Workspace?(this.target=se,this._name=this.name=Ce,this._source=this.source=Ke,this.execution=et,dt=at):(this.target=se,this._name=this.name=Ce,this._source=this.source=Ke,this.execution=et,dt=at),typeof dt=="string"?(this._problemMatchers=[dt],this._hasDefinedMatchers=!0):Array.isArray(dt)?(this._problemMatchers=dt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id($){this.__id=$}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Ge?this._definition={type:b.ProcessType,id:this._execution.computeId()}:this._execution instanceof Je?this._definition={type:b.ShellType,id:this._execution.computeId()}:this._execution instanceof it?this._definition={type:b.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:b.EmptyType,id:P.generateUuid()}}get definition(){return this._definition}set definition($){if($==null)throw R.illegalArgument("Kind can't be undefined or null");this.clear(),this._definition=$}get scope(){return this._scope}set target($){this.clear(),this._scope=$}get name(){return this._name}set name($){if(typeof $!="string")throw R.illegalArgument("name");this.clear(),this._name=$}get execution(){return this._execution}set execution($){$===null&&($=void 0),this.clear(),this._execution=$;const se=this._definition.type;(b.EmptyType===se||b.ProcessType===se||b.ShellType===se||b.ExtensionCallbackType===se)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers($){if(Array.isArray($))this.clear(),this._problemMatchers=$,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground($){$!==!0&&$!==!1&&($=!1),this.clear(),this._isBackground=$}get source(){return this._source}set source($){if(typeof $!="string"||$.length===0)throw R.illegalArgument("source must be a string of length > 0");this.clear(),this._source=$}get group(){return this._group}set group($){$===null&&($=void 0),this.clear(),this._group=$}get detail(){return this._detail}set detail($){$===null&&($=void 0),this._detail=$}get presentationOptions(){return this._presentationOptions}set presentationOptions($){$==null&&($=Object.create(null)),this.clear(),this._presentationOptions=$}get runOptions(){return this._runOptions}set runOptions($){$==null&&($=Object.create(null)),this.clear(),this._runOptions=$}};mt.ExtensionCallbackType="customExecution",mt.ProcessType="process",mt.ShellType="shell",mt.EmptyType="$empty",mt=b=Ve([o],mt),e.Task=mt;var St;(function(z){z[z.SourceControl=1]="SourceControl",z[z.Window=10]="Window",z[z.Notification=15]="Notification"})(St=e.ProgressLocation||(e.ProgressLocation={}));let vt=class{constructor($,se=bt.None){this.collapsibleState=se,D.URI.isUri($)?this.resourceUri=$:this.label=$}};vt=Ve([o],vt),e.TreeItem=vt;var bt;(function(z){z[z.None=0]="None",z[z.Collapsed=1]="Collapsed",z[z.Expanded=2]="Expanded"})(bt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let gt=class{constructor($,se){this.id=$,this.color=se}};gt=Ve([o],gt),e.ThemeIcon=gt,gt.File=new gt("file"),gt.Folder=new gt("folder");let ht=class{constructor($){this.id=$}};ht=Ve([o],ht),e.ThemeColor=ht;var kt;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace",z[z.WorkspaceFolder=3]="WorkspaceFolder"})(kt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let _t=class{constructor($,se){if(typeof $!="string"&&(!$||!D.URI.isUri($)&&!D.URI.isUri($.uri)))throw R.illegalArgument("base");if(typeof se!="string")throw R.illegalArgument("pattern");typeof $=="string"?(this.baseFolder=D.URI.file($),this.base=$):D.URI.isUri($)?(this.baseFolder=$,this.base=$.fsPath):(this.baseFolder=$.uri,this.base=$.uri.fsPath),this.pattern=se}};_t=Ve([o],_t),e.RelativePattern=_t;let It=class{constructor($,se,Ce,Ke){this.enabled=typeof $=="boolean"?$:!0,typeof se=="string"&&(this.condition=se),typeof Ce=="string"&&(this.hitCondition=Ce),typeof Ke=="string"&&(this.logMessage=Ke)}get id(){return this._id||(this._id=P.generateUuid()),this._id}};It=Ve([o],It),e.Breakpoint=It;let Lt=class extends It{constructor($,se,Ce,Ke,et){super(se,Ce,Ke,et);if($===null)throw R.illegalArgument("location");this.location=$}};Lt=Ve([o],Lt),e.SourceBreakpoint=Lt;let Et=class extends It{constructor($,se,Ce,Ke,et){super(se,Ce,Ke,et);this.functionName=$}};Et=Ve([o],Et),e.FunctionBreakpoint=Et;let Kt=class extends It{constructor($,se,Ce,Ke,et,at,dt){super(Ke,et,at,dt);if(!se)throw R.illegalArgument("dataId");this.label=$,this.dataId=se,this.canPersist=Ce}};Kt=Ve([o],Kt),e.DataBreakpoint=Kt;let Qt=class{constructor($,se,Ce){this.command=$,this.args=se||[],this.options=Ce}};Qt=Ve([o],Qt),e.DebugAdapterExecutable=Qt;let ft=class{constructor($,se){this.port=$,this.host=se}};ft=Ve([o],ft),e.DebugAdapterServer=ft;let Xt=class{constructor($){this.path=$}};Xt=Ve([o],Xt),e.DebugAdapterNamedPipeServer=Xt;let Yt=class{constructor($){this.implementation=$}};Yt=Ve([o],Yt),e.DebugAdapterInlineImplementation=Yt;let Dt=class{constructor($,se){this.range=$,this.expression=se}};Dt=Ve([o],Dt),e.EvaluatableExpression=Dt;var un;(function(z){z[z.Automatic=0]="Automatic",z[z.Explicit=1]="Explicit"})(un=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Jt=class{constructor($,se){this.range=$,this.text=se}};Jt=Ve([o],Jt),e.InlineValueText=Jt;let xt=class{constructor($,se,Ce=!0){this.range=$,this.variableName=se,this.caseSensitiveLookup=Ce}};xt=Ve([o],xt),e.InlineValueVariableLookup=xt;let ut=class{constructor($,se){this.range=$,this.expression=se}};ut=Ve([o],ut),e.InlineValueEvaluatableExpression=ut;let Zt=class{constructor($,se){this.frameId=$,this.stoppedLocation=se}};Zt=Ve([o],Zt),e.InlineValueContext=Zt;var Ft;(function(z){z[z.Changed=1]="Changed",z[z.Created=2]="Created",z[z.Deleted=3]="Deleted"})(Ft=e.FileChangeType||(e.FileChangeType={}));let Mt=S=class extends Error{constructor($,se=s.FileSystemProviderErrorCode.Unknown,Ce){var Ke;super(D.URI.isUri($)?$.toString(!0):$);this.code=(Ke=Ce==null?void 0:Ce.name)!==null&&Ke!==void 0?Ke:"Unknown",s.markAsFileSystemProviderError(this,se),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,S.prototype),typeof Error.captureStackTrace=="function"&&typeof Ce=="function"&&Error.captureStackTrace(this,Ce)}static FileExists($){return new S($,s.FileSystemProviderErrorCode.FileExists,S.FileExists)}static FileNotFound($){return new S($,s.FileSystemProviderErrorCode.FileNotFound,S.FileNotFound)}static FileNotADirectory($){return new S($,s.FileSystemProviderErrorCode.FileNotADirectory,S.FileNotADirectory)}static FileIsADirectory($){return new S($,s.FileSystemProviderErrorCode.FileIsADirectory,S.FileIsADirectory)}static NoPermissions($){return new S($,s.FileSystemProviderErrorCode.NoPermissions,S.NoPermissions)}static Unavailable($){return new S($,s.FileSystemProviderErrorCode.Unavailable,S.Unavailable)}};Mt=S=Ve([o],Mt),e.FileSystemError=Mt;let qt=class{constructor($,se,Ce){this.start=$,this.end=se,this.kind=Ce}};qt=Ve([o],qt),e.FoldingRange=qt;var _n;(function(z){z[z.Comment=1]="Comment",z[z.Imports=2]="Imports",z[z.Region=3]="Region"})(_n=e.FoldingRangeKind||(e.FoldingRangeKind={}));var dn;(function(z){z[z.Collapsed=0]="Collapsed",z[z.Expanded=1]="Expanded"})(dn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Sn;(function(z){z[z.Editing=0]="Editing",z[z.Preview=1]="Preview"})(Sn=e.CommentMode||(e.CommentMode={}));class hn{constructor($,se=[]){this.tokenTypes=$,this.tokenModifiers=se}}e.SemanticTokensLegend=hn;function Bt(z){return typeof z=="undefined"||C.isStringArray(z)}class en{constructor($){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,$){this._hasLegend=!0;for(let se=0,Ce=$.tokenTypes.length;se<Ce;se++)this._tokenTypeStrToInt.set($.tokenTypes[se],se);for(let se=0,Ce=$.tokenModifiers.length;se<Ce;se++)this._tokenModifierStrToInt.set($.tokenModifiers[se],se)}}push($,se,Ce,Ke,et){if(typeof $=="number"&&typeof se=="number"&&typeof Ce=="number"&&typeof Ke=="number"&&(typeof et=="number"||typeof et=="undefined"))return typeof et=="undefined"&&(et=0),this._pushEncoded($,se,Ce,Ke,et);if(W.isRange($)&&typeof se=="string"&&Bt(Ce))return this._push($,se,Ce);throw R.illegalArgument()}_push($,se,Ce){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if($.start.line!==$.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(se))throw new Error("`tokenType` is not in the provided legend");const Ke=$.start.line,et=$.start.character,at=$.end.character-$.start.character,dt=this._tokenTypeStrToInt.get(se);let yt=0;if(Ce)for(const Pt of Ce){if(!this._tokenModifierStrToInt.has(Pt))throw new Error("`tokenModifier` is not in the provided legend");const At=this._tokenModifierStrToInt.get(Pt);yt|=1<<At>>>0}this._pushEncoded(Ke,et,at,dt,yt)}_pushEncoded($,se,Ce,Ke,et){if(this._dataIsSortedAndDeltaEncoded&&($<this._prevLine||$===this._prevLine&&se<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const yt=this._data.length/5|0;let Pt=0,At=0;for(let Rt=0;Rt<yt;Rt++){let Nt=this._data[5*Rt],ln=this._data[5*Rt+1];Nt===0?(Nt=Pt,ln+=At):Nt+=Pt,this._data[5*Rt]=Nt,this._data[5*Rt+1]=ln,Pt=Nt,At=ln}}let at=$,dt=se;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(at-=this._prevLine,at===0&&(dt-=this._prevChar)),this._data[this._dataLen++]=at,this._data[this._dataLen++]=dt,this._data[this._dataLen++]=Ce,this._data[this._dataLen++]=Ke,this._data[this._dataLen++]=et,this._prevLine=$,this._prevChar=se}static _sortAndDeltaEncode($){let se=[];const Ce=$.length/5|0;for(let dt=0;dt<Ce;dt++)se[dt]=dt;se.sort((dt,yt)=>{const Pt=$[5*dt],At=$[5*yt];if(Pt===At){const Rt=$[5*dt+1],Nt=$[5*yt+1];return Rt-Nt}return Pt-At});const Ke=new Uint32Array($.length);let et=0,at=0;for(let dt=0;dt<Ce;dt++){const yt=5*se[dt],Pt=$[yt+0],At=$[yt+1],Rt=$[yt+2],Nt=$[yt+3],ln=$[yt+4],Mn=Pt-et,Wn=Mn===0?At-at:At,cn=5*dt;Ke[cn+0]=Mn,Ke[cn+1]=Wn,Ke[cn+2]=Rt,Ke[cn+3]=Nt,Ke[cn+4]=ln,et=Pt,at=At}return Ke}build($){return this._dataIsSortedAndDeltaEncoded?new Ht(new Uint32Array(this._data),$):new Ht(en._sortAndDeltaEncode(this._data),$)}}e.SemanticTokensBuilder=en;class Ht{constructor($,se){this.resultId=se,this.data=$}}e.SemanticTokens=Ht;class tn{constructor($,se,Ce){this.start=$,this.deleteCount=se,this.data=Ce}}e.SemanticTokensEdit=tn;class yn{constructor($,se){this.resultId=se,this.edits=$}}e.SemanticTokensEdits=yn;var Dn;(function(z){z[z.Separate=0]="Separate",z[z.MergeWithParent=1]="MergeWithParent"})(Dn=e.DebugConsoleMode||(e.DebugConsoleMode={}));var Ot;(function(z){z[z.Initial=1]="Initial",z[z.Dynamic=2]="Dynamic"})(Ot=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Gt=class{constructor(){}};Gt.Back={iconPath:new gt("arrow-left")},Gt=Ve([o],Gt),e.QuickInputButtons=Gt;var Cn;(function(z){z[z.UI=1]="UI",z[z.Workspace=2]="Workspace"})(Cn=e.ExtensionKind||(e.ExtensionKind={}));class kn{constructor($,se,Ce){this.badge=$,this.tooltip=se,this.color=Ce}static validate($){if($.badge&&$.badge.length!==1&&$.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!$.color&&!$.badge&&!$.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=kn;let nn=class{constructor($){this.kind=$}};nn=Ve([o],nn),e.ColorTheme=nn;var rn;(function(z){z[z.Light=1]="Light",z[z.Dark=2]="Dark",z[z.HighContrast=3]="HighContrast"})(rn=e.ColorThemeKind||(e.ColorThemeKind={}));class $t{constructor($,se){if($<0)throw R.illegalArgument("start must be positive");if(se<0)throw R.illegalArgument("end must be positive");$<=se?(this._start=$,this._end=se):(this._start=se,this._end=$)}static isNotebookRange($){return $ instanceof $t?!0:$?typeof $.start=="number"&&typeof $.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with($){let se=this._start,Ce=this._end;return $.start!==void 0&&(se=$.start),$.end!==void 0&&(Ce=$.end),se===this._start&&Ce===this._end?this:new $t(se,Ce)}}e.NotebookRange=$t;class Tt{constructor($,se,Ce,Ke,et,at){this.kind=$,this.value=se,this.languageId=Ce,this.outputs=Ke??[],this.metadata=et,this.executionSummary=at,Tt.validate(this)}static validate($){if(typeof $.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof $.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof $.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray($){return Array.isArray($)&&$.every(se=>Tt.isNotebookCellData(se))}static isNotebookCellData($){return!0}}e.NotebookCellData=Tt;class sn{constructor($){this.cells=$}}e.NotebookData=sn;class Fe{constructor($,se){this.data=$,this.mime=se;const Ce=A.normalizeMimeType(se,!0);if(!Ce)throw new Error("INVALID mime type, must not be empty or falsy: "+se);this.mime=Ce}static isNotebookCellOutputItem($){return $ instanceof Fe?!0:$?typeof $.mime=="string"&&$.data instanceof Uint8Array:!1}static error($){const se={name:$.name,message:$.message,stack:$.stack};return Fe.json(se,"application/vnd.code.notebook.error")}static stdout($){return Fe.text($,"application/vnd.code.notebook.stdout")}static stderr($){return Fe.text($,"application/vnd.code.notebook.stderr")}static bytes($,se="application/octet-stream"){return new Fe($,se)}static text($,se="text/plain"){const Ce=$e(Fe,f,"f",_).encode(String($));return new Fe(Ce,se)}static json($,se="application/json"){const Ce=JSON.stringify($,void 0,"	");return Fe.text(Ce,se)}}e.NotebookCellOutputItem=Fe,f=Fe,_={value:new TextEncoder};class Wt{constructor($,se,Ce){this.items=Wt.ensureUniqueMimeTypes($,!0),typeof se=="string"?(this.id=se,this.metadata=Ce):(this.id=P.generateUuid(),this.metadata=se??Ce)}static isNotebookCellOutput($){return $ instanceof Wt?!0:!$||typeof $!="object"?!1:typeof $.id=="string"&&C.isArray($.items)}static ensureUniqueMimeTypes($,se=!1){const Ce=new Set,Ke=new Set;for(let et=0;et<$.length;et++){const at=$[et],dt=A.normalizeMimeType(at.mime);if(!Ce.has(dt)){Ce.add(dt);continue}Ke.add(et),se&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return Ke.size===0?$:$.filter((et,at)=>!Ke.has(at))}}e.NotebookCellOutput=Wt;var fn;(function(z){z[z.Markup=1]="Markup",z[z.Code=2]="Code"})(fn=e.NotebookCellKind||(e.NotebookCellKind={}));var pt;(function(z){z[z.Idle=1]="Idle",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})(pt=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Pn;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(Pn=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var In;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(In=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class mn{constructor($,se){this.text=$,this.alignment=se}}e.NotebookCellStatusBarItem=mn;var gn;(function(z){z[z.Default=1]="Default",z[z.Preferred=2]="Preferred"})(gn=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class on{constructor($,se=[]){this.uri=$,this.provides=v.asArray(se)}}e.NotebookRendererScript=on;let an=class{constructor($,se){this.label=$,this.timestamp=se}};an=Ve([o],an),e.TimelineItem=an;var An;(function(z){z[z.Production=1]="Production",z[z.Development=2]="Development",z[z.Test=3]="Test"})(An=e.ExtensionMode||(e.ExtensionMode={}));var Tn;(function(z){z[z.Node=1]="Node",z[z.Webworker=2]="Webworker"})(Tn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var pn;(function(z){z[z.Other=0]="Other",z[z.Comment=1]="Comment",z[z.String=2]="String",z[z.RegEx=4]="RegEx"})(pn=e.StandardTokenType||(e.StandardTokenType={}));class Rn{constructor($,se){this.ranges=$,this.wordPattern=se}}e.LinkedEditingRanges=Rn;class Ln{constructor($,se){this._port=$,this._autoForwardAction=se}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Ln;var Fn;(function(z){z[z.Unset=0]="Unset",z[z.Queued=1]="Queued",z[z.Running=2]="Running",z[z.Passed=3]="Passed",z[z.Failed=4]="Failed",z[z.Skipped=5]="Skipped",z[z.Errored=6]="Errored"})(Fn=e.TestResultState||(e.TestResultState={}));var vn;(function(z){z[z.Error=0]="Error",z[z.Warning=1]="Warning",z[z.Information=2]="Information",z[z.Hint=3]="Hint"})(vn=e.TestMessageSeverity||(e.TestMessageSeverity={}));var wn;(function(z){z[z.Pending=0]="Pending",z[z.Resolved=1]="Resolved"})(wn=e.TestItemStatus||(e.TestItemStatus={}));const te=(z,$,se,Ce)=>{let Ke=se;return{enumerable:!0,configurable:!1,get(){return Ke},set(et){Ce(Ke,et)||(Ke=et,z.bus.fire([3,$,et]))}}},he=(z,$)=>z===$,Ie=(z,$)=>z===$?!0:!z||!$?!1:z.isEqual($);class st{constructor($,se,Ce,Ke){this.label=se,this.data=Ke;const et=l.getPrivateApiFor(this);Object.defineProperties(this,{id:{value:$,enumerable:!0,writable:!1},uri:{value:Ce,enumerable:!0,writable:!1},parent:{enumerable:!1,get:()=>et.parent},children:{value:new y.ReadonlyMapView(et.children),enumerable:!0,writable:!1},range:te(et,"range",void 0,Ie),description:te(et,"description",void 0,he),runnable:te(et,"runnable",!0,he),debuggable:te(et,"debuggable",!1,he),status:te(et,"status",wn.Resolved,he),error:te(et,"error",void 0,he)})}invalidate(){l.getPrivateApiFor(this).bus.fire([2])}dispose(){const $=l.getPrivateApiFor(this);$.parent&&l.getPrivateApiFor($.parent).children.delete(this.id),$.bus.fire([1])}addChild($){if(!($ instanceof st))throw new Error("Test child must be created through vscode.test.createTestItem()");const se=l.getPrivateApiFor(this);if(se.children.has($.id))throw new Error(`Attempted to insert a duplicate test item ID ${$.id}`);se.children.set($.id,$),se.bus.fire([0,$])}}e.TestItemImpl=st;class wt{constructor($){this.message=$,this.severity=vn.Error}static diff($,se,Ce){const Ke=new wt($);return Ke.expectedOutput=se,Ke.actualOutput=Ce,Ke}}e.TestMessage=wt;var Ct;(function(z){z[z.None=0]="None",z[z.Option=1]="Option",z[z.Default=2]="Default",z[z.Preferred=3]="Preferred"})(Ct=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Bn;(function(z){z[z.Untrusted=0]="Untrusted",z[z.Trusted=1]="Trusted",z[z.Unspecified=2]="Unspecified"})(Bn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var $n;(function(z){z[z.Notify=1]="Notify",z[z.OpenBrowser=2]="OpenBrowser",z[z.OpenPreview=3]="OpenPreview",z[z.Silent=4]="Silent",z[z.Ignore=5]="Ignore"})($n=e.PortAutoForwardAction||(e.PortAutoForwardAction={}))}),define(ge[118],pe([0,1,49,10,8,144,106,7,17]),function(X,e,v,R,k,y,A,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const P=new Map;function s(c,f){f?P.set(c,f):P.delete(c)}e.setWordDefinitionFor=s;function I(c){return P.get(c)}e.getWordDefinitionFor=I;class l extends y.MirrorTextModel{constructor(f,_,w,E,u,h,m,t){super(_,w,E,u);this._proxy=f,this._languageId=h,this._isDirty=m,this._notebook=t,this._isDisposed=!1}dispose(){v.ok(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(f){return D.equals(this._lines,f)}get document(){if(!this._document){const f=this;this._document={get uri(){return f._uri},get fileName(){return f._uri.fsPath},get isUntitled(){return f._uri.scheme===R.Schemas.untitled},get languageId(){return f._languageId},get version(){return f._versionId},get isClosed(){return f._isDisposed},get isDirty(){return f._isDirty},get notebook(){return f._notebook},save(){return f._save()},getText(_){return _?f._getTextInRange(_):f.getText()},get eol(){return f._eol===`
`?C.EndOfLine.LF:C.EndOfLine.CRLF},get lineCount(){return f._lines.length},lineAt(_){return f._lineAt(_)},offsetAt(_){return f._offsetAt(_)},positionAt(_){return f._positionAt(_)},validateRange(_){return f._validateRange(_)},validatePosition(_){return f._validatePosition(_)},getWordRangeAtPosition(_,w){return f._getWordRangeAtPosition(_,w)}}}return Object.freeze(this._document)}_acceptLanguageId(f){v.ok(!this._isDisposed),this._languageId=f}_acceptIsDirty(f){v.ok(!this._isDisposed),this._isDirty=f}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(f){const _=this._validateRange(f);if(_.isEmpty)return"";if(_.isSingleLine)return this._lines[_.start.line].substring(_.start.character,_.end.character);const w=this._eol,E=_.start.line,u=_.end.line,h=[];h.push(this._lines[E].substring(_.start.character));for(let m=E+1;m<u;m++)h.push(this._lines[m]);return h.push(this._lines[u].substring(0,_.end.character)),h.join(w)}_lineAt(f){let _;if(f instanceof C.Position?_=f.line:typeof f=="number"&&(_=f),typeof _!="number"||_<0||_>=this._lines.length||Math.floor(_)!==_)throw new Error("Illegal value for `line`");return new g(_,this._lines[_],_===this._lines.length-1)}_offsetAt(f){return f=this._validatePosition(f),this._ensureLineStarts(),this._lineStarts.getAccumulatedValue(f.line-1)+f.character}_positionAt(f){f=Math.floor(f),f=Math.max(0,f),this._ensureLineStarts();const _=this._lineStarts.getIndexOf(f),w=this._lines[_.index].length;return new C.Position(_.index,Math.min(_.remainder,w))}_validateRange(f){if(!(f instanceof C.Range))throw new Error("Invalid argument");const _=this._validatePosition(f.start),w=this._validatePosition(f.end);return _===f.start&&w===f.end?f:new C.Range(_.line,_.character,w.line,w.character)}_validatePosition(f){if(!(f instanceof C.Position))throw new Error("Invalid argument");if(this._lines.length===0)return f.with(0,0);let{line:_,character:w}=f,E=!1;if(_<0)_=0,w=0,E=!0;else if(_>=this._lines.length)_=this._lines.length-1,w=this._lines[_].length,E=!0;else{const u=this._lines[_].length;w<0?(w=0,E=!0):w>u&&(w=u,E=!0)}return E?new C.Position(_,w):f}_getWordRangeAtPosition(f,_){const w=this._validatePosition(f);if(!_)_=I(this._languageId);else if(k.regExpLeadsToEndlessLoop(_))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${_.source}' because it matches the empty string.`);const E=A.getWordAtText(w.character+1,A.ensureValidWordDefinition(_),this._lines[w.line],0);if(E)return new C.Range(w.line,E.startColumn-1,w.line,E.endColumn-1)}}e.ExtHostDocumentData=l;class g{constructor(f,_,w){this._line=f,this._text=_,this._isLastLine=w}get lineNumber(){return this._line}get text(){return this._text}get range(){return new C.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new C.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=g}),define(ge[191],pe([0,1,7,3,108,6,77,23,2,32]),function(X,e,v,R,k,y,A,C,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class s{constructor(l,g,c,f){this._notebook=c,this._selector=f,this._disposables=new y.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this.uri=D.URI.from({scheme:"vscode-concat-doc",path:P.generateUuid()}),this._init(),this._disposables.add(g.onDidChangeDocument(w=>{const E=this._cellUris.get(w.document.uri);E!==void 0&&(this._cellLengths.changeValue(E,this._cells[E].document.getText().length+1),this._cellLines.changeValue(E,this._cells[E].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const _=w=>{w===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(l.onDidChangeNotebookCells(w=>_(w.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new C.ResourceMap;const l=[],g=[];for(const c of this._notebook.getCells())c.kind===v.NotebookCellKind.Code&&(!this._selector||A.score(this._selector,c.document.uri,c.document.languageId,!0))&&(this._cellUris.set(c.document.uri,this._cells.length),this._cells.push(c),l.push(c.document.getText().length+1),g.push(c.document.lineCount));this._cellLengths=new k.PrefixSumComputer(new Uint32Array(l)),this._cellLines=new k.PrefixSumComputer(new Uint32Array(g))}get version(){return this._versionId}getText(l){var g,c;if(!l){let u="";for(const h of this._cells)u+=h.document.getText()+`
`;return u=u.slice(0,-1),u}if(l.isEmpty)return"";const f=this.locationAt(l.start),_=this.locationAt(l.end),w=this._cells[(g=this._cellUris.get(f.uri))!==null&&g!==void 0?g:-1],E=this._cells[(c=this._cellUris.get(_.uri))!==null&&c!==void 0?c:-1];if(!w||!E)return"";if(w===E)return w.document.getText(new v.Range(f.range.start,_.range.end));{const u=w.document.getText(new v.Range(f.range.start,new v.Position(w.document.lineCount,0))),h=E.document.getText(new v.Range(new v.Position(0,0),_.range.end));return u+`
`+h}}offsetAt(l){const g=this._cellLines.getIndexOf(l.line),c=this._cellLengths.getAccumulatedValue(g.index-1),f=this._cells[g.index].document.offsetAt(l.with(g.remainder));return c+f}positionAt(l){if(typeof l=="number"){const c=this._cellLengths.getIndexOf(l),f=this._cellLines.getAccumulatedValue(c.index-1);return this._cells[c.index].document.positionAt(c.remainder).translate(f)}const g=this._cellUris.get(l.uri);if(g!==void 0){const c=this._cellLines.getAccumulatedValue(g-1);return new v.Position(c+l.range.start.line,l.range.start.character)}return new v.Position(0,0)}locationAt(l){v.Range.isRange(l)||(l=new v.Range(l,l));const g=this._cellLines.getIndexOf(l.start.line);let c=g;l.isEmpty||(c=this._cellLines.getIndexOf(l.end.line));const f=new v.Position(g.remainder,l.start.character),_=new v.Position(c.remainder,l.end.character),w=new v.Range(f,_),E=this._cells[g.index];return new v.Location(E.document.uri,E.document.validateRange(w))}contains(l){return this._cellUris.has(l)}validateRange(l){const g=this.validatePosition(l.start),c=this.validatePosition(l.end);return l.with(g,c)}validatePosition(l){const g=this._cellLines.getIndexOf(l.line),c=new v.Position(g.remainder,l.character),f=this._cells[g.index].document.validatePosition(c),_=this._cellLines.getAccumulatedValue(g.index-1);return new v.Position(_+f.line,f.character)}}e.ExtHostNotebookConcatDocument=s}),define(ge[192],pe([0,1,7,12,3]),function(X,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let y=class{constructor(C){this._actual=new v.ColorTheme(v.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new k.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(C){let D=C==="light"?v.ColorThemeKind.Light:C==="dark"?v.ColorThemeKind.Dark:v.ColorThemeKind.HighContrast;this._actual=new v.ColorTheme(D),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};y=Ve([We(0,R.IExtHostRpcService)],y),e.ExtHostTheming=y}),define(ge[59],pe([0,1,4]),function(X,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=v.createDecorator("IURITransformerService");class R{constructor(y){y?(this.transformIncoming=y.transformIncoming.bind(y),this.transformOutgoing=y.transformOutgoing.bind(y),this.transformOutgoingURI=y.transformOutgoingURI.bind(y),this.transformOutgoingScheme=y.transformOutgoingScheme.bind(y)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.URITransformerService=R}),define(ge[193],pe([0,1,22]),function(X,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class R{constructor(){this.buffers=[]}add(D){let P=this.buffers.indexOf(D);return P<0&&(P=this.buffers.length,this.buffers.push(D)),P}}function k(C,D){if(D.serializeBuffersForPostMessage){const P=new R,s=(g,c)=>{if(c instanceof ArrayBuffer){const f=P.add(c);return{$$vscode_array_buffer_reference$$:!0,index:f}}else if(ArrayBuffer.isView(c)){const f=y(c);if(f){const _=P.add(c.buffer);return{$$vscode_array_buffer_reference$$:!0,index:_,view:{type:f,byteLength:c.byteLength,byteOffset:c.byteOffset}}}}return c},I=JSON.stringify(C,s),l=P.buffers.map(g=>{const c=new Uint8Array(g);return v.VSBuffer.wrap(c)});return{message:I,buffers:l}}else return{message:JSON.stringify(C),buffers:[]}}e.serializeWebviewMessage=k;function y(C){switch(C.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function A(C,D){const P=D.map(l=>{const g=new ArrayBuffer(l.byteLength);return new Uint8Array(g).set(l.buffer),g}),s=D.length?(l,g)=>{if(typeof g=="object"&&g.$$vscode_array_buffer_reference$$){const c=g,{index:f}=c,_=P[f];if(c.view)switch(c.view.type){case 1:return new Int8Array(_,c.view.byteOffset,c.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(_,c.view.byteOffset,c.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(_,c.view.byteOffset,c.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(_,c.view.byteOffset,c.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(_,c.view.byteOffset,c.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(_,c.view.byteOffset,c.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(_,c.view.byteOffset,c.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(_,c.view.byteOffset,c.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(_,c.view.byteOffset,c.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(_,c.view.byteOffset,c.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(_,c.view.byteOffset,c.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return _}return g}:void 0;return{message:JSON.parse(C,s),arrayBuffers:P}}e.deserializeWebviewMessage=A}),define(ge[85],pe([0,1,10,2]),function(X,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function k(y,A){return y.scheme===v.Schemas.http||y.scheme===v.Schemas.https?y:(A&&A.authority&&A.isRemote&&y.scheme===v.Schemas.file&&(y=R.URI.from({scheme:v.Schemas.vscodeRemote,authority:A.authority,path:y.path})),R.URI.from({scheme:v.Schemas.https,authority:`${y.scheme}+${y.authority}.${e.webviewRootResourceAuthority}`,path:y.path,fragment:y.fragment,query:y.query}))}e.asWebviewUri=k}),define(ge[194],pe([0,1,3,6,85]),function(X,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class y{constructor(C,D,P){this._proxy=C,this._editors=D,this._initData=P,this._handlePool=0,this._disposables=new R.DisposableStore,this._insets=new Map,this._disposables.add(D.onDidChangeVisibleTextEditors(()=>{const s=D.getVisibleTextEditors();for(const I of this._insets.values())s.indexOf(I.editor)<0&&I.inset.dispose()}))}dispose(){this._insets.forEach(C=>C.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(C,D,P,s,I){let l;for(const u of this._editors.getVisibleTextEditors(!0))if(u.value===C){l=u;break}if(!l)throw new Error("not a visible editor");const g=this,c=this._handlePool++,f=new v.Emitter,_=new v.Emitter,w=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(u){return k.asWebviewUri(u,g._initData.remote)}get cspSource(){return k.webviewGenericCspSource}set options(u){this._options=u,g._proxy.$setOptions(c,u)}get options(){return this._options}set html(u){this._html=u,g._proxy.$setHtml(c,u)}get html(){return this._html}get onDidReceiveMessage(){return f.event}postMessage(u){return g._proxy.$postMessage(c,u)}},E=new class{constructor(){this.editor=C,this.line=D,this.height=P,this.webview=w,this.onDidDispose=_.event}dispose(){g._insets.has(c)&&(g._insets.delete(c),g._proxy.$disposeEditorInset(c),_.fire(),_.dispose(),f.dispose())}};return this._proxy.$createEditorInset(c,l.id,l.value.document.uri,D+1,P,s||{},I.identifier,I.extensionLocation),this._insets.set(c,{editor:C,inset:E,onDidReceiveMessage:f}),E}$onDidDispose(C){const D=this._insets.get(C);D&&D.inset.dispose()}$onDidReceiveMessage(C,D){const P=this._insets.get(C);P&&P.onDidReceiveMessage.fire(D)}}e.ExtHostEditorInsets=y}),define(ge[119],pe([0,1,3,14,166]),function(X,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class y{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new v.Emitter,this._onExit=new v.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(C){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=C}onEvent(C){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=C}onRequest(C){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=C}sendResponse(C){C.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${C.command}`)):this.internalSend("response",C)}sendRequest(C,D,P,s){const I={command:C};if(D&&Object.keys(D).length>0&&(I.arguments=D),this.internalSend("request",I),typeof s=="number"){const l=setTimeout(()=>{clearTimeout(l);const g=this.pendingRequests.get(I.seq);if(g){this.pendingRequests.delete(I.seq);const c={type:"response",seq:0,request_seq:I.seq,success:!1,command:C,message:k.localize(0,null,s,C)};g(c)}},s)}return P&&this.pendingRequests.set(I.seq,P),I.seq}acceptMessage(C){this.messageCallback?this.messageCallback(C):(this.queue.push(C),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(C,D){return C.type!=="event"||D.type!=="event"}async processQueue(){let C;for(;this.queue.length;){if((!C||this.needsTaskBoundaryBetween(this.queue[0],C))&&await R.timeout(0),C=this.queue.shift(),!C)return;switch(C.type){case"event":this.eventCallback&&this.eventCallback(C);break;case"request":this.requestCallback&&this.requestCallback(C);break;case"response":const D=C,P=this.pendingRequests.get(D.request_seq);P&&(this.pendingRequests.delete(D.request_seq),P(D));break}}}internalSend(C,D){D.type=C,D.seq=this.sequence++,this.sendMessage(D)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const C=new Map;this.pendingRequests.forEach((D,P)=>C.set(P,D)),await R.timeout(500),C.forEach((D,P)=>{D({type:"response",seq:0,request_seq:P,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(P)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=y}),define(ge[195],pe([0,1,8,2,9,25,10]),function(X,e,v,R,k,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const C=/{([^}]+)}/g;function D(r,i,n){return r.replace(C,function(a,p){return i&&p.length>0&&p[0]!=="_"?a:n&&n.hasOwnProperty(p)?n[p]:a})}e.formatPII=D;function P(r){const i={};for(const n of Object.keys(r))n.startsWith("!")||(i[n]=r[n]);return i}e.filterExceptionsFromTelemetry=P;function s(r){return r.configuration.request==="attach"&&!I(r)}e.isSessionAttach=s;function I(r){let i=r.configuration.type;if(!!i)return i==="vslsShare"&&(i=r.configuration.adapterProxy.configuration.type),v.equalsIgnoreCase(i,"extensionhost")||v.equalsIgnoreCase(i,"pwa-extensionhost")?r:r.parentSession?I(r.parentSession):void 0}e.getExtensionHostDebugSession=I;function l(r){return r.type&&(r.label||r.program||r.runtime)}e.isDebuggerMainContribution=l;function g(r,i,n){let a,p=0,d=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,b=null;for(;b=d.exec(r);){let S=b.index+1,o=S+b[0].length;if(S<=i&&o>=n){a=b[0],p=S;break}}if(a){let S=/\w+/g,o=null;for(;(o=S.exec(a))&&!(o.index+1+p+o[0].length>=n););o&&(a=a.substring(0,S.lastIndex))}return a?{start:p,end:p+a.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=g;const c=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function f(r){return!!(r&&r.match(c))}e.isUri=f;function _(r){if(typeof r.path=="string"&&!(typeof r.sourceReference=="number"&&r.sourceReference>0)){if(f(r.path))return R.URI.parse(r.path);if(k.isAbsolute(r.path))return R.URI.file(r.path)}return r.path}function w(r){if(typeof r.path=="object"){const i=R.URI.revive(r.path);if(i)return i.scheme===A.Schemas.file?i.fsPath:i.toString()}return r.path}function E(r,i){const n=i?_:w,a=y.deepClone(r);return h(a,(p,d)=>{p&&d&&(d.path=n(d))}),a}e.convertToDAPaths=E;function u(r,i){const n=i?_:w,a=y.deepClone(r);return h(a,(p,d)=>{!p&&d&&(d.path=n(d))}),a}e.convertToVSCPaths=u;function h(r,i){switch(r.type){case"event":const n=r;switch(n.event){case"output":i(!1,n.body.source);break;case"loadedSource":i(!1,n.body.source);break;case"breakpoint":i(!1,n.body.breakpoint.source);break;default:break}break;case"request":const a=r;switch(a.command){case"setBreakpoints":i(!0,a.arguments.source);break;case"breakpointLocations":i(!0,a.arguments.source);break;case"source":i(!0,a.arguments.source);break;case"gotoTargets":i(!0,a.arguments.source);break;case"launchVSCode":a.arguments.args.forEach(d=>i(!1,d));break;default:break}break;case"response":const p=r;if(p.success&&p.body)switch(p.command){case"stackTrace":p.body.stackFrames.forEach(d=>i(!1,d.source));break;case"loadedSources":p.body.sources.forEach(d=>i(!1,d));break;case"scopes":p.body.scopes.forEach(d=>i(!1,d.source));break;case"setFunctionBreakpoints":p.body.breakpoints.forEach(d=>i(!1,d.source));break;case"setBreakpoints":p.body.breakpoints.forEach(d=>i(!1,d.source));break;default:break}break}}function m(r){return r.filter(i=>{var n;return!((n=i.presentation)===null||n===void 0?void 0:n.hidden)}).sort((i,n)=>i.presentation?n.presentation?i.presentation.group?n.presentation.group?i.presentation.group!==n.presentation.group?i.presentation.group.localeCompare(n.presentation.group):t(i.presentation.order,n.presentation.order):-1:n.presentation.group?1:t(i.presentation.order,n.presentation.order):-1:n.presentation?1:0)}e.getVisibleAndSorted=m;function t(r,i){return typeof r!="number"?typeof i!="number"?0:1:typeof i!="number"?-1:r-i}}),define(ge[196],pe([0,1,28,38,167,120,9,8,25,11,176,119]),function(X,e,v,R,k,y,A,C,D,P,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class l extends I.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(E,u){this.outputStream=u,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,E.on("data",h=>this.handleData(h))}sendMessage(E){if(this.outputStream){const u=JSON.stringify(E);this.outputStream.write(`Content-Length: ${Buffer.byteLength(u,"utf8")}${l.TWO_CRLF}${u}`,"utf8")}}handleData(E){for(this.rawData=Buffer.concat([this.rawData,E]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const u=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,u.length>0)try{this.acceptMessage(JSON.parse(u))}catch(h){this._onError.fire(new Error((h.message||h)+`
`+u))}continue}}else{const u=this.rawData.indexOf(l.TWO_CRLF);if(u!==-1){const m=this.rawData.toString("utf8",0,u).split(l.HEADER_LINESEPARATOR);for(const t of m){const r=t.split(l.HEADER_FIELDSEPARATOR);r[0]==="Content-Length"&&(this.contentLength=Number(r[1]))}this.rawData=this.rawData.slice(u+l.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=l,l.TWO_CRLF=`\r
\r
`,l.HEADER_LINESEPARATOR=/\r?\n/,l.HEADER_FIELDSEPARATOR=/: */;class g extends l{startSession(){return new Promise((E,u)=>{let h=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),E(),h=!0}),this.socket.on("close",()=>{h?this._onError.fire(new Error("connection closed")):u(new Error("connection closed"))}),this.socket.on("error",m=>{h?this._onError.fire(m):u(m)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=g;class c extends g{constructor(E){super();this.adapterServer=E}createConnection(E){return y.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",E)}}e.SocketDebugAdapter=c;class f extends g{constructor(E){super();this.adapterServer=E}createConnection(E){return y.createConnection(this.adapterServer.path,E)}}e.NamedPipeDebugAdapter=f;class _ extends l{constructor(E,u,h){super();this.adapterExecutable=E,this.debugType=u,this.outputService=h}async startSession(){const E=this.adapterExecutable.command,u=this.adapterExecutable.args,h=this.adapterExecutable.options||{};try{if(E)if(A.isAbsolute(E)){if(!await v.exists(E))throw new Error(k.localize(0,null,E))}else E.indexOf("/")<0&&E.indexOf("\\")<0;else throw new Error(k.localize(1,null,this.debugType));let m=process.env;if(h.env&&Object.keys(h.env).length>0&&(m=D.mixin(D.deepClone(process.env),h.env)),E==="node")if(Array.isArray(u)&&u.length>0){const r=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,i={env:m,execArgv:r?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};h.cwd&&(i.cwd=h.cwd);const n=R.fork(u[0],u.slice(1),i);if(!n.pid)throw new Error(k.localize(2,null,u[0]));this.serverProcess=n}else throw new Error(k.localize(3,null));else{const r={env:m};h.cwd&&(r.cwd=h.cwd),this.serverProcess=R.spawn(E,u,r)}this.serverProcess.on("error",r=>{this._onError.fire(r)}),this.serverProcess.on("exit",(r,i)=>{this._onExit.fire(r)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",r=>{this._onError.fire(r)}),this.serverProcess.stdin.on("error",r=>{this._onError.fire(r)});const t=this.outputService;if(t){const r=i=>i.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",i=>{const n=t.getChannel(s.ExtensionsChannelId);n&&n.append(r(i))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(m){this._onError.fire(m)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),P.isWindows?new Promise((E,u)=>{const h=R.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(m,t,r){if(m)return u(m)});h.on("exit",E),h.on("error",u)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(E,u){if(!E)return;const h=Object.create(null);E.runtime&&(E.runtime.indexOf("./")===0?h.runtime=A.join(u,E.runtime):h.runtime=E.runtime),E.runtimeArgs&&(h.runtimeArgs=E.runtimeArgs),E.program&&(A.isAbsolute(E.program)?h.program=E.program:h.program=A.join(u,E.program)),E.args&&(h.args=E.args);const m=E;return m.win&&(h.win=_.extract(m.win,u)),m.winx86&&(h.winx86=_.extract(m.winx86,u)),m.windows&&(h.windows=_.extract(m.windows,u)),m.osx&&(h.osx=_.extract(m.osx,u)),m.linux&&(h.linux=_.extract(m.linux,u)),h}static platformAdapterExecutable(E,u){let h=Object.create(null);u=u.toLowerCase();for(const a of E)if(a.contributes){const p=a.contributes.debuggers;p&&p.length>0&&p.filter(d=>typeof d.type=="string"&&C.equalsIgnoreCase(d.type,u)).forEach(d=>{const b=_.extract(d,a.extensionLocation.fsPath);h=D.mixin(h,b,a.isBuiltin)})}let m;P.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?m=h.winx86||h.win||h.windows:P.isWindows?m=h.win||h.windows:P.isMacintosh?m=h.osx:P.isLinux&&(m=h.linux),m=m||h;let t=m.program||h.program;const r=m.args||h.args;let i=m.runtime||h.runtime;const n=m.runtimeArgs||h.runtimeArgs;if(i)return{type:"executable",command:i,args:(n||[]).concat(typeof t=="string"?[t]:[]).concat(r||[])};if(t)return{type:"executable",command:t,args:r||[]}}}e.ExecutableDebugAdapter=_}),define(ge[197],pe([0,1,38,11,29,185]),function(X,e,v,R,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=e.runInExternalTerminal=void 0;function A(l,g){return new Promise((c,f)=>{let _="";const w=v.spawn(l,g);w.pid&&w.stdout.on("data",E=>{_+=E.toString()}),w.on("error",E=>{f(E)}),w.on("close",E=>{c(_)})})}let C;function D(l,g){if(!C)if(R.isWindows)C=new y.WindowsExternalTerminalService(void 0);else if(R.isMacintosh)C=new y.MacExternalTerminalService(void 0);else if(R.isLinux)C=new y.LinuxExternalTerminalService(void 0);else throw new Error("external terminals not supported on this platform");const c=g.getConfiguration("terminal");return C.runInTerminal(l.title,l.cwd,l.args,l.env||{},c.external||{})}e.runInExternalTerminal=D;function P(l){return l?R.isWindows?new Promise(async g=>{(await new Promise((f,_)=>{X(["windows-process-tree"],f,_)})).getProcessTree(l,f=>{g(f.children.length>0)})}):A("/usr/bin/pgrep",["-lP",String(l)]).then(g=>{const c=g.trim();return!(c.length===0||c.indexOf(" tmux")>=0)},g=>!0):Promise.resolve(!0)}e.hasChildProcesses=P;var s;(function(l){l[l.cmd=0]="cmd",l[l.powershell=1]="powershell",l[l.bash=2]="bash"})(s||(s={}));function I(l,g,c,f){l=l.trim().toLowerCase();let _;l.indexOf("powershell")>=0||l.indexOf("pwsh")>=0?_=1:l.indexOf("cmd.exe")>=0?_=0:l.indexOf("bash")>=0?_=2:R.isWindows?_=0:_=2;let w,E=" ";switch(_){case 1:if(w=h=>(h=h.replace(/\'/g,"''"),h.length>0&&h.charAt(h.length-1)==="\\"?`'${h}\\'`:`'${h}'`),c){const h=k.getDriveLetter(c);h&&(E+=`${h}:; `),E+=`cd ${w(c)}; `}if(f)for(let h in f){const m=f[h];m===null?E+=`Remove-Item env:${h}; `:E+=`\${env:${h}}='${m}'; `}if(g.length>0){const h=w(g.shift());E+=h[0]==="'"?`& ${h} `:`${h} `;for(let m of g)E+=`${w(m)} `}break;case 0:if(w=h=>(h=h.replace(/\"/g,'""'),h.indexOf(" ")>=0||h.indexOf('"')>=0||h.length===0?`"${h}"`:h),c){const h=k.getDriveLetter(c);h&&(E+=`${h}: && `),E+=`cd ${w(c)} && `}if(f){E+='cmd /C "';for(let h in f){let m=f[h];m===null?E+=`set "${h}=" && `:(m=m.replace(/[\^\&\|\<\>]/g,t=>`^${t}`),E+=`set "${h}=${m}" && `)}}for(let h of g)E+=`${w(h)} `;f&&(E+='"');break;case 2:w=h=>(h=h.replace(/(["'\\\$])/g,"\\$1"),h.indexOf(" ")>=0||h.indexOf(";")>=0||h.length===0?`"${h}"`:h);const u=h=>/[^\w@%\/+=,.:^-]/.test(h)?`'${h.replace(/'/g,"'\\''")}'`:h;if(c&&(E+=`cd ${w(c)} ; `),f){E+="/usr/bin/env";for(let h in f){const m=f[h];m===null?E+=` -u ${u(h)}`:E+=` ${u(`${h}=${m}`)}`}E+=" "}for(let h of g)E+=`${w(h)} `;break}return E}e.prepareCommand=I}),define(ge[60],pe([0,1,30,10,9,11,111]),function(X,e,v,R,k,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.OpenGettingStarted=e.ConsolidatedRunButton=e.NotebookCellEditorOptionsCustomizations=e.DragAndDropEnabled=e.ShowFoldingControls=e.ConsolidatedOutputButton=e.UndoRedoPerCell=e.GlobalToolbar=e.InsertToolbarLocation=e.FocusIndicator=e.CompactView=e.ExperimentalInsertToolbarAlignment=e.ExperimentalUseMarkdownRenderer=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBar=e.CellToolbarVisibility=e.CellToolbarLocation=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.getCellUndoRedoComparisonKey=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.AnyRendererApi=e.NotebookCellExecutionState=e.notebookDocumentMetadataDefaults=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var C;(function(o){o[o.Markup=1]="Markup",o[o.Code=2]="Code"})(C=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml","text/markdown","image/png","image/jpeg","text/plain"],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=["text/markdown","application/json","text/plain","text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var D;(function(o){o[o.Running=1]="Running",o[o.Idle=2]="Idle"})(D=e.NotebookRunState||(e.NotebookRunState={})),e.notebookDocumentMetadataDefaults={custom:{}};var P;(function(o){o[o.Pending=2]="Pending",o[o.Executing=3]="Executing"})(P=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={})),e.AnyRendererApi=Symbol("AnyRendererApi");var s;(function(o){o[o.WithHardKernelDependency=0]="WithHardKernelDependency",o[o.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",o[o.Pure=2]="Pure",o[o.Never=3]="Never"})(s=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var I;(function(o){o.Always="always",o.Never="never",o.Optional="optional"})(I=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var l;(function(o){o[o.ModelChange=1]="ModelChange",o[o.Move=2]="Move",o[o.CellClearOutput=3]="CellClearOutput",o[o.CellsClearOutput=4]="CellsClearOutput",o[o.ChangeLanguage=5]="ChangeLanguage",o[o.Initialize=6]="Initialize",o[o.ChangeCellMetadata=7]="ChangeCellMetadata",o[o.Output=8]="Output",o[o.OutputItem=9]="OutputItem",o[o.ChangeCellContent=10]="ChangeCellContent",o[o.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",o[o.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",o[o.Unknown=100]="Unknown"})(l=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var g;(function(o){o[o.Handle=0]="Handle",o[o.Index=1]="Index"})(g=e.SelectionStateType||(e.SelectionStateType={}));var c;(function(o){o[o.Replace=1]="Replace",o[o.Output=2]="Output",o[o.Metadata=3]="Metadata",o[o.CellLanguage=4]="CellLanguage",o[o.DocumentMetadata=5]="DocumentMetadata",o[o.Move=6]="Move",o[o.OutputItems=7]="OutputItems",o[o.PartialMetadata=8]="PartialMetadata",o[o.PartialInternalMetadata=9]="PartialInternalMetadata"})(c=e.CellEditType||(e.CellEditType={}));function f(o,L){if(L)return o.toString();const O=_.parse(o);return O?O.notebook.toString():o.toString()}e.getCellUndoRedoComparisonKey=f;var _;(function(o){o.scheme=R.Schemas.vscodeNotebookCell;const L=/^ch(\d{7,})/;function O(x,V){return x.with({scheme:o.scheme,fragment:`ch${V.toString().padStart(7,"0")}${x.scheme!==R.Schemas.file?x.scheme:""}`})}o.generate=O;function W(x){if(x.scheme!==o.scheme)return;const V=L.exec(x.fragment);return V?{handle:Number(V[1]),notebook:x.with({scheme:x.fragment.substr(V[0].length)||R.Schemas.file,fragment:null})}:void 0}o.parse=W;function J(x){if(x.scheme!==R.Schemas.vscodeNotebookCellMetadata)return;const V=L.exec(x.fragment);return V?{handle:Number(V[1]),notebook:x.with({scheme:x.fragment.substr(V[0].length)||R.Schemas.file,fragment:null})}:void 0}o.parseCellMetadataUri=J;function oe(x,V,T){return x.with({scheme:T,fragment:`ch${V.toString().padStart(7,"0")}${x.scheme!==R.Schemas.file?x.scheme:""}`})}o.generateCellUri=oe;function q(x,V){if(x.scheme!==V)return;const T=L.exec(x.fragment);return T?{handle:Number(T[1]),notebook:x.with({scheme:x.fragment.substr(T[0].length)||R.Schemas.file,fragment:null})}:void 0}o.parseCellUri=q})(_=e.CellUri||(e.CellUri={}));const w=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],["text/markdown",{alwaysSecure:!0,supportedByCore:!0}],["text/plain",{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/x.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stream",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function E(o){var L,O;return(O=(L=w.get(o))===null||L===void 0?void 0:L.alwaysSecure)!==null&&O!==void 0?O:!1}e.mimeTypeIsAlwaysSecure=E;function u(o){var L,O;return(O=(L=w.get(o))===null||L===void 0?void 0:L.supportedByCore)!==null&&O!==void 0?O:!1}e.mimeTypeSupportedByCore=u;function h(o){var L,O;return(O=(L=w.get(o))===null||L===void 0?void 0:L.mergeable)!==null&&O!==void 0?O:!1}e.mimeTypeIsMergeable=h;function m(o,L){return y.isWindows&&(o=o.replace(/\//g,"\\"),L=L.replace(/\//g,"\\")),v.match(o,L)}function t(o,L,O){let W=0;for(let J=0;J<L.length;J++){if(m(L[J],o))return W;W++}for(let J=0;J<O.length;J++){if(m(O[J],o))return W;W++}return W}function r(o,L,O){return o.sort((W,J)=>t(W,L,O)-t(J,L,O))}e.sortMimeTypes=r;function i(o,L,O,W=(J,oe)=>J===oe){const J=[];function oe(V,T,N){if(T===0&&N.length===0)return;const F=J[J.length-1];F&&F.start+F.deleteCount===V?(F.deleteCount+=T,F.toInsert.push(...N)):J.push({start:V,deleteCount:T,toInsert:N})}let q=0,x=0;for(;;){if(q===o.length){oe(q,0,L.slice(x));break}if(x===L.length){oe(q,o.length-q,[]);break}const V=o[q],T=L[x];if(W(V,T)){q+=1,x+=1;continue}O(T)?(oe(q,1,[]),q+=1):(oe(q,0,[T]),x+=1)}return J}e.diff=i,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new A.RawContextKey("notebookEditorCursorAtBoundary","none");var n;(function(o){o.default="default",o.option="option"})(n=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function a(o){const L=o;return!!((typeof L.include=="string"||v.isRelativePattern(L.include))&&(typeof L.exclude=="string"||v.isRelativePattern(L.exclude)))}e.isDocumentExcludePattern=a;function p(o,L,O){if(Array.isArray(o.viewType)&&o.viewType.indexOf(L)>=0||o.viewType===L)return!0;if(o.filenamePattern){let W=a(o.filenamePattern)?o.filenamePattern.include:o.filenamePattern,J=a(o.filenamePattern)?o.filenamePattern.exclude:void 0;if(v.match(W,k.basename(O.fsPath).toLowerCase()))return!(J&&v.match(J,k.basename(O.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=p;class d{constructor(L){this.textModel=L}getElements(){const L=new Int32Array(this.textModel.cells.length);for(let O=0;O<this.textModel.cells.length;O++)L[O]=this.textModel.cells[O].getHashValue();return L}}e.CellSequence=d,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocation="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBar="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalUseMarkdownRenderer="notebook.experimental.useMarkdownRenderer",e.ExperimentalInsertToolbarAlignment="notebook.experimental.insertToolbarAlignment",e.CompactView="notebook.compactView",e.FocusIndicator="notebook.cellFocusIndicator",e.InsertToolbarLocation="notebook.insertToolbarLocation",e.GlobalToolbar="notebook.globalToolbar",e.UndoRedoPerCell="notebook.undoRedoPerCell",e.ConsolidatedOutputButton="notebook.consolidatedOutputButton",e.ShowFoldingControls="notebook.showFoldingControls",e.DragAndDropEnabled="notebook.dragAndDropEnabled",e.NotebookCellEditorOptionsCustomizations="notebook.editorOptionsCustomizations",e.ConsolidatedRunButton="notebook.consolidatedRunButton",e.OpenGettingStarted="notebook.experimental.openGettingStarted";var b;(function(o){o[o.Left=1]="Left",o[o.Right=2]="Right"})(b=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class S{static create(L){return`${S._prefix}${L}`}static parse(L){if(L.startsWith(S._prefix))return L.substr(S._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=S,S._prefix="notebook/"}),define(ge[198],pe([0,1,169,4,111]),function(X,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new k.RawContextKey("customExecutionSupported",!0,v.localize(0,null)),e.ShellExecutionSupportedContext=new k.RawContextKey("shellExecutionSupported",!1,v.localize(1,null)),e.ProcessExecutionSupportedContext=new k.RawContextKey("processExecutionSupported",!1,v.localize(2,null)),e.ITaskService=R.createDecorator("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(ge[199],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function v(k){return[...k.entries()]}e.serializeEnvironmentVariableCollection=v;function R(k){return new Map(k)}e.deserializeEnvironmentVariableCollection=R}),define(ge[121],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.getTestSubscriptionKey=e.TestDiffOpType=e.applyTestItemUpdate=e.TestItemExpandState=void 0;var v;(function(D){D[D.NotExpandable=0]="NotExpandable",D[D.Expandable=1]="Expandable",D[D.BusyExpanding=2]="BusyExpanding",D[D.Expanded=3]="Expanded"})(v=e.TestItemExpandState||(e.TestItemExpandState={}));const R=(D,P)=>{P.expand!==void 0&&(D.expand=P.expand),P.item!==void 0&&(D.item=D.item?Object.assign(D.item,P.item):P.item)};e.applyTestItemUpdate=R;var k;(function(D){D[D.Add=0]="Add",D[D.Update=1]="Update",D[D.Remove=2]="Remove",D[D.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",D[D.Retire=4]="Retire"})(k=e.TestDiffOpType||(e.TestDiffOpType={}));const y=(D,P)=>`${D}:${P.toString()}`;e.getTestSubscriptionKey=y;class A{add(P){}update(P){}remove(P,s){}complete(){}}e.IncrementalChangeCollector=A;class C{constructor(){this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0}apply(P){const s=this.createChangeCollector();for(const I of P)switch(I[0]){case 0:{const l=I[1];if(l.parent){if(this.items.has(l.parent)){const g=this.items.get(l.parent);g.children.add(l.item.extId);const c=this.createItem(l,g);this.items.set(l.item.extId,c),s.add(c)}}else{this.roots.add(l.item.extId);const g=this.createItem(l);this.items.set(l.item.extId,g),s.add(g)}l.expand===2&&this.busyControllerCount++;break}case 1:{const l=I[1],g=this.items.get(l.extId);if(!g)break;l.expand!==void 0&&(g.expand===2&&this.busyControllerCount--,l.expand===2&&this.busyControllerCount++),e.applyTestItemUpdate(g,l),s.update(g);break}case 2:{const l=this.items.get(I[1]);if(!l)break;l.parent?this.items.get(l.parent).children.delete(l.item.extId):this.roots.delete(l.item.extId);const g=[[I[1]]];for(;g.length;)for(const c of g.pop()){const f=this.items.get(c);f&&(g.push(f.children),this.items.delete(c),s.remove(f,f!==l),f.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(I[1]);break;case 3:this.updatePendingRoots(I[1]);break}s.complete()}retireTest(P){}updatePendingRoots(P){this.pendingRootCount+=P}createChangeCollector(){return new A}}e.AbstractIncrementalTestCollection=C}),define(ge[200],pe([0,1,9,37,13,25,11,76,170]),function(X,e,v,R,k,y,A,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class P{constructor(I,l,g){this._contributedVariables=new Map,this._context=I,this._labelService=l,g&&(this._envVariablesPromise=g.then(c=>this.prepareEnv(c)))}prepareEnv(I){if(A.isWindows){const l=Object.create(null);return Object.keys(I).forEach(g=>{l[g.toLowerCase()]=I[g]}),l}return I}resolveWithEnvironment(I,l,g){return this.recursiveResolve(this.prepareEnv(I),l?l.uri:void 0,g)}async resolveAsync(I,l){return this.recursiveResolve(await this._envVariablesPromise,I?I.uri:void 0,l)}async resolveAnyBase(I,l,g,c){const f=y.deepClone(l);return A.isWindows&&f.windows?Object.keys(f.windows).forEach(_=>f[_]=f.windows[_]):A.isMacintosh&&f.osx?Object.keys(f.osx).forEach(_=>f[_]=f.osx[_]):A.isLinux&&f.linux&&Object.keys(f.linux).forEach(_=>f[_]=f.linux[_]),delete f.windows,delete f.osx,delete f.linux,this.recursiveResolve(await this._envVariablesPromise,I?I.uri:void 0,f,g,c)}async resolveAnyAsync(I,l,g){return this.resolveAnyBase(I,l,g)}async resolveAnyMap(I,l,g){const c=new Map;return{newConfig:await this.resolveAnyBase(I,l,g,c),resolvedVariables:c}}resolveWithInteractionReplace(I,l,g,c){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(I,l,g,c){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(I,l){if(this._contributedVariables.has(I))throw new Error("Variable "+I+" is contributed twice.");this._contributedVariables.set(I,l)}recursiveResolve(I,l,g,c,f){if(k.isString(g))return this.resolveString(I,l,g,c,f);if(k.isArray(g))return g.map(_=>this.recursiveResolve(I,l,_,c,f));if(k.isObject(g)){let _=Object.create(null);return Object.keys(g).forEach(w=>{const E=this.resolveString(I,l,w,c,f);_[E]=this.recursiveResolve(I,l,g[w],c,f)}),_}return g}resolveString(I,l,g,c,f){return g.replace(P.VARIABLE_REGEXP,(w,E)=>{if(E.includes(P.VARIABLE_LHS))return w;let u=this.evaluateSingleVariable(I,w,E,l,c);return f&&f.set(E,u),u!==w&&k.isString(u)&&u.match(P.VARIABLE_REGEXP)&&(u=this.resolveString(I,l,u,c,f)),u})}fsPath(I){return this._labelService?this._labelService.getUriLabel(I,{noPrefix:!0}):I.fsPath}evaluateSingleVariable(I,l,g,c,f){let _;const w=g.split(":");w.length>1&&(g=w[0],_=w[1]);const E=()=>{const m=this._context.getFilePath();if(m)return m;throw new Error(D.localize(0,null,l))},u=()=>{const m=E();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error(D.localize(1,null,l,v.basename(m)))},h=()=>{if(_){const m=this._context.getFolderUri(_);if(m)return m;throw new Error(D.localize(2,null,l,_))}if(c)return c;throw this._context.getWorkspaceFolderCount()>1?new Error(D.localize(3,null,l)):new Error(D.localize(4,null,l))};switch(g){case"env":if(_){if(I){const m=I[A.isWindows?_.toLowerCase():_];if(k.isString(m))return m}return""}throw new Error(D.localize(5,null,l));case"config":if(_){const m=this._context.getConfigurationValue(c,_);if(k.isUndefinedOrNull(m))throw new Error(D.localize(6,null,l,_));if(k.isObject(m))throw new Error(D.localize(7,null,l,_));return m}throw new Error(D.localize(8,null,l));case"command":return this.resolveFromMap(l,_,f,"command");case"input":return this.resolveFromMap(l,_,f,"input");default:switch(g){case"workspaceRoot":case"workspaceFolder":return C.normalizeDriveLetter(this.fsPath(h()));case"cwd":return c||_?C.normalizeDriveLetter(this.fsPath(h())):R.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return v.basename(this.fsPath(h()));case"lineNumber":const m=this._context.getLineNumber();if(m)return m;throw new Error(D.localize(9,null,l));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error(D.localize(10,null,l));case"file":return E();case"fileWorkspaceFolder":return u();case"relativeFile":return c||_?v.relative(this.fsPath(h()),E()):E();case"relativeFileDirname":const r=v.dirname(E());if(c||_){const p=v.relative(this.fsPath(h()),r);return p.length===0?".":p}return r;case"fileDirname":return v.dirname(E());case"fileExtname":return v.extname(E());case"fileBasename":return v.basename(E());case"fileBasenameNoExtension":const i=v.basename(E());return i.slice(0,i.length-v.extname(i).length);case"fileDirnameBasename":return v.basename(v.dirname(E()));case"execPath":const n=this._context.getExecPath();return n||l;case"execInstallFolder":const a=this._context.getAppRoot();return a||l;case"pathSeparator":return v.sep;default:try{const p=_?`${g}:${_}`:g;return this.resolveFromMap(l,p,f,void 0)}catch(p){return l}}}}resolveFromMap(I,l,g,c){if(l&&g){const f=c===void 0?g[l]:g[c+":"+l];if(typeof f=="string")return f;throw new Error(D.localize(11,null,I))}return I}}e.AbstractVariableResolverService=P,P.VARIABLE_LHS="${",P.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(ge[201],pe([0,1,4]),function(X,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=v.createDecorator("editorGroupsService");var R;(function(l){l[l.UP=0]="UP",l[l.DOWN=1]="DOWN",l[l.LEFT=2]="LEFT",l[l.RIGHT=3]="RIGHT"})(R=e.GroupDirection||(e.GroupDirection={}));var k;(function(l){l[l.HORIZONTAL=0]="HORIZONTAL",l[l.VERTICAL=1]="VERTICAL"})(k=e.GroupOrientation||(e.GroupOrientation={}));var y;(function(l){l[l.FIRST=0]="FIRST",l[l.LAST=1]="LAST",l[l.NEXT=2]="NEXT",l[l.PREVIOUS=3]="PREVIOUS"})(y=e.GroupLocation||(e.GroupLocation={}));var A;(function(l){l[l.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",l[l.EVEN=1]="EVEN",l[l.TOGGLE=2]="TOGGLE"})(A=e.GroupsArrangement||(e.GroupsArrangement={}));var C;(function(l){l[l.COPY_EDITORS=0]="COPY_EDITORS",l[l.MOVE_EDITORS=1]="MOVE_EDITORS"})(C=e.MergeGroupMode||(e.MergeGroupMode={}));var D;(function(l){l[l.CREATION_TIME=0]="CREATION_TIME",l[l.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",l[l.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(D=e.GroupsOrder||(e.GroupsOrder={}));var P;(function(l){l[l.GROUP_ACTIVE=0]="GROUP_ACTIVE",l[l.GROUP_INDEX=1]="GROUP_INDEX",l[l.EDITOR_OPEN=2]="EDITOR_OPEN",l[l.EDITOR_CLOSE=3]="EDITOR_CLOSE",l[l.EDITOR_MOVE=4]="EDITOR_MOVE",l[l.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",l[l.EDITOR_LABEL=6]="EDITOR_LABEL",l[l.EDITOR_CAPABILITIES=7]="EDITOR_CAPABILITIES",l[l.EDITOR_PIN=8]="EDITOR_PIN",l[l.EDITOR_STICKY=9]="EDITOR_STICKY",l[l.EDITOR_DIRTY=10]="EDITOR_DIRTY"})(P=e.GroupChangeKind||(e.GroupChangeKind={}));var s;(function(l){l[l.NEW_EDITOR=1]="NEW_EDITOR",l[l.MOVE_EDITOR=2]="MOVE_EDITOR",l[l.COPY_EDITOR=3]="COPY_EDITOR"})(s=e.OpenEditorContext||(e.OpenEditorContext={}));function I(l){return l.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=I}),define(ge[202],pe([0,1,4]),function(X,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=v.createDecorator("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2}),define(ge[18],pe([0,1,17,95,273,53,25,13,2,41,79,171,113,60,202,7]),function(X,e,v,R,k,y,A,C,D,P,s,I,l,g,c,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeActionTriggerKind=e.TestResults=e.TestItem=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var _;(function(Ee){function De(G){const{selectionStartLineNumber:Ue,selectionStartColumn:Le,positionLineNumber:Ge,positionColumn:Je}=G,lt=new f.Position(Ue-1,Le-1),ct=new f.Position(Ge-1,Je-1);return new f.Selection(lt,ct)}Ee.to=De;function de(G){const{anchor:Ue,active:Le}=G;return{selectionStartLineNumber:Ue.line+1,selectionStartColumn:Ue.character+1,positionLineNumber:Le.line+1,positionColumn:Le.character+1}}Ee.from=de})(_=e.Selection||(e.Selection={}));var w;(function(Ee){function De(G){if(!G)return;const{start:Ue,end:Le}=G;return{startLineNumber:Ue.line+1,startColumn:Ue.character+1,endLineNumber:Le.line+1,endColumn:Le.character+1}}Ee.from=De;function de(G){if(!G)return;const{startLineNumber:Ue,startColumn:Le,endLineNumber:Ge,endColumn:Je}=G;return new f.Range(Ue-1,Le-1,Ge-1,Je-1)}Ee.to=de})(w=e.Range||(e.Range={}));var E;(function(Ee){function De(de){switch(de){case 1:return f.StandardTokenType.Comment;case 0:return f.StandardTokenType.Other;case 4:return f.StandardTokenType.RegEx;case 2:return f.StandardTokenType.String}}Ee.to=De})(E=e.TokenType||(e.TokenType={}));var u;(function(Ee){function De(G){return new f.Position(G.lineNumber-1,G.column-1)}Ee.to=De;function de(G){return{lineNumber:G.line+1,column:G.character+1}}Ee.from=de})(u=e.Position||(e.Position={}));var h;(function(Ee){function De(G){switch(G){case f.DiagnosticTag.Unnecessary:return 1;case f.DiagnosticTag.Deprecated:return 2}}Ee.from=De;function de(G){switch(G){case 1:return f.DiagnosticTag.Unnecessary;case 2:return f.DiagnosticTag.Deprecated;default:return}}Ee.to=de})(h=e.DiagnosticTag||(e.DiagnosticTag={}));var m;(function(Ee){function De(G){let Ue;return G.code&&(C.isString(G.code)||C.isNumber(G.code)?Ue=String(G.code):Ue={value:String(G.code.value),target:G.code.target}),Object.assign(Object.assign({},w.from(G.range)),{message:G.message,source:G.source,code:Ue,severity:r.from(G.severity),relatedInformation:G.relatedInformation&&G.relatedInformation.map(t.from),tags:Array.isArray(G.tags)?v.coalesce(G.tags.map(h.from)):void 0})}Ee.from=De;function de(G){var Ue;const Le=new f.Diagnostic(w.to(G),G.message,r.to(G.severity));return Le.source=G.source,Le.code=C.isString(G.code)?G.code:(Ue=G.code)===null||Ue===void 0?void 0:Ue.value,Le.relatedInformation=G.relatedInformation&&G.relatedInformation.map(t.to),Le.tags=G.tags&&v.coalesce(G.tags.map(h.to)),Le}Ee.to=de})(m=e.Diagnostic||(e.Diagnostic={}));var t;(function(Ee){function De(G){return Object.assign(Object.assign({},w.from(G.location.range)),{message:G.message,resource:G.location.uri})}Ee.from=De;function de(G){return new f.DiagnosticRelatedInformation(new f.Location(G.resource,w.to(G)),G.message)}Ee.to=de})(t=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var r;(function(Ee){function De(G){switch(G){case f.DiagnosticSeverity.Error:return l.MarkerSeverity.Error;case f.DiagnosticSeverity.Warning:return l.MarkerSeverity.Warning;case f.DiagnosticSeverity.Information:return l.MarkerSeverity.Info;case f.DiagnosticSeverity.Hint:return l.MarkerSeverity.Hint}return l.MarkerSeverity.Error}Ee.from=De;function de(G){switch(G){case l.MarkerSeverity.Info:return f.DiagnosticSeverity.Information;case l.MarkerSeverity.Warning:return f.DiagnosticSeverity.Warning;case l.MarkerSeverity.Error:return f.DiagnosticSeverity.Error;case l.MarkerSeverity.Hint:return f.DiagnosticSeverity.Hint;default:return f.DiagnosticSeverity.Error}}Ee.to=de})(r=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var i;(function(Ee){function De(G){return typeof G=="number"&&G>=f.ViewColumn.One?G-1:G===f.ViewColumn.Beside?c.SIDE_GROUP:c.ACTIVE_GROUP}Ee.from=De;function de(G){if(typeof G=="number"&&G>=0)return G+1;throw new Error("invalid 'EditorGroupColumn'")}Ee.to=de})(i=e.ViewColumn||(e.ViewColumn={}));function n(Ee){return typeof Ee.range!="undefined"}function a(Ee){return Ee.length===0?!0:!!n(Ee[0])}e.isDecorationOptionsArr=a;var p;(function(Ee){function De(Je){return Je.map(Ee.from)}Ee.fromMany=De;function de(Je){return Je&&typeof Je=="object"&&typeof Je.language=="string"&&typeof Je.value=="string"}function G(Je){let lt;if(de(Je)){const{language:St,value:vt}=Je;lt={value:"```"+St+`
`+vt+"\n```\n"}}else f.MarkdownString.isMarkdownString(Je)?lt={value:Je.value,isTrusted:Je.isTrusted,supportThemeIcons:Je.supportThemeIcons}:typeof Je=="string"?lt={value:Je}:lt={value:""};const ct=Object.create(null);lt.uris=ct;const it=St=>{try{let vt=D.URI.parse(St,!0);vt=vt.with({query:Ue(vt.query,ct)}),ct[St]=vt}catch(vt){}return""},mt=new k.Renderer;return mt.link=it,mt.image=St=>it(R.parseHrefAndDimensions(St).href),k(lt.value,{renderer:mt}),lt}Ee.from=G;function Ue(Je,lt){if(!Je)return Je;let ct;try{ct=y.parse(Je)}catch(mt){}if(!ct)return Je;let it=!1;return ct=A.cloneAndChange(ct,mt=>{if(D.URI.isUri(mt)){const St=`__uri_${Math.random().toString(16).slice(2,8)}`;return lt[St]=mt,it=!0,St}else return}),it?JSON.stringify(ct):Je}function Le(Je){const lt=new f.MarkdownString(Je.value,Je.supportThemeIcons);return lt.isTrusted=Je.isTrusted,lt}Ee.to=Le;function Ge(Je){if(!!Je)return typeof Je=="string"?Je:Ee.from(Je)}Ee.fromStrict=Ge})(p=e.MarkdownString||(e.MarkdownString={}));function d(Ee){return a(Ee)?Ee.map(De=>({range:w.from(De.range),hoverMessage:Array.isArray(De.hoverMessage)?p.fromMany(De.hoverMessage):De.hoverMessage?p.from(De.hoverMessage):void 0,renderOptions:De.renderOptions})):Ee.map(De=>({range:w.from(De)}))}e.fromRangeOrRangeWithMessage=d;function b(Ee){return typeof Ee=="undefined"?Ee:typeof Ee=="string"?D.URI.file(Ee):Ee}e.pathOrURIToURI=b;var S;(function(Ee){function De(de){return typeof de=="undefined"?de:{contentText:de.contentText,contentIconPath:de.contentIconPath?b(de.contentIconPath):void 0,border:de.border,borderColor:de.borderColor,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,color:de.color,backgroundColor:de.backgroundColor,margin:de.margin,width:de.width,height:de.height}}Ee.from=De})(S=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var o;(function(Ee){function De(de){return typeof de=="undefined"?de:{backgroundColor:de.backgroundColor,outline:de.outline,outlineColor:de.outlineColor,outlineStyle:de.outlineStyle,outlineWidth:de.outlineWidth,border:de.border,borderColor:de.borderColor,borderRadius:de.borderRadius,borderSpacing:de.borderSpacing,borderStyle:de.borderStyle,borderWidth:de.borderWidth,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,cursor:de.cursor,color:de.color,opacity:de.opacity,letterSpacing:de.letterSpacing,gutterIconPath:de.gutterIconPath?b(de.gutterIconPath):void 0,gutterIconSize:de.gutterIconSize,overviewRulerColor:de.overviewRulerColor,before:de.before?S.from(de.before):void 0,after:de.after?S.from(de.after):void 0}}Ee.from=De})(o=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var L;(function(Ee){function De(de){if(typeof de=="undefined")return de;switch(de){case f.DecorationRangeBehavior.OpenOpen:return 0;case f.DecorationRangeBehavior.ClosedClosed:return 1;case f.DecorationRangeBehavior.OpenClosed:return 2;case f.DecorationRangeBehavior.ClosedOpen:return 3}}Ee.from=De})(L=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var O;(function(Ee){function De(de){return{isWholeLine:de.isWholeLine,rangeBehavior:de.rangeBehavior?L.from(de.rangeBehavior):void 0,overviewRulerLane:de.overviewRulerLane,light:de.light?o.from(de.light):void 0,dark:de.dark?o.from(de.dark):void 0,backgroundColor:de.backgroundColor,outline:de.outline,outlineColor:de.outlineColor,outlineStyle:de.outlineStyle,outlineWidth:de.outlineWidth,border:de.border,borderColor:de.borderColor,borderRadius:de.borderRadius,borderSpacing:de.borderSpacing,borderStyle:de.borderStyle,borderWidth:de.borderWidth,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,cursor:de.cursor,color:de.color,opacity:de.opacity,letterSpacing:de.letterSpacing,gutterIconPath:de.gutterIconPath?b(de.gutterIconPath):void 0,gutterIconSize:de.gutterIconSize,overviewRulerColor:de.overviewRulerColor,before:de.before?S.from(de.before):void 0,after:de.after?S.from(de.after):void 0}}Ee.from=De})(O=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var W;(function(Ee){function De(G){return{text:G.newText,eol:G.newEol&&Q.from(G.newEol),range:w.from(G.range)}}Ee.from=De;function de(G){const Ue=new f.TextEdit(w.to(G.range),G.text);return Ue.newEol=typeof G.eol=="undefined"?void 0:Q.to(G.eol),Ue}Ee.to=de})(W=e.TextEdit||(e.TextEdit={}));var J;(function(Ee){function De(G,Ue,Le){var Ge,Je,lt;const ct={edits:[]};if(G instanceof f.WorkspaceEdit)for(let it of G._allEntries())if(it._type===1)ct.edits.push({_type:1,oldUri:it.from,newUri:it.to,options:it.options,metadata:it.metadata});else if(it._type===2){const mt=Ue==null?void 0:Ue.getDocument(it.uri);ct.edits.push({_type:2,resource:it.uri,edit:W.from(it.edit),modelVersionId:mt==null?void 0:mt.version,metadata:it.metadata})}else it._type===3?ct.edits.push({_type:3,metadata:it.metadata,resource:it.uri,edit:it.edit,notebookMetadata:it.notebookMetadata,notebookVersionId:(Ge=Le==null?void 0:Le.getNotebookDocument(it.uri,!0))===null||Ge===void 0?void 0:Ge.apiNotebook.version}):it._type===4?(it.newOutputs&&ct.edits.push({_type:3,metadata:it.metadata,resource:it.uri,edit:{editType:2,index:it.index,append:it.append,outputs:it.newOutputs.map(ue.from)}}),it.newMetadata&&ct.edits.push({_type:3,metadata:it.metadata,resource:it.uri,edit:{editType:8,index:it.index,metadata:it.newMetadata}})):it._type===5?ct.edits.push({_type:3,metadata:it.metadata,resource:it.uri,notebookVersionId:(Je=Le==null?void 0:Le.getNotebookDocument(it.uri,!0))===null||Je===void 0?void 0:Je.apiNotebook.version,edit:{editType:1,index:it.index,count:it.count,cells:it.cells.map(H.from)}}):it._type===6&&ct.edits.push({_type:3,metadata:it.metadata,resource:it.uri,edit:{editType:7,outputId:it.outputId,items:((lt=it.newOutputItems)===null||lt===void 0?void 0:lt.map(ee.from))||[],append:it.append}});return ct}Ee.from=De;function de(G){const Ue=new f.WorkspaceEdit;for(const Le of G.edits)Le.edit?Ue.replace(D.URI.revive(Le.resource),w.to(Le.edit.range),Le.edit.text):Ue.renameFile(D.URI.revive(Le.oldUri),D.URI.revive(Le.newUri),Le.options);return Ue}Ee.to=de})(J=e.WorkspaceEdit||(e.WorkspaceEdit={}));var oe;(function(Ee){const De=Object.create(null);De[f.SymbolKind.File]=0,De[f.SymbolKind.Module]=1,De[f.SymbolKind.Namespace]=2,De[f.SymbolKind.Package]=3,De[f.SymbolKind.Class]=4,De[f.SymbolKind.Method]=5,De[f.SymbolKind.Property]=6,De[f.SymbolKind.Field]=7,De[f.SymbolKind.Constructor]=8,De[f.SymbolKind.Enum]=9,De[f.SymbolKind.Interface]=10,De[f.SymbolKind.Function]=11,De[f.SymbolKind.Variable]=12,De[f.SymbolKind.Constant]=13,De[f.SymbolKind.String]=14,De[f.SymbolKind.Number]=15,De[f.SymbolKind.Boolean]=16,De[f.SymbolKind.Array]=17,De[f.SymbolKind.Object]=18,De[f.SymbolKind.Key]=19,De[f.SymbolKind.Null]=20,De[f.SymbolKind.EnumMember]=21,De[f.SymbolKind.Struct]=22,De[f.SymbolKind.Event]=23,De[f.SymbolKind.Operator]=24,De[f.SymbolKind.TypeParameter]=25;function de(Ue){return typeof De[Ue]=="number"?De[Ue]:6}Ee.from=de;function G(Ue){for(const Le in De)if(De[Le]===Ue)return Number(Le);return f.SymbolKind.Property}Ee.to=G})(oe=e.SymbolKind||(e.SymbolKind={}));var q;(function(Ee){function De(G){switch(G){case f.SymbolTag.Deprecated:return 1}}Ee.from=De;function de(G){switch(G){case 1:return f.SymbolTag.Deprecated}}Ee.to=de})(q=e.SymbolTag||(e.SymbolTag={}));var x;(function(Ee){function De(G){return{name:G.name,kind:oe.from(G.kind),tags:G.tags&&G.tags.map(q.from),containerName:G.containerName,location:M.from(G.location)}}Ee.from=De;function de(G){const Ue=new f.SymbolInformation(G.name,oe.to(G.kind),G.containerName,M.to(G.location));return Ue.tags=G.tags&&G.tags.map(q.to),Ue}Ee.to=de})(x=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var V;(function(Ee){function De(G){var Ue,Le;const Ge={name:G.name||"!!MISSING: name!!",detail:G.detail,range:w.from(G.range),selectionRange:w.from(G.selectionRange),kind:oe.from(G.kind),tags:(Le=(Ue=G.tags)===null||Ue===void 0?void 0:Ue.map(q.from))!==null&&Le!==void 0?Le:[]};return G.children&&(Ge.children=G.children.map(De)),Ge}Ee.from=De;function de(G){const Ue=new f.DocumentSymbol(G.name,G.detail,oe.to(G.kind),w.to(G.range),w.to(G.selectionRange));return v.isNonEmptyArray(G.tags)&&(Ue.tags=G.tags.map(q.to)),G.children&&(Ue.children=G.children.map(de)),Ue}Ee.to=de})(V=e.DocumentSymbol||(e.DocumentSymbol={}));var T;(function(Ee){function De(de){const G=new f.CallHierarchyItem(oe.to(de.kind),de.name,de.detail||"",D.URI.revive(de.uri),w.to(de.range),w.to(de.selectionRange));return G._sessionId=de._sessionId,G._itemId=de._itemId,G}Ee.to=De})(T=e.CallHierarchyItem||(e.CallHierarchyItem={}));var N;(function(Ee){function De(de){return new f.CallHierarchyIncomingCall(T.to(de.from),de.fromRanges.map(G=>w.to(G)))}Ee.to=De})(N=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var F;(function(Ee){function De(de){return new f.CallHierarchyOutgoingCall(T.to(de.to),de.fromRanges.map(G=>w.to(G)))}Ee.to=De})(F=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var M;(function(Ee){function De(G){return{range:G.range&&w.from(G.range),uri:G.uri}}Ee.from=De;function de(G){return new f.Location(D.URI.revive(G.uri),w.to(G.range))}Ee.to=de})(M=e.location||(e.location={}));var U;(function(Ee){function De(G){const Ue=G,Le=G;return{originSelectionRange:Ue.originSelectionRange?w.from(Ue.originSelectionRange):void 0,uri:Ue.targetUri?Ue.targetUri:Le.uri,range:w.from(Ue.targetRange?Ue.targetRange:Le.range),targetSelectionRange:Ue.targetSelectionRange?w.from(Ue.targetSelectionRange):void 0}}Ee.from=De;function de(G){return{targetUri:D.URI.revive(G.uri),targetRange:w.to(G.range),targetSelectionRange:G.targetSelectionRange?w.to(G.targetSelectionRange):void 0,originSelectionRange:G.originSelectionRange?w.to(G.originSelectionRange):void 0}}Ee.to=de})(U=e.DefinitionLink||(e.DefinitionLink={}));var B;(function(Ee){function De(G){return{range:w.from(G.range),contents:p.fromMany(G.contents)}}Ee.from=De;function de(G){return new f.Hover(G.contents.map(p.to),w.to(G.range))}Ee.to=de})(B=e.Hover||(e.Hover={}));var K;(function(Ee){function De(G){return{range:w.from(G.range),expression:G.expression}}Ee.from=De;function de(G){return new f.EvaluatableExpression(w.to(G.range),G.expression)}Ee.to=de})(K=e.EvaluatableExpression||(e.EvaluatableExpression={}));var ie;(function(Ee){function De(G){if(G instanceof f.InlineValueText)return{type:"text",range:w.from(G.range),text:G.text};if(G instanceof f.InlineValueVariableLookup)return{type:"variable",range:w.from(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};if(G instanceof f.InlineValueEvaluatableExpression)return{type:"expression",range:w.from(G.range),expression:G.expression};throw new Error("Unknown 'InlineValue' type")}Ee.from=De;function de(G){switch(G.type){case"text":return{range:w.to(G.range),text:G.text};case"variable":return{range:w.to(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};case"expression":return{range:w.to(G.range),expression:G.expression}}}Ee.to=de})(ie=e.InlineValue||(e.InlineValue={}));var we;(function(Ee){function De(G){return{frameId:G.frameId,stoppedLocation:w.from(G.stoppedLocation)}}Ee.from=De;function de(G){return new f.InlineValueContext(G.frameId,w.to(G.stoppedLocation))}Ee.to=de})(we=e.InlineValueContext||(e.InlineValueContext={}));var Te;(function(Ee){function De(G){return{range:w.from(G.range),kind:G.kind}}Ee.from=De;function de(G){return new f.DocumentHighlight(w.to(G.range),G.kind)}Ee.to=de})(Te=e.DocumentHighlight||(e.DocumentHighlight={}));var ye;(function(Ee){function De(de){switch(de){case 1:return f.CompletionTriggerKind.TriggerCharacter;case 2:return f.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return f.CompletionTriggerKind.Invoke}}Ee.to=De})(ye=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Oe;(function(Ee){function De(de){return{triggerKind:ye.to(de.triggerKind),triggerCharacter:de.triggerCharacter}}Ee.to=De})(Oe=e.CompletionContext||(e.CompletionContext={}));var je;(function(Ee){function De(G){switch(G){case f.CompletionItemTag.Deprecated:return 1}}Ee.from=De;function de(G){switch(G){case 1:return f.CompletionItemTag.Deprecated}}Ee.to=de})(je=e.CompletionItemTag||(e.CompletionItemTag={}));var ze;(function(Ee){const De=new Map([[f.CompletionItemKind.Method,0],[f.CompletionItemKind.Function,1],[f.CompletionItemKind.Constructor,2],[f.CompletionItemKind.Field,3],[f.CompletionItemKind.Variable,4],[f.CompletionItemKind.Class,5],[f.CompletionItemKind.Interface,7],[f.CompletionItemKind.Struct,6],[f.CompletionItemKind.Module,8],[f.CompletionItemKind.Property,9],[f.CompletionItemKind.Unit,12],[f.CompletionItemKind.Value,13],[f.CompletionItemKind.Constant,14],[f.CompletionItemKind.Enum,15],[f.CompletionItemKind.EnumMember,16],[f.CompletionItemKind.Keyword,17],[f.CompletionItemKind.Snippet,27],[f.CompletionItemKind.Text,18],[f.CompletionItemKind.Color,19],[f.CompletionItemKind.File,20],[f.CompletionItemKind.Reference,21],[f.CompletionItemKind.Folder,23],[f.CompletionItemKind.Event,10],[f.CompletionItemKind.Operator,11],[f.CompletionItemKind.TypeParameter,24],[f.CompletionItemKind.Issue,26],[f.CompletionItemKind.User,25]]);function de(Le){var Ge;return(Ge=De.get(Le))!==null&&Ge!==void 0?Ge:9}Ee.from=de;const G=new Map([[0,f.CompletionItemKind.Method],[1,f.CompletionItemKind.Function],[2,f.CompletionItemKind.Constructor],[3,f.CompletionItemKind.Field],[4,f.CompletionItemKind.Variable],[5,f.CompletionItemKind.Class],[7,f.CompletionItemKind.Interface],[6,f.CompletionItemKind.Struct],[8,f.CompletionItemKind.Module],[9,f.CompletionItemKind.Property],[12,f.CompletionItemKind.Unit],[13,f.CompletionItemKind.Value],[14,f.CompletionItemKind.Constant],[15,f.CompletionItemKind.Enum],[16,f.CompletionItemKind.EnumMember],[17,f.CompletionItemKind.Keyword],[27,f.CompletionItemKind.Snippet],[18,f.CompletionItemKind.Text],[19,f.CompletionItemKind.Color],[20,f.CompletionItemKind.File],[21,f.CompletionItemKind.Reference],[23,f.CompletionItemKind.Folder],[10,f.CompletionItemKind.Event],[11,f.CompletionItemKind.Operator],[24,f.CompletionItemKind.TypeParameter],[25,f.CompletionItemKind.User],[26,f.CompletionItemKind.Issue]]);function Ue(Le){var Ge;return(Ge=G.get(Le))!==null&&Ge!==void 0?Ge:f.CompletionItemKind.Property}Ee.to=Ue})(ze=e.CompletionItemKind||(e.CompletionItemKind={}));var qe;(function(Ee){function De(de,G){var Ue;const Le=new f.CompletionItem(typeof de.label=="string"?de.label:de.label.name);return typeof de.label!="string"&&(Le.label2=de.label),Le.insertText=de.insertText,Le.kind=ze.to(de.kind),Le.tags=(Ue=de.tags)===null||Ue===void 0?void 0:Ue.map(je.to),Le.detail=de.detail,Le.documentation=R.isMarkdownString(de.documentation)?p.to(de.documentation):de.documentation,Le.sortText=de.sortText,Le.filterText=de.filterText,Le.preselect=de.preselect,Le.commitCharacters=de.commitCharacters,P.Range.isIRange(de.range)?Le.range=w.to(de.range):typeof de.range=="object"&&(Le.range={inserting:w.to(de.range.insert),replacing:w.to(de.range.replace)}),Le.keepWhitespace=typeof de.insertTextRules=="undefined"?!1:Boolean(de.insertTextRules&1),typeof de.insertTextRules!="undefined"&&de.insertTextRules&4?Le.insertText=new f.SnippetString(de.insertText):(Le.insertText=de.insertText,Le.textEdit=Le.range instanceof f.Range?new f.TextEdit(Le.range,Le.insertText):void 0),de.additionalTextEdits&&de.additionalTextEdits.length>0&&(Le.additionalTextEdits=de.additionalTextEdits.map(Ge=>W.to(Ge))),Le.command=G&&de.command?G.fromInternal(de.command):void 0,Le}Ee.to=De})(qe=e.CompletionItem||(e.CompletionItem={}));var j;(function(Ee){function De(G){return{label:G.label,documentation:G.documentation?p.fromStrict(G.documentation):void 0}}Ee.from=De;function de(G){return{label:G.label,documentation:R.isMarkdownString(G.documentation)?p.to(G.documentation):G.documentation}}Ee.to=de})(j=e.ParameterInformation||(e.ParameterInformation={}));var Z;(function(Ee){function De(G){return{label:G.label,documentation:G.documentation?p.fromStrict(G.documentation):void 0,parameters:Array.isArray(G.parameters)?G.parameters.map(j.from):[],activeParameter:G.activeParameter}}Ee.from=De;function de(G){return{label:G.label,documentation:R.isMarkdownString(G.documentation)?p.to(G.documentation):G.documentation,parameters:Array.isArray(G.parameters)?G.parameters.map(j.to):[],activeParameter:G.activeParameter}}Ee.to=de})(Z=e.SignatureInformation||(e.SignatureInformation={}));var ne;(function(Ee){function De(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(Z.from):[]}}Ee.from=De;function de(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(Z.to):[]}}Ee.to=de})(ne=e.SignatureHelp||(e.SignatureHelp={}));var ae;(function(Ee){function De(G){var Ue;return{text:G.text,position:u.from(G.position),kind:Y.from((Ue=G.kind)!==null&&Ue!==void 0?Ue:f.InlayHintKind.Other),whitespaceBefore:G.whitespaceBefore,whitespaceAfter:G.whitespaceAfter}}Ee.from=De;function de(G){const Ue=new f.InlayHint(G.text,u.to(G.position),Y.to(G.kind));return Ue.whitespaceAfter=G.whitespaceAfter,Ue.whitespaceBefore=G.whitespaceBefore,Ue}Ee.to=de})(ae=e.InlayHint||(e.InlayHint={}));var Y;(function(Ee){function De(G){return G}Ee.from=De;function de(G){return G}Ee.to=de})(Y=e.InlayHintKind||(e.InlayHintKind={}));var ce;(function(Ee){function De(G){return{range:w.from(G.range),url:G.target,tooltip:G.tooltip}}Ee.from=De;function de(G){let Ue;if(G.url)try{Ue=typeof G.url=="string"?D.URI.parse(G.url,!0):D.URI.revive(G.url)}catch(Le){}return new f.DocumentLink(w.to(G.range),Ue)}Ee.to=de})(ce=e.DocumentLink||(e.DocumentLink={}));var me;(function(Ee){function De(G){const Ue=new f.ColorPresentation(G.label);return G.textEdit&&(Ue.textEdit=W.to(G.textEdit)),G.additionalTextEdits&&(Ue.additionalTextEdits=G.additionalTextEdits.map(Le=>W.to(Le))),Ue}Ee.to=De;function de(G){return{label:G.label,textEdit:G.textEdit?W.from(G.textEdit):void 0,additionalTextEdits:G.additionalTextEdits?G.additionalTextEdits.map(Ue=>W.from(Ue)):void 0}}Ee.from=de})(me=e.ColorPresentation||(e.ColorPresentation={}));var Re;(function(Ee){function De(G){return new f.Color(G[0],G[1],G[2],G[3])}Ee.to=De;function de(G){return[G.red,G.green,G.blue,G.alpha]}Ee.from=de})(Re=e.Color||(e.Color={}));var He;(function(Ee){function De(G){return{range:w.from(G.range)}}Ee.from=De;function de(G){return new f.SelectionRange(w.to(G.range))}Ee.to=de})(He=e.SelectionRange||(e.SelectionRange={}));var be;(function(Ee){function De(de){switch(de){case 2:return f.TextDocumentSaveReason.AfterDelay;case 1:return f.TextDocumentSaveReason.Manual;case 3:case 4:return f.TextDocumentSaveReason.FocusOut}}Ee.to=De})(be=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Xe;(function(Ee){function De(G){switch(G){case f.TextEditorLineNumbersStyle.Off:return 0;case f.TextEditorLineNumbersStyle.Relative:return 2;case f.TextEditorLineNumbersStyle.On:default:return 1}}Ee.from=De;function de(G){switch(G){case 0:return f.TextEditorLineNumbersStyle.Off;case 2:return f.TextEditorLineNumbersStyle.Relative;case 1:default:return f.TextEditorLineNumbersStyle.On}}Ee.to=de})(Xe=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Q;(function(Ee){function De(G){if(G===f.EndOfLine.CRLF)return 1;if(G===f.EndOfLine.LF)return 0}Ee.from=De;function de(G){if(G===1)return f.EndOfLine.CRLF;if(G===0)return f.EndOfLine.LF}Ee.to=de})(Q=e.EndOfLine||(e.EndOfLine={}));var re;(function(Ee){function De(de){if(typeof de=="object")return de.viewId;switch(de){case f.ProgressLocation.SourceControl:return 3;case f.ProgressLocation.Window:return 10;case f.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ee.from=De})(re=e.ProgressLocation||(e.ProgressLocation={}));var ve;(function(Ee){function De(de){const G={start:de.start+1,end:de.end+1};return de.kind&&(G.kind=Me.from(de.kind)),G}Ee.from=De})(ve=e.FoldingRange||(e.FoldingRange={}));var Me;(function(Ee){function De(de){if(de)switch(de){case f.FoldingRangeKind.Comment:return s.FoldingRangeKind.Comment;case f.FoldingRangeKind.Imports:return s.FoldingRangeKind.Imports;case f.FoldingRangeKind.Region:return s.FoldingRangeKind.Region}}Ee.from=De})(Me=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Ne;(function(Ee){function De(de){if(de)return{pinned:typeof de.preview=="boolean"?!de.preview:void 0,inactive:de.background,preserveFocus:de.preserveFocus,selection:typeof de.selection=="object"?w.from(de.selection):void 0,override:typeof de.override=="boolean"?I.EditorOverride.DISABLED:void 0}}Ee.from=De})(Ne=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Ye;(function(Ee){function De(G){return G instanceof f.RelativePattern||typeof G=="string"?G:de(G)?new f.RelativePattern(G.base,G.pattern):G}Ee.from=De;function de(G){const Ue=G;return Ue&&typeof Ue.base=="string"&&typeof Ue.pattern=="string"}})(Ye=e.GlobPattern||(e.GlobPattern={}));var Se;(function(Ee){function De(de){if(de){if(Array.isArray(de))return de.map(De);if(typeof de=="string")return de;{const G=de;return{language:G.language,scheme:G.scheme,pattern:typeof G.pattern=="undefined"?void 0:Ye.from(G.pattern),exclusive:G.exclusive}}}else return}Ee.from=De})(Se=e.LanguageSelector||(e.LanguageSelector={}));var _e;(function(Ee){function De(G){return{start:G.start,end:G.end}}Ee.from=De;function de(G){return new f.NotebookRange(G.start,G.end)}Ee.to=de})(_e=e.NotebookRange||(e.NotebookRange={}));var ke;(function(Ee){function De(G){return{timing:typeof G.runStartTime=="number"&&typeof G.runEndTime=="number"?{startTime:G.runStartTime,endTime:G.runEndTime}:void 0,executionOrder:G.executionOrder,success:G.lastRunSuccess}}Ee.to=De;function de(G){var Ue,Le;return{lastRunSuccess:G.success,runStartTime:(Ue=G.timing)===null||Ue===void 0?void 0:Ue.startTime,runEndTime:(Le=G.timing)===null||Le===void 0?void 0:Le.endTime,executionOrder:G.executionOrder}}Ee.from=de})(ke=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var le;(function(Ee){function De(G){switch(G){case f.NotebookCellKind.Markup:return g.CellKind.Markup;case f.NotebookCellKind.Code:default:return g.CellKind.Code}}Ee.from=De;function de(G){switch(G){case g.CellKind.Markup:return f.NotebookCellKind.Markup;case g.CellKind.Code:default:return f.NotebookCellKind.Code}}Ee.to=de})(le=e.NotebookCellKind||(e.NotebookCellKind={}));var fe;(function(Ee){function De(G){var Ue;const Le={metadata:(Ue=G.metadata)!==null&&Ue!==void 0?Ue:Object.create(null),cells:[]};for(let Ge of G.cells)f.NotebookCellData.validate(Ge),Le.cells.push(H.from(Ge));return Le}Ee.from=De;function de(G){const Ue=new f.NotebookData(G.cells.map(H.to));return C.isEmptyObject(G.metadata)||(Ue.metadata=G.metadata),Ue}Ee.to=de})(fe=e.NotebookData||(e.NotebookData={}));var H;(function(Ee){function De(G){var Ue;return{cellKind:le.from(G.kind),language:G.languageId,source:G.value,metadata:G.metadata,internalMetadata:ke.from((Ue=G.executionSummary)!==null&&Ue!==void 0?Ue:{}),outputs:G.outputs?G.outputs.map(ue.from):[]}}Ee.from=De;function de(G){return new f.NotebookCellData(le.to(G.cellKind),G.source,G.language,G.outputs?G.outputs.map(ue.to):void 0,G.metadata,G.internalMetadata?ke.to(G.internalMetadata):void 0)}Ee.to=de})(H=e.NotebookCellData||(e.NotebookCellData={}));var ee;(function(Ee){function De(G){return{mime:G.mime,valueBytes:Array.from(G.data)}}Ee.from=De;function de(G){return new f.NotebookCellOutputItem(new Uint8Array(G.valueBytes),G.mime)}Ee.to=de})(ee=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var ue;(function(Ee){function De(G){return{outputId:G.id,outputs:G.items.map(ee.from),metadata:G.metadata}}Ee.from=De;function de(G){const Ue=G.outputs.map(ee.to);return new f.NotebookCellOutput(Ue,G.outputId,G.metadata)}Ee.to=de})(ue=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Pe;(function(Ee){function De(Le){if(Le!=null){if(Le instanceof f.RelativePattern||typeof Le=="string")return Le;if(Ue(Le))return new f.RelativePattern(Le.base,Le.pattern);if(G(Le))return{include:Ye.from(Le.include)||void 0,exclude:Ye.from(Le.exclude)||void 0}}}Ee.from=De;function de(Le){return typeof Le=="string"?Le:Ue(Le)?{base:Le.base,pattern:Le.pattern}:{include:Le.include,exclude:Le.exclude}}Ee.to=de;function G(Le){const Ge=Le,Je=Ye.from(Ge.include);if(!(Je&&Je instanceof f.RelativePattern||typeof Je=="string"))return!1;const lt=Ye.from(Ge.exclude);return!!(lt&&lt instanceof f.RelativePattern||typeof lt=="string")}function Ue(Le){const Ge=Le;return Ge&&typeof Ge.base=="string"&&typeof Ge.pattern=="string"}})(Pe=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Ae;(function(Ee){function De(de){return{backgroundColor:de.backgroundColor,borderColor:de.borderColor,top:de.top?S.from(de.top):void 0}}Ee.from=De})(Ae=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var xe;(function(Ee){function De(de,G,Ue){const Le=typeof de.command=="string"?{title:"",command:de.command}:de.command;return{alignment:de.alignment===f.NotebookCellStatusBarAlignment.Left?1:2,command:G.toInternal(Le,Ue),text:de.text,tooltip:de.tooltip,accessibilityInformation:de.accessibilityInformation,priority:de.priority}}Ee.from=De})(xe=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Be;(function(Ee){function De(de){var G,Ue,Le;return{transientOutputs:(G=de==null?void 0:de.transientOutputs)!==null&&G!==void 0?G:!1,transientCellMetadata:(Ue=de==null?void 0:de.transientCellMetadata)!==null&&Ue!==void 0?Ue:{},transientDocumentMetadata:(Le=de==null?void 0:de.transientDocumentMetadata)!==null&&Le!==void 0?Le:{}}}Ee.from=De})(Be=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Qe;(function(Ee){function De(G){return{uri:G.uri,provides:G.provides}}Ee.from=De;function de(G){return new f.NotebookRendererScript(D.URI.revive(G.uri),G.provides)}Ee.to=de})(Qe=e.NotebookRendererScript||(e.NotebookRendererScript={}));var rt;(function(Ee){function De(G){return{message:p.fromStrict(G.message)||"",severity:G.severity,expectedOutput:G.expectedOutput,actualOutput:G.actualOutput,location:G.location?M.from(G.location):void 0}}Ee.from=De;function de(G){const Ue=new f.TestMessage(typeof G.message=="string"?G.message:p.to(G.message));return Ue.severity=G.severity,Ue.actualOutput=G.actualOutput,Ue.expectedOutput=G.expectedOutput,Ue}Ee.to=de})(rt=e.TestMessage||(e.TestMessage={}));var nt;(function(Ee){function De(Le){var Ge,Je;return{extId:Le.id,label:Le.label,uri:Le.uri,range:w.from(Le.range)||null,debuggable:(Ge=Le.debuggable)!==null&&Ge!==void 0?Ge:!1,description:Le.description||null,runnable:(Je=Le.runnable)!==null&&Je!==void 0?Je:!0,error:Le.error&&p.fromStrict(Le.error)||null}}Ee.from=De;function de(Le){return{extId:Le.id,label:Le.label,uri:Le.uri,range:w.from(Le.range)||null,debuggable:!1,description:Le.description||null,error:null,runnable:!0}}Ee.fromResultSnapshot=de;function G(Le){return{id:Le.extId,label:Le.label,uri:D.URI.revive(Le.uri),range:w.to(Le.range||void 0),addChild:()=>{},dispose:()=>{},status:f.TestItemStatus.Pending,data:void 0,debuggable:Le.debuggable,description:Le.description||void 0,runnable:Le.runnable}}Ee.toPlain=G;function Ue(Le){const Ge=new f.TestItemImpl(Le.extId,Le.label,D.URI.revive(Le.uri),void 0);return Ge.range=w.to(Le.range||void 0),Ge.debuggable=Le.debuggable,Ge.description=Le.description||void 0,Ge.runnable=Le.runnable,Ge}Ee.to=Ue})(nt=e.TestItem||(e.TestItem={}));var Ze;(function(Ee){const De=(G,Ue)=>Object.assign(Object.assign({},nt.toPlain(G.item)),{taskStates:G.tasks.map(Le=>({state:Le.state,duration:Le.duration,messages:Le.messages.map(rt.to)})),children:G.children.map(Le=>Ue.get(Le)).filter(C.isDefined).map(Le=>De(Le,Ue))});function de(G){const Ue=[],Le=new Map;for(const Ge of G.items)Le.set(Ge.item.extId,Ge),Ge.direct&&Ue.push(Ge);return{completedAt:G.completedAt,results:Ue.map(Ge=>De(Ge,Le))}}Ee.to=de})(Ze=e.TestResults||(e.TestResults={}));var ot;(function(Ee){function De(de){switch(de){case 1:return f.CodeActionTriggerKind.Invoke;case 2:return f.CodeActionTriggerKind.Automatic}}Ee.to=De})(ot=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}))}),define(ge[203],pe([0,1,2,16,7,18,72]),function(X,e,v,R,k,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class C{constructor(P,s,I,l={timeout:1500,errors:3}){this._logService=P,this._documents=s,this._mainThreadBulkEdits=I,this._thresholds=l,this._callbacks=new A.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(P){return(s,I,l)=>{const c={dispose:this._callbacks.push([s,I,P])};return Array.isArray(l)&&l.push(c),c}}async $participateInSave(P,s){const I=v.URI.revive(P);let l=!1;const g=setTimeout(()=>l=!0,this._thresholds.timeout),c=[];try{for(let f of[...this._callbacks]){if(l)break;const _=this._documents.getDocument(I),w=await this._deliverEventAsyncAndBlameBadListeners(f,{document:_,reason:y.TextDocumentSaveReason.to(s)});c.push(w)}}finally{clearTimeout(g)}return c}_deliverEventAsyncAndBlameBadListeners([P,s,I],l){const g=this._badListeners.get(P);return typeof g=="number"&&g>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(I,P,s,l).then(()=>!0,c=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' threw ERROR`),this._logService.error(c),!(c instanceof Error)||c.message!=="concurrent_edits"){const f=this._badListeners.get(P);this._badListeners.set(P,f?f+1:1),typeof f=="number"&&f>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(P,s,I,l){const g=[],c=Date.now(),{document:f,reason:_}=l,{version:w}=f,E=Object.freeze({document:f,reason:_,waitUntil(u){if(Object.isFrozen(g))throw R.illegalState("waitUntil can not be called async");g.push(Promise.resolve(u))}});try{s.apply(I,[E])}catch(u){return Promise.reject(u)}return Object.freeze(g),new Promise((u,h)=>{const m=setTimeout(()=>h(new Error("timeout")),this._thresholds.timeout);return Promise.all(g).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' finished after ${Date.now()-c}ms`),clearTimeout(m),u(t)}).catch(t=>{clearTimeout(m),h(t)})}).then(u=>{const h={edits:[]};for(const m of u)if(Array.isArray(m)&&m.every(t=>t instanceof k.TextEdit))for(const{newText:t,newEol:r,range:i}of m)h.edits.push({_type:2,resource:f.uri,edit:{range:i&&y.Range.from(i),text:t,eol:r&&y.EndOfLine.from(r)}});if(h.edits.length!==0)return w===f.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(h):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=C}),define(ge[204],pe([0,1,3,14,30,2,18,7]),function(X,e,v,R,k,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class D{constructor(I,l,g,c,f){this._onDidCreate=new v.Emitter,this._onDidChange=new v.Emitter,this._onDidDelete=new v.Emitter,this._config=0,g&&(this._config+=1),c&&(this._config+=2),f&&(this._config+=4);const _=k.parse(l),w=I(E=>{if(!g)for(let u of E.created){const h=y.URI.revive(u);_(h.fsPath)&&this._onDidCreate.fire(h)}if(!c)for(let u of E.changed){const h=y.URI.revive(u);_(h.fsPath)&&this._onDidChange.fire(h)}if(!f)for(let u of E.deleted){const h=y.URI.revive(u);_(h.fsPath)&&this._onDidDelete.fire(h)}});this._disposable=C.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,w)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class P{constructor(I,l,g){this._logService=l,this._extHostDocumentsAndEditors=g,this._onFileSystemEvent=new v.Emitter,this._onDidRenameFile=new v.Emitter,this._onDidCreateFile=new v.Emitter,this._onDidDeleteFile=new v.Emitter,this._onWillRenameFile=new R.AsyncEmitter,this._onWillCreateFile=new R.AsyncEmitter,this._onWillDeleteFile=new R.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(I,l,g,c){return new D(this._onFileSystemEvent.event,I,l,g,c)}$onFileEvent(I){this._onFileSystemEvent.fire(I)}$onDidRunFileOperation(I,l){switch(I){case 2:this._onDidRenameFile.fire(Object.freeze({files:l.map(g=>({oldUri:y.URI.revive(g.source),newUri:y.URI.revive(g.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:l.map(g=>y.URI.revive(g.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:l.map(g=>y.URI.revive(g.target))}));break;default:}}getOnWillRenameFileEvent(I){return this._createWillExecuteEvent(I,this._onWillRenameFile)}getOnWillCreateFileEvent(I){return this._createWillExecuteEvent(I,this._onWillCreateFile)}getOnWillDeleteFileEvent(I){return this._createWillExecuteEvent(I,this._onWillDeleteFile)}_createWillExecuteEvent(I,l){return(g,c,f)=>{const _=function(E){g.call(c,E)};return _.extension=I,l.event(_,void 0,f)}}async $onWillRunFileOperation(I,l,g,c){switch(I){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:l.map(f=>({oldUri:y.URI.revive(f.source),newUri:y.URI.revive(f.target)}))},g,c);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:l.map(f=>y.URI.revive(f.target))},g,c);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:l.map(f=>y.URI.revive(f.target))},g,c)}}async _fireWillEvent(I,l,g,c){const f=new Set,_=[];if(await I.fireAsync(l,c,async(E,u)=>{var h;const m=Date.now(),t=await Promise.resolve(E);t instanceof C.WorkspaceEdit&&(_.push(t),f.add((h=u.extension.displayName)!==null&&h!==void 0?h:u.extension.identifier.value)),Date.now()-m>g&&this._logService.warn("SLOW file-participant",u.extension.identifier)}),c.isCancellationRequested||_.length===0)return;const w={edits:[]};for(let E of _){let{edits:u}=A.WorkspaceEdit.from(E,this._extHostDocumentsAndEditors);w.edits=w.edits.concat(u)}return{edit:w,extensionNames:Array.from(f)}}}e.ExtHostFileSystemEventService=P}),define(ge[205],pe([0,1,10,25,2,18,7,60]),function(X,e,v,R,k,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class D{constructor(l,g,c,f){this.start=l,this.deletedCount=g,this.deletedItems=c,this.items=f}static asApiEvents(l){return l.map(g=>({start:g.start,deletedCount:g.deletedCount,deletedItems:g.deletedItems,items:g.items.map(c=>c.apiCell)}))}}class P{constructor(l,g,c){var f,_,w;this.notebook=l,this._extHostDocument=g,this._cellData=c,this.handle=c.handle,this.uri=k.URI.revive(c.uri),this.cellKind=c.cellKind,this._outputs=c.outputs.map(y.NotebookCellOutput.to),this._internalMetadata=(f=c.internalMetadata)!==null&&f!==void 0?f:{},this._metadata=(_=c.metadata)!==null&&_!==void 0?_:{},this._previousResult=y.NotebookCellExecutionSummary.to((w=c.internalMetadata)!==null&&w!==void 0?w:{})}static asModelAddData(l,g){return{EOL:g.eol,lines:g.source,modeId:g.language,uri:g.uri,isDirty:!1,versionId:1,notebook:l}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const l=this,g=this._extHostDocument.getDocument(this.uri);if(!g)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return l.notebook.getCellIndex(l)},notebook:l.notebook.apiNotebook,kind:y.NotebookCellKind.to(this._cellData.cellKind),document:g.document,get outputs(){return l._outputs.slice(0)},get metadata(){return l._metadata},get executionSummary(){return l._previousResult}})}return this._apiCell}setOutputs(l){this._outputs=l.map(y.NotebookCellOutput.to)}setOutputItems(l,g,c){const f=c.map(y.NotebookCellOutputItem.to),_=this._outputs.find(w=>w.id===l);_&&(g||(_.items.length=0),_.items.push(...f))}setMetadata(l){this._metadata=l}setInternalMetadata(l){this._internalMetadata=l,this._previousResult=y.NotebookCellExecutionSummary.to(l)}}e.ExtHostCell=P;class s{constructor(l,g,c,f,_,w,E){this._proxy=l,this._textDocumentsAndEditors=g,this._textDocuments=c,this._emitter=f,this._notebookType=_,this._metadata=w,this.uri=E,this.handle=s._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const l=this;this._notebook={get uri(){return l.uri},get version(){return l._versionId},get notebookType(){return l._notebookType},get isDirty(){return l._isDirty},get isUntitled(){return l.uri.scheme===v.Schemas.untitled},get isClosed(){return l._disposed},get metadata(){return l._metadata},get cellCount(){return l._cells.length},cellAt(g){return g=l._validateIndex(g),l._cells[g].apiCell},getCells(g){return(g?l._getCells(g):l._cells).map(f=>f.apiCell)},save(){return l._save()}}}return this._notebook}updateBackup(l){var g;(g=this._backup)===null||g===void 0||g.delete(),this._backup=l}disposeBackup(){var l;(l=this._backup)===null||l===void 0||l.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(l){l.metadata&&(this._metadata=Object.assign(Object.assign({},this._metadata),l.metadata))}acceptModelChanged(l,g){this._versionId=l.versionId,this._isDirty=g;for(const c of l.rawEvents)c.kind===C.NotebookCellsChangeType.Initialize&&this._spliceNotebookCells(c.changes,!0),c.kind===C.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(c.changes,!1):c.kind===C.NotebookCellsChangeType.Move?this._moveCell(c.index,c.newIdx):c.kind===C.NotebookCellsChangeType.Output?this._setCellOutputs(c.index,c.outputs):c.kind===C.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(c.index,c.outputId,c.append,c.outputItems):c.kind===C.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(c.index,c.language):c.kind===C.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(c.index,c.metadata):c.kind===C.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(c.index,c.internalMetadata)}_validateIndex(l){return l=l|0,l<0?0:l>=this._cells.length?this._cells.length-1:l}_validateRange(l){let g=l.start|0,c=l.end|0;return g<0&&(g=0),c>this._cells.length&&(c=this._cells.length),l.with({start:g,end:c})}_getCells(l){l=this._validateRange(l);const g=[];for(let c=l.start;c<l.end;c++)g.push(this._cells[c]);return g}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(l,g){if(this._disposed)return;const c=[],f=[],_=[];l.reverse().forEach(w=>{const u=w[2].map(t=>{const r=new P(this,this._textDocumentsAndEditors,t);return g||f.push(P.asModelAddData(this.apiNotebook,t)),r}),h=new D(w[0],w[1],[],u),m=this._cells.splice(w[0],w[1],...u);for(const t of m)_.push(t.uri),h.deletedItems.push(t.apiCell);c.push(h)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:f,removedDocuments:_}),g||this._emitter.emitModelChange(R.deepFreeze({document:this.apiNotebook,changes:D.asApiEvents(c)}))}_moveCell(l,g){const c=this._cells.splice(l,1);this._cells.splice(g,0,...c);const f=[new D(l,1,c.map(_=>_.apiCell),[]),new D(g,0,[],c)];this._emitter.emitModelChange(R.deepFreeze({document:this.apiNotebook,changes:D.asApiEvents(f)}))}_setCellOutputs(l,g){const c=this._cells[l];c.setOutputs(g),this._emitter.emitCellOutputsChange(R.deepFreeze({document:this.apiNotebook,cells:[c.apiCell]}))}_setCellOutputItems(l,g,c,f){const _=this._cells[l];_.setOutputItems(g,c,f),this._emitter.emitCellOutputsChange(R.deepFreeze({document:this.apiNotebook,cells:[_.apiCell]}))}_changeCellLanguage(l,g){const c=this._cells[l];c.apiCell.document.languageId!==g&&this._textDocuments.$acceptModelModeChanged(c.uri,g)}_changeCellMetadata(l,g){const c=this._cells[l],f=c.apiCell.metadata;c.setMetadata(g);const _=c.apiCell.metadata;R.equals(f,_)||this._emitter.emitCellMetadataChange(R.deepFreeze({document:this.apiNotebook,cell:c.apiCell}))}_changeCellInternalMetadata(l,g){var c;const f=this._cells[l],_=f.internalMetadata;if(f.setInternalMetadata(g),_.runState!==g.runState){const w=(c=g.runState)!==null&&c!==void 0?c:A.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange(R.deepFreeze({document:this.apiNotebook,cell:f.apiCell,state:w}))}}getCellFromApiCell(l){return this._cells.find(g=>g.apiCell===l)}getCellFromIndex(l){return this._cells[l]}getCell(l){return this._cells.find(g=>g.handle===l)}getCellIndex(l){return this._cells.indexOf(l)}}e.ExtHostNotebookDocument=s,s._handlePool=0}),define(ge[122],pe([0,1,7,18]),function(X,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class k{constructor(C){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=C}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(C){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:C})}replaceCellMetadata(C,D){this._throwIfFinalized(),this._collectedEdits.push({editType:3,index:C,metadata:D})}replaceCells(C,D,P){this._throwIfFinalized(),!(C===D&&P.length===0)&&this._collectedEdits.push({editType:1,index:C,count:D-C,cells:P.map(R.NotebookCellData.from)})}}class y{constructor(C,D,P,s,I,l){this.id=C,this._proxy=D,this.notebookData=P,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=I,this._visibleRanges=s,this._viewColumn=l}get apiEditor(){if(!this._editor){const C=this;this._editor={get document(){return C.notebookData.apiNotebook},get selections(){return C._selections},get visibleRanges(){return C._visibleRanges},revealRange(D,P){C._proxy.$tryRevealRange(C.id,R.NotebookRange.from(D),P??v.NotebookEditorRevealType.Default)},get viewColumn(){return C._viewColumn},edit(D){const P=new k(this.document.version);return D(P),C._applyEdit(P.finalize())},setDecorations(D,P){return C.setDecorations(D,P)}},y.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(C){this._visible=C}_acceptVisibleRanges(C){this._visibleRanges=C}_acceptSelections(C){this._selections=C}_acceptViewColumn(C){this._viewColumn=C}_applyEdit(C){if(C.cellEdits.length===0)return Promise.resolve(!0);const D=[];let P=-1;for(let s=0;s<C.cellEdits.length;s++){if(P<0){D.push(C.cellEdits[s]),P++;continue}const l=D[P],g=C.cellEdits[s];if(l.editType===1&&g.editType===1&&l.index===g.index){l.cells.push(...C.cellEdits[s].cells),l.count+=C.cellEdits[s].count;continue}D.push(C.cellEdits[s]),P++}return this._proxy.$tryApplyEdits(this.id,C.documentVersionId,D)}setDecorations(C,D){if(!(D.isEmpty&&!this._hasDecorationsForKey.has(C.key)))return D.isEmpty?this._hasDecorationsForKey.delete(C.key):this._hasDecorationsForKey.add(C.key),this._proxy.$trySetDecorations(this.id,R.NotebookRange.from(D),C.key)}}e.ExtHostNotebookEditor=y,y.apiEditorsToExtHost=new WeakMap}),define(ge[206],pe([0,1,18,114,160,21,50]),function(X,e,v,R,k,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class C{constructor(I){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=I}withProgress(I,l,g){const c=this._handles++,{title:f,location:_,cancellable:w}=l,E={label:k.localize(0,null,I.displayName||I.name),id:I.identifier.value};return this._proxy.$startProgress(c,{location:v.ProgressLocation.from(_),title:f,source:E,cancellable:w},I),this._withProgress(c,g,!!w)}_withProgress(I,l,g){let c;g&&(c=new y.CancellationTokenSource,this._mapHandleToCancellationSource.set(I,c));const f=w=>{this._proxy.$progressEnd(w),this._mapHandleToCancellationSource.delete(w),c&&c.dispose()};let _;try{_=l(new P(this._proxy,I),g&&c?c.token:y.CancellationToken.None)}catch(w){throw f(I),w}return _.then(w=>f(I),w=>f(I)),_}$acceptProgressCanceled(I){const l=this._mapHandleToCancellationSource.get(I);l&&(l.cancel(),this._mapHandleToCancellationSource.delete(I))}}e.ExtHostProgress=C;function D(s,I){return s.message=I.message,typeof I.increment=="number"&&(typeof s.increment=="number"?s.increment+=I.increment:s.increment=I.increment),s}class P extends R.Progress{constructor(I,l){super(g=>this.throttledReport(g));this._proxy=I,this._handle=l}throttledReport(I){this._proxy.$progressReport(this._handle,I)}}Ve([A.throttle(100,(s,I)=>D(s,I),()=>Object.create(null))],P.prototype,"throttledReport",null)}),define(ge[123],pe([0,1,49,16,70,18,7]),function(X,e,v,R,k,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class C{constructor(l,g,c){const f=C._Keys.nextId();l.$registerTextEditorDecorationType(g.identifier,f,y.DecorationRenderOptions.from(c)),this.value=Object.freeze({key:f,dispose(){l.$removeTextEditorDecorationType(f)}})}}e.TextEditorDecorationType=C,C._Keys=new k.IdGenerator("TextEditorDecorationType");class D{constructor(l,g){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=l,this._documentVersionId=l.version,this._undoStopBefore=g.undoStopBefore,this._undoStopAfter=g.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(l,g){this._throwIfFinalized();let c=null;if(l instanceof A.Position)c=new A.Range(l,l);else if(l instanceof A.Range)c=l;else throw new Error("Unrecognized location");this._pushEdit(c,g,!1)}insert(l,g){this._throwIfFinalized(),this._pushEdit(new A.Range(l,l),g,!0)}delete(l){this._throwIfFinalized();let g=null;if(l instanceof A.Range)g=l;else throw new Error("Unrecognized location");this._pushEdit(g,null,!0)}_pushEdit(l,g,c){const f=this._document.validateRange(l);this._collectedEdits.push({range:f,text:g,forceMoveMarkers:c})}setEndOfLine(l){if(this._throwIfFinalized(),l!==A.EndOfLine.LF&&l!==A.EndOfLine.CRLF)throw R.illegalArgument("endOfLine");this._setEndOfLine=l}}e.TextEditorEdit=D;class P{constructor(l,g,c,f){this._proxy=l,this._id=g,this._accept(c),this._logService=f;const _=this;this.value={get tabSize(){return _._tabSize},set tabSize(w){_._setTabSize(w)},get insertSpaces(){return _._insertSpaces},set insertSpaces(w){_._setInsertSpaces(w)},get cursorStyle(){return _._cursorStyle},set cursorStyle(w){_._setCursorStyle(w)},get lineNumbers(){return _._lineNumbers},set lineNumbers(w){_._setLineNumbers(w)}}}_accept(l){this._tabSize=l.tabSize,this._insertSpaces=l.insertSpaces,this._cursorStyle=l.cursorStyle,this._lineNumbers=y.TextEditorLineNumbersStyle.to(l.lineNumbers)}_validateTabSize(l){if(l==="auto")return"auto";if(typeof l=="number"){const g=Math.floor(l);return g>0?g:null}if(typeof l=="string"){const g=parseInt(l,10);return isNaN(g)?null:g>0?g:null}return null}_setTabSize(l){const g=this._validateTabSize(l);if(g!==null){if(typeof g=="number"){if(this._tabSize===g)return;this._tabSize=g}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:g}))}}_validateInsertSpaces(l){return l==="auto"?"auto":l==="false"?!1:Boolean(l)}_setInsertSpaces(l){const g=this._validateInsertSpaces(l);if(typeof g=="boolean"){if(this._insertSpaces===g)return;this._insertSpaces=g}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:g}))}_setCursorStyle(l){this._cursorStyle!==l&&(this._cursorStyle=l,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:l})))}_setLineNumbers(l){this._lineNumbers!==l&&(this._lineNumbers=l,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:y.TextEditorLineNumbersStyle.from(l)})))}assign(l){const g={};let c=!1;if(typeof l.tabSize!="undefined"){const f=this._validateTabSize(l.tabSize);f==="auto"?(c=!0,g.tabSize=f):typeof f=="number"&&this._tabSize!==f&&(this._tabSize=f,c=!0,g.tabSize=f)}if(typeof l.insertSpaces!="undefined"){const f=this._validateInsertSpaces(l.insertSpaces);f==="auto"?(c=!0,g.insertSpaces=f):this._insertSpaces!==f&&(this._insertSpaces=f,c=!0,g.insertSpaces=f)}typeof l.cursorStyle!="undefined"&&this._cursorStyle!==l.cursorStyle&&(this._cursorStyle=l.cursorStyle,c=!0,g.cursorStyle=l.cursorStyle),typeof l.lineNumbers!="undefined"&&this._lineNumbers!==l.lineNumbers&&(this._lineNumbers=l.lineNumbers,c=!0,g.lineNumbers=y.TextEditorLineNumbersStyle.from(l.lineNumbers)),c&&this._warnOnError(this._proxy.$trySetOptions(this._id,g))}_warnOnError(l){l.catch(g=>this._logService.warn(g))}}e.ExtHostTextEditorOptions=P;class s{constructor(l,g,c,f,_,w,E,u){this.id=l,this._proxy=g,this._logService=c,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=_,this._options=new P(this._proxy,this.id,w,c),this._visibleRanges=E,this._viewColumn=u;const h=this;this.value=Object.freeze({get document(){return f.getValue()},set document(m){throw R.readonly("document")},get selection(){return h._selections&&h._selections[0]},set selection(m){if(!(m instanceof A.Selection))throw R.illegalArgument("selection");h._selections=[m],h._trySetSelection()},get selections(){return h._selections},set selections(m){if(!Array.isArray(m)||m.some(t=>!(t instanceof A.Selection)))throw R.illegalArgument("selections");h._selections=m,h._trySetSelection()},get visibleRanges(){return h._visibleRanges},set visibleRanges(m){throw R.readonly("visibleRanges")},get options(){return h._options.value},set options(m){h._disposed||h._options.assign(m)},get viewColumn(){return h._viewColumn},set viewColumn(m){throw R.readonly("viewColumn")},edit(m,t={undoStopBefore:!0,undoStopAfter:!0}){if(h._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const r=new D(f.getValue(),t);return m(r),h._applyEdit(r)},insertSnippet(m,t,r={undoStopBefore:!0,undoStopAfter:!0}){if(h._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let i;if(!t||Array.isArray(t)&&t.length===0)i=h._selections.map(n=>y.Range.from(n));else if(t instanceof A.Position){const{lineNumber:n,column:a}=y.Position.from(t);i=[{startLineNumber:n,startColumn:a,endLineNumber:n,endColumn:a}]}else if(t instanceof A.Range)i=[y.Range.from(t)];else{i=[];for(const n of t)if(n instanceof A.Range)i.push(y.Range.from(n));else{const{lineNumber:a,column:p}=y.Position.from(n);i.push({startLineNumber:a,startColumn:p,endLineNumber:a,endColumn:p})}}return g.$tryInsertSnippet(l,m.value,i,r)},setDecorations(m,t){const r=t.length===0;r&&!h._hasDecorationsForKey.has(m.key)||(r?h._hasDecorationsForKey.delete(m.key):h._hasDecorationsForKey.add(m.key),h._runOnProxy(()=>{if(y.isDecorationOptionsArr(t))return g.$trySetDecorations(l,m.key,y.fromRangeOrRangeWithMessage(t));{const i=new Array(4*t.length);for(let n=0,a=t.length;n<a;n++){const p=t[n];i[4*n]=p.start.line+1,i[4*n+1]=p.start.character+1,i[4*n+2]=p.end.line+1,i[4*n+3]=p.end.character+1}return g.$trySetDecorationsFast(l,m.key,i)}}))},revealRange(m,t){h._runOnProxy(()=>g.$tryRevealRange(l,y.Range.from(m),t||A.TextEditorRevealType.Default))},show(m){g.$tryShowEditor(l,y.ViewColumn.from(m))},hide(){g.$tryHideEditor(l)}})}dispose(){v.ok(!this._disposed),this._disposed=!0}_acceptOptions(l){v.ok(!this._disposed),this._options._accept(l)}_acceptVisibleRanges(l){v.ok(!this._disposed),this._visibleRanges=l}_acceptViewColumn(l){v.ok(!this._disposed),this._viewColumn=l}_acceptSelections(l){v.ok(!this._disposed),this._selections=l}async _trySetSelection(){const l=this._selections.map(y.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,l)),this.value}_applyEdit(l){const g=l.finalize();if(g.edits.length===0&&!g.setEndOfLine)return Promise.resolve(!0);const c=g.edits.map(_=>_.range);c.sort((_,w)=>_.end.line===w.end.line?_.end.character===w.end.character?_.start.line===w.start.line?_.start.character-w.start.character:_.start.line-w.start.line:_.end.character-w.end.character:_.end.line-w.end.line);for(let _=0,w=c.length-1;_<w;_++){const E=c[_].end;if(c[_+1].start.isBefore(E))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const f=g.edits.map(_=>({range:y.Range.from(_.range),text:_.text,forceMoveMarkers:_.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,g.documentVersionId,f,{setEndOfLine:typeof g.setEndOfLine=="number"?y.EndOfLine.from(g.setEndOfLine):void 0,undoStopBefore:g.undoStopBefore,undoStopAfter:g.undoStopAfter})}_runOnProxy(l){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):l().then(()=>this,g=>(g instanceof Error&&g.name==="DISPOSED"||this._logService.warn(g),null))}}e.ExtHostTextEditor=s}),define(ge[207],pe([0,1,163,24,2,3,6,14,7,13,17,18,21]),function(X,e,v,R,k,y,A,C,D,P,s,I,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function g(_,w){if(P.isString(_))return{label:_};if(_&&typeof _=="object"&&typeof _.label=="string"){let E;return Array.isArray(_.highlights)&&(E=_.highlights.filter(u=>u.length===2&&typeof u[0]=="number"&&typeof u[1]=="number"),E=E.length?E:void 0),{label:_.label,highlights:E}}}class c{constructor(w,E,u){this._proxy=w,this.commands=E,this.logService=u,this.treeViews=new Map;function h(m){return m&&m.$treeViewId&&m.$treeItemHandle}E.registerArgumentProcessor({processArgument:m=>h(m)?this.convertArgument(m):Array.isArray(m)&&m.length>0?m.map(t=>h(t)?this.convertArgument(t):t):m})}registerTreeDataProvider(w,E,u){const h=this.createTreeView(w,{treeDataProvider:E},u);return{dispose:()=>h.dispose()}}createTreeView(w,E,u){if(!E||!E.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const h=E.dragAndDropController!==void 0,m=this._proxy.$registerTreeViewDataProvider(w,{showCollapseAll:!!E.showCollapseAll,canSelectMany:!!E.canSelectMany,canDragAndDrop:h}),t=this.createExtHostTreeView(w,E,u);return{get onDidCollapseElement(){return t.onDidCollapseElement},get onDidExpandElement(){return t.onDidExpandElement},get selection(){return t.selectedElements},get onDidChangeSelection(){return t.onDidChangeSelection},get visible(){return t.visible},get onDidChangeVisibility(){return t.onDidChangeVisibility},get message(){return t.message},set message(r){t.message=r},get title(){return t.title},set title(r){t.title=r},get description(){return t.description},set description(r){t.description=r},reveal:(r,i)=>t.reveal(r,i),dispose:async()=>{await m,this.treeViews.delete(w),t.dispose()}}}$getChildren(w,E){const u=this.treeViews.get(w);return u?u.getChildren(E):Promise.reject(new Error(v.localize(0,null,w)))}$onDrop(w,E,u){const h=this.treeViews.get(w);return h?h.onDrop(E,u):Promise.reject(new Error(v.localize(1,null,w)))}async $hasResolve(w){const E=this.treeViews.get(w);if(!E)throw new Error(v.localize(2,null,w));return E.hasResolve}$resolve(w,E,u){const h=this.treeViews.get(w);if(!h)throw new Error(v.localize(3,null,w));return h.resolveTreeItem(E,u)}$setExpanded(w,E,u){const h=this.treeViews.get(w);if(!h)throw new Error(v.localize(4,null,w));h.setExpanded(E,u)}$setSelection(w,E){const u=this.treeViews.get(w);if(!u)throw new Error(v.localize(5,null,w));u.setSelection(E)}$setVisible(w,E){const u=this.treeViews.get(w);if(!u)throw new Error(v.localize(6,null,w));u.setVisible(E)}createExtHostTreeView(w,E,u){const h=new f(w,E,this._proxy,this.commands.converter,this.logService,u);return this.treeViews.set(w,h),h}convertArgument(w){const E=this.treeViews.get(w.$treeViewId);return E?E.getExtensionElement(w.$treeItemHandle):null}}e.ExtHostTreeViews=c;class f extends A.Disposable{constructor(w,E,u,h,m,t){super();if(this.viewId=w,this.proxy=u,this.commands=h,this.logService=m,this.extension=t,this.roots=null,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new y.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new y.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new y.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new y.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new y.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new l.CancellationTokenSource,t.contributes&&t.contributes.views)for(const n in t.contributes.views)for(const a of t.contributes.views[n])a.id===w&&(this._title=a.name);this.dataProvider=E.treeDataProvider,this.dndController=E.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(n=>this._onDidChangeData.fire({message:!1,element:n})));let r,i;this._register(y.Event.debounce(this._onDidChangeData.event,(n,a)=>(n||(n={message:!1,elements:[]}),a.element!==!1&&(r||(r=new Promise(p=>i=p),this.refreshPromise=this.refreshPromise.then(()=>r)),n.elements.push(a.element)),a.message&&(n.message=!0),n),200,!0)(({message:n,elements:a})=>{a.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const p=i;return r=null,this.refresh(a).then(()=>p())})),n&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(w=>this.getExtensionElement(w)).filter(w=>!P.isUndefinedOrNull(w))}getChildren(w){const E=w?this.getExtensionElement(w):void 0;if(w&&!E)return this.logService.error(`No tree item with id '${w}' found.`),Promise.resolve([]);const u=this.getChildrenNodes(w);return(u?Promise.resolve(u):this.fetchChildrenNodes(E)).then(h=>h.map(m=>m.item))}getExtensionElement(w){return this.elements.get(w)}reveal(w,E){E=E||{select:!0,focus:!1};const u=P.isUndefinedOrNull(E.select)?!0:E.select,h=P.isUndefinedOrNull(E.focus)?!1:E.focus,m=P.isUndefinedOrNull(E.expand)?!1:E.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):w?this.refreshPromise.then(()=>this.resolveUnknownParentChain(w)).then(t=>this.resolveTreeNode(w,t[t.length-1]).then(r=>this.proxy.$reveal(this.viewId,{item:r.item,parentChain:t.map(i=>i.item)},{select:u,focus:h,expand:m})),t=>this.logService.error(t)):this.proxy.$reveal(this.viewId,void 0,{select:u,focus:h,expand:m})}get message(){return this._message}set message(w){this._message=w,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(w){this._title=w,this.proxy.$setTitle(this.viewId,w,this._description)}get description(){return this._description}set description(w){this._description=w,this.proxy.$setTitle(this.viewId,this._title,w)}setExpanded(w,E){const u=this.getExtensionElement(w);u&&(E?this._onDidExpandElement.fire(Object.freeze({element:u})):this._onDidCollapseElement.fire(Object.freeze({element:u})))}setSelection(w){s.equals(this._selectedHandles,w)||(this._selectedHandles=w,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(w){w!==this._visible&&(this._visible=w,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}onDrop(w,E){const u=w.map(m=>this.getExtensionElement(m)).filter(m=>!P.isUndefinedOrNull(m)),h=this.getExtensionElement(E);return u&&h?C.asPromise(()=>{var m;return(m=this.dndController)===null||m===void 0?void 0:m.onDrop(u,h)}):Promise.resolve(void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(w,E){var u;if(!this.dataProvider.resolveTreeItem)return;const h=this.elements.get(w);if(h){const m=this.nodes.get(h);if(m){const t=(u=await this.dataProvider.resolveTreeItem(m.extensionItem,h,E))!==null&&u!==void 0?u:m.extensionItem;return m.item.tooltip=this.getTooltip(t.tooltip),m.item.command=this.getCommand(m.disposableStore,t.command),m.item}}}resolveUnknownParentChain(w){return this.resolveParent(w).then(E=>E?this.resolveUnknownParentChain(E).then(u=>this.resolveTreeNode(E,u[u.length-1]).then(h=>(u.push(h),u))):Promise.resolve([]))}resolveParent(w){const E=this.nodes.get(w);return E?Promise.resolve(E.parent?this.elements.get(E.parent.item.handle):void 0):C.asPromise(()=>this.dataProvider.getParent(w))}resolveTreeNode(w,E){const u=this.nodes.get(w);return u?Promise.resolve(u):C.asPromise(()=>this.dataProvider.getTreeItem(w)).then(h=>this.createHandle(w,h,E,!0)).then(h=>this.getChildren(E?E.item.handle:void 0).then(()=>{const m=this.getExtensionElement(h);if(m){const t=this.nodes.get(m);if(t)return Promise.resolve(t)}throw new Error(`Cannot resolve tree item for element ${h}`)}))}getChildrenNodes(w){if(w){let E;if(typeof w=="string"){const u=this.getExtensionElement(w);E=u?this.nodes.get(u):void 0}else E=w;return E&&E.children||null}return this.roots}async fetchChildrenNodes(w){this.clearChildren(w);const E=new l.CancellationTokenSource(this._refreshCancellationSource.token);try{const u=w?this.nodes.get(w):void 0,h=await this.dataProvider.getChildren(w);if(E.token.isCancellationRequested)return[];const m=await Promise.all(s.coalesce(h||[]).map(async t=>{const r=await this.dataProvider.getTreeItem(t);return r&&!E.token.isCancellationRequested?this.createAndRegisterTreeNode(t,r,u):null}));return E.token.isCancellationRequested?[]:s.coalesce(m)}finally{E.dispose()}}refresh(w){if(w.some(u=>!u))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new l.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const u=this.getHandlesToRefresh(w);if(u.length)return this.refreshHandles(u)}return Promise.resolve(void 0)}getHandlesToRefresh(w){const E=new Set,u=w.map(m=>this.nodes.get(m));for(const m of u)if(m&&!E.has(m.item.handle)){let t=m;for(;t&&t.parent&&u.findIndex(r=>t&&t.parent&&r&&r.item.handle===t.parent.item.handle)===-1;){const r=this.elements.get(t.parent.item.handle);t=r?this.nodes.get(r):void 0}t&&!t.parent&&E.add(m.item.handle)}const h=[];return E.forEach(m=>{const t=this.elements.get(m);if(t){const r=this.nodes.get(t);r&&(!r.parent||!E.has(r.parent.item.handle))&&h.push(m)}}),h}refreshHandles(w){const E={};return Promise.all(w.map(u=>this.refreshNode(u).then(h=>{h&&(E[u]=h.item)}))).then(()=>Object.keys(E).length?this.proxy.$refresh(this.viewId,E):void 0)}refreshNode(w){const E=this.getExtensionElement(w);if(E){const u=this.nodes.get(E);if(u)return this.clearChildren(E),C.asPromise(()=>this.dataProvider.getTreeItem(E)).then(h=>{if(h){const m=this.createTreeNode(E,h,u.parent);return this.updateNodeCache(E,m,u,u.parent),u.dispose(),m}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(w,E,u){const h=this.createTreeNode(w,E,u);if(E.id&&this.elements.has(h.item.handle))throw new Error(v.localize(7,null,E.id));return this.addNodeToCache(w,h),this.addNodeToParentCache(h,u),h}getTooltip(w){return D.MarkdownString.isMarkdownString(w)?I.MarkdownString.from(w):w}getCommand(w,E){return E?this.commands.toInternal(E,w):void 0}createTreeNode(w,E,u){const h=new A.DisposableStore,m=this.createHandle(w,E,u),t=this.getLightIconPath(E);return{item:{handle:m,parentHandle:u?u.item.handle:void 0,label:g(E.label,this.extension),description:E.description,resourceUri:E.resourceUri,tooltip:this.getTooltip(E.tooltip),command:this.getCommand(h,E.command),contextValue:E.contextValue,icon:t,iconDark:this.getDarkIconPath(E)||t,themeIcon:this.getThemeIcon(E),collapsibleState:P.isUndefinedOrNull(E.collapsibleState)?D.TreeItemCollapsibleState.None:E.collapsibleState,accessibilityInformation:E.accessibilityInformation},extensionItem:E,parent:u,children:void 0,disposableStore:h,dispose(){h.dispose()}}}getThemeIcon(w){return w.iconPath instanceof D.ThemeIcon?w.iconPath:void 0}createHandle(w,{id:E,label:u,resourceUri:h},m,t){if(E)return`${f.ID_HANDLE_PREFIX}/${E}`;const r=g(u,this.extension),i=m?m.item.handle:f.LABEL_HANDLE_PREFIX;let n=r?r.label:h?R.basename(h):"";n=n.indexOf("/")!==-1?n.replace("/","//"):n;const a=this.nodes.has(w)?this.nodes.get(w).item.handle:void 0,p=this.getChildrenNodes(m)||[];let d,b=0;do{if(d=`${i}/${b}:${n}`,t||!this.elements.has(d)||a===d)break;b++}while(b<=p.length);return d}getLightIconPath(w){if(w.iconPath&&!(w.iconPath instanceof D.ThemeIcon))return typeof w.iconPath=="string"||k.URI.isUri(w.iconPath)?this.getIconPath(w.iconPath):this.getIconPath(w.iconPath.light)}getDarkIconPath(w){if(w.iconPath&&!(w.iconPath instanceof D.ThemeIcon)&&w.iconPath.dark)return this.getIconPath(w.iconPath.dark)}getIconPath(w){return k.URI.isUri(w)?w:k.URI.file(w)}addNodeToCache(w,E){this.elements.set(E.item.handle,w),this.nodes.set(w,E)}updateNodeCache(w,E,u,h){this.elements.delete(E.item.handle),this.nodes.delete(w),E.item.handle!==u.item.handle&&this.elements.delete(u.item.handle),this.addNodeToCache(w,E);const m=this.getChildrenNodes(h)||[],t=m.filter(r=>r.item.handle===u.item.handle)[0];t&&m.splice(m.indexOf(t),1,E)}addNodeToParentCache(w,E){E?(E.children||(E.children=[]),E.children.push(w)):(this.roots||(this.roots=[]),this.roots.push(w))}clearChildren(w){if(w){const E=this.nodes.get(w);if(E){if(E.children)for(const u of E.children){const h=this.elements.get(u.item.handle);h&&this.clear(h)}E.children=void 0}}else this.clearAll()}clear(w){const E=this.nodes.get(w);if(E){if(E.children)for(const u of E.children){const h=this.elements.get(u.item.handle);h&&this.clear(h)}this.nodes.delete(w),this.elements.delete(E.item.handle),E.dispose()}}clearAll(){this.roots=null,this.elements.clear(),this.nodes.forEach(w=>w.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}f.LABEL_HANDLE_PREFIX="0",f.ID_HANDLE_PREFIX="1"}),define(ge[208],pe([0,1,17,14,21,13,84,18,7,121]),function(X,e,v,R,k,y,A,C,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=e.TestTree=e.TestPosition=e.OwnedTestCollection=void 0;class s{constructor(){this.testIdsToInternal=new Map}getTestById(_,w){if(w!==void 0){const E=this.testIdsToInternal.get(w),u=E==null?void 0:E.get(_);if(u)return[E,u]}return v.mapFind(this.testIdsToInternal.values(),E=>{const u=E.get(_);return u&&[E,u]})}createForHierarchy(_=()=>{}){return new c(this.createIdMap(l++),_)}createIdMap(_){const w=new g(_);return this.testIdsToInternal.set(w.id,w),{object:w,dispose:()=>this.testIdsToInternal.delete(w.id)}}}e.OwnedTestCollection=s;var I;(function(f){f[f.Disconnected=0]="Disconnected",f[f.IsChild=1]="IsChild",f[f.IsParent=2]="IsParent",f[f.IsSame=3]="IsSame"})(I=e.TestPosition||(e.TestPosition={}));let l=0;class g{constructor(_){this.id=_,this.map=new Map,this._roots=new Set,this.roots=this._roots}get size(){return this.map.size}add(_){if(this.map.has(_.item.extId))throw new Error(`Attempted to insert a duplicate test item ID ${_.item.extId}`);this.map.set(_.item.extId,_),_.parent||this._roots.add(_)}has(_){return this.map.has(_)}delete(_){const w=this.map.get(_);return w?(this.map.delete(_),this._roots.delete(w),!0):!1}get(_){return this.map.get(_)}comparePositions(_,w){const E=typeof _=="string"?this.map.get(_):_,u=typeof w=="string"?this.map.get(w):w;if(!E||!u)return 0;if(E===u)return 3;for(let h=this.map.get(u.parent);h;h=this.map.get(h.parent))if(h===E)return 1;for(let h=this.map.get(E.parent);h;h=this.map.get(h.parent))if(h===u)return 2;return 0}[Symbol.iterator](){return this.map.values()}}e.TestTree=g;class c{constructor(_,w){this.testIdToInternal=_,this.publishDiff=w,this.testItemToInternal=new Map,this.diff=[],this.debounceSendDiff=new R.RunOnceScheduler(()=>this.flushDiff(),200)}get treeId(){return this.testIdToInternal.object.id}addRoot(_,w){this.addItem(_,w,null)}getTestByReference(_){return this.testItemToInternal.get(_)}collectDiff(){const _=this.diff;return this.diff=[],_}pushDiff(_){const w=this.diff[this.diff.length-1];if(w&&_[0]===1){if(w[0]===1&&w[1].extId===_[1].extId){P.applyTestItemUpdate(w[1],_[1]);return}if(w[0]===0&&w[1].item.extId===_[1].extId){P.applyTestItemUpdate(w[1],_[1]);return}}this.diff.push(_),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(_,w){var E;const u=this.testIdToInternal.object.get(_);if(!!u){if((u.expandLevels===void 0||w>u.expandLevels)&&(u.expandLevels=w),u.expand===1){const h=this.refreshChildren(u);return h.isSettled?this.expandChildren(u,w-1):h.p.then(()=>this.expandChildren(u,w-1))}else if(u.expand===3)return((E=u.initialExpand)===null||E===void 0?void 0:E.isSettled)===!1?u.initialExpand.p.then(()=>this.expandChildren(u,w-1)):this.expandChildren(u,w-1)}}dispose(){var _;for(const w of this.testItemToInternal.values())(_=w.discoverCts)===null||_===void 0||_.dispose(!0),A.getPrivateApiFor(w.actual).bus.dispose();this.diff=[],this.testIdToInternal.dispose(),this.debounceSendDiff.dispose()}onTestItemEvent(_,w){const E=_==null?void 0:_.actual.id;switch(w[0]){case 2:this.pushDiff([4,E]);break;case 1:this.removeItem(_);break;case 0:this.addItem(w[1],_.src.controller,_);break;case 3:const[u,h,m]=w;switch(h){case"status":this.updateExpandability(_);break;case"range":this.pushDiff([1,{extId:E,item:{range:C.Range.from(m)}}]);break;case"error":this.pushDiff([1,{extId:E,item:{error:C.MarkdownString.fromStrict(m)||null}}]);break;default:this.pushDiff([1,{extId:E,item:{[h]:m??null}}]);break}break;default:y.assertNever(w[0])}}addItem(_,w,E){if(!(_ instanceof D.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${_.id} did not`);if(this.testItemToInternal.has(_))throw new Error(`Attempted to add a single TestItem ${_.id} multiple times to the tree`);if(this.testIdToInternal.object.has(_.id))throw new Error(`Attempted to insert a duplicate test item ID ${_.id}`);const u=E?E.item.extId:null,h=_.resolveHandler?1:0,m=E?E.expandLevels:1,t={controller:w,tree:this.testIdToInternal.object.id},r={actual:_,parent:u,item:C.TestItem.from(_),expandLevels:m?m-1:void 0,expand:0,src:t};this.testIdToInternal.object.add(r),this.testItemToInternal.set(_,r),this.pushDiff([0,{parent:u,src:t,expand:h,item:r.item}]);const i=A.getPrivateApiFor(_);i.parent=E==null?void 0:E.actual,i.bus.event(this.onTestItemEvent.bind(this,r)),this.updateExpandability(r);for(const n of i.children.values())this.testItemToInternal.has(n)||this.addItem(n,w,r)}updateExpandability(_){var w;let E;_.actual.resolveHandler?_.actual.status===D.TestItemStatus.Pending?E=_.discoverCts?2:1:((w=_.initialExpand)===null||w===void 0||w.complete(),E=3):E=0,E!==_.expand&&(_.expand=E,this.pushDiff([1,{extId:_.actual.id,expand:E}]),E===1&&_.expandLevels!==void 0&&this.refreshChildren(_))}expandChildren(_,w){if(w<0)return;const E=[..._.actual.children.values()].map(u=>this.expand(u.id,w)).filter(R.isThenable);if(E.length)return Promise.all(E).then(()=>{})}refreshChildren(_){if(_.discoverCts&&_.discoverCts.dispose(!0),!_.actual.resolveHandler){const w=new R.DeferredPromise;return w.complete(),w}return _.expand=2,_.discoverCts=new k.CancellationTokenSource,this.pushExpandStateUpdate(_),_.initialExpand=new R.DeferredPromise,_.actual.resolveHandler(_.discoverCts.token),_.initialExpand}pushExpandStateUpdate(_){this.pushDiff([1,{extId:_.actual.id,expand:_.expand}])}removeItem(_){var w;this.pushDiff([2,_.actual.id]);const E=[_];for(;E.length;){const u=E.pop();if(!!u){(w=u.discoverCts)===null||w===void 0||w.dispose(!0),this.testIdToInternal.object.delete(u.item.extId),this.testItemToInternal.delete(u.actual);for(const h of u.actual.children.values())E.push(this.testIdToInternal.object.get(h.id))}}}flushDiff(){const _=this.collectDiff();_.length&&this.publishDiff(_)}}e.SingleUseTestCollection=c}),define(ge[209],pe([0,1,26,3,9]),function(X,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class y{constructor(s){this.removedDueToLooping=s}}e.DeltaExtensionsResult=y;class A{constructor(s){this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=s,this._initialize()}_initialize(){this._extensionDescriptions.sort(D),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const s of this._extensionDescriptions){if(this._extensionsMap.has(v.ExtensionIdentifier.toKey(s.identifier))){console.error("Extension `"+s.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(v.ExtensionIdentifier.toKey(s.identifier),s),this._extensionsArr.push(s),Array.isArray(s.activationEvents))for(let I of s.activationEvents)I==="onUri"&&(I=`onUri:${v.ExtensionIdentifier.toKey(s.identifier)}`),this._activationMap.has(I)||this._activationMap.set(I,[]),this._activationMap.get(I).push(s)}}keepOnly(s){const I=new Set;s.forEach(l=>I.add(v.ExtensionIdentifier.toKey(l))),this._extensionDescriptions=this._extensionDescriptions.filter(l=>I.has(v.ExtensionIdentifier.toKey(l.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(s,I){s.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(s));const l=A._findLoopingExtensions(this._extensionDescriptions);if(I=I.concat(l.map(g=>g.identifier)),I.length>0){const g=new Set;I.forEach(c=>g.add(v.ExtensionIdentifier.toKey(c))),this._extensionDescriptions=this._extensionDescriptions.filter(c=>!g.has(v.ExtensionIdentifier.toKey(c.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new y(l)}static _findLoopingExtensions(s){const I=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(_){this._nodesSet.has(_)||(this._nodesSet.add(_),this._nodesArr.push(_))}addArc(_,w){this.addNode(_),this.addNode(w),this._arcs.has(_)?this._arcs.get(_).push(w):this._arcs.set(_,[w])}getArcs(_){return this._arcs.has(_)?this._arcs.get(_):[]}hasOnlyGoodArcs(_,w){const E=I.getArcs(_);for(let u=0;u<E.length;u++)if(!w.has(E[u]))return!1;return!0}getNodes(){return this._nodesArr}};let l=new Map;for(let _ of s){const w=v.ExtensionIdentifier.toKey(_.identifier);if(l.set(w,_),_.extensionDependencies)for(let E of _.extensionDependencies){const u=v.ExtensionIdentifier.toKey(E);I.addArc(w,u)}}let g=new Set;I.getNodes().filter(_=>I.getArcs(_).length===0).forEach(_=>g.add(_));let c=I.getNodes().filter(_=>!g.has(_)),f;do{f=!1;for(let _=0;_<c.length;_++){const w=c[_];I.hasOnlyGoodArcs(w,g)&&(c.splice(_,1),_--,g.add(w),f=!0)}}while(f);return c.map(_=>l.get(_))}containsActivationEvent(s){return this._activationMap.has(s)}containsExtension(s){return this._extensionsMap.has(v.ExtensionIdentifier.toKey(s))}getExtensionDescriptionsForActivationEvent(s){const I=this._activationMap.get(s);return I?I.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(s){const I=this._extensionsMap.get(v.ExtensionIdentifier.toKey(s));return I||void 0}}e.ExtensionDescriptionRegistry=A;var C;(function(P){P[P.Builtin=0]="Builtin",P[P.User=1]="User",P[P.Dev=2]="Dev"})(C||(C={}));function D(P,s){const I=P.isBuiltin?0:P.isUnderDevelopment?2:1,l=s.isBuiltin?0:s.isUnderDevelopment?2:1;if(I!==l)return I-l;const g=k.posix.basename(P.extensionLocation.path),c=k.posix.basename(s.extensionLocation.path);return g<c?-1:g>c?1:0}}),define(ge[210],pe([0,1,22]),function(X,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var R;(function(C){C[C.VersionMismatch=55]="VersionMismatch",C[C.UnexpectedError=81]="UnexpectedError"})(R=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var k;(function(C){C[C.Initialized=0]="Initialized",C[C.Ready=1]="Ready",C[C.Terminate=2]="Terminate"})(k=e.MessageType||(e.MessageType={}));function y(C){const D=v.VSBuffer.alloc(1);switch(C){case 0:D.writeUInt8(1,0);break;case 1:D.writeUInt8(2,0);break;case 2:D.writeUInt8(3,0);break}return D}e.createMessageOfType=y;function A(C,D){if(C.byteLength!==1)return!1;switch(C.readUInt8(0)){case 1:return D===0;case 2:return D===1;case 3:return D===2;default:return!1}}e.isMessageOfType=A}),define(ge[35],pe([0,1,3,2,4,26,177]),function(X,e,v,R,k,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new y.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:R.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=k.createDecorator("extensionService");class C{constructor(E){this.dependency=E}}e.MissingExtensionDependency=C;var D;(function(w){w[w.LocalProcess=0]="LocalProcess",w[w.LocalWebWorker=1]="LocalWebWorker",w[w.Remote=2]="Remote"})(D=e.ExtensionHostKind||(e.ExtensionHostKind={}));class P{constructor(E,u,h,m){this.codeLoadingTime=E,this.activateCallTime=u,this.activateResolvedTime=h,this.activationReason=m}}e.ActivationTimes=P;class s{constructor(E,u){this.description=E,this.value=u}}e.ExtensionPointContribution=s,e.ExtensionHostLogFileName="exthost";var I;(function(w){w[w.Normal=0]="Normal",w[w.Immediate=1]="Immediate"})(I=e.ActivationKind||(e.ActivationKind={}));function l(w){w.enableProposedApi||g(w)}e.checkProposedApiEnabled=l;function g(w){throw new Error(`[${w.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${w.identifier.value}`)}e.throwProposedApiError=g;function c(w){return{type:w.isBuiltin?0:1,isBuiltin:w.isBuiltin||w.isUserBuiltin,identifier:{id:A.getGalleryExtensionId(w.publisher,w.name),uuid:w.uuid},manifest:w,location:w.extensionLocation}}e.toExtension=c;function f(w){return Object.assign(Object.assign({identifier:new y.ExtensionIdentifier(w.identifier.id),isBuiltin:w.type===0,isUserBuiltin:w.type===1&&w.isBuiltin,isUnderDevelopment:!1,extensionLocation:w.location},w.manifest),{uuid:w.identifier.uuid})}e.toExtensionDescription=f;class _{constructor(){this.onDidRegisterExtensions=v.Event.None,this.onDidChangeExtensionsStatus=v.Event.None,this.onDidChangeExtensions=v.Event.None,this.onWillActivateByEvent=v.Event.None,this.onDidChangeResponsiveChange=v.Event.None}activateByEvent(E){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(E){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(E){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(E){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(E,u){return Promise.resolve()}_onWillActivateExtension(E){}_onDidActivateExtension(E,u,h,m,t){}_onDidActivateExtensionError(E,u){}_onExtensionRuntimeError(E,u){}_onExtensionHostExit(E){}}e.NullExtensionService=_}),define(ge[211],pe([0,1,26,35,15]),function(X,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const y=Promise.resolve(void 0);class A{constructor(c,f,_,w){this.startup=c,this.codeLoadingTime=f,this.activateCallTime=_,this.activateResolvedTime=w}}e.ExtensionActivationTimes=A,A.NONE=new A(!1,-1,-1,-1);class C{constructor(c){this._startup=c,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(c,f){return c===-1||f===-1?-1:f-c}build(){return new A(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=C;class D{constructor(c,f,_,w,E,u){this.activationFailed=c,this.activationFailedError=f,this.activationTimes=_,this.module=w,this.exports=E,this.subscriptions=u}}e.ActivatedExtension=D;class P extends D{constructor(c){super(!1,null,c,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=P;class s extends D{constructor(){super(!1,null,A.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=s;class I extends D{constructor(c){super(!0,c,A.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=I;let l=class{constructor(c,f,_,w,E){this._logService=E,this._registry=c,this._resolvedExtensionsSet=new Set,f.forEach(u=>this._resolvedExtensionsSet.add(v.ExtensionIdentifier.toKey(u))),this._hostExtensionsMap=new Map,_.forEach(u=>this._hostExtensionsMap.set(v.ExtensionIdentifier.toKey(u),u)),this._host=w,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(c){const f=v.ExtensionIdentifier.toKey(c);return this._activatedExtensions.has(f)}getActivatedExtension(c){const f=v.ExtensionIdentifier.toKey(c),_=this._activatedExtensions.get(f);if(!_)throw new Error("Extension `"+c.value+"` is not known or not activated");return _}activateByEvent(c,f){if(this._alreadyActivatedEvents[c])return y;const _=this._registry.getExtensionDescriptionsForActivationEvent(c);return this._activateExtensions(_.map(w=>({id:w.identifier,reason:{startup:f,extensionId:w.identifier,activationEvent:c}}))).then(()=>{this._alreadyActivatedEvents[c]=!0})}activateById(c,f){const _=this._registry.getExtensionDescription(c);if(!_)throw new Error("Extension `"+c+"` is not known");return this._activateExtensions([{id:_.identifier,reason:f}])}_handleActivateRequest(c,f,_){if(this._hostExtensionsMap.has(v.ExtensionIdentifier.toKey(c.id))){f[v.ExtensionIdentifier.toKey(c.id)]=c;return}const w=this._registry.getExtensionDescription(c.id);if(!w){const h=new Error(`Cannot activate unknown extension '${c.id.value}'`);this._host.onExtensionActivationError(c.id,h,new R.MissingExtensionDependency(c.id.value)),this._activatedExtensions.set(v.ExtensionIdentifier.toKey(c.id),new I(h));return}const E=typeof w.extensionDependencies=="undefined"?[]:w.extensionDependencies;let u=!0;for(let h=0,m=E.length;h<m;h++){const t=E[h];if(this._resolvedExtensionsSet.has(v.ExtensionIdentifier.toKey(t)))continue;const r=this._activatedExtensions.get(v.ExtensionIdentifier.toKey(t));if(r&&!r.activationFailed)continue;if(r&&r.activationFailed){const p=w.displayName||w.identifier.value,d=this._registry.getExtensionDescription(t),b=d&&d.displayName||t,S=new Error(`Cannot activate the '${p}' extension because its dependency '${b}' failed to activate`);S.detail=r.activationFailedError,this._host.onExtensionActivationError(w.identifier,S,null),this._activatedExtensions.set(v.ExtensionIdentifier.toKey(w.identifier),new I(S));return}if(this._hostExtensionsMap.has(v.ExtensionIdentifier.toKey(t))){u=!1,f[v.ExtensionIdentifier.toKey(t)]={id:this._hostExtensionsMap.get(v.ExtensionIdentifier.toKey(t)),reason:c.reason};continue}const i=this._registry.getExtensionDescription(t);if(i){u=!1,f[v.ExtensionIdentifier.toKey(t)]={id:i.identifier,reason:c.reason};continue}const n=w.displayName||w.identifier.value,a=new Error(`Cannot activate the '${n}' extension because it depends on unknown extension '${t}'`);this._host.onExtensionActivationError(w.identifier,a,new R.MissingExtensionDependency(t)),this._activatedExtensions.set(v.ExtensionIdentifier.toKey(w.identifier),new I(a));return}u?f[v.ExtensionIdentifier.toKey(w.identifier)]=c:_.push(c)}_activateExtensions(c){if(c.length===0||(c=c.filter(E=>!this._activatedExtensions.has(v.ExtensionIdentifier.toKey(E.id))),c.length===0))return Promise.resolve(void 0);const f=Object.create(null),_=[];for(let E=0,u=c.length;E<u;E++)this._handleActivateRequest(c[E],f,_);for(let E=0,u=_.length;E<u;E++){const h=v.ExtensionIdentifier.toKey(_[E].id);f[h]&&delete f[h]}const w=Object.keys(f).map(E=>f[E]);return _.length===0?Promise.all(w.map(E=>this._activateExtension(E.id,E.reason))).then(E=>{}):this._activateExtensions(w).then(E=>this._activateExtensions(_))}_activateExtension(c,f){const _=v.ExtensionIdentifier.toKey(c);if(this._activatedExtensions.has(_))return Promise.resolve(void 0);const w=this._activatingExtensions.get(_);if(w)return w;const E=this._host.actualActivateExtension(c,f).then(void 0,u=>{const h=new Error;return u&&u.name&&(h.name=u.name),u&&u.message?h.message=`Activating extension '${c.value}' failed: ${u.message}.`:h.message=`Activating extension '${c.value}' failed: ${u}.`,u&&u.stack&&(h.stack=u.stack),this._host.onExtensionActivationError(c,h,null),this._logService.error(`Activating extension ${c.value} failed due to an error:`),this._logService.error(u),new I(u)}).then(u=>{this._activatedExtensions.set(_,u),this._activatingExtensions.delete(_)});return this._activatingExtensions.set(_,E),E}};l=Ve([We(4,k.ILogService)],l),e.ExtensionsActivator=l}),define(ge[212],pe([0,1,15,35,27,10,112]),function(X,e,v,R,k,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let C=class extends v.LogService{constructor(P){if(P.logFile.scheme!==y.Schemas.file)throw new Error("Only file-logging supported");super(new A.SpdLogLogger(R.ExtensionHostLogFileName,P.logFile.fsPath,!0,P.logLevel))}$setLevel(P){this.setLevel(P)}};C=Ve([We(0,k.IExtHostInitDataService)],C),e.ExtHostLogService=C}),define(ge[213],pe([0,1,16]),function(X,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class R{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((y,A)=>{this._actualOk=y,this._actualErr=A,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(y){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=y,this._actual&&this._actualOk(y))}resolveErr(y){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=y,this._actual?this._actualErr(y):v.onUnexpectedError(y))}then(y,A){return this._ensureActual().then(y,A)}catch(y){return this._ensureActual().then(void 0,y)}finally(y){return this._ensureActual().finally(y)}}e.LazyPromise=R}),define(ge[124],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class v{constructor(D,P){this.isMain=D,this.sid=P,this.nid=++v.count}}e.ProxyIdentifier=v,v.count=0;const R=[];function k(C){const D=new v(!0,C);return R[D.nid]=D,D}e.createMainContextProxyIdentifier=k;function y(C){const D=new v(!1,C);return R[D.nid]=D,D}e.createExtHostContextProxyIdentifier=y;function A(C){return R[C].sid}e.getStringIdentifierForProxy=A}),define(ge[5],pe([0,1,53,2,124]),function(X,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var y;(function(u){u[u.Desktop=1]="Desktop",u[u.Web=2]="Web"})(y=e.UIKind||(e.UIKind={}));var A;(function(u){u[u.Default=0]="Default",u[u.InCenter=1]="InCenter",u[u.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",u[u.AtTop=3]="AtTop"})(A=e.TextEditorRevealType||(e.TextEditorRevealType={}));var C;(function(u){u[u.Editable=0]="Editable",u[u.SupportsHotExit=1]="SupportsHotExit"})(C=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var D;(function(u){u[u.Int8Array=1]="Int8Array",u[u.Uint8Array=2]="Uint8Array",u[u.Uint8ClampedArray=3]="Uint8ClampedArray",u[u.Int16Array=4]="Int16Array",u[u.Uint16Array=5]="Uint16Array",u[u.Int32Array=6]="Int32Array",u[u.Uint32Array=7]="Uint32Array",u[u.Float32Array=8]="Float32Array",u[u.Float64Array=9]="Float64Array",u[u.BigInt64Array=10]="BigInt64Array",u[u.BigUint64Array=11]="BigUint64Array"})(D=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var P;(function(u){u[u.Text=1]="Text",u[u.Error=2]="Error",u[u.Rich=3]="Rich"})(P=e.CellOutputKind||(e.CellOutputKind={}));var s;(function(u){u[u.Default=0]="Default",u[u.InCenter=1]="InCenter",u[u.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",u[u.AtTop=3]="AtTop"})(s=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var I;(function(u){u[u.None=0]="None",u[u.Process=1]="Process",u[u.Output=2]="Output"})(I=e.CandidatePortSource||(e.CandidatePortSource={}));var l;(function(u){u.name="$ident";function h(t,r){return Object.defineProperty(t,u.name,{value:r,enumerable:!0}),t}u.mixin=h;function m(t){return t[u.name]}u.of=m})(l=e.ObjectIdentifier||(e.ObjectIdentifier={}));class g{static mixin(h){return h._id=g._n++,h}}e.IdObject=g,g._n=0;var c;(function(u){u.label="a",u.kind="b",u.detail="c",u.documentation="d",u.sortText="e",u.filterText="f",u.preselect="g",u.insertText="h",u.insertTextRules="i",u.range="j",u.commitCharacters="k",u.additionalTextEdits="l",u.command="m",u.kindModifier="n",u.label2="o"})(c=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var f;(function(u){u.defaultRanges="a",u.completions="b",u.isIncomplete="c",u.duration="d"})(f=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var _;(function(u){u[u.File=1]="File",u[u.Text=2]="Text",u[u.Cell=3]="Cell"})(_=e.WorkspaceEditType||(e.WorkspaceEditType={}));function w(u){if(u&&u.edits)for(const h of u.edits)typeof h.resource=="object"?h.resource=R.URI.revive(h.resource):(h.newUri=R.URI.revive(h.newUri),h.oldUri=R.URI.revive(h.oldUri)),h.metadata&&h.metadata.iconPath&&(h.metadata=v.revive(h.metadata));return u}e.reviveWorkspaceEditDto=w;var E;(function(u){u[u.Workspace=0]="Workspace",u[u.TextDocument=1]="TextDocument"})(E=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:k.createMainContextProxyIdentifier("MainThreadAuthentication"),MainThreadBulkEdits:k.createMainContextProxyIdentifier("MainThreadBulkEdits"),MainThreadClipboard:k.createMainContextProxyIdentifier("MainThreadClipboard"),MainThreadCommands:k.createMainContextProxyIdentifier("MainThreadCommands"),MainThreadComments:k.createMainContextProxyIdentifier("MainThreadComments"),MainThreadConfiguration:k.createMainContextProxyIdentifier("MainThreadConfiguration"),MainThreadConsole:k.createMainContextProxyIdentifier("MainThreadConsole"),MainThreadDebugService:k.createMainContextProxyIdentifier("MainThreadDebugService"),MainThreadDecorations:k.createMainContextProxyIdentifier("MainThreadDecorations"),MainThreadDiagnostics:k.createMainContextProxyIdentifier("MainThreadDiagnostics"),MainThreadDialogs:k.createMainContextProxyIdentifier("MainThreadDiaglogs"),MainThreadDocuments:k.createMainContextProxyIdentifier("MainThreadDocuments"),MainThreadDocumentContentProviders:k.createMainContextProxyIdentifier("MainThreadDocumentContentProviders"),MainThreadTextEditors:k.createMainContextProxyIdentifier("MainThreadTextEditors"),MainThreadEditorInsets:k.createMainContextProxyIdentifier("MainThreadEditorInsets"),MainThreadEditorTabs:k.createMainContextProxyIdentifier("MainThreadEditorTabs"),MainThreadErrors:k.createMainContextProxyIdentifier("MainThreadErrors"),MainThreadTreeViews:k.createMainContextProxyIdentifier("MainThreadTreeViews"),MainThreadDownloadService:k.createMainContextProxyIdentifier("MainThreadDownloadService"),MainThreadKeytar:k.createMainContextProxyIdentifier("MainThreadKeytar"),MainThreadLanguageFeatures:k.createMainContextProxyIdentifier("MainThreadLanguageFeatures"),MainThreadLanguages:k.createMainContextProxyIdentifier("MainThreadLanguages"),MainThreadLog:k.createMainContextProxyIdentifier("MainThread"),MainThreadMessageService:k.createMainContextProxyIdentifier("MainThreadMessageService"),MainThreadOutputService:k.createMainContextProxyIdentifier("MainThreadOutputService"),MainThreadProgress:k.createMainContextProxyIdentifier("MainThreadProgress"),MainThreadQuickOpen:k.createMainContextProxyIdentifier("MainThreadQuickOpen"),MainThreadStatusBar:k.createMainContextProxyIdentifier("MainThreadStatusBar"),MainThreadSecretState:k.createMainContextProxyIdentifier("MainThreadSecretState"),MainThreadStorage:k.createMainContextProxyIdentifier("MainThreadStorage"),MainThreadTelemetry:k.createMainContextProxyIdentifier("MainThreadTelemetry"),MainThreadTerminalService:k.createMainContextProxyIdentifier("MainThreadTerminalService"),MainThreadWebviews:k.createMainContextProxyIdentifier("MainThreadWebviews"),MainThreadWebviewPanels:k.createMainContextProxyIdentifier("MainThreadWebviewPanels"),MainThreadWebviewViews:k.createMainContextProxyIdentifier("MainThreadWebviewViews"),MainThreadCustomEditors:k.createMainContextProxyIdentifier("MainThreadCustomEditors"),MainThreadUrls:k.createMainContextProxyIdentifier("MainThreadUrls"),MainThreadUriOpeners:k.createMainContextProxyIdentifier("MainThreadUriOpeners"),MainThreadWorkspace:k.createMainContextProxyIdentifier("MainThreadWorkspace"),MainThreadFileSystem:k.createMainContextProxyIdentifier("MainThreadFileSystem"),MainThreadExtensionService:k.createMainContextProxyIdentifier("MainThreadExtensionService"),MainThreadSCM:k.createMainContextProxyIdentifier("MainThreadSCM"),MainThreadSearch:k.createMainContextProxyIdentifier("MainThreadSearch"),MainThreadTask:k.createMainContextProxyIdentifier("MainThreadTask"),MainThreadWindow:k.createMainContextProxyIdentifier("MainThreadWindow"),MainThreadLabelService:k.createMainContextProxyIdentifier("MainThreadLabelService"),MainThreadNotebook:k.createMainContextProxyIdentifier("MainThreadNotebook"),MainThreadNotebookDocuments:k.createMainContextProxyIdentifier("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:k.createMainContextProxyIdentifier("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:k.createMainContextProxyIdentifier("MainThreadNotebookKernels"),MainThreadNotebookRenderers:k.createMainContextProxyIdentifier("MainThreadNotebookRenderers"),MainThreadTheming:k.createMainContextProxyIdentifier("MainThreadTheming"),MainThreadTunnelService:k.createMainContextProxyIdentifier("MainThreadTunnelService"),MainThreadTimeline:k.createMainContextProxyIdentifier("MainThreadTimeline"),MainThreadTesting:k.createMainContextProxyIdentifier("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:k.createExtHostContextProxyIdentifier("ExtHostCommands"),ExtHostConfiguration:k.createExtHostContextProxyIdentifier("ExtHostConfiguration"),ExtHostDiagnostics:k.createExtHostContextProxyIdentifier("ExtHostDiagnostics"),ExtHostDebugService:k.createExtHostContextProxyIdentifier("ExtHostDebugService"),ExtHostDecorations:k.createExtHostContextProxyIdentifier("ExtHostDecorations"),ExtHostDocumentsAndEditors:k.createExtHostContextProxyIdentifier("ExtHostDocumentsAndEditors"),ExtHostDocuments:k.createExtHostContextProxyIdentifier("ExtHostDocuments"),ExtHostDocumentContentProviders:k.createExtHostContextProxyIdentifier("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:k.createExtHostContextProxyIdentifier("ExtHostDocumentSaveParticipant"),ExtHostEditors:k.createExtHostContextProxyIdentifier("ExtHostEditors"),ExtHostTreeViews:k.createExtHostContextProxyIdentifier("ExtHostTreeViews"),ExtHostFileSystem:k.createExtHostContextProxyIdentifier("ExtHostFileSystem"),ExtHostFileSystemInfo:k.createExtHostContextProxyIdentifier("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:k.createExtHostContextProxyIdentifier("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:k.createExtHostContextProxyIdentifier("ExtHostLanguageFeatures"),ExtHostQuickOpen:k.createExtHostContextProxyIdentifier("ExtHostQuickOpen"),ExtHostExtensionService:k.createExtHostContextProxyIdentifier("ExtHostExtensionService"),ExtHostLogService:k.createExtHostContextProxyIdentifier("ExtHostLogService"),ExtHostTerminalService:k.createExtHostContextProxyIdentifier("ExtHostTerminalService"),ExtHostSCM:k.createExtHostContextProxyIdentifier("ExtHostSCM"),ExtHostSearch:k.createExtHostContextProxyIdentifier("ExtHostSearch"),ExtHostTask:k.createExtHostContextProxyIdentifier("ExtHostTask"),ExtHostWorkspace:k.createExtHostContextProxyIdentifier("ExtHostWorkspace"),ExtHostWindow:k.createExtHostContextProxyIdentifier("ExtHostWindow"),ExtHostWebviews:k.createExtHostContextProxyIdentifier("ExtHostWebviews"),ExtHostWebviewPanels:k.createExtHostContextProxyIdentifier("ExtHostWebviewPanels"),ExtHostCustomEditors:k.createExtHostContextProxyIdentifier("ExtHostCustomEditors"),ExtHostWebviewViews:k.createExtHostContextProxyIdentifier("ExtHostWebviewViews"),ExtHostEditorInsets:k.createExtHostContextProxyIdentifier("ExtHostEditorInsets"),ExtHostEditorTabs:k.createExtHostContextProxyIdentifier("ExtHostEditorTabs"),ExtHostProgress:k.createMainContextProxyIdentifier("ExtHostProgress"),ExtHostComments:k.createMainContextProxyIdentifier("ExtHostComments"),ExtHostSecretState:k.createMainContextProxyIdentifier("ExtHostSecretState"),ExtHostStorage:k.createMainContextProxyIdentifier("ExtHostStorage"),ExtHostUrls:k.createExtHostContextProxyIdentifier("ExtHostUrls"),ExtHostUriOpeners:k.createExtHostContextProxyIdentifier("ExtHostUriOpeners"),ExtHostOutputService:k.createMainContextProxyIdentifier("ExtHostOutputService"),ExtHosLabelService:k.createMainContextProxyIdentifier("ExtHostLabelService"),ExtHostNotebook:k.createMainContextProxyIdentifier("ExtHostNotebook"),ExtHostNotebookKernels:k.createMainContextProxyIdentifier("ExtHostNotebookKernels"),ExtHostNotebookRenderers:k.createMainContextProxyIdentifier("ExtHostNotebookRenderers"),ExtHostTheming:k.createMainContextProxyIdentifier("ExtHostTheming"),ExtHostTunnelService:k.createMainContextProxyIdentifier("ExtHostTunnelService"),ExtHostAuthentication:k.createMainContextProxyIdentifier("ExtHostAuthentication"),ExtHostTimeline:k.createMainContextProxyIdentifier("ExtHostTimeline"),ExtHostTesting:k.createMainContextProxyIdentifier("ExtHostTesting"),ExtHostTelemetry:k.createMainContextProxyIdentifier("ExtHostTelemetry")}}),define(ge[86],pe([0,1,5,3,4]),function(X,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class y{constructor(C){this._onDidChangePassword=new R.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=C.getProxy(v.MainContext.MainThreadSecretState)}async $onDidChangePassword(C){this._onDidChangePassword.fire(C)}get(C,D){return this._proxy.$getPassword(C,D)}store(C,D,P){return this._proxy.$setPassword(C,D,P)}delete(C,D){return this._proxy.$deletePassword(C,D)}}e.ExtHostSecretState=y,e.IExtHostSecretState=k.createDecorator("IExtHostSecretState")}),define(ge[61],pe([0,1,4,15,5,12]),function(X,e,v,R,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=v.createDecorator("IExtHostApiDeprecationService");let A=class{constructor(D,P){this._extHostLogService=P,this._reportedUsages=new Set,this._telemetryShape=D.getProxy(k.MainContext.MainThreadTelemetry)}report(D,P,s){const I=this.getUsageKey(D,P);this._reportedUsages.has(I)||(this._reportedUsages.add(I),P.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${D}' is deprecated. ${s}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:P.identifier.value,apiId:D}))}getUsageKey(D,P){return`${D}-${P.identifier.value}`}};A=Ve([We(0,y.IExtHostRpcService),We(1,R.ILogService)],A),e.ExtHostApiDeprecationService=A,e.NullApiDeprecationService=Object.freeze(new class{report(C,D,P){}})}),define(ge[214],pe([0,1,3,5,7,26]),function(X,e,v,R,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class A{constructor(D){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeAuthenticationProviders=new v.Emitter,this.onDidChangeAuthenticationProviders=this._onDidChangeAuthenticationProviders.event,this._onDidChangeSessions=new v.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=D.getProxy(R.MainContext.MainThreadAuthentication)}$setProviders(D){return this._providers=D,Promise.resolve()}get providers(){return Object.freeze(this._providers.slice())}async getSession(D,P,s,I={}){const l=y.ExtensionIdentifier.toKey(D.identifier),g=this._inFlightRequests.get(l)||[],c=[...s].sort().join(" ");let f=g.find(_=>_.scopes===c);if(f)return f.result;{const _=this._getSession(D,l,P,s,I);f={scopes:c,result:_},g.push(f),this._inFlightRequests.set(l,g);try{await _}finally{const w=g.findIndex(E=>E.scopes===c);w>-1&&(g.splice(w),this._inFlightRequests.set(l,g))}return _}}async _getSession(D,P,s,I,l={}){await this._proxy.$ensureProvider(s);const g=D.displayName||D.name;return this._proxy.$getSession(s,I,P,g,l)}async removeSession(D,P){const s=this._authenticationProviders.get(D);return s?s.provider.removeSession(P):this._proxy.$removeSession(D,P)}registerAuthenticationProvider(D,P,s,I){var l;if(this._authenticationProviders.get(D))throw new Error(`An authentication provider with id '${D}' is already registered.`);this._authenticationProviders.set(D,{label:P,provider:s,options:I??{supportsMultipleAccounts:!1}}),this._providers.find(c=>c.id===D)||this._providers.push({id:D,label:P});const g=s.onDidChangeSessions(c=>{var f,_,w;this._proxy.$sendDidChangeSessions(D,{added:(f=c.added)!==null&&f!==void 0?f:[],changed:(_=c.changed)!==null&&_!==void 0?_:[],removed:(w=c.removed)!==null&&w!==void 0?w:[]})});return this._proxy.$registerAuthenticationProvider(D,P,(l=I==null?void 0:I.supportsMultipleAccounts)!==null&&l!==void 0?l:!1),new k.Disposable(()=>{g.dispose(),this._authenticationProviders.delete(D);const c=this._providers.findIndex(f=>f.id===D);c>-1&&this._providers.splice(c),this._proxy.$unregisterAuthenticationProvider(D)})}$createSession(D,P){const s=this._authenticationProviders.get(D);if(s)return Promise.resolve(s.provider.createSession(P));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$removeSession(D,P){const s=this._authenticationProviders.get(D);if(s)return Promise.resolve(s.provider.removeSession(P));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$getSessions(D,P){const s=this._authenticationProviders.get(D);if(s)return Promise.resolve(s.provider.getSessions(P));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$onDidChangeAuthenticationSessions(D,P){return this._onDidChangeSessions.fire({provider:{id:D,label:P}}),Promise.resolve()}$onDidChangeAuthenticationProviders(D,P){return D.forEach(s=>{this._providers.some(I=>I.id===s.id)||this._providers.push(s)}),P.forEach(s=>{const I=this._providers.findIndex(l=>l.id===s.id);I>-1&&this._providers.splice(I)}),this._onDidChangeAuthenticationProviders.fire({added:D,removed:P}),Promise.resolve()}}e.ExtHostAuthentication=A}),define(ge[215],pe([0,1,5,12,18]),function(X,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let y=class{constructor(C,D){this._extHostDocumentsAndEditors=D,this._proxy=C.getProxy(v.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(C){const D=k.WorkspaceEdit.from(C,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(D)}};y=Ve([We(0,R.IExtHostRpcService)],y),e.ExtHostBulkEdits=y}),define(ge[216],pe([0,1,5]),function(X,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class R{constructor(y){const A=y.getProxy(v.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(C){return A.$writeText(C)}})}}e.ExtHostClipboard=R}),define(ge[47],pe([0,1,13,7,18,25,5,17,15,53,41,44,2,6,4,12]),function(X,e,v,R,k,y,A,C,D,P,s,I,l,g,c,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let _=class{constructor(t,r){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(A.MainContext.MainThreadCommands),this._logService=r,this.converter=new w(this,i=>{const n=this._apiCommands.get(i);return(n==null?void 0:n.result)===u.Void?n:void 0},r),this._argumentProcessors=[{processArgument(i){return P.revive(i)}},{processArgument(i){return y.cloneAndChange(i,function(n){if(s.Range.isIRange(n))return k.Range.to(n);if(I.Position.isIPosition(n))return k.Position.to(n);if(s.Range.isIRange(n.range)&&l.URI.isUri(n.uri))return k.location.to(n);if(!Array.isArray(n))return n})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const r=this.registerCommand(!1,t.id,async(...i)=>{const n=t.args.map((p,d)=>{if(!p.validate(i[d]))throw new Error(`Invalid argument '${p.name}' when running '${t.id}', received: ${i[d]}`);return p.convert(i[d])}),a=await this.executeCommand(t.internalId,...n);return t.result.convert(a,i,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new R.Disposable(()=>{r.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,r,i,n,a){if(this._logService.trace("ExtHostCommands#registerCommand",r),!r.trim().length)throw new Error("invalid id");if(this._commands.has(r))throw new Error(`command '${r}' already exists`);return this._commands.set(r,{callback:i,thisArg:n,description:a}),t&&this._proxy.$registerCommand(r),new R.Disposable(()=>{this._commands.delete(r)&&t&&this._proxy.$unregisterCommand(r)})}executeCommand(t,...r){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,r,!0)}async _doExecuteCommand(t,r,i){if(this._commands.has(t))return this._executeContributedCommand(t,r);{const n=y.cloneAndChange(r,function(a){if(a instanceof R.Position)return k.Position.from(a);if(a instanceof R.Range)return k.Range.from(a);if(a instanceof R.Location)return k.location.from(a);if(R.NotebookRange.isNotebookRange(a))return k.NotebookRange.from(a);if(!Array.isArray(a))return a});try{const a=await this._proxy.$executeCommand(t,n,i);return P.revive(a)}catch(a){if(a instanceof Error&&a.message==="$executeCommand:retry")return this._doExecuteCommand(t,r,!1);throw a}}}async _executeContributedCommand(t,r){const i=this._commands.get(t);if(!i)throw new Error("Unknown command");let{callback:n,thisArg:a,description:p}=i;if(p)for(let d=0;d<p.args.length;d++)try{v.validateConstraint(r[d],p.args[d].constraint)}catch(b){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${p.args[d].name}' - ${p.args[d].description}`)}try{return await n.apply(a,r)}catch(d){if(t===this.converter.delegatingCommandId){const b=this.converter.getActualCommand(...r);b&&(t=b.command)}throw this._logService.error(d,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...r){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(r=r.map(i=>this._argumentProcessors.reduce((n,a)=>a.processArgument(n),i)),this._executeContributedCommand(t,r)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(r=>(t&&(r=r.filter(i=>i[0]!=="_")),r))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[r,i]of this._commands){let{description:n}=i;n&&(t[r]=n)}return Promise.resolve(t)}};_=Ve([We(0,f.IExtHostRpcService),We(1,D.ILogService)],_),e.ExtHostCommands=_,e.IExtHostCommands=c.createDecorator("IExtHostCommands");class w{constructor(t,r,i){this._commands=t,this._lookupApiCommand=r,this._logService=i,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,r){if(!t)return;const i={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return i;const n=this._lookupApiCommand(t.command);if(n)i.id=n.internalId,i.arguments=n.args.map((a,p)=>a.convert(t.arguments&&t.arguments[p]));else if(C.isNonEmptyArray(t.arguments)){const a=++this._cachIdPool;this._cache.set(a,t),r.add(g.toDisposable(()=>{this._cache.delete(a),this._logService.trace("CommandsConverter#DISPOSE",a)})),i.$ident=a,i.id=this.delegatingCommandId,i.arguments=[a],this._logService.trace("CommandsConverter#CREATE",t.command,a)}return i}fromInternal(t){const r=A.ObjectIdentifier.of(t);return typeof r=="number"?this._cache.get(r):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const r=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],r?r.command:"MISSING"),r?this._commands.executeCommand(r.command,...r.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=w;class E{constructor(t,r,i,n){this.name=t,this.description=r,this.validate=i,this.convert=n}optional(){return new E(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,r){return new E(t??this.name,r??this.description,this.validate,this.convert)}}e.ApiCommandArgument=E,E.Uri=new E("uri","Uri of a text document",m=>l.URI.isUri(m),m=>m),E.Position=new E("position","A position in a text document",m=>R.Position.isPosition(m),k.Position.from),E.Range=new E("range","A range in a text document",m=>R.Range.isRange(m),k.Range.from),E.Selection=new E("selection","A selection in a text document",m=>R.Selection.isSelection(m),k.Selection.from),E.Number=new E("number","",m=>typeof m=="number",m=>m),E.String=new E("string","",m=>typeof m=="string",m=>m),E.CallHierarchyItem=new E("item","A call hierarchy item",m=>m instanceof R.CallHierarchyItem,k.CallHierarchyItem.to);class u{constructor(t,r){this.description=t,this.convert=r}}e.ApiCommandResult=u,u.Void=new u("no result",m=>m);class h{constructor(t,r,i,n,a){this.id=t,this.internalId=r,this.description=i,this.args=n,this.result=a}}e.ApiCommand=h}),define(ge[217],pe([0,1,18,7,79,47,17,107]),function(X,e,v,R,k,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const D=[new y.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",s(v.DocumentHighlight.to))),new y.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(l,g)=>{if(A.isFalsyOrEmpty(l))return;class c extends R.SymbolInformation{static to(_){const w=new c(_.name,v.SymbolKind.to(_.kind),_.containerName||"",new R.Location(g[0],v.Range.to(_.range)));return w.detail=_.detail,w.range=w.location.range,w.selectionRange=v.Range.to(_.selectionRange),w.children=_.children?_.children.map(c.to):[],w}}return l.map(c.to)})),new y.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",s(v.TextEdit.to))),new y.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range,new y.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",s(v.TextEdit.to))),new y.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,new y.ApiCommandArgument("ch","Trigger character",l=>typeof l=="string",l=>l),new y.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",s(v.TextEdit.to))),new y.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new y.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new y.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new y.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new y.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location-instances.",s(v.location.to))),new y.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Hover-instances.",s(v.Hover.to))),new y.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("position","A position in a text document",l=>Array.isArray(l)&&l.every(g=>R.Position.isPosition(g)),l=>l.map(v.Position.from))],new y.ApiCommandResult("A promise that resolves to an array of ranges.",l=>l.map(g=>{let c;for(const f of g.reverse())c=new R.SelectionRange(v.Range.to(f),c);return c}))),new y.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[y.ApiCommandArgument.String.with("query","Search string")],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",l=>{const g=[];if(Array.isArray(l))for(let c of l)g.push(...c[1].map(v.WorkspaceSymbol.to));return g})),new y.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(v.CallHierarchyItem.to))),new y.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(v.CallHierarchyIncomingCall.to))),new y.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(v.CallHierarchyOutgoingCall.to))),new y.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("newName","The new symbol name")],new y.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",l=>{if(!!l){if(l.rejectReason)throw new Error(l.rejectReason);return v.WorkspaceEdit.to(l)}})),new y.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new y.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",l=>l.map(v.DocumentLink.to))),new y.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",l=>{if(!!l)return new R.SemanticTokensLegend(l.tokenTypes,l.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",l=>{if(!l)return;const g=C.decodeSemanticTokensDto(l);if(g.type==="full")return new R.SemanticTokens(g.data,void 0)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",l=>{if(!!l)return new R.SemanticTokensLegend(l.tokenTypes,l.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",l=>{if(!l)return;const g=C.decodeSemanticTokensDto(l);if(g.type==="full")return new R.SemanticTokens(g.data,void 0)})),new y.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new y.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(l,g,c)=>{if(!l)return new R.CompletionList([]);const f=l.suggestions.map(_=>v.CompletionItem.to(_,c));return new R.CompletionList(f,l.incomplete)})),new y.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new y.ApiCommandResult("A promise that resolves to SignatureHelp.",l=>{if(l)return v.SignatureHelp.to(l)})),new y.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new y.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(l,g,c)=>s(f=>new R.CodeLens(v.Range.to(f.range),f.command&&c.fromInternal(f.command)))(l))),new y.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",l=>R.Range.isRange(l),l=>R.Selection.isSelection(l)?v.Selection.from(l):v.Range.from(l)),y.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new y.ApiCommandResult("A promise that resolves to an array of Command-instances.",(l,g,c)=>s(f=>{if(f._isSynthetic){if(!f.command)throw new Error("Synthetic code actions must have a command");return c.fromInternal(f.command)}else{const _=new R.CodeAction(f.title,f.kind?new R.CodeActionKind(f.kind):void 0);return f.edit&&(_.edit=v.WorkspaceEdit.to(f.edit)),f.command&&(_.command=c.fromInternal(f.command)),_.isPreferred=f.isPreferred,_}})(l))),new y.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",l=>l?l.map(g=>new R.ColorInformation(v.Range.to(g.range),v.Color.to(g.color))):[])),new y.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new y.ApiCommandArgument("color","The color to show and insert",l=>l instanceof R.Color,v.Color.from),new y.ApiCommandArgument("context","Context object with uri and range",l=>!0,l=>({uri:l.uri,range:v.Range.from(l.range)}))],new y.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",l=>l?l.map(v.ColorPresentation.to):[])),new y.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inline hints provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of Inlay objects",l=>l.map(v.InlayHint.to))),new y.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new y.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",s(l=>({viewType:l.viewType,displayName:l.displayName,options:{transientOutputs:l.options.transientOutputs,transientCellMetadata:l.options.transientCellMetadata,transientDocumentMetadata:l.options.transientDocumentMetadata},filenamePattern:l.filenamePattern.map(g=>v.NotebookExclusiveDocumentPattern.to(g))})))),new y.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of InlineValue objects",l=>l.map(v.InlineValue.to))),new y.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[l,void 0]:[v.ViewColumn.from(l.viewColumn),v.TextEditorOpenOptions.from(l)])).optional(),y.ApiCommandArgument.String.with("label","").optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[y.ApiCommandArgument.Uri.with("resource","Resource to open"),y.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[l,void 0]:[v.ViewColumn.from(l.viewColumn),v.TextEditorOpenOptions.from(l)])).optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[y.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),y.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),y.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="object",l=>l&&[v.ViewColumn.from(l.viewColumn),v.TextEditorOpenOptions.from(l)]).optional()],y.ApiCommandResult.Void)];class P{static register(g){D.forEach(g.registerApiCommand,g)}}e.ExtHostApiCommands=P;function s(l){return g=>{if(Array.isArray(g))return g.map(l)}}function I(l){if(!Array.isArray(l))return;const g=[];for(const c of l)k.isLocationLink(c)?g.push(v.DefinitionLink.to(c)):g.push(v.location.to(c));return g}}),define(ge[218],pe([0,1,14,50,3,6,2,79,26,18,7,5]),function(X,e,v,R,k,y,A,C,D,P,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCommentThread=e.ExtHostComments=void 0;class l{constructor(h,m,t){this._documents=t,this._commentControllers=new Map,this._commentControllersByExtension=new Map,this._proxy=h.getProxy(I.MainContext.MainThreadComments),m.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===6){const i=this._commentControllers.get(r.handle);return i||r}else if(r&&r.$mid===7){const i=this._commentControllers.get(r.commentControlHandle);if(!i)return r;const n=i.getCommentThread(r.commentThreadHandle);return n||r}else if(r&&r.$mid===8){const i=this._commentControllers.get(r.thread.commentControlHandle);if(!i)return r;const n=i.getCommentThread(r.thread.commentThreadHandle);return n?{thread:n,text:r.text}:r}else if(r&&r.$mid===9){const i=this._commentControllers.get(r.thread.commentControlHandle);if(!i)return r;const n=i.getCommentThread(r.thread.commentThreadHandle);if(!n)return r;let a=r.commentUniqueId,p=n.getCommentByUniqueId(a);return p||r}else if(r&&r.$mid===10){const i=this._commentControllers.get(r.thread.commentControlHandle);if(!i)return r;const n=i.getCommentThread(r.thread.commentThreadHandle);if(!n)return r;let a=r.text,p=r.commentUniqueId,d=n.getCommentByUniqueId(p);return d?(d.body=a,d):r}return r}})}createCommentController(h,m,t){const r=l.handlePool++,i=new c(h,r,this._proxy,m,t);this._commentControllers.set(i.handle,i);const n=this._commentControllersByExtension.get(D.ExtensionIdentifier.toKey(h.identifier))||[];return n.push(i),this._commentControllersByExtension.set(D.ExtensionIdentifier.toKey(h.identifier),n),i}$createCommentThreadTemplate(h,m,t){const r=this._commentControllers.get(h);!r||r.$createCommentThreadTemplate(m,t)}async $updateCommentThreadTemplate(h,m,t){const r=this._commentControllers.get(h);!r||r.$updateCommentThreadTemplate(m,t)}$deleteCommentThread(h,m){const t=this._commentControllers.get(h);t&&t.$deleteCommentThread(m)}$provideCommentingRanges(h,m,t){const r=this._commentControllers.get(h);if(!r||!r.commentingRangeProvider)return Promise.resolve(void 0);const i=this._documents.getDocument(A.URI.revive(m));return v.asPromise(()=>r.commentingRangeProvider.provideCommentingRanges(i,t)).then(n=>n?n.map(a=>P.Range.from(a)):void 0)}$toggleReaction(h,m,t,r,i){const n=this._commentControllers.get(h);return!n||!n.reactionHandler?Promise.resolve(void 0):v.asPromise(()=>{const a=n.getCommentThread(m);if(a){const p=a.getCommentByUniqueId(r.uniqueIdInThread);if(n!==void 0&&p&&n.reactionHandler)return n.reactionHandler(p,w(i))}return Promise.resolve(void 0)})}dispose(){}}e.ExtHostComments=l,l.handlePool=0;class g{constructor(h,m,t,r,i,n,a){this._proxy=h,this._commentController=m,this._id=t,this._uri=r,this._range=i,this._comments=n,this.handle=g._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new k.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new y.MutableDisposable,this._acceptInputDisposables.value=new y.DisposableStore,this._id===void 0&&(this._id=`${m.id}.${this.handle}`),this._proxy.$createCommentThread(this._commentController.handle,this.handle,this._id,this._uri,P.Range.from(this._range),a),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=n}set threadId(h){this._id=h}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(h){h.isEqual(this._range)||(this._range=h,this.modifications.range=h,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(h){this._canReply!==h&&(this._canReply=h,this.modifications.canReply=h,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(h){this._label=h,this.modifications.label=h,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(h){this._contextValue=h,this.modifications.contextValue=h,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(h){this._comments=h,this.modifications.comments=h,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(h){this._collapseState=h,this.modifications.collapsibleState=h,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new y.DisposableStore);const h=t=>Object.prototype.hasOwnProperty.call(this.modifications,t),m={};h("range")&&(m.range=P.Range.from(this._range)),h("label")&&(m.label=this.label),h("contextValue")&&(m.contextValue=this.contextValue),h("comments")&&(m.comments=this._comments.map(t=>f(this,this._commentController,t,this._commentsMap))),h("collapsibleState")&&(m.collapseState=E(this._collapseState)),h("canReply")&&(m.canReply=this.canReply),this.modifications={},this._proxy.$updateCommentThread(this._commentController.handle,this.handle,this._id,this._uri,m)}getCommentByUniqueId(h){for(let m of this._commentsMap){let t=m[0],r=m[1];if(h===r)return t}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(h=>h.dispose()),this._proxy.$deleteCommentThread(this._commentController.handle,this.handle)}}g._handlePool=0,Ve([R.debounce(100)],g.prototype,"eventuallyUpdateCommentThread",null),e.ExtHostCommentThread=g;class c{constructor(h,m,t,r,i){this._extension=h,this._handle=m,this._proxy=t,this._id=r,this._label=i,this._threads=new Map,this._proxy.$registerCommentController(this.handle,r,i)}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(h){this._reactionHandler=h,this._proxy.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!h})}get options(){return this._options}set options(h){this._options=h,this._proxy.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(h,m,t,r){if(typeof h=="string"){const i=new g(this._proxy,this,h,m,t,r,this._extension.identifier);return this._threads.set(i.handle,i),i}else{const i=new g(this._proxy,this,void 0,h,m,t,this._extension.identifier);return this._threads.set(i.handle,i),i}}$createCommentThreadTemplate(h,m){const t=new g(this._proxy,this,void 0,A.URI.revive(h),P.Range.to(m),[],this._extension.identifier);return t.collapsibleState=C.CommentThreadCollapsibleState.Expanded,this._threads.set(t.handle,t),t}$updateCommentThreadTemplate(h,m){let t=this._threads.get(h);t&&(t.range=P.Range.to(m))}$deleteCommentThread(h){let m=this._threads.get(h);m&&m.dispose(),this._threads.delete(h)}getCommentThread(h){return this._threads.get(h)}dispose(){this._threads.forEach(h=>{h.dispose()}),this._proxy.$unregisterCommentController(this.handle)}}function f(u,h,m,t){let r=t.get(m);r||(r=++u.commentHandle,t.set(m,r));const i=m.author&&m.author.iconPath?m.author.iconPath.toString():void 0;return{mode:m.mode,contextValue:m.contextValue,uniqueIdInThread:r,body:P.MarkdownString.from(m.body),userName:m.author.name,userIconPath:i,label:m.label,commentReactions:m.reactions?m.reactions.map(n=>_(n)):void 0}}function _(u){return{label:u.label,iconPath:u.iconPath?P.pathOrURIToURI(u.iconPath):void 0,count:u.count,hasReacted:u.authorHasReacted}}function w(u){return{label:u.label||"",count:u.count||0,iconPath:u.iconPath?A.URI.revive(u.iconPath):"",authorHasReacted:u.hasReacted||!1}}function E(u){if(u!==void 0)switch(u){case s.CommentThreadCollapsibleState.Expanded:return C.CommentThreadCollapsibleState.Expanded;case s.CommentThreadCollapsibleState.Collapsed:return C.CommentThreadCollapsibleState.Collapsed}return C.CommentThreadCollapsibleState.Collapsed}}),define(ge[125],pe([0,1,2,5,7,4,12,15,17,8,9]),function(X,e,v,R,k,y,A,C,D,P,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let I=class bn{constructor(g,c){this._logService=c,this._provider=new Map,this._proxy=g.getProxy(R.MainContext.MainThreadDecorations)}registerFileDecorationProvider(g,c){const f=bn._handlePool++;this._provider.set(f,{provider:g,extensionId:c}),this._proxy.$registerDecorationProvider(f,c.value);const _=g.onDidChangeFileDecorations&&g.onDidChangeFileDecorations(w=>{if(!w){this._proxy.$onDidChange(f,null);return}let E=D.asArray(w);if(E.length<=bn._maxEventSize){this._proxy.$onDidChange(f,E);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",c.value,E.length);const u=E.map(t=>({uri:t,rank:P.count(t.path,"/")})),h=D.groupBy(u,(t,r)=>t.rank-r.rank||P.compare(t.uri.path,r.uri.path));let m=[];e:for(let t of h){let r;for(let i of t){let n=s.dirname(i.uri.path);if(r!==n&&(r=n,m.push(i.uri)>=bn._maxEventSize))break e}}this._proxy.$onDidChange(f,m)});return new k.Disposable(()=>{_==null||_.dispose(),this._proxy.$unregisterDecorationProvider(f),this._provider.delete(f)})}async $provideDecorations(g,c,f){if(!this._provider.has(g))return Object.create(null);const _=Object.create(null),{provider:w,extensionId:E}=this._provider.get(g);return await Promise.all(c.map(async u=>{try{const{uri:h,id:m}=u,t=await Promise.resolve(w.provideFileDecoration(v.URI.revive(h),f));if(!t)return;try{k.FileDecoration.validate(t),_[m]=[t.propagate,t.tooltip,t.badge,t.color]}catch(r){this._logService.warn(`INVALID decoration from extension '${E.value}': ${r}`)}}catch(h){this._logService.error(h)}})),_}};I._handlePool=0,I._maxEventSize=250,I=Ve([We(0,A.IExtHostRpcService),We(1,C.ILogService)],I),e.ExtHostDecorations=I,e.IExtHostDecorations=y.createDecorator("IExtHostDecorations")}),define(ge[219],pe([0,1,158,113,2,5,7,18,3,15,23]),function(X,e,v,R,k,y,A,C,D,P,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class I{constructor(c,f,_,w,E){this._name=c,this._owner=f,this._maxDiagnosticsPerFile=_,this._proxy=w,this._onDidChangeDiagnostics=E,this._isDisposed=!1,this._data=new s.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(c,f){if(!c){this.clear();return}this._checkDisposed();let _=[];if(k.URI.isUri(c)){if(!f){this.delete(c);return}this._data.set(c,f.slice()),_=[c]}else if(Array.isArray(c)){_=[];let E;c=[...c].sort(I._compareIndexedTuplesByUri);for(const u of c){const[h,m]=u;if((!E||h.toString()!==E.toString())&&(E&&this._data.get(E).length===0&&this._data.delete(E),E=h,_.push(h),this._data.set(h,[])),m){const t=this._data.get(h);t&&t.push(...m)}else{const t=this._data.get(h);t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(_),!this._proxy)return;const w=[];for(let E of _){let u=[];const h=this._data.get(E);if(h)if(h.length>this._maxDiagnosticsPerFile){u=[];const m=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let r of h)if(r.severity===m[t]&&u.push(C.Diagnostic.from(r))===this._maxDiagnosticsPerFile)break e;u.push({severity:R.MarkerSeverity.Info,message:v.localize(0,null,h.length-this._maxDiagnosticsPerFile),startLineNumber:u[u.length-1].startLineNumber,startColumn:u[u.length-1].startColumn,endLineNumber:u[u.length-1].endLineNumber,endColumn:u[u.length-1].endColumn})}else u=h.map(m=>C.Diagnostic.from(m));w.push([E,u])}this._proxy.$changeMany(this._owner,w)}delete(c){this._checkDisposed(),this._onDidChangeDiagnostics.fire([c]),this._data.delete(c),this._proxy&&this._proxy.$changeMany(this._owner,[[c,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(c,f){this._checkDisposed();for(let _ of this._data.keys())c.apply(f,[_,this.get(_),this])}get(c){this._checkDisposed();const f=this._data.get(c);return Array.isArray(f)?Object.freeze(f.slice(0)):[]}has(c){return this._checkDisposed(),Array.isArray(this._data.get(c))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(c,f){return c[0].toString()<f[0].toString()?-1:c[0].toString()>f[0].toString()?1:0}}e.DiagnosticCollection=I;let l=class jt{constructor(c,f){this._logService=f,this._collections=new Map,this._onDidChangeDiagnostics=new D.Emitter,this.onDidChangeDiagnostics=D.Event.map(D.Event.debounce(this._onDidChangeDiagnostics.event,jt._debouncer,50),jt._mapper),this._proxy=c.getProxy(y.MainContext.MainThreadDiagnostics)}static _debouncer(c,f){return c?c.concat(f):f}static _mapper(c){const f=new s.ResourceMap;for(const _ of c)f.set(_,_);return{uris:Object.freeze(Array.from(f.values()))}}createDiagnosticCollection(c,f){const{_collections:_,_proxy:w,_onDidChangeDiagnostics:E,_logService:u}=this,h=new class{$changeMany(r,i){w.$changeMany(r,i),u.trace("[DiagnosticCollection] change many (extension, owner, uris)",c.value,r,i.length===0?"CLEARING":i)}$clear(r){w.$clear(r),u.trace("[DiagnosticCollection] remove all (extension, owner)",c.value,r)}dispose(){w.dispose()}};let m;if(!f)f="_generated_diagnostic_collection_name_#"+jt._idPool++,m=f;else if(!_.has(f))m=f;else{this._logService.warn(`DiagnosticCollection with name '${f}' does already exist.`);do m=f+jt._idPool++;while(_.has(m))}return new class extends I{constructor(){super(f,m,jt._maxDiagnosticsPerFile,h,E);_.set(m,this)}dispose(){super.dispose(),_.delete(m)}}}getDiagnostics(c){if(c)return this._getDiagnostics(c);{const f=new Map,_=[];for(const w of this._collections.values())w.forEach((E,u)=>{let h=f.get(E.toString());typeof h=="undefined"&&(h=_.length,f.set(E.toString(),h),_.push([E,[]])),_[h][1]=_[h][1].concat(...u)});return _}}_getDiagnostics(c){let f=[];for(let _ of this._collections.values())_.has(c)&&(f=f.concat(_.get(c)));return f}$acceptMarkersChange(c){if(!this._mirrorCollection){const f="_generated_mirror",_=new I(f,f,jt._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(f,_),this._mirrorCollection=_}for(const[f,_]of c)this._mirrorCollection.set(k.URI.revive(f),_.map(C.Diagnostic.to))}};l._idPool=0,l._maxDiagnosticsPerFile=1e3,l=Ve([We(1,P.ILogService)],l),e.ExtHostDiagnostics=l}),define(ge[220],pe([0,1,2,5]),function(X,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class k{constructor(A){this._proxy=A.getProxy(R.MainContext.MainThreadDialogs)}showOpenDialog(A){return this._proxy.$showOpenDialog(A).then(C=>C?C.map(D=>v.URI.revive(D)):void 0)}showSaveDialog(A){return this._proxy.$showSaveDialog(A).then(C=>C?v.URI.revive(C):void 0)}}e.ExtHostDialogs=k}),define(ge[221],pe([0,1,16,2,7,5,10,21,8]),function(X,e,v,R,k,y,A,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class P{constructor(I,l,g){this._documentsAndEditors=l,this._logService=g,this._documentContentProviders=new Map,this._proxy=I.getProxy(y.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(I,l){if(Object.keys(A.Schemas).indexOf(I)>=0)throw new Error(`scheme '${I}' already registered`);const g=P._handlePool++;this._documentContentProviders.set(g,l),this._proxy.$registerTextContentProvider(g,I);let c;return typeof l.onDidChange=="function"&&(c=l.onDidChange(f=>{if(f.scheme!==I){this._logService.warn(`Provider for scheme '${I}' is firing event for schema '${f.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(f)&&this.$provideTextDocumentContent(g,f).then(_=>{if(!_&&typeof _!="string")return;const w=this._documentsAndEditors.getDocument(f);if(!w)return;const E=D.splitLines(_);if(!w.equalLines(E))return this._proxy.$onVirtualDocumentChange(f,_)},v.onUnexpectedError)})),new k.Disposable(()=>{this._documentContentProviders.delete(g)&&this._proxy.$unregisterTextContentProvider(g),c&&(c.dispose(),c=void 0)})}$provideTextDocumentContent(I,l){const g=this._documentContentProviders.get(I);return g?Promise.resolve(g.provideTextDocumentContent(R.URI.revive(l),C.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${l.scheme}`))}}e.ExtHostDocumentContentProvider=P,P._handlePool=0}),define(ge[222],pe([0,1,3,6,2,5,118,18,13,25]),function(X,e,v,R,k,y,A,C,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class s{constructor(l,g){this._onDidAddDocument=new v.Emitter,this._onDidRemoveDocument=new v.Emitter,this._onDidChangeDocument=new v.Emitter,this._onDidSaveDocument=new v.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new R.DisposableStore,this._documentLoader=new Map,this._proxy=l.getProxy(y.MainContext.MainThreadDocuments),this._documentsAndEditors=g,this._documentsAndEditors.onDidRemoveDocuments(c=>{for(const f of c)this._onDidRemoveDocument.fire(f.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(c=>{for(const f of c)this._onDidAddDocument.fire(f.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(l){if(!l)return;const g=this._documentsAndEditors.getDocument(l);if(g)return g}getDocument(l){const g=this.getDocumentData(l);if(!(g==null?void 0:g.document))throw new Error(`Unable to retrieve document from URI '${l}'`);return g.document}ensureDocumentData(l){const g=this._documentsAndEditors.getDocument(l);if(g)return Promise.resolve(g);let c=this._documentLoader.get(l.toString());return c||(c=this._proxy.$tryOpenDocument(l).then(f=>{this._documentLoader.delete(l.toString());const _=k.URI.revive(f);return D.assertIsDefined(this._documentsAndEditors.getDocument(_))},f=>(this._documentLoader.delete(l.toString()),Promise.reject(f))),this._documentLoader.set(l.toString(),c)),c}createDocumentData(l){return this._proxy.$tryCreateDocument(l).then(g=>k.URI.revive(g))}$acceptModelModeChanged(l,g){const c=k.URI.revive(l),f=this._documentsAndEditors.getDocument(c);if(!f)throw new Error("unknown document");this._onDidRemoveDocument.fire(f.document),f._acceptLanguageId(g),this._onDidAddDocument.fire(f.document)}$acceptModelSaved(l){const g=k.URI.revive(l),c=this._documentsAndEditors.getDocument(g);if(!c)throw new Error("unknown document");this.$acceptDirtyStateChanged(l,!1),this._onDidSaveDocument.fire(c.document)}$acceptDirtyStateChanged(l,g){const c=k.URI.revive(l),f=this._documentsAndEditors.getDocument(c);if(!f)throw new Error("unknown document");f._acceptIsDirty(g),this._onDidChangeDocument.fire({document:f.document,contentChanges:[]})}$acceptModelChanged(l,g,c){const f=k.URI.revive(l),_=this._documentsAndEditors.getDocument(f);if(!_)throw new Error("unknown document");_._acceptIsDirty(c),_.onEvents(g),this._onDidChangeDocument.fire(P.deepFreeze({document:_.document,contentChanges:g.changes.map(w=>({range:C.Range.to(w.range),rangeOffset:w.rangeOffset,rangeLength:w.rangeLength,text:w.text}))}))}setWordDefinitionFor(l,g){A.setWordDefinitionFor(l,g)}}e.ExtHostDocuments=s}),define(ge[39],pe([0,1,49,3,6,2,4,5,118,12,123,18,15,23,10,71,133]),function(X,e,v,R,k,y,A,C,D,P,s,I,l,g,c,f,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class w{constructor(h){this.value=h,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let E=class{constructor(h,m){this._extHostRpc=h,this._logService=m,this._activeEditorId=null,this._editors=new Map,this._documents=new g.ResourceMap,this._onDidAddDocuments=new R.Emitter,this._onDidRemoveDocuments=new R.Emitter,this._onDidChangeVisibleTextEditors=new R.Emitter,this._onDidChangeActiveTextEditor=new R.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(h){this.acceptDocumentsAndEditorsDelta(h)}acceptDocumentsAndEditorsDelta(h){const m=[],t=[],r=[];if(h.removedDocuments)for(const i of h.removedDocuments){const n=y.URI.revive(i),a=this._documents.get(n);(a==null?void 0:a.unref())&&(this._documents.delete(n),m.push(a.value))}if(h.addedDocuments)for(const i of h.addedDocuments){const n=y.URI.revive(i.uri);let a=this._documents.get(n);if(a&&n.scheme!==c.Schemas.vscodeNotebookCell)throw new Error(`document '${n} already exists!'`);a||(a=new w(new D.ExtHostDocumentData(this._extHostRpc.getProxy(C.MainContext.MainThreadDocuments),n,i.lines,i.EOL,i.versionId,i.modeId,i.isDirty,i.notebook)),this._documents.set(n,a),t.push(a.value)),a.ref()}if(h.removedEditors)for(const i of h.removedEditors){const n=this._editors.get(i);this._editors.delete(i),n&&r.push(n)}if(h.addedEditors)for(const i of h.addedEditors){const n=y.URI.revive(i.documentUri);v.ok(this._documents.has(n),`document '${n}' does not exist`),v.ok(!this._editors.has(i.id),`editor '${i.id}' already exists!`);const a=this._documents.get(n).value,p=new s.ExtHostTextEditor(i.id,this._extHostRpc.getProxy(C.MainContext.MainThreadTextEditors),this._logService,new _.Lazy(()=>a.document),i.selections.map(I.Selection.to),i.options,i.visibleRanges.map(d=>I.Range.to(d)),typeof i.editorPosition=="number"?I.ViewColumn.to(i.editorPosition):void 0);this._editors.set(i.id,p)}h.newActiveEditor!==void 0&&(v.ok(h.newActiveEditor===null||this._editors.has(h.newActiveEditor),`active editor '${h.newActiveEditor}' does not exist`),this._activeEditorId=h.newActiveEditor),k.dispose(m),k.dispose(r),h.removedDocuments&&this._onDidRemoveDocuments.fire(m),h.addedDocuments&&this._onDidAddDocuments.fire(t),(h.removedEditors||h.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(i=>i.value)),h.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(h){var m;return(m=this._documents.get(h))===null||m===void 0?void 0:m.value}allDocuments(){return f.Iterable.map(this._documents.values(),h=>h.value)}getEditor(h){return this._editors.get(h)}activeEditor(h){if(!this._activeEditorId)return;const m=this._editors.get(this._activeEditorId);return h?m:m==null?void 0:m.value}allEditors(){return[...this._editors.values()]}};E=Ve([We(0,P.IExtHostRpcService),We(1,l.ILogService)],E),e.ExtHostDocumentsAndEditors=E,e.IExtHostDocumentsAndEditors=A.createDecorator("IExtHostDocumentsAndEditors")}),define(ge[223],pe([0,1,2,5,6,7,18,142,8,22]),function(X,e,v,R,k,y,A,C,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class s{constructor(){this._schemes=[]}add(g){this._stateMachine=void 0,this._schemes.push(g)}delete(g){const c=this._schemes.indexOf(g);c>=0&&(this._schemes.splice(c,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const g=this._schemes.sort(),c=[];let f,_,w=14,E=14;for(const u of g){let h=f?D.commonPrefixLength(f,u):0;for(h===0?_=1:_=E;h<u.length;h++)h+1===u.length?(w=E,E=9):E+=1,c.push([_,u.toUpperCase().charCodeAt(h),E]),c.push([_,u.toLowerCase().charCodeAt(h),E]),_=E;f=u,E=w}c.push([9,58,10]),c.push([10,47,12]),this._stateMachine=new C.StateMachine(c)}}provideDocumentLinks(g){this._initStateMachine();const c=[],f=C.LinkComputer.computeLinks({getLineContent(_){return g.lineAt(_-1).text},getLineCount(){return g.lineCount}},this._stateMachine);for(const _ of f){const w=A.DocumentLink.to(_);w.target&&c.push(w)}return c}}class I{constructor(g,c){this._extHostLanguageFeatures=c,this._linkProvider=new s,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._enableProposedApi=new Map,this._handlePool=0,this._proxy=g.getProxy(R.MainContext.MainThreadFileSystem)}dispose(){var g;(g=this._linkProviderRegistration)===null||g===void 0||g.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(g,c,f,_={},w){if(this._registeredSchemes.has(c))throw new Error(`a provider for the scheme '${c}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const E=this._handlePool++;this._linkProvider.add(c),this._registeredSchemes.add(c),this._fsProvider.set(E,f),this._enableProposedApi.set(E,w??!1);let u=2;_.isCaseSensitive&&(u+=1024),_.isReadonly&&(u+=2048),typeof f.copy=="function"&&(u+=8),typeof f.open=="function"&&typeof f.close=="function"&&typeof f.read=="function"&&typeof f.write=="function"&&(u+=4),this._proxy.$registerFileSystemProvider(E,c,u).catch(m=>{console.error(`FAILED to register filesystem provider of ${g.value}-extension for the scheme ${c}`),console.error(m)});const h=f.onDidChangeFile(m=>{const t=[];for(const r of m){let{uri:i,type:n}=r;if(i.scheme!==c)continue;let a;switch(n){case y.FileChangeType.Changed:a=0;break;case y.FileChangeType.Created:a=1;break;case y.FileChangeType.Deleted:a=2;break;default:throw new Error("Unknown FileChangeType")}t.push({resource:i,type:a})}this._proxy.$onFileSystemChange(E,t)});return k.toDisposable(()=>{h.dispose(),this._linkProvider.delete(c),this._registeredSchemes.delete(c),this._fsProvider.delete(E),this._enableProposedApi.delete(E),this._proxy.$unregisterProvider(E)})}static _asIStat(g,c){const{type:f,ctime:_,mtime:w,size:E,permissions:u}=g;return c?{type:f,ctime:_,mtime:w,size:E,permissions:u}:{type:f,ctime:_,mtime:w,size:E}}$stat(g,c){return Promise.resolve(this._getFsProvider(g).stat(v.URI.revive(c))).then(f=>{var _;return I._asIStat(f,(_=this._enableProposedApi.get(g))!==null&&_!==void 0?_:!1)})}$readdir(g,c){return Promise.resolve(this._getFsProvider(g).readDirectory(v.URI.revive(c)))}$readFile(g,c){return Promise.resolve(this._getFsProvider(g).readFile(v.URI.revive(c))).then(f=>P.VSBuffer.wrap(f))}$writeFile(g,c,f,_){return Promise.resolve(this._getFsProvider(g).writeFile(v.URI.revive(c),f.buffer,_))}$delete(g,c,f){return Promise.resolve(this._getFsProvider(g).delete(v.URI.revive(c),f))}$rename(g,c,f,_){return Promise.resolve(this._getFsProvider(g).rename(v.URI.revive(c),v.URI.revive(f),_))}$copy(g,c,f,_){const w=this._getFsProvider(g);if(!w.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(w.copy(v.URI.revive(c),v.URI.revive(f),_))}$mkdir(g,c){return Promise.resolve(this._getFsProvider(g).createDirectory(v.URI.revive(c)))}$watch(g,c,f,_){const w=this._getFsProvider(g).watch(v.URI.revive(f),_);this._watches.set(c,w)}$unwatch(g,c){const f=this._watches.get(c);f&&(f.dispose(),this._watches.delete(c))}$open(g,c,f){const _=this._getFsProvider(g);if(!_.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(_.open(v.URI.revive(c),f))}$close(g,c){const f=this._getFsProvider(g);if(!f.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(f.close(c))}$read(g,c,f,_){const w=this._getFsProvider(g);if(!w.read)throw new Error('FileSystemProvider does not implement "read"');const E=P.VSBuffer.alloc(_);return Promise.resolve(w.read(c,f,E.buffer,0,_)).then(u=>E.slice(0,u))}$write(g,c,f,_){const w=this._getFsProvider(g);if(!w.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(w.write(c,f,_.buffer,0,_.byteLength))}_getFsProvider(g){const c=this._fsProvider.get(g);if(!c){const f=new Error;throw f.name="ENOPRO",f.message="no provider",f}return c}}e.ExtHostFileSystem=I}),define(ge[87],pe([0,1,5,42,7,22,4,12,58]),function(X,e,v,R,k,y,A,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let P=class Ut{constructor(I,l){const g=I.getProxy(v.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(c){return g.$stat(c).catch(Ut._handleError)},readDirectory(c){return g.$readdir(c).catch(Ut._handleError)},createDirectory(c){return g.$mkdir(c).catch(Ut._handleError)},async readFile(c){return g.$readFile(c).then(f=>f.buffer).catch(Ut._handleError)},writeFile(c,f){return g.$writeFile(c,y.VSBuffer.wrap(f)).catch(Ut._handleError)},delete(c,f){return g.$delete(c,Object.assign({recursive:!1,useTrash:!1},f)).catch(Ut._handleError)},rename(c,f,_){return g.$rename(c,f,Object.assign({overwrite:!1},_)).catch(Ut._handleError)},copy(c,f,_){return g.$copy(c,f,Object.assign({overwrite:!1},_)).catch(Ut._handleError)},isWritableFileSystem(c){const f=l.getCapabilities(c);if(typeof f=="number")return!(f&2048)}})}static _handleError(I){if(!(I instanceof Error))throw new k.FileSystemError(String(I));if(I.name==="ENOPRO")throw k.FileSystemError.Unavailable(I.message);switch(I.name){case R.FileSystemProviderErrorCode.FileExists:throw k.FileSystemError.FileExists(I.message);case R.FileSystemProviderErrorCode.FileNotFound:throw k.FileSystemError.FileNotFound(I.message);case R.FileSystemProviderErrorCode.FileNotADirectory:throw k.FileSystemError.FileNotADirectory(I.message);case R.FileSystemProviderErrorCode.FileIsADirectory:throw k.FileSystemError.FileIsADirectory(I.message);case R.FileSystemProviderErrorCode.NoPermissions:throw k.FileSystemError.NoPermissions(I.message);case R.FileSystemProviderErrorCode.Unavailable:throw k.FileSystemError.Unavailable(I.message);default:throw new k.FileSystemError(I.message,I.name)}}};P=Ve([We(0,C.IExtHostRpcService),We(1,D.IExtHostFileSystemInfo)],P),e.ExtHostConsumerFileSystem=P,e.IExtHostConsumerFileSystem=A.createDecorator("IExtHostConsumerFileSystem")}),define(ge[224],pe([0,1,6,5]),function(X,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class k{constructor(A){this._handlePool=0,this._proxy=A.getProxy(R.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(A){const C=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(C,A),v.toDisposable(()=>{this._proxy.$unregisterResourceLabelFormatter(C)})}}e.ExtHostLabelService=k}),define(ge[225],pe([0,1,2,25,18,7,14,5,8,41,17,13,139,6,107,70,83,43,16,3]),function(X,e,v,R,k,y,A,C,D,P,s,I,l,g,c,f,_,w,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class h{constructor(j,Z){this._documents=j,this._provider=Z}provideDocumentSymbols(j,Z){const ne=this._documents.getDocument(j);return A.asPromise(()=>this._provider.provideDocumentSymbols(ne,Z)).then(ae=>{if(!s.isFalsyOrEmpty(ae))return ae[0]instanceof y.DocumentSymbol?ae.map(k.DocumentSymbol.from):h._asDocumentSymbolTree(ae)})}static _asDocumentSymbolTree(j){var Z;j=j.slice(0).sort((Y,ce)=>{let me=Y.location.range.start.compareTo(ce.location.range.start);return me===0&&(me=ce.location.range.end.compareTo(Y.location.range.end)),me});const ne=[],ae=[];for(const Y of j){const ce={name:Y.name||"!!MISSING: name!!",kind:k.SymbolKind.from(Y.kind),tags:((Z=Y.tags)===null||Z===void 0?void 0:Z.map(k.SymbolTag.from))||[],detail:"",containerName:Y.containerName,range:k.Range.from(Y.location.range),selectionRange:k.Range.from(Y.location.range),children:[]};for(;;){if(ae.length===0){ae.push(ce),ne.push(ce);break}const me=ae[ae.length-1];if(P.Range.containsRange(me.range,ce.range)&&!P.Range.equalsRange(me.range,ce.range)){me.children&&me.children.push(ce),ae.push(ce);break}ae.pop()}}return ne}}class m{constructor(j,Z,ne){this._documents=j,this._commands=Z,this._provider=ne,this._cache=new _.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(j,Z){const ne=this._documents.getDocument(j),ae=await this._provider.provideCodeLenses(ne,Z);if(!ae||Z.isCancellationRequested)return;const Y=this._cache.add(ae),ce=new g.DisposableStore;this._disposables.set(Y,ce);const me={cacheId:Y,lenses:[]};for(let Re=0;Re<ae.length;Re++)me.lenses.push({cacheId:[Y,Re],range:k.Range.from(ae[Re].range),command:this._commands.toInternal(ae[Re].command,ce)});return me}async resolveCodeLens(j,Z){var ne;const ae=j.cacheId&&this._cache.get(...j.cacheId);if(!ae)return;let Y;if(typeof this._provider.resolveCodeLens!="function"||ae.isResolved?Y=ae:Y=await this._provider.resolveCodeLens(ae,Z),Y||(Y=ae),Z.isCancellationRequested)return;const ce=j.cacheId&&this._disposables.get(j.cacheId[0]);if(!!ce)return j.command=this._commands.toInternal((ne=Y.command)!==null&&ne!==void 0?ne:m._badCmd,ce),j}releaseCodeLenses(j){var Z;(Z=this._disposables.get(j))===null||Z===void 0||Z.dispose(),this._disposables.delete(j),this._cache.delete(j)}}m._badCmd={command:"missing",title:"!!MISSING: command!!"};function t(qe){return Array.isArray(qe)?qe.map(k.DefinitionLink.from):qe?[k.DefinitionLink.from(qe)]:[]}class r{constructor(j,Z){this._documents=j,this._provider=Z}provideDefinition(j,Z,ne){const ae=this._documents.getDocument(j),Y=k.Position.to(Z);return A.asPromise(()=>this._provider.provideDefinition(ae,Y,ne)).then(t)}}class i{constructor(j,Z){this._documents=j,this._provider=Z}provideDeclaration(j,Z,ne){const ae=this._documents.getDocument(j),Y=k.Position.to(Z);return A.asPromise(()=>this._provider.provideDeclaration(ae,Y,ne)).then(t)}}class n{constructor(j,Z){this._documents=j,this._provider=Z}provideImplementation(j,Z,ne){const ae=this._documents.getDocument(j),Y=k.Position.to(Z);return A.asPromise(()=>this._provider.provideImplementation(ae,Y,ne)).then(t)}}class a{constructor(j,Z){this._documents=j,this._provider=Z}provideTypeDefinition(j,Z,ne){const ae=this._documents.getDocument(j),Y=k.Position.to(Z);return A.asPromise(()=>this._provider.provideTypeDefinition(ae,Y,ne)).then(t)}}class p{constructor(j,Z){this._documents=j,this._provider=Z}provideHover(j,Z,ne){const ae=this._documents.getDocument(j),Y=k.Position.to(Z);return A.asPromise(()=>this._provider.provideHover(ae,Y,ne)).then(ce=>{if(!(!ce||s.isFalsyOrEmpty(ce.contents)))return ce.range||(ce.range=ae.getWordRangeAtPosition(Y)),ce.range||(ce.range=new y.Range(Y,Y)),k.Hover.from(ce)})}}class d{constructor(j,Z){this._documents=j,this._provider=Z}provideEvaluatableExpression(j,Z,ne){const ae=this._documents.getDocument(j),Y=k.Position.to(Z);return A.asPromise(()=>this._provider.provideEvaluatableExpression(ae,Y,ne)).then(ce=>{if(ce)return k.EvaluatableExpression.from(ce)})}}class b{constructor(j,Z){this._documents=j,this._provider=Z}provideInlineValues(j,Z,ne,ae){const Y=this._documents.getDocument(j);return A.asPromise(()=>this._provider.provideInlineValues(Y,k.Range.to(Z),k.InlineValueContext.to(ne),ae)).then(ce=>{if(Array.isArray(ce))return ce.map(me=>k.InlineValue.from(me))})}}class S{constructor(j,Z){this._documents=j,this._provider=Z}provideDocumentHighlights(j,Z,ne){const ae=this._documents.getDocument(j),Y=k.Position.to(Z);return A.asPromise(()=>this._provider.provideDocumentHighlights(ae,Y,ne)).then(ce=>{if(Array.isArray(ce))return ce.map(k.DocumentHighlight.from)})}}class o{constructor(j,Z){this._documents=j,this._provider=Z}provideLinkedEditingRanges(j,Z,ne){const ae=this._documents.getDocument(j),Y=k.Position.to(Z);return A.asPromise(()=>this._provider.provideLinkedEditingRanges(ae,Y,ne)).then(ce=>{if(ce&&Array.isArray(ce.ranges))return{ranges:s.coalesce(ce.ranges.map(k.Range.from)),wordPattern:ce.wordPattern}})}}class L{constructor(j,Z){this._documents=j,this._provider=Z}provideReferences(j,Z,ne,ae){const Y=this._documents.getDocument(j),ce=k.Position.to(Z);return A.asPromise(()=>this._provider.provideReferences(Y,ce,ne,ae)).then(me=>{if(Array.isArray(me))return me.map(k.location.from)})}}class O{constructor(j,Z,ne,ae,Y,ce,me){this._documents=j,this._commands=Z,this._diagnostics=ne,this._provider=ae,this._logService=Y,this._extension=ce,this._apiDeprecation=me,this._cache=new _.Cache("CodeAction"),this._disposables=new Map}provideCodeActions(j,Z,ne,ae){const Y=this._documents.getDocument(j),ce=l.Selection.isISelection(Z)?k.Selection.to(Z):k.Range.to(Z),me=[];for(const He of this._diagnostics.getDiagnostics(j))if(ce.intersection(He.range)&&me.push(He)>O._maxCodeActionsPerFile)break;const Re={diagnostics:me,only:ne.only?new y.CodeActionKind(ne.only):void 0,triggerKind:k.CodeActionTriggerKind.to(ne.trigger)};return A.asPromise(()=>this._provider.provideCodeActions(Y,ce,Re,ae)).then(He=>{var be;if(!s.isNonEmptyArray(He)||ae.isCancellationRequested)return;const Xe=this._cache.add(He),Q=new g.DisposableStore;this._disposables.set(Xe,Q);const re=[];for(let ve=0;ve<He.length;ve++){const Me=He[ve];!Me||(O._isCommand(Me)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),re.push({_isSynthetic:!0,title:Me.title,command:this._commands.toInternal(Me,Q)})):(Re.only&&(Me.kind?Re.only.contains(Me.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Re.only.value} 'requested but returned code action is of kind '${Me.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Re.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),re.push({cacheId:[Xe,ve],title:Me.title,command:Me.command&&this._commands.toInternal(Me.command,Q),diagnostics:Me.diagnostics&&Me.diagnostics.map(k.Diagnostic.from),edit:Me.edit&&k.WorkspaceEdit.from(Me.edit),kind:Me.kind&&Me.kind.value,isPreferred:Me.isPreferred,disabled:(be=Me.disabled)===null||be===void 0?void 0:be.reason})))}return{cacheId:Xe,actions:re}})}async resolveCodeAction(j,Z){var ne;const[ae,Y]=j,ce=this._cache.get(ae,Y);if(!ce||O._isCommand(ce)||!this._provider.resolveCodeAction)return;const me=(ne=await this._provider.resolveCodeAction(ce,Z))!==null&&ne!==void 0?ne:ce;return(me==null?void 0:me.edit)?k.WorkspaceEdit.from(me.edit):void 0}releaseCodeActions(j){var Z;(Z=this._disposables.get(j))===null||Z===void 0||Z.dispose(),this._disposables.delete(j),this._cache.delete(j)}static _isCommand(j){return typeof j.command=="string"&&typeof j.title=="string"}}O._maxCodeActionsPerFile=1e3;class W{constructor(j,Z){this._documents=j,this._provider=Z}provideDocumentFormattingEdits(j,Z,ne){const ae=this._documents.getDocument(j);return A.asPromise(()=>this._provider.provideDocumentFormattingEdits(ae,Z,ne)).then(Y=>{if(Array.isArray(Y))return Y.map(k.TextEdit.from)})}}class J{constructor(j,Z){this._documents=j,this._provider=Z}provideDocumentRangeFormattingEdits(j,Z,ne,ae){const Y=this._documents.getDocument(j),ce=k.Range.to(Z);return A.asPromise(()=>this._provider.provideDocumentRangeFormattingEdits(Y,ce,ne,ae)).then(me=>{if(Array.isArray(me))return me.map(k.TextEdit.from)})}}class oe{constructor(j,Z){this._documents=j,this._provider=Z,this.autoFormatTriggerCharacters=[]}provideOnTypeFormattingEdits(j,Z,ne,ae,Y){const ce=this._documents.getDocument(j),me=k.Position.to(Z);return A.asPromise(()=>this._provider.provideOnTypeFormattingEdits(ce,me,ne,ae,Y)).then(Re=>{if(Array.isArray(Re))return Re.map(k.TextEdit.from)})}}class q{constructor(j,Z){this._provider=j,this._logService=Z,this._symbolCache=new Map,this._resultCache=new Map}provideWorkspaceSymbols(j,Z){const ne=C.IdObject.mixin({symbols:[]});return A.asPromise(()=>this._provider.provideWorkspaceSymbols(j,Z)).then(ae=>{if(s.isNonEmptyArray(ae))for(const Y of ae){if(!Y)continue;if(!Y.name){this._logService.warn("INVALID SymbolInformation, lacks name",Y);continue}const ce=C.IdObject.mixin(k.WorkspaceSymbol.from(Y));this._symbolCache.set(ce._id,Y),ne.symbols.push(ce)}}).then(()=>(ne.symbols.length>0&&this._resultCache.set(ne._id,[ne.symbols[0]._id,ne.symbols[ne.symbols.length-1]._id]),ne))}async resolveWorkspaceSymbol(j,Z){if(typeof this._provider.resolveWorkspaceSymbol!="function")return j;const ne=this._symbolCache.get(j._id);if(ne){const ae=await A.asPromise(()=>this._provider.resolveWorkspaceSymbol(ne,Z));return ae&&R.mixin(j,k.WorkspaceSymbol.from(ae),!0)}}releaseWorkspaceSymbols(j){const Z=this._resultCache.get(j);if(Z){for(let[ne,ae]=Z;ne<=ae;ne++)this._symbolCache.delete(ne);this._resultCache.delete(j)}}}class x{constructor(j,Z,ne){this._documents=j,this._provider=Z,this._logService=ne}static supportsResolving(j){return typeof j.prepareRename=="function"}provideRenameEdits(j,Z,ne,ae){const Y=this._documents.getDocument(j),ce=k.Position.to(Z);return A.asPromise(()=>this._provider.provideRenameEdits(Y,ce,ne,ae)).then(me=>{if(!!me)return k.WorkspaceEdit.from(me)},me=>{const Re=x._asMessage(me);return Re?{rejectReason:Re,edits:void 0}:Promise.reject(me)})}resolveRenameLocation(j,Z,ne){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const ae=this._documents.getDocument(j),Y=k.Position.to(Z);return A.asPromise(()=>this._provider.prepareRename(ae,Y,ne)).then(ce=>{let me,Re;if(y.Range.isRange(ce)?(me=ce,Re=ae.getText(ce)):I.isObject(ce)&&(me=ce.range,Re=ce.placeholder),!!me){if(me.start.line>Y.line||me.end.line<Y.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:k.Range.from(me),text:Re}}},ce=>{const me=x._asMessage(ce);return me?{rejectReason:me,range:void 0,text:void 0}:Promise.reject(ce)})}static _asMessage(j){return typeof j=="string"?j:j instanceof Error&&typeof j.message=="string"?j.message:void 0}}class V{constructor(j,Z){this.resultId=j,this.tokens=Z}}class T{constructor(j,Z){this._documents=j,this._provider=Z,this._nextResultId=1,this._previousResults=new Map}provideDocumentSemanticTokens(j,Z,ne){const ae=this._documents.getDocument(j),Y=Z!==0?this._previousResults.get(Z):null;return A.asPromise(()=>Y&&typeof Y.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?this._provider.provideDocumentSemanticTokensEdits(ae,Y.resultId,ne):this._provider.provideDocumentSemanticTokens(ae,ne)).then(ce=>(Y&&this._previousResults.delete(Z),ce?(ce=T._fixProvidedSemanticTokens(ce),this._send(T._convertToEdits(Y,ce),ce)):null))}async releaseDocumentSemanticColoring(j){this._previousResults.delete(j)}static _fixProvidedSemanticTokens(j){return T._isSemanticTokens(j)?T._isCorrectSemanticTokens(j)?j:new y.SemanticTokens(new Uint32Array(j.data),j.resultId):T._isSemanticTokensEdits(j)?T._isCorrectSemanticTokensEdits(j)?j:new y.SemanticTokensEdits(j.edits.map(Z=>new y.SemanticTokensEdit(Z.start,Z.deleteCount,Z.data?new Uint32Array(Z.data):Z.data)),j.resultId):j}static _isSemanticTokens(j){return j&&!!j.data}static _isCorrectSemanticTokens(j){return j.data instanceof Uint32Array}static _isSemanticTokensEdits(j){return j&&Array.isArray(j.edits)}static _isCorrectSemanticTokensEdits(j){for(const Z of j.edits)if(!(Z.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(j,Z){if(!T._isSemanticTokens(Z)||!j||!j.tokens)return Z;const ne=j.tokens,ae=ne.length,Y=Z.data,ce=Y.length;let me=0;const Re=Math.min(ae,ce);for(;me<Re&&ne[me]===Y[me];)me++;if(me===ae&&me===ce)return new y.SemanticTokensEdits([],Z.resultId);let He=0;const be=Re-me;for(;He<be&&ne[ae-He-1]===Y[ce-He-1];)He++;return new y.SemanticTokensEdits([{start:me,deleteCount:ae-me-He,data:Y.subarray(me,ce-He)}],Z.resultId)}_send(j,Z){if(T._isSemanticTokens(j)){const ne=this._nextResultId++;return this._previousResults.set(ne,new V(j.resultId,j.data)),c.encodeSemanticTokensDto({id:ne,type:"full",data:j.data})}if(T._isSemanticTokensEdits(j)){const ne=this._nextResultId++;return T._isSemanticTokens(Z)?this._previousResults.set(ne,new V(Z.resultId,Z.data)):this._previousResults.set(ne,new V(j.resultId)),c.encodeSemanticTokensDto({id:ne,type:"delta",deltas:(j.edits||[]).map(ae=>({start:ae.start,deleteCount:ae.deleteCount,data:ae.data}))})}return null}}e.DocumentSemanticTokensAdapter=T;class N{constructor(j,Z){this._documents=j,this._provider=Z}provideDocumentRangeSemanticTokens(j,Z,ne){const ae=this._documents.getDocument(j);return A.asPromise(()=>this._provider.provideDocumentRangeSemanticTokens(ae,k.Range.to(Z),ne)).then(Y=>Y?this._send(Y):null)}_send(j){return c.encodeSemanticTokensDto({id:0,type:"full",data:j.data})}}e.DocumentRangeSemanticTokensAdapter=N;class F{constructor(j,Z,ne,ae,Y){this._documents=j,this._commands=Z,this._provider=ne,this._apiDeprecation=ae,this._extension=Y,this._cache=new _.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(j){return typeof j.resolveCompletionItem=="function"}async provideCompletionItems(j,Z,ne,ae){const Y=this._documents.getDocument(j),ce=k.Position.to(Z),me=Y.getWordRangeAtPosition(ce)||new y.Range(ce,ce),Re=me.with({end:ce}),He=new w.StopWatch(!0),be=await A.asPromise(()=>this._provider.provideCompletionItems(Y,ce,ae,k.CompletionContext.to(ne)));if(!be||ae.isCancellationRequested)return;const Xe=Array.isArray(be)?new y.CompletionList(be):be,Q=F.supportsResolving(this._provider)?this._cache.add(Xe.items):this._cache.add([]),re=new g.DisposableStore;this._disposables.set(Q,re);const ve=[],Me={x:Q,b:ve,a:{replace:k.Range.from(me),insert:k.Range.from(Re)},c:Xe.isIncomplete||void 0,d:He.elapsed()};for(let Ne=0;Ne<Xe.items.length;Ne++){const Ye=Xe.items[Ne],Se=this._convertCompletionItem(Ye,[Q,Ne],Re,me);ve.push(Se)}return Me}async resolveCompletionItem(j,Z){if(typeof this._provider.resolveCompletionItem!="function")return;const ne=this._cache.get(...j);if(!ne)return;const ae=await A.asPromise(()=>this._provider.resolveCompletionItem(ne,Z));if(!!ae)return this._convertCompletionItem(ae,j)}releaseCompletionItems(j){var Z;(Z=this._disposables.get(j))===null||Z===void 0||Z.dispose(),this._disposables.delete(j),this._cache.delete(j)}_convertCompletionItem(j,Z,ne,ae){var Y;const ce=this._disposables.get(Z[0]);if(!ce)throw Error("DisposableStore is missing...");const me={x:Z,a:(Y=j.label)!==null&&Y!==void 0?Y:"",o:j.label2,b:j.kind!==void 0?k.CompletionItemKind.from(j.kind):void 0,n:j.tags&&j.tags.map(k.CompletionItemTag.from),c:j.detail,d:typeof j.documentation=="undefined"?void 0:k.MarkdownString.fromStrict(j.documentation),e:j.sortText!==j.label?j.sortText:void 0,f:j.filterText!==j.label?j.filterText:void 0,g:j.preselect||void 0,i:j.keepWhitespace?1:0,k:j.commitCharacters,l:j.additionalTextEdits&&j.additionalTextEdits.map(k.TextEdit.from),m:this._commands.toInternal(j.command,ce)};j.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),me.h=j.textEdit.newText):typeof j.insertText=="string"?me.h=j.insertText:j.insertText instanceof y.SnippetString&&(me.h=j.insertText.value,me.i|=4);let Re;return j.textEdit?Re=j.textEdit.range:j.range&&(Re=j.range),y.Range.isRange(Re)?me.j=k.Range.from(Re):Re&&(!(ne==null?void 0:ne.isEqual(Re.inserting))||!(ae==null?void 0:ae.isEqual(Re.replacing)))&&(me.j={insert:k.Range.from(Re.inserting),replace:k.Range.from(Re.replacing)}),me}}class M{constructor(j,Z,ne){this._documents=j,this._provider=Z,this._commands=ne,this._cache=new _.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(j,Z,ne,ae){const Y=this._documents.getDocument(j),ce=k.Position.to(Z),me=await A.asPromise(()=>this._provider.provideInlineCompletionItems(Y,ce,ne,ae));if(!me||ae.isCancellationRequested)return;const Re=I.isArray(me)?{items:me}:me,He=this._cache.add(Re.items);let be;return{pid:He,items:Re.items.map((Xe,Q)=>{let re;return Xe.command&&(be||(be=new g.DisposableStore,this._disposables.set(He,be)),re=this._commands.toInternal(Xe.command,be)),{text:Xe.text,range:Xe.range?k.Range.from(Xe.range):void 0,command:re,idx:Q}})}}disposeCompletions(j){this._cache.delete(j);const Z=this._disposables.get(j);Z&&Z.clear(),this._disposables.delete(j)}handleDidShowCompletionItem(j,Z){const ne=this._cache.get(j,Z);ne&&U.get(this._provider).fireOnDidShowCompletionItem({completionItem:ne})}}class U{constructor(){this._onDidShowCompletionItemEmitter=new u.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(j){let Z=U.map.get(j);return Z||(Z=new U,U.map.set(j,Z)),Z}fireOnDidShowCompletionItem(j){this._onDidShowCompletionItemEmitter.fire(j)}}e.InlineCompletionController=U,U.map=new WeakMap;class B{constructor(j,Z){this._documents=j,this._provider=Z,this._cache=new _.Cache("SignatureHelp")}provideSignatureHelp(j,Z,ne,ae){const Y=this._documents.getDocument(j),ce=k.Position.to(Z),me=this.reviveContext(ne);return A.asPromise(()=>this._provider.provideSignatureHelp(Y,ce,ae,me)).then(Re=>{if(Re){const He=this._cache.add([Re]);return Object.assign(Object.assign({},k.SignatureHelp.from(Re)),{id:He})}})}reviveContext(j){let Z;if(j.activeSignatureHelp){const ne=k.SignatureHelp.to(j.activeSignatureHelp),ae=this._cache.get(j.activeSignatureHelp.id,0);ae?(Z=ae,Z.activeSignature=ne.activeSignature,Z.activeParameter=ne.activeParameter):Z=ne}return Object.assign(Object.assign({},j),{activeSignatureHelp:Z})}releaseSignatureHelp(j){this._cache.delete(j)}}class K{constructor(j,Z){this._documents=j,this._provider=Z}provideInlayHints(j,Z,ne){const ae=this._documents.getDocument(j);return A.asPromise(()=>this._provider.provideInlayHints(ae,k.Range.to(Z),ne)).then(Y=>Y?{hints:Y.map(k.InlayHint.from)}:void 0)}}class ie{constructor(j,Z){this._documents=j,this._provider=Z,this._cache=new _.Cache("DocumentLink")}provideLinks(j,Z){const ne=this._documents.getDocument(j);return A.asPromise(()=>this._provider.provideDocumentLinks(ne,Z)).then(ae=>{if(!(!Array.isArray(ae)||ae.length===0)&&!Z.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:ae.map(k.DocumentLink.from)};{const Y=this._cache.add(ae),ce={links:[],id:Y};for(let me=0;me<ae.length;me++){const Re=k.DocumentLink.from(ae[me]);Re.cacheId=[Y,me],ce.links.push(Re)}return ce}}})}resolveLink(j,Z){if(typeof this._provider.resolveDocumentLink!="function")return Promise.resolve(void 0);const ne=this._cache.get(...j);return ne?A.asPromise(()=>this._provider.resolveDocumentLink(ne,Z)).then(ae=>ae&&k.DocumentLink.from(ae)||void 0):Promise.resolve(void 0)}releaseLinks(j){this._cache.delete(j)}}class we{constructor(j,Z){this._documents=j,this._provider=Z}provideColors(j,Z){const ne=this._documents.getDocument(j);return A.asPromise(()=>this._provider.provideDocumentColors(ne,Z)).then(ae=>Array.isArray(ae)?ae.map(ce=>({color:k.Color.from(ce.color),range:k.Range.from(ce.range)})):[])}provideColorPresentations(j,Z,ne){const ae=this._documents.getDocument(j),Y=k.Range.to(Z.range),ce=k.Color.to(Z.color);return A.asPromise(()=>this._provider.provideColorPresentations(ce,{document:ae,range:Y},ne)).then(me=>{if(!!Array.isArray(me))return me.map(k.ColorPresentation.from)})}}class Te{constructor(j,Z){this._documents=j,this._provider=Z}provideFoldingRanges(j,Z,ne){const ae=this._documents.getDocument(j);return A.asPromise(()=>this._provider.provideFoldingRanges(ae,Z,ne)).then(Y=>{if(!!Array.isArray(Y))return Y.map(k.FoldingRange.from)})}}class ye{constructor(j,Z,ne){this._documents=j,this._provider=Z,this._logService=ne}provideSelectionRanges(j,Z,ne){const ae=this._documents.getDocument(j),Y=Z.map(k.Position.to);return A.asPromise(()=>this._provider.provideSelectionRanges(ae,Y,ne)).then(ce=>{if(!s.isNonEmptyArray(ce))return[];if(ce.length!==Y.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const me=[];for(let Re=0;Re<Y.length;Re++){const He=[];me.push(He);let be=Y[Re],Xe=ce[Re];for(;;){if(!Xe.range.contains(be))throw new Error("INVALID selection range, must contain the previous range");if(He.push(k.SelectionRange.from(Xe)),!Xe.parent)break;be=Xe.range,Xe=Xe.parent}}return me})}}class Oe{constructor(j,Z){this._documents=j,this._provider=Z,this._idPool=new f.IdGenerator(""),this._cache=new Map}async prepareSession(j,Z,ne){const ae=this._documents.getDocument(j),Y=k.Position.to(Z),ce=await this._provider.prepareCallHierarchy(ae,Y,ne);if(!ce)return;const me=this._idPool.nextId();return this._cache.set(me,new Map),Array.isArray(ce)?ce.map(Re=>this._cacheAndConvertItem(me,Re)):[this._cacheAndConvertItem(me,ce)]}async provideCallsTo(j,Z,ne){const ae=this._itemFromCache(j,Z);if(!ae)throw new Error("missing call hierarchy item");const Y=await this._provider.provideCallHierarchyIncomingCalls(ae,ne);if(!!Y)return Y.map(ce=>({from:this._cacheAndConvertItem(j,ce.from),fromRanges:ce.fromRanges.map(me=>k.Range.from(me))}))}async provideCallsFrom(j,Z,ne){const ae=this._itemFromCache(j,Z);if(!ae)throw new Error("missing call hierarchy item");const Y=await this._provider.provideCallHierarchyOutgoingCalls(ae,ne);if(!!Y)return Y.map(ce=>({to:this._cacheAndConvertItem(j,ce.to),fromRanges:ce.fromRanges.map(me=>k.Range.from(me))}))}releaseSession(j){this._cache.delete(j)}_cacheAndConvertItem(j,Z){var ne;const ae=this._cache.get(j),Y={_sessionId:j,_itemId:ae.size.toString(36),name:Z.name,detail:Z.detail,kind:k.SymbolKind.from(Z.kind),uri:Z.uri,range:k.Range.from(Z.range),selectionRange:k.Range.from(Z.selectionRange),tags:(ne=Z.tags)===null||ne===void 0?void 0:ne.map(k.SymbolTag.from)};return ae.set(Y._itemId,Z),Y}_itemFromCache(j,Z){const ne=this._cache.get(j);return ne==null?void 0:ne.get(Z)}}class je{constructor(j,Z){this.adapter=j,this.extension=Z}}class ze{constructor(j,Z,ne,ae,Y,ce,me){this._adapter=new Map,this._uriTransformer=Z,this._proxy=j.getProxy(C.MainContext.MainThreadLanguageFeatures),this._documents=ne,this._commands=ae,this._diagnostics=Y,this._logService=ce,this._apiDeprecation=me}_transformDocumentSelector(j){return s.coalesce(s.asArray(j).map(Z=>this._doTransformDocumentSelector(Z)))}_doTransformDocumentSelector(j){if(typeof j=="string")return{$serialized:!0,language:j};if(j)return{$serialized:!0,language:j.language,scheme:this._transformScheme(j.scheme),pattern:typeof j.pattern=="undefined"?void 0:k.GlobPattern.from(j.pattern),exclusive:j.exclusive}}_transformScheme(j){return this._uriTransformer&&typeof j=="string"?this._uriTransformer.transformOutgoingScheme(j):j}_createDisposable(j){return new y.Disposable(()=>{this._adapter.delete(j),this._proxy.$unregister(j)})}_nextHandle(){return ze._handlePool++}_withAdapter(j,Z,ne,ae,Y=!1){const ce=this._adapter.get(j);if(!ce)return Promise.resolve(ae);if(ce.adapter instanceof Z){let me;ce.extension&&(me=Date.now(),this._logService.trace(`[${ce.extension.identifier.value}] INVOKE provider '${Z.name}'`));const Re=ne(ce.adapter,ce.extension),He=ce.extension;return He&&Promise.resolve(Re).then(()=>this._logService.trace(`[${He.identifier.value}] provider DONE after ${Date.now()-me}ms`),be=>{Y&&be instanceof E.CancellationError||(this._logService.error(`[${He.identifier.value}] provider FAILED`),this._logService.error(be))}),Re}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(j,Z){const ne=this._nextHandle();return this._adapter.set(ne,new je(j,Z)),ne}static _extLabel(j){return j.displayName||j.name}registerDocumentSymbolProvider(j,Z,ne,ae){const Y=this._addNewAdapter(new h(this._documents,ne),j),ce=ae&&ae.label||ze._extLabel(j);return this._proxy.$registerDocumentSymbolProvider(Y,this._transformDocumentSelector(Z),ce),this._createDisposable(Y)}$provideDocumentSymbols(j,Z,ne){return this._withAdapter(j,h,ae=>ae.provideDocumentSymbols(v.URI.revive(Z),ne),void 0)}registerCodeLensProvider(j,Z,ne){const ae=this._nextHandle(),Y=typeof ne.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(ae,new je(new m(this._documents,this._commands.converter,ne),j)),this._proxy.$registerCodeLensSupport(ae,this._transformDocumentSelector(Z),Y);let ce=this._createDisposable(ae);if(Y!==void 0){const me=ne.onDidChangeCodeLenses(Re=>this._proxy.$emitCodeLensEvent(Y));ce=y.Disposable.from(ce,me)}return ce}$provideCodeLenses(j,Z,ne){return this._withAdapter(j,m,ae=>ae.provideCodeLenses(v.URI.revive(Z),ne),void 0)}$resolveCodeLens(j,Z,ne){return this._withAdapter(j,m,ae=>ae.resolveCodeLens(Z,ne),void 0)}$releaseCodeLenses(j,Z){this._withAdapter(j,m,ne=>Promise.resolve(ne.releaseCodeLenses(Z)),void 0)}registerDefinitionProvider(j,Z,ne){const ae=this._addNewAdapter(new r(this._documents,ne),j);return this._proxy.$registerDefinitionSupport(ae,this._transformDocumentSelector(Z)),this._createDisposable(ae)}$provideDefinition(j,Z,ne,ae){return this._withAdapter(j,r,Y=>Y.provideDefinition(v.URI.revive(Z),ne,ae),[])}registerDeclarationProvider(j,Z,ne){const ae=this._addNewAdapter(new i(this._documents,ne),j);return this._proxy.$registerDeclarationSupport(ae,this._transformDocumentSelector(Z)),this._createDisposable(ae)}$provideDeclaration(j,Z,ne,ae){return this._withAdapter(j,i,Y=>Y.provideDeclaration(v.URI.revive(Z),ne,ae),[])}registerImplementationProvider(j,Z,ne){const ae=this._addNewAdapter(new n(this._documents,ne),j);return this._proxy.$registerImplementationSupport(ae,this._transformDocumentSelector(Z)),this._createDisposable(ae)}$provideImplementation(j,Z,ne,ae){return this._withAdapter(j,n,Y=>Y.provideImplementation(v.URI.revive(Z),ne,ae),[])}registerTypeDefinitionProvider(j,Z,ne){const ae=this._addNewAdapter(new a(this._documents,ne),j);return this._proxy.$registerTypeDefinitionSupport(ae,this._transformDocumentSelector(Z)),this._createDisposable(ae)}$provideTypeDefinition(j,Z,ne,ae){return this._withAdapter(j,a,Y=>Y.provideTypeDefinition(v.URI.revive(Z),ne,ae),[])}registerHoverProvider(j,Z,ne,ae){const Y=this._addNewAdapter(new p(this._documents,ne),j);return this._proxy.$registerHoverProvider(Y,this._transformDocumentSelector(Z)),this._createDisposable(Y)}$provideHover(j,Z,ne,ae){return this._withAdapter(j,p,Y=>Y.provideHover(v.URI.revive(Z),ne,ae),void 0)}registerEvaluatableExpressionProvider(j,Z,ne,ae){const Y=this._addNewAdapter(new d(this._documents,ne),j);return this._proxy.$registerEvaluatableExpressionProvider(Y,this._transformDocumentSelector(Z)),this._createDisposable(Y)}$provideEvaluatableExpression(j,Z,ne,ae){return this._withAdapter(j,d,Y=>Y.provideEvaluatableExpression(v.URI.revive(Z),ne,ae),void 0)}registerInlineValuesProvider(j,Z,ne,ae){const Y=typeof ne.onDidChangeInlineValues=="function"?this._nextHandle():void 0,ce=this._addNewAdapter(new b(this._documents,ne),j);this._proxy.$registerInlineValuesProvider(ce,this._transformDocumentSelector(Z),Y);let me=this._createDisposable(ce);if(Y!==void 0){const Re=ne.onDidChangeInlineValues(He=>this._proxy.$emitInlineValuesEvent(Y));me=y.Disposable.from(me,Re)}return me}$provideInlineValues(j,Z,ne,ae,Y){return this._withAdapter(j,b,ce=>ce.provideInlineValues(v.URI.revive(Z),ne,ae,Y),void 0)}registerDocumentHighlightProvider(j,Z,ne){const ae=this._addNewAdapter(new S(this._documents,ne),j);return this._proxy.$registerDocumentHighlightProvider(ae,this._transformDocumentSelector(Z)),this._createDisposable(ae)}$provideDocumentHighlights(j,Z,ne,ae){return this._withAdapter(j,S,Y=>Y.provideDocumentHighlights(v.URI.revive(Z),ne,ae),void 0)}registerLinkedEditingRangeProvider(j,Z,ne){const ae=this._addNewAdapter(new o(this._documents,ne),j);return this._proxy.$registerLinkedEditingRangeProvider(ae,this._transformDocumentSelector(Z)),this._createDisposable(ae)}$provideLinkedEditingRanges(j,Z,ne,ae){return this._withAdapter(j,o,async Y=>{const ce=await Y.provideLinkedEditingRanges(v.URI.revive(Z),ne,ae);if(ce)return{ranges:ce.ranges,wordPattern:ce.wordPattern?ze._serializeRegExp(ce.wordPattern):void 0}},void 0)}registerReferenceProvider(j,Z,ne){const ae=this._addNewAdapter(new L(this._documents,ne),j);return this._proxy.$registerReferenceSupport(ae,this._transformDocumentSelector(Z)),this._createDisposable(ae)}$provideReferences(j,Z,ne,ae,Y){return this._withAdapter(j,L,ce=>ce.provideReferences(v.URI.revive(Z),ne,ae,Y),void 0)}registerCodeActionProvider(j,Z,ne,ae){var Y,ce;const me=new g.DisposableStore,Re=this._addNewAdapter(new O(this._documents,this._commands.converter,this._diagnostics,ne,this._logService,j,this._apiDeprecation),j);return this._proxy.$registerQuickFixSupport(Re,this._transformDocumentSelector(Z),{providedKinds:(Y=ae==null?void 0:ae.providedCodeActionKinds)===null||Y===void 0?void 0:Y.map(He=>He.value),documentation:(ce=ae==null?void 0:ae.documentation)===null||ce===void 0?void 0:ce.map(He=>({kind:He.kind.value,command:this._commands.converter.toInternal(He.command,me)}))},ze._extLabel(j),Boolean(ne.resolveCodeAction)),me.add(this._createDisposable(Re)),me}$provideCodeActions(j,Z,ne,ae,Y){return this._withAdapter(j,O,ce=>ce.provideCodeActions(v.URI.revive(Z),ne,ae,Y),void 0)}$resolveCodeAction(j,Z,ne){return this._withAdapter(j,O,ae=>ae.resolveCodeAction(Z,ne),void 0)}$releaseCodeActions(j,Z){this._withAdapter(j,O,ne=>Promise.resolve(ne.releaseCodeActions(Z)),void 0)}registerDocumentFormattingEditProvider(j,Z,ne){const ae=this._addNewAdapter(new W(this._documents,ne),j);return this._proxy.$registerDocumentFormattingSupport(ae,this._transformDocumentSelector(Z),j.identifier,j.displayName||j.name),this._createDisposable(ae)}$provideDocumentFormattingEdits(j,Z,ne,ae){return this._withAdapter(j,W,Y=>Y.provideDocumentFormattingEdits(v.URI.revive(Z),ne,ae),void 0)}registerDocumentRangeFormattingEditProvider(j,Z,ne){const ae=this._addNewAdapter(new J(this._documents,ne),j);return this._proxy.$registerRangeFormattingSupport(ae,this._transformDocumentSelector(Z),j.identifier,j.displayName||j.name),this._createDisposable(ae)}$provideDocumentRangeFormattingEdits(j,Z,ne,ae,Y){return this._withAdapter(j,J,ce=>ce.provideDocumentRangeFormattingEdits(v.URI.revive(Z),ne,ae,Y),void 0)}registerOnTypeFormattingEditProvider(j,Z,ne,ae){const Y=this._addNewAdapter(new oe(this._documents,ne),j);return this._proxy.$registerOnTypeFormattingSupport(Y,this._transformDocumentSelector(Z),ae,j.identifier),this._createDisposable(Y)}$provideOnTypeFormattingEdits(j,Z,ne,ae,Y,ce){return this._withAdapter(j,oe,me=>me.provideOnTypeFormattingEdits(v.URI.revive(Z),ne,ae,Y,ce),void 0)}registerWorkspaceSymbolProvider(j,Z){const ne=this._addNewAdapter(new q(Z,this._logService),j);return this._proxy.$registerNavigateTypeSupport(ne),this._createDisposable(ne)}$provideWorkspaceSymbols(j,Z,ne){return this._withAdapter(j,q,ae=>ae.provideWorkspaceSymbols(Z,ne),{symbols:[]})}$resolveWorkspaceSymbol(j,Z,ne){return this._withAdapter(j,q,ae=>ae.resolveWorkspaceSymbol(Z,ne),void 0)}$releaseWorkspaceSymbols(j,Z){this._withAdapter(j,q,ne=>ne.releaseWorkspaceSymbols(Z),void 0)}registerRenameProvider(j,Z,ne){const ae=this._addNewAdapter(new x(this._documents,ne,this._logService),j);return this._proxy.$registerRenameSupport(ae,this._transformDocumentSelector(Z),x.supportsResolving(ne)),this._createDisposable(ae)}$provideRenameEdits(j,Z,ne,ae,Y){return this._withAdapter(j,x,ce=>ce.provideRenameEdits(v.URI.revive(Z),ne,ae,Y),void 0)}$resolveRenameLocation(j,Z,ne,ae){return this._withAdapter(j,x,Y=>Y.resolveRenameLocation(v.URI.revive(Z),ne,ae),void 0)}registerDocumentSemanticTokensProvider(j,Z,ne,ae){const Y=this._nextHandle(),ce=typeof ne.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(Y,new je(new T(this._documents,ne),j)),this._proxy.$registerDocumentSemanticTokensProvider(Y,this._transformDocumentSelector(Z),ae,ce);let me=this._createDisposable(Y);if(ce){const Re=ne.onDidChangeSemanticTokens(He=>this._proxy.$emitDocumentSemanticTokensEvent(ce));me=y.Disposable.from(me,Re)}return me}$provideDocumentSemanticTokens(j,Z,ne,ae){return this._withAdapter(j,T,Y=>Y.provideDocumentSemanticTokens(v.URI.revive(Z),ne,ae),null,!0)}$releaseDocumentSemanticTokens(j,Z){this._withAdapter(j,T,ne=>ne.releaseDocumentSemanticColoring(Z),void 0)}registerDocumentRangeSemanticTokensProvider(j,Z,ne,ae){const Y=this._addNewAdapter(new N(this._documents,ne),j);return this._proxy.$registerDocumentRangeSemanticTokensProvider(Y,this._transformDocumentSelector(Z),ae),this._createDisposable(Y)}$provideDocumentRangeSemanticTokens(j,Z,ne,ae){return this._withAdapter(j,N,Y=>Y.provideDocumentRangeSemanticTokens(v.URI.revive(Z),ne,ae),null,!0)}registerCompletionItemProvider(j,Z,ne,ae){const Y=this._addNewAdapter(new F(this._documents,this._commands.converter,ne,this._apiDeprecation,j),j);return this._proxy.$registerSuggestSupport(Y,this._transformDocumentSelector(Z),ae,F.supportsResolving(ne),`${j.identifier.value}(${ae.join("")})`),this._createDisposable(Y)}$provideCompletionItems(j,Z,ne,ae,Y){return this._withAdapter(j,F,ce=>ce.provideCompletionItems(v.URI.revive(Z),ne,ae,Y),void 0)}$resolveCompletionItem(j,Z,ne){return this._withAdapter(j,F,ae=>ae.resolveCompletionItem(Z,ne),void 0)}$releaseCompletionItems(j,Z){this._withAdapter(j,F,ne=>ne.releaseCompletionItems(Z),void 0)}registerInlineCompletionsProvider(j,Z,ne){const ae=this._addNewAdapter(new M(this._documents,ne,this._commands.converter),j);return this._proxy.$registerInlineCompletionsSupport(ae,this._transformDocumentSelector(Z)),this._createDisposable(ae)}$provideInlineCompletions(j,Z,ne,ae,Y){return this._withAdapter(j,M,ce=>ce.provideInlineCompletions(v.URI.revive(Z),ne,ae,Y),void 0)}$handleInlineCompletionDidShow(j,Z,ne){this._withAdapter(j,M,async ae=>{ae.handleDidShowCompletionItem(Z,ne)},void 0)}$freeInlineCompletionsList(j,Z){this._withAdapter(j,M,async ne=>{ne.disposeCompletions(Z)},void 0)}registerSignatureHelpProvider(j,Z,ne,ae){const Y=Array.isArray(ae)?{triggerCharacters:ae,retriggerCharacters:[]}:ae,ce=this._addNewAdapter(new B(this._documents,ne),j);return this._proxy.$registerSignatureHelpProvider(ce,this._transformDocumentSelector(Z),Y),this._createDisposable(ce)}$provideSignatureHelp(j,Z,ne,ae,Y){return this._withAdapter(j,B,ce=>ce.provideSignatureHelp(v.URI.revive(Z),ne,ae,Y),void 0)}$releaseSignatureHelp(j,Z){this._withAdapter(j,B,ne=>ne.releaseSignatureHelp(Z),void 0)}registerInlayHintsProvider(j,Z,ne){const ae=typeof ne.onDidChangeInlayHints=="function"?this._nextHandle():void 0,Y=this._addNewAdapter(new K(this._documents,ne),j);this._proxy.$registerInlayHintsProvider(Y,this._transformDocumentSelector(Z),ae);let ce=this._createDisposable(Y);if(ae!==void 0){const me=ne.onDidChangeInlayHints(Re=>this._proxy.$emitInlayHintsEvent(ae));ce=y.Disposable.from(ce,me)}return ce}$provideInlayHints(j,Z,ne,ae){return this._withAdapter(j,K,Y=>Y.provideInlayHints(v.URI.revive(Z),ne,ae),void 0)}registerDocumentLinkProvider(j,Z,ne){const ae=this._addNewAdapter(new ie(this._documents,ne),j);return this._proxy.$registerDocumentLinkProvider(ae,this._transformDocumentSelector(Z),typeof ne.resolveDocumentLink=="function"),this._createDisposable(ae)}$provideDocumentLinks(j,Z,ne){return this._withAdapter(j,ie,ae=>ae.provideLinks(v.URI.revive(Z),ne),void 0)}$resolveDocumentLink(j,Z,ne){return this._withAdapter(j,ie,ae=>ae.resolveLink(Z,ne),void 0)}$releaseDocumentLinks(j,Z){this._withAdapter(j,ie,ne=>ne.releaseLinks(Z),void 0)}registerColorProvider(j,Z,ne){const ae=this._addNewAdapter(new we(this._documents,ne),j);return this._proxy.$registerDocumentColorProvider(ae,this._transformDocumentSelector(Z)),this._createDisposable(ae)}$provideDocumentColors(j,Z,ne){return this._withAdapter(j,we,ae=>ae.provideColors(v.URI.revive(Z),ne),[])}$provideColorPresentations(j,Z,ne,ae){return this._withAdapter(j,we,Y=>Y.provideColorPresentations(v.URI.revive(Z),ne,ae),void 0)}registerFoldingRangeProvider(j,Z,ne){const ae=this._nextHandle(),Y=typeof ne.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(ae,new je(new Te(this._documents,ne),j)),this._proxy.$registerFoldingRangeProvider(ae,this._transformDocumentSelector(Z),Y);let ce=this._createDisposable(ae);if(Y!==void 0){const me=ne.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(Y));ce=y.Disposable.from(ce,me)}return ce}$provideFoldingRanges(j,Z,ne,ae){return this._withAdapter(j,Te,Y=>Y.provideFoldingRanges(v.URI.revive(Z),ne,ae),void 0)}registerSelectionRangeProvider(j,Z,ne){const ae=this._addNewAdapter(new ye(this._documents,ne,this._logService),j);return this._proxy.$registerSelectionRangeProvider(ae,this._transformDocumentSelector(Z)),this._createDisposable(ae)}$provideSelectionRanges(j,Z,ne,ae){return this._withAdapter(j,ye,Y=>Y.provideSelectionRanges(v.URI.revive(Z),ne,ae),[])}registerCallHierarchyProvider(j,Z,ne){const ae=this._addNewAdapter(new Oe(this._documents,ne),j);return this._proxy.$registerCallHierarchyProvider(ae,this._transformDocumentSelector(Z)),this._createDisposable(ae)}$prepareCallHierarchy(j,Z,ne,ae){return this._withAdapter(j,Oe,Y=>Promise.resolve(Y.prepareSession(v.URI.revive(Z),ne,ae)),void 0)}$provideCallHierarchyIncomingCalls(j,Z,ne,ae){return this._withAdapter(j,Oe,Y=>Y.provideCallsTo(Z,ne,ae),void 0)}$provideCallHierarchyOutgoingCalls(j,Z,ne,ae){return this._withAdapter(j,Oe,Y=>Y.provideCallsFrom(Z,ne,ae),void 0)}$releaseCallHierarchy(j,Z){this._withAdapter(j,Oe,ne=>Promise.resolve(ne.releaseSession(Z)),void 0)}static _serializeRegExp(j){return{pattern:j.source,flags:D.regExpFlags(j)}}static _serializeIndentationRule(j){return{decreaseIndentPattern:ze._serializeRegExp(j.decreaseIndentPattern),increaseIndentPattern:ze._serializeRegExp(j.increaseIndentPattern),indentNextLinePattern:j.indentNextLinePattern?ze._serializeRegExp(j.indentNextLinePattern):void 0,unIndentedLinePattern:j.unIndentedLinePattern?ze._serializeRegExp(j.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(j){return{beforeText:ze._serializeRegExp(j.beforeText),afterText:j.afterText?ze._serializeRegExp(j.afterText):void 0,previousLineText:j.previousLineText?ze._serializeRegExp(j.previousLineText):void 0,action:j.action}}static _serializeOnEnterRules(j){return j.map(ze._serializeOnEnterRule)}setLanguageConfiguration(j,Z,ne){let{wordPattern:ae}=ne;if(ae&&D.regExpLeadsToEndlessLoop(ae))throw new Error(`Invalid language configuration: wordPattern '${ae}' is not allowed to match the empty string.`);ae?this._documents.setWordDefinitionFor(Z,ae):this._documents.setWordDefinitionFor(Z,void 0),ne.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",j,"Do not use."),ne.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",j,"Do not use.");const Y=this._nextHandle(),ce={comments:ne.comments,brackets:ne.brackets,wordPattern:ne.wordPattern?ze._serializeRegExp(ne.wordPattern):void 0,indentationRules:ne.indentationRules?ze._serializeIndentationRule(ne.indentationRules):void 0,onEnterRules:ne.onEnterRules?ze._serializeOnEnterRules(ne.onEnterRules):void 0,__electricCharacterSupport:ne.__electricCharacterSupport,__characterPairSupport:ne.__characterPairSupport};return this._proxy.$setLanguageConfiguration(Y,Z,ce),this._createDisposable(Y)}$setWordDefinitions(j){for(const Z of j)this._documents.setWordDefinitionFor(Z.languageId,new RegExp(Z.regexSource,Z.regexFlags))}}e.ExtHostLanguageFeatures=ze,ze._handlePool=0}),define(ge[226],pe([0,1,5,18,7]),function(X,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class y{constructor(C,D){this._proxy=C.getProxy(v.MainContext.MainThreadLanguages),this._documents=D}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(C,D){await this._proxy.$changeLanguage(C,D);const P=this._documents.getDocumentData(C);if(!P)throw new Error(`document '${C.toString}' NOT found`);return P.document}async tokenAtPosition(C,D){var P;const s=C.version,I=R.Position.from(D),l=await this._proxy.$tokensAtPosition(C.uri,I),g={type:k.StandardTokenType.Other,range:(P=C.getWordRangeAtPosition(D))!==null&&P!==void 0?P:new k.Range(D.line,D.character,D.line,D.character)};if(!l)return g;const c={range:R.Range.to(l.range),type:R.TokenType.to(l.type)};return!c.range.contains(D)||s!==C.version?g:c}}e.ExtHostLanguages=y}),define(ge[227],pe([0,1,5,15,35]),function(X,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function y(C){return C&&C.title}let A=class{constructor(D,P){this._logService=P,this._proxy=D.getProxy(v.MainContext.MainThreadMessageService)}showMessage(D,P,s,I,l){const g={extension:D};let c;typeof I=="string"||y(I)?c=[I,...l]:(g.modal=I&&I.modal,g.useCustom=I&&I.useCustom,c=l),g.useCustom&&k.checkProposedApiEnabled(D);const f=[];for(let _=0;_<c.length;_++){const w=c[_];if(typeof w=="string")f.push({title:w,handle:_,isCloseAffordance:!1});else if(typeof w=="object"){let{title:E,isCloseAffordance:u}=w;f.push({title:E,isCloseAffordance:!!u,handle:_})}else this._logService.warn("Invalid message item:",w)}return this._proxy.$showMessage(P,s,g,f).then(_=>{if(typeof _=="number")return c[_]})}};A=Ve([We(1,R.ILogService)],A),e.ExtHostMessageService=A}),define(ge[228],pe([0,1,22,3,74,70,6,23,8,13,2,83,5,18,7,60,205,122]),function(X,e,v,R,k,y,A,C,D,P,s,I,l,g,c,f,_,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=e.NotebookEditorDecorationType=void 0;class E{constructor(m,t){const r=E._Keys.nextId();m.$registerNotebookEditorDecorationType(r,g.NotebookDecorationRenderOptions.from(t)),this.value={key:r,dispose(){m.$removeNotebookEditorDecorationType(r)}}}}e.NotebookEditorDecorationType=E,E._Keys=new y.IdGenerator("NotebookEditorDecorationType");class u{constructor(m,t,r,i,n,a){this._textDocumentsAndEditors=r,this._textDocuments=i,this.logService=n,this._extensionStoragePaths=a,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new C.ResourceMap,this._editors=new Map,this._onDidChangeNotebookEditorSelection=new R.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this._onDidChangeNotebookEditorVisibleRanges=new R.Emitter,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event,this._onDidChangeNotebookDocumentMetadata=new R.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidChangeNotebookCells=new R.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new R.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new R.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new R.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new R.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new R.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new R.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidSaveNotebookDocument=new R.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new R.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new I.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=m.getProxy(l.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=m.getProxy(l.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=m.getProxy(l.MainContext.MainThreadNotebookEditors),this._commandsConverter=t.converter,t.registerArgumentProcessor({processArgument:p=>{var d;if(p&&p.$mid===12){const b=(d=p.notebookEditor)===null||d===void 0?void 0:d.notebookUri,S=p.cell.handle,o=this._documents.get(b),L=o==null?void 0:o.getCell(S);if(L)return L.apiCell}return p}})}get activeNotebookEditor(){var m;return(m=this._activeNotebookEditor)===null||m===void 0?void 0:m.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(m=>m.apiEditor)}getEditorById(m){return this._editors.get(m)}getIdByEditor(m){for(const[t,r]of this._editors)if(r.apiEditor===m)return t}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(m,t){const r=this._documents.get(m);if(!r&&!t)throw new Error(`NO notebook document for '${m}'`);return r}_getProviderData(m){const t=this._notebookContentProviders.get(m);if(!t)throw new Error(`NO provider for '${m}'`);return t}registerNotebookContentProvider(m,t,r,i,n){if(D.isFalsyOrWhitespace(t))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(t))throw new Error(`Notebook provider for '${t}' already registered`);this._notebookContentProviders.set(t,{extension:m,provider:r});let a;return r.onDidChangeNotebookContentOptions&&(a=r.onDidChangeNotebookContentOptions(()=>{const p=g.NotebookDocumentContentOptions.from(r.options);this._notebookProxy.$updateNotebookProviderOptions(t,p)})),this._notebookProxy.$registerNotebookProvider({id:m.identifier,location:m.extensionLocation},t,g.NotebookDocumentContentOptions.from(i),u._convertNotebookRegistrationData(m,n)),new c.Disposable(()=>{a==null||a.dispose(),this._notebookContentProviders.delete(t),this._notebookProxy.$unregisterNotebookProvider(t)})}static _convertNotebookRegistrationData(m,t){if(!t)return;const r=t.filenamePattern.map(i=>g.NotebookExclusiveDocumentPattern.from(i)).filter(i=>i!==void 0);if(t.filenamePattern&&!r){console.warn(`Notebook content provider view options file name pattern is invalid ${t.filenamePattern}`);return}return{extension:m.identifier,providerDisplayName:m.displayName||m.name,displayName:t.displayName,filenamePattern:r,exclusive:t.exclusive||!1}}registerNotebookCellStatusBarItemProvider(m,t,r){const i=u._notebookStatusBarItemProviderHandlePool++,n=typeof r.onDidChangeCellStatusBarItems=="function"?u._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(i,r),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(i,n,t);let a;return n!==void 0&&(a=r.onDidChangeCellStatusBarItems(p=>this._notebookProxy.$emitCellStatusBarEvent(n))),new c.Disposable(()=>{this._notebookStatusBarItemProviders.delete(i),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(i,n),a&&a.dispose()})}createNotebookEditorDecorationType(m){return new E(this._notebookEditorsProxy,m).value}async createNotebookDocument(m){const t=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:m.viewType,content:m.content&&g.NotebookData.from(m.content)});return s.URI.revive(t)}async openNotebookDocument(m){const t=this._documents.get(m);if(t)return t.apiNotebook;const r=await this._notebookDocumentsProxy.$tryOpenNotebook(m),i=this._documents.get(s.URI.revive(r));return P.assertIsDefined(i==null?void 0:i.apiNotebook)}async showNotebookDocument(m,t){var r;s.URI.isUri(m)&&(m=await this.openNotebookDocument(m));let i;typeof t=="object"?i={position:g.ViewColumn.from(t.viewColumn),preserveFocus:t.preserveFocus,selections:t.selections&&t.selections.map(g.NotebookRange.from),pinned:typeof t.preview=="boolean"?!t.preview:void 0}:i={preserveFocus:!1};const n=await this._notebookEditorsProxy.$tryShowNotebookDocument(m.uri,m.notebookType,i),a=n&&((r=this._editors.get(n))===null||r===void 0?void 0:r.apiEditor);if(a)return a;throw n?new Error(`Could NOT open editor for "${m.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${m.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(m,t,r,i){const n=this._notebookStatusBarItemProviders.get(m),a=s.URI.revive(t),p=this._documents.get(a);if(!p||!n)return;const d=p.getCellFromIndex(r);if(!d)return;const b=await n.provideCellStatusBarItems(d.apiCell,i);if(!b)return;const S=new A.DisposableStore,o=this._statusBarCache.add([S]),O=(Array.isArray(b)?b:[b]).map(W=>g.NotebookStatusBarItem.from(W,this._commandsConverter,S));return{cacheId:o,items:O}}$releaseNotebookCellStatusBarItems(m){this._statusBarCache.delete(m)}registerNotebookSerializer(m,t,r,i,n){if(D.isFalsyOrWhitespace(t))throw new Error("viewType cannot be empty or just whitespace");const a=this._handlePool++;return this._notebookSerializer.set(a,r),this._notebookProxy.$registerNotebookSerializer(a,{id:m.identifier,location:m.extensionLocation},t,g.NotebookDocumentContentOptions.from(i),u._convertNotebookRegistrationData(m,n)),A.toDisposable(()=>{this._notebookProxy.$unregisterNotebookSerializer(a)})}async $dataToNotebook(m,t,r){const i=this._notebookSerializer.get(m);if(!i)throw new Error("NO serializer found");const n=await i.deserializeNotebook(t.buffer,r);return g.NotebookData.from(n)}async $notebookToData(m,t,r){const i=this._notebookSerializer.get(m);if(!i)throw new Error("NO serializer found");const n=await i.serializeNotebook(g.NotebookData.to(t),r);return v.VSBuffer.wrap(n)}async $openNotebook(m,t,r,i,n){var a;const{provider:p}=this._getProviderData(m),d=await p.openNotebook(s.URI.revive(t),{backupId:r,untitledDocumentData:i==null?void 0:i.buffer},n);return{metadata:(a=d.metadata)!==null&&a!==void 0?a:Object.create(null),cells:d.cells.map(g.NotebookCellData.from)}}async $saveNotebook(m,t,r){const i=this.getNotebookDocument(s.URI.revive(t)),{provider:n}=this._getProviderData(m);return await n.saveNotebook(i.apiNotebook,r),!0}async $saveNotebookAs(m,t,r,i){const n=this.getNotebookDocument(s.URI.revive(t)),{provider:a}=this._getProviderData(m);return await a.saveNotebookAs(s.URI.revive(r),n.apiNotebook,i),!0}async $backupNotebook(m,t,r){var i;const n=this.getNotebookDocument(s.URI.revive(t)),a=this._getProviderData(m),p=(i=this._extensionStoragePaths.workspaceValue(a.extension))!==null&&i!==void 0?i:this._extensionStoragePaths.globalValue(a.extension),d=String(k.hash([n.uri.toString(),this._backupIdPool++])),b=s.URI.joinPath(p,d),S=await a.provider.backupNotebook(n.apiNotebook,{destination:b},r);return n.updateBackup(S),S.id}$acceptModelChanged(m,t,r){this.getNotebookDocument(s.URI.revive(m)).acceptModelChanged(t,r)}$acceptDirtyStateChanged(m,t){const r=this.getNotebookDocument(s.URI.revive(m));r.acceptModelChanged({rawEvents:[],versionId:r.apiNotebook.version},t)}$acceptModelSaved(m){const t=this.getNotebookDocument(s.URI.revive(m));this._onDidSaveNotebookDocument.fire(t.apiNotebook)}$acceptEditorPropertiesChanged(m,t){this.logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",m,t);const r=this._editors.get(m);if(!r)throw new Error(`unknown text editor: ${m}. known editors: ${[...this._editors.keys()]} `);t.visibleRanges&&r._acceptVisibleRanges(t.visibleRanges.ranges.map(g.NotebookRange.to)),t.selections&&r._acceptSelections(t.selections.selections.map(g.NotebookRange.to)),t.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:r.apiEditor,visibleRanges:r.apiEditor.visibleRanges}),t.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:r.apiEditor,selections:r.apiEditor.selections}))}$acceptEditorViewColumns(m){for(const t in m){const r=this._editors.get(t);if(!r)throw new Error(`unknown text editor: ${t}. known editors: ${[...this._editors.keys()]} `);r._acceptViewColumn(g.ViewColumn.to(m[t]))}}$acceptDocumentPropertiesChanged(m,t){this.logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",m.path,t);const r=this.getNotebookDocument(s.URI.revive(m));r.acceptDocumentPropertiesChanged(t),t.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:r.apiNotebook})}_createExtHostEditor(m,t,r){if(this._editors.has(t))throw new Error(`editor with id ALREADY EXSIST: ${t}`);const i=new w.ExtHostNotebookEditor(t,this._notebookEditorsProxy,m,r.visibleRanges.map(g.NotebookRange.to),r.selections.map(g.NotebookRange.to),typeof r.viewColumn=="number"?g.ViewColumn.to(r.viewColumn):void 0);this._editors.set(t,i)}$acceptDocumentAndEditorsDelta(m){var t,r,i,n;if(m.removedDocuments)for(const p of m.removedDocuments){const d=s.URI.revive(p),b=this._documents.get(d);b&&(b.dispose(),this._documents.delete(d),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:b.apiNotebook.getCells().map(S=>S.document.uri)}),this._onDidCloseNotebookDocument.fire(b.apiNotebook));for(const S of this._editors.values())S.notebookData.uri.toString()===d.toString()&&this._editors.delete(S.id)}if(m.addedDocuments){const p=[];for(const d of m.addedDocuments){const b=s.URI.revive(d.uri),S=d.viewType;if(this._documents.has(b))throw new Error(`adding EXISTING notebook ${b} `);const o=this,L=new _.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(O){o._onDidChangeNotebookCells.fire(O)},emitCellOutputsChange(O){o._onDidChangeCellOutputs.fire(O)},emitCellMetadataChange(O){o._onDidChangeCellMetadata.fire(O)},emitCellExecutionStateChange(O){o._onDidChangeCellExecutionState.fire(O)}},S,(t=d.metadata)!==null&&t!==void 0?t:Object.create({}),b);L.acceptModelChanged({versionId:d.versionId,rawEvents:[{kind:f.NotebookCellsChangeType.Initialize,changes:[[0,0,d.cells]]}]},!1),p.push(...d.cells.map(O=>_.ExtHostCell.asModelAddData(L.apiNotebook,O))),(r=this._documents.get(b))===null||r===void 0||r.dispose(),this._documents.set(b,L),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:p}),this._onDidOpenNotebookDocument.fire(L.apiNotebook)}}if(m.addedEditors)for(const p of m.addedEditors){if(this._editors.has(p.id))return;const d=s.URI.revive(p.documentUri),b=this._documents.get(d);b&&this._createExtHostEditor(b,p.id,p)}const a=[];if(m.removedEditors)for(const p of m.removedEditors){const d=this._editors.get(p);d&&(this._editors.delete(p),((i=this._activeNotebookEditor)===null||i===void 0?void 0:i.id)===d.id&&(this._activeNotebookEditor=void 0),a.push(d))}if(m.visibleEditors){this._visibleNotebookEditors=m.visibleEditors.map(d=>this._editors.get(d)).filter(d=>!!d);const p=new Set;this._visibleNotebookEditors.forEach(d=>p.add(d.id));for(const d of this._editors.values()){const b=p.has(d.id);d._acceptVisibility(b)}this._visibleNotebookEditors=[...this._editors.values()].map(d=>d).filter(d=>d.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}m.newActiveEditor===null?this._activeNotebookEditor=void 0:m.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(m.newActiveEditor)),m.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire((n=this._activeNotebookEditor)===null||n===void 0?void 0:n.apiEditor)}}e.ExtHostNotebookController=u,u._notebookStatusBarItemProviderHandlePool=0}),define(ge[229],pe([0,1,3,6,5,26,2,18,85,23,14,60,21,17,15,7,35]),function(X,e,v,R,k,y,A,C,D,P,s,I,l,g,c,f,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let w=class{constructor(t,r,i,n){this._mainContext=t,this._initData=r,this._extHostNotebook=i,this._logService=n,this._activeExecutions=new P.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=t.getProxy(k.MainContext.MainThreadNotebookKernels)}createNotebookController(t,r,i,n,a,p){for(let F of this._kernelData.values())if(F.controller.id===r&&y.ExtensionIdentifier.equals(t.identifier,F.extensionId))throw new Error(`notebook controller with id '${r}' ALREADY exist`);const d=this._handlePool++,b=this;this._logService.trace(`NotebookController[${d}], CREATED by ${t.identifier.value}, ${r}`);const S=()=>console.warn(`NO execute handler from notebook controller '${J.id}' of extension: '${t.identifier}'`);let o=!1;const L=new R.DisposableStore,O=new v.Emitter,W=new v.Emitter,J={id:`${t.identifier.value}/${r}`,notebookType:i,extensionId:t.identifier,extensionLocation:t.extensionLocation,label:n||t.identifier.value,preloads:p?p.map(C.NotebookRendererScript.from):[]};let oe=a??S,q;this._proxy.$addKernel(d,J).catch(F=>{console.log(F),o=!0});let x=0;const V=()=>{if(o)return;const F=++x;Promise.resolve().then(()=>{F===x&&this._proxy.$updateKernel(d,J)})},T=new P.ResourceMap,N={get id(){return r},get notebookType(){return J.notebookType},onDidChangeSelectedNotebooks:O.event,get label(){return J.label},set label(F){var M;J.label=(M=F??t.displayName)!==null&&M!==void 0?M:t.name,V()},get detail(){var F;return(F=J.detail)!==null&&F!==void 0?F:""},set detail(F){J.detail=F,V()},get description(){var F;return(F=J.description)!==null&&F!==void 0?F:""},set description(F){J.description=F,V()},get supportedLanguages(){return J.supportedLanguages},set supportedLanguages(F){J.supportedLanguages=F,V()},get supportsExecutionOrder(){var F;return(F=J.supportsExecutionOrder)!==null&&F!==void 0?F:!1},set supportsExecutionOrder(F){J.supportsExecutionOrder=F,V()},get rendererScripts(){return J.preloads?J.preloads.map(C.NotebookRendererScript.to):[]},get executeHandler(){return oe},set executeHandler(F){oe=F??S},get interruptHandler(){return q},set interruptHandler(F){q=F,J.supportsInterrupt=Boolean(F),V()},createNotebookCellExecution(F){if(o)throw new Error("notebook controller is DISPOSED");if(!T.has(F.notebook.uri))throw b._logService.trace(`NotebookController[${d}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(T.keys()).map(M=>M.toString())),new Error(`notebook controller is NOT associated to notebook: ${F.notebook.uri.toString()}`);return b._createNotebookCellExecution(F)},dispose:()=>{o||(this._logService.trace(`NotebookController[${d}], DISPOSED`),o=!0,this._kernelData.delete(d),L.dispose(),O.dispose(),W.dispose(),this._proxy.$removeKernel(d))},updateNotebookAffinity(F,M){b._proxy.$updateNotebookPriority(d,F.uri,M)},onDidReceiveMessage:W.event,postMessage(F,M){return _.checkProposedApiEnabled(t),b._proxy.$postMessage(d,M&&b._extHostNotebook.getIdByEditor(M),F)},asWebviewUri(F){return _.checkProposedApiEnabled(t),D.asWebviewUri(F,b._initData.remote)}};return this._kernelData.set(d,{extensionId:t.identifier,controller:N,onDidReceiveMessage:W,onDidChangeSelection:O,associatedNotebooks:T}),N}$acceptNotebookAssociation(t,r,i){const n=this._kernelData.get(t);if(n){const a=this._extHostNotebook.getNotebookDocument(A.URI.revive(r));i?n.associatedNotebooks.set(a.uri,!0):n.associatedNotebooks.delete(a.uri),this._logService.trace(`NotebookController[${t}] ASSOCIATE notebook`,a.uri.toString(),i),n.onDidChangeSelection.fire({selected:i,notebook:a.apiNotebook})}}async $executeCells(t,r,i){const n=this._kernelData.get(t);if(!n)return;const a=this._extHostNotebook.getNotebookDocument(A.URI.revive(r)),p=[];for(let d of i){const b=a.getCell(d);b&&p.push(b.apiCell)}try{this._logService.trace(`NotebookController[${t}] EXECUTE cells`,a.uri.toString(),p.length),await n.controller.executeHandler.call(n.controller,p,a.apiNotebook,n.controller)}catch(d){this._logService.error(`NotebookController[${t}] execute cells FAILED`,d),console.error(d)}}async $cancelCells(t,r,i){var n;const a=this._kernelData.get(t);if(!a)return;const p=this._extHostNotebook.getNotebookDocument(A.URI.revive(r));if(a.controller.interruptHandler)await a.controller.interruptHandler.call(a.controller,p.apiNotebook);else for(let d of i){const b=p.getCell(d);b&&((n=this._activeExecutions.get(b.uri))===null||n===void 0||n.cancel())}}$acceptKernelMessageFromRenderer(t,r,i){const n=this._kernelData.get(t);if(!n)return;const a=this._extHostNotebook.getEditorById(r);if(!a)throw new Error(`send message for UNKNOWN editor: ${r}`);n.onDidReceiveMessage.fire(Object.freeze({editor:a.apiEditor,message:i}))}_createNotebookCellExecution(t){if(t.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const i=this._extHostNotebook.getNotebookDocument(t.notebook.uri).getCellFromApiCell(t);if(!i)throw new Error("invalid cell");if(this._activeExecutions.has(i.uri))throw new Error(`duplicate execution for ${i.uri}`);const n=new u(i.notebook,i,this._mainContext.getProxy(k.MainContext.MainThreadNotebookDocuments));this._activeExecutions.set(i.uri,n);const a=n.onDidChangeState(()=>{n.state===E.Resolved&&(n.dispose(),a.dispose(),this._activeExecutions.delete(i.uri))});return n.asApiObject()}};w=Ve([We(3,c.ILogService)],w),e.ExtHostNotebookKernels=w;var E;(function(m){m[m.Init=0]="Init",m[m.Started=1]="Started",m[m.Resolved=2]="Resolved"})(E||(E={}));class u extends R.Disposable{constructor(t,r,i){super();this._document=t,this._cell=r,this._proxy=i,this._onDidChangeState=new v.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=E.Init,this._tokenSource=this._register(new l.CancellationTokenSource),this._collector=new h(10,n=>this.applyEdits(n)),this._executionOrder=r.internalMetadata.executionOrder,this.mixinMetadata({runState:I.NotebookCellExecutionState.Pending,executionOrder:null})}get state(){return this._state}cancel(){this._tokenSource.cancel()}async applyEditSoon(t){await this._collector.addItem(t)}async applyEdits(t){return this._proxy.$applyEdits(this._document.uri,t,!1)}verifyStateForOutput(){if(this._state===E.Init)throw new Error("Must call start before modifying cell output");if(this._state===E.Resolved)throw new Error("Cannot modify cell output after calling resolve")}mixinMetadata(t){const r={editType:9,handle:this._cell.handle,internalMetadata:t};this.applyEdits([r])}cellIndexToHandle(t){let r=this._cell;if(typeof t=="number"?r=this._document.getCellFromIndex(t):t&&(r=this._document.getCellFromApiCell(t)),!r)throw new Error("INVALID cell");return r.handle}validateAndConvertOutputs(t){return t.map(r=>{const i=f.NotebookCellOutput.ensureUniqueMimeTypes(r.items,!0);return i===r.items?C.NotebookCellOutput.from(r):C.NotebookCellOutput.from({items:i,id:r.id,metadata:r.metadata})})}async updateOutputs(t,r,i){const n=this.cellIndexToHandle(r),a=this.validateAndConvertOutputs(g.asArray(t));return this.applyEditSoon({editType:2,handle:n,append:i,outputs:a})}async updateOutputItems(t,r,i){return f.NotebookCellOutput.isNotebookCellOutput(r)&&(r=r.id),t=f.NotebookCellOutput.ensureUniqueMimeTypes(g.asArray(t),!0),this.applyEditSoon({editType:7,items:t.map(C.NotebookCellOutputItem.from),outputId:r,append:i})}asApiObject(){const t=this;return Object.freeze({get token(){return t._tokenSource.token},get cell(){return t._cell.apiCell},get executionOrder(){return t._executionOrder},set executionOrder(i){t._executionOrder=i,t.mixinMetadata({executionOrder:i})},start(i){if(t._state===E.Resolved||t._state===E.Started)throw new Error("Cannot call start again");t._state=E.Started,t._onDidChangeState.fire(),t.mixinMetadata({runState:I.NotebookCellExecutionState.Executing,runStartTime:i??null})},end(i,n){if(t._state===E.Resolved)throw new Error("Cannot call resolve twice");t._state=E.Resolved,t._onDidChangeState.fire(),t.mixinMetadata({runState:null,lastRunSuccess:i??null,runEndTime:n??null})},clearOutput(i){return t.verifyStateForOutput(),t.updateOutputs([],i,!1)},appendOutput(i,n){return t.verifyStateForOutput(),t.updateOutputs(i,n,!0)},replaceOutput(i,n){return t.verifyStateForOutput(),t.updateOutputs(i,n,!1)},appendOutputItems(i,n){return t.verifyStateForOutput(),t.updateOutputItems(i,n,!0)},replaceOutputItems(i,n){return t.verifyStateForOutput(),t.updateOutputItems(i,n,!1)}})}}class h{constructor(t,r){this.delay=t,this.callback=r,this.batch=[]}addItem(t){return this.batch.push(t),this.waitPromise||(this.waitPromise=s.timeout(this.delay).then(()=>{this.waitPromise=void 0;const r=this.batch;return this.batch=[],this.callback(r)})),this.waitPromise}}}),define(ge[230],pe([0,1,3,5,122]),function(X,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class y{constructor(C,D){this._extHostNotebook=D,this._rendererMessageEmitters=new Map,this.proxy=C.getProxy(R.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(C,D,P){var s;const I=this._extHostNotebook.getEditorById(C);!I||(s=this._rendererMessageEmitters.get(D))===null||s===void 0||s.fire({editor:I.apiEditor,message:P})}createRendererMessaging(C){return{onDidReceiveMessage:(...P)=>this.getOrCreateEmitterFor(C).event(...P),postMessage:(P,s)=>{const I=k.ExtHostNotebookEditor.apiEditorsToExtHost.get(P);if(!I)throw new Error("The first argument to postMessage() must be a NotebookEditor");this.proxy.$postMessage(I.id,C,s)}}}getOrCreateEmitterFor(C){let D=this._rendererMessageEmitters.get(C);return D||(D=new v.Emitter({onLastListenerRemove:()=>{D==null||D.dispose(),this._rendererMessageEmitters.delete(C)}}),this._rendererMessageEmitters.set(C,D),D)}}e.ExtHostNotebookRenderers=y}),define(ge[62],pe([0,1,5,3,6,22,4,12]),function(X,e,v,R,k,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class D extends k.Disposable{constructor(c,f,_,w){super();this._onDidAppend=this._register(new R.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=c,this._proxy=w,this._id=w.$register(this.name,f,_),this._disposed=!1,this._offset=0}get name(){return this._name}append(c){this.validate(),this._offset+=c?y.VSBuffer.fromString(c).byteLength:0}update(){this._id.then(c=>this._proxy.$update(c))}appendLine(c){this.validate(),this.append(c+`
`)}clear(){this.validate();const c=this._offset;this._id.then(f=>this._proxy.$clear(f,c))}show(c,f){this.validate(),this._id.then(_=>this._proxy.$reveal(_,!!(typeof c=="boolean"?c:f)))}hide(){this.validate(),this._id.then(c=>this._proxy.$close(c))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(c=>this._proxy.$dispose(c)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=D;class P extends D{constructor(c,f){super(c,!1,void 0,f)}append(c){super.append(c),this._id.then(f=>this._proxy.$append(f,c)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=P;class s extends D{constructor(c,f,_){super(c,!0,f,_)}append(c){throw new Error("Not supported")}}class I{constructor(c,f){this.name=c,this._channel=f}append(c){this._channel.then(f=>f.append(c))}appendLine(c){this._channel.then(f=>f.appendLine(c))}clear(){this._channel.then(c=>c.clear())}show(c,f){this._channel.then(_=>_.show(c,f))}hide(){this._channel.then(c=>c.hide())}dispose(){this._channel.then(c=>c.dispose())}}e.LazyOutputChannel=I;let l=class{constructor(c){this._proxy=c.getProxy(v.MainContext.MainThreadOutputService)}$setVisibleChannel(c){}createOutputChannel(c){if(c=c.trim(),!c)throw new Error("illegal argument `name`. must not be falsy");return new P(c,this._proxy)}createOutputChannelFromLogFile(c,f){if(c=c.trim(),!c)throw new Error("illegal argument `name`. must not be falsy");if(!f)throw new Error("illegal argument `file`. must not be falsy");return new s(c,f,this._proxy)}};l=Ve([We(0,C.IExtHostRpcService)],l),e.ExtHostOutputService=l,e.IExtHostOutputService=A.createDecorator("IExtHostOutputService")}),define(ge[231],pe([0,1,14,21,3,6,5,2,7,16,17,52]),function(X,e,v,R,k,y,A,C,D,P,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function l(g,c,f){const _=g.getProxy(A.MainContext.MainThreadQuickOpen);class w{constructor(n,a){this._sessions=new Map,this._instances=0,this._workspace=n,this._commands=a}showQuickPick(n,a,p,d=R.CancellationToken.None){this._onDidSelectItem=void 0;const b=Promise.resolve(n),S=++this._instances,o=_.$show(S,{title:p==null?void 0:p.title,placeHolder:p==null?void 0:p.placeHolder,matchOnDescription:p==null?void 0:p.matchOnDescription,matchOnDetail:p==null?void 0:p.matchOnDetail,ignoreFocusLost:p==null?void 0:p.ignoreFocusOut,canPickMany:p==null?void 0:p.canPickMany},d),L={},O=o.then(()=>L);return Promise.race([O,b]).then(W=>{if(W!==L)return b.then(J=>{const oe=[];for(let q=0;q<J.length;q++){const x=J[q];let V,T,N,F,M;typeof x=="string"?V=x:(V=x.label,T=x.description,N=x.detail,F=x.picked,M=x.alwaysShow),oe.push({label:V,description:T,handle:q,detail:N,picked:F,alwaysShow:M})}return p&&typeof p.onDidSelectItem=="function"&&(this._onDidSelectItem=q=>{p.onDidSelectItem(J[q])}),_.$setItems(S,oe),o.then(q=>{if(typeof q=="number")return J[q];if(Array.isArray(q))return q.map(x=>J[x])})})}).then(void 0,W=>{if(!P.isPromiseCanceledError(W))return _.$setError(S,W),Promise.reject(W)})}$onItemSelected(n){this._onDidSelectItem&&this._onDidSelectItem(n)}showInput(n,a=R.CancellationToken.None){return this._validateInput=n?n.validateInput:void 0,_.$input(n,typeof this._validateInput=="function",a).then(void 0,p=>{if(!P.isPromiseCanceledError(p))return Promise.reject(p)})}$validateInput(n){return this._validateInput?v.asPromise(()=>this._validateInput(n)):Promise.resolve(void 0)}async showWorkspaceFolderPick(n,a=R.CancellationToken.None){const p=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[n]);if(!p)return;const d=await this._workspace.getWorkspaceFolders2();if(!!d)return d.find(b=>b.uri.toString()===p.uri.toString())}createQuickPick(n,a){const p=new t(n,a,()=>this._sessions.delete(p._id));return this._sessions.set(p._id,p),p}createInputBox(n){const a=new r(n,()=>this._sessions.delete(a._id));return this._sessions.set(a._id,a),a}$onDidChangeValue(n,a){const p=this._sessions.get(n);p&&p._fireDidChangeValue(a)}$onDidAccept(n){const a=this._sessions.get(n);a&&a._fireDidAccept()}$onDidChangeActive(n,a){const p=this._sessions.get(n);p instanceof t&&p._fireDidChangeActive(a)}$onDidChangeSelection(n,a){const p=this._sessions.get(n);p instanceof t&&p._fireDidChangeSelection(a)}$onDidTriggerButton(n,a){const p=this._sessions.get(n);p&&p._fireDidTriggerButton(a)}$onDidHide(n){const a=this._sessions.get(n);a&&a._fireDidHide()}}class E{constructor(n,a){this._extensionId=n,this._onDidDispose=a,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new k.Emitter,this._onDidChangeValueEmitter=new k.Emitter,this._onDidTriggerButtonEmitter=new k.Emitter,this._onDidHideEmitter=new k.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(n){this._title=n,this.update({title:n})}get step(){return this._steps}set step(n){this._steps=n,this.update({step:n})}get totalSteps(){return this._totalSteps}set totalSteps(n){this._totalSteps=n,this.update({totalSteps:n})}get enabled(){return this._enabled}set enabled(n){this._enabled=n,this.update({enabled:n})}get busy(){return this._busy}set busy(n){this._busy=n,this.update({busy:n})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(n){this._ignoreFocusOut=n,this.update({ignoreFocusOut:n})}get value(){return this._value}set value(n){this._value=n,this.update({value:n})}get placeholder(){return this._placeholder}set placeholder(n){this._placeholder=n,this.update({placeholder:n})}get buttons(){return this._buttons}set buttons(n){this._buttons=n.slice(),this._handlesToButtons.clear(),n.forEach((a,p)=>{const d=a===D.QuickInputButtons.Back?-1:p;this._handlesToButtons.set(d,a)}),this.update({buttons:n.map((a,p)=>({iconPath:u(a.iconPath),tooltip:a.tooltip,handle:a===D.QuickInputButtons.Back?-1:p}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(n){this._value=n,this._onDidChangeValueEmitter.fire(n)}_fireDidTriggerButton(n){const a=this._handlesToButtons.get(n);a&&this._onDidTriggerButtonEmitter.fire(a)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=y.dispose(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),_.$dispose(this._id))}update(n){if(!this._disposed){for(const a of Object.keys(n)){const p=n[a];this._pendingUpdate[a]=p===void 0?null:p}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){_.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}E._nextId=1;function u(i){if(i instanceof D.ThemeIcon)return{id:i.id};const n=m(i),a=h(i);return{dark:typeof n=="string"?C.URI.file(n):n,light:typeof a=="string"?C.URI.file(a):a}}function h(i){return typeof i=="object"&&"light"in i?i.light:i}function m(i){return typeof i=="object"&&"dark"in i?i.dark:i}class t extends E{constructor(n,a,p){super(n,p);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new k.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new k.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(n){this._items=n.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),n.forEach((a,p)=>{this._handlesToItems.set(p,a),this._itemsToHandles.set(a,p)}),this.update({items:n.map((a,p)=>({label:a.label,description:a.description,handle:p,detail:a.detail,picked:a.picked,alwaysShow:a.alwaysShow}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(n){this._canSelectMany=n,this.update({canSelectMany:n})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(n){this._matchOnDescription=n,this.update({matchOnDescription:n})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(n){this._matchOnDetail=n,this.update({matchOnDetail:n})}get sortByLabel(){return this._sortByLabel}set sortByLabel(n){this._sortByLabel=n,this.update({sortByLabel:n})}get activeItems(){return this._activeItems}set activeItems(n){this._activeItems=n.filter(a=>this._itemsToHandles.has(a)),this.update({activeItems:this._activeItems.map(a=>this._itemsToHandles.get(a))})}get selectedItems(){return this._selectedItems}set selectedItems(n){this._selectedItems=n.filter(a=>this._itemsToHandles.has(a)),this.update({selectedItems:this._selectedItems.map(a=>this._itemsToHandles.get(a))})}_fireDidChangeActive(n){const a=s.coalesce(n.map(p=>this._handlesToItems.get(p)));this._activeItems=a,this._onDidChangeActiveEmitter.fire(a)}_fireDidChangeSelection(n){const a=s.coalesce(n.map(p=>this._handlesToItems.get(p)));this._selectedItems=a,this._onDidChangeSelectionEmitter.fire(a)}}class r extends E{constructor(n,a){super(n,a);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(n){this._password=n,this.update({password:n})}get prompt(){return this._prompt}set prompt(n){this._prompt=n,this.update({prompt:n})}get validationMessage(){return this._validationMessage}set validationMessage(n){this._validationMessage=n,this.update({validationMessage:n,severity:n?I.default.Error:I.default.Ignore})}}return new w(c,f)}e.createExtHostQuickOpen=l}),define(ge[232],pe([0,1,2,3,50,6,14,5,17,96,15,26,35]),function(X,e,v,R,k,y,A,C,D,P,s,I,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function g(n){if(n)return typeof n.iconPath=="string"?v.URI.file(n.iconPath):n.iconPath}function c(n,a){if(!n.iconPath&&!a.iconPath)return 0;if(n.iconPath){if(!a.iconPath)return 1}else return-1;const p=typeof n.iconPath=="string"?n.iconPath:n.iconPath.fsPath,d=typeof a.iconPath=="string"?a.iconPath:a.iconPath.fsPath;return P.comparePaths(p,d)}function f(n,a){let p=0;if(n.strikeThrough!==a.strikeThrough)return n.strikeThrough?1:-1;if(n.faded!==a.faded)return n.faded?1:-1;if(n.tooltip!==a.tooltip)return(n.tooltip||"").localeCompare(a.tooltip||"");if(p=c(n,a),p!==0)return p;if(n.light&&a.light)p=c(n.light,a.light);else{if(n.light)return 1;if(a.light)return-1}if(p!==0)return p;if(n.dark&&a.dark)p=c(n.dark,a.dark);else{if(n.dark)return 1;if(a.dark)return-1}return p}function _(n,a){if(n.command!==a.command)return n.command<a.command?-1:1;if(n.title!==a.title)return n.title<a.title?-1:1;if(n.tooltip!==a.tooltip){if(n.tooltip!==void 0&&a.tooltip!==void 0)return n.tooltip<a.tooltip?-1:1;if(n.tooltip!==void 0)return 1;if(a.tooltip!==void 0)return-1}if(n.arguments===a.arguments)return 0;if(n.arguments)if(a.arguments){if(n.arguments.length!==a.arguments.length)return n.arguments.length-a.arguments.length}else return 1;else return-1;for(let p=0;p<n.arguments.length;p++){const d=n.arguments[p],b=a.arguments[p];if(d!==b)return d<b?-1:1}return 0}function w(n,a){let p=P.comparePaths(n.resourceUri.fsPath,a.resourceUri.fsPath,!0);if(p!==0)return p;if(n.command&&a.command)p=_(n.command,a.command);else{if(n.command)return 1;if(a.command)return-1}if(p!==0)return p;if(n.decorations&&a.decorations)p=f(n.decorations,a.decorations);else{if(n.decorations)return 1;if(a.decorations)return-1}return p}function E(n,a){for(let p=0;p<n.length;p++)if(n[p]!==a[p])return!1;return!0}function u(n,a){return n.command===a.command&&n.title===a.title&&n.tooltip===a.tooltip&&(n.arguments&&a.arguments?E(n.arguments,a.arguments):n.arguments===a.arguments)}function h(n,a){return D.equals(n,a,u)}class m{constructor(a,p,d){this._extension=a,this._proxy=p,this._sourceControlHandle=d,this._value="",this._onDidChange=new R.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(a){this._proxy.$setInputBoxValue(this._sourceControlHandle,a),this.updateValue(a)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(a){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,a),this._placeholder=a}get validateInput(){return l.checkProposedApiEnabled(this._extension),this._validateInput}set validateInput(a){if(l.checkProposedApiEnabled(this._extension),a&&typeof a!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=a,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!a)}get visible(){return this._visible}set visible(a){a=!!a,this._visible!==a&&(this._visible=a,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,a))}focus(){l.checkProposedApiEnabled(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(a,p){l.checkProposedApiEnabled(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,a,p)}$onInputBoxValueChange(a){this.updateValue(a)}updateValue(a){this._value=a,this._onDidChange.fire(a)}}e.ExtHostSCMInputBox=m;class t{constructor(a,p,d,b,S){this._proxy=a,this._commands=p,this._sourceControlHandle=d,this._id=b,this._label=S,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new R.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new R.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=t._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(a){this._label=a,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,a)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(a){this._hideWhenEmpty=a,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(a){this._resourceStates=[...a],this._onDidUpdateResourceStates.fire()}getResourceState(a){return this._resourceStatesMap.get(a)}$executeResourceCommand(a,p){const d=this._resourceStatesCommandsMap.get(a);return d?A.asPromise(()=>this._commands.executeCommand(d.command,...d.arguments||[],p)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){var a;const p=[...this._resourceStates].sort(w),b=D.sortedDiff(this._resourceSnapshot,p,w).map(L=>{const O=L.toInsert.map(W=>{const J=this._resourceHandlePool++;this._resourceStatesMap.set(J,W);const oe=W.resourceUri,q=g(W.decorations),x=W.decorations&&g(W.decorations.light)||q,V=W.decorations&&g(W.decorations.dark)||q,T=[];let N;if(W.command)if(W.command.command==="vscode.open"||W.command.command==="vscode.diff"){const ie=new y.DisposableStore;N=this._commands.converter.toInternal(W.command,ie),this._resourceStatesDisposablesMap.set(J,ie)}else this._resourceStatesCommandsMap.set(J,W.command);x&&T.push(x),V&&V.toString()!==(x==null?void 0:x.toString())&&T.push(V);const F=W.decorations&&W.decorations.tooltip||"",M=W.decorations&&!!W.decorations.strikeThrough,U=W.decorations&&!!W.decorations.faded,B=W.contextValue||"";return{rawResource:[J,oe,T,F,M,U,B,N],handle:J}});return{start:L.start,deleteCount:L.deleteCount,toInsert:O}}),S=b.map(({start:L,deleteCount:O,toInsert:W})=>[L,O,W.map(J=>J.rawResource)]),o=b.reverse();for(const{start:L,deleteCount:O,toInsert:W}of o){const J=W.map(q=>q.handle),oe=this._handlesSnapshot.splice(L,O,...J);for(const q of oe)this._resourceStatesMap.delete(q),this._resourceStatesCommandsMap.delete(q),(a=this._resourceStatesDisposablesMap.get(q))===null||a===void 0||a.dispose(),this._resourceStatesDisposablesMap.delete(q)}return this._resourceSnapshot=p,S}dispose(){this._disposed=!0,this._onDidDispose.fire()}}t._handlePool=0;class r{constructor(a,p,d,b,S,o){this._proxy=p,this._commands=d,this._id=b,this._label=S,this._rootUri=o,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new y.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new y.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new R.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=r._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new m(a,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,b,S,o)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(a){this._count!==a&&(this._count=a,this._proxy.$updateSourceControl(this.handle,{count:a}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(a){this._quickDiffProvider=a,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!a})}get commitTemplate(){return this._commitTemplate}set commitTemplate(a){a!==this._commitTemplate&&(this._commitTemplate=a,this._proxy.$updateSourceControl(this.handle,{commitTemplate:a}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(a){this._acceptInputDisposables.value=new y.DisposableStore,this._acceptInputCommand=a;const p=this._commands.converter.toInternal(a,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:p})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(a){if(this._statusBarCommands&&a&&h(this._statusBarCommands,a))return;this._statusBarDisposables.value=new y.DisposableStore,this._statusBarCommands=a;const p=(a||[]).map(d=>this._commands.converter.toInternal(d,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:p})}get selected(){return this._selected}createResourceGroup(a,p){const d=new t(this._proxy,this._commands,this.handle,a,p),b=R.Event.once(d.onDidDispose)(()=>this.createdResourceGroups.delete(d));return this.createdResourceGroups.set(d,b),this.eventuallyAddResourceGroups(),d}eventuallyAddResourceGroups(){const a=[],p=[];for(const[d,b]of this.createdResourceGroups){b.dispose();const S=d.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(d),this.eventuallyUpdateResourceStates()});R.Event.once(d.onDidDispose)(()=>{this.updatedResourceGroups.delete(d),S.dispose(),this._groups.delete(d.handle),this._proxy.$unregisterGroup(this.handle,d.handle)}),a.push([d.handle,d.id,d.label,d.features]);const o=d._takeResourceStateSnapshot();o.length>0&&p.push([d.handle,o]),this._groups.set(d.handle,d)}this._proxy.$registerGroups(this.handle,a,p),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const a=[];this.updatedResourceGroups.forEach(p=>{const d=p._takeResourceStateSnapshot();d.length!==0&&a.push([p.handle,d])}),a.length>0&&this._proxy.$spliceResourceStates(this.handle,a),this.updatedResourceGroups.clear()}getResourceGroup(a){return this._groups.get(a)}setSelectionState(a){this._selected=a,this._onDidChangeSelection.fire(a)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(a=>a.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}r._handlePool=0,Ve([k.debounce(100)],r.prototype,"eventuallyAddResourceGroups",null),Ve([k.debounce(100)],r.prototype,"eventuallyUpdateResourceStates",null);let i=class Nn{constructor(a,p,d){this._commands=p,this.logService=d,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new R.Emitter,this._proxy=a.getProxy(C.MainContext.MainThreadSCM),this._telemetry=a.getProxy(C.MainContext.MainThreadTelemetry),p.registerArgumentProcessor({processArgument:b=>{if(b&&b.$mid===3){const S=this._sourceControls.get(b.sourceControlHandle);if(!S)return b;const o=S.getResourceGroup(b.groupHandle);return o?o.getResourceState(b.handle):b}else if(b&&b.$mid===4){const S=this._sourceControls.get(b.sourceControlHandle);return S?S.getResourceGroup(b.groupHandle):b}else if(b&&b.$mid===5){const S=this._sourceControls.get(b.handle);return S||b}return b}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(a,p,d,b){this.logService.trace("ExtHostSCM#createSourceControl",a.identifier.value,p,d,b),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:a.identifier.value});const S=Nn._handlePool++,o=new r(a,this._proxy,this._commands,p,d,b);this._sourceControls.set(S,o);const L=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(a.identifier))||[];return L.push(o),this._sourceControlsByExtension.set(I.ExtensionIdentifier.toKey(a.identifier),L),o}getLastInputBox(a){this.logService.trace("ExtHostSCM#getLastInputBox",a.identifier.value);const p=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(a.identifier)),d=p&&p[p.length-1];return d&&d.inputBox}$provideOriginalResource(a,p,d){const b=v.URI.revive(p);this.logService.trace("ExtHostSCM#$provideOriginalResource",a,b.toString());const S=this._sourceControls.get(a);return!S||!S.quickDiffProvider||!S.quickDiffProvider.provideOriginalResource?Promise.resolve(null):A.asPromise(()=>S.quickDiffProvider.provideOriginalResource(b,d)).then(o=>o||null)}$onInputBoxValueChange(a,p){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",a);const d=this._sourceControls.get(a);return d&&d.inputBox.$onInputBoxValueChange(p),Promise.resolve(void 0)}$executeResourceCommand(a,p,d,b){this.logService.trace("ExtHostSCM#$executeResourceCommand",a,p,d);const S=this._sourceControls.get(a);if(!S)return Promise.resolve(void 0);const o=S.getResourceGroup(p);return o?o.$executeResourceCommand(d,b):Promise.resolve(void 0)}$validateInput(a,p,d){this.logService.trace("ExtHostSCM#$validateInput",a);const b=this._sourceControls.get(a);return!b||!b.inputBox.validateInput?Promise.resolve(void 0):A.asPromise(()=>b.inputBox.validateInput(p,d)).then(S=>S?Promise.resolve([S.message,S.type]):Promise.resolve(void 0))}$setSelectedSourceControl(a){var p,d;return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",a),a!==void 0&&((p=this._sourceControls.get(a))===null||p===void 0||p.setSelectionState(!0)),this._selectedSourceControlHandle!==void 0&&((d=this._sourceControls.get(this._selectedSourceControlHandle))===null||d===void 0||d.setSelectionState(!1)),this._selectedSourceControlHandle=a,Promise.resolve(void 0)}};i._handlePool=0,i=Ve([We(2,s.ILogService)],i),e.ExtHostSCM=i});var tt=this&&this.__classPrivateFieldSet||function(X,e,v,R,k){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!k:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?k.call(X,v):k?k.value=v:e.set(X,v),v},$e=this&&this.__classPrivateFieldGet||function(X,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!R:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(X):R?R.value:e.get(X)};define(ge[233],pe([0,1,7,5,161,6]),function(X,e,v,R,k,y){"use strict";var A,C;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class D{constructor(l,g,c,f,_=v.StatusBarAlignment.Left,w){A.set(this,void 0),C.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new y.DisposableStore,tt(this,A,l,"f"),tt(this,C,g,"f"),this._entryId=D.ID_GEN++,this._extension=c,this._id=f,this._alignment=_,this._priority=w}get id(){var l;return(l=this._id)!==null&&l!==void 0?l:this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){var l;return(l=this._command)===null||l===void 0?void 0:l.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(l){this._text=l,this.update()}set name(l){this._name=l,this.update()}set tooltip(l){this._tooltip=l,this.update()}set color(l){this._color=l,this.update()}set backgroundColor(l){l&&!D.ALLOWED_BACKGROUND_COLORS.has(l.id)&&(l=void 0),this._backgroundColor=l,this.update()}set command(l){var g;((g=this._command)===null||g===void 0?void 0:g.fromApi)!==l&&(this._internalCommandRegistration.clear(),typeof l=="string"?this._command={fromApi:l,internal:$e(this,C,"f").toInternal({title:"",command:l},this._internalCommandRegistration)}:l?this._command={fromApi:l,internal:$e(this,C,"f").toInternal(l,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(l){this._accessibilityInformation=l,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,$e(this,A,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{var l;this._timeoutHandle=void 0;let g;this._extension?this._id?g=`${this._extension.identifier.value}.${this._id}`:g=this._extension.identifier.value:g=this._id;let c;this._name?c=this._name:c=k.localize(0,null,this._extension.displayName||this._extension.name);let f=this._color;this._backgroundColor&&(f=D.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id)),$e(this,A,"f").$setEntry(this._entryId,g,c,this._text,this._tooltip,(l=this._command)===null||l===void 0?void 0:l.internal,f,this._backgroundColor,this._alignment===v.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=D,A=new WeakMap,C=new WeakMap,D.ID_GEN=0,D.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new v.ThemeColor("statusBarItem.errorForeground")]]);class P{constructor(l){this._messages=[],this._item=l.createStatusBarEntry(void 0,"status.extensionMessage",v.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=k.localize(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(l){const g={message:l};return this._messages.unshift(g),this._update(),new v.Disposable(()=>{const c=this._messages.indexOf(g);c>=0&&(this._messages.splice(c,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class s{constructor(l,g){this._proxy=l.getProxy(R.MainContext.MainThreadStatusBar),this._commands=g,this._statusMessage=new P(this)}createStatusBarEntry(l,g,c,f){return new D(this._proxy,this._commands,l,g,c,f)}setStatusBarMessage(l,g){const c=this._statusMessage.setMessage(l);let f;return typeof g=="number"?f=setTimeout(()=>c.dispose(),g):typeof g!="undefined"&&g.then(()=>c.dispose(),()=>c.dispose()),new v.Disposable(()=>{c.dispose(),clearTimeout(f)})}}e.ExtHostStatusBar=s}),define(ge[88],pe([0,1,5,3,4]),function(X,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class y{constructor(C){this._onDidChangeStorage=new R.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=C.getProxy(v.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(C,D){this._proxy.$registerExtensionStorageKeysToSync(C,D)}getValue(C,D,P){return this._proxy.$getValue(C,D).then(s=>s||P)}setValue(C,D,P){return this._proxy.$setValue(C,D,P)}$acceptValue(C,D,P){this._onDidChangeStorage.fire({shared:C,key:D,value:P})}}e.ExtHostStorage=y,e.IExtHostStorage=k.createDecorator("IExtHostStorage")}),define(ge[89],pe([0,1,4,27,15,87,2]),function(X,e,v,R,k,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=v.createDecorator("IExtensionStoragePaths");let C=class{constructor(P,s,I){var l;this._logService=s,this._extHostFileSystem=I,this._workspace=(l=P.workspace)!==null&&l!==void 0?l:void 0,this._environment=P.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(g=>this._value=g)}async _getOrCreateWorkspaceStoragePath(){var P;if(!this._workspace)return Promise.resolve(void 0);const s=this._workspace.id,I=A.URI.joinPath(this._environment.workspaceStorageHome,s);try{return await this._extHostFileSystem.value.stat(I),this._logService.trace("[ExtHostStorage] storage dir already exists",I),I}catch(l){}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",I),await this._extHostFileSystem.value.createDirectory(I),await this._extHostFileSystem.value.writeFile(A.URI.joinPath(I,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:(P=A.URI.revive(this._workspace.configuration))===null||P===void 0?void 0:P.toString(),name:this._workspace.name},void 0,2))),I}catch(l){this._logService.error("[ExtHostStorage]",l);return}}workspaceValue(P){if(this._value)return A.URI.joinPath(this._value,P.identifier.value)}globalValue(P){return A.URI.joinPath(this._environment.globalStorageHome,P.identifier.value.toLowerCase())}};C=Ve([We(0,R.IExtHostInitDataService),We(1,k.ILogService),We(2,y.IExtHostConsumerFileSystem)],C),e.ExtensionStoragePaths=C}),define(ge[33],pe([0,1,3,5,4,2,12,6,7,162,16,199,21,32,187,13]),function(X,e,v,R,k,y,A,C,D,P,s,I,l,g,c,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=k.createDecorator("IExtHostTerminalService");class _{constructor(i,n,a,p){this._proxy=i,this._id=n,this._creationOptions=a,this._name=p,this._disposed=!1,this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(b=>this._pidPromiseComplete=b);const d=this;this.value={get name(){return d._name||""},get processId(){return d._pidPromise},get creationOptions(){return d._creationOptions},get exitStatus(){return d._exitStatus},sendText(b,S=!0){d._checkDisposed(),d._proxy.$sendText(d._id,b,S)},show(b){d._checkDisposed(),d._proxy.$show(d._id,b)},hide(){d._checkDisposed(),d._proxy.$hide(d._id)},dispose(){d._disposed||(d._disposed=!0,d._proxy.$dispose(d._id))},get dimensions(){if(!(d._cols===void 0||d._rows===void 0))return{columns:d._cols,rows:d._rows}}}}async create(i,n){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:i.name,shellPath:f.withNullAsUndefined(i.shellPath),shellArgs:f.withNullAsUndefined(i.shellArgs),cwd:f.withNullAsUndefined(i.cwd),env:f.withNullAsUndefined(i.env),icon:f.withNullAsUndefined(t(i.iconPath)),initialText:f.withNullAsUndefined(i.message),strictEnv:f.withNullAsUndefined(i.strictEnv),hideFromUser:f.withNullAsUndefined(i.hideFromUser),isFeatureTerminal:f.withNullAsUndefined(n==null?void 0:n.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:f.withNullAsUndefined(n==null?void 0:n.useShellEnvironment),isSplitTerminal:f.withNullAsUndefined(n==null?void 0:n.isSplitTerminal)})}async createExtensionTerminal(i,n){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:n,isSplitTerminal:i}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(i){this._name=i}setExitCode(i){this._exitStatus=Object.freeze({code:i})}setDimensions(i,n){return i===this._cols&&n===this._rows||i===0||n===0?!1:(this._cols=i,this._rows=n,!0)}_setProcessId(i){this._pidPromiseComplete?(this._pidPromiseComplete(i),this._pidPromiseComplete=void 0):this._pidPromise.then(n=>{n!==i&&(this._pidPromise=Promise.resolve(i))})}}e.ExtHostTerminal=_;class w{constructor(i){this._pty=i,this.id=0,this.shouldPersist=!1,this._onProcessData=new v.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new v.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new v.Emitter,this._onProcessTitleChanged=new v.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new v.Emitter,this._onProcessShellTypeChanged=new v.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(i){this._pty.handleInput&&this._pty.handleInput(i)}resize(i,n){this._pty.setDimensions&&this._pty.setDimensions({columns:i,rows:n})}async processBinary(i){}acknowledgeDataEvent(i){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(i){this._pty.onDidWrite(n=>this._onProcessData.fire(n)),this._pty.onDidClose&&this._pty.onDidClose((n=void 0)=>{this._onProcessExit.fire(n===void 0?void 0:n)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(n=>this._onProcessOverrideDimensions.fire(n&&{cols:n.columns,rows:n.rows})),this._pty.onDidChangeName&&this._pty.onDidChangeName(n=>this._onProcessTitleChanged.fire(n)),this._pty.open(i||void 0),this._pty.setDimensions&&i&&this._pty.setDimensions(i),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=w;let E=1,u=class extends C.Disposable{constructor(i,n){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new v.Emitter,this._onDidOpenTerminal=new v.Emitter,this._onDidChangeActiveTerminal=new v.Emitter,this._onDidChangeTerminalDimensions=new v.Emitter,this._proxy=n.getProxy(R.MainContext.MainThreadTerminalService),this._bufferer=new c.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new v.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(i),this._register({dispose:()=>{for(const[a,p]of this._terminalProcesses)p.shutdown(!0)}})}get activeTerminal(){var i;return(i=this._activeTerminal)===null||i===void 0?void 0:i.value}get terminals(){return this._terminals.map(i=>i.value)}get onDidCloseTerminal(){return this._onDidCloseTerminal&&this._onDidCloseTerminal.event}get onDidOpenTerminal(){return this._onDidOpenTerminal&&this._onDidOpenTerminal.event}get onDidChangeActiveTerminal(){return this._onDidChangeActiveTerminal&&this._onDidChangeActiveTerminal.event}get onDidChangeTerminalDimensions(){return this._onDidChangeTerminalDimensions&&this._onDidChangeTerminalDimensions.event}get onDidWriteTerminalData(){return this._onDidWriteTerminalData&&this._onDidWriteTerminalData.event}getDefaultShell(i){const n=i?this._defaultAutomationProfile:this._defaultProfile;return(n==null?void 0:n.path)||""}getDefaultShellArgs(i){const n=i?this._defaultAutomationProfile:this._defaultProfile;return(n==null?void 0:n.args)||[]}createExtensionTerminal(i,n){const a=new _(this._proxy,g.generateUuid(),i,i.name),p=new w(i.pty);return a.createExtensionTerminal(n==null?void 0:n.isSplitTerminal,t(i.iconPath)).then(d=>{const b=this._setupExtHostProcessListeners(d,p);this._terminalProcessDisposables[d]=b}),this._terminals.push(a),a.value}attachPtyToTerminal(i,n){if(!this._getTerminalById(i))throw new Error(`Cannot resolve terminal with id ${i} for virtual process`);const p=new w(n),d=this._setupExtHostProcessListeners(i,p);this._terminalProcessDisposables[i]=d}async $acceptActiveTerminalChanged(i){const n=this._activeTerminal;if(i===null){this._activeTerminal=void 0,n!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const a=this._getTerminalById(i);a&&(this._activeTerminal=a,n!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(i,n){const a=this._getTerminalById(i);a&&this._onDidWriteTerminalData.fire({terminal:a.value,data:n})}async $acceptTerminalDimensions(i,n,a){const p=this._getTerminalById(i);p&&p.setDimensions(n,a)&&this._onDidChangeTerminalDimensions.fire({terminal:p.value,dimensions:p.value.dimensions})}async $acceptTerminalMaximumDimensions(i,n,a){var p;(p=this._terminalProcesses.get(i))===null||p===void 0||p.resize(n,a)}async $acceptTerminalTitleChange(i,n){const a=this._getTerminalById(i);a&&(a.name=n)}async $acceptTerminalClosed(i,n){const a=this._getTerminalObjectIndexById(this._terminals,i);if(a!==null){const p=this._terminals.splice(a,1)[0];p.setExitCode(n),this._onDidCloseTerminal.fire(p.value)}}$acceptTerminalOpened(i,n,a,p){if(n){const S=this._getTerminalObjectIndexById(this._terminals,n);if(S!==null){this._terminals[S]._id=i,this._onDidOpenTerminal.fire(this.terminals[S]),this._terminals[S].isOpen=!0;return}}const d={name:p.name,shellPath:p.executable,shellArgs:p.args,cwd:typeof p.cwd=="string"?p.cwd:y.URI.revive(p.cwd),env:p.env,hideFromUser:p.hideFromUser},b=new _(this._proxy,i,d,a);this._terminals.push(b),this._onDidOpenTerminal.fire(b.value),b.isOpen=!0}async $acceptTerminalProcessId(i,n){const a=this._getTerminalById(i);a&&a._setProcessId(n)}async $startExtensionTerminal(i,n){const a=this._getTerminalById(i);if(!a)return{message:P.localize(0,null,i)};a.isOpen||await new Promise(d=>{const b=this.onDidOpenTerminal(async S=>{S===a.value&&(b.dispose(),d())})});const p=this._terminalProcesses.get(i);p?p.startSendingEvents(n):this._extensionTerminalAwaitingStart[i]={initialDimensions:n}}_setupExtHostProcessListeners(i,n){const a=new C.DisposableStore;a.add(n.onProcessReady(d=>this._proxy.$sendProcessReady(i,d.pid,d.cwd))),a.add(n.onProcessTitleChanged(d=>this._proxy.$sendProcessTitle(i,d))),this._bufferer.startBuffering(i,n.onProcessData),a.add(n.onProcessExit(d=>this._onProcessExit(i,d))),n.onProcessOverrideDimensions&&a.add(n.onProcessOverrideDimensions(d=>this._proxy.$sendOverrideDimensions(i,d))),this._terminalProcesses.set(i,n);const p=this._extensionTerminalAwaitingStart[i];return p&&n instanceof w&&(n.startSendingEvents(p.initialDimensions),delete this._extensionTerminalAwaitingStart[i]),a}$acceptProcessAckDataEvent(i,n){var a;(a=this._terminalProcesses.get(i))===null||a===void 0||a.acknowledgeDataEvent(n)}$acceptProcessInput(i,n){var a;(a=this._terminalProcesses.get(i))===null||a===void 0||a.input(n)}$acceptProcessResize(i,n,a){var p;try{(p=this._terminalProcesses.get(i))===null||p===void 0||p.resize(n,a)}catch(d){if(d.code!=="EPIPE"&&d.code!=="ERR_IPC_CHANNEL_CLOSED")throw d}}$acceptProcessShutdown(i,n){var a;(a=this._terminalProcesses.get(i))===null||a===void 0||a.shutdown(n)}$acceptProcessRequestInitialCwd(i){var n;(n=this._terminalProcesses.get(i))===null||n===void 0||n.getInitialCwd().then(a=>this._proxy.$sendProcessInitialCwd(i,a))}$acceptProcessRequestCwd(i){var n;(n=this._terminalProcesses.get(i))===null||n===void 0||n.getCwd().then(a=>this._proxy.$sendProcessCwd(i,a))}$acceptProcessRequestLatency(i){return i}registerLinkProvider(i){return this._linkProviders.add(i),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new D.Disposable(()=>{this._linkProviders.delete(i),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(i,n){if(this._profileProviders.has(i))throw new Error(`Terminal profile provider "${i}" already registered`);return this._profileProviders.set(i,n),this._proxy.$registerProfileProvider(i),new D.Disposable(()=>{this._profileProviders.delete(i),this._proxy.$unregisterProfileProvider(i)})}async $createContributedProfileTerminal(i,n){var a;const p=new l.CancellationTokenSource().token,d=await((a=this._profileProviders.get(i))===null||a===void 0?void 0:a.provideProfileOptions(p));if(!p.isCancellationRequested){if(!d)throw new Error(`No terminal profile options provided for id "${i}"`);if("pty"in d){this.createExtensionTerminal(d,{isSplitTerminal:n});return}this.createTerminalFromOptions(d,{isSplitTerminal:n})}}async $provideLinks(i,n){const a=this._getTerminalById(i);if(!a)return[];this._terminalLinkCache.delete(i);const p=this._terminalLinkCancellationSource.get(i);p&&p.dispose(!0);const d=new l.CancellationTokenSource;this._terminalLinkCancellationSource.set(i,d);const b=[],S={terminal:a.value,line:n},o=[];for(const W of this._linkProviders)o.push(new Promise(async J=>{d.token.onCancellationRequested(()=>J({provider:W,links:[]}));const oe=await W.provideTerminalLinks(S,d.token)||[];d.token.isCancellationRequested||J({provider:W,links:oe})}));const L=await Promise.all(o);if(d.token.isCancellationRequested)return[];const O=new Map;for(const W of L)W&&W.links.length>0&&b.push(...W.links.map(J=>{const oe={id:E++,startIndex:J.startIndex,length:J.length,label:J.tooltip};return O.set(oe.id,{provider:W.provider,link:J}),oe}));return this._terminalLinkCache.set(i,O),b}$activateLink(i,n){var a;const p=(a=this._terminalLinkCache.get(i))===null||a===void 0?void 0:a.get(n);!p||p.provider.handleTerminalLink(p.link)}_onProcessExit(i,n){this._bufferer.stopBuffering(i),this._terminalProcesses.delete(i),delete this._extensionTerminalAwaitingStart[i];const a=this._terminalProcessDisposables[i];a&&(a.dispose(),delete this._terminalProcessDisposables[i]),this._proxy.$sendProcessExit(i,n)}_getTerminalById(i){return this._getTerminalObjectById(this._terminals,i)}_getTerminalObjectById(i,n){const a=this._getTerminalObjectIndexById(i,n);return a!==null?i[a]:null}_getTerminalObjectIndexById(i,n){let a=null;return i.some((p,d)=>p._id===n?(a=d,!0):!1),a}getEnvironmentVariableCollection(i){let n=this._environmentVariableCollections.get(i.identifier.value);return n||(n=new h,this._setEnvironmentVariableCollection(i.identifier.value,n)),n}_syncEnvironmentVariableCollection(i,n){const a=I.serializeEnvironmentVariableCollection(n.map);this._proxy.$setEnvironmentVariableCollection(i,n.persistent,a.length===0?void 0:a)}$initEnvironmentVariableCollections(i){i.forEach(n=>{const a=n[0],p=new h(n[1]);this._setEnvironmentVariableCollection(a,p)})}$acceptDefaultProfile(i,n){this._defaultProfile=i,this._defaultAutomationProfile=n}_setEnvironmentVariableCollection(i,n){this._environmentVariableCollections.set(i,n),n.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(i,n)})}};u=Ve([We(1,A.IExtHostRpcService)],u),e.BaseExtHostTerminalService=u;class h{constructor(i){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new v.Emitter,this.map=new Map(i)}get persistent(){return this._persistent}set persistent(i){this._persistent=i,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(i,n){this._setIfDiffers(i,{value:n,type:D.EnvironmentVariableMutatorType.Replace})}append(i,n){this._setIfDiffers(i,{value:n,type:D.EnvironmentVariableMutatorType.Append})}prepend(i,n){this._setIfDiffers(i,{value:n,type:D.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(i,n){const a=this.map.get(i);(!a||a.value!==n.value||a.type!==n.type)&&(this.map.set(i,n),this._onDidChangeCollection.fire())}get(i){return this.map.get(i)}forEach(i,n){this.map.forEach((a,p)=>i.call(n,p,a,this))}delete(i){this.map.delete(i),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=h;let m=class extends u{constructor(i){super(!1,i)}createTerminal(i,n,a){throw new s.NotSupportedError}createTerminalFromOptions(i,n){throw new s.NotSupportedError}};m=Ve([We(0,A.IExtHostRpcService)],m),e.WorkerExtHostTerminalService=m;function t(r){if(!!r)return"id"in r?{id:r.id,color:r.color}:r}}),define(ge[234],pe([0,1,3,17,5,123,18,7]),function(X,e,v,R,k,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class D{constructor(s,I){this._extHostDocumentsAndEditors=I,this._onDidChangeTextEditorSelection=new v.Emitter,this._onDidChangeTextEditorOptions=new v.Emitter,this._onDidChangeTextEditorVisibleRanges=new v.Emitter,this._onDidChangeTextEditorViewColumn=new v.Emitter,this._onDidChangeActiveTextEditor=new v.Emitter,this._onDidChangeVisibleTextEditors=new v.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=s.getProxy(k.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(l=>this._onDidChangeVisibleTextEditors.fire(l)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(l=>this._onDidChangeActiveTextEditor.fire(l))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(s){const I=this._extHostDocumentsAndEditors.allEditors();return s?I:I.map(l=>l.value)}async showTextDocument(s,I,l){let g;typeof I=="number"?g={position:A.ViewColumn.from(I),preserveFocus:l}:typeof I=="object"?g={position:A.ViewColumn.from(I.viewColumn),preserveFocus:I.preserveFocus,selection:typeof I.selection=="object"?A.Range.from(I.selection):void 0,pinned:typeof I.preview=="boolean"?!I.preview:void 0}:g={preserveFocus:!1};const c=await this._proxy.$tryShowTextDocument(s.uri,g),f=c&&this._extHostDocumentsAndEditors.getEditor(c);if(f)return f.value;throw c?new Error(`Could NOT open editor for "${s.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${s.uri.toString()}".`)}createTextEditorDecorationType(s,I){return new y.TextEditorDecorationType(this._proxy,s,I).value}$acceptEditorPropertiesChanged(s,I){const l=this._extHostDocumentsAndEditors.getEditor(s);if(!l)throw new Error("unknown text editor");if(I.options&&l._acceptOptions(I.options),I.selections){const g=I.selections.selections.map(A.Selection.to);l._acceptSelections(g)}if(I.visibleRanges){const g=R.coalesce(I.visibleRanges.map(A.Range.to));l._acceptVisibleRanges(g)}if(I.options&&this._onDidChangeTextEditorOptions.fire({textEditor:l.value,options:Object.assign(Object.assign({},I.options),{lineNumbers:A.TextEditorLineNumbersStyle.to(I.options.lineNumbers)})}),I.selections){const g=C.TextEditorSelectionChangeKind.fromValue(I.selections.source),c=I.selections.selections.map(A.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:l.value,selections:c,kind:g})}if(I.visibleRanges){const g=R.coalesce(I.visibleRanges.map(A.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:l.value,visibleRanges:g})}}$acceptEditorPositionData(s){for(const I in s){const l=this._extHostDocumentsAndEditors.getEditor(I);if(!l)throw new Error("Unknown text editor");const g=A.ViewColumn.to(s[I]);l.value.viewColumn!==g&&(l._acceptViewColumn(g),this._onDidChangeTextEditorViewColumn.fire({textEditor:l.value,viewColumn:g}))}}getDiffInformation(s){return Promise.resolve(this._proxy.$getDiffInformation(s))}}e.ExtHostEditors=D});var En=this&&this.__rest||function(X,e){var v={};for(var R in X)Object.prototype.hasOwnProperty.call(X,R)&&e.indexOf(R)<0&&(v[R]=X[R]);if(X!=null&&typeof Object.getOwnPropertySymbols=="function")for(var k=0,R=Object.getOwnPropertySymbols(X);k<R.length;k++)e.indexOf(R[k])<0&&Object.prototype.propertyIsEnumerable.call(X,R[k])&&(v[R[k]]=X[R[k]]);return v};define(ge[235],pe([0,1,2,4,5,6,7]),function(X,e,v,R,k,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=R.createDecorator("IExtHostTimeline");class C{constructor(s,I){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=s.getProxy(k.MainContext.MainThreadTimeline),I.registerArgumentProcessor({processArgument:l=>{var g,c;if(l&&l.$mid===11){const f=l.uri===void 0?void 0:v.URI.revive(l.uri);return(c=(g=this._itemsBySourceAndUriMap.get(l.source))===null||g===void 0?void 0:g.get(D(f)))===null||c===void 0?void 0:c.get(l.handle)}return l}})}async $getTimeline(s,I,l,g,c){const f=this._providers.get(s);return f==null?void 0:f.provideTimeline(v.URI.revive(I),l,g,c)}registerTimelineProvider(s,I,l,g){const c=new y.DisposableStore,f=this.convertTimelineItem(I.id,g,c).bind(this);let _;I.onDidChange&&(_=I.onDidChange(E=>this._proxy.$emitTimelineChangeEvent(Object.assign(Object.assign({uri:void 0,reset:!0},E),{id:I.id})),this));const w=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore(Object.assign(Object.assign({},I),{scheme:s,onDidChange:void 0,async provideTimeline(E,u,h,m){var t;(m==null?void 0:m.resetCache)&&(c.clear(),(t=w.get(I.id))===null||t===void 0||t.clear());const r=await I.provideTimeline(E,u,h);if(r==null)return;const i=f(E,m);return Object.assign(Object.assign({},r),{source:I.id,items:r.items.map(i)})},dispose(){var E;for(const u of w.values())(E=u.get(I.id))===null||E===void 0||E.clear();_==null||_.dispose(),c.dispose()}}))}convertTimelineItem(s,I,l){return(g,c)=>{let f;if(c==null?void 0:c.cacheResults){let _=this._itemsBySourceAndUriMap.get(s);_===void 0&&(_=new Map,this._itemsBySourceAndUriMap.set(s,_));const w=D(g);f=_.get(w),f===void 0&&(f=new Map,_.set(w,f))}return _=>{var w,E;const{iconPath:u}=_,h=En(_,["iconPath"]),m=`${s}|${(w=_.id)!==null&&w!==void 0?w:_.timestamp}`;f==null||f.set(m,_);let t,r,i;return _.iconPath&&(u instanceof A.ThemeIcon?i={id:u.id}:v.URI.isUri(u)?(t=u,r=u):{light:t,dark:r}=u),Object.assign(Object.assign({},h),{id:(E=h.id)!==null&&E!==void 0?E:void 0,handle:m,source:s,command:_.command?I.toInternal(_.command,l):void 0,icon:t,iconDark:r,themeIcon:i,accessibilityInformation:_.accessibilityInformation})}}}registerTimelineProviderCore(s){if(this._providers.get(s.id))throw new Error(`Timeline Provider ${s.id} already exists.`);return this._proxy.$registerTimelineProvider({id:s.id,label:s.label,scheme:s.scheme}),this._providers.set(s.id,s),y.toDisposable(()=>{var l;for(const g of this._itemsBySourceAndUriMap.values())(l=g.get(s.id))===null||l===void 0||l.clear();this._providers.delete(s.id),this._proxy.$unregisterTimelineProvider(s.id),s.dispose()})}}e.ExtHostTimeline=C;function D(P){return P==null?void 0:P.toString()}}),define(ge[236],pe([0,1,6,10,2,5]),function(X,e,v,R,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class A{constructor(D){this._openers=new Map,this._proxy=D.getProxy(y.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(D,P,s,I){if(this._openers.has(P))throw new Error(`Opener with id '${P}' already registered`);const l=I.schemes.find(g=>!A.supportedSchemes.has(g));if(l)throw new Error(`Scheme '${l}' is not supported. Only http and https are currently supported.`);return this._openers.set(P,s),this._proxy.$registerUriOpener(P,I.schemes,D,I.label),v.toDisposable(()=>{this._openers.delete(P),this._proxy.$unregisterUriOpener(P)})}async $canOpenUri(D,P,s){const I=this._openers.get(D);if(!I)throw new Error(`Unknown opener with id: ${D}`);const l=k.URI.revive(P);return I.canOpenExternalUri(l,s)}async $openUri(D,P,s){const I=this._openers.get(D);if(!I)throw new Error(`Unknown opener id: '${D}'`);return I.openExternalUri(k.URI.revive(P.resolvedUri),{sourceUri:k.URI.revive(P.sourceUri)},s)}}e.ExtHostUriOpeners=A,A.supportedSchemes=new Set([R.Schemas.http,R.Schemas.https])}),define(ge[237],pe([0,1,5,2,6,16,26]),function(X,e,v,R,k,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class C{constructor(P){this.handles=new Set,this.handlers=new Map,this._proxy=P.getProxy(v.MainContext.MainThreadUrls)}registerUriHandler(P,s){if(this.handles.has(A.ExtensionIdentifier.toKey(P)))throw new Error(`Protocol handler already registered for extension ${P}`);const I=C.HandlePool++;return this.handles.add(A.ExtensionIdentifier.toKey(P)),this.handlers.set(I,s),this._proxy.$registerUriHandler(I,P),k.toDisposable(()=>{this.handles.delete(A.ExtensionIdentifier.toKey(P)),this.handlers.delete(I),this._proxy.$unregisterUriHandler(I)})}$handleExternalUri(P,s){const I=this.handlers.get(P);if(!I)return Promise.resolve(void 0);try{I.handleUri(R.URI.revive(s))}catch(l){y.onUnexpectedError(l)}return Promise.resolve(void 0)}async createAppUri(P){return R.URI.revive(await this._proxy.$createAppUri(P))}}e.ExtHostUrls=C,C.HandlePool=0});var tt=this&&this.__classPrivateFieldSet||function(X,e,v,R,k){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!k:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?k.call(X,v):k?k.value=v:e.set(X,v),v},$e=this&&this.__classPrivateFieldGet||function(X,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!R:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(X):R?R.value:e.get(X)};define(ge[63],pe([0,1,3,2,172,193,85,5]),function(X,e,v,R,k,y,A,C){"use strict";var D,P,s,I,l,g,c,f,_,w,E,u;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class h{constructor(d,b,S,o,L,O,W){D.set(this,void 0),P.set(this,void 0),s.set(this,void 0),I.set(this,void 0),l.set(this,void 0),g.set(this,void 0),c.set(this,""),f.set(this,void 0),_.set(this,!1),w.set(this,!1),E.set(this,!1),this._onMessageEmitter=new v.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,u.set(this,new v.Emitter),this._onDidDispose=$e(this,u,"f").event,tt(this,D,d,"f"),tt(this,P,b,"f"),tt(this,f,S,"f"),tt(this,I,o,"f"),tt(this,l,L,"f"),tt(this,g,O,"f"),tt(this,E,m(O),"f"),tt(this,s,W,"f")}dispose(){tt(this,_,!0,"f"),$e(this,u,"f").fire(),$e(this,u,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(d){return tt(this,w,!0,"f"),A.asWebviewUri(d,$e(this,I,"f").remote)}get cspSource(){return A.webviewGenericCspSource}get html(){return this.assertNotDisposed(),$e(this,c,"f")}set html(d){this.assertNotDisposed(),$e(this,c,"f")!==d&&(tt(this,c,d,"f"),!$e(this,w,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(d)&&(tt(this,w,!0,"f"),$e(this,s,"f").report("Webview vscode-resource: uris",$e(this,g,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),$e(this,P,"f").$setHtml($e(this,D,"f"),d))}get options(){return this.assertNotDisposed(),$e(this,f,"f")}set options(d){this.assertNotDisposed(),$e(this,P,"f").$setOptions($e(this,D,"f"),i($e(this,g,"f"),$e(this,l,"f"),d)),tt(this,f,d,"f")}async postMessage(d){if($e(this,_,"f"))return!1;const b=y.serializeWebviewMessage(d,{serializeBuffersForPostMessage:$e(this,E,"f")});return $e(this,P,"f").$postMessage($e(this,D,"f"),b.message,...b.buffers)}assertNotDisposed(){if($e(this,_,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=h,D=new WeakMap,P=new WeakMap,s=new WeakMap,I=new WeakMap,l=new WeakMap,g=new WeakMap,c=new WeakMap,f=new WeakMap,_=new WeakMap,w=new WeakMap,E=new WeakMap,u=new WeakMap;function m(p){try{const d=k.normalizeVersion(k.parseVersion(p.engines.vscode));return!!d&&d.majorBase>=1&&d.minorBase>=57}catch(d){return!1}}e.shouldSerializeBuffersForPostMessage=m;class t{constructor(d,b,S,o,L){this.initData=b,this.workspace=S,this._logService=o,this._deprecationService=L,this._webviews=new Map,this._webviewProxy=d.getProxy(C.MainContext.MainThreadWebviews)}$onMessage(d,b,...S){const o=this.getWebview(d);if(o){const{message:L}=y.deserializeWebviewMessage(b,S);o._onMessageEmitter.fire(L)}}$onMissingCsp(d,b){this._logService.warn(`${b} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(d,b,S){const o=new h(d,this._webviewProxy,n(b),this.initData,this.workspace,S,this._deprecationService);return this._webviews.set(d,o),o._onDidDispose(()=>{this._webviews.delete(d)}),o}deleteWebview(d){this._webviews.delete(d)}getWebview(d){return this._webviews.get(d)}}e.ExtHostWebviews=t;function r(p){return{id:p.identifier,location:p.extensionLocation}}e.toExtensionData=r;function i(p,d,b){return{enableCommandUris:b.enableCommandUris,enableScripts:b.enableScripts,portMapping:b.portMapping,localResourceRoots:b.localResourceRoots||a(p,d)}}e.serializeWebviewOptions=i;function n(p){var d;return{enableCommandUris:p.enableCommandUris,enableScripts:p.enableScripts,portMapping:p.portMapping,localResourceRoots:(d=p.localResourceRoots)===null||d===void 0?void 0:d.map(b=>R.URI.from(b))}}e.reviveOptions=n;function a(p,d){return[...((d==null?void 0:d.getWorkspaceFolders())||[]).map(b=>b.uri),p.extensionLocation]}}),define(ge[238],pe([0,1,21,74,6,10,24,2,18,63,83,5,7]),function(X,e,v,R,k,y,A,C,D,P,s,I,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class g{constructor(t,r){this.document=t,this._storagePath=r,this._backupCounter=1,this._edits=new s.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,r){await this.getEdit(t).undo(),r||this.disposeBackup()}async redo(t,r){await this.getEdit(t).redo(),r||this.disposeBackup()}disposeEdits(t){for(const r of t)this._edits.delete(r)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=h(this.document.uri)+this._backupCounter++;return A.joinPath(this._storagePath,t)}updateBackup(t){var r;(r=this._backup)===null||r===void 0||r.delete(),this._backup=t}disposeBackup(){var t;(t=this._backup)===null||t===void 0||t.delete(),this._backup=void 0}getEdit(t){const r=this._edits.get(t,0);if(!r)throw new Error("No edit found");return r}}class c{constructor(){this._documents=new Map}get(t,r){return this._documents.get(this.key(t,r))}add(t,r,i){const n=this.key(t,r.uri);if(this._documents.has(n))throw new Error(`Document already exists for viewType:${t} resource:${r.uri}`);const a=new g(r,i);return this._documents.set(n,a),a}delete(t,r){const i=this.key(t,r.uri);this._documents.delete(i)}key(t,r){return`${t}@@@${r}`}}var f;(function(m){m[m.Text=0]="Text",m[m.Custom=1]="Custom"})(f||(f={}));class _{constructor(){this._providers=new Map}addTextProvider(t,r,i){return this.add(0,t,r,i)}addCustomProvider(t,r,i){return this.add(1,t,r,i)}get(t){return this._providers.get(t)}add(t,r,i,n){if(this._providers.has(r))throw new Error(`Provider for viewType:${r} already registered`);return this._providers.set(r,{type:t,extension:i,provider:n}),new l.Disposable(()=>this._providers.delete(r))}}class w{constructor(t,r,i,n,a){this._extHostDocuments=r,this._extensionStoragePaths=i,this._extHostWebview=n,this._extHostWebviewPanels=a,this._editorProviders=new _,this._documents=new c,this._proxy=t.getProxy(I.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,r,i,n){const a=new k.DisposableStore;return E(i)?(a.add(this._editorProviders.addTextProvider(r,t,i)),this._proxy.$registerTextEditorProvider(P.toExtensionData(t),r,n.webviewOptions||{},{supportsMove:!!i.moveCustomTextEditor},P.shouldSerializeBuffersForPostMessage(t))):(a.add(this._editorProviders.addCustomProvider(r,t,i)),this.supportEditing(i)&&a.add(i.onDidChangeCustomDocument(p=>{const d=this.getCustomDocumentEntry(r,p.document.uri);if(u(p)){const b=d.addEdit(p);this._proxy.$onDidEdit(p.document.uri,r,b,p.label)}else this._proxy.$onContentChange(p.document.uri,r)})),this._proxy.$registerCustomEditorProvider(P.toExtensionData(t),r,n.webviewOptions||{},!!n.supportsMultipleEditorsPerDocument,P.shouldSerializeBuffersForPostMessage(t))),l.Disposable.from(a,new l.Disposable(()=>{this._proxy.$unregisterEditorProvider(r)}))}async $createCustomDocument(t,r,i,n,a){var p;const d=this._editorProviders.get(r);if(!d)throw new Error(`No provider found for '${r}'`);if(d.type!==1)throw new Error(`Invalid provide type for '${r}'`);const b=C.URI.revive(t),S=await d.provider.openCustomDocument(b,{backupId:i,untitledDocumentData:n==null?void 0:n.buffer},a);let o;return this.supportEditing(d.provider)&&this._extensionStoragePaths&&(o=(p=this._extensionStoragePaths.workspaceValue(d.extension))!==null&&p!==void 0?p:this._extensionStoragePaths.globalValue(d.extension)),this._documents.add(r,S,o),{editable:this.supportEditing(d.provider)}}async $disposeCustomDocument(t,r){const i=this._editorProviders.get(r);if(!i)throw new Error(`No provider found for '${r}'`);if(i.type!==1)throw new Error(`Invalid provider type for '${r}'`);const n=C.URI.revive(t),{document:a}=this.getCustomDocumentEntry(r,n);this._documents.delete(r,a),a.dispose()}async $resolveWebviewEditor(t,r,i,n,a,p){const d=this._editorProviders.get(i);if(!d)throw new Error(`No provider found for '${i}'`);const b=D.ViewColumn.to(a),S=this._extHostWebview.createNewWebview(r,n.webviewOptions,d.extension),o=this._extHostWebviewPanels.createNewWebviewPanel(r,i,n.title,b,n.panelOptions,S),L=C.URI.revive(t);switch(d.type){case 1:{const{document:O}=this.getCustomDocumentEntry(i,L);return d.provider.resolveCustomEditor(O,o,p)}case 0:{const O=this._extHostDocuments.getDocument(L);return d.provider.resolveCustomTextEditor(O,o,p)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,r,i){this.getCustomDocumentEntry(r,t).disposeEdits(i)}async $onMoveCustomEditor(t,r,i){const n=this._editorProviders.get(i);if(!n)throw new Error(`No provider found for '${i}'`);if(!n.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${i}'`);const a=this._extHostWebviewPanels.getWebviewPanel(t);if(!a)throw new Error("No webview found");const p=C.URI.revive(r),d=this._extHostDocuments.getDocument(p);await n.provider.moveCustomTextEditor(d,a,v.CancellationToken.None)}async $undo(t,r,i,n){return this.getCustomDocumentEntry(r,t).undo(i,n)}async $redo(t,r,i,n){return this.getCustomDocumentEntry(r,t).redo(i,n)}async $revert(t,r,i){const n=this.getCustomDocumentEntry(r,t);await this.getCustomEditorProvider(r).revertCustomDocument(n.document,i),n.disposeBackup()}async $onSave(t,r,i){const n=this.getCustomDocumentEntry(r,t);await this.getCustomEditorProvider(r).saveCustomDocument(n.document,i),n.disposeBackup()}async $onSaveAs(t,r,i,n){const a=this.getCustomDocumentEntry(r,t);return this.getCustomEditorProvider(r).saveCustomDocumentAs(a.document,C.URI.revive(i),n)}async $backup(t,r,i){const n=this.getCustomDocumentEntry(r,t),p=await this.getCustomEditorProvider(r).backupCustomDocument(n.document,{destination:n.getNewBackupUri()},i);return n.updateBackup(p),p.id}getCustomDocumentEntry(t,r){const i=this._documents.get(t,C.URI.revive(r));if(!i)throw new Error("No custom document found");return i}getCustomEditorProvider(t){const r=this._editorProviders.get(t),i=r==null?void 0:r.provider;if(!i||!this.supportEditing(i))throw new Error("Custom document is not editable");return i}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=w;function E(m){return typeof m.resolveCustomTextEditor=="function"}function u(m){return typeof m.undo=="function"&&typeof m.redo=="function"}function h(m){const t=m.scheme===y.Schemas.file||m.scheme===y.Schemas.untitled?m.fsPath:m.toString();return R.hash(t)+""}});var tt=this&&this.__classPrivateFieldSet||function(X,e,v,R,k){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!k:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?k.call(X,v):k?k.value=v:e.set(X,v),v},$e=this&&this.__classPrivateFieldGet||function(X,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!R:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(X):R?R.value:e.get(X)};define(ge[239],pe([0,1,3,6,2,32,18,63,5,7]),function(X,e,v,R,k,y,A,C,D,P){"use strict";var s,I,l,g,c,f,_,w,E,u,h,m,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class r extends R.Disposable{constructor(p,d,b,S,o,L,O){super();s.set(this,void 0),I.set(this,void 0),l.set(this,void 0),g.set(this,void 0),c.set(this,void 0),f.set(this,void 0),_.set(this,void 0),w.set(this,void 0),E.set(this,!0),u.set(this,!0),h.set(this,!1),m.set(this,this._register(new v.Emitter)),this.onDidDispose=$e(this,m,"f").event,t.set(this,this._register(new v.Emitter)),this.onDidChangeViewState=$e(this,t,"f").event,tt(this,s,p,"f"),tt(this,I,d,"f"),tt(this,l,b,"f"),tt(this,c,L,"f"),tt(this,w,o,"f"),tt(this,f,S,"f"),tt(this,g,O,"f")}dispose(){$e(this,h,"f")||(tt(this,h,!0,"f"),$e(this,m,"f").fire(),$e(this,I,"f").$disposeWebview($e(this,s,"f")),$e(this,g,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),$e(this,g,"f")}get viewType(){return this.assertNotDisposed(),$e(this,l,"f")}get title(){return this.assertNotDisposed(),$e(this,f,"f")}set title(p){this.assertNotDisposed(),$e(this,f,"f")!==p&&(tt(this,f,p,"f"),$e(this,I,"f").$setTitle($e(this,s,"f"),p))}get iconPath(){return this.assertNotDisposed(),$e(this,_,"f")}set iconPath(p){this.assertNotDisposed(),$e(this,_,"f")!==p&&(tt(this,_,p,"f"),$e(this,I,"f").$setIconPath($e(this,s,"f"),k.URI.isUri(p)?{light:p,dark:p}:p))}get options(){return $e(this,c,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof $e(this,w,"f")=="number"&&$e(this,w,"f")<0))return $e(this,w,"f")}get active(){return this.assertNotDisposed(),$e(this,u,"f")}get visible(){return this.assertNotDisposed(),$e(this,E,"f")}_updateViewState(p){$e(this,h,"f")||(this.active!==p.active||this.visible!==p.visible||this.viewColumn!==p.viewColumn)&&(tt(this,u,p.active,"f"),tt(this,E,p.visible,"f"),tt(this,w,p.viewColumn,"f"),$e(this,t,"f").fire({webviewPanel:this}))}reveal(p,d){this.assertNotDisposed(),$e(this,I,"f").$reveal($e(this,s,"f"),{viewColumn:p?A.ViewColumn.from(p):void 0,preserveFocus:!!d})}assertNotDisposed(){if($e(this,h,"f"))throw new Error("Webview is disposed")}}s=new WeakMap,I=new WeakMap,l=new WeakMap,g=new WeakMap,c=new WeakMap,f=new WeakMap,_=new WeakMap,w=new WeakMap,E=new WeakMap,u=new WeakMap,h=new WeakMap,m=new WeakMap,t=new WeakMap;class i{constructor(p,d,b){this.webviews=d,this.workspace=b,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=p.getProxy(D.MainContext.MainThreadWebviewPanels)}static newHandle(){return y.generateUuid()}createWebviewPanel(p,d,b,S,o={}){const L=typeof S=="object"?S.viewColumn:S,O={viewColumn:A.ViewColumn.from(L),preserveFocus:typeof S=="object"&&!!S.preserveFocus},W=C.shouldSerializeBuffersForPostMessage(p),J=i.newHandle();this._proxy.$createWebviewPanel(C.toExtensionData(p),J,d,{title:b,panelOptions:n(o),webviewOptions:C.serializeWebviewOptions(p,this.workspace,o),serializeBuffersForPostMessage:W},O);const oe=this.webviews.createNewWebview(J,o,p);return this.createNewWebviewPanel(J,d,b,L,o,oe)}$onDidChangeWebviewPanelViewStates(p){const d=Object.keys(p);d.sort((b,S)=>{const o=p[b],L=p[S];return o.active?1:L.active?-1:+o.visible-+L.visible});for(const b of d){const S=this.getWebviewPanel(b);if(!S)continue;const o=p[b];S._updateViewState({active:o.active,visible:o.visible,viewColumn:A.ViewColumn.to(o.position)})}}async $onDidDisposeWebviewPanel(p){const d=this.getWebviewPanel(p);d==null||d.dispose(),this._webviewPanels.delete(p),this.webviews.deleteWebview(p)}registerWebviewPanelSerializer(p,d,b){if(this._serializers.has(d))throw new Error(`Serializer for '${d}' already registered`);return this._serializers.set(d,{serializer:b,extension:p}),this._proxy.$registerSerializer(d,{serializeBuffersForPostMessage:C.shouldSerializeBuffersForPostMessage(p)}),new P.Disposable(()=>{this._serializers.delete(d),this._proxy.$unregisterSerializer(d)})}async $deserializeWebviewPanel(p,d,b,S){const o=this._serializers.get(d);if(!o)throw new Error(`No serializer found for '${d}'`);const{serializer:L,extension:O}=o,W=this.webviews.createNewWebview(p,b.webviewOptions,O),J=this.createNewWebviewPanel(p,d,b.title,S,b.panelOptions,W);await L.deserializeWebviewPanel(J,b.state)}createNewWebviewPanel(p,d,b,S,o,L){const O=new r(p,this._proxy,d,b,S,o,L);return this._webviewPanels.set(p,O),O}getWebviewPanel(p){return this._webviewPanels.get(p)}}e.ExtHostWebviewPanels=i;function n(a){return{enableFindWidget:a.enableFindWidget,retainContextWhenHidden:a.retainContextWhenHidden}}});var tt=this&&this.__classPrivateFieldSet||function(X,e,v,R,k){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!k:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?k.call(X,v):k?k.value=v:e.set(X,v),v},$e=this&&this.__classPrivateFieldGet||function(X,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!R:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(X):R?R.value:e.get(X)};define(ge[240],pe([0,1,3,6,63,5,7]),function(X,e,v,R,k,y,A){"use strict";var C,D,P,s,I,l,g,c,f,_;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class w extends R.Disposable{constructor(h,m,t,r,i,n){super();C.set(this,void 0),D.set(this,void 0),P.set(this,void 0),s.set(this,void 0),I.set(this,!1),l.set(this,void 0),g.set(this,void 0),c.set(this,void 0),f.set(this,this._register(new v.Emitter)),this.onDidChangeVisibility=$e(this,f,"f").event,_.set(this,this._register(new v.Emitter)),this.onDidDispose=$e(this,_,"f").event,tt(this,P,t,"f"),tt(this,g,r,"f"),tt(this,C,h,"f"),tt(this,D,m,"f"),tt(this,s,i,"f"),tt(this,l,n,"f")}dispose(){$e(this,I,"f")||(tt(this,I,!0,"f"),$e(this,_,"f").fire(),$e(this,s,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),$e(this,g,"f")}set title(h){this.assertNotDisposed(),$e(this,g,"f")!==h&&(tt(this,g,h,"f"),$e(this,D,"f").$setWebviewViewTitle($e(this,C,"f"),h))}get description(){return this.assertNotDisposed(),$e(this,c,"f")}set description(h){this.assertNotDisposed(),$e(this,c,"f")!==h&&(tt(this,c,h,"f"),$e(this,D,"f").$setWebviewViewDescription($e(this,C,"f"),h))}get visible(){return $e(this,l,"f")}get webview(){return $e(this,s,"f")}get viewType(){return $e(this,P,"f")}_setVisible(h){h===$e(this,l,"f")||$e(this,I,"f")||(tt(this,l,h,"f"),$e(this,f,"f").fire())}show(h){this.assertNotDisposed(),$e(this,D,"f").$show($e(this,C,"f"),!!h)}assertNotDisposed(){if($e(this,I,"f"))throw new Error("Webview is disposed")}}C=new WeakMap,D=new WeakMap,P=new WeakMap,s=new WeakMap,I=new WeakMap,l=new WeakMap,g=new WeakMap,c=new WeakMap,f=new WeakMap,_=new WeakMap;class E{constructor(h,m){this._extHostWebview=m,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=h.getProxy(y.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(h,m,t,r){if(this._viewProviders.has(m))throw new Error(`View provider for '${m}' already registered`);return this._viewProviders.set(m,{provider:t,extension:h}),this._proxy.$registerWebviewViewProvider(k.toExtensionData(h),m,{retainContextWhenHidden:r==null?void 0:r.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new A.Disposable(()=>{this._viewProviders.delete(m),this._proxy.$unregisterWebviewViewProvider(m)})}async $resolveWebviewView(h,m,t,r,i){const n=this._viewProviders.get(m);if(!n)throw new Error(`No view provider found for '${m}'`);const{provider:a,extension:p}=n,d=this._extHostWebview.createNewWebview(h,{},p),b=new w(h,this._proxy,m,t,d,!0);this._webviewViews.set(h,b),await a.resolveWebviewView(b,{state:r},i)}async $onDidChangeWebviewViewVisibility(h,m){this.getWebviewView(h)._setVisible(m)}async $disposeWebviewView(h){const m=this.getWebviewView(h);this._webviewViews.delete(h),m.dispose(),this._extHostWebview.deleteWebview(h)}getWebviewView(h){const m=this._webviewViews.get(h);if(!m)throw new Error("No webview found");return m}}e.ExtHostWebviewViews=E}),define(ge[126],pe([0,1,3,5,2,10,8,4,12]),function(X,e,v,R,k,y,A,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let P=class Un{constructor(I){this._onDidChangeWindowState=new v.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Un.InitialState,this._proxy=I.getProxy(R.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(l=>this.$onDidChangeWindowFocus(l))}get state(){return this._state}$onDidChangeWindowFocus(I){I!==this._state.focused&&(this._state=Object.assign(Object.assign({},this._state),{focused:I}),this._onDidChangeWindowState.fire(this._state))}openUri(I,l){let g;if(typeof I=="string"){g=I;try{I=k.URI.parse(I)}catch(c){return Promise.reject(`Invalid uri - '${I}'`)}}return A.isFalsyOrWhitespace(I.scheme)?Promise.reject("Invalid scheme - cannot be empty"):I.scheme===y.Schemas.command?Promise.reject(`Invalid scheme '${I.scheme}'`):this._proxy.$openUri(I,g,l)}async asExternalUri(I,l){if(A.isFalsyOrWhitespace(I.scheme))return Promise.reject("Invalid scheme - cannot be empty");const g=await this._proxy.$asExternalUri(I,l);return k.URI.from(g)}};P.InitialState={focused:!0},P=Ve([We(0,D.IExtHostRpcService)],P),e.ExtHostWindow=P,e.IExtHostWindow=C.createDecorator("IExtHostWindow")}),define(ge[241],pe([0,1,9,100,32,47,6,5,2,12]),function(X,e,v,R,k,y,A,C,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let s=class extends A.Disposable{constructor(l,g){super();const c=l.getProxy(C.MainContext.MainThreadDownloadService);g.registerCommand(!1,"_workbench.downloadResource",async f=>{const _=D.URI.file(v.join(R.tmpdir(),k.generateUuid()));return await c.$download(f,_),_})}};s=Ve([We(0,P.IExtHostRpcService),We(1,y.IExtHostCommands)],s),e.ExtHostDownloadService=s}),define(ge[242],pe([0,1,2,9,146,28,62,27,12,6,15,112,42]),function(X,e,v,R,k,y,A,C,D,P,s,I,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostOutputService2=void 0;class g{constructor(w,E,u){this.name=w,this.file=E,this.appender=u}static async create(w,E){const u=await I.createRotatingLogger(w,E,30*l.ByteSize.MB,1);return u.clearFormatters(),new g(w,E,u)}append(w){this.appender.critical(w)}flush(){this.appender.flush()}}class c extends A.AbstractExtHostOutputChannel{constructor(w,E,u){super(w,!1,v.URI.file(E.file),u);this._appender=E}append(w){super.append(w),this._appender.append(w),this._onDidAppend.fire()}update(){this._appender.flush(),super.update()}show(w,E){this._appender.flush(),super.show(w,E)}clear(){this._appender.flush(),super.clear()}}let f=class extends A.ExtHostOutputService{constructor(w,E,u){super(w);this.logService=E,this._namePool=1,this._channels=new Map,this._visibleChannelDisposable=new P.MutableDisposable,this._logsLocation=u.logsLocation}$setVisibleChannel(w){if(w){const E=this._channels.get(w);E&&(this._visibleChannelDisposable.value=E.onDidAppend(()=>E.update()))}}createOutputChannel(w){if(w=w.trim(),!w)throw new Error("illegal argument `name`. must not be falsy");const E=this._doCreateOutChannel(w);return E.then(u=>u._id.then(h=>this._channels.set(h,u))),new A.LazyOutputChannel(w,E)}async _doCreateOutChannel(w){try{const E=R.join(this._logsLocation.fsPath,`output_logging_${k.toLocalISOString(new Date).replace(/-|:|\.\d+Z$/g,"")}`);await y.SymlinkSupport.existsDirectory(E)||await y.Promises.mkdir(E,{recursive:!0});const h=`${this._namePool++}-${w.replace(/[\\/:\*\?"<>\|]/g,"")}`,m=v.URI.file(R.join(E,`${h}.log`)),t=await g.create(h,m.fsPath);return new c(w,t,this._proxy)}catch(E){return this.logService.error(E),new A.ExtHostPushOutputChannel(w,this._proxy)}}};f=Ve([We(0,D.IExtHostRpcService),We(1,s.ILogService),We(2,C.IExtHostInitDataService)],f),e.ExtHostOutputService2=f}),define(ge[243],pe([0,1,32,12,33]),function(X,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let y=class extends k.BaseExtHostTerminalService{constructor(C){super(!0,C)}createTerminal(C,D,P){return this.createTerminalFromOptions({name:C,shellPath:D,shellArgs:P})}createTerminalFromOptions(C,D){const P=new k.ExtHostTerminal(this._proxy,v.generateUuid(),C,C.name);return this._terminals.push(P),P.create(C,D),P.value}};y=Ve([We(0,R.IExtHostRpcService)],y),e.ExtHostTerminalService=y}),define(ge[244],pe([0,1,5,12,6,27,2,38,24,28,7,11,46,3,73,15]),function(X,e,v,R,k,y,A,C,D,P,s,I,l,g,c,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class _{constructor(p,d,b){this.remoteAddress=p,this.localAddress=d,this._dispose=b,this._onDispose=new g.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function w(a){const p=a.trim().split(`
`),d=[];return p.forEach(S=>{const o=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(S);o&&o.length>=3&&d.push({pid:parseInt(o[1],10),socket:parseInt(o[2],10)})}),d.reduce((S,o)=>(S[o.socket]=o,S),{})}e.getSockets=w;function E(...a){const p=[].concat(...a.map(h));return[...new Map(p.filter(d=>d.st==="0A").map(d=>{const b=d.local_address.split(":");return{socket:parseInt(d.inode,10),ip:u(b[0]),port:parseInt(b[1],16)}}).map(d=>[d.ip+":"+d.port,d])).values()]}e.loadListeningPorts=E;function u(a){let p="";if(a.length===8)for(let d=a.length-2;d>=0;d-=2)p+=parseInt(a.substr(d,2),16),d!==0&&(p+=".");else for(let d=a.length-4;d>=0;d-=4)p+=parseInt(a.substr(d,4),16).toString(16),d!==0&&(p+=":");return p}e.parseIpAddress=u;function h(a){const p=a.trim().split(`
`),d=p.shift().trim().split(/\s+/).filter(S=>S!=="rx_queue"&&S!=="tm->when");return p.map(S=>S.trim().split(/\s+/).reduce((o,L,O)=>(o[d[O]||O]=L,o),{}))}e.loadConnectionTable=h;function m(a){return!!a.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||a.indexOf("out/vs/server/main.js")!==-1||a.indexOf("_productName=VSCode")!==-1}function t(a){const p=a.trim().split(`
`),d=[];return p.forEach(b=>{const S=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(b);S&&S.length>=4&&d.push({pid:parseInt(S[1],10),ppid:parseInt(S[2]),cmd:S[3]})}),d}e.getRootProcesses=t;async function r(a,p,d){const b=d.reduce((o,L)=>(o[L.pid]=L,o),{}),S=[];return a.forEach(({socket:o,ip:L,port:O})=>{var W;const J=p[o]?p[o].pid:void 0,oe=J?(W=b[J])===null||W===void 0?void 0:W.cmd:void 0;J&&oe&&!m(oe)&&S.push({host:L,port:O,detail:oe,pid:J})}),S}e.findPorts=r;function i(a,p,d){const b=new Map,S=t(p);for(const o of a){const L=d.get(o.port);if(L){b.set(o.port,L);continue}const O=S.find(W=>W.cmd.includes(`${o.port}`));if(O){let W=O,J;do J=S.find(oe=>oe.ppid===W.pid),J&&(W=J);while(J);b.set(o.port,{host:o.ip,port:o.port,pid:W.pid,detail:W.cmd,ppid:W.ppid})}else b.set(o.port,{host:o.ip,port:o.port,ppid:Number.MAX_VALUE})}return b}e.tryFindRootPorts=i;let n=class extends k.Disposable{constructor(p,d,b){super();this.logService=b,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new g.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=p.getProxy(v.MainContext.MainThreadTunnelService),I.isLinux&&d.remote.isRemote&&d.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(p,d){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${p.identifier.value} called openTunnel API for ${d.remoteAddress.host}:${d.remoteAddress.port}.`);const b=await this._proxy.$openTunnel(d,p.displayName);if(b){const S=new _(b.remoteAddress,b.localAddress,()=>this._proxy.$closeTunnel(b.remoteAddress));return this._register(S),S}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(p){return Math.max(p*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(p,d){const b=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(b,{selector:p,provider:d}),this._proxy.$registerPortsAttributesProvider(p,b),new s.Disposable(()=>{this._portAttributesProviders.delete(b),this._proxy.$unregisterPortsAttributesProvider(b)})}async $providePortAttributes(p,d,b,S,o){const L=[];for(const W of p){const J=this._portAttributesProviders.get(W);if(!J)return[];L.push(...await Promise.all(d.map(async oe=>J.provider.providePortAttributes(oe,b,S,o))))}const O=L.filter(W=>!!W);return O.length>0?O.map(W=>({autoForwardAction:W.autoForwardAction,port:W.port})):[]}async $registerCandidateFinder(p){if(p&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=p;let d=new c.MovingAverage,b;for(;this._candidateFindingEnabled;){const S=new Date().getTime(),o=await this.findCandidatePorts();this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${o.map(O=>O.port).join(", ")}`);const L=new Date().getTime()-S;d.update(L),(!b||JSON.stringify(b)!==JSON.stringify(o))&&(b=o,await this._proxy.$onFoundNewCandidates(b)),await new Promise(O=>setTimeout(()=>O(),this.calculateDelay(d.value)))}}async setTunnelExtensionFunctions(p){var d;return p?(p.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(p.candidatePortSource),p.showCandidatePort&&(this._showCandidatePort=p.showCandidatePort,this._proxy.$setCandidateFilter()),p.tunnelFactory&&(this._forwardPortProvider=p.tunnelFactory,this._proxy.$setTunnelProvider((d=p.tunnelFeatures)!==null&&d!==void 0?d:{elevation:!1,public:!1}))):this._forwardPortProvider=void 0,k.toDisposable(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(p,d){if(this._extensionTunnels.has(p.host)){const b=this._extensionTunnels.get(p.host);b.has(p.port)&&(d&&b.get(p.port).disposeListener.dispose(),await b.get(p.port).tunnel.dispose(),b.delete(p.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(p,d){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const b=this._forwardPortProvider(p,d);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),b!==void 0){const S=await b;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(p.remoteAddress.host)||this._extensionTunnels.set(p.remoteAddress.host,new Map);const o=this._register(S.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(S.remoteAddress))));return this._extensionTunnels.get(p.remoteAddress.host).set(p.remoteAddress.port,{tunnel:S,disposeListener:o}),l.TunnelDto.fromApiTunnel(S)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(b){this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(p){const d=await Promise.all(p.map(S=>{var o;return this._showCandidatePort(S.host,S.port,(o=S.detail)!==null&&o!==void 0?o:"")})),b=p.filter((S,o)=>d[o]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${p.map(S=>S.port).join(", ")} to ${b.map(S=>S.port).join(", ")}`),b}async findCandidatePorts(){let p="",d="";try{p=await P.Promises.readFile("/proc/net/tcp","utf8"),d=await P.Promises.readFile("/proc/net/tcp6","utf8")}catch(x){}const b=E(p,d),S=await new Promise(x=>{C.exec("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(V,T,N)=>{x(T)})}),o=w(S),L=await P.readdir("/proc"),O=[];for(let x of L)try{const V=Number(x),T=D.joinPath(A.URI.file("/proc"),x);if((await P.Promises.stat(T.fsPath)).isDirectory()&&!isNaN(V)){const F=await P.Promises.readlink(D.joinPath(T,"cwd").fsPath),M=await P.Promises.readFile(D.joinPath(T,"cmdline").fsPath,"utf8");O.push({pid:V,cwd:F,cmd:M})}}catch(V){}const W=[],J=b.filter(x=>{const V=o[x.socket];return V||W.push(x),V}),oe=r(J,o,O);let q;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${W.length}`),W.length>0){const x=await new Promise(V=>{C.exec("ps -F -A -l | grep root",(T,N,F)=>{V(N)})});this._foundRootPorts=i(W,x,this._foundRootPorts),q=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${q.join(", ")}`)}return oe.then(x=>q?x.concat(q):x)}};n=Ve([We(0,R.IExtHostRpcService),We(1,y.IExtHostInitDataService),We(2,f.ILogService)],n),e.ExtHostTunnelService=n}),define(ge[245],pe([0,1,14,21,16,3,6,98,213,124,22]),function(X,e,v,R,k,y,A,C,D,P,s){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0;function l(n,a){try{return JSON.stringify(n,a)}catch(p){return"null"}}function g(n,a){return JSON.stringify(n,a)}function c(n){return n?(a,p)=>p&&p.$mid===1?n.transformOutgoing(p):p:null}var f;(function(n){n[n.LocalSide=0]="LocalSide",n[n.OtherSide=1]="OtherSide"})(f=e.RequestInitiator||(e.RequestInitiator={}));var _;(function(n){n[n.Responsive=0]="Responsive",n[n.Unresponsive=1]="Unresponsive"})(_=e.ResponsiveState||(e.ResponsiveState={}));const w=()=>{},E=Symbol.for("rpcProtocol"),u=Symbol.for("rpcProxy");class h extends A.Disposable{constructor(a,p=null,d=null){super();this[I]=!0,this._onDidChangeResponsiveState=this._register(new y.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=a,this._logger=p,this._uriTransformer=d,this._uriReplacer=c(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let b=0,S=P.ProxyIdentifier.count;b<S;b++)this._locals[b]=null,this._proxies[b]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new v.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(b=>this._receiveOneMessage(b))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(a=>{this._pendingRPCReplies[a].resolveErr(k.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(a){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+h.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(a){this._unresponsiveTime=Date.now()+h.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(a){this._responsiveState!==a&&(this._responsiveState=a,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(a){return this._uriTransformer?C.transformIncomingURIs(a,this._uriTransformer):a}getProxy(a){const{nid:p,sid:d}=a;return this._proxies[p]||(this._proxies[p]=this._createProxy(p,d)),this._proxies[p]}_createProxy(a,p){let d={get:(b,S)=>(typeof S=="string"&&!b[S]&&S.charCodeAt(0)===36&&(b[S]=(...o)=>this._remoteCall(a,S,o)),S===u?p:b[S])};return new Proxy(Object.create(null),d)}set(a,p){return this._locals[a.nid]=p,p}assertRegistered(a){for(let p=0,d=a.length;p<d;p++){const b=a[p];if(!this._locals[b.nid])throw new Error(`Missing actor ${b.sid} (isMain: ${b.isMain})`)}}_receiveOneMessage(a){if(this._isDisposed)return;const p=a.byteLength,d=m.read(a,0),b=d.readUInt8(),S=d.readUInt32();switch(b){case 1:case 2:{let{rpcId:o,method:L,args:O}=t.deserializeRequestJSONArgs(d);this._uriTransformer&&(O=C.transformIncomingURIs(O,this._uriTransformer)),this._receiveRequest(p,S,o,L,O,b===2);break}case 3:case 4:{let{rpcId:o,method:L,args:O}=t.deserializeRequestMixedArgs(d);this._uriTransformer&&(O=C.transformIncomingURIs(O,this._uriTransformer)),this._receiveRequest(p,S,o,L,O,b===4);break}case 5:{this._logger&&this._logger.logIncoming(p,S,0,"ack"),this._onDidReceiveAcknowledge(S);break}case 6:{this._receiveCancel(p,S);break}case 7:{this._receiveReply(p,S,void 0);break}case 9:{let o=t.deserializeReplyOKJSON(d);this._uriTransformer&&(o=C.transformIncomingURIs(o,this._uriTransformer)),this._receiveReply(p,S,o);break}case 8:{let o=t.deserializeReplyOKVSBuffer(d);this._receiveReply(p,S,o);break}case 10:{let o=t.deserializeReplyErrError(d);this._uriTransformer&&(o=C.transformIncomingURIs(o,this._uriTransformer)),this._receiveReplyErr(p,S,o);break}case 11:{this._receiveReplyErr(p,S,void 0);break}default:console.error("received unexpected message"),console.error(a)}}_receiveRequest(a,p,d,b,S,o){this._logger&&this._logger.logIncoming(a,p,1,`receiveRequest ${P.getStringIdentifierForProxy(d)}.${b}(`,S);const L=String(p);let O,W;if(o){const oe=new R.CancellationTokenSource;S.push(oe.token),O=this._invokeHandler(d,b,S),W=()=>oe.cancel()}else O=this._invokeHandler(d,b,S),W=w;this._cancelInvokedHandlers[L]=W;const J=t.serializeAcknowledged(p);this._logger&&this._logger.logOutgoing(J.byteLength,p,1,"ack"),this._protocol.send(J),O.then(oe=>{delete this._cancelInvokedHandlers[L];const q=t.serializeReplyOK(p,oe,this._uriReplacer);this._logger&&this._logger.logOutgoing(q.byteLength,p,1,"reply:",oe),this._protocol.send(q)},oe=>{delete this._cancelInvokedHandlers[L];const q=t.serializeReplyErr(p,oe);this._logger&&this._logger.logOutgoing(q.byteLength,p,1,"replyErr:",oe),this._protocol.send(q)})}_receiveCancel(a,p){this._logger&&this._logger.logIncoming(a,p,1,"receiveCancel");const d=String(p);this._cancelInvokedHandlers[d]&&this._cancelInvokedHandlers[d]()}_receiveReply(a,p,d){this._logger&&this._logger.logIncoming(a,p,0,"receiveReply:",d);const b=String(p);if(!this._pendingRPCReplies.hasOwnProperty(b))return;const S=this._pendingRPCReplies[b];delete this._pendingRPCReplies[b],S.resolveOk(d)}_receiveReplyErr(a,p,d){this._logger&&this._logger.logIncoming(a,p,0,"receiveReplyErr:",d);const b=String(p);if(!this._pendingRPCReplies.hasOwnProperty(b))return;const S=this._pendingRPCReplies[b];delete this._pendingRPCReplies[b];let o;d&&(d.$isError?(o=new Error,o.name=d.name,o.message=d.message,o.stack=d.stack):o=d),S.resolveErr(o)}_invokeHandler(a,p,d){try{return Promise.resolve(this._doInvokeHandler(a,p,d))}catch(b){return Promise.reject(b)}}_doInvokeHandler(a,p,d){const b=this._locals[a];if(!b)throw new Error("Unknown actor "+P.getStringIdentifierForProxy(a));let S=b[p];if(typeof S!="function")throw new Error("Unknown method "+p+" on actor "+P.getStringIdentifierForProxy(a));return S.apply(b,d)}_remoteCall(a,p,d){if(this._isDisposed)return Promise.reject(k.canceled());let b=null;if(d.length>0&&R.CancellationToken.isCancellationToken(d[d.length-1])&&(b=d.pop()),b&&b.isCancellationRequested)return Promise.reject(k.canceled());const S=t.serializeRequestArguments(d,this._uriReplacer),o=++this._lastMessageId,L=String(o),O=new D.LazyPromise;b&&b.onCancellationRequested(()=>{const J=t.serializeCancel(o);this._logger&&this._logger.logOutgoing(J.byteLength,o,0,"cancel"),this._protocol.send(t.serializeCancel(o))}),this._pendingRPCReplies[L]=O,this._onWillSendRequest(o);const W=t.serializeRequest(o,a,p,S,!!b);return this._logger&&this._logger.logOutgoing(W.byteLength,o,0,`request: ${P.getStringIdentifierForProxy(a)}.${p}(`,d),this._protocol.send(W),O}}e.RPCProtocol=h,I=E,h.UNRESPONSIVE_TIME=3*1e3;class m{constructor(a,p){this._buff=a,this._offset=p}static alloc(a,p,d){let b=new m(s.VSBuffer.alloc(d+1+4),0);return b.writeUInt8(a),b.writeUInt32(p),b}static read(a,p){return new m(a,p)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(a){this._buff.writeUInt8(a,this._offset),this._offset+=1}readUInt8(){const a=this._buff.readUInt8(this._offset);return this._offset+=1,a}writeUInt32(a){this._buff.writeUInt32BE(a,this._offset),this._offset+=4}readUInt32(){const a=this._buff.readUInt32BE(this._offset);return this._offset+=4,a}static sizeShortString(a){return 1+a.byteLength}writeShortString(a){this._buff.writeUInt8(a.byteLength,this._offset),this._offset+=1,this._buff.set(a,this._offset),this._offset+=a.byteLength}readShortString(){const a=this._buff.readUInt8(this._offset);this._offset+=1;const d=this._buff.slice(this._offset,this._offset+a).toString();return this._offset+=a,d}static sizeLongString(a){return 4+a.byteLength}writeLongString(a){this._buff.writeUInt32BE(a.byteLength,this._offset),this._offset+=4,this._buff.set(a,this._offset),this._offset+=a.byteLength}readLongString(){const a=this._buff.readUInt32BE(this._offset);this._offset+=4;const d=this._buff.slice(this._offset,this._offset+a).toString();return this._offset+=a,d}writeBuffer(a){this._buff.writeUInt32BE(a.byteLength,this._offset),this._offset+=4,this._buff.set(a,this._offset),this._offset+=a.byteLength}static sizeVSBuffer(a){return 4+a.byteLength}writeVSBuffer(a){this._buff.writeUInt32BE(a.byteLength,this._offset),this._offset+=4,this._buff.set(a,this._offset),this._offset+=a.byteLength}readVSBuffer(){const a=this._buff.readUInt32BE(this._offset);this._offset+=4;const p=this._buff.slice(this._offset,this._offset+a);return this._offset+=a,p}static sizeMixedArray(a,p){let d=0;d+=1;for(let b=0,S=a.length;b<S;b++){const o=a[b],L=p[b];switch(d+=1,L){case 1:d+=this.sizeLongString(o);break;case 2:d+=this.sizeVSBuffer(o);break;case 3:break}}return d}writeMixedArray(a,p){this._buff.writeUInt8(a.length,this._offset),this._offset+=1;for(let d=0,b=a.length;d<b;d++){const S=a[d];switch(p[d]){case 1:this.writeUInt8(1),this.writeLongString(S);break;case 2:this.writeUInt8(2),this.writeVSBuffer(S);break;case 3:this.writeUInt8(3);break}}}readMixedArray(){const a=this._buff.readUInt8(this._offset);this._offset+=1;let p=new Array(a);for(let d=0;d<a;d++)switch(this.readUInt8()){case 1:p[d]=this.readLongString();break;case 2:p[d]=this.readVSBuffer();break;case 3:p[d]=void 0;break}return p}}class t{static _arrayContainsBufferOrUndefined(a){for(let p=0,d=a.length;p<d;p++)if(a[p]instanceof s.VSBuffer||typeof a[p]=="undefined")return!0;return!1}static serializeRequestArguments(a,p){if(this._arrayContainsBufferOrUndefined(a)){let d=[],b=[];for(let S=0,o=a.length;S<o;S++){const L=a[S];L instanceof s.VSBuffer?(d[S]=L,b[S]=2):typeof L=="undefined"?(d[S]=s.VSBuffer.alloc(0),b[S]=3):(d[S]=s.VSBuffer.fromString(g(L,p)),b[S]=1)}return{type:"mixed",args:d,argsType:b}}return{type:"simple",args:g(a,p)}}static serializeRequest(a,p,d,b,S){return b.type==="mixed"?this._requestMixedArgs(a,p,d,b.args,b.argsType,S):this._requestJSONArgs(a,p,d,b.args,S)}static _requestJSONArgs(a,p,d,b,S){const o=s.VSBuffer.fromString(d),L=s.VSBuffer.fromString(b);let O=0;O+=m.sizeUInt8(),O+=m.sizeShortString(o),O+=m.sizeLongString(L);let W=m.alloc(S?2:1,a,O);return W.writeUInt8(p),W.writeShortString(o),W.writeLongString(L),W.buffer}static deserializeRequestJSONArgs(a){const p=a.readUInt8(),d=a.readShortString(),b=a.readLongString();return{rpcId:p,method:d,args:JSON.parse(b)}}static _requestMixedArgs(a,p,d,b,S,o){const L=s.VSBuffer.fromString(d);let O=0;O+=m.sizeUInt8(),O+=m.sizeShortString(L),O+=m.sizeMixedArray(b,S);let W=m.alloc(o?4:3,a,O);return W.writeUInt8(p),W.writeShortString(L),W.writeMixedArray(b,S),W.buffer}static deserializeRequestMixedArgs(a){const p=a.readUInt8(),d=a.readShortString(),b=a.readMixedArray(),S=new Array(b.length);for(let o=0,L=b.length;o<L;o++){const O=b[o];typeof O=="string"?S[o]=JSON.parse(O):S[o]=O}return{rpcId:p,method:d,args:S}}static serializeAcknowledged(a){return m.alloc(5,a,0).buffer}static serializeCancel(a){return m.alloc(6,a,0).buffer}static serializeReplyOK(a,p,d){return typeof p=="undefined"?this._serializeReplyOKEmpty(a):p instanceof s.VSBuffer?this._serializeReplyOKVSBuffer(a,p):this._serializeReplyOKJSON(a,l(p,d))}static _serializeReplyOKEmpty(a){return m.alloc(7,a,0).buffer}static _serializeReplyOKVSBuffer(a,p){let d=0;d+=m.sizeVSBuffer(p);let b=m.alloc(8,a,d);return b.writeVSBuffer(p),b.buffer}static deserializeReplyOKVSBuffer(a){return a.readVSBuffer()}static _serializeReplyOKJSON(a,p){const d=s.VSBuffer.fromString(p);let b=0;b+=m.sizeLongString(d);let S=m.alloc(9,a,b);return S.writeLongString(d),S.buffer}static deserializeReplyOKJSON(a){const p=a.readLongString();return JSON.parse(p)}static serializeReplyErr(a,p){return p?this._serializeReplyErrEror(a,p):this._serializeReplyErrEmpty(a)}static _serializeReplyErrEror(a,p){const d=s.VSBuffer.fromString(l(k.transformErrorForSerialization(p),null));let b=0;b+=m.sizeLongString(d);let S=m.alloc(10,a,b);return S.writeLongString(d),S.buffer}static deserializeReplyErrError(a){const p=a.readLongString();return JSON.parse(p)}static _serializeReplyErrEmpty(a){return m.alloc(11,a,0).buffer}}var r;(function(n){n[n.RequestJSONArgs=1]="RequestJSONArgs",n[n.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",n[n.RequestMixedArgs=3]="RequestMixedArgs",n[n.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",n[n.Acknowledged=5]="Acknowledged",n[n.Cancel=6]="Cancel",n[n.ReplyOKEmpty=7]="ReplyOKEmpty",n[n.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",n[n.ReplyOKJSON=9]="ReplyOKJSON",n[n.ReplyErrError=10]="ReplyErrError",n[n.ReplyErrEmpty=11]="ReplyErrEmpty"})(r||(r={}));var i;(function(n){n[n.String=1]="String",n[n.VSBuffer=2]="VSBuffer",n[n.Undefined=3]="Undefined"})(i||(i={}))}),define(ge[246],pe([0,1,4]),function(X,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=v.createDecorator("remoteAgentService")}),define(ge[247],pe([0,1,10,9,11,2,4,246]),function(X,e,v,R,k,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=A.createDecorator("pathService");let D=class{constructor(s,I){this.localUserHome=s,this.remoteAgentService=I,this.resolveOS=(async()=>{const l=await this.remoteAgentService.getEnvironment();return(l==null?void 0:l.os)||k.OS})(),this.resolveUserHome=(async()=>{const l=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=(l==null?void 0:l.userHome)||s})()}async userHome(s){return(s==null?void 0:s.preferLocal)?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(s=>s===1?R.win32:R.posix)}async fileURI(s){let I="";if(await this.resolveOS===1&&(s=s.replace(/\\/g,"/")),s[0]==="/"&&s[1]==="/"){const g=s.indexOf("/",2);g===-1?(I=s.substring(2),s="/"):(I=s.substring(2,g),s=s.substring(g)||"/")}return y.URI.from({scheme:v.Schemas.file,authority:I,path:s,query:"",fragment:""})}};D=Ve([We(1,C.IRemoteAgentService)],D),e.AbstractPathService=D}),define(ge[64],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class v{constructor(A,C){this.line=A,this.character=C}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,C){return new v(0,0)}with(A){return new v(0,0)}}e.Position=v;class R{constructor(A,C,D,P){this.isEmpty=!1,this.isSingleLine=!1,this.start=new v(A,C),this.end=new v(D,P)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new R(0,0,0,0)}with(A){return new R(0,0,0,0)}}e.Range=R;var k;(function(y){y[y.Information=1]="Information",y[y.Warning=2]="Warning"})(k=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(ge[31],pe([0,1,17,30,25,29,8,4,9,16,64]),function(X,e,v,R,k,y,A,C,D,P,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return s.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const I="\u27EA ",l=" characters skipped \u27EB",g=(I.length+l.length+5)*2;e.ISearchService=C.createDecorator("searchService");var c;(function(T){T[T.file=0]="file",T[T.text=1]="text"})(c=e.SearchProviderType||(e.SearchProviderType={}));var f;(function(T){T[T.File=1]="File",T[T.Text=2]="Text"})(f=e.QueryType||(e.QueryType={}));function _(T){return!!T.preview}e.resultIsMatch=_;function w(T){return!!T.resource}e.isFileMatch=w;function E(T){return!!T.message}e.isProgressMessage=E;var u;(function(T){T[T.Normal=0]="Normal",T[T.NewSearchStarted=1]="NewSearchStarted"})(u=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class h{constructor(N){this.resource=N,this.results=[]}}e.FileMatch=h;class m{constructor(N,F,M){this.ranges=F;const U=Array.isArray(F)?F:[F];if(M&&M.matchLines===1&&t(U)){N=A.getNLines(N,M.matchLines);let B="",K=0,ie=0;const we=Math.floor(M.charsPerLine/5),Te=[];for(const ye of U){const Oe=Math.max(ye.startColumn-we,0),je=ye.startColumn+M.charsPerLine;if(Oe>ie+we+g){const ze=I+(Oe-ie)+l;B+=ze+N.slice(Oe,je),K+=Oe-(ie+ze.length)}else B+=N.slice(ie,je);Te.push(new i(0,ye.startColumn-K,ye.endColumn-K)),ie=je}this.preview={text:B,matches:Array.isArray(this.ranges)?Te:Te[0]}}else{const B=Array.isArray(F)?F[0].startLineNumber:F.startLineNumber;this.preview={text:N,matches:v.mapArrayOrNot(F,K=>new r(K.startLineNumber-B,K.startColumn,K.endLineNumber-B,K.endColumn))}}}}e.TextSearchMatch=m;function t(T){const N=T[0].startLineNumber;for(const F of T)if(F.startLineNumber!==N||F.endLineNumber!==N)return!1;return!0}class r{constructor(N,F,M,U){this.startLineNumber=N,this.startColumn=F,this.endLineNumber=M,this.endColumn=U}}e.SearchRange=r;class i extends r{constructor(N,F,M){super(N,F,N,M)}}e.OneLineRange=i;var n;(function(T){T.Default="default",T.FileNames="fileNames",T.Type="type",T.Modified="modified",T.CountDescending="countDescending",T.CountAscending="countAscending"})(n=e.SearchSortOrder||(e.SearchSortOrder={}));function a(T,N=!0){const F=T&&T.files&&T.files.exclude,M=N&&T&&T.search&&T.search.exclude;if(!F&&!M)return;if(!F||!M)return F||M;let U=Object.create(null);return U=k.mixin(U,k.deepClone(F)),U=k.mixin(U,k.deepClone(M),!0),U}e.getExcludes=a;function p(T,N){return T.excludePattern&&R.match(T.excludePattern,N)?!1:T.includePattern||T.usingSearchPaths?T.includePattern&&R.match(T.includePattern,N)?!0:T.usingSearchPaths?!!T.folderQueries&&T.folderQueries.some(F=>{const M=F.folder.fsPath;if(y.isEqualOrParent(N,M)){const U=D.relative(M,N);return!F.includePattern||!!R.match(F.includePattern,U)}else return!1}):!1:!0}e.pathIncludedInQuery=p;var d;(function(T){T[T.unknownEncoding=1]="unknownEncoding",T[T.regexParseError=2]="regexParseError",T[T.globParseError=3]="globParseError",T[T.invalidLiteral=4]="invalidLiteral",T[T.rgProcessError=5]="rgProcessError",T[T.other=6]="other",T[T.canceled=7]="canceled"})(d=e.SearchErrorCode||(e.SearchErrorCode={}));class b extends Error{constructor(N,F){super(N);this.code=F}}e.SearchError=b;function S(T){const N=T.message;if(P.isPromiseCanceledError(T))return new b(N,d.canceled);try{const F=JSON.parse(N);return new b(F.message,F.code)}catch(F){return new b(N,d.other)}}e.deserializeSearchError=S;function o(T){const N={message:T.message,code:T.code};return new Error(JSON.stringify(N))}e.serializeSearchError=o;function L(T){return T.type==="error"?!0:T.type==="success"}e.isSerializedSearchComplete=L;function O(T){return T.type==="success"}e.isSerializedSearchSuccess=O;function W(T){return!!T.path}e.isSerializedFileMatch=W;function J(T,N){const F=T.searchPath?T.searchPath:T.relativePath;return A.fuzzyContains(F,N)}e.isFilePatternMatch=J;class oe{constructor(N){this.path=N,this.results=[]}addMatch(N){this.results.push(N)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=oe;function q(T,N){const F=Object.assign(Object.assign({},T||{}),N||{});return Object.keys(F).filter(M=>{const U=F[M];return typeof U=="boolean"&&U})}e.resolvePatternsForProvider=q;class x{constructor(N,F){this._parsedIncludeExpression=null,this._excludeExpression=Object.assign(Object.assign({},N.excludePattern||{}),F.excludePattern||{}),this._parsedExcludeExpression=R.parse(this._excludeExpression);let M=N.includePattern;F.includePattern&&(M?M=Object.assign(Object.assign({},M),F.includePattern):M=F.includePattern),M&&(this._parsedIncludeExpression=R.parse(M))}includedInQuerySync(N,F,M){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(N,F,M)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(N,F,M))}includedInQuery(N,F,M){return Promise.resolve(this._parsedExcludeExpression(N,F,M)).then(B=>!!B).then(B=>B?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression(N,F,M)).then(K=>!!K):Promise.resolve(!0)).then(B=>B)}hasSiblingExcludeClauses(){return V(this._excludeExpression)}}e.QueryGlobTester=x;function V(T){for(const N in T)if(typeof T[N]!="boolean")return!0;return!1}}),define(ge[34],pe([0,1,17,14,21,3,23,10,73,24,8,13,2,164,4,15,180,57,58,27,12,7,31,5]),function(X,e,v,R,k,y,A,C,D,P,s,I,l,g,c,f,_,w,E,u,h,m,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function i(L,O,W){return new P.ExtUri(J=>d(J,W)).isEqual(L,O)}function n(L,O,W){return i(L.uri,O.uri,W)?0:s.compare(L.uri.toString(),O.uri.toString())}function a(L,O,W){return L.index!==O.index?L.index<O.index?-1:1:i(L.uri,O.uri,W)?s.compare(L.name,O.name):s.compare(L.uri.toString(),O.uri.toString())}function p(L,O,W,J){const oe=L.slice(0).sort((x,V)=>W(x,V,J)),q=O.slice(0).sort((x,V)=>W(x,V,J));return v.delta(oe,q,(x,V)=>W(x,V,J))}function d(L,O){const W=O.getCapabilities(L.scheme);return!(W&&W&1024)}class b extends w.Workspace{constructor(O,W,J,oe,q,x){super(O,J.map(V=>new w.WorkspaceFolder(V)),oe,x);this._name=W,this._isUntitled=q,this._workspaceFolders=[],this._structure=A.TernarySearchTree.forUris(x),J.forEach(V=>{this._workspaceFolders.push(V),this._structure.set(V.uri,V)})}static toExtHostWorkspace(O,W,J,oe){if(!O)return{workspace:null,added:[],removed:[]};const{id:q,name:x,folders:V,configuration:T,isUntitled:N}=O,F=[],M=W;W?V.forEach((ie,we)=>{const Te=l.URI.revive(ie.uri),ye=b._findFolder(J||W,Te,oe);ye?(ye.name=ie.name,ye.index=ie.index,F.push(ye)):F.push({uri:Te,name:ie.name,index:we})}):F.push(...V.map(({uri:ie,name:we,index:Te})=>({uri:l.URI.revive(ie),name:we,index:Te}))),F.sort((ie,we)=>ie.index<we.index?-1:1);const U=new b(q,x,F,T?l.URI.revive(T):null,!!N,ie=>d(ie,oe)),{added:B,removed:K}=p(M?M.workspaceFolders:[],U.workspaceFolders,n,oe);return{workspace:U,added:B,removed:K}}static _findFolder(O,W,J){for(let oe=0;oe<O.folders.length;oe++){const q=O.workspaceFolders[oe];if(i(q.uri,W,J))return q}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(O,W){return W&&this._structure.get(O)&&(O=P.dirname(O)),this._structure.findSubstr(O)}resolveWorkspaceFolder(O){return this._structure.get(O)}}let S=class{constructor(O,W,J,oe){this._onDidChangeWorkspace=new y.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new y.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=oe,this._extHostFileSystemInfo=J,this._requestIdProvider=new D.Counter,this._barrier=new R.Barrier,this._proxy=O.getProxy(r.MainContext.MainThreadWorkspace),this._messageService=O.getProxy(r.MainContext.MainThreadMessageService);const q=W.workspace;this._confirmedWorkspace=q?new b(q.id,q.name,[],q.configuration?l.URI.revive(q.configuration):null,!!q.isUntitled,x=>d(x,J)):void 0}$initializeWorkspace(O,W){this._trusted=W,this.$acceptWorkspaceData(O),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?l.URI.from({scheme:C.Schemas.untitled,path:P.basename(P.dirname(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(O,W,J,...oe){const q=[];if(Array.isArray(oe)&&oe.forEach(F=>{l.URI.isUri(F.uri)&&!q.some(M=>i(M.uri,F.uri,this._extHostFileSystemInfo))&&q.push({uri:F.uri,name:F.name||P.basenameOrAuthority(F.uri)})}),this._unconfirmedWorkspace||[W,J].some(F=>typeof F!="number"||F<0)||J===0&&q.length===0)return!1;const x=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(W+J>x.length)return!1;const V=x.slice(0);V.splice(W,J,...q.map(F=>({uri:F.uri,name:F.name||P.basenameOrAuthority(F.uri),index:void 0})));for(let F=0;F<V.length;F++){const M=V[F];if(V.some((U,B)=>B!==F&&i(M.uri,U.uri,this._extHostFileSystemInfo)))return!1}V.forEach((F,M)=>F.index=M);const{added:T,removed:N}=p(x,V,a,this._extHostFileSystemInfo);if(T.length===0&&N.length===0)return!1;if(this._proxy){const F=O.displayName||O.name;this._proxy.$updateWorkspaceFolders(F,W,J,q).then(void 0,M=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(_.Severity.Error,g.localize(0,null,F,M.toString()),{extension:O},[])})}return this.trySetWorkspaceFolders(V),!0}getWorkspaceFolder(O,W){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(O,W)}async getWorkspaceFolder2(O,W){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(O,W)}async resolveWorkspaceFolder(O){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(O)}getPath(){if(!this._actualWorkspace)return;const{folders:O}=this._actualWorkspace;if(O.length!==0)return O[0].uri.fsPath}getRelativePath(O,W){let J,oe="";if(typeof O=="string"?(J=l.URI.file(O),oe=O):typeof O!="undefined"&&(J=O,oe=O.fsPath),!J)return oe;const q=this.getWorkspaceFolder(J,!0);if(!q)return oe;typeof W=="undefined"&&this._actualWorkspace&&(W=this._actualWorkspace.folders.length>1);let x=P.relativePath(q.uri,J);return W&&q.name&&(x=`${q.name}/${x}`),x}trySetWorkspaceFolders(O){this._actualWorkspace&&(this._unconfirmedWorkspace=b.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:O,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(O){const{workspace:W,added:J,removed:oe}=b.toExtHostWorkspace(O,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=W||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:J,removed:oe}))}findFiles(O,W,J,oe,q=k.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${oe.value}, entryPoint: findFiles`);let x;if(W===null?x=!1:W&&(typeof W=="string"?x=W:x=W.pattern),q&&q.isCancellationRequested)return Promise.resolve([]);const{includePattern:V,folder:T}=o(O);return this._proxy.$startFileSearch(I.withUndefinedAsNull(V),I.withUndefinedAsNull(T),I.withUndefinedAsNull(x),I.withUndefinedAsNull(J),q).then(N=>Array.isArray(N)?N.map(F=>l.URI.revive(F)):[])}async findTextInFiles(O,W,J,oe,q=k.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${oe.value}, entryPoint: findTextInFiles`);const x=this._requestIdProvider.getNext(),V=typeof W.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:W.previewOptions,{includePattern:T,folder:N}=o(W.include),F=typeof W.exclude=="string"?W.exclude:W.exclude?W.exclude.pattern:void 0,M={ignoreSymlinks:typeof W.followSymlinks=="boolean"?!W.followSymlinks:void 0,disregardIgnoreFiles:typeof W.useIgnoreFiles=="boolean"?!W.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof W.useGlobalIgnoreFiles=="boolean"?!W.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof W.useDefaultExcludes=="boolean"?!W.useDefaultExcludes:!0,fileEncoding:W.encoding,maxResults:W.maxResults,previewOptions:V,afterContext:W.afterContext,beforeContext:W.beforeContext,includePattern:T,excludePattern:F},U=!1;if(this._activeSearchCallbacks[x]=B=>{if(U)return;const K=l.URI.revive(B.resource);B.results.forEach(ie=>{t.resultIsMatch(ie)?J({uri:K,preview:{text:ie.preview.text,matches:v.mapArrayOrNot(ie.preview.matches,we=>new m.Range(we.startLineNumber,we.startColumn,we.endLineNumber,we.endColumn))},ranges:v.mapArrayOrNot(ie.ranges,we=>new m.Range(we.startLineNumber,we.startColumn,we.endLineNumber,we.endColumn))}):J({uri:K,text:ie.text,lineNumber:ie.lineNumber})})},q.isCancellationRequested)return{};try{const B=await this._proxy.$startTextSearch(O,I.withUndefinedAsNull(N),M,x,q);return delete this._activeSearchCallbacks[x],B||{}}catch(B){throw delete this._activeSearchCallbacks[x],B}}$handleTextSearchResult(O,W){this._activeSearchCallbacks[W]&&this._activeSearchCallbacks[W](O)}saveAll(O){return this._proxy.$saveAll(O)}resolveProxy(O){return this._proxy.$resolveProxy(O)}get trusted(){return this._trusted}requestWorkspaceTrust(O){return this._proxy.$requestWorkspaceTrust(O)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};S=Ve([We(0,h.IExtHostRpcService),We(1,u.IExtHostInitDataService),We(2,E.IExtHostFileSystemInfo),We(3,f.ILogService)],S),e.ExtHostWorkspace=S,e.IExtHostWorkspace=c.createDecorator("IExtHostWorkspace");function o(L){let O,W;return L&&(typeof L=="string"?O=L:(O=L.pattern,W=L.baseFolder||l.URI.file(L.base))),{includePattern:O,folder:W}}}),define(ge[36],pe([0,1,25,3,34,5,7,184,81,13,14,4,12,15,2]),function(X,e,v,R,k,y,A,C,D,P,s,I,l,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function f(r,i){if(i){const n=i.split(".");let a=r;for(let p=0;a&&p<n.length;p++)a=a[n[p]];return a}}function _(r){return r instanceof c.URI}function w(r){return r&&r.uri instanceof c.URI&&r.languageId&&typeof r.languageId=="string"}function E(r){return r&&!r.uri&&r.languageId&&typeof r.languageId=="string"}function u(r){return r&&r.uri instanceof c.URI&&(!r.name||typeof r.name=="string")&&(!r.index||typeof r.index=="number")}function h(r){if(_(r))return{resource:r};if(w(r))return{resource:r.uri,overrideIdentifier:r.languageId};if(E(r))return{overrideIdentifier:r.languageId};if(u(r))return{resource:r.uri};if(r===null)return{resource:null}}let m=class{constructor(i,n,a){this._proxy=i.getProxy(y.MainContext.MainThreadConfiguration),this._extHostWorkspace=n,this._logService=a,this._barrier=new s.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(i=>this._actual)}$initializeConfiguration(i){this._actual=new t(this._proxy,this._extHostWorkspace,i,this._logService),this._barrier.open()}$acceptConfigurationChanged(i,n){this.getConfigProvider().then(a=>a.$acceptConfigurationChanged(i,n))}};m=Ve([We(0,l.IExtHostRpcService),We(1,k.IExtHostWorkspace),We(2,g.ILogService)],m),e.ExtHostConfiguration=m;class t{constructor(i,n,a,p){this._onDidChangeConfiguration=new R.Emitter,this._proxy=i,this._logService=p,this._extHostWorkspace=n,this._configuration=C.Configuration.parse(a),this._configurationScopes=this._toMap(a.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(i,n){const a={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=C.Configuration.parse(i),this._configurationScopes=this._toMap(i.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(n,a))}getConfiguration(i,n,a){const p=h(n)||{},d=this._toReadonlyValue(i?f(this._configuration.getValue(void 0,p,this._extHostWorkspace.workspace),i):this._configuration.getValue(void 0,p,this._extHostWorkspace.workspace));i&&this._validateConfigurationAccess(i,p,a==null?void 0:a.identifier);function b(o){if(o==null)return null;if(typeof o=="boolean")return o?1:4;switch(o){case A.ConfigurationTarget.Global:return 1;case A.ConfigurationTarget.Workspace:return 4;case A.ConfigurationTarget.WorkspaceFolder:return 5}}const S={has(o){return typeof f(d,o)!="undefined"},get:(o,L)=>{this._validateConfigurationAccess(i?`${i}.${o}`:o,p,a==null?void 0:a.identifier);let O=f(d,o);if(typeof O=="undefined")O=L;else{let W;const J=(oe,q)=>{let x;const V=()=>{W=W||v.deepClone(d),x=x||f(W,q)};return P.isObject(oe)?new Proxy(oe,{get:(T,N)=>{if(typeof N=="string"&&N.toLowerCase()==="tojson")return V(),()=>x;if(W)return x=x||f(W,q),x[N];const F=T[N];return typeof N=="string"?J(F,`${q}.${N}`):F},set:(T,N,F)=>(V(),x&&(x[N]=F),!0),deleteProperty:(T,N)=>(V(),x&&delete x[N],!0),defineProperty:(T,N,F)=>(V(),x&&Object.defineProperty(x,N,F),!0)}):oe};O=J(O,o)}return O},update:(o,L,O,W)=>{o=i?`${i}.${o}`:o;const J=b(O);return L!==void 0?this._proxy.$updateConfigurationOption(J,o,L,p,W):this._proxy.$removeConfigurationOption(J,o,p,W)},inspect:o=>{var L,O,W,J,oe,q,x,V;o=i?`${i}.${o}`:o;const T=v.deepClone(this._configuration.inspect(o,p,this._extHostWorkspace.workspace));if(T)return{key:o,defaultValue:(L=T.default)===null||L===void 0?void 0:L.value,globalValue:(O=T.user)===null||O===void 0?void 0:O.value,workspaceValue:(W=T.workspace)===null||W===void 0?void 0:W.value,workspaceFolderValue:(J=T.workspaceFolder)===null||J===void 0?void 0:J.value,defaultLanguageValue:(oe=T.default)===null||oe===void 0?void 0:oe.override,globalLanguageValue:(q=T.user)===null||q===void 0?void 0:q.override,workspaceLanguageValue:(x=T.workspace)===null||x===void 0?void 0:x.override,workspaceFolderLanguageValue:(V=T.workspaceFolder)===null||V===void 0?void 0:V.override,languageIds:T.overrideIdentifiers}}};return typeof d=="object"&&v.mixin(S,d,!1),Object.freeze(S)}_toReadonlyValue(i){const n=a=>P.isObject(a)?new Proxy(a,{get:(p,d)=>n(p[d]),set:(p,d,b)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(d)}' of object`)},deleteProperty:(p,d)=>{throw new Error(`TypeError: Cannot delete read only property '${String(d)}' of object`)},defineProperty:(p,d)=>{throw new Error(`TypeError: Cannot define property '${String(d)}' for a readonly object`)},setPrototypeOf:p=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):a;return n(i)}_validateConfigurationAccess(i,n,a){const p=D.OVERRIDE_PROPERTY_PATTERN.test(i)?4:this._configurationScopes.get(i),d=a?`[${a.value}] `:"";if(p===4){typeof(n==null?void 0:n.resource)=="undefined"&&this._logService.warn(`${d}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${i}', provide the URI of a resource or 'null' for any resource.`);return}if(p===3){(n==null?void 0:n.resource)&&this._logService.warn(`${d}Accessing a window scoped configuration for a resource is not expected. To associate '${i}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(i,n){const a=new C.ConfigurationChangeEvent(i,n,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(p,d)=>a.affectsConfiguration(p,h(d))})}_toMap(i){return i.reduce((n,a)=>(n.set(a[0],a[1]),n),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=I.createDecorator("IExtHostConfiguration")});var tt=this&&this.__classPrivateFieldSet||function(X,e,v,R,k){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!k:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?k.call(X,v):k?k.value=v:e.set(X,v),v},$e=this&&this.__classPrivateFieldGet||function(X,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!R:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(X):R?R.value:e.get(X)};define(ge[65],pe([0,1,2,14,3,5,7,34,39,36,21,33,12,27,4,10,11,15,61,198,16]),function(X,e,v,R,k,y,A,C,D,P,s,I,l,g,c,f,_,w,E,u,h){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(oe){function q(V){if(V!=null)return V}oe.from=q;function x(V){if(V!=null)return V}oe.to=x})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var r;(function(oe){function q(V){if(V!=null)return V}oe.from=q;function x(V){if(V!=null)return V}oe.to=x})(r=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var i;(function(oe){function q(V){if(V!=null)return V}oe.from=q;function x(V){if(V!=null)return V}oe.to=x})(i=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var n;(function(oe){function q(T){if(T){const N=T;return N&&!!N.process}else return!1}oe.is=q;function x(T){if(T==null)return;const N={process:T.process,args:T.args};return T.options&&(N.options=i.from(T.options)),N}oe.from=x;function V(T){if(T!=null)return new A.ProcessExecution(T.process,T.args,T.options)}oe.to=V})(n=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var a;(function(oe){function q(V){if(V!=null)return V}oe.from=q;function x(V){if(V!=null)return V}oe.to=x})(a=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var p;(function(oe){function q(T){if(T){const N=T;return N&&(!!N.commandLine||!!N.command)}else return!1}oe.is=q;function x(T){if(T==null)return;const N={};return T.commandLine!==void 0?N.commandLine=T.commandLine:(N.command=T.command,N.args=T.args),T.options&&(N.options=a.from(T.options)),N}oe.from=x;function V(T){if(!(T==null||T.command===void 0&&T.commandLine===void 0))return T.commandLine?new A.ShellExecution(T.commandLine,T.options):new A.ShellExecution(T.command,T.args?T.args:[],T.options)}oe.to=V})(p=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var d;(function(oe){function q(T){if(T){let N=T;return N&&N.customExecution==="customExecution"}else return!1}oe.is=q;function x(T){return{customExecution:"customExecution"}}oe.from=x;function V(T,N){return N.get(T)}oe.to=V})(d=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var b;(function(oe){function q(x,V){let T;return x.scope!==void 0&&typeof x.scope!="number"?T=x.scope.uri:x.scope!==void 0&&typeof x.scope=="number"&&(x.scope===A.TaskScope.Workspace&&V&&V.workspaceFile?T=V.workspaceFile:T=u.USER_TASKS_GROUP_KEY),{id:x._id,workspaceFolder:T}}oe.from=q})(b=e.TaskHandleDTO||(e.TaskHandleDTO={}));var S;(function(oe){function q(T,N){if(T==null)return[];const F=[];for(let M of T){const U=x(M,N);U&&F.push(U)}return F}oe.fromMany=q;function x(T,N){if(T==null)return;let F;T.execution instanceof A.ProcessExecution?F=n.from(T.execution):T.execution instanceof A.ShellExecution?F=p.from(T.execution):T.execution&&T.execution instanceof A.CustomExecution&&(F=d.from(T.execution));const M=t.from(T.definition);let U;if(T.scope?typeof T.scope=="number"?U=T.scope:U=T.scope.uri:U=A.TaskScope.Workspace,!M||!U)return;const B=T.group?T.group.id:void 0;return{_id:T._id,definition:M,name:T.name,source:{extensionId:N.identifier.value,label:T.source,scope:U},execution:F,isBackground:T.isBackground,group:B,presentationOptions:r.from(T.presentationOptions),problemMatchers:T.problemMatchers,hasDefinedMatchers:T.hasDefinedMatchers,runOptions:T.runOptions?T.runOptions:{reevaluateOnRerun:!0},detail:T.detail}}oe.from=x;async function V(T,N,F){if(T==null)return;let M;n.is(T.execution)?M=n.to(T.execution):p.is(T.execution)?M=p.to(T.execution):d.is(T.execution)&&(M=d.to(T._id,F));const U=t.to(T.definition);let B;if(T.source&&(T.source.scope!==void 0?typeof T.source.scope=="number"?B=T.source.scope:B=await N.resolveWorkspaceFolder(v.URI.revive(T.source.scope)):B=A.TaskScope.Workspace),!U||!B)return;const K=new A.Task(U,B,T.name,T.source.label,M,T.problemMatchers);return T.isBackground!==void 0&&(K.isBackground=T.isBackground),T.group!==void 0&&(K.group=A.TaskGroup.from(T.group)),T.presentationOptions&&(K.presentationOptions=r.to(T.presentationOptions)),T._id&&(K._id=T._id),T.detail&&(K.detail=T.detail),K}oe.to=V})(S=e.TaskDTO||(e.TaskDTO={}));var o;(function(oe){function q(V){return V}oe.from=q;function x(V){if(!!V)return Object.assign(Object.create(null),V)}oe.to=x})(o=e.TaskFilterDTO||(e.TaskFilterDTO={}));class L{constructor(q,x,V){this._id=x,this._task=V,m.set(this,void 0),tt(this,m,q,"f")}get task(){return this._task}terminate(){$e(this,m,"f").terminateTask(this)}fireDidStartProcess(q){}fireDidEndProcess(q){}}m=new WeakMap;var O;(function(oe){function q(x){return{id:x._id,task:void 0}}oe.from=q})(O=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let W=class{constructor(q,x,V,T,N,F,M,U){this._onDidExecuteTask=new k.Emitter,this._onDidTerminateTask=new k.Emitter,this._onDidTaskProcessStarted=new k.Emitter,this._onDidTaskProcessEnded=new k.Emitter,this._proxy=q.getProxy(y.MainContext.MainThreadTask),this._workspaceProvider=V,this._editorService=T,this._configurationService=N,this._terminalService=F,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=M,this._deprecationService=U,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(q,x,V){if(!V)return new A.Disposable(()=>{});const T=this.nextHandle();return this._handlers.set(T,{type:x,provider:V,extension:q}),this._proxy.$registerTaskProvider(T,x),new A.Disposable(()=>{this._handlers.delete(T),this._proxy.$unregisterTaskProvider(T)})}registerTaskSystem(q,x){this._proxy.$registerTaskSystem(q,x)}fetchTasks(q){return this._proxy.$fetchTasks(o.from(q)).then(async x=>{const V=[];for(let T of x){const N=await S.to(T,this._workspaceProvider,this._providedCustomExecutions2);N&&V.push(N)}return V})}get taskExecutions(){const q=[];return this._taskExecutions.forEach(x=>q.push(x)),q}terminateTask(q){if(!(q instanceof L))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(q._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(q,x,V){const T=this._providedCustomExecutions2.get(q.id);if(T){if(this._activeCustomExecutions2.get(q.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(q.id,T),this._terminalService.attachPtyToTerminal(x,await T.callback(V))}this._lastStartedTask=q.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(q)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(q){const x=await this.getTaskExecution(q);this._taskExecutionPromises.delete(q.id),this._taskExecutions.delete(q.id),this.customExecutionComplete(q),this._onDidTerminateTask.fire({execution:x})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(q){const x=await this.getTaskExecution(q.id);this._onDidTaskProcessStarted.fire({execution:x,processId:q.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(q){const x=await this.getTaskExecution(q.id);this._onDidTaskProcessEnded.fire({execution:x,exitCode:q.exitCode})}$provideTasks(q,x){const V=this._handlers.get(q);if(!V)return Promise.reject(new Error("no handler found"));const T=[],N=R.asPromise(()=>V.provider.provideTasks(s.CancellationToken.None)).then(F=>this.provideTasksInternal(x,T,V,F));return new Promise(F=>{N.then(M=>{Promise.all(T).then(()=>{F(M)})})})}async $resolveTask(q,x){const V=this._handlers.get(q);if(!V)return Promise.reject(new Error("no handler found"));if(x.definition.type!==V.type)throw new Error(`Unexpected: Task of type [${x.definition.type}] cannot be resolved by provider of type [${V.type}].`);const T=await S.to(x,this._workspaceProvider,this._providedCustomExecutions2);if(!T)throw new Error("Unexpected: Task cannot be resolved.");const N=await V.provider.resolveTask(T,s.CancellationToken.None);if(!N)return;this.checkDeprecation(N,V);const F=S.from(N,V.extension);if(!F)throw new Error("Unexpected: Task cannot be resolved.");if(N.definition!==T.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return d.is(F.execution)&&await this.addCustomExecution(F,N,!0),await this.resolveTaskInternal(F)}nextHandle(){return this._handleCounter++}async addCustomExecution(q,x,V){const T=await this._proxy.$createTaskId(q);!V&&!this._providedCustomExecutions2.has(T)&&this._notProvidedCustomExecutions.add(T),this._providedCustomExecutions2.set(T,x.execution)}async getTaskExecution(q,x){if(typeof q=="string"){const N=this._taskExecutionPromises.get(q);if(!N)throw new Error("Unexpected: The specified task is missing an execution");return N}let V=this._taskExecutionPromises.get(q.id);if(V)return V;const T=new Promise(async(N,F)=>{const M=x||await S.to(q.task,this._workspaceProvider,this._providedCustomExecutions2);M?N(new L(this,q.id,M)):F("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(q.id,T),T.then(N=>(this._taskExecutions.set(q.id,N),N),N=>Promise.reject(N))}checkDeprecation(q,x){q._deprecated&&this._deprecationService.report("Task.constructor",x.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(q){this._activeCustomExecutions2.get(q.id)&&this._activeCustomExecutions2.delete(q.id),this._notProvidedCustomExecutions.has(q.id)&&this._lastStartedTask!==q.id&&(this._providedCustomExecutions2.delete(q.id),this._notProvidedCustomExecutions.delete(q.id));let V=this._notProvidedCustomExecutions.values(),T=V.next();for(;!T.done;)!this._activeCustomExecutions2.has(T.value)&&this._lastStartedTask!==T.value&&(this._providedCustomExecutions2.delete(T.value),this._notProvidedCustomExecutions.delete(T.value)),T=V.next()}};W=Ve([We(0,l.IExtHostRpcService),We(1,g.IExtHostInitDataService),We(2,C.IExtHostWorkspace),We(3,D.IExtHostDocumentsAndEditors),We(4,P.IExtHostConfiguration),We(5,I.IExtHostTerminalService),We(6,w.ILogService),We(7,E.IExtHostApiDeprecationService)],W),e.ExtHostTaskBase=W;let J=class extends W{constructor(q,x,V,T,N,F,M,U){super(q,x,V,T,N,F,M,U);this.registerTaskSystem(f.Schemas.vscodeRemote,{scheme:f.Schemas.vscodeRemote,authority:"",platform:_.PlatformToString(0)})}async executeTask(q,x){if(!x.execution)throw new Error("Tasks to execute must include an execution");const V=S.from(x,q);if(V===void 0)throw new Error("Task is not valid");if(d.is(V.execution))await this.addCustomExecution(V,x,!1);else throw new h.NotSupportedError;const T=await this.getTaskExecution(await this._proxy.$getTaskExecution(V),x);return this._proxy.$executeTask(V).catch(N=>{throw new Error(N)}),T}provideTasksInternal(q,x,V,T){const N=[];if(T)for(let F of T){this.checkDeprecation(F,V),(!F.definition||!q[F.definition.type])&&this._logService.warn(`The task [${F.source}, ${F.name}] uses an undefined task type. The task will be ignored in the future.`);const M=S.from(F,V.extension);M&&d.is(M.execution)?(N.push(M),x.push(this.addCustomExecution(M,F,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:N,extension:V.extension}}async resolveTaskInternal(q){if(d.is(q.execution))return q;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(q,x){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(q,x,V){}};J=Ve([We(0,l.IExtHostRpcService),We(1,g.IExtHostInitDataService),We(2,C.IExtHostWorkspace),We(3,D.IExtHostDocumentsAndEditors),We(4,P.IExtHostConfiguration),We(5,I.IExtHostTerminalService),We(6,w.ILogService),We(7,E.IExtHostApiDeprecationService)],J),e.WorkerExtHostTask=J,e.IExtHostTask=c.createDecorator("IExtHostTask")});var tt=this&&this.__classPrivateFieldSet||function(X,e,v,R,k){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!k:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?k.call(X,v):k?k.value=v:e.set(X,v),v},$e=this&&this.__classPrivateFieldGet||function(X,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!R:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(X):R?R.value:e.get(X)},En=this&&this.__rest||function(X,e){var v={};for(var R in X)Object.prototype.hasOwnProperty.call(X,R)&&e.indexOf(R)<0&&(v[R]=X[R]);if(X!=null&&typeof Object.getOwnPropertySymbols=="function")for(var k=0,R=Object.getOwnPropertySymbols(X);k<R.length;k++)e.indexOf(R[k])<0&&Object.prototype.propertyIsEnumerable.call(X,R[k])&&(v[R[k]]=X[R[k]]);return v};define(ge[248],pe([0,1,17,14,22,21,3,69,71,6,25,13,2,32,5,39,12,84,18,7,34,208,121]),function(X,e,v,R,k,y,A,C,D,P,s,I,l,g,c,f,_,w,E,u,h,m,t){"use strict";var r,i,n,a;Object.defineProperty(e,"__esModule",{value:!0}),e.MirroredTestCollection=e.TestItemFilteredWrapper=e.createDefaultDocumentTestRoot=e.ExtHostTesting=void 0;const p=(V,T)=>`${V}:${T.toString()}`;let d=class{constructor(T,N,F){this.documents=N,this.workspace=F,this.resultsChangedEmitter=new A.Emitter,this.controllers=new Map,this.ownedTests=new m.OwnedTestCollection,this.testControllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=T.getProxy(c.MainContext.MainThreadTesting),this.runQueue=new b(this.proxy),this.workspaceObservers=new q(this.proxy),this.textDocumentObservers=new x(this.proxy,N)}registerTestController(T,N){const F=g.generateUuid();this.controllers.set(F,{instance:N,extensionId:T}),this.proxy.$registerTestController(F);const M=[...this.testControllers.keys()];return setTimeout(()=>{var U;for(const B of M)(U=this.testControllers.get(B))===null||U===void 0||U.subscribeFn(F,N)},0),new u.Disposable(()=>{this.controllers.delete(F),this.proxy.$unregisterTestController(F)})}createTextDocumentTestObserver(T){return this.textDocumentObservers.checkout(T.uri)}createWorkspaceTestObserver(T){return this.workspaceObservers.checkout(T.uri)}async runTests(T,N=y.CancellationToken.None){const F=M=>M.map(this.getInternalTestForReference,this).filter(I.isDefined).map(U=>({src:U.src,testId:U.item.extId}));await this.proxy.$runTests({exclude:T.exclude?F(T.exclude).map(M=>M.testId):void 0,tests:F(T.tests),debug:T.debug},N)}createTestRun(T,N,F,M=!0){return this.runQueue.createTestRun(T,N,F,M)}$publishTestResults(T){this.results=Object.freeze(T.map(N=>s.deepFreeze(E.TestResults.to(N))).concat(this.results).sort((N,F)=>F.completedAt-N.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $subscribeToTests(T,N){const F=l.URI.revive(N),M=p(T,F);if(this.testControllers.has(M))return;const U=new y.CancellationTokenSource;let B;if(T===1){let ye=this.documents.getDocument(F);if(!ye){const Oe=new P.DisposableStore;ye=await new Promise(je=>{Oe.add(R.disposableTimeout(()=>je(void 0),5e3)),Oe.add(this.documents.onDidAddDocuments(ze=>{const qe=ze.find(j=>j.document.uri.toString()===F.toString());qe&&je(qe)}))}).finally(()=>Oe.dispose())}if(ye){const Oe=await this.workspace.getWorkspaceFolder2(F,!1);B=je=>je.createDocumentTestRoot?je.createDocumentTestRoot(ye.document,U.token):e.createDefaultDocumentTestRoot(je,ye.document,Oe,U.token)}}else{const ye=await this.workspace.getWorkspaceFolder2(F,!1);ye&&(B=Oe=>Oe.createWorkspaceTestRoot(ye,U.token))}if(!B)return;const K=async(ye,Oe)=>{try{const je=await B(Oe);je&&we.addRoot(je,ye)}catch(je){console.error(je)}},ie=new P.DisposableStore,we=ie.add(this.ownedTests.createForHierarchy(ye=>this.proxy.$publishDiff(T,N,ye)));ie.add(P.toDisposable(()=>U.dispose(!0)));const Te=[];for(const[ye,Oe]of this.controllers)Te.push(K(ye,Oe.instance));Promise.all(Te).then(()=>we.pushDiff([3,-1])),this.testControllers.set(M,{store:ie,collection:we,subscribeFn:K})}async $expandTest(T,N){const F=v.mapFind(this.testControllers.values(),M=>M.collection.treeId===T.src.tree?M:void 0);await(F==null?void 0:F.collection.expand(T.testId,N<0?Infinity:N)),this.flushCollectionDiffs()}$unsubscribeFromTests(T,N){var F;const M=l.URI.revive(N),U=p(T,M);(F=this.testControllers.get(U))===null||F===void 0||F.store.dispose(),this.testControllers.delete(U)}$acceptDiff(T,N,F){T===1?this.textDocumentObservers.acceptDiff(l.URI.revive(N),F):this.workspaceObservers.acceptDiff(l.URI.revive(N),F)}async $runTestsForProvider(T,N){const F=this.controllers.get(T.tests[0].src.controller);if(!F)return;const M=T.tests.map(({testId:K,src:ie})=>this.ownedTests.getTestById(K,ie==null?void 0:ie.tree)).filter(I.isDefined).map(([K,ie])=>ie),U=T.excludeExtIds.map(K=>this.ownedTests.getTestById(K)).filter(I.isDefined).filter(([K,ie])=>M.some(we=>K.comparePositions(we,ie)===1));if(!M.length)return;const B={tests:M.map(K=>O.unwrap(K.actual)),exclude:U.map(([,K])=>O.unwrap(K.actual)),debug:T.debug};await this.runQueue.enqueueRun({dto:S.fromInternal(T),token:N,extensionId:F.extensionId,req:B,doRun:()=>F.instance.runTests(B,N)})}$lookupTest(T){const N=this.ownedTests.getTestById(T.testId);if(!N)return Promise.resolve(void 0);const F=N[1],{actual:M,discoverCts:U,expandLevels:B}=F,K=En(F,["actual","discoverCts","expandLevels"]);return Promise.resolve(K)}flushCollectionDiffs(){for(const{collection:T}of this.testControllers.values())T.flushDiff()}getInternalTestForReference(T){var N,F;return(F=(N=this.workspaceObservers.getMirroredTestDataByReference(T))!==null&&N!==void 0?N:v.mapFind(this.testControllers.values(),M=>M.collection.getTestByReference(T)))!==null&&F!==void 0?F:this.textDocumentObservers.getMirroredTestDataByReference(T)}};d=Ve([We(0,_.IExtHostRpcService),We(1,f.IExtHostDocumentsAndEditors),We(2,h.IExtHostWorkspace)],d),e.ExtHostTesting=d;class b{constructor(T){this.proxy=T,this.state=new Map}enqueueRun(T){let N=this.state.get(T.extensionId);N||(N={queue:[],current:void 0},this.state.set(T.extensionId,N));const F=new R.DeferredPromise,M=()=>{const U=[],B=new Set;N.current={publicReq:T.req,factory:K=>{const ie=new o(K,T.dto,B,this.proxy);return U.push(ie),T.token.onCancellationRequested(()=>ie.end()),ie}},this.invokeRunner(T.extensionId,T.dto.id,T.doRun,U).finally(()=>F.complete())};return N.queue.push(M),N.queue.length===1&&M(),F.p}createTestRun(T,N,F,M){var U,B;const K=this.state.get(T);if((K==null?void 0:K.current.publicReq)===N)return K.current.factory(F);const ie=S.fromPublic(N),we=new o(F,ie,new Set,this.proxy);return this.proxy.$startedExtensionTestRun({debug:N.debug,exclude:(B=(U=N.exclude)===null||U===void 0?void 0:U.map(Te=>Te.id))!==null&&B!==void 0?B:[],id:ie.id,tests:N.tests.map(Te=>Te.id),persist:M}),we.onEnd.wait().then(()=>this.proxy.$finishedExtensionTestRun(ie.id)),we}invokeRunner(T,N,F,M){try{const U=F();return R.isThenable(U)?U.then(()=>this.handleInvokeResult(T,N,M,void 0)).catch(B=>this.handleInvokeResult(T,N,M,B)):this.handleInvokeResult(T,N,M,void 0)}catch(U){return this.handleInvokeResult(T,N,M,U)}}async handleInvokeResult(T,N,F,M){const U=this.state.get(T);!U||(U.queue.shift(),U.queue.length>0?U.queue[0]():this.state.delete(T),await Promise.all(F.map(B=>B.onEnd.wait())))}}class S{constructor(T,N,F){this.id=T,this.include=N,this.exclude=F}static fromPublic(T){var N,F;return new S(g.generateUuid(),new Set(T.tests.map(M=>M.id)),new Set((F=(N=T.exclude)===null||N===void 0?void 0:N.map(M=>M.id))!==null&&F!==void 0?F:D.Iterable.empty()))}static fromInternal(T){return new S(T.runId,new Set(T.tests.map(N=>N.testId)),new Set(T.excludeExtIds))}isIncluded(T){for(let N=T;N;N=N.parent){if(this.include.has(N.id))return!0;if(this.exclude.has(N.id))return!1}return!0}}class o{constructor(T,N,F,M){this.name=T,r.set(this,void 0),i.set(this,void 0),n.set(this,g.generateUuid()),a.set(this,void 0),this.onEnd=new R.Barrier,tt(this,r,M,"f"),tt(this,i,N,"f"),tt(this,a,F,"f"),M.$startedTestRunTask(N.id,{id:$e(this,n,"f"),name:T,running:!0})}setState(T,N,F){$e(this,i,"f").isIncluded(T)&&(this.ensureTestIsKnown(T),$e(this,r,"f").$updateTestStateInRun($e(this,i,"f").id,$e(this,n,"f"),T.id,N,F))}appendMessage(T,N){$e(this,i,"f").isIncluded(T)&&(this.ensureTestIsKnown(T),$e(this,r,"f").$appendTestMessageInRun($e(this,i,"f").id,$e(this,n,"f"),T.id,E.TestMessage.from(N)))}appendOutput(T){$e(this,r,"f").$appendOutputToRun($e(this,i,"f").id,$e(this,n,"f"),k.VSBuffer.fromString(T))}end(){$e(this,r,"f").$finishedTestRunTask($e(this,i,"f").id,$e(this,n,"f")),this.onEnd.open()}ensureTestIsKnown(T){const N=$e(this,a,"f");if(N.has(T.id))return;const F=[];for(;F.unshift(E.TestItem.from(T)),!(N.has(T.id)||(N.add(T.id),!T.parent));)T=T.parent;$e(this,r,"f").$addTestsToRun($e(this,i,"f").id,F)}}r=new WeakMap,i=new WeakMap,n=new WeakMap,a=new WeakMap;const L=async(V,T,N,F)=>{if(!N)return;const M=await V.createWorkspaceTestRoot(N,F);if(!M)return;F.onCancellationRequested(()=>{O.removeFilter(T)});const U=O.getWrapperForTestItem(M,T);return U.refreshMatch(),U};e.createDefaultDocumentTestRoot=L;class O extends u.TestItemImpl{constructor(T,N,F){super(T.id,T.label,T.uri,void 0);if(this.actual=T,this.filterDocument=N,this.actualParent=F,!(T instanceof u.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${T.id} did not`);this.debuggable=T.debuggable,this.runnable=T.runnable,this.description=T.description,this.error=T.error,this.status=T.status,this.range=T.range,this.resolveHandler=T.resolveHandler;const M=w.getPrivateApiFor(this);w.getPrivateApiFor(T).bus.event(B=>{switch(B[0]){case 3:this[B[1]]=B[2];break;case 0:const K=O.getWrapperForTestItem(B[1],this.filterDocument,this);w.getPrivateApiFor(K).parent=T,K.refreshMatch();break;default:M.bus.fire(B)}})}static removeFilter(T){this.wrapperMap.delete(T)}static getWrapperForTestItem(T,N,F){let M=this.wrapperMap.get(N);if(M==null?void 0:M.has(T))return M.get(T);M||(M=new WeakMap,this.wrapperMap.set(N,M));const U=new O(T,N,F);return M.set(T,U),U}static unwrap(T){return T instanceof O?T.actual:T}get hasNodeMatchingFilter(){return this._cachedMatchesFilter===void 0?this.refreshMatch():this._cachedMatchesFilter}refreshMatch(){var T,N;const F=this._cachedMatchesFilter;for(const U of this.actual.children.values()){const B=O.getWrapperForTestItem(U,this.filterDocument,this);B.hasNodeMatchingFilter?this.children.has(B.id)||this.addChild(B):B.dispose()}const M=this.children.size>0||((T=this.actual.uri)===null||T===void 0?void 0:T.toString())===this.filterDocument.uri.toString();return this._cachedMatchesFilter=M,M!==F&&((N=this.actualParent)===null||N===void 0||N.refreshMatch()),this._cachedMatchesFilter}dispose(){this.actualParent&&w.getPrivateApiFor(this.actualParent).children.delete(this.id),w.getPrivateApiFor(this).bus.fire([1])}}e.TestItemFilteredWrapper=O,O.wrapperMap=new WeakMap;class W extends t.IncrementalChangeCollector{constructor(T){super();this.emitter=T,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(T){this.added.add(T)}update(T){Object.assign(T.revived,E.TestItem.toPlain(T.item)),this.added.has(T)||this.updated.add(T)}remove(T){if(this.added.has(T)){this.added.delete(T);return}if(this.updated.delete(T),T.parent&&this.alreadyRemoved.has(T.parent)){this.alreadyRemoved.add(T.item.extId);return}this.removed.add(T)}getChangeEvent(){const{added:T,updated:N,removed:F}=this;return{get added(){return[...T].map(M=>M.revived)},get updated(){return[...N].map(M=>M.revived)},get removed(){return[...F].map(M=>M.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class J extends t.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new A.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTestItems(){return this.getAllAsTestItem([...this.roots])}getAllAsTestItem(T){let N=[];for(const F of T){const M=this.items.get(F);M&&N.push(M.revived)}return N}getMirroredTestDataById(T){return this.items.get(T)}getMirroredTestDataByReference(T){return this.items.get(T.id)}createItem(T,N){return Object.assign(Object.assign({},T),{revived:E.TestItem.toPlain(T.item),depth:N?N.depth+1:0,children:new Set})}createChangeCollector(){return new W(this.changeEmitter)}}e.MirroredTestCollection=J;class oe{constructor(){this.resources=new Map}checkout(T){var N,F;const M=T.toString(),U=(N=this.resources.get(M))!==null&&N!==void 0?N:this.createObserverData(T);return(F=U.pendingDeletion)===null||F===void 0||F.dispose(),U.observers++,{onDidChangeTest:U.tests.onDidChangeTests,onDidDiscoverInitialTests:new A.Emitter().event,get tests(){return U.tests.rootTestItems},dispose:C.once(()=>{--U.observers||(U.pendingDeletion=this.eventuallyDispose(T))})}}getMirroredTestDataByReference(T){for(const{tests:N}of this.resources.values()){const F=N.getMirroredTestDataByReference(T);if(F)return F}}eventuallyDispose(T){return R.disposableTimeout(()=>this.unlisten(T),10*1e3)}createObserverData(T){const N=new J,F=this.listen(T,U=>N.apply(U)),M={observers:0,tests:N,listener:F};return this.resources.set(T.toString(),M),M}unlisten(T){var N;const F=T.toString(),M=this.resources.get(F);M&&(M.observers=-1,(N=M.pendingDeletion)===null||N===void 0||N.dispose(),M.listener.dispose(),this.resources.delete(F))}}class q extends oe{constructor(T){super();this.proxy=T,this.diffListeners=new Map}acceptDiff(T,N){var F;(F=this.diffListeners.get(T.toString()))===null||F===void 0||F(N)}listen(T,N){this.proxy.$subscribeToDiffs(0,T);const F=T.toString();return this.diffListeners.set(F,N),new u.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(0,T),this.diffListeners.delete(F)})}}class x extends oe{constructor(T,N){super();this.proxy=T,this.documents=N,this.diffListeners=new Map}acceptDiff(T,N){var F;(F=this.diffListeners.get(T.toString()))===null||F===void 0||F(N)}listen(T,N){if(!this.documents.getDocument(T))return new u.Disposable(()=>{});const M=T.toString();return this.diffListeners.set(M,N),this.proxy.$subscribeToDiffs(1,T),new u.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(1,T),this.diffListeners.delete(M)})}}}),define(ge[249],pe([0,1,17,68,30,76,23,10,9,24,8,13,2,140,168,82,57,201,247,31]),function(X,e,v,R,k,y,A,C,D,P,s,I,l,g,c,f,_,w,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let h=class{constructor(b,S,o,L){this.configurationService=b,this.workspaceContextService=S,this.editorGroupsService=o,this.pathService=L}text(b,S,o={}){b=this.getContentPattern(b,o);const L=this.configurationService.getValue(),O=S&&S.some(J=>!this.configurationService.getValue({resource:J}).search.useRipgrep),W=this.commonQuery(S==null?void 0:S.map(_.toWorkspaceFolder),o);return Object.assign(Object.assign({},W),{type:2,contentPattern:b,previewOptions:o.previewOptions,maxFileSize:o.maxFileSize,usePCRE2:L.search.usePCRE2||O||!1,beforeContext:o.beforeContext,afterContext:o.afterContext,userDisabledExcludesAndIgnoreFiles:o.disregardExcludeSettings&&o.disregardIgnoreFiles})}getContentPattern(b,S){const o=this.configurationService.getValue();b.isRegExp&&(b.pattern=b.pattern.replace(/\r?\n/g,"\\n"));const L=Object.assign(Object.assign({},b),{wordSeparators:o.editor.wordSeparators});return this.isCaseSensitive(b,S)&&(L.isCaseSensitive=!0),this.isMultiline(b)&&(L.isMultiline=!0),L}file(b,S={}){const o=this.commonQuery(b,S);return Object.assign(Object.assign({},o),{type:1,filePattern:S.filePattern?S.filePattern.trim():S.filePattern,exists:S.exists,sortByScore:S.sortByScore,cacheKey:S.cacheKey})}handleIncludeExclude(b,S){return b?(b=Array.isArray(b)?b.map(n):n(b),S?this.parseSearchPaths(b):{pattern:t(...Array.isArray(b)?b:[b])}):{}}commonQuery(b=[],S={}){const o=this.handleIncludeExclude(S.includePattern,S.expandPatterns),L=this.handleIncludeExclude(S.excludePattern,S.expandPatterns),O=b.length>1,W=(o.searchPaths&&o.searchPaths.length?o.searchPaths.map(q=>this.getFolderQueryForSearchPath(q,S,L)):b.map(q=>this.getFolderQueryForRoot(q,S,L,O))).filter(q=>!!q),J={_reason:S._reason,folderQueries:W,usingSearchPaths:!!(o.searchPaths&&o.searchPaths.length),extraFileResources:S.extraFileResources,excludePattern:L.pattern,includePattern:o.pattern,onlyOpenEditors:S.onlyOpenEditors,maxResults:S.maxResults};if(S.onlyOpenEditors){const x=v.coalesce(v.flatten(this.editorGroupsService.groups.map(T=>T.editors.map(N=>N.resource)))).filter(T=>u.pathIncludedInQuery(J,T.fsPath)),V=this.commonQueryFromFileList(x);return Object.assign(Object.assign({},J),V)}const oe=S.extraFileResources&&S.extraFileResources.filter(q=>u.pathIncludedInQuery(J,q.fsPath));return J.extraFileResources=oe&&oe.length?oe:void 0,J}commonQueryFromFileList(b){const S=[],o=new A.ResourceMap,L={};let O=!1;return b.forEach(W=>{var J,oe;if(W.scheme===C.Schemas.walkThrough)return;if(P.isAbsolutePath(W)){const x=(oe=(J=this.workspaceContextService.getWorkspaceFolder(W))===null||J===void 0?void 0:J.uri)!==null&&oe!==void 0?oe:W.with({path:D.dirname(W.fsPath)});let V=o.get(x);V||(O=!0,V={folder:x,includePattern:{}},S.push(V),o.set(x,V));const T=D.relative(x.fsPath,W.fsPath);I.assertIsDefined(V.includePattern)[T.replace(/\\/g,"/")]=!0}else W.fsPath&&(O=!0,L[W.fsPath]=!0)}),{folderQueries:S,includePattern:L,usingSearchPaths:!0,excludePattern:O?void 0:{"**/*":!0}}}isCaseSensitive(b,S){if(S.isSmartCase){if(b.isRegExp){if(s.containsUppercaseCharacter(b.pattern,!0))return!0}else if(s.containsUppercaseCharacter(b.pattern))return!0}return!!b.isCaseSensitive}isMultiline(b){return b.isMultiline||b.isRegExp&&g.isMultilineRegexSource(b.pattern)||b.pattern.indexOf(`
`)>=0?!0:!!b.isMultiline}parseSearchPaths(b){const S=V=>D.isAbsolute(V)||/^\.\.?([\/\\]|$)/.test(V),L=(Array.isArray(b)?b:r(b)).map(V=>{const T=this.pathService.resolvedUserHome;return T?y.untildify(V,T.scheme===C.Schemas.file?T.fsPath:T.path):V}),O=R.groupBy(L,V=>S(V)?"searchPaths":"exprSegments"),W=(O.exprSegments||[]).map(V=>s.rtrim(V,"/")).map(V=>s.rtrim(V,"\\")).map(V=>(V[0]==="."&&(V="*"+V),i(V))),J={},oe=this.expandSearchPathPatterns(O.searchPaths||[]);oe&&oe.length&&(J.searchPaths=oe);const q=v.flatten(W),x=t(...q);return x&&(J.pattern=x),J}getExcludesForFolder(b,S){return S.disregardExcludeSettings?void 0:u.getExcludes(b,!S.disregardSearchExcludeSettings)}expandSearchPathPatterns(b){if(!b||!b.length)return[];const S=v.flatten(b.map(L=>{let{pathPortion:O,globPortion:W}=m(L);W&&(W=a(W));const J=this.expandOneSearchPath(O);return v.flatten(J.map(oe=>this.resolveOneSearchPathPattern(oe,W)))})),o=new Map;return S.forEach(L=>{const O=L.searchPath.toString(),W=o.get(O);W?L.pattern&&(W.pattern=W.pattern||{},W.pattern[L.pattern]=!0):o.set(O,{searchPath:L.searchPath,pattern:L.pattern?t(L.pattern):void 0})}),Array.from(o.values())}expandOneSearchPath(b){if(D.isAbsolute(b)){const S=this.workspaceContextService.getWorkspace().folders;return S[0]&&S[0].uri.scheme!==C.Schemas.file?[{searchPath:S[0].uri.with({path:b})}]:[{searchPath:l.URI.file(D.normalize(b))}]}if(this.workspaceContextService.getWorkbenchState()===2){const S=this.workspaceContextService.getWorkspace().folders[0].uri;if(b=n(b),b.startsWith("../")||b===".."){const L=D.posix.resolve(S.path,b);return[{searchPath:S.with({path:L})}]}const o=a(b);return[{searchPath:S,pattern:o}]}else{if(b==="./"||b===".\\")return[];{const S=b.replace(/^\.[\/\\]/,""),L=this.workspaceContextService.getWorkspace().folders.map(O=>{const W=S.match(new RegExp(`^${O.name}(?:/(.*))?`));return W?{match:W,folder:O}:null}).filter(I.isDefined);if(L.length)return L.map(O=>{const W=O.match[1];return{searchPath:O.folder.uri,pattern:W&&a(W)}});{const O=b.match(/\.[\/\\](.+)[\/\\]?/),W=O?O[1]:b,J=c.localize(0,null,W);throw new Error(J)}}}}resolveOneSearchPathPattern(b,S){const o=b.pattern&&S?`${b.pattern}/${S}`:b.pattern||S,L=[{searchPath:b.searchPath,pattern:o}];return o&&!o.endsWith("**")&&L.push({searchPath:b.searchPath,pattern:o+"/**"}),L}getFolderQueryForSearchPath(b,S,o){const L=this.getFolderQueryForRoot(_.toWorkspaceFolder(b.searchPath),S,o,!1);return L?Object.assign(Object.assign({},L),{includePattern:b.pattern}):null}getFolderQueryForRoot(b,S,o,L){let O;const W=l.URI.isUri(b)?b:b.uri;if(o.searchPaths){const V=o.searchPaths.filter(T=>P.isEqual(T.searchPath,W))[0];if(V&&!V.pattern)return null;V&&(O=V.pattern)}const J=this.configurationService.getValue({resource:W}),oe=this.getExcludesForFolder(J,S),q=Object.assign(Object.assign({},oe||{}),O||{}),x=l.URI.isUri(b)?P.basename(b):b.name;return{folder:W,folderName:L?x:void 0,excludePattern:Object.keys(q).length>0?q:void 0,fileEncoding:J.files&&J.files.encoding,disregardIgnoreFiles:typeof S.disregardIgnoreFiles=="boolean"?S.disregardIgnoreFiles:!J.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof S.disregardGlobalIgnoreFiles=="boolean"?S.disregardGlobalIgnoreFiles:!J.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof S.ignoreSymlinks=="boolean"?S.ignoreSymlinks:!J.search.followSymlinks}}};h=Ve([We(0,f.IConfigurationService),We(1,_.IWorkspaceContextService),We(2,w.IEditorGroupsService),We(3,E.IPathService)],h),e.QueryBuilder=h;function m(d){const b=d.match(/[\*\{\}\(\)\[\]\?]/);if(b){const S=b.index,o=d.substr(0,S).match(/[/|\\][^/\\]*$/);if(o){let L=d.substr(0,o.index);return L.match(/[/\\]/)||(L+="/"),{pathPortion:L,globPortion:d.substr((o.index||0)+1)}}}return{pathPortion:d}}function t(...d){return d.length?d.reduce((b,S)=>(b[S]=!0,b),Object.create(null)):void 0}function r(d){return k.splitGlobAware(d,",").map(b=>b.trim()).filter(b=>!!b.length)}function i(d){return[`**/${d}/**`,`**/${d}`].map(S=>S.replace(/\*\*\/\*\*/g,"**"))}function n(d){return d.replace(/\\/g,"/")}function a(d){return n(d).replace(/^\.\//,"").replace(/\/+$/g,"")}function p(d,b){d=v.distinct(d,L=>L.toString());const S=[],o=b.getWorkspace();return d&&d.forEach(L=>{let O;if(b.getWorkbenchState()===2)O=P.relativePath(o.folders[0].uri,L),O&&O!=="."&&(O="./"+O);else{const W=b.getWorkspaceFolder(L);if(W){const J=W.name;if(o.folders.filter(q=>q.name===J).length===1){const q=P.relativePath(W.uri,L);q===""?O=`./${W.name}`:O=`./${W.name}/${q}`}else O=L.fsPath}}O&&S.push(O)}),S}e.resolveResourcesForSearchIncludes=p}),define(ge[250],pe([0,1,24,2,21,16,4,249,31,57]),function(X,e,v,R,k,y,A,C,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const s=7e3;function I(f,_){const w=_.activationEvents;if(!w)return Promise.resolve(void 0);const E=[],u=[];for(const n of w)if(/^workspaceContains:/.test(n)){const a=n.substr("workspaceContains:".length);a.indexOf("*")>=0||a.indexOf("?")>=0||f.forceUsingSearch?u.push(a):E.push(a)}if(E.length===0&&u.length===0)return Promise.resolve(void 0);let h;const m=new Promise((n,a)=>{h=n}),t=n=>h({activationEvent:n}),r=Promise.all(E.map(n=>l(f,n,t))).then(()=>{}),i=g(f,_.identifier,u,t);return Promise.all([r,i]).then(()=>{h(void 0)}),m}e.checkActivateWorkspaceContainsExtension=I;async function l(f,_,w){for(const E of f.folders)if(await f.exists(v.joinPath(R.URI.revive(E),_))){w(`workspaceContains:${_}`);return}}async function g(f,_,w,E){if(w.length===0)return Promise.resolve(void 0);const u=new k.CancellationTokenSource,h=f.checkExists(f.folders,w,u.token),m=setTimeout(async()=>{u.cancel(),E(`workspaceContainsTimeout:${w.join(",")}`)},s);let t=!1;try{t=await h}catch(r){y.isPromiseCanceledError(r)||y.onUnexpectedError(r)}u.dispose(),clearTimeout(m),t&&E(`workspaceContains:${w.join(",")}`)}function c(f,_,w,E){const u=f.get(A.IInstantiationService),h=f.get(D.ISearchService),t=u.createInstance(C.QueryBuilder).file(_.map(r=>P.toWorkspaceFolder(R.URI.revive(r))),{_reason:"checkExists",includePattern:w,exists:!0});return h.fileSearch(t,E).then(r=>!!r.limitHit,r=>y.isPromiseCanceledError(r)?!1:Promise.reject(r))}e.checkGlobFileExists=c});var tt=this&&this.__classPrivateFieldSet||function(X,e,v,R,k){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!k:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?k.call(X,v):k?k.value=v:e.set(X,v),v},$e=this&&this.__classPrivateFieldGet||function(X,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!R:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(X):R?R.value:e.get(X)};define(ge[40],pe([0,1,159,9,66,24,14,6,23,2,15,5,36,211,88,34,35,209,16,26,22,189,7,115,4,27,89,12,80,46,33,3,250,86,190]),function(X,e,v,R,k,y,A,C,D,P,s,I,l,g,c,f,_,w,E,u,h,m,t,r,i,n,a,p,d,b,S,o,L,O,W){"use strict";var J,oe,q;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=i.createDecorator("IHostUtils");let x=class xn extends C.Disposable{constructor(F,M,U,B,K,ie,we,Te,ye,Oe){super();this._onDidChangeRemoteConnectionData=this._register(new o.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=M,this._extHostContext=U,this._initData=we,this._extHostWorkspace=B,this._extHostConfiguration=K,this._logService=ie,this._extHostTunnelService=ye,this._extHostTerminalService=Oe,this._disposables=new C.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(I.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(I.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(I.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new A.Barrier,this._readyToStartExtensionHost=new A.Barrier,this._readyToRunExtensions=new A.Barrier,this._eagerExtensionsActivated=new A.Barrier,this._registry=new w.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new c.ExtHostStorage(this._extHostContext),this._secretState=new O.ExtHostSecretState(this._extHostContext),this._storagePath=Te,this._instaService=F.createChild(new d.ServiceCollection([c.IExtHostStorage,this._storage],[O.IExtHostSecretState,this._secretState]));const je=new Set;this._initData.hostExtensions.forEach(ze=>je.add(u.ExtensionIdentifier.toKey(ze))),this._activator=new g.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(ze,qe,j)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(ze,E.transformErrorForSerialization(qe),j)},actualActivateExtension:async(ze,qe)=>{if(je.has(u.ExtensionIdentifier.toKey(ze)))return await this._mainThreadExtensionsProxy.$activateExtension(ze,qe),new g.HostExtension;const j=this._registry.getExtensionDescription(ze);return this._activateExtension(j,qe)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),k.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(F){E.onUnexpectedError(F)}}async deactivateAll(){let F=[];try{F=this._registry.getAllExtensionDescriptions().map(K=>K.identifier).filter(K=>this.isActivated(K)).map(K=>this._deactivate(K))}catch(M){}await Promise.all(F)}isActivated(F){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(F):!1}_activateByEvent(F,M){return this._activator.activateByEvent(F,M)}_activateById(F,M){return this._activator.activateById(F,M)}activateByIdWithErrors(F,M){return this._activateById(F,M).then(()=>{const U=this._activator.getActivatedExtension(F);if(U.activationFailed)return Promise.reject(U.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(F=>this._registry)}getExtensionExports(F){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(F).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const F=D.TernarySearchTree.forPaths(),M=this._registry.getAllExtensionDescriptions().map(U=>{if(!!this._getEntryPoint(U))return this._hostUtils.realpath(U.extensionLocation.fsPath).then(B=>F.set(P.URI.file(B).fsPath,U))});this._extensionPathIndex=Promise.all(M).then(()=>F)}return this._extensionPathIndex}_deactivate(F){let M=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(F))return M;const U=this._activator.getActivatedExtension(F);if(!U)return M;try{typeof U.module.deactivate=="function"&&(M=Promise.resolve(U.module.deactivate()).then(void 0,B=>(this._logService.error(B),Promise.resolve(void 0))))}catch(B){this._logService.error(B)}try{C.dispose(U.subscriptions)}catch(B){this._logService.error(B)}return M}async _activateExtension(F,M){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(F.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(F.identifier),this._doActivateExtension(F,M).then(U=>{const B=U.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(F.identifier,B.codeLoadingTime,B.activateCallTime,B.activateResolvedTime,M),this._logExtensionActivationTimes(F,M,"success",B),U},U=>{throw this._logExtensionActivationTimes(F,M,"failure"),U})}_logExtensionActivationTimes(F,M,U,B){const K=V(F,M);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",Object.assign(Object.assign(Object.assign({},K),B||{}),{outcome:U}))}_doActivateExtension(F,M){const U=V(F,M);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",U);const B=this._getEntryPoint(F);if(!B)return Promise.resolve(new g.EmptyExtension(g.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${F.identifier.value} ${JSON.stringify(M)}`),this._logService.flush();const K=new g.ExtensionActivationTimesBuilder(M.startup);return Promise.all([this._loadCommonJSModule(F.identifier,y.joinPath(F.extensionLocation,B),K),this._loadExtensionContext(F)]).then(ie=>(k.mark(`code/extHost/willActivateExtension/${F.identifier.value}`),xn._callActivate(this._logService,F.identifier,ie[0],ie[1],K))).then(ie=>(k.mark(`code/extHost/didActivateExtension/${F.identifier.value}`),ie))}_loadExtensionContext(F){const M=new m.ExtensionGlobalMemento(F,this._storage),U=new m.ExtensionMemento(F.identifier.value,!1,this._storage),B=new W.ExtensionSecrets(F,this._secretState),K=F.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,ie=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${F.identifier.value}`),Promise.all([M.whenReady,U.whenReady,this._storagePath.whenReady]).then(()=>{const we=this;let Te;return Object.freeze({globalState:M,workspaceState:U,secrets:B,subscriptions:[],get extensionUri(){return F.extensionLocation},get extensionPath(){return F.extensionLocation.fsPath},asAbsolutePath(ye){return R.join(F.extensionLocation.fsPath,ye)},get storagePath(){var ye;return(ye=we._storagePath.workspaceValue(F))===null||ye===void 0?void 0:ye.fsPath},get globalStoragePath(){return we._storagePath.globalValue(F).fsPath},get logPath(){return R.join(we._initData.logsLocation.fsPath,F.identifier.value)},get logUri(){return P.URI.joinPath(we._initData.logsLocation,F.identifier.value)},get storageUri(){return we._storagePath.workspaceValue(F)},get globalStorageUri(){return we._storagePath.globalValue(F)},get extensionMode(){return K},get extension(){return Te===void 0&&(Te=new T(we,F.identifier,F,ie)),Te},get extensionRuntime(){return _.checkProposedApiEnabled(F),we.extensionRuntime},get environmentVariableCollection(){return we._extHostTerminalService.getEnvironmentVariableCollection(F)}})})}static _callActivate(F,M,U,B,K){return U=U||{activate:void 0,deactivate:void 0},this._callActivateOptional(F,M,U,B,K).then(ie=>new g.ActivatedExtension(!1,null,K.build(),U,ie,B.subscriptions))}static _callActivateOptional(F,M,U,B,K){if(typeof U.activate=="function")try{K.activateCallStart(),F.trace(`ExtensionService#_callActivateOptional ${M.value}`);const ie=typeof global=="object"?global:self,we=U.activate.apply(ie,[B]);return K.activateCallStop(),K.activateResolveStart(),Promise.resolve(we).then(Te=>(K.activateResolveStop(),Te))}catch(ie){return Promise.reject(ie)}else return Promise.resolve(U)}_activateOneStartupFinished(F,M){this._activateById(F.identifier,{startup:!1,extensionId:F.identifier,activationEvent:M}).then(void 0,U=>{this._logService.error(U)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(k.getMarks());for(const F of this._registry.getAllExtensionDescriptions())if(F.activationEvents)for(const M of F.activationEvents)M==="onStartupFinished"&&this._activateOneStartupFinished(F,M)}_handleEagerExtensions(){const F=this._activateByEvent("*",!0).then(void 0,K=>{this._logService.error(K)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(K=>this._handleWorkspaceContainsEagerExtensions(K.added)));const M=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],U=this._handleWorkspaceContainsEagerExtensions(M),B=Promise.all([F,U]).then(()=>{});return Promise.race([B,A.timeout(1e4)]).then(()=>{this._activateAllStartupFinished()}),B}_handleWorkspaceContainsEagerExtensions(F){return F.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(M=>this._handleWorkspaceContainsEagerExtension(F,M))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(F,M){if(this.isActivated(M.identifier))return;const U=!this._initData.remote.isRemote&&!!this._initData.remote.authority,B={folders:F.map(ie=>ie.uri),forceUsingSearch:U,exists:ie=>this._hostUtils.exists(ie.fsPath),checkExists:(ie,we,Te)=>this._mainThreadWorkspaceProxy.$checkExists(ie,we,Te)},K=await L.checkActivateWorkspaceContainsExtension(B,M);if(!!K)return this._activateById(M.identifier,{startup:!0,extensionId:M.identifier,activationEvent:K.activationEvent}).then(void 0,ie=>this._logService.error(ie))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return this._doHandleExtensionTests()}catch(F){throw console.error(F),F}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:F,extensionTestsLocationURI:M}=this._initData.environment;if(!F||!M)throw new Error(v.localize(0,null));const U=await this._loadCommonJSModule(null,M,new g.ExtensionActivationTimesBuilder(!1));if(!U||typeof U.run!="function")throw new Error(v.localize(1,null,M.toString()));return new Promise((B,K)=>{const ie=(ye,Oe)=>{ye?K(ye):B(typeof Oe=="number"&&Oe>0?1:0)},we=y.originalFSPath(M),Te=U.run(we,ie);Te&&Te.then&&Te.then(()=>{B(0)}).catch(ye=>{K(ye.toString())})})}async $extensionTestsExit(F){this._logService.info(`extension host terminating: test runner requested exit with code ${F}`),this._logService.info(`exiting with code ${F}`),this._logService.flush(),this._hostUtils.exit(F)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(F,M){return this._resolvers[F]=M,C.toDisposable(()=>{delete this._resolvers[F]})}async _activateAndGetResolver(F){const M=F.indexOf("+");if(M===-1)throw new Error("Not an authority that can be resolved!");const U=F.substr(0,M);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${U}`,!1),{authorityPrefix:U,resolver:this._resolvers[U]}}async $resolveAuthority(F,M){const{authorityPrefix:U,resolver:B}=await this._activateAndGetResolver(F);if(!B)return{type:"error",error:{code:r.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${U}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(B)),k.mark(`code/extHost/willResolveAuthority/${U}`);const K=await B.resolve(F,{resolveAttempt:M});k.mark(`code/extHost/didResolveAuthorityOK/${U}`);const ie={authority:F,host:K.host,port:K.port,connectionToken:K.connectionToken},we={extensionHostEnv:K.extensionHostEnv,isTrusted:K.isTrusted};return{type:"ok",value:{authority:ie,options:we,tunnelInformation:{environmentTunnels:K.environmentTunnels}}}}catch(K){if(k.mark(`code/extHost/didResolveAuthorityError/${U}`),K instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:K._code,message:K._message,detail:K._detail}};throw K}}async $getCanonicalURI(F,M){const{authorityPrefix:U,resolver:B}=await this._activateAndGetResolver(F);if(!B)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${U}`);const K=P.URI.revive(M);if(typeof B.getCanonicalURI=="undefined")return K;const ie=await A.asPromise(()=>B.getCanonicalURI(K));return ie||K}$startExtensionHost(F){return this._registry.keepOnly(F),this._startExtensionHost()}$activateByEvent(F,M){return M===1?this._activateByEvent(F,!1):this._readyToRunExtensions.wait().then(U=>this._activateByEvent(F,!1))}async $activate(F,M){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(F)?(await this._activateById(F,M),!0):!1}async $deltaExtensions(F,M){F.forEach(B=>B.extensionLocation=P.URI.revive(B.extensionLocation));const U=await this.getExtensionPathIndex();return await Promise.all(M.map(async B=>{const K=this._registry.getExtensionDescription(B);if(!K)return;const ie=await this._hostUtils.realpath(K.extensionLocation.fsPath);U.delete(P.URI.file(ie).fsPath)})),await Promise.all(F.map(async B=>{const K=await this._hostUtils.realpath(B.extensionLocation.fsPath);U.set(P.URI.file(K).fsPath,B)})),this._registry.deltaExtensions(F,M),Promise.resolve(void 0)}async $test_latency(F){return F}async $test_up(F){return F.byteLength}async $test_down(F){let M=h.VSBuffer.alloc(F),U=Math.random()%256;for(let B=0;B<F;B++)M.writeUInt8(U,B);return M}async $updateRemoteConnectionData(F){this._remoteConnectionData=F,this._onDidChangeRemoteConnectionData.fire()}};x=Ve([We(0,i.IInstantiationService),We(1,e.IHostUtils),We(2,p.IExtHostRpcService),We(3,f.IExtHostWorkspace),We(4,l.IExtHostConfiguration),We(5,s.ILogService),We(6,n.IExtHostInitDataService),We(7,a.IExtensionStoragePaths),We(8,b.IExtHostTunnelService),We(9,S.IExtHostTerminalService)],x),e.AbstractExtHostExtensionService=x;function V(N,F){return{id:N.identifier.value,name:N.name,extensionVersion:N.version,publisherDisplayName:N.publisher,activationEvents:N.activationEvents?N.activationEvents.join(","):null,isBuiltin:N.isBuiltin,reason:F.activationEvent,reasonId:F.extensionId.value}}e.IExtHostExtensionService=i.createDecorator("IExtHostExtensionService");class T{constructor(F,M,U,B){J.set(this,void 0),oe.set(this,void 0),q.set(this,void 0),tt(this,J,F,"f"),tt(this,oe,M,"f"),tt(this,q,U.identifier,"f"),this.id=U.identifier.value,this.extensionUri=U.extensionLocation,this.extensionPath=R.normalize(y.originalFSPath(U.extensionLocation)),this.packageJSON=U,this.extensionKind=B}get isActive(){return $e(this,J,"f").isActivated($e(this,q,"f"))}get exports(){if(this.packageJSON.api!=="none")return $e(this,J,"f").getExtensionExports($e(this,q,"f"))}activate(){return $e(this,J,"f").activateByIdWithErrors($e(this,q,"f"),{startup:!1,extensionId:$e(this,oe,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=T,J=new WeakMap,oe=new WeakMap,q=new WeakMap}),define(ge[48],pe([0,1,9,2,3,14,5,7,119,34,40,39,200,36,195,12,4,13,37,45]),function(X,e,v,R,k,y,A,C,D,P,s,I,l,g,c,f,_,w,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=_.createDecorator("IExtHostDebugService");let h=class{constructor(d,b,S,o,L,O){this._workspaceService=b,this._extensionService=S,this._editorsService=o,this._configurationService=L,this._editorTabs=O,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new k.Emitter,this._onDidTerminateDebugSession=new k.Emitter,this._onDidChangeActiveDebugSession=new k.Emitter,this._onDidReceiveDebugSessionCustomEvent=new k.Emitter,this._debugServiceProxy=d.getProxy(A.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new k.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new t(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(W=>{W.onDidChange(J=>{this.registerAllDebugTypes(W)}),this.registerAllDebugTypes(W)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(d,b){const S=d;if(typeof S.sourceReference=="number"&&S.sourceReference>0){let o=`debug:${encodeURIComponent(S.path||"")}`,L="?";return b&&(o+=`${L}session=${encodeURIComponent(b.id)}`,L="&"),o+=`${L}ref=${S.sourceReference}`,R.URI.parse(o)}else{if(S.path)return R.URI.file(S.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(d){const b=[];for(const S of d.getAllExtensionDescriptions())if(S.contributes){const o=S.contributes.debuggers;if(o&&o.length>0)for(const L of o)c.isDebuggerMainContribution(L)&&b.push(L.type)}this._debugServiceProxy.$registerDebugTypes(b)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const d=[];return this._breakpoints.forEach(b=>d.push(b)),d}addBreakpoints(d){this.startBreakpoints();const b=d.filter(L=>{const O=L.id;return this._breakpoints.has(O)?!1:(this._breakpoints.set(O,L),!0)});this.fireBreakpointChanges(b,[],[]);const S=[],o=new Map;for(const L of b)if(L instanceof C.SourceBreakpoint){let O=o.get(L.location.uri.toString());O||(O={type:"sourceMulti",uri:L.location.uri,lines:[]},o.set(L.location.uri.toString(),O),S.push(O)),O.lines.push({id:L.id,enabled:L.enabled,condition:L.condition,hitCondition:L.hitCondition,logMessage:L.logMessage,line:L.location.range.start.line,character:L.location.range.start.character})}else L instanceof C.FunctionBreakpoint&&S.push({type:"function",id:L.id,enabled:L.enabled,hitCondition:L.hitCondition,logMessage:L.logMessage,condition:L.condition,functionName:L.functionName});return this._debugServiceProxy.$registerBreakpoints(S)}removeBreakpoints(d){this.startBreakpoints();const b=d.filter(O=>this._breakpoints.delete(O.id));this.fireBreakpointChanges([],b,[]);const S=b.filter(O=>O instanceof C.SourceBreakpoint).map(O=>O.id),o=b.filter(O=>O instanceof C.FunctionBreakpoint).map(O=>O.id),L=b.filter(O=>O instanceof C.DataBreakpoint).map(O=>O.id);return this._debugServiceProxy.$unregisterBreakpoints(S,o,L)}startDebugging(d,b,S){return this._debugServiceProxy.$startDebugging(d?d.uri:void 0,b,{parentSessionID:S.parentSession?S.parentSession.id:void 0,repl:S.consoleMode===C.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:S.noDebug,compact:S.compact})}stopDebugging(d){return this._debugServiceProxy.$stopDebugging(d?d.id:void 0)}registerDebugConfigurationProvider(d,b,S){if(!b)return new C.Disposable(()=>{});const o=this._configProviderHandleCounter++;return this._configProviders.push({type:d,handle:o,provider:b}),this._debugServiceProxy.$registerDebugConfigurationProvider(d,S,!!b.provideDebugConfigurations,!!b.resolveDebugConfiguration,!!b.resolveDebugConfigurationWithSubstitutedVariables,o),new C.Disposable(()=>{this._configProviders=this._configProviders.filter(L=>L.provider!==b),this._debugServiceProxy.$unregisterDebugConfigurationProvider(o)})}registerDebugAdapterDescriptorFactory(d,b,S){if(!S)return new C.Disposable(()=>{});if(!this.definesDebugType(d,b))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${b}' debugger.`);if(this.getAdapterDescriptorFactoryByType(b))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const o=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:b,handle:o,factory:S}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(b,o),new C.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(L=>L.factory!==S),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(o)})}registerDebugAdapterTrackerFactory(d,b){if(!b)return new C.Disposable(()=>{});const S=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:d,handle:S,factory:b}),new C.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(o=>o.factory!==b)})}async $runInTerminal(d,b){return Promise.resolve(void 0)}async $substituteVariables(d,b){if(!this._variableResolver){const[L,O]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(L||[],this._editorsService,O)}let S;const o=await this.getFolder(d);return o&&(S={uri:o.uri,name:o.name,index:o.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(S,b)}createDebugAdapter(d,b){if(d.type==="implementation")return new n(d.implementation)}createSignService(){}async $startDASession(d,b){const S=this,o=await this.getSession(b);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(o.type),o).then(L=>{if(!L)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${o.type}' (extension might have failed to activate)`);const O=this.convertToDto(L),W=this.createDebugAdapter(O,o);if(!W)throw new Error(`Couldn't create a debug adapter for type '${o.type}'.`);const J=W;return this._debugAdapters.set(d,J),this.getDebugAdapterTrackers(o).then(oe=>(oe&&this._debugAdaptersTrackers.set(d,oe),J.onMessage(async q=>{if(q.type==="request"&&q.command==="handshake"){const x=q,V={type:"response",seq:0,command:x.command,request_seq:x.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const T=await this._signService.sign(x.arguments.value);V.body={signature:T},J.sendResponse(V)}else throw new Error("no signer")}catch(T){V.success=!1,V.message=T.message,J.sendResponse(V)}}else oe&&oe.onDidSendMessage&&oe.onDidSendMessage(q),q=c.convertToVSCPaths(q,!0),S._debugServiceProxy.$acceptDAMessage(d,q)}),J.onError(q=>{oe&&oe.onError&&oe.onError(q),this._debugServiceProxy.$acceptDAError(d,q.name,q.message,q.stack)}),J.onExit(q=>{oe&&oe.onExit&&oe.onExit(w.withNullAsUndefined(q),void 0),this._debugServiceProxy.$acceptDAExit(d,w.withNullAsUndefined(q),void 0)}),oe&&oe.onWillStartSession&&oe.onWillStartSession(),J.startSession()))})}$sendDAMessage(d,b){b=c.convertToDAPaths(b,!1);const S=this._debugAdaptersTrackers.get(d);S&&S.onWillReceiveMessage&&S.onWillReceiveMessage(b);const o=this._debugAdapters.get(d);o&&o.sendMessage(b)}$stopDASession(d){const b=this._debugAdaptersTrackers.get(d);this._debugAdaptersTrackers.delete(d),b&&b.onWillStopSession&&b.onWillStopSession();const S=this._debugAdapters.get(d);return this._debugAdapters.delete(d),S?S.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(d){const b=[],S=[],o=[];if(d.added)for(const L of d.added){const O=L.id;if(O&&!this._breakpoints.has(O)){let W;if(L.type==="function")W=new C.FunctionBreakpoint(L.functionName,L.enabled,L.condition,L.hitCondition,L.logMessage);else if(L.type==="data")W=new C.DataBreakpoint(L.label,L.dataId,L.canPersist,L.enabled,L.hitCondition,L.condition,L.logMessage);else{const J=R.URI.revive(L.uri);W=new C.SourceBreakpoint(new C.Location(J,new C.Position(L.line,L.character)),L.enabled,L.condition,L.hitCondition,L.logMessage)}W._id=O,this._breakpoints.set(O,W),b.push(W)}}if(d.removed)for(const L of d.removed){const O=this._breakpoints.get(L);O&&(this._breakpoints.delete(L),S.push(O))}if(d.changed){for(const L of d.changed)if(L.id){const O=this._breakpoints.get(L.id);if(O){if(O instanceof C.FunctionBreakpoint&&L.type==="function"){const W=O;W.enabled=L.enabled,W.condition=L.condition,W.hitCondition=L.hitCondition,W.logMessage=L.logMessage,W.functionName=L.functionName}else if(O instanceof C.SourceBreakpoint&&L.type==="source"){const W=O;W.enabled=L.enabled,W.condition=L.condition,W.hitCondition=L.hitCondition,W.logMessage=L.logMessage,W.location=new C.Location(R.URI.revive(L.uri),new C.Position(L.line,L.character))}o.push(O)}}}this.fireBreakpointChanges(b,S,o)}$provideDebugConfigurations(d,b,S){return y.asPromise(async()=>{const o=this.getConfigProviderByHandle(d);if(!o)throw new Error("no DebugConfigurationProvider found");if(!o.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const L=await this.getFolder(b);return o.provideDebugConfigurations(L,S)}).then(o=>{if(!o)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return o})}$resolveDebugConfiguration(d,b,S,o){return y.asPromise(async()=>{const L=this.getConfigProviderByHandle(d);if(!L)throw new Error("no DebugConfigurationProvider found");if(!L.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const O=await this.getFolder(b);return L.resolveDebugConfiguration(O,S,o)})}$resolveDebugConfigurationWithSubstitutedVariables(d,b,S,o){return y.asPromise(async()=>{const L=this.getConfigProviderByHandle(d);if(!L)throw new Error("no DebugConfigurationProvider found");if(!L.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const O=await this.getFolder(b);return L.resolveDebugConfigurationWithSubstitutedVariables(O,S,o)})}async $provideDebugAdapter(d,b){const S=this.getAdapterDescriptorFactoryByHandle(d);if(!S)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const o=await this.getSession(b);return this.getAdapterDescriptor(S,o).then(L=>{if(!L)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${o.type}'`);return this.convertToDto(L)})}async $acceptDebugSessionStarted(d){const b=await this.getSession(d);this._onDidStartDebugSession.fire(b)}async $acceptDebugSessionTerminated(d){const b=await this.getSession(d);b&&(this._onDidTerminateDebugSession.fire(b),this._debugSessions.delete(b.id))}async $acceptDebugSessionActiveChanged(d){this._activeDebugSession=d?await this.getSession(d):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(d,b){const S=await this.getSession(d);S&&S._acceptNameChanged(b)}async $acceptDebugSessionCustomEvent(d,b){const o={session:await this.getSession(d),event:b.event,body:b.body};this._onDidReceiveDebugSessionCustomEvent.fire(o)}convertToDto(d){if(d instanceof C.DebugAdapterExecutable)return{type:"executable",command:d.command,args:d.args,options:d.options};if(d instanceof C.DebugAdapterServer)return{type:"server",port:d.port,host:d.host};if(d instanceof C.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:d.path};if(d instanceof C.DebugAdapterInlineImplementation)return{type:"implementation",implementation:d.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(d){const b=this._adapterFactories.filter(S=>S.type===d);if(b.length>0)return b[0].factory}getAdapterDescriptorFactoryByHandle(d){const b=this._adapterFactories.filter(S=>S.handle===d);if(b.length>0)return b[0].factory}getConfigProviderByHandle(d){const b=this._configProviders.filter(S=>S.handle===d);if(b.length>0)return b[0].provider}definesDebugType(d,b){if(d.contributes){const S=d.contributes.debuggers;if(S&&S.length>0){for(const o of S)if(o.label&&o.type&&o.type===b)return!0}}return!1}getDebugAdapterTrackers(d){const S=d.configuration.type,o=this._trackerFactories.filter(L=>L.type===S||L.type==="*").map(L=>y.asPromise(()=>L.factory.createDebugAdapterTracker(d)).then(O=>O,O=>null));return Promise.race([Promise.all(o).then(L=>{const O=L.filter(W=>!!W);if(O.length>0)return new i(O)}),new Promise((L,O)=>{const W=setTimeout(()=>{clearTimeout(W),O(new Error("timeout"))},1e3)})]).catch(L=>{})}async getAdapterDescriptor(d,b){const S=b.configuration.debugServer;if(typeof S=="number")return Promise.resolve(new C.DebugAdapterServer(S));if(d){const L=await this._extensionService.getExtensionRegistry();return y.asPromise(()=>d.createDebugAdapterDescriptor(b,this.daExecutableFromPackage(b,L))).then(O=>{if(O)return O})}const o=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(b,o))}daExecutableFromPackage(d,b){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(d,b,S){(d.length>0||b.length>0||S.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:d,removed:b,changed:S}))}async getSession(d){if(d)if(typeof d=="string"){const b=this._debugSessions.get(d);if(b)return b}else{let b=this._debugSessions.get(d.id);if(!b){const S=await this.getFolder(d.folderUri),o=d.parent?this._debugSessions.get(d.parent):void 0;b=new m(this._debugServiceProxy,d.id,d.type,d.name,S,d.configuration,o),this._debugSessions.set(b.id,b),this._debugServiceProxy.$sessionCached(b.id)}return b}throw new Error("cannot find session")}getFolder(d){if(d){const b=R.URI.revive(d);return this._workspaceService.resolveWorkspaceFolder(b)}return Promise.resolve(void 0)}};h=Ve([We(0,f.IExtHostRpcService),We(1,P.IExtHostWorkspace),We(2,s.IExtHostExtensionService),We(3,I.IExtHostDocumentsAndEditors),We(4,g.IExtHostConfiguration),We(5,u.IExtHostEditorTabs)],h),e.ExtHostDebugServiceBase=h;class m{constructor(d,b,S,o,L,O,W){this._debugServiceProxy=d,this._id=b,this._type=S,this._name=o,this._workspaceFolder=L,this._configuration=O,this._parentSession=W}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(d){this._name=d,this._debugServiceProxy.$setDebugSessionName(this._id,d)}get parentSession(){return this._parentSession}_acceptNameChanged(d){this._name=d}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(d,b){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,d,b)}getDebugProtocolBreakpoint(d){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,d.id)}}e.ExtHostDebugSession=m;class t{constructor(d){this.value=Object.freeze({append(b){d.$appendDebugConsole(b)},appendLine(b){this.append(b+`
`)}})}}e.ExtHostDebugConsole=t;class r extends l.AbstractVariableResolverService{constructor(d,b,S,o,L){function O(){if(b){const W=b.activeEditor();if(W)return W.document.uri;const J=o.tabs.filter(oe=>oe.isActive);if(J.length>0)return J[0].resource}}super({getFolderUri:W=>{const J=d.filter(oe=>oe.name===W);if(J&&J.length>0)return J[0].uri},getWorkspaceFolderCount:()=>d.length,getConfigurationValue:(W,J)=>S.getConfiguration(void 0,W).get(J),getAppRoot:()=>E.cwd(),getExecPath:()=>E.env.VSCODE_EXEC_PATH,getFilePath:()=>{const W=O();if(W)return v.normalize(W.fsPath)},getWorkspaceFolderPathForFile:()=>{if(L){const W=O();if(W){const J=L.getWorkspaceFolder(W);if(J)return v.normalize(J.uri.fsPath)}}},getSelectedText:()=>{if(b){const W=b.activeEditor();if(W&&!W.selection.isEmpty)return W.document.getText(W.selection)}},getLineNumber:()=>{if(b){const W=b.activeEditor();if(W)return String(W.selection.end.line+1)}}},void 0,Promise.resolve(E.env))}}e.ExtHostVariableResolverService=r;class i{constructor(d){this.trackers=d}onWillStartSession(){this.trackers.forEach(d=>d.onWillStartSession?d.onWillStartSession():void 0)}onWillReceiveMessage(d){this.trackers.forEach(b=>b.onWillReceiveMessage?b.onWillReceiveMessage(d):void 0)}onDidSendMessage(d){this.trackers.forEach(b=>b.onDidSendMessage?b.onDidSendMessage(d):void 0)}onWillStopSession(){this.trackers.forEach(d=>d.onWillStopSession?d.onWillStopSession():void 0)}onError(d){this.trackers.forEach(b=>b.onError?b.onError(d):void 0)}onExit(d,b){this.trackers.forEach(S=>S.onExit?S.onExit(d,b):void 0)}}class n extends D.AbstractDebugAdapter{constructor(d){super();this.implementation=d,d.onDidSendMessage(b=>{this.acceptMessage(b)})}startSession(){return Promise.resolve(void 0)}sendMessage(d){this.implementation.handleMessage(d)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let a=class extends h{constructor(d,b,S,o,L,O){super(d,b,S,o,L,O)}createVariableResolver(d,b,S){return new r(d,b,S,this._editorTabs)}};a=Ve([We(0,f.IExtHostRpcService),We(1,P.IExtHostWorkspace),We(2,s.IExtHostExtensionService),We(3,I.IExtHostDocumentsAndEditors),We(4,g.IExtHostConfiguration),We(5,u.IExtHostEditorTabs)],a),e.WorkerExtHostDebugService=a}),define(ge[251],pe([0,1,66,2,5,36,35,26,12,27,4,40,37,15]),function(X,e,v,R,k,y,A,C,D,P,s,I,l,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let c=class{constructor(u,h,m,t,r,i,n){this._apiFactory=u,this._extensionRegistry=h,this._instaService=m,this._extHostConfiguration=t,this._extHostExtensionService=r,this._initData=i,this._logService=n,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),v.mark("code/extHost/willWaitForConfig");const u=await this._extHostConfiguration.getConfigProvider();v.mark("code/extHost/didWaitForConfig");const h=await this._extHostExtensionService.getExtensionPathIndex();this.register(new f(this._apiFactory,h,this._extensionRegistry,u,this._logService)),this.register(this._instaService.createInstance(_)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(w,h,this._initData.environment.appUriScheme))}register(u){if(Array.isArray(u.nodeModuleName))for(let h of u.nodeModuleName)this._factories.set(h,u);else this._factories.set(u.nodeModuleName,u);typeof u.alternativeModuleName=="function"&&this._alternatives.push(h=>u.alternativeModuleName(h))}};c=Ve([We(2,s.IInstantiationService),We(3,y.IExtHostConfiguration),We(4,I.IExtHostExtensionService),We(5,P.IExtHostInitDataService),We(6,g.ILogService)],c),e.RequireInterceptor=c;class f{constructor(u,h,m,t,r){this._apiFactory=u,this._extensionPaths=h,this._extensionRegistry=m,this._configProvider=t,this._logService=r,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(u,h){const m=this._extensionPaths.findSubstr(h.fsPath);if(m){let t=this._extApiImpl.get(C.ExtensionIdentifier.toKey(m.identifier));return t||(t=this._apiFactory(m,this._extensionRegistry,this._configProvider),this._extApiImpl.set(C.ExtensionIdentifier.toKey(m.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((r,i)=>t+=`	${i} -> ${r.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${h.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(A.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let _=class{constructor(u,h){this.nodeModuleName="keytar";const{environment:m}=h,t=u.getProxy(k.MainContext.MainThreadKeytar);if(m.appRoot){let r=m.appRoot.fsPath;l.platform==="win32"&&(r=r.replace(/\\/g,"/")),r[r.length-1]==="/"&&(r=r.substr(0,r.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${r}/node_modules.asar/keytar`),this.alternativeNames.add(`${r}/node_modules/keytar`)}this._impl={getPassword:(r,i)=>t.$getPassword(r,i),setPassword:(r,i,n)=>t.$setPassword(r,i,n),deletePassword:(r,i)=>t.$deletePassword(r,i),findPassword:r=>t.$findPassword(r),findCredentials(r){return t.$findCredentials(r)}}}load(u,h){return this._impl}alternativeModuleName(u){const h=u.length;if(h<=7||!this.alternativeNames)return;const m=h-7;if((u.charAt(m)==="/"||u.charAt(m)==="\\")&&u.endsWith("keytar")&&(u=u.replace(/\\/g,"/"),this.alternativeNames.has(u)))return"keytar"}};_=Ve([We(0,D.IExtHostRpcService),We(1,P.IExtHostInitDataService)],_);let w=class{constructor(u,h,m){this._extensionPaths=u,this._appUriScheme=h,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=m.getProxy(k.MainContext.MainThreadTelemetry);const t=m.getProxy(k.MainContext.MainThreadWindow);this._impl=(r,i)=>{const n=R.URI.parse(r);return i?this.callOriginal(r,i):n.scheme==="http"||n.scheme==="https"?t.$openUri(n,r,{allowTunneling:!0}):n.scheme==="mailto"||n.scheme===this._appUriScheme?t.$openUri(n,r,{}):this.callOriginal(r,i)}}load(u,h,m){const t=this._extensionPaths.findSubstr(h.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=m(u),this._impl}callOriginal(u,h){return this.sendNoForwardTelemetry(),this._original(u,h)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};w=Ve([We(2,D.IExtHostRpcService)],w)}),define(ge[252],pe([0,1,165,11,7,196,34,40,39,36,33,12,48,186,14,197,45]),function(X,e,v,R,k,y,A,C,D,P,s,I,l,g,c,f,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let w=class extends l.ExtHostDebugServiceBase{constructor(h,m,t,r,i,n,a){super(h,m,t,r,i,a);this._terminalService=n,this._integratedTerminalInstances=new E}createDebugAdapter(h,m){switch(h.type){case"server":return new y.SocketDebugAdapter(h);case"pipeServer":return new y.NamedPipeDebugAdapter(h);case"executable":return new y.ExecutableDebugAdapter(h,m.type)}return super.createDebugAdapter(h,m)}daExecutableFromPackage(h,m){const t=y.ExecutableDebugAdapter.platformAdapterExecutable(m.getAllExtensionDescriptions(),h.type);if(t)return new k.DebugAdapterExecutable(t.command,t.args,t.options)}createSignService(){return new g.SignService}async $runInTerminal(h,m){if(h.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(L=>{this._integratedTerminalInstances.onTerminalClosed(L)}));const t=await this._configurationService.getConfigProvider(),r=this._terminalService.getDefaultShell(!0),i=this._terminalService.getDefaultShellArgs(!0),n=JSON.stringify({shell:r,shellArgs:i});let a=await this._integratedTerminalInstances.checkout(n),p,d=!1;if(a)p=h.cwd;else{const L={shellPath:r,shellArgs:i,cwd:h.cwd,name:h.title||v.localize(0,null)};d=!0,a=this._terminalService.createTerminalFromOptions(L,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(a,n)}a.show(!0);const b=await a.processId;d?await new Promise(L=>setTimeout(L,1e3)):t.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(r.indexOf("powershell")>=0||r.indexOf("pwsh")>=0||r.indexOf("cmd.exe")>=0?a.sendText("cls"):r.indexOf("bash")>=0?a.sendText("clear"):R.isWindows?a.sendText("cls"):a.sendText("clear"));const S=f.prepareCommand(r,h.args,p,h.env);a.sendText(S);const o=this.onDidTerminateDebugSession(L=>{L.id===m&&(this._integratedTerminalInstances.free(a),o.dispose())});return b}else if(h.kind==="external")return f.runInExternalTerminal(h,await this._configurationService.getConfigProvider());return super.$runInTerminal(h,m)}createVariableResolver(h,m,t){return new l.ExtHostVariableResolverService(h,m,t,this._editorTabs,this._workspaceService)}};w=Ve([We(0,I.IExtHostRpcService),We(1,A.IExtHostWorkspace),We(2,C.IExtHostExtensionService),We(3,D.IExtHostDocumentsAndEditors),We(4,P.IExtHostConfiguration),We(5,s.IExtHostTerminalService),We(6,_.IExtHostEditorTabs)],w),e.ExtHostDebugService=w;class E{constructor(){this._terminalInstances=new Map}async checkout(h){const t=[...this._terminalInstances.entries()].map(([r,i])=>c.createCancelablePromise(async n=>{if(i.lastUsedAt!==-1&&await f.hasChildProcesses(await r.processId))return null;const a=Date.now();return i.lastUsedAt+E.minUseDelay>a||n.isCancellationRequested||i.config!==h?null:(i.lastUsedAt=a,r)}));return await c.firstParallel(t,r=>!!r)}insert(h,m){this._terminalInstances.set(h,{lastUsedAt:Date.now(),config:m})}free(h){const m=this._terminalInstances.get(h);m&&(m.lastUsedAt=-1)}onTerminalClosed(h){this._terminalInstances.delete(h)}}E.minUseDelay=1e3}),define(ge[253],pe([0,1,9,2,109,34,48,39,36,33,12,27,65,10,15,61,45]),function(X,e,v,R,k,y,A,C,D,P,s,I,l,g,c,f,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let w=class extends l.ExtHostTaskBase{constructor(u,h,m,t,r,i,n,a,p){super(u,h,m,t,r,i,n,a);this.workspaceService=m,this.editorTabs=p,h.remote.isRemote&&h.remote.authority?this.registerTaskSystem(g.Schemas.vscodeRemote,{scheme:g.Schemas.vscodeRemote,authority:h.remote.authority,platform:process.platform}):this.registerTaskSystem(g.Schemas.file,{scheme:g.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(u,h){const m=h;if(!h.execution&&m._id===void 0)throw new Error("Tasks to execute must include an execution");if(m._id!==void 0){const t=l.TaskHandleDTO.from(m,this.workspaceService),r=await this._proxy.$getTaskExecution(t);if(r.task===void 0)throw new Error("Task from execution DTO is undefined");const i=await this.getTaskExecution(r,h);return this._proxy.$executeTask(t).catch(()=>{}),i}else{const t=l.TaskDTO.from(h,u);if(t===void 0)return Promise.reject(new Error("Task is not valid"));l.CustomExecutionDTO.is(t.execution)&&await this.addCustomExecution(t,h,!1);const r=await this.getTaskExecution(await this._proxy.$getTaskExecution(t),h);return this._proxy.$executeTask(t).catch(()=>{}),r}}provideTasksInternal(u,h,m,t){const r=[];if(t)for(let i of t){this.checkDeprecation(i,m),(!i.definition||!u[i.definition.type])&&this._logService.warn(`The task [${i.source}, ${i.name}] uses an undefined task type. The task will be ignored in the future.`);const n=l.TaskDTO.from(i,m.extension);n&&(r.push(n),l.CustomExecutionDTO.is(n.execution)&&h.push(this.addCustomExecution(n,i,!0)))}return{tasks:r,extension:m.extension}}async resolveTaskInternal(u){return u}async getVariableResolver(u){if(this._variableResolver===void 0){const h=await this._configurationService.getConfigProvider();this._variableResolver=new A.ExtHostVariableResolverService(u,this._editorService,h,this.editorTabs,this.workspaceService)}return this._variableResolver}async $resolveVariables(u,h){const m=R.URI.revive(u),t={process:void 0,variables:Object.create(null)},r=await this._workspaceProvider.resolveWorkspaceFolder(m),i=await this._workspaceProvider.getWorkspaceFolders2();if(!i||!r)throw new Error("Unexpected: Tasks can only be run in a workspace folder");const n=await this.getVariableResolver(i),a={uri:r.uri,name:r.name,index:r.index,toResource:()=>{throw new Error("Not implemented")}};for(let p of h.variables)t.variables[p]=await n.resolveAsync(a,p);if(h.process!==void 0){let p;if(h.process.path!==void 0){p=h.process.path.split(v.delimiter);for(let d=0;d<p.length;d++)p[d]=await n.resolveAsync(a,p[d])}t.process=await k.win32.findExecutable(await n.resolveAsync(a,h.process.name),h.process.cwd!==void 0?await n.resolveAsync(a,h.process.cwd):void 0,p)}return t}async $jsonTasksSupported(){return!0}async $findExecutable(u,h,m){return k.win32.findExecutable(u,h,m)}};w=Ve([We(0,s.IExtHostRpcService),We(1,I.IExtHostInitDataService),We(2,y.IExtHostWorkspace),We(3,C.IExtHostDocumentsAndEditors),We(4,D.IExtHostConfiguration),We(5,P.IExtHostTerminalService),We(6,c.ILogService),We(7,f.IExtHostApiDeprecationService),We(8,_.IExtHostEditorTabs)],w),e.ExtHostTask=w}),define(ge[254],pe([0,1,14,16,66,6,2,5,245,15,78,80,27,179,12,59,40,33]),function(X,e,v,R,k,y,A,C,D,P,s,I,l,g,c,f,_,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class E{constructor(h,m,t,r){this._disposables=new y.DisposableStore,this._isTerminating=!1,this._hostUtils=t,this._rpcProtocol=new D.RPCProtocol(h,null,r),m=E._transform(m,this._rpcProtocol);const i=new I.ServiceCollection(...s.getSingletonServiceDescriptors());i.set(l.IExtHostInitDataService,Object.assign({_serviceBrand:void 0},m)),i.set(c.IExtHostRpcService,new c.ExtHostRpcService(this._rpcProtocol)),i.set(f.IURITransformerService,new f.URITransformerService(r)),i.set(_.IHostUtils,t);const n=new g.InstantiationService(i,!0),a=n.invokeFunction(S=>S.get(w.IExtHostTerminalService));this._disposables.add(a),this._logService=n.invokeFunction(S=>S.get(P.ILogService)),k.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",m),this._extensionService=n.invokeFunction(S=>S.get(_.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const p=new WeakMap;this._extensionService.getExtensionPathIndex().then(S=>{Error.prepareStackTrace=(o,L)=>{let O="",W,J;for(const oe of L)O+=`
	at ${oe.toString()}`,J=oe.getFileName(),!W&&J&&(W=S.findSubstr(J));return p.set(o,W),`${o.name||"Error"}: ${o.message||""}${O}`}});const d=this._rpcProtocol.getProxy(C.MainContext.MainThreadExtensionService),b=this._rpcProtocol.getProxy(C.MainContext.MainThreadErrors);R.setUnexpectedErrorHandler(S=>{const o=R.transformErrorForSerialization(S),L=p.get(S);L?d.$onExtensionRuntimeError(L.identifier,o):b.$onUnexpectedError(o)})}terminate(h){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${h}`),this._logService.flush(),this._disposables.dispose(),R.setUnexpectedErrorHandler(t=>{this._logService.error(t)}),this._rpcProtocol.dispose();const m=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([v.timeout(4e3),m]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}static _transform(h,m){h.extensions.forEach(r=>r.extensionLocation=A.URI.revive(m.transformIncomingURIs(r.extensionLocation))),h.environment.appRoot=A.URI.revive(m.transformIncomingURIs(h.environment.appRoot));const t=h.environment.extensionDevelopmentLocationURI;return t&&(h.environment.extensionDevelopmentLocationURI=t.map(r=>A.URI.revive(m.transformIncomingURIs(r)))),h.environment.extensionTestsLocationURI=A.URI.revive(m.transformIncomingURIs(h.environment.extensionTestsLocationURI)),h.environment.globalStorageHome=A.URI.revive(m.transformIncomingURIs(h.environment.globalStorageHome)),h.environment.workspaceStorageHome=A.URI.revive(m.transformIncomingURIs(h.environment.workspaceStorageHome)),h.logsLocation=A.URI.revive(m.transformIncomingURIs(h.logsLocation)),h.logFile=A.URI.revive(m.transformIncomingURIs(h.logFile)),h.workspace=m.transformIncomingURIs(h.workspace),h}}e.ExtensionHostMain=E}),define(ge[255],pe([0,1,9,21,55,30,24,43,31]),function(X,e,v,R,k,y,A,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class P{constructor(l,g,c){this.config=l,this.provider=g,this.sessionToken=c,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=l.filePattern,this.includePattern=l.includePattern&&y.parse(l.includePattern),this.maxResults=l.maxResults||void 0,this.exists=l.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=l.excludePattern&&y.parse(l.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(l=>l.cancel()),this.activeCancellationTokens=new Set}search(l){const g=this.config.folderQueries||[];return new Promise((c,f)=>{const _=w=>{this.resultCount++,l(w)};if(this.isCanceled)return c({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(w=>{const E=w.toString(),u=v.basename(E);this.globalExcludePattern&&this.globalExcludePattern(E,u)||this.matchFile(_,{base:w,basename:u})}),Promise.all(g.map(w=>this.searchInFolder(w,_))).then(w=>{c({limitHit:this.isLimitHit,stats:w[0]||void 0})},w=>{f(new Error(k.toErrorMessage(w)))})})}async searchInFolder(l,g){const c=new R.CancellationTokenSource,f=this.getSearchOptionsForFolder(l),_=this.initDirectoryTree(),w=new D.QueryGlobTester(this.config,l),E=!w.hasSiblingExcludeClauses();let u;try{this.activeCancellationTokens.add(c),u=C.StopWatch.create();const h=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},f,c.token),m=u.elapsed(),t=C.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(h&&h.forEach(r=>{const i=v.posix.relative(l.folder.path,r.path);if(E){const n=v.basename(r.path);this.matchFile(g,{base:l.folder,relativePath:i,basename:n});return}this.addDirectoryEntries(_,l.folder,i,g)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(_,w,g),{providerTime:m,postProcessTime:t.elapsed()})}finally{c.dispose(),this.activeCancellationTokens.delete(c)}}getSearchOptionsForFolder(l){const g=D.resolvePatternsForProvider(this.config.includePattern,l.includePattern),c=D.resolvePatternsForProvider(this.config.excludePattern,l.excludePattern);return{folder:l.folder,excludes:c,includes:g,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,followSymlinks:!l.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}addDirectoryEntries({pathToEntries:l},g,c,f){if(c===this.filePattern){const w=v.basename(this.filePattern);this.matchFile(f,{base:g,relativePath:this.filePattern,basename:w})}function _(w){const E=v.basename(w),u=v.dirname(w);let h=l[u];h||(h=l[u]=[],_(u)),h.push({base:g,relativePath:w,basename:E})}_(c)}matchDirectoryTree({rootEntries:l,pathToEntries:g},c,f){const _=this,w=this.filePattern;function E(u){const h=y.hasSiblingFn(()=>u.map(m=>m.basename));for(let m=0,t=u.length;m<t;m++){const r=u[m],{relativePath:i,basename:n}=r;if(!c.includedInQuerySync(i,n,w!==n?h:void 0))continue;const a=g[i];if(a)E(a);else{if(i===w)continue;_.matchFile(f,r)}if(_.isLimitHit)break}}E(l)}matchFile(l,g){(!this.includePattern||g.relativePath&&this.includePattern(g.relativePath,g.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||l(g))}}class s{constructor(){this.sessions=new Map}fileSearch(l,g,c,f){const _=this.getSessionTokenSource(l.cacheKey),w=new P(l,g,_&&_.token);let E=0;const u=h=>{E+=h.length,c(h.map(m=>this.rawMatchToSearchItem(m)))};return this.doSearch(w,s.BATCH_SIZE,u,f).then(h=>({limitHit:h.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:E,detailStats:h.stats}}))}clearCache(l){const g=this.getSessionTokenSource(l);g&&g.cancel()}getSessionTokenSource(l){if(!!l)return this.sessions.has(l)||this.sessions.set(l,new R.CancellationTokenSource),this.sessions.get(l)}rawMatchToSearchItem(l){return l.relativePath?{resource:A.joinPath(l.base,l.relativePath)}:{resource:l.base}}doSearch(l,g,c,f){f.onCancellationRequested(()=>{l.cancel()});const _=E=>{E&&(w.push(E),g>0&&w.length>=g&&(c(w),w=[]))};let w=[];return l.search(_).then(E=>(w.length&&c(w),E),E=>(w.length&&c(w),Promise.reject(E)))}}e.FileSearchManager=s,s.BATCH_SIZE=512}),define(ge[127],pe([0,1,9,17,21,55,24,30,2,31,10,13]),function(X,e,v,R,k,y,A,C,D,P,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class l{constructor(u,h,m){this.query=u,this.provider=h,this.fileUtils=m,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(u,h){const m=this.query.folderQueries||[],t=new k.CancellationTokenSource;return h.onCancellationRequested(()=>t.cancel()),new Promise((r,i)=>{this.collector=new c(u);let n=!1;const a=(p,d)=>{if(!n&&!this.isLimitHit){const b=this.resultSize(p);_(p)&&typeof this.query.maxResults=="number"&&this.resultCount+b>this.query.maxResults&&(this.isLimitHit=!0,n=!0,t.cancel(),p=this.trimResultToSize(p,this.query.maxResults-this.resultCount));const S=this.resultSize(p);this.resultCount+=S,(S>0||!_(p))&&this.collector.add(p,d)}};Promise.all(m.map((p,d)=>this.searchInFolder(p,b=>a(b,d),t.token))).then(p=>{t.dispose(),this.collector.flush();const d=p.some(b=>!!b&&!!b.limitHit);r({limitHit:this.isLimitHit||d,messages:R.flatten(p.map(b=>(b==null?void 0:b.message)?I.isArray(b.message)?b.message:[b.message]:[])),stats:{type:"textSearchProvider"}})},p=>{t.dispose();const d=y.toErrorMessage(p);i(new Error(d))})})}resultSize(u){return _(u)?Array.isArray(u.ranges)?u.ranges.length:1:0}trimResultToSize(u,h){const m=Array.isArray(u.ranges)?u.ranges:[u.ranges],t=Array.isArray(u.preview.matches)?u.preview.matches:[u.preview.matches];return{ranges:m.slice(0,h),preview:{matches:t.slice(0,h),text:u.preview.text},uri:u.uri}}async searchInFolder(u,h,m){const t=new P.QueryGlobTester(this.query,u),r=[],i={report:p=>{if(!this.validateProviderResult(p))return;const d=u.folder.scheme===s.Schemas.file?C.hasSiblingPromiseFn(()=>this.fileUtils.readdir(A.dirname(p.uri))):void 0,b=A.relativePath(u.folder,p.uri);b&&r.push(t.includedInQuery(b,v.basename(b),d).then(S=>{S&&h(p)}))}},n=this.getSearchOptionsForFolder(u),a=await this.provider.provideTextSearchResults(g(this.query.contentPattern),n,i,m);return await Promise.all(r),a}validateProviderResult(u){if(_(u)){if(Array.isArray(u.ranges)){if(!Array.isArray(u.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(u.preview.matches.length!==u.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(u.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(u){const h=P.resolvePatternsForProvider(this.query.includePattern,u.includePattern),m=P.resolvePatternsForProvider(this.query.excludePattern,u.excludePattern),t={folder:D.URI.from(u.folder),excludes:m,includes:h,useIgnoreFiles:!u.disregardIgnoreFiles,useGlobalIgnoreFiles:!u.disregardGlobalIgnoreFiles,followSymlinks:!u.ignoreSymlinks,encoding:u.fileEncoding&&this.fileUtils.toCanonicalName(u.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return t.usePCRE2=this.query.usePCRE2,t}}e.TextSearchManager=l;function g(E){return{isCaseSensitive:E.isCaseSensitive||!1,isRegExp:E.isRegExp||!1,isWordMatch:E.isWordMatch||!1,isMultiline:E.isMultiline||!1,pattern:E.pattern}}class c{constructor(u){this._onResult=u,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new w(512,h=>this.sendItems(h))}add(u,h){this._currentFileMatch&&(this._currentFolderIdx!==h||!A.isEqual(this._currentUri,u.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=h,this._currentFileMatch={resource:u.uri,results:[]}),this._currentFileMatch.results.push(f(u))}pushToCollector(){const u=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,u)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(u){this._onResult(u)}}e.TextSearchResultsCollector=c;function f(E){return _(E)?{preview:{matches:R.mapArrayOrNot(E.preview.matches,u=>({startLineNumber:u.start.line,startColumn:u.start.character,endLineNumber:u.end.line,endColumn:u.end.character})),text:E.preview.text},ranges:R.mapArrayOrNot(E.ranges,u=>({startLineNumber:u.start.line,startColumn:u.start.character,endLineNumber:u.end.line,endColumn:u.end.character}))}:{text:E.text,lineNumber:E.lineNumber}}function _(E){return!!E.preview}e.extensionResultIsMatch=_;class w{constructor(u,h){this.maxBatchSize=u,this.cb=h,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(u,h){!u||this.addItemToBatch(u,h)}addItems(u,h){!u||this.addItemsToBatch(u,h)}addItemToBatch(u,h){this.batch.push(u),this.batchSize+=h,this.onUpdate()}addItemsToBatch(u,h){this.batch=this.batch.concat(u),this.batchSize+=h,this.onUpdate()}onUpdate(){this.totalNumberCompleted<w.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},w.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=w,w.TIMEOUT=4e3,w.START_BATCH_AFTER_COUNT=50}),define(ge[67],pe([0,1,6,5,4,255,12,59,15,2,127]),function(X,e,v,R,k,y,A,C,D,P,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=k.createDecorator("IExtHostSearch");let I=class{constructor(f,_,w){this.extHostRpc=f,this._uriTransformer=_,this._logService=w,this._proxy=this.extHostRpc.getProxy(R.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new y.FileSearchManager}_transformScheme(f){return this._uriTransformer.transformOutgoingScheme(f)}registerTextSearchProvider(f,_){if(this._textSearchUsedSchemes.has(f))throw new Error(`a text search provider for the scheme '${f}' is already registered`);this._textSearchUsedSchemes.add(f);const w=this._handlePool++;return this._textSearchProvider.set(w,_),this._proxy.$registerTextSearchProvider(w,this._transformScheme(f)),v.toDisposable(()=>{this._textSearchUsedSchemes.delete(f),this._textSearchProvider.delete(w),this._proxy.$unregisterProvider(w)})}registerFileSearchProvider(f,_){if(this._fileSearchUsedSchemes.has(f))throw new Error(`a file search provider for the scheme '${f}' is already registered`);this._fileSearchUsedSchemes.add(f);const w=this._handlePool++;return this._fileSearchProvider.set(w,_),this._proxy.$registerFileSearchProvider(w,this._transformScheme(f)),v.toDisposable(()=>{this._fileSearchUsedSchemes.delete(f),this._fileSearchProvider.delete(w),this._proxy.$unregisterProvider(w)})}$provideFileSearchResults(f,_,w,E){const u=l(w),h=this._fileSearchProvider.get(f);if(h)return this._fileSearchManager.fileSearch(u,h,m=>{this._proxy.$handleFileMatch(f,_,m.map(t=>t.resource))},E);throw new Error("unknown provider: "+f)}$clearCache(f){return this._fileSearchManager.clearCache(f),Promise.resolve(void 0)}$provideTextSearchResults(f,_,w,E){const u=this._textSearchProvider.get(f);if(!u||!u.provideTextSearchResults)throw new Error(`Unknown provider ${f}`);const h=l(w);return this.createTextSearchManager(h,u).search(t=>this._proxy.$handleTextMatch(f,_,t),E)}createTextSearchManager(f,_){return new s.TextSearchManager(f,_,{readdir:w=>Promise.resolve([]),toCanonicalName:w=>w})}};I=Ve([We(0,A.IExtHostRpcService),We(1,C.IURITransformerService),We(2,D.ILogService)],I),e.ExtHostSearch=I;function l(c){return Object.assign(Object.assign({},c),{folderQueries:c.folderQueries&&c.folderQueries.map(g),extraFileResources:c.extraFileResources&&c.extraFileResources.map(f=>P.URI.revive(f))})}e.reviveQuery=l;function g(c){return Object.assign(Object.assign({},c),{folder:P.URI.revive(c.folder)})}}),define(ge[256],pe([0,1,21,16,3,52,2,150,105,141,77,42,5,217,216,47,218,36,219,220,221,203,222,39,40,223,204,225,226,227,62,206,231,232,233,88,33,234,207,18,7,237,63,126,34,35,68,194,224,116,125,65,48,67,15,59,12,27,228,192,46,61,214,235,191,89,87,240,238,239,215,58,248,236,86,45,117,229,64,230,10,181]),function(X,e,v,R,k,y,A,C,D,P,s,I,l,g,c,f,_,w,E,u,h,m,t,r,i,n,a,p,d,b,S,o,L,O,W,J,oe,q,x,V,T,N,F,M,U,B,K,ie,we,Te,ye,Oe,je,ze,qe,j,Z,ne,ae,Y,ce,me,Re,He,be,Xe,Q,re,ve,Me,Ne,Ye,Se,_e,ke,le,fe,H,ee,ue,Pe,Ae){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function xe(Be){const Qe=Be.get(ne.IExtHostInitDataService),rt=Be.get(Ye.IExtHostFileSystemInfo),nt=Be.get(Q.IExtHostConsumerFileSystem),Ze=Be.get(i.IExtHostExtensionService),ot=Be.get(U.IExtHostWorkspace),Ee=Be.get(fe.IExtHostTelemetry),De=Be.get(w.IExtHostConfiguration),de=Be.get(j.IURITransformerService),G=Be.get(Z.IExtHostRpcService),Ue=Be.get(J.IExtHostStorage),Le=Be.get(Xe.IExtensionStoragePaths),Ge=Be.get(qe.ILogService),Je=Be.get(ce.IExtHostTunnelService),lt=Be.get(me.IExtHostApiDeprecationService),ct=Be.get(M.IExtHostWindow),it=Be.get(ke.IExtHostSecretState),mt=Be.get(le.IExtHostEditorTabs);G.set(l.ExtHostContext.ExtHostFileSystemInfo,rt),G.set(l.ExtHostContext.ExtHostLogService,Ge),G.set(l.ExtHostContext.ExtHostWorkspace,ot),G.set(l.ExtHostContext.ExtHostConfiguration,De),G.set(l.ExtHostContext.ExtHostExtensionService,Ze),G.set(l.ExtHostContext.ExtHostStorage,Ue),G.set(l.ExtHostContext.ExtHostTunnelService,Je),G.set(l.ExtHostContext.ExtHostWindow,ct),G.set(l.ExtHostContext.ExtHostSecretState,it),G.set(l.ExtHostContext.ExtHostTelemetry,Ee),G.set(l.ExtHostContext.ExtHostEditorTabs,mt);const St=G.set(l.ExtHostContext.ExtHostDecorations,Be.get(ye.IExtHostDecorations)),vt=G.set(l.ExtHostContext.ExtHostDocumentsAndEditors,Be.get(r.IExtHostDocumentsAndEditors)),bt=G.set(l.ExtHostContext.ExtHostCommands,Be.get(f.IExtHostCommands)),gt=G.set(l.ExtHostContext.ExtHostTerminalService,Be.get(oe.IExtHostTerminalService)),ht=G.set(l.ExtHostContext.ExtHostDebugService,Be.get(je.IExtHostDebugService)),kt=G.set(l.ExtHostContext.ExtHostSearch,Be.get(ze.IExtHostSearch)),_t=G.set(l.ExtHostContext.ExtHostTask,Be.get(Oe.IExtHostTask)),It=G.set(l.ExtHostContext.ExtHostOutputService,Be.get(S.IExtHostOutputService)),Lt=G.set(l.ExtHostContext.ExtHostUrls,new N.ExtHostUrls(G)),Et=G.set(l.ExtHostContext.ExtHostDocuments,new t.ExtHostDocuments(G,vt)),Kt=G.set(l.ExtHostContext.ExtHostDocumentContentProviders,new h.ExtHostDocumentContentProvider(G,vt,Ge)),Qt=G.set(l.ExtHostContext.ExtHostDocumentSaveParticipant,new m.ExtHostDocumentSaveParticipant(Ge,Et,G.getProxy(l.MainContext.MainThreadBulkEdits))),ft=G.set(l.ExtHostContext.ExtHostNotebook,new ae.ExtHostNotebookController(G,bt,vt,Et,Ge,Le)),Xt=G.set(l.ExtHostContext.ExtHostNotebookKernels,new H.ExtHostNotebookKernels(G,Qe,ft,Ge)),Yt=G.set(l.ExtHostContext.ExtHostNotebookRenderers,new ue.ExtHostNotebookRenderers(G,ft)),Dt=G.set(l.ExtHostContext.ExtHostEditors,new q.ExtHostEditors(G,vt)),un=G.set(l.ExtHostContext.ExtHostTreeViews,new x.ExtHostTreeViews(G.getProxy(l.MainContext.MainThreadTreeViews),bt,Ge)),Jt=G.set(l.ExtHostContext.ExtHostEditorInsets,new ie.ExtHostEditorInsets(G.getProxy(l.MainContext.MainThreadEditorInsets),Dt,Qe)),xt=G.set(l.ExtHostContext.ExtHostDiagnostics,new E.ExtHostDiagnostics(G,Ge)),ut=G.set(l.ExtHostContext.ExtHostLanguageFeatures,new p.ExtHostLanguageFeatures(G,de,Et,bt,xt,Ge,lt)),Zt=G.set(l.ExtHostContext.ExtHostFileSystem,new n.ExtHostFileSystem(G,ut)),Ft=G.set(l.ExtHostContext.ExtHostFileSystemEventService,new a.ExtHostFileSystemEventService(G,Ge,vt)),Mt=G.set(l.ExtHostContext.ExtHostQuickOpen,L.createExtHostQuickOpen(G,ot,bt)),qt=G.set(l.ExtHostContext.ExtHostSCM,new O.ExtHostSCM(G,bt,Ge)),_n=G.set(l.ExtHostContext.ExtHostComments,new _.ExtHostComments(G,bt,Et)),dn=G.set(l.ExtHostContext.ExtHostProgress,new o.ExtHostProgress(G.getProxy(l.MainContext.MainThreadProgress))),Sn=G.set(l.ExtHostContext.ExtHosLabelService,new we.ExtHostLabelService(G)),hn=G.set(l.ExtHostContext.ExtHostTheming,new Y.ExtHostTheming(G)),Bt=G.set(l.ExtHostContext.ExtHostAuthentication,new Re.ExtHostAuthentication(G)),en=G.set(l.ExtHostContext.ExtHostTimeline,new He.ExtHostTimeline(G,bt)),Ht=G.set(l.ExtHostContext.ExtHostWebviews,new F.ExtHostWebviews(G,{remote:Qe.remote},ot,Ge,lt)),tn=G.set(l.ExtHostContext.ExtHostWebviewPanels,new Me.ExtHostWebviewPanels(G,Ht,ot)),yn=G.set(l.ExtHostContext.ExtHostCustomEditors,new ve.ExtHostCustomEditors(G,Et,Le,Ht,tn)),Dn=G.set(l.ExtHostContext.ExtHostWebviewViews,new re.ExtHostWebviewViews(G,Ht)),Ot=G.set(l.ExtHostContext.ExtHostTesting,new Se.ExtHostTesting(G,vt,ot)),Gt=G.set(l.ExtHostContext.ExtHostUriOpeners,new _e.ExtHostUriOpeners(G)),Cn=K.values(l.ExtHostContext);G.assertRegistered(Cn);const kn=new Ne.ExtHostBulkEdits(G,vt),nn=new c.ExtHostClipboard(G),rn=new b.ExtHostMessageService(G,Ge),$t=new u.ExtHostDialogs(G),Tt=new W.ExtHostStatusBar(G,bt.converter),sn=new d.ExtHostLanguages(G,Et);return g.ExtHostApiCommands.register(bt),function(Fe,Wt,fn){const pt=function(){let te=!Fe.isUnderDevelopment;function he(Ie){te||(Ge.info(`Extension '${Fe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),te=!0)}return function Ie(st){if(Array.isArray(st))st.forEach(Ie);else if(typeof st=="string")he(st);else{const wt=st;typeof wt.scheme=="undefined"&&he(st),!Fe.enableProposedApi&&typeof wt.exclusive=="boolean"&&B.throwProposedApiError(Fe)}return st}}(),Pn={getSession(te,he,Ie){return Bt.getSession(Fe,te,he,Ie)},get onDidChangeSessions(){return Bt.onDidChangeSessions},registerAuthenticationProvider(te,he,Ie,st){return Bt.registerAuthenticationProvider(te,he,Ie,st)},get onDidChangeAuthenticationProviders(){return B.checkProposedApiEnabled(Fe),Bt.onDidChangeAuthenticationProviders},get providers(){return B.checkProposedApiEnabled(Fe),Bt.providers},logout(te,he){return B.checkProposedApiEnabled(Fe),Bt.removeSession(te,he)}},In={registerCommand(te,he,Ie){return bt.registerCommand(!0,te,he,Ie)},registerTextEditorCommand(te,he,Ie){return bt.registerCommand(!0,te,(...st)=>{const wt=Dt.getActiveTextEditor();if(!wt){Ge.warn("Cannot execute "+te+" because there is no active text editor.");return}return wt.edit(Ct=>{he.apply(Ie,[wt,Ct,...st])}).then(Ct=>{Ct||Ge.warn("Edits from command "+te+" were not applied.")},Ct=>{Ge.warn("An error occurred while running command "+te,Ct)})})},registerDiffInformationCommand:(te,he,Ie)=>(B.checkProposedApiEnabled(Fe),bt.registerCommand(!0,te,async(...st)=>{const wt=vt.activeEditor(!0);if(!wt){Ge.warn("Cannot execute "+te+" because there is no active text editor.");return}const Ct=await Dt.getDiffInformation(wt.id);he.apply(Ie,[Ct,...st])})),executeCommand(te,...he){return bt.executeCommand(te,...he)},getCommands(te=!1){return bt.getCommands(te)}},mn={get machineId(){return Qe.telemetryInfo.machineId},get sessionId(){return Qe.telemetryInfo.sessionId},get language(){return Qe.environment.appLanguage},get appName(){return Qe.environment.appName},get appRoot(){var te,he;return(he=(te=Qe.environment.appRoot)===null||te===void 0?void 0:te.fsPath)!==null&&he!==void 0?he:""},get uriScheme(){return Qe.environment.appUriScheme},get clipboard(){return nn.value},get shell(){return gt.getDefaultShell(!1)},get isTelemetryEnabled(){return Ee.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return Ee.onDidChangeTelemetryEnabled},get isNewAppInstall(){const te=Date.now()-new Date(Qe.telemetryInfo.firstSessionDate).getTime();return isNaN(te)?!1:te<1e3*60*60*24},openExternal(te,he){return ct.openUri(te,{allowTunneling:!!Qe.remote.authority,allowContributedOpeners:he==null?void 0:he.allowContributedOpeners})},async asExternalUri(te){if(te.scheme===Qe.environment.appUriScheme)return Lt.createAppUri(te);const he=Ae.matchesScheme(te,Pe.Schemas.http)||Ae.matchesScheme(te,Pe.Schemas.https);he||B.checkProposedApiEnabled(Fe);try{return await ct.asExternalUri(te,{allowTunneling:!!Qe.remote.authority})}catch(Ie){if(he)return te;throw Ie}},get remoteName(){return Te.getRemoteName(Qe.remote.authority)},get uiKind(){return Qe.uiKind}};Qe.environment.extensionTestsLocationURI||Object.freeze(mn);const gn=Qe.remote.isRemote?T.ExtensionKind.Workspace:T.ExtensionKind.UI,on={registerTestController(te){return B.checkProposedApiEnabled(Fe),Ot.registerTestController(Fe.identifier.value,te)},createDocumentTestObserver(te){return B.checkProposedApiEnabled(Fe),Ot.createTextDocumentTestObserver(te)},createWorkspaceTestObserver(te){return B.checkProposedApiEnabled(Fe),Ot.createWorkspaceTestObserver(te)},runTests(te){return B.checkProposedApiEnabled(Fe),Ot.runTests(te)},createTestItem(te,he){return new T.TestItemImpl(te.id,te.label,te.uri,he)},createTestRun(te,he,Ie){return B.checkProposedApiEnabled(Fe),Ot.createTestRun(Fe.identifier.value,te,he,Ie)},get onDidChangeTestResults(){return B.checkProposedApiEnabled(Fe),Ot.onResultsChanged},get testResults(){return B.checkProposedApiEnabled(Fe),Ot.results}};on.createTestRunTask=on.createTestRun;const an={getExtension(te){const he=Wt.getExtensionDescription(te);if(he)return new i.Extension(Ze,Fe.identifier,he,gn)},get all(){return Wt.getAllExtensionDescriptions().map(te=>new i.Extension(Ze,Fe.identifier,te,gn))},get onDidChange(){return Wt.onDidChange}},An={createDiagnosticCollection(te){return xt.createDiagnosticCollection(Fe.identifier,te)},get onDidChangeDiagnostics(){return xt.onDidChangeDiagnostics},getDiagnostics:te=>xt.getDiagnostics(te),getLanguages(){return sn.getLanguages()},setTextDocumentLanguage(te,he){return sn.changeLanguage(te.uri,he)},match(te,he){return s.score(V.LanguageSelector.from(te),he.uri,he.languageId,!0)},registerCodeActionsProvider(te,he,Ie){return ut.registerCodeActionProvider(Fe,pt(te),he,Ie)},registerCodeLensProvider(te,he){return ut.registerCodeLensProvider(Fe,pt(te),he)},registerDefinitionProvider(te,he){return ut.registerDefinitionProvider(Fe,pt(te),he)},registerDeclarationProvider(te,he){return ut.registerDeclarationProvider(Fe,pt(te),he)},registerImplementationProvider(te,he){return ut.registerImplementationProvider(Fe,pt(te),he)},registerTypeDefinitionProvider(te,he){return ut.registerTypeDefinitionProvider(Fe,pt(te),he)},registerHoverProvider(te,he){return ut.registerHoverProvider(Fe,pt(te),he,Fe.identifier)},registerEvaluatableExpressionProvider(te,he){return ut.registerEvaluatableExpressionProvider(Fe,pt(te),he,Fe.identifier)},registerInlineValuesProvider(te,he){return ut.registerInlineValuesProvider(Fe,pt(te),he,Fe.identifier)},registerDocumentHighlightProvider(te,he){return ut.registerDocumentHighlightProvider(Fe,pt(te),he)},registerLinkedEditingRangeProvider(te,he){return ut.registerLinkedEditingRangeProvider(Fe,pt(te),he)},registerReferenceProvider(te,he){return ut.registerReferenceProvider(Fe,pt(te),he)},registerRenameProvider(te,he){return ut.registerRenameProvider(Fe,pt(te),he)},registerDocumentSymbolProvider(te,he,Ie){return ut.registerDocumentSymbolProvider(Fe,pt(te),he,Ie)},registerWorkspaceSymbolProvider(te){return ut.registerWorkspaceSymbolProvider(Fe,te)},registerDocumentFormattingEditProvider(te,he){return ut.registerDocumentFormattingEditProvider(Fe,pt(te),he)},registerDocumentRangeFormattingEditProvider(te,he){return ut.registerDocumentRangeFormattingEditProvider(Fe,pt(te),he)},registerOnTypeFormattingEditProvider(te,he,Ie,...st){return ut.registerOnTypeFormattingEditProvider(Fe,pt(te),he,[Ie].concat(st))},registerDocumentSemanticTokensProvider(te,he,Ie){return ut.registerDocumentSemanticTokensProvider(Fe,pt(te),he,Ie)},registerDocumentRangeSemanticTokensProvider(te,he,Ie){return ut.registerDocumentRangeSemanticTokensProvider(Fe,pt(te),he,Ie)},registerSignatureHelpProvider(te,he,Ie,...st){return typeof Ie=="object"?ut.registerSignatureHelpProvider(Fe,pt(te),he,Ie):ut.registerSignatureHelpProvider(Fe,pt(te),he,typeof Ie=="undefined"?[]:[Ie,...st])},registerCompletionItemProvider(te,he,...Ie){return ut.registerCompletionItemProvider(Fe,pt(te),he,Ie)},registerInlineCompletionItemProvider(te,he){return B.checkProposedApiEnabled(Fe),ut.registerInlineCompletionsProvider(Fe,pt(te),he)},registerDocumentLinkProvider(te,he){return ut.registerDocumentLinkProvider(Fe,pt(te),he)},registerColorProvider(te,he){return ut.registerColorProvider(Fe,pt(te),he)},registerFoldingRangeProvider(te,he){return ut.registerFoldingRangeProvider(Fe,pt(te),he)},registerSelectionRangeProvider(te,he){return ut.registerSelectionRangeProvider(Fe,te,he)},registerCallHierarchyProvider(te,he){return ut.registerCallHierarchyProvider(Fe,te,he)},setLanguageConfiguration:(te,he)=>ut.setLanguageConfiguration(Fe,te,he),getTokenInformationAtPosition(te,he){return B.checkProposedApiEnabled(Fe),sn.tokenAtPosition(te,he)},registerInlayHintsProvider(te,he){return B.checkProposedApiEnabled(Fe),ut.registerInlayHintsProvider(Fe,te,he)}},Tn={get activeTextEditor(){return Dt.getActiveTextEditor()},get visibleTextEditors(){return Dt.getVisibleTextEditors()},get activeTerminal(){return gt.activeTerminal},get terminals(){return gt.terminals},async showTextDocument(te,he,Ie){const st=await(A.URI.isUri(te)?Promise.resolve(pn.openTextDocument(te)):Promise.resolve(te));return Dt.showTextDocument(st,he,Ie)},createTextEditorDecorationType(te){return Dt.createTextEditorDecorationType(Fe,te)},onDidChangeActiveTextEditor(te,he,Ie){return Dt.onDidChangeActiveTextEditor(te,he,Ie)},onDidChangeVisibleTextEditors(te,he,Ie){return Dt.onDidChangeVisibleTextEditors(te,he,Ie)},onDidChangeTextEditorSelection(te,he,Ie){return Dt.onDidChangeTextEditorSelection(te,he,Ie)},onDidChangeTextEditorOptions(te,he,Ie){return Dt.onDidChangeTextEditorOptions(te,he,Ie)},onDidChangeTextEditorVisibleRanges(te,he,Ie){return Dt.onDidChangeTextEditorVisibleRanges(te,he,Ie)},onDidChangeTextEditorViewColumn(te,he,Ie){return Dt.onDidChangeTextEditorViewColumn(te,he,Ie)},onDidCloseTerminal(te,he,Ie){return gt.onDidCloseTerminal(te,he,Ie)},onDidOpenTerminal(te,he,Ie){return gt.onDidOpenTerminal(te,he,Ie)},onDidChangeActiveTerminal(te,he,Ie){return gt.onDidChangeActiveTerminal(te,he,Ie)},onDidChangeTerminalDimensions(te,he,Ie){return B.checkProposedApiEnabled(Fe),gt.onDidChangeTerminalDimensions(te,he,Ie)},onDidWriteTerminalData(te,he,Ie){return B.checkProposedApiEnabled(Fe),gt.onDidWriteTerminalData(te,he,Ie)},get state(){return ct.state},onDidChangeWindowState(te,he,Ie){return ct.onDidChangeWindowState(te,he,Ie)},showInformationMessage(te,...he){return rn.showMessage(Fe,y.default.Info,te,he[0],he.slice(1))},showWarningMessage(te,...he){return rn.showMessage(Fe,y.default.Warning,te,he[0],he.slice(1))},showErrorMessage(te,...he){return rn.showMessage(Fe,y.default.Error,te,he[0],he.slice(1))},showQuickPick(te,he,Ie){return Mt.showQuickPick(te,!!Fe.enableProposedApi,he,Ie)},showWorkspaceFolderPick(te){return Mt.showWorkspaceFolderPick(te)},showInputBox(te,he){return Mt.showInput(te,he)},showOpenDialog(te){return $t.showOpenDialog(te)},showSaveDialog(te){return $t.showSaveDialog(te)},createStatusBarItem(te,he,Ie){let st,wt,Ct;return typeof te=="string"?(st=te,wt=he,Ct=Ie):(wt=te,Ct=he),Tt.createStatusBarEntry(Fe,st,wt,Ct)},setStatusBarMessage(te,he){return Tt.setStatusBarMessage(te,he)},withScmProgress(te){return lt.report("window.withScmProgress",Fe,"Use 'withProgress' instead."),dn.withProgress(Fe,{location:T.ProgressLocation.SourceControl},(he,Ie)=>te({report(st){}}))},withProgress(te,he){return dn.withProgress(Fe,te,he)},createOutputChannel(te){return It.createOutputChannel(te)},createWebviewPanel(te,he,Ie,st){return tn.createWebviewPanel(Fe,te,he,Ie,st)},createWebviewTextEditorInset(te,he,Ie,st){return B.checkProposedApiEnabled(Fe),Jt.createWebviewEditorInset(te,he,Ie,st,Fe)},createTerminal(te,he,Ie){return typeof te=="object"?"pty"in te?gt.createExtensionTerminal(te):(te.iconPath&&B.checkProposedApiEnabled(Fe),gt.createTerminalFromOptions(te)):gt.createTerminal(te,he,Ie)},registerTerminalLinkProvider(te){return gt.registerLinkProvider(te)},registerTerminalProfileProvider(te,he){return gt.registerProfileProvider(te,he)},registerTreeDataProvider(te,he){return un.registerTreeDataProvider(te,he,Fe)},createTreeView(te,he){return un.createTreeView(te,he,Fe)},registerWebviewPanelSerializer:(te,he)=>tn.registerWebviewPanelSerializer(Fe,te,he),registerCustomEditorProvider:(te,he,Ie={})=>yn.registerCustomEditorProvider(Fe,te,he,Ie),registerFileDecorationProvider(te){return St.registerFileDecorationProvider(te,Fe.identifier)},registerUriHandler(te){return Lt.registerUriHandler(Fe.identifier,te)},createQuickPick(){return Mt.createQuickPick(Fe.identifier,!!Fe.enableProposedApi)},createInputBox(){return Mt.createInputBox(Fe.identifier)},get activeColorTheme(){return hn.activeColorTheme},onDidChangeActiveColorTheme(te,he,Ie){return hn.onDidChangeActiveColorTheme(te,he,Ie)},registerWebviewViewProvider(te,he,Ie){return Dn.registerWebviewViewProvider(Fe,te,he,Ie==null?void 0:Ie.webviewOptions)},get activeNotebookEditor(){return B.checkProposedApiEnabled(Fe),ft.activeNotebookEditor},onDidChangeActiveNotebookEditor(te,he,Ie){return B.checkProposedApiEnabled(Fe),ft.onDidChangeActiveNotebookEditor(te,he,Ie)},get visibleNotebookEditors(){return B.checkProposedApiEnabled(Fe),ft.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return B.checkProposedApiEnabled(Fe),ft.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(te,he,Ie){return B.checkProposedApiEnabled(Fe),ft.onDidChangeNotebookEditorSelection(te,he,Ie)},onDidChangeNotebookEditorVisibleRanges(te,he,Ie){return B.checkProposedApiEnabled(Fe),ft.onDidChangeNotebookEditorVisibleRanges(te,he,Ie)},showNotebookDocument(te,he){return B.checkProposedApiEnabled(Fe),ft.showNotebookDocument(te,he)},registerExternalUriOpener(te,he,Ie){return B.checkProposedApiEnabled(Fe),Gt.registerExternalUriOpener(Fe.identifier,te,he,Ie)},get openEditors(){return B.checkProposedApiEnabled(Fe),mt.tabs},get onDidChangeOpenEditors(){return B.checkProposedApiEnabled(Fe),mt.onDidChangeTabs},getInlineCompletionItemController(te){return B.checkProposedApiEnabled(Fe),p.InlineCompletionController.get(te)}},pn={get rootPath(){return lt.report("workspace.rootPath",Fe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ot.getPath()},set rootPath(te){throw R.readonly()},getWorkspaceFolder(te){return ot.getWorkspaceFolder(te)},get workspaceFolders(){return ot.getWorkspaceFolders()},get name(){return ot.name},set name(te){throw R.readonly()},get workspaceFile(){return ot.workspaceFile},set workspaceFile(te){throw R.readonly()},updateWorkspaceFolders:(te,he,...Ie)=>ot.updateWorkspaceFolders(Fe,te,he||0,...Ie),onDidChangeWorkspaceFolders:function(te,he,Ie){return ot.onDidChangeWorkspace(te,he,Ie)},asRelativePath:(te,he)=>ot.getRelativePath(te,he),findFiles:(te,he,Ie,st)=>ot.findFiles(V.GlobPattern.from(te),V.GlobPattern.from(he),Ie,Fe.identifier,st),findTextInFiles:(te,he,Ie,st)=>{let wt,Ct;return typeof he=="object"?(wt=he,Ct=Ie):(wt={},Ct=he,st=Ie),ot.findTextInFiles(te,wt||{},Ct,Fe.identifier,st)},saveAll:te=>ot.saveAll(te),applyEdit(te){return kn.applyWorkspaceEdit(te)},createFileSystemWatcher:(te,he,Ie,st)=>Ft.createFileSystemWatcher(V.GlobPattern.from(te),he,Ie,st),get textDocuments(){return Et.getAllDocumentData().map(te=>te.document)},set textDocuments(te){throw R.readonly()},openTextDocument(te){let he;const Ie=te;if(typeof te=="string")he=Promise.resolve(A.URI.file(te));else if(A.URI.isUri(te))he=Promise.resolve(te);else if(!Ie||typeof Ie=="object")he=Et.createDocumentData(Ie);else throw new Error("illegal argument - uriOrFileNameOrOptions");return he.then(st=>Et.ensureDocumentData(st).then(wt=>wt.document))},onDidOpenTextDocument:(te,he,Ie)=>Et.onDidAddDocument(te,he,Ie),onDidCloseTextDocument:(te,he,Ie)=>Et.onDidRemoveDocument(te,he,Ie),onDidChangeTextDocument:(te,he,Ie)=>Et.onDidChangeDocument(te,he,Ie),onDidSaveTextDocument:(te,he,Ie)=>Et.onDidSaveDocument(te,he,Ie),onWillSaveTextDocument:(te,he,Ie)=>Qt.getOnWillSaveTextDocumentEvent(Fe)(te,he,Ie),get notebookDocuments(){return ft.notebookDocuments.map(te=>te.apiNotebook)},async openNotebookDocument(te,he){let Ie;if(A.URI.isUri(te))Ie=te,await ft.openNotebookDocument(te);else if(typeof te=="string")Ie=A.URI.revive(await ft.createNotebookDocument({viewType:te,content:he}));else throw new Error("Invalid arguments");return ft.getNotebookDocument(Ie).apiNotebook},get onDidOpenNotebookDocument(){return ft.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return ft.onDidCloseNotebookDocument},registerNotebookSerializer(te,he,Ie,st){return ft.registerNotebookSerializer(Fe,te,he,Ie,Fe.enableProposedApi?st:void 0)},registerNotebookContentProvider:(te,he,Ie,st)=>(B.checkProposedApiEnabled(Fe),ft.registerNotebookContentProvider(Fe,te,he,Ie,Fe.enableProposedApi?st:void 0)),onDidChangeConfiguration:(te,he,Ie)=>fn.onDidChangeConfiguration(te,he,Ie),getConfiguration(te,he){return he=arguments.length===1?void 0:he,fn.getConfiguration(te,he,Fe)},registerTextDocumentContentProvider(te,he){return Kt.registerTextDocumentContentProvider(te,he)},registerTaskProvider:(te,he)=>(lt.report("window.registerTaskProvider",Fe,"Use the corresponding function on the 'tasks' namespace instead"),_t.registerTaskProvider(Fe,te,he)),registerFileSystemProvider(te,he,Ie){return Zt.registerFileSystemProvider(Fe.identifier,te,he,Ie,Fe.enableProposedApi)},get fs(){return nt.value},registerFileSearchProvider:(te,he)=>(B.checkProposedApiEnabled(Fe),kt.registerFileSearchProvider(te,he)),registerTextSearchProvider:(te,he)=>(B.checkProposedApiEnabled(Fe),kt.registerTextSearchProvider(te,he)),registerRemoteAuthorityResolver:(te,he)=>(B.checkProposedApiEnabled(Fe),Ze.registerRemoteAuthorityResolver(te,he)),registerResourceLabelFormatter:te=>(B.checkProposedApiEnabled(Fe),Sn.$registerResourceLabelFormatter(te)),onDidCreateFiles:(te,he,Ie)=>Ft.onDidCreateFile(te,he,Ie),onDidDeleteFiles:(te,he,Ie)=>Ft.onDidDeleteFile(te,he,Ie),onDidRenameFiles:(te,he,Ie)=>Ft.onDidRenameFile(te,he,Ie),onWillCreateFiles:(te,he,Ie)=>Ft.getOnWillCreateFileEvent(Fe)(te,he,Ie),onWillDeleteFiles:(te,he,Ie)=>Ft.getOnWillDeleteFileEvent(Fe)(te,he,Ie),onWillRenameFiles:(te,he,Ie)=>Ft.getOnWillRenameFileEvent(Fe)(te,he,Ie),openTunnel:te=>(B.checkProposedApiEnabled(Fe),Je.openTunnel(Fe,te).then(he=>{if(!he)throw new Error("cannot open tunnel");return he})),get tunnels(){return B.checkProposedApiEnabled(Fe),Je.getTunnels()},onDidChangeTunnels:(te,he,Ie)=>(B.checkProposedApiEnabled(Fe),Je.onDidChangeTunnels(te,he,Ie)),registerPortAttributesProvider:(te,he)=>(B.checkProposedApiEnabled(Fe),Je.registerPortsAttributesProvider(te,he)),registerTimelineProvider:(te,he)=>(B.checkProposedApiEnabled(Fe),en.registerTimelineProvider(te,he,Fe.identifier,bt.converter)),get isTrusted(){return ot.trusted},requestWorkspaceTrust:te=>(B.checkProposedApiEnabled(Fe),ot.requestWorkspaceTrust(te)),onDidGrantWorkspaceTrust:(te,he,Ie)=>ot.onDidGrantWorkspaceTrust(te,he,Ie)},Rn={get inputBox(){return lt.report("scm.inputBox",Fe,"Use 'SourceControl.inputBox' instead"),qt.getLastInputBox(Fe)},createSourceControl(te,he,Ie){return qt.createSourceControl(Fe,te,he,Ie)}},Ln={createCommentController(te,he){return _n.createCommentController(Fe,te,he)}},Fn={get activeDebugSession(){return ht.activeDebugSession},get activeDebugConsole(){return ht.activeDebugConsole},get breakpoints(){return ht.breakpoints},onDidStartDebugSession(te,he,Ie){return ht.onDidStartDebugSession(te,he,Ie)},onDidTerminateDebugSession(te,he,Ie){return ht.onDidTerminateDebugSession(te,he,Ie)},onDidChangeActiveDebugSession(te,he,Ie){return ht.onDidChangeActiveDebugSession(te,he,Ie)},onDidReceiveDebugSessionCustomEvent(te,he,Ie){return ht.onDidReceiveDebugSessionCustomEvent(te,he,Ie)},onDidChangeBreakpoints(te,he,Ie){return ht.onDidChangeBreakpoints(te,he,Ie)},registerDebugConfigurationProvider(te,he,Ie){return ht.registerDebugConfigurationProvider(te,he,Ie||T.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(te,he){return ht.registerDebugAdapterDescriptorFactory(Fe,te,he)},registerDebugAdapterTrackerFactory(te,he){return ht.registerDebugAdapterTrackerFactory(te,he)},startDebugging(te,he,Ie){return!Ie||typeof Ie=="object"&&"configuration"in Ie?ht.startDebugging(te,he,{parentSession:Ie}):ht.startDebugging(te,he,Ie||{})},stopDebugging(te){return ht.stopDebugging(te)},addBreakpoints(te){return ht.addBreakpoints(te)},removeBreakpoints(te){return ht.removeBreakpoints(te)},asDebugSourceUri(te,he){return ht.asDebugSourceUri(te,he)}},vn={registerTaskProvider:(te,he)=>_t.registerTaskProvider(Fe,te,he),fetchTasks:te=>_t.fetchTasks(te),executeTask:te=>_t.executeTask(Fe,te),get taskExecutions(){return _t.taskExecutions},onDidStartTask:(te,he,Ie)=>_t.onDidStartTask(te,he,Ie),onDidEndTask:(te,he,Ie)=>_t.onDidEndTask(te,he,Ie),onDidStartTaskProcess:(te,he,Ie)=>_t.onDidStartTaskProcess(te,he,Ie),onDidEndTaskProcess:(te,he,Ie)=>_t.onDidEndTaskProcess(te,he,Ie)},wn={createNotebookController(te,he,Ie,st,wt){return Xt.createNotebookController(Fe,te,he,Ie,st,Fe.enableProposedApi?wt:void 0)},registerNotebookCellStatusBarItemProvider:(te,he)=>ft.registerNotebookCellStatusBarItemProvider(Fe,te,he),get onDidSaveNotebookDocument(){return B.checkProposedApiEnabled(Fe),ft.onDidSaveNotebookDocument},createNotebookEditorDecorationType(te){return B.checkProposedApiEnabled(Fe),ft.createNotebookEditorDecorationType(te)},createRendererMessaging(te){return B.checkProposedApiEnabled(Fe),Yt.createRendererMessaging(te)},onDidChangeNotebookDocumentMetadata(te,he,Ie){return B.checkProposedApiEnabled(Fe),ft.onDidChangeNotebookDocumentMetadata(te,he,Ie)},onDidChangeNotebookCells(te,he,Ie){return B.checkProposedApiEnabled(Fe),ft.onDidChangeNotebookCells(te,he,Ie)},onDidChangeNotebookCellExecutionState(te,he,Ie){return B.checkProposedApiEnabled(Fe),ft.onDidChangeNotebookCellExecutionState(te,he,Ie)},onDidChangeCellOutputs(te,he,Ie){return B.checkProposedApiEnabled(Fe),ft.onDidChangeCellOutputs(te,he,Ie)},onDidChangeCellMetadata(te,he,Ie){return B.checkProposedApiEnabled(Fe),ft.onDidChangeCellMetadata(te,he,Ie)},createConcatTextDocument(te,he){return B.checkProposedApiEnabled(Fe),new be.ExtHostNotebookConcatDocument(ft,Et,te,he)}};return{version:Qe.version,authentication:Pn,commands:In,comments:Ln,debug:Fn,env:mn,extensions:an,languages:An,notebooks:wn,scm:Rn,tasks:vn,test:on,window:Tn,workspace:pn,Breakpoint:T.Breakpoint,CallHierarchyIncomingCall:T.CallHierarchyIncomingCall,CallHierarchyItem:T.CallHierarchyItem,CallHierarchyOutgoingCall:T.CallHierarchyOutgoingCall,CancellationError:R.CancellationError,CancellationTokenSource:v.CancellationTokenSource,CandidatePortSource:l.CandidatePortSource,CodeAction:T.CodeAction,CodeActionKind:T.CodeActionKind,CodeActionTriggerKind:T.CodeActionTriggerKind,CodeLens:T.CodeLens,Color:T.Color,ColorInformation:T.ColorInformation,ColorPresentation:T.ColorPresentation,ColorThemeKind:T.ColorThemeKind,CommentMode:T.CommentMode,CommentThreadCollapsibleState:T.CommentThreadCollapsibleState,CompletionItem:T.CompletionItem,CompletionItemKind:T.CompletionItemKind,CompletionItemTag:T.CompletionItemTag,CompletionList:T.CompletionList,CompletionTriggerKind:T.CompletionTriggerKind,ConfigurationTarget:T.ConfigurationTarget,CustomExecution:T.CustomExecution,DebugAdapterExecutable:T.DebugAdapterExecutable,DebugAdapterInlineImplementation:T.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:T.DebugAdapterNamedPipeServer,DebugAdapterServer:T.DebugAdapterServer,DebugConfigurationProviderTriggerKind:T.DebugConfigurationProviderTriggerKind,DebugConsoleMode:T.DebugConsoleMode,DecorationRangeBehavior:T.DecorationRangeBehavior,Diagnostic:T.Diagnostic,DiagnosticRelatedInformation:T.DiagnosticRelatedInformation,DiagnosticSeverity:T.DiagnosticSeverity,DiagnosticTag:T.DiagnosticTag,Disposable:T.Disposable,DocumentHighlight:T.DocumentHighlight,DocumentHighlightKind:T.DocumentHighlightKind,DocumentLink:T.DocumentLink,DocumentSymbol:T.DocumentSymbol,EndOfLine:T.EndOfLine,EnvironmentVariableMutatorType:T.EnvironmentVariableMutatorType,EvaluatableExpression:T.EvaluatableExpression,InlineValueText:T.InlineValueText,InlineValueVariableLookup:T.InlineValueVariableLookup,InlineValueEvaluatableExpression:T.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:T.InlineCompletionTriggerKind,EventEmitter:k.Emitter,ExtensionKind:T.ExtensionKind,ExtensionMode:T.ExtensionMode,ExternalUriOpenerPriority:T.ExternalUriOpenerPriority,FileChangeType:T.FileChangeType,FileDecoration:T.FileDecoration,FileSystemError:T.FileSystemError,FileType:I.FileType,FilePermission:I.FilePermission,FoldingRange:T.FoldingRange,FoldingRangeKind:T.FoldingRangeKind,FunctionBreakpoint:T.FunctionBreakpoint,InlineCompletionItem:T.InlineSuggestion,InlineCompletionList:T.InlineSuggestions,Hover:T.Hover,IndentAction:P.IndentAction,Location:T.Location,MarkdownString:T.MarkdownString,OverviewRulerLane:D.OverviewRulerLane,ParameterInformation:T.ParameterInformation,PortAutoForwardAction:T.PortAutoForwardAction,Position:T.Position,ProcessExecution:T.ProcessExecution,ProgressLocation:T.ProgressLocation,QuickInputButtons:T.QuickInputButtons,Range:T.Range,RelativePattern:T.RelativePattern,Selection:T.Selection,SelectionRange:T.SelectionRange,SemanticTokens:T.SemanticTokens,SemanticTokensBuilder:T.SemanticTokensBuilder,SemanticTokensEdit:T.SemanticTokensEdit,SemanticTokensEdits:T.SemanticTokensEdits,SemanticTokensLegend:T.SemanticTokensLegend,ShellExecution:T.ShellExecution,ShellQuoting:T.ShellQuoting,SignatureHelp:T.SignatureHelp,SignatureHelpTriggerKind:T.SignatureHelpTriggerKind,SignatureInformation:T.SignatureInformation,SnippetString:T.SnippetString,SourceBreakpoint:T.SourceBreakpoint,StandardTokenType:T.StandardTokenType,StatusBarAlignment:T.StatusBarAlignment,SymbolInformation:T.SymbolInformation,SymbolKind:T.SymbolKind,SymbolTag:T.SymbolTag,Task:T.Task,TaskGroup:T.TaskGroup,TaskPanelKind:T.TaskPanelKind,TaskRevealKind:T.TaskRevealKind,TaskScope:T.TaskScope,TextDocumentSaveReason:T.TextDocumentSaveReason,TextEdit:T.TextEdit,TextEditorCursorStyle:C.TextEditorCursorStyle,TextEditorLineNumbersStyle:T.TextEditorLineNumbersStyle,TextEditorRevealType:T.TextEditorRevealType,TextEditorSelectionChangeKind:T.TextEditorSelectionChangeKind,ThemeColor:T.ThemeColor,ThemeIcon:T.ThemeIcon,TreeItem:T.TreeItem,TreeItemCollapsibleState:T.TreeItemCollapsibleState,UIKind:l.UIKind,Uri:A.URI,ViewColumn:T.ViewColumn,WorkspaceEdit:T.WorkspaceEdit,InlayHint:T.InlayHint,InlayHintKind:T.InlayHintKind,RemoteAuthorityResolverError:T.RemoteAuthorityResolverError,ResolvedAuthority:T.ResolvedAuthority,SourceControlInputBoxValidationType:T.SourceControlInputBoxValidationType,ExtensionRuntime:T.ExtensionRuntime,TimelineItem:T.TimelineItem,NotebookRange:T.NotebookRange,NotebookCellKind:T.NotebookCellKind,NotebookCellExecutionState:T.NotebookCellExecutionState,NotebookCellData:T.NotebookCellData,NotebookData:T.NotebookData,NotebookRendererScript:T.NotebookRendererScript,NotebookCellStatusBarAlignment:T.NotebookCellStatusBarAlignment,NotebookEditorRevealType:T.NotebookEditorRevealType,NotebookCellOutput:T.NotebookCellOutput,NotebookCellOutputItem:T.NotebookCellOutputItem,NotebookCellStatusBarItem:T.NotebookCellStatusBarItem,NotebookControllerAffinity:T.NotebookControllerAffinity,PortAttributes:T.PortAttributes,LinkedEditingRanges:T.LinkedEditingRanges,TestItemStatus:T.TestItemStatus,TestResultState:T.TestResultState,TestMessage:T.TestMessage,TextSearchCompleteMessageType:ee.TextSearchCompleteMessageType,TestMessageSeverity:T.TestMessageSeverity,WorkspaceTrustState:T.WorkspaceTrustState}}}e.createApiFactoryAndRegisterActors=xe}),define(ge[257],pe([0,1,78,62,34,125,36,47,39,33,65,48,67,89,88,46,61,126,87,58,86,117,45]),function(X,e,v,R,k,y,A,C,D,P,s,I,l,g,c,f,_,w,E,u,h,m,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),v.registerSingleton(g.IExtensionStoragePaths,g.ExtensionStoragePaths),v.registerSingleton(_.IExtHostApiDeprecationService,_.ExtHostApiDeprecationService),v.registerSingleton(C.IExtHostCommands,C.ExtHostCommands),v.registerSingleton(A.IExtHostConfiguration,A.ExtHostConfiguration),v.registerSingleton(E.IExtHostConsumerFileSystem,E.ExtHostConsumerFileSystem),v.registerSingleton(I.IExtHostDebugService,I.WorkerExtHostDebugService),v.registerSingleton(y.IExtHostDecorations,y.ExtHostDecorations),v.registerSingleton(D.IExtHostDocumentsAndEditors,D.ExtHostDocumentsAndEditors),v.registerSingleton(u.IExtHostFileSystemInfo,u.ExtHostFileSystemInfo),v.registerSingleton(R.IExtHostOutputService,R.ExtHostOutputService),v.registerSingleton(l.IExtHostSearch,l.ExtHostSearch),v.registerSingleton(c.IExtHostStorage,c.ExtHostStorage),v.registerSingleton(s.IExtHostTask,s.WorkerExtHostTask),v.registerSingleton(P.IExtHostTerminalService,P.WorkerExtHostTerminalService),v.registerSingleton(f.IExtHostTunnelService,f.ExtHostTunnelService),v.registerSingleton(w.IExtHostWindow,w.ExtHostWindow),v.registerSingleton(k.IExtHostWorkspace,k.ExtHostWorkspace),v.registerSingleton(h.IExtHostSecretState,h.ExtHostSecretState),v.registerSingleton(m.IExtHostTelemetry,m.ExtHostTelemetry),v.registerSingleton(t.IExtHostEditorTabs,t.ExtHostEditorTabs)}),define(ge[90],pe([0,1,17,15,31,64]),function(X,e,v,R,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function A(I){return I.startsWith("**")||I.startsWith("/")?I:`/${I}`}e.anchorGlob=A;function C(I,l,g,c){const f=v.mapArrayOrNot(g,D),_=new k.TextSearchMatch(l,f,c),w=_.preview.matches;return{ranges:v.mapArrayOrNot(f,P),uri:I,preview:{text:_.preview.text,matches:v.mapArrayOrNot(w,P)}}}e.createTextSearchResult=C;function D(I){return new k.SearchRange(I.start.line,I.start.character,I.end.line,I.end.character)}function P(I){return new y.Range(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn)}let s=class{constructor(l,g){this.prefix=l,this.logService=g}appendLine(l){this.logService.debug(`${this.prefix}#search`,l)}};s=Ve([We(1,R.ILogService)],s),e.OutputChannel=s}),define(ge[258],pe([0,1,92,22]),function(X,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function k(t){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(r=>r===t)}e.isUTFEncoding=k,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const y=512,A=512,C=512*8,D=512*128;class P{constructor(r){this.iconvLiteDecoder=r}static async create(r){let i;if(r!==e.UTF8)i=(await new Promise((a,p)=>{X(["iconv-lite-umd"],a,p)})).getDecoder(g(r));else{const n=new TextDecoder;i={write(a){return n.decode(a,{stream:!0})},end(){return n.decode()}}}return new P(i)}write(r){return this.iconvLiteDecoder.write(r)}end(){return this.iconvLiteDecoder.end()}}function s(t,r){var i;const n=((i=r.minBytesRequiredForDetection)!==null&&i!==void 0?i:r.guessEncoding)?C:A;return new Promise((a,p)=>{const d=v.newWriteableStream(O=>O.join("")),b=[];let S=0,o;const L=async()=>{try{const O=await m({buffer:R.VSBuffer.concat(b),bytesRead:S},r.guessEncoding);O.encoding=await r.overwriteEncoding(O.encoding),o=await P.create(O.encoding);const W=o.write(R.VSBuffer.concat(b).buffer);d.write(W),b.length=0,S=0,a({stream:d,detected:O})}catch(O){p(O)}};v.listenStream(t,{onData:async O=>{o?d.write(o.write(O.buffer)):(b.push(O),S+=O.byteLength,S>=n&&(t.pause(),await L(),setTimeout(()=>t.resume())))},onError:O=>d.error(O),onEnd:async()=>{o||await L(),d.end(o==null?void 0:o.end())}})})}e.toDecodeStream=s;async function I(t,r,i){const a=(await new Promise((b,S)=>{X(["iconv-lite-umd"],b,S)})).getEncoder(g(r),i);let p=!1,d=!1;return{read(){if(d)return null;const b=t.read();if(typeof b!="string"){if(d=!0,!p&&(i==null?void 0:i.addBOM))switch(r){case e.UTF8:case e.UTF8_with_bom:return R.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return R.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return R.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const S=a.end();return S&&S.length>0?(p=!0,R.VSBuffer.wrap(S)):null}return p=!0,R.VSBuffer.wrap(a.write(b))}}}e.toEncodeReadable=I;async function l(t){return(await new Promise((i,n)=>{X(["iconv-lite-umd"],i,n)})).encodingExists(g(t))}e.encodingExists=l;function g(t){return t===e.UTF8_with_bom||t===null?e.UTF8:t}e.toNodeEncoding=g;function c(t,r){if(!t||r<e.UTF16be_BOM.length)return null;const i=t.readUInt8(0),n=t.readUInt8(1);if(i===e.UTF16be_BOM[0]&&n===e.UTF16be_BOM[1])return e.UTF16be;if(i===e.UTF16le_BOM[0]&&n===e.UTF16le_BOM[1])return e.UTF16le;if(r<e.UTF8_BOM.length)return null;const a=t.readUInt8(2);return i===e.UTF8_BOM[0]&&n===e.UTF8_BOM[1]&&a===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=c;const f=["ascii","utf-16","utf-32"];async function _(t){const r=await new Promise((d,b)=>{X(["jschardet"],d,b)}),i=t.slice(0,D),n=u(i.buffer),a=r.detect(n);if(!a||!a.encoding)return null;const p=a.encoding.toLowerCase();return 0<=f.indexOf(p)?null:E(a.encoding)}const w={ibm866:"cp866",big5:"cp950"};function E(t){const r=t.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return w[r]||r}function u(t){let r="";for(let i=0;i<t.length;i++)r+=String.fromCharCode(t[i]);return r}function h(t){switch(t){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:const r=t.match(/windows(\d+)/);return r?"windows-"+r[1]:t}}e.toCanonicalName=h;function m({buffer:t,bytesRead:r},i){let n=c(t,r),a=!1;if(n!==e.UTF16be&&n!==e.UTF16le&&t){let p=!0,d=!0,b=!1;for(let S=0;S<r&&S<y;S++){const o=S%2==1,L=t.readUInt8(S)===0;if(L&&(b=!0),p&&(o&&!L||!o&&L)&&(p=!1),d&&(o&&L||!o&&!L)&&(d=!1),L&&!p&&!d)break}b&&(p?n=e.UTF16le:d?n=e.UTF16be:a=!0)}return i&&!a&&!n&&t?_(t.slice(0,r)).then(p=>({seemsBinary:!1,encoding:p})):{seemsBinary:a,encoding:n}}e.detectEncodingFromBuffer=m,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(ge[128],pe([0,1,258,28,127]),function(X,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class y extends k.TextSearchManager{constructor(C,D,P=R){super(C,D,{readdir:s=>P.readdir(s.fsPath),toCanonicalName:s=>v.toCanonicalName(s)})}}e.NativeTextSearchManager=y}),define(ge[259],pe([0,1,260,274,275,2,276]),function(X,e,v,R,k,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function C(I,l,g,c,f,_){const w=_.environment.useHostProxy,E=typeof w=="boolean"?w:!_.remote.isRemote,u=A.createProxyResolver({resolveProxy:m=>I.resolveProxy(m),getHttpProxySetting:()=>l.getConfiguration("http").get("proxy"),log:(m,t,...r)=>{switch(m){case A.LogLevel.Trace:c.trace(t,...r);break;case A.LogLevel.Debug:c.debug(t,...r);break;case A.LogLevel.Info:c.info(t,...r);break;case A.LogLevel.Warning:c.warn(t,...r);break;case A.LogLevel.Error:c.error(t,...r);break;case A.LogLevel.Critical:c.critical(t,...r);break;case A.LogLevel.Off:break;default:i(m,t,r);break}function i(n,a,...p){c.error("Unknown log level",n),c.error(a,...p)}},getLogLevel:()=>c.getLevel(),proxyResolveTelemetry:m=>{f.$publicLog2("resolveProxy",m)},useHostProxy:E,env:process.env}),h=D(l,u);return s(g,h)}e.connectProxyResolver=C;function D(I,l){const g={config:I.getConfiguration("http").get("proxySupport")||"off"};I.onDidChangeConfiguration(f=>{g.config=I.getConfiguration("http").get("proxySupport")||"off"});const c={config:!!I.getConfiguration("http").get("systemCertificates")};return I.onDidChangeConfiguration(f=>{c.config=!!I.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},v,A.createHttpPatch(v,l,{config:"off"},c,!0)),on:Object.assign({},v,A.createHttpPatch(v,l,{config:"on"},c,!0)),override:Object.assign({},v,A.createHttpPatch(v,l,{config:"override"},c,!0)),onRequest:Object.assign({},v,A.createHttpPatch(v,l,g,c,!0)),default:Object.assign(v,A.createHttpPatch(v,l,g,c,!1))},https:{off:Object.assign({},R,A.createHttpPatch(R,l,{config:"off"},c,!0)),on:Object.assign({},R,A.createHttpPatch(R,l,{config:"on"},c,!0)),override:Object.assign({},R,A.createHttpPatch(R,l,{config:"override"},c,!0)),onRequest:Object.assign({},R,A.createHttpPatch(R,l,g,c,!0)),default:Object.assign(R,A.createHttpPatch(R,l,g,c,!1))},tls:Object.assign(k,A.createTlsPatch(k))}}const P=new Map;function s(I,l){return I.getExtensionPathIndex().then(g=>{const c=X.__$__nodeRequire("module"),f=c._load;c._load=function(w,E,u){if(w==="tls")return l.tls;if(w!=="http"&&w!=="https")return f.apply(this,arguments);const h=l[w],m=g.findSubstr(y.URI.file(E.filename).fsPath);let t=P.get(m);if(t||P.set(m,t={}),!t[w]){let r=h.default;m&&m.enableProposedApi&&(r=h[m.proxySupport]||h.onRequest),t[w]=Object.assign({},r)}return t[w]}})}}),define(ge[261],pe([0,1,38,9,75,29,11,8,90,262]),function(X,e,v,R,k,y,A,C,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const s=P.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function I(u,h,m,t){const r=l(u,h,m,t),i=h.folder.fsPath;return{cmd:v.spawn(s,r.args,{cwd:i}),rgDiskPath:s,siblingClauses:r.siblingClauses,rgArgs:r,cwd:i}}e.spawnRipgrepCmd=I;function l(u,h,m,t){const r=["--files","--hidden","--case-sensitive"];c([h],m,!1).forEach(n=>{const a=D.anchorGlob(n);if(r.push("-g",a),A.isMacintosh){const p=k.normalizeNFD(a);p!==a&&r.push("-g",p)}});const i=g([h],t,void 0,!1);return i.globArgs.forEach(n=>{const a=`!${D.anchorGlob(n)}`;if(r.push("-g",a),A.isMacintosh){const p=k.normalizeNFD(a);p!==a&&r.push("-g",p)}}),h.disregardIgnoreFiles!==!1?r.push("--no-ignore"):r.push("--no-ignore-parent"),h.ignoreSymlinks||r.push("--follow"),u.exists&&r.push("--quiet"),r.push("--no-config"),h.disregardGlobalIgnoreFiles&&r.push("--no-ignore-global"),{args:r,siblingClauses:i.siblingClauses}}function g(u,h,m,t=!0){const r=[];let i={};return u.forEach(n=>{const a=Object.assign({},n.excludePattern||{},h||{}),p=f(a,t?n.folder.fsPath:void 0,m);r.push(...p.globArgs),p.siblingClauses&&(i=Object.assign(i,p.siblingClauses))}),{globArgs:r,siblingClauses:i}}e.foldersToRgExcludeGlobs=g;function c(u,h,m=!0){const t=[];return u.forEach(r=>{const i=Object.assign({},h||{},r.includePattern||{}),n=f(i,m?r.folder.fsPath:void 0);t.push(...n.globArgs)}),t}e.foldersToIncludeGlobs=c;function f(u,h,m){const t=[],r={};return Object.keys(u).forEach(i=>{if(m&&m.has(i)||!i)return;const n=u[i];i=w(h?_(h,i):i),i.startsWith("\\\\")?i="\\\\"+i.substr(2).replace(/\\/g,"/"):i=i.replace(/\\/g,"/"),typeof n=="boolean"&&n?(i.startsWith("\\\\")&&(i+="**"),t.push(E(i))):n&&n.when&&(r[i]=n)}),{globArgs:t,siblingClauses:r}}function _(u,h){return R.isAbsolute(h)?h:R.join(u,h)}e.getAbsoluteGlob=_;function w(u){return u=C.rtrim(u,"\\"),C.rtrim(u,"/")}function E(u){return y.getRoot(u).toLowerCase()==="c:/"?u.replace(/^c:[/\\]/i,"/"):u}e.fixDriveC=E}),define(ge[263],pe([0,1,38,54,9,99,17,55,30,75,29,11,43,8,13,28,31,261,97]),function(X,e,v,R,k,y,A,C,D,P,s,I,l,g,c,f,_,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const u=new Set;process.on("exit",()=>{u.forEach(i=>i())});class h{constructor(n){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=n,this.filePattern=n.filePattern||"",this.includePattern=n.includePattern&&D.parse(n.includePattern),this.maxResults=n.maxResults||null,this.exists=!!n.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=E.prepareQuery(this.filePattern).normalizedLowercase),this.globalExcludePattern=n.excludePattern&&D.parse(n.excludePattern),this.folderExcludePatterns=new Map,n.folderQueries.forEach(a=>{const p=Object.assign({},a.excludePattern||{},this.config.excludePattern||{}),d=a.folder.fsPath;n.folderQueries.map(b=>b.folder.fsPath).filter(b=>b!==d).forEach(b=>{s.isEqualOrParent(b,d)&&(p[k.relative(d,b)]=!0)}),this.folderExcludePatterns.set(d,new t(p,d))})}cancel(){this.isCanceled=!0}walk(n,a,p,d,b){if(this.fileWalkSW=l.StopWatch.create(!1),this.isCanceled)return b(null,this.isLimitHit);a.forEach(S=>{const o=k.basename(S.fsPath);this.globalExcludePattern&&this.globalExcludePattern(S.fsPath,o)||this.matchFile(p,{relativePath:S.fsPath,searchPath:void 0})}),this.cmdSW=l.StopWatch.create(!1),this.parallel(n,(S,o)=>{this.call(this.cmdTraversal,this,S,p,d,L=>{if(L){const O=C.toErrorMessage(L);console.error(O),this.errors.push(O),o(L,void 0)}else o(null,void 0)})},(S,o)=>{this.fileWalkSW.stop();const L=S?A.coalesce(S)[0]:null;b(L,this.isLimitHit)})}parallel(n,a,p){const d=new Array(n.length),b=new Array(n.length);let S=!1,o=0;if(n.length===0)return p(null,[]);n.forEach((L,O)=>{a(L,(W,J)=>{if(W?(S=!0,d[O]=null,b[O]=W):(d[O]=J,b[O]=null),++o===n.length)return p(S?b:null,d)})})}call(n,a,...p){try{n.apply(a,p)}catch(d){p[p.length-1](d)}}cmdTraversal(n,a,p,d){const b=n.folder.fsPath,S=I.isMacintosh;let o;const L=()=>o&&o.kill();u.add(L);let O=T=>{u.delete(L),O=()=>{},d(T)},W="";const J=this.initDirectoryTree();let oe;const q=w.spawnRipgrepCmd(this.config,n,this.config.includePattern,this.folderExcludePatterns.get(n.folder.fsPath).expression);o=q.cmd,oe=!Object.keys(q.siblingClauses).length;const x=q.rgArgs.args.map(T=>T.match(/^-/)?T:`'${T}'`).join(" ");let V=`${q.rgDiskPath} ${x}
 - cwd: ${q.cwd}`;q.rgArgs.siblingClauses&&(V+=`
 - Sibling clauses: ${JSON.stringify(q.rgArgs.siblingClauses)}`),p({message:V}),this.cmdResultCount=0,this.collectStdout(o,"utf8",p,(T,N,F)=>{if(T){O(T);return}if(this.isLimitHit){O();return}const U=(W+(S?P.normalizeNFC(N||""):N)).split(`
`);if(F){const B=U.length;U[B-1]=U[B-1].trim(),U[B-1]||U.pop()}else W=U.pop()||"";if(U.length&&U[0].indexOf(`
`)!==-1){O(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=U.length,oe){for(const B of U)if(this.matchFile(a,{base:b,relativePath:B,searchPath:this.getSearchPath(n,B)}),this.isLimitHit){L();break}(F||this.isLimitHit)&&O();return}this.addDirectoryEntries(n,J,b,U,a),F&&(this.matchDirectoryTree(J,b,a),O())})}spawnFindCmd(n){const a=this.folderExcludePatterns.get(n.folder.fsPath),p=a.getBasenameTerms(),d=a.getPathTerms(),b=["-L","."];if(p.length||d.length){b.push("-not","(","(");for(const S of p)b.push("-name",S),b.push("-o");for(const S of d)b.push("-path",S),b.push("-o");b.pop(),b.push(")","-prune",")")}return b.push("-type","f"),v.spawn("find",b,{cwd:n.folder.fsPath})}readStdout(n,a,p){let d="";this.collectStdout(n,a,()=>{},(b,S,o)=>{if(b){p(b);return}d+=S,o&&p(null,d)})}collectStdout(n,a,p,d){let b=(L,O,W)=>{(L||W)&&(b=()=>{},this.cmdSW&&this.cmdSW.stop()),d(L,O,W)},S=!1;n.stdout?(this.forwardData(n.stdout,a,b),n.stdout.once("data",()=>S=!0)):p({message:"stdout is null"});let o;n.stderr?o=this.collectData(n.stderr):p({message:"stderr is null"}),n.on("error",L=>{b(L)}),n.on("close",L=>{let O;!S&&(O=this.decodeData(o,a))&&r(O)?b(new Error(`command failed with error code ${L}: ${this.decodeData(o,a)}`)):(this.exists&&L===0&&(this.isLimitHit=!0),b(null,"",!0))})}forwardData(n,a,p){const d=new y.StringDecoder(a);return n.on("data",b=>{p(null,d.write(b))}),d}collectData(n){const a=[];return n.on("data",p=>{a.push(p)}),a}decodeData(n,a){const p=new y.StringDecoder(a);return n.map(d=>p.write(d)).join("")}initDirectoryTree(){const n={rootEntries:[],pathToEntries:Object.create(null)};return n.pathToEntries["."]=n.rootEntries,n}addDirectoryEntries(n,{pathToEntries:a},p,d,b){d.indexOf(this.filePattern)!==-1&&this.matchFile(b,{base:p,relativePath:this.filePattern,searchPath:this.getSearchPath(n,this.filePattern)});const S=o=>{const L=k.basename(o),O=k.dirname(o);let W=a[O];W||(W=a[O]=[],S(O)),W.push({base:p,relativePath:o,basename:L,searchPath:this.getSearchPath(n,o)})};d.forEach(S)}matchDirectoryTree({rootEntries:n,pathToEntries:a},p,d){const b=this,S=this.folderExcludePatterns.get(p),o=this.filePattern;function L(O){b.directoriesWalked++;const W=D.hasSiblingFn(()=>O.map(J=>J.basename));for(let J=0,oe=O.length;J<oe;J++){const q=O[J],{relativePath:x,basename:V}=q;if(S.test(x,V,o!==V?W:void 0))continue;const T=a[x];if(T)L(T);else{if(b.filesWalked++,x===o)continue;b.matchFile(d,q)}if(b.isLimitHit)break}}L(n)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(n,a,p,d,b){const S=n.folder,o=D.hasSiblingFn(()=>p);this.parallel(p,(L,O)=>{if(this.isCanceled||this.isLimitHit)return O(null);const W=a?[a,L].join(k.sep):L;if(this.folderExcludePatterns.get(n.folder.fsPath).test(W,L,this.config.filePattern!==L?o:void 0))return O(null);const J=[S.fsPath,W].join(k.sep);R.lstat(J,(oe,q)=>{if(oe||this.isCanceled||this.isLimitHit)return O(null);this.statLinkIfNeeded(J,q,(x,V)=>x||this.isCanceled||this.isLimitHit?O(null):V.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(J,q,(T,N)=>T||this.isCanceled||this.isLimitHit||(N=N||"",this.walkedPaths[N])?O(null):(this.walkedPaths[N]=!0,f.readdir(J).then(F=>{if(this.isCanceled||this.isLimitHit)return O(null);this.doWalk(n,W,F,d,M=>O(M||null))},F=>{O(null)})))):(this.filesWalked++,W===this.filePattern||this.maxFilesize&&c.isNumber(V.size)&&V.size>this.maxFilesize||this.matchFile(d,{base:S.fsPath,relativePath:W,searchPath:this.getSearchPath(n,W)}),O(null,void 0)))})},L=>{const O=L&&A.coalesce(L);return b(O&&O.length>0?O[0]:void 0)})}matchFile(n,a){this.isFileMatch(a)&&(!this.includePattern||this.includePattern(a.relativePath,k.basename(a.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||n(a))}isFileMatch(n){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return _.isFilePatternMatch(n,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(n,a,p){return a.isSymbolicLink()?R.stat(n,p):p(null,a)}realPathIfNeeded(n,a,p){return a.isSymbolicLink()?R.realpath(n,(d,b)=>d?p(d):p(null,b)):p(null,n)}getSearchPath(n,a){return n.folderName?k.join(n.folderName,a):a}}e.FileWalker=h;class m{constructor(n){this.folderQueries=n.folderQueries,this.extraFiles=n.extraFileResources||[],this.walker=new h(n)}search(n,a,p){this.walker.walk(this.folderQueries,this.extraFiles,n,a,(d,b)=>{p(d,{limitHit:b,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=m;class t{constructor(n,a){this.expression=n,this.root=a,this.init(n)}init(n){let a,p;Object.keys(n).filter(d=>n[d]).forEach(d=>{k.isAbsolute(d)?(a=a||D.getEmptyExpression(),a[d]=n[d]):(p=p||D.getEmptyExpression(),p[d]=n[d])}),this.absoluteParsedExpr=a&&D.parse(a,{trimForExclusions:!0}),this.relativeParsedExpr=p&&D.parse(p,{trimForExclusions:!0})}test(n,a,p){return this.relativeParsedExpr&&this.relativeParsedExpr(n,a,p)||this.absoluteParsedExpr&&this.absoluteParsedExpr(k.join(this.root,n),a,p)}getBasenameTerms(){const n=[];return this.absoluteParsedExpr&&n.push(...D.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&n.push(...D.getBasenameTerms(this.relativeParsedExpr)),n}getPathTerms(){const n=[];return this.absoluteParsedExpr&&n.push(...D.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&n.push(...D.getPathTerms(this.relativeParsedExpr)),n}}function r(i){const n=i.trim().split(`
`),a=n[0].trim();if(a.startsWith("Error parsing regex"))return a;if(a.startsWith("regex parse error"))return g.uppercaseFirstLetter(n[n.length-1].trim());if(a.startsWith("error parsing glob")||a.startsWith("unsupported encoding"))return a.charAt(0).toUpperCase()+a.substr(1);if(a==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(a.startsWith("Literal "))return a}e.rgErrorMsgForDisplay=r}),define(ge[129],pe([0,1,38,277,99,17,68,30,9,8,2,31,64,278,262,90]),function(X,e,v,R,k,y,A,C,D,P,s,I,l,g,c,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const _=c.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class w{constructor(S){this.outputChannel=S}provideTextSearchResults(S,o,L,O){return this.outputChannel.appendLine(`provideTextSearchResults ${S.pattern}, ${JSON.stringify(Object.assign(Object.assign({},o),{folder:o.folder.toString()}))}`),new Promise((W,J)=>{O.onCancellationRequested(()=>M());const oe=r(S,o),q=o.folder.fsPath,x=oe.map(we=>we.match(/^-/)?we:`'${we}'`).join(" ");this.outputChannel.appendLine(`${_} ${x}
 - cwd: ${q}`);let V=v.spawn(_,oe,{cwd:q});V.on("error",we=>{console.error(we),this.outputChannel.appendLine("Error: "+(we&&we.message)),J(I.serializeSearchError(new I.SearchError(we&&we.message,I.SearchErrorCode.rgProcessError)))});let T=!1;const N=new h(o.maxResults,q,o.previewOptions);N.on("result",we=>{T=!0,B="",L.report(we)});let F=!1;const M=()=>{F=!0,V&&V.kill(),N&&N.cancel()};let U=!1;N.on("hitLimit",()=>{U=!0,M()});let B="";V.stdout.on("data",we=>{N.handleData(we),T||(B+=we)});let K=!1;V.stdout.once("data",()=>K=!0);let ie="";V.stderr.on("data",we=>{const Te=we.toString();this.outputChannel.appendLine(Te),ie+=Te}),V.on("close",()=>{if(this.outputChannel.appendLine(K?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(T?"Got result from parser":"No result from parser"),B&&this.outputChannel.appendLine(`Got data without result: ${B}`),this.outputChannel.appendLine(""),F)W({limitHit:U});else{N.flush(),V=null;let we;ie&&!K&&(we=E(ie))?J(I.serializeSearchError(new I.SearchError(we.message,we.code))):W({limitHit:U})}})})}}e.RipgrepTextSearchEngine=w;function E(b){const S=b.split(`
`),o=S[0].trim();if(S.some(O=>O.startsWith("regex parse error")))return new I.SearchError(u(S),I.SearchErrorCode.regexParseError);const L=o.match(/grep config error: unknown encoding: (.*)/);if(L)return new I.SearchError(`Unknown encoding: ${L[1]}`,I.SearchErrorCode.unknownEncoding);if(o.startsWith("error parsing glob"))return new I.SearchError(o.charAt(0).toUpperCase()+o.substr(1),I.SearchErrorCode.globParseError);if(o.startsWith("the literal"))return new I.SearchError(o.charAt(0).toUpperCase()+o.substr(1),I.SearchErrorCode.invalidLiteral);if(o.startsWith("PCRE2: error compiling pattern"))return new I.SearchError(o,I.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=E;function u(b){const S=["Regex parse error"],o=b.filter(L=>L.startsWith("PCRE2:"));if(o.length>=1){const L=o[0].replace("PCRE2:","");if(L.indexOf(":")!==-1&&L.split(":").length>=2){const O=L.split(":")[1];S.push(":"+O)}}return S.join("")}e.buildRegexParseError=u;class h extends R.EventEmitter{constructor(S,o,L){super();this.maxResults=S,this.rootFolder=o,this.previewOptions=L,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new k.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(S,o){return super.on(S,o),this}handleData(S){if(this.isDone)return;const o=typeof S=="string"?S:this.stringDecoder.write(S);this.handleDecodedData(o)}handleDecodedData(S){let o=S.indexOf(`
`);const L=this.remainder+S;if(o>=0)o+=this.remainder.length;else{this.remainder=L;return}let O=0;for(;o>=0;)this.handleLine(L.substring(O,o).trim()),O=o+1,o=L.indexOf(`
`,O);this.remainder=L.substring(O)}handleLine(S){if(this.isDone||!S)return;let o;try{o=JSON.parse(S)}catch(L){throw new Error(`malformed line from rg: ${S}`)}if(o.type==="match"){const L=m(o.data.path),O=s.URI.file(D.join(this.rootFolder,L)),W=this.createTextSearchMatch(o.data,O);this.onResult(W),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(o.type==="context"){const L=m(o.data.path),O=s.URI.file(D.join(this.rootFolder,L));this.createTextSearchContext(o.data,O).forEach(J=>this.onResult(J))}}createTextSearchMatch(S,o){const L=S.line_number-1;let O=!1,W=m(S.lines);L===0&&P.startsWithUTF8BOM(W)&&(O=!0,W=P.stripUTF8BOM(W));const J=Buffer.from(W);let oe=0,q=0,x=L;S.submatches.length===0&&S.submatches.push(W.length?{start:0,end:1,match:{text:W[0]}}:{start:0,end:0,match:{text:""}});const V=y.coalesce(S.submatches.map((T,N)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);let F=m(T.match);L===0&&N===0&&O&&(F=P.stripUTF8BOM(F),T.start=T.start<=3?0:T.start-3,T.end=T.end<=3?0:T.end-3);const M=J.slice(oe,T.start).toString().length,U=q+M,B=t(F),K=x,ie=B.numLines+K,we=B.numLines>0?B.lastLineLength:B.lastLineLength+U;return oe=T.end,q=we,x=ie,new l.Range(K,U,ie,we)}));return f.createTextSearchResult(o,W,V,this.previewOptions)}createTextSearchContext(S,o){const L=m(S.lines),O=S.line_number;return L.replace(/\r?\n$/,"").split(`
`).map((W,J)=>({text:W,uri:o,lineNumber:O+J}))}onResult(S){this.emit("result",S)}}e.RipgrepParser=h;function m(b){return b.bytes?Buffer.from(b.bytes,"base64").toString():b.text}function t(b){const S=/\n/g;let o=0,L=-1,O;for(;O=S.exec(b);)o++,L=O.index;const W=L>=0?b.length-L-1:b.length;return{numLines:o,lastLineLength:W}}function r(b,S){const o=["--hidden"];o.push(b.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:L,otherIncludes:O}=A.groupBy(S.includes,J=>J.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(O&&O.length){const J=new Set;O.forEach(oe=>{J.add(oe)}),o.push("-g","!*"),J.forEach(oe=>{i(oe).map(f.anchorGlob).forEach(q=>{o.push("-g",q)})})}L&&L.length&&L.forEach(J=>{o.push("-g",J)}),S.excludes.map(f.anchorGlob).forEach(J=>o.push("-g",`!${J}`)),S.maxFileSize&&o.push("--max-filesize",S.maxFileSize+""),S.useIgnoreFiles?o.push("--no-ignore-parent"):o.push("--no-ignore"),S.followSymlinks&&o.push("--follow"),S.encoding&&S.encoding!=="utf8"&&o.push("--encoding",S.encoding),b.pattern==="--"&&(b.isRegExp=!0,b.pattern="\\-\\-"),b.isMultiline&&!b.isRegExp&&(b.pattern=P.escapeRegExpCharacters(b.pattern),b.isRegExp=!0),S.usePCRE2&&o.push("--pcre2"),o.push("--crlf"),b.isRegExp&&(b.pattern=n(b.pattern),o.push("--auto-hybrid-regex"));let W;if(b.isWordMatch){const oe=P.createRegExp(b.pattern,!!b.isRegExp,{wholeWord:b.isWordMatch}).source.replace(/\\\//g,"/");o.push("--regexp",oe)}else if(b.isRegExp){let J=p(b.pattern);J=d(J),o.push("--regexp",J)}else W=b.pattern,o.push("--fixed-strings");return o.push("--no-config"),S.useGlobalIgnoreFiles||o.push("--no-ignore-global"),o.push("--json"),b.isMultiline&&o.push("--multiline"),S.beforeContext&&o.push("--before-context",S.beforeContext+""),S.afterContext&&o.push("--after-context",S.afterContext+""),o.push("--"),W&&o.push(W),o.push("."),o}function i(b){const S=C.splitGlobAware(b,"/");return S.map((o,L)=>S.slice(0,L+1).join("/"))}e.spreadGlobComponents=i;function n(b){const S=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;b.match(S);)b=b.replace(S,"$1\\x{$2}");const o=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;b.match(o);)b=b.replace(o,"$1\\x{$2}");return b}e.unicodeEscapesToPCRE2=n;const a=b=>b.type==="Assertion"&&b.kind==="lookbehind";function p(b){let S;try{S=new g.RegExpParser().parsePattern(b)}catch(oe){return b}let o="",L=0;const O=(oe,q,x)=>{o+=b.slice(L,oe)+x,L=q},W=[];return new g.RegExpVisitor({onCharacterEnter(oe){if(oe.raw!=="\\n")return;const q=W[0];if(!q)O(oe.start,oe.end,"\\r?\\n");else if(!W.some(a))if(q.type==="CharacterClass")if(q.negate){const x=b.slice(q.start+2,oe.start)+b.slice(oe.end,q.end-1);O(q.start,q.end,"(?!\\r?\\n"+(x?`|[${x}]`:"")+")")}else{const x=b.slice(q.start+1,oe.start)+b.slice(oe.end,q.end-1);O(q.start,q.end,x===""?"\\r?\\n":`(?:[${x}]|\\r?\\n)`)}else q.type==="Quantifier"&&O(oe.start,oe.end,"(?:\\r?\\n)")},onQuantifierEnter(oe){W.unshift(oe)},onQuantifierLeave(){W.shift()},onCharacterClassRangeEnter(oe){W.unshift(oe)},onCharacterClassRangeLeave(){W.shift()},onCharacterClassEnter(oe){W.unshift(oe)},onCharacterClassLeave(){W.shift()},onAssertionEnter(oe){a(oe)&&W.push(oe)},onAssertionLeave(oe){W[0]===oe&&W.shift()}}).visit(S),o+=b.slice(L),o}e.fixRegexNewline=p;function d(b){return b.replace(/\n/g,"\\r?\\n")}e.fixNewline=d}),define(ge[264],pe([0,1,21,129,114,10]),function(X,e,v,R,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class A{constructor(P){this.outputChannel=P,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(P,s,I,l){const g=new R.RipgrepTextSearchEngine(this.outputChannel);if(s.folder.scheme===y.Schemas.userData){const c=Object.assign(Object.assign({},s),{folder:s.folder.with({scheme:y.Schemas.file})}),f=new k.Progress(_=>I.report(Object.assign(Object.assign({},_),{uri:_.uri.with({scheme:s.folder.scheme})})));return this.withToken(l,_=>g.provideTextSearchResults(P,c,f,_))}else return this.withToken(l,c=>g.provideTextSearchResults(P,s,I,c))}async withToken(P,s){const I=C(P);this.inProgress.add(I);const l=await s(I.token);return this.inProgress.delete(I),l}dispose(){this.inProgress.forEach(P=>P.cancel())}}e.RipgrepSearchProvider=A;function C(D){const P=new v.CancellationTokenSource;return D.onCancellationRequested(()=>P.cancel()),P}}),define(ge[265],pe([0,1,28,129,128]),function(X,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class y{constructor(D){this.query=D}search(D,P,s){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const I={appendLine(g){s({message:g})}},l=new k.NativeTextSearchManager(this.query,new R.RipgrepTextSearchEngine(I),v);return new Promise((g,c)=>l.search(f=>{P(f.map(A))},D).then(f=>g({limitHit:f.limitHit,type:"success"}),c))}}e.TextSearchEngineAdapter=y;function A(C){return{path:C.resource&&C.resource.fsPath,results:C.results,numMatches:(C.results||[]).reduce((D,P)=>{if(P.ranges){const s=P;return D+(Array.isArray(s.ranges)?s.ranges.length:1)}else return D+1},0)}}}),define(ge[266],pe([0,1,54,279,17,14,16,3,97,9,43,2,42,31,263,265]),function(X,e,v,R,k,y,A,C,D,P,s,I,l,g,c,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0,R.gracefulify(v);class _{constructor(){this.caches=Object.create(null)}fileSearch(t){let r;const i=u(t),n=new C.Emitter({onFirstListenerDidAdd:()=>{r=y.createCancelablePromise(a=>this.doFileSearchWithEngine(c.Engine,i,p=>n.fire(p),a)),r.then(a=>n.fire(a),a=>n.fire({type:"error",error:{message:a.message,stack:a.stack}}))},onLastListenerRemove:()=>{r.cancel()}});return n.event}textSearch(t){let r;const i=u(t),n=new C.Emitter({onFirstListenerDidAdd:()=>{r=y.createCancelablePromise(a=>this.ripgrepTextSearch(i,p=>n.fire(p),a)),r.then(a=>n.fire(a),a=>n.fire({type:"error",error:{message:a.message,stack:a.stack}}))},onLastListenerRemove:()=>{r.cancel()}});return n.event}ripgrepTextSearch(t,r,i){return t.maxFileSize=l.getPlatformLimits(process.arch==="ia32"?0:1).maxFileSize,new f.TextSearchEngineAdapter(t).search(i,r,r)}doFileSearch(t,r,i){return this.doFileSearchWithEngine(c.Engine,t,r,i)}doFileSearchWithEngine(t,r,i,n,a=_.BATCH_SIZE){let p=0;const d=S=>{Array.isArray(S)?(p+=S.length,i(S.map(o=>this.rawMatchToSearchItem(o)))):S.relativePath?(p++,i(this.rawMatchToSearchItem(S))):i(S)};if(r.sortByScore){let S=this.trySortedSearchFromCache(r,d,n);if(!S){const o=r.maxResults?Object.assign({},r,{maxResults:null}):r,L=new t(o);S=this.doSortedSearch(L,r,i,d,n)}return new Promise((o,L)=>{S.then(([O,W])=>{const J=W.map(oe=>this.rawMatchToSearchItem(oe));this.sendProgress(J,i,a),o(O)},L)})}const b=new t(r);return this.doSearch(b,d,a,n).then(S=>({limitHit:S.limitHit,type:"success",stats:{detailStats:S.stats,type:"searchProcess",fromCache:!1,resultCount:p,sortingTime:void 0}}))}rawMatchToSearchItem(t){return{path:t.base?P.join(t.base,t.relativePath):t.relativePath}}doSortedSearch(t,r,i,n,a){const p=new C.Emitter;let d=y.createCancelablePromise(S=>{let o=[];const L=O=>{Array.isArray(O)?o=O:(n(O),p.fire(O))};return this.doSearch(t,L,-1,S).then(O=>[O,o])}),b;if(r.cacheKey){b=this.getOrCreateCache(r.cacheKey);const S={promise:d,event:p.event,resolved:!1};b.resultsToSearchCache[r.filePattern||""]=S,d.then(()=>{S.resolved=!0},o=>{delete b.resultsToSearchCache[r.filePattern||""]}),d=this.preventCancellation(d)}return d.then(([S,o])=>{const L=b?b.scorerCache:Object.create(null),O=(typeof r.maxResults!="number"||r.maxResults>0)&&s.StopWatch.create(!1);return this.sortResults(r,o,L,a).then(W=>{const J=O?O.elapsed():-1;return[{type:"success",stats:{detailStats:S.stats,sortingTime:J,fromCache:!1,type:"searchProcess",workspaceFolderCount:r.folderQueries.length,resultCount:W.length},messages:S.messages,limitHit:S.limitHit||typeof r.maxResults=="number"&&o.length>r.maxResults},W]})})}getOrCreateCache(t){const r=this.caches[t];return r||(this.caches[t]=new w)}trySortedSearchFromCache(t,r,i){const n=t.cacheKey&&this.caches[t.cacheKey];if(!n)return;const a=this.getResultsFromCache(n,t.filePattern||"",r,i);if(a)return a.then(([p,d,b])=>{const S=s.StopWatch.create(!1);return this.sortResults(t,d,n.scorerCache,i).then(o=>{const L=S.elapsed(),O={fromCache:!0,detailStats:b,type:"searchProcess",resultCount:d.length,sortingTime:L};return[{type:"success",limitHit:p.limitHit||typeof t.maxResults=="number"&&d.length>t.maxResults,stats:O},o]})})}sortResults(t,r,i,n){const a=D.prepareQuery(t.filePattern||""),p=(b,S)=>D.compareItemsByFuzzyScore(b,S,a,!0,E,i),d=typeof t.maxResults=="number"?t.maxResults:Number.MAX_VALUE;return k.topAsync(r,p,d,1e4,n)}sendProgress(t,r,i){if(i&&i>0)for(let n=0;n<t.length;n+=i)r(t.slice(n,n+i));else r(t)}getResultsFromCache(t,r,i,n){const a=s.StopWatch.create(!1),p=r.indexOf(P.sep)>=0;let d;for(const L in t.resultsToSearchCache)if(r.startsWith(L)){if(p&&L.indexOf(P.sep)<0&&L!=="")continue;const O=t.resultsToSearchCache[L];d={promise:this.preventCancellation(O.promise),event:O.event,resolved:O.resolved};break}if(!d)return null;const b=a.elapsed(),S=s.StopWatch.create(!1),o=d.event(i);return n&&n.onCancellationRequested(()=>{o.dispose()}),d.promise.then(([L,O])=>{if(n&&n.isCancellationRequested)throw A.canceled();const W=[],J=D.prepareQuery(r).normalizedLowercase;for(const oe of O)!g.isFilePatternMatch(oe,J)||W.push(oe);return[L,W,{cacheWasResolved:d.resolved,cacheLookupTime:b,cacheFilterTime:S.elapsed(),cacheEntryCount:O.length}]})}doSearch(t,r,i,n){return new Promise((a,p)=>{let d=[];n&&n.onCancellationRequested(()=>t.cancel()),t.search(b=>{b&&(i?(d.push(b),i>0&&d.length>=i&&(r(d),d=[])):r(b))},b=>{r(b)},(b,S)=>{d.length&&r(d),b?p(b):a(S)})})}clearCache(t){return delete this.caches[t],Promise.resolve(void 0)}preventCancellation(t){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(r,i){return t.then(r,i)}catch(r){return this.then(void 0,r)}finally(r){return t.finally(r)}}}}e.SearchService=_,_.BATCH_SIZE=512;class w{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const E=new class{getItemLabel(m){return P.basename(m.relativePath)}getItemDescription(m){return P.dirname(m.relativePath)}getItemPath(m){return m.relativePath}};function u(m){return Object.assign(Object.assign({},m),{folderQueries:m.folderQueries&&m.folderQueries.map(h),extraFileResources:m.extraFileResources&&m.extraFileResources.map(t=>I.URI.revive(t))})}function h(m){return Object.assign(Object.assign({},m),{folder:I.URI.revive(m.folder)})}}),define(ge[267],pe([0,1,6,2,28,15,31,266,264,90,12,59,27,67,10,128]),function(X,e,v,R,k,y,A,C,D,P,s,I,l,g,c,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let _=class extends g.ExtHostSearch{constructor(E,u,h,m){super(E,h,m);this._pfs=k,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null;const t=new P.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(c.Schemas.userData,new D.RipgrepSearchProvider(t)),u.remote.isRemote&&u.remote.authority&&this._registerEHSearchProviders()}_registerEHSearchProviders(){const E=new P.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(c.Schemas.file,new D.RipgrepSearchProvider(E)),this.registerInternalFileSearchProvider(c.Schemas.file,new C.SearchService)}registerInternalFileSearchProvider(E,u){const h=this._handlePool++;return this._internalFileSearchProvider=u,this._internalFileSearchHandle=h,this._proxy.$registerFileSearchProvider(h,this._transformScheme(E)),v.toDisposable(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(h)})}$provideFileSearchResults(E,u,h,m){const t=g.reviveQuery(h);return E===this._internalFileSearchHandle?this.doInternalFileSearch(E,u,t,m):super.$provideFileSearchResults(E,u,h,m)}doInternalFileSearch(E,u,h,m){const t=r=>{if(A.isSerializedFileMatch(r)&&(r=[r]),Array.isArray(r)){this._proxy.$handleFileMatch(E,u,r.map(i=>R.URI.file(i.path)));return}r.message&&this._logService.debug("ExtHostSearch",r.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(h,t,m)}$clearCache(E){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(E),super.$clearCache(E)}createTextSearchManager(E,u){return new f.NativeTextSearchManager(E,u)}};_=Ve([We(0,s.IExtHostRpcService),We(1,l.IExtHostInitDataService),We(2,I.IURITransformerService),We(3,y.ILogService)],_),e.NativeExtHostSearch=_}),define(ge[130],pe([0,1,280,120,281,3,102,9,100,32,6,22,103,16,11]),function(X,e,v,R,k,y,A,C,D,P,s,I,l,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class f{constructor(d){this.socket=d,this._errorListener=b=>{if(b){if(b.code==="EPIPE")return;g.onUnexpectedError(b)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(d){const b=S=>d(I.VSBuffer.wrap(S));return this.socket.on("data",b),{dispose:()=>this.socket.off("data",b)}}onClose(d){return this.socket.on("close",d),{dispose:()=>this.socket.off("close",d)}}onEnd(d){return this.socket.on("end",d),{dispose:()=>this.socket.off("end",d)}}write(d){if(!this.socket.destroyed)try{this.socket.write(d.buffer,b=>{if(b){if(b.code==="EPIPE")return;g.onUnexpectedError(b)}})}catch(b){if(b.code==="EPIPE")return;g.onUnexpectedError(b)}}end(){this.socket.end()}drain(){return new Promise((d,b)=>{if(this.socket.bufferSize===0){d();return}const S=()=>{this.socket.off("close",S),this.socket.off("end",S),this.socket.off("error",S),this.socket.off("timeout",S),this.socket.off("drain",S),d()};this.socket.on("close",S),this.socket.on("end",S),this.socket.on("error",S),this.socket.on("timeout",S),this.socket.on("drain",S)})}}e.NodeSocket=f;var _;(function(p){p[p.MinHeaderByteSize=2]="MinHeaderByteSize"})(_||(_={}));var w;(function(p){p[p.PeekHeader=1]="PeekHeader",p[p.ReadHeader=2]="ReadHeader",p[p.ReadBody=3]="ReadBody",p[p.Fin=4]="Fin"})(w||(w={}));class E extends s.Disposable{constructor(d,b,S,o){super();this._onDidZlibFlush=this._register(new y.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new y.Emitter),this._onClose=this._register(new y.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=d,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=b,this._recordInflateBytes=o,b?(this._zlibInflate=k.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",L=>{console.error(L),g.onUnexpectedError(L),this._onClose.fire()}),this._zlibInflate.on("data",L=>{this._pendingInflateData.push(L)}),S&&(this._zlibInflate.write(S.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=k.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",L=>{console.error(L),g.onUnexpectedError(L),this._onClose.fire()}),this._zlibDeflate.on("data",L=>{this._pendingDeflateData.push(L)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new l.ChunkStream,this._register(this.socket.onData(L=>this._acceptChunk(L))),this._register(this.socket.onClose(()=>this._onClose.fire()))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?I.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):I.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(d){return this._onData.event(d)}onClose(d){return this._onClose.event(d)}onEnd(d){return this.socket.onEnd(d)}write(d){this._totalOutgoingDataBytes+=d.byteLength,this._zlibDeflate?(this._zlibDeflate.write(d.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let b=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,b=b.slice(0,b.length-4),this._isEnded||this._write(I.VSBuffer.wrap(b),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(d,!1)}_write(d,b){let S=2;d.byteLength<126?S+=0:d.byteLength<2**16?S+=2:S+=8;const o=I.VSBuffer.alloc(S);if(b?o.writeUInt8(194,0):o.writeUInt8(130,0),d.byteLength<126)o.writeUInt8(d.byteLength,1);else if(d.byteLength<2**16){o.writeUInt8(126,1);let L=1;o.writeUInt8(d.byteLength>>>8&255,++L),o.writeUInt8(d.byteLength>>>0&255,++L)}else{o.writeUInt8(127,1);let L=1;o.writeUInt8(0,++L),o.writeUInt8(0,++L),o.writeUInt8(0,++L),o.writeUInt8(0,++L),o.writeUInt8(d.byteLength>>>24&255,++L),o.writeUInt8(d.byteLength>>>16&255,++L),o.writeUInt8(d.byteLength>>>8&255,++L),o.writeUInt8(d.byteLength>>>0&255,++L)}this._totalOutgoingWireBytes+=o.byteLength+d.byteLength,this.socket.write(I.VSBuffer.concat([o,d]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(d){if(d.byteLength!==0){for(this._totalIncomingWireBytes+=d.byteLength,this._incomingData.acceptChunk(d);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const b=this._incomingData.peek(this._state.readLen),o=(b.readUInt8(0)&128)>>>7,L=b.readUInt8(1),O=(L&128)>>>7,W=L&127;this._state.state=2,this._state.readLen=2+(O?4:0)+(W===126?2:0)+(W===127?8:0),this._state.fin=o,this._state.mask=0}else if(this._state.state===2){const b=this._incomingData.read(this._state.readLen),S=b.readUInt8(1),o=(S&128)>>>7;let L=S&127,O=1;L===126?L=b.readUInt8(++O)*2**8+b.readUInt8(++O):L===127&&(L=b.readUInt8(++O)*0+b.readUInt8(++O)*0+b.readUInt8(++O)*0+b.readUInt8(++O)*0+b.readUInt8(++O)*2**24+b.readUInt8(++O)*2**16+b.readUInt8(++O)*2**8+b.readUInt8(++O));let W=0;o&&(W=b.readUInt8(++O)*2**24+b.readUInt8(++O)*2**16+b.readUInt8(++O)*2**8+b.readUInt8(++O)),this._state.state=3,this._state.readLen=L,this._state.mask=W}else if(this._state.state===3){const b=this._incomingData.read(this._state.readLen);u(b,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(b.buffer)),this._zlibInflate.write(b.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const S=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=S.length,this._onData.fire(I.VSBuffer.wrap(S))})):(this._totalIncomingDataBytes+=b.byteLength,this._onData.fire(b))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await y.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=E;function u(p,d){if(d===0)return;let b=p.byteLength>>>2;for(let J=0;J<b;J++){const oe=p.readUInt32BE(J*4);p.writeUInt32BE(oe^d,J*4)}let S=b*4,o=p.byteLength-S;const L=d>>>24&255,O=d>>>16&255,W=d>>>8&255;o>=1&&p.writeUInt8(p.readUInt8(S)^L,S),o>=2&&p.writeUInt8(p.readUInt8(S+1)^O,S+1),o>=3&&p.writeUInt8(p.readUInt8(S+2)^W,S+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const h={[2]:107,[1]:103};function m(){const p=P.generateUuid();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${p}-sock`;let d;return e.XDG_RUNTIME_DIR?d=C.join(e.XDG_RUNTIME_DIR,`vscode-ipc-${p}.sock`):d=C.join(D.tmpdir(),`vscode-ipc-${p}.sock`),r(d),d}e.createRandomIPCHandle=m;function t(p,d,b){const S=v.createHash("md5").update(p).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${S}-${b}-${d}-sock`;let o;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?o=C.join(e.XDG_RUNTIME_DIR,`vscode-${S.substr(0,8)}-${b}-${d}.sock`):o=C.join(p,`${b}-${d}.sock`),r(o),o}e.createStaticIPCHandle=t;function r(p){const d=h[c.platform];typeof d=="number"&&p.length>=d&&console.warn(`WARNING: IPC handle "${p}" is longer than ${d} chars, try a shorter --user-data-dir`)}class i extends A.IPCServer{constructor(d){super(i.toClientConnectionEvent(d));this.server=d}static toClientConnectionEvent(d){const b=y.Event.fromNodeEventEmitter(d,"connection");return y.Event.map(b,S=>({protocol:new l.Protocol(new f(S)),onDidClientDisconnect:y.Event.once(y.Event.fromNodeEventEmitter(S,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=i;function n(p){return new Promise((d,b)=>{const S=R.createServer();S.on("error",b),S.listen(p,()=>{S.removeListener("error",b),d(new i(S))})})}e.serve=n;function a(p,d){return new Promise((b,S)=>{const o=R.createConnection(p,()=>{o.removeListener("error",S),b(l.Client.fromSocket(new f(o),d))});o.once("error",S)})}e.connect=a}),define(ge[268],pe([0,1,130,260,54,47,2,188,15]),function(X,e,v,R,k,y,A,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class P{constructor(l,g,c){this._commands=l,this.logService=g,this._ipcHandlePath=c,this._server=R.createServer((f,_)=>this.onRequest(f,_)),this.setup().catch(f=>(g.error(f),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",l=>this.logService.error(l))}catch(l){this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(l,g){const c=[];l.setEncoding("utf8"),l.on("data",f=>c.push(f)),l.on("end",()=>{const f=JSON.parse(c.join(""));switch(f.type){case"open":this.open(f,g);break;case"openExternal":this.openExternal(f,g);break;case"status":this.getStatus(f,g);break;case"extensionManagement":this.manageExtensions(f,g).catch(this.logService.error);break;default:g.writeHead(404),g.write(`Unknown message type: ${f.type}`,_=>{_&&this.logService.error(_)}),g.end();break}})}open(l,g){let{fileURIs:c,folderURIs:f,forceNewWindow:_,diffMode:w,addMode:E,forceReuseWindow:u,gotoLineMode:h,waitMarkerFilePath:m}=l;const t=[];if(Array.isArray(f))for(const r of f)try{t.push({folderUri:A.URI.parse(r)})}catch(i){}if(Array.isArray(c))for(const r of c)try{C.hasWorkspaceFileExtension(r)?t.push({workspaceUri:A.URI.parse(r)}):t.push({fileUri:A.URI.parse(r)})}catch(i){}if(t.length){const r=m?A.URI.file(m):void 0,n={forceNewWindow:_,diffMode:w,addMode:E,gotoLineMode:h,forceReuseWindow:u,preferNewWindow:!u&&!r&&!E,waitMarkerFileURI:r};this._commands.executeCommand("_remoteCLI.windowOpen",t,n)}g.writeHead(200),g.end()}async openExternal(l,g){for(const c of l.uris){const f=A.URI.parse(c),_=f.scheme==="file"?f:c;await this._commands.executeCommand("_remoteCLI.openExternal",_)}g.writeHead(200),g.end()}async manageExtensions(l,g){try{const c=w=>w==null?void 0:w.map(E=>/\.vsix$/i.test(E)?A.URI.parse(E):E),f={list:l.list,install:c(l.install),uninstall:c(l.uninstall),force:l.force},_=await this._commands.executeCommand("_remoteCLI.manageExtensions",f);g.writeHead(200),g.write(_)}catch(c){g.writeHead(500),g.write(String(c),f=>{f&&this.logService.error(f)})}g.end()}async getStatus(l,g){try{const c=await this._commands.executeCommand("_remoteCLI.getSystemStatus");g.writeHead(200),g.write(c),g.end()}catch(c){g.writeHead(500),g.write(String(c),f=>{f&&this.logService.error(f)}),g.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&k.existsSync(this._ipcHandlePath)&&k.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=P;let s=class extends P{constructor(l,g){super(l,g,v.createRandomIPCHandle())}};s=Ve([We(0,y.IExtHostCommands),We(1,D.ILogService)],s),e.CLIServer=s}),define(ge[269],pe([0,1,66,256,251,5,259,40,241,2,10,7,268,101]),function(X,e,v,R,k,y,A,C,D,P,s,I,l,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class c extends k.RequireInterceptor{_installInterceptor(){const w=this,E=X.__$__nodeRequire("module"),u=E._load;E._load=function(m,t,r){for(let i of w._alternatives){let n=i(m);if(n){m=n;break}}return w._factories.has(m)?w._factories.get(m).load(m,P.URI.file(g.realpathSync(t.filename)),i=>u.apply(this,[i,t,r])):u.apply(this,arguments)}}}class f extends C.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=I.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const w=this._instaService.invokeFunction(R.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(D.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const t=this._instaService.createInstance(l.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=t.ipcHandlePath}await this._instaService.createInstance(c,w,this._registry).install(),v.mark("code/extHost/didInitAPI");const u=await this._extHostConfiguration.getConfigProvider();await A.connectProxyResolver(this._extHostWorkspace,u,this,this._logService,this._mainThreadTelemetryProxy,this._initData),v.mark("code/extHost/didInitProxyResolver");const h=process.send,m=this._extHostContext.getProxy(y.MainContext.MainThreadConsole);process.send=(...t)=>t.length===0||!t[0]||t[0].type!=="__$console"?h.apply(process,t):(m.$logExtensionHostMessage(t[0]),!1)}_getEntryPoint(w){return w.main}_loadCommonJSModule(w,E,u){if(E.scheme!==s.Schemas.file)throw new Error(`Cannot load URI: '${E}', must be of file-scheme`);let h=null;u.codeLoadingStart(),this._logService.info(`ExtensionService#loadCommonJSModule ${E.toString(!0)}`),this._logService.flush();try{w&&v.mark(`code/extHost/willLoadExtensionCode/${w.value}`),h=X.__$__nodeRequire(E.fsPath)}catch(m){return Promise.reject(m)}finally{w&&v.mark(`code/extHost/didLoadExtensionCode/${w.value}`),u.codeLoadingStop()}return Promise.resolve(h)}async $setRemoteEnvironment(w){if(!!this._initData.remote.isRemote)for(const E in w){const u=w[E];u===null?delete process.env[E]:process.env[E]=u}}}e.ExtHostExtensionService=f}),define(ge[270],pe([0,1,78,242,243,253,252,267,269,212,244,48,40,62,67,65,33,46,15]),function(X,e,v,R,k,y,A,C,D,P,s,I,l,g,c,f,_,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),v.registerSingleton(l.IExtHostExtensionService,D.ExtHostExtensionService),v.registerSingleton(E.ILogService,P.ExtHostLogService),v.registerSingleton(I.IExtHostDebugService,A.ExtHostDebugService),v.registerSingleton(g.IExtHostOutputService,R.ExtHostOutputService2),v.registerSingleton(c.IExtHostSearch,C.NativeExtHostSearch),v.registerSingleton(f.IExtHostTask,y.ExtHostTask),v.registerSingleton(_.IExtHostTerminalService,k.ExtHostTerminalService),v.registerSingleton(w.IExtHostTunnelService,s.ExtHostTunnelService)}),define(ge[271],pe([0,1,120,282,66,16,103,130,182,210,254,22,98,28,101,14,257,270]),function(X,e,v,R,k,y,A,C,D,P,s,I,l,g,c,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let n=0;n<process.execArgv.length;n++)process.execArgv[n]==="--inspect-port=0"&&(process.execArgv.splice(n,1),n--)}();const _=R(process.argv.slice(2),{string:["uriTransformerPath","useHostProxy"]});(function(){const i=X.__$__nodeRequire("module"),n=i._load;i._load=function(a){if(a==="natives")throw new Error('Either the extension or a NPM dependency is using the "natives" node module which is unsupported as it can cause a crash of the extension host. Click [here](https://go.microsoft.com/fwlink/?linkid=871887) to find out more');return n.apply(this,arguments)}})();const w=process.exit.bind(process);function E(i){process.exit=function(n){if(i)w(n);else{const a=new Error("An extension called process.exit() and this was prevented.");console.warn(a.stack)}},process.crash=function(){const n=new Error("An extension called process.crash() and this was prevented.");console.warn(n.stack)}}let u=function(i){w()};function h(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((i,n)=>{let a=null,p=setTimeout(()=>{u("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4);const d=108e5,b=3e5,S=new f.RunOnceScheduler(()=>u("renderer disconnected for too long (1)"),d),o=new f.RunOnceScheduler(()=>u("renderer disconnected for too long (2)"),b);process.on("message",(O,W)=>{if(O&&O.type==="VSCODE_EXTHOST_IPC_SOCKET"){const J=I.VSBuffer.wrap(Buffer.from(O.initialDataChunk,"base64"));let oe;if(O.skipWebSocketFrames)oe=new C.NodeSocket(W);else{const q=I.VSBuffer.wrap(Buffer.from(O.inflateBytes,"base64"));oe=new C.WebSocketNodeSocket(new C.NodeSocket(W),O.permessageDeflate,q,!1)}a?(S.cancel(),o.cancel(),a.beginAcceptReconnection(oe,J),a.endAcceptReconnection()):(clearTimeout(p),a=new A.PersistentProtocol(oe,J),a.onDidDispose(()=>u("renderer disconnected")),i(a),a.onSocketClose(()=>{S.schedule()}))}if(O&&O.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(o.isScheduled())return;S.isScheduled()&&o.schedule()}});const L={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(L)});{const i=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((n,a)=>{const p=v.createConnection(i,()=>{p.removeListener("error",a),n(new A.PersistentProtocol(new C.NodeSocket(p)))});p.once("error",a),p.on("close",()=>{u("renderer closed the socket")})})}}async function m(){const i=await h();return new class{constructor(){this._onMessage=new A.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,i.onMessage(n=>{P.isMessageOfType(n,2)?(this._terminating=!0,u("received terminate message from renderer")):this._onMessage.fire(n)})}send(n){this._terminating||i.send(n)}drain(){return i.drain()}}}function t(i){return new Promise(n=>{const a=i.onMessage(p=>{a.dispose();const d=JSON.parse(p.toString()),b=d.commit,S=D.default.commit;b&&S&&b!==S&&w(55);const o=[];process.on("unhandledRejection",(W,J)=>{o.push(J),setTimeout(()=>{const oe=o.indexOf(J);oe>=0&&J.catch(q=>{o.splice(oe,1),console.warn(`rejected promise not handled within 1 second: ${q}`),q&&q.stack&&console.warn(`stack trace: ${q.stack}`),y.onUnexpectedError(W)})},1e3)}),process.on("rejectionHandled",W=>{const J=o.indexOf(W);J>=0&&o.splice(J,1)}),process.on("uncaughtException",function(W){y.onUnexpectedError(W)});let L=0;setInterval(function(){try{process.kill(d.parentPid,0),L=0}catch(W){W&&W.code==="EPERM"?(L++,L>=3&&u(`parent process ${d.parentPid} does not exist anymore (3 x EPERM): ${W.message} (code: ${W.code}) (errno: ${W.errno})`)):u(`parent process ${d.parentPid} does not exist anymore: ${W.message} (code: ${W.code}) (errno: ${W.errno})`)}},1e3);let O;try{O=X.__$__nodeRequire("native-watchdog"),O.start(d.parentPid)}catch(W){y.onUnexpectedError(W)}i.send(P.createMessageOfType(0)),n({protocol:i,initData:d})});i.send(P.createMessageOfType(1))})}async function r(){k.mark("code/extHost/willConnectToRenderer");const i=await m();k.mark("code/extHost/didConnectToRenderer");const n=await t(i);k.mark("code/extHost/didWaitForInitData");const{initData:a}=n;E(!!a.environment.extensionTestsLocationURI),a.environment.useHostProxy=_.useHostProxy!==void 0?_.useHostProxy!=="false":void 0;const p=new class{exit(o){w(o)}exists(o){return g.exists(o)}realpath(o){return c.realpath(o)}};let d=null;if(a.remote.authority&&_.uriTransformerPath)try{const o=X.__$__nodeRequire(_.uriTransformerPath)(a.remote.authority);d=new l.URITransformer(o)}catch(S){console.error(S)}const b=new s.ExtensionHostMain(n.protocol,a,p,d);u=S=>b.terminate(S)}e.startExtensionHostProcess=r}),define(ge[283],pe([0,1,271]),function(X,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),v.startExtensionHostProcess().catch(R=>console.log(R))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/b4c1bd0a9b03c749ea011b06c6d2676c8091a70c/core/vs/workbench/services/extensions/node/extensionHostProcess.js.map
