/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var we=["require","exports","vs/base/common/uri","vs/base/common/event","vs/workbench/api/common/extHost.protocol","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHostTypes","vs/base/common/lifecycle","vs/base/common/strings","vs/workbench/api/common/extHostTypeConverters","vs/base/common/types","vs/base/common/async","vs/base/common/errors","vs/base/common/path","vs/workbench/api/common/extHostRpcService","vs/base/common/network","vs/base/common/arrays","vs/platform/log/common/log","vs/base/common/cancellation","vs/nls","vs/nls!vs/workbench/services/extensions/worker/extensionHostWorker","vs/base/common/platform","vs/base/common/map","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/base/common/glob","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostWorkspace","vs/editor/common/core/range","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/uuid","vs/editor/common/core/position","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/process","vs/base/common/severity","vs/base/common/extpath","vs/platform/registry/common/platform","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/marshalling","vs/editor/common/modes/languageSelector","vs/base/common/errorMessage","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/files/common/files","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/platform/workspace/common/workspace","vs/workbench/api/common/cache","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/shared/webview","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/collections","vs/base/common/numbers","vs/base/common/codicons","vs/base/common/uint","vs/base/common/htmlContent","vs/base/common/labels","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/platform/instantiation/common/descriptors","vs/platform/contextkey/common/contextkey","vs/platform/markers/common/markers","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/testing/common/testCollection","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/lazy","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/comparers","vs/base/common/mime","vs/base/common/uriIpc","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/terminal/common/terminalDataBuffering","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/extHostCodeInsets","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostLogService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/api/common/extHostTesting","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/marked/marked","vs/workbench/services/extensions/worker/extensionHostWorker"],_e=function(Z){for(var e=[],g=0,T=Z.length;g<T;g++)e[g]=we[Z[g]];return e};define(we[39],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function g(T,D){if(!T)throw new Error(D?`Assertion failed (${D})`:"Assertion Failed")}e.ok=g}),define(we[76],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const g=Object.prototype.hasOwnProperty;function T(n){const I=[];for(let o in n)g.call(n,o)&&I.push(n[o]);return I}e.values=T;function D(n,I){for(let o in n)if(g.call(n,o)&&I({key:o,value:n[o]},function(){delete n[o]})===!1)return}e.forEach=D;function E(n,I){const o=Object.create(null);for(const h of n){const d=I(h);let u=o[d];u||(u=o[d]=[]),u.push(h)}return o}e.groupBy=E;function C(n){const I=Object.create(null);return n&&n.forEach((o,h)=>{I[h]=o}),I}e.fromMap=C;function y(n,I){const o=[],h=[];for(let d of n)I.has(d)||o.push(d);for(let d of I)n.has(d)||h.push(d);return{removed:o,added:h}}e.diffSets=y;function _(n,I){const o=[],h=[];for(let[d,u]of n)I.has(d)||o.push(u);for(let[d,u]of I)n.has(d)||h.push(u);return{removed:o,added:h}}e.diffMaps=_;class k{constructor(){this.map=new Map}add(I,o){let h=this.map.get(I);h||(h=new Set,this.map.set(I,h)),h.add(o)}delete(I,o){const h=this.map.get(I);!h||(h.delete(o),h.size===0&&this.map.delete(I))}forEach(I,o){const h=this.map.get(I);!h||h.forEach(o)}}e.SetMap=k}),define(we[47],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function g(C){return(y,_,k)=>{let n=null,I=null;if(typeof k.value=="function"?(n="value",I=k.value):typeof k.get=="function"&&(n="get",I=k.get),!I)throw new Error("not supported");k[n]=C(I,_)}}e.createDecorator=g;function T(C,y,_){let k=null,n=null;if(typeof _.value=="function"?(k="value",n=_.value,n.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof _.get=="function"&&(k="get",n=_.get),!n)throw new Error("not supported");const I=`$memoize$${y}`;_[k]=function(...o){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:n.apply(this,o)}),this[I]}}e.memoize=T;function D(C,y,_){return g((k,n)=>{const I=`$debounce$${n}`,o=`$debounce$result$${n}`;return function(...h){this[o]||(this[o]=_?_():void 0),clearTimeout(this[I]),y&&(this[o]=y(this[o],...h),h=[this[o]]),this[I]=setTimeout(()=>{k.apply(this,h),this[o]=_?_():void 0},C)}})}e.debounce=D;function E(C,y,_){return g((k,n)=>{const I=`$throttle$timer$${n}`,o=`$throttle$result$${n}`,h=`$throttle$lastRun$${n}`,d=`$throttle$pending$${n}`;return function(...u){if(this[o]||(this[o]=_?_():void 0),(this[h]===null||this[h]===void 0)&&(this[h]=-Number.MAX_VALUE),y&&(this[o]=y(this[o],...u)),this[d])return;const w=this[h]+C;w<=Date.now()?(this[h]=Date.now(),k.apply(this,[this[o]]),this[o]=_?_():void 0):(this[d]=!0,this[I]=setTimeout(()=>{this[d]=!1,this[h]=Date.now(),k.apply(this,[this[o]]),this[o]=_?_():void 0},w-Date.now()))}})}e.throttle=E}),define(we[12],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class g{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(r=>{r(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=g,e.errorHandler=new g;function T(f){e.errorHandler.setUnexpectedErrorHandler(f)}e.setUnexpectedErrorHandler=T;function D(f){_(f)||e.errorHandler.onUnexpectedError(f)}e.onUnexpectedError=D;function E(f){_(f)||e.errorHandler.onUnexpectedExternalError(f)}e.onUnexpectedExternalError=E;function C(f){if(f instanceof Error){let{name:t,message:r}=f;const i=f.stacktrace||f.stack;return{$isError:!0,name:t,message:r,stack:i}}return f}e.transformErrorForSerialization=C;const y="Canceled";function _(f){return f instanceof Error&&f.name===y&&f.message===y}e.isPromiseCanceledError=_;class k extends Error{constructor(){super(y);this.name=this.message}}e.CancellationError=k;function n(){const f=new Error(y);return f.name=f.message,f}e.canceled=n;function I(f){return f?new Error(`Illegal argument: ${f}`):new Error("Illegal argument")}e.illegalArgument=I;function o(f){return f?new Error(`Illegal state: ${f}`):new Error("Illegal state")}e.illegalState=o;function h(f){return f?new Error(`readonly property '${f} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=h;function d(f){const t=new Error(`${f} has been disposed`);return t.name="DISPOSED",t}e.disposed=d;function u(f){return f?f.message?f.message:f.stack?f.stack.split(`
`)[0]:String(f):"Error"}e.getErrorMessage=u;class w extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=w;class v extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=v;class S extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=S;function c(f){const t=f;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=c;function m(f,t=Object.create(null)){const r=new Error(f);return t.actions&&(r.actions=t.actions),r}e.createErrorWithActions=m}),define(we[16],_e([0,1,12]),function(Z,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.maxIndex=e.minIndex=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function T(B,M=0){return B[B.length-(1+M)]}e.tail=T;function D(B){if(B.length===0)throw new Error("Invalid tail call");return[B.slice(0,B.length-1),B[B.length-1]]}e.tail2=D;function E(B,M,U=(q,V)=>q===V){if(B===M)return!0;if(!B||!M||B.length!==M.length)return!1;for(let q=0,V=B.length;q<V;q++)if(!U(B[q],M[q]))return!1;return!0}e.equals=E;function C(B,M,U){let q=0,V=B.length-1;for(;q<=V;){const oe=(q+V)/2|0,ge=U(B[oe],M);if(ge<0)q=oe+1;else if(ge>0)V=oe-1;else return oe}return-(q+1)}e.binarySearch=C;function y(B,M){let U=0,q=B.length;if(q===0)return 0;for(;U<q;){const V=Math.floor((U+q)/2);M(B[V])?q=V:U=V+1}return U}e.findFirstInSorted=y;function _(B,M,U){if(B=B|0,B>=M.length)throw new TypeError("invalid index");let q=M[Math.floor(M.length*Math.random())],V=[],oe=[],ge=[];for(let Re of M){const $e=U(Re,q);$e<0?V.push(Re):$e>0?oe.push(Re):ge.push(Re)}return B<V.length?_(B,V,U):B<V.length+ge.length?ge[0]:_(B-(V.length+ge.length),oe,U)}e.quickSelect=_;function k(B,M){const U=[];let q;for(const V of B.slice(0).sort(M))!q||M(q[0],V)!==0?(q=[V],U.push(q)):q.push(V);return U}e.groupBy=k;function n(B,M,U){const q=[];function V(Re,$e,Me){if($e===0&&Me.length===0)return;const We=q[q.length-1];We&&We.start+We.deleteCount===Re?(We.deleteCount+=$e,We.toInsert.push(...Me)):q.push({start:Re,deleteCount:$e,toInsert:Me})}let oe=0,ge=0;for(;;){if(oe===B.length){V(oe,0,M.slice(ge));break}if(ge===M.length){V(oe,B.length-oe,[]);break}const Re=B[oe],$e=M[ge],Me=U(Re,$e);Me===0?(oe+=1,ge+=1):Me<0?(V(oe,1,[]),oe+=1):Me>0&&(V(oe,0,[$e]),ge+=1)}return q}e.sortedDiff=n;function I(B,M,U){const q=n(B,M,U),V=[],oe=[];for(const ge of q)V.push(...B.slice(ge.start,ge.start+ge.deleteCount)),oe.push(...ge.toInsert);return{removed:V,added:oe}}e.delta=I;function o(B,M,U){if(U===0)return[];const q=B.slice(0,U).sort(M);return d(B,M,q,U,B.length),q}e.top=o;function h(B,M,U,q,V){return U===0?Promise.resolve([]):new Promise((oe,ge)=>{(async()=>{const Re=B.length,$e=B.slice(0,U).sort(M);for(let Me=U,We=Math.min(U+q,Re);Me<Re;Me=We,We=Math.min(We+q,Re)){if(Me>U&&await new Promise(Je=>setTimeout(Je)),V&&V.isCancellationRequested)throw g.canceled();d(B,M,$e,Me,We)}return $e})().then(oe,ge)})}e.topAsync=h;function d(B,M,U,q,V){for(const oe=U.length;q<V;q++){const ge=B[q];if(M(ge,U[oe-1])<0){U.pop();const Re=y(U,$e=>M(ge,$e)<0);U.splice(Re,0,ge)}}}function u(B){return B.filter(M=>!!M)}e.coalesce=u;function w(B){let M=0;for(let U=0;U<B.length;U++)B[U]&&(B[M]=B[U],M+=1);B.length=M}e.coalesceInPlace=w;function v(B,M,U){B.splice(U,0,B.splice(M,1)[0])}e.move=v;function S(B){return!Array.isArray(B)||B.length===0}e.isFalsyOrEmpty=S;function c(B){return Array.isArray(B)&&B.length>0}e.isNonEmptyArray=c;function m(B,M){if(!M)return B.filter((q,V)=>B.indexOf(q)===V);const U=Object.create(null);return B.filter(q=>{const V=M(q);return U[V]?!1:(U[V]=!0,!0)})}e.distinct=m;function f(B){const M=new Set;return B.filter(U=>M.has(U)?!1:(M.add(U),!0))}e.distinctES6=f;function t(B){const M=Object.create(null);return U=>{const q=B(U);return M[q]?!1:(M[q]=!0,!0)}}e.uniqueFilter=t;function r(B,M){for(let U=B.length-1;U>=0;U--){const q=B[U];if(M(q))return U}return-1}e.lastIndex=r;function i(B,M){return B.length>0?B[0]:M}e.firstOrDefault=i;function s(B,M,U=(q,V)=>q===V){let q=0;for(let V=0,oe=Math.min(B.length,M.length);V<oe&&U(B[V],M[V]);V++)q++;return q}e.commonPrefixLength=s;function l(B){return[].concat(...B)}e.flatten=l;function b(B,M){let U=typeof M=="number"?B:0;typeof M=="number"?U=B:(U=0,M=B);const q=[];if(U<=M)for(let V=U;V<M;V++)q.push(V);else for(let V=U;V>M;V--)q.push(V);return q}e.range=b;function p(B,M,U){return B.reduce((q,V)=>(q[M(V)]=U?U(V):V,q),Object.create(null))}e.index=p;function P(B,M){return B.push(M),()=>A(B,M)}e.insert=P;function A(B,M){const U=B.indexOf(M);if(U>-1)return B.splice(U,1),M}e.remove=A;function a(B,M,U){const q=B.slice(0,M),V=B.slice(M);return q.concat(U,V)}e.arrayInsert=a;function F(B,M){let U;if(typeof M=="number"){let q=M;U=()=>{const V=Math.sin(q++)*179426549;return V-Math.floor(V)}}else U=Math.random;for(let q=B.length-1;q>0;q-=1){const V=Math.floor(U()*(q+1)),oe=B[q];B[q]=B[V],B[V]=oe}}e.shuffle=F;function N(B,M){const U=B.indexOf(M);U>-1&&(B.splice(U,1),B.unshift(M))}e.pushToStart=N;function H(B,M){const U=B.indexOf(M);U>-1&&(B.splice(U,1),B.push(M))}e.pushToEnd=H;function le(B,M){return Array.isArray(B)?B.map(M):M(B)}e.mapArrayOrNot=le;function fe(B){return Array.isArray(B)?B:[B]}e.asArray=fe;function X(B){return B[Math.floor(Math.random()*B.length)]}e.getRandomElement=X;function z(B,M){for(const U of B){const q=M(U);if(q!==void 0)return q}}e.mapFind=z;function Y(B,M){let U=Number.MAX_SAFE_INTEGER,q=0;return B.forEach((V,oe)=>{const ge=M(V);ge<U&&(U=ge,q=oe)}),q}e.minIndex=Y;function R(B,M){let U=Number.MIN_SAFE_INTEGER,q=0;return B.forEach((V,oe)=>{const ge=M(V);ge>U&&(U=ge,q=oe)}),q}e.maxIndex=R}),define(we[48],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function g(T){const D=this;let E=!1,C;return function(){return E||(E=!0,C=T.apply(D,arguments)),C}}e.once=g}),define(we[49],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class g{constructor(D){this._prefix=D,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=g,e.defaultGenerator=new g("id#")}),define(we[50],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var g;(function(T){function D(f){return f&&typeof f=="object"&&typeof f[Symbol.iterator]=="function"}T.is=D;const E=Object.freeze([]);function C(){return E}T.empty=C;function*y(f){yield f}T.single=y;function _(f){return f||E}T.from=_;function k(f){return!f||f[Symbol.iterator]().next().done===!0}T.isEmpty=k;function n(f){return f[Symbol.iterator]().next().value}T.first=n;function I(f,t){for(const r of f)if(t(r))return!0;return!1}T.some=I;function o(f,t){for(const r of f)if(t(r))return r}T.find=o;function*h(f,t){for(const r of f)t(r)&&(yield r)}T.filter=h;function*d(f,t){let r=0;for(const i of f)yield t(i,r++)}T.map=d;function*u(...f){for(const t of f)for(const r of t)yield r}T.concat=u;function*w(f){for(const t of f)for(const r of t)yield r}T.concatNested=w;function v(f,t,r){let i=r;for(const s of f)i=t(i,s);return i}T.reduce=v;function*S(f,t,r=f.length){for(t<0&&(t+=f.length),r<0?r+=f.length:r>f.length&&(r=f.length);t<r;t++)yield f[t]}T.slice=S;function c(f,t=Number.POSITIVE_INFINITY){const r=[];if(t===0)return[r,f];const i=f[Symbol.iterator]();for(let s=0;s<t;s++){const l=i.next();if(l.done)return[r,T.empty()];r.push(l.value)}return[r,{[Symbol.iterator](){return i}}]}T.consume=c;function m(f,t,r=(i,s)=>i===s){const i=f[Symbol.iterator](),s=t[Symbol.iterator]();for(;;){const l=i.next(),b=s.next();if(l.done!==b.done)return!1;if(l.done)return!0;if(!r(l.value,b.value))return!1}}T.equals=m})(g=e.Iterable||(e.Iterable={}))}),define(we[105],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var g;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(g=e.ScanError||(e.ScanError={}));var T;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(T=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var E;(function(t){t.DEFAULT={allowTrailingComma:!0}})(E=e.ParseOptions||(e.ParseOptions={}));function C(t,r=!1){let i=0,s=t.length,l="",b=0,p=16,P=0;function A(X){let z=0,Y=0;for(;z<X;){const R=t.charCodeAt(i);if(R>=48&&R<=57)Y=Y*16+R-48;else if(R>=65&&R<=70)Y=Y*16+R-65+10;else if(R>=97&&R<=102)Y=Y*16+R-97+10;else break;i++,z++}return z<X&&(Y=-1),Y}function a(X){i=X,l="",b=0,p=16,P=0}function F(){const X=i;if(t.charCodeAt(i)===48)i++;else for(i++;i<t.length&&k(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===46)if(i++,i<t.length&&k(t.charCodeAt(i)))for(i++;i<t.length&&k(t.charCodeAt(i));)i++;else return P=3,t.substring(X,i);let z=i;if(i<t.length&&(t.charCodeAt(i)===69||t.charCodeAt(i)===101))if(i++,(i<t.length&&t.charCodeAt(i)===43||t.charCodeAt(i)===45)&&i++,i<t.length&&k(t.charCodeAt(i))){for(i++;i<t.length&&k(t.charCodeAt(i));)i++;z=i}else P=3;return t.substring(X,z)}function N(){let X="",z=i;for(;;){if(i>=s){X+=t.substring(z,i),P=2;break}const Y=t.charCodeAt(i);if(Y===34){X+=t.substring(z,i),i++;break}if(Y===92){if(X+=t.substring(z,i),i++,i>=s){P=2;break}switch(t.charCodeAt(i++)){case 34:X+='"';break;case 92:X+="\\";break;case 47:X+="/";break;case 98:X+="\b";break;case 102:X+="\f";break;case 110:X+=`
`;break;case 114:X+="\r";break;case 116:X+="	";break;case 117:const B=A(4);B>=0?X+=String.fromCharCode(B):P=4;break;default:P=5}z=i;continue}if(Y>=0&&Y<=31)if(_(Y)){X+=t.substring(z,i),P=2;break}else P=6;i++}return X}function H(){if(l="",P=0,b=i,i>=s)return b=s,p=17;let X=t.charCodeAt(i);if(y(X)){do i++,l+=String.fromCharCode(X),X=t.charCodeAt(i);while(y(X));return p=15}if(_(X))return i++,l+=String.fromCharCode(X),X===13&&t.charCodeAt(i)===10&&(i++,l+=`
`),p=14;switch(X){case 123:return i++,p=1;case 125:return i++,p=2;case 91:return i++,p=3;case 93:return i++,p=4;case 58:return i++,p=6;case 44:return i++,p=5;case 34:return i++,l=N(),p=10;case 47:const z=i-1;if(t.charCodeAt(i+1)===47){for(i+=2;i<s&&!_(t.charCodeAt(i));)i++;return l=t.substring(z,i),p=12}if(t.charCodeAt(i+1)===42){i+=2;const Y=s-1;let R=!1;for(;i<Y;){if(t.charCodeAt(i)===42&&t.charCodeAt(i+1)===47){i+=2,R=!0;break}i++}return R||(i++,P=1),l=t.substring(z,i),p=13}return l+=String.fromCharCode(X),i++,p=16;case 45:if(l+=String.fromCharCode(X),i++,i===s||!k(t.charCodeAt(i)))return p=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return l+=F(),p=11;default:for(;i<s&&le(X);)i++,X=t.charCodeAt(i);if(b!==i){switch(l=t.substring(b,i),l){case"true":return p=8;case"false":return p=9;case"null":return p=7}return p=16}return l+=String.fromCharCode(X),i++,p=16}}function le(X){if(y(X)||_(X))return!1;switch(X){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function fe(){let X;do X=H();while(X>=12&&X<=15);return X}return{setPosition:a,getPosition:()=>i,scan:r?fe:H,getToken:()=>p,getTokenValue:()=>l,getTokenOffset:()=>b,getTokenLength:()=>i-b,getTokenError:()=>P}}e.createScanner=C;function y(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function _(t){return t===10||t===13||t===8232||t===8233}function k(t){return t>=48&&t<=57}var n;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(n||(n={}));function I(t,r){const i=[],s=new Object;let l;const b={value:{},offset:0,length:0,type:"object",parent:void 0};let p=!1;function P(A,a,F,N){b.value=A,b.offset=a,b.length=F,b.type=N,b.colonOffset=void 0,l=b}try{c(t,{onObjectBegin:(A,a)=>{if(r<=A)throw s;l=void 0,p=r>A,i.push("")},onObjectProperty:(A,a,F)=>{if(r<a||(P(A,a,F,"property"),i[i.length-1]=A,r<=a+F))throw s},onObjectEnd:(A,a)=>{if(r<=A)throw s;l=void 0,i.pop()},onArrayBegin:(A,a)=>{if(r<=A)throw s;l=void 0,i.push(0)},onArrayEnd:(A,a)=>{if(r<=A)throw s;l=void 0,i.pop()},onLiteralValue:(A,a,F)=>{if(r<a||(P(A,a,F,f(A)),r<=a+F))throw s},onSeparator:(A,a,F)=>{if(r<=a)throw s;if(A===":"&&l&&l.type==="property")l.colonOffset=a,p=!1,l=void 0;else if(A===","){const N=i[i.length-1];typeof N=="number"?i[i.length-1]=N+1:(p=!0,i[i.length-1]=""),l=void 0}}})}catch(A){if(A!==s)throw A}return{path:i,previousNode:l,isAtPropertyKey:p,matches:A=>{let a=0;for(let F=0;a<A.length&&F<i.length;F++)if(A[a]===i[F]||A[a]==="*")a++;else if(A[a]!=="**")return!1;return a===A.length}}}e.getLocation=I;function o(t,r=[],i=E.DEFAULT){let s=null,l=[];const b=[];function p(A){Array.isArray(l)?l.push(A):s!==null&&(l[s]=A)}return c(t,{onObjectBegin:()=>{const A={};p(A),b.push(l),l=A,s=null},onObjectProperty:A=>{s=A},onObjectEnd:()=>{l=b.pop()},onArrayBegin:()=>{const A=[];p(A),b.push(l),l=A,s=null},onArrayEnd:()=>{l=b.pop()},onLiteralValue:p,onError:(A,a,F)=>{r.push({error:A,offset:a,length:F})}},i),l[0]}e.parse=o;function h(t,r=[],i=E.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function l(A){s.type==="property"&&(s.length=A-s.offset,s=s.parent)}function b(A){return s.children.push(A),A}c(t,{onObjectBegin:A=>{s=b({type:"object",offset:A,length:-1,parent:s,children:[]})},onObjectProperty:(A,a,F)=>{s=b({type:"property",offset:a,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:A,offset:a,length:F,parent:s})},onObjectEnd:(A,a)=>{s.length=A+a-s.offset,s=s.parent,l(A+a)},onArrayBegin:(A,a)=>{s=b({type:"array",offset:A,length:-1,parent:s,children:[]})},onArrayEnd:(A,a)=>{s.length=A+a-s.offset,s=s.parent,l(A+a)},onLiteralValue:(A,a,F)=>{b({type:f(A),offset:a,length:F,parent:s,value:A}),l(a+F)},onSeparator:(A,a,F)=>{s.type==="property"&&(A===":"?s.colonOffset=a:A===","&&l(a))},onError:(A,a,F)=>{r.push({error:A,offset:a,length:F})}},i);const P=s.children[0];return P&&delete P.parent,P}e.parseTree=h;function d(t,r){if(!t)return;let i=t;for(let s of r)if(typeof s=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let l=!1;for(const b of i.children)if(Array.isArray(b.children)&&b.children[0].value===s){i=b.children[1],l=!0;break}if(!l)return}else{const l=s;if(i.type!=="array"||l<0||!Array.isArray(i.children)||l>=i.children.length)return;i=i.children[l]}return i}e.findNodeAtLocation=d;function u(t){if(!t.parent||!t.parent.children)return[];const r=u(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;r.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&r.push(i)}return r}e.getNodePath=u;function w(t){switch(t.type){case"array":return t.children.map(w);case"object":const r=Object.create(null);for(let i of t.children){const s=i.children[1];s&&(r[i.children[0].value]=w(s))}return r;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=w;function v(t,r,i=!1){return r>=t.offset&&r<t.offset+t.length||i&&r===t.offset+t.length}e.contains=v;function S(t,r,i=!1){if(v(t,r,i)){const s=t.children;if(Array.isArray(s))for(let l=0;l<s.length&&s[l].offset<=r;l++){const b=S(s[l],r,i);if(b)return b}return t}}e.findNodeAtOffset=S;function c(t,r,i=E.DEFAULT){const s=C(t,!1);function l(ge){return ge?()=>ge(s.getTokenOffset(),s.getTokenLength()):()=>!0}function b(ge){return ge?Re=>ge(Re,s.getTokenOffset(),s.getTokenLength()):()=>!0}const p=l(r.onObjectBegin),P=b(r.onObjectProperty),A=l(r.onObjectEnd),a=l(r.onArrayBegin),F=l(r.onArrayEnd),N=b(r.onLiteralValue),H=b(r.onSeparator),le=l(r.onComment),fe=b(r.onError),X=i&&i.disallowComments,z=i&&i.allowTrailingComma;function Y(){for(;;){const ge=s.scan();switch(s.getTokenError()){case 4:R(14);break;case 5:R(15);break;case 3:R(13);break;case 1:X||R(11);break;case 2:R(12);break;case 6:R(16);break}switch(ge){case 12:case 13:X?R(10):le();break;case 16:R(1);break;case 15:case 14:break;default:return ge}}}function R(ge,Re=[],$e=[]){if(fe(ge),Re.length+$e.length>0){let Me=s.getToken();for(;Me!==17;){if(Re.indexOf(Me)!==-1){Y();break}else if($e.indexOf(Me)!==-1)break;Me=Y()}}}function B(ge){const Re=s.getTokenValue();return ge?N(Re):P(Re),Y(),!0}function M(){switch(s.getToken()){case 11:let ge=0;try{ge=JSON.parse(s.getTokenValue()),typeof ge!="number"&&(R(2),ge=0)}catch(Re){R(2)}N(ge);break;case 7:N(null);break;case 8:N(!0);break;case 9:N(!1);break;default:return!1}return Y(),!0}function U(){return s.getToken()!==10?(R(3,[],[2,5]),!1):(B(!1),s.getToken()===6?(H(":"),Y(),oe()||R(4,[],[2,5])):R(5,[],[2,5]),!0)}function q(){p(),Y();let ge=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(ge||R(4,[],[]),H(","),Y(),s.getToken()===2&&z)break}else ge&&R(6,[],[]);U()||R(4,[],[2,5]),ge=!0}return A(),s.getToken()!==2?R(7,[2],[]):Y(),!0}function V(){a(),Y();let ge=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(ge||R(4,[],[]),H(","),Y(),s.getToken()===4&&z)break}else ge&&R(6,[],[]);oe()||R(4,[],[4,5]),ge=!0}return F(),s.getToken()!==4?R(8,[4],[]):Y(),!0}function oe(){switch(s.getToken()){case 3:return V();case 1:return q();case 10:return B(!0);default:return M()}}return Y(),s.getToken()===17?i.allowEmptyContent?!0:(R(4,[],[]),!1):oe()?(s.getToken()!==17&&R(9,[],[]),!0):(R(4,[],[]),!1)}e.visit=c;function m(t,r){let i=C(t),s=[],l,b=0,p;do switch(p=i.getPosition(),l=i.scan(),l){case 12:case 13:case 17:b!==p&&s.push(t.substring(b,p)),r!==void 0&&s.push(i.getTokenValue().replace(/[^\r\n]/g,r)),b=i.getPosition();break}while(l!==17);return s.join("")}e.stripComments=m;function f(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=f}),define(we[106],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class g{constructor(D){this.executor=D,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(D){this._error=D}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(D){return new g(()=>D(this.getValue()))}}e.Lazy=g}),define(we[7],_e([0,1,48,50]),function(Z,e,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const D=!1;let E=null;function C(c){E=c}if(e.setDisposableTracker=C,D){const c="__is_disposable_tracked__";E=new class{trackDisposable(m){const f=new Error("Potentially leaked disposable").stack;setTimeout(()=>{m[c]||console.log(f)},3e3)}markTracked(m){if(m&&m!==u.None)try{m[c]=!0}catch(f){}}}}function y(c){!E||E.markTracked(c)}function _(c){return E&&E.trackDisposable(c),c}e.trackDisposable=_;class k extends Error{constructor(m){super(`Encountered errors while disposing of store. Errors: [${m.join(", ")}]`);this.errors=m}}e.MultiDisposeError=k;function n(c){return typeof c.dispose=="function"&&c.dispose.length===0}e.isDisposable=n;function I(c){if(T.Iterable.is(c)){let m=[];for(const f of c)if(f){y(f);try{f.dispose()}catch(t){m.push(t)}}if(m.length===1)throw m[0];if(m.length>1)throw new k(m);return Array.isArray(c)?[]:c}else if(c)return y(c),c.dispose(),c}e.dispose=I;function o(...c){return c.forEach(y),h(()=>I(c))}e.combinedDisposable=o;function h(c){const m=_({dispose:()=>{y(m),c()}});return m}e.toDisposable=h;class d{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(y(this),this._isDisposed=!0,this.clear())}clear(){try{I(this._toDispose.values())}finally{this._toDispose.clear()}}add(m){if(!m)return m;if(m===this)throw new Error("Cannot register a disposable on itself!");return y(m),this._isDisposed?d.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(m),m}}e.DisposableStore=d,d.DISABLE_DISPOSED_WARNING=!1;class u{constructor(){this._store=new d,_(this)}dispose(){y(this),this._store.dispose()}_register(m){if(m===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(m)}}e.Disposable=u,u.None=Object.freeze({dispose(){}});class w{constructor(){this._isDisposed=!1,_(this)}get value(){return this._isDisposed?void 0:this._value}set value(m){var f;this._isDisposed||m===this._value||((f=this._value)===null||f===void 0||f.dispose(),m&&y(m),this._value=m)}clear(){this.value=void 0}dispose(){var m;this._isDisposed=!0,y(this),(m=this._value)===null||m===void 0||m.dispose(),this._value=void 0}}e.MutableDisposable=w;class v{constructor(){this.references=new Map}acquire(m,...f){let t=this.references.get(m);t||(t={counter:0,object:this.createReferencedObject(m,...f)},this.references.set(m,t));const{object:r}=t,i=g.once(()=>{--t.counter==0&&(this.destroyReferencedObject(m,t.object),this.references.delete(m))});return t.counter++,{object:r,dispose:i}}}e.ReferenceCollection=v;class S{constructor(m){this.object=m}dispose(){}}e.ImmortalReference=S}),define(we[51],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class g{constructor(E){this.element=E,this.next=g.Undefined,this.prev=g.Undefined}}g.Undefined=new g(void 0);class T{constructor(){this._first=g.Undefined,this._last=g.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===g.Undefined}clear(){let E=this._first;for(;E!==g.Undefined;){const C=E.next;E.prev=g.Undefined,E.next=g.Undefined,E=C}this._first=g.Undefined,this._last=g.Undefined,this._size=0}unshift(E){return this._insert(E,!1)}push(E){return this._insert(E,!0)}_insert(E,C){const y=new g(E);if(this._first===g.Undefined)this._first=y,this._last=y;else if(C){const k=this._last;this._last=y,y.prev=k,k.next=y}else{const k=this._first;this._first=y,y.next=k,k.prev=y}this._size+=1;let _=!1;return()=>{_||(_=!0,this._remove(y))}}shift(){if(this._first!==g.Undefined){const E=this._first.element;return this._remove(this._first),E}}pop(){if(this._last!==g.Undefined){const E=this._last.element;return this._remove(this._last),E}}_remove(E){if(E.prev!==g.Undefined&&E.next!==g.Undefined){const C=E.prev;C.next=E.next,E.next.prev=C}else E.prev===g.Undefined&&E.next===g.Undefined?(this._first=g.Undefined,this._last=g.Undefined):E.next===g.Undefined?(this._last=this._last.prev,this._last.next=g.Undefined):E.prev===g.Undefined&&(this._first=this._first.next,this._first.prev=g.Undefined);this._size-=1}*[Symbol.iterator](){let E=this._first;for(;E!==g.Undefined;)yield E.element,E=E.next}}e.LinkedList=T}),function(Z,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(Z=typeof globalThis!="undefined"?globalThis:Z||self,Z.marked=e())}(this,function(){"use strict";function Z(Ee,be){for(var De=0;De<be.length;De++){var ie=be[De];ie.enumerable=ie.enumerable||!1,ie.configurable=!0,"value"in ie&&(ie.writable=!0),Object.defineProperty(Ee,ie.key,ie)}}function e(Ee,be,De){return be&&Z(Ee.prototype,be),De&&Z(Ee,De),Ee}function g(Ee,be){if(!!Ee){if(typeof Ee=="string")return T(Ee,be);var De=Object.prototype.toString.call(Ee).slice(8,-1);if(De==="Object"&&Ee.constructor&&(De=Ee.constructor.name),De==="Map"||De==="Set")return Array.from(Ee);if(De==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(De))return T(Ee,be)}}function T(Ee,be){(be==null||be>Ee.length)&&(be=Ee.length);for(var De=0,ie=new Array(be);De<be;De++)ie[De]=Ee[De];return ie}function D(Ee,be){var De;if(typeof Symbol=="undefined"||Ee[Symbol.iterator]==null){if(Array.isArray(Ee)||(De=g(Ee))||be&&Ee&&typeof Ee.length=="number"){De&&(Ee=De);var ie=0;return function(){return ie>=Ee.length?{done:!0}:{done:!1,value:Ee[ie++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return De=Ee[Symbol.iterator](),De.next.bind(De)}function E(Ee){var be={exports:{}};return Ee(be,be.exports),be.exports}var C=E(function(Ee){function be(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function De(ie){Ee.exports.defaults=ie}Ee.exports={defaults:be(),getDefaults:be,changeDefaults:De}}),y=/[&<>"']/,_=/[&<>"']/g,k=/[<>"']|&(?!#?\w+;)/,n=/[<>"']|&(?!#?\w+;)/g,I={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},o=function(be){return I[be]};function h(Ee,be){if(be){if(y.test(Ee))return Ee.replace(_,o)}else if(k.test(Ee))return Ee.replace(n,o);return Ee}var d=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function u(Ee){return Ee.replace(d,function(be,De){return De=De.toLowerCase(),De==="colon"?":":De.charAt(0)==="#"?De.charAt(1)==="x"?String.fromCharCode(parseInt(De.substring(2),16)):String.fromCharCode(+De.substring(1)):""})}var w=/(^|[^\[])\^/g;function v(Ee,be){Ee=Ee.source||Ee,be=be||"";var De={replace:function(de,O){return O=O.source||O,O=O.replace(w,"$1"),Ee=Ee.replace(de,O),De},getRegex:function(){return new RegExp(Ee,be)}};return De}var S=/[^\w:]/g,c=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function m(Ee,be,De){if(Ee){var ie;try{ie=decodeURIComponent(u(De)).replace(S,"").toLowerCase()}catch(de){return null}if(ie.indexOf("javascript:")===0||ie.indexOf("vbscript:")===0||ie.indexOf("data:")===0)return null}be&&!c.test(De)&&(De=s(be,De));try{De=encodeURI(De).replace(/%25/g,"%")}catch(de){return null}return De}var f={},t=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function s(Ee,be){f[" "+Ee]||(t.test(Ee)?f[" "+Ee]=Ee+"/":f[" "+Ee]=P(Ee,"/",!0)),Ee=f[" "+Ee];var De=Ee.indexOf(":")===-1;return be.substring(0,2)==="//"?De?be:Ee.replace(r,"$1")+be:be.charAt(0)==="/"?De?be:Ee.replace(i,"$1")+be:Ee+be}var l={exec:function(){}};function b(Ee){for(var be=1,De,ie;be<arguments.length;be++){De=arguments[be];for(ie in De)Object.prototype.hasOwnProperty.call(De,ie)&&(Ee[ie]=De[ie])}return Ee}function p(Ee,be){var De=Ee.replace(/\|/g,function(O,G,ae){for(var Ce=!1,Ie=G;--Ie>=0&&ae[Ie]==="\\";)Ce=!Ce;return Ce?"|":" |"}),ie=De.split(/ \|/),de=0;if(ie.length>be)ie.splice(be);else for(;ie.length<be;)ie.push("");for(;de<ie.length;de++)ie[de]=ie[de].trim().replace(/\\\|/g,"|");return ie}function P(Ee,be,De){var ie=Ee.length;if(ie===0)return"";for(var de=0;de<ie;){var O=Ee.charAt(ie-de-1);if(O===be&&!De)de++;else if(O!==be&&De)de++;else break}return Ee.substr(0,ie-de)}function A(Ee,be){if(Ee.indexOf(be[1])===-1)return-1;for(var De=Ee.length,ie=0,de=0;de<De;de++)if(Ee[de]==="\\")de++;else if(Ee[de]===be[0])ie++;else if(Ee[de]===be[1]&&(ie--,ie<0))return de;return-1}function a(Ee){Ee&&Ee.sanitize&&!Ee.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function F(Ee,be){if(be<1)return"";for(var De="";be>1;)be&1&&(De+=Ee),be>>=1,Ee+=Ee;return De+Ee}var N={escape:h,unescape:u,edit:v,cleanUrl:m,resolveUrl:s,noopTest:l,merge:b,splitCells:p,rtrim:P,findClosingBracket:A,checkSanitizeDeprecation:a,repeatString:F},H=C.defaults,le=N.rtrim,fe=N.splitCells,X=N.escape,z=N.findClosingBracket;function Y(Ee,be,De){var ie=be.href,de=be.title?X(be.title):null,O=Ee[1].replace(/\\([\[\]])/g,"$1");return Ee[0].charAt(0)!=="!"?{type:"link",raw:De,href:ie,title:de,text:O}:{type:"image",raw:De,href:ie,title:de,text:X(O)}}function R(Ee,be){var De=Ee.match(/^(\s+)(?:```)/);if(De===null)return be;var ie=De[1];return be.split(`
`).map(function(de){var O=de.match(/^\s+/);if(O===null)return de;var G=O[0];return G.length>=ie.length?de.slice(ie.length):de}).join(`
`)}var B=function(){function Ee(De){this.options=De||H}var be=Ee.prototype;return be.space=function(ie){var de=this.rules.block.newline.exec(ie);if(de)return de[0].length>1?{type:"space",raw:de[0]}:{raw:`
`}},be.code=function(ie){var de=this.rules.block.code.exec(ie);if(de){var O=de[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:de[0],codeBlockStyle:"indented",text:this.options.pedantic?O:le(O,`
`)}}},be.fences=function(ie){var de=this.rules.block.fences.exec(ie);if(de){var O=de[0],G=R(O,de[3]||"");return{type:"code",raw:O,lang:de[2]?de[2].trim():de[2],text:G}}},be.heading=function(ie){var de=this.rules.block.heading.exec(ie);if(de){var O=de[2].trim();if(/#$/.test(O)){var G=le(O,"#");(this.options.pedantic||!G||/ $/.test(G))&&(O=G.trim())}return{type:"heading",raw:de[0],depth:de[1].length,text:O}}},be.nptable=function(ie){var de=this.rules.block.nptable.exec(ie);if(de){var O={type:"table",header:fe(de[1].replace(/^ *| *\| *$/g,"")),align:de[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:de[3]?de[3].replace(/\n$/,"").split(`
`):[],raw:de[0]};if(O.header.length===O.align.length){var G=O.align.length,ae;for(ae=0;ae<G;ae++)/^ *-+: *$/.test(O.align[ae])?O.align[ae]="right":/^ *:-+: *$/.test(O.align[ae])?O.align[ae]="center":/^ *:-+ *$/.test(O.align[ae])?O.align[ae]="left":O.align[ae]=null;for(G=O.cells.length,ae=0;ae<G;ae++)O.cells[ae]=fe(O.cells[ae],O.header.length);return O}}},be.hr=function(ie){var de=this.rules.block.hr.exec(ie);if(de)return{type:"hr",raw:de[0]}},be.blockquote=function(ie){var de=this.rules.block.blockquote.exec(ie);if(de){var O=de[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:de[0],text:O}}},be.list=function(ie){var de=this.rules.block.list.exec(ie);if(de){var O=de[0],G=de[2],ae=G.length>1,Ce={type:"list",raw:O,ordered:ae,start:ae?+G.slice(0,-1):"",loose:!1,items:[]},Ie=de[0].match(this.rules.block.item),Oe=!1,Ue,qe,rt,nt,Ze,ot,ve,ye,ue=Ie.length;rt=this.rules.block.listItemStart.exec(Ie[0]);for(var $=0;$<ue;$++){if(Ue=Ie[$],O=Ue,$!==ue-1){if(nt=this.rules.block.listItemStart.exec(Ie[$+1]),this.options.pedantic?nt[1].length>rt[1].length:nt[1].length>rt[0].length||nt[1].length>3){Ie.splice($,2,Ie[$]+`
`+Ie[$+1]),$--,ue--;continue}else(!this.options.pedantic||this.options.smartLists?nt[2][nt[2].length-1]!==G[G.length-1]:ae===(nt[2].length===1))&&(Ze=Ie.slice($+1).join(`
`),Ce.raw=Ce.raw.substring(0,Ce.raw.length-Ze.length),$=ue-1);rt=nt}qe=Ue.length,Ue=Ue.replace(/^ *([*+-]|\d+[.)]) ?/,""),~Ue.indexOf(`
 `)&&(qe-=Ue.length,Ue=this.options.pedantic?Ue.replace(/^ {1,4}/gm,""):Ue.replace(new RegExp("^ {1,"+qe+"}","gm"),"")),ot=Oe||/\n\n(?!\s*$)/.test(Ue),$!==ue-1&&(Oe=Ue.charAt(Ue.length-1)===`
`,ot||(ot=Oe)),ot&&(Ce.loose=!0),this.options.gfm&&(ve=/^\[[ xX]\] /.test(Ue),ye=void 0,ve&&(ye=Ue[1]!==" ",Ue=Ue.replace(/^\[[ xX]\] +/,""))),Ce.items.push({type:"list_item",raw:O,task:ve,checked:ye,loose:ot,text:Ue})}return Ce}},be.html=function(ie){var de=this.rules.block.html.exec(ie);if(de)return{type:this.options.sanitize?"paragraph":"html",raw:de[0],pre:!this.options.sanitizer&&(de[1]==="pre"||de[1]==="script"||de[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(de[0]):X(de[0]):de[0]}},be.def=function(ie){var de=this.rules.block.def.exec(ie);if(de){de[3]&&(de[3]=de[3].substring(1,de[3].length-1));var O=de[1].toLowerCase().replace(/\s+/g," ");return{tag:O,raw:de[0],href:de[2],title:de[3]}}},be.table=function(ie){var de=this.rules.block.table.exec(ie);if(de){var O={type:"table",header:fe(de[1].replace(/^ *| *\| *$/g,"")),align:de[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:de[3]?de[3].replace(/\n$/,"").split(`
`):[]};if(O.header.length===O.align.length){O.raw=de[0];var G=O.align.length,ae;for(ae=0;ae<G;ae++)/^ *-+: *$/.test(O.align[ae])?O.align[ae]="right":/^ *:-+: *$/.test(O.align[ae])?O.align[ae]="center":/^ *:-+ *$/.test(O.align[ae])?O.align[ae]="left":O.align[ae]=null;for(G=O.cells.length,ae=0;ae<G;ae++)O.cells[ae]=fe(O.cells[ae].replace(/^ *\| *| *\| *$/g,""),O.header.length);return O}}},be.lheading=function(ie){var de=this.rules.block.lheading.exec(ie);if(de)return{type:"heading",raw:de[0],depth:de[2].charAt(0)==="="?1:2,text:de[1]}},be.paragraph=function(ie){var de=this.rules.block.paragraph.exec(ie);if(de)return{type:"paragraph",raw:de[0],text:de[1].charAt(de[1].length-1)===`
`?de[1].slice(0,-1):de[1]}},be.text=function(ie){var de=this.rules.block.text.exec(ie);if(de)return{type:"text",raw:de[0],text:de[0]}},be.escape=function(ie){var de=this.rules.inline.escape.exec(ie);if(de)return{type:"escape",raw:de[0],text:X(de[1])}},be.tag=function(ie,de,O){var G=this.rules.inline.tag.exec(ie);if(G)return!de&&/^<a /i.test(G[0])?de=!0:de&&/^<\/a>/i.test(G[0])&&(de=!1),!O&&/^<(pre|code|kbd|script)(\s|>)/i.test(G[0])?O=!0:O&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(G[0])&&(O=!1),{type:this.options.sanitize?"text":"html",raw:G[0],inLink:de,inRawBlock:O,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(G[0]):X(G[0]):G[0]}},be.link=function(ie){var de=this.rules.inline.link.exec(ie);if(de){var O=de[2].trim();if(!this.options.pedantic&&/^</.test(O)){if(!/>$/.test(O))return;var G=le(O.slice(0,-1),"\\");if((O.length-G.length)%2==0)return}else{var ae=z(de[2],"()");if(ae>-1){var Ce=de[0].indexOf("!")===0?5:4,Ie=Ce+de[1].length+ae;de[2]=de[2].substring(0,ae),de[0]=de[0].substring(0,Ie).trim(),de[3]=""}}var Oe=de[2],Ue="";if(this.options.pedantic){var qe=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Oe);qe&&(Oe=qe[1],Ue=qe[3])}else Ue=de[3]?de[3].slice(1,-1):"";return Oe=Oe.trim(),/^</.test(Oe)&&(this.options.pedantic&&!/>$/.test(O)?Oe=Oe.slice(1):Oe=Oe.slice(1,-1)),Y(de,{href:Oe&&Oe.replace(this.rules.inline._escapes,"$1"),title:Ue&&Ue.replace(this.rules.inline._escapes,"$1")},de[0])}},be.reflink=function(ie,de){var O;if((O=this.rules.inline.reflink.exec(ie))||(O=this.rules.inline.nolink.exec(ie))){var G=(O[2]||O[1]).replace(/\s+/g," ");if(G=de[G.toLowerCase()],!G||!G.href){var ae=O[0].charAt(0);return{type:"text",raw:ae,text:ae}}return Y(O,G,O[0])}},be.emStrong=function(ie,de,O){O===void 0&&(O="");var G=this.rules.inline.emStrong.lDelim.exec(ie);if(!!G&&!(G[3]&&O.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var ae=G[1]||G[2]||"";if(!ae||ae&&(O===""||this.rules.inline.punctuation.exec(O))){var Ce=G[0].length-1,Ie,Oe,Ue=Ce,qe=0,rt=G[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(rt.lastIndex=0,de=de.slice(-1*ie.length+Ce);(G=rt.exec(de))!=null;)if(Ie=G[1]||G[2]||G[3]||G[4]||G[5]||G[6],!!Ie){if(Oe=Ie.length,G[3]||G[4]){Ue+=Oe;continue}else if((G[5]||G[6])&&Ce%3&&!((Ce+Oe)%3)){qe+=Oe;continue}if(Ue-=Oe,!(Ue>0)){if(Ue+qe-Oe<=0&&!de.slice(rt.lastIndex).match(rt)&&(Oe=Math.min(Oe,Oe+Ue+qe)),Math.min(Ce,Oe)%2)return{type:"em",raw:ie.slice(0,Ce+G.index+Oe+1),text:ie.slice(1,Ce+G.index+Oe)};if(Math.min(Ce,Oe)%2==0)return{type:"strong",raw:ie.slice(0,Ce+G.index+Oe+1),text:ie.slice(2,Ce+G.index+Oe-1)}}}}}},be.codespan=function(ie){var de=this.rules.inline.code.exec(ie);if(de){var O=de[2].replace(/\n/g," "),G=/[^ ]/.test(O),ae=/^ /.test(O)&&/ $/.test(O);return G&&ae&&(O=O.substring(1,O.length-1)),O=X(O,!0),{type:"codespan",raw:de[0],text:O}}},be.br=function(ie){var de=this.rules.inline.br.exec(ie);if(de)return{type:"br",raw:de[0]}},be.del=function(ie){var de=this.rules.inline.del.exec(ie);if(de)return{type:"del",raw:de[0],text:de[2]}},be.autolink=function(ie,de){var O=this.rules.inline.autolink.exec(ie);if(O){var G,ae;return O[2]==="@"?(G=X(this.options.mangle?de(O[1]):O[1]),ae="mailto:"+G):(G=X(O[1]),ae=G),{type:"link",raw:O[0],text:G,href:ae,tokens:[{type:"text",raw:G,text:G}]}}},be.url=function(ie,de){var O;if(O=this.rules.inline.url.exec(ie)){var G,ae;if(O[2]==="@")G=X(this.options.mangle?de(O[0]):O[0]),ae="mailto:"+G;else{var Ce;do Ce=O[0],O[0]=this.rules.inline._backpedal.exec(O[0])[0];while(Ce!==O[0]);G=X(O[0]),O[1]==="www."?ae="http://"+G:ae=G}return{type:"link",raw:O[0],text:G,href:ae,tokens:[{type:"text",raw:G,text:G}]}}},be.inlineText=function(ie,de,O){var G=this.rules.inline.text.exec(ie);if(G){var ae;return de?ae=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(G[0]):X(G[0]):G[0]:ae=X(this.options.smartypants?O(G[0]):G[0]),{type:"text",raw:G[0],text:ae}}},Ee}(),M=N.noopTest,U=N.edit,q=N.merge,V={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:M,table:M,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};V._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,V._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,V.def=U(V.def).replace("label",V._label).replace("title",V._title).getRegex(),V.bullet=/(?:[*+-]|\d{1,9}[.)])/,V.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,V.item=U(V.item,"gm").replace(/bull/g,V.bullet).getRegex(),V.listItemStart=U(/^( *)(bull)/).replace("bull",V.bullet).getRegex(),V.list=U(V.list).replace(/bull/g,V.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+V.def.source+")").getRegex(),V._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",V._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,V.html=U(V.html,"i").replace("comment",V._comment).replace("tag",V._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),V.paragraph=U(V._paragraph).replace("hr",V.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",V._tag).getRegex(),V.blockquote=U(V.blockquote).replace("paragraph",V.paragraph).getRegex(),V.normal=q({},V),V.gfm=q({},V.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),V.gfm.nptable=U(V.gfm.nptable).replace("hr",V.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",V._tag).getRegex(),V.gfm.table=U(V.gfm.table).replace("hr",V.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",V._tag).getRegex(),V.pedantic=q({},V.normal,{html:U(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",V._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:M,paragraph:U(V.normal._paragraph).replace("hr",V.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",V.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var oe={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:M,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:M,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};oe._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",oe.punctuation=U(oe.punctuation).replace(/punctuation/g,oe._punctuation).getRegex(),oe.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,oe.escapedEmSt=/\\\*|\\_/g,oe._comment=U(V._comment).replace("(?:-->|$)","-->").getRegex(),oe.emStrong.lDelim=U(oe.emStrong.lDelim).replace(/punct/g,oe._punctuation).getRegex(),oe.emStrong.rDelimAst=U(oe.emStrong.rDelimAst,"g").replace(/punct/g,oe._punctuation).getRegex(),oe.emStrong.rDelimUnd=U(oe.emStrong.rDelimUnd,"g").replace(/punct/g,oe._punctuation).getRegex(),oe._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,oe._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,oe._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,oe.autolink=U(oe.autolink).replace("scheme",oe._scheme).replace("email",oe._email).getRegex(),oe._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,oe.tag=U(oe.tag).replace("comment",oe._comment).replace("attribute",oe._attribute).getRegex(),oe._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,oe._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,oe._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,oe.link=U(oe.link).replace("label",oe._label).replace("href",oe._href).replace("title",oe._title).getRegex(),oe.reflink=U(oe.reflink).replace("label",oe._label).getRegex(),oe.reflinkSearch=U(oe.reflinkSearch,"g").replace("reflink",oe.reflink).replace("nolink",oe.nolink).getRegex(),oe.normal=q({},oe),oe.pedantic=q({},oe.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:U(/^!?\[(label)\]\((.*?)\)/).replace("label",oe._label).getRegex(),reflink:U(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",oe._label).getRegex()}),oe.gfm=q({},oe.normal,{escape:U(oe.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),oe.gfm.url=U(oe.gfm.url,"i").replace("email",oe.gfm._extended_email).getRegex(),oe.breaks=q({},oe.gfm,{br:U(oe.br).replace("{2,}","*").getRegex(),text:U(oe.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var ge={block:V,inline:oe},Re=C.defaults,$e=ge.block,Me=ge.inline,We=N.repeatString;function Je(Ee){return Ee.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Qe(Ee){var be="",De,ie,de=Ee.length;for(De=0;De<de;De++)ie=Ee.charCodeAt(De),Math.random()>.5&&(ie="x"+ie.toString(16)),be+="&#"+ie+";";return be}var Ye=function(){function Ee(De){this.tokens=[],this.tokens.links=Object.create(null),this.options=De||Re,this.options.tokenizer=this.options.tokenizer||new B,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var ie={block:$e.normal,inline:Me.normal};this.options.pedantic?(ie.block=$e.pedantic,ie.inline=Me.pedantic):this.options.gfm&&(ie.block=$e.gfm,this.options.breaks?ie.inline=Me.breaks:ie.inline=Me.gfm),this.tokenizer.rules=ie}Ee.lex=function(ie,de){var O=new Ee(de);return O.lex(ie)},Ee.lexInline=function(ie,de){var O=new Ee(de);return O.inlineTokens(ie)};var be=Ee.prototype;return be.lex=function(ie){return ie=ie.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(ie,this.tokens,!0),this.inline(this.tokens),this.tokens},be.blockTokens=function(ie,de,O){de===void 0&&(de=[]),O===void 0&&(O=!0),this.options.pedantic&&(ie=ie.replace(/^ +$/gm,""));for(var G,ae,Ce,Ie;ie;){if(G=this.tokenizer.space(ie)){ie=ie.substring(G.raw.length),G.type&&de.push(G);continue}if(G=this.tokenizer.code(ie)){ie=ie.substring(G.raw.length),Ie=de[de.length-1],Ie&&Ie.type==="paragraph"?(Ie.raw+=`
`+G.raw,Ie.text+=`
`+G.text):de.push(G);continue}if(G=this.tokenizer.fences(ie)){ie=ie.substring(G.raw.length),de.push(G);continue}if(G=this.tokenizer.heading(ie)){ie=ie.substring(G.raw.length),de.push(G);continue}if(G=this.tokenizer.nptable(ie)){ie=ie.substring(G.raw.length),de.push(G);continue}if(G=this.tokenizer.hr(ie)){ie=ie.substring(G.raw.length),de.push(G);continue}if(G=this.tokenizer.blockquote(ie)){ie=ie.substring(G.raw.length),G.tokens=this.blockTokens(G.text,[],O),de.push(G);continue}if(G=this.tokenizer.list(ie)){for(ie=ie.substring(G.raw.length),Ce=G.items.length,ae=0;ae<Ce;ae++)G.items[ae].tokens=this.blockTokens(G.items[ae].text,[],!1);de.push(G);continue}if(G=this.tokenizer.html(ie)){ie=ie.substring(G.raw.length),de.push(G);continue}if(O&&(G=this.tokenizer.def(ie))){ie=ie.substring(G.raw.length),this.tokens.links[G.tag]||(this.tokens.links[G.tag]={href:G.href,title:G.title});continue}if(G=this.tokenizer.table(ie)){ie=ie.substring(G.raw.length),de.push(G);continue}if(G=this.tokenizer.lheading(ie)){ie=ie.substring(G.raw.length),de.push(G);continue}if(O&&(G=this.tokenizer.paragraph(ie))){ie=ie.substring(G.raw.length),de.push(G);continue}if(G=this.tokenizer.text(ie)){ie=ie.substring(G.raw.length),Ie=de[de.length-1],Ie&&Ie.type==="text"?(Ie.raw+=`
`+G.raw,Ie.text+=`
`+G.text):de.push(G);continue}if(ie){var Oe="Infinite loop on byte: "+ie.charCodeAt(0);if(this.options.silent){console.error(Oe);break}else throw new Error(Oe)}}return de},be.inline=function(ie){var de,O,G,ae,Ce,Ie,Oe=ie.length;for(de=0;de<Oe;de++)switch(Ie=ie[de],Ie.type){case"paragraph":case"text":case"heading":{Ie.tokens=[],this.inlineTokens(Ie.text,Ie.tokens);break}case"table":{for(Ie.tokens={header:[],cells:[]},ae=Ie.header.length,O=0;O<ae;O++)Ie.tokens.header[O]=[],this.inlineTokens(Ie.header[O],Ie.tokens.header[O]);for(ae=Ie.cells.length,O=0;O<ae;O++)for(Ce=Ie.cells[O],Ie.tokens.cells[O]=[],G=0;G<Ce.length;G++)Ie.tokens.cells[O][G]=[],this.inlineTokens(Ce[G],Ie.tokens.cells[O][G]);break}case"blockquote":{this.inline(Ie.tokens);break}case"list":{for(ae=Ie.items.length,O=0;O<ae;O++)this.inline(Ie.items[O].tokens);break}}return ie},be.inlineTokens=function(ie,de,O,G){de===void 0&&(de=[]),O===void 0&&(O=!1),G===void 0&&(G=!1);var ae,Ce,Ie=ie,Oe,Ue,qe;if(this.tokens.links){var rt=Object.keys(this.tokens.links);if(rt.length>0)for(;(Oe=this.tokenizer.rules.inline.reflinkSearch.exec(Ie))!=null;)rt.includes(Oe[0].slice(Oe[0].lastIndexOf("[")+1,-1))&&(Ie=Ie.slice(0,Oe.index)+"["+We("a",Oe[0].length-2)+"]"+Ie.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Oe=this.tokenizer.rules.inline.blockSkip.exec(Ie))!=null;)Ie=Ie.slice(0,Oe.index)+"["+We("a",Oe[0].length-2)+"]"+Ie.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Oe=this.tokenizer.rules.inline.escapedEmSt.exec(Ie))!=null;)Ie=Ie.slice(0,Oe.index)+"++"+Ie.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ie;){if(Ue||(qe=""),Ue=!1,ae=this.tokenizer.escape(ie)){ie=ie.substring(ae.raw.length),de.push(ae);continue}if(ae=this.tokenizer.tag(ie,O,G)){ie=ie.substring(ae.raw.length),O=ae.inLink,G=ae.inRawBlock;var nt=de[de.length-1];nt&&ae.type==="text"&&nt.type==="text"?(nt.raw+=ae.raw,nt.text+=ae.text):de.push(ae);continue}if(ae=this.tokenizer.link(ie)){ie=ie.substring(ae.raw.length),ae.type==="link"&&(ae.tokens=this.inlineTokens(ae.text,[],!0,G)),de.push(ae);continue}if(ae=this.tokenizer.reflink(ie,this.tokens.links)){ie=ie.substring(ae.raw.length);var Ze=de[de.length-1];ae.type==="link"?(ae.tokens=this.inlineTokens(ae.text,[],!0,G),de.push(ae)):Ze&&ae.type==="text"&&Ze.type==="text"?(Ze.raw+=ae.raw,Ze.text+=ae.text):de.push(ae);continue}if(ae=this.tokenizer.emStrong(ie,Ie,qe)){ie=ie.substring(ae.raw.length),ae.tokens=this.inlineTokens(ae.text,[],O,G),de.push(ae);continue}if(ae=this.tokenizer.codespan(ie)){ie=ie.substring(ae.raw.length),de.push(ae);continue}if(ae=this.tokenizer.br(ie)){ie=ie.substring(ae.raw.length),de.push(ae);continue}if(ae=this.tokenizer.del(ie)){ie=ie.substring(ae.raw.length),ae.tokens=this.inlineTokens(ae.text,[],O,G),de.push(ae);continue}if(ae=this.tokenizer.autolink(ie,Qe)){ie=ie.substring(ae.raw.length),de.push(ae);continue}if(!O&&(ae=this.tokenizer.url(ie,Qe))){ie=ie.substring(ae.raw.length),de.push(ae);continue}if(ae=this.tokenizer.inlineText(ie,G,Je)){ie=ie.substring(ae.raw.length),ae.raw.slice(-1)!=="_"&&(qe=ae.raw.slice(-1)),Ue=!0,Ce=de[de.length-1],Ce&&Ce.type==="text"?(Ce.raw+=ae.raw,Ce.text+=ae.text):de.push(ae);continue}if(ie){var ot="Infinite loop on byte: "+ie.charCodeAt(0);if(this.options.silent){console.error(ot);break}else throw new Error(ot)}}return de},e(Ee,null,[{key:"rules",get:function(){return{block:$e,inline:Me}}}]),Ee}(),W=C.defaults,Q=N.cleanUrl,te=N.escape,re=function(){function Ee(De){this.options=De||W}var be=Ee.prototype;return be.code=function(ie,de,O){var G=(de||"").match(/\S*/)[0];if(this.options.highlight){var ae=this.options.highlight(ie,G);ae!=null&&ae!==ie&&(O=!0,ie=ae)}return ie=ie.replace(/\n$/,"")+`
`,G?'<pre><code class="'+this.options.langPrefix+te(G,!0)+'">'+(O?ie:te(ie,!0))+`</code></pre>
`:"<pre><code>"+(O?ie:te(ie,!0))+`</code></pre>
`},be.blockquote=function(ie){return`<blockquote>
`+ie+`</blockquote>
`},be.html=function(ie){return ie},be.heading=function(ie,de,O,G){return this.options.headerIds?"<h"+de+' id="'+this.options.headerPrefix+G.slug(O)+'">'+ie+"</h"+de+`>
`:"<h"+de+">"+ie+"</h"+de+`>
`},be.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},be.list=function(ie,de,O){var G=de?"ol":"ul",ae=de&&O!==1?' start="'+O+'"':"";return"<"+G+ae+`>
`+ie+"</"+G+`>
`},be.listitem=function(ie){return"<li>"+ie+`</li>
`},be.checkbox=function(ie){return"<input "+(ie?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},be.paragraph=function(ie){return"<p>"+ie+`</p>
`},be.table=function(ie,de){return de&&(de="<tbody>"+de+"</tbody>"),`<table>
<thead>
`+ie+`</thead>
`+de+`</table>
`},be.tablerow=function(ie){return`<tr>
`+ie+`</tr>
`},be.tablecell=function(ie,de){var O=de.header?"th":"td",G=de.align?"<"+O+' align="'+de.align+'">':"<"+O+">";return G+ie+"</"+O+`>
`},be.strong=function(ie){return"<strong>"+ie+"</strong>"},be.em=function(ie){return"<em>"+ie+"</em>"},be.codespan=function(ie){return"<code>"+ie+"</code>"},be.br=function(){return this.options.xhtml?"<br/>":"<br>"},be.del=function(ie){return"<del>"+ie+"</del>"},be.link=function(ie,de,O){if(ie=Q(this.options.sanitize,this.options.baseUrl,ie),ie===null)return O;var G='<a href="'+te(ie)+'"';return de&&(G+=' title="'+de+'"'),G+=">"+O+"</a>",G},be.image=function(ie,de,O){if(ie=Q(this.options.sanitize,this.options.baseUrl,ie),ie===null)return O;var G='<img src="'+ie+'" alt="'+O+'"';return de&&(G+=' title="'+de+'"'),G+=this.options.xhtml?"/>":">",G},be.text=function(ie){return ie},Ee}(),K=function(){function Ee(){}var be=Ee.prototype;return be.strong=function(ie){return ie},be.em=function(ie){return ie},be.codespan=function(ie){return ie},be.del=function(ie){return ie},be.html=function(ie){return ie},be.text=function(ie){return ie},be.link=function(ie,de,O){return""+O},be.image=function(ie,de,O){return""+O},be.br=function(){return""},Ee}(),se=function(){function Ee(){this.seen={}}var be=Ee.prototype;return be.serialize=function(ie){return ie.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},be.getNextSafeSlug=function(ie,de){var O=ie,G=0;if(this.seen.hasOwnProperty(O)){G=this.seen[ie];do G++,O=ie+"-"+G;while(this.seen.hasOwnProperty(O))}return de||(this.seen[ie]=G,this.seen[O]=0),O},be.slug=function(ie,de){de===void 0&&(de={});var O=this.serialize(ie);return this.getNextSafeSlug(O,de.dryrun)},Ee}(),he=C.defaults,Ae=N.unescape,Be=function(){function Ee(De){this.options=De||he,this.options.renderer=this.options.renderer||new re,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new K,this.slugger=new se}Ee.parse=function(ie,de){var O=new Ee(de);return O.parse(ie)},Ee.parseInline=function(ie,de){var O=new Ee(de);return O.parseInline(ie)};var be=Ee.prototype;return be.parse=function(ie,de){de===void 0&&(de=!0);var O="",G,ae,Ce,Ie,Oe,Ue,qe,rt,nt,Ze,ot,ve,ye,ue,$,Ne,Pe,Ve,Xe=ie.length;for(G=0;G<Xe;G++)switch(Ze=ie[G],Ze.type){case"space":continue;case"hr":{O+=this.renderer.hr();continue}case"heading":{O+=this.renderer.heading(this.parseInline(Ze.tokens),Ze.depth,Ae(this.parseInline(Ze.tokens,this.textRenderer)),this.slugger);continue}case"code":{O+=this.renderer.code(Ze.text,Ze.lang,Ze.escaped);continue}case"table":{for(rt="",qe="",Ie=Ze.header.length,ae=0;ae<Ie;ae++)qe+=this.renderer.tablecell(this.parseInline(Ze.tokens.header[ae]),{header:!0,align:Ze.align[ae]});for(rt+=this.renderer.tablerow(qe),nt="",Ie=Ze.cells.length,ae=0;ae<Ie;ae++){for(Ue=Ze.tokens.cells[ae],qe="",Oe=Ue.length,Ce=0;Ce<Oe;Ce++)qe+=this.renderer.tablecell(this.parseInline(Ue[Ce]),{header:!1,align:Ze.align[Ce]});nt+=this.renderer.tablerow(qe)}O+=this.renderer.table(rt,nt);continue}case"blockquote":{nt=this.parse(Ze.tokens),O+=this.renderer.blockquote(nt);continue}case"list":{for(ot=Ze.ordered,ve=Ze.start,ye=Ze.loose,Ie=Ze.items.length,nt="",ae=0;ae<Ie;ae++)$=Ze.items[ae],Ne=$.checked,Pe=$.task,ue="",$.task&&(Ve=this.renderer.checkbox(Ne),ye?$.tokens.length>0&&$.tokens[0].type==="text"?($.tokens[0].text=Ve+" "+$.tokens[0].text,$.tokens[0].tokens&&$.tokens[0].tokens.length>0&&$.tokens[0].tokens[0].type==="text"&&($.tokens[0].tokens[0].text=Ve+" "+$.tokens[0].tokens[0].text)):$.tokens.unshift({type:"text",text:Ve}):ue+=Ve),ue+=this.parse($.tokens,ye),nt+=this.renderer.listitem(ue,Pe,Ne);O+=this.renderer.list(nt,ot,ve);continue}case"html":{O+=this.renderer.html(Ze.text);continue}case"paragraph":{O+=this.renderer.paragraph(this.parseInline(Ze.tokens));continue}case"text":{for(nt=Ze.tokens?this.parseInline(Ze.tokens):Ze.text;G+1<Xe&&ie[G+1].type==="text";)Ze=ie[++G],nt+=`
`+(Ze.tokens?this.parseInline(Ze.tokens):Ze.text);O+=de?this.renderer.paragraph(nt):nt;continue}default:{var lt='Token with "'+Ze.type+'" type was not found.';if(this.options.silent){console.error(lt);return}else throw new Error(lt)}}return O},be.parseInline=function(ie,de){de=de||this.renderer;var O="",G,ae,Ce=ie.length;for(G=0;G<Ce;G++)switch(ae=ie[G],ae.type){case"escape":{O+=de.text(ae.text);break}case"html":{O+=de.html(ae.text);break}case"link":{O+=de.link(ae.href,ae.title,this.parseInline(ae.tokens,de));break}case"image":{O+=de.image(ae.href,ae.title,ae.text);break}case"strong":{O+=de.strong(this.parseInline(ae.tokens,de));break}case"em":{O+=de.em(this.parseInline(ae.tokens,de));break}case"codespan":{O+=de.codespan(ae.text);break}case"br":{O+=de.br();break}case"del":{O+=de.del(this.parseInline(ae.tokens,de));break}case"text":{O+=de.text(ae.text);break}default:{var Ie='Token with "'+ae.type+'" type was not found.';if(this.options.silent){console.error(Ie);return}else throw new Error(Ie)}}return O},Ee}(),pe=N.merge,Ke=N.checkSanitizeDeprecation,j=N.escape,ee=C.getDefaults,me=C.changeDefaults,Fe=C.defaults;function Le(Ee,be,De){if(typeof Ee=="undefined"||Ee===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Ee!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Ee)+", string expected");if(typeof be=="function"&&(De=be,be=null),be=pe({},Le.defaults,be||{}),Ke(be),De){var ie=be.highlight,de;try{de=Ye.lex(Ee,be)}catch(Ce){return De(Ce)}var O=function(Ie){var Oe;if(!Ie)try{Oe=Be.parse(de,be)}catch(Ue){Ie=Ue}return be.highlight=ie,Ie?De(Ie):De(null,Oe)};if(!ie||ie.length<3||(delete be.highlight,!de.length))return O();var G=0;Le.walkTokens(de,function(Ce){Ce.type==="code"&&(G++,setTimeout(function(){ie(Ce.text,Ce.lang,function(Ie,Oe){if(Ie)return O(Ie);Oe!=null&&Oe!==Ce.text&&(Ce.text=Oe,Ce.escaped=!0),G--,G===0&&O()})},0))}),G===0&&O();return}try{var ae=Ye.lex(Ee,be);return be.walkTokens&&Le.walkTokens(ae,be.walkTokens),Be.parse(ae,be)}catch(Ce){if(Ce.message+=`
Please report this to https://github.com/markedjs/marked.`,be.silent)return"<p>An error occurred:</p><pre>"+j(Ce.message+"",!0)+"</pre>";throw Ce}}Le.options=Le.setOptions=function(Ee){return pe(Le.defaults,Ee),me(Le.defaults),Le},Le.getDefaults=ee,Le.defaults=Fe,Le.use=function(Ee){var be=pe({},Ee);if(Ee.renderer&&function(){var ie=Le.defaults.renderer||new re,de=function(ae){var Ce=ie[ae];ie[ae]=function(){for(var Ie=arguments.length,Oe=new Array(Ie),Ue=0;Ue<Ie;Ue++)Oe[Ue]=arguments[Ue];var qe=Ee.renderer[ae].apply(ie,Oe);return qe===!1&&(qe=Ce.apply(ie,Oe)),qe}};for(var O in Ee.renderer)de(O);be.renderer=ie}(),Ee.tokenizer&&function(){var ie=Le.defaults.tokenizer||new B,de=function(ae){var Ce=ie[ae];ie[ae]=function(){for(var Ie=arguments.length,Oe=new Array(Ie),Ue=0;Ue<Ie;Ue++)Oe[Ue]=arguments[Ue];var qe=Ee.tokenizer[ae].apply(ie,Oe);return qe===!1&&(qe=Ce.apply(ie,Oe)),qe}};for(var O in Ee.tokenizer)de(O);be.tokenizer=ie}(),Ee.walkTokens){var De=Le.defaults.walkTokens;be.walkTokens=function(ie){Ee.walkTokens(ie),De&&De(ie)}}Le.setOptions(be)},Le.walkTokens=function(Ee,be){for(var De=D(Ee),ie;!(ie=De()).done;){var de=ie.value;switch(be(de),de.type){case"table":{for(var O=D(de.tokens.header),G;!(G=O()).done;){var ae=G.value;Le.walkTokens(ae,be)}for(var Ce=D(de.tokens.cells),Ie;!(Ie=Ce()).done;)for(var Oe=Ie.value,Ue=D(Oe),qe;!(qe=Ue()).done;){var rt=qe.value;Le.walkTokens(rt,be)}break}case"list":{Le.walkTokens(de.items,be);break}default:de.tokens&&Le.walkTokens(de.tokens,be)}}},Le.parseInline=function(Ee,be){if(typeof Ee=="undefined"||Ee===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Ee!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Ee)+", string expected");be=pe({},Le.defaults,be||{}),Ke(be);try{var De=Ye.lexInline(Ee,be);return be.walkTokens&&Le.walkTokens(De,be.walkTokens),Be.parseInline(De,be)}catch(ie){if(ie.message+=`
Please report this to https://github.com/markedjs/marked.`,be.silent)return"<p>An error occurred:</p><pre>"+j(ie.message+"",!0)+"</pre>";throw ie}},Le.Parser=Be,Le.parser=Be.parse,Le.Renderer=re,Le.TextRenderer=K,Le.Lexer=Ye,Le.lexer=Ye.lex,Le.Tokenizer=B,Le.Slugger=se,Le.parse=Le;var Ge=Le;return Ge}),define(we[77],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function g(C,y,_){return Math.min(Math.max(C,y),_)}e.clamp=g;function T(C,y){return(y+C%y)%y}e.rot=T;class D{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=D;class E{constructor(){this._n=1,this._val=0}update(y){return this._val=this._val+(y-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=E}),function(){function Z(D){const E=[];typeof D=="number"&&E.push("code/timeOrigin",D);function C(_){E.push(_,Date.now())}function y(){const _=[];for(let k=0;k<E.length;k+=2)_.push({name:E[k],startTime:E[k+1]});return _}return{mark:C,getMarks:y}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?Z():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const E=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const C of performance.getEntriesByType("mark"))E.push({name:C.name,startTime:Math.round(D+C.startTime)});return E}};if(typeof process=="object"){const D=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Z(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),Z()}function g(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var T;typeof global=="object"?T=global:typeof self=="object"?T=self:T={},typeof define=="function"?define("vs/base/common/performance",[],function(){return g(T)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=g(T):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),T.perf=g(T))}(),define(we[21],_e([0,1]),function(Z,e){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const T="en";let D=!1,E=!1,C=!1,y=!1,_=!1,k=!1,n=!1,I,o=T,h,d;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let u;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?u=e.globals.vscode.process:typeof process!="undefined"&&(u=process);const w=typeof((g=u==null?void 0:u.versions)===null||g===void 0?void 0:g.electron)=="string"&&u.type==="renderer";if(e.isElectronSandboxed=w&&(u==null?void 0:u.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const s=u==null?void 0:u.env.VSCODE_BROWSER_CODE_LOADING;if(typeof s=="string")return s==="none"||s==="code"||s==="bypassHeatCheck"||s==="bypassHeatCheckAndEagerCompile"?s:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!w)d=navigator.userAgent,D=d.indexOf("Windows")>=0,E=d.indexOf("Macintosh")>=0,n=(d.indexOf("Macintosh")>=0||d.indexOf("iPad")>=0||d.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,C=d.indexOf("Linux")>=0,k=!0,I=navigator.language,o=I;else if(typeof u=="object"){D=u.platform==="win32",E=u.platform==="darwin",C=u.platform==="linux",y=C&&!!u.env.SNAP&&!!u.env.SNAP_REVISION,I=T,o=T;const s=u.env.VSCODE_NLS_CONFIG;if(s)try{const l=JSON.parse(s),b=l.availableLanguages["*"];I=l.locale,o=b||T,h=l._translationsConfigFile}catch(l){}_=!0}else console.error("Unable to resolve platform.");var v;(function(s){s[s.Web=0]="Web",s[s.Mac=1]="Mac",s[s.Linux=2]="Linux",s[s.Windows=3]="Windows"})(v=e.Platform||(e.Platform={}));function S(s){switch(s){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=S;let c=0;E?c=1:D?c=3:C&&(c=2),e.isWindows=D,e.isMacintosh=E,e.isLinux=C,e.isLinuxSnap=y,e.isNative=_,e.isWeb=k,e.isIOS=n,e.platform=c,e.userAgent=d,e.language=o;var m;(function(s){function l(){return e.language}s.value=l;function b(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}s.isDefaultVariant=b;function p(){return e.language==="en"}s.isDefault=p})(m=e.Language||(e.Language={})),e.locale=I,e.translationsConfigFile=h,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let b=[];e.globals.addEventListener("message",P=>{if(P.data&&P.data.vscodeSetImmediateId)for(let A=0,a=b.length;A<a;A++){const F=b[A];if(F.id===P.data.vscodeSetImmediateId){b.splice(A,1),F.callback();return}}});let p=0;return P=>{const A=++p;b.push({id:A,callback:P}),e.globals.postMessage({vscodeSetImmediateId:A},"*")}}if(typeof(u==null?void 0:u.nextTick)=="function")return u.nextTick.bind(u);const l=Promise.resolve();return b=>l.then(b)}();var f;(function(s){s[s.Windows=1]="Windows",s[s.Macintosh=2]="Macintosh",s[s.Linux=3]="Linux"})(f=e.OperatingSystem||(e.OperatingSystem={})),e.OS=E||n?2:D?1:3;let t=!0,r=!1;function i(){if(!r){r=!0;const s=new Uint8Array(2);s[0]=1,s[1]=2,t=new Uint16Array(s.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=i}),define(we[40],_e([0,1,21]),function(Z,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let T;if(typeof g.globals.vscode!="undefined"&&typeof g.globals.vscode.process!="undefined"){const D=g.globals.vscode.process;T={get platform(){return D.platform},get env(){return D.env},cwd(){return D.cwd()},nextTick(E){return g.setImmediate(E)}}}else typeof process!="undefined"?T={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(D){return process.nextTick(D)}}:T={get platform(){return g.isWindows?"win32":g.isMacintosh?"darwin":"linux"},nextTick(D){return g.setImmediate(D)},get env(){return{}},cwd(){return"/"}};e.cwd=T.cwd,e.env=T.env,e.platform=T.platform,e.nextTick=T.nextTick}),define(we[13],_e([0,1,40]),function(Z,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const T=65,D=97,E=90,C=122,y=46,_=47,k=92,n=58,I=63;class o extends Error{constructor(m,f,t){let r;typeof f=="string"&&f.indexOf("not ")===0?(r="must not be",f=f.replace(/^not /,"")):r="must be";const i=m.indexOf(".")!==-1?"property":"argument";let s=`The "${m}" ${i} ${r} of type ${f}`;s+=`. Received type ${typeof t}`,super(s),this.code="ERR_INVALID_ARG_TYPE"}}function h(c,m){if(typeof c!="string")throw new o(m,"string",c)}function d(c){return c===_||c===k}function u(c){return c===_}function w(c){return c>=T&&c<=E||c>=D&&c<=C}function v(c,m,f,t){let r="",i=0,s=-1,l=0,b=0;for(let p=0;p<=c.length;++p){if(p<c.length)b=c.charCodeAt(p);else{if(t(b))break;b=_}if(t(b)){if(!(s===p-1||l===1))if(l===2){if(r.length<2||i!==2||r.charCodeAt(r.length-1)!==y||r.charCodeAt(r.length-2)!==y){if(r.length>2){const P=r.lastIndexOf(f);P===-1?(r="",i=0):(r=r.slice(0,P),i=r.length-1-r.lastIndexOf(f)),s=p,l=0;continue}else if(r.length!==0){r="",i=0,s=p,l=0;continue}}m&&(r+=r.length>0?`${f}..`:"..",i=2)}else r.length>0?r+=`${f}${c.slice(s+1,p)}`:r=c.slice(s+1,p),i=p-s-1;s=p,l=0}else b===y&&l!==-1?++l:l=-1}return r}function S(c,m){if(m===null||typeof m!="object")throw new o("pathObject","Object",m);const f=m.dir||m.root,t=m.base||`${m.name||""}${m.ext||""}`;return f?f===m.root?`${f}${t}`:`${f}${c}${t}`:t}e.win32={resolve(...c){let m="",f="",t=!1;for(let r=c.length-1;r>=-1;r--){let i;if(r>=0){if(i=c[r],h(i,"path"),i.length===0)continue}else m.length===0?i=g.cwd():(i=g.env[`=${m}`]||g.cwd(),(i===void 0||i.slice(0,2).toLowerCase()!==m.toLowerCase()&&i.charCodeAt(2)===k)&&(i=`${m}\\`));const s=i.length;let l=0,b="",p=!1;const P=i.charCodeAt(0);if(s===1)d(P)&&(l=1,p=!0);else if(d(P))if(p=!0,d(i.charCodeAt(1))){let A=2,a=A;for(;A<s&&!d(i.charCodeAt(A));)A++;if(A<s&&A!==a){const F=i.slice(a,A);for(a=A;A<s&&d(i.charCodeAt(A));)A++;if(A<s&&A!==a){for(a=A;A<s&&!d(i.charCodeAt(A));)A++;(A===s||A!==a)&&(b=`\\\\${F}\\${i.slice(a,A)}`,l=A)}}}else l=1;else w(P)&&i.charCodeAt(1)===n&&(b=i.slice(0,2),l=2,s>2&&d(i.charCodeAt(2))&&(p=!0,l=3));if(b.length>0)if(m.length>0){if(b.toLowerCase()!==m.toLowerCase())continue}else m=b;if(t){if(m.length>0)break}else if(f=`${i.slice(l)}\\${f}`,t=p,p&&m.length>0)break}return f=v(f,!t,"\\",d),t?`${m}\\${f}`:`${m}${f}`||"."},normalize(c){h(c,"path");const m=c.length;if(m===0)return".";let f=0,t,r=!1;const i=c.charCodeAt(0);if(m===1)return u(i)?"\\":c;if(d(i))if(r=!0,d(c.charCodeAt(1))){let l=2,b=l;for(;l<m&&!d(c.charCodeAt(l));)l++;if(l<m&&l!==b){const p=c.slice(b,l);for(b=l;l<m&&d(c.charCodeAt(l));)l++;if(l<m&&l!==b){for(b=l;l<m&&!d(c.charCodeAt(l));)l++;if(l===m)return`\\\\${p}\\${c.slice(b)}\\`;l!==b&&(t=`\\\\${p}\\${c.slice(b,l)}`,f=l)}}}else f=1;else w(i)&&c.charCodeAt(1)===n&&(t=c.slice(0,2),f=2,m>2&&d(c.charCodeAt(2))&&(r=!0,f=3));let s=f<m?v(c.slice(f),!r,"\\",d):"";return s.length===0&&!r&&(s="."),s.length>0&&d(c.charCodeAt(m-1))&&(s+="\\"),t===void 0?r?`\\${s}`:s:r?`${t}\\${s}`:`${t}${s}`},isAbsolute(c){h(c,"path");const m=c.length;if(m===0)return!1;const f=c.charCodeAt(0);return d(f)||m>2&&w(f)&&c.charCodeAt(1)===n&&d(c.charCodeAt(2))},join(...c){if(c.length===0)return".";let m,f;for(let i=0;i<c.length;++i){const s=c[i];h(s,"path"),s.length>0&&(m===void 0?m=f=s:m+=`\\${s}`)}if(m===void 0)return".";let t=!0,r=0;if(typeof f=="string"&&d(f.charCodeAt(0))){++r;const i=f.length;i>1&&d(f.charCodeAt(1))&&(++r,i>2&&(d(f.charCodeAt(2))?++r:t=!1))}if(t){for(;r<m.length&&d(m.charCodeAt(r));)r++;r>=2&&(m=`\\${m.slice(r)}`)}return e.win32.normalize(m)},relative(c,m){if(h(c,"from"),h(m,"to"),c===m)return"";const f=e.win32.resolve(c),t=e.win32.resolve(m);if(f===t||(c=f.toLowerCase(),m=t.toLowerCase(),c===m))return"";let r=0;for(;r<c.length&&c.charCodeAt(r)===k;)r++;let i=c.length;for(;i-1>r&&c.charCodeAt(i-1)===k;)i--;const s=i-r;let l=0;for(;l<m.length&&m.charCodeAt(l)===k;)l++;let b=m.length;for(;b-1>l&&m.charCodeAt(b-1)===k;)b--;const p=b-l,P=s<p?s:p;let A=-1,a=0;for(;a<P;a++){const N=c.charCodeAt(r+a);if(N!==m.charCodeAt(l+a))break;N===k&&(A=a)}if(a!==P){if(A===-1)return t}else{if(p>P){if(m.charCodeAt(l+a)===k)return t.slice(l+a+1);if(a===2)return t.slice(l+a)}s>P&&(c.charCodeAt(r+a)===k?A=a:a===2&&(A=3)),A===-1&&(A=0)}let F="";for(a=r+A+1;a<=i;++a)(a===i||c.charCodeAt(a)===k)&&(F+=F.length===0?"..":"\\..");return l+=A,F.length>0?`${F}${t.slice(l,b)}`:(t.charCodeAt(l)===k&&++l,t.slice(l,b))},toNamespacedPath(c){if(typeof c!="string")return c;if(c.length===0)return"";const m=e.win32.resolve(c);if(m.length<=2)return c;if(m.charCodeAt(0)===k){if(m.charCodeAt(1)===k){const f=m.charCodeAt(2);if(f!==I&&f!==y)return`\\\\?\\UNC\\${m.slice(2)}`}}else if(w(m.charCodeAt(0))&&m.charCodeAt(1)===n&&m.charCodeAt(2)===k)return`\\\\?\\${m}`;return c},dirname(c){h(c,"path");const m=c.length;if(m===0)return".";let f=-1,t=0;const r=c.charCodeAt(0);if(m===1)return d(r)?c:".";if(d(r)){if(f=t=1,d(c.charCodeAt(1))){let l=2,b=l;for(;l<m&&!d(c.charCodeAt(l));)l++;if(l<m&&l!==b){for(b=l;l<m&&d(c.charCodeAt(l));)l++;if(l<m&&l!==b){for(b=l;l<m&&!d(c.charCodeAt(l));)l++;if(l===m)return c;l!==b&&(f=t=l+1)}}}}else w(r)&&c.charCodeAt(1)===n&&(f=m>2&&d(c.charCodeAt(2))?3:2,t=f);let i=-1,s=!0;for(let l=m-1;l>=t;--l)if(d(c.charCodeAt(l))){if(!s){i=l;break}}else s=!1;if(i===-1){if(f===-1)return".";i=f}return c.slice(0,i)},basename(c,m){m!==void 0&&h(m,"ext"),h(c,"path");let f=0,t=-1,r=!0,i;if(c.length>=2&&w(c.charCodeAt(0))&&c.charCodeAt(1)===n&&(f=2),m!==void 0&&m.length>0&&m.length<=c.length){if(m===c)return"";let s=m.length-1,l=-1;for(i=c.length-1;i>=f;--i){const b=c.charCodeAt(i);if(d(b)){if(!r){f=i+1;break}}else l===-1&&(r=!1,l=i+1),s>=0&&(b===m.charCodeAt(s)?--s==-1&&(t=i):(s=-1,t=l))}return f===t?t=l:t===-1&&(t=c.length),c.slice(f,t)}for(i=c.length-1;i>=f;--i)if(d(c.charCodeAt(i))){if(!r){f=i+1;break}}else t===-1&&(r=!1,t=i+1);return t===-1?"":c.slice(f,t)},extname(c){h(c,"path");let m=0,f=-1,t=0,r=-1,i=!0,s=0;c.length>=2&&c.charCodeAt(1)===n&&w(c.charCodeAt(0))&&(m=t=2);for(let l=c.length-1;l>=m;--l){const b=c.charCodeAt(l);if(d(b)){if(!i){t=l+1;break}continue}r===-1&&(i=!1,r=l+1),b===y?f===-1?f=l:s!==1&&(s=1):f!==-1&&(s=-1)}return f===-1||r===-1||s===0||s===1&&f===r-1&&f===t+1?"":c.slice(f,r)},format:S.bind(null,"\\"),parse(c){h(c,"path");const m={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return m;const f=c.length;let t=0,r=c.charCodeAt(0);if(f===1)return d(r)?(m.root=m.dir=c,m):(m.base=m.name=c,m);if(d(r)){if(t=1,d(c.charCodeAt(1))){let A=2,a=A;for(;A<f&&!d(c.charCodeAt(A));)A++;if(A<f&&A!==a){for(a=A;A<f&&d(c.charCodeAt(A));)A++;if(A<f&&A!==a){for(a=A;A<f&&!d(c.charCodeAt(A));)A++;A===f?t=A:A!==a&&(t=A+1)}}}}else if(w(r)&&c.charCodeAt(1)===n){if(f<=2)return m.root=m.dir=c,m;if(t=2,d(c.charCodeAt(2))){if(f===3)return m.root=m.dir=c,m;t=3}}t>0&&(m.root=c.slice(0,t));let i=-1,s=t,l=-1,b=!0,p=c.length-1,P=0;for(;p>=t;--p){if(r=c.charCodeAt(p),d(r)){if(!b){s=p+1;break}continue}l===-1&&(b=!1,l=p+1),r===y?i===-1?i=p:P!==1&&(P=1):i!==-1&&(P=-1)}return l!==-1&&(i===-1||P===0||P===1&&i===l-1&&i===s+1?m.base=m.name=c.slice(s,l):(m.name=c.slice(s,i),m.base=c.slice(s,l),m.ext=c.slice(i,l))),s>0&&s!==t?m.dir=c.slice(0,s-1):m.dir=m.root,m},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...c){let m="",f=!1;for(let t=c.length-1;t>=-1&&!f;t--){const r=t>=0?c[t]:g.cwd();h(r,"path"),r.length!==0&&(m=`${r}/${m}`,f=r.charCodeAt(0)===_)}return m=v(m,!f,"/",u),f?`/${m}`:m.length>0?m:"."},normalize(c){if(h(c,"path"),c.length===0)return".";const m=c.charCodeAt(0)===_,f=c.charCodeAt(c.length-1)===_;return c=v(c,!m,"/",u),c.length===0?m?"/":f?"./":".":(f&&(c+="/"),m?`/${c}`:c)},isAbsolute(c){return h(c,"path"),c.length>0&&c.charCodeAt(0)===_},join(...c){if(c.length===0)return".";let m;for(let f=0;f<c.length;++f){const t=c[f];h(t,"path"),t.length>0&&(m===void 0?m=t:m+=`/${t}`)}return m===void 0?".":e.posix.normalize(m)},relative(c,m){if(h(c,"from"),h(m,"to"),c===m||(c=e.posix.resolve(c),m=e.posix.resolve(m),c===m))return"";const f=1,t=c.length,r=t-f,i=1,s=m.length-i,l=r<s?r:s;let b=-1,p=0;for(;p<l;p++){const A=c.charCodeAt(f+p);if(A!==m.charCodeAt(i+p))break;A===_&&(b=p)}if(p===l)if(s>l){if(m.charCodeAt(i+p)===_)return m.slice(i+p+1);if(p===0)return m.slice(i+p)}else r>l&&(c.charCodeAt(f+p)===_?b=p:p===0&&(b=0));let P="";for(p=f+b+1;p<=t;++p)(p===t||c.charCodeAt(p)===_)&&(P+=P.length===0?"..":"/..");return`${P}${m.slice(i+b)}`},toNamespacedPath(c){return c},dirname(c){if(h(c,"path"),c.length===0)return".";const m=c.charCodeAt(0)===_;let f=-1,t=!0;for(let r=c.length-1;r>=1;--r)if(c.charCodeAt(r)===_){if(!t){f=r;break}}else t=!1;return f===-1?m?"/":".":m&&f===1?"//":c.slice(0,f)},basename(c,m){m!==void 0&&h(m,"ext"),h(c,"path");let f=0,t=-1,r=!0,i;if(m!==void 0&&m.length>0&&m.length<=c.length){if(m===c)return"";let s=m.length-1,l=-1;for(i=c.length-1;i>=0;--i){const b=c.charCodeAt(i);if(b===_){if(!r){f=i+1;break}}else l===-1&&(r=!1,l=i+1),s>=0&&(b===m.charCodeAt(s)?--s==-1&&(t=i):(s=-1,t=l))}return f===t?t=l:t===-1&&(t=c.length),c.slice(f,t)}for(i=c.length-1;i>=0;--i)if(c.charCodeAt(i)===_){if(!r){f=i+1;break}}else t===-1&&(r=!1,t=i+1);return t===-1?"":c.slice(f,t)},extname(c){h(c,"path");let m=-1,f=0,t=-1,r=!0,i=0;for(let s=c.length-1;s>=0;--s){const l=c.charCodeAt(s);if(l===_){if(!r){f=s+1;break}continue}t===-1&&(r=!1,t=s+1),l===y?m===-1?m=s:i!==1&&(i=1):m!==-1&&(i=-1)}return m===-1||t===-1||i===0||i===1&&m===t-1&&m===f+1?"":c.slice(m,t)},format:S.bind(null,"/"),parse(c){h(c,"path");const m={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return m;const f=c.charCodeAt(0)===_;let t;f?(m.root="/",t=1):t=0;let r=-1,i=0,s=-1,l=!0,b=c.length-1,p=0;for(;b>=t;--b){const P=c.charCodeAt(b);if(P===_){if(!l){i=b+1;break}continue}s===-1&&(l=!1,s=b+1),P===y?r===-1?r=b:p!==1&&(p=1):r!==-1&&(p=-1)}if(s!==-1){const P=i===0&&f?1:i;r===-1||p===0||p===1&&r===s-1&&r===i+1?m.base=m.name=c.slice(P,s):(m.name=c.slice(P,r),m.base=c.slice(P,s),m.ext=c.slice(r,s))}return i>0?m.dir=c.slice(0,i-1):f&&(m.dir="/"),m},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=g.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=g.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=g.platform==="win32"?e.win32.join:e.posix.join,e.resolve=g.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=g.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=g.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=g.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=g.platform==="win32"?e.win32.extname:e.posix.extname,e.format=g.platform==="win32"?e.win32.format:e.posix.format,e.parse=g.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=g.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=g.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=g.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(we[52],_e([0,1,21]),function(Z,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const T=g.globals.performance&&typeof g.globals.performance.now=="function";class D{constructor(C){this._highResolution=T&&C,this._startTime=this._now(),this._stopTime=-1}static create(C=!0){return new D(C)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?g.globals.performance.now():Date.now()}}e.StopWatch=D}),define(we[3],_e([0,1,12,48,7,51,52]),function(Z,e,g,T,D,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var y;(function(v){v.None=()=>D.Disposable.None;function S(X){return(z,Y=null,R)=>{let B=!1,M;return M=X(U=>{if(!B)return M?M.dispose():B=!0,z.call(Y,U)},null,R),B&&M.dispose(),M}}v.once=S;function c(X,z){return s((Y,R=null,B)=>X(M=>Y.call(R,z(M)),null,B))}v.map=c;function m(X,z){return s((Y,R=null,B)=>X(M=>{z(M),Y.call(R,M)},null,B))}v.forEach=m;function f(X,z){return s((Y,R=null,B)=>X(M=>z(M)&&Y.call(R,M),null,B))}v.filter=f;function t(X){return X}v.signal=t;function r(...X){return(z,Y=null,R)=>D.combinedDisposable(...X.map(B=>B(M=>z.call(Y,M),null,R)))}v.any=r;function i(X,z,Y){let R=Y;return c(X,B=>(R=z(R,B),R))}v.reduce=i;function s(X){let z;const Y=new o({onFirstListenerAdd(){z=X(Y.fire,Y)},onLastListenerRemove(){z.dispose()}});return Y.event}v.snapshot=s;function l(X,z,Y=100,R=!1,B){let M,U,q,V=0;const oe=new o({leakWarningThreshold:B,onFirstListenerAdd(){M=X(ge=>{V++,U=z(U,ge),R&&!q&&(oe.fire(U),U=void 0),clearTimeout(q),q=setTimeout(()=>{const Re=U;U=void 0,q=void 0,(!R||V>1)&&oe.fire(Re),V=0},Y)})},onLastListenerRemove(){M.dispose()}});return oe.event}v.debounce=l;function b(X){const z=new Date().getTime();return c(S(X),Y=>new Date().getTime()-z)}v.stopwatch=b;function p(X,z=(Y,R)=>Y===R){let Y=!0,R;return f(X,B=>{const M=Y||!z(B,R);return Y=!1,R=B,M})}v.latch=p;function P(X,z){return[v.filter(X,z),v.filter(X,Y=>!z(Y))]}v.split=P;function A(X,z=!1,Y=[]){let R=Y.slice(),B=X(q=>{R?R.push(q):U.fire(q)});const M=()=>{R&&R.forEach(q=>U.fire(q)),R=null},U=new o({onFirstListenerAdd(){B||(B=X(q=>U.fire(q)))},onFirstListenerDidAdd(){R&&(z?setTimeout(M):M())},onLastListenerRemove(){B&&B.dispose(),B=null}});return U.event}v.buffer=A;class a{constructor(z){this.event=z}map(z){return new a(c(this.event,z))}forEach(z){return new a(m(this.event,z))}filter(z){return new a(f(this.event,z))}reduce(z,Y){return new a(i(this.event,z,Y))}latch(){return new a(p(this.event))}debounce(z,Y=100,R=!1,B){return new a(l(this.event,z,Y,R,B))}on(z,Y,R){return this.event(z,Y,R)}once(z,Y,R){return S(this.event)(z,Y,R)}}function F(X){return new a(X)}v.chain=F;function N(X,z,Y=R=>R){const R=(...q)=>U.fire(Y(...q)),B=()=>X.on(z,R),M=()=>X.removeListener(z,R),U=new o({onFirstListenerAdd:B,onLastListenerRemove:M});return U.event}v.fromNodeEventEmitter=N;function H(X,z,Y=R=>R){const R=(...q)=>U.fire(Y(...q)),B=()=>X.addEventListener(z,R),M=()=>X.removeEventListener(z,R),U=new o({onFirstListenerAdd:B,onLastListenerRemove:M});return U.event}v.fromDOMEventEmitter=H;function le(X){const z=new o;let Y=!1;return X.then(void 0,()=>null).then(()=>{Y?z.fire(void 0):setTimeout(()=>z.fire(void 0),0)}),Y=!0,z.event}v.fromPromise=le;function fe(X){return new Promise(z=>S(X)(z))}v.toPromise=fe})(y=e.Event||(e.Event={}));class _{constructor(S){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${S}_${_._idPool++}`}start(S){this._stopWatch=new C.StopWatch(!0),this._listenerCount=S}stop(){if(this._stopWatch){const S=this._stopWatch.elapsed();this._elapsedOverall+=S,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${S.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}_._idPool=0;let k=-1;function n(v){const S=k;return k=v,{dispose(){k=S}}}e.setGlobalLeakWarningThreshold=n;class I{constructor(S,c=Math.random().toString(18).slice(2,5)){this.customThreshold=S,this.name=c,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(S){let c=k;if(typeof this.customThreshold=="number"&&(c=this.customThreshold),c<=0||S<c)return;this._stacks||(this._stacks=new Map);const m=new Error().stack.split(`
`).slice(3).join(`
`),f=this._stacks.get(m)||0;if(this._stacks.set(m,f+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=c*.5;let t,r=0;for(const[i,s]of this._stacks)(!t||r<s)&&(t=i,r=s);console.warn(`[${this.name}] potential listener LEAK detected, having ${S} listeners already. MOST frequent listener (${r}):`),console.warn(t)}return()=>{const t=this._stacks.get(m)||0;this._stacks.set(m,t-1)}}}class o{constructor(S){var c;this._disposed=!1,this._options=S,this._leakageMon=k>0?new I(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((c=this._options)===null||c===void 0?void 0:c._profName)?new _(this._options._profName):void 0}get event(){return this._event||(this._event=(S,c,m)=>{var f;this._listeners||(this._listeners=new E.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const r=this._listeners.push(c?[S,c]:S);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,S,c);const i=(f=this._leakageMon)===null||f===void 0?void 0:f.check(this._listeners.size);let s;return s={dispose:()=>{i&&i(),s.dispose=o._noop,this._disposed||(r(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},m instanceof D.DisposableStore?m.add(s):Array.isArray(m)&&m.push(s),s}),this._event}fire(S){var c,m;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new E.LinkedList);for(let f of this._listeners)this._deliveryQueue.push([f,S]);for((c=this._perfMon)===null||c===void 0||c.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[f,t]=this._deliveryQueue.shift();try{typeof f=="function"?f.call(void 0,t):f[0].call(f[1],t)}catch(r){g.onUnexpectedError(r)}}(m=this._perfMon)===null||m===void 0||m.stop()}}dispose(){var S,c,m,f,t;this._disposed||(this._disposed=!0,(S=this._listeners)===null||S===void 0||S.clear(),(c=this._deliveryQueue)===null||c===void 0||c.clear(),(f=(m=this._options)===null||m===void 0?void 0:m.onLastListenerRemove)===null||f===void 0||f.call(m),(t=this._leakageMon)===null||t===void 0||t.dispose())}}e.Emitter=o,o._noop=function(){};class h extends o{constructor(S){super(S);this._isPaused=0,this._eventQueue=new E.LinkedList,this._mergeFn=S==null?void 0:S.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const S=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(S))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(S){this._listeners&&(this._isPaused!==0?this._eventQueue.push(S):super.fire(S))}}e.PauseableEmitter=h;class d{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new o({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(S){const c={event:S,listener:null};this.events.push(c),this.hasListeners&&this.hook(c);const m=()=>{this.hasListeners&&this.unhook(c);const f=this.events.indexOf(c);this.events.splice(f,1)};return D.toDisposable(T.once(m))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(S=>this.hook(S))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(S=>this.unhook(S))}hook(S){S.listener=S.event(c=>this.emitter.fire(c))}unhook(S){S.listener&&S.listener.dispose(),S.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=d;class u{constructor(){this.buffers=[]}wrapEvent(S){return(c,m,f)=>S(t=>{const r=this.buffers[this.buffers.length-1];r?r.push(()=>c.call(m,t)):c.call(m,t)},void 0,f)}bufferEvents(S){const c=[];this.buffers.push(c);const m=S();return this.buffers.pop(),c.forEach(f=>f()),m}}e.EventBufferer=u;class w{constructor(){this.listening=!1,this.inputEvent=y.None,this.inputEventListener=D.Disposable.None,this.emitter=new o({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(S){this.inputEvent=S,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=S(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=w}),define(we[18],_e([0,1,3]),function(Z,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const T=Object.freeze(function(y,_){const k=setTimeout(y.bind(_),0);return{dispose(){clearTimeout(k)}}});var D;(function(y){function _(k){return k===y.None||k===y.Cancelled||k instanceof E?!0:!k||typeof k!="object"?!1:typeof k.isCancellationRequested=="boolean"&&typeof k.onCancellationRequested=="function"}y.isCancellationToken=_,y.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:g.Event.None}),y.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:T})})(D=e.CancellationToken||(e.CancellationToken={}));class E{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?T:(this._emitter||(this._emitter=new g.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class C{constructor(_){this._token=void 0,this._parentListener=void 0,this._parentListener=_&&_.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new E),this._token}cancel(){this._token?this._token instanceof E&&this._token.cancel():this._token=D.Cancelled}dispose(_=!1){_&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof E&&this._token.dispose():this._token=D.None}}e.CancellationTokenSource=C}),define(we[78],_e([0,1,3]),function(Z,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class T{constructor(){this._icons=new Map,this._onDidRegister=new g.Emitter}add(I){const o=this._icons.get(I.id);o?I.description?o.description=I.description:console.error(`Duplicate registration of codicon ${I.id}`):(this._icons.set(I.id,I),this._onDidRegister.fire(I))}get(I){return this._icons.get(I)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const D=new T;e.iconRegistry=D;function E(n,I){return new y(n,I)}e.registerCodicon=E;function C(n){return n?n.replace(/\$\((.*?)\)/g,(I,o)=>` ${o} `).trim():""}e.getCodiconAriaLabel=C;class y{constructor(I,o,h){this.id=I,this.definition=o,this.description=h,D.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=y;function _(n,I){const o=["codicon","codicon-"+n];return I&&o.push("codicon-modifier-"+I),o}e.getClassNamesArray=_;var k;(function(n){n.iconNameSegment="[A-Za-z0-9]+",n.iconNameExpression="[A-Za-z0-9\\-]+",n.iconModifierExpression="~[A-Za-z]+";const I=new RegExp(`^(${n.iconNameExpression})(${n.iconModifierExpression})?$`);function o(u){if(u instanceof y)return["codicon","codicon-"+u.id];const w=I.exec(u.id);if(!w)return o(y.error);let[,v,S]=w;const c=["codicon","codicon-"+v];return S&&c.push("codicon-modifier-"+S.substr(1)),c}n.asClassNameArray=o;function h(u){return o(u).join(" ")}n.asClassName=h;function d(u){return"."+o(u).join(".")}n.asCSSSelector=d})(k=e.CSSIcon||(e.CSSIcon={})),function(n){n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",{fontCharacter:"\\ea60"}),n.gistNew=new n("gist-new",{fontCharacter:"\\ea60"}),n.repoCreate=new n("repo-create",{fontCharacter:"\\ea60"}),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eb0a"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition)}(y=e.Codicon||(e.Codicon={}))}),define(we[107],_e([0,1,12,7]),function(Z,e,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function D(c){const m=c;return m?[m.on,m.pause,m.resume,m.destroy].every(f=>typeof f=="function"):!1}e.isReadableStream=D;function E(c){const m=c;return m?D(m.stream)&&Array.isArray(m.buffer)&&typeof m.ended=="boolean":!1}e.isReadableBufferedStream=E;function C(c,m){return new y(c,m)}e.newWriteableStream=C;class y{constructor(m,f){this.reducer=m,this.options=f,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(m){var f;if(!this.state.destroyed){if(this.state.flowing)this.emitData(m);else if(this.buffer.data.push(m),typeof((f=this.options)===null||f===void 0?void 0:f.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(m){this.state.destroyed||(this.state.flowing?this.emitError(m):this.buffer.error.push(m))}end(m){this.state.destroyed||(typeof m!="undefined"&&this.write(m),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(m){this.listeners.data.slice(0).forEach(f=>f(m))}emitError(m){this.listeners.error.length===0?g.onUnexpectedError(m):this.listeners.error.slice(0).forEach(f=>f(m))}emitEnd(){this.listeners.end.slice(0).forEach(m=>m())}on(m,f){if(!this.state.destroyed)switch(m){case"data":this.listeners.data.push(f),this.resume();break;case"end":this.listeners.end.push(f),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(f),this.state.flowing&&this.flowErrors();break}}removeListener(m,f){if(this.state.destroyed)return;let t;switch(m){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const r=t.indexOf(f);r>=0&&t.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const m=this.reducer(this.buffer.data);this.emitData(m),this.buffer.data.length=0;const f=[...this.pendingWritePromises];this.pendingWritePromises.length=0,f.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const m of this.buffer.error)this.emitError(m);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function _(c,m){const f=[];let t;for(;(t=c.read())!==null;)f.push(t);return m(f)}e.consumeReadable=_;function k(c,m,f){const t=[];let r;for(;(r=c.read())!==null&&t.length<f;)t.push(r);return r===null&&t.length>0?m(t):{read:()=>{if(t.length>0)return t.shift();if(typeof r!="undefined"){const i=r;return r=void 0,i}return c.read()}}}e.peekReadable=k;function n(c,m){return new Promise((f,t)=>{const r=[];I(c,{onData:i=>{m&&r.push(i)},onError:i=>{m?t(i):f(void 0)},onEnd:()=>{f(m?m(r):void 0)}})})}e.consumeStream=n;function I(c,m){c.on("error",f=>m.onError(f)),c.on("end",()=>m.onEnd()),c.on("data",f=>m.onData(f))}e.listenStream=I;function o(c,m){return new Promise((f,t)=>{const r=new T.DisposableStore,i=[],s=p=>{if(i.push(p),i.length>m)return r.dispose(),c.pause(),f({stream:c,buffer:i,ended:!1})},l=p=>t(p),b=()=>f({stream:c,buffer:i,ended:!0});r.add(T.toDisposable(()=>c.removeListener("error",l))),c.on("error",l),r.add(T.toDisposable(()=>c.removeListener("end",b))),c.on("end",b),r.add(T.toDisposable(()=>c.removeListener("data",s))),c.on("data",s)})}e.peekStream=o;function h(c,m){const f=C(m);return f.end(c),f}e.toStream=h;function d(){const c=C(()=>{throw new Error("not supported")});return c.end(),c}e.emptyStream=d;function u(c){let m=!1;return{read:()=>m?null:(m=!0,c)}}e.toReadable=u;function w(c,m,f){const t=C(f);return I(c,{onData:r=>t.write(m.data(r)),onError:r=>t.error(m.error?m.error(r):r),onEnd:()=>t.end()}),t}e.transform=w;function v(c,m,f){let t=!1;return{read:()=>{const r=m.read();return t?r:(t=!0,r!==null?f([c,r]):c)}}}e.prefixedReadable=v;function S(c,m,f){let t=!1;const r=C(f);return I(m,{onData:i=>t?r.write(i):(t=!0,r.write(f([c,i]))),onError:i=>r.error(i),onEnd:()=>{t||(t=!0,r.write(c)),r.end()}}),r}e.prefixedStream=S}),define(we[8],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function g(O){return!O||typeof O!="string"?!0:O.trim().length===0}e.isFalsyOrWhitespace=g;const T=/{(\d+)}/g;function D(O,...G){return G.length===0?O:O.replace(T,function(ae,Ce){const Ie=parseInt(Ce,10);return isNaN(Ie)||Ie<0||Ie>=G.length?ae:G[Ie]})}e.format=D;function E(O){return O.replace(/[<>&]/g,function(G){switch(G){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return G}})}e.escape=E;function C(O){return O.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=C;function y(O,G){let ae=0;const Ce=G.charCodeAt(0);for(let Ie=O.length-1;Ie>=0;Ie--)O.charCodeAt(Ie)===Ce&&ae++;return ae}e.count=y;function _(O,G,ae="\u2026"){return O.length<=G?O:`${O.substr(0,G)}${ae}`}e.truncate=_;function k(O,G=" "){const ae=n(O,G);return I(ae,G)}e.trim=k;function n(O,G){if(!O||!G)return O;const ae=G.length;if(ae===0||O.length===0)return O;let Ce=0;for(;O.indexOf(G,Ce)===Ce;)Ce=Ce+ae;return O.substring(Ce)}e.ltrim=n;function I(O,G){if(!O||!G)return O;const ae=G.length,Ce=O.length;if(ae===0||Ce===0)return O;let Ie=Ce,Oe=-1;for(;Oe=O.lastIndexOf(G,Ie-1),!(Oe===-1||Oe+ae!==Ie);){if(Oe===0)return"";Ie=Oe}return O.substring(0,Ie)}e.rtrim=I;function o(O){return O.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=o;function h(O){return O.replace(/\*/g,"")}e.stripWildcards=h;function d(O,G,ae={}){if(!O)throw new Error("Cannot create regex from empty string");G||(O=C(O)),ae.wholeWord&&(/\B/.test(O.charAt(0))||(O="\\b"+O),/\B/.test(O.charAt(O.length-1))||(O=O+"\\b"));let Ce="";return ae.global&&(Ce+="g"),ae.matchCase||(Ce+="i"),ae.multiline&&(Ce+="m"),ae.unicode&&(Ce+="u"),new RegExp(O,Ce)}e.createRegExp=d;function u(O){return O.source==="^"||O.source==="^$"||O.source==="$"||O.source==="^\\s*$"?!1:!!(O.exec("")&&O.lastIndex===0)}e.regExpLeadsToEndlessLoop=u;function w(O){return!!O.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=w;function v(O){return(O.global?"g":"")+(O.ignoreCase?"i":"")+(O.multiline?"m":"")+(O.unicode?"u":"")}e.regExpFlags=v;function S(O){return O.split(/\r\n|\r|\n/)}e.splitLines=S;function c(O){for(let G=0,ae=O.length;G<ae;G++){const Ce=O.charCodeAt(G);if(Ce!==32&&Ce!==9)return G}return-1}e.firstNonWhitespaceIndex=c;function m(O,G=0,ae=O.length){for(let Ce=G;Ce<ae;Ce++){const Ie=O.charCodeAt(Ce);if(Ie!==32&&Ie!==9)return O.substring(G,Ce)}return O.substring(G,ae)}e.getLeadingWhitespace=m;function f(O,G=O.length-1){for(let ae=G;ae>=0;ae--){const Ce=O.charCodeAt(ae);if(Ce!==32&&Ce!==9)return ae}return-1}e.lastNonWhitespaceIndex=f;function t(O,G){return O<G?-1:O>G?1:0}e.compare=t;function r(O,G,ae=0,Ce=O.length,Ie=0,Oe=G.length){for(;ae<Ce&&Ie<Oe;ae++,Ie++){let rt=O.charCodeAt(ae),nt=G.charCodeAt(Ie);if(rt<nt)return-1;if(rt>nt)return 1}const Ue=Ce-ae,qe=Oe-Ie;return Ue<qe?-1:Ue>qe?1:0}e.compareSubstring=r;function i(O,G){return s(O,G,0,O.length,0,G.length)}e.compareIgnoreCase=i;function s(O,G,ae=0,Ce=O.length,Ie=0,Oe=G.length){for(;ae<Ce&&Ie<Oe;ae++,Ie++){let rt=O.charCodeAt(ae),nt=G.charCodeAt(Ie);if(rt===nt)continue;const Ze=rt-nt;if(!(Ze===32&&b(nt))&&!(Ze===-32&&b(rt)))return l(rt)&&l(nt)?Ze:r(O.toLowerCase(),G.toLowerCase(),ae,Ce,Ie,Oe)}const Ue=Ce-ae,qe=Oe-Ie;return Ue<qe?-1:Ue>qe?1:0}e.compareSubstringIgnoreCase=s;function l(O){return O>=97&&O<=122}e.isLowerAsciiLetter=l;function b(O){return O>=65&&O<=90}e.isUpperAsciiLetter=b;function p(O){return l(O)||b(O)}function P(O,G){return O.length===G.length&&A(O,G)}e.equalsIgnoreCase=P;function A(O,G,ae=O.length){for(let Ce=0;Ce<ae;Ce++){const Ie=O.charCodeAt(Ce),Oe=G.charCodeAt(Ce);if(Ie!==Oe){if(p(Ie)&&p(Oe)){const Ue=Math.abs(Ie-Oe);if(Ue!==0&&Ue!==32)return!1}else if(String.fromCharCode(Ie).toLowerCase()!==String.fromCharCode(Oe).toLowerCase())return!1}}return!0}function a(O,G){const ae=G.length;return G.length>O.length?!1:A(O,G,ae)}e.startsWithIgnoreCase=a;function F(O,G){let ae,Ce=Math.min(O.length,G.length);for(ae=0;ae<Ce;ae++)if(O.charCodeAt(ae)!==G.charCodeAt(ae))return ae;return Ce}e.commonPrefixLength=F;function N(O,G){let ae,Ce=Math.min(O.length,G.length);const Ie=O.length-1,Oe=G.length-1;for(ae=0;ae<Ce;ae++)if(O.charCodeAt(Ie-ae)!==G.charCodeAt(Oe-ae))return ae;return Ce}e.commonSuffixLength=N;function H(O){return 55296<=O&&O<=56319}e.isHighSurrogate=H;function le(O){return 56320<=O&&O<=57343}e.isLowSurrogate=le;function fe(O,G){return(O-55296<<10)+(G-56320)+65536}e.computeCodePoint=fe;function X(O,G,ae){const Ce=O.charCodeAt(ae);if(H(Ce)&&ae+1<G){const Ie=O.charCodeAt(ae+1);if(le(Ie))return fe(Ce,Ie)}return Ce}e.getNextCodePoint=X;function z(O,G){const ae=O.charCodeAt(G-1);if(le(ae)&&G>1){const Ce=O.charCodeAt(G-2);if(H(Ce))return fe(Ce,ae)}return ae}function Y(O,G){const ae=Le.getInstance(),Ce=G,Ie=O.length,Oe=X(O,Ie,G);G+=Oe>=65536?2:1;let Ue=ae.getGraphemeBreakType(Oe);for(;G<Ie;){const qe=X(O,Ie,G),rt=ae.getGraphemeBreakType(qe);if(me(Ue,rt))break;G+=qe>=65536?2:1,Ue=rt}return G-Ce}e.nextCharLength=Y;function R(O,G){const ae=Le.getInstance(),Ce=G,Ie=z(O,G);G-=Ie>=65536?2:1;let Oe=ae.getGraphemeBreakType(Ie);for(;G>0;){const Ue=z(O,G),qe=ae.getGraphemeBreakType(Ue);if(me(qe,Oe))break;G-=Ue>=65536?2:1,Oe=qe}return Ce-G}e.prevCharLength=R;function B(O,G){const ae=Le.getInstance(),Ce=O.length,Ie=G,Oe=X(O,Ce,G),Ue=ae.getGraphemeBreakType(Oe);G+=Oe>=65536?2:1;let qe=Ue;for(;G<Ce;){const nt=X(O,Ce,G),Ze=ae.getGraphemeBreakType(nt);if(me(qe,Ze))break;G+=nt>=65536?2:1,qe=Ze}const rt=G;for(G=Ie,qe=Ue;G>0;){const nt=z(O,G),Ze=ae.getGraphemeBreakType(nt);if(me(Ze,qe))break;G-=nt>=65536?2:1,qe=Ze}return[G,rt]}function M(O,G){return G>0&&le(O.charCodeAt(G))?B(O,G-1):B(O,G)}e.getCharContainingOffset=M;function U(O){const G=O.length;let ae=0,Ce=0;for(;Ce<G;){const Ue=X(O,G,Ce);Ce+=Ue>=65536?2:1,Ue<128?ae+=1:Ue<2048?ae+=2:Ue<65536?ae+=3:ae+=4}const Ie=new Uint8Array(ae);Ce=0;let Oe=0;for(;Ce<G;){const Ue=X(O,G,Ce);Ce+=Ue>=65536?2:1,Ue<128?Ie[Oe++]=Ue:Ue<2048?(Ie[Oe++]=192|(Ue&1984)>>>6,Ie[Oe++]=128|(Ue&63)>>>0):Ue<65536?(Ie[Oe++]=224|(Ue&61440)>>>12,Ie[Oe++]=128|(Ue&4032)>>>6,Ie[Oe++]=128|(Ue&63)>>>0):(Ie[Oe++]=240|(Ue&1835008)>>>18,Ie[Oe++]=128|(Ue&258048)>>>12,Ie[Oe++]=128|(Ue&4032)>>>6,Ie[Oe++]=128|(Ue&63)>>>0)}return Ie}e.encodeUTF8=U;function q(O){const G=O.byteLength,ae=[];let Ce=0;for(;Ce<G;){const Ie=O[Ce];let Oe;if(Ie>=240&&Ce+3<G?Oe=(O[Ce++]&7)<<18>>>0|(O[Ce++]&63)<<12>>>0|(O[Ce++]&63)<<6>>>0|(O[Ce++]&63)<<0>>>0:Ie>=224&&Ce+2<G?Oe=(O[Ce++]&15)<<12>>>0|(O[Ce++]&63)<<6>>>0|(O[Ce++]&63)<<0>>>0:Ie>=192&&Ce+1<G?Oe=(O[Ce++]&31)<<6>>>0|(O[Ce++]&63)<<0>>>0:Oe=O[Ce++],Oe>=0&&Oe<=55295||Oe>=57344&&Oe<=65535)ae.push(String.fromCharCode(Oe));else if(Oe>=65536&&Oe<=1114111){const Ue=Oe-65536,qe=55296+((Ue&1047552)>>>10),rt=56320+((Ue&1023)>>>0);ae.push(String.fromCharCode(qe)),ae.push(String.fromCharCode(rt))}else ae.push(String.fromCharCode(65533))}return ae.join("")}e.decodeUTF8=q;const V=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function oe(O){return V.test(O)}e.containsRTL=oe;const ge=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function Re(O){return ge.test(O)}e.containsEmoji=Re;const $e=/^[\t\n\r\x20-\x7E]*$/;function Me(O){return $e.test(O)}e.isBasicASCII=Me,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function We(O){return e.UNUSUAL_LINE_TERMINATORS.test(O)}e.containsUnusualLineTerminators=We;function Je(O){for(let G=0,ae=O.length;G<ae;G++)if(Qe(O.charCodeAt(G)))return!0;return!1}e.containsFullWidthCharacter=Je;function Qe(O){return O=+O,O>=11904&&O<=55215||O>=63744&&O<=64255||O>=65281&&O<=65374}e.isFullWidthCharacter=Qe;function Ye(O){return O>=127462&&O<=127487||O===8986||O===8987||O===9200||O===9203||O>=9728&&O<=10175||O===11088||O===11093||O>=127744&&O<=128591||O>=128640&&O<=128764||O>=128992&&O<=129003||O>=129280&&O<=129535||O>=129648&&O<=129750}e.isEmojiImprecise=Ye;function W(O,G){if(O.length<G)return O;const ae=/\b/g;let Ce=0;for(;ae.test(O)&&!(O.length-ae.lastIndex<G);)Ce=ae.lastIndex,ae.lastIndex+=1;return O.substring(Ce).replace(/^\s/,"")}e.lcut=W;const Q=/\x1B\x5B[12]?K/g,te=/\x1b\[\d+m/g,re=/\x1b\[0?m/g;function K(O){return O&&(O=O.replace(Q,""),O=O.replace(te,""),O=O.replace(re,"")),O}e.removeAnsiEscapeCodes=K,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function se(O){return!!(O&&O.length>0&&O.charCodeAt(0)===65279)}e.startsWithUTF8BOM=se;function he(O){return se(O)?O.substr(1):O}e.stripUTF8BOM=he;function Ae(O,G){if(!O||!G||O.length<G.length)return!1;const ae=G.length,Ce=O.toLowerCase();let Ie=0,Oe=-1;for(;Ie<ae;){const Ue=Ce.indexOf(G[Ie],Oe+1);if(Ue<0)return!1;Oe=Ue,Ie++}return!0}e.fuzzyContains=Ae;function Be(O,G=!1){return O?(G&&(O=O.replace(/\\./g,"")),O.toLowerCase()!==O):!1}e.containsUppercaseCharacter=Be;function pe(O){return O.charAt(0).toUpperCase()+O.slice(1)}e.uppercaseFirstLetter=pe;function Ke(O,G=1){if(G===0)return"";let ae=-1;do ae=O.indexOf(`
`,ae+1),G--;while(G>0&&ae>=0);return ae===-1?O:(O[ae-1]==="\r"&&ae--,O.substr(0,ae))}e.getNLines=Ke;function j(O){const G=90-65+1;return O=O%(2*G),O<G?String.fromCharCode(97+O):String.fromCharCode(65+O-G)}e.singleLetterHash=j;function ee(O){return Le.getInstance().getGraphemeBreakType(O)}e.getGraphemeBreakType=ee;function me(O,G){return O===0?G!==5&&G!==7:O===2&&G===3?!1:O===4||O===2||O===3||G===4||G===2||G===3?!0:!(O===8&&(G===8||G===9||G===11||G===12)||(O===11||O===9)&&(G===9||G===10)||(O===12||O===10)&&G===10||G===5||G===13||G===7||O===1||O===13&&G===14||O===6&&G===6)}e.breakBetweenGraphemeBreakType=me;var Fe;(function(O){O[O.Other=0]="Other",O[O.Prepend=1]="Prepend",O[O.CR=2]="CR",O[O.LF=3]="LF",O[O.Control=4]="Control",O[O.Extend=5]="Extend",O[O.Regional_Indicator=6]="Regional_Indicator",O[O.SpacingMark=7]="SpacingMark",O[O.L=8]="L",O[O.V=9]="V",O[O.T=10]="T",O[O.LV=11]="LV",O[O.LVT=12]="LVT",O[O.ZWJ=13]="ZWJ",O[O.Extended_Pictographic=14]="Extended_Pictographic"})(Fe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Le{constructor(){this._data=Ge()}static getInstance(){return Le._INSTANCE||(Le._INSTANCE=new Le),Le._INSTANCE}getGraphemeBreakType(G){if(G<32)return G===10?3:G===13?2:4;if(G<127)return 0;const ae=this._data,Ce=ae.length/3;let Ie=1;for(;Ie<=Ce;)if(G<ae[3*Ie])Ie=2*Ie;else if(G>ae[3*Ie+1])Ie=2*Ie+1;else return ae[3*Ie+2];return 0}}Le._INSTANCE=null;function Ge(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function Ee(O,G){if(O===0)return 0;const ae=be(O,G);if(ae!==void 0)return ae;const Ce=z(G,O);return O-=De(Ce),O}e.getLeftDeleteOffset=Ee;function be(O,G){let ae=z(G,O);for(O-=De(ae);ie(ae)||ae===65039||ae===8419;){if(O===0)return;ae=z(G,O),O-=De(ae)}if(!!Ye(ae)){if(O>=0){const Ce=z(G,O);Ce===8205&&(O-=De(Ce))}return O}}function De(O){return O>=65536?2:1}function ie(O){return 127995<=O&&O<=127999}var de;(function(O){O[O.zwj=8205]="zwj",O[O.emojiVariantSelector=65039]="emojiVariantSelector",O[O.enclosingKeyCap=8419]="enclosingKeyCap"})(de||(de={}))}),define(we[23],_e([0,1,8,107]),function(Z,e,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const D=typeof Buffer!="undefined",E=typeof TextEncoder!="undefined",C=typeof TextDecoder!="undefined";let y,_;class k{constructor(p){this.buffer=p,this.byteLength=this.buffer.byteLength}static alloc(p){return D?new k(Buffer.allocUnsafe(p)):new k(new Uint8Array(p))}static wrap(p){return D&&!Buffer.isBuffer(p)&&(p=Buffer.from(p.buffer,p.byteOffset,p.byteLength)),new k(p)}static fromString(p,P){return!((P==null?void 0:P.dontUseNodeBuffer)||!1)&&D?new k(Buffer.from(p)):E?(y||(y=new TextEncoder),new k(y.encode(p))):new k(g.encodeUTF8(p))}static concat(p,P){if(typeof P=="undefined"){P=0;for(let F=0,N=p.length;F<N;F++)P+=p[F].byteLength}const A=k.alloc(P);let a=0;for(let F=0,N=p.length;F<N;F++){const H=p[F];A.set(H,a),a+=H.byteLength}return A}toString(){return D?this.buffer.toString():C?(_||(_=new TextDecoder),_.decode(this.buffer)):g.decodeUTF8(this.buffer)}slice(p,P){return new k(this.buffer.subarray(p,P))}set(p,P){p instanceof k?this.buffer.set(p.buffer,P):this.buffer.set(p,P)}readUInt32BE(p){return o(this.buffer,p)}writeUInt32BE(p,P){h(this.buffer,p,P)}readUInt32LE(p){return d(this.buffer,p)}writeUInt32LE(p,P){u(this.buffer,p,P)}readUInt8(p){return w(this.buffer,p)}writeUInt8(p,P){v(this.buffer,p,P)}}e.VSBuffer=k;function n(b,p){return b[p+0]<<0>>>0|b[p+1]<<8>>>0}e.readUInt16LE=n;function I(b,p,P){b[P+0]=p&255,p=p>>>8,b[P+1]=p&255}e.writeUInt16LE=I;function o(b,p){return b[p]*2**24+b[p+1]*2**16+b[p+2]*2**8+b[p+3]}e.readUInt32BE=o;function h(b,p,P){b[P+3]=p,p=p>>>8,b[P+2]=p,p=p>>>8,b[P+1]=p,p=p>>>8,b[P]=p}e.writeUInt32BE=h;function d(b,p){return b[p+0]<<0>>>0|b[p+1]<<8>>>0|b[p+2]<<16>>>0|b[p+3]<<24>>>0}e.readUInt32LE=d;function u(b,p,P){b[P+0]=p&255,p=p>>>8,b[P+1]=p&255,p=p>>>8,b[P+2]=p&255,p=p>>>8,b[P+3]=p&255}e.writeUInt32LE=u;function w(b,p){return b[p]}e.readUInt8=w;function v(b,p,P){b[P]=p}e.writeUInt8=v;function S(b){return T.consumeReadable(b,p=>k.concat(p))}e.readableToBuffer=S;function c(b){return T.toReadable(b)}e.bufferToReadable=c;function m(b){return T.consumeStream(b,p=>k.concat(p))}e.streamToBuffer=m;async function f(b){return b.ended?k.concat(b.buffer):k.concat([...b.buffer,await m(b.stream)])}e.bufferedStreamToBuffer=f;function t(b){return T.toStream(b,p=>k.concat(p))}e.bufferToStream=t;function r(b){return T.transform(b,{data:p=>typeof p=="string"?k.fromString(p):k.wrap(p)},p=>k.concat(p))}e.streamToBufferReadableStream=r;function i(b){return T.newWriteableStream(p=>k.concat(p),b)}e.newWriteableBufferStream=i;function s(b,p){return T.prefixedReadable(b,p,P=>k.concat(P))}e.prefixedBufferReadable=s;function l(b,p){return T.prefixedStream(b,p,P=>k.concat(P))}e.prefixedBufferStream=l}),define(we[53],_e([0,1,8]),function(Z,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function T(v){return D(v,0)}e.hash=T;function D(v,S){switch(typeof v){case"object":return v===null?E(349,S):Array.isArray(v)?_(v,S):k(v,S);case"string":return y(v,S);case"boolean":return C(v,S);case"number":return E(v,S);case"undefined":return E(937,S);default:return E(617,S)}}e.doHash=D;function E(v,S){return(S<<5)-S+v|0}function C(v,S){return E(v?433:863,S)}function y(v,S){S=E(149417,S);for(let c=0,m=v.length;c<m;c++)S=E(v.charCodeAt(c),S);return S}e.stringHash=y;function _(v,S){return S=E(104579,S),v.reduce((c,m)=>D(m,c),S)}function k(v,S){return S=E(181387,S),Object.keys(v).sort().reduce((c,m)=>(c=y(m,c),D(v[m],c)),S)}class n{constructor(){this._value=0}get value(){return this._value}hash(S){return this._value=D(S,this._value),this._value}}e.Hasher=n;var I;(function(v){v[v.BLOCK_SIZE=64]="BLOCK_SIZE",v[v.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function o(v,S,c=32){const m=c-S,f=~((1<<m)-1);return(v<<S|(f&v)>>>m)>>>0}function h(v,S=0,c=v.byteLength,m=0){for(let f=0;f<c;f++)v[S+f]=m}function d(v,S,c="0"){for(;v.length<S;)v=c+v;return v}function u(v,S=32){return v instanceof ArrayBuffer?Array.from(new Uint8Array(v)).map(c=>c.toString(16).padStart(2,"0")).join(""):d((v>>>0).toString(16),S/4)}e.toHexString=u;class w{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(S){const c=S.length;if(c===0)return;const m=this._buff;let f=this._buffLen,t=this._leftoverHighSurrogate,r,i;for(t!==0?(r=t,i=-1,t=0):(r=S.charCodeAt(0),i=0);;){let s=r;if(g.isHighSurrogate(r))if(i+1<c){const l=S.charCodeAt(i+1);g.isLowSurrogate(l)?(i++,s=g.computeCodePoint(r,l)):s=65533}else{t=r;break}else g.isLowSurrogate(r)&&(s=65533);if(f=this._push(m,f,s),i++,i<c)r=S.charCodeAt(i);else break}this._buffLen=f,this._leftoverHighSurrogate=t}_push(S,c,m){return m<128?S[c++]=m:m<2048?(S[c++]=192|(m&1984)>>>6,S[c++]=128|(m&63)>>>0):m<65536?(S[c++]=224|(m&61440)>>>12,S[c++]=128|(m&4032)>>>6,S[c++]=128|(m&63)>>>0):(S[c++]=240|(m&1835008)>>>18,S[c++]=128|(m&258048)>>>12,S[c++]=128|(m&4032)>>>6,S[c++]=128|(m&63)>>>0),c>=64&&(this._step(),c-=64,this._totalLen+=64,S[0]=S[64+0],S[1]=S[64+1],S[2]=S[64+2]),c}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),u(this._h0)+u(this._h1)+u(this._h2)+u(this._h3)+u(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,h(this._buff,this._buffLen),this._buffLen>56&&(this._step(),h(this._buff));const S=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(S/4294967296),!1),this._buffDV.setUint32(60,S%4294967296,!1),this._step()}_step(){const S=w._bigBlock32,c=this._buffDV;for(let p=0;p<64;p+=4)S.setUint32(p,c.getUint32(p,!1),!1);for(let p=64;p<320;p+=4)S.setUint32(p,o(S.getUint32(p-12,!1)^S.getUint32(p-32,!1)^S.getUint32(p-56,!1)^S.getUint32(p-64,!1),1),!1);let m=this._h0,f=this._h1,t=this._h2,r=this._h3,i=this._h4,s,l,b;for(let p=0;p<80;p++)p<20?(s=f&t|~f&r,l=1518500249):p<40?(s=f^t^r,l=1859775393):p<60?(s=f&t|f&r|t&r,l=2400959708):(s=f^t^r,l=3395469782),b=o(m,5)+s+i+l+S.getUint32(p*4,!1)&4294967295,i=r,r=t,t=o(f,30),f=m,m=b;this._h0=this._h0+m&4294967295,this._h1=this._h1+f&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+r&4294967295,this._h4=this._h4+i&4294967295}}e.StringSHA1=w,w._bigBlock32=new DataView(new ArrayBuffer(320))}),define(we[41],_e([0,1,8]),function(Z,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var T;(function(D){D[D.Ignore=0]="Ignore",D[D.Info=1]="Info",D[D.Warning=2]="Warning",D[D.Error=3]="Error"})(T||(T={})),function(D){const E="error",C="warning",y="warn",_="info",k="ignore";function n(o){return o?g.equalsIgnoreCase(E,o)?D.Error:g.equalsIgnoreCase(C,o)||g.equalsIgnoreCase(y,o)?D.Warning:g.equalsIgnoreCase(_,o)?D.Info:D.Ignore:D.Ignore}D.fromValue=n;function I(o){switch(o){case D.Error:return E;case D.Warning:return C;case D.Info:return _;default:return k}}D.toString=I}(T||(T={})),e.default=T}),define(we[10],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function g(p){return Array.isArray(p)}e.isArray=g;function T(p){return typeof p=="string"}e.isString=T;function D(p){return Array.isArray(p)&&p.every(P=>T(P))}e.isStringArray=D;function E(p){return typeof p=="object"&&p!==null&&!Array.isArray(p)&&!(p instanceof RegExp)&&!(p instanceof Date)}e.isObject=E;function C(p){return typeof p=="number"&&!isNaN(p)}e.isNumber=C;function y(p){return!!p&&typeof p[Symbol.iterator]=="function"}e.isIterable=y;function _(p){return p===!0||p===!1}e.isBoolean=_;function k(p){return typeof p=="undefined"}e.isUndefined=k;function n(p){return!I(p)}e.isDefined=n;function I(p){return k(p)||p===null}e.isUndefinedOrNull=I;function o(p,P){if(!p)throw new Error(P?`Unexpected type, expected '${P}'`:"Unexpected type")}e.assertType=o;function h(p){if(I(p))throw new Error("Assertion Failed: argument is undefined or null");return p}e.assertIsDefined=h;function d(...p){const P=[];for(let A=0;A<p.length;A++){const a=p[A];if(I(a))throw new Error(`Assertion Failed: argument at index ${A} is undefined or null`);P.push(a)}return P}e.assertAllDefined=d;const u=Object.prototype.hasOwnProperty;function w(p){if(!E(p))return!1;for(let P in p)if(u.call(p,P))return!1;return!0}e.isEmptyObject=w;function v(p){return typeof p=="function"}e.isFunction=v;function S(...p){return p.length>0&&p.every(v)}e.areFunctions=S;function c(p,P){const A=Math.min(p.length,P.length);for(let a=0;a<A;a++)m(p[a],P[a])}e.validateConstraints=c;function m(p,P){if(T(P)){if(typeof p!==P)throw new Error(`argument does not match constraint: typeof ${P}`)}else if(v(P)){try{if(p instanceof P)return}catch(A){}if(!I(p)&&p.constructor===P||P.length===1&&P.call(void 0,p)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=m;function f(p){let P=[],A=Object.getPrototypeOf(p);for(;Object.prototype!==A;)P=P.concat(Object.getOwnPropertyNames(A)),A=Object.getPrototypeOf(A);return P}e.getAllPropertyNames=f;function t(p){const P=[];for(const A of f(p))typeof p[A]=="function"&&P.push(A);return P}e.getAllMethodNames=t;function r(p,P){const A=F=>function(){const N=Array.prototype.slice.call(arguments,0);return P(F,N)};let a={};for(const F of p)a[F]=A(F);return a}e.createProxyObject=r;function i(p){return p===null?void 0:p}e.withNullAsUndefined=i;function s(p){return typeof p=="undefined"?null:p}e.withUndefinedAsNull=s;function l(p){return class{constructor(){return new Proxy({},{get(P,A){if(P[A])return P[A];throw new Error(`Not Implemented: ${p}->${String(A)}`)}})}}}e.NotImplementedProxy=l;function b(p){throw new Error("Unreachable")}e.assertNever=b}),define(we[42],_e([0,1,21,8,13,10]),function(Z,e,g,T,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function C(i){return i===47||i===92}e.isPathSeparator=C;function y(i){return i.replace(/[\\/]/g,D.posix.sep)}e.toSlashes=y;function _(i){return i.indexOf("/")===-1&&(i=y(i)),/^[a-zA-Z]:(\/|$)/.test(i)&&(i="/"+i),i}e.toPosixPath=_;function k(i,s=D.posix.sep){if(!i)return"";const l=i.length,b=i.charCodeAt(0);if(C(b)){if(C(i.charCodeAt(1))&&!C(i.charCodeAt(2))){let P=3;const A=P;for(;P<l&&!C(i.charCodeAt(P));P++);if(A!==P&&!C(i.charCodeAt(P+1))){for(P+=1;P<l;P++)if(C(i.charCodeAt(P)))return i.slice(0,P+1).replace(/[\\/]/g,s)}}return s}else if(v(b)&&i.charCodeAt(1)===58)return C(i.charCodeAt(2))?i.slice(0,2)+s:i.slice(0,2);let p=i.indexOf("://");if(p!==-1){for(p+=3;p<l;p++)if(C(i.charCodeAt(p)))return i.slice(0,p+1)}return""}e.getRoot=k;function n(i){if(!g.isWindows||!i||i.length<5)return!1;let s=i.charCodeAt(0);if(s!==92||(s=i.charCodeAt(1),s!==92))return!1;let l=2;const b=l;for(;l<i.length&&(s=i.charCodeAt(l),s!==92);l++);return!(b===l||(s=i.charCodeAt(l+1),isNaN(s)||s===92))}e.isUNC=n;const I=/[\\/:\*\?"<>\|]/g,o=/[\\/]/g,h=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(i,s=g.isWindows){const l=s?I:o;return!(!i||i.length===0||/^\s+$/.test(i)||(l.lastIndex=0,l.test(i))||s&&h.test(i)||i==="."||i===".."||s&&i[i.length-1]==="."||s&&i.length!==i.trim().length||i.length>255)}e.isValidBasename=d;function u(i,s,l){const b=i===s;return!l||b?b:!i||!s?!1:T.equalsIgnoreCase(i,s)}e.isEqual=u;function w(i,s,l,b=D.sep){if(i===s)return!0;if(!i||!s||s.length>i.length)return!1;if(l){if(!T.startsWithIgnoreCase(i,s))return!1;if(s.length===i.length)return!0;let P=s.length;return s.charAt(s.length-1)===b&&P--,i.charAt(P)===b}return s.charAt(s.length-1)!==b&&(s+=b),i.indexOf(s)===0}e.isEqualOrParent=w;function v(i){return i>=65&&i<=90||i>=97&&i<=122}e.isWindowsDriveLetter=v;function S(i,s){return g.isWindows&&i.endsWith(":")&&(i+=D.sep),D.isAbsolute(i)||(i=D.join(s,i)),i=D.normalize(i),g.isWindows?(i=T.rtrim(i,D.sep),i.endsWith(":")&&(i+=D.sep)):(i=T.rtrim(i,D.sep),i||(i=D.sep)),i}e.sanitizeFilePath=S;function c(i){const s=D.normalize(i);return g.isWindows?i.length>3?!1:m(s)&&(i.length===2||s.charCodeAt(2)===92):s===D.posix.sep}e.isRootOrDriveLetter=c;function m(i){return g.isWindows?v(i.charCodeAt(0))&&i.charCodeAt(1)===58:!1}e.hasDriveLetter=m;function f(i){return m(i)?i[0]:void 0}e.getDriveLetter=f;function t(i,s,l){return s.length>i.length?-1:i===s?0:(l&&(i=i.toLowerCase(),s=s.toLowerCase()),i.indexOf(s))}e.indexOfPath=t;function r(i){const s=i.split(":");let l,b,p;if(s.forEach(P=>{const A=Number(P);E.isNumber(A)?b===void 0?b=A:p===void 0&&(p=A):l=l?[l,P].join(":"):P}),!l)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:l,line:b!==void 0?b:void 0,column:p!==void 0?p:b!==void 0?1:void 0}}e.parseLineAndColumnAware=r}),define(we[24],_e([0,1,10]),function(Z,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function T(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const w=Array.isArray(u)?[]:{};return Object.keys(u).forEach(v=>{u[v]&&typeof u[v]=="object"?w[v]=T(u[v]):w[v]=u[v]}),w}e.deepClone=T;function D(u){if(!u||typeof u!="object")return u;const w=[u];for(;w.length>0;){const v=w.shift();Object.freeze(v);for(const S in v)if(E.call(v,S)){const c=v[S];typeof c=="object"&&!Object.isFrozen(c)&&w.push(c)}}return u}e.deepFreeze=D;const E=Object.prototype.hasOwnProperty;function C(u,w){return y(u,w,new Set)}e.cloneAndChange=C;function y(u,w,v){if(g.isUndefinedOrNull(u))return u;const S=w(u);if(typeof S!="undefined")return S;if(g.isArray(u)){const c=[];for(const m of u)c.push(y(m,w,v));return c}if(g.isObject(u)){if(v.has(u))throw new Error("Cannot clone recursive data-structure");v.add(u);const c={};for(let m in u)E.call(u,m)&&(c[m]=y(u[m],w,v));return v.delete(u),c}return u}function _(u,w,v=!0){return g.isObject(u)?(g.isObject(w)&&Object.keys(w).forEach(S=>{S in u?v&&(g.isObject(u[S])&&g.isObject(w[S])?_(u[S],w[S],v):u[S]=w[S]):u[S]=w[S]}),u):w}e.mixin=_;function k(u,w){if(u===w)return!0;if(u==null||w===null||w===void 0||typeof u!=typeof w||typeof u!="object"||Array.isArray(u)!==Array.isArray(w))return!1;let v,S;if(Array.isArray(u)){if(u.length!==w.length)return!1;for(v=0;v<u.length;v++)if(!k(u[v],w[v]))return!1}else{const c=[];for(S in u)c.push(S);c.sort();const m=[];for(S in w)m.push(S);if(m.sort(),!k(c,m))return!1;for(v=0;v<c.length;v++)if(!k(u[c[v]],w[c[v]]))return!1}return!0}e.equals=k;function n(u){const w=new Set;return JSON.stringify(u,(v,S)=>{if(g.isObject(S)||Array.isArray(S)){if(w.has(S))return"[Circular]";w.add(S)}return S})}e.safeStringify=n;function I(u,w,v){const S=w(u);return typeof S=="undefined"?v:S}e.getOrDefault=I;function o(u,w){const v=Object.create(null);return!u||!w||Object.keys(w).forEach(c=>{const m=u[c],f=w[c];k(m,f)||(v[c]=f)}),v}e.distinct=o;function h(u,w){const v=w.toLowerCase(),S=Object.keys(u).find(c=>c.toLowerCase()===v);return S?u[S]:u[w]}e.getCaseInsensitive=h;function d(u,w){const v=Object.create(null);for(const S of Object.keys(u))w(S,u[S])&&(v[S]=u[S]);return v}e.filter=d}),define(we[79],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var g;(function(E){E[E.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",E[E.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",E[E.MAX_UINT_8=255]="MAX_UINT_8",E[E.MAX_UINT_16=65535]="MAX_UINT_16",E[E.MAX_UINT_32=4294967295]="MAX_UINT_32",E[E.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(g=e.Constants||(e.Constants={}));function T(E){return E<0?0:E>255?255:E|0}e.toUint8=T;function D(E){return E<0?0:E>4294967295?4294967295:E|0}e.toUint32=D}),define(we[2],_e([0,1,21,13]),function(Z,e,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const D=/^\w[\w\d+.-]*$/,E=/^\//,C=/^\/\//;function y(i,s){if(!i.scheme&&s)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!D.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!E.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(C.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function _(i,s){return!i&&!s?"file":i}function k(i,s){switch(i){case"https":case"http":case"file":s?s[0]!==I&&(s=I+s):s=I;break}return s}const n="",I="/",o=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class h{constructor(s,l,b,p,P,A=!1){typeof s=="object"?(this.scheme=s.scheme||n,this.authority=s.authority||n,this.path=s.path||n,this.query=s.query||n,this.fragment=s.fragment||n):(this.scheme=_(s,A),this.authority=l||n,this.path=k(this.scheme,b||n),this.query=p||n,this.fragment=P||n,y(this,A))}static isUri(s){return s instanceof h?!0:s?typeof s.authority=="string"&&typeof s.fragment=="string"&&typeof s.path=="string"&&typeof s.query=="string"&&typeof s.scheme=="string"&&typeof s.fsPath=="string"&&typeof s.with=="function"&&typeof s.toString=="function":!1}get fsPath(){return c(this,!1)}with(s){if(!s)return this;let{scheme:l,authority:b,path:p,query:P,fragment:A}=s;return l===void 0?l=this.scheme:l===null&&(l=n),b===void 0?b=this.authority:b===null&&(b=n),p===void 0?p=this.path:p===null&&(p=n),P===void 0?P=this.query:P===null&&(P=n),A===void 0?A=this.fragment:A===null&&(A=n),l===this.scheme&&b===this.authority&&p===this.path&&P===this.query&&A===this.fragment?this:new u(l,b,p,P,A)}static parse(s,l=!1){const b=o.exec(s);return b?new u(b[2]||n,r(b[4]||n),r(b[5]||n),r(b[7]||n),r(b[9]||n),l):new u(n,n,n,n,n)}static file(s){let l=n;if(g.isWindows&&(s=s.replace(/\\/g,I)),s[0]===I&&s[1]===I){const b=s.indexOf(I,2);b===-1?(l=s.substring(2),s=I):(l=s.substring(2,b),s=s.substring(b)||I)}return new u("file",l,s,n,n)}static from(s){const l=new u(s.scheme,s.authority,s.path,s.query,s.fragment);return y(l,!0),l}static joinPath(s,...l){if(!s.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let b;return g.isWindows&&s.scheme==="file"?b=h.file(T.win32.join(c(s,!0),...l)).path:b=T.posix.join(s.path,...l),s.with({path:b})}toString(s=!1){return m(this,s)}toJSON(){return this}static revive(s){if(s){if(s instanceof h)return s;{const l=new u(s);return l._formatted=s.external,l._fsPath=s._sep===d?s.fsPath:null,l}}else return s}}e.URI=h;const d=g.isWindows?1:void 0;class u extends h{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=c(this,!1)),this._fsPath}toString(s=!1){return s?m(this,!0):(this._formatted||(this._formatted=m(this,!1)),this._formatted)}toJSON(){const s={$mid:1};return this._fsPath&&(s.fsPath=this._fsPath,s._sep=d),this._formatted&&(s.external=this._formatted),this.path&&(s.path=this.path),this.scheme&&(s.scheme=this.scheme),this.authority&&(s.authority=this.authority),this.query&&(s.query=this.query),this.fragment&&(s.fragment=this.fragment),s}}const w={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function v(i,s){let l,b=-1;for(let p=0;p<i.length;p++){const P=i.charCodeAt(p);if(P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57||P===45||P===46||P===95||P===126||s&&P===47)b!==-1&&(l+=encodeURIComponent(i.substring(b,p)),b=-1),l!==void 0&&(l+=i.charAt(p));else{l===void 0&&(l=i.substr(0,p));const A=w[P];A!==void 0?(b!==-1&&(l+=encodeURIComponent(i.substring(b,p)),b=-1),l+=A):b===-1&&(b=p)}}return b!==-1&&(l+=encodeURIComponent(i.substring(b))),l!==void 0?l:i}function S(i){let s;for(let l=0;l<i.length;l++){const b=i.charCodeAt(l);b===35||b===63?(s===void 0&&(s=i.substr(0,l)),s+=w[b]):s!==void 0&&(s+=i[l])}return s!==void 0?s:i}function c(i,s){let l;return i.authority&&i.path.length>1&&i.scheme==="file"?l=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?s?l=i.path.substr(1):l=i.path[1].toLowerCase()+i.path.substr(2):l=i.path,g.isWindows&&(l=l.replace(/\//g,"\\")),l}e.uriToFsPath=c;function m(i,s){const l=s?S:v;let b="",{scheme:p,authority:P,path:A,query:a,fragment:F}=i;if(p&&(b+=p,b+=":"),(P||p==="file")&&(b+=I,b+=I),P){let N=P.indexOf("@");if(N!==-1){const H=P.substr(0,N);P=P.substr(N+1),N=H.indexOf(":"),N===-1?b+=l(H,!1):(b+=l(H.substr(0,N),!1),b+=":",b+=l(H.substr(N+1),!1)),b+="@"}P=P.toLowerCase(),N=P.indexOf(":"),N===-1?b+=l(P,!1):(b+=l(P.substr(0,N),!1),b+=P.substr(N))}if(A){if(A.length>=3&&A.charCodeAt(0)===47&&A.charCodeAt(2)===58){const N=A.charCodeAt(1);N>=65&&N<=90&&(A=`/${String.fromCharCode(N+32)}:${A.substr(3)}`)}else if(A.length>=2&&A.charCodeAt(1)===58){const N=A.charCodeAt(0);N>=65&&N<=90&&(A=`${String.fromCharCode(N+32)}:${A.substr(2)}`)}b+=l(A,!0)}return a&&(b+="?",b+=l(a,!1)),F&&(b+="#",b+=s?F:v(F,!1)),b}function f(i){try{return decodeURIComponent(i)}catch(s){return i.length>3?i.substr(0,3)+f(i.substr(3)):i}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(i){return i.match(t)?i.replace(t,s=>f(s)):i}});var tt=this&&this.__classPrivateFieldSet||function(Z,e,g,T,D){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!D:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?D.call(Z,g):D?D.value=g:e.set(Z,g),g},xe=this&&this.__classPrivateFieldGet||function(Z,e,g,T){if(g==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!T:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?T:g==="a"?T.call(Z):T?T.value:e.get(Z)};define(we[22],_e([0,1,2,8]),function(Z,e,g,T){"use strict";var D,E,C;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function y(t,r,i){let s=t.get(r);return s===void 0&&(s=i,t.set(r,s)),s}e.getOrSet=y;function _(t){const r=[];return t.forEach((i,s)=>{r.push(`${s} => ${i}`)}),`Map(${t.size}) {${r.join(", ")}}`}e.mapToString=_;function k(t){const r=[];return t.forEach(i=>{r.push(i)}),`Set(${t.size}) {${r.join(", ")}}`}e.setToString=k;class n{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const i=r.charCodeAt(0),s=this._value.charCodeAt(this._pos);return i-s}value(){return this._value[this._pos]}}e.StringIterator=n;class I{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?T.compareSubstring(r,this._value,0,r.length,this._from,this._to):T.compareSubstringIgnoreCase(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=I;class o{constructor(r=!0,i=!0){this._splitOnBackslash=r,this._caseSensitive=i}reset(r){return this._value=r.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++){const i=this._value.charCodeAt(this._to);if(i===47||this._splitOnBackslash&&i===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?T.compareSubstring(r,this._value,0,r.length,this._from,this._to):T.compareSubstringIgnoreCase(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=o;var h;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(h||(h={}));class d{constructor(r){this._ignorePathCasing=r,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new o(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return T.compareIgnoreCase(r,this._value.scheme);if(this._states[this._stateIdx]===2)return T.compareIgnoreCase(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return T.compare(r,this._value.query);if(this._states[this._stateIdx]===5)return T.compare(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=d;class u{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class w{constructor(r){this._iter=r}static forUris(r=()=>!1){return new w(new d(r))}static forPaths(){return new w(new o)}static forStrings(){return new w(new n)}static forConfigKeys(){return new w(new I)}clear(){this._root=void 0}set(r,i){const s=this._iter.reset(r);let l;for(this._root||(this._root=new u,this._root.segment=s.value()),l=this._root;;){const p=s.cmp(l.segment);if(p>0)l.left||(l.left=new u,l.left.segment=s.value()),l=l.left;else if(p<0)l.right||(l.right=new u,l.right.segment=s.value()),l=l.right;else if(s.hasNext())s.next(),l.mid||(l.mid=new u,l.mid.segment=s.value()),l=l.mid;else break}const b=l.value;return l.value=i,l.key=r,b}get(r){var i;return(i=this._getNode(r))===null||i===void 0?void 0:i.value}_getNode(r){const i=this._iter.reset(r);let s=this._root;for(;s;){const l=i.cmp(s.segment);if(l>0)s=s.left;else if(l<0)s=s.right;else if(i.hasNext())i.next(),s=s.mid;else break}return s}has(r){const i=this._getNode(r);return!((i==null?void 0:i.value)===void 0&&(i==null?void 0:i.mid)===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,i){const s=this._iter.reset(r),l=[];let b=this._root;for(;b;){const p=s.cmp(b.segment);if(p>0)l.push([1,b]),b=b.left;else if(p<0)l.push([-1,b]),b=b.right;else if(s.hasNext())s.next(),l.push([0,b]),b=b.mid;else{for(i?(b.left=void 0,b.mid=void 0,b.right=void 0):b.value=void 0;l.length>0&&b.isEmpty();){let[P,A]=l.pop();switch(P){case 1:A.left=void 0;break;case 0:A.mid=void 0;break;case-1:A.right=void 0;break}b=A}break}}}findSubstr(r){const i=this._iter.reset(r);let s=this._root,l;for(;s;){const b=i.cmp(s.segment);if(b>0)s=s.left;else if(b<0)s=s.right;else if(i.hasNext())i.next(),l=s.value||l,s=s.mid;else break}return s&&s.value||l}findSuperstr(r){const i=this._iter.reset(r);let s=this._root;for(;s;){const l=i.cmp(s.segment);if(l>0)s=s.left;else if(l<0)s=s.right;else if(i.hasNext())i.next(),s=s.mid;else return s.mid?this._entries(s.mid):void 0}}forEach(r){for(const[i,s]of this)r(s,i)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(r,i=0){if(i>5e3){console.log("potential CYCLE detected",new Error().stack);return}r&&(yield*this._entries(r.left,i++),r.value&&(yield[r.key,r.value]),yield*this._entries(r.mid,i++),yield*this._entries(r.right,i++))}}e.TernarySearchTree=w;class v{constructor(r,i){this[D]="ResourceMap",r instanceof v?(this.map=new Map(r.map),this.toKey=i??v.defaultToKey):(this.map=new Map,this.toKey=r??v.defaultToKey)}set(r,i){return this.map.set(this.toKey(r),i),this}get(r){return this.map.get(this.toKey(r))}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,i){typeof i!="undefined"&&(r=r.bind(i));for(let[s,l]of this.map)r(l,g.URI.parse(s),this)}values(){return this.map.values()}*keys(){for(let r of this.map.keys())yield g.URI.parse(r)}*entries(){for(let r of this.map.entries())yield[g.URI.parse(r[0]),r[1]]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(let r of this.map)yield[g.URI.parse(r[0]),r[1]]}}e.ResourceMap=v,v.defaultToKey=t=>t.toString();var S;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(S=e.Touch||(e.Touch={}));class c{constructor(){this[E]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var r;return(r=this._head)===null||r===void 0?void 0:r.value}get last(){var r;return(r=this._tail)===null||r===void 0?void 0:r.value}has(r){return this._map.has(r)}get(r,i=0){const s=this._map.get(r);if(!!s)return i!==0&&this.touch(s,i),s.value}set(r,i,s=0){let l=this._map.get(r);if(l)l.value=i,s!==0&&this.touch(l,s);else{switch(l={key:r,value:i,next:void 0,previous:void 0},s){case 0:this.addItemLast(l);break;case 1:this.addItemFirst(l);break;case 2:this.addItemLast(l);break;default:this.addItemLast(l);break}this._map.set(r,l),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const i=this._map.get(r);if(!!i)return this._map.delete(r),this.removeItem(i),this._size--,i.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,i){const s=this._state;let l=this._head;for(;l;){if(i?r.bind(i)(l.value,l.key,this):r(l.value,l.key,this),this._state!==s)throw new Error("LinkedMap got modified during iteration.");l=l.next}}keys(){const r=this,i=this._state;let s=this._head;const l={[Symbol.iterator](){return l},next(){if(r._state!==i)throw new Error("LinkedMap got modified during iteration.");if(s){const b={value:s.key,done:!1};return s=s.next,b}else return{value:void 0,done:!0}}};return l}values(){const r=this,i=this._state;let s=this._head;const l={[Symbol.iterator](){return l},next(){if(r._state!==i)throw new Error("LinkedMap got modified during iteration.");if(s){const b={value:s.value,done:!1};return s=s.next,b}else return{value:void 0,done:!0}}};return l}entries(){const r=this,i=this._state;let s=this._head;const l={[Symbol.iterator](){return l},next(){if(r._state!==i)throw new Error("LinkedMap got modified during iteration.");if(s){const b={value:[s.key,s.value],done:!1};return s=s.next,b}else return{value:void 0,done:!0}}};return l}[(E=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let i=this._head,s=this.size;for(;i&&s>r;)this._map.delete(i.key),i=i.next,s--;this._head=i,this._size=s,i&&(i.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const i=r.next,s=r.previous;if(!i||!s)throw new Error("Invalid list");i.previous=s,s.next=i}r.next=void 0,r.previous=void 0,this._state++}touch(r,i){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(i!==1&&i!==2)){if(i===1){if(r===this._head)return;const s=r.next,l=r.previous;r===this._tail?(l.next=void 0,this._tail=l):(s.previous=l,l.next=s),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(i===2){if(r===this._tail)return;const s=r.next,l=r.previous;r===this._head?(s.previous=void 0,this._head=s):(s.previous=l,l.next=s),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((i,s)=>{r.push([s,i])}),r}fromJSON(r){this.clear();for(const[i,s]of r)this.set(i,s)}}e.LinkedMap=c;class m extends c{constructor(r,i=1){super();this._limit=r,this._ratio=Math.min(Math.max(0,i),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,i=2){return super.get(r,i)}peek(r){return super.get(r,0)}set(r,i){return super.set(r,i,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=m;class f{constructor(r){C.set(this,void 0),tt(this,C,r,"f")}get size(){return xe(this,C,"f").size}forEach(r,i){xe(this,C,"f").forEach(r,i)}get(r){return xe(this,C,"f").get(r)}has(r){return xe(this,C,"f").has(r)}entries(){return xe(this,C,"f").entries()}keys(){return xe(this,C,"f").keys()}values(){return xe(this,C,"f").values()}[(C=new WeakMap,Symbol.iterator)](){return xe(this,C,"f").entries()}}e.ReadonlyMapView=f}),define(we[108],_e([0,1,22,8]),function(Z,e,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function D(...K){return function(se,he){for(let Ae=0,Be=K.length;Ae<Be;Ae++){const pe=K[Ae](se,he);if(pe)return pe}return null}}e.or=D,e.matchesStrictPrefix=E.bind(void 0,!1),e.matchesPrefix=E.bind(void 0,!0);function E(K,se,he){if(!he||he.length<se.length)return null;let Ae;return K?Ae=T.startsWithIgnoreCase(he,se):Ae=he.indexOf(se)===0,Ae?se.length>0?[{start:0,end:se.length}]:[]:null}function C(K,se){const he=se.toLowerCase().indexOf(K.toLowerCase());return he===-1?null:[{start:he,end:he+K.length}]}e.matchesContiguousSubString=C;function y(K,se){return _(K.toLowerCase(),se.toLowerCase(),0,0)}e.matchesSubString=y;function _(K,se,he,Ae){if(he===K.length)return[];if(Ae===se.length)return null;if(K[he]===se[Ae]){let Be=null;return(Be=_(K,se,he+1,Ae+1))?v({start:Ae,end:Ae+1},Be):null}return _(K,se,he,Ae+1)}function k(K){return 97<=K&&K<=122}function n(K){return 65<=K&&K<=90}e.isUpper=n;function I(K){return 48<=K&&K<=57}function o(K){return K===32||K===9||K===10||K===13}const h=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(K=>h.add(K.charCodeAt(0)));function d(K){return o(K)||h.has(K)}function u(K,se){return K===se||d(K)&&d(se)}function w(K){return k(K)||n(K)||I(K)}function v(K,se){return se.length===0?se=[K]:K.end===se[0].start?se[0].start=K.start:se.unshift(K),se}function S(K,se){for(let he=se;he<K.length;he++){const Ae=K.charCodeAt(he);if(n(Ae)||I(Ae)||he>0&&!w(K.charCodeAt(he-1)))return he}return K.length}function c(K,se,he,Ae){if(he===K.length)return[];if(Ae===se.length)return null;if(K[he]!==se[Ae].toLowerCase())return null;{let Be=null,pe=Ae+1;for(Be=c(K,se,he+1,Ae+1);!Be&&(pe=S(se,pe))<se.length;)Be=c(K,se,he+1,pe),pe++;return Be===null?null:v({start:Ae,end:Ae+1},Be)}}function m(K){let se=0,he=0,Ae=0,Be=0,pe=0;for(let Fe=0;Fe<K.length;Fe++)pe=K.charCodeAt(Fe),n(pe)&&se++,k(pe)&&he++,w(pe)&&Ae++,I(pe)&&Be++;const Ke=se/K.length,j=he/K.length,ee=Ae/K.length,me=Be/K.length;return{upperPercent:Ke,lowerPercent:j,alphaPercent:ee,numericPercent:me}}function f(K){const{upperPercent:se,lowerPercent:he}=K;return he===0&&se>.6}function t(K){const{upperPercent:se,lowerPercent:he,alphaPercent:Ae,numericPercent:Be}=K;return he>.2&&se<.8&&Ae>.6&&Be<.2}function r(K){let se=0,he=0,Ae=0,Be=0;for(let pe=0;pe<K.length;pe++)Ae=K.charCodeAt(pe),n(Ae)&&se++,k(Ae)&&he++,o(Ae)&&Be++;return(se===0||he===0)&&Be===0?K.length<=30:se<=5}function i(K,se){if(!se||(se=se.trim(),se.length===0)||!r(K)||se.length>60)return null;const he=m(se);if(!t(he)){if(!f(he))return null;se=se.toLowerCase()}let Ae=null,Be=0;for(K=K.toLowerCase();Be<se.length&&(Ae=c(K,se,0,Be))===null;)Be=S(se,Be+1);return Ae}e.matchesCamelCase=i;function s(K,se,he=!1){if(!se||se.length===0)return null;let Ae=null,Be=0;for(K=K.toLowerCase(),se=se.toLowerCase();Be<se.length&&(Ae=l(K,se,0,Be,he))===null;)Be=b(se,Be+1);return Ae}e.matchesWords=s;function l(K,se,he,Ae,Be){if(he===K.length)return[];if(Ae===se.length)return null;if(u(K.charCodeAt(he),se.charCodeAt(Ae))){let pe=null,Ke=Ae+1;if(pe=l(K,se,he+1,Ae+1,Be),!Be)for(;!pe&&(Ke=b(se,Ke))<se.length;)pe=l(K,se,he+1,Ke,Be),Ke++;return pe===null?null:v({start:Ae,end:Ae+1},pe)}else return null}function b(K,se){for(let he=se;he<K.length;he++)if(d(K.charCodeAt(he))||he>0&&d(K.charCodeAt(he-1)))return he;return K.length}const p=D(e.matchesPrefix,i,C),P=D(e.matchesPrefix,i,y),A=new g.LRUCache(1e4);function a(K,se,he=!1){if(typeof K!="string"||typeof se!="string")return null;let Ae=A.get(K);Ae||(Ae=new RegExp(T.convertSimple2RegExpPattern(K),"i"),A.set(K,Ae));const Be=Ae.exec(se);return Be?[{start:Be.index,end:Be.index+Be[0].length}]:he?P(K,se):p(K,se)}e.matchesFuzzy=a;function F(K,se){const he=Je(K,K.toLowerCase(),0,se,se.toLowerCase(),0,!0);return he?H(he):null}e.matchesFuzzy2=F;function N(K,se,he,Ae,Be,pe){const Ke=Math.min(13,K.length);for(;he<Ke;he++){const j=Je(K,se,he,Ae,Be,pe,!1);if(j)return j}return[0,pe]}e.anyScore=N;function H(K){if(typeof K=="undefined")return[];const se=[],he=K[1];for(let Ae=K.length-1;Ae>1;Ae--){const Be=K[Ae]+he,pe=se[se.length-1];pe&&pe.end===Be?pe.end=Be+1:se.push({start:Be,end:Be+1})}return se}e.createMatches=H;const le=128;function fe(){const K=[],se=[];for(let he=0;he<=le;he++)se[he]=0;for(let he=0;he<=le;he++)K.push(se.slice(0));return K}function X(K){const se=[];for(let he=0;he<=K;he++)se[he]=0;return se}const z=X(2*le),Y=X(2*le),R=fe(),B=fe(),M=fe(),U=!1;function q(K,se,he,Ae,Be){function pe(j,ee,me=" "){for(;j.length<ee;)j=me+j;return j}let Ke=` |   |${Ae.split("").map(j=>pe(j,3)).join("|")}
`;for(let j=0;j<=he;j++)j===0?Ke+=" |":Ke+=`${se[j-1]}|`,Ke+=K[j].slice(0,Be+1).map(ee=>pe(ee.toString(),3)).join("|")+`
`;return Ke}function V(K,se,he,Ae){K=K.substr(se),he=he.substr(Ae),console.log(q(B,K,K.length,he,he.length)),console.log(q(M,K,K.length,he,he.length)),console.log(q(R,K,K.length,he,he.length))}function oe(K,se){if(se<0||se>=K.length)return!1;const he=K.codePointAt(se);switch(he){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!T.isEmojiImprecise(he)}}function ge(K,se){if(se<0||se>=K.length)return!1;switch(K.charCodeAt(se)){case 32:case 9:return!0;default:return!1}}function Re(K,se,he){return se[K]!==he[K]}function $e(K,se,he,Ae,Be,pe,Ke=!1){for(;se<he&&Be<pe;)K[se]===Ae[Be]&&(Ke&&(z[se]=Be),se+=1),Be+=1;return se===he}e.isPatternInWord=$e;var Me;(function(K){K[K.Diag=1]="Diag",K[K.Left=2]="Left",K[K.LeftLeft=3]="LeftLeft"})(Me||(Me={}));var We;(function(K){K.Default=[-100,0];function se(he){return!he||he.length===2&&he[0]===-100&&he[1]===0}K.isDefault=se})(We=e.FuzzyScore||(e.FuzzyScore={}));function Je(K,se,he,Ae,Be,pe,Ke){const j=K.length>le?le:K.length,ee=Ae.length>le?le:Ae.length;if(he>=j||pe>=ee||j-he>ee-pe||!$e(se,he,j,Be,pe,ee,!0))return;Qe(j,ee,he,pe,se,Be);let me=1,Fe=1,Le=he,Ge=pe;const Ee=[!1];for(me=1,Le=he;Le<j;me++,Le++){const O=z[Le],G=Y[Le],ae=Le+1<j?Y[Le+1]:ee;for(Fe=O-pe+1,Ge=O;Ge<ae;Fe++,Ge++){let Ce=Number.MIN_SAFE_INTEGER,Ie=!1;Ge<=G&&(Ce=Ye(K,se,Le,he,Ae,Be,Ge,ee,pe,R[me-1][Fe-1]===0,Ee));let Oe=0;Ce!==Number.MAX_SAFE_INTEGER&&(Ie=!0,Oe=Ce+B[me-1][Fe-1]);const Ue=Ge>O,qe=Ue?B[me][Fe-1]+(R[me][Fe-1]>0?-5:0):0,rt=Ge>O+1&&R[me][Fe-1]>0,nt=rt?B[me][Fe-2]+(R[me][Fe-2]>0?-5:0):0;if(rt&&(!Ue||nt>=qe)&&(!Ie||nt>=Oe))B[me][Fe]=nt,M[me][Fe]=3,R[me][Fe]=0;else if(Ue&&(!Ie||qe>=Oe))B[me][Fe]=qe,M[me][Fe]=2,R[me][Fe]=0;else if(Ie)B[me][Fe]=Oe,M[me][Fe]=1,R[me][Fe]=R[me-1][Fe-1]+1;else throw new Error("not possible")}}if(U&&V(K,he,Ae,pe),!Ee[0]&&!Ke)return;me--,Fe--;const be=[B[me][Fe],pe];let De=0,ie=0;for(;me>=1;){let O=Fe;do{const G=M[me][O];if(G===3)O=O-2;else if(G===2)O=O-1;else break}while(O>=1);De>1&&se[he+me-1]===Be[pe+Fe-1]&&!Re(O+pe-1,Ae,Be)&&De+1>R[me][O]&&(O=Fe),O===Fe?De++:De=1,ie||(ie=O),me--,Fe=O-1,be.push(Fe)}ee===j&&(be[0]+=2);const de=ie-j;return be[0]-=de,be}e.fuzzyScore=Je;function Qe(K,se,he,Ae,Be,pe){let Ke=K-1,j=se-1;for(;Ke>=he&&j>=Ae;)Be[Ke]===pe[j]&&(Y[Ke]=j,Ke--),j--}function Ye(K,se,he,Ae,Be,pe,Ke,j,ee,me,Fe){if(se[he]!==pe[Ke])return Number.MIN_SAFE_INTEGER;let Le=1,Ge=!1;return Ke===he-Ae?Le=K[he]===Be[Ke]?7:5:Re(Ke,Be,pe)&&(Ke===0||!Re(Ke-1,Be,pe))?(Le=K[he]===Be[Ke]?7:5,Ge=!0):oe(pe,Ke)&&(Ke===0||!oe(pe,Ke-1))?Le=5:(oe(pe,Ke-1)||ge(pe,Ke-1))&&(Le=5,Ge=!0),Le>1&&he===Ae&&(Fe[0]=!0),Ge||(Ge=Re(Ke,Be,pe)||oe(pe,Ke-1)||ge(pe,Ke-1)),he===Ae?Ke>ee&&(Le-=Ge?3:5):me?Le+=Ge?2:0:Le+=Ge?0:1,Ke+1===j&&(Le-=Ge?3:5),Le}function W(K,se,he,Ae,Be,pe,Ke){return te(K,se,he,Ae,Be,pe,!0,Ke)}e.fuzzyScoreGracefulAggressive=W;function Q(K,se,he,Ae,Be,pe,Ke){return te(K,se,he,Ae,Be,pe,!1,Ke)}e.fuzzyScoreGraceful=Q;function te(K,se,he,Ae,Be,pe,Ke,j){let ee=Je(K,se,he,Ae,Be,pe,j);if(ee&&!Ke)return ee;if(K.length>=3){const me=Math.min(7,K.length-1);for(let Fe=he+1;Fe<me;Fe++){const Le=re(K,Fe);if(Le){const Ge=Je(Le,Le.toLowerCase(),he,Ae,Be,pe,j);Ge&&(Ge[0]-=3,(!ee||Ge[0]>ee[0])&&(ee=Ge))}}}return ee}function re(K,se){if(se+1>=K.length)return;const he=K[se],Ae=K[se+1];if(he!==Ae)return K.slice(0,se)+Ae+he+K.slice(se+2)}}),define(we[109],_e([0,1,78,108,8]),function(Z,e,g,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const E=new RegExp(`\\$\\(${g.CSSIcon.iconNameExpression}(?:${g.CSSIcon.iconModifierExpression})?\\)`,"g"),C=new RegExp(`(\\\\)?${E.source}`,"g");function y(u){return u.replace(C,(w,v)=>v?w:`\\${w}`)}e.escapeIcons=y;const _=new RegExp(`\\\\${E.source}`,"g");function k(u){return u.replace(_,w=>`\\${w}`)}e.markdownEscapeEscapedIcons=k;const n=new RegExp(`(\\s)?(\\\\)?${E.source}(\\s)?`,"g");function I(u){return u.indexOf(e.iconStartMarker)===-1?u:u.replace(n,(w,v,S,c)=>S?w:v||c||"")}e.stripIcons=I;function o(u){const w=u.indexOf(e.iconStartMarker);return w===-1?{text:u}:h(u,w)}e.parseLabelWithIcons=o;function h(u,w){const v=[];let S="";function c(b){if(b){S+=b;for(const p of b)v.push(t)}}let m=-1,f="",t=0,r,i,s=w;const l=u.length;for(c(u.substr(0,w));s<l;)r=u[s],i=u[s+1],r===e.iconStartMarker[0]&&i===e.iconStartMarker[1]?(m=s,c(f),f=e.iconStartMarker,s++):r===")"&&m!==-1?(t+=s-m+1,m=-1,f=""):m!==-1?/^[a-z0-9\-]$/i.test(r)?f+=r:(c(f),m=-1,f=""):c(r),s++;return c(f),{text:S,iconOffsets:v}}function d(u,w,v=!1){const{text:S,iconOffsets:c}=w;if(!c||c.length===0)return T.matchesFuzzy(u,S,v);const m=D.ltrim(S," "),f=S.length-m.length,t=T.matchesFuzzy(u,m,v);if(t)for(const r of t){const i=c[r.start+f]+f;r.start+=i,r.end+=i}return t}e.matchesFuzzyIconAware=d}),define(we[80],_e([0,1,109,12]),function(Z,e,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var D;(function(o){o[o.Paragraph=0]="Paragraph",o[o.Break=1]="Break"})(D=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class E{constructor(h="",d=!1){var u,w;if(this.value=h,typeof this.value!="string")throw T.illegalArgument("value");typeof d=="boolean"?(this.isTrusted=d,this.supportThemeIcons=!1):(this.isTrusted=(u=d.isTrusted)!==null&&u!==void 0?u:void 0,this.supportThemeIcons=(w=d.supportThemeIcons)!==null&&w!==void 0?w:!1)}appendText(h,d=0){return this.value+=k(this.supportThemeIcons?g.escapeIcons(h):h).replace(/([ \t]+)/g,(u,w)=>"&nbsp;".repeat(w.length)).replace(/^>/gm,"\\>").replace(/\n/g,d===1?`\\
`:`

`),this}appendMarkdown(h){return this.value+=h,this}appendCodeblock(h,d){return this.value+="\n```",this.value+=h,this.value+=`
`,this.value+=d,this.value+="\n```\n",this}}e.MarkdownString=E;function C(o){return y(o)?!o.value:Array.isArray(o)?o.every(C):!0}e.isEmptyMarkdownString=C;function y(o){return o instanceof E?!0:o&&typeof o=="object"?typeof o.value=="string"&&(typeof o.isTrusted=="boolean"||o.isTrusted===void 0)&&(typeof o.supportThemeIcons=="boolean"||o.supportThemeIcons===void 0):!1}e.isMarkdownString=y;function _(o,h){return o===h?!0:!o||!h?!1:o.value===h.value&&o.isTrusted===h.isTrusted&&o.supportThemeIcons===h.supportThemeIcons}e.markdownStringEqual=_;function k(o){return o.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=k;function n(o){return o&&o.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=n;function I(o){const h=[],d=o.split("|").map(w=>w.trim());o=d[0];const u=d[1];if(u){const w=/height=(\d+)/.exec(u),v=/width=(\d+)/.exec(u),S=w?w[1]:"",c=v?v[1]:"",m=isFinite(parseInt(c)),f=isFinite(parseInt(S));m&&h.push(`width="${c}"`),f&&h.push(`height="${S}"`)}return{href:o,dimensions:h}}e.parseHrefAndDimensions=I}),define(we[54],_e([0,1,23,8,2]),function(Z,e,g,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function E(k){return JSON.stringify(k,y)}e.stringify=E;function C(k){let n=JSON.parse(k);return n=_(n),n}e.parse=C;function y(k,n){return n instanceof RegExp?{$mid:2,source:n.source,flags:T.regExpFlags(n)}:n}function _(k,n=0){if(!k||n>200)return k;if(typeof k=="object"){switch(k.$mid){case 1:return D.URI.revive(k);case 2:return new RegExp(k.source,k.flags)}if(k instanceof g.VSBuffer||k instanceof Uint8Array)return k;if(Array.isArray(k))for(let I=0;I<k.length;++I)k[I]=_(k[I],n+1);else for(const I in k)Object.hasOwnProperty.call(k,I)&&(k[I]=_(k[I],n+1))}return k}e.revive=_}),define(we[15],_e([0,1,2,21]),function(Z,e,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var D;(function(y){y.inMemory="inmemory",y.vscode="vscode",y.internal="private",y.walkThrough="walkThrough",y.walkThroughSnippet="walkThroughSnippet",y.http="http",y.https="https",y.file="file",y.mailto="mailto",y.untitled="untitled",y.data="data",y.command="command",y.vscodeRemote="vscode-remote",y.vscodeRemoteResource="vscode-remote-resource",y.userData="vscode-userdata",y.vscodeCustomEditor="vscode-custom-editor",y.vscodeNotebook="vscode-notebook",y.vscodeNotebookCell="vscode-notebook-cell",y.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",y.vscodeNotebookCellOutput="vscode-notebook-cell-output",y.vscodeSettings="vscode-settings",y.vscodeWorkspaceTrust="vscode-workspace-trust",y.vscodeTerminal="vscode-terminal",y.webviewPanel="webview-panel",y.vscodeWebview="vscode-webview",y.extension="extension",y.vscodeFileResource="vscode-file",y.tmp="tmp"})(D=e.Schemas||(e.Schemas={}));class E{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(_){this._preferredWebSchema=_}setDelegate(_){this._delegate=_}set(_,k,n){this._hosts[_]=k,this._ports[_]=n}setConnectionToken(_,k){this._connectionTokens[_]=k}rewrite(_){if(this._delegate)return this._delegate(_);const k=_.authority;let n=this._hosts[k];n&&n.indexOf(":")!==-1&&(n=`[${n}]`);const I=this._ports[k],o=this._connectionTokens[k];let h=`path=${encodeURIComponent(_.path)}`;return typeof o=="string"&&(h+=`&tkn=${encodeURIComponent(o)}`),g.URI.from({scheme:T.isWeb?this._preferredWebSchema:D.vscodeRemoteResource,authority:`${n}:${I}`,path:"/vscode-remote-resource",query:h})}}e.RemoteAuthorities=new E;class C{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(_,k,n){const I=this.toUri(_,k);return I.scheme===D.vscodeRemote?e.RemoteAuthorities.rewrite(I):T.isNative&&(n||T.isPreferringBrowserCodeLoad)&&I.scheme===D.file?I.with({scheme:D.vscodeFileResource,authority:I.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):I}asFileUri(_,k){const n=this.toUri(_,k);return n.scheme===D.vscodeFileResource?n.with({scheme:D.file,authority:n.authority!==this.FALLBACK_AUTHORITY?n.authority:null,query:null,fragment:null}):n}toUri(_,k){return g.URI.isUri(_)?_:g.URI.parse(k.toUrl(_))}}e.FileAccess=new C}),define(we[25],_e([0,1,42,13,2,8,15,21]),function(Z,e,g,T,D,E,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function _(h){return D.uriToFsPath(h,!0)}e.originalFSPath=_;class k{constructor(d){this._ignorePathCasing=d}compare(d,u,w=!1){return d===u?0:E.compare(this.getComparisonKey(d,w),this.getComparisonKey(u,w))}isEqual(d,u,w=!1){return d===u?!0:!d||!u?!1:this.getComparisonKey(d,w)===this.getComparisonKey(u,w)}getComparisonKey(d,u=!1){return d.with({path:this._ignorePathCasing(d)?d.path.toLowerCase():void 0,fragment:u?null:void 0}).toString()}ignorePathCasing(d){return this._ignorePathCasing(d)}isEqualOrParent(d,u,w=!1){if(d.scheme===u.scheme){if(d.scheme===C.Schemas.file)return g.isEqualOrParent(_(d),_(u),this._ignorePathCasing(d))&&d.query===u.query&&(w||d.fragment===u.fragment);if(e.isEqualAuthority(d.authority,u.authority))return g.isEqualOrParent(d.path,u.path,this._ignorePathCasing(d),"/")&&d.query===u.query&&(w||d.fragment===u.fragment)}return!1}joinPath(d,...u){return D.URI.joinPath(d,...u)}basenameOrAuthority(d){return e.basename(d)||d.authority}basename(d){return T.posix.basename(d.path)}extname(d){return T.posix.extname(d.path)}dirname(d){if(d.path.length===0)return d;let u;return d.scheme===C.Schemas.file?u=D.URI.file(T.dirname(_(d))).path:(u=T.posix.dirname(d.path),d.authority&&u.length&&u.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),u="/")),d.with({path:u})}normalizePath(d){if(!d.path.length)return d;let u;return d.scheme===C.Schemas.file?u=D.URI.file(T.normalize(_(d))).path:u=T.posix.normalize(d.path),d.with({path:u})}relativePath(d,u){if(d.scheme!==u.scheme||!e.isEqualAuthority(d.authority,u.authority))return;if(d.scheme===C.Schemas.file){const S=T.relative(_(d),_(u));return y.isWindows?g.toSlashes(S):S}let w=d.path||"/",v=u.path||"/";if(this._ignorePathCasing(d)){let S=0;for(const c=Math.min(w.length,v.length);S<c&&!(w.charCodeAt(S)!==v.charCodeAt(S)&&w.charAt(S).toLowerCase()!==v.charAt(S).toLowerCase());S++);w=v.substr(0,S)+w.substr(S)}return T.posix.relative(w,v)}resolvePath(d,u){if(d.scheme===C.Schemas.file){const w=D.URI.file(T.resolve(_(d),u));return d.with({authority:w.authority,path:w.path})}return u=g.toPosixPath(u),d.with({path:T.posix.resolve(d.path,u)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,u){return d===u||E.equalsIgnoreCase(d,u)}hasTrailingPathSeparator(d,u=T.sep){if(d.scheme===C.Schemas.file){const w=_(d);return w.length>g.getRoot(w).length&&w[w.length-1]===u}else{const w=d.path;return w.length>1&&w.charCodeAt(w.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,u=T.sep){return e.hasTrailingPathSeparator(d,u)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,u=T.sep){let w=!1;if(d.scheme===C.Schemas.file){const v=_(d);w=v!==void 0&&v.length===g.getRoot(v).length&&v[v.length-1]===u}else{u="/";const v=d.path;w=v.length===1&&v.charCodeAt(v.length-1)===47}return!w&&!e.hasTrailingPathSeparator(d,u)?d.with({path:d.path+"/"}):d}}e.ExtUri=k,e.extUri=new k(()=>!1),e.extUriBiasedIgnorePathCase=new k(h=>h.scheme===C.Schemas.file?!y.isLinux:!0),e.extUriIgnorePathCase=new k(h=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function n(h,d){const u=[];for(let w=0;w<h.length;w++){const v=d(h[w]);h.some((S,c)=>c===w?!1:e.isEqualOrParent(v,d(S)))||u.push(h[w])}return u}e.distinctParents=n;var I;(function(h){h.META_DATA_LABEL="label",h.META_DATA_DESCRIPTION="description",h.META_DATA_SIZE="size",h.META_DATA_MIME="mime";function d(u){const w=new Map;u.path.substring(u.path.indexOf(";")+1,u.path.lastIndexOf(";")).split(";").forEach(c=>{const[m,f]=c.split(":");m&&f&&w.set(m,f)});const S=u.path.substring(0,u.path.indexOf(";"));return S&&w.set(h.META_DATA_MIME,S),w}h.parseMetaData=d})(I=e.DataUri||(e.DataUri={}));function o(h,d,u){if(d){let w=h.path;return w&&w[0]!==T.posix.sep&&(w=T.posix.sep+w),h.with({scheme:u,authority:d,path:w})}return h.with({scheme:u})}e.toLocalResource=o}),define(we[11],_e([0,1,18,12,3,7,51,25]),function(Z,e,g,T,D,E,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function _(B){return!!B&&typeof B.then=="function"}e.isThenable=_;function k(B){const M=new g.CancellationTokenSource,U=B(M.token),q=new Promise((V,oe)=>{M.token.onCancellationRequested(()=>{oe(T.canceled())}),Promise.resolve(U).then(ge=>{M.dispose(),V(ge)},ge=>{M.dispose(),oe(ge)})});return new class{cancel(){M.cancel()}then(V,oe){return q.then(V,oe)}catch(V){return this.then(void 0,V)}finally(V){return q.finally(V)}}}e.createCancelablePromise=k;function n(B,M,U){return Promise.race([B,new Promise(q=>M.onCancellationRequested(()=>q(U)))])}e.raceCancellation=n;async function I(B){let M=-1;const U=B.map((V,oe)=>V.then(ge=>(M=oe,ge))),q=await Promise.race(U);return B.forEach((V,oe)=>{oe!==M&&V.cancel()}),q}e.raceCancellablePromises=I;function o(B,M,U){let q;const V=setTimeout(()=>{q==null||q(void 0),U==null||U()},M);return Promise.race([B.finally(()=>clearTimeout(V)),new Promise(oe=>q=oe)])}e.raceTimeout=o;function h(B){return new Promise((M,U)=>{const q=B();_(q)?q.then(M,U):M(q)})}e.asPromise=h;class d{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(M){if(this.activePromise){if(this.queuedPromiseFactory=M,!this.queuedPromise){const U=()=>{this.queuedPromise=null;const q=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,q};this.queuedPromise=new Promise(q=>{this.activePromise.then(U,U).then(q)})}return new Promise((U,q)=>{this.queuedPromise.then(U,q)})}return this.activePromise=M(),new Promise((U,q)=>{this.activePromise.then(V=>{this.activePromise=null,U(V)},V=>{this.activePromise=null,q(V)})})}}e.Throttler=d;class u{constructor(){this.current=Promise.resolve(null)}queue(M){return this.current=this.current.then(()=>M(),()=>M())}}e.Sequencer=u;class w{constructor(){this.promiseMap=new Map}queue(M,U){var q;const oe=((q=this.promiseMap.get(M))!==null&&q!==void 0?q:Promise.resolve()).catch(()=>{}).then(U).finally(()=>{this.promiseMap.get(M)===oe&&this.promiseMap.delete(M)});return this.promiseMap.set(M,oe),oe}}e.SequencerByKey=w;class v{constructor(M){this.defaultDelay=M,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(M,U=this.defaultDelay){return this.task=M,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((q,V)=>{this.doResolve=q,this.doReject=V}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const q=this.task;return this.task=null,q()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},U),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(T.canceled()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=v;class S{constructor(M){this.delayer=new v(M),this.throttler=new d}trigger(M,U){return this.delayer.trigger(()=>this.throttler.queue(M),U)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=S;class c{constructor(){this._isOpen=!1,this._promise=new Promise((M,U)=>{this._completePromise=M})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=c;class m extends c{constructor(M){super();this._timeout=setTimeout(()=>this.open(),M)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=m;function f(B,M){return M?new Promise((U,q)=>{const V=setTimeout(U,B);M.onCancellationRequested(()=>{clearTimeout(V),q(T.canceled())})}):k(U=>f(B,U))}e.timeout=f;function t(B,M=0){const U=setTimeout(B,M);return E.toDisposable(()=>clearTimeout(U))}e.disposableTimeout=t;function r(B){return B.then(void 0,M=>{})}e.ignoreErrors=r;function i(B){const M=[];let U=0;const q=B.length;function V(){return U<q?B[U++]():null}function oe(ge){ge!=null&&M.push(ge);const Re=V();return Re?Re.then(oe):Promise.resolve(M)}return Promise.resolve(null).then(oe)}e.sequence=i;function s(B,M=q=>!!q,U=null){let q=0;const V=B.length,oe=()=>{if(q>=V)return Promise.resolve(U);const ge=B[q++];return Promise.resolve(ge()).then($e=>M($e)?Promise.resolve($e):oe())};return oe()}e.first=s;function l(B,M=q=>!!q,U=null){if(B.length===0)return Promise.resolve(U);let q=B.length;const V=()=>{var oe,ge;q=-1;for(const Re of B)(ge=(oe=Re).cancel)===null||ge===void 0||ge.call(oe)};return new Promise((oe,ge)=>{for(const Re of B)Re.then($e=>{--q>=0&&M($e)?(V(),oe($e)):q===0&&oe(U)}).catch($e=>{--q>=0&&(V(),ge($e))})})}e.firstParallel=l;class b{constructor(M){this._size=0,this.maxDegreeOfParalellism=M,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new D.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(M){return this._size++,new Promise((U,q)=>{this.outstandingPromises.push({factory:M,c:U,e:q}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const M=this.outstandingPromises.shift();this.runningPromises++;const U=M.factory();U.then(M.c,M.e),U.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=b;class p extends b{constructor(){super(1)}}e.Queue=p;class P{constructor(){this.queues=new Map}queueFor(M,U=y.extUri){const q=U.getComparisonKey(M);let V=this.queues.get(q);return V||(V=new p,D.Event.once(V.onFinished)(()=>{V==null||V.dispose(),this.queues.delete(q)}),this.queues.set(q,V)),V}dispose(){this.queues.forEach(M=>M.dispose()),this.queues.clear()}}e.ResourceQueue=P;class A{constructor(M,U){this._token=-1,typeof M=="function"&&typeof U=="number"&&this.setIfNotSet(M,U)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(M,U){this.cancel(),this._token=setTimeout(()=>{this._token=-1,M()},U)}setIfNotSet(M,U){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,M()},U))}}e.TimeoutTimer=A;class a{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(M,U){this.cancel(),this._token=setInterval(()=>{M()},U)}}e.IntervalTimer=a;class F{constructor(M,U){this.timeoutToken=-1,this.runner=M,this.timeout=U,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(M=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,M)}get delay(){return this.timeout}set delay(M){this.timeout=M}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=F;class N extends F{constructor(M,U){super(M,U);this.units=[]}work(M){this.units.push(M),this.isScheduled()||this.schedule()}doRun(){const M=this.units;this.units=[],this.runner&&this.runner(M)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=N,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const B=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=M=>{const U=setTimeout(()=>M(B));let q=!1;return{dispose(){q||(q=!0,clearTimeout(U))}}}}else e.runWhenIdle=(B,M)=>{const U=requestIdleCallback(B,typeof M=="number"?{timeout:M}:void 0);let q=!1;return{dispose(){q||(q=!0,cancelIdleCallback(U))}}}}();class H{constructor(M){this._didRun=!1,this._executor=()=>{try{this._value=M()}catch(U){this._error=U}finally{this._didRun=!0}},this._handle=e.runWhenIdle(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=H;async function le(B,M,U){let q;for(let V=0;V<U;V++)try{return await B()}catch(oe){q=oe,await f(M)}throw q}e.retry=le;class fe{hasPending(M){return this._pending?typeof M=="number"?this._pending.taskId===M:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var M;(M=this._pending)===null||M===void 0||M.cancel()}setPending(M,U,q){return this._pending={taskId:M,cancel:()=>q==null?void 0:q(),promise:U},U.then(()=>this.donePending(M),()=>this.donePending(M)),U}donePending(M){this._pending&&M===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const M=this._next;this._next=void 0,M.run().then(M.promiseResolve,M.promiseReject)}}setNext(M){if(this._next)this._next.run=M;else{let U,q;const V=new Promise((oe,ge)=>{U=oe,q=ge});this._next={run:M,promise:V,promiseResolve:U,promiseReject:q}}return this._next.promise}}e.TaskSequentializer=fe;class X{constructor(M){this.interval=M,this.lastIncrementTime=0,this.value=0}increment(){const M=Date.now();return M-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=M,this.value=0),this.value++,this.value}}e.IntervalCounter=X;class z{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((M,U)=>{this.completeCallback=M,this.errorCallback=U})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(M){return new Promise(U=>{this.completeCallback(M),this.resolved=!0,U()})}error(M){return new Promise(U=>{this.errorCallback(M),this.rejected=!0,U()})}cancel(){new Promise(M=>{this.errorCallback(T.canceled()),this.rejected=!0,M()})}}e.DeferredPromise=z;class Y extends D.Emitter{async fireAsync(M,U,q){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new C.LinkedList);for(const V of this._listeners)this._asyncDeliveryQueue.push([V,M]);for(;this._asyncDeliveryQueue.size>0&&!U.isCancellationRequested;){const[V,oe]=this._asyncDeliveryQueue.shift(),ge=[],Re=Object.assign(Object.assign({},oe),{waitUntil:$e=>{if(Object.isFrozen(ge))throw new Error("waitUntil can NOT be called asynchronous");q&&($e=q($e,typeof V=="function"?V:V[0])),ge.push($e)}});try{typeof V=="function"?V.call(void 0,Re):V[0].call(V[1],Re)}catch($e){T.onUnexpectedError($e);continue}Object.freeze(ge),await R.settled(ge).catch($e=>T.onUnexpectedError($e))}}}}e.AsyncEmitter=Y;var R;(function(B){async function M(oe){return typeof Promise.allSettled=="function"?U(oe):q(oe)}B.allSettled=M;async function U(oe){return Promise.allSettled(oe)}async function q(oe){return Promise.all(oe.map(ge=>ge.then(Re=>({status:"fulfilled",value:Re}),Re=>({status:"rejected",reason:Re}))))}async function V(oe){let ge;const Re=await Promise.all(oe.map($e=>$e.then(Me=>Me,Me=>{ge||(ge=Me)})));if(typeof ge!="undefined")throw ge;return Re}B.settled=V})(R=e.Promises||(e.Promises={}))}),define(we[110],_e([0,1,13,11]),function(Z,e,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const D=new T.IdleValue(()=>{const A=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:A,collatorIsNumeric:A.resolvedOptions().numeric}}),E=new T.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),C=new T.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function y(A,a,F=!1){const N=A||"",H=a||"",le=D.value.collator.compare(N,H);return D.value.collatorIsNumeric&&le===0&&N!==H?N<H?-1:1:le}e.compareFileNames=y;function _(A,a){const F=E.value.collator;return A=A||"",a=a||"",f(F,A,a)}e.compareFileNamesDefault=_;function k(A,a){const F=E.value.collator;return A=A||"",a=a||"",s(A,a)||f(F,A,a)}e.compareFileNamesUpper=k;function n(A,a){const F=E.value.collator;return A=A||"",a=a||"",i(A,a)||f(F,A,a)}e.compareFileNamesLower=n;function I(A,a){return A=A||"",a=a||"",A===a?0:A<a?-1:1}e.compareFileNamesUnicode=I;function o(A,a,F=!1){F||(A=A&&A.toLowerCase(),a=a&&a.toLowerCase());const[N,H]=c(A),[le,fe]=c(a);return N!==le?N<le?-1:1:H===fe?0:H<fe?-1:1}e.noIntlCompareFileNames=o;function h(A,a){const[F,N]=c(A),[H,le]=c(a);let fe=D.value.collator.compare(N,le);if(fe===0){if(D.value.collatorIsNumeric&&N!==le)return N<le?-1:1;if(fe=D.value.collator.compare(F,H),D.value.collatorIsNumeric&&fe===0&&F!==H)return F<H?-1:1}return fe}e.compareFileExtensions=h;function d(A,a){A=A||"",a=a||"";const F=m(A),N=m(a),H=E.value.collator,le=C.value.collator;return f(le,F,N)||f(H,A,a)}e.compareFileExtensionsDefault=d;function u(A,a){A=A||"",a=a||"";const F=m(A),N=m(a),H=E.value.collator,le=C.value.collator;return f(le,F,N)||s(A,a)||f(H,A,a)}e.compareFileExtensionsUpper=u;function w(A,a){A=A||"",a=a||"";const F=m(A),N=m(a),H=E.value.collator,le=C.value.collator;return f(le,F,N)||i(A,a)||f(H,A,a)}e.compareFileExtensionsLower=w;function v(A,a){A=A||"",a=a||"";const F=m(A).toLowerCase(),N=m(a).toLowerCase();return F!==N?F<N?-1:1:A!==a?A<a?-1:1:0}e.compareFileExtensionsUnicode=v;const S=/^(.*?)(\.([^.]*))?$/;function c(A,a=!1){const F=A?S.exec(A):[];let N=[F&&F[1]||"",F&&F[3]||""];return a&&(!N[0]&&N[1]||N[0]&&N[0].charAt(0)===".")&&(N=[N[0]+"."+N[1],""]),N}function m(A){const a=A?S.exec(A):[];return a&&a[1]&&a[1].charAt(0)!=="."&&a[3]||""}function f(A,a,F){let N=A.compare(a,F);return N!==0?N:a.length!==F.length?a.length<F.length?-1:1:0}function t(A){const a=A.charAt(0);return a.toLocaleUpperCase()!==a}function r(A){const a=A.charAt(0);return a.toLocaleLowerCase()!==a}function i(A,a){return t(A)&&r(a)?-1:r(A)&&t(a)?1:0}function s(A,a){return r(A)&&t(a)?-1:t(A)&&r(a)?1:0}function l(A,a,F=!1){return F||(A=A&&A.toLowerCase(),a=a&&a.toLowerCase()),A===a?0:A<a?-1:1}function b(A,a,F=!1){const N=A.split(g.sep),H=a.split(g.sep),le=N.length-1,fe=H.length-1;let X,z;for(let Y=0;;Y++){if(X=le===Y,z=fe===Y,X&&z)return y(N[Y],H[Y],F);if(X)return-1;if(z)return 1;const R=l(N[Y],H[Y],F);if(R!==0)return R}}e.comparePaths=b;function p(A,a,F){const N=A.toLowerCase(),H=a.toLowerCase(),le=P(A,a,F);if(le)return le;const fe=N.endsWith(F),X=H.endsWith(F);if(fe!==X)return fe?-1:1;const z=y(N,H);return z!==0?z:N.localeCompare(H)}e.compareAnything=p;function P(A,a,F){const N=A.toLowerCase(),H=a.toLowerCase(),le=N.startsWith(F),fe=H.startsWith(F);if(le!==fe)return le?-1:1;if(le&&fe){if(N.length<H.length)return-1;if(N.length>H.length)return 1}return 0}e.compareByPrefix=P}),define(we[27],_e([0,1,8,42,13,22,11]),function(Z,e,g,T,D,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function y(){return Object.create(null)}e.getEmptyExpression=y;const _="**",k="/",n="[/\\\\]",I="[^/\\\\]",o=/\//g;function h(U){switch(U){case 0:return"";case 1:return`${I}*?`;default:return`(?:${n}|${I}+${n}|${n}${I}+)*?`}}function d(U,q){if(!U)return[];const V=[];let oe=!1,ge=!1,Re="";for(const $e of U){switch($e){case q:if(!oe&&!ge){V.push(Re),Re="";continue}break;case"{":oe=!0;break;case"}":oe=!1;break;case"[":ge=!0;break;case"]":ge=!1;break}Re+=$e}return Re&&V.push(Re),V}e.splitGlobAware=d;function u(U){if(!U)return"";let q="";const V=d(U,k);if(V.every(oe=>oe===_))q=".*";else{let oe=!1;V.forEach((ge,Re)=>{if(ge===_){oe||(q+=h(2),oe=!0);return}let $e=!1,Me="",We=!1,Je="";for(const Qe of ge){if(Qe!=="}"&&$e){Me+=Qe;continue}if(We&&(Qe!=="]"||!Je)){let Ye;Qe==="-"?Ye=Qe:(Qe==="^"||Qe==="!")&&!Je?Ye="^":Qe===k?Ye="":Ye=g.escapeRegExpCharacters(Qe),Je+=Ye;continue}switch(Qe){case"{":$e=!0;continue;case"[":We=!0;continue;case"}":q+=`(?:${d(Me,",").map(Q=>u(Q)).join("|")})`,$e=!1,Me="";break;case"]":q+="["+Je+"]",We=!1,Je="";break;case"?":q+=I;continue;case"*":q+=h(1);continue;default:q+=g.escapeRegExpCharacters(Qe)}}Re<V.length-1&&(V[Re+1]!==_||Re+2<V.length)&&(q+=n),oe=!1})}return q}const w=/^\*\*\/\*\.[\w\.-]+$/,v=/^\*\*\/([\w\.-]+)\/?$/,S=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,c=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,m=/^\*\*((\/[\w\.-]+)+)\/?$/,f=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new E.LRUCache(1e4),r=function(){return!1},i=function(){return null};function s(U,q){if(!U)return i;let V;typeof U!="string"?V=U.pattern:V=U,V=V.trim();const oe=`${V}_${!!q.trimForExclusions}`;let ge=t.get(oe);if(ge)return l(ge,U);let Re;if(w.test(V)){const $e=V.substr(4);ge=function(Me,We){return typeof Me=="string"&&Me.endsWith($e)?V:null}}else(Re=v.exec(b(V,q)))?ge=p(Re[1],V):(q.trimForExclusions?c:S).test(V)?ge=P(V,q):(Re=m.exec(b(V,q)))?ge=A(Re[1].substr(1),V,!0):(Re=f.exec(b(V,q)))?ge=A(Re[1],V,!1):ge=a(V);return t.set(oe,ge),l(ge,U)}function l(U,q){return typeof q=="string"?U:function(V,oe){return T.isEqualOrParent(V,q.base)?U(D.relative(q.base,V),oe):null}}function b(U,q){return q.trimForExclusions&&U.endsWith("/**")?U.substr(0,U.length-2):U}function p(U,q){const V=`/${U}`,oe=`\\${U}`,ge=function($e,Me){return typeof $e!="string"?null:Me?Me===U?q:null:$e===U||$e.endsWith(V)||$e.endsWith(oe)?q:null},Re=[U];return ge.basenames=Re,ge.patterns=[q],ge.allBasenames=Re,ge}function P(U,q){const V=M(U.slice(1,-1).split(",").map(Me=>s(Me,q)).filter(Me=>Me!==i),U),oe=V.length;if(!oe)return i;if(oe===1)return V[0];const ge=function(Me,We){for(let Je=0,Qe=V.length;Je<Qe;Je++)if(V[Je](Me,We))return U;return null},Re=V.find(Me=>!!Me.allBasenames);Re&&(ge.allBasenames=Re.allBasenames);const $e=V.reduce((Me,We)=>We.allPaths?Me.concat(We.allPaths):Me,[]);return $e.length&&(ge.allPaths=$e),ge}function A(U,q,V){const oe=D.sep===D.posix.sep,ge=oe?U:U.replace(o,D.sep),Re=D.sep+ge,$e=D.posix.sep+U,Me=V?function(We,Je){return typeof We=="string"&&(We===ge||We.endsWith(Re)||!oe&&(We===U||We.endsWith($e)))?q:null}:function(We,Je){return typeof We=="string"&&(We===ge||!oe&&We===U)?q:null};return Me.allPaths=[(V?"*/":"./")+U],Me}function a(U){try{const q=new RegExp(`^${u(U)}$`);return function(V){return q.lastIndex=0,typeof V=="string"&&q.test(V)?U:null}}catch(q){return i}}function F(U,q,V){return!U||typeof q!="string"?!1:N(U)(q,void 0,V)}e.match=F;function N(U,q={}){if(!U)return r;if(typeof U=="string"||X(U)){const V=s(U,q);if(V===i)return r;const oe=function(ge,Re){return!!V(ge,Re)};return V.allBasenames&&(oe.allBasenames=V.allBasenames),V.allPaths&&(oe.allPaths=V.allPaths),oe}return R(U,q)}e.parse=N;function H(U){if(!U)return;let q;return V=>(q||(q=(U()||Promise.resolve([])).then(oe=>oe?fe(oe):{})),q.then(oe=>!!oe[V]))}e.hasSiblingPromiseFn=H;function le(U){if(!U)return;let q;return V=>{if(!q){const oe=U();q=oe?fe(oe):{}}return!!q[V]}}e.hasSiblingFn=le;function fe(U){const q={};for(const V of U)q[V]=!0;return q}function X(U){const q=U;return q&&typeof q.base=="string"&&typeof q.pattern=="string"}e.isRelativePattern=X;function z(U){return U.allBasenames||[]}e.getBasenameTerms=z;function Y(U){return U.allPaths||[]}e.getPathTerms=Y;function R(U,q){const V=M(Object.getOwnPropertyNames(U).map(Me=>B(Me,U[Me],q)).filter(Me=>Me!==i)),oe=V.length;if(!oe)return i;if(!V.some(Me=>!!Me.requiresSiblings)){if(oe===1)return V[0];const Me=function(Qe,Ye){for(let W=0,Q=V.length;W<Q;W++){const te=V[W](Qe,Ye);if(te)return te}return null},We=V.find(Qe=>!!Qe.allBasenames);We&&(Me.allBasenames=We.allBasenames);const Je=V.reduce((Qe,Ye)=>Ye.allPaths?Qe.concat(Ye.allPaths):Qe,[]);return Je.length&&(Me.allPaths=Je),Me}const ge=function(Me,We,Je){let Qe;for(let Ye=0,W=V.length;Ye<W;Ye++){const Q=V[Ye];Q.requiresSiblings&&Je&&(We||(We=D.basename(Me)),Qe||(Qe=We.substr(0,We.length-D.extname(Me).length)));const te=Q(Me,We,Qe,Je);if(te)return te}return null},Re=V.find(Me=>!!Me.allBasenames);Re&&(ge.allBasenames=Re.allBasenames);const $e=V.reduce((Me,We)=>We.allPaths?Me.concat(We.allPaths):Me,[]);return $e.length&&(ge.allPaths=$e),ge}function B(U,q,V){if(q===!1)return i;const oe=s(U,V);if(oe===i)return i;if(typeof q=="boolean")return oe;if(q){const ge=q.when;if(typeof ge=="string"){const Re=($e,Me,We,Je)=>{if(!Je||!oe($e,Me))return null;const Qe=ge.replace("$(basename)",We),Ye=Je(Qe);return C.isThenable(Ye)?Ye.then(W=>W?U:null):Ye?U:null};return Re.requiresSiblings=!0,Re}}return oe}function M(U,q){const V=U.filter(Me=>!!Me.basenames);if(V.length<2)return U;const oe=V.reduce((Me,We)=>{const Je=We.basenames;return Je?Me.concat(Je):Me},[]);let ge;if(q){ge=[];for(let Me=0,We=oe.length;Me<We;Me++)ge.push(q)}else ge=V.reduce((Me,We)=>{const Je=We.patterns;return Je?Me.concat(Je):Me},[]);const Re=function(Me,We){if(typeof Me!="string")return null;if(!We){let Qe;for(Qe=Me.length;Qe>0;Qe--){const Ye=Me.charCodeAt(Qe-1);if(Ye===47||Ye===92)break}We=Me.substr(Qe)}const Je=oe.indexOf(We);return Je!==-1?ge[Je]:null};Re.basenames=oe,Re.patterns=ge,Re.allBasenames=oe;const $e=U.filter(Me=>!Me.basenames);return $e.push(Re),$e}}),define(we[81],_e([0,1,2,13,8,15,21,25,42]),function(Z,e,g,T,D,E,C,y,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function k(s,l,b){if(typeof s=="string"&&(s=g.URI.file(s)),b){const P=b.getWorkspaceFolder(s);if(P){const A=b.getWorkspace().folders.length>1;let a;if(y.isEqual(P.uri,s)?a="":a=y.relativePath(P.uri,s),A){const F=P.name?P.name:y.basename(P.uri);a=a?F+" \u2022 "+a:F}return a}}if(s.scheme!==E.Schemas.file&&s.scheme!==E.Schemas.untitled)return s.with({query:null,fragment:null}).toString(!0);if(_.hasDriveLetter(s.fsPath))return T.normalize(I(s.fsPath));let p=T.normalize(s.fsPath);return!C.isWindows&&(l==null?void 0:l.userHome)&&(p=h(p,l.userHome.fsPath)),p}e.getPathLabel=k;function n(s){if(!s)return;typeof s=="string"&&(s=g.URI.file(s));const l=y.basename(s)||(s.scheme===E.Schemas.file?s.fsPath:s.path);return C.isWindows&&_.isRootOrDriveLetter(l)?I(l):l}e.getBaseLabel=n;function I(s){return _.hasDriveLetter(s)?s.charAt(0).toUpperCase()+s.slice(1):s}e.normalizeDriveLetter=I;let o=Object.create(null);function h(s,l){if(C.isWindows||!s||!l)return s;let b=o.original===l?o.normalized:void 0;return b||(b=`${D.rtrim(l,T.posix.sep)}${T.posix.sep}`,o={original:l,normalized:b}),(C.isLinux?s.startsWith(b):D.startsWithIgnoreCase(s,b))&&(s=`~/${s.substr(b.length)}`),s}e.tildify=h;function d(s,l){return s.replace(/^~($|\/|\\)/,`${l}$1`)}e.untildify=d;const u="\u2026",w="\\\\",v="~";function S(s,l=T.sep){const b=new Array(s.length);let p=!1;for(let P=0;P<s.length;P++){let A=s[P];if(A===""){b[P]=`.${l}`;continue}if(!A){b[P]=A;continue}p=!0;let a="";A.indexOf(w)===0?(a=A.substr(0,A.indexOf(w)+w.length),A=A.substr(A.indexOf(w)+w.length)):A.indexOf(l)===0?(a=A.substr(0,A.indexOf(l)+l.length),A=A.substr(A.indexOf(l)+l.length)):A.indexOf(v)===0&&(a=A.substr(0,A.indexOf(v)+v.length),A=A.substr(A.indexOf(v)+v.length));const F=A.split(l);for(let N=1;p&&N<=F.length;N++)for(let H=F.length-N;p&&H>=0;H--){p=!1;let le=F.slice(H,H+N).join(l);for(let fe=0;!p&&fe<s.length;fe++)if(fe!==P&&s[fe]&&s[fe].indexOf(le)>-1){const X=H+N===F.length,z=H>0&&s[fe].indexOf(l)>-1?l+le:le,Y=s[fe].endsWith(z);p=!X||Y}if(!p){let fe="";(F[0].endsWith(":")||a!=="")&&(H===1&&(H=0,N++,le=F[0]+l+le),H>0&&(fe=F[0]+l),fe=a+fe),H>0&&(fe=fe+u+l),fe=fe+le,H+N<F.length&&(fe=fe+l+u),b[P]=fe}}p&&(b[P]=A)}return b}e.shorten=S;var c;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})(c||(c={}));function m(s,l=Object.create(null)){const b=[];let p=!1,P="";for(const A of s)if(A==="$"||p&&A==="{")P&&b.push({value:P,type:c.TEXT}),P="",p=!0;else if(A==="}"&&p){const a=l[P];if(typeof a=="string")a.length&&b.push({value:a,type:c.VARIABLE});else if(a){const F=b[b.length-1];(!F||F.type!==c.SEPARATOR)&&b.push({value:a.label,type:c.SEPARATOR})}P="",p=!1}else P+=A;return P&&!p&&b.push({value:P,type:c.TEXT}),b.filter((A,a)=>{if(A.type===c.SEPARATOR){const F=b[a-1],N=b[a+1];return[F,N].every(H=>H&&(H.type===c.VARIABLE||H.type===c.TEXT)&&H.value.length>0)}return!0}).map(A=>A.value).join("")}e.template=m;function f(s,l){return C.isMacintosh||l?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,C.isMacintosh?"&":"&&"):s.replace(/&&|&/g,b=>b==="&"?"&&":"&")}e.mnemonicMenuLabel=f;function t(s,l){return C.isMacintosh||l?s.replace(/\(&&\w\)|&&/g,""):C.isWindows?s.replace(/&&|&/g,b=>b==="&"?"&&":"&"):s.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function r(s){return s.replace(/&/g,"&&")}e.unmnemonicLabel=r;function i(s){const l=s.indexOf("/")!==-1?T.posix:T.win32,b=l.basename(s),p=l.dirname(s);return b.length?{name:b,parentPath:p}:{name:p,parentPath:""}}e.splitName=i}),define(we[111],_e([0,1,13,8,27,15,25]),function(Z,e,g,T,D,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.MIME_UNKNOWN=e.MIME_BINARY=e.MIME_TEXT=void 0,e.MIME_TEXT="text/plain",e.MIME_BINARY="application/octet-stream",e.MIME_UNKNOWN="application/unknown";let y=[],_=[],k=[];function n(t,r=!1){const i=I(t);y.push(i),i.userConfigured?k.push(i):_.push(i),r&&!i.userConfigured&&y.forEach(s=>{s.mime===i.mime||s.userConfigured||(i.extension&&s.extension===i.extension&&console.warn(`Overwriting extension <<${i.extension}>> to now point to mime <<${i.mime}>>`),i.filename&&s.filename===i.filename&&console.warn(`Overwriting filename <<${i.filename}>> to now point to mime <<${i.mime}>>`),i.filepattern&&s.filepattern===i.filepattern&&console.warn(`Overwriting filepattern <<${i.filepattern}>> to now point to mime <<${i.mime}>>`),i.firstline&&s.firstline===i.firstline&&console.warn(`Overwriting firstline <<${i.firstline}>> to now point to mime <<${i.mime}>>`))})}e.registerTextMime=n;function I(t){return{id:t.id,mime:t.mime,filename:t.filename,extension:t.extension,filepattern:t.filepattern,firstline:t.firstline,userConfigured:t.userConfigured,filenameLowercase:t.filename?t.filename.toLowerCase():void 0,extensionLowercase:t.extension?t.extension.toLowerCase():void 0,filepatternLowercase:t.filepattern?t.filepattern.toLowerCase():void 0,filepatternOnPath:t.filepattern?t.filepattern.indexOf(g.posix.sep)>=0:!1}}function o(t){t?(y=y.filter(r=>!r.userConfigured),k=[]):(y=[],_=[],k=[])}e.clearTextMimes=o;function h(t,r){let i;if(t)switch(t.scheme){case E.Schemas.file:i=t.fsPath;break;case E.Schemas.data:i=C.DataUri.parseMetaData(t).get(C.DataUri.META_DATA_LABEL);break;default:i=t.path}if(!i)return[e.MIME_UNKNOWN];i=i.toLowerCase();const s=g.basename(i),l=d(i,s,k);if(l)return[l,e.MIME_TEXT];const b=d(i,s,_);if(b)return[b,e.MIME_TEXT];if(r){const p=u(r);if(p)return[p,e.MIME_TEXT]}return[e.MIME_UNKNOWN]}e.guessMimeTypes=h;function d(t,r,i){let s=null,l=null,b=null;for(let p=i.length-1;p>=0;p--){const P=i[p];if(r===P.filenameLowercase){s=P;break}if(P.filepattern&&(!l||P.filepattern.length>l.filepattern.length)){const A=P.filepatternOnPath?t:r;D.match(P.filepatternLowercase,A)&&(l=P)}P.extension&&(!b||P.extension.length>b.extension.length)&&r.endsWith(P.extensionLowercase)&&(b=P)}return s?s.mime:l?l.mime:b?b.mime:null}function u(t){if(T.startsWithUTF8BOM(t)&&(t=t.substr(1)),t.length>0)for(let r=y.length-1;r>=0;r--){const i=y[r];if(!i.firstline)continue;const s=t.match(i.firstline);if(s&&s.length>0)return i.mime}return null}function w(t){return t?typeof t=="string"?t===e.MIME_BINARY||t===e.MIME_TEXT||t===e.MIME_UNKNOWN:t.length===1&&w(t[0]):!0}e.isUnspecific=w;const v={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function S(t){const r=g.extname(t);return v[r.toLowerCase()]}e.getMediaMime=S;function c(t){for(const r in v)if(v[r]===t)return r}e.getExtensionForMimeType=c;const m=/^(.+)\/(.+?)(;.+)?$/;function f(t,r){var i;const s=m.exec(t);return s?`${s[1].toLowerCase()}/${s[2].toLowerCase()}${(i=s[3])!==null&&i!==void 0?i:""}`:r?void 0:t}e.normalizeMimeType=f}),define(we[112],_e([0,1,2]),function(Z,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function T(n){return n.toJSON()}class D{constructor(I){this._uriTransformer=I}transformIncoming(I){const o=this._uriTransformer.transformIncoming(I);return o===I?I:T(g.URI.from(o))}transformOutgoing(I){const o=this._uriTransformer.transformOutgoing(I);return o===I?I:T(g.URI.from(o))}transformOutgoingURI(I){const o=this._uriTransformer.transformOutgoing(I);return o===I?I:g.URI.from(o)}transformOutgoingScheme(I){return this._uriTransformer.transformOutgoingScheme(I)}}e.URITransformer=D,e.DefaultURITransformer=new class{transformIncoming(n){return n}transformOutgoing(n){return n}transformOutgoingURI(n){return n}transformOutgoingScheme(n){return n}};function E(n,I,o){if(!n||o>200)return null;if(typeof n=="object"){if(n instanceof g.URI)return I.transformOutgoing(n);for(let h in n)if(Object.hasOwnProperty.call(n,h)){const d=E(n[h],I,o+1);d!==null&&(n[h]=d)}}return null}function C(n,I){const o=E(n,I,0);return o===null?n:o}e.transformOutgoingURIs=C;function y(n,I,o,h){if(!n||h>200)return null;if(typeof n=="object"){if(n.$mid===1)return o?g.URI.revive(I.transformIncoming(n)):I.transformIncoming(n);for(let d in n)if(Object.hasOwnProperty.call(n,d)){const u=y(n[d],I,o,h+1);u!==null&&(n[d]=u)}}return null}function _(n,I){const o=y(n,I,!1,0);return o===null?n:o}e.transformIncomingURIs=_;function k(n,I){const o=y(n,I,!0,0);return o===null?n:o}e.transformAndReviveIncomingURIs=k}),define(we[34],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const g=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function T(_){return g.test(_)}e.isUUID=T;const D=new Uint8Array(16),E=[];for(let _=0;_<256;_++)E.push(_.toString(16).padStart(2,"0"));let C;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?C=crypto.getRandomValues.bind(crypto):C=function(_){for(let k=0;k<_.length;k++)_[k]=Math.floor(Math.random()*256);return _};function y(){C(D),D[6]=D[6]&15|64,D[8]=D[8]&63|128;let _=0,k="";return k+=E[D[_++]],k+=E[D[_++]],k+=E[D[_++]],k+=E[D[_++]],k+="-",k+=E[D[_++]],k+=E[D[_++]],k+="-",k+=E[D[_++]],k+=E[D[_++]],k+="-",k+=E[D[_++]],k+=E[D[_++]],k+="-",k+=E[D[_++]],k+=E[D[_++]],k+=E[D[_++]],k+=E[D[_++]],k+=E[D[_++]],k+=E[D[_++]],k}e.generateUuid=y}),define(we[82],_e([0,1,79]),function(Z,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class T{constructor(y){let _=g.toUint8(y);this._defaultValue=_,this._asciiMap=T._createAsciiMap(_),this._map=new Map}static _createAsciiMap(y){let _=new Uint8Array(256);for(let k=0;k<256;k++)_[k]=y;return _}set(y,_){let k=g.toUint8(_);y>=0&&y<256?this._asciiMap[y]=k:this._map.set(y,k)}get(y){return y>=0&&y<256?this._asciiMap[y]:this._map.get(y)||this._defaultValue}}e.CharacterClassifier=T;var D;(function(C){C[C.False=0]="False",C[C.True=1]="True"})(D||(D={}));class E{constructor(){this._actual=new T(0)}add(y){this._actual.set(y,1)}has(y){return this._actual.get(y)===1}}e.CharacterSet=E}),define(we[113],_e([0,1,82]),function(Z,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var T;(function(C){C[C.Regular=0]="Regular",C[C.Whitespace=1]="Whitespace",C[C.WordSeparator=2]="WordSeparator"})(T=e.WordCharacterClass||(e.WordCharacterClass={}));class D extends g.CharacterClassifier{constructor(y){super(0);for(let _=0,k=y.length;_<k;_++)this.set(y.charCodeAt(_),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=D;function E(C){let y={};return _=>(y.hasOwnProperty(_)||(y[_]=C(_)),y[_])}e.getMapForWordSeparators=E(C=>new D(C))}),define(we[35],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class g{constructor(D,E){this.lineNumber=D,this.column=E}with(D=this.lineNumber,E=this.column){return D===this.lineNumber&&E===this.column?this:new g(D,E)}delta(D=0,E=0){return this.with(this.lineNumber+D,this.column+E)}equals(D){return g.equals(this,D)}static equals(D,E){return!D&&!E?!0:!!D&&!!E&&D.lineNumber===E.lineNumber&&D.column===E.column}isBefore(D){return g.isBefore(this,D)}static isBefore(D,E){return D.lineNumber<E.lineNumber?!0:E.lineNumber<D.lineNumber?!1:D.column<E.column}isBeforeOrEqual(D){return g.isBeforeOrEqual(this,D)}static isBeforeOrEqual(D,E){return D.lineNumber<E.lineNumber?!0:E.lineNumber<D.lineNumber?!1:D.column<=E.column}static compare(D,E){let C=D.lineNumber|0,y=E.lineNumber|0;if(C===y){let _=D.column|0,k=E.column|0;return _-k}return C-y}clone(){return new g(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(D){return new g(D.lineNumber,D.column)}static isIPosition(D){return D&&typeof D.lineNumber=="number"&&typeof D.column=="number"}}e.Position=g}),define(we[31],_e([0,1,35]),function(Z,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class T{constructor(E,C,y,_){E>y||E===y&&C>_?(this.startLineNumber=y,this.startColumn=_,this.endLineNumber=E,this.endColumn=C):(this.startLineNumber=E,this.startColumn=C,this.endLineNumber=y,this.endColumn=_)}isEmpty(){return T.isEmpty(this)}static isEmpty(E){return E.startLineNumber===E.endLineNumber&&E.startColumn===E.endColumn}containsPosition(E){return T.containsPosition(this,E)}static containsPosition(E,C){return!(C.lineNumber<E.startLineNumber||C.lineNumber>E.endLineNumber||C.lineNumber===E.startLineNumber&&C.column<E.startColumn||C.lineNumber===E.endLineNumber&&C.column>E.endColumn)}containsRange(E){return T.containsRange(this,E)}static containsRange(E,C){return!(C.startLineNumber<E.startLineNumber||C.endLineNumber<E.startLineNumber||C.startLineNumber>E.endLineNumber||C.endLineNumber>E.endLineNumber||C.startLineNumber===E.startLineNumber&&C.startColumn<E.startColumn||C.endLineNumber===E.endLineNumber&&C.endColumn>E.endColumn)}strictContainsRange(E){return T.strictContainsRange(this,E)}static strictContainsRange(E,C){return!(C.startLineNumber<E.startLineNumber||C.endLineNumber<E.startLineNumber||C.startLineNumber>E.endLineNumber||C.endLineNumber>E.endLineNumber||C.startLineNumber===E.startLineNumber&&C.startColumn<=E.startColumn||C.endLineNumber===E.endLineNumber&&C.endColumn>=E.endColumn)}plusRange(E){return T.plusRange(this,E)}static plusRange(E,C){let y,_,k,n;return C.startLineNumber<E.startLineNumber?(y=C.startLineNumber,_=C.startColumn):C.startLineNumber===E.startLineNumber?(y=C.startLineNumber,_=Math.min(C.startColumn,E.startColumn)):(y=E.startLineNumber,_=E.startColumn),C.endLineNumber>E.endLineNumber?(k=C.endLineNumber,n=C.endColumn):C.endLineNumber===E.endLineNumber?(k=C.endLineNumber,n=Math.max(C.endColumn,E.endColumn)):(k=E.endLineNumber,n=E.endColumn),new T(y,_,k,n)}intersectRanges(E){return T.intersectRanges(this,E)}static intersectRanges(E,C){let y=E.startLineNumber,_=E.startColumn,k=E.endLineNumber,n=E.endColumn,I=C.startLineNumber,o=C.startColumn,h=C.endLineNumber,d=C.endColumn;return y<I?(y=I,_=o):y===I&&(_=Math.max(_,o)),k>h?(k=h,n=d):k===h&&(n=Math.min(n,d)),y>k||y===k&&_>n?null:new T(y,_,k,n)}equalsRange(E){return T.equalsRange(this,E)}static equalsRange(E,C){return!!E&&!!C&&E.startLineNumber===C.startLineNumber&&E.startColumn===C.startColumn&&E.endLineNumber===C.endLineNumber&&E.endColumn===C.endColumn}getEndPosition(){return T.getEndPosition(this)}static getEndPosition(E){return new g.Position(E.endLineNumber,E.endColumn)}getStartPosition(){return T.getStartPosition(this)}static getStartPosition(E){return new g.Position(E.startLineNumber,E.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(E,C){return new T(this.startLineNumber,this.startColumn,E,C)}setStartPosition(E,C){return new T(E,C,this.endLineNumber,this.endColumn)}collapseToStart(){return T.collapseToStart(this)}static collapseToStart(E){return new T(E.startLineNumber,E.startColumn,E.startLineNumber,E.startColumn)}static fromPositions(E,C=E){return new T(E.lineNumber,E.column,C.lineNumber,C.column)}static lift(E){return E?new T(E.startLineNumber,E.startColumn,E.endLineNumber,E.endColumn):null}static isIRange(E){return E&&typeof E.startLineNumber=="number"&&typeof E.startColumn=="number"&&typeof E.endLineNumber=="number"&&typeof E.endColumn=="number"}static areIntersectingOrTouching(E,C){return!(E.endLineNumber<C.startLineNumber||E.endLineNumber===C.startLineNumber&&E.endColumn<C.startColumn||C.endLineNumber<E.startLineNumber||C.endLineNumber===E.startLineNumber&&C.endColumn<E.startColumn)}static areIntersecting(E,C){return!(E.endLineNumber<C.startLineNumber||E.endLineNumber===C.startLineNumber&&E.endColumn<=C.startColumn||C.endLineNumber<E.startLineNumber||C.endLineNumber===E.startLineNumber&&C.endColumn<=E.startColumn)}static compareRangesUsingStarts(E,C){if(E&&C){const k=E.startLineNumber|0,n=C.startLineNumber|0;if(k===n){const I=E.startColumn|0,o=C.startColumn|0;if(I===o){const h=E.endLineNumber|0,d=C.endLineNumber|0;if(h===d){const u=E.endColumn|0,w=C.endColumn|0;return u-w}return h-d}return I-o}return k-n}return(E?1:0)-(C?1:0)}static compareRangesUsingEnds(E,C){return E.endLineNumber===C.endLineNumber?E.endColumn===C.endColumn?E.startLineNumber===C.startLineNumber?E.startColumn-C.startColumn:E.startLineNumber-C.startLineNumber:E.endColumn-C.endColumn:E.endLineNumber-C.endLineNumber}static spansMultipleLines(E){return E.endLineNumber>E.startLineNumber}}e.Range=T}),define(we[114],_e([0,1,35,31]),function(Z,e,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var D;(function(C){C[C.LTR=0]="LTR",C[C.RTL=1]="RTL"})(D=e.SelectionDirection||(e.SelectionDirection={}));class E extends T.Range{constructor(y,_,k,n){super(y,_,k,n);this.selectionStartLineNumber=y,this.selectionStartColumn=_,this.positionLineNumber=k,this.positionColumn=n}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(y){return E.selectionsEqual(this,y)}static selectionsEqual(y,_){return y.selectionStartLineNumber===_.selectionStartLineNumber&&y.selectionStartColumn===_.selectionStartColumn&&y.positionLineNumber===_.positionLineNumber&&y.positionColumn===_.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(y,_){return this.getDirection()===0?new E(this.startLineNumber,this.startColumn,y,_):new E(y,_,this.startLineNumber,this.startColumn)}getPosition(){return new g.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(y,_){return this.getDirection()===0?new E(y,_,this.endLineNumber,this.endColumn):new E(this.endLineNumber,this.endColumn,y,_)}static fromPositions(y,_=y){return new E(y.lineNumber,y.column,_.lineNumber,_.column)}static liftSelection(y){return new E(y.selectionStartLineNumber,y.selectionStartColumn,y.positionLineNumber,y.positionColumn)}static selectionsArrEqual(y,_){if(y&&!_||!y&&_)return!1;if(!y&&!_)return!0;if(y.length!==_.length)return!1;for(let k=0,n=y.length;k<n;k++)if(!this.selectionsEqual(y[k],_[k]))return!1;return!0}static isISelection(y){return y&&typeof y.selectionStartLineNumber=="number"&&typeof y.selectionStartColumn=="number"&&typeof y.positionLineNumber=="number"&&typeof y.positionColumn=="number"}static createWithDirection(y,_,k,n,I){return I===0?new E(y,_,k,n):new E(k,n,y,_)}}e.Selection=E}),define(we[83],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionNormalizationAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var g;(function(d){d[d.Left=1]="Left",d[d.Center=2]="Center",d[d.Right=4]="Right",d[d.Full=7]="Full"})(g=e.OverviewRulerLane||(e.OverviewRulerLane={}));var T;(function(d){d[d.Inline=1]="Inline",d[d.Gutter=2]="Gutter"})(T=e.MinimapPosition||(e.MinimapPosition={}));var D;(function(d){d[d.TextDefined=0]="TextDefined",d[d.LF=1]="LF",d[d.CRLF=2]="CRLF"})(D=e.EndOfLinePreference||(e.EndOfLinePreference={}));var E;(function(d){d[d.LF=1]="LF",d[d.CRLF=2]="CRLF"})(E=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var C;(function(d){d[d.LF=0]="LF",d[d.CRLF=1]="CRLF"})(C=e.EndOfLineSequence||(e.EndOfLineSequence={}));class y{constructor(u){this.tabSize=Math.max(1,u.tabSize|0),this.indentSize=u.tabSize|0,this.insertSpaces=Boolean(u.insertSpaces),this.defaultEOL=u.defaultEOL|0,this.trimAutoWhitespace=Boolean(u.trimAutoWhitespace)}equals(u){return this.tabSize===u.tabSize&&this.indentSize===u.indentSize&&this.insertSpaces===u.insertSpaces&&this.defaultEOL===u.defaultEOL&&this.trimAutoWhitespace===u.trimAutoWhitespace}createChangeEvent(u){return{tabSize:this.tabSize!==u.tabSize,indentSize:this.indentSize!==u.indentSize,insertSpaces:this.insertSpaces!==u.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==u.trimAutoWhitespace}}}e.TextModelResolvedOptions=y;class _{constructor(u,w){this.range=u,this.matches=w}}e.FindMatch=_;var k;(function(d){d[d.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",d[d.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",d[d.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",d[d.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(k=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var n;(function(d){d[d.Left=0]="Left",d[d.Right=1]="Right"})(n=e.PositionNormalizationAffinity||(e.PositionNormalizationAffinity={}));var I;(function(d){d[d.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(I=e.ModelConstants||(e.ModelConstants={}));class o{constructor(u,w,v,S,c,m){this.identifier=u,this.range=w,this.text=v,this.forceMoveMarkers=S,this.isAutoWhitespaceEdit=c,this._isTracked=m}}e.ValidAnnotatedEditOperation=o;class h{constructor(u,w,v){this.reverseEdits=u,this.changes=w,this.trimAutoWhitespaceLineNumbers=v}}e.ApplyEditsResult=h}),define(we[115],_e([0,1,8,113,35,31,83]),function(Z,e,g,T,D,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const y=999;class _{constructor(c,m,f,t){this.searchString=c,this.isRegex=m,this.matchCase=f,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let c;this.isRegex?c=k(this.searchString):c=this.searchString.indexOf(`
`)>=0;let m=null;try{m=g.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:c,global:!0,unicode:!0})}catch(t){return null}if(!m)return null;let f=!this.isRegex&&!c;return f&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(f=this.matchCase),new n(m,this.wordSeparators?T.getMapForWordSeparators(this.wordSeparators):null,f?this.searchString:null)}}e.SearchParams=_;function k(S){if(!S||S.length===0)return!1;for(let c=0,m=S.length;c<m;c++)if(S.charCodeAt(c)===92){if(c++,c>=m)break;const t=S.charCodeAt(c);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=k;class n{constructor(c,m,f){this.regex=c,this.wordSeparators=m,this.simpleSearch=f}}e.SearchData=n;function I(S,c,m){if(!m)return new C.FindMatch(S,null);let f=[];for(let t=0,r=c.length;t<r;t++)f[t]=c[t];return new C.FindMatch(S,f)}e.createFindMatch=I;class o{constructor(c){let m=[],f=0;for(let t=0,r=c.length;t<r;t++)c.charCodeAt(t)===10&&(m[f++]=t);this._lineFeedsOffsets=m}findLineFeedCountBeforeOffset(c){const m=this._lineFeedsOffsets;let f=0,t=m.length-1;if(t===-1||c<=m[0])return 0;for(;f<t;){const r=f+((t-f)/2>>0);m[r]>=c?t=r-1:m[r+1]>=c?(f=r,t=r):f=r+1}return f+1}}class h{static findMatches(c,m,f,t,r){const i=m.parseSearchRequest();return i?i.regex.multiline?this._doFindMatchesMultiline(c,f,new v(i.wordSeparators,i.regex),t,r):this._doFindMatchesLineByLine(c,f,i,t,r):[]}static _getMultilineMatchRange(c,m,f,t,r,i){let s,l=0;t?(l=t.findLineFeedCountBeforeOffset(r),s=m+r+l):s=m+r;let b;if(t){let a=t.findLineFeedCountBeforeOffset(r+i.length)-l;b=s+i.length+a}else b=s+i.length;const p=c.getPositionAt(s),P=c.getPositionAt(b);return new E.Range(p.lineNumber,p.column,P.lineNumber,P.column)}static _doFindMatchesMultiline(c,m,f,t,r){const i=c.getOffsetAt(m.getStartPosition()),s=c.getValueInRange(m,1),l=c.getEOL()===`\r
`?new o(s):null,b=[];let p=0,P;for(f.reset(0);P=f.next(s);)if(b[p++]=I(this._getMultilineMatchRange(c,i,s,l,P.index,P[0]),P,t),p>=r)return b;return b}static _doFindMatchesLineByLine(c,m,f,t,r){const i=[];let s=0;if(m.startLineNumber===m.endLineNumber){const b=c.getLineContent(m.startLineNumber).substring(m.startColumn-1,m.endColumn-1);return s=this._findMatchesInLine(f,b,m.startLineNumber,m.startColumn-1,s,i,t,r),i}const l=c.getLineContent(m.startLineNumber).substring(m.startColumn-1);s=this._findMatchesInLine(f,l,m.startLineNumber,m.startColumn-1,s,i,t,r);for(let b=m.startLineNumber+1;b<m.endLineNumber&&s<r;b++)s=this._findMatchesInLine(f,c.getLineContent(b),b,0,s,i,t,r);if(s<r){const b=c.getLineContent(m.endLineNumber).substring(0,m.endColumn-1);s=this._findMatchesInLine(f,b,m.endLineNumber,0,s,i,t,r)}return i}static _findMatchesInLine(c,m,f,t,r,i,s,l){const b=c.wordSeparators;if(!s&&c.simpleSearch){const A=c.simpleSearch,a=A.length,F=m.length;let N=-a;for(;(N=m.indexOf(A,N+a))!==-1;)if((!b||w(b,m,F,N,a))&&(i[r++]=new C.FindMatch(new E.Range(f,N+1+t,f,N+1+a+t),null),r>=l))return r;return r}const p=new v(c.wordSeparators,c.regex);let P;p.reset(0);do if(P=p.next(m),P&&(i[r++]=I(new E.Range(f,P.index+1+t,f,P.index+1+P[0].length+t),P,s),r>=l))return r;while(P);return r}static findNextMatch(c,m,f,t){const r=m.parseSearchRequest();if(!r)return null;const i=new v(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindNextMatchMultiline(c,f,i,t):this._doFindNextMatchLineByLine(c,f,i,t)}static _doFindNextMatchMultiline(c,m,f,t){const r=new D.Position(m.lineNumber,1),i=c.getOffsetAt(r),s=c.getLineCount(),l=c.getValueInRange(new E.Range(r.lineNumber,r.column,s,c.getLineMaxColumn(s)),1),b=c.getEOL()===`\r
`?new o(l):null;f.reset(m.column-1);let p=f.next(l);return p?I(this._getMultilineMatchRange(c,i,l,b,p.index,p[0]),p,t):m.lineNumber!==1||m.column!==1?this._doFindNextMatchMultiline(c,new D.Position(1,1),f,t):null}static _doFindNextMatchLineByLine(c,m,f,t){const r=c.getLineCount(),i=m.lineNumber,s=c.getLineContent(i),l=this._findFirstMatchInLine(f,s,i,m.column,t);if(l)return l;for(let b=1;b<=r;b++){const p=(i+b-1)%r,P=c.getLineContent(p+1),A=this._findFirstMatchInLine(f,P,p+1,1,t);if(A)return A}return null}static _findFirstMatchInLine(c,m,f,t,r){c.reset(t-1);const i=c.next(m);return i?I(new E.Range(f,i.index+1,f,i.index+1+i[0].length),i,r):null}static findPreviousMatch(c,m,f,t){const r=m.parseSearchRequest();if(!r)return null;const i=new v(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindPreviousMatchMultiline(c,f,i,t):this._doFindPreviousMatchLineByLine(c,f,i,t)}static _doFindPreviousMatchMultiline(c,m,f,t){const r=this._doFindMatchesMultiline(c,new E.Range(1,1,m.lineNumber,m.column),f,t,10*y);if(r.length>0)return r[r.length-1];const i=c.getLineCount();return m.lineNumber!==i||m.column!==c.getLineMaxColumn(i)?this._doFindPreviousMatchMultiline(c,new D.Position(i,c.getLineMaxColumn(i)),f,t):null}static _doFindPreviousMatchLineByLine(c,m,f,t){const r=c.getLineCount(),i=m.lineNumber,s=c.getLineContent(i).substring(0,m.column-1),l=this._findLastMatchInLine(f,s,i,t);if(l)return l;for(let b=1;b<=r;b++){const p=(r+i-b-1)%r,P=c.getLineContent(p+1),A=this._findLastMatchInLine(f,P,p+1,t);if(A)return A}return null}static _findLastMatchInLine(c,m,f,t){let r=null,i;for(c.reset(0);i=c.next(m);)r=I(new E.Range(f,i.index+1,f,i.index+1+i[0].length),i,t);return r}}e.TextModelSearch=h;function d(S,c,m,f,t){if(f===0)return!0;const r=c.charCodeAt(f-1);if(S.get(r)!==0||r===13||r===10)return!0;if(t>0){const i=c.charCodeAt(f);if(S.get(i)!==0)return!0}return!1}function u(S,c,m,f,t){if(f+t===m)return!0;const r=c.charCodeAt(f+t);if(S.get(r)!==0||r===13||r===10)return!0;if(t>0){const i=c.charCodeAt(f+t-1);if(S.get(i)!==0)return!0}return!1}function w(S,c,m,f,t){return d(S,c,m,f,t)&&u(S,c,m,f,t)}e.isValidMatch=w;class v{constructor(c,m){this._wordSeparators=c,this._searchRegex=m,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(c){this._searchRegex.lastIndex=c,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(c){const m=c.length;let f;do{if(this._prevMatchStartIndex+this._prevMatchLength===m||(f=this._searchRegex.exec(c),!f))return null;const t=f.index,r=f[0].length;if(t===this._prevMatchStartIndex&&r===this._prevMatchLength){if(r===0){g.getNextCodePoint(c,m,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=r,!this._wordSeparators||w(this._wordSeparators,c,m,t,r))return f}while(f);return null}}e.Searcher=v}),define(we[84],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function g(y=""){let _="(-?\\d*\\.\\d\\w*)|([^";for(const k of e.USUAL_WORD_SEPARATORS)y.indexOf(k)>=0||(_+="\\"+k);return _+="\\s]+)",new RegExp(_,"g")}e.DEFAULT_WORD_REGEXP=g();function T(y){let _=e.DEFAULT_WORD_REGEXP;if(y&&y instanceof RegExp)if(y.global)_=y;else{let k="g";y.ignoreCase&&(k+="i"),y.multiline&&(k+="m"),y.unicode&&(k+="u"),_=new RegExp(y.source,k)}return _.lastIndex=0,_}e.ensureValidWordDefinition=T;const D={maxLen:1e3,windowSize:15,timeBudget:150};function E(y,_,k,n,I=D){if(k.length>I.maxLen){let w=y-I.maxLen/2;return w<0?w=0:n+=w,k=k.substring(w,y+I.maxLen/2),E(y,_,k,n,I)}const o=Date.now(),h=y-1-n;let d=-1,u=null;for(let w=1;!(Date.now()-o>=I.timeBudget);w++){const v=h-I.windowSize*w;_.lastIndex=Math.max(0,v);const S=C(_,k,h,d);if(!S&&u||(u=S,v<=0))break;d=v}if(u){let w={word:u[0],startColumn:n+1+u.index,endColumn:n+1+u.index+u[0].length};return _.lastIndex=0,w}return null}e.getWordAtText=E;function C(y,_,k,n){let I;for(;I=y.exec(_);){const o=I.index||0;if(o<=k&&y.lastIndex>=k)return I;if(n>0&&o>n)return null}return null}}),define(we[116],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var g;(function(C){C[C.None=0]="None",C[C.Indent=1]="Indent",C[C.IndentOutdent=2]="IndentOutdent",C[C.Outdent=3]="Outdent"})(g=e.IndentAction||(e.IndentAction={}));class T{constructor(y){if(this.open=y.open,this.close=y.close,this._standardTokenMask=0,Array.isArray(y.notIn))for(let _=0,k=y.notIn.length;_<k;_++)switch(y.notIn[_]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(y){return(this._standardTokenMask&y)==0}}e.StandardAutoClosingPairConditional=T;class D{constructor(y){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const _ of y)E(this.autoClosingPairsOpenByStart,_.open.charAt(0),_),E(this.autoClosingPairsOpenByEnd,_.open.charAt(_.open.length-1),_),E(this.autoClosingPairsCloseByStart,_.close.charAt(0),_),E(this.autoClosingPairsCloseByEnd,_.close.charAt(_.close.length-1),_),_.close.length===1&&_.open.length===1&&E(this.autoClosingPairsCloseSingleChar,_.close,_)}}e.AutoClosingPairs=D;function E(C,y,_){C.has(y)?C.get(y).push(_):C.set(y,[_])}}),define(we[55],_e([0,1,27,13]),function(Z,e,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function D(E,C,y,_){if(Array.isArray(E)){let k=0;for(const n of E){const I=D(n,C,y,_);if(I===10)return I;I>k&&(k=I)}return k}else{if(typeof E=="string")return _?E==="*"?5:E===y?10:0:0;if(E){const{language:k,pattern:n,scheme:I,hasAccessToAllModels:o}=E;if(!_&&!o)return 0;let h=0;if(I)if(I===C.scheme)h=10;else if(I==="*")h=5;else return 0;if(k)if(k===y)h=10;else if(k==="*")h=Math.max(h,5);else return 0;if(n){let d;if(typeof n=="string"?d=n:d=Object.assign(Object.assign({},n),{base:T.normalize(n.base)}),d===C.fsPath||g.match(d,C.fsPath))h=10;else return 0}return h}else return 0}}e.score=D}),define(we[117],_e([0,1,82]),function(Z,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var T;(function(h){h[h.Invalid=0]="Invalid",h[h.Start=1]="Start",h[h.H=2]="H",h[h.HT=3]="HT",h[h.HTT=4]="HTT",h[h.HTTP=5]="HTTP",h[h.F=6]="F",h[h.FI=7]="FI",h[h.FIL=8]="FIL",h[h.BeforeColon=9]="BeforeColon",h[h.AfterColon=10]="AfterColon",h[h.AlmostThere=11]="AlmostThere",h[h.End=12]="End",h[h.Accept=13]="Accept",h[h.LastKnownState=14]="LastKnownState"})(T=e.State||(e.State={}));class D{constructor(d,u,w){const v=new Uint8Array(d*u);for(let S=0,c=d*u;S<c;S++)v[S]=w;this._data=v,this.rows=d,this.cols=u}get(d,u){return this._data[d*this.cols+u]}set(d,u,w){this._data[d*this.cols+u]=w}}e.Uint8Matrix=D;class E{constructor(d){let u=0,w=0;for(let S=0,c=d.length;S<c;S++){let[m,f,t]=d[S];f>u&&(u=f),m>w&&(w=m),t>w&&(w=t)}u++,w++;let v=new D(w,u,0);for(let S=0,c=d.length;S<c;S++){let[m,f,t]=d[S];v.set(m,f,t)}this._states=v,this._maxCharCode=u}nextState(d,u){return u<0||u>=this._maxCharCode?0:this._states.get(d,u)}}e.StateMachine=E;let C=null;function y(){return C===null&&(C=new E([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),C}var _;(function(h){h[h.None=0]="None",h[h.ForceTermination=1]="ForceTermination",h[h.CannotEndIn=2]="CannotEndIn"})(_||(_={}));let k=null;function n(){if(k===null){k=new g.CharacterClassifier(0);const h=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let u=0;u<h.length;u++)k.set(h.charCodeAt(u),1);const d=".,;";for(let u=0;u<d.length;u++)k.set(d.charCodeAt(u),2)}return k}class I{static _createLink(d,u,w,v,S){let c=S-1;do{const m=u.charCodeAt(c);if(d.get(m)!==2)break;c--}while(c>v);if(v>0){const m=u.charCodeAt(v-1),f=u.charCodeAt(c);(m===40&&f===41||m===91&&f===93||m===123&&f===125)&&c--}return{range:{startLineNumber:w,startColumn:v+1,endLineNumber:w,endColumn:c+2},url:u.substring(v,c+1)}}static computeLinks(d,u=y()){const w=n();let v=[];for(let S=1,c=d.getLineCount();S<=c;S++){const m=d.getLineContent(S),f=m.length;let t=0,r=0,i=0,s=1,l=!1,b=!1,p=!1,P=!1;for(;t<f;){let A=!1;const a=m.charCodeAt(t);if(s===13){let F;switch(a){case 40:l=!0,F=0;break;case 41:F=l?0:1;break;case 91:p=!0,b=!0,F=0;break;case 93:p=!1,F=b?0:1;break;case 123:P=!0,F=0;break;case 125:F=P?0:1;break;case 39:F=i===34||i===96?0:1;break;case 34:F=i===39||i===96?0:1;break;case 96:F=i===39||i===34?0:1;break;case 42:F=i===42?1:0;break;case 124:F=i===124?1:0;break;case 32:F=p?0:1;break;default:F=w.get(a)}F===1&&(v.push(I._createLink(w,m,S,r,t)),A=!0)}else if(s===12){let F;a===91?(b=!0,F=0):F=w.get(a),F===1?A=!0:s=13}else s=u.nextState(s,a),s===0&&(A=!0);A&&(s=1,l=!1,b=!1,P=!1,r=t+1,i=a),t++}s===13&&v.push(I._createLink(w,m,S,r,f))}return v}}e.LinkComputer=I;function o(h){return!h||typeof h.getLineCount!="function"||typeof h.getLineContent!="function"?[]:I.computeLinks(h)}e.computeLinks=o}),define(we[118],_e([0,1,3,7]),function(Z,e,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class D{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new g.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(C){this._onDidChange.fire({changedLanguages:C,changedColorMap:!1})}register(C,y){return this._map.set(C,y),this.fire([C]),T.toDisposable(()=>{this._map.get(C)===y&&(this._map.delete(C),this.fire([C]))})}registerPromise(C,y){let _=null,k=!1;return this._promises.set(C,y.then(n=>{this._promises.delete(C),!(k||!n)&&(_=this.register(C,n))})),T.toDisposable(()=>{k=!0,_&&_.dispose()})}getPromise(C){const y=this.get(C);if(y)return Promise.resolve(y);const _=this._promises.get(C);return _?_.then(k=>this.get(C)):null}get(C){return this._map.get(C)||null}setColorMap(C){this._colorMap=C,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=D}),define(we[85],_e([0,1,23,21]),function(Z,e,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var D;(function(I){I[I.Full=1]="Full",I[I.Delta=2]="Delta"})(D||(D={}));function E(I){for(let o=0,h=I.length;o<h;o+=4){const d=I[o+0],u=I[o+1],w=I[o+2],v=I[o+3];I[o+0]=v,I[o+1]=w,I[o+2]=u,I[o+3]=d}}function C(I){const o=new Uint8Array(I.buffer,I.byteOffset,I.length*4);return T.isLittleEndian()||E(o),g.VSBuffer.wrap(o)}function y(I){const o=I.buffer;if(T.isLittleEndian()||E(o),o.byteOffset%4==0)return new Uint32Array(o.buffer,o.byteOffset,o.length/4);{const h=new Uint8Array(o.byteLength);return h.set(o),new Uint32Array(h.buffer,h.byteOffset,h.length/4)}}function _(I){const o=new Uint32Array(k(I));let h=0;if(o[h++]=I.id,I.type==="full")o[h++]=1,o[h++]=I.data.length,o.set(I.data,h),h+=I.data.length;else{o[h++]=2,o[h++]=I.deltas.length;for(const d of I.deltas)o[h++]=d.start,o[h++]=d.deleteCount,d.data?(o[h++]=d.data.length,o.set(d.data,h),h+=d.data.length):o[h++]=0}return C(o)}e.encodeSemanticTokensDto=_;function k(I){let o=0;if(o+=1+1,I.type==="full")o+=1+I.data.length;else{o+=1,o+=(1+1+1)*I.deltas.length;for(const h of I.deltas)h.data&&(o+=h.data.length)}return o}function n(I){const o=y(I);let h=0;const d=o[h++];if(o[h++]===1){const S=o[h++],c=o.subarray(h,h+S);return h+=S,{id:d,type:"full",data:c}}const w=o[h++];let v=[];for(let S=0;S<w;S++){const c=o[h++],m=o[h++],f=o[h++];let t;f>0&&(t=o.subarray(h,h+f),h+=f),v[S]={start:c,deleteCount:m,data:t}}return{id:d,type:"delta",deltas:v}}e.decodeSemanticTokensDto=n}),define(we[86],_e([0,1,79]),function(Z,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class T{constructor(C,y){this.index=C,this.remainder=y}}e.PrefixSumIndexOfResult=T;class D{constructor(C){this.values=C,this.prefixSum=new Uint32Array(C.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(C,y){C=g.toUint32(C);const _=this.values,k=this.prefixSum,n=y.length;return n===0?!1:(this.values=new Uint32Array(_.length+n),this.values.set(_.subarray(0,C),0),this.values.set(_.subarray(C),C+n),this.values.set(y,C),C-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=C-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(k.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(C,y){return C=g.toUint32(C),y=g.toUint32(y),this.values[C]===y?!1:(this.values[C]=y,C-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=C-1),!0)}removeValues(C,y){C=g.toUint32(C),y=g.toUint32(y);const _=this.values,k=this.prefixSum;if(C>=_.length)return!1;let n=_.length-C;return y>=n&&(y=n),y===0?!1:(this.values=new Uint32Array(_.length-y),this.values.set(_.subarray(0,C),0),this.values.set(_.subarray(C+y),C),this.prefixSum=new Uint32Array(this.values.length),C-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=C-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(k.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalValue(){return this.values.length===0?0:this._getAccumulatedValue(this.values.length-1)}getAccumulatedValue(C){return C<0?0:(C=g.toUint32(C),this._getAccumulatedValue(C))}_getAccumulatedValue(C){if(C<=this.prefixSumValidIndex[0])return this.prefixSum[C];let y=this.prefixSumValidIndex[0]+1;y===0&&(this.prefixSum[0]=this.values[0],y++),C>=this.values.length&&(C=this.values.length-1);for(let _=y;_<=C;_++)this.prefixSum[_]=this.prefixSum[_-1]+this.values[_];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],C),this.prefixSum[C]}getIndexOf(C){C=Math.floor(C),this.getTotalValue();let y=0,_=this.values.length-1,k=0,n=0,I=0;for(;y<=_;)if(k=y+(_-y)/2|0,n=this.prefixSum[k],I=n-this.values[k],C<I)_=k-1;else if(C>=n)y=k+1;else break;return new T(k,C-I)}}e.PrefixSumComputer=D}),define(we[119],_e([0,1,8,35,86]),function(Z,e,g,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class E{constructor(y,_,k,n){this._uri=y,this._lines=_,this._eol=k,this._versionId=n,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(y){y.eol&&y.eol!==this._eol&&(this._eol=y.eol,this._lineStarts=null);const _=y.changes;for(const k of _)this._acceptDeleteRange(k.range),this._acceptInsertText(new T.Position(k.range.startLineNumber,k.range.startColumn),k.text);this._versionId=y.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const y=this._eol.length,_=this._lines.length,k=new Uint32Array(_);for(let n=0;n<_;n++)k[n]=this._lines[n].length+y;this._lineStarts=new D.PrefixSumComputer(k)}}_setLineText(y,_){this._lines[y]=_,this._lineStarts&&this._lineStarts.changeValue(y,this._lines[y].length+this._eol.length)}_acceptDeleteRange(y){if(y.startLineNumber===y.endLineNumber){if(y.startColumn===y.endColumn)return;this._setLineText(y.startLineNumber-1,this._lines[y.startLineNumber-1].substring(0,y.startColumn-1)+this._lines[y.startLineNumber-1].substring(y.endColumn-1));return}this._setLineText(y.startLineNumber-1,this._lines[y.startLineNumber-1].substring(0,y.startColumn-1)+this._lines[y.endLineNumber-1].substring(y.endColumn-1)),this._lines.splice(y.startLineNumber,y.endLineNumber-y.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(y.startLineNumber,y.endLineNumber-y.startLineNumber)}_acceptInsertText(y,_){if(_.length===0)return;let k=g.splitLines(_);if(k.length===1){this._setLineText(y.lineNumber-1,this._lines[y.lineNumber-1].substring(0,y.column-1)+k[0]+this._lines[y.lineNumber-1].substring(y.column-1));return}k[k.length-1]+=this._lines[y.lineNumber-1].substring(y.column-1),this._setLineText(y.lineNumber-1,this._lines[y.lineNumber-1].substring(0,y.column-1)+k[0]);let n=new Uint32Array(k.length-1);for(let I=1;I<k.length;I++)this._lines.splice(y.lineNumber+I-1,0,k[I]),n[I-1]=k[I].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(y.lineNumber,n)}}e.MirrorTextModel=E}),define(we[120],_e([19,20]),function(Z,e){return Z.create("vs/base/common/errorMessage",e)}),define(we[56],_e([0,1,120,10,16]),function(Z,e,g,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function E(k,n){return n&&(k.stack||k.stacktrace)?g.localize(0,null,y(k),C(k.stack)||C(k.stacktrace)):y(k)}function C(k){return Array.isArray(k)?k.join(`
`):k}function y(k){return typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?g.localize(1,null,k.message):k.message||g.localize(2,null)}function _(k=null,n=!1){if(!k)return g.localize(3,null);if(Array.isArray(k)){const I=D.coalesce(k),o=_(I[0],n);return I.length>1?g.localize(4,null,o,I.length):o}if(T.isString(k))return k;if(k.detail){const I=k.detail;if(I.error)return E(I.error,n);if(I.exception)return E(I.exception,n)}return k.stack?E(k,n):k.message?k.message:g.localize(5,null)}e.toErrorMessage=_}),define(we[121],_e([19,20]),function(Z,e){return Z.create("vs/editor/common/config/editorOptions",e)}),define(we[122],_e([0,1,121,21,84]),function(Z,e,g,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var E;(function(j){j[j.None=0]="None",j[j.Keep=1]="Keep",j[j.Brackets=2]="Brackets",j[j.Advanced=3]="Advanced",j[j.Full=4]="Full"})(E=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class C{constructor(ee){this._values=ee}hasChanged(ee){return this._values[ee]}}e.ConfigurationChangedEvent=C;class y{constructor(){this._values=[]}_read(ee){return this._values[ee]}get(ee){return this._values[ee]}_write(ee,me){this._values[ee]=me}}e.ValidatedEditorOptions=y;class _{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=_;class k{constructor(ee,me,Fe,Le){this.id=ee,this.name=me,this.defaultValue=Fe,this.schema=Le}compute(ee,me,Fe){return Fe}}class n{constructor(ee,me=null){this.schema=void 0,this.id=ee,this.name="_never_",this.defaultValue=void 0,this.deps=me}validate(ee){return this.defaultValue}}class I{constructor(ee,me,Fe,Le){this.id=ee,this.name=me,this.defaultValue=Fe,this.schema=Le}validate(ee){return typeof ee=="undefined"?this.defaultValue:ee}compute(ee,me,Fe){return Fe}}function o(j,ee){return typeof j=="undefined"?ee:j==="false"?!1:Boolean(j)}e.boolean=o;class h extends I{constructor(ee,me,Fe,Le=void 0){typeof Le!="undefined"&&(Le.type="boolean",Le.default=Fe),super(ee,me,Fe,Le)}validate(ee){return o(ee,this.defaultValue)}}class d extends I{constructor(ee,me,Fe,Le,Ge,Ee=void 0){typeof Ee!="undefined"&&(Ee.type="integer",Ee.default=Fe,Ee.minimum=Le,Ee.maximum=Ge),super(ee,me,Fe,Ee),this.minimum=Le,this.maximum=Ge}static clampedInt(ee,me,Fe,Le){if(typeof ee=="undefined")return me;let Ge=parseInt(ee,10);return isNaN(Ge)?me:(Ge=Math.max(Fe,Ge),Ge=Math.min(Le,Ge),Ge|0)}validate(ee){return d.clampedInt(ee,this.defaultValue,this.minimum,this.maximum)}}class u extends I{constructor(ee,me,Fe,Le,Ge){typeof Ge!="undefined"&&(Ge.type="number",Ge.default=Fe),super(ee,me,Fe,Ge),this.validationFn=Le}static clamp(ee,me,Fe){return ee<me?me:ee>Fe?Fe:ee}static float(ee,me){if(typeof ee=="number")return ee;if(typeof ee=="undefined")return me;const Fe=parseFloat(ee);return isNaN(Fe)?me:Fe}validate(ee){return this.validationFn(u.float(ee,this.defaultValue))}}class w extends I{static string(ee,me){return typeof ee!="string"?me:ee}constructor(ee,me,Fe,Le=void 0){typeof Le!="undefined"&&(Le.type="string",Le.default=Fe),super(ee,me,Fe,Le)}validate(ee){return w.string(ee,this.defaultValue)}}function v(j,ee,me){return typeof j!="string"||me.indexOf(j)===-1?ee:j}e.stringSet=v;class S extends I{constructor(ee,me,Fe,Le,Ge=void 0){typeof Ge!="undefined"&&(Ge.type="string",Ge.enum=Le,Ge.default=Fe),super(ee,me,Fe,Ge),this._allowedValues=Le}validate(ee){return v(ee,this.defaultValue,this._allowedValues)}}class c extends k{constructor(ee,me,Fe,Le,Ge,Ee,be=void 0){typeof be!="undefined"&&(be.type="string",be.enum=Ge,be.default=Le),super(ee,me,Fe,be),this._allowedValues=Ge,this._convert=Ee}validate(ee){return typeof ee!="string"?this.defaultValue:this._allowedValues.indexOf(ee)===-1?this.defaultValue:this._convert(ee)}}function m(j){switch(j){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class f extends k{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[g.localize(0,null),g.localize(1,null),g.localize(2,null)],default:"auto",description:g.localize(3,null)})}validate(ee){switch(ee){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ee,me,Fe){return Fe===0?ee.accessibilitySupport:Fe}}class t extends k{constructor(){const ee={insertSpace:!0,ignoreEmptyLines:!0};super(17,"comments",ee,{"editor.comments.insertSpace":{type:"boolean",default:ee.insertSpace,description:g.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ee.ignoreEmptyLines,description:g.localize(5,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const me=ee;return{insertSpace:o(me.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:o(me.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var r;(function(j){j[j.Hidden=0]="Hidden",j[j.Blink=1]="Blink",j[j.Smooth=2]="Smooth",j[j.Phase=3]="Phase",j[j.Expand=4]="Expand",j[j.Solid=5]="Solid"})(r=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function i(j){switch(j){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var s;(function(j){j[j.Line=1]="Line",j[j.Block=2]="Block",j[j.Underline=3]="Underline",j[j.LineThin=4]="LineThin",j[j.BlockOutline=5]="BlockOutline",j[j.UnderlineThin=6]="UnderlineThin"})(s=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function l(j){switch(j){case s.Line:return"line";case s.Block:return"block";case s.Underline:return"underline";case s.LineThin:return"line-thin";case s.BlockOutline:return"block-outline";case s.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=l;function b(j){switch(j){case"line":return s.Line;case"block":return s.Block;case"underline":return s.Underline;case"line-thin":return s.LineThin;case"block-outline":return s.BlockOutline;case"underline-thin":return s.UnderlineThin}}class p extends n{constructor(){super(125,[63,31])}compute(ee,me,Fe){const Le=["monaco-editor"];return me.get(31)&&Le.push(me.get(31)),ee.extraEditorClassName&&Le.push(ee.extraEditorClassName),me.get(63)==="default"?Le.push("mouse-default"):me.get(63)==="copy"&&Le.push("mouse-copy"),me.get(98)&&Le.push("showUnused"),me.get(123)&&Le.push("showDeprecated"),Le.join(" ")}}class P extends h{constructor(){super(30,"emptySelectionClipboard",!0,{description:g.localize(6,null)})}compute(ee,me,Fe){return Fe&&ee.emptySelectionClipboard}}class A extends k{constructor(){const ee={cursorMoveOnType:!0,seedSearchStringFromSelection:!0,autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(33,"find",ee,{"editor.find.cursorMoveOnType":{type:"boolean",default:ee.cursorMoveOnType,description:g.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"boolean",default:ee.seedSearchStringFromSelection,description:g.localize(8,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ee.autoFindInSelection,enumDescriptions:[g.localize(9,null),g.localize(10,null),g.localize(11,null)],description:g.localize(12,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ee.globalFindClipboard,description:g.localize(13,null),included:T.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ee.addExtraSpaceOnTop,description:g.localize(14,null)},"editor.find.loop":{type:"boolean",default:ee.loop,description:g.localize(15,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const me=ee;return{cursorMoveOnType:o(me.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:o(me.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection),autoFindInSelection:typeof ee.autoFindInSelection=="boolean"?ee.autoFindInSelection?"always":"never":v(me.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:o(me.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:o(me.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:o(me.loop,this.defaultValue.loop)}}}class a extends k{constructor(){super(41,"fontLigatures",a.OFF,{anyOf:[{type:"boolean",description:g.localize(16,null)},{type:"string",description:g.localize(17,null)}],description:g.localize(18,null),default:!1})}validate(ee){return typeof ee=="undefined"?this.defaultValue:typeof ee=="string"?ee==="false"?a.OFF:ee==="true"?a.ON:ee:Boolean(ee)?a.ON:a.OFF}}e.EditorFontLigatures=a,a.OFF='"liga" off, "calt" off',a.ON='"liga" on, "calt" on';class F extends n{constructor(){super(40)}compute(ee,me,Fe){return ee.fontInfo}}class N extends I{constructor(){super(42,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:g.localize(19,null)})}validate(ee){let me=u.float(ee,this.defaultValue);return me===0?e.EDITOR_FONT_DEFAULTS.fontSize:u.clamp(me,6,100)}compute(ee,me,Fe){return ee.fontInfo.fontSize}}class H extends k{constructor(){super(43,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:H.MINIMUM_VALUE,maximum:H.MAXIMUM_VALUE,errorMessage:g.localize(20,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:H.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:g.localize(21,null)})}validate(ee){return ee==="normal"||ee==="bold"?ee:String(d.clampedInt(ee,e.EDITOR_FONT_DEFAULTS.fontWeight,H.MINIMUM_VALUE,H.MAXIMUM_VALUE))}}H.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],H.MINIMUM_VALUE=1,H.MAXIMUM_VALUE=1e3;class le extends k{constructor(){const ee={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},me={type:"string",enum:["peek","gotoAndPeek","goto"],default:ee.multiple,enumDescriptions:[g.localize(22,null),g.localize(23,null),g.localize(24,null)]},Fe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(47,"gotoLocation",ee,{"editor.gotoLocation.multiple":{deprecationMessage:g.localize(25,null)},"editor.gotoLocation.multipleDefinitions":Object.assign({description:g.localize(26,null)},me),"editor.gotoLocation.multipleTypeDefinitions":Object.assign({description:g.localize(27,null)},me),"editor.gotoLocation.multipleDeclarations":Object.assign({description:g.localize(28,null)},me),"editor.gotoLocation.multipleImplementations":Object.assign({description:g.localize(29,null)},me),"editor.gotoLocation.multipleReferences":Object.assign({description:g.localize(30,null)},me),"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ee.alternativeDefinitionCommand,enum:Fe,description:g.localize(31,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ee.alternativeTypeDefinitionCommand,enum:Fe,description:g.localize(32,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ee.alternativeDeclarationCommand,enum:Fe,description:g.localize(33,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ee.alternativeImplementationCommand,enum:Fe,description:g.localize(34,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ee.alternativeReferenceCommand,enum:Fe,description:g.localize(35,null)}})}validate(ee){var me,Fe,Le,Ge,Ee;if(!ee||typeof ee!="object")return this.defaultValue;const be=ee;return{multiple:v(be.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:(me=be.multipleDefinitions)!==null&&me!==void 0?me:v(be.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:(Fe=be.multipleTypeDefinitions)!==null&&Fe!==void 0?Fe:v(be.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:(Le=be.multipleDeclarations)!==null&&Le!==void 0?Le:v(be.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:(Ge=be.multipleImplementations)!==null&&Ge!==void 0?Ge:v(be.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:(Ee=be.multipleReferences)!==null&&Ee!==void 0?Ee:v(be.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:w.string(be.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:w.string(be.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:w.string(be.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:w.string(be.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:w.string(be.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class fe extends k{constructor(){const ee={enabled:!0,delay:300,sticky:!0};super(50,"hover",ee,{"editor.hover.enabled":{type:"boolean",default:ee.enabled,description:g.localize(36,null)},"editor.hover.delay":{type:"number",default:ee.delay,description:g.localize(37,null)},"editor.hover.sticky":{type:"boolean",default:ee.sticky,description:g.localize(38,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const me=ee;return{enabled:o(me.enabled,this.defaultValue.enabled),delay:d.clampedInt(me.delay,this.defaultValue.delay,0,1e4),sticky:o(me.sticky,this.defaultValue.sticky)}}}var X;(function(j){j[j.None=0]="None",j[j.Text=1]="Text",j[j.Blocks=2]="Blocks"})(X=e.RenderMinimap||(e.RenderMinimap={}));class z extends n{constructor(){super(128,[46,55,35,62,90,57,58,92,115,118,119,120,2])}compute(ee,me,Fe){return z.computeLayout(me,{memory:ee.memory,outerWidth:ee.outerWidth,outerHeight:ee.outerHeight,isDominatedByLongLines:ee.isDominatedByLongLines,lineHeight:ee.fontInfo.lineHeight,viewLineCount:ee.viewLineCount,lineNumbersDigitCount:ee.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ee.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ee.fontInfo.maxDigitWidth,pixelRatio:ee.pixelRatio})}static computeContainedMinimapLineCount(ee){const me=ee.height/ee.lineHeight,Fe=ee.scrollBeyondLastLine?me-1:0,Le=(ee.viewLineCount+Fe)/(ee.pixelRatio*ee.height),Ge=Math.floor(ee.viewLineCount/Le);return{typicalViewportLineCount:me,extraLinesBeyondLastLine:Fe,desiredRatio:Le,minimapLineCount:Ge}}static _computeMinimapLayout(ee,me){const Fe=ee.outerWidth,Le=ee.outerHeight,Ge=ee.pixelRatio;if(!ee.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ge*Le),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Le};const Ee=me.stableMinimapLayoutInput,be=Ee&&ee.outerHeight===Ee.outerHeight&&ee.lineHeight===Ee.lineHeight&&ee.typicalHalfwidthCharacterWidth===Ee.typicalHalfwidthCharacterWidth&&ee.pixelRatio===Ee.pixelRatio&&ee.scrollBeyondLastLine===Ee.scrollBeyondLastLine&&ee.minimap.enabled===Ee.minimap.enabled&&ee.minimap.side===Ee.minimap.side&&ee.minimap.size===Ee.minimap.size&&ee.minimap.showSlider===Ee.minimap.showSlider&&ee.minimap.renderCharacters===Ee.minimap.renderCharacters&&ee.minimap.maxColumn===Ee.minimap.maxColumn&&ee.minimap.scale===Ee.minimap.scale&&ee.verticalScrollbarWidth===Ee.verticalScrollbarWidth&&ee.isViewportWrapping===Ee.isViewportWrapping,De=ee.lineHeight,ie=ee.typicalHalfwidthCharacterWidth,de=ee.scrollBeyondLastLine,O=ee.minimap.renderCharacters;let G=Ge>=2?Math.round(ee.minimap.scale*2):ee.minimap.scale;const ae=ee.minimap.maxColumn,Ce=ee.minimap.size,Ie=ee.minimap.side,Oe=ee.verticalScrollbarWidth,Ue=ee.viewLineCount,qe=ee.remainingWidth,rt=ee.isViewportWrapping,nt=O?2:3;let Ze=Math.floor(Ge*Le);const ot=Ze/Ge;let ve=!1,ye=!1,ue=nt*G,$=G/Ge,Ne=1;if(Ce==="fill"||Ce==="fit"){const{typicalViewportLineCount:mt,extraLinesBeyondLastLine:yt,desiredRatio:vt,minimapLineCount:wt}=z.computeContainedMinimapLineCount({viewLineCount:Ue,scrollBeyondLastLine:de,height:Le,lineHeight:De,pixelRatio:Ge});if(Ue/wt>1)ve=!0,ye=!0,G=1,ue=1,$=G/Ge;else{let ht=!1,kt=G+1;if(Ce==="fit"){const Et=Math.ceil((Ue+yt)*ue);rt&&be&&qe<=me.stableFitRemainingWidth?(ht=!0,kt=me.stableFitMaxMinimapScale):(ht=Et>Ze,rt&&ht?(me.stableMinimapLayoutInput=ee,me.stableFitRemainingWidth=qe):(me.stableMinimapLayoutInput=null,me.stableFitRemainingWidth=0))}if(Ce==="fill"||ht){ve=!0;const Et=G;ue=Math.min(De*Ge,Math.max(1,Math.floor(1/vt))),G=Math.min(kt,Math.max(1,Math.floor(ue/nt))),G>Et&&(Ne=Math.min(2,G/Et)),$=G/Ge/Ne,Ze=Math.ceil(Math.max(mt,Ue+yt)*ue),rt&&ht&&(me.stableFitMaxMinimapScale=G)}}}const Pe=Math.floor(ae*$),Ve=Math.min(Pe,Math.max(0,Math.floor((qe-Oe-2)*$/(ie+$)))+e.MINIMAP_GUTTER_WIDTH);let Xe=Math.floor(Ge*Ve);const lt=Xe/Ge;Xe=Math.floor(Xe*Ne);const ut=O?1:2,it=Ie==="left"?0:Fe-Ve-Oe;return{renderMinimap:ut,minimapLeft:it,minimapWidth:Ve,minimapHeightIsEditorHeight:ve,minimapIsSampling:ye,minimapScale:G,minimapLineHeight:ue,minimapCanvasInnerWidth:Xe,minimapCanvasInnerHeight:Ze,minimapCanvasOuterWidth:lt,minimapCanvasOuterHeight:ot}}static computeLayout(ee,me){const Fe=me.outerWidth|0,Le=me.outerHeight|0,Ge=me.lineHeight|0,Ee=me.lineNumbersDigitCount|0,be=me.typicalHalfwidthCharacterWidth,De=me.maxDigitWidth,ie=me.pixelRatio,de=me.viewLineCount,O=ee.get(120),G=O==="inherit"?ee.get(119):O,ae=G==="inherit"?ee.get(115):G,Ce=ee.get(118),Ie=ee.get(2),Oe=me.isDominatedByLongLines,Ue=ee.get(46),qe=ee.get(57).renderType!==0,rt=ee.get(58),nt=ee.get(92),Ze=ee.get(62),ot=ee.get(90),ve=ot.verticalScrollbarSize,ye=ot.verticalHasArrows,ue=ot.arrowSize,$=ot.horizontalScrollbarSize,Ne=ee.get(55),Pe=ee.get(35);let Ve;if(typeof Ne=="string"&&/^\d+(\.\d+)?ch$/.test(Ne)){const _t=parseFloat(Ne.substr(0,Ne.length-2));Ve=d.clampedInt(_t*be,0,0,1e3)}else Ve=d.clampedInt(Ne,0,0,1e3);Pe&&(Ve+=16);let Xe=0;if(qe){const _t=Math.max(Ee,rt);Xe=Math.round(_t*De)}let lt=0;Ue&&(lt=Ge);let ut=0,it=ut+lt,mt=it+Xe,yt=mt+Ve;const vt=Fe-lt-Xe-Ve;let wt=!1,gt=!1,ht=-1;Ie!==2&&(G==="inherit"&&Oe?(wt=!0,gt=!0):ae==="on"||ae==="bounded"?gt=!0:ae==="wordWrapColumn"&&(ht=Ce));const kt=z._computeMinimapLayout({outerWidth:Fe,outerHeight:Le,lineHeight:Ge,typicalHalfwidthCharacterWidth:be,pixelRatio:ie,scrollBeyondLastLine:nt,minimap:Ze,verticalScrollbarWidth:ve,viewLineCount:de,remainingWidth:vt,isViewportWrapping:gt},me.memory||new _);kt.renderMinimap!==0&&kt.minimapLeft===0&&(ut+=kt.minimapWidth,it+=kt.minimapWidth,mt+=kt.minimapWidth,yt+=kt.minimapWidth);const Et=vt-kt.minimapWidth,Pt=Math.max(1,Math.floor((Et-ve-2)/be)),Ft=ye?ue:0;return gt&&(ht=Math.max(1,Pt),ae==="bounded"&&(ht=Math.min(ht,Ce))),{width:Fe,height:Le,glyphMarginLeft:ut,glyphMarginWidth:lt,lineNumbersLeft:it,lineNumbersWidth:Xe,decorationsLeft:mt,decorationsWidth:Ve,contentLeft:yt,contentWidth:Et,minimap:kt,viewportColumn:Pt,isWordWrapMinified:wt,isViewportWrapping:gt,wrappingColumn:ht,verticalScrollbarWidth:ve,horizontalScrollbarHeight:$,overviewRuler:{top:Ft,width:ve,height:Le-2*Ft,right:0}}}}e.EditorLayoutInfoComputer=z;class Y extends k{constructor(){const ee={enabled:!0};super(54,"lightbulb",ee,{"editor.lightbulb.enabled":{type:"boolean",default:ee.enabled,description:g.localize(39,null)}})}validate(ee){return!ee||typeof ee!="object"?this.defaultValue:{enabled:o(ee.enabled,this.defaultValue.enabled)}}}class R extends k{constructor(){const ee={enabled:!0,fontSize:0,fontFamily:e.EDITOR_FONT_DEFAULTS.fontFamily};super(124,"inlayHints",ee,{"editor.inlayHints.enabled":{type:"boolean",default:ee.enabled,description:g.localize(40,null)},"editor.inlayHints.fontSize":{type:"number",default:ee.fontSize,description:g.localize(41,null)},"editor.inlayHints.fontFamily":{type:"string",default:ee.fontFamily,description:g.localize(42,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const me=ee;return{enabled:o(me.enabled,this.defaultValue.enabled),fontSize:d.clampedInt(me.fontSize,this.defaultValue.fontSize,0,100),fontFamily:w.string(me.fontFamily,this.defaultValue.fontFamily)}}}class B extends d{constructor(){super(56,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,0,150,{description:g.localize(43,null)})}compute(ee,me,Fe){return ee.fontInfo.lineHeight}}class M extends k{constructor(){const ee={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(62,"minimap",ee,{"editor.minimap.enabled":{type:"boolean",default:ee.enabled,description:g.localize(44,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[g.localize(45,null),g.localize(46,null),g.localize(47,null)],default:ee.size,description:g.localize(48,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ee.side,description:g.localize(49,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ee.showSlider,description:g.localize(50,null)},"editor.minimap.scale":{type:"number",default:ee.scale,minimum:1,maximum:3,enum:[1,2,3],description:g.localize(51,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ee.renderCharacters,description:g.localize(52,null)},"editor.minimap.maxColumn":{type:"number",default:ee.maxColumn,description:g.localize(53,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const me=ee;return{enabled:o(me.enabled,this.defaultValue.enabled),size:v(me.size,this.defaultValue.size,["proportional","fill","fit"]),side:v(me.side,this.defaultValue.side,["right","left"]),showSlider:v(me.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:o(me.renderCharacters,this.defaultValue.renderCharacters),scale:d.clampedInt(me.scale,1,1,3),maxColumn:d.clampedInt(me.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function U(j){return j==="ctrlCmd"?T.isMacintosh?"metaKey":"ctrlKey":"altKey"}class q extends k{constructor(){super(72,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:g.localize(54,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:g.localize(55,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const me=ee;return{top:d.clampedInt(me.top,0,0,1e3),bottom:d.clampedInt(me.bottom,0,0,1e3)}}}class V extends k{constructor(){const ee={enabled:!0,cycle:!1};super(73,"parameterHints",ee,{"editor.parameterHints.enabled":{type:"boolean",default:ee.enabled,description:g.localize(56,null)},"editor.parameterHints.cycle":{type:"boolean",default:ee.cycle,description:g.localize(57,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const me=ee;return{enabled:o(me.enabled,this.defaultValue.enabled),cycle:o(me.cycle,this.defaultValue.cycle)}}}class oe extends n{constructor(){super(126)}compute(ee,me,Fe){return ee.pixelRatio}}class ge extends k{constructor(){const ee={other:!0,comments:!1,strings:!1};super(76,"quickSuggestions",ee,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:ee.strings,description:g.localize(58,null)},comments:{type:"boolean",default:ee.comments,description:g.localize(59,null)},other:{type:"boolean",default:ee.other,description:g.localize(60,null)}}}],default:ee,description:g.localize(61,null)});this.defaultValue=ee}validate(ee){if(typeof ee=="boolean")return ee;if(ee&&typeof ee=="object"){const me=ee,Fe={other:o(me.other,this.defaultValue.other),comments:o(me.comments,this.defaultValue.comments),strings:o(me.strings,this.defaultValue.strings)};return Fe.other&&Fe.comments&&Fe.strings?!0:!Fe.other&&!Fe.comments&&!Fe.strings?!1:Fe}return this.defaultValue}}var Re;(function(j){j[j.Off=0]="Off",j[j.On=1]="On",j[j.Relative=2]="Relative",j[j.Interval=3]="Interval",j[j.Custom=4]="Custom"})(Re=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class $e extends k{constructor(){super(57,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[g.localize(62,null),g.localize(63,null),g.localize(64,null),g.localize(65,null)],default:"on",description:g.localize(66,null)})}validate(ee){let me=this.defaultValue.renderType,Fe=this.defaultValue.renderFn;return typeof ee!="undefined"&&(typeof ee=="function"?(me=4,Fe=ee):ee==="interval"?me=3:ee==="relative"?me=2:ee==="on"?me=1:me=0),{renderType:me,renderFn:Fe}}}function Me(j){const ee=j.get(85);return ee==="editable"?j.get(78):ee!=="on"}e.filterValidationDecorations=Me;class We extends k{constructor(){const ee=[],me={type:"number",description:g.localize(67,null)};super(89,"rulers",ee,{type:"array",items:{anyOf:[me,{type:["object"],properties:{column:me,color:{type:"string",description:g.localize(68,null),format:"color-hex"}}}]},default:ee,description:g.localize(69,null)})}validate(ee){if(Array.isArray(ee)){let me=[];for(let Fe of ee)if(typeof Fe=="number")me.push({column:d.clampedInt(Fe,0,0,1e4),color:null});else if(Fe&&typeof Fe=="object"){const Le=Fe;me.push({column:d.clampedInt(Le.column,0,0,1e4),color:Le.color})}return me.sort((Fe,Le)=>Fe.column-Le.column),me}return this.defaultValue}}function Je(j,ee){if(typeof j!="string")return ee;switch(j){case"hidden":return 2;case"visible":return 3;default:return 1}}class Qe extends k{constructor(){super(90,"scrollbar",{vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const me=ee,Fe=d.clampedInt(me.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Le=d.clampedInt(me.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:d.clampedInt(me.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Je(me.vertical,this.defaultValue.vertical),horizontal:Je(me.horizontal,this.defaultValue.horizontal),useShadows:o(me.useShadows,this.defaultValue.useShadows),verticalHasArrows:o(me.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:o(me.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:o(me.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:o(me.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Fe,horizontalSliderSize:d.clampedInt(me.horizontalSliderSize,Fe,0,1e3),verticalScrollbarSize:Le,verticalSliderSize:d.clampedInt(me.verticalSliderSize,Le,0,1e3),scrollByPage:o(me.scrollByPage,this.defaultValue.scrollByPage)}}}class Ye extends k{constructor(){const ee={enabled:!1};super(52,"inlineSuggest",ee,{"editor.inlineSuggest.enabled":{type:"boolean",default:ee.enabled,description:g.localize(70,null)}})}validate(ee){return!ee||typeof ee!="object"?this.defaultValue:{enabled:o(ee.enabled,this.defaultValue.enabled)}}}class W extends k{constructor(){const ee={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(104,"suggest",ee,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[g.localize(71,null),g.localize(72,null)],default:ee.insertMode,description:g.localize(73,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ee.filterGraceful,description:g.localize(74,null)},"editor.suggest.localityBonus":{type:"boolean",default:ee.localityBonus,description:g.localize(75,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ee.shareSuggestSelections,markdownDescription:g.localize(76,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ee.snippetsPreventQuickSuggestions,description:g.localize(77,null)},"editor.suggest.showIcons":{type:"boolean",default:ee.showIcons,description:g.localize(78,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ee.showStatusBar,description:g.localize(79,null)},"editor.suggest.preview":{type:"boolean",default:ee.preview,description:g.localize(80,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ee.showInlineDetails,description:g.localize(81,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:g.localize(82,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:g.localize(83,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:g.localize(84,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:g.localize(85,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:g.localize(86,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:g.localize(87,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:g.localize(88,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:g.localize(89,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:g.localize(90,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:g.localize(91,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:g.localize(92,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:g.localize(93,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:g.localize(94,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:g.localize(95,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:g.localize(96,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:g.localize(97,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:g.localize(98,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:g.localize(99,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:g.localize(100,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:g.localize(101,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:g.localize(102,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:g.localize(103,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:g.localize(104,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:g.localize(105,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:g.localize(106,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:g.localize(107,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:g.localize(108,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:g.localize(109,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:g.localize(110,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:g.localize(111,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:g.localize(112,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const me=ee;return{insertMode:v(me.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:o(me.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:o(me.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:o(me.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:o(me.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:o(me.showIcons,this.defaultValue.showIcons),showStatusBar:o(me.showStatusBar,this.defaultValue.showStatusBar),preview:o(me.preview,this.defaultValue.preview),showInlineDetails:o(me.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:o(me.showMethods,this.defaultValue.showMethods),showFunctions:o(me.showFunctions,this.defaultValue.showFunctions),showConstructors:o(me.showConstructors,this.defaultValue.showConstructors),showDeprecated:o(me.showDeprecated,this.defaultValue.showDeprecated),showFields:o(me.showFields,this.defaultValue.showFields),showVariables:o(me.showVariables,this.defaultValue.showVariables),showClasses:o(me.showClasses,this.defaultValue.showClasses),showStructs:o(me.showStructs,this.defaultValue.showStructs),showInterfaces:o(me.showInterfaces,this.defaultValue.showInterfaces),showModules:o(me.showModules,this.defaultValue.showModules),showProperties:o(me.showProperties,this.defaultValue.showProperties),showEvents:o(me.showEvents,this.defaultValue.showEvents),showOperators:o(me.showOperators,this.defaultValue.showOperators),showUnits:o(me.showUnits,this.defaultValue.showUnits),showValues:o(me.showValues,this.defaultValue.showValues),showConstants:o(me.showConstants,this.defaultValue.showConstants),showEnums:o(me.showEnums,this.defaultValue.showEnums),showEnumMembers:o(me.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:o(me.showKeywords,this.defaultValue.showKeywords),showWords:o(me.showWords,this.defaultValue.showWords),showColors:o(me.showColors,this.defaultValue.showColors),showFiles:o(me.showFiles,this.defaultValue.showFiles),showReferences:o(me.showReferences,this.defaultValue.showReferences),showFolders:o(me.showFolders,this.defaultValue.showFolders),showTypeParameters:o(me.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:o(me.showSnippets,this.defaultValue.showSnippets),showUsers:o(me.showUsers,this.defaultValue.showUsers),showIssues:o(me.showIssues,this.defaultValue.showIssues)}}}class Q extends k{constructor(){super(100,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:g.localize(113,null),default:!0,type:"boolean"}})}validate(ee){return!ee||typeof ee!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:o(ee.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class te extends n{constructor(){super(127,[78])}compute(ee,me,Fe){return me.get(78)?!0:ee.tabFocusMode}}var re;(function(j){j[j.None=0]="None",j[j.Same=1]="Same",j[j.Indent=2]="Indent",j[j.DeepIndent=3]="DeepIndent"})(re=e.WrappingIndent||(e.WrappingIndent={}));function K(j){switch(j){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class se extends n{constructor(){super(129,[128])}compute(ee,me,Fe){const Le=me.get(128);return{isDominatedByLongLines:ee.isDominatedByLongLines,isWordWrapMinified:Le.isWordWrapMinified,isViewportWrapping:Le.isViewportWrapping,wrappingColumn:Le.wrappingColumn}}}const he="Consolas, 'Courier New', monospace",Ae="Menlo, Monaco, 'Courier New', monospace",Be="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:T.isMacintosh?Ae:T.isLinux?Be:he,fontWeight:"normal",fontSize:T.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0},e.editorOptionsRegistry=[];function pe(j){return e.editorOptionsRegistry[j.id]=j,j}var Ke;(function(j){j[j.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",j[j.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",j[j.accessibilitySupport=2]="accessibilitySupport",j[j.accessibilityPageSize=3]="accessibilityPageSize",j[j.ariaLabel=4]="ariaLabel",j[j.autoClosingBrackets=5]="autoClosingBrackets",j[j.autoClosingDelete=6]="autoClosingDelete",j[j.autoClosingOvertype=7]="autoClosingOvertype",j[j.autoClosingQuotes=8]="autoClosingQuotes",j[j.autoIndent=9]="autoIndent",j[j.automaticLayout=10]="automaticLayout",j[j.autoSurround=11]="autoSurround",j[j.codeLens=12]="codeLens",j[j.codeLensFontFamily=13]="codeLensFontFamily",j[j.codeLensFontSize=14]="codeLensFontSize",j[j.colorDecorators=15]="colorDecorators",j[j.columnSelection=16]="columnSelection",j[j.comments=17]="comments",j[j.contextmenu=18]="contextmenu",j[j.copyWithSyntaxHighlighting=19]="copyWithSyntaxHighlighting",j[j.cursorBlinking=20]="cursorBlinking",j[j.cursorSmoothCaretAnimation=21]="cursorSmoothCaretAnimation",j[j.cursorStyle=22]="cursorStyle",j[j.cursorSurroundingLines=23]="cursorSurroundingLines",j[j.cursorSurroundingLinesStyle=24]="cursorSurroundingLinesStyle",j[j.cursorWidth=25]="cursorWidth",j[j.disableLayerHinting=26]="disableLayerHinting",j[j.disableMonospaceOptimizations=27]="disableMonospaceOptimizations",j[j.domReadOnly=28]="domReadOnly",j[j.dragAndDrop=29]="dragAndDrop",j[j.emptySelectionClipboard=30]="emptySelectionClipboard",j[j.extraEditorClassName=31]="extraEditorClassName",j[j.fastScrollSensitivity=32]="fastScrollSensitivity",j[j.find=33]="find",j[j.fixedOverflowWidgets=34]="fixedOverflowWidgets",j[j.folding=35]="folding",j[j.foldingStrategy=36]="foldingStrategy",j[j.foldingHighlight=37]="foldingHighlight",j[j.unfoldOnClickAfterEndOfLine=38]="unfoldOnClickAfterEndOfLine",j[j.fontFamily=39]="fontFamily",j[j.fontInfo=40]="fontInfo",j[j.fontLigatures=41]="fontLigatures",j[j.fontSize=42]="fontSize",j[j.fontWeight=43]="fontWeight",j[j.formatOnPaste=44]="formatOnPaste",j[j.formatOnType=45]="formatOnType",j[j.glyphMargin=46]="glyphMargin",j[j.gotoLocation=47]="gotoLocation",j[j.hideCursorInOverviewRuler=48]="hideCursorInOverviewRuler",j[j.highlightActiveIndentGuide=49]="highlightActiveIndentGuide",j[j.hover=50]="hover",j[j.inDiffEditor=51]="inDiffEditor",j[j.inlineSuggest=52]="inlineSuggest",j[j.letterSpacing=53]="letterSpacing",j[j.lightbulb=54]="lightbulb",j[j.lineDecorationsWidth=55]="lineDecorationsWidth",j[j.lineHeight=56]="lineHeight",j[j.lineNumbers=57]="lineNumbers",j[j.lineNumbersMinChars=58]="lineNumbersMinChars",j[j.linkedEditing=59]="linkedEditing",j[j.links=60]="links",j[j.matchBrackets=61]="matchBrackets",j[j.minimap=62]="minimap",j[j.mouseStyle=63]="mouseStyle",j[j.mouseWheelScrollSensitivity=64]="mouseWheelScrollSensitivity",j[j.mouseWheelZoom=65]="mouseWheelZoom",j[j.multiCursorMergeOverlapping=66]="multiCursorMergeOverlapping",j[j.multiCursorModifier=67]="multiCursorModifier",j[j.multiCursorPaste=68]="multiCursorPaste",j[j.occurrencesHighlight=69]="occurrencesHighlight",j[j.overviewRulerBorder=70]="overviewRulerBorder",j[j.overviewRulerLanes=71]="overviewRulerLanes",j[j.padding=72]="padding",j[j.parameterHints=73]="parameterHints",j[j.peekWidgetDefaultFocus=74]="peekWidgetDefaultFocus",j[j.definitionLinkOpensInPeek=75]="definitionLinkOpensInPeek",j[j.quickSuggestions=76]="quickSuggestions",j[j.quickSuggestionsDelay=77]="quickSuggestionsDelay",j[j.readOnly=78]="readOnly",j[j.renameOnType=79]="renameOnType",j[j.renderControlCharacters=80]="renderControlCharacters",j[j.renderIndentGuides=81]="renderIndentGuides",j[j.renderFinalNewline=82]="renderFinalNewline",j[j.renderLineHighlight=83]="renderLineHighlight",j[j.renderLineHighlightOnlyWhenFocus=84]="renderLineHighlightOnlyWhenFocus",j[j.renderValidationDecorations=85]="renderValidationDecorations",j[j.renderWhitespace=86]="renderWhitespace",j[j.revealHorizontalRightPadding=87]="revealHorizontalRightPadding",j[j.roundedSelection=88]="roundedSelection",j[j.rulers=89]="rulers",j[j.scrollbar=90]="scrollbar",j[j.scrollBeyondLastColumn=91]="scrollBeyondLastColumn",j[j.scrollBeyondLastLine=92]="scrollBeyondLastLine",j[j.scrollPredominantAxis=93]="scrollPredominantAxis",j[j.selectionClipboard=94]="selectionClipboard",j[j.selectionHighlight=95]="selectionHighlight",j[j.selectOnLineNumbers=96]="selectOnLineNumbers",j[j.showFoldingControls=97]="showFoldingControls",j[j.showUnused=98]="showUnused",j[j.snippetSuggestions=99]="snippetSuggestions",j[j.smartSelect=100]="smartSelect",j[j.smoothScrolling=101]="smoothScrolling",j[j.stickyTabStops=102]="stickyTabStops",j[j.stopRenderingLineAfter=103]="stopRenderingLineAfter",j[j.suggest=104]="suggest",j[j.suggestFontSize=105]="suggestFontSize",j[j.suggestLineHeight=106]="suggestLineHeight",j[j.suggestOnTriggerCharacters=107]="suggestOnTriggerCharacters",j[j.suggestSelection=108]="suggestSelection",j[j.tabCompletion=109]="tabCompletion",j[j.tabIndex=110]="tabIndex",j[j.unusualLineTerminators=111]="unusualLineTerminators",j[j.useShadowDOM=112]="useShadowDOM",j[j.useTabStops=113]="useTabStops",j[j.wordSeparators=114]="wordSeparators",j[j.wordWrap=115]="wordWrap",j[j.wordWrapBreakAfterCharacters=116]="wordWrapBreakAfterCharacters",j[j.wordWrapBreakBeforeCharacters=117]="wordWrapBreakBeforeCharacters",j[j.wordWrapColumn=118]="wordWrapColumn",j[j.wordWrapOverride1=119]="wordWrapOverride1",j[j.wordWrapOverride2=120]="wordWrapOverride2",j[j.wrappingIndent=121]="wrappingIndent",j[j.wrappingStrategy=122]="wrappingStrategy",j[j.showDeprecated=123]="showDeprecated",j[j.inlayHints=124]="inlayHints",j[j.editorClassName=125]="editorClassName",j[j.pixelRatio=126]="pixelRatio",j[j.tabFocusMode=127]="tabFocusMode",j[j.layoutInfo=128]="layoutInfo",j[j.wrappingInfo=129]="wrappingInfo"})(Ke=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:pe(new h(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:g.localize(114,null)})),acceptSuggestionOnEnter:pe(new S(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",g.localize(115,null),""],markdownDescription:g.localize(116,null)})),accessibilitySupport:pe(new f),accessibilityPageSize:pe(new d(3,"accessibilityPageSize",10,1,1073741824,{description:g.localize(117,null)})),ariaLabel:pe(new w(4,"ariaLabel",g.localize(118,null))),autoClosingBrackets:pe(new S(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",g.localize(119,null),g.localize(120,null),""],description:g.localize(121,null)})),autoClosingDelete:pe(new S(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",g.localize(122,null),""],description:g.localize(123,null)})),autoClosingOvertype:pe(new S(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",g.localize(124,null),""],description:g.localize(125,null)})),autoClosingQuotes:pe(new S(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",g.localize(126,null),g.localize(127,null),""],description:g.localize(128,null)})),autoIndent:pe(new c(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],m,{enumDescriptions:[g.localize(129,null),g.localize(130,null),g.localize(131,null),g.localize(132,null),g.localize(133,null)],description:g.localize(134,null)})),automaticLayout:pe(new h(10,"automaticLayout",!1)),autoSurround:pe(new S(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[g.localize(135,null),g.localize(136,null),g.localize(137,null),""],description:g.localize(138,null)})),stickyTabStops:pe(new h(102,"stickyTabStops",!1,{description:g.localize(139,null)})),codeLens:pe(new h(12,"codeLens",!0,{description:g.localize(140,null)})),codeLensFontFamily:pe(new w(13,"codeLensFontFamily","",{description:g.localize(141,null)})),codeLensFontSize:pe(new d(14,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,description:g.localize(142,null)})),colorDecorators:pe(new h(15,"colorDecorators",!0,{description:g.localize(143,null)})),columnSelection:pe(new h(16,"columnSelection",!1,{description:g.localize(144,null)})),comments:pe(new t),contextmenu:pe(new h(18,"contextmenu",!0)),copyWithSyntaxHighlighting:pe(new h(19,"copyWithSyntaxHighlighting",!0,{description:g.localize(145,null)})),cursorBlinking:pe(new c(20,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],i,{description:g.localize(146,null)})),cursorSmoothCaretAnimation:pe(new h(21,"cursorSmoothCaretAnimation",!1,{description:g.localize(147,null)})),cursorStyle:pe(new c(22,"cursorStyle",s.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],b,{description:g.localize(148,null)})),cursorSurroundingLines:pe(new d(23,"cursorSurroundingLines",0,0,1073741824,{description:g.localize(149,null)})),cursorSurroundingLinesStyle:pe(new S(24,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[g.localize(150,null),g.localize(151,null)],description:g.localize(152,null)})),cursorWidth:pe(new d(25,"cursorWidth",0,0,1073741824,{markdownDescription:g.localize(153,null)})),disableLayerHinting:pe(new h(26,"disableLayerHinting",!1)),disableMonospaceOptimizations:pe(new h(27,"disableMonospaceOptimizations",!1)),domReadOnly:pe(new h(28,"domReadOnly",!1)),dragAndDrop:pe(new h(29,"dragAndDrop",!0,{description:g.localize(154,null)})),emptySelectionClipboard:pe(new P),extraEditorClassName:pe(new w(31,"extraEditorClassName","")),fastScrollSensitivity:pe(new u(32,"fastScrollSensitivity",5,j=>j<=0?5:j,{markdownDescription:g.localize(155,null)})),find:pe(new A),fixedOverflowWidgets:pe(new h(34,"fixedOverflowWidgets",!1)),folding:pe(new h(35,"folding",!0,{description:g.localize(156,null)})),foldingStrategy:pe(new S(36,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[g.localize(157,null),g.localize(158,null)],description:g.localize(159,null)})),foldingHighlight:pe(new h(37,"foldingHighlight",!0,{description:g.localize(160,null)})),unfoldOnClickAfterEndOfLine:pe(new h(38,"unfoldOnClickAfterEndOfLine",!1,{description:g.localize(161,null)})),fontFamily:pe(new w(39,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:g.localize(162,null)})),fontInfo:pe(new F),fontLigatures2:pe(new a),fontSize:pe(new N),fontWeight:pe(new H),formatOnPaste:pe(new h(44,"formatOnPaste",!1,{description:g.localize(163,null)})),formatOnType:pe(new h(45,"formatOnType",!1,{description:g.localize(164,null)})),glyphMargin:pe(new h(46,"glyphMargin",!0,{description:g.localize(165,null)})),gotoLocation:pe(new le),hideCursorInOverviewRuler:pe(new h(48,"hideCursorInOverviewRuler",!1,{description:g.localize(166,null)})),highlightActiveIndentGuide:pe(new h(49,"highlightActiveIndentGuide",!0,{description:g.localize(167,null)})),hover:pe(new fe),inDiffEditor:pe(new h(51,"inDiffEditor",!1)),letterSpacing:pe(new u(53,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,j=>u.clamp(j,-5,20),{description:g.localize(168,null)})),lightbulb:pe(new Y),lineDecorationsWidth:pe(new I(55,"lineDecorationsWidth",10)),lineHeight:pe(new B),lineNumbers:pe(new $e),lineNumbersMinChars:pe(new d(58,"lineNumbersMinChars",5,1,300)),linkedEditing:pe(new h(59,"linkedEditing",!1,{description:g.localize(169,null)})),links:pe(new h(60,"links",!0,{description:g.localize(170,null)})),matchBrackets:pe(new S(61,"matchBrackets","always",["always","near","never"],{description:g.localize(171,null)})),minimap:pe(new M),mouseStyle:pe(new S(63,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:pe(new u(64,"mouseWheelScrollSensitivity",1,j=>j===0?1:j,{markdownDescription:g.localize(172,null)})),mouseWheelZoom:pe(new h(65,"mouseWheelZoom",!1,{markdownDescription:g.localize(173,null)})),multiCursorMergeOverlapping:pe(new h(66,"multiCursorMergeOverlapping",!0,{description:g.localize(174,null)})),multiCursorModifier:pe(new c(67,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],U,{markdownEnumDescriptions:[g.localize(175,null),g.localize(176,null)],markdownDescription:g.localize(177,null)})),multiCursorPaste:pe(new S(68,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[g.localize(178,null),g.localize(179,null)],markdownDescription:g.localize(180,null)})),occurrencesHighlight:pe(new h(69,"occurrencesHighlight",!0,{description:g.localize(181,null)})),overviewRulerBorder:pe(new h(70,"overviewRulerBorder",!0,{description:g.localize(182,null)})),overviewRulerLanes:pe(new d(71,"overviewRulerLanes",3,0,3)),padding:pe(new q),parameterHints:pe(new V),peekWidgetDefaultFocus:pe(new S(74,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[g.localize(183,null),g.localize(184,null)],description:g.localize(185,null)})),definitionLinkOpensInPeek:pe(new h(75,"definitionLinkOpensInPeek",!1,{description:g.localize(186,null)})),quickSuggestions:pe(new ge),quickSuggestionsDelay:pe(new d(77,"quickSuggestionsDelay",10,0,1073741824,{description:g.localize(187,null)})),readOnly:pe(new h(78,"readOnly",!1)),renameOnType:pe(new h(79,"renameOnType",!1,{description:g.localize(188,null),markdownDeprecationMessage:g.localize(189,null)})),renderControlCharacters:pe(new h(80,"renderControlCharacters",!1,{description:g.localize(190,null)})),renderIndentGuides:pe(new h(81,"renderIndentGuides",!0,{description:g.localize(191,null)})),renderFinalNewline:pe(new h(82,"renderFinalNewline",!0,{description:g.localize(192,null)})),renderLineHighlight:pe(new S(83,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",g.localize(193,null)],description:g.localize(194,null)})),renderLineHighlightOnlyWhenFocus:pe(new h(84,"renderLineHighlightOnlyWhenFocus",!1,{description:g.localize(195,null)})),renderValidationDecorations:pe(new S(85,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:pe(new S(86,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",g.localize(196,null),g.localize(197,null),g.localize(198,null),""],description:g.localize(199,null)})),revealHorizontalRightPadding:pe(new d(87,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:pe(new h(88,"roundedSelection",!0,{description:g.localize(200,null)})),rulers:pe(new We),scrollbar:pe(new Qe),scrollBeyondLastColumn:pe(new d(91,"scrollBeyondLastColumn",5,0,1073741824,{description:g.localize(201,null)})),scrollBeyondLastLine:pe(new h(92,"scrollBeyondLastLine",!0,{description:g.localize(202,null)})),scrollPredominantAxis:pe(new h(93,"scrollPredominantAxis",!0,{description:g.localize(203,null)})),selectionClipboard:pe(new h(94,"selectionClipboard",!0,{description:g.localize(204,null),included:T.isLinux})),selectionHighlight:pe(new h(95,"selectionHighlight",!0,{description:g.localize(205,null)})),selectOnLineNumbers:pe(new h(96,"selectOnLineNumbers",!0)),showFoldingControls:pe(new S(97,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[g.localize(206,null),g.localize(207,null)],description:g.localize(208,null)})),showUnused:pe(new h(98,"showUnused",!0,{description:g.localize(209,null)})),showDeprecated:pe(new h(123,"showDeprecated",!0,{description:g.localize(210,null)})),inlayHints:pe(new R),snippetSuggestions:pe(new S(99,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[g.localize(211,null),g.localize(212,null),g.localize(213,null),g.localize(214,null)],description:g.localize(215,null)})),smartSelect:pe(new Q),smoothScrolling:pe(new h(101,"smoothScrolling",!1,{description:g.localize(216,null)})),stopRenderingLineAfter:pe(new d(103,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:pe(new W),inlineSuggest:pe(new Ye),suggestFontSize:pe(new d(105,"suggestFontSize",0,0,1e3,{markdownDescription:g.localize(217,null)})),suggestLineHeight:pe(new d(106,"suggestLineHeight",0,0,1e3,{markdownDescription:g.localize(218,null)})),suggestOnTriggerCharacters:pe(new h(107,"suggestOnTriggerCharacters",!0,{description:g.localize(219,null)})),suggestSelection:pe(new S(108,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[g.localize(220,null),g.localize(221,null),g.localize(222,null)],description:g.localize(223,null)})),tabCompletion:pe(new S(109,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[g.localize(224,null),g.localize(225,null),g.localize(226,null)],description:g.localize(227,null)})),tabIndex:pe(new d(110,"tabIndex",0,-1,1073741824)),unusualLineTerminators:pe(new S(111,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[g.localize(228,null),g.localize(229,null),g.localize(230,null)],description:g.localize(231,null)})),useShadowDOM:pe(new h(112,"useShadowDOM",!0)),useTabStops:pe(new h(113,"useTabStops",!0,{description:g.localize(232,null)})),wordSeparators:pe(new w(114,"wordSeparators",D.USUAL_WORD_SEPARATORS,{description:g.localize(233,null)})),wordWrap:pe(new S(115,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[g.localize(234,null),g.localize(235,null),g.localize(236,null),g.localize(237,null)],description:g.localize(238,null)})),wordWrapBreakAfterCharacters:pe(new w(116,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:pe(new w(117,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:pe(new d(118,"wordWrapColumn",80,1,1073741824,{markdownDescription:g.localize(239,null)})),wordWrapOverride1:pe(new S(119,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:pe(new S(120,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:pe(new c(121,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],K,{enumDescriptions:[g.localize(240,null),g.localize(241,null),g.localize(242,null),g.localize(243,null)],description:g.localize(244,null)})),wrappingStrategy:pe(new S(122,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[g.localize(245,null),g.localize(246,null)],description:g.localize(247,null)})),editorClassName:pe(new p),pixelRatio:pe(new oe),tabFocusMode:pe(new te),layoutInfo:pe(new z),wrappingInfo:pe(new se)}}),define(we[123],_e([19,20]),function(Z,e){return Z.create("vs/platform/configuration/common/configurationRegistry",e)}),define(we[124],_e([19,20]),function(Z,e){return Z.create("vs/platform/extensions/common/extensionValidator",e)}),define(we[125],_e([19,20]),function(Z,e){return Z.create("vs/platform/files/common/files",e)}),define(we[126],_e([19,20]),function(Z,e){return Z.create("vs/platform/markers/common/markers",e)}),define(we[127],_e([19,20]),function(Z,e){return Z.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(we[128],_e([19,20]),function(Z,e){return Z.create("vs/workbench/api/common/extHostExtensionService",e)}),define(we[129],_e([19,20]),function(Z,e){return Z.create("vs/workbench/api/common/extHostProgress",e)}),define(we[130],_e([19,20]),function(Z,e){return Z.create("vs/workbench/api/common/extHostStatusBar",e)}),define(we[131],_e([19,20]),function(Z,e){return Z.create("vs/workbench/api/common/extHostTerminalService",e)}),define(we[132],_e([19,20]),function(Z,e){return Z.create("vs/workbench/api/common/extHostTreeViews",e)}),define(we[133],_e([19,20]),function(Z,e){return Z.create("vs/workbench/api/common/extHostWorkspace",e)}),define(we[134],_e([19,20]),function(Z,e){return Z.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(we[135],_e([19,20]),function(Z,e){return Z.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(we[136],_e([19,20]),function(Z,e){return Z.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(we[137],_e([19,20]),function(Z,e){return Z.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(we[138],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorOverride=e.EditorActivation=void 0;var g;(function(C){C[C.ACTIVATE=0]="ACTIVATE",C[C.RESTORE=1]="RESTORE",C[C.PRESERVE=2]="PRESERVE"})(g=e.EditorActivation||(e.EditorActivation={}));var T;(function(C){C[C.PICK=1]="PICK",C[C.DISABLED=2]="DISABLED"})(T=e.EditorOverride||(e.EditorOverride={}));var D;(function(C){C[C.API=0]="API",C[C.USER=1]="USER"})(D=e.EditorOpenContext||(e.EditorOpenContext={}));var E;(function(C){C[C.Center=0]="Center",C[C.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",C[C.NearTop=2]="NearTop",C[C.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(E=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(we[139],_e([0,1,124]),function(Z,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const T=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,D=/^-(\d{4})(\d{2})(\d{2})$/;function E(o){return o=o.trim(),o==="*"||T.test(o)}e.isValidVersionStr=E;function C(o){if(!E(o))return null;if(o=o.trim(),o==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let h=o.match(T);return h?{hasCaret:h[1]==="^",hasGreaterEquals:h[1]===">=",majorBase:h[2]==="x"?0:parseInt(h[2],10),majorMustEqual:h[2]!=="x",minorBase:h[4]==="x"?0:parseInt(h[4],10),minorMustEqual:h[4]!=="x",patchBase:h[6]==="x"?0:parseInt(h[6],10),patchMustEqual:h[6]!=="x",preRelease:h[8]||null}:null}e.parseVersion=C;function y(o){if(!o)return null;let h=o.majorBase,d=o.majorMustEqual,u=o.minorBase,w=o.minorMustEqual,v=o.patchBase,S=o.patchMustEqual;o.hasCaret&&(h===0||(w=!1),S=!1);let c=0;if(o.preRelease){const m=D.exec(o.preRelease);if(m){const[,f,t,r]=m;c=Date.UTC(Number(f),Number(t)-1,Number(r))}}return{majorBase:h,majorMustEqual:d,minorBase:u,minorMustEqual:w,patchBase:v,patchMustEqual:S,isMinimum:o.hasGreaterEquals,notBefore:c}}e.normalizeVersion=y;function _(o,h,d){let u;typeof o=="string"?u=y(C(o)):u=o;let w;h instanceof Date?w=h.getTime():typeof h=="string"&&(w=new Date(h).getTime());let v;if(typeof d=="string"?v=y(C(d)):v=d,!u||!v)return!1;let S=u.majorBase,c=u.minorBase,m=u.patchBase,f=v.majorBase,t=v.minorBase,r=v.patchBase,i=v.notBefore,s=v.majorMustEqual,l=v.minorMustEqual,b=v.patchMustEqual;return v.isMinimum?S>f?!0:S<f?!1:c>t?!0:c<t||w&&w<i?!1:m>=r:(S===1&&f===0&&(!s||!l||!b)&&(f=1,t=0,r=0,s=!0,l=!1,b=!1),S<f?!1:S>f?!s:c<t?!1:c>t?!l:m<r?!1:m>r?!b:!(w&&w<i))}e.isValidVersion=_;function k(o,h,d,u){return d.isBuiltin||typeof d.main=="undefined"?!0:I(o,h,d.engines.vscode,u)}e.isValidExtensionVersion=k;function n(o,h,d){return o==="*"||I(h,d,o)}e.isEngineValid=n;function I(o,h,d,u=[]){let w=y(C(d));if(!w)return u.push(g.localize(0,null,d)),!1;if(w.majorBase===0){if(!w.majorMustEqual||!w.minorMustEqual)return u.push(g.localize(1,null,d)),!1}else if(!w.majorMustEqual)return u.push(g.localize(2,null,d)),!1;return _(o,h,w)?!0:(u.push(g.localize(3,null,o,d)),!1)}}),define(we[87],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class g{constructor(E,C=[],y=!1){this.ctor=E,this.staticArguments=C,this.supportsDelayedInstantiation=y}}e.SyncDescriptor=g;const T=(D,...E)=>new g(D,E);e.createSyncDescriptor=T}),define(we[57],_e([0,1,87]),function(Z,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const T=[];function D(C,y,_){y instanceof g.SyncDescriptor||(y=new g.SyncDescriptor(y,[],_)),T.push([C,y])}e.registerSingleton=D;function E(){return T}e.getSingletonServiceDescriptors=E}),define(we[140],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class g{constructor(E){this.incoming=new Map,this.outgoing=new Map,this.data=E}}e.Node=g;class T{constructor(E){this._hashFn=E,this._nodes=new Map}roots(){const E=[];for(let C of this._nodes.values())C.outgoing.size===0&&E.push(C);return E}insertEdge(E,C){const y=this.lookupOrInsertNode(E),_=this.lookupOrInsertNode(C);y.outgoing.set(this._hashFn(C),_),_.incoming.set(this._hashFn(E),y)}removeNode(E){const C=this._hashFn(E);this._nodes.delete(C);for(let y of this._nodes.values())y.outgoing.delete(C),y.incoming.delete(C)}lookupOrInsertNode(E){const C=this._hashFn(E);let y=this._nodes.get(C);return y||(y=new g(E),this._nodes.set(C,y)),y}lookup(E){return this._nodes.get(this._hashFn(E))}isEmpty(){return this._nodes.size===0}toString(){let E=[];for(let[C,y]of this._nodes)E.push(`${C}, (incoming)[${[...y.incoming.keys()].join(", ")}], (outgoing)[${[...y.outgoing.keys()].join(",")}]`);return E.join(`
`)}findCycleSlow(){for(let[E,C]of this._nodes){const y=new Set([E]),_=this._findCycle(C,y);if(_)return _}}_findCycle(E,C){for(let[y,_]of E.outgoing){if(C.has(y))return[...C,y].join(" -> ");C.add(y);const k=this._findCycle(_,C);if(k)return k;C.delete(y)}}}e.Graph=T}),define(we[5],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var g;(function(y){y.serviceIds=new Map,y.DI_TARGET="$di$target",y.DI_DEPENDENCIES="$di$dependencies";function _(k){return k[y.DI_DEPENDENCIES]||[]}y.getServiceDependencies=_})(g=e._util||(e._util={})),e.IInstantiationService=D("instantiationService");function T(y,_,k,n){_[g.DI_TARGET]===_?_[g.DI_DEPENDENCIES].push({id:y,index:k,optional:n}):(_[g.DI_DEPENDENCIES]=[{id:y,index:k,optional:n}],_[g.DI_TARGET]=_)}function D(y){if(g.serviceIds.has(y))return g.serviceIds.get(y);const _=function(k,n,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");T(_,k,I,!1)};return _.toString=()=>y,g.serviceIds.set(y,_),_}e.createDecorator=D;function E(y){return y}e.refineServiceDecorator=E;function C(y){return function(_,k,n){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");T(y,_,n,!0)}}e.optional=C}),define(we[141],_e([0,1,5]),function(Z,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=g.createDecorator("modelService");function T(D){return!D.isTooLargeForSyncing()&&!D.isForSimpleWidget}e.shouldSynchronizeModel=T}),define(we[142],_e([0,1,3,53,7,22,77,55,141]),function(Z,e,g,T,D,E,C,y,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function k(o){return typeof o=="string"?!1:Array.isArray(o)?o.every(k):!!o.exclusive}class n{constructor(){this._clock=0,this._entries=[],this._onDidChange=new g.Emitter}get onDidChange(){return this._onDidChange.event}register(h,d){let u={selector:h,provider:d,_score:-1,_time:this._clock++};return this._entries.push(u),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),D.toDisposable(()=>{if(u){let w=this._entries.indexOf(u);w>=0&&(this._entries.splice(w,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),u=void 0)}})}has(h){return this.all(h).length>0}all(h){if(!h)return[];this._updateScores(h);const d=[];for(let u of this._entries)u._score>0&&d.push(u.provider);return d}ordered(h){const d=[];return this._orderedForEach(h,u=>d.push(u.provider)),d}orderedGroups(h){const d=[];let u,w;return this._orderedForEach(h,v=>{u&&w===v._score?u.push(v.provider):(w=v._score,u=[v.provider],d.push(u))}),d}_orderedForEach(h,d){if(!!h){this._updateScores(h);for(const u of this._entries)u._score>0&&d(u)}}_updateScores(h){let d={uri:h.uri.toString(),language:h.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===d.language&&this._lastCandidate.uri===d.uri)){this._lastCandidate=d;for(let u of this._entries)if(u._score=y.score(u.selector,h.uri,h.getLanguageIdentifier().language,_.shouldSynchronizeModel(h)),k(u.selector)&&u._score>0){for(let w of this._entries)w._score=0;u._score=1e3;break}this._entries.sort(n._compareByScoreAndTime)}}static _compareByScoreAndTime(h,d){return h._score<d._score?1:h._score>d._score?-1:h._time<d._time?1:h._time>d._time?-1:0}}e.LanguageFeatureRegistry=n;class I{constructor(h,d,u=Number.MAX_SAFE_INTEGER){this._registry=h,this.min=d,this.max=u,this._cache=new E.LRUCache(50,.7)}_key(h){return h.id+T.hash(this._registry.all(h))}_clamp(h){return h===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(h*1.3)))}get(h){const d=this._key(h),u=this._cache.get(d);return this._clamp(u==null?void 0:u.value)}update(h,d){const u=this._key(h);let w=this._cache.get(u);return w||(w=new C.MovingAverage,this._cache.set(u,w)),w.update(d),this.get(h)}}e.LanguageFeatureRequestDelays=I}),define(we[58],_e([0,1,2,31,142,118,78]),function(Z,e,g,T,D,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var y;(function(a){a[a.Null=0]="Null",a[a.PlainText=1]="PlainText"})(y=e.LanguageId||(e.LanguageId={}));class _{constructor(F,N){this.language=F,this.id=N}}e.LanguageIdentifier=_;var k;(function(a){a[a.NotSet=-1]="NotSet",a[a.None=0]="None",a[a.Italic=1]="Italic",a[a.Bold=2]="Bold",a[a.Underline=4]="Underline"})(k=e.FontStyle||(e.FontStyle={}));var n;(function(a){a[a.None=0]="None",a[a.DefaultForeground=1]="DefaultForeground",a[a.DefaultBackground=2]="DefaultBackground"})(n=e.ColorId||(e.ColorId={}));var I;(function(a){a[a.Other=0]="Other",a[a.Comment=1]="Comment",a[a.String=2]="String",a[a.RegEx=4]="RegEx"})(I=e.StandardTokenType||(e.StandardTokenType={}));var o;(function(a){a[a.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",a[a.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",a[a.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",a[a.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",a[a.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",a[a.ITALIC_MASK=2048]="ITALIC_MASK",a[a.BOLD_MASK=4096]="BOLD_MASK",a[a.UNDERLINE_MASK=8192]="UNDERLINE_MASK",a[a.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",a[a.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",a[a.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",a[a.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",a[a.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",a[a.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",a[a.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",a[a.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",a[a.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",a[a.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(o=e.MetadataConsts||(e.MetadataConsts={}));class h{static getLanguageId(F){return(F&255)>>>0}static getTokenType(F){return(F&1792)>>>8}static getFontStyle(F){return(F&14336)>>>11}static getForeground(F){return(F&8372224)>>>14}static getBackground(F){return(F&4286578688)>>>23}static getClassNameFromMetadata(F){let N=this.getForeground(F),H="mtk"+N,le=this.getFontStyle(F);return le&1&&(H+=" mtki"),le&2&&(H+=" mtkb"),le&4&&(H+=" mtku"),H}static getInlineStyleFromMetadata(F,N){const H=this.getForeground(F),le=this.getFontStyle(F);let fe=`color: ${N[H]};`;return le&1&&(fe+="font-style: italic;"),le&2&&(fe+="font-weight: bold;"),le&4&&(fe+="text-decoration: underline;"),fe}}e.TokenMetadata=h;var d;(function(a){a[a.Method=0]="Method",a[a.Function=1]="Function",a[a.Constructor=2]="Constructor",a[a.Field=3]="Field",a[a.Variable=4]="Variable",a[a.Class=5]="Class",a[a.Struct=6]="Struct",a[a.Interface=7]="Interface",a[a.Module=8]="Module",a[a.Property=9]="Property",a[a.Event=10]="Event",a[a.Operator=11]="Operator",a[a.Unit=12]="Unit",a[a.Value=13]="Value",a[a.Constant=14]="Constant",a[a.Enum=15]="Enum",a[a.EnumMember=16]="EnumMember",a[a.Keyword=17]="Keyword",a[a.Text=18]="Text",a[a.Color=19]="Color",a[a.File=20]="File",a[a.Reference=21]="Reference",a[a.Customcolor=22]="Customcolor",a[a.Folder=23]="Folder",a[a.TypeParameter=24]="TypeParameter",a[a.User=25]="User",a[a.Issue=26]="Issue",a[a.Snippet=27]="Snippet"})(d=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let a=Object.create(null);return a[0]="symbol-method",a[1]="symbol-function",a[2]="symbol-constructor",a[3]="symbol-field",a[4]="symbol-variable",a[5]="symbol-class",a[6]="symbol-struct",a[7]="symbol-interface",a[8]="symbol-module",a[9]="symbol-property",a[10]="symbol-event",a[11]="symbol-operator",a[12]="symbol-unit",a[13]="symbol-value",a[14]="symbol-constant",a[15]="symbol-enum",a[16]="symbol-enum-member",a[17]="symbol-keyword",a[27]="symbol-snippet",a[18]="symbol-text",a[19]="symbol-color",a[20]="symbol-file",a[21]="symbol-reference",a[22]="symbol-customcolor",a[23]="symbol-folder",a[24]="symbol-type-parameter",a[25]="account",a[26]="issues",function(F){const N=a[F];let H=N&&C.iconRegistry.get(N);return H||(console.info("No codicon found for CompletionItemKind "+F),H=C.Codicon.symbolProperty),H.classNames}}(),e.completionKindFromString=function(){let a=Object.create(null);return a.method=0,a.function=1,a.constructor=2,a.field=3,a.variable=4,a.class=5,a.struct=6,a.interface=7,a.module=8,a.property=9,a.event=10,a.operator=11,a.unit=12,a.value=13,a.constant=14,a.enum=15,a["enum-member"]=16,a.enumMember=16,a.keyword=17,a.snippet=27,a.text=18,a.color=19,a.file=20,a.reference=21,a.customcolor=22,a.folder=23,a["type-parameter"]=24,a.typeParameter=24,a.account=25,a.issue=26,function(F,N){let H=a[F];return typeof H=="undefined"&&!N&&(H=9),H}}();var u;(function(a){a[a.Deprecated=1]="Deprecated"})(u=e.CompletionItemTag||(e.CompletionItemTag={}));var w;(function(a){a[a.KeepWhitespace=1]="KeepWhitespace",a[a.InsertAsSnippet=4]="InsertAsSnippet"})(w=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var v;(function(a){a[a.Invoke=0]="Invoke",a[a.TriggerCharacter=1]="TriggerCharacter",a[a.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(v=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var S;(function(a){a[a.Automatic=0]="Automatic",a[a.Explicit=1]="Explicit"})(S=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var c;(function(a){a[a.Invoke=1]="Invoke",a[a.Auto=2]="Auto"})(c=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var m;(function(a){a[a.Invoke=1]="Invoke",a[a.TriggerCharacter=2]="TriggerCharacter",a[a.ContentChange=3]="ContentChange"})(m=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var f;(function(a){a[a.Text=0]="Text",a[a.Read=1]="Read",a[a.Write=2]="Write"})(f=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function t(a){return a&&g.URI.isUri(a.uri)&&T.Range.isIRange(a.range)&&(T.Range.isIRange(a.originSelectionRange)||T.Range.isIRange(a.targetSelectionRange))}e.isLocationLink=t;var r;(function(a){a[a.File=0]="File",a[a.Module=1]="Module",a[a.Namespace=2]="Namespace",a[a.Package=3]="Package",a[a.Class=4]="Class",a[a.Method=5]="Method",a[a.Property=6]="Property",a[a.Field=7]="Field",a[a.Constructor=8]="Constructor",a[a.Enum=9]="Enum",a[a.Interface=10]="Interface",a[a.Function=11]="Function",a[a.Variable=12]="Variable",a[a.Constant=13]="Constant",a[a.String=14]="String",a[a.Number=15]="Number",a[a.Boolean=16]="Boolean",a[a.Array=17]="Array",a[a.Object=18]="Object",a[a.Key=19]="Key",a[a.Null=20]="Null",a[a.EnumMember=21]="EnumMember",a[a.Struct=22]="Struct",a[a.Event=23]="Event",a[a.Operator=24]="Operator",a[a.TypeParameter=25]="TypeParameter"})(r=e.SymbolKind||(e.SymbolKind={}));var i;(function(a){a[a.Deprecated=1]="Deprecated"})(i=e.SymbolTag||(e.SymbolTag={}));var s;(function(a){const F=new Map;F.set("file",0),F.set("module",1),F.set("namespace",2),F.set("package",3),F.set("class",4),F.set("method",5),F.set("property",6),F.set("field",7),F.set("constructor",8),F.set("enum",9),F.set("interface",10),F.set("function",11),F.set("variable",12),F.set("constant",13),F.set("string",14),F.set("number",15),F.set("boolean",16),F.set("array",17),F.set("object",18),F.set("key",19),F.set("null",20),F.set("enum-member",21),F.set("struct",22),F.set("event",23),F.set("operator",24),F.set("type-parameter",25);const N=new Map;N.set(0,"file"),N.set(1,"module"),N.set(2,"namespace"),N.set(3,"package"),N.set(4,"class"),N.set(5,"method"),N.set(6,"property"),N.set(7,"field"),N.set(8,"constructor"),N.set(9,"enum"),N.set(10,"interface"),N.set(11,"function"),N.set(12,"variable"),N.set(13,"constant"),N.set(14,"string"),N.set(15,"number"),N.set(16,"boolean"),N.set(17,"array"),N.set(18,"object"),N.set(19,"key"),N.set(20,"null"),N.set(21,"enum-member"),N.set(22,"struct"),N.set(23,"event"),N.set(24,"operator"),N.set(25,"type-parameter");function H(X){return F.get(X)}a.fromString=H;function le(X){return N.get(X)}a.toString=le;function fe(X,z){const Y=N.get(X);let R=Y&&C.iconRegistry.get("symbol-"+Y);return R||(console.info("No codicon found for SymbolKind "+X),R=C.Codicon.symbolProperty),`${z?"inline":"block"} ${R.classNames}`}a.toCssClassName=fe})(s=e.SymbolKinds||(e.SymbolKinds={}));class l{constructor(F){this.value=F}}e.FoldingRangeKind=l,l.Comment=new l("comment"),l.Imports=new l("imports"),l.Region=new l("region");var b;(function(a){a[a.Collapsed=0]="Collapsed",a[a.Expanded=1]="Expanded"})(b=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var p;(function(a){a[a.Editing=0]="Editing",a[a.Preview=1]="Preview"})(p=e.CommentMode||(e.CommentMode={}));var P;(function(a){a[a.Other=0]="Other",a[a.Type=1]="Type",a[a.Parameter=2]="Parameter"})(P=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new D.LanguageFeatureRegistry,e.RenameProviderRegistry=new D.LanguageFeatureRegistry,e.CompletionProviderRegistry=new D.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new D.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new D.LanguageFeatureRegistry,e.HoverProviderRegistry=new D.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new D.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new D.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new D.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new D.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new D.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new D.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new D.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new D.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new D.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new D.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new D.LanguageFeatureRegistry,e.LinkProviderRegistry=new D.LanguageFeatureRegistry,e.ColorProviderRegistry=new D.LanguageFeatureRegistry,e.SelectionRangeRegistry=new D.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new D.LanguageFeatureRegistry,e.TokenizationRegistry=new E.TokenizationRegistryImpl;var A;(function(a){a[a.None=0]="None",a[a.Option=1]="Option",a[a.Default=2]="Default",a[a.Preferred=3]="Preferred"})(A=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(we[88],_e([0,1,8,5,21]),function(Z,e,g,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let E=D.userAgent||"";const C=new Map;C.set("false",!1),C.set("true",!0),C.set("isMac",D.isMacintosh),C.set("isLinux",D.isLinux),C.set("isWindows",D.isWindows),C.set("isWeb",D.isWeb),C.set("isMacNative",D.isMacintosh&&!D.isWeb),C.set("isEdge",E.indexOf("Edg/")>=0),C.set("isFirefox",E.indexOf("Firefox")>=0),C.set("isChrome",E.indexOf("Chrome")>=0),C.set("isSafari",E.indexOf("Safari")>=0);const y=Object.prototype.hasOwnProperty;var _;(function(A){A[A.False=0]="False",A[A.True=1]="True",A[A.Defined=2]="Defined",A[A.Not=3]="Not",A[A.Equals=4]="Equals",A[A.NotEquals=5]="NotEquals",A[A.And=6]="And",A[A.Regex=7]="Regex",A[A.NotRegex=8]="NotRegex",A[A.Or=9]="Or",A[A.In=10]="In",A[A.NotIn=11]="NotIn",A[A.Greater=12]="Greater",A[A.GreaterEquals=13]="GreaterEquals",A[A.Smaller=14]="Smaller",A[A.SmallerEquals=15]="SmallerEquals"})(_=e.ContextKeyExprType||(e.ContextKeyExprType={}));class k{static false(){return I.INSTANCE}static true(){return o.INSTANCE}static has(a){return h.create(a)}static equals(a,F){return d.create(a,F)}static notEquals(a,F){return v.create(a,F)}static regex(a,F){return r.create(a,F)}static in(a,F){return u.create(a,F)}static not(a){return S.create(a)}static and(...a){return s.create(a)}static or(...a){return l.create(a)}static greater(a,F){return c.create(a,F)}static less(a,F){return f.create(a,F)}static deserialize(a,F=!1){if(!!a)return this._deserializeOrExpression(a,F)}static _deserializeOrExpression(a,F){let N=a.split("||");return l.create(N.map(H=>this._deserializeAndExpression(H,F)))}static _deserializeAndExpression(a,F){let N=a.split("&&");return s.create(N.map(H=>this._deserializeOne(H,F)))}static _deserializeOne(a,F){if(a=a.trim(),a.indexOf("!=")>=0){let N=a.split("!=");return v.create(N[0].trim(),this._deserializeValue(N[1],F))}if(a.indexOf("==")>=0){let N=a.split("==");return d.create(N[0].trim(),this._deserializeValue(N[1],F))}if(a.indexOf("=~")>=0){let N=a.split("=~");return r.create(N[0].trim(),this._deserializeRegexValue(N[1],F))}if(a.indexOf(" in ")>=0){let N=a.split(" in ");return u.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(a)){const N=a.split(">=");return m.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(a)){const N=a.split(">");return c.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(a)){const N=a.split("<=");return t.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(a)){const N=a.split("<");return f.create(N[0].trim(),N[1].trim())}return/^\!\s*/.test(a)?S.create(a.substr(1).trim()):h.create(a)}static _deserializeValue(a,F){if(a=a.trim(),a==="true")return!0;if(a==="false")return!1;let N=/^'([^']*)'$/.exec(a);return N?N[1].trim():a}static _deserializeRegexValue(a,F){if(g.isFalsyOrWhitespace(a)){if(F)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let N=a.indexOf("/"),H=a.lastIndexOf("/");if(N===H||N<0){if(F)throw new Error(`bad regexp-value '${a}', missing /-enclosure`);return console.warn(`bad regexp-value '${a}', missing /-enclosure`),null}let le=a.slice(N+1,H),fe=a[H+1]==="i"?"i":"";try{return new RegExp(le,fe)}catch(X){if(F)throw new Error(`bad regexp-value '${a}', parse error: ${X}`);return console.warn(`bad regexp-value '${a}', parse error: ${X}`),null}}}e.ContextKeyExpr=k;function n(A,a){return A.cmp(a)}class I{constructor(){this.type=0}cmp(a){return this.type-a.type}equals(a){return a.type===this.type}evaluate(a){return!1}serialize(){return"false"}keys(){return[]}map(a){return this}negate(){return o.INSTANCE}}e.ContextKeyFalseExpr=I,I.INSTANCE=new I;class o{constructor(){this.type=1}cmp(a){return this.type-a.type}equals(a){return a.type===this.type}evaluate(a){return!0}serialize(){return"true"}keys(){return[]}map(a){return this}negate(){return I.INSTANCE}}e.ContextKeyTrueExpr=o,o.INSTANCE=new o;class h{constructor(a){this.key=a,this.type=2}static create(a){const F=C.get(a);return typeof F=="boolean"?F?o.INSTANCE:I.INSTANCE:new h(a)}cmp(a){return a.type!==this.type?this.type-a.type:p(this.key,a.key)}equals(a){return a.type===this.type?this.key===a.key:!1}evaluate(a){return!!a.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(a){return a.mapDefined(this.key)}negate(){return S.create(this.key)}}e.ContextKeyDefinedExpr=h;class d{constructor(a,F){this.key=a,this.value=F,this.type=4}static create(a,F){if(typeof F=="boolean")return F?h.create(a):S.create(a);const N=C.get(a);return typeof N=="boolean"?F===(N?"true":"false")?o.INSTANCE:I.INSTANCE:new d(a,F)}cmp(a){return a.type!==this.type?this.type-a.type:P(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}evaluate(a){return a.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(a){return a.mapEquals(this.key,this.value)}negate(){return v.create(this.key,this.value)}}e.ContextKeyEqualsExpr=d;class u{constructor(a,F){this.key=a,this.valueKey=F,this.type=10}static create(a,F){return new u(a,F)}cmp(a){return a.type!==this.type?this.type-a.type:P(this.key,this.valueKey,a.key,a.valueKey)}equals(a){return a.type===this.type?this.key===a.key&&this.valueKey===a.valueKey:!1}evaluate(a){const F=a.getValue(this.valueKey),N=a.getValue(this.key);return Array.isArray(F)?F.indexOf(N)>=0:typeof N=="string"&&typeof F=="object"&&F!==null?y.call(F,N):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(a){return a.mapIn(this.key,this.valueKey)}negate(){return w.create(this)}}e.ContextKeyInExpr=u;class w{constructor(a){this._actual=a,this.type=11}static create(a){return new w(a)}cmp(a){return a.type!==this.type?this.type-a.type:this._actual.cmp(a._actual)}equals(a){return a.type===this.type?this._actual.equals(a._actual):!1}evaluate(a){return!this._actual.evaluate(a)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(a){return new w(this._actual.map(a))}negate(){return this._actual}}e.ContextKeyNotInExpr=w;class v{constructor(a,F){this.key=a,this.value=F,this.type=5}static create(a,F){if(typeof F=="boolean")return F?S.create(a):h.create(a);const N=C.get(a);return typeof N=="boolean"?F===(N?"true":"false")?I.INSTANCE:o.INSTANCE:new v(a,F)}cmp(a){return a.type!==this.type?this.type-a.type:P(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}evaluate(a){return a.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(a){return a.mapNotEquals(this.key,this.value)}negate(){return d.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=v;class S{constructor(a){this.key=a,this.type=3}static create(a){const F=C.get(a);return typeof F=="boolean"?F?I.INSTANCE:o.INSTANCE:new S(a)}cmp(a){return a.type!==this.type?this.type-a.type:p(this.key,a.key)}equals(a){return a.type===this.type?this.key===a.key:!1}evaluate(a){return!a.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(a){return a.mapNot(this.key)}negate(){return h.create(this.key)}}e.ContextKeyNotExpr=S;class c{constructor(a,F){this.key=a,this.value=F,this.type=12}static create(a,F){return new c(a,F)}cmp(a){return a.type!==this.type?this.type-a.type:P(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}evaluate(a){return parseFloat(a.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(a){return a.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=c;class m{constructor(a,F){this.key=a,this.value=F,this.type=13}static create(a,F){return new m(a,F)}cmp(a){return a.type!==this.type?this.type-a.type:P(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}evaluate(a){return parseFloat(a.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(a){return a.mapGreaterEquals(this.key,this.value)}negate(){return f.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=m;class f{constructor(a,F){this.key=a,this.value=F,this.type=14}static create(a,F){return new f(a,F)}cmp(a){return a.type!==this.type?this.type-a.type:P(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}evaluate(a){return parseFloat(a.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(a){return a.mapSmaller(this.key,this.value)}negate(){return m.create(this.key,this.value)}}e.ContextKeySmallerExpr=f;class t{constructor(a,F){this.key=a,this.value=F,this.type=15}static create(a,F){return new t(a,F)}cmp(a){return a.type!==this.type?this.type-a.type:P(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}evaluate(a){return parseFloat(a.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(a){return a.mapSmallerEquals(this.key,this.value)}negate(){return c.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class r{constructor(a,F){this.key=a,this.regexp=F,this.type=7}static create(a,F){return new r(a,F)}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.key<a.key)return-1;if(this.key>a.key)return 1;const F=this.regexp?this.regexp.source:"",N=a.regexp?a.regexp.source:"";return F<N?-1:F>N?1:0}equals(a){if(a.type===this.type){const F=this.regexp?this.regexp.source:"",N=a.regexp?a.regexp.source:"";return this.key===a.key&&F===N}return!1}evaluate(a){let F=a.getValue(this.key);return this.regexp?this.regexp.test(F):!1}serialize(){const a=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${a}`}keys(){return[this.key]}map(a){return a.mapRegex(this.key,this.regexp)}negate(){return i.create(this)}}e.ContextKeyRegexExpr=r;class i{constructor(a){this._actual=a,this.type=8}static create(a){return new i(a)}cmp(a){return a.type!==this.type?this.type-a.type:this._actual.cmp(a._actual)}equals(a){return a.type===this.type?this._actual.equals(a._actual):!1}evaluate(a){return!this._actual.evaluate(a)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(a){return new i(this._actual.map(a))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=i;class s{constructor(a){this.expr=a,this.type=6}static create(a){return s._normalizeArr(a)}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.expr.length<a.expr.length)return-1;if(this.expr.length>a.expr.length)return 1;for(let F=0,N=this.expr.length;F<N;F++){const H=n(this.expr[F],a.expr[F]);if(H!==0)return H}return 0}equals(a){if(a.type===this.type){if(this.expr.length!==a.expr.length)return!1;for(let F=0,N=this.expr.length;F<N;F++)if(!this.expr[F].equals(a.expr[F]))return!1;return!0}return!1}evaluate(a){for(let F=0,N=this.expr.length;F<N;F++)if(!this.expr[F].evaluate(a))return!1;return!0}static _normalizeArr(a){const F=[];let N=!1;for(const H of a)if(!!H){if(H.type===1){N=!0;continue}if(H.type===0)return I.INSTANCE;if(H.type===6){F.push(...H.expr);continue}F.push(H)}if(F.length===0&&N)return o.INSTANCE;if(F.length!==0){if(F.length===1)return F[0];for(F.sort(n);F.length>1;){const H=F[F.length-1];if(H.type!==9)break;F.pop();const le=F.pop(),fe=l.create(H.expr.map(X=>s.create([X,le])));fe&&(F.push(fe),F.sort(n))}return F.length===1?F[0]:new s(F)}}serialize(){return this.expr.map(a=>a.serialize()).join(" && ")}keys(){const a=[];for(let F of this.expr)a.push(...F.keys());return a}map(a){return new s(this.expr.map(F=>F.map(a)))}negate(){let a=[];for(let F of this.expr)a.push(F.negate());return l.create(a)}}e.ContextKeyAndExpr=s;class l{constructor(a){this.expr=a,this.type=9}static create(a){const F=l._normalizeArr(a);if(F.length!==0)return F.length===1?F[0]:new l(F)}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.expr.length<a.expr.length)return-1;if(this.expr.length>a.expr.length)return 1;for(let F=0,N=this.expr.length;F<N;F++){const H=n(this.expr[F],a.expr[F]);if(H!==0)return H}return 0}equals(a){if(a.type===this.type){if(this.expr.length!==a.expr.length)return!1;for(let F=0,N=this.expr.length;F<N;F++)if(!this.expr[F].equals(a.expr[F]))return!1;return!0}return!1}evaluate(a){for(let F=0,N=this.expr.length;F<N;F++)if(this.expr[F].evaluate(a))return!0;return!1}static _normalizeArr(a){let F=[],N=!1;if(a){for(let H=0,le=a.length;H<le;H++){const fe=a[H];if(!!fe){if(fe.type===0){N=!0;continue}if(fe.type===1)return[o.INSTANCE];if(fe.type===9){F=F.concat(fe.expr);continue}F.push(fe)}}if(F.length===0&&N)return[I.INSTANCE];F.sort(n)}return F}serialize(){return this.expr.map(a=>a.serialize()).join(" || ")}keys(){const a=[];for(let F of this.expr)a.push(...F.keys());return a}map(a){return new l(this.expr.map(F=>F.map(a)))}negate(){let a=[];for(let N of this.expr)a.push(N.negate());const F=N=>N.type===9?N.expr:[N];for(;a.length>1;){const N=a.shift(),H=a.shift(),le=[];for(const fe of F(N))for(const X of F(H))le.push(k.and(fe,X));a.unshift(k.or(...le))}return a[0]}}e.ContextKeyOrExpr=l;class b extends h{constructor(a,F,N){super(a);this._defaultValue=F,typeof N=="object"?b._info.push(Object.assign(Object.assign({},N),{key:a})):N!==!0&&b._info.push({key:a,description:N,type:F!=null?typeof F:void 0})}static all(){return b._info.values()}bindTo(a){return a.createKey(this.key,this._defaultValue)}getValue(a){return a.getContextKeyValue(this.key)}toNegated(){return k.not(this.key)}isEqualTo(a){return k.equals(this.key,a)}notEqualsTo(a){return k.notEquals(this.key,a)}}e.RawContextKey=b,b._info=[],e.IContextKeyService=T.createDecorator("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function p(A,a){return A<a?-1:A>a?1:0}function P(A,a,F,N){return A<F?-1:A>F?1:a<N?-1:a>N?1:0}}),define(we[26],_e([0,1,8,5]),function(Z,e,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkpaceSupportTypeMessage=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function D(n){if(typeof n=="object"&&n!==null&&n.supported!==!0)return n.description}e.getWorkpaceSupportTypeMessage=D;function E(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.isIExtensionIdentifier=E,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var C;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(C=e.ExtensionType||(e.ExtensionType={}));class y{constructor(I){this.value=I,this._lower=I.toLowerCase()}static equals(I,o){if(typeof I=="undefined"||I===null)return typeof o=="undefined"||o===null;if(typeof o=="undefined"||o===null)return!1;if(typeof I=="string"||typeof o=="string"){let h=typeof I=="string"?I:I.value,d=typeof o=="string"?o:o.value;return g.equalsIgnoreCase(h,d)}return I._lower===o._lower}static toKey(I){return typeof I=="string"?I.toLowerCase():I._lower}}e.ExtensionIdentifier=y;function _(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}e.isLanguagePackExtension=_;function k(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=k,e.IBuiltinExtensionsScannerService=T.createDecorator("IBuiltinExtensionsScannerService")}),define(we[143],_e([0,1,8,26]),function(Z,e,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function D(h,d){return h.uuid&&d.uuid?h.uuid===d.uuid:h.id===d.id?!0:g.compareIgnoreCase(h.id,d.id)===0}e.areSameExtensions=D;class E{constructor(d,u){this.version=u,this.id=d.id,this.uuid=d.uuid}key(){return`${this.id}-${this.version}`}equals(d){return d instanceof E?D(this,d)&&this.version===d.version:!1}}e.ExtensionIdentifierWithVersion=E;function C(h,d){return`${h}.${d}`}e.getExtensionId=C;function y(h){return h.toLocaleLowerCase()}e.adoptToGalleryExtensionId=y;function _(h,d){return y(C(h,d))}e.getGalleryExtensionId=_;function k(h,d){const u=[],w=v=>{for(const S of u)if(S.some(c=>D(d(c),d(v))))return S;return null};for(const v of h){const S=w(v);S?S.push(v):u.push([v])}return u}e.groupByExtension=k;function n(h){return{id:h.identifier.id,name:h.manifest.name,galleryId:null,publisherId:h.publisherId,publisherName:h.manifest.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:h.manifest.extensionDependencies&&h.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=n;function I(h){return Object.assign({id:h.identifier.id,name:h.name,galleryId:h.identifier.uuid,publisherId:h.publisherId,publisherName:h.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:!!(h.properties.dependencies&&h.properties.dependencies.length>0)},h.telemetryData)}e.getGalleryExtensionTelemetryData=I,e.BetterMergeId=new T.ExtensionIdentifier("pprice.better-merge");function o(h){const d=new Set;for(const u of h)u.malicious&&d.add(u.id.id);return d}e.getMaliciousExtensionsSet=o}),define(we[59],_e([0,1,125,13,2,5,8,10,22]),function(Z,e,g,T,D,E,C,y,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=E.createDecorator("fileService");function k(z){return z.create===!0}e.isFileOpenForWriteOptions=k;var n;(function(z){z[z.Unknown=0]="Unknown",z[z.File=1]="File",z[z.Directory=2]="Directory",z[z.SymbolicLink=64]="SymbolicLink"})(n=e.FileType||(e.FileType={}));var I;(function(z){z[z.Readonly=1]="Readonly"})(I=e.FilePermission||(e.FilePermission={}));var o;(function(z){z[z.FileReadWrite=2]="FileReadWrite",z[z.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",z[z.FileReadStream=16]="FileReadStream",z[z.FileFolderCopy=8]="FileFolderCopy",z[z.PathCaseSensitive=1024]="PathCaseSensitive",z[z.Readonly=2048]="Readonly",z[z.Trash=4096]="Trash",z[z.FileWriteUnlock=8192]="FileWriteUnlock"})(o=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function h(z){return!!(z.capabilities&2)}e.hasReadWriteCapability=h;function d(z){return!!(z.capabilities&8)}e.hasFileFolderCopyCapability=d;function u(z){return!!(z.capabilities&4)}e.hasOpenReadWriteCloseCapability=u;function w(z){return!!(z.capabilities&16)}e.hasFileReadStreamCapability=w;var v;(function(z){z.FileExists="EntryExists",z.FileNotFound="EntryNotFound",z.FileNotADirectory="EntryNotADirectory",z.FileIsADirectory="EntryIsADirectory",z.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",z.FileTooLarge="EntryTooLarge",z.FileWriteLocked="EntryWriteLocked",z.NoPermissions="NoPermissions",z.Unavailable="Unavailable",z.Unknown="Unknown"})(v=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class S extends Error{constructor(Y,R){super(Y);this.code=R}}e.FileSystemProviderError=S;function c(z,Y){const R=new S(z.toString(),Y);return f(R,Y),R}e.createFileSystemProviderError=c;function m(z){return z||c(g.localize(0,null),v.Unknown)}e.ensureFileSystemProviderError=m;function f(z,Y){return z.name=Y?`${Y} (FileSystemError)`:"FileSystemError",z}e.markAsFileSystemProviderError=f;function t(z){if(!z)return v.Unknown;if(z instanceof S)return z.code;const Y=/^(.+) \(FileSystemError\)$/.exec(z.name);if(!Y)return v.Unknown;switch(Y[1]){case v.FileExists:return v.FileExists;case v.FileIsADirectory:return v.FileIsADirectory;case v.FileNotADirectory:return v.FileNotADirectory;case v.FileNotFound:return v.FileNotFound;case v.FileExceedsMemoryLimit:return v.FileExceedsMemoryLimit;case v.FileTooLarge:return v.FileTooLarge;case v.FileWriteLocked:return v.FileWriteLocked;case v.NoPermissions:return v.NoPermissions;case v.Unavailable:return v.Unavailable}return v.Unknown}e.toFileSystemProviderErrorCode=t;function r(z){if(z instanceof P)return z.fileOperationResult;switch(t(z)){case v.FileNotFound:return 1;case v.FileIsADirectory:return 0;case v.FileNotADirectory:return 10;case v.FileWriteLocked:return 5;case v.NoPermissions:return 6;case v.FileExists:return 4;case v.FileExceedsMemoryLimit:return 9;case v.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var i;(function(z){z[z.CREATE=0]="CREATE",z[z.DELETE=1]="DELETE",z[z.MOVE=2]="MOVE",z[z.COPY=3]="COPY"})(i=e.FileOperation||(e.FileOperation={}));class s{constructor(Y,R,B){this.resource=Y,this.operation=R,this.target=B}isOperation(Y){return this.operation===Y}}e.FileOperationEvent=s;var l;(function(z){z[z.UPDATED=0]="UPDATED",z[z.ADDED=1]="ADDED",z[z.DELETED=2]="DELETED"})(l=e.FileChangeType||(e.FileChangeType={}));class b{constructor(Y,R){this.ignorePathCasing=R,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=Y;for(const B of Y)switch(B.type){case 1:this.added||(this.added=_.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set(B.resource,B);break;case 0:this.updated||(this.updated=_.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set(B.resource,B);break;case 2:this.deleted||(this.deleted=_.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set(B.resource,B);break}}contains(Y,...R){return this.doContains(Y,{includeChildren:!1},...R)}affects(Y,...R){return this.doContains(Y,{includeChildren:!0},...R)}doContains(Y,R,...B){var M,U,q,V,oe,ge;if(!Y)return!1;const Re=B.length>0;return!!((!Re||B.includes(1))&&(((M=this.added)===null||M===void 0?void 0:M.get(Y))||R.includeChildren&&((U=this.added)===null||U===void 0?void 0:U.findSuperstr(Y)))||(!Re||B.includes(0))&&(((q=this.updated)===null||q===void 0?void 0:q.get(Y))||R.includeChildren&&((V=this.updated)===null||V===void 0?void 0:V.findSuperstr(Y)))||(!Re||B.includes(2))&&(((oe=this.deleted)===null||oe===void 0?void 0:oe.findSubstr(Y))||R.includeChildren&&((ge=this.deleted)===null||ge===void 0?void 0:ge.findSuperstr(Y))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType(Y){const R=[],B=Y===1?this.added:Y===0?this.updated:this.deleted;if(B)for(const[,M]of B)R.push(M);return R}filter(Y){return new b(this.changes.filter(R=>Y(R)),this.ignorePathCasing)}}e.FileChangesEvent=b;function p(z,Y,R){return!z||!Y||z===Y||Y.length>z.length?!1:(Y.charAt(Y.length-1)!==T.sep&&(Y+=T.sep),R?C.startsWithIgnoreCase(z,Y):z.indexOf(Y)===0)}e.isParent=p;class P extends Error{constructor(Y,R,B){super(Y);this.fileOperationResult=R,this.options=B}}e.FileOperationError=P;class A extends P{constructor(Y,R,B){super(Y,2,B);this.stat=R}}e.NotModifiedSinceFileOperationError=A;var a;(function(z){z[z.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",z[z.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",z[z.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",z[z.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",z[z.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",z[z.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",z[z.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",z[z.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",z[z.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",z[z.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",z[z.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",z[z.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(a=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var F;(function(z){z[z.FILE=0]="FILE",z[z.FOLDER=1]="FOLDER",z[z.ROOT_FOLDER=2]="ROOT_FOLDER"})(F=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function N(z){if(!(typeof z.size!="number"||typeof z.mtime!="number"))return z.mtime.toString(29)+z.size.toString(31)}e.etag=N;async function H(z,Y){if(!Y.canHandleResource(D.URI.from({scheme:z.scheme})))return new Promise(R=>{const B=Y.onDidChangeFileSystemProviderRegistrations(M=>{M.scheme===z.scheme&&M.added&&(B.dispose(),R())})})}e.whenProviderRegistered=H,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class le{static formatSize(Y){return y.isNumber(Y)||(Y=0),Y<le.KB?g.localize(1,null,Y.toFixed(0)):Y<le.MB?g.localize(2,null,(Y/le.KB).toFixed(2)):Y<le.GB?g.localize(3,null,(Y/le.MB).toFixed(2)):Y<le.TB?g.localize(4,null,(Y/le.GB).toFixed(2)):g.localize(5,null,(Y/le.TB).toFixed(2))}}e.ByteSize=le,le.KB=1024,le.MB=le.KB*le.KB,le.GB=le.MB*le.KB,le.TB=le.GB*le.KB;var fe;(function(z){z[z.IA32=0]="IA32",z[z.OTHER=1]="OTHER"})(fe=e.Arch||(e.Arch={}));function X(z){return{maxFileSize:z===0?300*le.MB:16*le.GB,maxHeapSize:z===0?700*le.MB:2*700*le.MB}}e.getPlatformLimits=X}),define(we[60],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class g{constructor(...D){this._entries=new Map;for(let[E,C]of D)this.set(E,C)}set(D,E){const C=this._entries.get(D);return this._entries.set(D,E),C}has(D){return this._entries.has(D)}get(D){return this._entries.get(D)}}e.ServiceCollection=g}),define(we[144],_e([0,1,12,140,87,5,60,11]),function(Z,e,g,T,D,E,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const _=!1;class k extends Error{constructor(d){var u;super("cyclic dependency between services");this.message=(u=d.findCycleSlow())!==null&&u!==void 0?u:`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class n{constructor(d=new C.ServiceCollection,u=!1,w){this._activeInstantiations=new Set,this._services=d,this._strict=u,this._parent=w,this._services.set(E.IInstantiationService,this)}createChild(d){return new n(d,this._strict,this)}invokeFunction(d,...u){let w=o.traceInvocation(d),v=!1;try{return d({get:(c,m)=>{if(v)throw g.illegalState("service accessor is only valid during the invocation of its target method");const f=this._getOrCreateServiceInstance(c,w);if(!f&&m!==E.optional)throw new Error(`[invokeFunction] unknown service '${c}'`);return f}},...u)}finally{v=!0,w.stop()}}createInstance(d,...u){let w,v;return d instanceof D.SyncDescriptor?(w=o.traceCreation(d.ctor),v=this._createInstance(d.ctor,d.staticArguments.concat(u),w)):(w=o.traceCreation(d),v=this._createInstance(d,u,w)),w.stop(),v}_createInstance(d,u=[],w){let v=E._util.getServiceDependencies(d).sort((m,f)=>m.index-f.index),S=[];for(const m of v){let f=this._getOrCreateServiceInstance(m.id,w);if(!f&&this._strict&&!m.optional)throw new Error(`[createInstance] ${d.name} depends on UNKNOWN service ${m.id}.`);S.push(f)}let c=v.length>0?v[0].index:u.length;if(u.length!==c){console.warn(`[createInstance] First service dependency of ${d.name} at position ${c+1} conflicts with ${u.length} static arguments`);let m=c-u.length;m>0?u=u.concat(new Array(m)):u=u.slice(0,c)}return new d(...[...u,...S])}_setServiceInstance(d,u){if(this._services.get(d)instanceof D.SyncDescriptor)this._services.set(d,u);else if(this._parent)this._parent._setServiceInstance(d,u);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(d){let u=this._services.get(d);return!u&&this._parent?this._parent._getServiceInstanceOrDescriptor(d):u}_getOrCreateServiceInstance(d,u){let w=this._getServiceInstanceOrDescriptor(d);return w instanceof D.SyncDescriptor?this._safeCreateAndCacheServiceInstance(d,w,u.branch(d,!0)):(u.branch(d,!1),w)}_safeCreateAndCacheServiceInstance(d,u,w){if(this._activeInstantiations.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this._activeInstantiations.add(d);try{return this._createAndCacheServiceInstance(d,u,w)}finally{this._activeInstantiations.delete(d)}}_createAndCacheServiceInstance(d,u,w){const v=new T.Graph(m=>m.id.toString());let S=0;const c=[{id:d,desc:u,_trace:w}];for(;c.length;){const m=c.pop();if(v.lookupOrInsertNode(m),S++>1e3)throw new k(v);for(let f of E._util.getServiceDependencies(m.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(f.id);if(!t&&!f.optional&&console.warn(`[createInstance] ${d} depends on ${f.id} which is NOT registered.`),t instanceof D.SyncDescriptor){const r={id:f.id,desc:t,_trace:m._trace.branch(f.id,!0)};v.insertEdge(m,r),c.push(r)}}}for(;;){const m=v.roots();if(m.length===0){if(!v.isEmpty())throw new k(v);break}for(const{data:f}of m){if(this._getServiceInstanceOrDescriptor(f.id)instanceof D.SyncDescriptor){const r=this._createServiceInstanceWithOwner(f.id,f.desc.ctor,f.desc.staticArguments,f.desc.supportsDelayedInstantiation,f._trace);this._setServiceInstance(f.id,r)}v.removeNode(f)}}return this._getServiceInstanceOrDescriptor(d)}_createServiceInstanceWithOwner(d,u,w=[],v,S){if(this._services.get(d)instanceof D.SyncDescriptor)return this._createServiceInstance(u,w,v,S);if(this._parent)return this._parent._createServiceInstanceWithOwner(d,u,w,v,S);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}_createServiceInstance(d,u=[],w,v){if(w){const S=new y.IdleValue(()=>this._createInstance(d,u,v));return new Proxy(Object.create(null),{get(c,m){if(m in c)return c[m];let f=S.value,t=f[m];return typeof t!="function"||(t=t.bind(f),c[m]=t),t},set(c,m,f){return S.value[m]=f,!0}})}else return this._createInstance(d,u,v)}}e.InstantiationService=n;var I;(function(h){h[h.Creation=0]="Creation",h[h.Invocation=1]="Invocation",h[h.Branch=2]="Branch"})(I||(I={}));class o{constructor(d,u){this.type=d,this.name=u,this._start=Date.now(),this._dep=[]}static traceInvocation(d){return _?new o(1,d.name||d.toString().substring(0,42).replace(/\n/g,"")):o._None}static traceCreation(d){return _?new o(0,d.name):o._None}branch(d,u){let w=new o(2,d.toString());return this._dep.push([d,u,w]),w}stop(){let d=Date.now()-this._start;o._totals+=d;let u=!1;function w(S,c){let m=[],f=new Array(S+1).join("	");for(const[t,r,i]of c._dep)if(r&&i){u=!0,m.push(`${f}CREATES -> ${t}`);let s=w(S+1,i);s&&m.push(s)}else m.push(`${f}uses -> ${t}`);return m.join(`
`)}let v=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${w(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${o._totals.toFixed(2)}ms)`];(d>2||u)&&console.log(v.join(`
`))}}o._None=new class extends o{constructor(){super(-1,null)}stop(){}branch(){return this}},o._totals=0}),define(we[17],_e([0,1,5,7,21,3,56]),function(Z,e,g,T,D,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=g.createDecorator("logService"),e.ILoggerService=g.createDecorator("loggerService");function y(){return new Date().toISOString()}var _;(function(f){f[f.Trace=0]="Trace",f[f.Debug=1]="Debug",f[f.Info=2]="Info",f[f.Warning=3]="Warning",f[f.Error=4]="Error",f[f.Critical=5]="Critical",f[f.Off=6]="Off"})(_=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=_.Info;class k extends T.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new E.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=k;class n extends k{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...r){this.checkLogLevel(_.Trace)&&this.log(_.Trace,this.format([t,...r]))}debug(t,...r){this.checkLogLevel(_.Debug)&&this.log(_.Debug,this.format([t,...r]))}info(t,...r){this.checkLogLevel(_.Info)&&this.log(_.Info,this.format([t,...r]))}warn(t,...r){this.checkLogLevel(_.Warning)&&this.log(_.Warning,this.format([t,...r]))}error(t,...r){if(this.checkLogLevel(_.Error))if(t instanceof Error){const i=Array.prototype.slice.call(arguments);i[0]=t.stack,this.log(_.Error,this.format(i))}else this.log(_.Error,this.format([t,...r]))}critical(t,...r){this.checkLogLevel(_.Critical)&&this.log(_.Critical,this.format([t,...r]))}flush(){}format(t){let r="";for(let i=0;i<t.length;i++){let s=t[i];if(typeof s=="object")try{s=JSON.stringify(s)}catch(l){}r+=(i>0?" ":"")+s}return r}}e.AbstractMessageLogger=n;class I extends k{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!D.isWindows}trace(t,...r){this.getLevel()<=_.Trace&&(this.useColors?console.log(`[90m[main ${y()}][0m`,t,...r):console.log(`[main ${y()}]`,t,...r))}debug(t,...r){this.getLevel()<=_.Debug&&(this.useColors?console.log(`[90m[main ${y()}][0m`,t,...r):console.log(`[main ${y()}]`,t,...r))}info(t,...r){this.getLevel()<=_.Info&&(this.useColors?console.log(`[90m[main ${y()}][0m`,t,...r):console.log(`[main ${y()}]`,t,...r))}warn(t,...r){this.getLevel()<=_.Warning&&(this.useColors?console.warn(`[93m[main ${y()}][0m`,t,...r):console.warn(`[main ${y()}]`,t,...r))}error(t,...r){this.getLevel()<=_.Error&&(this.useColors?console.error(`[91m[main ${y()}][0m`,t,...r):console.error(`[main ${y()}]`,t,...r))}critical(t,...r){this.getLevel()<=_.Critical&&(this.useColors?console.error(`[90m[main ${y()}][0m`,t,...r):console.error(`[main ${y()}]`,t,...r))}dispose(){}flush(){}}e.ConsoleMainLogger=I;class o extends k{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...r){this.getLevel()<=_.Trace&&console.log("%cTRACE","color: #888",t,...r)}debug(t,...r){this.getLevel()<=_.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...r)}info(t,...r){this.getLevel()<=_.Info&&console.log("%c INFO","color: #33f",t,...r)}warn(t,...r){this.getLevel()<=_.Warning&&console.log("%c WARN","color: #993",t,...r)}error(t,...r){this.getLevel()<=_.Error&&console.log("%c  ERR","color: #f33",t,...r)}critical(t,...r){this.getLevel()<=_.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...r)}dispose(){}flush(){}}e.ConsoleLogger=o;class h extends k{constructor(t,r=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(r)}trace(t,...r){this.getLevel()<=_.Trace&&this.adapter.log(_.Trace,[this.extractMessage(t),...r])}debug(t,...r){this.getLevel()<=_.Debug&&this.adapter.log(_.Debug,[this.extractMessage(t),...r])}info(t,...r){this.getLevel()<=_.Info&&this.adapter.log(_.Info,[this.extractMessage(t),...r])}warn(t,...r){this.getLevel()<=_.Warning&&this.adapter.log(_.Warning,[this.extractMessage(t),...r])}error(t,...r){this.getLevel()<=_.Error&&this.adapter.log(_.Error,[this.extractMessage(t),...r])}critical(t,...r){this.getLevel()<=_.Critical&&this.adapter.log(_.Critical,[this.extractMessage(t),...r])}extractMessage(t){return typeof t=="string"?t:C.toErrorMessage(t,this.getLevel()<=_.Trace)}dispose(){}flush(){}}e.AdapterLogger=h;class d extends k{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const r of this.logServices)r.setLevel(t);super.setLevel(t)}trace(t,...r){for(const i of this.logServices)i.trace(t,...r)}debug(t,...r){for(const i of this.logServices)i.debug(t,...r)}info(t,...r){for(const i of this.logServices)i.info(t,...r)}warn(t,...r){for(const i of this.logServices)i.warn(t,...r)}error(t,...r){for(const i of this.logServices)i.error(t,...r)}critical(t,...r){for(const i of this.logServices)i.critical(t,...r)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=d;class u extends T.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...r){this.logger.trace(t,...r)}debug(t,...r){this.logger.debug(t,...r)}info(t,...r){this.logger.info(t,...r)}warn(t,...r){this.logger.warn(t,...r)}error(t,...r){this.logger.error(t,...r)}critical(t,...r){this.logger.critical(t,...r)}flush(){this.logger.flush()}}e.LogService=u;class w extends T.Disposable{constructor(t,r){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(r(i=>{this.logLevel=i,this.logLevelChangeableLoggers.forEach(s=>s.setLevel(i))}))}createLogger(t,r){let i=this.loggers.get(t.toString());return i||(i=this.doCreateLogger(t,(r==null?void 0:r.always)?_.Trace:this.logLevel,r),this.loggers.set(t.toString(),i),(r==null?void 0:r.always)||this.logLevelChangeableLoggers.push(i)),i}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=w;class v{constructor(){this.onDidChangeLogLevel=new E.Emitter().event}setLevel(t){}getLevel(){return _.Info}trace(t,...r){}debug(t,...r){}info(t,...r){}warn(t,...r){}error(t,...r){}critical(t,...r){}dispose(){}flush(){}}e.NullLogService=v;function S(f){if(f.verbose)return _.Trace;if(typeof f.logLevel=="string"){const t=c(f.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=S;function c(f){switch(f){case"trace":return _.Trace;case"debug":return _.Debug;case"info":return _.Info;case"warn":return _.Warning;case"error":return _.Error;case"critical":return _.Critical;case"off":return _.Off}}e.parseLogLevel=c;function m(f){switch(f){case _.Trace:return"trace";case _.Debug:return"debug";case _.Info:return"info";case _.Warning:return"warn";case _.Error:return"error";case _.Critical:return"critical";case _.Off:return"off"}}e.LogLevelToString=m}),define(we[89],_e([0,1,5,126,41]),function(Z,e,g,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var E;(function(_){_[_.Unnecessary=1]="Unnecessary",_[_.Deprecated=2]="Deprecated"})(E=e.MarkerTag||(e.MarkerTag={}));var C;(function(_){_[_.Hint=1]="Hint",_[_.Info=2]="Info",_[_.Warning=4]="Warning",_[_.Error=8]="Error"})(C=e.MarkerSeverity||(e.MarkerSeverity={})),function(_){function k(d,u){return u-d}_.compare=k;const n=Object.create(null);n[_.Error]=T.localize(0,null),n[_.Warning]=T.localize(1,null),n[_.Info]=T.localize(2,null);function I(d){return n[d]||""}_.toString=I;function o(d){switch(d){case D.default.Error:return _.Error;case D.default.Warning:return _.Warning;case D.default.Info:return _.Info;case D.default.Ignore:return _.Hint}}_.fromSeverity=o;function h(d){switch(d){case _.Error:return D.default.Error;case _.Warning:return D.default.Warning;case _.Info:return D.default.Info;case _.Hint:return D.default.Ignore}}_.toSeverity=h}(C=e.MarkerSeverity||(e.MarkerSeverity={}));var y;(function(_){const k="";function n(o){return I(o,!0)}_.makeKey=n;function I(o,h){let d=[k];return o.source?d.push(o.source.replace("\xA6","\\\xA6")):d.push(k),o.code?typeof o.code=="string"?d.push(o.code.replace("\xA6","\\\xA6")):d.push(o.code.value.replace("\xA6","\\\xA6")):d.push(k),o.severity!==void 0&&o.severity!==null?d.push(C.toString(o.severity)):d.push(k),o.message&&h?d.push(o.message.replace("\xA6","\\\xA6")):d.push(k),o.startLineNumber!==void 0&&o.startLineNumber!==null?d.push(o.startLineNumber.toString()):d.push(k),o.startColumn!==void 0&&o.startColumn!==null?d.push(o.startColumn.toString()):d.push(k),o.endLineNumber!==void 0&&o.endLineNumber!==null?d.push(o.endLineNumber.toString()):d.push(k),o.endColumn!==void 0&&o.endColumn!==null?d.push(o.endColumn.toString()):d.push(k),d.push(k),d.join("\xA6")}_.makeKeyOptionalMessage=I})(y=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=g.createDecorator("markerService")}),define(we[145],_e([0,1,41,5,3]),function(Z,e,g,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=g.default,e.INotificationService=T.createDecorator("notificationService");var E;(function(k){k[k.WORKSPACE=0]="WORKSPACE",k[k.GLOBAL=1]="GLOBAL"})(E=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var C;(function(k){k[k.OFF=0]="OFF",k[k.SILENT=1]="SILENT",k[k.ERROR=2]="ERROR"})(C=e.NotificationsFilter||(e.NotificationsFilter={}));class y{constructor(){this.progress=new _,this.onDidClose=D.Event.None,this.onDidChangeVisibility=D.Event.None}updateSeverity(n){}updateMessage(n){}updateActions(n){}close(){}}e.NoOpNotification=y;class _{infinite(){}done(){}total(n){}worked(n){}}e.NoOpProgress=_}),define(we[146],_e([0,1,7,8,2,5]),function(Z,e,g,T,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=E.createDecorator("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return g.Disposable.None},registerValidator(){return g.Disposable.None},registerExternalUriResolver(){return g.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return g.Disposable.None},async open(){return!1},async resolveExternalUri(y){return{resolved:y,dispose(){}}}});function C(y,_){return D.URI.isUri(y)?T.equalsIgnoreCase(y.scheme,_):T.startsWithIgnoreCase(y,_+":")}e.matchesScheme=C});var He=this&&this.__decorate||function(Z,e,g,T){var D=arguments.length,E=D<3?e:T===null?T=Object.getOwnPropertyDescriptor(e,g):T,C;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")E=Reflect.decorate(Z,e,g,T);else for(var y=Z.length-1;y>=0;y--)(C=Z[y])&&(E=(D<3?C(E):D>3?C(e,g,E):C(e,g))||E);return D>3&&E&&Object.defineProperty(e,g,E),E},ze=this&&this.__param||function(Z,e){return function(g,T){e(g,T,Z)}};define(we[147],_e([0,1,5,18,7,11]),function(Z,e,g,T,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=g.createDecorator("progressService");var C;(function(n){n[n.Explorer=1]="Explorer",n[n.Scm=3]="Scm",n[n.Extensions=5]="Extensions",n[n.Window=10]="Window",n[n.Notification=15]="Notification",n[n.Dialog=20]="Dialog"})(C=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class y{constructor(I){this.callback=I}get value(){return this._value}report(I){this._value=I,this.callback(this._value)}}e.Progress=y,y.None=Object.freeze({report(){}});let _=class extends D.Disposable{constructor(I,o){super();this.deferred=new E.DeferredPromise,o.withProgress(I,h=>(this.reporter=h,this.lastStep&&h.report(this.lastStep),this.deferred.p)),this._register(D.toDisposable(()=>this.deferred.complete()))}report(I){this.reporter?this.reporter.report(I):this.lastStep=I}};_=He([ze(1,e.IProgressService)],_),e.UnmanagedProgress=_;class k extends D.Disposable{constructor(I){super();this.progressIndicator=I,this.currentOperationId=0,this.currentOperationDisposables=this._register(new D.DisposableStore)}start(I){this.stop();const o=++this.currentOperationId,h=new T.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{o===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},I),this.currentOperationDisposables.add(D.toDisposable(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add(D.toDisposable(()=>h.cancel())),this.currentOperationDisposables.add(D.toDisposable(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:o,token:h.token,stop:()=>this.doStop(o),isCurrent:()=>this.currentOperationId===o}}stop(){this.doStop(this.currentOperationId)}doStop(I){this.currentOperationId===I&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=k,e.IEditorProgressService=g.createDecorator("editorProgressService")}),define(we[43],_e([0,1,10,39]),function(Z,e,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.data=new Map}add(C,y){T.ok(g.isString(C)),T.ok(g.isObject(y)),T.ok(!this.data.has(C),"There is already an extension with this id"),this.data.set(C,y)}knows(C){return this.data.has(C)}as(C){return this.data.get(C)||null}}e.Registry=new D}),define(we[148],_e([0,1,43,3]),function(Z,e,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(y){return y.length>0&&y.charAt(y.length-1)==="#"?y.substring(0,y.length-1):y}class E{constructor(){this._onDidChangeSchema=new T.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(_,k){this.schemasById[D(_)]=k,this._onDidChangeSchema.fire(_)}notifySchemaChanged(_){this._onDidChangeSchema.fire(_)}getSchemaContributions(){return{schemas:this.schemasById}}}const C=new E;g.Registry.add(e.Extensions.JSONContribution,C)}),define(we[61],_e([0,1,123,3,43,10,148]),function(Z,e,g,T,D,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var y;(function(w){w[w.APPLICATION=1]="APPLICATION",w[w.MACHINE=2]="MACHINE",w[w.WINDOW=3]="WINDOW",w[w.RESOURCE=4]="RESOURCE",w[w.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",w[w.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(y=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const _=D.Registry.as(C.Extensions.JSONContribution);class k{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new T.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new T.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:g.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},_.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(v,S=!0){this.registerConfigurations([v],S)}registerConfigurations(v,S=!0){const c=[];v.forEach(m=>{c.push(...this.validateAndRegisterProperties(m,S,m.extensionInfo)),this.configurationContributors.push(m),this.registerJSONConfiguration(m)}),_.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}deregisterConfigurations(v){const S=[],c=m=>{if(m.properties)for(const f in m.properties)S.push(f),delete this.configurationProperties[f],this.removeFromSchema(f,m.properties[f]);m.allOf&&m.allOf.forEach(f=>c(f))};for(const m of v){c(m);const f=this.configurationContributors.indexOf(m);f!==-1&&this.configurationContributors.splice(f,1)}_.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(S)}registerDefaultConfigurations(v){const S=[],c=[];for(const m of v)for(const f in m)if(S.push(f),e.OVERRIDE_PROPERTY_PATTERN.test(f)){this.defaultValues[f]=Object.assign(Object.assign({},this.defaultValues[f]||{}),m[f]);const t={type:"object",default:this.defaultValues[f],description:g.localize(1,null,f),$ref:e.resourceLanguageSettingsSchemaId};c.push(I(f)),this.configurationProperties[f]=t,this.defaultLanguageConfigurationOverridesNode.properties[f]=t}else{this.defaultValues[f]=m[f];const t=this.configurationProperties[f];t&&(this.updatePropertyDefaultValue(f,t),this.updateSchema(f,t))}this.registerOverrideIdentifiers(c),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(S)}deregisterDefaultConfigurations(v){const S=[];for(const c of v)for(const m in c)if(S.push(m),delete this.defaultValues[m],e.OVERRIDE_PROPERTY_PATTERN.test(m))delete this.configurationProperties[m],delete this.defaultLanguageConfigurationOverridesNode.properties[m];else{const f=this.configurationProperties[m];f&&(this.updatePropertyDefaultValue(m,f),this.updateSchema(m,f))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(S)}notifyConfigurationSchemaUpdated(...v){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(v){for(const S of v)this.overrideIdentifiers.add(S);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(v,S=!0,c,m=3){var f;m=E.isUndefinedOrNull(v.scope)?m:v.scope;let t=[],r=v.properties;if(r)for(let s in r){if(S&&d(s)){delete r[s];continue}const l=r[s];if(this.updatePropertyDefaultValue(s,l),e.OVERRIDE_PROPERTY_PATTERN.test(s)?l.scope=void 0:(l.scope=E.isUndefinedOrNull(l.scope)?m:l.scope,l.restricted=E.isUndefinedOrNull(l.restricted)?!!((f=c==null?void 0:c.restrictedConfigurations)===null||f===void 0?void 0:f.includes(s)):l.restricted),r[s].hasOwnProperty("included")&&!r[s].included){this.excludedConfigurationProperties[s]=r[s],delete r[s];continue}else this.configurationProperties[s]=r[s];!r[s].deprecationMessage&&r[s].markdownDeprecationMessage&&(r[s].deprecationMessage=r[s].markdownDeprecationMessage),t.push(s)}let i=v.allOf;if(i)for(let s of i)t.push(...this.validateAndRegisterProperties(s,S,c,m));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(v){const S=c=>{let m=c.properties;if(m)for(const t in m)this.updateSchema(t,m[t]);let f=c.allOf;f&&f.forEach(S)};S(v)}updateSchema(v,S){switch(e.allSettings.properties[v]=S,S.scope){case 1:e.applicationSettings.properties[v]=S;break;case 2:e.machineSettings.properties[v]=S;break;case 6:e.machineOverridableSettings.properties[v]=S;break;case 3:e.windowSettings.properties[v]=S;break;case 4:e.resourceSettings.properties[v]=S;break;case 5:e.resourceSettings.properties[v]=S,this.resourceLanguageSettingsSchema.properties[v]=S;break}}removeFromSchema(v,S){switch(delete e.allSettings.properties[v],S.scope){case 1:delete e.applicationSettings.properties[v];break;case 2:delete e.machineSettings.properties[v];break;case 6:delete e.machineOverridableSettings.properties[v];break;case 3:delete e.windowSettings.properties[v];break;case 4:case 5:delete e.resourceSettings.properties[v];break}}updateOverridePropertyPatternKey(){for(const v of this.overrideIdentifiers.values()){const S=`[${v}]`,c={type:"object",description:g.localize(2,null),errorMessage:g.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(S,c),e.allSettings.properties[S]=c,e.applicationSettings.properties[S]=c,e.machineSettings.properties[S]=c,e.machineOverridableSettings.properties[S]=c,e.windowSettings.properties[S]=c,e.resourceSettings.properties[S]=c}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(v,S){let c=this.defaultValues[v];E.isUndefined(c)&&(c=S.default),E.isUndefined(c)&&(c=o(S.type)),S.default=c}}const n="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(n);function I(w){return w.substring(1,w.length-1)}e.overrideIdentifierFromKey=I;function o(w){switch(Array.isArray(w)?w[0]:w){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=o;const h=new k;D.Registry.add(e.Extensions.Configuration,h);function d(w){return w.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(w)?g.localize(5,null,w):h.getConfigurationProperties()[w]!==void 0?g.localize(6,null,w):null:g.localize(4,null)}e.validateProperty=d;function u(){const w=[],v=h.getConfigurationProperties();for(const S of Object.keys(v))w.push([S,v[S].scope]);return w.push(["launch",4]),w.push(["task",4]),w}e.getScopes=u}),define(we[90],_e([0,1,24,10,2,43,5,61]),function(Z,e,g,T,D,E,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=C.createDecorator("configurationService");function _(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof D.URI)}e.isConfigurationOverrides=_;var k;(function(r){r[r.USER=1]="USER",r[r.USER_LOCAL=2]="USER_LOCAL",r[r.USER_REMOTE=3]="USER_REMOTE",r[r.WORKSPACE=4]="WORKSPACE",r[r.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",r[r.DEFAULT=6]="DEFAULT",r[r.MEMORY=7]="MEMORY"})(k=e.ConfigurationTarget||(e.ConfigurationTarget={}));function n(r){switch(r){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=n;function I(r,i){const s=i?r?i.keys.filter(F=>r.keys.indexOf(F)===-1):[...i.keys]:[],l=r?i?r.keys.filter(F=>i.keys.indexOf(F)===-1):[...r.keys]:[],b=[];if(i&&r){for(const F of r.keys)if(i.keys.indexOf(F)!==-1){const N=v(r.contents,F),H=v(i.contents,F);g.equals(N,H)||b.push(F)}}const p=[],P=F=>{const N={};for(const H of F)for(const le of H.identifiers)N[f(le)]=H;return N},A=i?P(i.overrides):{},a=r?P(r.overrides):{};if(Object.keys(A).length)for(const F of s){const N=A[F];N&&p.push([y.overrideIdentifierFromKey(F),N.keys])}if(Object.keys(a).length)for(const F of l){const N=a[F];N&&p.push([y.overrideIdentifierFromKey(F),N.keys])}if(Object.keys(A).length&&Object.keys(a).length)for(const F of b){const N=a[F],H=A[F];if(N&&H){const le=I({contents:N.contents,keys:N.keys,overrides:[]},{contents:H.contents,keys:H.keys,overrides:[]});p.push([y.overrideIdentifierFromKey(F),[...le.added,...le.removed,...le.updated]])}}return{added:s,removed:l,updated:b,overrides:p}}e.compare=I;function o(r,i){const s=[];for(const l of Object.keys(r))if(y.OVERRIDE_PROPERTY_PATTERN.test(l)){const b={};for(const p in r[l])b[p]=r[l][p];s.push({identifiers:[y.overrideIdentifierFromKey(l).trim()],keys:Object.keys(b),contents:h(b,i)})}return s}e.toOverrides=o;function h(r,i){const s=Object.create(null);for(let l in r)d(s,l,r[l],i);return s}e.toValuesTree=h;function d(r,i,s,l){const b=i.split("."),p=b.pop();let P=r;for(let A=0;A<b.length;A++){let a=b[A],F=P[a];switch(typeof F){case"undefined":F=P[a]=Object.create(null);break;case"object":break;default:l(`Ignoring ${i} as ${b.slice(0,A+1).join(".")} is ${JSON.stringify(F)}`);return}P=F}if(typeof P=="object"&&P!==null)try{P[p]=s}catch(A){l(`Ignoring ${i} as ${b.join(".")} is ${JSON.stringify(P)}`)}else l(`Ignoring ${i} as ${b.join(".")} is ${JSON.stringify(P)}`)}e.addToValueTree=d;function u(r,i){const s=i.split(".");w(r,s)}e.removeFromValueTree=u;function w(r,i){const s=i.shift();if(i.length===0){delete r[s];return}if(Object.keys(r).indexOf(s)!==-1){const l=r[s];typeof l=="object"&&!Array.isArray(l)&&(w(l,i),Object.keys(l).length===0&&delete r[s])}}function v(r,i,s){function l(P,A){let a=P;for(const F of A){if(typeof a!="object"||a===null)return;a=a[F]}return a}const b=i.split("."),p=l(r,b);return typeof p=="undefined"?s:p}e.getConfigurationValue=v;function S(r,i,s){Object.keys(i).forEach(l=>{l!=="__proto__"&&(l in r?T.isObject(r[l])&&T.isObject(i[l])?S(r[l],i[l],s):s&&(r[l]=i[l]):r[l]=i[l])})}e.merge=S;function c(){const r=E.Registry.as(y.Extensions.Configuration).getConfigurationProperties();return Object.keys(r)}e.getConfigurationKeys=c;function m(){const r=Object.create(null),i=E.Registry.as(y.Extensions.Configuration).getConfigurationProperties();for(let s in i){let l=i[s].default;d(r,s,l,b=>console.error(`Conflict in default settings: ${b}`))}return r}e.getDefaultValues=m;function f(r){return`[${r}]`}e.keyFromOverrideIdentifier=f;function t(r,i,s){const l=r.inspect(i),b=r.inspect(s);return typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:typeof b.userValue!="undefined"||typeof b.workspaceValue!="undefined"||typeof b.workspaceFolderValue!="undefined"?b.value:l.defaultValue}e.getMigratedSettingValue=t}),define(we[149],_e([0,1,105,22,16,10,24,2,61,90,43,7,3]),function(Z,e,g,T,D,E,C,y,_,k,n,I,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class h{constructor(t={},r=[],i=[]){this._contents=t,this._keys=r,this._overrides=i,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?k.getConfigurationValue(this.contents,t):this.contents}getOverrideValue(t,r){const i=this.getContentsForOverrideIdentifer(r);return i?t?k.getConfigurationValue(i,t):i:void 0}getKeysForOverrideIdentifier(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.keys;return[]}override(t){const r=this.getContentsForOverrideIdentifer(t);if(!r||typeof r!="object"||!Object.keys(r).length)return this;let i={};for(const s of D.distinct([...Object.keys(this.contents),...Object.keys(r)])){let l=this.contents[s],b=r[s];b&&(typeof l=="object"&&typeof b=="object"?(l=C.deepClone(l),this.mergeContents(l,b)):l=b),i[s]=l}return new h(i,this.keys,this.overrides)}merge(...t){const r=C.deepClone(this.contents),i=C.deepClone(this.overrides),s=[...this.keys];for(const l of t){this.mergeContents(r,l.contents);for(const b of l.overrides){const[p]=i.filter(P=>D.equals(P.identifiers,b.identifiers));p?this.mergeContents(p.contents,b.contents):i.push(C.deepClone(b))}for(const b of l.keys)s.indexOf(b)===-1&&s.push(b)}return new h(r,s,i)}freeze(){return this.isFrozen=!0,this}mergeContents(t,r){for(const i of Object.keys(r)){if(i in t&&E.isObject(t[i])&&E.isObject(r[i])){this.mergeContents(t[i],r[i]);continue}t[i]=C.deepClone(r[i])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?C.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,r){this.addKey(t),k.addToValueTree(this.contents,t,r,i=>{throw new Error(i)})}removeValue(t){this.removeKey(t)&&k.removeFromValueTree(this.contents,t)}addKey(t){let r=this.keys.length;for(let i=0;i<r;i++)t.indexOf(this.keys[i])===0&&(r=i);this.keys.splice(r,1,t)}removeKey(t){let r=this.keys.indexOf(t);return r!==-1?(this.keys.splice(r,1),!0):!1}}e.ConfigurationModel=h;class d extends h{constructor(){const t=k.getDefaultValues(),r=k.getConfigurationKeys(),i=[];for(const s of Object.keys(t))_.OVERRIDE_PROPERTY_PATTERN.test(s)&&i.push({identifiers:[_.overrideIdentifierFromKey(s).trim()],keys:Object.keys(t[s]),contents:k.toValuesTree(t[s],l=>console.error(`Conflict in default settings file: ${l}`))});super(t,r,i)}}e.DefaultConfigurationModel=d;class u{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new h}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,r){if(!E.isUndefinedOrNull(t)){const i=this.doParseContent(t);this.parseRaw(i,r)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,r){this._raw=t;const{contents:i,keys:s,overrides:l,restricted:b}=this.doParseRaw(t,r);this._configurationModel=new h(i,s,l),this._restrictedConfigurations=b||[]}doParseContent(t){let r={},i=null,s=[],l=[],b=[];function p(A){Array.isArray(s)?s.push(A):i&&(s[i]=A)}let P={onObjectBegin:()=>{let A={};p(A),l.push(s),s=A,i=null},onObjectProperty:A=>{i=A},onObjectEnd:()=>{s=l.pop()},onArrayBegin:()=>{let A=[];p(A),l.push(s),s=A,i=null},onArrayEnd:()=>{s=l.pop()},onLiteralValue:p,onError:(A,a,F)=>{b.push({error:A,offset:a,length:F})}};if(t)try{g.visit(t,P),r=s[0]||{}}catch(A){console.error(`Error while parsing settings file ${this._name}: ${A}`),this._parseErrors=[A]}return r}doParseRaw(t,r){const i=n.Registry.as(_.Extensions.Configuration).getConfigurationProperties(),s=this.filter(t,i,!0,r);t=s.raw;const l=k.toValuesTree(t,P=>console.error(`Conflict in settings file ${this._name}: ${P}`)),b=Object.keys(t),p=k.toOverrides(t,P=>console.error(`Conflict in settings file ${this._name}: ${P}`));return{contents:l,keys:b,overrides:p,restricted:s.restricted}}filter(t,r,i,s){if(!(s==null?void 0:s.scopes)&&!(s==null?void 0:s.skipRestricted))return{raw:t,restricted:[]};const l={},b=[];for(let p in t)if(_.OVERRIDE_PROPERTY_PATTERN.test(p)&&i){const P=this.filter(t[p],r,!1,s);l[p]=P.raw,b.push(...P.restricted)}else{const P=r[p],A=P?typeof P.scope!="undefined"?P.scope:3:void 0;(P==null?void 0:P.restricted)&&b.push(p),(A===void 0||s.scopes===void 0||s.scopes.includes(A))&&(s.skipRestricted&&(P==null?void 0:P.restricted)||(l[p]=t[p]))}return{raw:l,restricted:b}}}e.ConfigurationModelParser=u;class w extends I.Disposable{constructor(t,r,i,s){super();this.userSettingsResource=t,this.scopes=r,this.fileService=s,this._onDidChange=this._register(new o.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new u(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(i.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(o.Event.filter(this.fileService.onDidFilesChange,l=>l.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new h}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=w;class v{constructor(t,r,i=new h,s=new h,l=new T.ResourceMap,b=new h,p=new T.ResourceMap,P=!0){this._defaultConfiguration=t,this._localUserConfiguration=r,this._remoteUserConfiguration=i,this._workspaceConfiguration=s,this._folderConfigurations=l,this._memoryConfiguration=b,this._memoryConfigurationByResource=p,this._freeze=P,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new T.ResourceMap,this._userConfiguration=null}getValue(t,r,i){return this.getConsolidateConfigurationModel(r,i).getValue(t)}updateValue(t,r,i={}){let s;i.resource?(s=this._memoryConfigurationByResource.get(i.resource),s||(s=new h,this._memoryConfigurationByResource.set(i.resource,s))):s=this._memoryConfiguration,r===void 0?s.removeValue(t):s.setValue(t,r),i.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,r,i){const s=this.getConsolidateConfigurationModel(r,i),l=this.getFolderConfigurationModelForResource(r.resource,i),b=r.resource?this._memoryConfigurationByResource.get(r.resource)||this._memoryConfiguration:this._memoryConfiguration,p=r.overrideIdentifier?this._defaultConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),P=r.overrideIdentifier?this.userConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),A=r.overrideIdentifier?this.localUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),a=r.overrideIdentifier?this.remoteUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),F=i?r.overrideIdentifier?this._workspaceConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,N=l?r.overrideIdentifier?l.freeze().override(r.overrideIdentifier).getValue(t):l.freeze().getValue(t):void 0,H=r.overrideIdentifier?b.override(r.overrideIdentifier).getValue(t):b.getValue(t),le=s.getValue(t),fe=D.distinct(D.flatten(s.overrides.map(X=>X.identifiers))).filter(X=>s.getOverrideValue(t,X)!==void 0);return{defaultValue:p,userValue:P,userLocalValue:A,userRemoteValue:a,workspaceValue:F,workspaceFolderValue:N,memoryValue:H,value:le,default:p!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,user:P!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userLocal:A!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userRemote:a!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspace:F!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspaceFolder:N!==void 0?{value:l==null?void 0:l.freeze().getValue(t),override:r.overrideIdentifier?l==null?void 0:l.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,memory:H!==void 0?{value:b.getValue(t),override:r.overrideIdentifier?b.getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,overrideIdentifiers:fe.length?fe:void 0}}keys(t){const r=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:r?r.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,r){this._folderConfigurations.set(t,r),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,r){const i=r.filter(s=>_.OVERRIDE_PROPERTY_PATTERN.test(s)).map(s=>{const l=_.overrideIdentifierFromKey(s),b=this._defaultConfiguration.getKeysForOverrideIdentifier(l),p=t.getKeysForOverrideIdentifier(l),P=[...p.filter(A=>b.indexOf(A)===-1),...b.filter(A=>p.indexOf(A)===-1),...b.filter(A=>!C.equals(this._defaultConfiguration.override(l).getValue(A),t.override(l).getValue(A)))];return[l,P]});return this.updateDefaultConfiguration(t),{keys:r,overrides:i}}compareAndUpdateLocalUserConfiguration(t){const{added:r,updated:i,removed:s,overrides:l}=k.compare(this.localUserConfiguration,t),b=[...r,...i,...s];return b.length&&this.updateLocalUserConfiguration(t),{keys:b,overrides:l}}compareAndUpdateRemoteUserConfiguration(t){const{added:r,updated:i,removed:s,overrides:l}=k.compare(this.remoteUserConfiguration,t);let b=[...r,...i,...s];return b.length&&this.updateRemoteUserConfiguration(t),{keys:b,overrides:l}}compareAndUpdateWorkspaceConfiguration(t){const{added:r,updated:i,removed:s,overrides:l}=k.compare(this.workspaceConfiguration,t);let b=[...r,...i,...s];return b.length&&this.updateWorkspaceConfiguration(t),{keys:b,overrides:l}}compareAndUpdateFolderConfiguration(t,r){const i=this.folderConfigurations.get(t),{added:s,updated:l,removed:b,overrides:p}=k.compare(i,r);let P=[...s,...l,...b];return(P.length||!i)&&this.updateFolderConfiguration(t,r),{keys:P,overrides:p}}compareAndDeleteFolderConfiguration(t){const r=this.folderConfigurations.get(t);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:i,updated:s,removed:l,overrides:b}=k.compare(r,void 0);return{keys:[...i,...s,...l],overrides:b}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,r){let i=this.getConsolidatedConfigurationModelForResource(t,r);return t.overrideIdentifier?i.override(t.overrideIdentifier):i}getConsolidatedConfigurationModelForResource({resource:t},r){let i=this.getWorkspaceConsolidatedConfiguration();if(r&&t){const s=r.getFolder(t);s&&(i=this.getFolderConsolidatedConfiguration(s.uri)||i);const l=this._memoryConfigurationByResource.get(t);l&&(i=i.merge(l))}return i}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let r=this._foldersConsolidatedConfigurations.get(t);if(!r){const i=this.getWorkspaceConsolidatedConfiguration(),s=this._folderConfigurations.get(t);s?(r=i.merge(s),this._freeze&&(r=r.freeze()),this._foldersConsolidatedConfigurations.set(t,r)):r=i}return r}getFolderConfigurationModelForResource(t,r){if(r&&t){const i=r.getFolder(t);if(i)return this._folderConfigurations.get(i.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,r)=>{const{contents:i,overrides:s,keys:l}=this._folderConfigurations.get(r);return t.push([r,{contents:i,overrides:s,keys:l}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(r=>t.add(r)),this.userConfiguration.freeze().keys.forEach(r=>t.add(r)),this._workspaceConfiguration.freeze().keys.forEach(r=>t.add(r)),this._folderConfigurations.forEach(r=>r.freeze().keys.forEach(i=>t.add(i))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const r=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>r.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>r.add(i)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.getKeysForOverrideIdentifier(t).forEach(s=>r.add(s))),[...r.values()]}static parse(t){const r=this.parseConfigurationModel(t.defaults),i=this.parseConfigurationModel(t.user),s=this.parseConfigurationModel(t.workspace),l=t.folders.reduce((b,p)=>(b.set(y.URI.revive(p[0]),this.parseConfigurationModel(p[1])),b),new T.ResourceMap);return new v(r,i,new h,s,l,new h,new T.ResourceMap,!1)}static parseConfigurationModel(t){return new h(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=v;function S(...f){if(f.length===0)return{keys:[],overrides:[]};if(f.length===1)return f[0];const t=new Set,r=new Map;for(const s of f)s.keys.forEach(l=>t.add(l)),s.overrides.forEach(([l,b])=>{const p=T.getOrSet(r,l,new Set);b.forEach(P=>p.add(P))});const i=[];return r.forEach((s,l)=>i.push([l,[...s.values()]])),{keys:[...t.values()],overrides:i}}e.mergeChanges=S;class c{constructor(t,r,i,s){this.change=t,this.previous=r,this.currentConfiguraiton=i,this.currentWorkspace=s,this._previousConfiguration=void 0;const l=new Set;t.keys.forEach(p=>l.add(p)),t.overrides.forEach(([,p])=>p.forEach(P=>l.add(P))),this.affectedKeys=[...l.values()];const b=new h;this.affectedKeys.forEach(p=>b.setValue(p,{})),this.affectedKeysTree=b.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=v.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,r){var i;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(r){const s=this.previousConfiguration?this.previousConfiguration.getValue(t,r,(i=this.previous)===null||i===void 0?void 0:i.workspace):void 0,l=this.currentConfiguraiton.getValue(t,r,this.currentWorkspace);return!C.equals(s,l)}return!0}return!1}doesAffectedKeysTreeContains(t,r){let i=k.toValuesTree({[r]:!0},()=>{}),s;for(;typeof i=="object"&&(s=Object.keys(i)[0]);){if(t=t[s],!t)return!1;i=i[s]}return!0}}e.ConfigurationChangeEvent=c;class m extends c{constructor(t,r,i,s){super({keys:t.allKeys(),overrides:[]},void 0,t,r);this.source=i,this.sourceConfig=s}}e.AllKeysConfigurationChangeEvent=m}),define(we[91],_e([0,1,5]),function(Z,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=g.createDecorator("remoteAuthorityResolverService");var T;(function(E){E.Unknown="Unknown",E.NotAvailable="NotAvailable",E.TemporarilyNotAvailable="TemporarilyNotAvailable",E.NoResolverFound="NoResolverFound"})(T=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class D extends Error{constructor(C,y=T.Unknown,_){super(C);this._message=C,this._code=y,this._detail=_,this.isHandled=y===T.NotAvailable&&_===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,D.prototype)}static isTemporarilyNotAvailable(C){return C instanceof D&&C._code===T.TemporarilyNotAvailable}static isNoResolverFound(C){return C instanceof D&&C._code===T.NoResolverFound}static isHandled(C){return C instanceof D&&C.isHandled}}e.RemoteAuthorityResolverError=D}),define(we[150],_e([0,1,15]),function(Z,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function T(k){return k.scheme===g.Schemas.vscodeRemote?k.authority:void 0}e.getRemoteAuthority=T;function D(k){if(!k)return;const n=k.indexOf("+");return n<0?k:k.substr(0,n)}e.getRemoteName=D;function E(k){return k.scheme!==g.Schemas.file&&k.scheme!==g.Schemas.vscodeRemote}e.isVirtualResource=E;function C(k){if(k.folders.length)return k.folders.every(n=>E(n.uri))?k.folders[0].uri:void 0;if(k.configuration&&E(k.configuration))return k.configuration}e.getVirtualWorkspaceLocation=C;function y(k){var n;return(n=C(k))===null||n===void 0?void 0:n.scheme}e.getVirtualWorkspaceScheme=y;function _(k){return C(k)!==void 0}e.isVirtualWorkspace=_}),define(we[151],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class g{constructor(D){this._callback=D,this._terminalBufferMap=new Map}dispose(){for(const D of this._terminalBufferMap.values())D.dispose()}startBuffering(D,E,C=5){let y;return y=E(_=>{const k=typeof _=="string"?_:_.data;let n=this._terminalBufferMap.get(D);if(n){n.data.push(k);return}const I=setTimeout(()=>this.flushBuffer(D),C);n={data:[k],timeoutId:I,dispose:()=>{clearTimeout(I),this.flushBuffer(D),y.dispose()}},this._terminalBufferMap.set(D,n)}),y}stopBuffering(D){const E=this._terminalBufferMap.get(D);E&&E.dispose()}flushBuffer(D){const E=this._terminalBufferMap.get(D);E&&(this._terminalBufferMap.delete(D),this._callback(D,E.data.join("")))}}e.TerminalDataBufferer=g}),define(we[62],_e([0,1,2,25,5,22]),function(Z,e,g,T,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=D.createDecorator("contextService");var C;(function(o){o[o.EMPTY=1]="EMPTY",o[o.FOLDER=2]="FOLDER",o[o.WORKSPACE=3]="WORKSPACE"})(C=e.WorkbenchState||(e.WorkbenchState={}));function y(o){const h=o;return!!(h&&typeof h=="object"&&typeof h.id=="string"&&Array.isArray(h.folders))}e.isWorkspace=y;function _(o){const h=o;return!!(h&&typeof h=="object"&&g.URI.isUri(h.uri)&&typeof h.name=="string"&&typeof h.toResource=="function")}e.isWorkspaceFolder=_;class k{constructor(h,d,u,w){this._id=h,this._configuration=u,this._ignorePathCasing=w,this._foldersMap=E.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=d}update(h){this._id=h.id,this._configuration=h.configuration,this._ignorePathCasing=h._ignorePathCasing,this.folders=h.folders}get folders(){return this._folders}set folders(h){this._folders=h,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(h){this._configuration=h}getFolder(h){return h&&this._foldersMap.findSubstr(h.with({scheme:h.scheme,authority:h.authority,path:h.path}))||null}updateFoldersMap(){this._foldersMap=E.TernarySearchTree.forUris(this._ignorePathCasing);for(const h of this.folders)this._foldersMap.set(h.uri,h)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=k;class n{constructor(h,d){this.raw=d,this.uri=h.uri,this.index=h.index,this.name=h.name}toResource(h){return T.joinPath(this.uri,h)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=n;function I(o){return new n({uri:o,index:0,name:T.basenameOrAuthority(o)},{uri:o.toString()})}e.toWorkspaceFolder=I}),define(we[63],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class g{constructor(D){this.id=D,this._data=new Map,this._idPool=1}add(D){const E=this._idPool++;return this._data.set(E,D),this.logDebugInfo(),E}get(D,E){return this._data.has(D)?this._data.get(D)[E]:void 0}delete(D){this._data.delete(D),this.logDebugInfo()}logDebugInfo(){!g.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=g,g.enableDebugLogging=!1}),define(we[64],_e([0,1,2,3,5]),function(Z,e,g,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=D.createDecorator("IExtHostEditorTabs");class E{constructor(){this._onDidChangeTabs=new T.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(y){this._tabs=y.map(_=>({name:_.name,group:_.group,resource:g.URI.revive(_.resource),isActive:_.isActive})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=E}),define(we[44],_e([0,1,15,5]),function(Z,e,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class D{constructor(){this._systemSchemes=new Set(Object.keys(g.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(C,y){y===null?this._providerInfo.delete(C):this._providerInfo.set(C,y)}isFreeScheme(C){return!this._providerInfo.has(C)&&!this._systemSchemes.has(C)}getCapabilities(C){return this._providerInfo.get(C)}}e.ExtHostFileSystemInfo=D,e.IExtHostFileSystemInfo=T.createDecorator("IExtHostFileSystemInfo")}),define(we[28],_e([0,1,5]),function(Z,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=g.createDecorator("IExtHostInitDataService")}),define(we[152],_e([0,1,11]),function(Z,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class T{constructor(C,y,_){this._deferredPromises=new Map,this._id=C,this._shared=y,this._storage=_,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(k=>(this._value=k,this)),this._storageListener=this._storage.onDidChangeStorage(k=>{k.shared===this._shared&&k.key===this._id&&(this._value=k.value)}),this._scheduler=new g.RunOnceScheduler(()=>{const k=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const n of k.values())n.complete()}catch(n){for(const I of k.values())I.error(n)}})()},0)}get keys(){var C;return Object.entries((C=this._value)!==null&&C!==void 0?C:{}).filter(([,y])=>y!==void 0).map(([y])=>y)}get whenReady(){return this._init}get(C,y){let _=this._value[C];return typeof _=="undefined"&&(_=y),_}update(C,y){this._value[C]=y;let _=this._deferredPromises.get(C);if(_!==void 0)return _.p;const k=new g.DeferredPromise;return this._deferredPromises.set(C,k),this._scheduler.isScheduled()||this._scheduler.schedule(),k.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=T;class D extends T{constructor(C,y){super(C.identifier.value,!0,y);this._extension=C}setKeysForSync(C){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},C)}}e.ExtensionGlobalMemento=D}),define(we[14],_e([0,1,5]),function(Z,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=g.createDecorator("IExtHostRpcService");class T{constructor(E){this.getProxy=E.getProxy.bind(E),this.set=E.set.bind(E),this.assertRegistered=E.assertRegistered.bind(E),this.drain=E.drain.bind(E)}}e.ExtHostRpcService=T});var tt=this&&this.__classPrivateFieldSet||function(Z,e,g,T,D){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!D:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?D.call(Z,g):D?D.value=g:e.set(Z,g),g},xe=this&&this.__classPrivateFieldGet||function(Z,e,g,T){if(g==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!T:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?T:g==="a"?T.call(Z):T?T.value:e.get(Z)};define(we[153],_e([0,1,26,3]),function(Z,e,g,T){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class E{constructor(y,_){D.set(this,void 0),this._onDidChange=new T.Emitter,this.onDidChange=this._onDidChange.event,this._id=g.ExtensionIdentifier.toKey(y.identifier),tt(this,D,_,"f"),xe(this,D,"f").onDidChangePassword(k=>{k.extensionId===this._id&&this._onDidChange.fire({key:k.key})})}get(y){return xe(this,D,"f").get(this._id,y)}store(y,_){return xe(this,D,"f").store(this._id,y,_)}delete(y){return xe(this,D,"f").delete(this._id,y)}}e.ExtensionSecrets=E,D=new WeakMap}),define(we[92],_e([0,1,5,3]),function(Z,e,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class D{constructor(){this._onDidChangeTelemetryEnabled=new T.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(C){this._enabled=C}$onDidChangeTelemetryEnabled(C){this._enabled=C,this._onDidChangeTelemetryEnabled.fire(C)}}e.ExtHostTelemetry=D,e.IExtHostTelemetry=g.createDecorator("IExtHostTelemetry")}),define(we[65],_e([0,1,3]),function(Z,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.ExtHostTestItemEventType=void 0;var T;(function(C){C[C.NewChild=0]="NewChild",C[C.Disposed=1]="Disposed",C[C.Invalidated=2]="Invalidated",C[C.SetProp=3]="SetProp"})(T=e.ExtHostTestItemEventType||(e.ExtHostTestItemEventType={}));const D=new WeakMap,E=C=>{let y=D.get(C);return y||(y={children:new Map,bus:new g.Emitter},D.set(C,y)),y};e.getPrivateApiFor=E}),define(we[66],_e([0,1,5,3,14]),function(Z,e,g,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var E;(function(y){function _(n){return{remoteAddress:n.remoteAddress,localAddress:n.localAddress,public:!!n.public}}y.fromApiTunnel=_;function k(n){return{remoteAddress:{host:n.tunnelRemoteHost,port:n.tunnelRemotePort},localAddress:n.localAddress,public:n.public}}y.fromServiceTunnel=k})(E=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=g.createDecorator("IExtHostTunnelService");let C=class{constructor(_){this.onDidChangeTunnels=new T.Emitter().event}async $applyCandidateFilter(_){return _}async openTunnel(_,k){}async getTunnels(){return[]}async setTunnelExtensionFunctions(_){return{dispose:()=>{}}}registerPortsAttributesProvider(_,k){return{dispose:()=>{}}}async $providePortAttributes(_,k,n,I,o){return[]}async $forwardPort(_,k){}async $closeTunnel(_){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};C=He([ze(0,D.IExtHostRpcService)],C),e.ExtHostTunnelService=C});var tt=this&&this.__classPrivateFieldSet||function(Z,e,g,T,D){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!D:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?D.call(Z,g):D?D.value=g:e.set(Z,g),g},xe=this&&this.__classPrivateFieldGet||function(Z,e,g,T){if(g==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!T:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?T:g==="a"?T.call(Z):T?T.value:e.get(Z)};define(we[6],_e([0,1,16,12,80,22,111,10,2,34,59,91,65]),function(Z,e,g,T,D,E,C,y,_,k,n,I,o){"use strict";var h,d,u,w,v,S,c,m,f,t,r,i,s,l,b,p,P,A;Object.defineProperty(e,"__esModule",{value:!0}),e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.TestMessage=e.TestItemImpl=e.TestItemStatus=e.TestMessageSeverity=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function a(x){function L(){return Reflect.construct(x,arguments,this.constructor)}return Object.defineProperty(L,"name",Object.getOwnPropertyDescriptor(x,"name")),Object.setPrototypeOf(L,x),Object.setPrototypeOf(L.prototype,x.prototype),L}let F=v=class{constructor(L){h.set(this,void 0),tt(this,h,L,"f")}static from(...L){let ne=L;return new v(function(){if(ne){for(const Se of ne)Se&&typeof Se.dispose=="function"&&Se.dispose();ne=void 0}})}dispose(){typeof xe(this,h,"f")=="function"&&(xe(this,h,"f").call(this),tt(this,h,void 0,"f"))}};h=new WeakMap,F=v=He([a],F),e.Disposable=F;let N=S=class{constructor(L,ne){if(L<0)throw T.illegalArgument("line must be non-negative");if(ne<0)throw T.illegalArgument("character must be non-negative");this._line=L,this._character=ne}static Min(...L){if(L.length===0)throw new TypeError;let ne=L[0];for(let Se=1;Se<L.length;Se++){const je=L[Se];je.isBefore(ne)&&(ne=je)}return ne}static Max(...L){if(L.length===0)throw new TypeError;let ne=L[0];for(let Se=1;Se<L.length;Se++){const je=L[Se];je.isAfter(ne)&&(ne=je)}return ne}static isPosition(L){if(!L)return!1;if(L instanceof S)return!0;let{line:ne,character:Se}=L;return typeof ne=="number"&&typeof Se=="number"}get line(){return this._line}get character(){return this._character}isBefore(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<L._character}isBeforeOrEqual(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<=L._character}isAfter(L){return!this.isBeforeOrEqual(L)}isAfterOrEqual(L){return!this.isBefore(L)}isEqual(L){return this._line===L._line&&this._character===L._character}compareTo(L){return this._line<L._line?-1:this._line>L.line?1:this._character<L._character?-1:this._character>L._character?1:0}translate(L,ne=0){if(L===null||ne===null)throw T.illegalArgument();let Se;return typeof L=="undefined"?Se=0:typeof L=="number"?Se=L:(Se=typeof L.lineDelta=="number"?L.lineDelta:0,ne=typeof L.characterDelta=="number"?L.characterDelta:0),Se===0&&ne===0?this:new S(this.line+Se,this.character+ne)}with(L,ne=this.character){if(L===null||ne===null)throw T.illegalArgument();let Se;return typeof L=="undefined"?Se=this.line:typeof L=="number"?Se=L:(Se=typeof L.line=="number"?L.line:this.line,ne=typeof L.character=="number"?L.character:this.character),Se===this.line&&ne===this.character?this:new S(Se,ne)}toJSON(){return{line:this.line,character:this.character}}};N=S=He([a],N),e.Position=N;let H=c=class{constructor(L,ne,Se,je){let et,at;if(typeof L=="number"&&typeof ne=="number"&&typeof Se=="number"&&typeof je=="number"?(et=new N(L,ne),at=new N(Se,je)):L instanceof N&&ne instanceof N&&(et=L,at=ne),!et||!at)throw new Error("Invalid arguments");et.isBefore(at)?(this._start=et,this._end=at):(this._start=at,this._end=et)}static isRange(L){return L instanceof c?!0:L?N.isPosition(L.start)&&N.isPosition(L.end):!1}get start(){return this._start}get end(){return this._end}contains(L){return L instanceof c?this.contains(L._start)&&this.contains(L._end):L instanceof N?!(L.isBefore(this._start)||this._end.isBefore(L)):!1}isEqual(L){return this._start.isEqual(L._start)&&this._end.isEqual(L._end)}intersection(L){const ne=N.Max(L.start,this._start),Se=N.Min(L.end,this._end);if(!ne.isAfter(Se))return new c(ne,Se)}union(L){if(this.contains(L))return this;if(L.contains(this))return L;const ne=N.Min(L.start,this._start),Se=N.Max(L.end,this.end);return new c(ne,Se)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(L,ne=this.end){if(L===null||ne===null)throw T.illegalArgument();let Se;return L?N.isPosition(L)?Se=L:(Se=L.start||this.start,ne=L.end||this.end):Se=this.start,Se.isEqual(this._start)&&ne.isEqual(this.end)?this:new c(Se,ne)}toJSON(){return[this.start,this.end]}};H=c=He([a],H),e.Range=H;let le=m=class extends H{constructor(L,ne,Se,je){let et,at;if(typeof L=="number"&&typeof ne=="number"&&typeof Se=="number"&&typeof je=="number"?(et=new N(L,ne),at=new N(Se,je)):L instanceof N&&ne instanceof N&&(et=L,at=ne),!et||!at)throw new Error("Invalid arguments");super(et,at);this._anchor=et,this._active=at}static isSelection(L){return L instanceof m?!0:L?H.isRange(L)&&N.isPosition(L.anchor)&&N.isPosition(L.active)&&typeof L.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};le=m=He([a],le),e.Selection=le;class fe{constructor(L,ne,Se){if(typeof L!="string"||L.length===0)throw T.illegalArgument("host");if(typeof ne!="number"||ne===0||Math.round(ne)!==ne)throw T.illegalArgument("port");if(typeof Se!="undefined"&&(typeof Se!="string"||Se.length===0||!/^[0-9A-Za-z\-]+$/.test(Se)))throw T.illegalArgument("connectionToken");this.host=L,this.port=Math.round(ne),this.connectionToken=Se}}e.ResolvedAuthority=fe;class X extends Error{constructor(L,ne=I.RemoteAuthorityResolverErrorCode.Unknown,Se){super(L);this._message=L,this._code=ne,this._detail=Se,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,X.prototype)}static NotAvailable(L,ne){return new X(L,I.RemoteAuthorityResolverErrorCode.NotAvailable,ne)}static TemporarilyNotAvailable(L){return new X(L,I.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=X;var z;(function(x){x[x.LF=1]="LF",x[x.CRLF=2]="CRLF"})(z=e.EndOfLine||(e.EndOfLine={}));var Y;(function(x){x[x.Replace=1]="Replace",x[x.Append=2]="Append",x[x.Prepend=3]="Prepend"})(Y=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let R=f=class{constructor(L,ne){this._range=L,this._newText=ne}static isTextEdit(L){return L instanceof f?!0:L?H.isRange(L)&&typeof L.newText=="string":!1}static replace(L,ne){return new f(L,ne)}static insert(L,ne){return f.replace(new H(L,L),ne)}static delete(L){return f.replace(L,"")}static setEndOfLine(L){const ne=new f(new H(new N(0,0),new N(0,0)),"");return ne.newEol=L,ne}get range(){return this._range}set range(L){if(L&&!H.isRange(L))throw T.illegalArgument("range");this._range=L}get newText(){return this._newText||""}set newText(L){if(L&&typeof L!="string")throw T.illegalArgument("newText");this._newText=L}get newEol(){return this._newEol}set newEol(L){if(L&&typeof L!="number")throw T.illegalArgument("newEol");this._newEol=L}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};R=f=He([a],R),e.TextEdit=R;var B;(function(x){x[x.File=1]="File",x[x.Text=2]="Text",x[x.Cell=3]="Cell",x[x.CellOutput=4]="CellOutput",x[x.CellReplace=5]="CellReplace",x[x.CellOutputItem=6]="CellOutputItem"})(B=e.FileEditType||(e.FileEditType={}));let M=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(L,ne,Se,je){this._edits.push({_type:1,from:L,to:ne,options:Se,metadata:je})}createFile(L,ne,Se){this._edits.push({_type:1,from:void 0,to:L,options:ne,metadata:Se})}deleteFile(L,ne,Se){this._edits.push({_type:1,from:L,to:void 0,options:ne,metadata:Se})}replaceNotebookMetadata(L,ne,Se){this._edits.push({_type:3,metadata:Se,uri:L,edit:{editType:5,metadata:ne},notebookMetadata:ne})}replaceNotebookCells(L,ne,Se,je,et){let at,dt,St=[],It;if($t.isNotebookRange(ne)&&Tt.isNotebookCellDataArray(Se)&&!Tt.isNotebookCellDataArray(je)?(at=ne.start,dt=ne.end,St=Se,It=je):typeof ne=="number"&&typeof Se=="number"&&Tt.isNotebookCellDataArray(je)&&(at=ne,dt=Se,St=je,It=et),at===void 0||dt===void 0)throw new Error("Invalid arguments");(at!==dt||St.length>0)&&this._edits.push({_type:5,uri:L,index:at,count:dt-at,cells:St,metadata:It})}replaceNotebookCellMetadata(L,ne,Se,je){this._edits.push({_type:3,metadata:je,uri:L,edit:{editType:8,index:ne,metadata:Se}})}replace(L,ne,Se,je){this._edits.push({_type:2,uri:L,edit:new R(ne,Se),metadata:je})}insert(L,ne,Se,je){this.replace(L,new H(ne,ne),Se,je)}delete(L,ne,Se){this.replace(L,ne,"",Se)}has(L){return this._edits.some(ne=>ne._type===2&&ne.uri.toString()===L.toString())}set(L,ne){if(ne)for(const Se of ne)Se&&this._edits.push({_type:2,uri:L,edit:Se});else{for(let Se=0;Se<this._edits.length;Se++){const je=this._edits[Se];je._type===2&&je.uri.toString()===L.toString()&&(this._edits[Se]=void 0)}g.coalesceInPlace(this._edits)}}get(L){const ne=[];for(let Se of this._edits)Se._type===2&&Se.uri.toString()===L.toString()&&ne.push(Se.edit);return ne}entries(){const L=new E.ResourceMap;for(let ne of this._edits)if(ne._type===2){let Se=L.get(ne.uri);Se||(Se=[ne.uri,[]],L.set(ne.uri,Se)),Se[1].push(ne.edit)}return[...L.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};M=He([a],M),e.WorkspaceEdit=M;let U=t=class{constructor(L){this._tabstop=1,this.value=L||""}static isSnippetString(L){return L instanceof t?!0:L?typeof L.value=="string":!1}static _escape(L){return L.replace(/\$|}|\\/g,"\\$&")}appendText(L){return this.value+=t._escape(L),this}appendTabstop(L=this._tabstop++){return this.value+="$",this.value+=L,this}appendPlaceholder(L,ne=this._tabstop++){if(typeof L=="function"){const Se=new t;Se._tabstop=this._tabstop,L(Se),this._tabstop=Se._tabstop,L=Se.value}else L=t._escape(L);return this.value+="${",this.value+=ne,this.value+=":",this.value+=L,this.value+="}",this}appendChoice(L,ne=this._tabstop++){const Se=L.map(je=>je.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ne,this.value+="|",this.value+=Se,this.value+="|}",this}appendVariable(L,ne){if(typeof ne=="function"){const Se=new t;Se._tabstop=this._tabstop,ne(Se),this._tabstop=Se._tabstop,ne=Se.value}else typeof ne=="string"&&(ne=ne.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=L,ne&&(this.value+=":",this.value+=ne),this.value+="}",this}};U=t=He([a],U),e.SnippetString=U;var q;(function(x){x[x.Unnecessary=1]="Unnecessary",x[x.Deprecated=2]="Deprecated"})(q=e.DiagnosticTag||(e.DiagnosticTag={}));var V;(function(x){x[x.Hint=3]="Hint",x[x.Information=2]="Information",x[x.Warning=1]="Warning",x[x.Error=0]="Error"})(V=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let oe=r=class{constructor(L,ne){if(this.uri=L,ne)if(ne instanceof H)this.range=ne;else if(ne instanceof N)this.range=new H(ne,ne);else throw new Error("Illegal argument")}static isLocation(L){return L instanceof r?!0:L?H.isRange(L.range)&&_.URI.isUri(L.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};oe=r=He([a],oe),e.Location=oe;let ge=class{constructor(L,ne){this.location=L,this.message=ne}static is(L){return L?typeof L.message=="string"&&L.location&&H.isRange(L.location.range)&&_.URI.isUri(L.location.uri):!1}static isEqual(L,ne){return L===ne?!0:!L||!ne?!1:L.message===ne.message&&L.location.range.isEqual(ne.location.range)&&L.location.uri.toString()===ne.location.uri.toString()}};ge=He([a],ge),e.DiagnosticRelatedInformation=ge;let Re=class{constructor(L,ne,Se=V.Error){if(!H.isRange(L))throw new TypeError("range must be set");if(!ne)throw new TypeError("message must be set");this.range=L,this.message=ne,this.severity=Se}toJSON(){return{severity:V[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(L,ne){return L===ne?!0:!L||!ne?!1:L.message===ne.message&&L.severity===ne.severity&&L.code===ne.code&&L.severity===ne.severity&&L.source===ne.source&&L.range.isEqual(ne.range)&&g.equals(L.tags,ne.tags)&&g.equals(L.relatedInformation,ne.relatedInformation,ge.isEqual)}};Re=He([a],Re),e.Diagnostic=Re;let $e=class{constructor(L,ne){if(!L)throw new Error("Illegal argument, contents must be defined");Array.isArray(L)?this.contents=L:D.isMarkdownString(L)?this.contents=[L]:this.contents=[L],this.range=ne}};$e=He([a],$e),e.Hover=$e;var Me;(function(x){x[x.Text=0]="Text",x[x.Read=1]="Read",x[x.Write=2]="Write"})(Me=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let We=class{constructor(L,ne=Me.Text){this.range=L,this.kind=ne}toJSON(){return{range:this.range,kind:Me[this.kind]}}};We=He([a],We),e.DocumentHighlight=We;var Je;(function(x){x[x.File=0]="File",x[x.Module=1]="Module",x[x.Namespace=2]="Namespace",x[x.Package=3]="Package",x[x.Class=4]="Class",x[x.Method=5]="Method",x[x.Property=6]="Property",x[x.Field=7]="Field",x[x.Constructor=8]="Constructor",x[x.Enum=9]="Enum",x[x.Interface=10]="Interface",x[x.Function=11]="Function",x[x.Variable=12]="Variable",x[x.Constant=13]="Constant",x[x.String=14]="String",x[x.Number=15]="Number",x[x.Boolean=16]="Boolean",x[x.Array=17]="Array",x[x.Object=18]="Object",x[x.Key=19]="Key",x[x.Null=20]="Null",x[x.EnumMember=21]="EnumMember",x[x.Struct=22]="Struct",x[x.Event=23]="Event",x[x.Operator=24]="Operator",x[x.TypeParameter=25]="TypeParameter"})(Je=e.SymbolKind||(e.SymbolKind={}));var Qe;(function(x){x[x.Deprecated=1]="Deprecated"})(Qe=e.SymbolTag||(e.SymbolTag={}));let Ye=i=class{constructor(L,ne,Se,je,et){this.name=L,this.kind=ne,this.containerName=et,typeof Se=="string"&&(this.containerName=Se),je instanceof oe?this.location=je:Se instanceof H&&(this.location=new oe(je,Se)),i.validate(this)}static validate(L){if(!L.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Je[this.kind],location:this.location,containerName:this.containerName}}};Ye=i=He([a],Ye),e.SymbolInformation=Ye;let W=s=class{constructor(L,ne,Se,je,et){this.name=L,this.detail=ne,this.kind=Se,this.range=je,this.selectionRange=et,this.children=[],s.validate(this)}static validate(L){if(!L.name)throw new Error("name must not be falsy");if(!L.range.contains(L.selectionRange))throw new Error("selectionRange must be contained in fullRange");L.children&&L.children.forEach(s.validate)}};W=s=He([a],W),e.DocumentSymbol=W;var Q;(function(x){x[x.Invoke=1]="Invoke",x[x.Automatic=2]="Automatic"})(Q=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let te=class{constructor(L,ne){this.title=L,this.kind=ne}};te=He([a],te),e.CodeAction=te;let re=l=class{constructor(L){this.value=L}append(L){return new l(this.value?this.value+l.sep+L:L)}intersects(L){return this.contains(L)||L.contains(this)}contains(L){return this.value===L.value||L.value.startsWith(this.value+l.sep)}};re.sep=".",re=l=He([a],re),e.CodeActionKind=re,re.Empty=new re(""),re.QuickFix=re.Empty.append("quickfix"),re.Refactor=re.Empty.append("refactor"),re.RefactorExtract=re.Refactor.append("extract"),re.RefactorInline=re.Refactor.append("inline"),re.RefactorRewrite=re.Refactor.append("rewrite"),re.Source=re.Empty.append("source"),re.SourceOrganizeImports=re.Source.append("organizeImports"),re.SourceFixAll=re.Source.append("fixAll");let K=class{constructor(L,ne){if(this.range=L,this.parent=ne,ne&&!ne.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};K=He([a],K),e.SelectionRange=K;class se{constructor(L,ne,Se,je,et,at){this.kind=L,this.name=ne,this.detail=Se,this.uri=je,this.range=et,this.selectionRange=at}}e.CallHierarchyItem=se;class he{constructor(L,ne){this.fromRanges=ne,this.from=L}}e.CallHierarchyIncomingCall=he;class Ae{constructor(L,ne){this.fromRanges=ne,this.to=L}}e.CallHierarchyOutgoingCall=Ae;let Be=class{constructor(L,ne){this.range=L,this.command=ne}get isResolved(){return!!this.command}};Be=He([a],Be),e.CodeLens=Be;let pe=b=class{constructor(L,ne=!1){d.set(this,void 0),tt(this,d,new D.MarkdownString(L,{supportThemeIcons:ne}),"f")}static isMarkdownString(L){return L instanceof b?!0:L&&L.appendCodeblock&&L.appendMarkdown&&L.appendText&&L.value!==void 0}get value(){return xe(this,d,"f").value}set value(L){xe(this,d,"f").value=L}get isTrusted(){return xe(this,d,"f").isTrusted}set isTrusted(L){xe(this,d,"f").isTrusted=L}get supportThemeIcons(){return xe(this,d,"f").supportThemeIcons}appendText(L){return xe(this,d,"f").appendText(L),this}appendMarkdown(L){return xe(this,d,"f").appendMarkdown(L),this}appendCodeblock(L,ne){return xe(this,d,"f").appendCodeblock(ne??"",L),this}};d=new WeakMap,pe=b=He([a],pe),e.MarkdownString=pe;let Ke=class{constructor(L,ne){this.label=L,this.documentation=ne}};Ke=He([a],Ke),e.ParameterInformation=Ke;let j=class{constructor(L,ne){this.label=L,this.documentation=ne,this.parameters=[]}};j=He([a],j),e.SignatureInformation=j;let ee=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};ee=He([a],ee),e.SignatureHelp=ee;var me;(function(x){x[x.Invoke=1]="Invoke",x[x.TriggerCharacter=2]="TriggerCharacter",x[x.ContentChange=3]="ContentChange"})(me=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Fe;(function(x){x[x.Other=0]="Other",x[x.Type=1]="Type",x[x.Parameter=2]="Parameter"})(Fe=e.InlayHintKind||(e.InlayHintKind={}));let Le=class{constructor(L,ne,Se){this.text=L,this.position=ne,this.kind=Se}};Le=He([a],Le),e.InlayHint=Le;var Ge;(function(x){x[x.Invoke=0]="Invoke",x[x.TriggerCharacter=1]="TriggerCharacter",x[x.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ge=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ee;(function(x){x[x.Text=0]="Text",x[x.Method=1]="Method",x[x.Function=2]="Function",x[x.Constructor=3]="Constructor",x[x.Field=4]="Field",x[x.Variable=5]="Variable",x[x.Class=6]="Class",x[x.Interface=7]="Interface",x[x.Module=8]="Module",x[x.Property=9]="Property",x[x.Unit=10]="Unit",x[x.Value=11]="Value",x[x.Enum=12]="Enum",x[x.Keyword=13]="Keyword",x[x.Snippet=14]="Snippet",x[x.Color=15]="Color",x[x.File=16]="File",x[x.Reference=17]="Reference",x[x.Folder=18]="Folder",x[x.EnumMember=19]="EnumMember",x[x.Constant=20]="Constant",x[x.Struct=21]="Struct",x[x.Event=22]="Event",x[x.Operator=23]="Operator",x[x.TypeParameter=24]="TypeParameter",x[x.User=25]="User",x[x.Issue=26]="Issue"})(Ee=e.CompletionItemKind||(e.CompletionItemKind={}));var be;(function(x){x[x.Deprecated=1]="Deprecated"})(be=e.CompletionItemTag||(e.CompletionItemTag={}));let De=class{constructor(L,ne){this.label=L,this.kind=ne}toJSON(){return{label:this.label,label2:this.label2,kind:this.kind&&Ee[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};De=He([a],De),e.CompletionItem=De;let ie=class{constructor(L=[],ne=!1){this.items=L,this.isIncomplete=ne}};ie=He([a],ie),e.CompletionList=ie;let de=class{constructor(L,ne,Se){this.text=L,this.range=ne,this.command=Se}};de=He([a],de),e.InlineSuggestion=de;let O=class{constructor(L){this.items=L}};O=He([a],O),e.InlineSuggestions=O;var G;(function(x){x[x.Active=-1]="Active",x[x.Beside=-2]="Beside",x[x.One=1]="One",x[x.Two=2]="Two",x[x.Three=3]="Three",x[x.Four=4]="Four",x[x.Five=5]="Five",x[x.Six=6]="Six",x[x.Seven=7]="Seven",x[x.Eight=8]="Eight",x[x.Nine=9]="Nine"})(G=e.ViewColumn||(e.ViewColumn={}));var ae;(function(x){x[x.Left=1]="Left",x[x.Right=2]="Right"})(ae=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Ce;(function(x){x[x.Off=0]="Off",x[x.On=1]="On",x[x.Relative=2]="Relative"})(Ce=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Ie;(function(x){x[x.Manual=1]="Manual",x[x.AfterDelay=2]="AfterDelay",x[x.FocusOut=3]="FocusOut"})(Ie=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Oe;(function(x){x[x.Default=0]="Default",x[x.InCenter=1]="InCenter",x[x.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",x[x.AtTop=3]="AtTop"})(Oe=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Ue;(function(x){x[x.Keyboard=1]="Keyboard",x[x.Mouse=2]="Mouse",x[x.Command=3]="Command"})(Ue=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var qe;(function(x){x[x.OpenOpen=0]="OpenOpen",x[x.ClosedClosed=1]="ClosedClosed",x[x.OpenClosed=2]="OpenClosed",x[x.ClosedOpen=3]="ClosedOpen"})(qe=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(x){function L(ne){switch(ne){case"keyboard":return x.Keyboard;case"mouse":return x.Mouse;case"api":return x.Command}}x.fromValue=L}(Ue=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let rt=class{constructor(L,ne){if(ne&&!_.URI.isUri(ne))throw T.illegalArgument("target");if(!H.isRange(L)||L.isEmpty)throw T.illegalArgument("range");this.range=L,this.target=ne}};rt=He([a],rt),e.DocumentLink=rt;let nt=class{constructor(L,ne,Se,je){this.red=L,this.green=ne,this.blue=Se,this.alpha=je}};nt=He([a],nt),e.Color=nt;let Ze=class{constructor(L,ne){if(ne&&!(ne instanceof nt))throw T.illegalArgument("color");if(!H.isRange(L)||L.isEmpty)throw T.illegalArgument("range");this.range=L,this.color=ne}};Ze=He([a],Ze),e.ColorInformation=Ze;let ot=class{constructor(L){if(!L||typeof L!="string")throw T.illegalArgument("label");this.label=L}};ot=He([a],ot),e.ColorPresentation=ot;var ve;(function(x){x[x.RGB=0]="RGB",x[x.HEX=1]="HEX",x[x.HSL=2]="HSL"})(ve=e.ColorFormat||(e.ColorFormat={}));var ye;(function(x){x[x.Error=0]="Error",x[x.Warning=1]="Warning",x[x.Information=2]="Information"})(ye=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var ue;(function(x){x[x.Always=1]="Always",x[x.Silent=2]="Silent",x[x.Never=3]="Never"})(ue=e.TaskRevealKind||(e.TaskRevealKind={}));var $;(function(x){x[x.Shared=1]="Shared",x[x.Dedicated=2]="Dedicated",x[x.New=3]="New"})($=e.TaskPanelKind||(e.TaskPanelKind={}));let Ne=p=class{constructor(L,ne){if(typeof L!="string"||typeof ne!="string")throw T.illegalArgument("name");this._id=L}static from(L){switch(L){case"clean":return p.Clean;case"build":return p.Build;case"rebuild":return p.Rebuild;case"test":return p.Test;default:return}}get id(){return this._id}};Ne.Clean=new p("clean","Clean"),Ne.Build=new p("build","Build"),Ne.Rebuild=new p("rebuild","Rebuild"),Ne.Test=new p("test","Test"),Ne=p=He([a],Ne),e.TaskGroup=Ne;function Pe(x){let L="";for(let ne=0;ne<x.length;ne++)L+=x[ne].replace(/,/g,",,")+",";return L}let Ve=class{constructor(L,ne,Se){if(typeof L!="string")throw T.illegalArgument("process");this._args=[],this._process=L,ne!==void 0&&(Array.isArray(ne)?(this._args=ne,this._options=Se):this._options=ne)}get process(){return this._process}set process(L){if(typeof L!="string")throw T.illegalArgument("process");this._process=L}get args(){return this._args}set args(L){Array.isArray(L)||(L=[]),this._args=L}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("process"),this._process!==void 0&&L.push(this._process),this._args&&this._args.length>0)for(let ne of this._args)L.push(ne);return Pe(L)}};Ve=He([a],Ve),e.ProcessExecution=Ve;let Xe=class{constructor(L,ne,Se){if(this._args=[],Array.isArray(ne)){if(!L)throw T.illegalArgument("command can't be undefined or null");if(typeof L!="string"&&typeof L.value!="string")throw T.illegalArgument("command");this._command=L,this._args=ne,this._options=Se}else{if(typeof L!="string")throw T.illegalArgument("commandLine");this._commandLine=L,this._options=ne}}get commandLine(){return this._commandLine}set commandLine(L){if(typeof L!="string")throw T.illegalArgument("commandLine");this._commandLine=L}get command(){return this._command?this._command:""}set command(L){if(typeof L!="string"&&typeof L.value!="string")throw T.illegalArgument("command");this._command=L}get args(){return this._args}set args(L){this._args=L||[]}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("shell"),this._commandLine!==void 0&&L.push(this._commandLine),this._command!==void 0&&L.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let ne of this._args)L.push(typeof ne=="string"?ne:ne.value);return Pe(L)}};Xe=He([a],Xe),e.ShellExecution=Xe;var lt;(function(x){x[x.Escape=1]="Escape",x[x.Strong=2]="Strong",x[x.Weak=3]="Weak"})(lt=e.ShellQuoting||(e.ShellQuoting={}));var ut;(function(x){x[x.Global=1]="Global",x[x.Workspace=2]="Workspace"})(ut=e.TaskScope||(e.TaskScope={}));class it{constructor(L){this._callback=L}computeId(){return"customExecution"+k.generateUuid()}set callback(L){this._callback=L}get callback(){return this._callback}}e.CustomExecution=it;let mt=P=class{constructor(L,ne,Se,je,et,at){this.__deprecated=!1,this._definition=this.definition=L;let dt;typeof ne=="string"?(this._name=this.name=ne,this._source=this.source=Se,this.execution=je,dt=et,this.__deprecated=!0):ne===ut.Global||ne===ut.Workspace?(this.target=ne,this._name=this.name=Se,this._source=this.source=je,this.execution=et,dt=at):(this.target=ne,this._name=this.name=Se,this._source=this.source=je,this.execution=et,dt=at),typeof dt=="string"?(this._problemMatchers=[dt],this._hasDefinedMatchers=!0):Array.isArray(dt)?(this._problemMatchers=dt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(L){this.__id=L}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Ve?this._definition={type:P.ProcessType,id:this._execution.computeId()}:this._execution instanceof Xe?this._definition={type:P.ShellType,id:this._execution.computeId()}:this._execution instanceof it?this._definition={type:P.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:P.EmptyType,id:k.generateUuid()}}get definition(){return this._definition}set definition(L){if(L==null)throw T.illegalArgument("Kind can't be undefined or null");this.clear(),this._definition=L}get scope(){return this._scope}set target(L){this.clear(),this._scope=L}get name(){return this._name}set name(L){if(typeof L!="string")throw T.illegalArgument("name");this.clear(),this._name=L}get execution(){return this._execution}set execution(L){L===null&&(L=void 0),this.clear(),this._execution=L;const ne=this._definition.type;(P.EmptyType===ne||P.ProcessType===ne||P.ShellType===ne||P.ExtensionCallbackType===ne)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(L){if(Array.isArray(L))this.clear(),this._problemMatchers=L,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(L){L!==!0&&L!==!1&&(L=!1),this.clear(),this._isBackground=L}get source(){return this._source}set source(L){if(typeof L!="string"||L.length===0)throw T.illegalArgument("source must be a string of length > 0");this.clear(),this._source=L}get group(){return this._group}set group(L){L===null&&(L=void 0),this.clear(),this._group=L}get detail(){return this._detail}set detail(L){L===null&&(L=void 0),this._detail=L}get presentationOptions(){return this._presentationOptions}set presentationOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._presentationOptions=L}get runOptions(){return this._runOptions}set runOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._runOptions=L}};mt.ExtensionCallbackType="customExecution",mt.ProcessType="process",mt.ShellType="shell",mt.EmptyType="$empty",mt=P=He([a],mt),e.Task=mt;var yt;(function(x){x[x.SourceControl=1]="SourceControl",x[x.Window=10]="Window",x[x.Notification=15]="Notification"})(yt=e.ProgressLocation||(e.ProgressLocation={}));let vt=class{constructor(L,ne=wt.None){this.collapsibleState=ne,_.URI.isUri(L)?this.resourceUri=L:this.label=L}};vt=He([a],vt),e.TreeItem=vt;var wt;(function(x){x[x.None=0]="None",x[x.Collapsed=1]="Collapsed",x[x.Expanded=2]="Expanded"})(wt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let gt=class{constructor(L,ne){this.id=L,this.color=ne}};gt=He([a],gt),e.ThemeIcon=gt,gt.File=new gt("file"),gt.Folder=new gt("folder");let ht=class{constructor(L){this.id=L}};ht=He([a],ht),e.ThemeColor=ht;var kt;(function(x){x[x.Global=1]="Global",x[x.Workspace=2]="Workspace",x[x.WorkspaceFolder=3]="WorkspaceFolder"})(kt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Et=class{constructor(L,ne){if(typeof L!="string"&&(!L||!_.URI.isUri(L)&&!_.URI.isUri(L.uri)))throw T.illegalArgument("base");if(typeof ne!="string")throw T.illegalArgument("pattern");typeof L=="string"?(this.baseFolder=_.URI.file(L),this.base=L):_.URI.isUri(L)?(this.baseFolder=L,this.base=L.fsPath):(this.baseFolder=L.uri,this.base=L.uri.fsPath),this.pattern=ne}};Et=He([a],Et),e.RelativePattern=Et;let Pt=class{constructor(L,ne,Se,je){this.enabled=typeof L=="boolean"?L:!0,typeof ne=="string"&&(this.condition=ne),typeof Se=="string"&&(this.hitCondition=Se),typeof je=="string"&&(this.logMessage=je)}get id(){return this._id||(this._id=k.generateUuid()),this._id}};Pt=He([a],Pt),e.Breakpoint=Pt;let Ft=class extends Pt{constructor(L,ne,Se,je,et){super(ne,Se,je,et);if(L===null)throw T.illegalArgument("location");this.location=L}};Ft=He([a],Ft),e.SourceBreakpoint=Ft;let _t=class extends Pt{constructor(L,ne,Se,je,et){super(ne,Se,je,et);this.functionName=L}};_t=He([a],_t),e.FunctionBreakpoint=_t;let qt=class extends Pt{constructor(L,ne,Se,je,et,at,dt){super(je,et,at,dt);if(!ne)throw T.illegalArgument("dataId");this.label=L,this.dataId=ne,this.canPersist=Se}};qt=He([a],qt),e.DataBreakpoint=qt;let Kt=class{constructor(L,ne,Se){this.command=L,this.args=ne||[],this.options=Se}};Kt=He([a],Kt),e.DebugAdapterExecutable=Kt;let ft=class{constructor(L,ne){this.port=L,this.host=ne}};ft=He([a],ft),e.DebugAdapterServer=ft;let Gt=class{constructor(L){this.path=L}};Gt=He([a],Gt),e.DebugAdapterNamedPipeServer=Gt;let Qt=class{constructor(L){this.implementation=L}};Qt=He([a],Qt),e.DebugAdapterInlineImplementation=Qt;let Dt=class{constructor(L,ne){this.range=L,this.expression=ne}};Dt=He([a],Dt),e.EvaluatableExpression=Dt;var ln;(function(x){x[x.Automatic=0]="Automatic",x[x.Explicit=1]="Explicit"})(ln=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Yt=class{constructor(L,ne){this.range=L,this.text=ne}};Yt=He([a],Yt),e.InlineValueText=Yt;let xt=class{constructor(L,ne,Se=!0){this.range=L,this.variableName=ne,this.caseSensitiveLookup=Se}};xt=He([a],xt),e.InlineValueVariableLookup=xt;let ct=class{constructor(L,ne){this.range=L,this.expression=ne}};ct=He([a],ct),e.InlineValueEvaluatableExpression=ct;let Jt=class{constructor(L,ne){this.frameId=L,this.stoppedLocation=ne}};Jt=He([a],Jt),e.InlineValueContext=Jt;var Mt;(function(x){x[x.Changed=1]="Changed",x[x.Created=2]="Created",x[x.Deleted=3]="Deleted"})(Mt=e.FileChangeType||(e.FileChangeType={}));let Lt=A=class extends Error{constructor(L,ne=n.FileSystemProviderErrorCode.Unknown,Se){var je;super(_.URI.isUri(L)?L.toString(!0):L);this.code=(je=Se==null?void 0:Se.name)!==null&&je!==void 0?je:"Unknown",n.markAsFileSystemProviderError(this,ne),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,A.prototype),typeof Error.captureStackTrace=="function"&&typeof Se=="function"&&Error.captureStackTrace(this,Se)}static FileExists(L){return new A(L,n.FileSystemProviderErrorCode.FileExists,A.FileExists)}static FileNotFound(L){return new A(L,n.FileSystemProviderErrorCode.FileNotFound,A.FileNotFound)}static FileNotADirectory(L){return new A(L,n.FileSystemProviderErrorCode.FileNotADirectory,A.FileNotADirectory)}static FileIsADirectory(L){return new A(L,n.FileSystemProviderErrorCode.FileIsADirectory,A.FileIsADirectory)}static NoPermissions(L){return new A(L,n.FileSystemProviderErrorCode.NoPermissions,A.NoPermissions)}static Unavailable(L){return new A(L,n.FileSystemProviderErrorCode.Unavailable,A.Unavailable)}};Lt=A=He([a],Lt),e.FileSystemError=Lt;let Vt=class{constructor(L,ne,Se){this.start=L,this.end=ne,this.kind=Se}};Vt=He([a],Vt),e.FoldingRange=Vt;var wn;(function(x){x[x.Comment=1]="Comment",x[x.Imports=2]="Imports",x[x.Region=3]="Region"})(wn=e.FoldingRangeKind||(e.FoldingRangeKind={}));var un;(function(x){x[x.Collapsed=0]="Collapsed",x[x.Expanded=1]="Expanded"})(un=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var _n;(function(x){x[x.Editing=0]="Editing",x[x.Preview=1]="Preview"})(_n=e.CommentMode||(e.CommentMode={}));class cn{constructor(L,ne=[]){this.tokenTypes=L,this.tokenModifiers=ne}}e.SemanticTokensLegend=cn;function Bt(x){return typeof x=="undefined"||y.isStringArray(x)}class Xt{constructor(L){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,L){this._hasLegend=!0;for(let ne=0,Se=L.tokenTypes.length;ne<Se;ne++)this._tokenTypeStrToInt.set(L.tokenTypes[ne],ne);for(let ne=0,Se=L.tokenModifiers.length;ne<Se;ne++)this._tokenModifierStrToInt.set(L.tokenModifiers[ne],ne)}}push(L,ne,Se,je,et){if(typeof L=="number"&&typeof ne=="number"&&typeof Se=="number"&&typeof je=="number"&&(typeof et=="number"||typeof et=="undefined"))return typeof et=="undefined"&&(et=0),this._pushEncoded(L,ne,Se,je,et);if(H.isRange(L)&&typeof ne=="string"&&Bt(Se))return this._push(L,ne,Se);throw T.illegalArgument()}_push(L,ne,Se){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(L.start.line!==L.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ne))throw new Error("`tokenType` is not in the provided legend");const je=L.start.line,et=L.start.character,at=L.end.character-L.start.character,dt=this._tokenTypeStrToInt.get(ne);let St=0;if(Se)for(const It of Se){if(!this._tokenModifierStrToInt.has(It))throw new Error("`tokenModifier` is not in the provided legend");const At=this._tokenModifierStrToInt.get(It);St|=1<<At>>>0}this._pushEncoded(je,et,at,dt,St)}_pushEncoded(L,ne,Se,je,et){if(this._dataIsSortedAndDeltaEncoded&&(L<this._prevLine||L===this._prevLine&&ne<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const St=this._data.length/5|0;let It=0,At=0;for(let Rt=0;Rt<St;Rt++){let Ot=this._data[5*Rt],on=this._data[5*Rt+1];Ot===0?(Ot=It,on+=At):Ot+=It,this._data[5*Rt]=Ot,this._data[5*Rt+1]=on,It=Ot,At=on}}let at=L,dt=ne;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(at-=this._prevLine,at===0&&(dt-=this._prevChar)),this._data[this._dataLen++]=at,this._data[this._dataLen++]=dt,this._data[this._dataLen++]=Se,this._data[this._dataLen++]=je,this._data[this._dataLen++]=et,this._prevLine=L,this._prevChar=ne}static _sortAndDeltaEncode(L){let ne=[];const Se=L.length/5|0;for(let dt=0;dt<Se;dt++)ne[dt]=dt;ne.sort((dt,St)=>{const It=L[5*dt],At=L[5*St];if(It===At){const Rt=L[5*dt+1],Ot=L[5*St+1];return Rt-Ot}return It-At});const je=new Uint32Array(L.length);let et=0,at=0;for(let dt=0;dt<Se;dt++){const St=5*ne[dt],It=L[St+0],At=L[St+1],Rt=L[St+2],Ot=L[St+3],on=L[St+4],Fn=It-et,xn=Fn===0?At-at:At,an=5*dt;je[an+0]=Fn,je[an+1]=xn,je[an+2]=Rt,je[an+3]=Ot,je[an+4]=on,et=It,at=At}return je}build(L){return this._dataIsSortedAndDeltaEncoded?new Ht(new Uint32Array(this._data),L):new Ht(Xt._sortAndDeltaEncode(this._data),L)}}e.SemanticTokensBuilder=Xt;class Ht{constructor(L,ne){this.resultId=ne,this.data=L}}e.SemanticTokens=Ht;class Zt{constructor(L,ne,Se){this.start=L,this.deleteCount=ne,this.data=Se}}e.SemanticTokensEdit=Zt;class En{constructor(L,ne){this.resultId=ne,this.edits=L}}e.SemanticTokensEdits=En;var yn;(function(x){x[x.Separate=0]="Separate",x[x.MergeWithParent=1]="MergeWithParent"})(yn=e.DebugConsoleMode||(e.DebugConsoleMode={}));var Nt;(function(x){x[x.Initial=1]="Initial",x[x.Dynamic=2]="Dynamic"})(Nt=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let jt=class{constructor(){}};jt.Back={iconPath:new gt("arrow-left")},jt=He([a],jt),e.QuickInputButtons=jt;var Sn;(function(x){x[x.UI=1]="UI",x[x.Workspace=2]="Workspace"})(Sn=e.ExtensionKind||(e.ExtensionKind={}));class Dn{constructor(L,ne,Se){this.badge=L,this.tooltip=ne,this.color=Se}static validate(L){if(L.badge&&L.badge.length!==1&&L.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!L.color&&!L.badge&&!L.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=Dn;let en=class{constructor(L){this.kind=L}};en=He([a],en),e.ColorTheme=en;var tn;(function(x){x[x.Light=1]="Light",x[x.Dark=2]="Dark",x[x.HighContrast=3]="HighContrast"})(tn=e.ColorThemeKind||(e.ColorThemeKind={}));class $t{constructor(L,ne){if(L<0)throw T.illegalArgument("start must be positive");if(ne<0)throw T.illegalArgument("end must be positive");L<=ne?(this._start=L,this._end=ne):(this._start=ne,this._end=L)}static isNotebookRange(L){return L instanceof $t?!0:L?typeof L.start=="number"&&typeof L.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(L){let ne=this._start,Se=this._end;return L.start!==void 0&&(ne=L.start),L.end!==void 0&&(Se=L.end),ne===this._start&&Se===this._end?this:new $t(ne,Se)}}e.NotebookRange=$t;class Tt{constructor(L,ne,Se,je,et,at){this.kind=L,this.value=ne,this.languageId=Se,this.outputs=je??[],this.metadata=et,this.executionSummary=at,Tt.validate(this)}static validate(L){if(typeof L.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof L.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof L.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(L){return Array.isArray(L)&&L.every(ne=>Tt.isNotebookCellData(ne))}static isNotebookCellData(L){return!0}}e.NotebookCellData=Tt;class nn{constructor(L){this.cells=L}}e.NotebookData=nn;class Te{constructor(L,ne){this.data=L,this.mime=ne;const Se=C.normalizeMimeType(ne,!0);if(!Se)throw new Error("INVALID mime type, must not be empty or falsy: "+ne);this.mime=Se}static isNotebookCellOutputItem(L){return L instanceof Te?!0:L?typeof L.mime=="string"&&L.data instanceof Uint8Array:!1}static error(L){const ne={name:L.name,message:L.message,stack:L.stack};return Te.json(ne,"application/vnd.code.notebook.error")}static stdout(L){return Te.text(L,"application/vnd.code.notebook.stdout")}static stderr(L){return Te.text(L,"application/vnd.code.notebook.stderr")}static bytes(L,ne="application/octet-stream"){return new Te(L,ne)}static text(L,ne="text/plain"){const Se=xe(Te,u,"f",w).encode(String(L));return new Te(Se,ne)}static json(L,ne="application/json"){const Se=JSON.stringify(L,void 0,"	");return Te.text(Se,ne)}}e.NotebookCellOutputItem=Te,u=Te,w={value:new TextEncoder};class Wt{constructor(L,ne,Se){this.items=Wt.ensureUniqueMimeTypes(L,!0),typeof ne=="string"?(this.id=ne,this.metadata=Se):(this.id=k.generateUuid(),this.metadata=ne??Se)}static isNotebookCellOutput(L){return L instanceof Wt?!0:!L||typeof L!="object"?!1:typeof L.id=="string"&&y.isArray(L.items)}static ensureUniqueMimeTypes(L,ne=!1){const Se=new Set,je=new Set;for(let et=0;et<L.length;et++){const at=L[et],dt=C.normalizeMimeType(at.mime);if(!Se.has(dt)){Se.add(dt);continue}je.add(et),ne&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return je.size===0?L:L.filter((et,at)=>!je.has(at))}}e.NotebookCellOutput=Wt;var dn;(function(x){x[x.Markup=1]="Markup",x[x.Code=2]="Code"})(dn=e.NotebookCellKind||(e.NotebookCellKind={}));var pt;(function(x){x[x.Idle=1]="Idle",x[x.Pending=2]="Pending",x[x.Executing=3]="Executing"})(pt=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Cn;(function(x){x[x.Left=1]="Left",x[x.Right=2]="Right"})(Cn=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var kn;(function(x){x[x.Default=0]="Default",x[x.InCenter=1]="InCenter",x[x.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",x[x.AtTop=3]="AtTop"})(kn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class hn{constructor(L,ne){this.text=L,this.alignment=ne}}e.NotebookCellStatusBarItem=hn;var fn;(function(x){x[x.Default=1]="Default",x[x.Preferred=2]="Preferred"})(fn=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class rn{constructor(L,ne=[]){this.uri=L,this.provides=g.asArray(ne)}}e.NotebookRendererScript=rn;let sn=class{constructor(L,ne){this.label=L,this.timestamp=ne}};sn=He([a],sn),e.TimelineItem=sn;var In;(function(x){x[x.Production=1]="Production",x[x.Development=2]="Development",x[x.Test=3]="Test"})(In=e.ExtensionMode||(e.ExtensionMode={}));var Pn;(function(x){x[x.Node=1]="Node",x[x.Webworker=2]="Webworker"})(Pn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var mn;(function(x){x[x.Other=0]="Other",x[x.Comment=1]="Comment",x[x.String=2]="String",x[x.RegEx=4]="RegEx"})(mn=e.StandardTokenType||(e.StandardTokenType={}));class An{constructor(L,ne){this.ranges=L,this.wordPattern=ne}}e.LinkedEditingRanges=An;class Tn{constructor(L,ne){this._port=L,this._autoForwardAction=ne}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Tn;var Rn;(function(x){x[x.Unset=0]="Unset",x[x.Queued=1]="Queued",x[x.Running=2]="Running",x[x.Passed=3]="Passed",x[x.Failed=4]="Failed",x[x.Skipped=5]="Skipped",x[x.Errored=6]="Errored"})(Rn=e.TestResultState||(e.TestResultState={}));var gn;(function(x){x[x.Error=0]="Error",x[x.Warning=1]="Warning",x[x.Information=2]="Information",x[x.Hint=3]="Hint"})(gn=e.TestMessageSeverity||(e.TestMessageSeverity={}));var pn;(function(x){x[x.Pending=0]="Pending",x[x.Resolved=1]="Resolved"})(pn=e.TestItemStatus||(e.TestItemStatus={}));const J=(x,L,ne,Se)=>{let je=ne;return{enumerable:!0,configurable:!1,get(){return je},set(et){Se(je,et)||(je=et,x.bus.fire([3,L,et]))}}},ce=(x,L)=>x===L,ke=(x,L)=>x===L?!0:!x||!L?!1:x.isEqual(L);class st{constructor(L,ne,Se,je){this.label=ne,this.data=je;const et=o.getPrivateApiFor(this);Object.defineProperties(this,{id:{value:L,enumerable:!0,writable:!1},uri:{value:Se,enumerable:!0,writable:!1},parent:{enumerable:!1,get:()=>et.parent},children:{value:new E.ReadonlyMapView(et.children),enumerable:!0,writable:!1},range:J(et,"range",void 0,ke),description:J(et,"description",void 0,ce),runnable:J(et,"runnable",!0,ce),debuggable:J(et,"debuggable",!1,ce),status:J(et,"status",pn.Resolved,ce),error:J(et,"error",void 0,ce)})}invalidate(){o.getPrivateApiFor(this).bus.fire([2])}dispose(){const L=o.getPrivateApiFor(this);L.parent&&o.getPrivateApiFor(L.parent).children.delete(this.id),L.bus.fire([1])}addChild(L){if(!(L instanceof st))throw new Error("Test child must be created through vscode.test.createTestItem()");const ne=o.getPrivateApiFor(this);if(ne.children.has(L.id))throw new Error(`Attempted to insert a duplicate test item ID ${L.id}`);ne.children.set(L.id,L),ne.bus.fire([0,L])}}e.TestItemImpl=st;class bt{constructor(L){this.message=L,this.severity=gn.Error}static diff(L,ne,Se){const je=new bt(L);return je.expectedOutput=ne,je.actualOutput=Se,je}}e.TestMessage=bt;var Ct;(function(x){x[x.None=0]="None",x[x.Option=1]="Option",x[x.Default=2]="Default",x[x.Preferred=3]="Preferred"})(Ct=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var On;(function(x){x[x.Untrusted=0]="Untrusted",x[x.Trusted=1]="Trusted",x[x.Unspecified=2]="Unspecified"})(On=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Un;(function(x){x[x.Notify=1]="Notify",x[x.OpenBrowser=2]="OpenBrowser",x[x.OpenPreview=3]="OpenPreview",x[x.Silent=4]="Silent",x[x.Ignore=5]="Ignore"})(Un=e.PortAutoForwardAction||(e.PortAutoForwardAction={}))}),define(we[93],_e([0,1,39,15,8,119,84,6,16]),function(Z,e,g,T,D,E,C,y,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const k=new Map;function n(d,u){u?k.set(d,u):k.delete(d)}e.setWordDefinitionFor=n;function I(d){return k.get(d)}e.getWordDefinitionFor=I;class o extends E.MirrorTextModel{constructor(u,w,v,S,c,m,f,t){super(w,v,S,c);this._proxy=u,this._languageId=m,this._isDirty=f,this._notebook=t,this._isDisposed=!1}dispose(){g.ok(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(u){return _.equals(this._lines,u)}get document(){if(!this._document){const u=this;this._document={get uri(){return u._uri},get fileName(){return u._uri.fsPath},get isUntitled(){return u._uri.scheme===T.Schemas.untitled},get languageId(){return u._languageId},get version(){return u._versionId},get isClosed(){return u._isDisposed},get isDirty(){return u._isDirty},get notebook(){return u._notebook},save(){return u._save()},getText(w){return w?u._getTextInRange(w):u.getText()},get eol(){return u._eol===`
`?y.EndOfLine.LF:y.EndOfLine.CRLF},get lineCount(){return u._lines.length},lineAt(w){return u._lineAt(w)},offsetAt(w){return u._offsetAt(w)},positionAt(w){return u._positionAt(w)},validateRange(w){return u._validateRange(w)},validatePosition(w){return u._validatePosition(w)},getWordRangeAtPosition(w,v){return u._getWordRangeAtPosition(w,v)}}}return Object.freeze(this._document)}_acceptLanguageId(u){g.ok(!this._isDisposed),this._languageId=u}_acceptIsDirty(u){g.ok(!this._isDisposed),this._isDirty=u}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(u){const w=this._validateRange(u);if(w.isEmpty)return"";if(w.isSingleLine)return this._lines[w.start.line].substring(w.start.character,w.end.character);const v=this._eol,S=w.start.line,c=w.end.line,m=[];m.push(this._lines[S].substring(w.start.character));for(let f=S+1;f<c;f++)m.push(this._lines[f]);return m.push(this._lines[c].substring(0,w.end.character)),m.join(v)}_lineAt(u){let w;if(u instanceof y.Position?w=u.line:typeof u=="number"&&(w=u),typeof w!="number"||w<0||w>=this._lines.length||Math.floor(w)!==w)throw new Error("Illegal value for `line`");return new h(w,this._lines[w],w===this._lines.length-1)}_offsetAt(u){return u=this._validatePosition(u),this._ensureLineStarts(),this._lineStarts.getAccumulatedValue(u.line-1)+u.character}_positionAt(u){u=Math.floor(u),u=Math.max(0,u),this._ensureLineStarts();const w=this._lineStarts.getIndexOf(u),v=this._lines[w.index].length;return new y.Position(w.index,Math.min(w.remainder,v))}_validateRange(u){if(!(u instanceof y.Range))throw new Error("Invalid argument");const w=this._validatePosition(u.start),v=this._validatePosition(u.end);return w===u.start&&v===u.end?u:new y.Range(w.line,w.character,v.line,v.character)}_validatePosition(u){if(!(u instanceof y.Position))throw new Error("Invalid argument");if(this._lines.length===0)return u.with(0,0);let{line:w,character:v}=u,S=!1;if(w<0)w=0,v=0,S=!0;else if(w>=this._lines.length)w=this._lines.length-1,v=this._lines[w].length,S=!0;else{const c=this._lines[w].length;v<0?(v=0,S=!0):v>c&&(v=c,S=!0)}return S?new y.Position(w,v):u}_getWordRangeAtPosition(u,w){const v=this._validatePosition(u);if(!w)w=I(this._languageId);else if(D.regExpLeadsToEndlessLoop(w))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${w.source}' because it matches the empty string.`);const S=C.getWordAtText(v.character+1,C.ensureValidWordDefinition(w),this._lines[v.line],0);if(S)return new y.Range(v.line,S.startColumn-1,v.line,S.endColumn-1)}}e.ExtHostDocumentData=o;class h{constructor(u,w,v){this._line=u,this._text=w,this._isLastLine=v}get lineNumber(){return this._line}get text(){return this._text}get range(){return new y.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new y.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=h}),define(we[154],_e([0,1,6,3,86,7,55,22,2,34]),function(Z,e,g,T,D,E,C,y,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class n{constructor(o,h,d,u){this._notebook=d,this._selector=u,this._disposables=new E.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new T.Emitter,this.onDidChange=this._onDidChange.event,this.uri=_.URI.from({scheme:"vscode-concat-doc",path:k.generateUuid()}),this._init(),this._disposables.add(h.onDidChangeDocument(v=>{const S=this._cellUris.get(v.document.uri);S!==void 0&&(this._cellLengths.changeValue(S,this._cells[S].document.getText().length+1),this._cellLines.changeValue(S,this._cells[S].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const w=v=>{v===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(o.onDidChangeNotebookCells(v=>w(v.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new y.ResourceMap;const o=[],h=[];for(const d of this._notebook.getCells())d.kind===g.NotebookCellKind.Code&&(!this._selector||C.score(this._selector,d.document.uri,d.document.languageId,!0))&&(this._cellUris.set(d.document.uri,this._cells.length),this._cells.push(d),o.push(d.document.getText().length+1),h.push(d.document.lineCount));this._cellLengths=new D.PrefixSumComputer(new Uint32Array(o)),this._cellLines=new D.PrefixSumComputer(new Uint32Array(h))}get version(){return this._versionId}getText(o){var h,d;if(!o){let c="";for(const m of this._cells)c+=m.document.getText()+`
`;return c=c.slice(0,-1),c}if(o.isEmpty)return"";const u=this.locationAt(o.start),w=this.locationAt(o.end),v=this._cells[(h=this._cellUris.get(u.uri))!==null&&h!==void 0?h:-1],S=this._cells[(d=this._cellUris.get(w.uri))!==null&&d!==void 0?d:-1];if(!v||!S)return"";if(v===S)return v.document.getText(new g.Range(u.range.start,w.range.end));{const c=v.document.getText(new g.Range(u.range.start,new g.Position(v.document.lineCount,0))),m=S.document.getText(new g.Range(new g.Position(0,0),w.range.end));return c+`
`+m}}offsetAt(o){const h=this._cellLines.getIndexOf(o.line),d=this._cellLengths.getAccumulatedValue(h.index-1),u=this._cells[h.index].document.offsetAt(o.with(h.remainder));return d+u}positionAt(o){if(typeof o=="number"){const d=this._cellLengths.getIndexOf(o),u=this._cellLines.getAccumulatedValue(d.index-1);return this._cells[d.index].document.positionAt(d.remainder).translate(u)}const h=this._cellUris.get(o.uri);if(h!==void 0){const d=this._cellLines.getAccumulatedValue(h-1);return new g.Position(d+o.range.start.line,o.range.start.character)}return new g.Position(0,0)}locationAt(o){g.Range.isRange(o)||(o=new g.Range(o,o));const h=this._cellLines.getIndexOf(o.start.line);let d=h;o.isEmpty||(d=this._cellLines.getIndexOf(o.end.line));const u=new g.Position(h.remainder,o.start.character),w=new g.Position(d.remainder,o.end.character),v=new g.Range(u,w),S=this._cells[h.index];return new g.Location(S.document.uri,S.document.validateRange(v))}contains(o){return this._cellUris.has(o)}validateRange(o){const h=this.validatePosition(o.start),d=this.validatePosition(o.end);return o.with(h,d)}validatePosition(o){const h=this._cellLines.getIndexOf(o.line),d=new g.Position(h.remainder,o.character),u=this._cells[h.index].document.validatePosition(d),w=this._cellLines.getAccumulatedValue(h.index-1);return new g.Position(w+u.line,u.character)}}e.ExtHostNotebookConcatDocument=n}),define(we[155],_e([0,1,6,14,3]),function(Z,e,g,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let E=class{constructor(y){this._actual=new g.ColorTheme(g.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new D.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(y){let _=y==="light"?g.ColorThemeKind.Light:y==="dark"?g.ColorThemeKind.Dark:g.ColorThemeKind.HighContrast;this._actual=new g.ColorTheme(_),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};E=He([ze(0,T.IExtHostRpcService)],E),e.ExtHostTheming=E}),define(we[67],_e([0,1,5]),function(Z,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=g.createDecorator("IURITransformerService");class T{constructor(E){E?(this.transformIncoming=E.transformIncoming.bind(E),this.transformOutgoing=E.transformOutgoing.bind(E),this.transformOutgoingURI=E.transformOutgoingURI.bind(E),this.transformOutgoingScheme=E.transformOutgoingScheme.bind(E)):(this.transformIncoming=C=>C,this.transformOutgoing=C=>C,this.transformOutgoingURI=C=>C,this.transformOutgoingScheme=C=>C)}}e.URITransformerService=T}),define(we[156],_e([0,1,23]),function(Z,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class T{constructor(){this.buffers=[]}add(_){let k=this.buffers.indexOf(_);return k<0&&(k=this.buffers.length,this.buffers.push(_)),k}}function D(y,_){if(_.serializeBuffersForPostMessage){const k=new T,n=(h,d)=>{if(d instanceof ArrayBuffer){const u=k.add(d);return{$$vscode_array_buffer_reference$$:!0,index:u}}else if(ArrayBuffer.isView(d)){const u=E(d);if(u){const w=k.add(d.buffer);return{$$vscode_array_buffer_reference$$:!0,index:w,view:{type:u,byteLength:d.byteLength,byteOffset:d.byteOffset}}}}return d},I=JSON.stringify(y,n),o=k.buffers.map(h=>{const d=new Uint8Array(h);return g.VSBuffer.wrap(d)});return{message:I,buffers:o}}else return{message:JSON.stringify(y),buffers:[]}}e.serializeWebviewMessage=D;function E(y){switch(y.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function C(y,_){const k=_.map(o=>{const h=new ArrayBuffer(o.byteLength);return new Uint8Array(h).set(o.buffer),h}),n=_.length?(o,h)=>{if(typeof h=="object"&&h.$$vscode_array_buffer_reference$$){const d=h,{index:u}=d,w=k[u];if(d.view)switch(d.view.type){case 1:return new Int8Array(w,d.view.byteOffset,d.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(w,d.view.byteOffset,d.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(w,d.view.byteOffset,d.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(w,d.view.byteOffset,d.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(w,d.view.byteOffset,d.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(w,d.view.byteOffset,d.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(w,d.view.byteOffset,d.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(w,d.view.byteOffset,d.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(w,d.view.byteOffset,d.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(w,d.view.byteOffset,d.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(w,d.view.byteOffset,d.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return w}return h}:void 0;return{message:JSON.parse(y,n),arrayBuffers:k}}e.deserializeWebviewMessage=C}),define(we[68],_e([0,1,15,2]),function(Z,e,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function D(E,C){return E.scheme===g.Schemas.http||E.scheme===g.Schemas.https?E:(C&&C.authority&&C.isRemote&&E.scheme===g.Schemas.file&&(E=T.URI.from({scheme:g.Schemas.vscodeRemote,authority:C.authority,path:E.path})),T.URI.from({scheme:g.Schemas.https,authority:`${E.scheme}+${E.authority}.${e.webviewRootResourceAuthority}`,path:E.path,fragment:E.fragment,query:E.query}))}e.asWebviewUri=D}),define(we[157],_e([0,1,3,7,68]),function(Z,e,g,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class E{constructor(y,_,k){this._proxy=y,this._editors=_,this._initData=k,this._handlePool=0,this._disposables=new T.DisposableStore,this._insets=new Map,this._disposables.add(_.onDidChangeVisibleTextEditors(()=>{const n=_.getVisibleTextEditors();for(const I of this._insets.values())n.indexOf(I.editor)<0&&I.inset.dispose()}))}dispose(){this._insets.forEach(y=>y.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(y,_,k,n,I){let o;for(const c of this._editors.getVisibleTextEditors(!0))if(c.value===y){o=c;break}if(!o)throw new Error("not a visible editor");const h=this,d=this._handlePool++,u=new g.Emitter,w=new g.Emitter,v=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(c){return D.asWebviewUri(c,h._initData.remote)}get cspSource(){return D.webviewGenericCspSource}set options(c){this._options=c,h._proxy.$setOptions(d,c)}get options(){return this._options}set html(c){this._html=c,h._proxy.$setHtml(d,c)}get html(){return this._html}get onDidReceiveMessage(){return u.event}postMessage(c){return h._proxy.$postMessage(d,c)}},S=new class{constructor(){this.editor=y,this.line=_,this.height=k,this.webview=v,this.onDidDispose=w.event}dispose(){h._insets.has(d)&&(h._insets.delete(d),h._proxy.$disposeEditorInset(d),w.fire(),w.dispose(),u.dispose())}};return this._proxy.$createEditorInset(d,o.id,o.value.document.uri,_+1,k,n||{},I.identifier,I.extensionLocation),this._insets.set(d,{editor:y,inset:S,onDidReceiveMessage:u}),S}$onDidDispose(y){const _=this._insets.get(y);_&&_.inset.dispose()}$onDidReceiveMessage(y,_){const k=this._insets.get(y);k&&k.onDidReceiveMessage.fire(_)}}e.ExtHostEditorInsets=E}),define(we[158],_e([0,1,3,11,134]),function(Z,e,g,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class E{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new g.Emitter,this._onExit=new g.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(y){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=y}onEvent(y){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=y}onRequest(y){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=y}sendResponse(y){y.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${y.command}`)):this.internalSend("response",y)}sendRequest(y,_,k,n){const I={command:y};if(_&&Object.keys(_).length>0&&(I.arguments=_),this.internalSend("request",I),typeof n=="number"){const o=setTimeout(()=>{clearTimeout(o);const h=this.pendingRequests.get(I.seq);if(h){this.pendingRequests.delete(I.seq);const d={type:"response",seq:0,request_seq:I.seq,success:!1,command:y,message:D.localize(0,null,n,y)};h(d)}},n)}return k&&this.pendingRequests.set(I.seq,k),I.seq}acceptMessage(y){this.messageCallback?this.messageCallback(y):(this.queue.push(y),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(y,_){return y.type!=="event"||_.type!=="event"}async processQueue(){let y;for(;this.queue.length;){if((!y||this.needsTaskBoundaryBetween(this.queue[0],y))&&await T.timeout(0),y=this.queue.shift(),!y)return;switch(y.type){case"event":this.eventCallback&&this.eventCallback(y);break;case"request":this.requestCallback&&this.requestCallback(y);break;case"response":const _=y,k=this.pendingRequests.get(_.request_seq);k&&(this.pendingRequests.delete(_.request_seq),k(_));break}}}internalSend(y,_){_.type=y,_.seq=this.sequence++,this.sendMessage(_)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const y=new Map;this.pendingRequests.forEach((_,k)=>y.set(k,_)),await T.timeout(500),y.forEach((_,k)=>{_({type:"response",seq:0,request_seq:k,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(k)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=E}),define(we[159],_e([0,1,8,2,13,24,15]),function(Z,e,g,T,D,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const y=/{([^}]+)}/g;function _(r,i,s){return r.replace(y,function(l,b){return i&&b.length>0&&b[0]!=="_"?l:s&&s.hasOwnProperty(b)?s[b]:l})}e.formatPII=_;function k(r){const i={};for(const s of Object.keys(r))s.startsWith("!")||(i[s]=r[s]);return i}e.filterExceptionsFromTelemetry=k;function n(r){return r.configuration.request==="attach"&&!I(r)}e.isSessionAttach=n;function I(r){let i=r.configuration.type;if(!!i)return i==="vslsShare"&&(i=r.configuration.adapterProxy.configuration.type),g.equalsIgnoreCase(i,"extensionhost")||g.equalsIgnoreCase(i,"pwa-extensionhost")?r:r.parentSession?I(r.parentSession):void 0}e.getExtensionHostDebugSession=I;function o(r){return r.type&&(r.label||r.program||r.runtime)}e.isDebuggerMainContribution=o;function h(r,i,s){let l,b=0,p=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,P=null;for(;P=p.exec(r);){let A=P.index+1,a=A+P[0].length;if(A<=i&&a>=s){l=P[0],b=A;break}}if(l){let A=/\w+/g,a=null;for(;(a=A.exec(l))&&!(a.index+1+b+a[0].length>=s););a&&(l=l.substring(0,A.lastIndex))}return l?{start:b,end:b+l.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=h;const d=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function u(r){return!!(r&&r.match(d))}e.isUri=u;function w(r){if(typeof r.path=="string"&&!(typeof r.sourceReference=="number"&&r.sourceReference>0)){if(u(r.path))return T.URI.parse(r.path);if(D.isAbsolute(r.path))return T.URI.file(r.path)}return r.path}function v(r){if(typeof r.path=="object"){const i=T.URI.revive(r.path);if(i)return i.scheme===C.Schemas.file?i.fsPath:i.toString()}return r.path}function S(r,i){const s=i?w:v,l=E.deepClone(r);return m(l,(b,p)=>{b&&p&&(p.path=s(p))}),l}e.convertToDAPaths=S;function c(r,i){const s=i?w:v,l=E.deepClone(r);return m(l,(b,p)=>{!b&&p&&(p.path=s(p))}),l}e.convertToVSCPaths=c;function m(r,i){switch(r.type){case"event":const s=r;switch(s.event){case"output":i(!1,s.body.source);break;case"loadedSource":i(!1,s.body.source);break;case"breakpoint":i(!1,s.body.breakpoint.source);break;default:break}break;case"request":const l=r;switch(l.command){case"setBreakpoints":i(!0,l.arguments.source);break;case"breakpointLocations":i(!0,l.arguments.source);break;case"source":i(!0,l.arguments.source);break;case"gotoTargets":i(!0,l.arguments.source);break;case"launchVSCode":l.arguments.args.forEach(p=>i(!1,p));break;default:break}break;case"response":const b=r;if(b.success&&b.body)switch(b.command){case"stackTrace":b.body.stackFrames.forEach(p=>i(!1,p.source));break;case"loadedSources":b.body.sources.forEach(p=>i(!1,p));break;case"scopes":b.body.scopes.forEach(p=>i(!1,p.source));break;case"setFunctionBreakpoints":b.body.breakpoints.forEach(p=>i(!1,p.source));break;case"setBreakpoints":b.body.breakpoints.forEach(p=>i(!1,p.source));break;default:break}break}}function f(r){return r.filter(i=>{var s;return!((s=i.presentation)===null||s===void 0?void 0:s.hidden)}).sort((i,s)=>i.presentation?s.presentation?i.presentation.group?s.presentation.group?i.presentation.group!==s.presentation.group?i.presentation.group.localeCompare(s.presentation.group):t(i.presentation.order,s.presentation.order):-1:s.presentation.group?1:t(i.presentation.order,s.presentation.order):-1:s.presentation?1:0)}e.getVisibleAndSorted=f;function t(r,i){return typeof r!="number"?typeof i!="number"?0:1:typeof i!="number"?-1:r-i}}),define(we[45],_e([0,1,27,15,13,21,88]),function(Z,e,g,T,D,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.OpenGettingStarted=e.ConsolidatedRunButton=e.NotebookCellEditorOptionsCustomizations=e.DragAndDropEnabled=e.ShowFoldingControls=e.ConsolidatedOutputButton=e.UndoRedoPerCell=e.GlobalToolbar=e.InsertToolbarLocation=e.FocusIndicator=e.CompactView=e.ExperimentalInsertToolbarAlignment=e.ExperimentalUseMarkdownRenderer=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBar=e.CellToolbarVisibility=e.CellToolbarLocation=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.getCellUndoRedoComparisonKey=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.AnyRendererApi=e.NotebookCellExecutionState=e.notebookDocumentMetadataDefaults=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var y;(function(a){a[a.Markup=1]="Markup",a[a.Code=2]="Code"})(y=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml","text/markdown","image/png","image/jpeg","text/plain"],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=["text/markdown","application/json","text/plain","text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var _;(function(a){a[a.Running=1]="Running",a[a.Idle=2]="Idle"})(_=e.NotebookRunState||(e.NotebookRunState={})),e.notebookDocumentMetadataDefaults={custom:{}};var k;(function(a){a[a.Pending=2]="Pending",a[a.Executing=3]="Executing"})(k=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={})),e.AnyRendererApi=Symbol("AnyRendererApi");var n;(function(a){a[a.WithHardKernelDependency=0]="WithHardKernelDependency",a[a.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",a[a.Pure=2]="Pure",a[a.Never=3]="Never"})(n=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var I;(function(a){a.Always="always",a.Never="never",a.Optional="optional"})(I=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var o;(function(a){a[a.ModelChange=1]="ModelChange",a[a.Move=2]="Move",a[a.CellClearOutput=3]="CellClearOutput",a[a.CellsClearOutput=4]="CellsClearOutput",a[a.ChangeLanguage=5]="ChangeLanguage",a[a.Initialize=6]="Initialize",a[a.ChangeCellMetadata=7]="ChangeCellMetadata",a[a.Output=8]="Output",a[a.OutputItem=9]="OutputItem",a[a.ChangeCellContent=10]="ChangeCellContent",a[a.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",a[a.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",a[a.Unknown=100]="Unknown"})(o=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var h;(function(a){a[a.Handle=0]="Handle",a[a.Index=1]="Index"})(h=e.SelectionStateType||(e.SelectionStateType={}));var d;(function(a){a[a.Replace=1]="Replace",a[a.Output=2]="Output",a[a.Metadata=3]="Metadata",a[a.CellLanguage=4]="CellLanguage",a[a.DocumentMetadata=5]="DocumentMetadata",a[a.Move=6]="Move",a[a.OutputItems=7]="OutputItems",a[a.PartialMetadata=8]="PartialMetadata",a[a.PartialInternalMetadata=9]="PartialInternalMetadata"})(d=e.CellEditType||(e.CellEditType={}));function u(a,F){if(F)return a.toString();const N=w.parse(a);return N?N.notebook.toString():a.toString()}e.getCellUndoRedoComparisonKey=u;var w;(function(a){a.scheme=T.Schemas.vscodeNotebookCell;const F=/^ch(\d{7,})/;function N(z,Y){return z.with({scheme:a.scheme,fragment:`ch${Y.toString().padStart(7,"0")}${z.scheme!==T.Schemas.file?z.scheme:""}`})}a.generate=N;function H(z){if(z.scheme!==a.scheme)return;const Y=F.exec(z.fragment);return Y?{handle:Number(Y[1]),notebook:z.with({scheme:z.fragment.substr(Y[0].length)||T.Schemas.file,fragment:null})}:void 0}a.parse=H;function le(z){if(z.scheme!==T.Schemas.vscodeNotebookCellMetadata)return;const Y=F.exec(z.fragment);return Y?{handle:Number(Y[1]),notebook:z.with({scheme:z.fragment.substr(Y[0].length)||T.Schemas.file,fragment:null})}:void 0}a.parseCellMetadataUri=le;function fe(z,Y,R){return z.with({scheme:R,fragment:`ch${Y.toString().padStart(7,"0")}${z.scheme!==T.Schemas.file?z.scheme:""}`})}a.generateCellUri=fe;function X(z,Y){if(z.scheme!==Y)return;const R=F.exec(z.fragment);return R?{handle:Number(R[1]),notebook:z.with({scheme:z.fragment.substr(R[0].length)||T.Schemas.file,fragment:null})}:void 0}a.parseCellUri=X})(w=e.CellUri||(e.CellUri={}));const v=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],["text/markdown",{alwaysSecure:!0,supportedByCore:!0}],["text/plain",{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/x.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stream",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function S(a){var F,N;return(N=(F=v.get(a))===null||F===void 0?void 0:F.alwaysSecure)!==null&&N!==void 0?N:!1}e.mimeTypeIsAlwaysSecure=S;function c(a){var F,N;return(N=(F=v.get(a))===null||F===void 0?void 0:F.supportedByCore)!==null&&N!==void 0?N:!1}e.mimeTypeSupportedByCore=c;function m(a){var F,N;return(N=(F=v.get(a))===null||F===void 0?void 0:F.mergeable)!==null&&N!==void 0?N:!1}e.mimeTypeIsMergeable=m;function f(a,F){return E.isWindows&&(a=a.replace(/\//g,"\\"),F=F.replace(/\//g,"\\")),g.match(a,F)}function t(a,F,N){let H=0;for(let le=0;le<F.length;le++){if(f(F[le],a))return H;H++}for(let le=0;le<N.length;le++){if(f(N[le],a))return H;H++}return H}function r(a,F,N){return a.sort((H,le)=>t(H,F,N)-t(le,F,N))}e.sortMimeTypes=r;function i(a,F,N,H=(le,fe)=>le===fe){const le=[];function fe(Y,R,B){if(R===0&&B.length===0)return;const M=le[le.length-1];M&&M.start+M.deleteCount===Y?(M.deleteCount+=R,M.toInsert.push(...B)):le.push({start:Y,deleteCount:R,toInsert:B})}let X=0,z=0;for(;;){if(X===a.length){fe(X,0,F.slice(z));break}if(z===F.length){fe(X,a.length-X,[]);break}const Y=a[X],R=F[z];if(H(Y,R)){X+=1,z+=1;continue}N(R)?(fe(X,1,[]),X+=1):(fe(X,0,[R]),z+=1)}return le}e.diff=i,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new C.RawContextKey("notebookEditorCursorAtBoundary","none");var s;(function(a){a.default="default",a.option="option"})(s=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function l(a){const F=a;return!!((typeof F.include=="string"||g.isRelativePattern(F.include))&&(typeof F.exclude=="string"||g.isRelativePattern(F.exclude)))}e.isDocumentExcludePattern=l;function b(a,F,N){if(Array.isArray(a.viewType)&&a.viewType.indexOf(F)>=0||a.viewType===F)return!0;if(a.filenamePattern){let H=l(a.filenamePattern)?a.filenamePattern.include:a.filenamePattern,le=l(a.filenamePattern)?a.filenamePattern.exclude:void 0;if(g.match(H,D.basename(N.fsPath).toLowerCase()))return!(le&&g.match(le,D.basename(N.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=b;class p{constructor(F){this.textModel=F}getElements(){const F=new Int32Array(this.textModel.cells.length);for(let N=0;N<this.textModel.cells.length;N++)F[N]=this.textModel.cells[N].getHashValue();return F}}e.CellSequence=p,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocation="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBar="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalUseMarkdownRenderer="notebook.experimental.useMarkdownRenderer",e.ExperimentalInsertToolbarAlignment="notebook.experimental.insertToolbarAlignment",e.CompactView="notebook.compactView",e.FocusIndicator="notebook.cellFocusIndicator",e.InsertToolbarLocation="notebook.insertToolbarLocation",e.GlobalToolbar="notebook.globalToolbar",e.UndoRedoPerCell="notebook.undoRedoPerCell",e.ConsolidatedOutputButton="notebook.consolidatedOutputButton",e.ShowFoldingControls="notebook.showFoldingControls",e.DragAndDropEnabled="notebook.dragAndDropEnabled",e.NotebookCellEditorOptionsCustomizations="notebook.editorOptionsCustomizations",e.ConsolidatedRunButton="notebook.consolidatedRunButton",e.OpenGettingStarted="notebook.experimental.openGettingStarted";var P;(function(a){a[a.Left=1]="Left",a[a.Right=2]="Right"})(P=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class A{static create(F){return`${A._prefix}${F}`}static parse(F){if(F.startsWith(A._prefix))return F.substr(A._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=A,A._prefix="notebook/"}),define(we[160],_e([0,1,136,5,88]),function(Z,e,g,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new D.RawContextKey("customExecutionSupported",!0,g.localize(0,null)),e.ShellExecutionSupportedContext=new D.RawContextKey("shellExecutionSupported",!1,g.localize(1,null)),e.ProcessExecutionSupportedContext=new D.RawContextKey("processExecutionSupported",!1,g.localize(2,null)),e.ITaskService=T.createDecorator("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(we[161],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function g(D){return[...D.entries()]}e.serializeEnvironmentVariableCollection=g;function T(D){return new Map(D)}e.deserializeEnvironmentVariableCollection=T}),define(we[94],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.getTestSubscriptionKey=e.TestDiffOpType=e.applyTestItemUpdate=e.TestItemExpandState=void 0;var g;(function(_){_[_.NotExpandable=0]="NotExpandable",_[_.Expandable=1]="Expandable",_[_.BusyExpanding=2]="BusyExpanding",_[_.Expanded=3]="Expanded"})(g=e.TestItemExpandState||(e.TestItemExpandState={}));const T=(_,k)=>{k.expand!==void 0&&(_.expand=k.expand),k.item!==void 0&&(_.item=_.item?Object.assign(_.item,k.item):k.item)};e.applyTestItemUpdate=T;var D;(function(_){_[_.Add=0]="Add",_[_.Update=1]="Update",_[_.Remove=2]="Remove",_[_.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",_[_.Retire=4]="Retire"})(D=e.TestDiffOpType||(e.TestDiffOpType={}));const E=(_,k)=>`${_}:${k.toString()}`;e.getTestSubscriptionKey=E;class C{add(k){}update(k){}remove(k,n){}complete(){}}e.IncrementalChangeCollector=C;class y{constructor(){this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0}apply(k){const n=this.createChangeCollector();for(const I of k)switch(I[0]){case 0:{const o=I[1];if(o.parent){if(this.items.has(o.parent)){const h=this.items.get(o.parent);h.children.add(o.item.extId);const d=this.createItem(o,h);this.items.set(o.item.extId,d),n.add(d)}}else{this.roots.add(o.item.extId);const h=this.createItem(o);this.items.set(o.item.extId,h),n.add(h)}o.expand===2&&this.busyControllerCount++;break}case 1:{const o=I[1],h=this.items.get(o.extId);if(!h)break;o.expand!==void 0&&(h.expand===2&&this.busyControllerCount--,o.expand===2&&this.busyControllerCount++),e.applyTestItemUpdate(h,o),n.update(h);break}case 2:{const o=this.items.get(I[1]);if(!o)break;o.parent?this.items.get(o.parent).children.delete(o.item.extId):this.roots.delete(o.item.extId);const h=[[I[1]]];for(;h.length;)for(const d of h.pop()){const u=this.items.get(d);u&&(h.push(u.children),this.items.delete(d),n.remove(u,u!==o),u.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(I[1]);break;case 3:this.updatePendingRoots(I[1]);break}n.complete()}retireTest(k){}updatePendingRoots(k){this.pendingRootCount+=k}createChangeCollector(){return new C}}e.AbstractIncrementalTestCollection=y}),define(we[162],_e([0,1,13,40,10,24,21,81,137]),function(Z,e,g,T,D,E,C,y,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class k{constructor(I,o,h){this._contributedVariables=new Map,this._context=I,this._labelService=o,h&&(this._envVariablesPromise=h.then(d=>this.prepareEnv(d)))}prepareEnv(I){if(C.isWindows){const o=Object.create(null);return Object.keys(I).forEach(h=>{o[h.toLowerCase()]=I[h]}),o}return I}resolveWithEnvironment(I,o,h){return this.recursiveResolve(this.prepareEnv(I),o?o.uri:void 0,h)}async resolveAsync(I,o){return this.recursiveResolve(await this._envVariablesPromise,I?I.uri:void 0,o)}async resolveAnyBase(I,o,h,d){const u=E.deepClone(o);return C.isWindows&&u.windows?Object.keys(u.windows).forEach(w=>u[w]=u.windows[w]):C.isMacintosh&&u.osx?Object.keys(u.osx).forEach(w=>u[w]=u.osx[w]):C.isLinux&&u.linux&&Object.keys(u.linux).forEach(w=>u[w]=u.linux[w]),delete u.windows,delete u.osx,delete u.linux,this.recursiveResolve(await this._envVariablesPromise,I?I.uri:void 0,u,h,d)}async resolveAnyAsync(I,o,h){return this.resolveAnyBase(I,o,h)}async resolveAnyMap(I,o,h){const d=new Map;return{newConfig:await this.resolveAnyBase(I,o,h,d),resolvedVariables:d}}resolveWithInteractionReplace(I,o,h,d){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(I,o,h,d){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(I,o){if(this._contributedVariables.has(I))throw new Error("Variable "+I+" is contributed twice.");this._contributedVariables.set(I,o)}recursiveResolve(I,o,h,d,u){if(D.isString(h))return this.resolveString(I,o,h,d,u);if(D.isArray(h))return h.map(w=>this.recursiveResolve(I,o,w,d,u));if(D.isObject(h)){let w=Object.create(null);return Object.keys(h).forEach(v=>{const S=this.resolveString(I,o,v,d,u);w[S]=this.recursiveResolve(I,o,h[v],d,u)}),w}return h}resolveString(I,o,h,d,u){return h.replace(k.VARIABLE_REGEXP,(v,S)=>{if(S.includes(k.VARIABLE_LHS))return v;let c=this.evaluateSingleVariable(I,v,S,o,d);return u&&u.set(S,c),c!==v&&D.isString(c)&&c.match(k.VARIABLE_REGEXP)&&(c=this.resolveString(I,o,c,d,u)),c})}fsPath(I){return this._labelService?this._labelService.getUriLabel(I,{noPrefix:!0}):I.fsPath}evaluateSingleVariable(I,o,h,d,u){let w;const v=h.split(":");v.length>1&&(h=v[0],w=v[1]);const S=()=>{const f=this._context.getFilePath();if(f)return f;throw new Error(_.localize(0,null,o))},c=()=>{const f=S();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error(_.localize(1,null,o,g.basename(f)))},m=()=>{if(w){const f=this._context.getFolderUri(w);if(f)return f;throw new Error(_.localize(2,null,o,w))}if(d)return d;throw this._context.getWorkspaceFolderCount()>1?new Error(_.localize(3,null,o)):new Error(_.localize(4,null,o))};switch(h){case"env":if(w){if(I){const f=I[C.isWindows?w.toLowerCase():w];if(D.isString(f))return f}return""}throw new Error(_.localize(5,null,o));case"config":if(w){const f=this._context.getConfigurationValue(d,w);if(D.isUndefinedOrNull(f))throw new Error(_.localize(6,null,o,w));if(D.isObject(f))throw new Error(_.localize(7,null,o,w));return f}throw new Error(_.localize(8,null,o));case"command":return this.resolveFromMap(o,w,u,"command");case"input":return this.resolveFromMap(o,w,u,"input");default:switch(h){case"workspaceRoot":case"workspaceFolder":return y.normalizeDriveLetter(this.fsPath(m()));case"cwd":return d||w?y.normalizeDriveLetter(this.fsPath(m())):T.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return g.basename(this.fsPath(m()));case"lineNumber":const f=this._context.getLineNumber();if(f)return f;throw new Error(_.localize(9,null,o));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error(_.localize(10,null,o));case"file":return S();case"fileWorkspaceFolder":return c();case"relativeFile":return d||w?g.relative(this.fsPath(m()),S()):S();case"relativeFileDirname":const r=g.dirname(S());if(d||w){const b=g.relative(this.fsPath(m()),r);return b.length===0?".":b}return r;case"fileDirname":return g.dirname(S());case"fileExtname":return g.extname(S());case"fileBasename":return g.basename(S());case"fileBasenameNoExtension":const i=g.basename(S());return i.slice(0,i.length-g.extname(i).length);case"fileDirnameBasename":return g.basename(g.dirname(S()));case"execPath":const s=this._context.getExecPath();return s||o;case"execInstallFolder":const l=this._context.getAppRoot();return l||o;case"pathSeparator":return g.sep;default:try{const b=w?`${h}:${w}`:h;return this.resolveFromMap(o,b,u,void 0)}catch(b){return o}}}}resolveFromMap(I,o,h,d){if(o&&h){const u=d===void 0?h[o]:h[d+":"+o];if(typeof u=="string")return u;throw new Error(_.localize(11,null,I))}return I}}e.AbstractVariableResolverService=k,k.VARIABLE_LHS="${",k.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(we[163],_e([0,1,5]),function(Z,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=g.createDecorator("editorGroupsService");var T;(function(o){o[o.UP=0]="UP",o[o.DOWN=1]="DOWN",o[o.LEFT=2]="LEFT",o[o.RIGHT=3]="RIGHT"})(T=e.GroupDirection||(e.GroupDirection={}));var D;(function(o){o[o.HORIZONTAL=0]="HORIZONTAL",o[o.VERTICAL=1]="VERTICAL"})(D=e.GroupOrientation||(e.GroupOrientation={}));var E;(function(o){o[o.FIRST=0]="FIRST",o[o.LAST=1]="LAST",o[o.NEXT=2]="NEXT",o[o.PREVIOUS=3]="PREVIOUS"})(E=e.GroupLocation||(e.GroupLocation={}));var C;(function(o){o[o.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",o[o.EVEN=1]="EVEN",o[o.TOGGLE=2]="TOGGLE"})(C=e.GroupsArrangement||(e.GroupsArrangement={}));var y;(function(o){o[o.COPY_EDITORS=0]="COPY_EDITORS",o[o.MOVE_EDITORS=1]="MOVE_EDITORS"})(y=e.MergeGroupMode||(e.MergeGroupMode={}));var _;(function(o){o[o.CREATION_TIME=0]="CREATION_TIME",o[o.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",o[o.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(_=e.GroupsOrder||(e.GroupsOrder={}));var k;(function(o){o[o.GROUP_ACTIVE=0]="GROUP_ACTIVE",o[o.GROUP_INDEX=1]="GROUP_INDEX",o[o.EDITOR_OPEN=2]="EDITOR_OPEN",o[o.EDITOR_CLOSE=3]="EDITOR_CLOSE",o[o.EDITOR_MOVE=4]="EDITOR_MOVE",o[o.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",o[o.EDITOR_LABEL=6]="EDITOR_LABEL",o[o.EDITOR_CAPABILITIES=7]="EDITOR_CAPABILITIES",o[o.EDITOR_PIN=8]="EDITOR_PIN",o[o.EDITOR_STICKY=9]="EDITOR_STICKY",o[o.EDITOR_DIRTY=10]="EDITOR_DIRTY"})(k=e.GroupChangeKind||(e.GroupChangeKind={}));var n;(function(o){o[o.NEW_EDITOR=1]="NEW_EDITOR",o[o.MOVE_EDITOR=2]="MOVE_EDITOR",o[o.COPY_EDITOR=3]="COPY_EDITOR"})(n=e.OpenEditorContext||(e.OpenEditorContext={}));function I(o){return o.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=I}),define(we[164],_e([0,1,5]),function(Z,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=g.createDecorator("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2}),define(we[9],_e([0,1,16,80,218,54,24,10,2,31,58,138,89,45,164,6]),function(Z,e,g,T,D,E,C,y,_,k,n,I,o,h,d,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeActionTriggerKind=e.TestResults=e.TestItem=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var w;(function(ve){function ye($){const{selectionStartLineNumber:Ne,selectionStartColumn:Pe,positionLineNumber:Ve,positionColumn:Xe}=$,lt=new u.Position(Ne-1,Pe-1),ut=new u.Position(Ve-1,Xe-1);return new u.Selection(lt,ut)}ve.to=ye;function ue($){const{anchor:Ne,active:Pe}=$;return{selectionStartLineNumber:Ne.line+1,selectionStartColumn:Ne.character+1,positionLineNumber:Pe.line+1,positionColumn:Pe.character+1}}ve.from=ue})(w=e.Selection||(e.Selection={}));var v;(function(ve){function ye($){if(!$)return;const{start:Ne,end:Pe}=$;return{startLineNumber:Ne.line+1,startColumn:Ne.character+1,endLineNumber:Pe.line+1,endColumn:Pe.character+1}}ve.from=ye;function ue($){if(!$)return;const{startLineNumber:Ne,startColumn:Pe,endLineNumber:Ve,endColumn:Xe}=$;return new u.Range(Ne-1,Pe-1,Ve-1,Xe-1)}ve.to=ue})(v=e.Range||(e.Range={}));var S;(function(ve){function ye(ue){switch(ue){case 1:return u.StandardTokenType.Comment;case 0:return u.StandardTokenType.Other;case 4:return u.StandardTokenType.RegEx;case 2:return u.StandardTokenType.String}}ve.to=ye})(S=e.TokenType||(e.TokenType={}));var c;(function(ve){function ye($){return new u.Position($.lineNumber-1,$.column-1)}ve.to=ye;function ue($){return{lineNumber:$.line+1,column:$.character+1}}ve.from=ue})(c=e.Position||(e.Position={}));var m;(function(ve){function ye($){switch($){case u.DiagnosticTag.Unnecessary:return 1;case u.DiagnosticTag.Deprecated:return 2}}ve.from=ye;function ue($){switch($){case 1:return u.DiagnosticTag.Unnecessary;case 2:return u.DiagnosticTag.Deprecated;default:return}}ve.to=ue})(m=e.DiagnosticTag||(e.DiagnosticTag={}));var f;(function(ve){function ye($){let Ne;return $.code&&(y.isString($.code)||y.isNumber($.code)?Ne=String($.code):Ne={value:String($.code.value),target:$.code.target}),Object.assign(Object.assign({},v.from($.range)),{message:$.message,source:$.source,code:Ne,severity:r.from($.severity),relatedInformation:$.relatedInformation&&$.relatedInformation.map(t.from),tags:Array.isArray($.tags)?g.coalesce($.tags.map(m.from)):void 0})}ve.from=ye;function ue($){var Ne;const Pe=new u.Diagnostic(v.to($),$.message,r.to($.severity));return Pe.source=$.source,Pe.code=y.isString($.code)?$.code:(Ne=$.code)===null||Ne===void 0?void 0:Ne.value,Pe.relatedInformation=$.relatedInformation&&$.relatedInformation.map(t.to),Pe.tags=$.tags&&g.coalesce($.tags.map(m.to)),Pe}ve.to=ue})(f=e.Diagnostic||(e.Diagnostic={}));var t;(function(ve){function ye($){return Object.assign(Object.assign({},v.from($.location.range)),{message:$.message,resource:$.location.uri})}ve.from=ye;function ue($){return new u.DiagnosticRelatedInformation(new u.Location($.resource,v.to($)),$.message)}ve.to=ue})(t=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var r;(function(ve){function ye($){switch($){case u.DiagnosticSeverity.Error:return o.MarkerSeverity.Error;case u.DiagnosticSeverity.Warning:return o.MarkerSeverity.Warning;case u.DiagnosticSeverity.Information:return o.MarkerSeverity.Info;case u.DiagnosticSeverity.Hint:return o.MarkerSeverity.Hint}return o.MarkerSeverity.Error}ve.from=ye;function ue($){switch($){case o.MarkerSeverity.Info:return u.DiagnosticSeverity.Information;case o.MarkerSeverity.Warning:return u.DiagnosticSeverity.Warning;case o.MarkerSeverity.Error:return u.DiagnosticSeverity.Error;case o.MarkerSeverity.Hint:return u.DiagnosticSeverity.Hint;default:return u.DiagnosticSeverity.Error}}ve.to=ue})(r=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var i;(function(ve){function ye($){return typeof $=="number"&&$>=u.ViewColumn.One?$-1:$===u.ViewColumn.Beside?d.SIDE_GROUP:d.ACTIVE_GROUP}ve.from=ye;function ue($){if(typeof $=="number"&&$>=0)return $+1;throw new Error("invalid 'EditorGroupColumn'")}ve.to=ue})(i=e.ViewColumn||(e.ViewColumn={}));function s(ve){return typeof ve.range!="undefined"}function l(ve){return ve.length===0?!0:!!s(ve[0])}e.isDecorationOptionsArr=l;var b;(function(ve){function ye(Xe){return Xe.map(ve.from)}ve.fromMany=ye;function ue(Xe){return Xe&&typeof Xe=="object"&&typeof Xe.language=="string"&&typeof Xe.value=="string"}function $(Xe){let lt;if(ue(Xe)){const{language:yt,value:vt}=Xe;lt={value:"```"+yt+`
`+vt+"\n```\n"}}else u.MarkdownString.isMarkdownString(Xe)?lt={value:Xe.value,isTrusted:Xe.isTrusted,supportThemeIcons:Xe.supportThemeIcons}:typeof Xe=="string"?lt={value:Xe}:lt={value:""};const ut=Object.create(null);lt.uris=ut;const it=yt=>{try{let vt=_.URI.parse(yt,!0);vt=vt.with({query:Ne(vt.query,ut)}),ut[yt]=vt}catch(vt){}return""},mt=new D.Renderer;return mt.link=it,mt.image=yt=>it(T.parseHrefAndDimensions(yt).href),D(lt.value,{renderer:mt}),lt}ve.from=$;function Ne(Xe,lt){if(!Xe)return Xe;let ut;try{ut=E.parse(Xe)}catch(mt){}if(!ut)return Xe;let it=!1;return ut=C.cloneAndChange(ut,mt=>{if(_.URI.isUri(mt)){const yt=`__uri_${Math.random().toString(16).slice(2,8)}`;return lt[yt]=mt,it=!0,yt}else return}),it?JSON.stringify(ut):Xe}function Pe(Xe){const lt=new u.MarkdownString(Xe.value,Xe.supportThemeIcons);return lt.isTrusted=Xe.isTrusted,lt}ve.to=Pe;function Ve(Xe){if(!!Xe)return typeof Xe=="string"?Xe:ve.from(Xe)}ve.fromStrict=Ve})(b=e.MarkdownString||(e.MarkdownString={}));function p(ve){return l(ve)?ve.map(ye=>({range:v.from(ye.range),hoverMessage:Array.isArray(ye.hoverMessage)?b.fromMany(ye.hoverMessage):ye.hoverMessage?b.from(ye.hoverMessage):void 0,renderOptions:ye.renderOptions})):ve.map(ye=>({range:v.from(ye)}))}e.fromRangeOrRangeWithMessage=p;function P(ve){return typeof ve=="undefined"?ve:typeof ve=="string"?_.URI.file(ve):ve}e.pathOrURIToURI=P;var A;(function(ve){function ye(ue){return typeof ue=="undefined"?ue:{contentText:ue.contentText,contentIconPath:ue.contentIconPath?P(ue.contentIconPath):void 0,border:ue.border,borderColor:ue.borderColor,fontStyle:ue.fontStyle,fontWeight:ue.fontWeight,textDecoration:ue.textDecoration,color:ue.color,backgroundColor:ue.backgroundColor,margin:ue.margin,width:ue.width,height:ue.height}}ve.from=ye})(A=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var a;(function(ve){function ye(ue){return typeof ue=="undefined"?ue:{backgroundColor:ue.backgroundColor,outline:ue.outline,outlineColor:ue.outlineColor,outlineStyle:ue.outlineStyle,outlineWidth:ue.outlineWidth,border:ue.border,borderColor:ue.borderColor,borderRadius:ue.borderRadius,borderSpacing:ue.borderSpacing,borderStyle:ue.borderStyle,borderWidth:ue.borderWidth,fontStyle:ue.fontStyle,fontWeight:ue.fontWeight,textDecoration:ue.textDecoration,cursor:ue.cursor,color:ue.color,opacity:ue.opacity,letterSpacing:ue.letterSpacing,gutterIconPath:ue.gutterIconPath?P(ue.gutterIconPath):void 0,gutterIconSize:ue.gutterIconSize,overviewRulerColor:ue.overviewRulerColor,before:ue.before?A.from(ue.before):void 0,after:ue.after?A.from(ue.after):void 0}}ve.from=ye})(a=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var F;(function(ve){function ye(ue){if(typeof ue=="undefined")return ue;switch(ue){case u.DecorationRangeBehavior.OpenOpen:return 0;case u.DecorationRangeBehavior.ClosedClosed:return 1;case u.DecorationRangeBehavior.OpenClosed:return 2;case u.DecorationRangeBehavior.ClosedOpen:return 3}}ve.from=ye})(F=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var N;(function(ve){function ye(ue){return{isWholeLine:ue.isWholeLine,rangeBehavior:ue.rangeBehavior?F.from(ue.rangeBehavior):void 0,overviewRulerLane:ue.overviewRulerLane,light:ue.light?a.from(ue.light):void 0,dark:ue.dark?a.from(ue.dark):void 0,backgroundColor:ue.backgroundColor,outline:ue.outline,outlineColor:ue.outlineColor,outlineStyle:ue.outlineStyle,outlineWidth:ue.outlineWidth,border:ue.border,borderColor:ue.borderColor,borderRadius:ue.borderRadius,borderSpacing:ue.borderSpacing,borderStyle:ue.borderStyle,borderWidth:ue.borderWidth,fontStyle:ue.fontStyle,fontWeight:ue.fontWeight,textDecoration:ue.textDecoration,cursor:ue.cursor,color:ue.color,opacity:ue.opacity,letterSpacing:ue.letterSpacing,gutterIconPath:ue.gutterIconPath?P(ue.gutterIconPath):void 0,gutterIconSize:ue.gutterIconSize,overviewRulerColor:ue.overviewRulerColor,before:ue.before?A.from(ue.before):void 0,after:ue.after?A.from(ue.after):void 0}}ve.from=ye})(N=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var H;(function(ve){function ye($){return{text:$.newText,eol:$.newEol&&j.from($.newEol),range:v.from($.range)}}ve.from=ye;function ue($){const Ne=new u.TextEdit(v.to($.range),$.text);return Ne.newEol=typeof $.eol=="undefined"?void 0:j.to($.eol),Ne}ve.to=ue})(H=e.TextEdit||(e.TextEdit={}));var le;(function(ve){function ye($,Ne,Pe){var Ve,Xe,lt;const ut={edits:[]};if($ instanceof u.WorkspaceEdit)for(let it of $._allEntries())if(it._type===1)ut.edits.push({_type:1,oldUri:it.from,newUri:it.to,options:it.options,metadata:it.metadata});else if(it._type===2){const mt=Ne==null?void 0:Ne.getDocument(it.uri);ut.edits.push({_type:2,resource:it.uri,edit:H.from(it.edit),modelVersionId:mt==null?void 0:mt.version,metadata:it.metadata})}else it._type===3?ut.edits.push({_type:3,metadata:it.metadata,resource:it.uri,edit:it.edit,notebookMetadata:it.notebookMetadata,notebookVersionId:(Ve=Pe==null?void 0:Pe.getNotebookDocument(it.uri,!0))===null||Ve===void 0?void 0:Ve.apiNotebook.version}):it._type===4?(it.newOutputs&&ut.edits.push({_type:3,metadata:it.metadata,resource:it.uri,edit:{editType:2,index:it.index,append:it.append,outputs:it.newOutputs.map(ae.from)}}),it.newMetadata&&ut.edits.push({_type:3,metadata:it.metadata,resource:it.uri,edit:{editType:8,index:it.index,metadata:it.newMetadata}})):it._type===5?ut.edits.push({_type:3,metadata:it.metadata,resource:it.uri,notebookVersionId:(Xe=Pe==null?void 0:Pe.getNotebookDocument(it.uri,!0))===null||Xe===void 0?void 0:Xe.apiNotebook.version,edit:{editType:1,index:it.index,count:it.count,cells:it.cells.map(O.from)}}):it._type===6&&ut.edits.push({_type:3,metadata:it.metadata,resource:it.uri,edit:{editType:7,outputId:it.outputId,items:((lt=it.newOutputItems)===null||lt===void 0?void 0:lt.map(G.from))||[],append:it.append}});return ut}ve.from=ye;function ue($){const Ne=new u.WorkspaceEdit;for(const Pe of $.edits)Pe.edit?Ne.replace(_.URI.revive(Pe.resource),v.to(Pe.edit.range),Pe.edit.text):Ne.renameFile(_.URI.revive(Pe.oldUri),_.URI.revive(Pe.newUri),Pe.options);return Ne}ve.to=ue})(le=e.WorkspaceEdit||(e.WorkspaceEdit={}));var fe;(function(ve){const ye=Object.create(null);ye[u.SymbolKind.File]=0,ye[u.SymbolKind.Module]=1,ye[u.SymbolKind.Namespace]=2,ye[u.SymbolKind.Package]=3,ye[u.SymbolKind.Class]=4,ye[u.SymbolKind.Method]=5,ye[u.SymbolKind.Property]=6,ye[u.SymbolKind.Field]=7,ye[u.SymbolKind.Constructor]=8,ye[u.SymbolKind.Enum]=9,ye[u.SymbolKind.Interface]=10,ye[u.SymbolKind.Function]=11,ye[u.SymbolKind.Variable]=12,ye[u.SymbolKind.Constant]=13,ye[u.SymbolKind.String]=14,ye[u.SymbolKind.Number]=15,ye[u.SymbolKind.Boolean]=16,ye[u.SymbolKind.Array]=17,ye[u.SymbolKind.Object]=18,ye[u.SymbolKind.Key]=19,ye[u.SymbolKind.Null]=20,ye[u.SymbolKind.EnumMember]=21,ye[u.SymbolKind.Struct]=22,ye[u.SymbolKind.Event]=23,ye[u.SymbolKind.Operator]=24,ye[u.SymbolKind.TypeParameter]=25;function ue(Ne){return typeof ye[Ne]=="number"?ye[Ne]:6}ve.from=ue;function $(Ne){for(const Pe in ye)if(ye[Pe]===Ne)return Number(Pe);return u.SymbolKind.Property}ve.to=$})(fe=e.SymbolKind||(e.SymbolKind={}));var X;(function(ve){function ye($){switch($){case u.SymbolTag.Deprecated:return 1}}ve.from=ye;function ue($){switch($){case 1:return u.SymbolTag.Deprecated}}ve.to=ue})(X=e.SymbolTag||(e.SymbolTag={}));var z;(function(ve){function ye($){return{name:$.name,kind:fe.from($.kind),tags:$.tags&&$.tags.map(X.from),containerName:$.containerName,location:U.from($.location)}}ve.from=ye;function ue($){const Ne=new u.SymbolInformation($.name,fe.to($.kind),$.containerName,U.to($.location));return Ne.tags=$.tags&&$.tags.map(X.to),Ne}ve.to=ue})(z=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var Y;(function(ve){function ye($){var Ne,Pe;const Ve={name:$.name||"!!MISSING: name!!",detail:$.detail,range:v.from($.range),selectionRange:v.from($.selectionRange),kind:fe.from($.kind),tags:(Pe=(Ne=$.tags)===null||Ne===void 0?void 0:Ne.map(X.from))!==null&&Pe!==void 0?Pe:[]};return $.children&&(Ve.children=$.children.map(ye)),Ve}ve.from=ye;function ue($){const Ne=new u.DocumentSymbol($.name,$.detail,fe.to($.kind),v.to($.range),v.to($.selectionRange));return g.isNonEmptyArray($.tags)&&(Ne.tags=$.tags.map(X.to)),$.children&&(Ne.children=$.children.map(ue)),Ne}ve.to=ue})(Y=e.DocumentSymbol||(e.DocumentSymbol={}));var R;(function(ve){function ye(ue){const $=new u.CallHierarchyItem(fe.to(ue.kind),ue.name,ue.detail||"",_.URI.revive(ue.uri),v.to(ue.range),v.to(ue.selectionRange));return $._sessionId=ue._sessionId,$._itemId=ue._itemId,$}ve.to=ye})(R=e.CallHierarchyItem||(e.CallHierarchyItem={}));var B;(function(ve){function ye(ue){return new u.CallHierarchyIncomingCall(R.to(ue.from),ue.fromRanges.map($=>v.to($)))}ve.to=ye})(B=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var M;(function(ve){function ye(ue){return new u.CallHierarchyOutgoingCall(R.to(ue.to),ue.fromRanges.map($=>v.to($)))}ve.to=ye})(M=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var U;(function(ve){function ye($){return{range:$.range&&v.from($.range),uri:$.uri}}ve.from=ye;function ue($){return new u.Location(_.URI.revive($.uri),v.to($.range))}ve.to=ue})(U=e.location||(e.location={}));var q;(function(ve){function ye($){const Ne=$,Pe=$;return{originSelectionRange:Ne.originSelectionRange?v.from(Ne.originSelectionRange):void 0,uri:Ne.targetUri?Ne.targetUri:Pe.uri,range:v.from(Ne.targetRange?Ne.targetRange:Pe.range),targetSelectionRange:Ne.targetSelectionRange?v.from(Ne.targetSelectionRange):void 0}}ve.from=ye;function ue($){return{targetUri:_.URI.revive($.uri),targetRange:v.to($.range),targetSelectionRange:$.targetSelectionRange?v.to($.targetSelectionRange):void 0,originSelectionRange:$.originSelectionRange?v.to($.originSelectionRange):void 0}}ve.to=ue})(q=e.DefinitionLink||(e.DefinitionLink={}));var V;(function(ve){function ye($){return{range:v.from($.range),contents:b.fromMany($.contents)}}ve.from=ye;function ue($){return new u.Hover($.contents.map(b.to),v.to($.range))}ve.to=ue})(V=e.Hover||(e.Hover={}));var oe;(function(ve){function ye($){return{range:v.from($.range),expression:$.expression}}ve.from=ye;function ue($){return new u.EvaluatableExpression(v.to($.range),$.expression)}ve.to=ue})(oe=e.EvaluatableExpression||(e.EvaluatableExpression={}));var ge;(function(ve){function ye($){if($ instanceof u.InlineValueText)return{type:"text",range:v.from($.range),text:$.text};if($ instanceof u.InlineValueVariableLookup)return{type:"variable",range:v.from($.range),variableName:$.variableName,caseSensitiveLookup:$.caseSensitiveLookup};if($ instanceof u.InlineValueEvaluatableExpression)return{type:"expression",range:v.from($.range),expression:$.expression};throw new Error("Unknown 'InlineValue' type")}ve.from=ye;function ue($){switch($.type){case"text":return{range:v.to($.range),text:$.text};case"variable":return{range:v.to($.range),variableName:$.variableName,caseSensitiveLookup:$.caseSensitiveLookup};case"expression":return{range:v.to($.range),expression:$.expression}}}ve.to=ue})(ge=e.InlineValue||(e.InlineValue={}));var Re;(function(ve){function ye($){return{frameId:$.frameId,stoppedLocation:v.from($.stoppedLocation)}}ve.from=ye;function ue($){return new u.InlineValueContext($.frameId,v.to($.stoppedLocation))}ve.to=ue})(Re=e.InlineValueContext||(e.InlineValueContext={}));var $e;(function(ve){function ye($){return{range:v.from($.range),kind:$.kind}}ve.from=ye;function ue($){return new u.DocumentHighlight(v.to($.range),$.kind)}ve.to=ue})($e=e.DocumentHighlight||(e.DocumentHighlight={}));var Me;(function(ve){function ye(ue){switch(ue){case 1:return u.CompletionTriggerKind.TriggerCharacter;case 2:return u.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return u.CompletionTriggerKind.Invoke}}ve.to=ye})(Me=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var We;(function(ve){function ye(ue){return{triggerKind:Me.to(ue.triggerKind),triggerCharacter:ue.triggerCharacter}}ve.to=ye})(We=e.CompletionContext||(e.CompletionContext={}));var Je;(function(ve){function ye($){switch($){case u.CompletionItemTag.Deprecated:return 1}}ve.from=ye;function ue($){switch($){case 1:return u.CompletionItemTag.Deprecated}}ve.to=ue})(Je=e.CompletionItemTag||(e.CompletionItemTag={}));var Qe;(function(ve){const ye=new Map([[u.CompletionItemKind.Method,0],[u.CompletionItemKind.Function,1],[u.CompletionItemKind.Constructor,2],[u.CompletionItemKind.Field,3],[u.CompletionItemKind.Variable,4],[u.CompletionItemKind.Class,5],[u.CompletionItemKind.Interface,7],[u.CompletionItemKind.Struct,6],[u.CompletionItemKind.Module,8],[u.CompletionItemKind.Property,9],[u.CompletionItemKind.Unit,12],[u.CompletionItemKind.Value,13],[u.CompletionItemKind.Constant,14],[u.CompletionItemKind.Enum,15],[u.CompletionItemKind.EnumMember,16],[u.CompletionItemKind.Keyword,17],[u.CompletionItemKind.Snippet,27],[u.CompletionItemKind.Text,18],[u.CompletionItemKind.Color,19],[u.CompletionItemKind.File,20],[u.CompletionItemKind.Reference,21],[u.CompletionItemKind.Folder,23],[u.CompletionItemKind.Event,10],[u.CompletionItemKind.Operator,11],[u.CompletionItemKind.TypeParameter,24],[u.CompletionItemKind.Issue,26],[u.CompletionItemKind.User,25]]);function ue(Pe){var Ve;return(Ve=ye.get(Pe))!==null&&Ve!==void 0?Ve:9}ve.from=ue;const $=new Map([[0,u.CompletionItemKind.Method],[1,u.CompletionItemKind.Function],[2,u.CompletionItemKind.Constructor],[3,u.CompletionItemKind.Field],[4,u.CompletionItemKind.Variable],[5,u.CompletionItemKind.Class],[7,u.CompletionItemKind.Interface],[6,u.CompletionItemKind.Struct],[8,u.CompletionItemKind.Module],[9,u.CompletionItemKind.Property],[12,u.CompletionItemKind.Unit],[13,u.CompletionItemKind.Value],[14,u.CompletionItemKind.Constant],[15,u.CompletionItemKind.Enum],[16,u.CompletionItemKind.EnumMember],[17,u.CompletionItemKind.Keyword],[27,u.CompletionItemKind.Snippet],[18,u.CompletionItemKind.Text],[19,u.CompletionItemKind.Color],[20,u.CompletionItemKind.File],[21,u.CompletionItemKind.Reference],[23,u.CompletionItemKind.Folder],[10,u.CompletionItemKind.Event],[11,u.CompletionItemKind.Operator],[24,u.CompletionItemKind.TypeParameter],[25,u.CompletionItemKind.User],[26,u.CompletionItemKind.Issue]]);function Ne(Pe){var Ve;return(Ve=$.get(Pe))!==null&&Ve!==void 0?Ve:u.CompletionItemKind.Property}ve.to=Ne})(Qe=e.CompletionItemKind||(e.CompletionItemKind={}));var Ye;(function(ve){function ye(ue,$){var Ne;const Pe=new u.CompletionItem(typeof ue.label=="string"?ue.label:ue.label.name);return typeof ue.label!="string"&&(Pe.label2=ue.label),Pe.insertText=ue.insertText,Pe.kind=Qe.to(ue.kind),Pe.tags=(Ne=ue.tags)===null||Ne===void 0?void 0:Ne.map(Je.to),Pe.detail=ue.detail,Pe.documentation=T.isMarkdownString(ue.documentation)?b.to(ue.documentation):ue.documentation,Pe.sortText=ue.sortText,Pe.filterText=ue.filterText,Pe.preselect=ue.preselect,Pe.commitCharacters=ue.commitCharacters,k.Range.isIRange(ue.range)?Pe.range=v.to(ue.range):typeof ue.range=="object"&&(Pe.range={inserting:v.to(ue.range.insert),replacing:v.to(ue.range.replace)}),Pe.keepWhitespace=typeof ue.insertTextRules=="undefined"?!1:Boolean(ue.insertTextRules&1),typeof ue.insertTextRules!="undefined"&&ue.insertTextRules&4?Pe.insertText=new u.SnippetString(ue.insertText):(Pe.insertText=ue.insertText,Pe.textEdit=Pe.range instanceof u.Range?new u.TextEdit(Pe.range,Pe.insertText):void 0),ue.additionalTextEdits&&ue.additionalTextEdits.length>0&&(Pe.additionalTextEdits=ue.additionalTextEdits.map(Ve=>H.to(Ve))),Pe.command=$&&ue.command?$.fromInternal(ue.command):void 0,Pe}ve.to=ye})(Ye=e.CompletionItem||(e.CompletionItem={}));var W;(function(ve){function ye($){return{label:$.label,documentation:$.documentation?b.fromStrict($.documentation):void 0}}ve.from=ye;function ue($){return{label:$.label,documentation:T.isMarkdownString($.documentation)?b.to($.documentation):$.documentation}}ve.to=ue})(W=e.ParameterInformation||(e.ParameterInformation={}));var Q;(function(ve){function ye($){return{label:$.label,documentation:$.documentation?b.fromStrict($.documentation):void 0,parameters:Array.isArray($.parameters)?$.parameters.map(W.from):[],activeParameter:$.activeParameter}}ve.from=ye;function ue($){return{label:$.label,documentation:T.isMarkdownString($.documentation)?b.to($.documentation):$.documentation,parameters:Array.isArray($.parameters)?$.parameters.map(W.to):[],activeParameter:$.activeParameter}}ve.to=ue})(Q=e.SignatureInformation||(e.SignatureInformation={}));var te;(function(ve){function ye($){return{activeSignature:$.activeSignature,activeParameter:$.activeParameter,signatures:Array.isArray($.signatures)?$.signatures.map(Q.from):[]}}ve.from=ye;function ue($){return{activeSignature:$.activeSignature,activeParameter:$.activeParameter,signatures:Array.isArray($.signatures)?$.signatures.map(Q.to):[]}}ve.to=ue})(te=e.SignatureHelp||(e.SignatureHelp={}));var re;(function(ve){function ye($){var Ne;return{text:$.text,position:c.from($.position),kind:K.from((Ne=$.kind)!==null&&Ne!==void 0?Ne:u.InlayHintKind.Other),whitespaceBefore:$.whitespaceBefore,whitespaceAfter:$.whitespaceAfter}}ve.from=ye;function ue($){const Ne=new u.InlayHint($.text,c.to($.position),K.to($.kind));return Ne.whitespaceAfter=$.whitespaceAfter,Ne.whitespaceBefore=$.whitespaceBefore,Ne}ve.to=ue})(re=e.InlayHint||(e.InlayHint={}));var K;(function(ve){function ye($){return $}ve.from=ye;function ue($){return $}ve.to=ue})(K=e.InlayHintKind||(e.InlayHintKind={}));var se;(function(ve){function ye($){return{range:v.from($.range),url:$.target,tooltip:$.tooltip}}ve.from=ye;function ue($){let Ne;if($.url)try{Ne=typeof $.url=="string"?_.URI.parse($.url,!0):_.URI.revive($.url)}catch(Pe){}return new u.DocumentLink(v.to($.range),Ne)}ve.to=ue})(se=e.DocumentLink||(e.DocumentLink={}));var he;(function(ve){function ye($){const Ne=new u.ColorPresentation($.label);return $.textEdit&&(Ne.textEdit=H.to($.textEdit)),$.additionalTextEdits&&(Ne.additionalTextEdits=$.additionalTextEdits.map(Pe=>H.to(Pe))),Ne}ve.to=ye;function ue($){return{label:$.label,textEdit:$.textEdit?H.from($.textEdit):void 0,additionalTextEdits:$.additionalTextEdits?$.additionalTextEdits.map(Ne=>H.from(Ne)):void 0}}ve.from=ue})(he=e.ColorPresentation||(e.ColorPresentation={}));var Ae;(function(ve){function ye($){return new u.Color($[0],$[1],$[2],$[3])}ve.to=ye;function ue($){return[$.red,$.green,$.blue,$.alpha]}ve.from=ue})(Ae=e.Color||(e.Color={}));var Be;(function(ve){function ye($){return{range:v.from($.range)}}ve.from=ye;function ue($){return new u.SelectionRange(v.to($.range))}ve.to=ue})(Be=e.SelectionRange||(e.SelectionRange={}));var pe;(function(ve){function ye(ue){switch(ue){case 2:return u.TextDocumentSaveReason.AfterDelay;case 1:return u.TextDocumentSaveReason.Manual;case 3:case 4:return u.TextDocumentSaveReason.FocusOut}}ve.to=ye})(pe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ke;(function(ve){function ye($){switch($){case u.TextEditorLineNumbersStyle.Off:return 0;case u.TextEditorLineNumbersStyle.Relative:return 2;case u.TextEditorLineNumbersStyle.On:default:return 1}}ve.from=ye;function ue($){switch($){case 0:return u.TextEditorLineNumbersStyle.Off;case 2:return u.TextEditorLineNumbersStyle.Relative;case 1:default:return u.TextEditorLineNumbersStyle.On}}ve.to=ue})(Ke=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var j;(function(ve){function ye($){if($===u.EndOfLine.CRLF)return 1;if($===u.EndOfLine.LF)return 0}ve.from=ye;function ue($){if($===1)return u.EndOfLine.CRLF;if($===0)return u.EndOfLine.LF}ve.to=ue})(j=e.EndOfLine||(e.EndOfLine={}));var ee;(function(ve){function ye(ue){if(typeof ue=="object")return ue.viewId;switch(ue){case u.ProgressLocation.SourceControl:return 3;case u.ProgressLocation.Window:return 10;case u.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ve.from=ye})(ee=e.ProgressLocation||(e.ProgressLocation={}));var me;(function(ve){function ye(ue){const $={start:ue.start+1,end:ue.end+1};return ue.kind&&($.kind=Fe.from(ue.kind)),$}ve.from=ye})(me=e.FoldingRange||(e.FoldingRange={}));var Fe;(function(ve){function ye(ue){if(ue)switch(ue){case u.FoldingRangeKind.Comment:return n.FoldingRangeKind.Comment;case u.FoldingRangeKind.Imports:return n.FoldingRangeKind.Imports;case u.FoldingRangeKind.Region:return n.FoldingRangeKind.Region}}ve.from=ye})(Fe=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Le;(function(ve){function ye(ue){if(ue)return{pinned:typeof ue.preview=="boolean"?!ue.preview:void 0,inactive:ue.background,preserveFocus:ue.preserveFocus,selection:typeof ue.selection=="object"?v.from(ue.selection):void 0,override:typeof ue.override=="boolean"?I.EditorOverride.DISABLED:void 0}}ve.from=ye})(Le=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Ge;(function(ve){function ye($){return $ instanceof u.RelativePattern||typeof $=="string"?$:ue($)?new u.RelativePattern($.base,$.pattern):$}ve.from=ye;function ue($){const Ne=$;return Ne&&typeof Ne.base=="string"&&typeof Ne.pattern=="string"}})(Ge=e.GlobPattern||(e.GlobPattern={}));var Ee;(function(ve){function ye(ue){if(ue){if(Array.isArray(ue))return ue.map(ye);if(typeof ue=="string")return ue;{const $=ue;return{language:$.language,scheme:$.scheme,pattern:typeof $.pattern=="undefined"?void 0:Ge.from($.pattern),exclusive:$.exclusive}}}else return}ve.from=ye})(Ee=e.LanguageSelector||(e.LanguageSelector={}));var be;(function(ve){function ye($){return{start:$.start,end:$.end}}ve.from=ye;function ue($){return new u.NotebookRange($.start,$.end)}ve.to=ue})(be=e.NotebookRange||(e.NotebookRange={}));var De;(function(ve){function ye($){return{timing:typeof $.runStartTime=="number"&&typeof $.runEndTime=="number"?{startTime:$.runStartTime,endTime:$.runEndTime}:void 0,executionOrder:$.executionOrder,success:$.lastRunSuccess}}ve.to=ye;function ue($){var Ne,Pe;return{lastRunSuccess:$.success,runStartTime:(Ne=$.timing)===null||Ne===void 0?void 0:Ne.startTime,runEndTime:(Pe=$.timing)===null||Pe===void 0?void 0:Pe.endTime,executionOrder:$.executionOrder}}ve.from=ue})(De=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var ie;(function(ve){function ye($){switch($){case u.NotebookCellKind.Markup:return h.CellKind.Markup;case u.NotebookCellKind.Code:default:return h.CellKind.Code}}ve.from=ye;function ue($){switch($){case h.CellKind.Markup:return u.NotebookCellKind.Markup;case h.CellKind.Code:default:return u.NotebookCellKind.Code}}ve.to=ue})(ie=e.NotebookCellKind||(e.NotebookCellKind={}));var de;(function(ve){function ye($){var Ne;const Pe={metadata:(Ne=$.metadata)!==null&&Ne!==void 0?Ne:Object.create(null),cells:[]};for(let Ve of $.cells)u.NotebookCellData.validate(Ve),Pe.cells.push(O.from(Ve));return Pe}ve.from=ye;function ue($){const Ne=new u.NotebookData($.cells.map(O.to));return y.isEmptyObject($.metadata)||(Ne.metadata=$.metadata),Ne}ve.to=ue})(de=e.NotebookData||(e.NotebookData={}));var O;(function(ve){function ye($){var Ne;return{cellKind:ie.from($.kind),language:$.languageId,source:$.value,metadata:$.metadata,internalMetadata:De.from((Ne=$.executionSummary)!==null&&Ne!==void 0?Ne:{}),outputs:$.outputs?$.outputs.map(ae.from):[]}}ve.from=ye;function ue($){return new u.NotebookCellData(ie.to($.cellKind),$.source,$.language,$.outputs?$.outputs.map(ae.to):void 0,$.metadata,$.internalMetadata?De.to($.internalMetadata):void 0)}ve.to=ue})(O=e.NotebookCellData||(e.NotebookCellData={}));var G;(function(ve){function ye($){return{mime:$.mime,valueBytes:Array.from($.data)}}ve.from=ye;function ue($){return new u.NotebookCellOutputItem(new Uint8Array($.valueBytes),$.mime)}ve.to=ue})(G=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var ae;(function(ve){function ye($){return{outputId:$.id,outputs:$.items.map(G.from),metadata:$.metadata}}ve.from=ye;function ue($){const Ne=$.outputs.map(G.to);return new u.NotebookCellOutput(Ne,$.outputId,$.metadata)}ve.to=ue})(ae=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Ce;(function(ve){function ye(Pe){if(Pe!=null){if(Pe instanceof u.RelativePattern||typeof Pe=="string")return Pe;if(Ne(Pe))return new u.RelativePattern(Pe.base,Pe.pattern);if($(Pe))return{include:Ge.from(Pe.include)||void 0,exclude:Ge.from(Pe.exclude)||void 0}}}ve.from=ye;function ue(Pe){return typeof Pe=="string"?Pe:Ne(Pe)?{base:Pe.base,pattern:Pe.pattern}:{include:Pe.include,exclude:Pe.exclude}}ve.to=ue;function $(Pe){const Ve=Pe,Xe=Ge.from(Ve.include);if(!(Xe&&Xe instanceof u.RelativePattern||typeof Xe=="string"))return!1;const lt=Ge.from(Ve.exclude);return!!(lt&&lt instanceof u.RelativePattern||typeof lt=="string")}function Ne(Pe){const Ve=Pe;return Ve&&typeof Ve.base=="string"&&typeof Ve.pattern=="string"}})(Ce=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Ie;(function(ve){function ye(ue){return{backgroundColor:ue.backgroundColor,borderColor:ue.borderColor,top:ue.top?A.from(ue.top):void 0}}ve.from=ye})(Ie=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var Oe;(function(ve){function ye(ue,$,Ne){const Pe=typeof ue.command=="string"?{title:"",command:ue.command}:ue.command;return{alignment:ue.alignment===u.NotebookCellStatusBarAlignment.Left?1:2,command:$.toInternal(Pe,Ne),text:ue.text,tooltip:ue.tooltip,accessibilityInformation:ue.accessibilityInformation,priority:ue.priority}}ve.from=ye})(Oe=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Ue;(function(ve){function ye(ue){var $,Ne,Pe;return{transientOutputs:($=ue==null?void 0:ue.transientOutputs)!==null&&$!==void 0?$:!1,transientCellMetadata:(Ne=ue==null?void 0:ue.transientCellMetadata)!==null&&Ne!==void 0?Ne:{},transientDocumentMetadata:(Pe=ue==null?void 0:ue.transientDocumentMetadata)!==null&&Pe!==void 0?Pe:{}}}ve.from=ye})(Ue=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var qe;(function(ve){function ye($){return{uri:$.uri,provides:$.provides}}ve.from=ye;function ue($){return new u.NotebookRendererScript(_.URI.revive($.uri),$.provides)}ve.to=ue})(qe=e.NotebookRendererScript||(e.NotebookRendererScript={}));var rt;(function(ve){function ye($){return{message:b.fromStrict($.message)||"",severity:$.severity,expectedOutput:$.expectedOutput,actualOutput:$.actualOutput,location:$.location?U.from($.location):void 0}}ve.from=ye;function ue($){const Ne=new u.TestMessage(typeof $.message=="string"?$.message:b.to($.message));return Ne.severity=$.severity,Ne.actualOutput=$.actualOutput,Ne.expectedOutput=$.expectedOutput,Ne}ve.to=ue})(rt=e.TestMessage||(e.TestMessage={}));var nt;(function(ve){function ye(Pe){var Ve,Xe;return{extId:Pe.id,label:Pe.label,uri:Pe.uri,range:v.from(Pe.range)||null,debuggable:(Ve=Pe.debuggable)!==null&&Ve!==void 0?Ve:!1,description:Pe.description||null,runnable:(Xe=Pe.runnable)!==null&&Xe!==void 0?Xe:!0,error:Pe.error&&b.fromStrict(Pe.error)||null}}ve.from=ye;function ue(Pe){return{extId:Pe.id,label:Pe.label,uri:Pe.uri,range:v.from(Pe.range)||null,debuggable:!1,description:Pe.description||null,error:null,runnable:!0}}ve.fromResultSnapshot=ue;function $(Pe){return{id:Pe.extId,label:Pe.label,uri:_.URI.revive(Pe.uri),range:v.to(Pe.range||void 0),addChild:()=>{},dispose:()=>{},status:u.TestItemStatus.Pending,data:void 0,debuggable:Pe.debuggable,description:Pe.description||void 0,runnable:Pe.runnable}}ve.toPlain=$;function Ne(Pe){const Ve=new u.TestItemImpl(Pe.extId,Pe.label,_.URI.revive(Pe.uri),void 0);return Ve.range=v.to(Pe.range||void 0),Ve.debuggable=Pe.debuggable,Ve.description=Pe.description||void 0,Ve.runnable=Pe.runnable,Ve}ve.to=Ne})(nt=e.TestItem||(e.TestItem={}));var Ze;(function(ve){const ye=($,Ne)=>Object.assign(Object.assign({},nt.toPlain($.item)),{taskStates:$.tasks.map(Pe=>({state:Pe.state,duration:Pe.duration,messages:Pe.messages.map(rt.to)})),children:$.children.map(Pe=>Ne.get(Pe)).filter(y.isDefined).map(Pe=>ye(Pe,Ne))});function ue($){const Ne=[],Pe=new Map;for(const Ve of $.items)Pe.set(Ve.item.extId,Ve),Ve.direct&&Ne.push(Ve);return{completedAt:$.completedAt,results:Ne.map(Ve=>ye(Ve,Pe))}}ve.to=ue})(Ze=e.TestResults||(e.TestResults={}));var ot;(function(ve){function ye(ue){switch(ue){case 1:return u.CodeActionTriggerKind.Invoke;case 2:return u.CodeActionTriggerKind.Automatic}}ve.to=ye})(ot=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}))}),define(we[165],_e([0,1,2,12,6,9,51]),function(Z,e,g,T,D,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class y{constructor(k,n,I,o={timeout:1500,errors:3}){this._logService=k,this._documents=n,this._mainThreadBulkEdits=I,this._thresholds=o,this._callbacks=new C.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(k){return(n,I,o)=>{const d={dispose:this._callbacks.push([n,I,k])};return Array.isArray(o)&&o.push(d),d}}async $participateInSave(k,n){const I=g.URI.revive(k);let o=!1;const h=setTimeout(()=>o=!0,this._thresholds.timeout),d=[];try{for(let u of[...this._callbacks]){if(o)break;const w=this._documents.getDocument(I),v=await this._deliverEventAsyncAndBlameBadListeners(u,{document:w,reason:E.TextDocumentSaveReason.to(n)});d.push(v)}}finally{clearTimeout(h)}return d}_deliverEventAsyncAndBlameBadListeners([k,n,I],o){const h=this._badListeners.get(k);return typeof h=="number"&&h>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(I,k,n,o).then(()=>!0,d=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' threw ERROR`),this._logService.error(d),!(d instanceof Error)||d.message!=="concurrent_edits"){const u=this._badListeners.get(k);this._badListeners.set(k,u?u+1:1),typeof u=="number"&&u>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(k,n,I,o){const h=[],d=Date.now(),{document:u,reason:w}=o,{version:v}=u,S=Object.freeze({document:u,reason:w,waitUntil(c){if(Object.isFrozen(h))throw T.illegalState("waitUntil can not be called async");h.push(Promise.resolve(c))}});try{n.apply(I,[S])}catch(c){return Promise.reject(c)}return Object.freeze(h),new Promise((c,m)=>{const f=setTimeout(()=>m(new Error("timeout")),this._thresholds.timeout);return Promise.all(h).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' finished after ${Date.now()-d}ms`),clearTimeout(f),c(t)}).catch(t=>{clearTimeout(f),m(t)})}).then(c=>{const m={edits:[]};for(const f of c)if(Array.isArray(f)&&f.every(t=>t instanceof D.TextEdit))for(const{newText:t,newEol:r,range:i}of f)m.edits.push({_type:2,resource:u.uri,edit:{range:i&&E.Range.from(i),text:t,eol:r&&E.EndOfLine.from(r)}});if(m.edits.length!==0)return v===u.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(m):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=y}),define(we[166],_e([0,1,3,11,27,2,9,6]),function(Z,e,g,T,D,E,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class _{constructor(I,o,h,d,u){this._onDidCreate=new g.Emitter,this._onDidChange=new g.Emitter,this._onDidDelete=new g.Emitter,this._config=0,h&&(this._config+=1),d&&(this._config+=2),u&&(this._config+=4);const w=D.parse(o),v=I(S=>{if(!h)for(let c of S.created){const m=E.URI.revive(c);w(m.fsPath)&&this._onDidCreate.fire(m)}if(!d)for(let c of S.changed){const m=E.URI.revive(c);w(m.fsPath)&&this._onDidChange.fire(m)}if(!u)for(let c of S.deleted){const m=E.URI.revive(c);w(m.fsPath)&&this._onDidDelete.fire(m)}});this._disposable=y.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,v)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class k{constructor(I,o,h){this._logService=o,this._extHostDocumentsAndEditors=h,this._onFileSystemEvent=new g.Emitter,this._onDidRenameFile=new g.Emitter,this._onDidCreateFile=new g.Emitter,this._onDidDeleteFile=new g.Emitter,this._onWillRenameFile=new T.AsyncEmitter,this._onWillCreateFile=new T.AsyncEmitter,this._onWillDeleteFile=new T.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(I,o,h,d){return new _(this._onFileSystemEvent.event,I,o,h,d)}$onFileEvent(I){this._onFileSystemEvent.fire(I)}$onDidRunFileOperation(I,o){switch(I){case 2:this._onDidRenameFile.fire(Object.freeze({files:o.map(h=>({oldUri:E.URI.revive(h.source),newUri:E.URI.revive(h.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:o.map(h=>E.URI.revive(h.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:o.map(h=>E.URI.revive(h.target))}));break;default:}}getOnWillRenameFileEvent(I){return this._createWillExecuteEvent(I,this._onWillRenameFile)}getOnWillCreateFileEvent(I){return this._createWillExecuteEvent(I,this._onWillCreateFile)}getOnWillDeleteFileEvent(I){return this._createWillExecuteEvent(I,this._onWillDeleteFile)}_createWillExecuteEvent(I,o){return(h,d,u)=>{const w=function(S){h.call(d,S)};return w.extension=I,o.event(w,void 0,u)}}async $onWillRunFileOperation(I,o,h,d){switch(I){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:o.map(u=>({oldUri:E.URI.revive(u.source),newUri:E.URI.revive(u.target)}))},h,d);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:o.map(u=>E.URI.revive(u.target))},h,d);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:o.map(u=>E.URI.revive(u.target))},h,d)}}async _fireWillEvent(I,o,h,d){const u=new Set,w=[];if(await I.fireAsync(o,d,async(S,c)=>{var m;const f=Date.now(),t=await Promise.resolve(S);t instanceof y.WorkspaceEdit&&(w.push(t),u.add((m=c.extension.displayName)!==null&&m!==void 0?m:c.extension.identifier.value)),Date.now()-f>h&&this._logService.warn("SLOW file-participant",c.extension.identifier)}),d.isCancellationRequested||w.length===0)return;const v={edits:[]};for(let S of w){let{edits:c}=C.WorkspaceEdit.from(S,this._extHostDocumentsAndEditors);v.edits=v.edits.concat(c)}return{edit:v,extensionNames:Array.from(u)}}}e.ExtHostFileSystemEventService=k}),define(we[167],_e([0,1,15,24,2,9,6,45]),function(Z,e,g,T,D,E,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class _{constructor(o,h,d,u){this.start=o,this.deletedCount=h,this.deletedItems=d,this.items=u}static asApiEvents(o){return o.map(h=>({start:h.start,deletedCount:h.deletedCount,deletedItems:h.deletedItems,items:h.items.map(d=>d.apiCell)}))}}class k{constructor(o,h,d){var u,w,v;this.notebook=o,this._extHostDocument=h,this._cellData=d,this.handle=d.handle,this.uri=D.URI.revive(d.uri),this.cellKind=d.cellKind,this._outputs=d.outputs.map(E.NotebookCellOutput.to),this._internalMetadata=(u=d.internalMetadata)!==null&&u!==void 0?u:{},this._metadata=(w=d.metadata)!==null&&w!==void 0?w:{},this._previousResult=E.NotebookCellExecutionSummary.to((v=d.internalMetadata)!==null&&v!==void 0?v:{})}static asModelAddData(o,h){return{EOL:h.eol,lines:h.source,modeId:h.language,uri:h.uri,isDirty:!1,versionId:1,notebook:o}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const o=this,h=this._extHostDocument.getDocument(this.uri);if(!h)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return o.notebook.getCellIndex(o)},notebook:o.notebook.apiNotebook,kind:E.NotebookCellKind.to(this._cellData.cellKind),document:h.document,get outputs(){return o._outputs.slice(0)},get metadata(){return o._metadata},get executionSummary(){return o._previousResult}})}return this._apiCell}setOutputs(o){this._outputs=o.map(E.NotebookCellOutput.to)}setOutputItems(o,h,d){const u=d.map(E.NotebookCellOutputItem.to),w=this._outputs.find(v=>v.id===o);w&&(h||(w.items.length=0),w.items.push(...u))}setMetadata(o){this._metadata=o}setInternalMetadata(o){this._internalMetadata=o,this._previousResult=E.NotebookCellExecutionSummary.to(o)}}e.ExtHostCell=k;class n{constructor(o,h,d,u,w,v,S){this._proxy=o,this._textDocumentsAndEditors=h,this._textDocuments=d,this._emitter=u,this._notebookType=w,this._metadata=v,this.uri=S,this.handle=n._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const o=this;this._notebook={get uri(){return o.uri},get version(){return o._versionId},get notebookType(){return o._notebookType},get isDirty(){return o._isDirty},get isUntitled(){return o.uri.scheme===g.Schemas.untitled},get isClosed(){return o._disposed},get metadata(){return o._metadata},get cellCount(){return o._cells.length},cellAt(h){return h=o._validateIndex(h),o._cells[h].apiCell},getCells(h){return(h?o._getCells(h):o._cells).map(u=>u.apiCell)},save(){return o._save()}}}return this._notebook}updateBackup(o){var h;(h=this._backup)===null||h===void 0||h.delete(),this._backup=o}disposeBackup(){var o;(o=this._backup)===null||o===void 0||o.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(o){o.metadata&&(this._metadata=Object.assign(Object.assign({},this._metadata),o.metadata))}acceptModelChanged(o,h){this._versionId=o.versionId,this._isDirty=h;for(const d of o.rawEvents)d.kind===y.NotebookCellsChangeType.Initialize&&this._spliceNotebookCells(d.changes,!0),d.kind===y.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(d.changes,!1):d.kind===y.NotebookCellsChangeType.Move?this._moveCell(d.index,d.newIdx):d.kind===y.NotebookCellsChangeType.Output?this._setCellOutputs(d.index,d.outputs):d.kind===y.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(d.index,d.outputId,d.append,d.outputItems):d.kind===y.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(d.index,d.language):d.kind===y.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(d.index,d.metadata):d.kind===y.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(d.index,d.internalMetadata)}_validateIndex(o){return o=o|0,o<0?0:o>=this._cells.length?this._cells.length-1:o}_validateRange(o){let h=o.start|0,d=o.end|0;return h<0&&(h=0),d>this._cells.length&&(d=this._cells.length),o.with({start:h,end:d})}_getCells(o){o=this._validateRange(o);const h=[];for(let d=o.start;d<o.end;d++)h.push(this._cells[d]);return h}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(o,h){if(this._disposed)return;const d=[],u=[],w=[];o.reverse().forEach(v=>{const c=v[2].map(t=>{const r=new k(this,this._textDocumentsAndEditors,t);return h||u.push(k.asModelAddData(this.apiNotebook,t)),r}),m=new _(v[0],v[1],[],c),f=this._cells.splice(v[0],v[1],...c);for(const t of f)w.push(t.uri),m.deletedItems.push(t.apiCell);d.push(m)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:u,removedDocuments:w}),h||this._emitter.emitModelChange(T.deepFreeze({document:this.apiNotebook,changes:_.asApiEvents(d)}))}_moveCell(o,h){const d=this._cells.splice(o,1);this._cells.splice(h,0,...d);const u=[new _(o,1,d.map(w=>w.apiCell),[]),new _(h,0,[],d)];this._emitter.emitModelChange(T.deepFreeze({document:this.apiNotebook,changes:_.asApiEvents(u)}))}_setCellOutputs(o,h){const d=this._cells[o];d.setOutputs(h),this._emitter.emitCellOutputsChange(T.deepFreeze({document:this.apiNotebook,cells:[d.apiCell]}))}_setCellOutputItems(o,h,d,u){const w=this._cells[o];w.setOutputItems(h,d,u),this._emitter.emitCellOutputsChange(T.deepFreeze({document:this.apiNotebook,cells:[w.apiCell]}))}_changeCellLanguage(o,h){const d=this._cells[o];d.apiCell.document.languageId!==h&&this._textDocuments.$acceptModelModeChanged(d.uri,h)}_changeCellMetadata(o,h){const d=this._cells[o],u=d.apiCell.metadata;d.setMetadata(h);const w=d.apiCell.metadata;T.equals(u,w)||this._emitter.emitCellMetadataChange(T.deepFreeze({document:this.apiNotebook,cell:d.apiCell}))}_changeCellInternalMetadata(o,h){var d;const u=this._cells[o],w=u.internalMetadata;if(u.setInternalMetadata(h),w.runState!==h.runState){const v=(d=h.runState)!==null&&d!==void 0?d:C.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange(T.deepFreeze({document:this.apiNotebook,cell:u.apiCell,state:v}))}}getCellFromApiCell(o){return this._cells.find(h=>h.apiCell===o)}getCellFromIndex(o){return this._cells[o]}getCell(o){return this._cells.find(h=>h.handle===o)}getCellIndex(o){return this._cells.indexOf(o)}}e.ExtHostNotebookDocument=n,n._handlePool=0}),define(we[95],_e([0,1,6,9]),function(Z,e,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class D{constructor(y){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=y}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(y){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:y})}replaceCellMetadata(y,_){this._throwIfFinalized(),this._collectedEdits.push({editType:3,index:y,metadata:_})}replaceCells(y,_,k){this._throwIfFinalized(),!(y===_&&k.length===0)&&this._collectedEdits.push({editType:1,index:y,count:_-y,cells:k.map(T.NotebookCellData.from)})}}class E{constructor(y,_,k,n,I,o){this.id=y,this._proxy=_,this.notebookData=k,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=I,this._visibleRanges=n,this._viewColumn=o}get apiEditor(){if(!this._editor){const y=this;this._editor={get document(){return y.notebookData.apiNotebook},get selections(){return y._selections},get visibleRanges(){return y._visibleRanges},revealRange(_,k){y._proxy.$tryRevealRange(y.id,T.NotebookRange.from(_),k??g.NotebookEditorRevealType.Default)},get viewColumn(){return y._viewColumn},edit(_){const k=new D(this.document.version);return _(k),y._applyEdit(k.finalize())},setDecorations(_,k){return y.setDecorations(_,k)}},E.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(y){this._visible=y}_acceptVisibleRanges(y){this._visibleRanges=y}_acceptSelections(y){this._selections=y}_acceptViewColumn(y){this._viewColumn=y}_applyEdit(y){if(y.cellEdits.length===0)return Promise.resolve(!0);const _=[];let k=-1;for(let n=0;n<y.cellEdits.length;n++){if(k<0){_.push(y.cellEdits[n]),k++;continue}const o=_[k],h=y.cellEdits[n];if(o.editType===1&&h.editType===1&&o.index===h.index){o.cells.push(...y.cellEdits[n].cells),o.count+=y.cellEdits[n].count;continue}_.push(y.cellEdits[n]),k++}return this._proxy.$tryApplyEdits(this.id,y.documentVersionId,_)}setDecorations(y,_){if(!(_.isEmpty&&!this._hasDecorationsForKey.has(y.key)))return _.isEmpty?this._hasDecorationsForKey.delete(y.key):this._hasDecorationsForKey.add(y.key),this._proxy.$trySetDecorations(this.id,T.NotebookRange.from(_),y.key)}}e.ExtHostNotebookEditor=E,E.apiEditorsToExtHost=new WeakMap}),define(we[168],_e([0,1,9,147,129,18,47]),function(Z,e,g,T,D,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class y{constructor(I){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=I}withProgress(I,o,h){const d=this._handles++,{title:u,location:w,cancellable:v}=o,S={label:D.localize(0,null,I.displayName||I.name),id:I.identifier.value};return this._proxy.$startProgress(d,{location:g.ProgressLocation.from(w),title:u,source:S,cancellable:v},I),this._withProgress(d,h,!!v)}_withProgress(I,o,h){let d;h&&(d=new E.CancellationTokenSource,this._mapHandleToCancellationSource.set(I,d));const u=v=>{this._proxy.$progressEnd(v),this._mapHandleToCancellationSource.delete(v),d&&d.dispose()};let w;try{w=o(new k(this._proxy,I),h&&d?d.token:E.CancellationToken.None)}catch(v){throw u(I),v}return w.then(v=>u(I),v=>u(I)),w}$acceptProgressCanceled(I){const o=this._mapHandleToCancellationSource.get(I);o&&(o.cancel(),this._mapHandleToCancellationSource.delete(I))}}e.ExtHostProgress=y;function _(n,I){return n.message=I.message,typeof I.increment=="number"&&(typeof n.increment=="number"?n.increment+=I.increment:n.increment=I.increment),n}class k extends T.Progress{constructor(I,o){super(h=>this.throttledReport(h));this._proxy=I,this._handle=o}throttledReport(I){this._proxy.$progressReport(this._handle,I)}}He([C.throttle(100,(n,I)=>_(n,I),()=>Object.create(null))],k.prototype,"throttledReport",null)}),define(we[96],_e([0,1,39,12,49,9,6]),function(Z,e,g,T,D,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class y{constructor(o,h,d){const u=y._Keys.nextId();o.$registerTextEditorDecorationType(h.identifier,u,E.DecorationRenderOptions.from(d)),this.value=Object.freeze({key:u,dispose(){o.$removeTextEditorDecorationType(u)}})}}e.TextEditorDecorationType=y,y._Keys=new D.IdGenerator("TextEditorDecorationType");class _{constructor(o,h){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=o,this._documentVersionId=o.version,this._undoStopBefore=h.undoStopBefore,this._undoStopAfter=h.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(o,h){this._throwIfFinalized();let d=null;if(o instanceof C.Position)d=new C.Range(o,o);else if(o instanceof C.Range)d=o;else throw new Error("Unrecognized location");this._pushEdit(d,h,!1)}insert(o,h){this._throwIfFinalized(),this._pushEdit(new C.Range(o,o),h,!0)}delete(o){this._throwIfFinalized();let h=null;if(o instanceof C.Range)h=o;else throw new Error("Unrecognized location");this._pushEdit(h,null,!0)}_pushEdit(o,h,d){const u=this._document.validateRange(o);this._collectedEdits.push({range:u,text:h,forceMoveMarkers:d})}setEndOfLine(o){if(this._throwIfFinalized(),o!==C.EndOfLine.LF&&o!==C.EndOfLine.CRLF)throw T.illegalArgument("endOfLine");this._setEndOfLine=o}}e.TextEditorEdit=_;class k{constructor(o,h,d,u){this._proxy=o,this._id=h,this._accept(d),this._logService=u;const w=this;this.value={get tabSize(){return w._tabSize},set tabSize(v){w._setTabSize(v)},get insertSpaces(){return w._insertSpaces},set insertSpaces(v){w._setInsertSpaces(v)},get cursorStyle(){return w._cursorStyle},set cursorStyle(v){w._setCursorStyle(v)},get lineNumbers(){return w._lineNumbers},set lineNumbers(v){w._setLineNumbers(v)}}}_accept(o){this._tabSize=o.tabSize,this._insertSpaces=o.insertSpaces,this._cursorStyle=o.cursorStyle,this._lineNumbers=E.TextEditorLineNumbersStyle.to(o.lineNumbers)}_validateTabSize(o){if(o==="auto")return"auto";if(typeof o=="number"){const h=Math.floor(o);return h>0?h:null}if(typeof o=="string"){const h=parseInt(o,10);return isNaN(h)?null:h>0?h:null}return null}_setTabSize(o){const h=this._validateTabSize(o);if(h!==null){if(typeof h=="number"){if(this._tabSize===h)return;this._tabSize=h}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:h}))}}_validateInsertSpaces(o){return o==="auto"?"auto":o==="false"?!1:Boolean(o)}_setInsertSpaces(o){const h=this._validateInsertSpaces(o);if(typeof h=="boolean"){if(this._insertSpaces===h)return;this._insertSpaces=h}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:h}))}_setCursorStyle(o){this._cursorStyle!==o&&(this._cursorStyle=o,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:o})))}_setLineNumbers(o){this._lineNumbers!==o&&(this._lineNumbers=o,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:E.TextEditorLineNumbersStyle.from(o)})))}assign(o){const h={};let d=!1;if(typeof o.tabSize!="undefined"){const u=this._validateTabSize(o.tabSize);u==="auto"?(d=!0,h.tabSize=u):typeof u=="number"&&this._tabSize!==u&&(this._tabSize=u,d=!0,h.tabSize=u)}if(typeof o.insertSpaces!="undefined"){const u=this._validateInsertSpaces(o.insertSpaces);u==="auto"?(d=!0,h.insertSpaces=u):this._insertSpaces!==u&&(this._insertSpaces=u,d=!0,h.insertSpaces=u)}typeof o.cursorStyle!="undefined"&&this._cursorStyle!==o.cursorStyle&&(this._cursorStyle=o.cursorStyle,d=!0,h.cursorStyle=o.cursorStyle),typeof o.lineNumbers!="undefined"&&this._lineNumbers!==o.lineNumbers&&(this._lineNumbers=o.lineNumbers,d=!0,h.lineNumbers=E.TextEditorLineNumbersStyle.from(o.lineNumbers)),d&&this._warnOnError(this._proxy.$trySetOptions(this._id,h))}_warnOnError(o){o.catch(h=>this._logService.warn(h))}}e.ExtHostTextEditorOptions=k;class n{constructor(o,h,d,u,w,v,S,c){this.id=o,this._proxy=h,this._logService=d,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=w,this._options=new k(this._proxy,this.id,v,d),this._visibleRanges=S,this._viewColumn=c;const m=this;this.value=Object.freeze({get document(){return u.getValue()},set document(f){throw T.readonly("document")},get selection(){return m._selections&&m._selections[0]},set selection(f){if(!(f instanceof C.Selection))throw T.illegalArgument("selection");m._selections=[f],m._trySetSelection()},get selections(){return m._selections},set selections(f){if(!Array.isArray(f)||f.some(t=>!(t instanceof C.Selection)))throw T.illegalArgument("selections");m._selections=f,m._trySetSelection()},get visibleRanges(){return m._visibleRanges},set visibleRanges(f){throw T.readonly("visibleRanges")},get options(){return m._options.value},set options(f){m._disposed||m._options.assign(f)},get viewColumn(){return m._viewColumn},set viewColumn(f){throw T.readonly("viewColumn")},edit(f,t={undoStopBefore:!0,undoStopAfter:!0}){if(m._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const r=new _(u.getValue(),t);return f(r),m._applyEdit(r)},insertSnippet(f,t,r={undoStopBefore:!0,undoStopAfter:!0}){if(m._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let i;if(!t||Array.isArray(t)&&t.length===0)i=m._selections.map(s=>E.Range.from(s));else if(t instanceof C.Position){const{lineNumber:s,column:l}=E.Position.from(t);i=[{startLineNumber:s,startColumn:l,endLineNumber:s,endColumn:l}]}else if(t instanceof C.Range)i=[E.Range.from(t)];else{i=[];for(const s of t)if(s instanceof C.Range)i.push(E.Range.from(s));else{const{lineNumber:l,column:b}=E.Position.from(s);i.push({startLineNumber:l,startColumn:b,endLineNumber:l,endColumn:b})}}return h.$tryInsertSnippet(o,f.value,i,r)},setDecorations(f,t){const r=t.length===0;r&&!m._hasDecorationsForKey.has(f.key)||(r?m._hasDecorationsForKey.delete(f.key):m._hasDecorationsForKey.add(f.key),m._runOnProxy(()=>{if(E.isDecorationOptionsArr(t))return h.$trySetDecorations(o,f.key,E.fromRangeOrRangeWithMessage(t));{const i=new Array(4*t.length);for(let s=0,l=t.length;s<l;s++){const b=t[s];i[4*s]=b.start.line+1,i[4*s+1]=b.start.character+1,i[4*s+2]=b.end.line+1,i[4*s+3]=b.end.character+1}return h.$trySetDecorationsFast(o,f.key,i)}}))},revealRange(f,t){m._runOnProxy(()=>h.$tryRevealRange(o,E.Range.from(f),t||C.TextEditorRevealType.Default))},show(f){h.$tryShowEditor(o,E.ViewColumn.from(f))},hide(){h.$tryHideEditor(o)}})}dispose(){g.ok(!this._disposed),this._disposed=!0}_acceptOptions(o){g.ok(!this._disposed),this._options._accept(o)}_acceptVisibleRanges(o){g.ok(!this._disposed),this._visibleRanges=o}_acceptViewColumn(o){g.ok(!this._disposed),this._viewColumn=o}_acceptSelections(o){g.ok(!this._disposed),this._selections=o}async _trySetSelection(){const o=this._selections.map(E.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,o)),this.value}_applyEdit(o){const h=o.finalize();if(h.edits.length===0&&!h.setEndOfLine)return Promise.resolve(!0);const d=h.edits.map(w=>w.range);d.sort((w,v)=>w.end.line===v.end.line?w.end.character===v.end.character?w.start.line===v.start.line?w.start.character-v.start.character:w.start.line-v.start.line:w.end.character-v.end.character:w.end.line-v.end.line);for(let w=0,v=d.length-1;w<v;w++){const S=d[w].end;if(d[w+1].start.isBefore(S))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const u=h.edits.map(w=>({range:E.Range.from(w.range),text:w.text,forceMoveMarkers:w.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,h.documentVersionId,u,{setEndOfLine:typeof h.setEndOfLine=="number"?E.EndOfLine.from(h.setEndOfLine):void 0,undoStopBefore:h.undoStopBefore,undoStopAfter:h.undoStopAfter})}_runOnProxy(o){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):o().then(()=>this,h=>(h instanceof Error&&h.name==="DISPOSED"||this._logService.warn(h),null))}}e.ExtHostTextEditor=n}),define(we[169],_e([0,1,132,25,2,3,7,11,6,10,16,9,18]),function(Z,e,g,T,D,E,C,y,_,k,n,I,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function h(w,v){if(k.isString(w))return{label:w};if(w&&typeof w=="object"&&typeof w.label=="string"){let S;return Array.isArray(w.highlights)&&(S=w.highlights.filter(c=>c.length===2&&typeof c[0]=="number"&&typeof c[1]=="number"),S=S.length?S:void 0),{label:w.label,highlights:S}}}class d{constructor(v,S,c){this._proxy=v,this.commands=S,this.logService=c,this.treeViews=new Map;function m(f){return f&&f.$treeViewId&&f.$treeItemHandle}S.registerArgumentProcessor({processArgument:f=>m(f)?this.convertArgument(f):Array.isArray(f)&&f.length>0?f.map(t=>m(t)?this.convertArgument(t):t):f})}registerTreeDataProvider(v,S,c){const m=this.createTreeView(v,{treeDataProvider:S},c);return{dispose:()=>m.dispose()}}createTreeView(v,S,c){if(!S||!S.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const m=S.dragAndDropController!==void 0,f=this._proxy.$registerTreeViewDataProvider(v,{showCollapseAll:!!S.showCollapseAll,canSelectMany:!!S.canSelectMany,canDragAndDrop:m}),t=this.createExtHostTreeView(v,S,c);return{get onDidCollapseElement(){return t.onDidCollapseElement},get onDidExpandElement(){return t.onDidExpandElement},get selection(){return t.selectedElements},get onDidChangeSelection(){return t.onDidChangeSelection},get visible(){return t.visible},get onDidChangeVisibility(){return t.onDidChangeVisibility},get message(){return t.message},set message(r){t.message=r},get title(){return t.title},set title(r){t.title=r},get description(){return t.description},set description(r){t.description=r},reveal:(r,i)=>t.reveal(r,i),dispose:async()=>{await f,this.treeViews.delete(v),t.dispose()}}}$getChildren(v,S){const c=this.treeViews.get(v);return c?c.getChildren(S):Promise.reject(new Error(g.localize(0,null,v)))}$onDrop(v,S,c){const m=this.treeViews.get(v);return m?m.onDrop(S,c):Promise.reject(new Error(g.localize(1,null,v)))}async $hasResolve(v){const S=this.treeViews.get(v);if(!S)throw new Error(g.localize(2,null,v));return S.hasResolve}$resolve(v,S,c){const m=this.treeViews.get(v);if(!m)throw new Error(g.localize(3,null,v));return m.resolveTreeItem(S,c)}$setExpanded(v,S,c){const m=this.treeViews.get(v);if(!m)throw new Error(g.localize(4,null,v));m.setExpanded(S,c)}$setSelection(v,S){const c=this.treeViews.get(v);if(!c)throw new Error(g.localize(5,null,v));c.setSelection(S)}$setVisible(v,S){const c=this.treeViews.get(v);if(!c)throw new Error(g.localize(6,null,v));c.setVisible(S)}createExtHostTreeView(v,S,c){const m=new u(v,S,this._proxy,this.commands.converter,this.logService,c);return this.treeViews.set(v,m),m}convertArgument(v){const S=this.treeViews.get(v.$treeViewId);return S?S.getExtensionElement(v.$treeItemHandle):null}}e.ExtHostTreeViews=d;class u extends C.Disposable{constructor(v,S,c,m,f,t){super();if(this.viewId=v,this.proxy=c,this.commands=m,this.logService=f,this.extension=t,this.roots=null,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new E.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new E.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new E.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new E.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new E.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new o.CancellationTokenSource,t.contributes&&t.contributes.views)for(const s in t.contributes.views)for(const l of t.contributes.views[s])l.id===v&&(this._title=l.name);this.dataProvider=S.treeDataProvider,this.dndController=S.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(s=>this._onDidChangeData.fire({message:!1,element:s})));let r,i;this._register(E.Event.debounce(this._onDidChangeData.event,(s,l)=>(s||(s={message:!1,elements:[]}),l.element!==!1&&(r||(r=new Promise(b=>i=b),this.refreshPromise=this.refreshPromise.then(()=>r)),s.elements.push(l.element)),l.message&&(s.message=!0),s),200,!0)(({message:s,elements:l})=>{l.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const b=i;return r=null,this.refresh(l).then(()=>b())})),s&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(v=>this.getExtensionElement(v)).filter(v=>!k.isUndefinedOrNull(v))}getChildren(v){const S=v?this.getExtensionElement(v):void 0;if(v&&!S)return this.logService.error(`No tree item with id '${v}' found.`),Promise.resolve([]);const c=this.getChildrenNodes(v);return(c?Promise.resolve(c):this.fetchChildrenNodes(S)).then(m=>m.map(f=>f.item))}getExtensionElement(v){return this.elements.get(v)}reveal(v,S){S=S||{select:!0,focus:!1};const c=k.isUndefinedOrNull(S.select)?!0:S.select,m=k.isUndefinedOrNull(S.focus)?!1:S.focus,f=k.isUndefinedOrNull(S.expand)?!1:S.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):v?this.refreshPromise.then(()=>this.resolveUnknownParentChain(v)).then(t=>this.resolveTreeNode(v,t[t.length-1]).then(r=>this.proxy.$reveal(this.viewId,{item:r.item,parentChain:t.map(i=>i.item)},{select:c,focus:m,expand:f})),t=>this.logService.error(t)):this.proxy.$reveal(this.viewId,void 0,{select:c,focus:m,expand:f})}get message(){return this._message}set message(v){this._message=v,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(v){this._title=v,this.proxy.$setTitle(this.viewId,v,this._description)}get description(){return this._description}set description(v){this._description=v,this.proxy.$setTitle(this.viewId,this._title,v)}setExpanded(v,S){const c=this.getExtensionElement(v);c&&(S?this._onDidExpandElement.fire(Object.freeze({element:c})):this._onDidCollapseElement.fire(Object.freeze({element:c})))}setSelection(v){n.equals(this._selectedHandles,v)||(this._selectedHandles=v,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(v){v!==this._visible&&(this._visible=v,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}onDrop(v,S){const c=v.map(f=>this.getExtensionElement(f)).filter(f=>!k.isUndefinedOrNull(f)),m=this.getExtensionElement(S);return c&&m?y.asPromise(()=>{var f;return(f=this.dndController)===null||f===void 0?void 0:f.onDrop(c,m)}):Promise.resolve(void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(v,S){var c;if(!this.dataProvider.resolveTreeItem)return;const m=this.elements.get(v);if(m){const f=this.nodes.get(m);if(f){const t=(c=await this.dataProvider.resolveTreeItem(f.extensionItem,m,S))!==null&&c!==void 0?c:f.extensionItem;return f.item.tooltip=this.getTooltip(t.tooltip),f.item.command=this.getCommand(f.disposableStore,t.command),f.item}}}resolveUnknownParentChain(v){return this.resolveParent(v).then(S=>S?this.resolveUnknownParentChain(S).then(c=>this.resolveTreeNode(S,c[c.length-1]).then(m=>(c.push(m),c))):Promise.resolve([]))}resolveParent(v){const S=this.nodes.get(v);return S?Promise.resolve(S.parent?this.elements.get(S.parent.item.handle):void 0):y.asPromise(()=>this.dataProvider.getParent(v))}resolveTreeNode(v,S){const c=this.nodes.get(v);return c?Promise.resolve(c):y.asPromise(()=>this.dataProvider.getTreeItem(v)).then(m=>this.createHandle(v,m,S,!0)).then(m=>this.getChildren(S?S.item.handle:void 0).then(()=>{const f=this.getExtensionElement(m);if(f){const t=this.nodes.get(f);if(t)return Promise.resolve(t)}throw new Error(`Cannot resolve tree item for element ${m}`)}))}getChildrenNodes(v){if(v){let S;if(typeof v=="string"){const c=this.getExtensionElement(v);S=c?this.nodes.get(c):void 0}else S=v;return S&&S.children||null}return this.roots}async fetchChildrenNodes(v){this.clearChildren(v);const S=new o.CancellationTokenSource(this._refreshCancellationSource.token);try{const c=v?this.nodes.get(v):void 0,m=await this.dataProvider.getChildren(v);if(S.token.isCancellationRequested)return[];const f=await Promise.all(n.coalesce(m||[]).map(async t=>{const r=await this.dataProvider.getTreeItem(t);return r&&!S.token.isCancellationRequested?this.createAndRegisterTreeNode(t,r,c):null}));return S.token.isCancellationRequested?[]:n.coalesce(f)}finally{S.dispose()}}refresh(v){if(v.some(c=>!c))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new o.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const c=this.getHandlesToRefresh(v);if(c.length)return this.refreshHandles(c)}return Promise.resolve(void 0)}getHandlesToRefresh(v){const S=new Set,c=v.map(f=>this.nodes.get(f));for(const f of c)if(f&&!S.has(f.item.handle)){let t=f;for(;t&&t.parent&&c.findIndex(r=>t&&t.parent&&r&&r.item.handle===t.parent.item.handle)===-1;){const r=this.elements.get(t.parent.item.handle);t=r?this.nodes.get(r):void 0}t&&!t.parent&&S.add(f.item.handle)}const m=[];return S.forEach(f=>{const t=this.elements.get(f);if(t){const r=this.nodes.get(t);r&&(!r.parent||!S.has(r.parent.item.handle))&&m.push(f)}}),m}refreshHandles(v){const S={};return Promise.all(v.map(c=>this.refreshNode(c).then(m=>{m&&(S[c]=m.item)}))).then(()=>Object.keys(S).length?this.proxy.$refresh(this.viewId,S):void 0)}refreshNode(v){const S=this.getExtensionElement(v);if(S){const c=this.nodes.get(S);if(c)return this.clearChildren(S),y.asPromise(()=>this.dataProvider.getTreeItem(S)).then(m=>{if(m){const f=this.createTreeNode(S,m,c.parent);return this.updateNodeCache(S,f,c,c.parent),c.dispose(),f}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(v,S,c){const m=this.createTreeNode(v,S,c);if(S.id&&this.elements.has(m.item.handle))throw new Error(g.localize(7,null,S.id));return this.addNodeToCache(v,m),this.addNodeToParentCache(m,c),m}getTooltip(v){return _.MarkdownString.isMarkdownString(v)?I.MarkdownString.from(v):v}getCommand(v,S){return S?this.commands.toInternal(S,v):void 0}createTreeNode(v,S,c){const m=new C.DisposableStore,f=this.createHandle(v,S,c),t=this.getLightIconPath(S);return{item:{handle:f,parentHandle:c?c.item.handle:void 0,label:h(S.label,this.extension),description:S.description,resourceUri:S.resourceUri,tooltip:this.getTooltip(S.tooltip),command:this.getCommand(m,S.command),contextValue:S.contextValue,icon:t,iconDark:this.getDarkIconPath(S)||t,themeIcon:this.getThemeIcon(S),collapsibleState:k.isUndefinedOrNull(S.collapsibleState)?_.TreeItemCollapsibleState.None:S.collapsibleState,accessibilityInformation:S.accessibilityInformation},extensionItem:S,parent:c,children:void 0,disposableStore:m,dispose(){m.dispose()}}}getThemeIcon(v){return v.iconPath instanceof _.ThemeIcon?v.iconPath:void 0}createHandle(v,{id:S,label:c,resourceUri:m},f,t){if(S)return`${u.ID_HANDLE_PREFIX}/${S}`;const r=h(c,this.extension),i=f?f.item.handle:u.LABEL_HANDLE_PREFIX;let s=r?r.label:m?T.basename(m):"";s=s.indexOf("/")!==-1?s.replace("/","//"):s;const l=this.nodes.has(v)?this.nodes.get(v).item.handle:void 0,b=this.getChildrenNodes(f)||[];let p,P=0;do{if(p=`${i}/${P}:${s}`,t||!this.elements.has(p)||l===p)break;P++}while(P<=b.length);return p}getLightIconPath(v){if(v.iconPath&&!(v.iconPath instanceof _.ThemeIcon))return typeof v.iconPath=="string"||D.URI.isUri(v.iconPath)?this.getIconPath(v.iconPath):this.getIconPath(v.iconPath.light)}getDarkIconPath(v){if(v.iconPath&&!(v.iconPath instanceof _.ThemeIcon)&&v.iconPath.dark)return this.getIconPath(v.iconPath.dark)}getIconPath(v){return D.URI.isUri(v)?v:D.URI.file(v)}addNodeToCache(v,S){this.elements.set(S.item.handle,v),this.nodes.set(v,S)}updateNodeCache(v,S,c,m){this.elements.delete(S.item.handle),this.nodes.delete(v),S.item.handle!==c.item.handle&&this.elements.delete(c.item.handle),this.addNodeToCache(v,S);const f=this.getChildrenNodes(m)||[],t=f.filter(r=>r.item.handle===c.item.handle)[0];t&&f.splice(f.indexOf(t),1,S)}addNodeToParentCache(v,S){S?(S.children||(S.children=[]),S.children.push(v)):(this.roots||(this.roots=[]),this.roots.push(v))}clearChildren(v){if(v){const S=this.nodes.get(v);if(S){if(S.children)for(const c of S.children){const m=this.elements.get(c.item.handle);m&&this.clear(m)}S.children=void 0}}else this.clearAll()}clear(v){const S=this.nodes.get(v);if(S){if(S.children)for(const c of S.children){const m=this.elements.get(c.item.handle);m&&this.clear(m)}this.nodes.delete(v),this.elements.delete(S.item.handle),S.dispose()}}clearAll(){this.roots=null,this.elements.clear(),this.nodes.forEach(v=>v.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}u.LABEL_HANDLE_PREFIX="0",u.ID_HANDLE_PREFIX="1"}),define(we[170],_e([0,1,16,11,18,10,65,9,6,94]),function(Z,e,g,T,D,E,C,y,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=e.TestTree=e.TestPosition=e.OwnedTestCollection=void 0;class n{constructor(){this.testIdsToInternal=new Map}getTestById(w,v){if(v!==void 0){const S=this.testIdsToInternal.get(v),c=S==null?void 0:S.get(w);if(c)return[S,c]}return g.mapFind(this.testIdsToInternal.values(),S=>{const c=S.get(w);return c&&[S,c]})}createForHierarchy(w=()=>{}){return new d(this.createIdMap(o++),w)}createIdMap(w){const v=new h(w);return this.testIdsToInternal.set(v.id,v),{object:v,dispose:()=>this.testIdsToInternal.delete(v.id)}}}e.OwnedTestCollection=n;var I;(function(u){u[u.Disconnected=0]="Disconnected",u[u.IsChild=1]="IsChild",u[u.IsParent=2]="IsParent",u[u.IsSame=3]="IsSame"})(I=e.TestPosition||(e.TestPosition={}));let o=0;class h{constructor(w){this.id=w,this.map=new Map,this._roots=new Set,this.roots=this._roots}get size(){return this.map.size}add(w){if(this.map.has(w.item.extId))throw new Error(`Attempted to insert a duplicate test item ID ${w.item.extId}`);this.map.set(w.item.extId,w),w.parent||this._roots.add(w)}has(w){return this.map.has(w)}delete(w){const v=this.map.get(w);return v?(this.map.delete(w),this._roots.delete(v),!0):!1}get(w){return this.map.get(w)}comparePositions(w,v){const S=typeof w=="string"?this.map.get(w):w,c=typeof v=="string"?this.map.get(v):v;if(!S||!c)return 0;if(S===c)return 3;for(let m=this.map.get(c.parent);m;m=this.map.get(m.parent))if(m===S)return 1;for(let m=this.map.get(S.parent);m;m=this.map.get(m.parent))if(m===c)return 2;return 0}[Symbol.iterator](){return this.map.values()}}e.TestTree=h;class d{constructor(w,v){this.testIdToInternal=w,this.publishDiff=v,this.testItemToInternal=new Map,this.diff=[],this.debounceSendDiff=new T.RunOnceScheduler(()=>this.flushDiff(),200)}get treeId(){return this.testIdToInternal.object.id}addRoot(w,v){this.addItem(w,v,null)}getTestByReference(w){return this.testItemToInternal.get(w)}collectDiff(){const w=this.diff;return this.diff=[],w}pushDiff(w){const v=this.diff[this.diff.length-1];if(v&&w[0]===1){if(v[0]===1&&v[1].extId===w[1].extId){k.applyTestItemUpdate(v[1],w[1]);return}if(v[0]===0&&v[1].item.extId===w[1].extId){k.applyTestItemUpdate(v[1],w[1]);return}}this.diff.push(w),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(w,v){var S;const c=this.testIdToInternal.object.get(w);if(!!c){if((c.expandLevels===void 0||v>c.expandLevels)&&(c.expandLevels=v),c.expand===1){const m=this.refreshChildren(c);return m.isSettled?this.expandChildren(c,v-1):m.p.then(()=>this.expandChildren(c,v-1))}else if(c.expand===3)return((S=c.initialExpand)===null||S===void 0?void 0:S.isSettled)===!1?c.initialExpand.p.then(()=>this.expandChildren(c,v-1)):this.expandChildren(c,v-1)}}dispose(){var w;for(const v of this.testItemToInternal.values())(w=v.discoverCts)===null||w===void 0||w.dispose(!0),C.getPrivateApiFor(v.actual).bus.dispose();this.diff=[],this.testIdToInternal.dispose(),this.debounceSendDiff.dispose()}onTestItemEvent(w,v){const S=w==null?void 0:w.actual.id;switch(v[0]){case 2:this.pushDiff([4,S]);break;case 1:this.removeItem(w);break;case 0:this.addItem(v[1],w.src.controller,w);break;case 3:const[c,m,f]=v;switch(m){case"status":this.updateExpandability(w);break;case"range":this.pushDiff([1,{extId:S,item:{range:y.Range.from(f)}}]);break;case"error":this.pushDiff([1,{extId:S,item:{error:y.MarkdownString.fromStrict(f)||null}}]);break;default:this.pushDiff([1,{extId:S,item:{[m]:f??null}}]);break}break;default:E.assertNever(v[0])}}addItem(w,v,S){if(!(w instanceof _.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${w.id} did not`);if(this.testItemToInternal.has(w))throw new Error(`Attempted to add a single TestItem ${w.id} multiple times to the tree`);if(this.testIdToInternal.object.has(w.id))throw new Error(`Attempted to insert a duplicate test item ID ${w.id}`);const c=S?S.item.extId:null,m=w.resolveHandler?1:0,f=S?S.expandLevels:1,t={controller:v,tree:this.testIdToInternal.object.id},r={actual:w,parent:c,item:y.TestItem.from(w),expandLevels:f?f-1:void 0,expand:0,src:t};this.testIdToInternal.object.add(r),this.testItemToInternal.set(w,r),this.pushDiff([0,{parent:c,src:t,expand:m,item:r.item}]);const i=C.getPrivateApiFor(w);i.parent=S==null?void 0:S.actual,i.bus.event(this.onTestItemEvent.bind(this,r)),this.updateExpandability(r);for(const s of i.children.values())this.testItemToInternal.has(s)||this.addItem(s,v,r)}updateExpandability(w){var v;let S;w.actual.resolveHandler?w.actual.status===_.TestItemStatus.Pending?S=w.discoverCts?2:1:((v=w.initialExpand)===null||v===void 0||v.complete(),S=3):S=0,S!==w.expand&&(w.expand=S,this.pushDiff([1,{extId:w.actual.id,expand:S}]),S===1&&w.expandLevels!==void 0&&this.refreshChildren(w))}expandChildren(w,v){if(v<0)return;const S=[...w.actual.children.values()].map(c=>this.expand(c.id,v)).filter(T.isThenable);if(S.length)return Promise.all(S).then(()=>{})}refreshChildren(w){if(w.discoverCts&&w.discoverCts.dispose(!0),!w.actual.resolveHandler){const v=new T.DeferredPromise;return v.complete(),v}return w.expand=2,w.discoverCts=new D.CancellationTokenSource,this.pushExpandStateUpdate(w),w.initialExpand=new T.DeferredPromise,w.actual.resolveHandler(w.discoverCts.token),w.initialExpand}pushExpandStateUpdate(w){this.pushDiff([1,{extId:w.actual.id,expand:w.expand}])}removeItem(w){var v;this.pushDiff([2,w.actual.id]);const S=[w];for(;S.length;){const c=S.pop();if(!!c){(v=c.discoverCts)===null||v===void 0||v.dispose(!0),this.testIdToInternal.object.delete(c.item.extId),this.testItemToInternal.delete(c.actual);for(const m of c.actual.children.values())S.push(this.testIdToInternal.object.get(m.id))}}}flushDiff(){const w=this.collectDiff();w.length&&this.publishDiff(w)}}e.SingleUseTestCollection=d}),define(we[171],_e([0,1,26,3,13]),function(Z,e,g,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class E{constructor(n){this.removedDueToLooping=n}}e.DeltaExtensionsResult=E;class C{constructor(n){this._onDidChange=new T.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=n,this._initialize()}_initialize(){this._extensionDescriptions.sort(_),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const n of this._extensionDescriptions){if(this._extensionsMap.has(g.ExtensionIdentifier.toKey(n.identifier))){console.error("Extension `"+n.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(g.ExtensionIdentifier.toKey(n.identifier),n),this._extensionsArr.push(n),Array.isArray(n.activationEvents))for(let I of n.activationEvents)I==="onUri"&&(I=`onUri:${g.ExtensionIdentifier.toKey(n.identifier)}`),this._activationMap.has(I)||this._activationMap.set(I,[]),this._activationMap.get(I).push(n)}}keepOnly(n){const I=new Set;n.forEach(o=>I.add(g.ExtensionIdentifier.toKey(o))),this._extensionDescriptions=this._extensionDescriptions.filter(o=>I.has(g.ExtensionIdentifier.toKey(o.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(n,I){n.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(n));const o=C._findLoopingExtensions(this._extensionDescriptions);if(I=I.concat(o.map(h=>h.identifier)),I.length>0){const h=new Set;I.forEach(d=>h.add(g.ExtensionIdentifier.toKey(d))),this._extensionDescriptions=this._extensionDescriptions.filter(d=>!h.has(g.ExtensionIdentifier.toKey(d.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new E(o)}static _findLoopingExtensions(n){const I=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(w){this._nodesSet.has(w)||(this._nodesSet.add(w),this._nodesArr.push(w))}addArc(w,v){this.addNode(w),this.addNode(v),this._arcs.has(w)?this._arcs.get(w).push(v):this._arcs.set(w,[v])}getArcs(w){return this._arcs.has(w)?this._arcs.get(w):[]}hasOnlyGoodArcs(w,v){const S=I.getArcs(w);for(let c=0;c<S.length;c++)if(!v.has(S[c]))return!1;return!0}getNodes(){return this._nodesArr}};let o=new Map;for(let w of n){const v=g.ExtensionIdentifier.toKey(w.identifier);if(o.set(v,w),w.extensionDependencies)for(let S of w.extensionDependencies){const c=g.ExtensionIdentifier.toKey(S);I.addArc(v,c)}}let h=new Set;I.getNodes().filter(w=>I.getArcs(w).length===0).forEach(w=>h.add(w));let d=I.getNodes().filter(w=>!h.has(w)),u;do{u=!1;for(let w=0;w<d.length;w++){const v=d[w];I.hasOnlyGoodArcs(v,h)&&(d.splice(w,1),w--,h.add(v),u=!0)}}while(u);return d.map(w=>o.get(w))}containsActivationEvent(n){return this._activationMap.has(n)}containsExtension(n){return this._extensionsMap.has(g.ExtensionIdentifier.toKey(n))}getExtensionDescriptionsForActivationEvent(n){const I=this._activationMap.get(n);return I?I.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(n){const I=this._extensionsMap.get(g.ExtensionIdentifier.toKey(n));return I||void 0}}e.ExtensionDescriptionRegistry=C;var y;(function(k){k[k.Builtin=0]="Builtin",k[k.User=1]="User",k[k.Dev=2]="Dev"})(y||(y={}));function _(k,n){const I=k.isBuiltin?0:k.isUnderDevelopment?2:1,o=n.isBuiltin?0:n.isUnderDevelopment?2:1;if(I!==o)return I-o;const h=D.posix.basename(k.extensionLocation.path),d=D.posix.basename(n.extensionLocation.path);return h<d?-1:h>d?1:0}}),define(we[172],_e([0,1,23]),function(Z,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var T;(function(y){y[y.VersionMismatch=55]="VersionMismatch",y[y.UnexpectedError=81]="UnexpectedError"})(T=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var D;(function(y){y[y.Initialized=0]="Initialized",y[y.Ready=1]="Ready",y[y.Terminate=2]="Terminate"})(D=e.MessageType||(e.MessageType={}));function E(y){const _=g.VSBuffer.alloc(1);switch(y){case 0:_.writeUInt8(1,0);break;case 1:_.writeUInt8(2,0);break;case 2:_.writeUInt8(3,0);break}return _}e.createMessageOfType=E;function C(y,_){if(y.byteLength!==1)return!1;switch(y.readUInt8(0)){case 1:return _===0;case 2:return _===1;case 3:return _===2;default:return!1}}e.isMessageOfType=C}),define(we[29],_e([0,1,3,2,5,26,143]),function(Z,e,g,T,D,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new E.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:T.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=D.createDecorator("extensionService");class y{constructor(S){this.dependency=S}}e.MissingExtensionDependency=y;var _;(function(v){v[v.LocalProcess=0]="LocalProcess",v[v.LocalWebWorker=1]="LocalWebWorker",v[v.Remote=2]="Remote"})(_=e.ExtensionHostKind||(e.ExtensionHostKind={}));class k{constructor(S,c,m,f){this.codeLoadingTime=S,this.activateCallTime=c,this.activateResolvedTime=m,this.activationReason=f}}e.ActivationTimes=k;class n{constructor(S,c){this.description=S,this.value=c}}e.ExtensionPointContribution=n,e.ExtensionHostLogFileName="exthost";var I;(function(v){v[v.Normal=0]="Normal",v[v.Immediate=1]="Immediate"})(I=e.ActivationKind||(e.ActivationKind={}));function o(v){v.enableProposedApi||h(v)}e.checkProposedApiEnabled=o;function h(v){throw new Error(`[${v.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${v.identifier.value}`)}e.throwProposedApiError=h;function d(v){return{type:v.isBuiltin?0:1,isBuiltin:v.isBuiltin||v.isUserBuiltin,identifier:{id:C.getGalleryExtensionId(v.publisher,v.name),uuid:v.uuid},manifest:v,location:v.extensionLocation}}e.toExtension=d;function u(v){return Object.assign(Object.assign({identifier:new E.ExtensionIdentifier(v.identifier.id),isBuiltin:v.type===0,isUserBuiltin:v.type===1&&v.isBuiltin,isUnderDevelopment:!1,extensionLocation:v.location},v.manifest),{uuid:v.identifier.uuid})}e.toExtensionDescription=u;class w{constructor(){this.onDidRegisterExtensions=g.Event.None,this.onDidChangeExtensionsStatus=g.Event.None,this.onDidChangeExtensions=g.Event.None,this.onWillActivateByEvent=g.Event.None,this.onDidChangeResponsiveChange=g.Event.None}activateByEvent(S){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(S){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(S){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(S){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(S,c){return Promise.resolve()}_onWillActivateExtension(S){}_onDidActivateExtension(S,c,m,f,t){}_onDidActivateExtensionError(S,c){}_onExtensionRuntimeError(S,c){}_onExtensionHostExit(S){}}e.NullExtensionService=w}),define(we[173],_e([0,1,26,29,17]),function(Z,e,g,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const E=Promise.resolve(void 0);class C{constructor(d,u,w,v){this.startup=d,this.codeLoadingTime=u,this.activateCallTime=w,this.activateResolvedTime=v}}e.ExtensionActivationTimes=C,C.NONE=new C(!1,-1,-1,-1);class y{constructor(d){this._startup=d,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(d,u){return d===-1||u===-1?-1:u-d}build(){return new C(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=y;class _{constructor(d,u,w,v,S,c){this.activationFailed=d,this.activationFailedError=u,this.activationTimes=w,this.module=v,this.exports=S,this.subscriptions=c}}e.ActivatedExtension=_;class k extends _{constructor(d){super(!1,null,d,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=k;class n extends _{constructor(){super(!1,null,C.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=n;class I extends _{constructor(d){super(!0,d,C.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=I;let o=class{constructor(d,u,w,v,S){this._logService=S,this._registry=d,this._resolvedExtensionsSet=new Set,u.forEach(c=>this._resolvedExtensionsSet.add(g.ExtensionIdentifier.toKey(c))),this._hostExtensionsMap=new Map,w.forEach(c=>this._hostExtensionsMap.set(g.ExtensionIdentifier.toKey(c),c)),this._host=v,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(d){const u=g.ExtensionIdentifier.toKey(d);return this._activatedExtensions.has(u)}getActivatedExtension(d){const u=g.ExtensionIdentifier.toKey(d),w=this._activatedExtensions.get(u);if(!w)throw new Error("Extension `"+d.value+"` is not known or not activated");return w}activateByEvent(d,u){if(this._alreadyActivatedEvents[d])return E;const w=this._registry.getExtensionDescriptionsForActivationEvent(d);return this._activateExtensions(w.map(v=>({id:v.identifier,reason:{startup:u,extensionId:v.identifier,activationEvent:d}}))).then(()=>{this._alreadyActivatedEvents[d]=!0})}activateById(d,u){const w=this._registry.getExtensionDescription(d);if(!w)throw new Error("Extension `"+d+"` is not known");return this._activateExtensions([{id:w.identifier,reason:u}])}_handleActivateRequest(d,u,w){if(this._hostExtensionsMap.has(g.ExtensionIdentifier.toKey(d.id))){u[g.ExtensionIdentifier.toKey(d.id)]=d;return}const v=this._registry.getExtensionDescription(d.id);if(!v){const m=new Error(`Cannot activate unknown extension '${d.id.value}'`);this._host.onExtensionActivationError(d.id,m,new T.MissingExtensionDependency(d.id.value)),this._activatedExtensions.set(g.ExtensionIdentifier.toKey(d.id),new I(m));return}const S=typeof v.extensionDependencies=="undefined"?[]:v.extensionDependencies;let c=!0;for(let m=0,f=S.length;m<f;m++){const t=S[m];if(this._resolvedExtensionsSet.has(g.ExtensionIdentifier.toKey(t)))continue;const r=this._activatedExtensions.get(g.ExtensionIdentifier.toKey(t));if(r&&!r.activationFailed)continue;if(r&&r.activationFailed){const b=v.displayName||v.identifier.value,p=this._registry.getExtensionDescription(t),P=p&&p.displayName||t,A=new Error(`Cannot activate the '${b}' extension because its dependency '${P}' failed to activate`);A.detail=r.activationFailedError,this._host.onExtensionActivationError(v.identifier,A,null),this._activatedExtensions.set(g.ExtensionIdentifier.toKey(v.identifier),new I(A));return}if(this._hostExtensionsMap.has(g.ExtensionIdentifier.toKey(t))){c=!1,u[g.ExtensionIdentifier.toKey(t)]={id:this._hostExtensionsMap.get(g.ExtensionIdentifier.toKey(t)),reason:d.reason};continue}const i=this._registry.getExtensionDescription(t);if(i){c=!1,u[g.ExtensionIdentifier.toKey(t)]={id:i.identifier,reason:d.reason};continue}const s=v.displayName||v.identifier.value,l=new Error(`Cannot activate the '${s}' extension because it depends on unknown extension '${t}'`);this._host.onExtensionActivationError(v.identifier,l,new T.MissingExtensionDependency(t)),this._activatedExtensions.set(g.ExtensionIdentifier.toKey(v.identifier),new I(l));return}c?u[g.ExtensionIdentifier.toKey(v.identifier)]=d:w.push(d)}_activateExtensions(d){if(d.length===0||(d=d.filter(S=>!this._activatedExtensions.has(g.ExtensionIdentifier.toKey(S.id))),d.length===0))return Promise.resolve(void 0);const u=Object.create(null),w=[];for(let S=0,c=d.length;S<c;S++)this._handleActivateRequest(d[S],u,w);for(let S=0,c=w.length;S<c;S++){const m=g.ExtensionIdentifier.toKey(w[S].id);u[m]&&delete u[m]}const v=Object.keys(u).map(S=>u[S]);return w.length===0?Promise.all(v.map(S=>this._activateExtension(S.id,S.reason))).then(S=>{}):this._activateExtensions(v).then(S=>this._activateExtensions(w))}_activateExtension(d,u){const w=g.ExtensionIdentifier.toKey(d);if(this._activatedExtensions.has(w))return Promise.resolve(void 0);const v=this._activatingExtensions.get(w);if(v)return v;const S=this._host.actualActivateExtension(d,u).then(void 0,c=>{const m=new Error;return c&&c.name&&(m.name=c.name),c&&c.message?m.message=`Activating extension '${d.value}' failed: ${c.message}.`:m.message=`Activating extension '${d.value}' failed: ${c}.`,c&&c.stack&&(m.stack=c.stack),this._host.onExtensionActivationError(d,m,null),this._logService.error(`Activating extension ${d.value} failed due to an error:`),this._logService.error(c),new I(c)}).then(c=>{this._activatedExtensions.set(w,c),this._activatingExtensions.delete(w)});return this._activatingExtensions.set(w,S),S}};o=He([ze(4,D.ILogService)],o),e.ExtensionsActivator=o}),define(we[174],_e([0,1,12]),function(Z,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class T{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((E,C)=>{this._actualOk=E,this._actualErr=C,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(E){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=E,this._actual&&this._actualOk(E))}resolveErr(E){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=E,this._actual?this._actualErr(E):g.onUnexpectedError(E))}then(E,C){return this._ensureActual().then(E,C)}catch(E){return this._ensureActual().then(void 0,E)}finally(E){return this._ensureActual().finally(E)}}e.LazyPromise=T}),define(we[97],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class g{constructor(_,k){this.isMain=_,this.sid=k,this.nid=++g.count}}e.ProxyIdentifier=g,g.count=0;const T=[];function D(y){const _=new g(!0,y);return T[_.nid]=_,_}e.createMainContextProxyIdentifier=D;function E(y){const _=new g(!1,y);return T[_.nid]=_,_}e.createExtHostContextProxyIdentifier=E;function C(y){return T[y].sid}e.getStringIdentifierForProxy=C}),define(we[4],_e([0,1,54,2,97]),function(Z,e,g,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var E;(function(c){c[c.Desktop=1]="Desktop",c[c.Web=2]="Web"})(E=e.UIKind||(e.UIKind={}));var C;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(C=e.TextEditorRevealType||(e.TextEditorRevealType={}));var y;(function(c){c[c.Editable=0]="Editable",c[c.SupportsHotExit=1]="SupportsHotExit"})(y=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var _;(function(c){c[c.Int8Array=1]="Int8Array",c[c.Uint8Array=2]="Uint8Array",c[c.Uint8ClampedArray=3]="Uint8ClampedArray",c[c.Int16Array=4]="Int16Array",c[c.Uint16Array=5]="Uint16Array",c[c.Int32Array=6]="Int32Array",c[c.Uint32Array=7]="Uint32Array",c[c.Float32Array=8]="Float32Array",c[c.Float64Array=9]="Float64Array",c[c.BigInt64Array=10]="BigInt64Array",c[c.BigUint64Array=11]="BigUint64Array"})(_=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var k;(function(c){c[c.Text=1]="Text",c[c.Error=2]="Error",c[c.Rich=3]="Rich"})(k=e.CellOutputKind||(e.CellOutputKind={}));var n;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(n=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var I;(function(c){c[c.None=0]="None",c[c.Process=1]="Process",c[c.Output=2]="Output"})(I=e.CandidatePortSource||(e.CandidatePortSource={}));var o;(function(c){c.name="$ident";function m(t,r){return Object.defineProperty(t,c.name,{value:r,enumerable:!0}),t}c.mixin=m;function f(t){return t[c.name]}c.of=f})(o=e.ObjectIdentifier||(e.ObjectIdentifier={}));class h{static mixin(m){return m._id=h._n++,m}}e.IdObject=h,h._n=0;var d;(function(c){c.label="a",c.kind="b",c.detail="c",c.documentation="d",c.sortText="e",c.filterText="f",c.preselect="g",c.insertText="h",c.insertTextRules="i",c.range="j",c.commitCharacters="k",c.additionalTextEdits="l",c.command="m",c.kindModifier="n",c.label2="o"})(d=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var u;(function(c){c.defaultRanges="a",c.completions="b",c.isIncomplete="c",c.duration="d"})(u=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var w;(function(c){c[c.File=1]="File",c[c.Text=2]="Text",c[c.Cell=3]="Cell"})(w=e.WorkspaceEditType||(e.WorkspaceEditType={}));function v(c){if(c&&c.edits)for(const m of c.edits)typeof m.resource=="object"?m.resource=T.URI.revive(m.resource):(m.newUri=T.URI.revive(m.newUri),m.oldUri=T.URI.revive(m.oldUri)),m.metadata&&m.metadata.iconPath&&(m.metadata=g.revive(m.metadata));return c}e.reviveWorkspaceEditDto=v;var S;(function(c){c[c.Workspace=0]="Workspace",c[c.TextDocument=1]="TextDocument"})(S=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:D.createMainContextProxyIdentifier("MainThreadAuthentication"),MainThreadBulkEdits:D.createMainContextProxyIdentifier("MainThreadBulkEdits"),MainThreadClipboard:D.createMainContextProxyIdentifier("MainThreadClipboard"),MainThreadCommands:D.createMainContextProxyIdentifier("MainThreadCommands"),MainThreadComments:D.createMainContextProxyIdentifier("MainThreadComments"),MainThreadConfiguration:D.createMainContextProxyIdentifier("MainThreadConfiguration"),MainThreadConsole:D.createMainContextProxyIdentifier("MainThreadConsole"),MainThreadDebugService:D.createMainContextProxyIdentifier("MainThreadDebugService"),MainThreadDecorations:D.createMainContextProxyIdentifier("MainThreadDecorations"),MainThreadDiagnostics:D.createMainContextProxyIdentifier("MainThreadDiagnostics"),MainThreadDialogs:D.createMainContextProxyIdentifier("MainThreadDiaglogs"),MainThreadDocuments:D.createMainContextProxyIdentifier("MainThreadDocuments"),MainThreadDocumentContentProviders:D.createMainContextProxyIdentifier("MainThreadDocumentContentProviders"),MainThreadTextEditors:D.createMainContextProxyIdentifier("MainThreadTextEditors"),MainThreadEditorInsets:D.createMainContextProxyIdentifier("MainThreadEditorInsets"),MainThreadEditorTabs:D.createMainContextProxyIdentifier("MainThreadEditorTabs"),MainThreadErrors:D.createMainContextProxyIdentifier("MainThreadErrors"),MainThreadTreeViews:D.createMainContextProxyIdentifier("MainThreadTreeViews"),MainThreadDownloadService:D.createMainContextProxyIdentifier("MainThreadDownloadService"),MainThreadKeytar:D.createMainContextProxyIdentifier("MainThreadKeytar"),MainThreadLanguageFeatures:D.createMainContextProxyIdentifier("MainThreadLanguageFeatures"),MainThreadLanguages:D.createMainContextProxyIdentifier("MainThreadLanguages"),MainThreadLog:D.createMainContextProxyIdentifier("MainThread"),MainThreadMessageService:D.createMainContextProxyIdentifier("MainThreadMessageService"),MainThreadOutputService:D.createMainContextProxyIdentifier("MainThreadOutputService"),MainThreadProgress:D.createMainContextProxyIdentifier("MainThreadProgress"),MainThreadQuickOpen:D.createMainContextProxyIdentifier("MainThreadQuickOpen"),MainThreadStatusBar:D.createMainContextProxyIdentifier("MainThreadStatusBar"),MainThreadSecretState:D.createMainContextProxyIdentifier("MainThreadSecretState"),MainThreadStorage:D.createMainContextProxyIdentifier("MainThreadStorage"),MainThreadTelemetry:D.createMainContextProxyIdentifier("MainThreadTelemetry"),MainThreadTerminalService:D.createMainContextProxyIdentifier("MainThreadTerminalService"),MainThreadWebviews:D.createMainContextProxyIdentifier("MainThreadWebviews"),MainThreadWebviewPanels:D.createMainContextProxyIdentifier("MainThreadWebviewPanels"),MainThreadWebviewViews:D.createMainContextProxyIdentifier("MainThreadWebviewViews"),MainThreadCustomEditors:D.createMainContextProxyIdentifier("MainThreadCustomEditors"),MainThreadUrls:D.createMainContextProxyIdentifier("MainThreadUrls"),MainThreadUriOpeners:D.createMainContextProxyIdentifier("MainThreadUriOpeners"),MainThreadWorkspace:D.createMainContextProxyIdentifier("MainThreadWorkspace"),MainThreadFileSystem:D.createMainContextProxyIdentifier("MainThreadFileSystem"),MainThreadExtensionService:D.createMainContextProxyIdentifier("MainThreadExtensionService"),MainThreadSCM:D.createMainContextProxyIdentifier("MainThreadSCM"),MainThreadSearch:D.createMainContextProxyIdentifier("MainThreadSearch"),MainThreadTask:D.createMainContextProxyIdentifier("MainThreadTask"),MainThreadWindow:D.createMainContextProxyIdentifier("MainThreadWindow"),MainThreadLabelService:D.createMainContextProxyIdentifier("MainThreadLabelService"),MainThreadNotebook:D.createMainContextProxyIdentifier("MainThreadNotebook"),MainThreadNotebookDocuments:D.createMainContextProxyIdentifier("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:D.createMainContextProxyIdentifier("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:D.createMainContextProxyIdentifier("MainThreadNotebookKernels"),MainThreadNotebookRenderers:D.createMainContextProxyIdentifier("MainThreadNotebookRenderers"),MainThreadTheming:D.createMainContextProxyIdentifier("MainThreadTheming"),MainThreadTunnelService:D.createMainContextProxyIdentifier("MainThreadTunnelService"),MainThreadTimeline:D.createMainContextProxyIdentifier("MainThreadTimeline"),MainThreadTesting:D.createMainContextProxyIdentifier("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:D.createExtHostContextProxyIdentifier("ExtHostCommands"),ExtHostConfiguration:D.createExtHostContextProxyIdentifier("ExtHostConfiguration"),ExtHostDiagnostics:D.createExtHostContextProxyIdentifier("ExtHostDiagnostics"),ExtHostDebugService:D.createExtHostContextProxyIdentifier("ExtHostDebugService"),ExtHostDecorations:D.createExtHostContextProxyIdentifier("ExtHostDecorations"),ExtHostDocumentsAndEditors:D.createExtHostContextProxyIdentifier("ExtHostDocumentsAndEditors"),ExtHostDocuments:D.createExtHostContextProxyIdentifier("ExtHostDocuments"),ExtHostDocumentContentProviders:D.createExtHostContextProxyIdentifier("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:D.createExtHostContextProxyIdentifier("ExtHostDocumentSaveParticipant"),ExtHostEditors:D.createExtHostContextProxyIdentifier("ExtHostEditors"),ExtHostTreeViews:D.createExtHostContextProxyIdentifier("ExtHostTreeViews"),ExtHostFileSystem:D.createExtHostContextProxyIdentifier("ExtHostFileSystem"),ExtHostFileSystemInfo:D.createExtHostContextProxyIdentifier("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:D.createExtHostContextProxyIdentifier("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:D.createExtHostContextProxyIdentifier("ExtHostLanguageFeatures"),ExtHostQuickOpen:D.createExtHostContextProxyIdentifier("ExtHostQuickOpen"),ExtHostExtensionService:D.createExtHostContextProxyIdentifier("ExtHostExtensionService"),ExtHostLogService:D.createExtHostContextProxyIdentifier("ExtHostLogService"),ExtHostTerminalService:D.createExtHostContextProxyIdentifier("ExtHostTerminalService"),ExtHostSCM:D.createExtHostContextProxyIdentifier("ExtHostSCM"),ExtHostSearch:D.createExtHostContextProxyIdentifier("ExtHostSearch"),ExtHostTask:D.createExtHostContextProxyIdentifier("ExtHostTask"),ExtHostWorkspace:D.createExtHostContextProxyIdentifier("ExtHostWorkspace"),ExtHostWindow:D.createExtHostContextProxyIdentifier("ExtHostWindow"),ExtHostWebviews:D.createExtHostContextProxyIdentifier("ExtHostWebviews"),ExtHostWebviewPanels:D.createExtHostContextProxyIdentifier("ExtHostWebviewPanels"),ExtHostCustomEditors:D.createExtHostContextProxyIdentifier("ExtHostCustomEditors"),ExtHostWebviewViews:D.createExtHostContextProxyIdentifier("ExtHostWebviewViews"),ExtHostEditorInsets:D.createExtHostContextProxyIdentifier("ExtHostEditorInsets"),ExtHostEditorTabs:D.createExtHostContextProxyIdentifier("ExtHostEditorTabs"),ExtHostProgress:D.createMainContextProxyIdentifier("ExtHostProgress"),ExtHostComments:D.createMainContextProxyIdentifier("ExtHostComments"),ExtHostSecretState:D.createMainContextProxyIdentifier("ExtHostSecretState"),ExtHostStorage:D.createMainContextProxyIdentifier("ExtHostStorage"),ExtHostUrls:D.createExtHostContextProxyIdentifier("ExtHostUrls"),ExtHostUriOpeners:D.createExtHostContextProxyIdentifier("ExtHostUriOpeners"),ExtHostOutputService:D.createMainContextProxyIdentifier("ExtHostOutputService"),ExtHosLabelService:D.createMainContextProxyIdentifier("ExtHostLabelService"),ExtHostNotebook:D.createMainContextProxyIdentifier("ExtHostNotebook"),ExtHostNotebookKernels:D.createMainContextProxyIdentifier("ExtHostNotebookKernels"),ExtHostNotebookRenderers:D.createMainContextProxyIdentifier("ExtHostNotebookRenderers"),ExtHostTheming:D.createMainContextProxyIdentifier("ExtHostTheming"),ExtHostTunnelService:D.createMainContextProxyIdentifier("ExtHostTunnelService"),ExtHostAuthentication:D.createMainContextProxyIdentifier("ExtHostAuthentication"),ExtHostTimeline:D.createMainContextProxyIdentifier("ExtHostTimeline"),ExtHostTesting:D.createMainContextProxyIdentifier("ExtHostTesting"),ExtHostTelemetry:D.createMainContextProxyIdentifier("ExtHostTelemetry")}}),define(we[69],_e([0,1,4,3,5]),function(Z,e,g,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class E{constructor(y){this._onDidChangePassword=new T.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=y.getProxy(g.MainContext.MainThreadSecretState)}async $onDidChangePassword(y){this._onDidChangePassword.fire(y)}get(y,_){return this._proxy.$getPassword(y,_)}store(y,_,k){return this._proxy.$setPassword(y,_,k)}delete(y,_){return this._proxy.$deletePassword(y,_)}}e.ExtHostSecretState=E,e.IExtHostSecretState=D.createDecorator("IExtHostSecretState")}),define(we[70],_e([0,1,5,17,4,14]),function(Z,e,g,T,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=g.createDecorator("IExtHostApiDeprecationService");let C=class{constructor(_,k){this._extHostLogService=k,this._reportedUsages=new Set,this._telemetryShape=_.getProxy(D.MainContext.MainThreadTelemetry)}report(_,k,n){const I=this.getUsageKey(_,k);this._reportedUsages.has(I)||(this._reportedUsages.add(I),k.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${_}' is deprecated. ${n}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:k.identifier.value,apiId:_}))}getUsageKey(_,k){return`${_}-${k.identifier.value}`}};C=He([ze(0,E.IExtHostRpcService),ze(1,T.ILogService)],C),e.ExtHostApiDeprecationService=C,e.NullApiDeprecationService=Object.freeze(new class{report(y,_,k){}})}),define(we[175],_e([0,1,3,4,6,26]),function(Z,e,g,T,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class C{constructor(_){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeAuthenticationProviders=new g.Emitter,this.onDidChangeAuthenticationProviders=this._onDidChangeAuthenticationProviders.event,this._onDidChangeSessions=new g.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=_.getProxy(T.MainContext.MainThreadAuthentication)}$setProviders(_){return this._providers=_,Promise.resolve()}get providers(){return Object.freeze(this._providers.slice())}async getSession(_,k,n,I={}){const o=E.ExtensionIdentifier.toKey(_.identifier),h=this._inFlightRequests.get(o)||[],d=[...n].sort().join(" ");let u=h.find(w=>w.scopes===d);if(u)return u.result;{const w=this._getSession(_,o,k,n,I);u={scopes:d,result:w},h.push(u),this._inFlightRequests.set(o,h);try{await w}finally{const v=h.findIndex(S=>S.scopes===d);v>-1&&(h.splice(v),this._inFlightRequests.set(o,h))}return w}}async _getSession(_,k,n,I,o={}){await this._proxy.$ensureProvider(n);const h=_.displayName||_.name;return this._proxy.$getSession(n,I,k,h,o)}async removeSession(_,k){const n=this._authenticationProviders.get(_);return n?n.provider.removeSession(k):this._proxy.$removeSession(_,k)}registerAuthenticationProvider(_,k,n,I){var o;if(this._authenticationProviders.get(_))throw new Error(`An authentication provider with id '${_}' is already registered.`);this._authenticationProviders.set(_,{label:k,provider:n,options:I??{supportsMultipleAccounts:!1}}),this._providers.find(d=>d.id===_)||this._providers.push({id:_,label:k});const h=n.onDidChangeSessions(d=>{var u,w,v;this._proxy.$sendDidChangeSessions(_,{added:(u=d.added)!==null&&u!==void 0?u:[],changed:(w=d.changed)!==null&&w!==void 0?w:[],removed:(v=d.removed)!==null&&v!==void 0?v:[]})});return this._proxy.$registerAuthenticationProvider(_,k,(o=I==null?void 0:I.supportsMultipleAccounts)!==null&&o!==void 0?o:!1),new D.Disposable(()=>{h.dispose(),this._authenticationProviders.delete(_);const d=this._providers.findIndex(u=>u.id===_);d>-1&&this._providers.splice(d),this._proxy.$unregisterAuthenticationProvider(_)})}$createSession(_,k){const n=this._authenticationProviders.get(_);if(n)return Promise.resolve(n.provider.createSession(k));throw new Error(`Unable to find authentication provider with handle: ${_}`)}$removeSession(_,k){const n=this._authenticationProviders.get(_);if(n)return Promise.resolve(n.provider.removeSession(k));throw new Error(`Unable to find authentication provider with handle: ${_}`)}$getSessions(_,k){const n=this._authenticationProviders.get(_);if(n)return Promise.resolve(n.provider.getSessions(k));throw new Error(`Unable to find authentication provider with handle: ${_}`)}$onDidChangeAuthenticationSessions(_,k){return this._onDidChangeSessions.fire({provider:{id:_,label:k}}),Promise.resolve()}$onDidChangeAuthenticationProviders(_,k){return _.forEach(n=>{this._providers.some(I=>I.id===n.id)||this._providers.push(n)}),k.forEach(n=>{const I=this._providers.findIndex(o=>o.id===n.id);I>-1&&this._providers.splice(I)}),this._onDidChangeAuthenticationProviders.fire({added:_,removed:k}),Promise.resolve()}}e.ExtHostAuthentication=C}),define(we[176],_e([0,1,4,14,9]),function(Z,e,g,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let E=class{constructor(y,_){this._extHostDocumentsAndEditors=_,this._proxy=y.getProxy(g.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(y){const _=D.WorkspaceEdit.from(y,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(_)}};E=He([ze(0,T.IExtHostRpcService)],E),e.ExtHostBulkEdits=E}),define(we[177],_e([0,1,4]),function(Z,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class T{constructor(E){const C=E.getProxy(g.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return C.$readText()},writeText(y){return C.$writeText(y)}})}}e.ExtHostClipboard=T}),define(we[71],_e([0,1,10,6,9,24,4,16,17,54,31,35,2,7,5,14]),function(Z,e,g,T,D,E,C,y,_,k,n,I,o,h,d,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let w=class{constructor(t,r){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(C.MainContext.MainThreadCommands),this._logService=r,this.converter=new v(this,i=>{const s=this._apiCommands.get(i);return(s==null?void 0:s.result)===c.Void?s:void 0},r),this._argumentProcessors=[{processArgument(i){return k.revive(i)}},{processArgument(i){return E.cloneAndChange(i,function(s){if(n.Range.isIRange(s))return D.Range.to(s);if(I.Position.isIPosition(s))return D.Position.to(s);if(n.Range.isIRange(s.range)&&o.URI.isUri(s.uri))return D.location.to(s);if(!Array.isArray(s))return s})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const r=this.registerCommand(!1,t.id,async(...i)=>{const s=t.args.map((b,p)=>{if(!b.validate(i[p]))throw new Error(`Invalid argument '${b.name}' when running '${t.id}', received: ${i[p]}`);return b.convert(i[p])}),l=await this.executeCommand(t.internalId,...s);return t.result.convert(l,i,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new T.Disposable(()=>{r.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,r,i,s,l){if(this._logService.trace("ExtHostCommands#registerCommand",r),!r.trim().length)throw new Error("invalid id");if(this._commands.has(r))throw new Error(`command '${r}' already exists`);return this._commands.set(r,{callback:i,thisArg:s,description:l}),t&&this._proxy.$registerCommand(r),new T.Disposable(()=>{this._commands.delete(r)&&t&&this._proxy.$unregisterCommand(r)})}executeCommand(t,...r){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,r,!0)}async _doExecuteCommand(t,r,i){if(this._commands.has(t))return this._executeContributedCommand(t,r);{const s=E.cloneAndChange(r,function(l){if(l instanceof T.Position)return D.Position.from(l);if(l instanceof T.Range)return D.Range.from(l);if(l instanceof T.Location)return D.location.from(l);if(T.NotebookRange.isNotebookRange(l))return D.NotebookRange.from(l);if(!Array.isArray(l))return l});try{const l=await this._proxy.$executeCommand(t,s,i);return k.revive(l)}catch(l){if(l instanceof Error&&l.message==="$executeCommand:retry")return this._doExecuteCommand(t,r,!1);throw l}}}async _executeContributedCommand(t,r){const i=this._commands.get(t);if(!i)throw new Error("Unknown command");let{callback:s,thisArg:l,description:b}=i;if(b)for(let p=0;p<b.args.length;p++)try{g.validateConstraint(r[p],b.args[p].constraint)}catch(P){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${b.args[p].name}' - ${b.args[p].description}`)}try{return await s.apply(l,r)}catch(p){if(t===this.converter.delegatingCommandId){const P=this.converter.getActualCommand(...r);P&&(t=P.command)}throw this._logService.error(p,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...r){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(r=r.map(i=>this._argumentProcessors.reduce((s,l)=>l.processArgument(s),i)),this._executeContributedCommand(t,r)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(r=>(t&&(r=r.filter(i=>i[0]!=="_")),r))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[r,i]of this._commands){let{description:s}=i;s&&(t[r]=s)}return Promise.resolve(t)}};w=He([ze(0,u.IExtHostRpcService),ze(1,_.ILogService)],w),e.ExtHostCommands=w,e.IExtHostCommands=d.createDecorator("IExtHostCommands");class v{constructor(t,r,i){this._commands=t,this._lookupApiCommand=r,this._logService=i,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,r){if(!t)return;const i={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return i;const s=this._lookupApiCommand(t.command);if(s)i.id=s.internalId,i.arguments=s.args.map((l,b)=>l.convert(t.arguments&&t.arguments[b]));else if(y.isNonEmptyArray(t.arguments)){const l=++this._cachIdPool;this._cache.set(l,t),r.add(h.toDisposable(()=>{this._cache.delete(l),this._logService.trace("CommandsConverter#DISPOSE",l)})),i.$ident=l,i.id=this.delegatingCommandId,i.arguments=[l],this._logService.trace("CommandsConverter#CREATE",t.command,l)}return i}fromInternal(t){const r=C.ObjectIdentifier.of(t);return typeof r=="number"?this._cache.get(r):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const r=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],r?r.command:"MISSING"),r?this._commands.executeCommand(r.command,...r.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=v;class S{constructor(t,r,i,s){this.name=t,this.description=r,this.validate=i,this.convert=s}optional(){return new S(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,r){return new S(t??this.name,r??this.description,this.validate,this.convert)}}e.ApiCommandArgument=S,S.Uri=new S("uri","Uri of a text document",f=>o.URI.isUri(f),f=>f),S.Position=new S("position","A position in a text document",f=>T.Position.isPosition(f),D.Position.from),S.Range=new S("range","A range in a text document",f=>T.Range.isRange(f),D.Range.from),S.Selection=new S("selection","A selection in a text document",f=>T.Selection.isSelection(f),D.Selection.from),S.Number=new S("number","",f=>typeof f=="number",f=>f),S.String=new S("string","",f=>typeof f=="string",f=>f),S.CallHierarchyItem=new S("item","A call hierarchy item",f=>f instanceof T.CallHierarchyItem,D.CallHierarchyItem.to);class c{constructor(t,r){this.description=t,this.convert=r}}e.ApiCommandResult=c,c.Void=new c("no result",f=>f);class m{constructor(t,r,i,s,l){this.id=t,this.internalId=r,this.description=i,this.args=s,this.result=l}}e.ApiCommand=m}),define(we[178],_e([0,1,9,6,58,71,16,85]),function(Z,e,g,T,D,E,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const _=[new E.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",n(g.DocumentHighlight.to))),new E.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[E.ApiCommandArgument.Uri],new E.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(o,h)=>{if(C.isFalsyOrEmpty(o))return;class d extends T.SymbolInformation{static to(w){const v=new d(w.name,g.SymbolKind.to(w.kind),w.containerName||"",new T.Location(h[0],g.Range.to(w.range)));return v.detail=w.detail,v.range=v.location.range,v.selectionRange=g.Range.to(w.selectionRange),v.children=w.children?w.children.map(d.to):[],v}}return o.map(d.to)})),new E.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[E.ApiCommandArgument.Uri,new E.ApiCommandArgument("options","Formatting options",o=>!0,o=>o)],new E.ApiCommandResult("A promise that resolves to an array of TextEdits.",n(g.TextEdit.to))),new E.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Range,new E.ApiCommandArgument("options","Formatting options",o=>!0,o=>o)],new E.ApiCommandResult("A promise that resolves to an array of TextEdits.",n(g.TextEdit.to))),new E.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position,new E.ApiCommandArgument("ch","Trigger character",o=>typeof o=="string",o=>o),new E.ApiCommandArgument("options","Formatting options",o=>!0,o=>o)],new E.ApiCommandResult("A promise that resolves to an array of TextEdits.",n(g.TextEdit.to))),new E.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new E.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new E.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new E.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new E.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Location-instances.",n(g.location.to))),new E.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Hover-instances.",n(g.Hover.to))),new E.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[E.ApiCommandArgument.Uri,new E.ApiCommandArgument("position","A position in a text document",o=>Array.isArray(o)&&o.every(h=>T.Position.isPosition(h)),o=>o.map(g.Position.from))],new E.ApiCommandResult("A promise that resolves to an array of ranges.",o=>o.map(h=>{let d;for(const u of h.reverse())d=new T.SelectionRange(g.Range.to(u),d);return d}))),new E.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[E.ApiCommandArgument.String.with("query","Search string")],new E.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",o=>{const h=[];if(Array.isArray(o))for(let d of o)h.push(...d[1].map(g.WorkspaceSymbol.to));return h})),new E.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A CallHierarchyItem or undefined",o=>o.map(g.CallHierarchyItem.to))),new E.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[E.ApiCommandArgument.CallHierarchyItem],new E.ApiCommandResult("A CallHierarchyItem or undefined",o=>o.map(g.CallHierarchyIncomingCall.to))),new E.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[E.ApiCommandArgument.CallHierarchyItem],new E.ApiCommandResult("A CallHierarchyItem or undefined",o=>o.map(g.CallHierarchyOutgoingCall.to))),new E.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position,E.ApiCommandArgument.String.with("newName","The new symbol name")],new E.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",o=>{if(!!o){if(o.rejectReason)throw new Error(o.rejectReason);return g.WorkspaceEdit.to(o)}})),new E.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new E.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",o=>o.map(g.DocumentLink.to))),new E.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[E.ApiCommandArgument.Uri],new E.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",o=>{if(!!o)return new T.SemanticTokensLegend(o.tokenTypes,o.tokenModifiers)})),new E.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[E.ApiCommandArgument.Uri],new E.ApiCommandResult("A promise that resolves to SemanticTokens.",o=>{if(!o)return;const h=y.decodeSemanticTokensDto(o);if(h.type==="full")return new T.SemanticTokens(h.data,void 0)})),new E.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[E.ApiCommandArgument.Uri],new E.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",o=>{if(!!o)return new T.SemanticTokensLegend(o.tokenTypes,o.tokenModifiers)})),new E.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Range],new E.ApiCommandResult("A promise that resolves to SemanticTokens.",o=>{if(!o)return;const h=y.decodeSemanticTokensDto(o);if(h.type==="full")return new T.SemanticTokens(h.data,void 0)})),new E.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position,E.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),E.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new E.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(o,h,d)=>{if(!o)return new T.CompletionList([]);const u=o.suggestions.map(w=>g.CompletionItem.to(w,d));return new T.CompletionList(u,o.incomplete)})),new E.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position,E.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new E.ApiCommandResult("A promise that resolves to SignatureHelp.",o=>{if(o)return g.SignatureHelp.to(o)})),new E.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new E.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(o,h,d)=>n(u=>new T.CodeLens(g.Range.to(u.range),u.command&&d.fromInternal(u.command)))(o))),new E.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[E.ApiCommandArgument.Uri,new E.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",o=>T.Range.isRange(o),o=>T.Selection.isSelection(o)?g.Selection.from(o):g.Range.from(o)),E.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),E.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new E.ApiCommandResult("A promise that resolves to an array of Command-instances.",(o,h,d)=>n(u=>{if(u._isSynthetic){if(!u.command)throw new Error("Synthetic code actions must have a command");return d.fromInternal(u.command)}else{const w=new T.CodeAction(u.title,u.kind?new T.CodeActionKind(u.kind):void 0);return u.edit&&(w.edit=g.WorkspaceEdit.to(u.edit)),u.command&&(w.command=d.fromInternal(u.command)),w.isPreferred=u.isPreferred,w}})(o))),new E.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[E.ApiCommandArgument.Uri],new E.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",o=>o?o.map(h=>new T.ColorInformation(g.Range.to(h.range),g.Color.to(h.color))):[])),new E.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new E.ApiCommandArgument("color","The color to show and insert",o=>o instanceof T.Color,g.Color.from),new E.ApiCommandArgument("context","Context object with uri and range",o=>!0,o=>({uri:o.uri,range:g.Range.from(o.range)}))],new E.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",o=>o?o.map(g.ColorPresentation.to):[])),new E.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inline hints provider",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Range],new E.ApiCommandResult("A promise that resolves to an array of Inlay objects",o=>o.map(g.InlayHint.to))),new E.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new E.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",n(o=>({viewType:o.viewType,displayName:o.displayName,options:{transientOutputs:o.options.transientOutputs,transientCellMetadata:o.options.transientCellMetadata,transientDocumentMetadata:o.options.transientDocumentMetadata},filenamePattern:o.filenamePattern.map(h=>g.NotebookExclusiveDocumentPattern.to(h))})))),new E.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Range],new E.ApiCommandResult("A promise that resolves to an array of InlineValue objects",o=>o.map(g.InlineValue.to))),new E.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[E.ApiCommandArgument.Uri,new E.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",o=>o===void 0||typeof o=="number"||typeof o=="object",o=>o&&(typeof o=="number"?[o,void 0]:[g.ViewColumn.from(o.viewColumn),g.TextEditorOpenOptions.from(o)])).optional(),E.ApiCommandArgument.String.with("label","").optional()],E.ApiCommandResult.Void),new E.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[E.ApiCommandArgument.Uri.with("resource","Resource to open"),E.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new E.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",o=>o===void 0||typeof o=="number"||typeof o=="object",o=>o&&(typeof o=="number"?[o,void 0]:[g.ViewColumn.from(o.viewColumn),g.TextEditorOpenOptions.from(o)])).optional()],E.ApiCommandResult.Void),new E.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[E.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),E.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),E.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new E.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",o=>o===void 0||typeof o=="object",o=>o&&[g.ViewColumn.from(o.viewColumn),g.TextEditorOpenOptions.from(o)]).optional()],E.ApiCommandResult.Void)];class k{static register(h){_.forEach(h.registerApiCommand,h)}}e.ExtHostApiCommands=k;function n(o){return h=>{if(Array.isArray(h))return h.map(o)}}function I(o){if(!Array.isArray(o))return;const h=[];for(const d of o)D.isLocationLink(d)?h.push(g.DefinitionLink.to(d)):h.push(g.location.to(d));return h}}),define(we[179],_e([0,1,11,47,3,7,2,58,26,9,6,4]),function(Z,e,g,T,D,E,C,y,_,k,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCommentThread=e.ExtHostComments=void 0;class o{constructor(m,f,t){this._documents=t,this._commentControllers=new Map,this._commentControllersByExtension=new Map,this._proxy=m.getProxy(I.MainContext.MainThreadComments),f.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===6){const i=this._commentControllers.get(r.handle);return i||r}else if(r&&r.$mid===7){const i=this._commentControllers.get(r.commentControlHandle);if(!i)return r;const s=i.getCommentThread(r.commentThreadHandle);return s||r}else if(r&&r.$mid===8){const i=this._commentControllers.get(r.thread.commentControlHandle);if(!i)return r;const s=i.getCommentThread(r.thread.commentThreadHandle);return s?{thread:s,text:r.text}:r}else if(r&&r.$mid===9){const i=this._commentControllers.get(r.thread.commentControlHandle);if(!i)return r;const s=i.getCommentThread(r.thread.commentThreadHandle);if(!s)return r;let l=r.commentUniqueId,b=s.getCommentByUniqueId(l);return b||r}else if(r&&r.$mid===10){const i=this._commentControllers.get(r.thread.commentControlHandle);if(!i)return r;const s=i.getCommentThread(r.thread.commentThreadHandle);if(!s)return r;let l=r.text,b=r.commentUniqueId,p=s.getCommentByUniqueId(b);return p?(p.body=l,p):r}return r}})}createCommentController(m,f,t){const r=o.handlePool++,i=new d(m,r,this._proxy,f,t);this._commentControllers.set(i.handle,i);const s=this._commentControllersByExtension.get(_.ExtensionIdentifier.toKey(m.identifier))||[];return s.push(i),this._commentControllersByExtension.set(_.ExtensionIdentifier.toKey(m.identifier),s),i}$createCommentThreadTemplate(m,f,t){const r=this._commentControllers.get(m);!r||r.$createCommentThreadTemplate(f,t)}async $updateCommentThreadTemplate(m,f,t){const r=this._commentControllers.get(m);!r||r.$updateCommentThreadTemplate(f,t)}$deleteCommentThread(m,f){const t=this._commentControllers.get(m);t&&t.$deleteCommentThread(f)}$provideCommentingRanges(m,f,t){const r=this._commentControllers.get(m);if(!r||!r.commentingRangeProvider)return Promise.resolve(void 0);const i=this._documents.getDocument(C.URI.revive(f));return g.asPromise(()=>r.commentingRangeProvider.provideCommentingRanges(i,t)).then(s=>s?s.map(l=>k.Range.from(l)):void 0)}$toggleReaction(m,f,t,r,i){const s=this._commentControllers.get(m);return!s||!s.reactionHandler?Promise.resolve(void 0):g.asPromise(()=>{const l=s.getCommentThread(f);if(l){const b=l.getCommentByUniqueId(r.uniqueIdInThread);if(s!==void 0&&b&&s.reactionHandler)return s.reactionHandler(b,v(i))}return Promise.resolve(void 0)})}dispose(){}}e.ExtHostComments=o,o.handlePool=0;class h{constructor(m,f,t,r,i,s,l){this._proxy=m,this._commentController=f,this._id=t,this._uri=r,this._range=i,this._comments=s,this.handle=h._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new D.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new E.MutableDisposable,this._acceptInputDisposables.value=new E.DisposableStore,this._id===void 0&&(this._id=`${f.id}.${this.handle}`),this._proxy.$createCommentThread(this._commentController.handle,this.handle,this._id,this._uri,k.Range.from(this._range),l),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=s}set threadId(m){this._id=m}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(m){m.isEqual(this._range)||(this._range=m,this.modifications.range=m,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(m){this._canReply!==m&&(this._canReply=m,this.modifications.canReply=m,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(m){this._label=m,this.modifications.label=m,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(m){this._contextValue=m,this.modifications.contextValue=m,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(m){this._comments=m,this.modifications.comments=m,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(m){this._collapseState=m,this.modifications.collapsibleState=m,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new E.DisposableStore);const m=t=>Object.prototype.hasOwnProperty.call(this.modifications,t),f={};m("range")&&(f.range=k.Range.from(this._range)),m("label")&&(f.label=this.label),m("contextValue")&&(f.contextValue=this.contextValue),m("comments")&&(f.comments=this._comments.map(t=>u(this,this._commentController,t,this._commentsMap))),m("collapsibleState")&&(f.collapseState=S(this._collapseState)),m("canReply")&&(f.canReply=this.canReply),this.modifications={},this._proxy.$updateCommentThread(this._commentController.handle,this.handle,this._id,this._uri,f)}getCommentByUniqueId(m){for(let f of this._commentsMap){let t=f[0],r=f[1];if(m===r)return t}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(m=>m.dispose()),this._proxy.$deleteCommentThread(this._commentController.handle,this.handle)}}h._handlePool=0,He([T.debounce(100)],h.prototype,"eventuallyUpdateCommentThread",null),e.ExtHostCommentThread=h;class d{constructor(m,f,t,r,i){this._extension=m,this._handle=f,this._proxy=t,this._id=r,this._label=i,this._threads=new Map,this._proxy.$registerCommentController(this.handle,r,i)}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(m){this._reactionHandler=m,this._proxy.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!m})}get options(){return this._options}set options(m){this._options=m,this._proxy.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(m,f,t,r){if(typeof m=="string"){const i=new h(this._proxy,this,m,f,t,r,this._extension.identifier);return this._threads.set(i.handle,i),i}else{const i=new h(this._proxy,this,void 0,m,f,t,this._extension.identifier);return this._threads.set(i.handle,i),i}}$createCommentThreadTemplate(m,f){const t=new h(this._proxy,this,void 0,C.URI.revive(m),k.Range.to(f),[],this._extension.identifier);return t.collapsibleState=y.CommentThreadCollapsibleState.Expanded,this._threads.set(t.handle,t),t}$updateCommentThreadTemplate(m,f){let t=this._threads.get(m);t&&(t.range=k.Range.to(f))}$deleteCommentThread(m){let f=this._threads.get(m);f&&f.dispose(),this._threads.delete(m)}getCommentThread(m){return this._threads.get(m)}dispose(){this._threads.forEach(m=>{m.dispose()}),this._proxy.$unregisterCommentController(this.handle)}}function u(c,m,f,t){let r=t.get(f);r||(r=++c.commentHandle,t.set(f,r));const i=f.author&&f.author.iconPath?f.author.iconPath.toString():void 0;return{mode:f.mode,contextValue:f.contextValue,uniqueIdInThread:r,body:k.MarkdownString.from(f.body),userName:f.author.name,userIconPath:i,label:f.label,commentReactions:f.reactions?f.reactions.map(s=>w(s)):void 0}}function w(c){return{label:c.label,iconPath:c.iconPath?k.pathOrURIToURI(c.iconPath):void 0,count:c.count,hasReacted:c.authorHasReacted}}function v(c){return{label:c.label||"",count:c.count||0,iconPath:c.iconPath?C.URI.revive(c.iconPath):"",authorHasReacted:c.hasReacted||!1}}function S(c){if(c!==void 0)switch(c){case n.CommentThreadCollapsibleState.Expanded:return y.CommentThreadCollapsibleState.Expanded;case n.CommentThreadCollapsibleState.Collapsed:return y.CommentThreadCollapsibleState.Collapsed}return y.CommentThreadCollapsibleState.Collapsed}}),define(we[98],_e([0,1,2,4,6,5,14,17,16,8,13]),function(Z,e,g,T,D,E,C,y,_,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let I=class vn{constructor(h,d){this._logService=d,this._provider=new Map,this._proxy=h.getProxy(T.MainContext.MainThreadDecorations)}registerFileDecorationProvider(h,d){const u=vn._handlePool++;this._provider.set(u,{provider:h,extensionId:d}),this._proxy.$registerDecorationProvider(u,d.value);const w=h.onDidChangeFileDecorations&&h.onDidChangeFileDecorations(v=>{if(!v){this._proxy.$onDidChange(u,null);return}let S=_.asArray(v);if(S.length<=vn._maxEventSize){this._proxy.$onDidChange(u,S);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",d.value,S.length);const c=S.map(t=>({uri:t,rank:k.count(t.path,"/")})),m=_.groupBy(c,(t,r)=>t.rank-r.rank||k.compare(t.uri.path,r.uri.path));let f=[];e:for(let t of m){let r;for(let i of t){let s=n.dirname(i.uri.path);if(r!==s&&(r=s,f.push(i.uri)>=vn._maxEventSize))break e}}this._proxy.$onDidChange(u,f)});return new D.Disposable(()=>{w==null||w.dispose(),this._proxy.$unregisterDecorationProvider(u),this._provider.delete(u)})}async $provideDecorations(h,d,u){if(!this._provider.has(h))return Object.create(null);const w=Object.create(null),{provider:v,extensionId:S}=this._provider.get(h);return await Promise.all(d.map(async c=>{try{const{uri:m,id:f}=c,t=await Promise.resolve(v.provideFileDecoration(g.URI.revive(m),u));if(!t)return;try{D.FileDecoration.validate(t),w[f]=[t.propagate,t.tooltip,t.badge,t.color]}catch(r){this._logService.warn(`INVALID decoration from extension '${S.value}': ${r}`)}}catch(m){this._logService.error(m)}})),w}};I._handlePool=0,I._maxEventSize=250,I=He([ze(0,C.IExtHostRpcService),ze(1,y.ILogService)],I),e.ExtHostDecorations=I,e.IExtHostDecorations=E.createDecorator("IExtHostDecorations")}),define(we[180],_e([0,1,127,89,2,4,6,9,3,17,22]),function(Z,e,g,T,D,E,C,y,_,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class I{constructor(d,u,w,v,S){this._name=d,this._owner=u,this._maxDiagnosticsPerFile=w,this._proxy=v,this._onDidChangeDiagnostics=S,this._isDisposed=!1,this._data=new n.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(d,u){if(!d){this.clear();return}this._checkDisposed();let w=[];if(D.URI.isUri(d)){if(!u){this.delete(d);return}this._data.set(d,u.slice()),w=[d]}else if(Array.isArray(d)){w=[];let S;d=[...d].sort(I._compareIndexedTuplesByUri);for(const c of d){const[m,f]=c;if((!S||m.toString()!==S.toString())&&(S&&this._data.get(S).length===0&&this._data.delete(S),S=m,w.push(m),this._data.set(m,[])),f){const t=this._data.get(m);t&&t.push(...f)}else{const t=this._data.get(m);t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(w),!this._proxy)return;const v=[];for(let S of w){let c=[];const m=this._data.get(S);if(m)if(m.length>this._maxDiagnosticsPerFile){c=[];const f=[C.DiagnosticSeverity.Error,C.DiagnosticSeverity.Warning,C.DiagnosticSeverity.Information,C.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let r of m)if(r.severity===f[t]&&c.push(y.Diagnostic.from(r))===this._maxDiagnosticsPerFile)break e;c.push({severity:T.MarkerSeverity.Info,message:g.localize(0,null,m.length-this._maxDiagnosticsPerFile),startLineNumber:c[c.length-1].startLineNumber,startColumn:c[c.length-1].startColumn,endLineNumber:c[c.length-1].endLineNumber,endColumn:c[c.length-1].endColumn})}else c=m.map(f=>y.Diagnostic.from(f));v.push([S,c])}this._proxy.$changeMany(this._owner,v)}delete(d){this._checkDisposed(),this._onDidChangeDiagnostics.fire([d]),this._data.delete(d),this._proxy&&this._proxy.$changeMany(this._owner,[[d,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(d,u){this._checkDisposed();for(let w of this._data.keys())d.apply(u,[w,this.get(w),this])}get(d){this._checkDisposed();const u=this._data.get(d);return Array.isArray(u)?Object.freeze(u.slice(0)):[]}has(d){return this._checkDisposed(),Array.isArray(this._data.get(d))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(d,u){return d[0].toString()<u[0].toString()?-1:d[0].toString()>u[0].toString()?1:0}}e.DiagnosticCollection=I;let o=class zt{constructor(d,u){this._logService=u,this._collections=new Map,this._onDidChangeDiagnostics=new _.Emitter,this.onDidChangeDiagnostics=_.Event.map(_.Event.debounce(this._onDidChangeDiagnostics.event,zt._debouncer,50),zt._mapper),this._proxy=d.getProxy(E.MainContext.MainThreadDiagnostics)}static _debouncer(d,u){return d?d.concat(u):u}static _mapper(d){const u=new n.ResourceMap;for(const w of d)u.set(w,w);return{uris:Object.freeze(Array.from(u.values()))}}createDiagnosticCollection(d,u){const{_collections:w,_proxy:v,_onDidChangeDiagnostics:S,_logService:c}=this,m=new class{$changeMany(r,i){v.$changeMany(r,i),c.trace("[DiagnosticCollection] change many (extension, owner, uris)",d.value,r,i.length===0?"CLEARING":i)}$clear(r){v.$clear(r),c.trace("[DiagnosticCollection] remove all (extension, owner)",d.value,r)}dispose(){v.dispose()}};let f;if(!u)u="_generated_diagnostic_collection_name_#"+zt._idPool++,f=u;else if(!w.has(u))f=u;else{this._logService.warn(`DiagnosticCollection with name '${u}' does already exist.`);do f=u+zt._idPool++;while(w.has(f))}return new class extends I{constructor(){super(u,f,zt._maxDiagnosticsPerFile,m,S);w.set(f,this)}dispose(){super.dispose(),w.delete(f)}}}getDiagnostics(d){if(d)return this._getDiagnostics(d);{const u=new Map,w=[];for(const v of this._collections.values())v.forEach((S,c)=>{let m=u.get(S.toString());typeof m=="undefined"&&(m=w.length,u.set(S.toString(),m),w.push([S,[]])),w[m][1]=w[m][1].concat(...c)});return w}}_getDiagnostics(d){let u=[];for(let w of this._collections.values())w.has(d)&&(u=u.concat(w.get(d)));return u}$acceptMarkersChange(d){if(!this._mirrorCollection){const u="_generated_mirror",w=new I(u,u,zt._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(u,w),this._mirrorCollection=w}for(const[u,w]of d)this._mirrorCollection.set(D.URI.revive(u),w.map(y.Diagnostic.to))}};o._idPool=0,o._maxDiagnosticsPerFile=1e3,o=He([ze(1,k.ILogService)],o),e.ExtHostDiagnostics=o}),define(we[181],_e([0,1,2,4]),function(Z,e,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class D{constructor(C){this._proxy=C.getProxy(T.MainContext.MainThreadDialogs)}showOpenDialog(C){return this._proxy.$showOpenDialog(C).then(y=>y?y.map(_=>g.URI.revive(_)):void 0)}showSaveDialog(C){return this._proxy.$showSaveDialog(C).then(y=>y?g.URI.revive(y):void 0)}}e.ExtHostDialogs=D}),define(we[182],_e([0,1,12,2,6,4,15,18,8]),function(Z,e,g,T,D,E,C,y,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class k{constructor(I,o,h){this._documentsAndEditors=o,this._logService=h,this._documentContentProviders=new Map,this._proxy=I.getProxy(E.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(I,o){if(Object.keys(C.Schemas).indexOf(I)>=0)throw new Error(`scheme '${I}' already registered`);const h=k._handlePool++;this._documentContentProviders.set(h,o),this._proxy.$registerTextContentProvider(h,I);let d;return typeof o.onDidChange=="function"&&(d=o.onDidChange(u=>{if(u.scheme!==I){this._logService.warn(`Provider for scheme '${I}' is firing event for schema '${u.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(u)&&this.$provideTextDocumentContent(h,u).then(w=>{if(!w&&typeof w!="string")return;const v=this._documentsAndEditors.getDocument(u);if(!v)return;const S=_.splitLines(w);if(!v.equalLines(S))return this._proxy.$onVirtualDocumentChange(u,w)},g.onUnexpectedError)})),new D.Disposable(()=>{this._documentContentProviders.delete(h)&&this._proxy.$unregisterTextContentProvider(h),d&&(d.dispose(),d=void 0)})}$provideTextDocumentContent(I,o){const h=this._documentContentProviders.get(I);return h?Promise.resolve(h.provideTextDocumentContent(T.URI.revive(o),y.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${o.scheme}`))}}e.ExtHostDocumentContentProvider=k,k._handlePool=0}),define(we[183],_e([0,1,3,7,2,4,93,9,10,24]),function(Z,e,g,T,D,E,C,y,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class n{constructor(o,h){this._onDidAddDocument=new g.Emitter,this._onDidRemoveDocument=new g.Emitter,this._onDidChangeDocument=new g.Emitter,this._onDidSaveDocument=new g.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new T.DisposableStore,this._documentLoader=new Map,this._proxy=o.getProxy(E.MainContext.MainThreadDocuments),this._documentsAndEditors=h,this._documentsAndEditors.onDidRemoveDocuments(d=>{for(const u of d)this._onDidRemoveDocument.fire(u.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(d=>{for(const u of d)this._onDidAddDocument.fire(u.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(o){if(!o)return;const h=this._documentsAndEditors.getDocument(o);if(h)return h}getDocument(o){const h=this.getDocumentData(o);if(!(h==null?void 0:h.document))throw new Error(`Unable to retrieve document from URI '${o}'`);return h.document}ensureDocumentData(o){const h=this._documentsAndEditors.getDocument(o);if(h)return Promise.resolve(h);let d=this._documentLoader.get(o.toString());return d||(d=this._proxy.$tryOpenDocument(o).then(u=>{this._documentLoader.delete(o.toString());const w=D.URI.revive(u);return _.assertIsDefined(this._documentsAndEditors.getDocument(w))},u=>(this._documentLoader.delete(o.toString()),Promise.reject(u))),this._documentLoader.set(o.toString(),d)),d}createDocumentData(o){return this._proxy.$tryCreateDocument(o).then(h=>D.URI.revive(h))}$acceptModelModeChanged(o,h){const d=D.URI.revive(o),u=this._documentsAndEditors.getDocument(d);if(!u)throw new Error("unknown document");this._onDidRemoveDocument.fire(u.document),u._acceptLanguageId(h),this._onDidAddDocument.fire(u.document)}$acceptModelSaved(o){const h=D.URI.revive(o),d=this._documentsAndEditors.getDocument(h);if(!d)throw new Error("unknown document");this.$acceptDirtyStateChanged(o,!1),this._onDidSaveDocument.fire(d.document)}$acceptDirtyStateChanged(o,h){const d=D.URI.revive(o),u=this._documentsAndEditors.getDocument(d);if(!u)throw new Error("unknown document");u._acceptIsDirty(h),this._onDidChangeDocument.fire({document:u.document,contentChanges:[]})}$acceptModelChanged(o,h,d){const u=D.URI.revive(o),w=this._documentsAndEditors.getDocument(u);if(!w)throw new Error("unknown document");w._acceptIsDirty(d),w.onEvents(h),this._onDidChangeDocument.fire(k.deepFreeze({document:w.document,contentChanges:h.changes.map(v=>({range:y.Range.to(v.range),rangeOffset:v.rangeOffset,rangeLength:v.rangeLength,text:v.text}))}))}setWordDefinitionFor(o,h){C.setWordDefinitionFor(o,h)}}e.ExtHostDocuments=n}),define(we[36],_e([0,1,39,3,7,2,5,4,93,14,96,9,17,22,15,50,106]),function(Z,e,g,T,D,E,C,y,_,k,n,I,o,h,d,u,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class v{constructor(m){this.value=m,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let S=class{constructor(m,f){this._extHostRpc=m,this._logService=f,this._activeEditorId=null,this._editors=new Map,this._documents=new h.ResourceMap,this._onDidAddDocuments=new T.Emitter,this._onDidRemoveDocuments=new T.Emitter,this._onDidChangeVisibleTextEditors=new T.Emitter,this._onDidChangeActiveTextEditor=new T.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(m){this.acceptDocumentsAndEditorsDelta(m)}acceptDocumentsAndEditorsDelta(m){const f=[],t=[],r=[];if(m.removedDocuments)for(const i of m.removedDocuments){const s=E.URI.revive(i),l=this._documents.get(s);(l==null?void 0:l.unref())&&(this._documents.delete(s),f.push(l.value))}if(m.addedDocuments)for(const i of m.addedDocuments){const s=E.URI.revive(i.uri);let l=this._documents.get(s);if(l&&s.scheme!==d.Schemas.vscodeNotebookCell)throw new Error(`document '${s} already exists!'`);l||(l=new v(new _.ExtHostDocumentData(this._extHostRpc.getProxy(y.MainContext.MainThreadDocuments),s,i.lines,i.EOL,i.versionId,i.modeId,i.isDirty,i.notebook)),this._documents.set(s,l),t.push(l.value)),l.ref()}if(m.removedEditors)for(const i of m.removedEditors){const s=this._editors.get(i);this._editors.delete(i),s&&r.push(s)}if(m.addedEditors)for(const i of m.addedEditors){const s=E.URI.revive(i.documentUri);g.ok(this._documents.has(s),`document '${s}' does not exist`),g.ok(!this._editors.has(i.id),`editor '${i.id}' already exists!`);const l=this._documents.get(s).value,b=new n.ExtHostTextEditor(i.id,this._extHostRpc.getProxy(y.MainContext.MainThreadTextEditors),this._logService,new w.Lazy(()=>l.document),i.selections.map(I.Selection.to),i.options,i.visibleRanges.map(p=>I.Range.to(p)),typeof i.editorPosition=="number"?I.ViewColumn.to(i.editorPosition):void 0);this._editors.set(i.id,b)}m.newActiveEditor!==void 0&&(g.ok(m.newActiveEditor===null||this._editors.has(m.newActiveEditor),`active editor '${m.newActiveEditor}' does not exist`),this._activeEditorId=m.newActiveEditor),D.dispose(f),D.dispose(r),m.removedDocuments&&this._onDidRemoveDocuments.fire(f),m.addedDocuments&&this._onDidAddDocuments.fire(t),(m.removedEditors||m.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(i=>i.value)),m.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(m){var f;return(f=this._documents.get(m))===null||f===void 0?void 0:f.value}allDocuments(){return u.Iterable.map(this._documents.values(),m=>m.value)}getEditor(m){return this._editors.get(m)}activeEditor(m){if(!this._activeEditorId)return;const f=this._editors.get(this._activeEditorId);return m?f:f==null?void 0:f.value}allEditors(){return[...this._editors.values()]}};S=He([ze(0,k.IExtHostRpcService),ze(1,o.ILogService)],S),e.ExtHostDocumentsAndEditors=S,e.IExtHostDocumentsAndEditors=C.createDecorator("IExtHostDocumentsAndEditors")}),define(we[184],_e([0,1,2,4,7,6,9,117,8,23]),function(Z,e,g,T,D,E,C,y,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class n{constructor(){this._schemes=[]}add(h){this._stateMachine=void 0,this._schemes.push(h)}delete(h){const d=this._schemes.indexOf(h);d>=0&&(this._schemes.splice(d,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const h=this._schemes.sort(),d=[];let u,w,v=14,S=14;for(const c of h){let m=u?_.commonPrefixLength(u,c):0;for(m===0?w=1:w=S;m<c.length;m++)m+1===c.length?(v=S,S=9):S+=1,d.push([w,c.toUpperCase().charCodeAt(m),S]),d.push([w,c.toLowerCase().charCodeAt(m),S]),w=S;u=c,S=v}d.push([9,58,10]),d.push([10,47,12]),this._stateMachine=new y.StateMachine(d)}}provideDocumentLinks(h){this._initStateMachine();const d=[],u=y.LinkComputer.computeLinks({getLineContent(w){return h.lineAt(w-1).text},getLineCount(){return h.lineCount}},this._stateMachine);for(const w of u){const v=C.DocumentLink.to(w);v.target&&d.push(v)}return d}}class I{constructor(h,d){this._extHostLanguageFeatures=d,this._linkProvider=new n,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._enableProposedApi=new Map,this._handlePool=0,this._proxy=h.getProxy(T.MainContext.MainThreadFileSystem)}dispose(){var h;(h=this._linkProviderRegistration)===null||h===void 0||h.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(h,d,u,w={},v){if(this._registeredSchemes.has(d))throw new Error(`a provider for the scheme '${d}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const S=this._handlePool++;this._linkProvider.add(d),this._registeredSchemes.add(d),this._fsProvider.set(S,u),this._enableProposedApi.set(S,v??!1);let c=2;w.isCaseSensitive&&(c+=1024),w.isReadonly&&(c+=2048),typeof u.copy=="function"&&(c+=8),typeof u.open=="function"&&typeof u.close=="function"&&typeof u.read=="function"&&typeof u.write=="function"&&(c+=4),this._proxy.$registerFileSystemProvider(S,d,c).catch(f=>{console.error(`FAILED to register filesystem provider of ${h.value}-extension for the scheme ${d}`),console.error(f)});const m=u.onDidChangeFile(f=>{const t=[];for(const r of f){let{uri:i,type:s}=r;if(i.scheme!==d)continue;let l;switch(s){case E.FileChangeType.Changed:l=0;break;case E.FileChangeType.Created:l=1;break;case E.FileChangeType.Deleted:l=2;break;default:throw new Error("Unknown FileChangeType")}t.push({resource:i,type:l})}this._proxy.$onFileSystemChange(S,t)});return D.toDisposable(()=>{m.dispose(),this._linkProvider.delete(d),this._registeredSchemes.delete(d),this._fsProvider.delete(S),this._enableProposedApi.delete(S),this._proxy.$unregisterProvider(S)})}static _asIStat(h,d){const{type:u,ctime:w,mtime:v,size:S,permissions:c}=h;return d?{type:u,ctime:w,mtime:v,size:S,permissions:c}:{type:u,ctime:w,mtime:v,size:S}}$stat(h,d){return Promise.resolve(this._getFsProvider(h).stat(g.URI.revive(d))).then(u=>{var w;return I._asIStat(u,(w=this._enableProposedApi.get(h))!==null&&w!==void 0?w:!1)})}$readdir(h,d){return Promise.resolve(this._getFsProvider(h).readDirectory(g.URI.revive(d)))}$readFile(h,d){return Promise.resolve(this._getFsProvider(h).readFile(g.URI.revive(d))).then(u=>k.VSBuffer.wrap(u))}$writeFile(h,d,u,w){return Promise.resolve(this._getFsProvider(h).writeFile(g.URI.revive(d),u.buffer,w))}$delete(h,d,u){return Promise.resolve(this._getFsProvider(h).delete(g.URI.revive(d),u))}$rename(h,d,u,w){return Promise.resolve(this._getFsProvider(h).rename(g.URI.revive(d),g.URI.revive(u),w))}$copy(h,d,u,w){const v=this._getFsProvider(h);if(!v.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(v.copy(g.URI.revive(d),g.URI.revive(u),w))}$mkdir(h,d){return Promise.resolve(this._getFsProvider(h).createDirectory(g.URI.revive(d)))}$watch(h,d,u,w){const v=this._getFsProvider(h).watch(g.URI.revive(u),w);this._watches.set(d,v)}$unwatch(h,d){const u=this._watches.get(d);u&&(u.dispose(),this._watches.delete(d))}$open(h,d,u){const w=this._getFsProvider(h);if(!w.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(w.open(g.URI.revive(d),u))}$close(h,d){const u=this._getFsProvider(h);if(!u.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(u.close(d))}$read(h,d,u,w){const v=this._getFsProvider(h);if(!v.read)throw new Error('FileSystemProvider does not implement "read"');const S=k.VSBuffer.alloc(w);return Promise.resolve(v.read(d,u,S.buffer,0,w)).then(c=>S.slice(0,c))}$write(h,d,u,w){const v=this._getFsProvider(h);if(!v.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(v.write(d,u,w.buffer,0,w.byteLength))}_getFsProvider(h){const d=this._fsProvider.get(h);if(!d){const u=new Error;throw u.name="ENOPRO",u.message="no provider",u}return d}}e.ExtHostFileSystem=I}),define(we[72],_e([0,1,4,59,6,23,5,14,44]),function(Z,e,g,T,D,E,C,y,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let k=class Ut{constructor(I,o){const h=I.getProxy(g.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(d){return h.$stat(d).catch(Ut._handleError)},readDirectory(d){return h.$readdir(d).catch(Ut._handleError)},createDirectory(d){return h.$mkdir(d).catch(Ut._handleError)},async readFile(d){return h.$readFile(d).then(u=>u.buffer).catch(Ut._handleError)},writeFile(d,u){return h.$writeFile(d,E.VSBuffer.wrap(u)).catch(Ut._handleError)},delete(d,u){return h.$delete(d,Object.assign({recursive:!1,useTrash:!1},u)).catch(Ut._handleError)},rename(d,u,w){return h.$rename(d,u,Object.assign({overwrite:!1},w)).catch(Ut._handleError)},copy(d,u,w){return h.$copy(d,u,Object.assign({overwrite:!1},w)).catch(Ut._handleError)},isWritableFileSystem(d){const u=o.getCapabilities(d);if(typeof u=="number")return!(u&2048)}})}static _handleError(I){if(!(I instanceof Error))throw new D.FileSystemError(String(I));if(I.name==="ENOPRO")throw D.FileSystemError.Unavailable(I.message);switch(I.name){case T.FileSystemProviderErrorCode.FileExists:throw D.FileSystemError.FileExists(I.message);case T.FileSystemProviderErrorCode.FileNotFound:throw D.FileSystemError.FileNotFound(I.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw D.FileSystemError.FileNotADirectory(I.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw D.FileSystemError.FileIsADirectory(I.message);case T.FileSystemProviderErrorCode.NoPermissions:throw D.FileSystemError.NoPermissions(I.message);case T.FileSystemProviderErrorCode.Unavailable:throw D.FileSystemError.Unavailable(I.message);default:throw new D.FileSystemError(I.message,I.name)}}};k=He([ze(0,y.IExtHostRpcService),ze(1,_.IExtHostFileSystemInfo)],k),e.ExtHostConsumerFileSystem=k,e.IExtHostConsumerFileSystem=C.createDecorator("IExtHostConsumerFileSystem")}),define(we[185],_e([0,1,7,4]),function(Z,e,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class D{constructor(C){this._handlePool=0,this._proxy=C.getProxy(T.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(C){const y=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(y,C),g.toDisposable(()=>{this._proxy.$unregisterResourceLabelFormatter(y)})}}e.ExtHostLabelService=D}),define(we[186],_e([0,1,2,24,9,6,11,4,8,31,16,10,114,7,85,49,63,52,12,3]),function(Z,e,g,T,D,E,C,y,_,k,n,I,o,h,d,u,w,v,S,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class m{constructor(W,Q){this._documents=W,this._provider=Q}provideDocumentSymbols(W,Q){const te=this._documents.getDocument(W);return C.asPromise(()=>this._provider.provideDocumentSymbols(te,Q)).then(re=>{if(!n.isFalsyOrEmpty(re))return re[0]instanceof E.DocumentSymbol?re.map(D.DocumentSymbol.from):m._asDocumentSymbolTree(re)})}static _asDocumentSymbolTree(W){var Q;W=W.slice(0).sort((K,se)=>{let he=K.location.range.start.compareTo(se.location.range.start);return he===0&&(he=se.location.range.end.compareTo(K.location.range.end)),he});const te=[],re=[];for(const K of W){const se={name:K.name||"!!MISSING: name!!",kind:D.SymbolKind.from(K.kind),tags:((Q=K.tags)===null||Q===void 0?void 0:Q.map(D.SymbolTag.from))||[],detail:"",containerName:K.containerName,range:D.Range.from(K.location.range),selectionRange:D.Range.from(K.location.range),children:[]};for(;;){if(re.length===0){re.push(se),te.push(se);break}const he=re[re.length-1];if(k.Range.containsRange(he.range,se.range)&&!k.Range.equalsRange(he.range,se.range)){he.children&&he.children.push(se),re.push(se);break}re.pop()}}return te}}class f{constructor(W,Q,te){this._documents=W,this._commands=Q,this._provider=te,this._cache=new w.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(W,Q){const te=this._documents.getDocument(W),re=await this._provider.provideCodeLenses(te,Q);if(!re||Q.isCancellationRequested)return;const K=this._cache.add(re),se=new h.DisposableStore;this._disposables.set(K,se);const he={cacheId:K,lenses:[]};for(let Ae=0;Ae<re.length;Ae++)he.lenses.push({cacheId:[K,Ae],range:D.Range.from(re[Ae].range),command:this._commands.toInternal(re[Ae].command,se)});return he}async resolveCodeLens(W,Q){var te;const re=W.cacheId&&this._cache.get(...W.cacheId);if(!re)return;let K;if(typeof this._provider.resolveCodeLens!="function"||re.isResolved?K=re:K=await this._provider.resolveCodeLens(re,Q),K||(K=re),Q.isCancellationRequested)return;const se=W.cacheId&&this._disposables.get(W.cacheId[0]);if(!!se)return W.command=this._commands.toInternal((te=K.command)!==null&&te!==void 0?te:f._badCmd,se),W}releaseCodeLenses(W){var Q;(Q=this._disposables.get(W))===null||Q===void 0||Q.dispose(),this._disposables.delete(W),this._cache.delete(W)}}f._badCmd={command:"missing",title:"!!MISSING: command!!"};function t(Ye){return Array.isArray(Ye)?Ye.map(D.DefinitionLink.from):Ye?[D.DefinitionLink.from(Ye)]:[]}class r{constructor(W,Q){this._documents=W,this._provider=Q}provideDefinition(W,Q,te){const re=this._documents.getDocument(W),K=D.Position.to(Q);return C.asPromise(()=>this._provider.provideDefinition(re,K,te)).then(t)}}class i{constructor(W,Q){this._documents=W,this._provider=Q}provideDeclaration(W,Q,te){const re=this._documents.getDocument(W),K=D.Position.to(Q);return C.asPromise(()=>this._provider.provideDeclaration(re,K,te)).then(t)}}class s{constructor(W,Q){this._documents=W,this._provider=Q}provideImplementation(W,Q,te){const re=this._documents.getDocument(W),K=D.Position.to(Q);return C.asPromise(()=>this._provider.provideImplementation(re,K,te)).then(t)}}class l{constructor(W,Q){this._documents=W,this._provider=Q}provideTypeDefinition(W,Q,te){const re=this._documents.getDocument(W),K=D.Position.to(Q);return C.asPromise(()=>this._provider.provideTypeDefinition(re,K,te)).then(t)}}class b{constructor(W,Q){this._documents=W,this._provider=Q}provideHover(W,Q,te){const re=this._documents.getDocument(W),K=D.Position.to(Q);return C.asPromise(()=>this._provider.provideHover(re,K,te)).then(se=>{if(!(!se||n.isFalsyOrEmpty(se.contents)))return se.range||(se.range=re.getWordRangeAtPosition(K)),se.range||(se.range=new E.Range(K,K)),D.Hover.from(se)})}}class p{constructor(W,Q){this._documents=W,this._provider=Q}provideEvaluatableExpression(W,Q,te){const re=this._documents.getDocument(W),K=D.Position.to(Q);return C.asPromise(()=>this._provider.provideEvaluatableExpression(re,K,te)).then(se=>{if(se)return D.EvaluatableExpression.from(se)})}}class P{constructor(W,Q){this._documents=W,this._provider=Q}provideInlineValues(W,Q,te,re){const K=this._documents.getDocument(W);return C.asPromise(()=>this._provider.provideInlineValues(K,D.Range.to(Q),D.InlineValueContext.to(te),re)).then(se=>{if(Array.isArray(se))return se.map(he=>D.InlineValue.from(he))})}}class A{constructor(W,Q){this._documents=W,this._provider=Q}provideDocumentHighlights(W,Q,te){const re=this._documents.getDocument(W),K=D.Position.to(Q);return C.asPromise(()=>this._provider.provideDocumentHighlights(re,K,te)).then(se=>{if(Array.isArray(se))return se.map(D.DocumentHighlight.from)})}}class a{constructor(W,Q){this._documents=W,this._provider=Q}provideLinkedEditingRanges(W,Q,te){const re=this._documents.getDocument(W),K=D.Position.to(Q);return C.asPromise(()=>this._provider.provideLinkedEditingRanges(re,K,te)).then(se=>{if(se&&Array.isArray(se.ranges))return{ranges:n.coalesce(se.ranges.map(D.Range.from)),wordPattern:se.wordPattern}})}}class F{constructor(W,Q){this._documents=W,this._provider=Q}provideReferences(W,Q,te,re){const K=this._documents.getDocument(W),se=D.Position.to(Q);return C.asPromise(()=>this._provider.provideReferences(K,se,te,re)).then(he=>{if(Array.isArray(he))return he.map(D.location.from)})}}class N{constructor(W,Q,te,re,K,se,he){this._documents=W,this._commands=Q,this._diagnostics=te,this._provider=re,this._logService=K,this._extension=se,this._apiDeprecation=he,this._cache=new w.Cache("CodeAction"),this._disposables=new Map}provideCodeActions(W,Q,te,re){const K=this._documents.getDocument(W),se=o.Selection.isISelection(Q)?D.Selection.to(Q):D.Range.to(Q),he=[];for(const Be of this._diagnostics.getDiagnostics(W))if(se.intersection(Be.range)&&he.push(Be)>N._maxCodeActionsPerFile)break;const Ae={diagnostics:he,only:te.only?new E.CodeActionKind(te.only):void 0,triggerKind:D.CodeActionTriggerKind.to(te.trigger)};return C.asPromise(()=>this._provider.provideCodeActions(K,se,Ae,re)).then(Be=>{var pe;if(!n.isNonEmptyArray(Be)||re.isCancellationRequested)return;const Ke=this._cache.add(Be),j=new h.DisposableStore;this._disposables.set(Ke,j);const ee=[];for(let me=0;me<Be.length;me++){const Fe=Be[me];!Fe||(N._isCommand(Fe)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),ee.push({_isSynthetic:!0,title:Fe.title,command:this._commands.toInternal(Fe,j)})):(Ae.only&&(Fe.kind?Ae.only.contains(Fe.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ae.only.value} 'requested but returned code action is of kind '${Fe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ae.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),ee.push({cacheId:[Ke,me],title:Fe.title,command:Fe.command&&this._commands.toInternal(Fe.command,j),diagnostics:Fe.diagnostics&&Fe.diagnostics.map(D.Diagnostic.from),edit:Fe.edit&&D.WorkspaceEdit.from(Fe.edit),kind:Fe.kind&&Fe.kind.value,isPreferred:Fe.isPreferred,disabled:(pe=Fe.disabled)===null||pe===void 0?void 0:pe.reason})))}return{cacheId:Ke,actions:ee}})}async resolveCodeAction(W,Q){var te;const[re,K]=W,se=this._cache.get(re,K);if(!se||N._isCommand(se)||!this._provider.resolveCodeAction)return;const he=(te=await this._provider.resolveCodeAction(se,Q))!==null&&te!==void 0?te:se;return(he==null?void 0:he.edit)?D.WorkspaceEdit.from(he.edit):void 0}releaseCodeActions(W){var Q;(Q=this._disposables.get(W))===null||Q===void 0||Q.dispose(),this._disposables.delete(W),this._cache.delete(W)}static _isCommand(W){return typeof W.command=="string"&&typeof W.title=="string"}}N._maxCodeActionsPerFile=1e3;class H{constructor(W,Q){this._documents=W,this._provider=Q}provideDocumentFormattingEdits(W,Q,te){const re=this._documents.getDocument(W);return C.asPromise(()=>this._provider.provideDocumentFormattingEdits(re,Q,te)).then(K=>{if(Array.isArray(K))return K.map(D.TextEdit.from)})}}class le{constructor(W,Q){this._documents=W,this._provider=Q}provideDocumentRangeFormattingEdits(W,Q,te,re){const K=this._documents.getDocument(W),se=D.Range.to(Q);return C.asPromise(()=>this._provider.provideDocumentRangeFormattingEdits(K,se,te,re)).then(he=>{if(Array.isArray(he))return he.map(D.TextEdit.from)})}}class fe{constructor(W,Q){this._documents=W,this._provider=Q,this.autoFormatTriggerCharacters=[]}provideOnTypeFormattingEdits(W,Q,te,re,K){const se=this._documents.getDocument(W),he=D.Position.to(Q);return C.asPromise(()=>this._provider.provideOnTypeFormattingEdits(se,he,te,re,K)).then(Ae=>{if(Array.isArray(Ae))return Ae.map(D.TextEdit.from)})}}class X{constructor(W,Q){this._provider=W,this._logService=Q,this._symbolCache=new Map,this._resultCache=new Map}provideWorkspaceSymbols(W,Q){const te=y.IdObject.mixin({symbols:[]});return C.asPromise(()=>this._provider.provideWorkspaceSymbols(W,Q)).then(re=>{if(n.isNonEmptyArray(re))for(const K of re){if(!K)continue;if(!K.name){this._logService.warn("INVALID SymbolInformation, lacks name",K);continue}const se=y.IdObject.mixin(D.WorkspaceSymbol.from(K));this._symbolCache.set(se._id,K),te.symbols.push(se)}}).then(()=>(te.symbols.length>0&&this._resultCache.set(te._id,[te.symbols[0]._id,te.symbols[te.symbols.length-1]._id]),te))}async resolveWorkspaceSymbol(W,Q){if(typeof this._provider.resolveWorkspaceSymbol!="function")return W;const te=this._symbolCache.get(W._id);if(te){const re=await C.asPromise(()=>this._provider.resolveWorkspaceSymbol(te,Q));return re&&T.mixin(W,D.WorkspaceSymbol.from(re),!0)}}releaseWorkspaceSymbols(W){const Q=this._resultCache.get(W);if(Q){for(let[te,re]=Q;te<=re;te++)this._symbolCache.delete(te);this._resultCache.delete(W)}}}class z{constructor(W,Q,te){this._documents=W,this._provider=Q,this._logService=te}static supportsResolving(W){return typeof W.prepareRename=="function"}provideRenameEdits(W,Q,te,re){const K=this._documents.getDocument(W),se=D.Position.to(Q);return C.asPromise(()=>this._provider.provideRenameEdits(K,se,te,re)).then(he=>{if(!!he)return D.WorkspaceEdit.from(he)},he=>{const Ae=z._asMessage(he);return Ae?{rejectReason:Ae,edits:void 0}:Promise.reject(he)})}resolveRenameLocation(W,Q,te){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const re=this._documents.getDocument(W),K=D.Position.to(Q);return C.asPromise(()=>this._provider.prepareRename(re,K,te)).then(se=>{let he,Ae;if(E.Range.isRange(se)?(he=se,Ae=re.getText(se)):I.isObject(se)&&(he=se.range,Ae=se.placeholder),!!he){if(he.start.line>K.line||he.end.line<K.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:D.Range.from(he),text:Ae}}},se=>{const he=z._asMessage(se);return he?{rejectReason:he,range:void 0,text:void 0}:Promise.reject(se)})}static _asMessage(W){return typeof W=="string"?W:W instanceof Error&&typeof W.message=="string"?W.message:void 0}}class Y{constructor(W,Q){this.resultId=W,this.tokens=Q}}class R{constructor(W,Q){this._documents=W,this._provider=Q,this._nextResultId=1,this._previousResults=new Map}provideDocumentSemanticTokens(W,Q,te){const re=this._documents.getDocument(W),K=Q!==0?this._previousResults.get(Q):null;return C.asPromise(()=>K&&typeof K.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?this._provider.provideDocumentSemanticTokensEdits(re,K.resultId,te):this._provider.provideDocumentSemanticTokens(re,te)).then(se=>(K&&this._previousResults.delete(Q),se?(se=R._fixProvidedSemanticTokens(se),this._send(R._convertToEdits(K,se),se)):null))}async releaseDocumentSemanticColoring(W){this._previousResults.delete(W)}static _fixProvidedSemanticTokens(W){return R._isSemanticTokens(W)?R._isCorrectSemanticTokens(W)?W:new E.SemanticTokens(new Uint32Array(W.data),W.resultId):R._isSemanticTokensEdits(W)?R._isCorrectSemanticTokensEdits(W)?W:new E.SemanticTokensEdits(W.edits.map(Q=>new E.SemanticTokensEdit(Q.start,Q.deleteCount,Q.data?new Uint32Array(Q.data):Q.data)),W.resultId):W}static _isSemanticTokens(W){return W&&!!W.data}static _isCorrectSemanticTokens(W){return W.data instanceof Uint32Array}static _isSemanticTokensEdits(W){return W&&Array.isArray(W.edits)}static _isCorrectSemanticTokensEdits(W){for(const Q of W.edits)if(!(Q.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(W,Q){if(!R._isSemanticTokens(Q)||!W||!W.tokens)return Q;const te=W.tokens,re=te.length,K=Q.data,se=K.length;let he=0;const Ae=Math.min(re,se);for(;he<Ae&&te[he]===K[he];)he++;if(he===re&&he===se)return new E.SemanticTokensEdits([],Q.resultId);let Be=0;const pe=Ae-he;for(;Be<pe&&te[re-Be-1]===K[se-Be-1];)Be++;return new E.SemanticTokensEdits([{start:he,deleteCount:re-he-Be,data:K.subarray(he,se-Be)}],Q.resultId)}_send(W,Q){if(R._isSemanticTokens(W)){const te=this._nextResultId++;return this._previousResults.set(te,new Y(W.resultId,W.data)),d.encodeSemanticTokensDto({id:te,type:"full",data:W.data})}if(R._isSemanticTokensEdits(W)){const te=this._nextResultId++;return R._isSemanticTokens(Q)?this._previousResults.set(te,new Y(Q.resultId,Q.data)):this._previousResults.set(te,new Y(W.resultId)),d.encodeSemanticTokensDto({id:te,type:"delta",deltas:(W.edits||[]).map(re=>({start:re.start,deleteCount:re.deleteCount,data:re.data}))})}return null}}e.DocumentSemanticTokensAdapter=R;class B{constructor(W,Q){this._documents=W,this._provider=Q}provideDocumentRangeSemanticTokens(W,Q,te){const re=this._documents.getDocument(W);return C.asPromise(()=>this._provider.provideDocumentRangeSemanticTokens(re,D.Range.to(Q),te)).then(K=>K?this._send(K):null)}_send(W){return d.encodeSemanticTokensDto({id:0,type:"full",data:W.data})}}e.DocumentRangeSemanticTokensAdapter=B;class M{constructor(W,Q,te,re,K){this._documents=W,this._commands=Q,this._provider=te,this._apiDeprecation=re,this._extension=K,this._cache=new w.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(W){return typeof W.resolveCompletionItem=="function"}async provideCompletionItems(W,Q,te,re){const K=this._documents.getDocument(W),se=D.Position.to(Q),he=K.getWordRangeAtPosition(se)||new E.Range(se,se),Ae=he.with({end:se}),Be=new v.StopWatch(!0),pe=await C.asPromise(()=>this._provider.provideCompletionItems(K,se,re,D.CompletionContext.to(te)));if(!pe||re.isCancellationRequested)return;const Ke=Array.isArray(pe)?new E.CompletionList(pe):pe,j=M.supportsResolving(this._provider)?this._cache.add(Ke.items):this._cache.add([]),ee=new h.DisposableStore;this._disposables.set(j,ee);const me=[],Fe={x:j,b:me,a:{replace:D.Range.from(he),insert:D.Range.from(Ae)},c:Ke.isIncomplete||void 0,d:Be.elapsed()};for(let Le=0;Le<Ke.items.length;Le++){const Ge=Ke.items[Le],Ee=this._convertCompletionItem(Ge,[j,Le],Ae,he);me.push(Ee)}return Fe}async resolveCompletionItem(W,Q){if(typeof this._provider.resolveCompletionItem!="function")return;const te=this._cache.get(...W);if(!te)return;const re=await C.asPromise(()=>this._provider.resolveCompletionItem(te,Q));if(!!re)return this._convertCompletionItem(re,W)}releaseCompletionItems(W){var Q;(Q=this._disposables.get(W))===null||Q===void 0||Q.dispose(),this._disposables.delete(W),this._cache.delete(W)}_convertCompletionItem(W,Q,te,re){var K;const se=this._disposables.get(Q[0]);if(!se)throw Error("DisposableStore is missing...");const he={x:Q,a:(K=W.label)!==null&&K!==void 0?K:"",o:W.label2,b:W.kind!==void 0?D.CompletionItemKind.from(W.kind):void 0,n:W.tags&&W.tags.map(D.CompletionItemTag.from),c:W.detail,d:typeof W.documentation=="undefined"?void 0:D.MarkdownString.fromStrict(W.documentation),e:W.sortText!==W.label?W.sortText:void 0,f:W.filterText!==W.label?W.filterText:void 0,g:W.preselect||void 0,i:W.keepWhitespace?1:0,k:W.commitCharacters,l:W.additionalTextEdits&&W.additionalTextEdits.map(D.TextEdit.from),m:this._commands.toInternal(W.command,se)};W.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),he.h=W.textEdit.newText):typeof W.insertText=="string"?he.h=W.insertText:W.insertText instanceof E.SnippetString&&(he.h=W.insertText.value,he.i|=4);let Ae;return W.textEdit?Ae=W.textEdit.range:W.range&&(Ae=W.range),E.Range.isRange(Ae)?he.j=D.Range.from(Ae):Ae&&(!(te==null?void 0:te.isEqual(Ae.inserting))||!(re==null?void 0:re.isEqual(Ae.replacing)))&&(he.j={insert:D.Range.from(Ae.inserting),replace:D.Range.from(Ae.replacing)}),he}}class U{constructor(W,Q,te){this._documents=W,this._provider=Q,this._commands=te,this._cache=new w.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(W,Q,te,re){const K=this._documents.getDocument(W),se=D.Position.to(Q),he=await C.asPromise(()=>this._provider.provideInlineCompletionItems(K,se,te,re));if(!he||re.isCancellationRequested)return;const Ae=I.isArray(he)?{items:he}:he,Be=this._cache.add(Ae.items);let pe;return{pid:Be,items:Ae.items.map((Ke,j)=>{let ee;return Ke.command&&(pe||(pe=new h.DisposableStore,this._disposables.set(Be,pe)),ee=this._commands.toInternal(Ke.command,pe)),{text:Ke.text,range:Ke.range?D.Range.from(Ke.range):void 0,command:ee,idx:j}})}}disposeCompletions(W){this._cache.delete(W);const Q=this._disposables.get(W);Q&&Q.clear(),this._disposables.delete(W)}handleDidShowCompletionItem(W,Q){const te=this._cache.get(W,Q);te&&q.get(this._provider).fireOnDidShowCompletionItem({completionItem:te})}}class q{constructor(){this._onDidShowCompletionItemEmitter=new c.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(W){let Q=q.map.get(W);return Q||(Q=new q,q.map.set(W,Q)),Q}fireOnDidShowCompletionItem(W){this._onDidShowCompletionItemEmitter.fire(W)}}e.InlineCompletionController=q,q.map=new WeakMap;class V{constructor(W,Q){this._documents=W,this._provider=Q,this._cache=new w.Cache("SignatureHelp")}provideSignatureHelp(W,Q,te,re){const K=this._documents.getDocument(W),se=D.Position.to(Q),he=this.reviveContext(te);return C.asPromise(()=>this._provider.provideSignatureHelp(K,se,re,he)).then(Ae=>{if(Ae){const Be=this._cache.add([Ae]);return Object.assign(Object.assign({},D.SignatureHelp.from(Ae)),{id:Be})}})}reviveContext(W){let Q;if(W.activeSignatureHelp){const te=D.SignatureHelp.to(W.activeSignatureHelp),re=this._cache.get(W.activeSignatureHelp.id,0);re?(Q=re,Q.activeSignature=te.activeSignature,Q.activeParameter=te.activeParameter):Q=te}return Object.assign(Object.assign({},W),{activeSignatureHelp:Q})}releaseSignatureHelp(W){this._cache.delete(W)}}class oe{constructor(W,Q){this._documents=W,this._provider=Q}provideInlayHints(W,Q,te){const re=this._documents.getDocument(W);return C.asPromise(()=>this._provider.provideInlayHints(re,D.Range.to(Q),te)).then(K=>K?{hints:K.map(D.InlayHint.from)}:void 0)}}class ge{constructor(W,Q){this._documents=W,this._provider=Q,this._cache=new w.Cache("DocumentLink")}provideLinks(W,Q){const te=this._documents.getDocument(W);return C.asPromise(()=>this._provider.provideDocumentLinks(te,Q)).then(re=>{if(!(!Array.isArray(re)||re.length===0)&&!Q.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:re.map(D.DocumentLink.from)};{const K=this._cache.add(re),se={links:[],id:K};for(let he=0;he<re.length;he++){const Ae=D.DocumentLink.from(re[he]);Ae.cacheId=[K,he],se.links.push(Ae)}return se}}})}resolveLink(W,Q){if(typeof this._provider.resolveDocumentLink!="function")return Promise.resolve(void 0);const te=this._cache.get(...W);return te?C.asPromise(()=>this._provider.resolveDocumentLink(te,Q)).then(re=>re&&D.DocumentLink.from(re)||void 0):Promise.resolve(void 0)}releaseLinks(W){this._cache.delete(W)}}class Re{constructor(W,Q){this._documents=W,this._provider=Q}provideColors(W,Q){const te=this._documents.getDocument(W);return C.asPromise(()=>this._provider.provideDocumentColors(te,Q)).then(re=>Array.isArray(re)?re.map(se=>({color:D.Color.from(se.color),range:D.Range.from(se.range)})):[])}provideColorPresentations(W,Q,te){const re=this._documents.getDocument(W),K=D.Range.to(Q.range),se=D.Color.to(Q.color);return C.asPromise(()=>this._provider.provideColorPresentations(se,{document:re,range:K},te)).then(he=>{if(!!Array.isArray(he))return he.map(D.ColorPresentation.from)})}}class $e{constructor(W,Q){this._documents=W,this._provider=Q}provideFoldingRanges(W,Q,te){const re=this._documents.getDocument(W);return C.asPromise(()=>this._provider.provideFoldingRanges(re,Q,te)).then(K=>{if(!!Array.isArray(K))return K.map(D.FoldingRange.from)})}}class Me{constructor(W,Q,te){this._documents=W,this._provider=Q,this._logService=te}provideSelectionRanges(W,Q,te){const re=this._documents.getDocument(W),K=Q.map(D.Position.to);return C.asPromise(()=>this._provider.provideSelectionRanges(re,K,te)).then(se=>{if(!n.isNonEmptyArray(se))return[];if(se.length!==K.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const he=[];for(let Ae=0;Ae<K.length;Ae++){const Be=[];he.push(Be);let pe=K[Ae],Ke=se[Ae];for(;;){if(!Ke.range.contains(pe))throw new Error("INVALID selection range, must contain the previous range");if(Be.push(D.SelectionRange.from(Ke)),!Ke.parent)break;pe=Ke.range,Ke=Ke.parent}}return he})}}class We{constructor(W,Q){this._documents=W,this._provider=Q,this._idPool=new u.IdGenerator(""),this._cache=new Map}async prepareSession(W,Q,te){const re=this._documents.getDocument(W),K=D.Position.to(Q),se=await this._provider.prepareCallHierarchy(re,K,te);if(!se)return;const he=this._idPool.nextId();return this._cache.set(he,new Map),Array.isArray(se)?se.map(Ae=>this._cacheAndConvertItem(he,Ae)):[this._cacheAndConvertItem(he,se)]}async provideCallsTo(W,Q,te){const re=this._itemFromCache(W,Q);if(!re)throw new Error("missing call hierarchy item");const K=await this._provider.provideCallHierarchyIncomingCalls(re,te);if(!!K)return K.map(se=>({from:this._cacheAndConvertItem(W,se.from),fromRanges:se.fromRanges.map(he=>D.Range.from(he))}))}async provideCallsFrom(W,Q,te){const re=this._itemFromCache(W,Q);if(!re)throw new Error("missing call hierarchy item");const K=await this._provider.provideCallHierarchyOutgoingCalls(re,te);if(!!K)return K.map(se=>({to:this._cacheAndConvertItem(W,se.to),fromRanges:se.fromRanges.map(he=>D.Range.from(he))}))}releaseSession(W){this._cache.delete(W)}_cacheAndConvertItem(W,Q){var te;const re=this._cache.get(W),K={_sessionId:W,_itemId:re.size.toString(36),name:Q.name,detail:Q.detail,kind:D.SymbolKind.from(Q.kind),uri:Q.uri,range:D.Range.from(Q.range),selectionRange:D.Range.from(Q.selectionRange),tags:(te=Q.tags)===null||te===void 0?void 0:te.map(D.SymbolTag.from)};return re.set(K._itemId,Q),K}_itemFromCache(W,Q){const te=this._cache.get(W);return te==null?void 0:te.get(Q)}}class Je{constructor(W,Q){this.adapter=W,this.extension=Q}}class Qe{constructor(W,Q,te,re,K,se,he){this._adapter=new Map,this._uriTransformer=Q,this._proxy=W.getProxy(y.MainContext.MainThreadLanguageFeatures),this._documents=te,this._commands=re,this._diagnostics=K,this._logService=se,this._apiDeprecation=he}_transformDocumentSelector(W){return n.coalesce(n.asArray(W).map(Q=>this._doTransformDocumentSelector(Q)))}_doTransformDocumentSelector(W){if(typeof W=="string")return{$serialized:!0,language:W};if(W)return{$serialized:!0,language:W.language,scheme:this._transformScheme(W.scheme),pattern:typeof W.pattern=="undefined"?void 0:D.GlobPattern.from(W.pattern),exclusive:W.exclusive}}_transformScheme(W){return this._uriTransformer&&typeof W=="string"?this._uriTransformer.transformOutgoingScheme(W):W}_createDisposable(W){return new E.Disposable(()=>{this._adapter.delete(W),this._proxy.$unregister(W)})}_nextHandle(){return Qe._handlePool++}_withAdapter(W,Q,te,re,K=!1){const se=this._adapter.get(W);if(!se)return Promise.resolve(re);if(se.adapter instanceof Q){let he;se.extension&&(he=Date.now(),this._logService.trace(`[${se.extension.identifier.value}] INVOKE provider '${Q.name}'`));const Ae=te(se.adapter,se.extension),Be=se.extension;return Be&&Promise.resolve(Ae).then(()=>this._logService.trace(`[${Be.identifier.value}] provider DONE after ${Date.now()-he}ms`),pe=>{K&&pe instanceof S.CancellationError||(this._logService.error(`[${Be.identifier.value}] provider FAILED`),this._logService.error(pe))}),Ae}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(W,Q){const te=this._nextHandle();return this._adapter.set(te,new Je(W,Q)),te}static _extLabel(W){return W.displayName||W.name}registerDocumentSymbolProvider(W,Q,te,re){const K=this._addNewAdapter(new m(this._documents,te),W),se=re&&re.label||Qe._extLabel(W);return this._proxy.$registerDocumentSymbolProvider(K,this._transformDocumentSelector(Q),se),this._createDisposable(K)}$provideDocumentSymbols(W,Q,te){return this._withAdapter(W,m,re=>re.provideDocumentSymbols(g.URI.revive(Q),te),void 0)}registerCodeLensProvider(W,Q,te){const re=this._nextHandle(),K=typeof te.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(re,new Je(new f(this._documents,this._commands.converter,te),W)),this._proxy.$registerCodeLensSupport(re,this._transformDocumentSelector(Q),K);let se=this._createDisposable(re);if(K!==void 0){const he=te.onDidChangeCodeLenses(Ae=>this._proxy.$emitCodeLensEvent(K));se=E.Disposable.from(se,he)}return se}$provideCodeLenses(W,Q,te){return this._withAdapter(W,f,re=>re.provideCodeLenses(g.URI.revive(Q),te),void 0)}$resolveCodeLens(W,Q,te){return this._withAdapter(W,f,re=>re.resolveCodeLens(Q,te),void 0)}$releaseCodeLenses(W,Q){this._withAdapter(W,f,te=>Promise.resolve(te.releaseCodeLenses(Q)),void 0)}registerDefinitionProvider(W,Q,te){const re=this._addNewAdapter(new r(this._documents,te),W);return this._proxy.$registerDefinitionSupport(re,this._transformDocumentSelector(Q)),this._createDisposable(re)}$provideDefinition(W,Q,te,re){return this._withAdapter(W,r,K=>K.provideDefinition(g.URI.revive(Q),te,re),[])}registerDeclarationProvider(W,Q,te){const re=this._addNewAdapter(new i(this._documents,te),W);return this._proxy.$registerDeclarationSupport(re,this._transformDocumentSelector(Q)),this._createDisposable(re)}$provideDeclaration(W,Q,te,re){return this._withAdapter(W,i,K=>K.provideDeclaration(g.URI.revive(Q),te,re),[])}registerImplementationProvider(W,Q,te){const re=this._addNewAdapter(new s(this._documents,te),W);return this._proxy.$registerImplementationSupport(re,this._transformDocumentSelector(Q)),this._createDisposable(re)}$provideImplementation(W,Q,te,re){return this._withAdapter(W,s,K=>K.provideImplementation(g.URI.revive(Q),te,re),[])}registerTypeDefinitionProvider(W,Q,te){const re=this._addNewAdapter(new l(this._documents,te),W);return this._proxy.$registerTypeDefinitionSupport(re,this._transformDocumentSelector(Q)),this._createDisposable(re)}$provideTypeDefinition(W,Q,te,re){return this._withAdapter(W,l,K=>K.provideTypeDefinition(g.URI.revive(Q),te,re),[])}registerHoverProvider(W,Q,te,re){const K=this._addNewAdapter(new b(this._documents,te),W);return this._proxy.$registerHoverProvider(K,this._transformDocumentSelector(Q)),this._createDisposable(K)}$provideHover(W,Q,te,re){return this._withAdapter(W,b,K=>K.provideHover(g.URI.revive(Q),te,re),void 0)}registerEvaluatableExpressionProvider(W,Q,te,re){const K=this._addNewAdapter(new p(this._documents,te),W);return this._proxy.$registerEvaluatableExpressionProvider(K,this._transformDocumentSelector(Q)),this._createDisposable(K)}$provideEvaluatableExpression(W,Q,te,re){return this._withAdapter(W,p,K=>K.provideEvaluatableExpression(g.URI.revive(Q),te,re),void 0)}registerInlineValuesProvider(W,Q,te,re){const K=typeof te.onDidChangeInlineValues=="function"?this._nextHandle():void 0,se=this._addNewAdapter(new P(this._documents,te),W);this._proxy.$registerInlineValuesProvider(se,this._transformDocumentSelector(Q),K);let he=this._createDisposable(se);if(K!==void 0){const Ae=te.onDidChangeInlineValues(Be=>this._proxy.$emitInlineValuesEvent(K));he=E.Disposable.from(he,Ae)}return he}$provideInlineValues(W,Q,te,re,K){return this._withAdapter(W,P,se=>se.provideInlineValues(g.URI.revive(Q),te,re,K),void 0)}registerDocumentHighlightProvider(W,Q,te){const re=this._addNewAdapter(new A(this._documents,te),W);return this._proxy.$registerDocumentHighlightProvider(re,this._transformDocumentSelector(Q)),this._createDisposable(re)}$provideDocumentHighlights(W,Q,te,re){return this._withAdapter(W,A,K=>K.provideDocumentHighlights(g.URI.revive(Q),te,re),void 0)}registerLinkedEditingRangeProvider(W,Q,te){const re=this._addNewAdapter(new a(this._documents,te),W);return this._proxy.$registerLinkedEditingRangeProvider(re,this._transformDocumentSelector(Q)),this._createDisposable(re)}$provideLinkedEditingRanges(W,Q,te,re){return this._withAdapter(W,a,async K=>{const se=await K.provideLinkedEditingRanges(g.URI.revive(Q),te,re);if(se)return{ranges:se.ranges,wordPattern:se.wordPattern?Qe._serializeRegExp(se.wordPattern):void 0}},void 0)}registerReferenceProvider(W,Q,te){const re=this._addNewAdapter(new F(this._documents,te),W);return this._proxy.$registerReferenceSupport(re,this._transformDocumentSelector(Q)),this._createDisposable(re)}$provideReferences(W,Q,te,re,K){return this._withAdapter(W,F,se=>se.provideReferences(g.URI.revive(Q),te,re,K),void 0)}registerCodeActionProvider(W,Q,te,re){var K,se;const he=new h.DisposableStore,Ae=this._addNewAdapter(new N(this._documents,this._commands.converter,this._diagnostics,te,this._logService,W,this._apiDeprecation),W);return this._proxy.$registerQuickFixSupport(Ae,this._transformDocumentSelector(Q),{providedKinds:(K=re==null?void 0:re.providedCodeActionKinds)===null||K===void 0?void 0:K.map(Be=>Be.value),documentation:(se=re==null?void 0:re.documentation)===null||se===void 0?void 0:se.map(Be=>({kind:Be.kind.value,command:this._commands.converter.toInternal(Be.command,he)}))},Qe._extLabel(W),Boolean(te.resolveCodeAction)),he.add(this._createDisposable(Ae)),he}$provideCodeActions(W,Q,te,re,K){return this._withAdapter(W,N,se=>se.provideCodeActions(g.URI.revive(Q),te,re,K),void 0)}$resolveCodeAction(W,Q,te){return this._withAdapter(W,N,re=>re.resolveCodeAction(Q,te),void 0)}$releaseCodeActions(W,Q){this._withAdapter(W,N,te=>Promise.resolve(te.releaseCodeActions(Q)),void 0)}registerDocumentFormattingEditProvider(W,Q,te){const re=this._addNewAdapter(new H(this._documents,te),W);return this._proxy.$registerDocumentFormattingSupport(re,this._transformDocumentSelector(Q),W.identifier,W.displayName||W.name),this._createDisposable(re)}$provideDocumentFormattingEdits(W,Q,te,re){return this._withAdapter(W,H,K=>K.provideDocumentFormattingEdits(g.URI.revive(Q),te,re),void 0)}registerDocumentRangeFormattingEditProvider(W,Q,te){const re=this._addNewAdapter(new le(this._documents,te),W);return this._proxy.$registerRangeFormattingSupport(re,this._transformDocumentSelector(Q),W.identifier,W.displayName||W.name),this._createDisposable(re)}$provideDocumentRangeFormattingEdits(W,Q,te,re,K){return this._withAdapter(W,le,se=>se.provideDocumentRangeFormattingEdits(g.URI.revive(Q),te,re,K),void 0)}registerOnTypeFormattingEditProvider(W,Q,te,re){const K=this._addNewAdapter(new fe(this._documents,te),W);return this._proxy.$registerOnTypeFormattingSupport(K,this._transformDocumentSelector(Q),re,W.identifier),this._createDisposable(K)}$provideOnTypeFormattingEdits(W,Q,te,re,K,se){return this._withAdapter(W,fe,he=>he.provideOnTypeFormattingEdits(g.URI.revive(Q),te,re,K,se),void 0)}registerWorkspaceSymbolProvider(W,Q){const te=this._addNewAdapter(new X(Q,this._logService),W);return this._proxy.$registerNavigateTypeSupport(te),this._createDisposable(te)}$provideWorkspaceSymbols(W,Q,te){return this._withAdapter(W,X,re=>re.provideWorkspaceSymbols(Q,te),{symbols:[]})}$resolveWorkspaceSymbol(W,Q,te){return this._withAdapter(W,X,re=>re.resolveWorkspaceSymbol(Q,te),void 0)}$releaseWorkspaceSymbols(W,Q){this._withAdapter(W,X,te=>te.releaseWorkspaceSymbols(Q),void 0)}registerRenameProvider(W,Q,te){const re=this._addNewAdapter(new z(this._documents,te,this._logService),W);return this._proxy.$registerRenameSupport(re,this._transformDocumentSelector(Q),z.supportsResolving(te)),this._createDisposable(re)}$provideRenameEdits(W,Q,te,re,K){return this._withAdapter(W,z,se=>se.provideRenameEdits(g.URI.revive(Q),te,re,K),void 0)}$resolveRenameLocation(W,Q,te,re){return this._withAdapter(W,z,K=>K.resolveRenameLocation(g.URI.revive(Q),te,re),void 0)}registerDocumentSemanticTokensProvider(W,Q,te,re){const K=this._nextHandle(),se=typeof te.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(K,new Je(new R(this._documents,te),W)),this._proxy.$registerDocumentSemanticTokensProvider(K,this._transformDocumentSelector(Q),re,se);let he=this._createDisposable(K);if(se){const Ae=te.onDidChangeSemanticTokens(Be=>this._proxy.$emitDocumentSemanticTokensEvent(se));he=E.Disposable.from(he,Ae)}return he}$provideDocumentSemanticTokens(W,Q,te,re){return this._withAdapter(W,R,K=>K.provideDocumentSemanticTokens(g.URI.revive(Q),te,re),null,!0)}$releaseDocumentSemanticTokens(W,Q){this._withAdapter(W,R,te=>te.releaseDocumentSemanticColoring(Q),void 0)}registerDocumentRangeSemanticTokensProvider(W,Q,te,re){const K=this._addNewAdapter(new B(this._documents,te),W);return this._proxy.$registerDocumentRangeSemanticTokensProvider(K,this._transformDocumentSelector(Q),re),this._createDisposable(K)}$provideDocumentRangeSemanticTokens(W,Q,te,re){return this._withAdapter(W,B,K=>K.provideDocumentRangeSemanticTokens(g.URI.revive(Q),te,re),null,!0)}registerCompletionItemProvider(W,Q,te,re){const K=this._addNewAdapter(new M(this._documents,this._commands.converter,te,this._apiDeprecation,W),W);return this._proxy.$registerSuggestSupport(K,this._transformDocumentSelector(Q),re,M.supportsResolving(te),`${W.identifier.value}(${re.join("")})`),this._createDisposable(K)}$provideCompletionItems(W,Q,te,re,K){return this._withAdapter(W,M,se=>se.provideCompletionItems(g.URI.revive(Q),te,re,K),void 0)}$resolveCompletionItem(W,Q,te){return this._withAdapter(W,M,re=>re.resolveCompletionItem(Q,te),void 0)}$releaseCompletionItems(W,Q){this._withAdapter(W,M,te=>te.releaseCompletionItems(Q),void 0)}registerInlineCompletionsProvider(W,Q,te){const re=this._addNewAdapter(new U(this._documents,te,this._commands.converter),W);return this._proxy.$registerInlineCompletionsSupport(re,this._transformDocumentSelector(Q)),this._createDisposable(re)}$provideInlineCompletions(W,Q,te,re,K){return this._withAdapter(W,U,se=>se.provideInlineCompletions(g.URI.revive(Q),te,re,K),void 0)}$handleInlineCompletionDidShow(W,Q,te){this._withAdapter(W,U,async re=>{re.handleDidShowCompletionItem(Q,te)},void 0)}$freeInlineCompletionsList(W,Q){this._withAdapter(W,U,async te=>{te.disposeCompletions(Q)},void 0)}registerSignatureHelpProvider(W,Q,te,re){const K=Array.isArray(re)?{triggerCharacters:re,retriggerCharacters:[]}:re,se=this._addNewAdapter(new V(this._documents,te),W);return this._proxy.$registerSignatureHelpProvider(se,this._transformDocumentSelector(Q),K),this._createDisposable(se)}$provideSignatureHelp(W,Q,te,re,K){return this._withAdapter(W,V,se=>se.provideSignatureHelp(g.URI.revive(Q),te,re,K),void 0)}$releaseSignatureHelp(W,Q){this._withAdapter(W,V,te=>te.releaseSignatureHelp(Q),void 0)}registerInlayHintsProvider(W,Q,te){const re=typeof te.onDidChangeInlayHints=="function"?this._nextHandle():void 0,K=this._addNewAdapter(new oe(this._documents,te),W);this._proxy.$registerInlayHintsProvider(K,this._transformDocumentSelector(Q),re);let se=this._createDisposable(K);if(re!==void 0){const he=te.onDidChangeInlayHints(Ae=>this._proxy.$emitInlayHintsEvent(re));se=E.Disposable.from(se,he)}return se}$provideInlayHints(W,Q,te,re){return this._withAdapter(W,oe,K=>K.provideInlayHints(g.URI.revive(Q),te,re),void 0)}registerDocumentLinkProvider(W,Q,te){const re=this._addNewAdapter(new ge(this._documents,te),W);return this._proxy.$registerDocumentLinkProvider(re,this._transformDocumentSelector(Q),typeof te.resolveDocumentLink=="function"),this._createDisposable(re)}$provideDocumentLinks(W,Q,te){return this._withAdapter(W,ge,re=>re.provideLinks(g.URI.revive(Q),te),void 0)}$resolveDocumentLink(W,Q,te){return this._withAdapter(W,ge,re=>re.resolveLink(Q,te),void 0)}$releaseDocumentLinks(W,Q){this._withAdapter(W,ge,te=>te.releaseLinks(Q),void 0)}registerColorProvider(W,Q,te){const re=this._addNewAdapter(new Re(this._documents,te),W);return this._proxy.$registerDocumentColorProvider(re,this._transformDocumentSelector(Q)),this._createDisposable(re)}$provideDocumentColors(W,Q,te){return this._withAdapter(W,Re,re=>re.provideColors(g.URI.revive(Q),te),[])}$provideColorPresentations(W,Q,te,re){return this._withAdapter(W,Re,K=>K.provideColorPresentations(g.URI.revive(Q),te,re),void 0)}registerFoldingRangeProvider(W,Q,te){const re=this._nextHandle(),K=typeof te.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(re,new Je(new $e(this._documents,te),W)),this._proxy.$registerFoldingRangeProvider(re,this._transformDocumentSelector(Q),K);let se=this._createDisposable(re);if(K!==void 0){const he=te.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(K));se=E.Disposable.from(se,he)}return se}$provideFoldingRanges(W,Q,te,re){return this._withAdapter(W,$e,K=>K.provideFoldingRanges(g.URI.revive(Q),te,re),void 0)}registerSelectionRangeProvider(W,Q,te){const re=this._addNewAdapter(new Me(this._documents,te,this._logService),W);return this._proxy.$registerSelectionRangeProvider(re,this._transformDocumentSelector(Q)),this._createDisposable(re)}$provideSelectionRanges(W,Q,te,re){return this._withAdapter(W,Me,K=>K.provideSelectionRanges(g.URI.revive(Q),te,re),[])}registerCallHierarchyProvider(W,Q,te){const re=this._addNewAdapter(new We(this._documents,te),W);return this._proxy.$registerCallHierarchyProvider(re,this._transformDocumentSelector(Q)),this._createDisposable(re)}$prepareCallHierarchy(W,Q,te,re){return this._withAdapter(W,We,K=>Promise.resolve(K.prepareSession(g.URI.revive(Q),te,re)),void 0)}$provideCallHierarchyIncomingCalls(W,Q,te,re){return this._withAdapter(W,We,K=>K.provideCallsTo(Q,te,re),void 0)}$provideCallHierarchyOutgoingCalls(W,Q,te,re){return this._withAdapter(W,We,K=>K.provideCallsFrom(Q,te,re),void 0)}$releaseCallHierarchy(W,Q){this._withAdapter(W,We,te=>Promise.resolve(te.releaseSession(Q)),void 0)}static _serializeRegExp(W){return{pattern:W.source,flags:_.regExpFlags(W)}}static _serializeIndentationRule(W){return{decreaseIndentPattern:Qe._serializeRegExp(W.decreaseIndentPattern),increaseIndentPattern:Qe._serializeRegExp(W.increaseIndentPattern),indentNextLinePattern:W.indentNextLinePattern?Qe._serializeRegExp(W.indentNextLinePattern):void 0,unIndentedLinePattern:W.unIndentedLinePattern?Qe._serializeRegExp(W.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(W){return{beforeText:Qe._serializeRegExp(W.beforeText),afterText:W.afterText?Qe._serializeRegExp(W.afterText):void 0,previousLineText:W.previousLineText?Qe._serializeRegExp(W.previousLineText):void 0,action:W.action}}static _serializeOnEnterRules(W){return W.map(Qe._serializeOnEnterRule)}setLanguageConfiguration(W,Q,te){let{wordPattern:re}=te;if(re&&_.regExpLeadsToEndlessLoop(re))throw new Error(`Invalid language configuration: wordPattern '${re}' is not allowed to match the empty string.`);re?this._documents.setWordDefinitionFor(Q,re):this._documents.setWordDefinitionFor(Q,void 0),te.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",W,"Do not use."),te.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",W,"Do not use.");const K=this._nextHandle(),se={comments:te.comments,brackets:te.brackets,wordPattern:te.wordPattern?Qe._serializeRegExp(te.wordPattern):void 0,indentationRules:te.indentationRules?Qe._serializeIndentationRule(te.indentationRules):void 0,onEnterRules:te.onEnterRules?Qe._serializeOnEnterRules(te.onEnterRules):void 0,__electricCharacterSupport:te.__electricCharacterSupport,__characterPairSupport:te.__characterPairSupport};return this._proxy.$setLanguageConfiguration(K,Q,se),this._createDisposable(K)}$setWordDefinitions(W){for(const Q of W)this._documents.setWordDefinitionFor(Q.languageId,new RegExp(Q.regexSource,Q.regexFlags))}}e.ExtHostLanguageFeatures=Qe,Qe._handlePool=0}),define(we[187],_e([0,1,4,9,6]),function(Z,e,g,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class E{constructor(y,_){this._proxy=y.getProxy(g.MainContext.MainThreadLanguages),this._documents=_}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(y,_){await this._proxy.$changeLanguage(y,_);const k=this._documents.getDocumentData(y);if(!k)throw new Error(`document '${y.toString}' NOT found`);return k.document}async tokenAtPosition(y,_){var k;const n=y.version,I=T.Position.from(_),o=await this._proxy.$tokensAtPosition(y.uri,I),h={type:D.StandardTokenType.Other,range:(k=y.getWordRangeAtPosition(_))!==null&&k!==void 0?k:new D.Range(_.line,_.character,_.line,_.character)};if(!o)return h;const d={range:T.Range.to(o.range),type:T.TokenType.to(o.type)};return!d.range.contains(_)||n!==y.version?h:d}}e.ExtHostLanguages=E}),define(we[188],_e([0,1,4,17,29]),function(Z,e,g,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function E(y){return y&&y.title}let C=class{constructor(_,k){this._logService=k,this._proxy=_.getProxy(g.MainContext.MainThreadMessageService)}showMessage(_,k,n,I,o){const h={extension:_};let d;typeof I=="string"||E(I)?d=[I,...o]:(h.modal=I&&I.modal,h.useCustom=I&&I.useCustom,d=o),h.useCustom&&D.checkProposedApiEnabled(_);const u=[];for(let w=0;w<d.length;w++){const v=d[w];if(typeof v=="string")u.push({title:v,handle:w,isCloseAffordance:!1});else if(typeof v=="object"){let{title:S,isCloseAffordance:c}=v;u.push({title:S,isCloseAffordance:!!c,handle:w})}else this._logService.warn("Invalid message item:",v)}return this._proxy.$showMessage(k,n,h,u).then(w=>{if(typeof w=="number")return d[w]})}};C=He([ze(1,T.ILogService)],C),e.ExtHostMessageService=C}),define(we[189],_e([0,1,23,3,53,49,7,22,8,10,2,63,4,9,6,45,167,95]),function(Z,e,g,T,D,E,C,y,_,k,n,I,o,h,d,u,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=e.NotebookEditorDecorationType=void 0;class S{constructor(f,t){const r=S._Keys.nextId();f.$registerNotebookEditorDecorationType(r,h.NotebookDecorationRenderOptions.from(t)),this.value={key:r,dispose(){f.$removeNotebookEditorDecorationType(r)}}}}e.NotebookEditorDecorationType=S,S._Keys=new E.IdGenerator("NotebookEditorDecorationType");class c{constructor(f,t,r,i,s,l){this._textDocumentsAndEditors=r,this._textDocuments=i,this.logService=s,this._extensionStoragePaths=l,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new y.ResourceMap,this._editors=new Map,this._onDidChangeNotebookEditorSelection=new T.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this._onDidChangeNotebookEditorVisibleRanges=new T.Emitter,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event,this._onDidChangeNotebookDocumentMetadata=new T.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidChangeNotebookCells=new T.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new T.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new T.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new T.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new T.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new T.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new T.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidSaveNotebookDocument=new T.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new T.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new I.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=f.getProxy(o.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=f.getProxy(o.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=f.getProxy(o.MainContext.MainThreadNotebookEditors),this._commandsConverter=t.converter,t.registerArgumentProcessor({processArgument:b=>{var p;if(b&&b.$mid===12){const P=(p=b.notebookEditor)===null||p===void 0?void 0:p.notebookUri,A=b.cell.handle,a=this._documents.get(P),F=a==null?void 0:a.getCell(A);if(F)return F.apiCell}return b}})}get activeNotebookEditor(){var f;return(f=this._activeNotebookEditor)===null||f===void 0?void 0:f.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(f=>f.apiEditor)}getEditorById(f){return this._editors.get(f)}getIdByEditor(f){for(const[t,r]of this._editors)if(r.apiEditor===f)return t}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(f,t){const r=this._documents.get(f);if(!r&&!t)throw new Error(`NO notebook document for '${f}'`);return r}_getProviderData(f){const t=this._notebookContentProviders.get(f);if(!t)throw new Error(`NO provider for '${f}'`);return t}registerNotebookContentProvider(f,t,r,i,s){if(_.isFalsyOrWhitespace(t))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(t))throw new Error(`Notebook provider for '${t}' already registered`);this._notebookContentProviders.set(t,{extension:f,provider:r});let l;return r.onDidChangeNotebookContentOptions&&(l=r.onDidChangeNotebookContentOptions(()=>{const b=h.NotebookDocumentContentOptions.from(r.options);this._notebookProxy.$updateNotebookProviderOptions(t,b)})),this._notebookProxy.$registerNotebookProvider({id:f.identifier,location:f.extensionLocation},t,h.NotebookDocumentContentOptions.from(i),c._convertNotebookRegistrationData(f,s)),new d.Disposable(()=>{l==null||l.dispose(),this._notebookContentProviders.delete(t),this._notebookProxy.$unregisterNotebookProvider(t)})}static _convertNotebookRegistrationData(f,t){if(!t)return;const r=t.filenamePattern.map(i=>h.NotebookExclusiveDocumentPattern.from(i)).filter(i=>i!==void 0);if(t.filenamePattern&&!r){console.warn(`Notebook content provider view options file name pattern is invalid ${t.filenamePattern}`);return}return{extension:f.identifier,providerDisplayName:f.displayName||f.name,displayName:t.displayName,filenamePattern:r,exclusive:t.exclusive||!1}}registerNotebookCellStatusBarItemProvider(f,t,r){const i=c._notebookStatusBarItemProviderHandlePool++,s=typeof r.onDidChangeCellStatusBarItems=="function"?c._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(i,r),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(i,s,t);let l;return s!==void 0&&(l=r.onDidChangeCellStatusBarItems(b=>this._notebookProxy.$emitCellStatusBarEvent(s))),new d.Disposable(()=>{this._notebookStatusBarItemProviders.delete(i),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(i,s),l&&l.dispose()})}createNotebookEditorDecorationType(f){return new S(this._notebookEditorsProxy,f).value}async createNotebookDocument(f){const t=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:f.viewType,content:f.content&&h.NotebookData.from(f.content)});return n.URI.revive(t)}async openNotebookDocument(f){const t=this._documents.get(f);if(t)return t.apiNotebook;const r=await this._notebookDocumentsProxy.$tryOpenNotebook(f),i=this._documents.get(n.URI.revive(r));return k.assertIsDefined(i==null?void 0:i.apiNotebook)}async showNotebookDocument(f,t){var r;n.URI.isUri(f)&&(f=await this.openNotebookDocument(f));let i;typeof t=="object"?i={position:h.ViewColumn.from(t.viewColumn),preserveFocus:t.preserveFocus,selections:t.selections&&t.selections.map(h.NotebookRange.from),pinned:typeof t.preview=="boolean"?!t.preview:void 0}:i={preserveFocus:!1};const s=await this._notebookEditorsProxy.$tryShowNotebookDocument(f.uri,f.notebookType,i),l=s&&((r=this._editors.get(s))===null||r===void 0?void 0:r.apiEditor);if(l)return l;throw s?new Error(`Could NOT open editor for "${f.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${f.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(f,t,r,i){const s=this._notebookStatusBarItemProviders.get(f),l=n.URI.revive(t),b=this._documents.get(l);if(!b||!s)return;const p=b.getCellFromIndex(r);if(!p)return;const P=await s.provideCellStatusBarItems(p.apiCell,i);if(!P)return;const A=new C.DisposableStore,a=this._statusBarCache.add([A]),N=(Array.isArray(P)?P:[P]).map(H=>h.NotebookStatusBarItem.from(H,this._commandsConverter,A));return{cacheId:a,items:N}}$releaseNotebookCellStatusBarItems(f){this._statusBarCache.delete(f)}registerNotebookSerializer(f,t,r,i,s){if(_.isFalsyOrWhitespace(t))throw new Error("viewType cannot be empty or just whitespace");const l=this._handlePool++;return this._notebookSerializer.set(l,r),this._notebookProxy.$registerNotebookSerializer(l,{id:f.identifier,location:f.extensionLocation},t,h.NotebookDocumentContentOptions.from(i),c._convertNotebookRegistrationData(f,s)),C.toDisposable(()=>{this._notebookProxy.$unregisterNotebookSerializer(l)})}async $dataToNotebook(f,t,r){const i=this._notebookSerializer.get(f);if(!i)throw new Error("NO serializer found");const s=await i.deserializeNotebook(t.buffer,r);return h.NotebookData.from(s)}async $notebookToData(f,t,r){const i=this._notebookSerializer.get(f);if(!i)throw new Error("NO serializer found");const s=await i.serializeNotebook(h.NotebookData.to(t),r);return g.VSBuffer.wrap(s)}async $openNotebook(f,t,r,i,s){var l;const{provider:b}=this._getProviderData(f),p=await b.openNotebook(n.URI.revive(t),{backupId:r,untitledDocumentData:i==null?void 0:i.buffer},s);return{metadata:(l=p.metadata)!==null&&l!==void 0?l:Object.create(null),cells:p.cells.map(h.NotebookCellData.from)}}async $saveNotebook(f,t,r){const i=this.getNotebookDocument(n.URI.revive(t)),{provider:s}=this._getProviderData(f);return await s.saveNotebook(i.apiNotebook,r),!0}async $saveNotebookAs(f,t,r,i){const s=this.getNotebookDocument(n.URI.revive(t)),{provider:l}=this._getProviderData(f);return await l.saveNotebookAs(n.URI.revive(r),s.apiNotebook,i),!0}async $backupNotebook(f,t,r){var i;const s=this.getNotebookDocument(n.URI.revive(t)),l=this._getProviderData(f),b=(i=this._extensionStoragePaths.workspaceValue(l.extension))!==null&&i!==void 0?i:this._extensionStoragePaths.globalValue(l.extension),p=String(D.hash([s.uri.toString(),this._backupIdPool++])),P=n.URI.joinPath(b,p),A=await l.provider.backupNotebook(s.apiNotebook,{destination:P},r);return s.updateBackup(A),A.id}$acceptModelChanged(f,t,r){this.getNotebookDocument(n.URI.revive(f)).acceptModelChanged(t,r)}$acceptDirtyStateChanged(f,t){const r=this.getNotebookDocument(n.URI.revive(f));r.acceptModelChanged({rawEvents:[],versionId:r.apiNotebook.version},t)}$acceptModelSaved(f){const t=this.getNotebookDocument(n.URI.revive(f));this._onDidSaveNotebookDocument.fire(t.apiNotebook)}$acceptEditorPropertiesChanged(f,t){this.logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",f,t);const r=this._editors.get(f);if(!r)throw new Error(`unknown text editor: ${f}. known editors: ${[...this._editors.keys()]} `);t.visibleRanges&&r._acceptVisibleRanges(t.visibleRanges.ranges.map(h.NotebookRange.to)),t.selections&&r._acceptSelections(t.selections.selections.map(h.NotebookRange.to)),t.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:r.apiEditor,visibleRanges:r.apiEditor.visibleRanges}),t.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:r.apiEditor,selections:r.apiEditor.selections}))}$acceptEditorViewColumns(f){for(const t in f){const r=this._editors.get(t);if(!r)throw new Error(`unknown text editor: ${t}. known editors: ${[...this._editors.keys()]} `);r._acceptViewColumn(h.ViewColumn.to(f[t]))}}$acceptDocumentPropertiesChanged(f,t){this.logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",f.path,t);const r=this.getNotebookDocument(n.URI.revive(f));r.acceptDocumentPropertiesChanged(t),t.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:r.apiNotebook})}_createExtHostEditor(f,t,r){if(this._editors.has(t))throw new Error(`editor with id ALREADY EXSIST: ${t}`);const i=new v.ExtHostNotebookEditor(t,this._notebookEditorsProxy,f,r.visibleRanges.map(h.NotebookRange.to),r.selections.map(h.NotebookRange.to),typeof r.viewColumn=="number"?h.ViewColumn.to(r.viewColumn):void 0);this._editors.set(t,i)}$acceptDocumentAndEditorsDelta(f){var t,r,i,s;if(f.removedDocuments)for(const b of f.removedDocuments){const p=n.URI.revive(b),P=this._documents.get(p);P&&(P.dispose(),this._documents.delete(p),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:P.apiNotebook.getCells().map(A=>A.document.uri)}),this._onDidCloseNotebookDocument.fire(P.apiNotebook));for(const A of this._editors.values())A.notebookData.uri.toString()===p.toString()&&this._editors.delete(A.id)}if(f.addedDocuments){const b=[];for(const p of f.addedDocuments){const P=n.URI.revive(p.uri),A=p.viewType;if(this._documents.has(P))throw new Error(`adding EXISTING notebook ${P} `);const a=this,F=new w.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(N){a._onDidChangeNotebookCells.fire(N)},emitCellOutputsChange(N){a._onDidChangeCellOutputs.fire(N)},emitCellMetadataChange(N){a._onDidChangeCellMetadata.fire(N)},emitCellExecutionStateChange(N){a._onDidChangeCellExecutionState.fire(N)}},A,(t=p.metadata)!==null&&t!==void 0?t:Object.create({}),P);F.acceptModelChanged({versionId:p.versionId,rawEvents:[{kind:u.NotebookCellsChangeType.Initialize,changes:[[0,0,p.cells]]}]},!1),b.push(...p.cells.map(N=>w.ExtHostCell.asModelAddData(F.apiNotebook,N))),(r=this._documents.get(P))===null||r===void 0||r.dispose(),this._documents.set(P,F),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:b}),this._onDidOpenNotebookDocument.fire(F.apiNotebook)}}if(f.addedEditors)for(const b of f.addedEditors){if(this._editors.has(b.id))return;const p=n.URI.revive(b.documentUri),P=this._documents.get(p);P&&this._createExtHostEditor(P,b.id,b)}const l=[];if(f.removedEditors)for(const b of f.removedEditors){const p=this._editors.get(b);p&&(this._editors.delete(b),((i=this._activeNotebookEditor)===null||i===void 0?void 0:i.id)===p.id&&(this._activeNotebookEditor=void 0),l.push(p))}if(f.visibleEditors){this._visibleNotebookEditors=f.visibleEditors.map(p=>this._editors.get(p)).filter(p=>!!p);const b=new Set;this._visibleNotebookEditors.forEach(p=>b.add(p.id));for(const p of this._editors.values()){const P=b.has(p.id);p._acceptVisibility(P)}this._visibleNotebookEditors=[...this._editors.values()].map(p=>p).filter(p=>p.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}f.newActiveEditor===null?this._activeNotebookEditor=void 0:f.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(f.newActiveEditor)),f.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire((s=this._activeNotebookEditor)===null||s===void 0?void 0:s.apiEditor)}}e.ExtHostNotebookController=c,c._notebookStatusBarItemProviderHandlePool=0}),define(we[190],_e([0,1,3,7,4,26,2,9,68,22,11,45,18,16,17,6,29]),function(Z,e,g,T,D,E,C,y,_,k,n,I,o,h,d,u,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let v=class{constructor(t,r,i,s){this._mainContext=t,this._initData=r,this._extHostNotebook=i,this._logService=s,this._activeExecutions=new k.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=t.getProxy(D.MainContext.MainThreadNotebookKernels)}createNotebookController(t,r,i,s,l,b){for(let M of this._kernelData.values())if(M.controller.id===r&&E.ExtensionIdentifier.equals(t.identifier,M.extensionId))throw new Error(`notebook controller with id '${r}' ALREADY exist`);const p=this._handlePool++,P=this;this._logService.trace(`NotebookController[${p}], CREATED by ${t.identifier.value}, ${r}`);const A=()=>console.warn(`NO execute handler from notebook controller '${le.id}' of extension: '${t.identifier}'`);let a=!1;const F=new T.DisposableStore,N=new g.Emitter,H=new g.Emitter,le={id:`${t.identifier.value}/${r}`,notebookType:i,extensionId:t.identifier,extensionLocation:t.extensionLocation,label:s||t.identifier.value,preloads:b?b.map(y.NotebookRendererScript.from):[]};let fe=l??A,X;this._proxy.$addKernel(p,le).catch(M=>{console.log(M),a=!0});let z=0;const Y=()=>{if(a)return;const M=++z;Promise.resolve().then(()=>{M===z&&this._proxy.$updateKernel(p,le)})},R=new k.ResourceMap,B={get id(){return r},get notebookType(){return le.notebookType},onDidChangeSelectedNotebooks:N.event,get label(){return le.label},set label(M){var U;le.label=(U=M??t.displayName)!==null&&U!==void 0?U:t.name,Y()},get detail(){var M;return(M=le.detail)!==null&&M!==void 0?M:""},set detail(M){le.detail=M,Y()},get description(){var M;return(M=le.description)!==null&&M!==void 0?M:""},set description(M){le.description=M,Y()},get supportedLanguages(){return le.supportedLanguages},set supportedLanguages(M){le.supportedLanguages=M,Y()},get supportsExecutionOrder(){var M;return(M=le.supportsExecutionOrder)!==null&&M!==void 0?M:!1},set supportsExecutionOrder(M){le.supportsExecutionOrder=M,Y()},get rendererScripts(){return le.preloads?le.preloads.map(y.NotebookRendererScript.to):[]},get executeHandler(){return fe},set executeHandler(M){fe=M??A},get interruptHandler(){return X},set interruptHandler(M){X=M,le.supportsInterrupt=Boolean(M),Y()},createNotebookCellExecution(M){if(a)throw new Error("notebook controller is DISPOSED");if(!R.has(M.notebook.uri))throw P._logService.trace(`NotebookController[${p}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(R.keys()).map(U=>U.toString())),new Error(`notebook controller is NOT associated to notebook: ${M.notebook.uri.toString()}`);return P._createNotebookCellExecution(M)},dispose:()=>{a||(this._logService.trace(`NotebookController[${p}], DISPOSED`),a=!0,this._kernelData.delete(p),F.dispose(),N.dispose(),H.dispose(),this._proxy.$removeKernel(p))},updateNotebookAffinity(M,U){P._proxy.$updateNotebookPriority(p,M.uri,U)},onDidReceiveMessage:H.event,postMessage(M,U){return w.checkProposedApiEnabled(t),P._proxy.$postMessage(p,U&&P._extHostNotebook.getIdByEditor(U),M)},asWebviewUri(M){return w.checkProposedApiEnabled(t),_.asWebviewUri(M,P._initData.remote)}};return this._kernelData.set(p,{extensionId:t.identifier,controller:B,onDidReceiveMessage:H,onDidChangeSelection:N,associatedNotebooks:R}),B}$acceptNotebookAssociation(t,r,i){const s=this._kernelData.get(t);if(s){const l=this._extHostNotebook.getNotebookDocument(C.URI.revive(r));i?s.associatedNotebooks.set(l.uri,!0):s.associatedNotebooks.delete(l.uri),this._logService.trace(`NotebookController[${t}] ASSOCIATE notebook`,l.uri.toString(),i),s.onDidChangeSelection.fire({selected:i,notebook:l.apiNotebook})}}async $executeCells(t,r,i){const s=this._kernelData.get(t);if(!s)return;const l=this._extHostNotebook.getNotebookDocument(C.URI.revive(r)),b=[];for(let p of i){const P=l.getCell(p);P&&b.push(P.apiCell)}try{this._logService.trace(`NotebookController[${t}] EXECUTE cells`,l.uri.toString(),b.length),await s.controller.executeHandler.call(s.controller,b,l.apiNotebook,s.controller)}catch(p){this._logService.error(`NotebookController[${t}] execute cells FAILED`,p),console.error(p)}}async $cancelCells(t,r,i){var s;const l=this._kernelData.get(t);if(!l)return;const b=this._extHostNotebook.getNotebookDocument(C.URI.revive(r));if(l.controller.interruptHandler)await l.controller.interruptHandler.call(l.controller,b.apiNotebook);else for(let p of i){const P=b.getCell(p);P&&((s=this._activeExecutions.get(P.uri))===null||s===void 0||s.cancel())}}$acceptKernelMessageFromRenderer(t,r,i){const s=this._kernelData.get(t);if(!s)return;const l=this._extHostNotebook.getEditorById(r);if(!l)throw new Error(`send message for UNKNOWN editor: ${r}`);s.onDidReceiveMessage.fire(Object.freeze({editor:l.apiEditor,message:i}))}_createNotebookCellExecution(t){if(t.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const i=this._extHostNotebook.getNotebookDocument(t.notebook.uri).getCellFromApiCell(t);if(!i)throw new Error("invalid cell");if(this._activeExecutions.has(i.uri))throw new Error(`duplicate execution for ${i.uri}`);const s=new c(i.notebook,i,this._mainContext.getProxy(D.MainContext.MainThreadNotebookDocuments));this._activeExecutions.set(i.uri,s);const l=s.onDidChangeState(()=>{s.state===S.Resolved&&(s.dispose(),l.dispose(),this._activeExecutions.delete(i.uri))});return s.asApiObject()}};v=He([ze(3,d.ILogService)],v),e.ExtHostNotebookKernels=v;var S;(function(f){f[f.Init=0]="Init",f[f.Started=1]="Started",f[f.Resolved=2]="Resolved"})(S||(S={}));class c extends T.Disposable{constructor(t,r,i){super();this._document=t,this._cell=r,this._proxy=i,this._onDidChangeState=new g.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=S.Init,this._tokenSource=this._register(new o.CancellationTokenSource),this._collector=new m(10,s=>this.applyEdits(s)),this._executionOrder=r.internalMetadata.executionOrder,this.mixinMetadata({runState:I.NotebookCellExecutionState.Pending,executionOrder:null})}get state(){return this._state}cancel(){this._tokenSource.cancel()}async applyEditSoon(t){await this._collector.addItem(t)}async applyEdits(t){return this._proxy.$applyEdits(this._document.uri,t,!1)}verifyStateForOutput(){if(this._state===S.Init)throw new Error("Must call start before modifying cell output");if(this._state===S.Resolved)throw new Error("Cannot modify cell output after calling resolve")}mixinMetadata(t){const r={editType:9,handle:this._cell.handle,internalMetadata:t};this.applyEdits([r])}cellIndexToHandle(t){let r=this._cell;if(typeof t=="number"?r=this._document.getCellFromIndex(t):t&&(r=this._document.getCellFromApiCell(t)),!r)throw new Error("INVALID cell");return r.handle}validateAndConvertOutputs(t){return t.map(r=>{const i=u.NotebookCellOutput.ensureUniqueMimeTypes(r.items,!0);return i===r.items?y.NotebookCellOutput.from(r):y.NotebookCellOutput.from({items:i,id:r.id,metadata:r.metadata})})}async updateOutputs(t,r,i){const s=this.cellIndexToHandle(r),l=this.validateAndConvertOutputs(h.asArray(t));return this.applyEditSoon({editType:2,handle:s,append:i,outputs:l})}async updateOutputItems(t,r,i){return u.NotebookCellOutput.isNotebookCellOutput(r)&&(r=r.id),t=u.NotebookCellOutput.ensureUniqueMimeTypes(h.asArray(t),!0),this.applyEditSoon({editType:7,items:t.map(y.NotebookCellOutputItem.from),outputId:r,append:i})}asApiObject(){const t=this;return Object.freeze({get token(){return t._tokenSource.token},get cell(){return t._cell.apiCell},get executionOrder(){return t._executionOrder},set executionOrder(i){t._executionOrder=i,t.mixinMetadata({executionOrder:i})},start(i){if(t._state===S.Resolved||t._state===S.Started)throw new Error("Cannot call start again");t._state=S.Started,t._onDidChangeState.fire(),t.mixinMetadata({runState:I.NotebookCellExecutionState.Executing,runStartTime:i??null})},end(i,s){if(t._state===S.Resolved)throw new Error("Cannot call resolve twice");t._state=S.Resolved,t._onDidChangeState.fire(),t.mixinMetadata({runState:null,lastRunSuccess:i??null,runEndTime:s??null})},clearOutput(i){return t.verifyStateForOutput(),t.updateOutputs([],i,!1)},appendOutput(i,s){return t.verifyStateForOutput(),t.updateOutputs(i,s,!0)},replaceOutput(i,s){return t.verifyStateForOutput(),t.updateOutputs(i,s,!1)},appendOutputItems(i,s){return t.verifyStateForOutput(),t.updateOutputItems(i,s,!0)},replaceOutputItems(i,s){return t.verifyStateForOutput(),t.updateOutputItems(i,s,!1)}})}}class m{constructor(t,r){this.delay=t,this.callback=r,this.batch=[]}addItem(t){return this.batch.push(t),this.waitPromise||(this.waitPromise=n.timeout(this.delay).then(()=>{this.waitPromise=void 0;const r=this.batch;return this.batch=[],this.callback(r)})),this.waitPromise}}}),define(we[191],_e([0,1,3,4,95]),function(Z,e,g,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class E{constructor(y,_){this._extHostNotebook=_,this._rendererMessageEmitters=new Map,this.proxy=y.getProxy(T.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(y,_,k){var n;const I=this._extHostNotebook.getEditorById(y);!I||(n=this._rendererMessageEmitters.get(_))===null||n===void 0||n.fire({editor:I.apiEditor,message:k})}createRendererMessaging(y){return{onDidReceiveMessage:(...k)=>this.getOrCreateEmitterFor(y).event(...k),postMessage:(k,n)=>{const I=D.ExtHostNotebookEditor.apiEditorsToExtHost.get(k);if(!I)throw new Error("The first argument to postMessage() must be a NotebookEditor");this.proxy.$postMessage(I.id,y,n)}}}getOrCreateEmitterFor(y){let _=this._rendererMessageEmitters.get(y);return _||(_=new g.Emitter({onLastListenerRemove:()=>{_==null||_.dispose(),this._rendererMessageEmitters.delete(y)}}),this._rendererMessageEmitters.set(y,_),_)}}e.ExtHostNotebookRenderers=E}),define(we[99],_e([0,1,4,3,7,23,5,14]),function(Z,e,g,T,D,E,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class _ extends D.Disposable{constructor(d,u,w,v){super();this._onDidAppend=this._register(new T.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=d,this._proxy=v,this._id=v.$register(this.name,u,w),this._disposed=!1,this._offset=0}get name(){return this._name}append(d){this.validate(),this._offset+=d?E.VSBuffer.fromString(d).byteLength:0}update(){this._id.then(d=>this._proxy.$update(d))}appendLine(d){this.validate(),this.append(d+`
`)}clear(){this.validate();const d=this._offset;this._id.then(u=>this._proxy.$clear(u,d))}show(d,u){this.validate(),this._id.then(w=>this._proxy.$reveal(w,!!(typeof d=="boolean"?d:u)))}hide(){this.validate(),this._id.then(d=>this._proxy.$close(d))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(d=>this._proxy.$dispose(d)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=_;class k extends _{constructor(d,u){super(d,!1,void 0,u)}append(d){super.append(d),this._id.then(u=>this._proxy.$append(u,d)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=k;class n extends _{constructor(d,u,w){super(d,!0,u,w)}append(d){throw new Error("Not supported")}}class I{constructor(d,u){this.name=d,this._channel=u}append(d){this._channel.then(u=>u.append(d))}appendLine(d){this._channel.then(u=>u.appendLine(d))}clear(){this._channel.then(d=>d.clear())}show(d,u){this._channel.then(w=>w.show(d,u))}hide(){this._channel.then(d=>d.hide())}dispose(){this._channel.then(d=>d.dispose())}}e.LazyOutputChannel=I;let o=class{constructor(d){this._proxy=d.getProxy(g.MainContext.MainThreadOutputService)}$setVisibleChannel(d){}createOutputChannel(d){if(d=d.trim(),!d)throw new Error("illegal argument `name`. must not be falsy");return new k(d,this._proxy)}createOutputChannelFromLogFile(d,u){if(d=d.trim(),!d)throw new Error("illegal argument `name`. must not be falsy");if(!u)throw new Error("illegal argument `file`. must not be falsy");return new n(d,u,this._proxy)}};o=He([ze(0,y.IExtHostRpcService)],o),e.ExtHostOutputService=o,e.IExtHostOutputService=C.createDecorator("IExtHostOutputService")}),define(we[192],_e([0,1,11,18,3,7,4,2,6,12,16,41]),function(Z,e,g,T,D,E,C,y,_,k,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function o(h,d,u){const w=h.getProxy(C.MainContext.MainThreadQuickOpen);class v{constructor(s,l){this._sessions=new Map,this._instances=0,this._workspace=s,this._commands=l}showQuickPick(s,l,b,p=T.CancellationToken.None){this._onDidSelectItem=void 0;const P=Promise.resolve(s),A=++this._instances,a=w.$show(A,{title:b==null?void 0:b.title,placeHolder:b==null?void 0:b.placeHolder,matchOnDescription:b==null?void 0:b.matchOnDescription,matchOnDetail:b==null?void 0:b.matchOnDetail,ignoreFocusLost:b==null?void 0:b.ignoreFocusOut,canPickMany:b==null?void 0:b.canPickMany},p),F={},N=a.then(()=>F);return Promise.race([N,P]).then(H=>{if(H!==F)return P.then(le=>{const fe=[];for(let X=0;X<le.length;X++){const z=le[X];let Y,R,B,M,U;typeof z=="string"?Y=z:(Y=z.label,R=z.description,B=z.detail,M=z.picked,U=z.alwaysShow),fe.push({label:Y,description:R,handle:X,detail:B,picked:M,alwaysShow:U})}return b&&typeof b.onDidSelectItem=="function"&&(this._onDidSelectItem=X=>{b.onDidSelectItem(le[X])}),w.$setItems(A,fe),a.then(X=>{if(typeof X=="number")return le[X];if(Array.isArray(X))return X.map(z=>le[z])})})}).then(void 0,H=>{if(!k.isPromiseCanceledError(H))return w.$setError(A,H),Promise.reject(H)})}$onItemSelected(s){this._onDidSelectItem&&this._onDidSelectItem(s)}showInput(s,l=T.CancellationToken.None){return this._validateInput=s?s.validateInput:void 0,w.$input(s,typeof this._validateInput=="function",l).then(void 0,b=>{if(!k.isPromiseCanceledError(b))return Promise.reject(b)})}$validateInput(s){return this._validateInput?g.asPromise(()=>this._validateInput(s)):Promise.resolve(void 0)}async showWorkspaceFolderPick(s,l=T.CancellationToken.None){const b=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[s]);if(!b)return;const p=await this._workspace.getWorkspaceFolders2();if(!!p)return p.find(P=>P.uri.toString()===b.uri.toString())}createQuickPick(s,l){const b=new t(s,l,()=>this._sessions.delete(b._id));return this._sessions.set(b._id,b),b}createInputBox(s){const l=new r(s,()=>this._sessions.delete(l._id));return this._sessions.set(l._id,l),l}$onDidChangeValue(s,l){const b=this._sessions.get(s);b&&b._fireDidChangeValue(l)}$onDidAccept(s){const l=this._sessions.get(s);l&&l._fireDidAccept()}$onDidChangeActive(s,l){const b=this._sessions.get(s);b instanceof t&&b._fireDidChangeActive(l)}$onDidChangeSelection(s,l){const b=this._sessions.get(s);b instanceof t&&b._fireDidChangeSelection(l)}$onDidTriggerButton(s,l){const b=this._sessions.get(s);b&&b._fireDidTriggerButton(l)}$onDidHide(s){const l=this._sessions.get(s);l&&l._fireDidHide()}}class S{constructor(s,l){this._extensionId=s,this._onDidDispose=l,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new D.Emitter,this._onDidChangeValueEmitter=new D.Emitter,this._onDidTriggerButtonEmitter=new D.Emitter,this._onDidHideEmitter=new D.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(s){this._title=s,this.update({title:s})}get step(){return this._steps}set step(s){this._steps=s,this.update({step:s})}get totalSteps(){return this._totalSteps}set totalSteps(s){this._totalSteps=s,this.update({totalSteps:s})}get enabled(){return this._enabled}set enabled(s){this._enabled=s,this.update({enabled:s})}get busy(){return this._busy}set busy(s){this._busy=s,this.update({busy:s})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(s){this._ignoreFocusOut=s,this.update({ignoreFocusOut:s})}get value(){return this._value}set value(s){this._value=s,this.update({value:s})}get placeholder(){return this._placeholder}set placeholder(s){this._placeholder=s,this.update({placeholder:s})}get buttons(){return this._buttons}set buttons(s){this._buttons=s.slice(),this._handlesToButtons.clear(),s.forEach((l,b)=>{const p=l===_.QuickInputButtons.Back?-1:b;this._handlesToButtons.set(p,l)}),this.update({buttons:s.map((l,b)=>({iconPath:c(l.iconPath),tooltip:l.tooltip,handle:l===_.QuickInputButtons.Back?-1:b}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(s){this._value=s,this._onDidChangeValueEmitter.fire(s)}_fireDidTriggerButton(s){const l=this._handlesToButtons.get(s);l&&this._onDidTriggerButtonEmitter.fire(l)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=E.dispose(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),w.$dispose(this._id))}update(s){if(!this._disposed){for(const l of Object.keys(s)){const b=s[l];this._pendingUpdate[l]=b===void 0?null:b}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){w.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}S._nextId=1;function c(i){if(i instanceof _.ThemeIcon)return{id:i.id};const s=f(i),l=m(i);return{dark:typeof s=="string"?y.URI.file(s):s,light:typeof l=="string"?y.URI.file(l):l}}function m(i){return typeof i=="object"&&"light"in i?i.light:i}function f(i){return typeof i=="object"&&"dark"in i?i.dark:i}class t extends S{constructor(s,l,b){super(s,b);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new D.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new D.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(s){this._items=s.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),s.forEach((l,b)=>{this._handlesToItems.set(b,l),this._itemsToHandles.set(l,b)}),this.update({items:s.map((l,b)=>({label:l.label,description:l.description,handle:b,detail:l.detail,picked:l.picked,alwaysShow:l.alwaysShow}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(s){this._canSelectMany=s,this.update({canSelectMany:s})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(s){this._matchOnDescription=s,this.update({matchOnDescription:s})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(s){this._matchOnDetail=s,this.update({matchOnDetail:s})}get sortByLabel(){return this._sortByLabel}set sortByLabel(s){this._sortByLabel=s,this.update({sortByLabel:s})}get activeItems(){return this._activeItems}set activeItems(s){this._activeItems=s.filter(l=>this._itemsToHandles.has(l)),this.update({activeItems:this._activeItems.map(l=>this._itemsToHandles.get(l))})}get selectedItems(){return this._selectedItems}set selectedItems(s){this._selectedItems=s.filter(l=>this._itemsToHandles.has(l)),this.update({selectedItems:this._selectedItems.map(l=>this._itemsToHandles.get(l))})}_fireDidChangeActive(s){const l=n.coalesce(s.map(b=>this._handlesToItems.get(b)));this._activeItems=l,this._onDidChangeActiveEmitter.fire(l)}_fireDidChangeSelection(s){const l=n.coalesce(s.map(b=>this._handlesToItems.get(b)));this._selectedItems=l,this._onDidChangeSelectionEmitter.fire(l)}}class r extends S{constructor(s,l){super(s,l);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(s){this._password=s,this.update({password:s})}get prompt(){return this._prompt}set prompt(s){this._prompt=s,this.update({prompt:s})}get validationMessage(){return this._validationMessage}set validationMessage(s){this._validationMessage=s,this.update({validationMessage:s,severity:s?I.default.Error:I.default.Ignore})}}return new v(d,u)}e.createExtHostQuickOpen=o}),define(we[193],_e([0,1,2,3,47,7,11,4,16,110,17,26,29]),function(Z,e,g,T,D,E,C,y,_,k,n,I,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function h(s){if(s)return typeof s.iconPath=="string"?g.URI.file(s.iconPath):s.iconPath}function d(s,l){if(!s.iconPath&&!l.iconPath)return 0;if(s.iconPath){if(!l.iconPath)return 1}else return-1;const b=typeof s.iconPath=="string"?s.iconPath:s.iconPath.fsPath,p=typeof l.iconPath=="string"?l.iconPath:l.iconPath.fsPath;return k.comparePaths(b,p)}function u(s,l){let b=0;if(s.strikeThrough!==l.strikeThrough)return s.strikeThrough?1:-1;if(s.faded!==l.faded)return s.faded?1:-1;if(s.tooltip!==l.tooltip)return(s.tooltip||"").localeCompare(l.tooltip||"");if(b=d(s,l),b!==0)return b;if(s.light&&l.light)b=d(s.light,l.light);else{if(s.light)return 1;if(l.light)return-1}if(b!==0)return b;if(s.dark&&l.dark)b=d(s.dark,l.dark);else{if(s.dark)return 1;if(l.dark)return-1}return b}function w(s,l){if(s.command!==l.command)return s.command<l.command?-1:1;if(s.title!==l.title)return s.title<l.title?-1:1;if(s.tooltip!==l.tooltip){if(s.tooltip!==void 0&&l.tooltip!==void 0)return s.tooltip<l.tooltip?-1:1;if(s.tooltip!==void 0)return 1;if(l.tooltip!==void 0)return-1}if(s.arguments===l.arguments)return 0;if(s.arguments)if(l.arguments){if(s.arguments.length!==l.arguments.length)return s.arguments.length-l.arguments.length}else return 1;else return-1;for(let b=0;b<s.arguments.length;b++){const p=s.arguments[b],P=l.arguments[b];if(p!==P)return p<P?-1:1}return 0}function v(s,l){let b=k.comparePaths(s.resourceUri.fsPath,l.resourceUri.fsPath,!0);if(b!==0)return b;if(s.command&&l.command)b=w(s.command,l.command);else{if(s.command)return 1;if(l.command)return-1}if(b!==0)return b;if(s.decorations&&l.decorations)b=u(s.decorations,l.decorations);else{if(s.decorations)return 1;if(l.decorations)return-1}return b}function S(s,l){for(let b=0;b<s.length;b++)if(s[b]!==l[b])return!1;return!0}function c(s,l){return s.command===l.command&&s.title===l.title&&s.tooltip===l.tooltip&&(s.arguments&&l.arguments?S(s.arguments,l.arguments):s.arguments===l.arguments)}function m(s,l){return _.equals(s,l,c)}class f{constructor(l,b,p){this._extension=l,this._proxy=b,this._sourceControlHandle=p,this._value="",this._onDidChange=new T.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(l){this._proxy.$setInputBoxValue(this._sourceControlHandle,l),this.updateValue(l)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(l){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,l),this._placeholder=l}get validateInput(){return o.checkProposedApiEnabled(this._extension),this._validateInput}set validateInput(l){if(o.checkProposedApiEnabled(this._extension),l&&typeof l!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=l,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!l)}get visible(){return this._visible}set visible(l){l=!!l,this._visible!==l&&(this._visible=l,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,l))}focus(){o.checkProposedApiEnabled(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(l,b){o.checkProposedApiEnabled(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,l,b)}$onInputBoxValueChange(l){this.updateValue(l)}updateValue(l){this._value=l,this._onDidChange.fire(l)}}e.ExtHostSCMInputBox=f;class t{constructor(l,b,p,P,A){this._proxy=l,this._commands=b,this._sourceControlHandle=p,this._id=P,this._label=A,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new T.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new T.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=t._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(l){this._label=l,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,l)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(l){this._hideWhenEmpty=l,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(l){this._resourceStates=[...l],this._onDidUpdateResourceStates.fire()}getResourceState(l){return this._resourceStatesMap.get(l)}$executeResourceCommand(l,b){const p=this._resourceStatesCommandsMap.get(l);return p?C.asPromise(()=>this._commands.executeCommand(p.command,...p.arguments||[],b)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){var l;const b=[...this._resourceStates].sort(v),P=_.sortedDiff(this._resourceSnapshot,b,v).map(F=>{const N=F.toInsert.map(H=>{const le=this._resourceHandlePool++;this._resourceStatesMap.set(le,H);const fe=H.resourceUri,X=h(H.decorations),z=H.decorations&&h(H.decorations.light)||X,Y=H.decorations&&h(H.decorations.dark)||X,R=[];let B;if(H.command)if(H.command.command==="vscode.open"||H.command.command==="vscode.diff"){const ge=new E.DisposableStore;B=this._commands.converter.toInternal(H.command,ge),this._resourceStatesDisposablesMap.set(le,ge)}else this._resourceStatesCommandsMap.set(le,H.command);z&&R.push(z),Y&&Y.toString()!==(z==null?void 0:z.toString())&&R.push(Y);const M=H.decorations&&H.decorations.tooltip||"",U=H.decorations&&!!H.decorations.strikeThrough,q=H.decorations&&!!H.decorations.faded,V=H.contextValue||"";return{rawResource:[le,fe,R,M,U,q,V,B],handle:le}});return{start:F.start,deleteCount:F.deleteCount,toInsert:N}}),A=P.map(({start:F,deleteCount:N,toInsert:H})=>[F,N,H.map(le=>le.rawResource)]),a=P.reverse();for(const{start:F,deleteCount:N,toInsert:H}of a){const le=H.map(X=>X.handle),fe=this._handlesSnapshot.splice(F,N,...le);for(const X of fe)this._resourceStatesMap.delete(X),this._resourceStatesCommandsMap.delete(X),(l=this._resourceStatesDisposablesMap.get(X))===null||l===void 0||l.dispose(),this._resourceStatesDisposablesMap.delete(X)}return this._resourceSnapshot=b,A}dispose(){this._disposed=!0,this._onDidDispose.fire()}}t._handlePool=0;class r{constructor(l,b,p,P,A,a){this._proxy=b,this._commands=p,this._id=P,this._label=A,this._rootUri=a,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new E.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new E.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new T.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=r._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new f(l,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,P,A,a)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(l){this._count!==l&&(this._count=l,this._proxy.$updateSourceControl(this.handle,{count:l}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(l){this._quickDiffProvider=l,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!l})}get commitTemplate(){return this._commitTemplate}set commitTemplate(l){l!==this._commitTemplate&&(this._commitTemplate=l,this._proxy.$updateSourceControl(this.handle,{commitTemplate:l}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(l){this._acceptInputDisposables.value=new E.DisposableStore,this._acceptInputCommand=l;const b=this._commands.converter.toInternal(l,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:b})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(l){if(this._statusBarCommands&&l&&m(this._statusBarCommands,l))return;this._statusBarDisposables.value=new E.DisposableStore,this._statusBarCommands=l;const b=(l||[]).map(p=>this._commands.converter.toInternal(p,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:b})}get selected(){return this._selected}createResourceGroup(l,b){const p=new t(this._proxy,this._commands,this.handle,l,b),P=T.Event.once(p.onDidDispose)(()=>this.createdResourceGroups.delete(p));return this.createdResourceGroups.set(p,P),this.eventuallyAddResourceGroups(),p}eventuallyAddResourceGroups(){const l=[],b=[];for(const[p,P]of this.createdResourceGroups){P.dispose();const A=p.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(p),this.eventuallyUpdateResourceStates()});T.Event.once(p.onDidDispose)(()=>{this.updatedResourceGroups.delete(p),A.dispose(),this._groups.delete(p.handle),this._proxy.$unregisterGroup(this.handle,p.handle)}),l.push([p.handle,p.id,p.label,p.features]);const a=p._takeResourceStateSnapshot();a.length>0&&b.push([p.handle,a]),this._groups.set(p.handle,p)}this._proxy.$registerGroups(this.handle,l,b),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const l=[];this.updatedResourceGroups.forEach(b=>{const p=b._takeResourceStateSnapshot();p.length!==0&&l.push([b.handle,p])}),l.length>0&&this._proxy.$spliceResourceStates(this.handle,l),this.updatedResourceGroups.clear()}getResourceGroup(l){return this._groups.get(l)}setSelectionState(l){this._selected=l,this._onDidChangeSelection.fire(l)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(l=>l.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}r._handlePool=0,He([D.debounce(100)],r.prototype,"eventuallyAddResourceGroups",null),He([D.debounce(100)],r.prototype,"eventuallyUpdateResourceStates",null);let i=class Mn{constructor(l,b,p){this._commands=b,this.logService=p,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new T.Emitter,this._proxy=l.getProxy(y.MainContext.MainThreadSCM),this._telemetry=l.getProxy(y.MainContext.MainThreadTelemetry),b.registerArgumentProcessor({processArgument:P=>{if(P&&P.$mid===3){const A=this._sourceControls.get(P.sourceControlHandle);if(!A)return P;const a=A.getResourceGroup(P.groupHandle);return a?a.getResourceState(P.handle):P}else if(P&&P.$mid===4){const A=this._sourceControls.get(P.sourceControlHandle);return A?A.getResourceGroup(P.groupHandle):P}else if(P&&P.$mid===5){const A=this._sourceControls.get(P.handle);return A||P}return P}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(l,b,p,P){this.logService.trace("ExtHostSCM#createSourceControl",l.identifier.value,b,p,P),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:l.identifier.value});const A=Mn._handlePool++,a=new r(l,this._proxy,this._commands,b,p,P);this._sourceControls.set(A,a);const F=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(l.identifier))||[];return F.push(a),this._sourceControlsByExtension.set(I.ExtensionIdentifier.toKey(l.identifier),F),a}getLastInputBox(l){this.logService.trace("ExtHostSCM#getLastInputBox",l.identifier.value);const b=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(l.identifier)),p=b&&b[b.length-1];return p&&p.inputBox}$provideOriginalResource(l,b,p){const P=g.URI.revive(b);this.logService.trace("ExtHostSCM#$provideOriginalResource",l,P.toString());const A=this._sourceControls.get(l);return!A||!A.quickDiffProvider||!A.quickDiffProvider.provideOriginalResource?Promise.resolve(null):C.asPromise(()=>A.quickDiffProvider.provideOriginalResource(P,p)).then(a=>a||null)}$onInputBoxValueChange(l,b){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",l);const p=this._sourceControls.get(l);return p&&p.inputBox.$onInputBoxValueChange(b),Promise.resolve(void 0)}$executeResourceCommand(l,b,p,P){this.logService.trace("ExtHostSCM#$executeResourceCommand",l,b,p);const A=this._sourceControls.get(l);if(!A)return Promise.resolve(void 0);const a=A.getResourceGroup(b);return a?a.$executeResourceCommand(p,P):Promise.resolve(void 0)}$validateInput(l,b,p){this.logService.trace("ExtHostSCM#$validateInput",l);const P=this._sourceControls.get(l);return!P||!P.inputBox.validateInput?Promise.resolve(void 0):C.asPromise(()=>P.inputBox.validateInput(b,p)).then(A=>A?Promise.resolve([A.message,A.type]):Promise.resolve(void 0))}$setSelectedSourceControl(l){var b,p;return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",l),l!==void 0&&((b=this._sourceControls.get(l))===null||b===void 0||b.setSelectionState(!0)),this._selectedSourceControlHandle!==void 0&&((p=this._sourceControls.get(this._selectedSourceControlHandle))===null||p===void 0||p.setSelectionState(!1)),this._selectedSourceControlHandle=l,Promise.resolve(void 0)}};i._handlePool=0,i=He([ze(2,n.ILogService)],i),e.ExtHostSCM=i});var tt=this&&this.__classPrivateFieldSet||function(Z,e,g,T,D){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!D:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?D.call(Z,g):D?D.value=g:e.set(Z,g),g},xe=this&&this.__classPrivateFieldGet||function(Z,e,g,T){if(g==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!T:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?T:g==="a"?T.call(Z):T?T.value:e.get(Z)};define(we[194],_e([0,1,6,4,130,7]),function(Z,e,g,T,D,E){"use strict";var C,y;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class _{constructor(o,h,d,u,w=g.StatusBarAlignment.Left,v){C.set(this,void 0),y.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new E.DisposableStore,tt(this,C,o,"f"),tt(this,y,h,"f"),this._entryId=_.ID_GEN++,this._extension=d,this._id=u,this._alignment=w,this._priority=v}get id(){var o;return(o=this._id)!==null&&o!==void 0?o:this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){var o;return(o=this._command)===null||o===void 0?void 0:o.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(o){this._text=o,this.update()}set name(o){this._name=o,this.update()}set tooltip(o){this._tooltip=o,this.update()}set color(o){this._color=o,this.update()}set backgroundColor(o){o&&!_.ALLOWED_BACKGROUND_COLORS.has(o.id)&&(o=void 0),this._backgroundColor=o,this.update()}set command(o){var h;((h=this._command)===null||h===void 0?void 0:h.fromApi)!==o&&(this._internalCommandRegistration.clear(),typeof o=="string"?this._command={fromApi:o,internal:xe(this,y,"f").toInternal({title:"",command:o},this._internalCommandRegistration)}:o?this._command={fromApi:o,internal:xe(this,y,"f").toInternal(o,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(o){this._accessibilityInformation=o,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,xe(this,C,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{var o;this._timeoutHandle=void 0;let h;this._extension?this._id?h=`${this._extension.identifier.value}.${this._id}`:h=this._extension.identifier.value:h=this._id;let d;this._name?d=this._name:d=D.localize(0,null,this._extension.displayName||this._extension.name);let u=this._color;this._backgroundColor&&(u=_.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id)),xe(this,C,"f").$setEntry(this._entryId,h,d,this._text,this._tooltip,(o=this._command)===null||o===void 0?void 0:o.internal,u,this._backgroundColor,this._alignment===g.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=_,C=new WeakMap,y=new WeakMap,_.ID_GEN=0,_.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new g.ThemeColor("statusBarItem.errorForeground")]]);class k{constructor(o){this._messages=[],this._item=o.createStatusBarEntry(void 0,"status.extensionMessage",g.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=D.localize(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(o){const h={message:o};return this._messages.unshift(h),this._update(),new g.Disposable(()=>{const d=this._messages.indexOf(h);d>=0&&(this._messages.splice(d,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class n{constructor(o,h){this._proxy=o.getProxy(T.MainContext.MainThreadStatusBar),this._commands=h,this._statusMessage=new k(this)}createStatusBarEntry(o,h,d,u){return new _(this._proxy,this._commands,o,h,d,u)}setStatusBarMessage(o,h){const d=this._statusMessage.setMessage(o);let u;return typeof h=="number"?u=setTimeout(()=>d.dispose(),h):typeof h!="undefined"&&h.then(()=>d.dispose(),()=>d.dispose()),new g.Disposable(()=>{d.dispose(),clearTimeout(u)})}}e.ExtHostStatusBar=n}),define(we[73],_e([0,1,4,3,5]),function(Z,e,g,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class E{constructor(y){this._onDidChangeStorage=new T.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=y.getProxy(g.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(y,_){this._proxy.$registerExtensionStorageKeysToSync(y,_)}getValue(y,_,k){return this._proxy.$getValue(y,_).then(n=>n||k)}setValue(y,_,k){return this._proxy.$setValue(y,_,k)}$acceptValue(y,_,k){this._onDidChangeStorage.fire({shared:y,key:_,value:k})}}e.ExtHostStorage=E,e.IExtHostStorage=D.createDecorator("IExtHostStorage")}),define(we[74],_e([0,1,5,28,17,72,2]),function(Z,e,g,T,D,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=g.createDecorator("IExtensionStoragePaths");let y=class{constructor(k,n,I){var o;this._logService=n,this._extHostFileSystem=I,this._workspace=(o=k.workspace)!==null&&o!==void 0?o:void 0,this._environment=k.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(h=>this._value=h)}async _getOrCreateWorkspaceStoragePath(){var k;if(!this._workspace)return Promise.resolve(void 0);const n=this._workspace.id,I=C.URI.joinPath(this._environment.workspaceStorageHome,n);try{return await this._extHostFileSystem.value.stat(I),this._logService.trace("[ExtHostStorage] storage dir already exists",I),I}catch(o){}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",I),await this._extHostFileSystem.value.createDirectory(I),await this._extHostFileSystem.value.writeFile(C.URI.joinPath(I,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:(k=C.URI.revive(this._workspace.configuration))===null||k===void 0?void 0:k.toString(),name:this._workspace.name},void 0,2))),I}catch(o){this._logService.error("[ExtHostStorage]",o);return}}workspaceValue(k){if(this._value)return C.URI.joinPath(this._value,k.identifier.value)}globalValue(k){return C.URI.joinPath(this._environment.globalStorageHome,k.identifier.value.toLowerCase())}};y=He([ze(0,T.IExtHostInitDataService),ze(1,D.ILogService),ze(2,E.IExtHostConsumerFileSystem)],y),e.ExtensionStoragePaths=y}),define(we[37],_e([0,1,3,4,5,2,14,7,6,131,12,161,18,34,151,10]),function(Z,e,g,T,D,E,C,y,_,k,n,I,o,h,d,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=D.createDecorator("IExtHostTerminalService");class w{constructor(i,s,l,b){this._proxy=i,this._id=s,this._creationOptions=l,this._name=b,this._disposed=!1,this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(P=>this._pidPromiseComplete=P);const p=this;this.value={get name(){return p._name||""},get processId(){return p._pidPromise},get creationOptions(){return p._creationOptions},get exitStatus(){return p._exitStatus},sendText(P,A=!0){p._checkDisposed(),p._proxy.$sendText(p._id,P,A)},show(P){p._checkDisposed(),p._proxy.$show(p._id,P)},hide(){p._checkDisposed(),p._proxy.$hide(p._id)},dispose(){p._disposed||(p._disposed=!0,p._proxy.$dispose(p._id))},get dimensions(){if(!(p._cols===void 0||p._rows===void 0))return{columns:p._cols,rows:p._rows}}}}async create(i,s){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:i.name,shellPath:u.withNullAsUndefined(i.shellPath),shellArgs:u.withNullAsUndefined(i.shellArgs),cwd:u.withNullAsUndefined(i.cwd),env:u.withNullAsUndefined(i.env),icon:u.withNullAsUndefined(t(i.iconPath)),initialText:u.withNullAsUndefined(i.message),strictEnv:u.withNullAsUndefined(i.strictEnv),hideFromUser:u.withNullAsUndefined(i.hideFromUser),isFeatureTerminal:u.withNullAsUndefined(s==null?void 0:s.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:u.withNullAsUndefined(s==null?void 0:s.useShellEnvironment),isSplitTerminal:u.withNullAsUndefined(s==null?void 0:s.isSplitTerminal)})}async createExtensionTerminal(i,s){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:s,isSplitTerminal:i}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(i){this._name=i}setExitCode(i){this._exitStatus=Object.freeze({code:i})}setDimensions(i,s){return i===this._cols&&s===this._rows||i===0||s===0?!1:(this._cols=i,this._rows=s,!0)}_setProcessId(i){this._pidPromiseComplete?(this._pidPromiseComplete(i),this._pidPromiseComplete=void 0):this._pidPromise.then(s=>{s!==i&&(this._pidPromise=Promise.resolve(i))})}}e.ExtHostTerminal=w;class v{constructor(i){this._pty=i,this.id=0,this.shouldPersist=!1,this._onProcessData=new g.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new g.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new g.Emitter,this._onProcessTitleChanged=new g.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new g.Emitter,this._onProcessShellTypeChanged=new g.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(i){this._pty.handleInput&&this._pty.handleInput(i)}resize(i,s){this._pty.setDimensions&&this._pty.setDimensions({columns:i,rows:s})}async processBinary(i){}acknowledgeDataEvent(i){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(i){this._pty.onDidWrite(s=>this._onProcessData.fire(s)),this._pty.onDidClose&&this._pty.onDidClose((s=void 0)=>{this._onProcessExit.fire(s===void 0?void 0:s)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(s=>this._onProcessOverrideDimensions.fire(s&&{cols:s.columns,rows:s.rows})),this._pty.onDidChangeName&&this._pty.onDidChangeName(s=>this._onProcessTitleChanged.fire(s)),this._pty.open(i||void 0),this._pty.setDimensions&&i&&this._pty.setDimensions(i),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=v;let S=1,c=class extends y.Disposable{constructor(i,s){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new g.Emitter,this._onDidOpenTerminal=new g.Emitter,this._onDidChangeActiveTerminal=new g.Emitter,this._onDidChangeTerminalDimensions=new g.Emitter,this._proxy=s.getProxy(T.MainContext.MainThreadTerminalService),this._bufferer=new d.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new g.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(i),this._register({dispose:()=>{for(const[l,b]of this._terminalProcesses)b.shutdown(!0)}})}get activeTerminal(){var i;return(i=this._activeTerminal)===null||i===void 0?void 0:i.value}get terminals(){return this._terminals.map(i=>i.value)}get onDidCloseTerminal(){return this._onDidCloseTerminal&&this._onDidCloseTerminal.event}get onDidOpenTerminal(){return this._onDidOpenTerminal&&this._onDidOpenTerminal.event}get onDidChangeActiveTerminal(){return this._onDidChangeActiveTerminal&&this._onDidChangeActiveTerminal.event}get onDidChangeTerminalDimensions(){return this._onDidChangeTerminalDimensions&&this._onDidChangeTerminalDimensions.event}get onDidWriteTerminalData(){return this._onDidWriteTerminalData&&this._onDidWriteTerminalData.event}getDefaultShell(i){const s=i?this._defaultAutomationProfile:this._defaultProfile;return(s==null?void 0:s.path)||""}getDefaultShellArgs(i){const s=i?this._defaultAutomationProfile:this._defaultProfile;return(s==null?void 0:s.args)||[]}createExtensionTerminal(i,s){const l=new w(this._proxy,h.generateUuid(),i,i.name),b=new v(i.pty);return l.createExtensionTerminal(s==null?void 0:s.isSplitTerminal,t(i.iconPath)).then(p=>{const P=this._setupExtHostProcessListeners(p,b);this._terminalProcessDisposables[p]=P}),this._terminals.push(l),l.value}attachPtyToTerminal(i,s){if(!this._getTerminalById(i))throw new Error(`Cannot resolve terminal with id ${i} for virtual process`);const b=new v(s),p=this._setupExtHostProcessListeners(i,b);this._terminalProcessDisposables[i]=p}async $acceptActiveTerminalChanged(i){const s=this._activeTerminal;if(i===null){this._activeTerminal=void 0,s!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const l=this._getTerminalById(i);l&&(this._activeTerminal=l,s!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(i,s){const l=this._getTerminalById(i);l&&this._onDidWriteTerminalData.fire({terminal:l.value,data:s})}async $acceptTerminalDimensions(i,s,l){const b=this._getTerminalById(i);b&&b.setDimensions(s,l)&&this._onDidChangeTerminalDimensions.fire({terminal:b.value,dimensions:b.value.dimensions})}async $acceptTerminalMaximumDimensions(i,s,l){var b;(b=this._terminalProcesses.get(i))===null||b===void 0||b.resize(s,l)}async $acceptTerminalTitleChange(i,s){const l=this._getTerminalById(i);l&&(l.name=s)}async $acceptTerminalClosed(i,s){const l=this._getTerminalObjectIndexById(this._terminals,i);if(l!==null){const b=this._terminals.splice(l,1)[0];b.setExitCode(s),this._onDidCloseTerminal.fire(b.value)}}$acceptTerminalOpened(i,s,l,b){if(s){const A=this._getTerminalObjectIndexById(this._terminals,s);if(A!==null){this._terminals[A]._id=i,this._onDidOpenTerminal.fire(this.terminals[A]),this._terminals[A].isOpen=!0;return}}const p={name:b.name,shellPath:b.executable,shellArgs:b.args,cwd:typeof b.cwd=="string"?b.cwd:E.URI.revive(b.cwd),env:b.env,hideFromUser:b.hideFromUser},P=new w(this._proxy,i,p,l);this._terminals.push(P),this._onDidOpenTerminal.fire(P.value),P.isOpen=!0}async $acceptTerminalProcessId(i,s){const l=this._getTerminalById(i);l&&l._setProcessId(s)}async $startExtensionTerminal(i,s){const l=this._getTerminalById(i);if(!l)return{message:k.localize(0,null,i)};l.isOpen||await new Promise(p=>{const P=this.onDidOpenTerminal(async A=>{A===l.value&&(P.dispose(),p())})});const b=this._terminalProcesses.get(i);b?b.startSendingEvents(s):this._extensionTerminalAwaitingStart[i]={initialDimensions:s}}_setupExtHostProcessListeners(i,s){const l=new y.DisposableStore;l.add(s.onProcessReady(p=>this._proxy.$sendProcessReady(i,p.pid,p.cwd))),l.add(s.onProcessTitleChanged(p=>this._proxy.$sendProcessTitle(i,p))),this._bufferer.startBuffering(i,s.onProcessData),l.add(s.onProcessExit(p=>this._onProcessExit(i,p))),s.onProcessOverrideDimensions&&l.add(s.onProcessOverrideDimensions(p=>this._proxy.$sendOverrideDimensions(i,p))),this._terminalProcesses.set(i,s);const b=this._extensionTerminalAwaitingStart[i];return b&&s instanceof v&&(s.startSendingEvents(b.initialDimensions),delete this._extensionTerminalAwaitingStart[i]),l}$acceptProcessAckDataEvent(i,s){var l;(l=this._terminalProcesses.get(i))===null||l===void 0||l.acknowledgeDataEvent(s)}$acceptProcessInput(i,s){var l;(l=this._terminalProcesses.get(i))===null||l===void 0||l.input(s)}$acceptProcessResize(i,s,l){var b;try{(b=this._terminalProcesses.get(i))===null||b===void 0||b.resize(s,l)}catch(p){if(p.code!=="EPIPE"&&p.code!=="ERR_IPC_CHANNEL_CLOSED")throw p}}$acceptProcessShutdown(i,s){var l;(l=this._terminalProcesses.get(i))===null||l===void 0||l.shutdown(s)}$acceptProcessRequestInitialCwd(i){var s;(s=this._terminalProcesses.get(i))===null||s===void 0||s.getInitialCwd().then(l=>this._proxy.$sendProcessInitialCwd(i,l))}$acceptProcessRequestCwd(i){var s;(s=this._terminalProcesses.get(i))===null||s===void 0||s.getCwd().then(l=>this._proxy.$sendProcessCwd(i,l))}$acceptProcessRequestLatency(i){return i}registerLinkProvider(i){return this._linkProviders.add(i),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new _.Disposable(()=>{this._linkProviders.delete(i),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(i,s){if(this._profileProviders.has(i))throw new Error(`Terminal profile provider "${i}" already registered`);return this._profileProviders.set(i,s),this._proxy.$registerProfileProvider(i),new _.Disposable(()=>{this._profileProviders.delete(i),this._proxy.$unregisterProfileProvider(i)})}async $createContributedProfileTerminal(i,s){var l;const b=new o.CancellationTokenSource().token,p=await((l=this._profileProviders.get(i))===null||l===void 0?void 0:l.provideProfileOptions(b));if(!b.isCancellationRequested){if(!p)throw new Error(`No terminal profile options provided for id "${i}"`);if("pty"in p){this.createExtensionTerminal(p,{isSplitTerminal:s});return}this.createTerminalFromOptions(p,{isSplitTerminal:s})}}async $provideLinks(i,s){const l=this._getTerminalById(i);if(!l)return[];this._terminalLinkCache.delete(i);const b=this._terminalLinkCancellationSource.get(i);b&&b.dispose(!0);const p=new o.CancellationTokenSource;this._terminalLinkCancellationSource.set(i,p);const P=[],A={terminal:l.value,line:s},a=[];for(const H of this._linkProviders)a.push(new Promise(async le=>{p.token.onCancellationRequested(()=>le({provider:H,links:[]}));const fe=await H.provideTerminalLinks(A,p.token)||[];p.token.isCancellationRequested||le({provider:H,links:fe})}));const F=await Promise.all(a);if(p.token.isCancellationRequested)return[];const N=new Map;for(const H of F)H&&H.links.length>0&&P.push(...H.links.map(le=>{const fe={id:S++,startIndex:le.startIndex,length:le.length,label:le.tooltip};return N.set(fe.id,{provider:H.provider,link:le}),fe}));return this._terminalLinkCache.set(i,N),P}$activateLink(i,s){var l;const b=(l=this._terminalLinkCache.get(i))===null||l===void 0?void 0:l.get(s);!b||b.provider.handleTerminalLink(b.link)}_onProcessExit(i,s){this._bufferer.stopBuffering(i),this._terminalProcesses.delete(i),delete this._extensionTerminalAwaitingStart[i];const l=this._terminalProcessDisposables[i];l&&(l.dispose(),delete this._terminalProcessDisposables[i]),this._proxy.$sendProcessExit(i,s)}_getTerminalById(i){return this._getTerminalObjectById(this._terminals,i)}_getTerminalObjectById(i,s){const l=this._getTerminalObjectIndexById(i,s);return l!==null?i[l]:null}_getTerminalObjectIndexById(i,s){let l=null;return i.some((b,p)=>b._id===s?(l=p,!0):!1),l}getEnvironmentVariableCollection(i){let s=this._environmentVariableCollections.get(i.identifier.value);return s||(s=new m,this._setEnvironmentVariableCollection(i.identifier.value,s)),s}_syncEnvironmentVariableCollection(i,s){const l=I.serializeEnvironmentVariableCollection(s.map);this._proxy.$setEnvironmentVariableCollection(i,s.persistent,l.length===0?void 0:l)}$initEnvironmentVariableCollections(i){i.forEach(s=>{const l=s[0],b=new m(s[1]);this._setEnvironmentVariableCollection(l,b)})}$acceptDefaultProfile(i,s){this._defaultProfile=i,this._defaultAutomationProfile=s}_setEnvironmentVariableCollection(i,s){this._environmentVariableCollections.set(i,s),s.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(i,s)})}};c=He([ze(1,C.IExtHostRpcService)],c),e.BaseExtHostTerminalService=c;class m{constructor(i){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new g.Emitter,this.map=new Map(i)}get persistent(){return this._persistent}set persistent(i){this._persistent=i,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(i,s){this._setIfDiffers(i,{value:s,type:_.EnvironmentVariableMutatorType.Replace})}append(i,s){this._setIfDiffers(i,{value:s,type:_.EnvironmentVariableMutatorType.Append})}prepend(i,s){this._setIfDiffers(i,{value:s,type:_.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(i,s){const l=this.map.get(i);(!l||l.value!==s.value||l.type!==s.type)&&(this.map.set(i,s),this._onDidChangeCollection.fire())}get(i){return this.map.get(i)}forEach(i,s){this.map.forEach((l,b)=>i.call(s,b,l,this))}delete(i){this.map.delete(i),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=m;let f=class extends c{constructor(i){super(!1,i)}createTerminal(i,s,l){throw new n.NotSupportedError}createTerminalFromOptions(i,s){throw new n.NotSupportedError}};f=He([ze(0,C.IExtHostRpcService)],f),e.WorkerExtHostTerminalService=f;function t(r){if(!!r)return"id"in r?{id:r.id,color:r.color}:r}}),define(we[195],_e([0,1,3,16,4,96,9,6]),function(Z,e,g,T,D,E,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class _{constructor(n,I){this._extHostDocumentsAndEditors=I,this._onDidChangeTextEditorSelection=new g.Emitter,this._onDidChangeTextEditorOptions=new g.Emitter,this._onDidChangeTextEditorVisibleRanges=new g.Emitter,this._onDidChangeTextEditorViewColumn=new g.Emitter,this._onDidChangeActiveTextEditor=new g.Emitter,this._onDidChangeVisibleTextEditors=new g.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=n.getProxy(D.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(o=>this._onDidChangeVisibleTextEditors.fire(o)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(o=>this._onDidChangeActiveTextEditor.fire(o))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(n){const I=this._extHostDocumentsAndEditors.allEditors();return n?I:I.map(o=>o.value)}async showTextDocument(n,I,o){let h;typeof I=="number"?h={position:C.ViewColumn.from(I),preserveFocus:o}:typeof I=="object"?h={position:C.ViewColumn.from(I.viewColumn),preserveFocus:I.preserveFocus,selection:typeof I.selection=="object"?C.Range.from(I.selection):void 0,pinned:typeof I.preview=="boolean"?!I.preview:void 0}:h={preserveFocus:!1};const d=await this._proxy.$tryShowTextDocument(n.uri,h),u=d&&this._extHostDocumentsAndEditors.getEditor(d);if(u)return u.value;throw d?new Error(`Could NOT open editor for "${n.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${n.uri.toString()}".`)}createTextEditorDecorationType(n,I){return new E.TextEditorDecorationType(this._proxy,n,I).value}$acceptEditorPropertiesChanged(n,I){const o=this._extHostDocumentsAndEditors.getEditor(n);if(!o)throw new Error("unknown text editor");if(I.options&&o._acceptOptions(I.options),I.selections){const h=I.selections.selections.map(C.Selection.to);o._acceptSelections(h)}if(I.visibleRanges){const h=T.coalesce(I.visibleRanges.map(C.Range.to));o._acceptVisibleRanges(h)}if(I.options&&this._onDidChangeTextEditorOptions.fire({textEditor:o.value,options:Object.assign(Object.assign({},I.options),{lineNumbers:C.TextEditorLineNumbersStyle.to(I.options.lineNumbers)})}),I.selections){const h=y.TextEditorSelectionChangeKind.fromValue(I.selections.source),d=I.selections.selections.map(C.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:o.value,selections:d,kind:h})}if(I.visibleRanges){const h=T.coalesce(I.visibleRanges.map(C.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:o.value,visibleRanges:h})}}$acceptEditorPositionData(n){for(const I in n){const o=this._extHostDocumentsAndEditors.getEditor(I);if(!o)throw new Error("Unknown text editor");const h=C.ViewColumn.to(n[I]);o.value.viewColumn!==h&&(o._acceptViewColumn(h),this._onDidChangeTextEditorViewColumn.fire({textEditor:o.value,viewColumn:h}))}}getDiffInformation(n){return Promise.resolve(this._proxy.$getDiffInformation(n))}}e.ExtHostEditors=_});var bn=this&&this.__rest||function(Z,e){var g={};for(var T in Z)Object.prototype.hasOwnProperty.call(Z,T)&&e.indexOf(T)<0&&(g[T]=Z[T]);if(Z!=null&&typeof Object.getOwnPropertySymbols=="function")for(var D=0,T=Object.getOwnPropertySymbols(Z);D<T.length;D++)e.indexOf(T[D])<0&&Object.prototype.propertyIsEnumerable.call(Z,T[D])&&(g[T[D]]=Z[T[D]]);return g};define(we[196],_e([0,1,2,5,4,7,6]),function(Z,e,g,T,D,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=T.createDecorator("IExtHostTimeline");class y{constructor(n,I){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=n.getProxy(D.MainContext.MainThreadTimeline),I.registerArgumentProcessor({processArgument:o=>{var h,d;if(o&&o.$mid===11){const u=o.uri===void 0?void 0:g.URI.revive(o.uri);return(d=(h=this._itemsBySourceAndUriMap.get(o.source))===null||h===void 0?void 0:h.get(_(u)))===null||d===void 0?void 0:d.get(o.handle)}return o}})}async $getTimeline(n,I,o,h,d){const u=this._providers.get(n);return u==null?void 0:u.provideTimeline(g.URI.revive(I),o,h,d)}registerTimelineProvider(n,I,o,h){const d=new E.DisposableStore,u=this.convertTimelineItem(I.id,h,d).bind(this);let w;I.onDidChange&&(w=I.onDidChange(S=>this._proxy.$emitTimelineChangeEvent(Object.assign(Object.assign({uri:void 0,reset:!0},S),{id:I.id})),this));const v=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore(Object.assign(Object.assign({},I),{scheme:n,onDidChange:void 0,async provideTimeline(S,c,m,f){var t;(f==null?void 0:f.resetCache)&&(d.clear(),(t=v.get(I.id))===null||t===void 0||t.clear());const r=await I.provideTimeline(S,c,m);if(r==null)return;const i=u(S,f);return Object.assign(Object.assign({},r),{source:I.id,items:r.items.map(i)})},dispose(){var S;for(const c of v.values())(S=c.get(I.id))===null||S===void 0||S.clear();w==null||w.dispose(),d.dispose()}}))}convertTimelineItem(n,I,o){return(h,d)=>{let u;if(d==null?void 0:d.cacheResults){let w=this._itemsBySourceAndUriMap.get(n);w===void 0&&(w=new Map,this._itemsBySourceAndUriMap.set(n,w));const v=_(h);u=w.get(v),u===void 0&&(u=new Map,w.set(v,u))}return w=>{var v,S;const{iconPath:c}=w,m=bn(w,["iconPath"]),f=`${n}|${(v=w.id)!==null&&v!==void 0?v:w.timestamp}`;u==null||u.set(f,w);let t,r,i;return w.iconPath&&(c instanceof C.ThemeIcon?i={id:c.id}:g.URI.isUri(c)?(t=c,r=c):{light:t,dark:r}=c),Object.assign(Object.assign({},m),{id:(S=m.id)!==null&&S!==void 0?S:void 0,handle:f,source:n,command:w.command?I.toInternal(w.command,o):void 0,icon:t,iconDark:r,themeIcon:i,accessibilityInformation:w.accessibilityInformation})}}}registerTimelineProviderCore(n){if(this._providers.get(n.id))throw new Error(`Timeline Provider ${n.id} already exists.`);return this._proxy.$registerTimelineProvider({id:n.id,label:n.label,scheme:n.scheme}),this._providers.set(n.id,n),E.toDisposable(()=>{var o;for(const h of this._itemsBySourceAndUriMap.values())(o=h.get(n.id))===null||o===void 0||o.clear();this._providers.delete(n.id),this._proxy.$unregisterTimelineProvider(n.id),n.dispose()})}}e.ExtHostTimeline=y;function _(k){return k==null?void 0:k.toString()}}),define(we[197],_e([0,1,7,15,2,4]),function(Z,e,g,T,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class C{constructor(_){this._openers=new Map,this._proxy=_.getProxy(E.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(_,k,n,I){if(this._openers.has(k))throw new Error(`Opener with id '${k}' already registered`);const o=I.schemes.find(h=>!C.supportedSchemes.has(h));if(o)throw new Error(`Scheme '${o}' is not supported. Only http and https are currently supported.`);return this._openers.set(k,n),this._proxy.$registerUriOpener(k,I.schemes,_,I.label),g.toDisposable(()=>{this._openers.delete(k),this._proxy.$unregisterUriOpener(k)})}async $canOpenUri(_,k,n){const I=this._openers.get(_);if(!I)throw new Error(`Unknown opener with id: ${_}`);const o=D.URI.revive(k);return I.canOpenExternalUri(o,n)}async $openUri(_,k,n){const I=this._openers.get(_);if(!I)throw new Error(`Unknown opener id: '${_}'`);return I.openExternalUri(D.URI.revive(k.resolvedUri),{sourceUri:D.URI.revive(k.sourceUri)},n)}}e.ExtHostUriOpeners=C,C.supportedSchemes=new Set([T.Schemas.http,T.Schemas.https])}),define(we[198],_e([0,1,4,2,7,12,26]),function(Z,e,g,T,D,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class y{constructor(k){this.handles=new Set,this.handlers=new Map,this._proxy=k.getProxy(g.MainContext.MainThreadUrls)}registerUriHandler(k,n){if(this.handles.has(C.ExtensionIdentifier.toKey(k)))throw new Error(`Protocol handler already registered for extension ${k}`);const I=y.HandlePool++;return this.handles.add(C.ExtensionIdentifier.toKey(k)),this.handlers.set(I,n),this._proxy.$registerUriHandler(I,k),D.toDisposable(()=>{this.handles.delete(C.ExtensionIdentifier.toKey(k)),this.handlers.delete(I),this._proxy.$unregisterUriHandler(I)})}$handleExternalUri(k,n){const I=this.handlers.get(k);if(!I)return Promise.resolve(void 0);try{I.handleUri(T.URI.revive(n))}catch(o){E.onUnexpectedError(o)}return Promise.resolve(void 0)}async createAppUri(k){return T.URI.revive(await this._proxy.$createAppUri(k))}}e.ExtHostUrls=y,y.HandlePool=0});var tt=this&&this.__classPrivateFieldSet||function(Z,e,g,T,D){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!D:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?D.call(Z,g):D?D.value=g:e.set(Z,g),g},xe=this&&this.__classPrivateFieldGet||function(Z,e,g,T){if(g==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!T:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?T:g==="a"?T.call(Z):T?T.value:e.get(Z)};define(we[46],_e([0,1,3,2,139,156,68,4]),function(Z,e,g,T,D,E,C,y){"use strict";var _,k,n,I,o,h,d,u,w,v,S,c;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class m{constructor(p,P,A,a,F,N,H){_.set(this,void 0),k.set(this,void 0),n.set(this,void 0),I.set(this,void 0),o.set(this,void 0),h.set(this,void 0),d.set(this,""),u.set(this,void 0),w.set(this,!1),v.set(this,!1),S.set(this,!1),this._onMessageEmitter=new g.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,c.set(this,new g.Emitter),this._onDidDispose=xe(this,c,"f").event,tt(this,_,p,"f"),tt(this,k,P,"f"),tt(this,u,A,"f"),tt(this,I,a,"f"),tt(this,o,F,"f"),tt(this,h,N,"f"),tt(this,S,f(N),"f"),tt(this,n,H,"f")}dispose(){tt(this,w,!0,"f"),xe(this,c,"f").fire(),xe(this,c,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(p){return tt(this,v,!0,"f"),C.asWebviewUri(p,xe(this,I,"f").remote)}get cspSource(){return C.webviewGenericCspSource}get html(){return this.assertNotDisposed(),xe(this,d,"f")}set html(p){this.assertNotDisposed(),xe(this,d,"f")!==p&&(tt(this,d,p,"f"),!xe(this,v,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(p)&&(tt(this,v,!0,"f"),xe(this,n,"f").report("Webview vscode-resource: uris",xe(this,h,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),xe(this,k,"f").$setHtml(xe(this,_,"f"),p))}get options(){return this.assertNotDisposed(),xe(this,u,"f")}set options(p){this.assertNotDisposed(),xe(this,k,"f").$setOptions(xe(this,_,"f"),i(xe(this,h,"f"),xe(this,o,"f"),p)),tt(this,u,p,"f")}async postMessage(p){if(xe(this,w,"f"))return!1;const P=E.serializeWebviewMessage(p,{serializeBuffersForPostMessage:xe(this,S,"f")});return xe(this,k,"f").$postMessage(xe(this,_,"f"),P.message,...P.buffers)}assertNotDisposed(){if(xe(this,w,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=m,_=new WeakMap,k=new WeakMap,n=new WeakMap,I=new WeakMap,o=new WeakMap,h=new WeakMap,d=new WeakMap,u=new WeakMap,w=new WeakMap,v=new WeakMap,S=new WeakMap,c=new WeakMap;function f(b){try{const p=D.normalizeVersion(D.parseVersion(b.engines.vscode));return!!p&&p.majorBase>=1&&p.minorBase>=57}catch(p){return!1}}e.shouldSerializeBuffersForPostMessage=f;class t{constructor(p,P,A,a,F){this.initData=P,this.workspace=A,this._logService=a,this._deprecationService=F,this._webviews=new Map,this._webviewProxy=p.getProxy(y.MainContext.MainThreadWebviews)}$onMessage(p,P,...A){const a=this.getWebview(p);if(a){const{message:F}=E.deserializeWebviewMessage(P,A);a._onMessageEmitter.fire(F)}}$onMissingCsp(p,P){this._logService.warn(`${P} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(p,P,A){const a=new m(p,this._webviewProxy,s(P),this.initData,this.workspace,A,this._deprecationService);return this._webviews.set(p,a),a._onDidDispose(()=>{this._webviews.delete(p)}),a}deleteWebview(p){this._webviews.delete(p)}getWebview(p){return this._webviews.get(p)}}e.ExtHostWebviews=t;function r(b){return{id:b.identifier,location:b.extensionLocation}}e.toExtensionData=r;function i(b,p,P){return{enableCommandUris:P.enableCommandUris,enableScripts:P.enableScripts,portMapping:P.portMapping,localResourceRoots:P.localResourceRoots||l(b,p)}}e.serializeWebviewOptions=i;function s(b){var p;return{enableCommandUris:b.enableCommandUris,enableScripts:b.enableScripts,portMapping:b.portMapping,localResourceRoots:(p=b.localResourceRoots)===null||p===void 0?void 0:p.map(P=>T.URI.from(P))}}e.reviveOptions=s;function l(b,p){return[...((p==null?void 0:p.getWorkspaceFolders())||[]).map(P=>P.uri),b.extensionLocation]}}),define(we[199],_e([0,1,18,53,7,15,25,2,9,46,63,4,6]),function(Z,e,g,T,D,E,C,y,_,k,n,I,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class h{constructor(t,r){this.document=t,this._storagePath=r,this._backupCounter=1,this._edits=new n.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,r){await this.getEdit(t).undo(),r||this.disposeBackup()}async redo(t,r){await this.getEdit(t).redo(),r||this.disposeBackup()}disposeEdits(t){for(const r of t)this._edits.delete(r)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=m(this.document.uri)+this._backupCounter++;return C.joinPath(this._storagePath,t)}updateBackup(t){var r;(r=this._backup)===null||r===void 0||r.delete(),this._backup=t}disposeBackup(){var t;(t=this._backup)===null||t===void 0||t.delete(),this._backup=void 0}getEdit(t){const r=this._edits.get(t,0);if(!r)throw new Error("No edit found");return r}}class d{constructor(){this._documents=new Map}get(t,r){return this._documents.get(this.key(t,r))}add(t,r,i){const s=this.key(t,r.uri);if(this._documents.has(s))throw new Error(`Document already exists for viewType:${t} resource:${r.uri}`);const l=new h(r,i);return this._documents.set(s,l),l}delete(t,r){const i=this.key(t,r.uri);this._documents.delete(i)}key(t,r){return`${t}@@@${r}`}}var u;(function(f){f[f.Text=0]="Text",f[f.Custom=1]="Custom"})(u||(u={}));class w{constructor(){this._providers=new Map}addTextProvider(t,r,i){return this.add(0,t,r,i)}addCustomProvider(t,r,i){return this.add(1,t,r,i)}get(t){return this._providers.get(t)}add(t,r,i,s){if(this._providers.has(r))throw new Error(`Provider for viewType:${r} already registered`);return this._providers.set(r,{type:t,extension:i,provider:s}),new o.Disposable(()=>this._providers.delete(r))}}class v{constructor(t,r,i,s,l){this._extHostDocuments=r,this._extensionStoragePaths=i,this._extHostWebview=s,this._extHostWebviewPanels=l,this._editorProviders=new w,this._documents=new d,this._proxy=t.getProxy(I.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,r,i,s){const l=new D.DisposableStore;return S(i)?(l.add(this._editorProviders.addTextProvider(r,t,i)),this._proxy.$registerTextEditorProvider(k.toExtensionData(t),r,s.webviewOptions||{},{supportsMove:!!i.moveCustomTextEditor},k.shouldSerializeBuffersForPostMessage(t))):(l.add(this._editorProviders.addCustomProvider(r,t,i)),this.supportEditing(i)&&l.add(i.onDidChangeCustomDocument(b=>{const p=this.getCustomDocumentEntry(r,b.document.uri);if(c(b)){const P=p.addEdit(b);this._proxy.$onDidEdit(b.document.uri,r,P,b.label)}else this._proxy.$onContentChange(b.document.uri,r)})),this._proxy.$registerCustomEditorProvider(k.toExtensionData(t),r,s.webviewOptions||{},!!s.supportsMultipleEditorsPerDocument,k.shouldSerializeBuffersForPostMessage(t))),o.Disposable.from(l,new o.Disposable(()=>{this._proxy.$unregisterEditorProvider(r)}))}async $createCustomDocument(t,r,i,s,l){var b;const p=this._editorProviders.get(r);if(!p)throw new Error(`No provider found for '${r}'`);if(p.type!==1)throw new Error(`Invalid provide type for '${r}'`);const P=y.URI.revive(t),A=await p.provider.openCustomDocument(P,{backupId:i,untitledDocumentData:s==null?void 0:s.buffer},l);let a;return this.supportEditing(p.provider)&&this._extensionStoragePaths&&(a=(b=this._extensionStoragePaths.workspaceValue(p.extension))!==null&&b!==void 0?b:this._extensionStoragePaths.globalValue(p.extension)),this._documents.add(r,A,a),{editable:this.supportEditing(p.provider)}}async $disposeCustomDocument(t,r){const i=this._editorProviders.get(r);if(!i)throw new Error(`No provider found for '${r}'`);if(i.type!==1)throw new Error(`Invalid provider type for '${r}'`);const s=y.URI.revive(t),{document:l}=this.getCustomDocumentEntry(r,s);this._documents.delete(r,l),l.dispose()}async $resolveWebviewEditor(t,r,i,s,l,b){const p=this._editorProviders.get(i);if(!p)throw new Error(`No provider found for '${i}'`);const P=_.ViewColumn.to(l),A=this._extHostWebview.createNewWebview(r,s.webviewOptions,p.extension),a=this._extHostWebviewPanels.createNewWebviewPanel(r,i,s.title,P,s.panelOptions,A),F=y.URI.revive(t);switch(p.type){case 1:{const{document:N}=this.getCustomDocumentEntry(i,F);return p.provider.resolveCustomEditor(N,a,b)}case 0:{const N=this._extHostDocuments.getDocument(F);return p.provider.resolveCustomTextEditor(N,a,b)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,r,i){this.getCustomDocumentEntry(r,t).disposeEdits(i)}async $onMoveCustomEditor(t,r,i){const s=this._editorProviders.get(i);if(!s)throw new Error(`No provider found for '${i}'`);if(!s.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${i}'`);const l=this._extHostWebviewPanels.getWebviewPanel(t);if(!l)throw new Error("No webview found");const b=y.URI.revive(r),p=this._extHostDocuments.getDocument(b);await s.provider.moveCustomTextEditor(p,l,g.CancellationToken.None)}async $undo(t,r,i,s){return this.getCustomDocumentEntry(r,t).undo(i,s)}async $redo(t,r,i,s){return this.getCustomDocumentEntry(r,t).redo(i,s)}async $revert(t,r,i){const s=this.getCustomDocumentEntry(r,t);await this.getCustomEditorProvider(r).revertCustomDocument(s.document,i),s.disposeBackup()}async $onSave(t,r,i){const s=this.getCustomDocumentEntry(r,t);await this.getCustomEditorProvider(r).saveCustomDocument(s.document,i),s.disposeBackup()}async $onSaveAs(t,r,i,s){const l=this.getCustomDocumentEntry(r,t);return this.getCustomEditorProvider(r).saveCustomDocumentAs(l.document,y.URI.revive(i),s)}async $backup(t,r,i){const s=this.getCustomDocumentEntry(r,t),b=await this.getCustomEditorProvider(r).backupCustomDocument(s.document,{destination:s.getNewBackupUri()},i);return s.updateBackup(b),b.id}getCustomDocumentEntry(t,r){const i=this._documents.get(t,y.URI.revive(r));if(!i)throw new Error("No custom document found");return i}getCustomEditorProvider(t){const r=this._editorProviders.get(t),i=r==null?void 0:r.provider;if(!i||!this.supportEditing(i))throw new Error("Custom document is not editable");return i}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=v;function S(f){return typeof f.resolveCustomTextEditor=="function"}function c(f){return typeof f.undo=="function"&&typeof f.redo=="function"}function m(f){const t=f.scheme===E.Schemas.file||f.scheme===E.Schemas.untitled?f.fsPath:f.toString();return T.hash(t)+""}});var tt=this&&this.__classPrivateFieldSet||function(Z,e,g,T,D){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!D:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?D.call(Z,g):D?D.value=g:e.set(Z,g),g},xe=this&&this.__classPrivateFieldGet||function(Z,e,g,T){if(g==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!T:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?T:g==="a"?T.call(Z):T?T.value:e.get(Z)};define(we[200],_e([0,1,3,7,2,34,9,46,4,6]),function(Z,e,g,T,D,E,C,y,_,k){"use strict";var n,I,o,h,d,u,w,v,S,c,m,f,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class r extends T.Disposable{constructor(b,p,P,A,a,F,N){super();n.set(this,void 0),I.set(this,void 0),o.set(this,void 0),h.set(this,void 0),d.set(this,void 0),u.set(this,void 0),w.set(this,void 0),v.set(this,void 0),S.set(this,!0),c.set(this,!0),m.set(this,!1),f.set(this,this._register(new g.Emitter)),this.onDidDispose=xe(this,f,"f").event,t.set(this,this._register(new g.Emitter)),this.onDidChangeViewState=xe(this,t,"f").event,tt(this,n,b,"f"),tt(this,I,p,"f"),tt(this,o,P,"f"),tt(this,d,F,"f"),tt(this,v,a,"f"),tt(this,u,A,"f"),tt(this,h,N,"f")}dispose(){xe(this,m,"f")||(tt(this,m,!0,"f"),xe(this,f,"f").fire(),xe(this,I,"f").$disposeWebview(xe(this,n,"f")),xe(this,h,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),xe(this,h,"f")}get viewType(){return this.assertNotDisposed(),xe(this,o,"f")}get title(){return this.assertNotDisposed(),xe(this,u,"f")}set title(b){this.assertNotDisposed(),xe(this,u,"f")!==b&&(tt(this,u,b,"f"),xe(this,I,"f").$setTitle(xe(this,n,"f"),b))}get iconPath(){return this.assertNotDisposed(),xe(this,w,"f")}set iconPath(b){this.assertNotDisposed(),xe(this,w,"f")!==b&&(tt(this,w,b,"f"),xe(this,I,"f").$setIconPath(xe(this,n,"f"),D.URI.isUri(b)?{light:b,dark:b}:b))}get options(){return xe(this,d,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof xe(this,v,"f")=="number"&&xe(this,v,"f")<0))return xe(this,v,"f")}get active(){return this.assertNotDisposed(),xe(this,c,"f")}get visible(){return this.assertNotDisposed(),xe(this,S,"f")}_updateViewState(b){xe(this,m,"f")||(this.active!==b.active||this.visible!==b.visible||this.viewColumn!==b.viewColumn)&&(tt(this,c,b.active,"f"),tt(this,S,b.visible,"f"),tt(this,v,b.viewColumn,"f"),xe(this,t,"f").fire({webviewPanel:this}))}reveal(b,p){this.assertNotDisposed(),xe(this,I,"f").$reveal(xe(this,n,"f"),{viewColumn:b?C.ViewColumn.from(b):void 0,preserveFocus:!!p})}assertNotDisposed(){if(xe(this,m,"f"))throw new Error("Webview is disposed")}}n=new WeakMap,I=new WeakMap,o=new WeakMap,h=new WeakMap,d=new WeakMap,u=new WeakMap,w=new WeakMap,v=new WeakMap,S=new WeakMap,c=new WeakMap,m=new WeakMap,f=new WeakMap,t=new WeakMap;class i{constructor(b,p,P){this.webviews=p,this.workspace=P,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=b.getProxy(_.MainContext.MainThreadWebviewPanels)}static newHandle(){return E.generateUuid()}createWebviewPanel(b,p,P,A,a={}){const F=typeof A=="object"?A.viewColumn:A,N={viewColumn:C.ViewColumn.from(F),preserveFocus:typeof A=="object"&&!!A.preserveFocus},H=y.shouldSerializeBuffersForPostMessage(b),le=i.newHandle();this._proxy.$createWebviewPanel(y.toExtensionData(b),le,p,{title:P,panelOptions:s(a),webviewOptions:y.serializeWebviewOptions(b,this.workspace,a),serializeBuffersForPostMessage:H},N);const fe=this.webviews.createNewWebview(le,a,b);return this.createNewWebviewPanel(le,p,P,F,a,fe)}$onDidChangeWebviewPanelViewStates(b){const p=Object.keys(b);p.sort((P,A)=>{const a=b[P],F=b[A];return a.active?1:F.active?-1:+a.visible-+F.visible});for(const P of p){const A=this.getWebviewPanel(P);if(!A)continue;const a=b[P];A._updateViewState({active:a.active,visible:a.visible,viewColumn:C.ViewColumn.to(a.position)})}}async $onDidDisposeWebviewPanel(b){const p=this.getWebviewPanel(b);p==null||p.dispose(),this._webviewPanels.delete(b),this.webviews.deleteWebview(b)}registerWebviewPanelSerializer(b,p,P){if(this._serializers.has(p))throw new Error(`Serializer for '${p}' already registered`);return this._serializers.set(p,{serializer:P,extension:b}),this._proxy.$registerSerializer(p,{serializeBuffersForPostMessage:y.shouldSerializeBuffersForPostMessage(b)}),new k.Disposable(()=>{this._serializers.delete(p),this._proxy.$unregisterSerializer(p)})}async $deserializeWebviewPanel(b,p,P,A){const a=this._serializers.get(p);if(!a)throw new Error(`No serializer found for '${p}'`);const{serializer:F,extension:N}=a,H=this.webviews.createNewWebview(b,P.webviewOptions,N),le=this.createNewWebviewPanel(b,p,P.title,A,P.panelOptions,H);await F.deserializeWebviewPanel(le,P.state)}createNewWebviewPanel(b,p,P,A,a,F){const N=new r(b,this._proxy,p,P,A,a,F);return this._webviewPanels.set(b,N),N}getWebviewPanel(b){return this._webviewPanels.get(b)}}e.ExtHostWebviewPanels=i;function s(l){return{enableFindWidget:l.enableFindWidget,retainContextWhenHidden:l.retainContextWhenHidden}}});var tt=this&&this.__classPrivateFieldSet||function(Z,e,g,T,D){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!D:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?D.call(Z,g):D?D.value=g:e.set(Z,g),g},xe=this&&this.__classPrivateFieldGet||function(Z,e,g,T){if(g==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!T:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?T:g==="a"?T.call(Z):T?T.value:e.get(Z)};define(we[201],_e([0,1,3,7,46,4,6]),function(Z,e,g,T,D,E,C){"use strict";var y,_,k,n,I,o,h,d,u,w;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class v extends T.Disposable{constructor(m,f,t,r,i,s){super();y.set(this,void 0),_.set(this,void 0),k.set(this,void 0),n.set(this,void 0),I.set(this,!1),o.set(this,void 0),h.set(this,void 0),d.set(this,void 0),u.set(this,this._register(new g.Emitter)),this.onDidChangeVisibility=xe(this,u,"f").event,w.set(this,this._register(new g.Emitter)),this.onDidDispose=xe(this,w,"f").event,tt(this,k,t,"f"),tt(this,h,r,"f"),tt(this,y,m,"f"),tt(this,_,f,"f"),tt(this,n,i,"f"),tt(this,o,s,"f")}dispose(){xe(this,I,"f")||(tt(this,I,!0,"f"),xe(this,w,"f").fire(),xe(this,n,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),xe(this,h,"f")}set title(m){this.assertNotDisposed(),xe(this,h,"f")!==m&&(tt(this,h,m,"f"),xe(this,_,"f").$setWebviewViewTitle(xe(this,y,"f"),m))}get description(){return this.assertNotDisposed(),xe(this,d,"f")}set description(m){this.assertNotDisposed(),xe(this,d,"f")!==m&&(tt(this,d,m,"f"),xe(this,_,"f").$setWebviewViewDescription(xe(this,y,"f"),m))}get visible(){return xe(this,o,"f")}get webview(){return xe(this,n,"f")}get viewType(){return xe(this,k,"f")}_setVisible(m){m===xe(this,o,"f")||xe(this,I,"f")||(tt(this,o,m,"f"),xe(this,u,"f").fire())}show(m){this.assertNotDisposed(),xe(this,_,"f").$show(xe(this,y,"f"),!!m)}assertNotDisposed(){if(xe(this,I,"f"))throw new Error("Webview is disposed")}}y=new WeakMap,_=new WeakMap,k=new WeakMap,n=new WeakMap,I=new WeakMap,o=new WeakMap,h=new WeakMap,d=new WeakMap,u=new WeakMap,w=new WeakMap;class S{constructor(m,f){this._extHostWebview=f,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=m.getProxy(E.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(m,f,t,r){if(this._viewProviders.has(f))throw new Error(`View provider for '${f}' already registered`);return this._viewProviders.set(f,{provider:t,extension:m}),this._proxy.$registerWebviewViewProvider(D.toExtensionData(m),f,{retainContextWhenHidden:r==null?void 0:r.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new C.Disposable(()=>{this._viewProviders.delete(f),this._proxy.$unregisterWebviewViewProvider(f)})}async $resolveWebviewView(m,f,t,r,i){const s=this._viewProviders.get(f);if(!s)throw new Error(`No view provider found for '${f}'`);const{provider:l,extension:b}=s,p=this._extHostWebview.createNewWebview(m,{},b),P=new v(m,this._proxy,f,t,p,!0);this._webviewViews.set(m,P),await l.resolveWebviewView(P,{state:r},i)}async $onDidChangeWebviewViewVisibility(m,f){this.getWebviewView(m)._setVisible(f)}async $disposeWebviewView(m){const f=this.getWebviewView(m);this._webviewViews.delete(m),f.dispose(),this._extHostWebview.deleteWebview(m)}getWebviewView(m){const f=this._webviewViews.get(m);if(!f)throw new Error("No webview found");return f}}e.ExtHostWebviewViews=S}),define(we[100],_e([0,1,3,4,2,15,8,5,14]),function(Z,e,g,T,D,E,C,y,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let k=class Ln{constructor(I){this._onDidChangeWindowState=new g.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Ln.InitialState,this._proxy=I.getProxy(T.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(o=>this.$onDidChangeWindowFocus(o))}get state(){return this._state}$onDidChangeWindowFocus(I){I!==this._state.focused&&(this._state=Object.assign(Object.assign({},this._state),{focused:I}),this._onDidChangeWindowState.fire(this._state))}openUri(I,o){let h;if(typeof I=="string"){h=I;try{I=D.URI.parse(I)}catch(d){return Promise.reject(`Invalid uri - '${I}'`)}}return C.isFalsyOrWhitespace(I.scheme)?Promise.reject("Invalid scheme - cannot be empty"):I.scheme===E.Schemas.command?Promise.reject(`Invalid scheme '${I.scheme}'`):this._proxy.$openUri(I,h,o)}async asExternalUri(I,o){if(C.isFalsyOrWhitespace(I.scheme))return Promise.reject("Invalid scheme - cannot be empty");const h=await this._proxy.$asExternalUri(I,o);return D.URI.from(h)}};k.InitialState={focused:!0},k=He([ze(0,_.IExtHostRpcService)],k),e.ExtHostWindow=k,e.IExtHostWindow=y.createDecorator("IExtHostWindow")}),define(we[202],_e([0,1,17,4,28,14]),function(Z,e,g,T,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let C=class extends g.AbstractLogger{constructor(_,k){super();this._proxy=_.getProxy(T.MainContext.MainThreadLog),this._logFile=k.logFile.toJSON(),this.setLevel(k.logLevel)}$setLevel(_){this.setLevel(_)}trace(_,...k){this.getLevel()<=g.LogLevel.Trace&&this._proxy.$log(this._logFile,g.LogLevel.Trace,Array.from(arguments))}debug(_,...k){this.getLevel()<=g.LogLevel.Debug&&this._proxy.$log(this._logFile,g.LogLevel.Debug,Array.from(arguments))}info(_,...k){this.getLevel()<=g.LogLevel.Info&&this._proxy.$log(this._logFile,g.LogLevel.Info,Array.from(arguments))}warn(_,...k){this.getLevel()<=g.LogLevel.Warning&&this._proxy.$log(this._logFile,g.LogLevel.Warning,Array.from(arguments))}error(_,...k){this.getLevel()<=g.LogLevel.Error&&this._proxy.$log(this._logFile,g.LogLevel.Error,Array.from(arguments))}critical(_,...k){this.getLevel()<=g.LogLevel.Critical&&this._proxy.$log(this._logFile,g.LogLevel.Critical,Array.from(arguments))}flush(){}};C=He([ze(0,E.IExtHostRpcService),ze(1,D.IExtHostInitDataService)],C),e.ExtHostLogService=C}),define(we[203],_e([0,1,11,18,12,3,7,112,174,97,23]),function(Z,e,g,T,D,E,C,y,_,k,n){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0;function o(s,l){try{return JSON.stringify(s,l)}catch(b){return"null"}}function h(s,l){return JSON.stringify(s,l)}function d(s){return s?(l,b)=>b&&b.$mid===1?s.transformOutgoing(b):b:null}var u;(function(s){s[s.LocalSide=0]="LocalSide",s[s.OtherSide=1]="OtherSide"})(u=e.RequestInitiator||(e.RequestInitiator={}));var w;(function(s){s[s.Responsive=0]="Responsive",s[s.Unresponsive=1]="Unresponsive"})(w=e.ResponsiveState||(e.ResponsiveState={}));const v=()=>{},S=Symbol.for("rpcProtocol"),c=Symbol.for("rpcProxy");class m extends C.Disposable{constructor(l,b=null,p=null){super();this[I]=!0,this._onDidChangeResponsiveState=this._register(new E.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=l,this._logger=b,this._uriTransformer=p,this._uriReplacer=d(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let P=0,A=k.ProxyIdentifier.count;P<A;P++)this._locals[P]=null,this._proxies[P]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new g.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(P=>this._receiveOneMessage(P))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(l=>{this._pendingRPCReplies[l].resolveErr(D.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(l){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+m.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(l){this._unresponsiveTime=Date.now()+m.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(l){this._responsiveState!==l&&(this._responsiveState=l,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(l){return this._uriTransformer?y.transformIncomingURIs(l,this._uriTransformer):l}getProxy(l){const{nid:b,sid:p}=l;return this._proxies[b]||(this._proxies[b]=this._createProxy(b,p)),this._proxies[b]}_createProxy(l,b){let p={get:(P,A)=>(typeof A=="string"&&!P[A]&&A.charCodeAt(0)===36&&(P[A]=(...a)=>this._remoteCall(l,A,a)),A===c?b:P[A])};return new Proxy(Object.create(null),p)}set(l,b){return this._locals[l.nid]=b,b}assertRegistered(l){for(let b=0,p=l.length;b<p;b++){const P=l[b];if(!this._locals[P.nid])throw new Error(`Missing actor ${P.sid} (isMain: ${P.isMain})`)}}_receiveOneMessage(l){if(this._isDisposed)return;const b=l.byteLength,p=f.read(l,0),P=p.readUInt8(),A=p.readUInt32();switch(P){case 1:case 2:{let{rpcId:a,method:F,args:N}=t.deserializeRequestJSONArgs(p);this._uriTransformer&&(N=y.transformIncomingURIs(N,this._uriTransformer)),this._receiveRequest(b,A,a,F,N,P===2);break}case 3:case 4:{let{rpcId:a,method:F,args:N}=t.deserializeRequestMixedArgs(p);this._uriTransformer&&(N=y.transformIncomingURIs(N,this._uriTransformer)),this._receiveRequest(b,A,a,F,N,P===4);break}case 5:{this._logger&&this._logger.logIncoming(b,A,0,"ack"),this._onDidReceiveAcknowledge(A);break}case 6:{this._receiveCancel(b,A);break}case 7:{this._receiveReply(b,A,void 0);break}case 9:{let a=t.deserializeReplyOKJSON(p);this._uriTransformer&&(a=y.transformIncomingURIs(a,this._uriTransformer)),this._receiveReply(b,A,a);break}case 8:{let a=t.deserializeReplyOKVSBuffer(p);this._receiveReply(b,A,a);break}case 10:{let a=t.deserializeReplyErrError(p);this._uriTransformer&&(a=y.transformIncomingURIs(a,this._uriTransformer)),this._receiveReplyErr(b,A,a);break}case 11:{this._receiveReplyErr(b,A,void 0);break}default:console.error("received unexpected message"),console.error(l)}}_receiveRequest(l,b,p,P,A,a){this._logger&&this._logger.logIncoming(l,b,1,`receiveRequest ${k.getStringIdentifierForProxy(p)}.${P}(`,A);const F=String(b);let N,H;if(a){const fe=new T.CancellationTokenSource;A.push(fe.token),N=this._invokeHandler(p,P,A),H=()=>fe.cancel()}else N=this._invokeHandler(p,P,A),H=v;this._cancelInvokedHandlers[F]=H;const le=t.serializeAcknowledged(b);this._logger&&this._logger.logOutgoing(le.byteLength,b,1,"ack"),this._protocol.send(le),N.then(fe=>{delete this._cancelInvokedHandlers[F];const X=t.serializeReplyOK(b,fe,this._uriReplacer);this._logger&&this._logger.logOutgoing(X.byteLength,b,1,"reply:",fe),this._protocol.send(X)},fe=>{delete this._cancelInvokedHandlers[F];const X=t.serializeReplyErr(b,fe);this._logger&&this._logger.logOutgoing(X.byteLength,b,1,"replyErr:",fe),this._protocol.send(X)})}_receiveCancel(l,b){this._logger&&this._logger.logIncoming(l,b,1,"receiveCancel");const p=String(b);this._cancelInvokedHandlers[p]&&this._cancelInvokedHandlers[p]()}_receiveReply(l,b,p){this._logger&&this._logger.logIncoming(l,b,0,"receiveReply:",p);const P=String(b);if(!this._pendingRPCReplies.hasOwnProperty(P))return;const A=this._pendingRPCReplies[P];delete this._pendingRPCReplies[P],A.resolveOk(p)}_receiveReplyErr(l,b,p){this._logger&&this._logger.logIncoming(l,b,0,"receiveReplyErr:",p);const P=String(b);if(!this._pendingRPCReplies.hasOwnProperty(P))return;const A=this._pendingRPCReplies[P];delete this._pendingRPCReplies[P];let a;p&&(p.$isError?(a=new Error,a.name=p.name,a.message=p.message,a.stack=p.stack):a=p),A.resolveErr(a)}_invokeHandler(l,b,p){try{return Promise.resolve(this._doInvokeHandler(l,b,p))}catch(P){return Promise.reject(P)}}_doInvokeHandler(l,b,p){const P=this._locals[l];if(!P)throw new Error("Unknown actor "+k.getStringIdentifierForProxy(l));let A=P[b];if(typeof A!="function")throw new Error("Unknown method "+b+" on actor "+k.getStringIdentifierForProxy(l));return A.apply(P,p)}_remoteCall(l,b,p){if(this._isDisposed)return Promise.reject(D.canceled());let P=null;if(p.length>0&&T.CancellationToken.isCancellationToken(p[p.length-1])&&(P=p.pop()),P&&P.isCancellationRequested)return Promise.reject(D.canceled());const A=t.serializeRequestArguments(p,this._uriReplacer),a=++this._lastMessageId,F=String(a),N=new _.LazyPromise;P&&P.onCancellationRequested(()=>{const le=t.serializeCancel(a);this._logger&&this._logger.logOutgoing(le.byteLength,a,0,"cancel"),this._protocol.send(t.serializeCancel(a))}),this._pendingRPCReplies[F]=N,this._onWillSendRequest(a);const H=t.serializeRequest(a,l,b,A,!!P);return this._logger&&this._logger.logOutgoing(H.byteLength,a,0,`request: ${k.getStringIdentifierForProxy(l)}.${b}(`,p),this._protocol.send(H),N}}e.RPCProtocol=m,I=S,m.UNRESPONSIVE_TIME=3*1e3;class f{constructor(l,b){this._buff=l,this._offset=b}static alloc(l,b,p){let P=new f(n.VSBuffer.alloc(p+1+4),0);return P.writeUInt8(l),P.writeUInt32(b),P}static read(l,b){return new f(l,b)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(l){this._buff.writeUInt8(l,this._offset),this._offset+=1}readUInt8(){const l=this._buff.readUInt8(this._offset);return this._offset+=1,l}writeUInt32(l){this._buff.writeUInt32BE(l,this._offset),this._offset+=4}readUInt32(){const l=this._buff.readUInt32BE(this._offset);return this._offset+=4,l}static sizeShortString(l){return 1+l.byteLength}writeShortString(l){this._buff.writeUInt8(l.byteLength,this._offset),this._offset+=1,this._buff.set(l,this._offset),this._offset+=l.byteLength}readShortString(){const l=this._buff.readUInt8(this._offset);this._offset+=1;const p=this._buff.slice(this._offset,this._offset+l).toString();return this._offset+=l,p}static sizeLongString(l){return 4+l.byteLength}writeLongString(l){this._buff.writeUInt32BE(l.byteLength,this._offset),this._offset+=4,this._buff.set(l,this._offset),this._offset+=l.byteLength}readLongString(){const l=this._buff.readUInt32BE(this._offset);this._offset+=4;const p=this._buff.slice(this._offset,this._offset+l).toString();return this._offset+=l,p}writeBuffer(l){this._buff.writeUInt32BE(l.byteLength,this._offset),this._offset+=4,this._buff.set(l,this._offset),this._offset+=l.byteLength}static sizeVSBuffer(l){return 4+l.byteLength}writeVSBuffer(l){this._buff.writeUInt32BE(l.byteLength,this._offset),this._offset+=4,this._buff.set(l,this._offset),this._offset+=l.byteLength}readVSBuffer(){const l=this._buff.readUInt32BE(this._offset);this._offset+=4;const b=this._buff.slice(this._offset,this._offset+l);return this._offset+=l,b}static sizeMixedArray(l,b){let p=0;p+=1;for(let P=0,A=l.length;P<A;P++){const a=l[P],F=b[P];switch(p+=1,F){case 1:p+=this.sizeLongString(a);break;case 2:p+=this.sizeVSBuffer(a);break;case 3:break}}return p}writeMixedArray(l,b){this._buff.writeUInt8(l.length,this._offset),this._offset+=1;for(let p=0,P=l.length;p<P;p++){const A=l[p];switch(b[p]){case 1:this.writeUInt8(1),this.writeLongString(A);break;case 2:this.writeUInt8(2),this.writeVSBuffer(A);break;case 3:this.writeUInt8(3);break}}}readMixedArray(){const l=this._buff.readUInt8(this._offset);this._offset+=1;let b=new Array(l);for(let p=0;p<l;p++)switch(this.readUInt8()){case 1:b[p]=this.readLongString();break;case 2:b[p]=this.readVSBuffer();break;case 3:b[p]=void 0;break}return b}}class t{static _arrayContainsBufferOrUndefined(l){for(let b=0,p=l.length;b<p;b++)if(l[b]instanceof n.VSBuffer||typeof l[b]=="undefined")return!0;return!1}static serializeRequestArguments(l,b){if(this._arrayContainsBufferOrUndefined(l)){let p=[],P=[];for(let A=0,a=l.length;A<a;A++){const F=l[A];F instanceof n.VSBuffer?(p[A]=F,P[A]=2):typeof F=="undefined"?(p[A]=n.VSBuffer.alloc(0),P[A]=3):(p[A]=n.VSBuffer.fromString(h(F,b)),P[A]=1)}return{type:"mixed",args:p,argsType:P}}return{type:"simple",args:h(l,b)}}static serializeRequest(l,b,p,P,A){return P.type==="mixed"?this._requestMixedArgs(l,b,p,P.args,P.argsType,A):this._requestJSONArgs(l,b,p,P.args,A)}static _requestJSONArgs(l,b,p,P,A){const a=n.VSBuffer.fromString(p),F=n.VSBuffer.fromString(P);let N=0;N+=f.sizeUInt8(),N+=f.sizeShortString(a),N+=f.sizeLongString(F);let H=f.alloc(A?2:1,l,N);return H.writeUInt8(b),H.writeShortString(a),H.writeLongString(F),H.buffer}static deserializeRequestJSONArgs(l){const b=l.readUInt8(),p=l.readShortString(),P=l.readLongString();return{rpcId:b,method:p,args:JSON.parse(P)}}static _requestMixedArgs(l,b,p,P,A,a){const F=n.VSBuffer.fromString(p);let N=0;N+=f.sizeUInt8(),N+=f.sizeShortString(F),N+=f.sizeMixedArray(P,A);let H=f.alloc(a?4:3,l,N);return H.writeUInt8(b),H.writeShortString(F),H.writeMixedArray(P,A),H.buffer}static deserializeRequestMixedArgs(l){const b=l.readUInt8(),p=l.readShortString(),P=l.readMixedArray(),A=new Array(P.length);for(let a=0,F=P.length;a<F;a++){const N=P[a];typeof N=="string"?A[a]=JSON.parse(N):A[a]=N}return{rpcId:b,method:p,args:A}}static serializeAcknowledged(l){return f.alloc(5,l,0).buffer}static serializeCancel(l){return f.alloc(6,l,0).buffer}static serializeReplyOK(l,b,p){return typeof b=="undefined"?this._serializeReplyOKEmpty(l):b instanceof n.VSBuffer?this._serializeReplyOKVSBuffer(l,b):this._serializeReplyOKJSON(l,o(b,p))}static _serializeReplyOKEmpty(l){return f.alloc(7,l,0).buffer}static _serializeReplyOKVSBuffer(l,b){let p=0;p+=f.sizeVSBuffer(b);let P=f.alloc(8,l,p);return P.writeVSBuffer(b),P.buffer}static deserializeReplyOKVSBuffer(l){return l.readVSBuffer()}static _serializeReplyOKJSON(l,b){const p=n.VSBuffer.fromString(b);let P=0;P+=f.sizeLongString(p);let A=f.alloc(9,l,P);return A.writeLongString(p),A.buffer}static deserializeReplyOKJSON(l){const b=l.readLongString();return JSON.parse(b)}static serializeReplyErr(l,b){return b?this._serializeReplyErrEror(l,b):this._serializeReplyErrEmpty(l)}static _serializeReplyErrEror(l,b){const p=n.VSBuffer.fromString(o(D.transformErrorForSerialization(b),null));let P=0;P+=f.sizeLongString(p);let A=f.alloc(10,l,P);return A.writeLongString(p),A.buffer}static deserializeReplyErrError(l){const b=l.readLongString();return JSON.parse(b)}static _serializeReplyErrEmpty(l){return f.alloc(11,l,0).buffer}}var r;(function(s){s[s.RequestJSONArgs=1]="RequestJSONArgs",s[s.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",s[s.RequestMixedArgs=3]="RequestMixedArgs",s[s.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",s[s.Acknowledged=5]="Acknowledged",s[s.Cancel=6]="Cancel",s[s.ReplyOKEmpty=7]="ReplyOKEmpty",s[s.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",s[s.ReplyOKJSON=9]="ReplyOKJSON",s[s.ReplyErrError=10]="ReplyErrError",s[s.ReplyErrEmpty=11]="ReplyErrEmpty"})(r||(r={}));var i;(function(s){s[s.String=1]="String",s[s.VSBuffer=2]="VSBuffer",s[s.Undefined=3]="Undefined"})(i||(i={}))}),define(we[204],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const g=function(E){const C=y=>{self.removeEventListener("message",C);const _=y.data;Object.defineProperties(self,{postMessage:{value(k,n){_.postMessage(k,n)}},onmessage:{get(){return _.onmessage},set(k){_.onmessage=k}}}),_.addEventListener("message",k=>{self.dispatchEvent(new MessageEvent("message",{data:k.data}))}),_.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(E)};self.addEventListener("message",C)}.toString();class T extends EventTarget{constructor(E,C,y){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const _=`((${g})('${C}'))`,k=new Blob([_],{type:"application/javascript"}),n=URL.createObjectURL(k),I=new MessageChannel,o=n,h={type:"_newWorker",id:o,port:I.port2,url:n,options:y};E(h,[I.port2]),this.postMessage=I.port1.postMessage.bind(I.port1),this.terminate=()=>{const d={type:"_terminateWorker",id:o};I.port1.postMessage(d),URL.revokeObjectURL(n),I.port1.close(),I.port2.close()},Object.defineProperties(this,{onmessage:{get(){return I.port1.onmessage},set(d){I.port1.onmessage=d}},onmessageerror:{get(){return I.port1.onmessageerror},set(d){I.port1.onmessageerror=d}}}),I.port1.addEventListener("messageerror",d=>{const u=new MessageEvent("messageerror",{data:d.data});this.dispatchEvent(u)}),I.port1.addEventListener("message",d=>{const u=new MessageEvent("message",{data:d.data});this.dispatchEvent(u)}),I.port1.start()}}e.NestedWorker=T}),define(we[205],_e([0,1,5]),function(Z,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=g.createDecorator("remoteAgentService")}),define(we[206],_e([0,1,15,13,21,2,5,205]),function(Z,e,g,T,D,E,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=C.createDecorator("pathService");let _=class{constructor(n,I){this.localUserHome=n,this.remoteAgentService=I,this.resolveOS=(async()=>{const o=await this.remoteAgentService.getEnvironment();return(o==null?void 0:o.os)||D.OS})(),this.resolveUserHome=(async()=>{const o=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=(o==null?void 0:o.userHome)||n})()}async userHome(n){return(n==null?void 0:n.preferLocal)?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(n=>n===1?T.win32:T.posix)}async fileURI(n){let I="";if(await this.resolveOS===1&&(n=n.replace(/\\/g,"/")),n[0]==="/"&&n[1]==="/"){const h=n.indexOf("/",2);h===-1?(I=n.substring(2),n="/"):(I=n.substring(2,h),n=n.substring(h)||"/")}return E.URI.from({scheme:g.Schemas.file,authority:I,path:n,query:"",fragment:""})}};_=He([ze(1,y.IRemoteAgentService)],_),e.AbstractPathService=_}),define(we[101],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class g{constructor(C,y){this.line=C,this.character=y}isBefore(C){return!1}isBeforeOrEqual(C){return!1}isAfter(C){return!1}isAfterOrEqual(C){return!1}isEqual(C){return!1}compareTo(C){return 0}translate(C,y){return new g(0,0)}with(C){return new g(0,0)}}e.Position=g;class T{constructor(C,y,_,k){this.isEmpty=!1,this.isSingleLine=!1,this.start=new g(C,y),this.end=new g(_,k)}contains(C){return!1}isEqual(C){return!1}intersection(C){}union(C){return new T(0,0,0,0)}with(C){return new T(0,0,0,0)}}e.Range=T;var D;(function(E){E[E.Information=1]="Information",E[E.Warning=2]="Warning"})(D=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(we[38],_e([0,1,16,27,24,42,8,5,13,12,101]),function(Z,e,g,T,D,E,C,y,_,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return n.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const I="\u27EA ",o=" characters skipped \u27EB",h=(I.length+o.length+5)*2;e.ISearchService=y.createDecorator("searchService");var d;(function(R){R[R.file=0]="file",R[R.text=1]="text"})(d=e.SearchProviderType||(e.SearchProviderType={}));var u;(function(R){R[R.File=1]="File",R[R.Text=2]="Text"})(u=e.QueryType||(e.QueryType={}));function w(R){return!!R.preview}e.resultIsMatch=w;function v(R){return!!R.resource}e.isFileMatch=v;function S(R){return!!R.message}e.isProgressMessage=S;var c;(function(R){R[R.Normal=0]="Normal",R[R.NewSearchStarted=1]="NewSearchStarted"})(c=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class m{constructor(B){this.resource=B,this.results=[]}}e.FileMatch=m;class f{constructor(B,M,U){this.ranges=M;const q=Array.isArray(M)?M:[M];if(U&&U.matchLines===1&&t(q)){B=C.getNLines(B,U.matchLines);let V="",oe=0,ge=0;const Re=Math.floor(U.charsPerLine/5),$e=[];for(const Me of q){const We=Math.max(Me.startColumn-Re,0),Je=Me.startColumn+U.charsPerLine;if(We>ge+Re+h){const Qe=I+(We-ge)+o;V+=Qe+B.slice(We,Je),oe+=We-(ge+Qe.length)}else V+=B.slice(ge,Je);$e.push(new i(0,Me.startColumn-oe,Me.endColumn-oe)),ge=Je}this.preview={text:V,matches:Array.isArray(this.ranges)?$e:$e[0]}}else{const V=Array.isArray(M)?M[0].startLineNumber:M.startLineNumber;this.preview={text:B,matches:g.mapArrayOrNot(M,oe=>new r(oe.startLineNumber-V,oe.startColumn,oe.endLineNumber-V,oe.endColumn))}}}}e.TextSearchMatch=f;function t(R){const B=R[0].startLineNumber;for(const M of R)if(M.startLineNumber!==B||M.endLineNumber!==B)return!1;return!0}class r{constructor(B,M,U,q){this.startLineNumber=B,this.startColumn=M,this.endLineNumber=U,this.endColumn=q}}e.SearchRange=r;class i extends r{constructor(B,M,U){super(B,M,B,U)}}e.OneLineRange=i;var s;(function(R){R.Default="default",R.FileNames="fileNames",R.Type="type",R.Modified="modified",R.CountDescending="countDescending",R.CountAscending="countAscending"})(s=e.SearchSortOrder||(e.SearchSortOrder={}));function l(R,B=!0){const M=R&&R.files&&R.files.exclude,U=B&&R&&R.search&&R.search.exclude;if(!M&&!U)return;if(!M||!U)return M||U;let q=Object.create(null);return q=D.mixin(q,D.deepClone(M)),q=D.mixin(q,D.deepClone(U),!0),q}e.getExcludes=l;function b(R,B){return R.excludePattern&&T.match(R.excludePattern,B)?!1:R.includePattern||R.usingSearchPaths?R.includePattern&&T.match(R.includePattern,B)?!0:R.usingSearchPaths?!!R.folderQueries&&R.folderQueries.some(M=>{const U=M.folder.fsPath;if(E.isEqualOrParent(B,U)){const q=_.relative(U,B);return!M.includePattern||!!T.match(M.includePattern,q)}else return!1}):!1:!0}e.pathIncludedInQuery=b;var p;(function(R){R[R.unknownEncoding=1]="unknownEncoding",R[R.regexParseError=2]="regexParseError",R[R.globParseError=3]="globParseError",R[R.invalidLiteral=4]="invalidLiteral",R[R.rgProcessError=5]="rgProcessError",R[R.other=6]="other",R[R.canceled=7]="canceled"})(p=e.SearchErrorCode||(e.SearchErrorCode={}));class P extends Error{constructor(B,M){super(B);this.code=M}}e.SearchError=P;function A(R){const B=R.message;if(k.isPromiseCanceledError(R))return new P(B,p.canceled);try{const M=JSON.parse(B);return new P(M.message,M.code)}catch(M){return new P(B,p.other)}}e.deserializeSearchError=A;function a(R){const B={message:R.message,code:R.code};return new Error(JSON.stringify(B))}e.serializeSearchError=a;function F(R){return R.type==="error"?!0:R.type==="success"}e.isSerializedSearchComplete=F;function N(R){return R.type==="success"}e.isSerializedSearchSuccess=N;function H(R){return!!R.path}e.isSerializedFileMatch=H;function le(R,B){const M=R.searchPath?R.searchPath:R.relativePath;return C.fuzzyContains(M,B)}e.isFilePatternMatch=le;class fe{constructor(B){this.path=B,this.results=[]}addMatch(B){this.results.push(B)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=fe;function X(R,B){const M=Object.assign(Object.assign({},R||{}),B||{});return Object.keys(M).filter(U=>{const q=M[U];return typeof q=="boolean"&&q})}e.resolvePatternsForProvider=X;class z{constructor(B,M){this._parsedIncludeExpression=null,this._excludeExpression=Object.assign(Object.assign({},B.excludePattern||{}),M.excludePattern||{}),this._parsedExcludeExpression=T.parse(this._excludeExpression);let U=B.includePattern;M.includePattern&&(U?U=Object.assign(Object.assign({},U),M.includePattern):U=M.includePattern),U&&(this._parsedIncludeExpression=T.parse(U))}includedInQuerySync(B,M,U){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(B,M,U)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(B,M,U))}includedInQuery(B,M,U){return Promise.resolve(this._parsedExcludeExpression(B,M,U)).then(V=>!!V).then(V=>V?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression(B,M,U)).then(oe=>!!oe):Promise.resolve(!0)).then(V=>V)}hasSiblingExcludeClauses(){return Y(this._excludeExpression)}}e.QueryGlobTester=z;function Y(R){for(const B in R)if(typeof R[B]!="boolean")return!0;return!1}}),define(we[30],_e([0,1,16,11,18,3,22,15,77,25,8,10,2,133,5,17,145,62,44,28,14,6,38,4]),function(Z,e,g,T,D,E,C,y,_,k,n,I,o,h,d,u,w,v,S,c,m,f,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function i(F,N,H){return new k.ExtUri(le=>p(le,H)).isEqual(F,N)}function s(F,N,H){return i(F.uri,N.uri,H)?0:n.compare(F.uri.toString(),N.uri.toString())}function l(F,N,H){return F.index!==N.index?F.index<N.index?-1:1:i(F.uri,N.uri,H)?n.compare(F.name,N.name):n.compare(F.uri.toString(),N.uri.toString())}function b(F,N,H,le){const fe=F.slice(0).sort((z,Y)=>H(z,Y,le)),X=N.slice(0).sort((z,Y)=>H(z,Y,le));return g.delta(fe,X,(z,Y)=>H(z,Y,le))}function p(F,N){const H=N.getCapabilities(F.scheme);return!(H&&H&1024)}class P extends v.Workspace{constructor(N,H,le,fe,X,z){super(N,le.map(Y=>new v.WorkspaceFolder(Y)),fe,z);this._name=H,this._isUntitled=X,this._workspaceFolders=[],this._structure=C.TernarySearchTree.forUris(z),le.forEach(Y=>{this._workspaceFolders.push(Y),this._structure.set(Y.uri,Y)})}static toExtHostWorkspace(N,H,le,fe){if(!N)return{workspace:null,added:[],removed:[]};const{id:X,name:z,folders:Y,configuration:R,isUntitled:B}=N,M=[],U=H;H?Y.forEach((ge,Re)=>{const $e=o.URI.revive(ge.uri),Me=P._findFolder(le||H,$e,fe);Me?(Me.name=ge.name,Me.index=ge.index,M.push(Me)):M.push({uri:$e,name:ge.name,index:Re})}):M.push(...Y.map(({uri:ge,name:Re,index:$e})=>({uri:o.URI.revive(ge),name:Re,index:$e}))),M.sort((ge,Re)=>ge.index<Re.index?-1:1);const q=new P(X,z,M,R?o.URI.revive(R):null,!!B,ge=>p(ge,fe)),{added:V,removed:oe}=b(U?U.workspaceFolders:[],q.workspaceFolders,s,fe);return{workspace:q,added:V,removed:oe}}static _findFolder(N,H,le){for(let fe=0;fe<N.folders.length;fe++){const X=N.workspaceFolders[fe];if(i(X.uri,H,le))return X}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(N,H){return H&&this._structure.get(N)&&(N=k.dirname(N)),this._structure.findSubstr(N)}resolveWorkspaceFolder(N){return this._structure.get(N)}}let A=class{constructor(N,H,le,fe){this._onDidChangeWorkspace=new E.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new E.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=fe,this._extHostFileSystemInfo=le,this._requestIdProvider=new _.Counter,this._barrier=new T.Barrier,this._proxy=N.getProxy(r.MainContext.MainThreadWorkspace),this._messageService=N.getProxy(r.MainContext.MainThreadMessageService);const X=H.workspace;this._confirmedWorkspace=X?new P(X.id,X.name,[],X.configuration?o.URI.revive(X.configuration):null,!!X.isUntitled,z=>p(z,le)):void 0}$initializeWorkspace(N,H){this._trusted=H,this.$acceptWorkspaceData(N),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?o.URI.from({scheme:y.Schemas.untitled,path:k.basename(k.dirname(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(N,H,le,...fe){const X=[];if(Array.isArray(fe)&&fe.forEach(M=>{o.URI.isUri(M.uri)&&!X.some(U=>i(U.uri,M.uri,this._extHostFileSystemInfo))&&X.push({uri:M.uri,name:M.name||k.basenameOrAuthority(M.uri)})}),this._unconfirmedWorkspace||[H,le].some(M=>typeof M!="number"||M<0)||le===0&&X.length===0)return!1;const z=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(H+le>z.length)return!1;const Y=z.slice(0);Y.splice(H,le,...X.map(M=>({uri:M.uri,name:M.name||k.basenameOrAuthority(M.uri),index:void 0})));for(let M=0;M<Y.length;M++){const U=Y[M];if(Y.some((q,V)=>V!==M&&i(U.uri,q.uri,this._extHostFileSystemInfo)))return!1}Y.forEach((M,U)=>M.index=U);const{added:R,removed:B}=b(z,Y,l,this._extHostFileSystemInfo);if(R.length===0&&B.length===0)return!1;if(this._proxy){const M=N.displayName||N.name;this._proxy.$updateWorkspaceFolders(M,H,le,X).then(void 0,U=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(w.Severity.Error,h.localize(0,null,M,U.toString()),{extension:N},[])})}return this.trySetWorkspaceFolders(Y),!0}getWorkspaceFolder(N,H){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(N,H)}async getWorkspaceFolder2(N,H){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(N,H)}async resolveWorkspaceFolder(N){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(N)}getPath(){if(!this._actualWorkspace)return;const{folders:N}=this._actualWorkspace;if(N.length!==0)return N[0].uri.fsPath}getRelativePath(N,H){let le,fe="";if(typeof N=="string"?(le=o.URI.file(N),fe=N):typeof N!="undefined"&&(le=N,fe=N.fsPath),!le)return fe;const X=this.getWorkspaceFolder(le,!0);if(!X)return fe;typeof H=="undefined"&&this._actualWorkspace&&(H=this._actualWorkspace.folders.length>1);let z=k.relativePath(X.uri,le);return H&&X.name&&(z=`${X.name}/${z}`),z}trySetWorkspaceFolders(N){this._actualWorkspace&&(this._unconfirmedWorkspace=P.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:N,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(N){const{workspace:H,added:le,removed:fe}=P.toExtHostWorkspace(N,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=H||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:le,removed:fe}))}findFiles(N,H,le,fe,X=D.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${fe.value}, entryPoint: findFiles`);let z;if(H===null?z=!1:H&&(typeof H=="string"?z=H:z=H.pattern),X&&X.isCancellationRequested)return Promise.resolve([]);const{includePattern:Y,folder:R}=a(N);return this._proxy.$startFileSearch(I.withUndefinedAsNull(Y),I.withUndefinedAsNull(R),I.withUndefinedAsNull(z),I.withUndefinedAsNull(le),X).then(B=>Array.isArray(B)?B.map(M=>o.URI.revive(M)):[])}async findTextInFiles(N,H,le,fe,X=D.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${fe.value}, entryPoint: findTextInFiles`);const z=this._requestIdProvider.getNext(),Y=typeof H.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:H.previewOptions,{includePattern:R,folder:B}=a(H.include),M=typeof H.exclude=="string"?H.exclude:H.exclude?H.exclude.pattern:void 0,U={ignoreSymlinks:typeof H.followSymlinks=="boolean"?!H.followSymlinks:void 0,disregardIgnoreFiles:typeof H.useIgnoreFiles=="boolean"?!H.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof H.useGlobalIgnoreFiles=="boolean"?!H.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof H.useDefaultExcludes=="boolean"?!H.useDefaultExcludes:!0,fileEncoding:H.encoding,maxResults:H.maxResults,previewOptions:Y,afterContext:H.afterContext,beforeContext:H.beforeContext,includePattern:R,excludePattern:M},q=!1;if(this._activeSearchCallbacks[z]=V=>{if(q)return;const oe=o.URI.revive(V.resource);V.results.forEach(ge=>{t.resultIsMatch(ge)?le({uri:oe,preview:{text:ge.preview.text,matches:g.mapArrayOrNot(ge.preview.matches,Re=>new f.Range(Re.startLineNumber,Re.startColumn,Re.endLineNumber,Re.endColumn))},ranges:g.mapArrayOrNot(ge.ranges,Re=>new f.Range(Re.startLineNumber,Re.startColumn,Re.endLineNumber,Re.endColumn))}):le({uri:oe,text:ge.text,lineNumber:ge.lineNumber})})},X.isCancellationRequested)return{};try{const V=await this._proxy.$startTextSearch(N,I.withUndefinedAsNull(B),U,z,X);return delete this._activeSearchCallbacks[z],V||{}}catch(V){throw delete this._activeSearchCallbacks[z],V}}$handleTextSearchResult(N,H){this._activeSearchCallbacks[H]&&this._activeSearchCallbacks[H](N)}saveAll(N){return this._proxy.$saveAll(N)}resolveProxy(N){return this._proxy.$resolveProxy(N)}get trusted(){return this._trusted}requestWorkspaceTrust(N){return this._proxy.$requestWorkspaceTrust(N)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};A=He([ze(0,m.IExtHostRpcService),ze(1,c.IExtHostInitDataService),ze(2,S.IExtHostFileSystemInfo),ze(3,u.ILogService)],A),e.ExtHostWorkspace=A,e.IExtHostWorkspace=d.createDecorator("IExtHostWorkspace");function a(F){let N,H;return F&&(typeof F=="string"?N=F:(N=F.pattern,H=F.baseFolder||o.URI.file(F.base))),{includePattern:N,folder:H}}}),define(we[32],_e([0,1,24,3,30,4,6,149,61,10,11,5,14,17,2]),function(Z,e,g,T,D,E,C,y,_,k,n,I,o,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function u(r,i){if(i){const s=i.split(".");let l=r;for(let b=0;l&&b<s.length;b++)l=l[s[b]];return l}}function w(r){return r instanceof d.URI}function v(r){return r&&r.uri instanceof d.URI&&r.languageId&&typeof r.languageId=="string"}function S(r){return r&&!r.uri&&r.languageId&&typeof r.languageId=="string"}function c(r){return r&&r.uri instanceof d.URI&&(!r.name||typeof r.name=="string")&&(!r.index||typeof r.index=="number")}function m(r){if(w(r))return{resource:r};if(v(r))return{resource:r.uri,overrideIdentifier:r.languageId};if(S(r))return{overrideIdentifier:r.languageId};if(c(r))return{resource:r.uri};if(r===null)return{resource:null}}let f=class{constructor(i,s,l){this._proxy=i.getProxy(E.MainContext.MainThreadConfiguration),this._extHostWorkspace=s,this._logService=l,this._barrier=new n.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(i=>this._actual)}$initializeConfiguration(i){this._actual=new t(this._proxy,this._extHostWorkspace,i,this._logService),this._barrier.open()}$acceptConfigurationChanged(i,s){this.getConfigProvider().then(l=>l.$acceptConfigurationChanged(i,s))}};f=He([ze(0,o.IExtHostRpcService),ze(1,D.IExtHostWorkspace),ze(2,h.ILogService)],f),e.ExtHostConfiguration=f;class t{constructor(i,s,l,b){this._onDidChangeConfiguration=new T.Emitter,this._proxy=i,this._logService=b,this._extHostWorkspace=s,this._configuration=y.Configuration.parse(l),this._configurationScopes=this._toMap(l.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(i,s){const l={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=y.Configuration.parse(i),this._configurationScopes=this._toMap(i.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(s,l))}getConfiguration(i,s,l){const b=m(s)||{},p=this._toReadonlyValue(i?u(this._configuration.getValue(void 0,b,this._extHostWorkspace.workspace),i):this._configuration.getValue(void 0,b,this._extHostWorkspace.workspace));i&&this._validateConfigurationAccess(i,b,l==null?void 0:l.identifier);function P(a){if(a==null)return null;if(typeof a=="boolean")return a?1:4;switch(a){case C.ConfigurationTarget.Global:return 1;case C.ConfigurationTarget.Workspace:return 4;case C.ConfigurationTarget.WorkspaceFolder:return 5}}const A={has(a){return typeof u(p,a)!="undefined"},get:(a,F)=>{this._validateConfigurationAccess(i?`${i}.${a}`:a,b,l==null?void 0:l.identifier);let N=u(p,a);if(typeof N=="undefined")N=F;else{let H;const le=(fe,X)=>{let z;const Y=()=>{H=H||g.deepClone(p),z=z||u(H,X)};return k.isObject(fe)?new Proxy(fe,{get:(R,B)=>{if(typeof B=="string"&&B.toLowerCase()==="tojson")return Y(),()=>z;if(H)return z=z||u(H,X),z[B];const M=R[B];return typeof B=="string"?le(M,`${X}.${B}`):M},set:(R,B,M)=>(Y(),z&&(z[B]=M),!0),deleteProperty:(R,B)=>(Y(),z&&delete z[B],!0),defineProperty:(R,B,M)=>(Y(),z&&Object.defineProperty(z,B,M),!0)}):fe};N=le(N,a)}return N},update:(a,F,N,H)=>{a=i?`${i}.${a}`:a;const le=P(N);return F!==void 0?this._proxy.$updateConfigurationOption(le,a,F,b,H):this._proxy.$removeConfigurationOption(le,a,b,H)},inspect:a=>{var F,N,H,le,fe,X,z,Y;a=i?`${i}.${a}`:a;const R=g.deepClone(this._configuration.inspect(a,b,this._extHostWorkspace.workspace));if(R)return{key:a,defaultValue:(F=R.default)===null||F===void 0?void 0:F.value,globalValue:(N=R.user)===null||N===void 0?void 0:N.value,workspaceValue:(H=R.workspace)===null||H===void 0?void 0:H.value,workspaceFolderValue:(le=R.workspaceFolder)===null||le===void 0?void 0:le.value,defaultLanguageValue:(fe=R.default)===null||fe===void 0?void 0:fe.override,globalLanguageValue:(X=R.user)===null||X===void 0?void 0:X.override,workspaceLanguageValue:(z=R.workspace)===null||z===void 0?void 0:z.override,workspaceFolderLanguageValue:(Y=R.workspaceFolder)===null||Y===void 0?void 0:Y.override,languageIds:R.overrideIdentifiers}}};return typeof p=="object"&&g.mixin(A,p,!1),Object.freeze(A)}_toReadonlyValue(i){const s=l=>k.isObject(l)?new Proxy(l,{get:(b,p)=>s(b[p]),set:(b,p,P)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(p)}' of object`)},deleteProperty:(b,p)=>{throw new Error(`TypeError: Cannot delete read only property '${String(p)}' of object`)},defineProperty:(b,p)=>{throw new Error(`TypeError: Cannot define property '${String(p)}' for a readonly object`)},setPrototypeOf:b=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):l;return s(i)}_validateConfigurationAccess(i,s,l){const b=_.OVERRIDE_PROPERTY_PATTERN.test(i)?4:this._configurationScopes.get(i),p=l?`[${l.value}] `:"";if(b===4){typeof(s==null?void 0:s.resource)=="undefined"&&this._logService.warn(`${p}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${i}', provide the URI of a resource or 'null' for any resource.`);return}if(b===3){(s==null?void 0:s.resource)&&this._logService.warn(`${p}Accessing a window scoped configuration for a resource is not expected. To associate '${i}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(i,s){const l=new y.ConfigurationChangeEvent(i,s,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(b,p)=>l.affectsConfiguration(b,m(p))})}_toMap(i){return i.reduce((s,l)=>(s.set(l[0],l[1]),s),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=I.createDecorator("IExtHostConfiguration")});var tt=this&&this.__classPrivateFieldSet||function(Z,e,g,T,D){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!D:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?D.call(Z,g):D?D.value=g:e.set(Z,g),g},xe=this&&this.__classPrivateFieldGet||function(Z,e,g,T){if(g==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!T:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?T:g==="a"?T.call(Z):T?T.value:e.get(Z)};define(we[102],_e([0,1,2,11,3,4,6,30,36,32,18,37,14,28,5,15,21,17,70,160,12]),function(Z,e,g,T,D,E,C,y,_,k,n,I,o,h,d,u,w,v,S,c,m){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(fe){function X(Y){if(Y!=null)return Y}fe.from=X;function z(Y){if(Y!=null)return Y}fe.to=z})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var r;(function(fe){function X(Y){if(Y!=null)return Y}fe.from=X;function z(Y){if(Y!=null)return Y}fe.to=z})(r=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var i;(function(fe){function X(Y){if(Y!=null)return Y}fe.from=X;function z(Y){if(Y!=null)return Y}fe.to=z})(i=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var s;(function(fe){function X(R){if(R){const B=R;return B&&!!B.process}else return!1}fe.is=X;function z(R){if(R==null)return;const B={process:R.process,args:R.args};return R.options&&(B.options=i.from(R.options)),B}fe.from=z;function Y(R){if(R!=null)return new C.ProcessExecution(R.process,R.args,R.options)}fe.to=Y})(s=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var l;(function(fe){function X(Y){if(Y!=null)return Y}fe.from=X;function z(Y){if(Y!=null)return Y}fe.to=z})(l=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var b;(function(fe){function X(R){if(R){const B=R;return B&&(!!B.commandLine||!!B.command)}else return!1}fe.is=X;function z(R){if(R==null)return;const B={};return R.commandLine!==void 0?B.commandLine=R.commandLine:(B.command=R.command,B.args=R.args),R.options&&(B.options=l.from(R.options)),B}fe.from=z;function Y(R){if(!(R==null||R.command===void 0&&R.commandLine===void 0))return R.commandLine?new C.ShellExecution(R.commandLine,R.options):new C.ShellExecution(R.command,R.args?R.args:[],R.options)}fe.to=Y})(b=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var p;(function(fe){function X(R){if(R){let B=R;return B&&B.customExecution==="customExecution"}else return!1}fe.is=X;function z(R){return{customExecution:"customExecution"}}fe.from=z;function Y(R,B){return B.get(R)}fe.to=Y})(p=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var P;(function(fe){function X(z,Y){let R;return z.scope!==void 0&&typeof z.scope!="number"?R=z.scope.uri:z.scope!==void 0&&typeof z.scope=="number"&&(z.scope===C.TaskScope.Workspace&&Y&&Y.workspaceFile?R=Y.workspaceFile:R=c.USER_TASKS_GROUP_KEY),{id:z._id,workspaceFolder:R}}fe.from=X})(P=e.TaskHandleDTO||(e.TaskHandleDTO={}));var A;(function(fe){function X(R,B){if(R==null)return[];const M=[];for(let U of R){const q=z(U,B);q&&M.push(q)}return M}fe.fromMany=X;function z(R,B){if(R==null)return;let M;R.execution instanceof C.ProcessExecution?M=s.from(R.execution):R.execution instanceof C.ShellExecution?M=b.from(R.execution):R.execution&&R.execution instanceof C.CustomExecution&&(M=p.from(R.execution));const U=t.from(R.definition);let q;if(R.scope?typeof R.scope=="number"?q=R.scope:q=R.scope.uri:q=C.TaskScope.Workspace,!U||!q)return;const V=R.group?R.group.id:void 0;return{_id:R._id,definition:U,name:R.name,source:{extensionId:B.identifier.value,label:R.source,scope:q},execution:M,isBackground:R.isBackground,group:V,presentationOptions:r.from(R.presentationOptions),problemMatchers:R.problemMatchers,hasDefinedMatchers:R.hasDefinedMatchers,runOptions:R.runOptions?R.runOptions:{reevaluateOnRerun:!0},detail:R.detail}}fe.from=z;async function Y(R,B,M){if(R==null)return;let U;s.is(R.execution)?U=s.to(R.execution):b.is(R.execution)?U=b.to(R.execution):p.is(R.execution)&&(U=p.to(R._id,M));const q=t.to(R.definition);let V;if(R.source&&(R.source.scope!==void 0?typeof R.source.scope=="number"?V=R.source.scope:V=await B.resolveWorkspaceFolder(g.URI.revive(R.source.scope)):V=C.TaskScope.Workspace),!q||!V)return;const oe=new C.Task(q,V,R.name,R.source.label,U,R.problemMatchers);return R.isBackground!==void 0&&(oe.isBackground=R.isBackground),R.group!==void 0&&(oe.group=C.TaskGroup.from(R.group)),R.presentationOptions&&(oe.presentationOptions=r.to(R.presentationOptions)),R._id&&(oe._id=R._id),R.detail&&(oe.detail=R.detail),oe}fe.to=Y})(A=e.TaskDTO||(e.TaskDTO={}));var a;(function(fe){function X(Y){return Y}fe.from=X;function z(Y){if(!!Y)return Object.assign(Object.create(null),Y)}fe.to=z})(a=e.TaskFilterDTO||(e.TaskFilterDTO={}));class F{constructor(X,z,Y){this._id=z,this._task=Y,f.set(this,void 0),tt(this,f,X,"f")}get task(){return this._task}terminate(){xe(this,f,"f").terminateTask(this)}fireDidStartProcess(X){}fireDidEndProcess(X){}}f=new WeakMap;var N;(function(fe){function X(z){return{id:z._id,task:void 0}}fe.from=X})(N=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let H=class{constructor(X,z,Y,R,B,M,U,q){this._onDidExecuteTask=new D.Emitter,this._onDidTerminateTask=new D.Emitter,this._onDidTaskProcessStarted=new D.Emitter,this._onDidTaskProcessEnded=new D.Emitter,this._proxy=X.getProxy(E.MainContext.MainThreadTask),this._workspaceProvider=Y,this._editorService=R,this._configurationService=B,this._terminalService=M,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=U,this._deprecationService=q,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(X,z,Y){if(!Y)return new C.Disposable(()=>{});const R=this.nextHandle();return this._handlers.set(R,{type:z,provider:Y,extension:X}),this._proxy.$registerTaskProvider(R,z),new C.Disposable(()=>{this._handlers.delete(R),this._proxy.$unregisterTaskProvider(R)})}registerTaskSystem(X,z){this._proxy.$registerTaskSystem(X,z)}fetchTasks(X){return this._proxy.$fetchTasks(a.from(X)).then(async z=>{const Y=[];for(let R of z){const B=await A.to(R,this._workspaceProvider,this._providedCustomExecutions2);B&&Y.push(B)}return Y})}get taskExecutions(){const X=[];return this._taskExecutions.forEach(z=>X.push(z)),X}terminateTask(X){if(!(X instanceof F))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(X._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(X,z,Y){const R=this._providedCustomExecutions2.get(X.id);if(R){if(this._activeCustomExecutions2.get(X.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(X.id,R),this._terminalService.attachPtyToTerminal(z,await R.callback(Y))}this._lastStartedTask=X.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(X)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(X){const z=await this.getTaskExecution(X);this._taskExecutionPromises.delete(X.id),this._taskExecutions.delete(X.id),this.customExecutionComplete(X),this._onDidTerminateTask.fire({execution:z})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(X){const z=await this.getTaskExecution(X.id);this._onDidTaskProcessStarted.fire({execution:z,processId:X.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(X){const z=await this.getTaskExecution(X.id);this._onDidTaskProcessEnded.fire({execution:z,exitCode:X.exitCode})}$provideTasks(X,z){const Y=this._handlers.get(X);if(!Y)return Promise.reject(new Error("no handler found"));const R=[],B=T.asPromise(()=>Y.provider.provideTasks(n.CancellationToken.None)).then(M=>this.provideTasksInternal(z,R,Y,M));return new Promise(M=>{B.then(U=>{Promise.all(R).then(()=>{M(U)})})})}async $resolveTask(X,z){const Y=this._handlers.get(X);if(!Y)return Promise.reject(new Error("no handler found"));if(z.definition.type!==Y.type)throw new Error(`Unexpected: Task of type [${z.definition.type}] cannot be resolved by provider of type [${Y.type}].`);const R=await A.to(z,this._workspaceProvider,this._providedCustomExecutions2);if(!R)throw new Error("Unexpected: Task cannot be resolved.");const B=await Y.provider.resolveTask(R,n.CancellationToken.None);if(!B)return;this.checkDeprecation(B,Y);const M=A.from(B,Y.extension);if(!M)throw new Error("Unexpected: Task cannot be resolved.");if(B.definition!==R.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return p.is(M.execution)&&await this.addCustomExecution(M,B,!0),await this.resolveTaskInternal(M)}nextHandle(){return this._handleCounter++}async addCustomExecution(X,z,Y){const R=await this._proxy.$createTaskId(X);!Y&&!this._providedCustomExecutions2.has(R)&&this._notProvidedCustomExecutions.add(R),this._providedCustomExecutions2.set(R,z.execution)}async getTaskExecution(X,z){if(typeof X=="string"){const B=this._taskExecutionPromises.get(X);if(!B)throw new Error("Unexpected: The specified task is missing an execution");return B}let Y=this._taskExecutionPromises.get(X.id);if(Y)return Y;const R=new Promise(async(B,M)=>{const U=z||await A.to(X.task,this._workspaceProvider,this._providedCustomExecutions2);U?B(new F(this,X.id,U)):M("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(X.id,R),R.then(B=>(this._taskExecutions.set(X.id,B),B),B=>Promise.reject(B))}checkDeprecation(X,z){X._deprecated&&this._deprecationService.report("Task.constructor",z.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(X){this._activeCustomExecutions2.get(X.id)&&this._activeCustomExecutions2.delete(X.id),this._notProvidedCustomExecutions.has(X.id)&&this._lastStartedTask!==X.id&&(this._providedCustomExecutions2.delete(X.id),this._notProvidedCustomExecutions.delete(X.id));let Y=this._notProvidedCustomExecutions.values(),R=Y.next();for(;!R.done;)!this._activeCustomExecutions2.has(R.value)&&this._lastStartedTask!==R.value&&(this._providedCustomExecutions2.delete(R.value),this._notProvidedCustomExecutions.delete(R.value)),R=Y.next()}};H=He([ze(0,o.IExtHostRpcService),ze(1,h.IExtHostInitDataService),ze(2,y.IExtHostWorkspace),ze(3,_.IExtHostDocumentsAndEditors),ze(4,k.IExtHostConfiguration),ze(5,I.IExtHostTerminalService),ze(6,v.ILogService),ze(7,S.IExtHostApiDeprecationService)],H),e.ExtHostTaskBase=H;let le=class extends H{constructor(X,z,Y,R,B,M,U,q){super(X,z,Y,R,B,M,U,q);this.registerTaskSystem(u.Schemas.vscodeRemote,{scheme:u.Schemas.vscodeRemote,authority:"",platform:w.PlatformToString(0)})}async executeTask(X,z){if(!z.execution)throw new Error("Tasks to execute must include an execution");const Y=A.from(z,X);if(Y===void 0)throw new Error("Task is not valid");if(p.is(Y.execution))await this.addCustomExecution(Y,z,!1);else throw new m.NotSupportedError;const R=await this.getTaskExecution(await this._proxy.$getTaskExecution(Y),z);return this._proxy.$executeTask(Y).catch(B=>{throw new Error(B)}),R}provideTasksInternal(X,z,Y,R){const B=[];if(R)for(let M of R){this.checkDeprecation(M,Y),(!M.definition||!X[M.definition.type])&&this._logService.warn(`The task [${M.source}, ${M.name}] uses an undefined task type. The task will be ignored in the future.`);const U=A.from(M,Y.extension);U&&p.is(U.execution)?(B.push(U),z.push(this.addCustomExecution(U,M,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:B,extension:Y.extension}}async resolveTaskInternal(X){if(p.is(X.execution))return X;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(X,z){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(X,z,Y){}};le=He([ze(0,o.IExtHostRpcService),ze(1,h.IExtHostInitDataService),ze(2,y.IExtHostWorkspace),ze(3,_.IExtHostDocumentsAndEditors),ze(4,k.IExtHostConfiguration),ze(5,I.IExtHostTerminalService),ze(6,v.ILogService),ze(7,S.IExtHostApiDeprecationService)],le),e.WorkerExtHostTask=le,e.IExtHostTask=d.createDecorator("IExtHostTask")});var tt=this&&this.__classPrivateFieldSet||function(Z,e,g,T,D){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!D:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?D.call(Z,g):D?D.value=g:e.set(Z,g),g},xe=this&&this.__classPrivateFieldGet||function(Z,e,g,T){if(g==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!T:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?T:g==="a"?T.call(Z):T?T.value:e.get(Z)},bn=this&&this.__rest||function(Z,e){var g={};for(var T in Z)Object.prototype.hasOwnProperty.call(Z,T)&&e.indexOf(T)<0&&(g[T]=Z[T]);if(Z!=null&&typeof Object.getOwnPropertySymbols=="function")for(var D=0,T=Object.getOwnPropertySymbols(Z);D<T.length;D++)e.indexOf(T[D])<0&&Object.prototype.propertyIsEnumerable.call(Z,T[D])&&(g[T[D]]=Z[T[D]]);return g};define(we[207],_e([0,1,16,11,23,18,3,48,50,7,24,10,2,34,4,36,14,65,9,6,30,170,94]),function(Z,e,g,T,D,E,C,y,_,k,n,I,o,h,d,u,w,v,S,c,m,f,t){"use strict";var r,i,s,l;Object.defineProperty(e,"__esModule",{value:!0}),e.MirroredTestCollection=e.TestItemFilteredWrapper=e.createDefaultDocumentTestRoot=e.ExtHostTesting=void 0;const b=(Y,R)=>`${Y}:${R.toString()}`;let p=class{constructor(R,B,M){this.documents=B,this.workspace=M,this.resultsChangedEmitter=new C.Emitter,this.controllers=new Map,this.ownedTests=new f.OwnedTestCollection,this.testControllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=R.getProxy(d.MainContext.MainThreadTesting),this.runQueue=new P(this.proxy),this.workspaceObservers=new X(this.proxy),this.textDocumentObservers=new z(this.proxy,B)}registerTestController(R,B){const M=h.generateUuid();this.controllers.set(M,{instance:B,extensionId:R}),this.proxy.$registerTestController(M);const U=[...this.testControllers.keys()];return setTimeout(()=>{var q;for(const V of U)(q=this.testControllers.get(V))===null||q===void 0||q.subscribeFn(M,B)},0),new c.Disposable(()=>{this.controllers.delete(M),this.proxy.$unregisterTestController(M)})}createTextDocumentTestObserver(R){return this.textDocumentObservers.checkout(R.uri)}createWorkspaceTestObserver(R){return this.workspaceObservers.checkout(R.uri)}async runTests(R,B=E.CancellationToken.None){const M=U=>U.map(this.getInternalTestForReference,this).filter(I.isDefined).map(q=>({src:q.src,testId:q.item.extId}));await this.proxy.$runTests({exclude:R.exclude?M(R.exclude).map(U=>U.testId):void 0,tests:M(R.tests),debug:R.debug},B)}createTestRun(R,B,M,U=!0){return this.runQueue.createTestRun(R,B,M,U)}$publishTestResults(R){this.results=Object.freeze(R.map(B=>n.deepFreeze(S.TestResults.to(B))).concat(this.results).sort((B,M)=>M.completedAt-B.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $subscribeToTests(R,B){const M=o.URI.revive(B),U=b(R,M);if(this.testControllers.has(U))return;const q=new E.CancellationTokenSource;let V;if(R===1){let Me=this.documents.getDocument(M);if(!Me){const We=new k.DisposableStore;Me=await new Promise(Je=>{We.add(T.disposableTimeout(()=>Je(void 0),5e3)),We.add(this.documents.onDidAddDocuments(Qe=>{const Ye=Qe.find(W=>W.document.uri.toString()===M.toString());Ye&&Je(Ye)}))}).finally(()=>We.dispose())}if(Me){const We=await this.workspace.getWorkspaceFolder2(M,!1);V=Je=>Je.createDocumentTestRoot?Je.createDocumentTestRoot(Me.document,q.token):e.createDefaultDocumentTestRoot(Je,Me.document,We,q.token)}}else{const Me=await this.workspace.getWorkspaceFolder2(M,!1);Me&&(V=We=>We.createWorkspaceTestRoot(Me,q.token))}if(!V)return;const oe=async(Me,We)=>{try{const Je=await V(We);Je&&Re.addRoot(Je,Me)}catch(Je){console.error(Je)}},ge=new k.DisposableStore,Re=ge.add(this.ownedTests.createForHierarchy(Me=>this.proxy.$publishDiff(R,B,Me)));ge.add(k.toDisposable(()=>q.dispose(!0)));const $e=[];for(const[Me,We]of this.controllers)$e.push(oe(Me,We.instance));Promise.all($e).then(()=>Re.pushDiff([3,-1])),this.testControllers.set(U,{store:ge,collection:Re,subscribeFn:oe})}async $expandTest(R,B){const M=g.mapFind(this.testControllers.values(),U=>U.collection.treeId===R.src.tree?U:void 0);await(M==null?void 0:M.collection.expand(R.testId,B<0?Infinity:B)),this.flushCollectionDiffs()}$unsubscribeFromTests(R,B){var M;const U=o.URI.revive(B),q=b(R,U);(M=this.testControllers.get(q))===null||M===void 0||M.store.dispose(),this.testControllers.delete(q)}$acceptDiff(R,B,M){R===1?this.textDocumentObservers.acceptDiff(o.URI.revive(B),M):this.workspaceObservers.acceptDiff(o.URI.revive(B),M)}async $runTestsForProvider(R,B){const M=this.controllers.get(R.tests[0].src.controller);if(!M)return;const U=R.tests.map(({testId:oe,src:ge})=>this.ownedTests.getTestById(oe,ge==null?void 0:ge.tree)).filter(I.isDefined).map(([oe,ge])=>ge),q=R.excludeExtIds.map(oe=>this.ownedTests.getTestById(oe)).filter(I.isDefined).filter(([oe,ge])=>U.some(Re=>oe.comparePositions(Re,ge)===1));if(!U.length)return;const V={tests:U.map(oe=>N.unwrap(oe.actual)),exclude:q.map(([,oe])=>N.unwrap(oe.actual)),debug:R.debug};await this.runQueue.enqueueRun({dto:A.fromInternal(R),token:B,extensionId:M.extensionId,req:V,doRun:()=>M.instance.runTests(V,B)})}$lookupTest(R){const B=this.ownedTests.getTestById(R.testId);if(!B)return Promise.resolve(void 0);const M=B[1],{actual:U,discoverCts:q,expandLevels:V}=M,oe=bn(M,["actual","discoverCts","expandLevels"]);return Promise.resolve(oe)}flushCollectionDiffs(){for(const{collection:R}of this.testControllers.values())R.flushDiff()}getInternalTestForReference(R){var B,M;return(M=(B=this.workspaceObservers.getMirroredTestDataByReference(R))!==null&&B!==void 0?B:g.mapFind(this.testControllers.values(),U=>U.collection.getTestByReference(R)))!==null&&M!==void 0?M:this.textDocumentObservers.getMirroredTestDataByReference(R)}};p=He([ze(0,w.IExtHostRpcService),ze(1,u.IExtHostDocumentsAndEditors),ze(2,m.IExtHostWorkspace)],p),e.ExtHostTesting=p;class P{constructor(R){this.proxy=R,this.state=new Map}enqueueRun(R){let B=this.state.get(R.extensionId);B||(B={queue:[],current:void 0},this.state.set(R.extensionId,B));const M=new T.DeferredPromise,U=()=>{const q=[],V=new Set;B.current={publicReq:R.req,factory:oe=>{const ge=new a(oe,R.dto,V,this.proxy);return q.push(ge),R.token.onCancellationRequested(()=>ge.end()),ge}},this.invokeRunner(R.extensionId,R.dto.id,R.doRun,q).finally(()=>M.complete())};return B.queue.push(U),B.queue.length===1&&U(),M.p}createTestRun(R,B,M,U){var q,V;const oe=this.state.get(R);if((oe==null?void 0:oe.current.publicReq)===B)return oe.current.factory(M);const ge=A.fromPublic(B),Re=new a(M,ge,new Set,this.proxy);return this.proxy.$startedExtensionTestRun({debug:B.debug,exclude:(V=(q=B.exclude)===null||q===void 0?void 0:q.map($e=>$e.id))!==null&&V!==void 0?V:[],id:ge.id,tests:B.tests.map($e=>$e.id),persist:U}),Re.onEnd.wait().then(()=>this.proxy.$finishedExtensionTestRun(ge.id)),Re}invokeRunner(R,B,M,U){try{const q=M();return T.isThenable(q)?q.then(()=>this.handleInvokeResult(R,B,U,void 0)).catch(V=>this.handleInvokeResult(R,B,U,V)):this.handleInvokeResult(R,B,U,void 0)}catch(q){return this.handleInvokeResult(R,B,U,q)}}async handleInvokeResult(R,B,M,U){const q=this.state.get(R);!q||(q.queue.shift(),q.queue.length>0?q.queue[0]():this.state.delete(R),await Promise.all(M.map(V=>V.onEnd.wait())))}}class A{constructor(R,B,M){this.id=R,this.include=B,this.exclude=M}static fromPublic(R){var B,M;return new A(h.generateUuid(),new Set(R.tests.map(U=>U.id)),new Set((M=(B=R.exclude)===null||B===void 0?void 0:B.map(U=>U.id))!==null&&M!==void 0?M:_.Iterable.empty()))}static fromInternal(R){return new A(R.runId,new Set(R.tests.map(B=>B.testId)),new Set(R.excludeExtIds))}isIncluded(R){for(let B=R;B;B=B.parent){if(this.include.has(B.id))return!0;if(this.exclude.has(B.id))return!1}return!0}}class a{constructor(R,B,M,U){this.name=R,r.set(this,void 0),i.set(this,void 0),s.set(this,h.generateUuid()),l.set(this,void 0),this.onEnd=new T.Barrier,tt(this,r,U,"f"),tt(this,i,B,"f"),tt(this,l,M,"f"),U.$startedTestRunTask(B.id,{id:xe(this,s,"f"),name:R,running:!0})}setState(R,B,M){xe(this,i,"f").isIncluded(R)&&(this.ensureTestIsKnown(R),xe(this,r,"f").$updateTestStateInRun(xe(this,i,"f").id,xe(this,s,"f"),R.id,B,M))}appendMessage(R,B){xe(this,i,"f").isIncluded(R)&&(this.ensureTestIsKnown(R),xe(this,r,"f").$appendTestMessageInRun(xe(this,i,"f").id,xe(this,s,"f"),R.id,S.TestMessage.from(B)))}appendOutput(R){xe(this,r,"f").$appendOutputToRun(xe(this,i,"f").id,xe(this,s,"f"),D.VSBuffer.fromString(R))}end(){xe(this,r,"f").$finishedTestRunTask(xe(this,i,"f").id,xe(this,s,"f")),this.onEnd.open()}ensureTestIsKnown(R){const B=xe(this,l,"f");if(B.has(R.id))return;const M=[];for(;M.unshift(S.TestItem.from(R)),!(B.has(R.id)||(B.add(R.id),!R.parent));)R=R.parent;xe(this,r,"f").$addTestsToRun(xe(this,i,"f").id,M)}}r=new WeakMap,i=new WeakMap,s=new WeakMap,l=new WeakMap;const F=async(Y,R,B,M)=>{if(!B)return;const U=await Y.createWorkspaceTestRoot(B,M);if(!U)return;M.onCancellationRequested(()=>{N.removeFilter(R)});const q=N.getWrapperForTestItem(U,R);return q.refreshMatch(),q};e.createDefaultDocumentTestRoot=F;class N extends c.TestItemImpl{constructor(R,B,M){super(R.id,R.label,R.uri,void 0);if(this.actual=R,this.filterDocument=B,this.actualParent=M,!(R instanceof c.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${R.id} did not`);this.debuggable=R.debuggable,this.runnable=R.runnable,this.description=R.description,this.error=R.error,this.status=R.status,this.range=R.range,this.resolveHandler=R.resolveHandler;const U=v.getPrivateApiFor(this);v.getPrivateApiFor(R).bus.event(V=>{switch(V[0]){case 3:this[V[1]]=V[2];break;case 0:const oe=N.getWrapperForTestItem(V[1],this.filterDocument,this);v.getPrivateApiFor(oe).parent=R,oe.refreshMatch();break;default:U.bus.fire(V)}})}static removeFilter(R){this.wrapperMap.delete(R)}static getWrapperForTestItem(R,B,M){let U=this.wrapperMap.get(B);if(U==null?void 0:U.has(R))return U.get(R);U||(U=new WeakMap,this.wrapperMap.set(B,U));const q=new N(R,B,M);return U.set(R,q),q}static unwrap(R){return R instanceof N?R.actual:R}get hasNodeMatchingFilter(){return this._cachedMatchesFilter===void 0?this.refreshMatch():this._cachedMatchesFilter}refreshMatch(){var R,B;const M=this._cachedMatchesFilter;for(const q of this.actual.children.values()){const V=N.getWrapperForTestItem(q,this.filterDocument,this);V.hasNodeMatchingFilter?this.children.has(V.id)||this.addChild(V):V.dispose()}const U=this.children.size>0||((R=this.actual.uri)===null||R===void 0?void 0:R.toString())===this.filterDocument.uri.toString();return this._cachedMatchesFilter=U,U!==M&&((B=this.actualParent)===null||B===void 0||B.refreshMatch()),this._cachedMatchesFilter}dispose(){this.actualParent&&v.getPrivateApiFor(this.actualParent).children.delete(this.id),v.getPrivateApiFor(this).bus.fire([1])}}e.TestItemFilteredWrapper=N,N.wrapperMap=new WeakMap;class H extends t.IncrementalChangeCollector{constructor(R){super();this.emitter=R,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(R){this.added.add(R)}update(R){Object.assign(R.revived,S.TestItem.toPlain(R.item)),this.added.has(R)||this.updated.add(R)}remove(R){if(this.added.has(R)){this.added.delete(R);return}if(this.updated.delete(R),R.parent&&this.alreadyRemoved.has(R.parent)){this.alreadyRemoved.add(R.item.extId);return}this.removed.add(R)}getChangeEvent(){const{added:R,updated:B,removed:M}=this;return{get added(){return[...R].map(U=>U.revived)},get updated(){return[...B].map(U=>U.revived)},get removed(){return[...M].map(U=>U.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class le extends t.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new C.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTestItems(){return this.getAllAsTestItem([...this.roots])}getAllAsTestItem(R){let B=[];for(const M of R){const U=this.items.get(M);U&&B.push(U.revived)}return B}getMirroredTestDataById(R){return this.items.get(R)}getMirroredTestDataByReference(R){return this.items.get(R.id)}createItem(R,B){return Object.assign(Object.assign({},R),{revived:S.TestItem.toPlain(R.item),depth:B?B.depth+1:0,children:new Set})}createChangeCollector(){return new H(this.changeEmitter)}}e.MirroredTestCollection=le;class fe{constructor(){this.resources=new Map}checkout(R){var B,M;const U=R.toString(),q=(B=this.resources.get(U))!==null&&B!==void 0?B:this.createObserverData(R);return(M=q.pendingDeletion)===null||M===void 0||M.dispose(),q.observers++,{onDidChangeTest:q.tests.onDidChangeTests,onDidDiscoverInitialTests:new C.Emitter().event,get tests(){return q.tests.rootTestItems},dispose:y.once(()=>{--q.observers||(q.pendingDeletion=this.eventuallyDispose(R))})}}getMirroredTestDataByReference(R){for(const{tests:B}of this.resources.values()){const M=B.getMirroredTestDataByReference(R);if(M)return M}}eventuallyDispose(R){return T.disposableTimeout(()=>this.unlisten(R),10*1e3)}createObserverData(R){const B=new le,M=this.listen(R,q=>B.apply(q)),U={observers:0,tests:B,listener:M};return this.resources.set(R.toString(),U),U}unlisten(R){var B;const M=R.toString(),U=this.resources.get(M);U&&(U.observers=-1,(B=U.pendingDeletion)===null||B===void 0||B.dispose(),U.listener.dispose(),this.resources.delete(M))}}class X extends fe{constructor(R){super();this.proxy=R,this.diffListeners=new Map}acceptDiff(R,B){var M;(M=this.diffListeners.get(R.toString()))===null||M===void 0||M(B)}listen(R,B){this.proxy.$subscribeToDiffs(0,R);const M=R.toString();return this.diffListeners.set(M,B),new c.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(0,R),this.diffListeners.delete(M)})}}class z extends fe{constructor(R,B){super();this.proxy=R,this.documents=B,this.diffListeners=new Map}acceptDiff(R,B){var M;(M=this.diffListeners.get(R.toString()))===null||M===void 0||M(B)}listen(R,B){if(!this.documents.getDocument(R))return new c.Disposable(()=>{});const U=R.toString();return this.diffListeners.set(U,B),this.proxy.$subscribeToDiffs(1,R),new c.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(1,R),this.diffListeners.delete(U)})}}}),define(we[208],_e([0,1,16,76,27,81,22,15,13,25,8,10,2,115,135,90,62,163,206,38]),function(Z,e,g,T,D,E,C,y,_,k,n,I,o,h,d,u,w,v,S,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let m=class{constructor(P,A,a,F){this.configurationService=P,this.workspaceContextService=A,this.editorGroupsService=a,this.pathService=F}text(P,A,a={}){P=this.getContentPattern(P,a);const F=this.configurationService.getValue(),N=A&&A.some(le=>!this.configurationService.getValue({resource:le}).search.useRipgrep),H=this.commonQuery(A==null?void 0:A.map(w.toWorkspaceFolder),a);return Object.assign(Object.assign({},H),{type:2,contentPattern:P,previewOptions:a.previewOptions,maxFileSize:a.maxFileSize,usePCRE2:F.search.usePCRE2||N||!1,beforeContext:a.beforeContext,afterContext:a.afterContext,userDisabledExcludesAndIgnoreFiles:a.disregardExcludeSettings&&a.disregardIgnoreFiles})}getContentPattern(P,A){const a=this.configurationService.getValue();P.isRegExp&&(P.pattern=P.pattern.replace(/\r?\n/g,"\\n"));const F=Object.assign(Object.assign({},P),{wordSeparators:a.editor.wordSeparators});return this.isCaseSensitive(P,A)&&(F.isCaseSensitive=!0),this.isMultiline(P)&&(F.isMultiline=!0),F}file(P,A={}){const a=this.commonQuery(P,A);return Object.assign(Object.assign({},a),{type:1,filePattern:A.filePattern?A.filePattern.trim():A.filePattern,exists:A.exists,sortByScore:A.sortByScore,cacheKey:A.cacheKey})}handleIncludeExclude(P,A){return P?(P=Array.isArray(P)?P.map(s):s(P),A?this.parseSearchPaths(P):{pattern:t(...Array.isArray(P)?P:[P])}):{}}commonQuery(P=[],A={}){const a=this.handleIncludeExclude(A.includePattern,A.expandPatterns),F=this.handleIncludeExclude(A.excludePattern,A.expandPatterns),N=P.length>1,H=(a.searchPaths&&a.searchPaths.length?a.searchPaths.map(X=>this.getFolderQueryForSearchPath(X,A,F)):P.map(X=>this.getFolderQueryForRoot(X,A,F,N))).filter(X=>!!X),le={_reason:A._reason,folderQueries:H,usingSearchPaths:!!(a.searchPaths&&a.searchPaths.length),extraFileResources:A.extraFileResources,excludePattern:F.pattern,includePattern:a.pattern,onlyOpenEditors:A.onlyOpenEditors,maxResults:A.maxResults};if(A.onlyOpenEditors){const z=g.coalesce(g.flatten(this.editorGroupsService.groups.map(R=>R.editors.map(B=>B.resource)))).filter(R=>c.pathIncludedInQuery(le,R.fsPath)),Y=this.commonQueryFromFileList(z);return Object.assign(Object.assign({},le),Y)}const fe=A.extraFileResources&&A.extraFileResources.filter(X=>c.pathIncludedInQuery(le,X.fsPath));return le.extraFileResources=fe&&fe.length?fe:void 0,le}commonQueryFromFileList(P){const A=[],a=new C.ResourceMap,F={};let N=!1;return P.forEach(H=>{var le,fe;if(H.scheme===y.Schemas.walkThrough)return;if(k.isAbsolutePath(H)){const z=(fe=(le=this.workspaceContextService.getWorkspaceFolder(H))===null||le===void 0?void 0:le.uri)!==null&&fe!==void 0?fe:H.with({path:_.dirname(H.fsPath)});let Y=a.get(z);Y||(N=!0,Y={folder:z,includePattern:{}},A.push(Y),a.set(z,Y));const R=_.relative(z.fsPath,H.fsPath);I.assertIsDefined(Y.includePattern)[R.replace(/\\/g,"/")]=!0}else H.fsPath&&(N=!0,F[H.fsPath]=!0)}),{folderQueries:A,includePattern:F,usingSearchPaths:!0,excludePattern:N?void 0:{"**/*":!0}}}isCaseSensitive(P,A){if(A.isSmartCase){if(P.isRegExp){if(n.containsUppercaseCharacter(P.pattern,!0))return!0}else if(n.containsUppercaseCharacter(P.pattern))return!0}return!!P.isCaseSensitive}isMultiline(P){return P.isMultiline||P.isRegExp&&h.isMultilineRegexSource(P.pattern)||P.pattern.indexOf(`
`)>=0?!0:!!P.isMultiline}parseSearchPaths(P){const A=Y=>_.isAbsolute(Y)||/^\.\.?([\/\\]|$)/.test(Y),F=(Array.isArray(P)?P:r(P)).map(Y=>{const R=this.pathService.resolvedUserHome;return R?E.untildify(Y,R.scheme===y.Schemas.file?R.fsPath:R.path):Y}),N=T.groupBy(F,Y=>A(Y)?"searchPaths":"exprSegments"),H=(N.exprSegments||[]).map(Y=>n.rtrim(Y,"/")).map(Y=>n.rtrim(Y,"\\")).map(Y=>(Y[0]==="."&&(Y="*"+Y),i(Y))),le={},fe=this.expandSearchPathPatterns(N.searchPaths||[]);fe&&fe.length&&(le.searchPaths=fe);const X=g.flatten(H),z=t(...X);return z&&(le.pattern=z),le}getExcludesForFolder(P,A){return A.disregardExcludeSettings?void 0:c.getExcludes(P,!A.disregardSearchExcludeSettings)}expandSearchPathPatterns(P){if(!P||!P.length)return[];const A=g.flatten(P.map(F=>{let{pathPortion:N,globPortion:H}=f(F);H&&(H=l(H));const le=this.expandOneSearchPath(N);return g.flatten(le.map(fe=>this.resolveOneSearchPathPattern(fe,H)))})),a=new Map;return A.forEach(F=>{const N=F.searchPath.toString(),H=a.get(N);H?F.pattern&&(H.pattern=H.pattern||{},H.pattern[F.pattern]=!0):a.set(N,{searchPath:F.searchPath,pattern:F.pattern?t(F.pattern):void 0})}),Array.from(a.values())}expandOneSearchPath(P){if(_.isAbsolute(P)){const A=this.workspaceContextService.getWorkspace().folders;return A[0]&&A[0].uri.scheme!==y.Schemas.file?[{searchPath:A[0].uri.with({path:P})}]:[{searchPath:o.URI.file(_.normalize(P))}]}if(this.workspaceContextService.getWorkbenchState()===2){const A=this.workspaceContextService.getWorkspace().folders[0].uri;if(P=s(P),P.startsWith("../")||P===".."){const F=_.posix.resolve(A.path,P);return[{searchPath:A.with({path:F})}]}const a=l(P);return[{searchPath:A,pattern:a}]}else{if(P==="./"||P===".\\")return[];{const A=P.replace(/^\.[\/\\]/,""),F=this.workspaceContextService.getWorkspace().folders.map(N=>{const H=A.match(new RegExp(`^${N.name}(?:/(.*))?`));return H?{match:H,folder:N}:null}).filter(I.isDefined);if(F.length)return F.map(N=>{const H=N.match[1];return{searchPath:N.folder.uri,pattern:H&&l(H)}});{const N=P.match(/\.[\/\\](.+)[\/\\]?/),H=N?N[1]:P,le=d.localize(0,null,H);throw new Error(le)}}}}resolveOneSearchPathPattern(P,A){const a=P.pattern&&A?`${P.pattern}/${A}`:P.pattern||A,F=[{searchPath:P.searchPath,pattern:a}];return a&&!a.endsWith("**")&&F.push({searchPath:P.searchPath,pattern:a+"/**"}),F}getFolderQueryForSearchPath(P,A,a){const F=this.getFolderQueryForRoot(w.toWorkspaceFolder(P.searchPath),A,a,!1);return F?Object.assign(Object.assign({},F),{includePattern:P.pattern}):null}getFolderQueryForRoot(P,A,a,F){let N;const H=o.URI.isUri(P)?P:P.uri;if(a.searchPaths){const Y=a.searchPaths.filter(R=>k.isEqual(R.searchPath,H))[0];if(Y&&!Y.pattern)return null;Y&&(N=Y.pattern)}const le=this.configurationService.getValue({resource:H}),fe=this.getExcludesForFolder(le,A),X=Object.assign(Object.assign({},fe||{}),N||{}),z=o.URI.isUri(P)?k.basename(P):P.name;return{folder:H,folderName:F?z:void 0,excludePattern:Object.keys(X).length>0?X:void 0,fileEncoding:le.files&&le.files.encoding,disregardIgnoreFiles:typeof A.disregardIgnoreFiles=="boolean"?A.disregardIgnoreFiles:!le.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof A.disregardGlobalIgnoreFiles=="boolean"?A.disregardGlobalIgnoreFiles:!le.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof A.ignoreSymlinks=="boolean"?A.ignoreSymlinks:!le.search.followSymlinks}}};m=He([ze(0,u.IConfigurationService),ze(1,w.IWorkspaceContextService),ze(2,v.IEditorGroupsService),ze(3,S.IPathService)],m),e.QueryBuilder=m;function f(p){const P=p.match(/[\*\{\}\(\)\[\]\?]/);if(P){const A=P.index,a=p.substr(0,A).match(/[/|\\][^/\\]*$/);if(a){let F=p.substr(0,a.index);return F.match(/[/\\]/)||(F+="/"),{pathPortion:F,globPortion:p.substr((a.index||0)+1)}}}return{pathPortion:p}}function t(...p){return p.length?p.reduce((P,A)=>(P[A]=!0,P),Object.create(null)):void 0}function r(p){return D.splitGlobAware(p,",").map(P=>P.trim()).filter(P=>!!P.length)}function i(p){return[`**/${p}/**`,`**/${p}`].map(A=>A.replace(/\*\*\/\*\*/g,"**"))}function s(p){return p.replace(/\\/g,"/")}function l(p){return s(p).replace(/^\.\//,"").replace(/\/+$/g,"")}function b(p,P){p=g.distinct(p,F=>F.toString());const A=[],a=P.getWorkspace();return p&&p.forEach(F=>{let N;if(P.getWorkbenchState()===2)N=k.relativePath(a.folders[0].uri,F),N&&N!=="."&&(N="./"+N);else{const H=P.getWorkspaceFolder(F);if(H){const le=H.name;if(a.folders.filter(X=>X.name===le).length===1){const X=k.relativePath(H.uri,F);X===""?N=`./${H.name}`:N=`./${H.name}/${X}`}else N=F.fsPath}}N&&A.push(N)}),A}e.resolveResourcesForSearchIncludes=b}),define(we[209],_e([0,1,25,2,18,12,5,208,38,62]),function(Z,e,g,T,D,E,C,y,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const n=7e3;function I(u,w){const v=w.activationEvents;if(!v)return Promise.resolve(void 0);const S=[],c=[];for(const s of v)if(/^workspaceContains:/.test(s)){const l=s.substr("workspaceContains:".length);l.indexOf("*")>=0||l.indexOf("?")>=0||u.forceUsingSearch?c.push(l):S.push(l)}if(S.length===0&&c.length===0)return Promise.resolve(void 0);let m;const f=new Promise((s,l)=>{m=s}),t=s=>m({activationEvent:s}),r=Promise.all(S.map(s=>o(u,s,t))).then(()=>{}),i=h(u,w.identifier,c,t);return Promise.all([r,i]).then(()=>{m(void 0)}),f}e.checkActivateWorkspaceContainsExtension=I;async function o(u,w,v){for(const S of u.folders)if(await u.exists(g.joinPath(T.URI.revive(S),w))){v(`workspaceContains:${w}`);return}}async function h(u,w,v,S){if(v.length===0)return Promise.resolve(void 0);const c=new D.CancellationTokenSource,m=u.checkExists(u.folders,v,c.token),f=setTimeout(async()=>{c.cancel(),S(`workspaceContainsTimeout:${v.join(",")}`)},n);let t=!1;try{t=await m}catch(r){E.isPromiseCanceledError(r)||E.onUnexpectedError(r)}c.dispose(),clearTimeout(f),t&&S(`workspaceContains:${v.join(",")}`)}function d(u,w,v,S){const c=u.get(C.IInstantiationService),m=u.get(_.ISearchService),t=c.createInstance(y.QueryBuilder).file(w.map(r=>k.toWorkspaceFolder(T.URI.revive(r))),{_reason:"checkExists",includePattern:v,exists:!0});return m.fileSearch(t,S).then(r=>!!r.limitHit,r=>E.isPromiseCanceledError(r)?!1:Promise.reject(r))}e.checkGlobFileExists=d});var tt=this&&this.__classPrivateFieldSet||function(Z,e,g,T,D){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!D:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?D.call(Z,g):D?D.value=g:e.set(Z,g),g},xe=this&&this.__classPrivateFieldGet||function(Z,e,g,T){if(g==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!T:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?T:g==="a"?T.call(Z):T?T.value:e.get(Z)};define(we[33],_e([0,1,128,13,75,25,11,7,22,2,17,4,32,173,73,30,29,171,12,26,23,152,6,91,5,28,74,14,60,66,37,3,209,69,153]),function(Z,e,g,T,D,E,C,y,_,k,n,I,o,h,d,u,w,v,S,c,m,f,t,r,i,s,l,b,p,P,A,a,F,N,H){"use strict";var le,fe,X;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=i.createDecorator("IHostUtils");let z=class Nn extends y.Disposable{constructor(M,U,q,V,oe,ge,Re,$e,Me,We){super();this._onDidChangeRemoteConnectionData=this._register(new a.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=U,this._extHostContext=q,this._initData=Re,this._extHostWorkspace=V,this._extHostConfiguration=oe,this._logService=ge,this._extHostTunnelService=Me,this._extHostTerminalService=We,this._disposables=new y.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(I.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(I.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(I.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new C.Barrier,this._readyToStartExtensionHost=new C.Barrier,this._readyToRunExtensions=new C.Barrier,this._eagerExtensionsActivated=new C.Barrier,this._registry=new v.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new d.ExtHostStorage(this._extHostContext),this._secretState=new N.ExtHostSecretState(this._extHostContext),this._storagePath=$e,this._instaService=M.createChild(new p.ServiceCollection([d.IExtHostStorage,this._storage],[N.IExtHostSecretState,this._secretState]));const Je=new Set;this._initData.hostExtensions.forEach(Qe=>Je.add(c.ExtensionIdentifier.toKey(Qe))),this._activator=new h.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(Qe,Ye,W)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(Qe,S.transformErrorForSerialization(Ye),W)},actualActivateExtension:async(Qe,Ye)=>{if(Je.has(c.ExtensionIdentifier.toKey(Qe)))return await this._mainThreadExtensionsProxy.$activateExtension(Qe,Ye),new h.HostExtension;const W=this._registry.getExtensionDescription(Qe);return this._activateExtension(W,Ye)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),D.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(M){S.onUnexpectedError(M)}}async deactivateAll(){let M=[];try{M=this._registry.getAllExtensionDescriptions().map(oe=>oe.identifier).filter(oe=>this.isActivated(oe)).map(oe=>this._deactivate(oe))}catch(U){}await Promise.all(M)}isActivated(M){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(M):!1}_activateByEvent(M,U){return this._activator.activateByEvent(M,U)}_activateById(M,U){return this._activator.activateById(M,U)}activateByIdWithErrors(M,U){return this._activateById(M,U).then(()=>{const q=this._activator.getActivatedExtension(M);if(q.activationFailed)return Promise.reject(q.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(M=>this._registry)}getExtensionExports(M){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(M).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const M=_.TernarySearchTree.forPaths(),U=this._registry.getAllExtensionDescriptions().map(q=>{if(!!this._getEntryPoint(q))return this._hostUtils.realpath(q.extensionLocation.fsPath).then(V=>M.set(k.URI.file(V).fsPath,q))});this._extensionPathIndex=Promise.all(U).then(()=>M)}return this._extensionPathIndex}_deactivate(M){let U=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(M))return U;const q=this._activator.getActivatedExtension(M);if(!q)return U;try{typeof q.module.deactivate=="function"&&(U=Promise.resolve(q.module.deactivate()).then(void 0,V=>(this._logService.error(V),Promise.resolve(void 0))))}catch(V){this._logService.error(V)}try{y.dispose(q.subscriptions)}catch(V){this._logService.error(V)}return U}async _activateExtension(M,U){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(M.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(M.identifier),this._doActivateExtension(M,U).then(q=>{const V=q.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(M.identifier,V.codeLoadingTime,V.activateCallTime,V.activateResolvedTime,U),this._logExtensionActivationTimes(M,U,"success",V),q},q=>{throw this._logExtensionActivationTimes(M,U,"failure"),q})}_logExtensionActivationTimes(M,U,q,V){const oe=Y(M,U);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",Object.assign(Object.assign(Object.assign({},oe),V||{}),{outcome:q}))}_doActivateExtension(M,U){const q=Y(M,U);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",q);const V=this._getEntryPoint(M);if(!V)return Promise.resolve(new h.EmptyExtension(h.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${M.identifier.value} ${JSON.stringify(U)}`),this._logService.flush();const oe=new h.ExtensionActivationTimesBuilder(U.startup);return Promise.all([this._loadCommonJSModule(M.identifier,E.joinPath(M.extensionLocation,V),oe),this._loadExtensionContext(M)]).then(ge=>(D.mark(`code/extHost/willActivateExtension/${M.identifier.value}`),Nn._callActivate(this._logService,M.identifier,ge[0],ge[1],oe))).then(ge=>(D.mark(`code/extHost/didActivateExtension/${M.identifier.value}`),ge))}_loadExtensionContext(M){const U=new f.ExtensionGlobalMemento(M,this._storage),q=new f.ExtensionMemento(M.identifier.value,!1,this._storage),V=new H.ExtensionSecrets(M,this._secretState),oe=M.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,ge=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${M.identifier.value}`),Promise.all([U.whenReady,q.whenReady,this._storagePath.whenReady]).then(()=>{const Re=this;let $e;return Object.freeze({globalState:U,workspaceState:q,secrets:V,subscriptions:[],get extensionUri(){return M.extensionLocation},get extensionPath(){return M.extensionLocation.fsPath},asAbsolutePath(Me){return T.join(M.extensionLocation.fsPath,Me)},get storagePath(){var Me;return(Me=Re._storagePath.workspaceValue(M))===null||Me===void 0?void 0:Me.fsPath},get globalStoragePath(){return Re._storagePath.globalValue(M).fsPath},get logPath(){return T.join(Re._initData.logsLocation.fsPath,M.identifier.value)},get logUri(){return k.URI.joinPath(Re._initData.logsLocation,M.identifier.value)},get storageUri(){return Re._storagePath.workspaceValue(M)},get globalStorageUri(){return Re._storagePath.globalValue(M)},get extensionMode(){return oe},get extension(){return $e===void 0&&($e=new R(Re,M.identifier,M,ge)),$e},get extensionRuntime(){return w.checkProposedApiEnabled(M),Re.extensionRuntime},get environmentVariableCollection(){return Re._extHostTerminalService.getEnvironmentVariableCollection(M)}})})}static _callActivate(M,U,q,V,oe){return q=q||{activate:void 0,deactivate:void 0},this._callActivateOptional(M,U,q,V,oe).then(ge=>new h.ActivatedExtension(!1,null,oe.build(),q,ge,V.subscriptions))}static _callActivateOptional(M,U,q,V,oe){if(typeof q.activate=="function")try{oe.activateCallStart(),M.trace(`ExtensionService#_callActivateOptional ${U.value}`);const ge=typeof global=="object"?global:self,Re=q.activate.apply(ge,[V]);return oe.activateCallStop(),oe.activateResolveStart(),Promise.resolve(Re).then($e=>(oe.activateResolveStop(),$e))}catch(ge){return Promise.reject(ge)}else return Promise.resolve(q)}_activateOneStartupFinished(M,U){this._activateById(M.identifier,{startup:!1,extensionId:M.identifier,activationEvent:U}).then(void 0,q=>{this._logService.error(q)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(D.getMarks());for(const M of this._registry.getAllExtensionDescriptions())if(M.activationEvents)for(const U of M.activationEvents)U==="onStartupFinished"&&this._activateOneStartupFinished(M,U)}_handleEagerExtensions(){const M=this._activateByEvent("*",!0).then(void 0,oe=>{this._logService.error(oe)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(oe=>this._handleWorkspaceContainsEagerExtensions(oe.added)));const U=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],q=this._handleWorkspaceContainsEagerExtensions(U),V=Promise.all([M,q]).then(()=>{});return Promise.race([V,C.timeout(1e4)]).then(()=>{this._activateAllStartupFinished()}),V}_handleWorkspaceContainsEagerExtensions(M){return M.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(U=>this._handleWorkspaceContainsEagerExtension(M,U))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(M,U){if(this.isActivated(U.identifier))return;const q=!this._initData.remote.isRemote&&!!this._initData.remote.authority,V={folders:M.map(ge=>ge.uri),forceUsingSearch:q,exists:ge=>this._hostUtils.exists(ge.fsPath),checkExists:(ge,Re,$e)=>this._mainThreadWorkspaceProxy.$checkExists(ge,Re,$e)},oe=await F.checkActivateWorkspaceContainsExtension(V,U);if(!!oe)return this._activateById(U.identifier,{startup:!0,extensionId:U.identifier,activationEvent:oe.activationEvent}).then(void 0,ge=>this._logService.error(ge))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return this._doHandleExtensionTests()}catch(M){throw console.error(M),M}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:M,extensionTestsLocationURI:U}=this._initData.environment;if(!M||!U)throw new Error(g.localize(0,null));const q=await this._loadCommonJSModule(null,U,new h.ExtensionActivationTimesBuilder(!1));if(!q||typeof q.run!="function")throw new Error(g.localize(1,null,U.toString()));return new Promise((V,oe)=>{const ge=(Me,We)=>{Me?oe(Me):V(typeof We=="number"&&We>0?1:0)},Re=E.originalFSPath(U),$e=q.run(Re,ge);$e&&$e.then&&$e.then(()=>{V(0)}).catch(Me=>{oe(Me.toString())})})}async $extensionTestsExit(M){this._logService.info(`extension host terminating: test runner requested exit with code ${M}`),this._logService.info(`exiting with code ${M}`),this._logService.flush(),this._hostUtils.exit(M)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(M,U){return this._resolvers[M]=U,y.toDisposable(()=>{delete this._resolvers[M]})}async _activateAndGetResolver(M){const U=M.indexOf("+");if(U===-1)throw new Error("Not an authority that can be resolved!");const q=M.substr(0,U);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${q}`,!1),{authorityPrefix:q,resolver:this._resolvers[q]}}async $resolveAuthority(M,U){const{authorityPrefix:q,resolver:V}=await this._activateAndGetResolver(M);if(!V)return{type:"error",error:{code:r.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${q}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(V)),D.mark(`code/extHost/willResolveAuthority/${q}`);const oe=await V.resolve(M,{resolveAttempt:U});D.mark(`code/extHost/didResolveAuthorityOK/${q}`);const ge={authority:M,host:oe.host,port:oe.port,connectionToken:oe.connectionToken},Re={extensionHostEnv:oe.extensionHostEnv,isTrusted:oe.isTrusted};return{type:"ok",value:{authority:ge,options:Re,tunnelInformation:{environmentTunnels:oe.environmentTunnels}}}}catch(oe){if(D.mark(`code/extHost/didResolveAuthorityError/${q}`),oe instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:oe._code,message:oe._message,detail:oe._detail}};throw oe}}async $getCanonicalURI(M,U){const{authorityPrefix:q,resolver:V}=await this._activateAndGetResolver(M);if(!V)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${q}`);const oe=k.URI.revive(U);if(typeof V.getCanonicalURI=="undefined")return oe;const ge=await C.asPromise(()=>V.getCanonicalURI(oe));return ge||oe}$startExtensionHost(M){return this._registry.keepOnly(M),this._startExtensionHost()}$activateByEvent(M,U){return U===1?this._activateByEvent(M,!1):this._readyToRunExtensions.wait().then(q=>this._activateByEvent(M,!1))}async $activate(M,U){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(M)?(await this._activateById(M,U),!0):!1}async $deltaExtensions(M,U){M.forEach(V=>V.extensionLocation=k.URI.revive(V.extensionLocation));const q=await this.getExtensionPathIndex();return await Promise.all(U.map(async V=>{const oe=this._registry.getExtensionDescription(V);if(!oe)return;const ge=await this._hostUtils.realpath(oe.extensionLocation.fsPath);q.delete(k.URI.file(ge).fsPath)})),await Promise.all(M.map(async V=>{const oe=await this._hostUtils.realpath(V.extensionLocation.fsPath);q.set(k.URI.file(oe).fsPath,V)})),this._registry.deltaExtensions(M,U),Promise.resolve(void 0)}async $test_latency(M){return M}async $test_up(M){return M.byteLength}async $test_down(M){let U=m.VSBuffer.alloc(M),q=Math.random()%256;for(let V=0;V<M;V++)U.writeUInt8(q,V);return U}async $updateRemoteConnectionData(M){this._remoteConnectionData=M,this._onDidChangeRemoteConnectionData.fire()}};z=He([ze(0,i.IInstantiationService),ze(1,e.IHostUtils),ze(2,b.IExtHostRpcService),ze(3,u.IExtHostWorkspace),ze(4,o.IExtHostConfiguration),ze(5,n.ILogService),ze(6,s.IExtHostInitDataService),ze(7,l.IExtensionStoragePaths),ze(8,P.IExtHostTunnelService),ze(9,A.IExtHostTerminalService)],z),e.AbstractExtHostExtensionService=z;function Y(B,M){return{id:B.identifier.value,name:B.name,extensionVersion:B.version,publisherDisplayName:B.publisher,activationEvents:B.activationEvents?B.activationEvents.join(","):null,isBuiltin:B.isBuiltin,reason:M.activationEvent,reasonId:M.extensionId.value}}e.IExtHostExtensionService=i.createDecorator("IExtHostExtensionService");class R{constructor(M,U,q,V){le.set(this,void 0),fe.set(this,void 0),X.set(this,void 0),tt(this,le,M,"f"),tt(this,fe,U,"f"),tt(this,X,q.identifier,"f"),this.id=q.identifier.value,this.extensionUri=q.extensionLocation,this.extensionPath=T.normalize(E.originalFSPath(q.extensionLocation)),this.packageJSON=q,this.extensionKind=V}get isActive(){return xe(this,le,"f").isActivated(xe(this,X,"f"))}get exports(){if(this.packageJSON.api!=="none")return xe(this,le,"f").getExtensionExports(xe(this,X,"f"))}activate(){return xe(this,le,"f").activateByIdWithErrors(xe(this,X,"f"),{startup:!1,extensionId:xe(this,fe,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=R,le=new WeakMap,fe=new WeakMap,X=new WeakMap}),define(we[103],_e([0,1,13,2,3,11,4,6,158,30,33,36,162,32,159,14,5,10,40,64]),function(Z,e,g,T,D,E,C,y,_,k,n,I,o,h,d,u,w,v,S,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=w.createDecorator("IExtHostDebugService");let m=class{constructor(p,P,A,a,F,N){this._workspaceService=P,this._extensionService=A,this._editorsService=a,this._configurationService=F,this._editorTabs=N,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new D.Emitter,this._onDidTerminateDebugSession=new D.Emitter,this._onDidChangeActiveDebugSession=new D.Emitter,this._onDidReceiveDebugSessionCustomEvent=new D.Emitter,this._debugServiceProxy=p.getProxy(C.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new D.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new t(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(H=>{H.onDidChange(le=>{this.registerAllDebugTypes(H)}),this.registerAllDebugTypes(H)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(p,P){const A=p;if(typeof A.sourceReference=="number"&&A.sourceReference>0){let a=`debug:${encodeURIComponent(A.path||"")}`,F="?";return P&&(a+=`${F}session=${encodeURIComponent(P.id)}`,F="&"),a+=`${F}ref=${A.sourceReference}`,T.URI.parse(a)}else{if(A.path)return T.URI.file(A.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(p){const P=[];for(const A of p.getAllExtensionDescriptions())if(A.contributes){const a=A.contributes.debuggers;if(a&&a.length>0)for(const F of a)d.isDebuggerMainContribution(F)&&P.push(F.type)}this._debugServiceProxy.$registerDebugTypes(P)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const p=[];return this._breakpoints.forEach(P=>p.push(P)),p}addBreakpoints(p){this.startBreakpoints();const P=p.filter(F=>{const N=F.id;return this._breakpoints.has(N)?!1:(this._breakpoints.set(N,F),!0)});this.fireBreakpointChanges(P,[],[]);const A=[],a=new Map;for(const F of P)if(F instanceof y.SourceBreakpoint){let N=a.get(F.location.uri.toString());N||(N={type:"sourceMulti",uri:F.location.uri,lines:[]},a.set(F.location.uri.toString(),N),A.push(N)),N.lines.push({id:F.id,enabled:F.enabled,condition:F.condition,hitCondition:F.hitCondition,logMessage:F.logMessage,line:F.location.range.start.line,character:F.location.range.start.character})}else F instanceof y.FunctionBreakpoint&&A.push({type:"function",id:F.id,enabled:F.enabled,hitCondition:F.hitCondition,logMessage:F.logMessage,condition:F.condition,functionName:F.functionName});return this._debugServiceProxy.$registerBreakpoints(A)}removeBreakpoints(p){this.startBreakpoints();const P=p.filter(N=>this._breakpoints.delete(N.id));this.fireBreakpointChanges([],P,[]);const A=P.filter(N=>N instanceof y.SourceBreakpoint).map(N=>N.id),a=P.filter(N=>N instanceof y.FunctionBreakpoint).map(N=>N.id),F=P.filter(N=>N instanceof y.DataBreakpoint).map(N=>N.id);return this._debugServiceProxy.$unregisterBreakpoints(A,a,F)}startDebugging(p,P,A){return this._debugServiceProxy.$startDebugging(p?p.uri:void 0,P,{parentSessionID:A.parentSession?A.parentSession.id:void 0,repl:A.consoleMode===y.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:A.noDebug,compact:A.compact})}stopDebugging(p){return this._debugServiceProxy.$stopDebugging(p?p.id:void 0)}registerDebugConfigurationProvider(p,P,A){if(!P)return new y.Disposable(()=>{});const a=this._configProviderHandleCounter++;return this._configProviders.push({type:p,handle:a,provider:P}),this._debugServiceProxy.$registerDebugConfigurationProvider(p,A,!!P.provideDebugConfigurations,!!P.resolveDebugConfiguration,!!P.resolveDebugConfigurationWithSubstitutedVariables,a),new y.Disposable(()=>{this._configProviders=this._configProviders.filter(F=>F.provider!==P),this._debugServiceProxy.$unregisterDebugConfigurationProvider(a)})}registerDebugAdapterDescriptorFactory(p,P,A){if(!A)return new y.Disposable(()=>{});if(!this.definesDebugType(p,P))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${P}' debugger.`);if(this.getAdapterDescriptorFactoryByType(P))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const a=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:P,handle:a,factory:A}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(P,a),new y.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(F=>F.factory!==A),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(a)})}registerDebugAdapterTrackerFactory(p,P){if(!P)return new y.Disposable(()=>{});const A=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:p,handle:A,factory:P}),new y.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(a=>a.factory!==P)})}async $runInTerminal(p,P){return Promise.resolve(void 0)}async $substituteVariables(p,P){if(!this._variableResolver){const[F,N]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(F||[],this._editorsService,N)}let A;const a=await this.getFolder(p);return a&&(A={uri:a.uri,name:a.name,index:a.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(A,P)}createDebugAdapter(p,P){if(p.type==="implementation")return new s(p.implementation)}createSignService(){}async $startDASession(p,P){const A=this,a=await this.getSession(P);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(a.type),a).then(F=>{if(!F)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${a.type}' (extension might have failed to activate)`);const N=this.convertToDto(F),H=this.createDebugAdapter(N,a);if(!H)throw new Error(`Couldn't create a debug adapter for type '${a.type}'.`);const le=H;return this._debugAdapters.set(p,le),this.getDebugAdapterTrackers(a).then(fe=>(fe&&this._debugAdaptersTrackers.set(p,fe),le.onMessage(async X=>{if(X.type==="request"&&X.command==="handshake"){const z=X,Y={type:"response",seq:0,command:z.command,request_seq:z.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const R=await this._signService.sign(z.arguments.value);Y.body={signature:R},le.sendResponse(Y)}else throw new Error("no signer")}catch(R){Y.success=!1,Y.message=R.message,le.sendResponse(Y)}}else fe&&fe.onDidSendMessage&&fe.onDidSendMessage(X),X=d.convertToVSCPaths(X,!0),A._debugServiceProxy.$acceptDAMessage(p,X)}),le.onError(X=>{fe&&fe.onError&&fe.onError(X),this._debugServiceProxy.$acceptDAError(p,X.name,X.message,X.stack)}),le.onExit(X=>{fe&&fe.onExit&&fe.onExit(v.withNullAsUndefined(X),void 0),this._debugServiceProxy.$acceptDAExit(p,v.withNullAsUndefined(X),void 0)}),fe&&fe.onWillStartSession&&fe.onWillStartSession(),le.startSession()))})}$sendDAMessage(p,P){P=d.convertToDAPaths(P,!1);const A=this._debugAdaptersTrackers.get(p);A&&A.onWillReceiveMessage&&A.onWillReceiveMessage(P);const a=this._debugAdapters.get(p);a&&a.sendMessage(P)}$stopDASession(p){const P=this._debugAdaptersTrackers.get(p);this._debugAdaptersTrackers.delete(p),P&&P.onWillStopSession&&P.onWillStopSession();const A=this._debugAdapters.get(p);return this._debugAdapters.delete(p),A?A.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(p){const P=[],A=[],a=[];if(p.added)for(const F of p.added){const N=F.id;if(N&&!this._breakpoints.has(N)){let H;if(F.type==="function")H=new y.FunctionBreakpoint(F.functionName,F.enabled,F.condition,F.hitCondition,F.logMessage);else if(F.type==="data")H=new y.DataBreakpoint(F.label,F.dataId,F.canPersist,F.enabled,F.hitCondition,F.condition,F.logMessage);else{const le=T.URI.revive(F.uri);H=new y.SourceBreakpoint(new y.Location(le,new y.Position(F.line,F.character)),F.enabled,F.condition,F.hitCondition,F.logMessage)}H._id=N,this._breakpoints.set(N,H),P.push(H)}}if(p.removed)for(const F of p.removed){const N=this._breakpoints.get(F);N&&(this._breakpoints.delete(F),A.push(N))}if(p.changed){for(const F of p.changed)if(F.id){const N=this._breakpoints.get(F.id);if(N){if(N instanceof y.FunctionBreakpoint&&F.type==="function"){const H=N;H.enabled=F.enabled,H.condition=F.condition,H.hitCondition=F.hitCondition,H.logMessage=F.logMessage,H.functionName=F.functionName}else if(N instanceof y.SourceBreakpoint&&F.type==="source"){const H=N;H.enabled=F.enabled,H.condition=F.condition,H.hitCondition=F.hitCondition,H.logMessage=F.logMessage,H.location=new y.Location(T.URI.revive(F.uri),new y.Position(F.line,F.character))}a.push(N)}}}this.fireBreakpointChanges(P,A,a)}$provideDebugConfigurations(p,P,A){return E.asPromise(async()=>{const a=this.getConfigProviderByHandle(p);if(!a)throw new Error("no DebugConfigurationProvider found");if(!a.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const F=await this.getFolder(P);return a.provideDebugConfigurations(F,A)}).then(a=>{if(!a)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return a})}$resolveDebugConfiguration(p,P,A,a){return E.asPromise(async()=>{const F=this.getConfigProviderByHandle(p);if(!F)throw new Error("no DebugConfigurationProvider found");if(!F.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const N=await this.getFolder(P);return F.resolveDebugConfiguration(N,A,a)})}$resolveDebugConfigurationWithSubstitutedVariables(p,P,A,a){return E.asPromise(async()=>{const F=this.getConfigProviderByHandle(p);if(!F)throw new Error("no DebugConfigurationProvider found");if(!F.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const N=await this.getFolder(P);return F.resolveDebugConfigurationWithSubstitutedVariables(N,A,a)})}async $provideDebugAdapter(p,P){const A=this.getAdapterDescriptorFactoryByHandle(p);if(!A)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const a=await this.getSession(P);return this.getAdapterDescriptor(A,a).then(F=>{if(!F)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${a.type}'`);return this.convertToDto(F)})}async $acceptDebugSessionStarted(p){const P=await this.getSession(p);this._onDidStartDebugSession.fire(P)}async $acceptDebugSessionTerminated(p){const P=await this.getSession(p);P&&(this._onDidTerminateDebugSession.fire(P),this._debugSessions.delete(P.id))}async $acceptDebugSessionActiveChanged(p){this._activeDebugSession=p?await this.getSession(p):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(p,P){const A=await this.getSession(p);A&&A._acceptNameChanged(P)}async $acceptDebugSessionCustomEvent(p,P){const a={session:await this.getSession(p),event:P.event,body:P.body};this._onDidReceiveDebugSessionCustomEvent.fire(a)}convertToDto(p){if(p instanceof y.DebugAdapterExecutable)return{type:"executable",command:p.command,args:p.args,options:p.options};if(p instanceof y.DebugAdapterServer)return{type:"server",port:p.port,host:p.host};if(p instanceof y.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:p.path};if(p instanceof y.DebugAdapterInlineImplementation)return{type:"implementation",implementation:p.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(p){const P=this._adapterFactories.filter(A=>A.type===p);if(P.length>0)return P[0].factory}getAdapterDescriptorFactoryByHandle(p){const P=this._adapterFactories.filter(A=>A.handle===p);if(P.length>0)return P[0].factory}getConfigProviderByHandle(p){const P=this._configProviders.filter(A=>A.handle===p);if(P.length>0)return P[0].provider}definesDebugType(p,P){if(p.contributes){const A=p.contributes.debuggers;if(A&&A.length>0){for(const a of A)if(a.label&&a.type&&a.type===P)return!0}}return!1}getDebugAdapterTrackers(p){const A=p.configuration.type,a=this._trackerFactories.filter(F=>F.type===A||F.type==="*").map(F=>E.asPromise(()=>F.factory.createDebugAdapterTracker(p)).then(N=>N,N=>null));return Promise.race([Promise.all(a).then(F=>{const N=F.filter(H=>!!H);if(N.length>0)return new i(N)}),new Promise((F,N)=>{const H=setTimeout(()=>{clearTimeout(H),N(new Error("timeout"))},1e3)})]).catch(F=>{})}async getAdapterDescriptor(p,P){const A=P.configuration.debugServer;if(typeof A=="number")return Promise.resolve(new y.DebugAdapterServer(A));if(p){const F=await this._extensionService.getExtensionRegistry();return E.asPromise(()=>p.createDebugAdapterDescriptor(P,this.daExecutableFromPackage(P,F))).then(N=>{if(N)return N})}const a=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(P,a))}daExecutableFromPackage(p,P){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(p,P,A){(p.length>0||P.length>0||A.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:p,removed:P,changed:A}))}async getSession(p){if(p)if(typeof p=="string"){const P=this._debugSessions.get(p);if(P)return P}else{let P=this._debugSessions.get(p.id);if(!P){const A=await this.getFolder(p.folderUri),a=p.parent?this._debugSessions.get(p.parent):void 0;P=new f(this._debugServiceProxy,p.id,p.type,p.name,A,p.configuration,a),this._debugSessions.set(P.id,P),this._debugServiceProxy.$sessionCached(P.id)}return P}throw new Error("cannot find session")}getFolder(p){if(p){const P=T.URI.revive(p);return this._workspaceService.resolveWorkspaceFolder(P)}return Promise.resolve(void 0)}};m=He([ze(0,u.IExtHostRpcService),ze(1,k.IExtHostWorkspace),ze(2,n.IExtHostExtensionService),ze(3,I.IExtHostDocumentsAndEditors),ze(4,h.IExtHostConfiguration),ze(5,c.IExtHostEditorTabs)],m),e.ExtHostDebugServiceBase=m;class f{constructor(p,P,A,a,F,N,H){this._debugServiceProxy=p,this._id=P,this._type=A,this._name=a,this._workspaceFolder=F,this._configuration=N,this._parentSession=H}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(p){this._name=p,this._debugServiceProxy.$setDebugSessionName(this._id,p)}get parentSession(){return this._parentSession}_acceptNameChanged(p){this._name=p}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(p,P){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,p,P)}getDebugProtocolBreakpoint(p){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,p.id)}}e.ExtHostDebugSession=f;class t{constructor(p){this.value=Object.freeze({append(P){p.$appendDebugConsole(P)},appendLine(P){this.append(P+`
`)}})}}e.ExtHostDebugConsole=t;class r extends o.AbstractVariableResolverService{constructor(p,P,A,a,F){function N(){if(P){const H=P.activeEditor();if(H)return H.document.uri;const le=a.tabs.filter(fe=>fe.isActive);if(le.length>0)return le[0].resource}}super({getFolderUri:H=>{const le=p.filter(fe=>fe.name===H);if(le&&le.length>0)return le[0].uri},getWorkspaceFolderCount:()=>p.length,getConfigurationValue:(H,le)=>A.getConfiguration(void 0,H).get(le),getAppRoot:()=>S.cwd(),getExecPath:()=>S.env.VSCODE_EXEC_PATH,getFilePath:()=>{const H=N();if(H)return g.normalize(H.fsPath)},getWorkspaceFolderPathForFile:()=>{if(F){const H=N();if(H){const le=F.getWorkspaceFolder(H);if(le)return g.normalize(le.uri.fsPath)}}},getSelectedText:()=>{if(P){const H=P.activeEditor();if(H&&!H.selection.isEmpty)return H.document.getText(H.selection)}},getLineNumber:()=>{if(P){const H=P.activeEditor();if(H)return String(H.selection.end.line+1)}}},void 0,Promise.resolve(S.env))}}e.ExtHostVariableResolverService=r;class i{constructor(p){this.trackers=p}onWillStartSession(){this.trackers.forEach(p=>p.onWillStartSession?p.onWillStartSession():void 0)}onWillReceiveMessage(p){this.trackers.forEach(P=>P.onWillReceiveMessage?P.onWillReceiveMessage(p):void 0)}onDidSendMessage(p){this.trackers.forEach(P=>P.onDidSendMessage?P.onDidSendMessage(p):void 0)}onWillStopSession(){this.trackers.forEach(p=>p.onWillStopSession?p.onWillStopSession():void 0)}onError(p){this.trackers.forEach(P=>P.onError?P.onError(p):void 0)}onExit(p,P){this.trackers.forEach(A=>A.onExit?A.onExit(p,P):void 0)}}class s extends _.AbstractDebugAdapter{constructor(p){super();this.implementation=p,p.onDidSendMessage(P=>{this.acceptMessage(P)})}startSession(){return Promise.resolve(void 0)}sendMessage(p){this.implementation.handleMessage(p)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let l=class extends m{constructor(p,P,A,a,F,N){super(p,P,A,a,F,N)}createVariableResolver(p,P,A){return new r(p,P,A,this._editorTabs)}};l=He([ze(0,u.IExtHostRpcService),ze(1,k.IExtHostWorkspace),ze(2,n.IExtHostExtensionService),ze(3,I.IExtHostDocumentsAndEditors),ze(4,h.IExtHostConfiguration),ze(5,c.IExtHostEditorTabs)],l),e.WorkerExtHostDebugService=l}),define(we[210],_e([0,1,75,2,4,32,29,26,14,28,5,33,40,17]),function(Z,e,g,T,D,E,C,y,_,k,n,I,o,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let d=class{constructor(c,m,f,t,r,i,s){this._apiFactory=c,this._extensionRegistry=m,this._instaService=f,this._extHostConfiguration=t,this._extHostExtensionService=r,this._initData=i,this._logService=s,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),g.mark("code/extHost/willWaitForConfig");const c=await this._extHostConfiguration.getConfigProvider();g.mark("code/extHost/didWaitForConfig");const m=await this._extHostExtensionService.getExtensionPathIndex();this.register(new u(this._apiFactory,m,this._extensionRegistry,c,this._logService)),this.register(this._instaService.createInstance(w)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(v,m,this._initData.environment.appUriScheme))}register(c){if(Array.isArray(c.nodeModuleName))for(let m of c.nodeModuleName)this._factories.set(m,c);else this._factories.set(c.nodeModuleName,c);typeof c.alternativeModuleName=="function"&&this._alternatives.push(m=>c.alternativeModuleName(m))}};d=He([ze(2,n.IInstantiationService),ze(3,E.IExtHostConfiguration),ze(4,I.IExtHostExtensionService),ze(5,k.IExtHostInitDataService),ze(6,h.ILogService)],d),e.RequireInterceptor=d;class u{constructor(c,m,f,t,r){this._apiFactory=c,this._extensionPaths=m,this._extensionRegistry=f,this._configProvider=t,this._logService=r,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(c,m){const f=this._extensionPaths.findSubstr(m.fsPath);if(f){let t=this._extApiImpl.get(y.ExtensionIdentifier.toKey(f.identifier));return t||(t=this._apiFactory(f,this._extensionRegistry,this._configProvider),this._extApiImpl.set(y.ExtensionIdentifier.toKey(f.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((r,i)=>t+=`	${i} -> ${r.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${m.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(C.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let w=class{constructor(c,m){this.nodeModuleName="keytar";const{environment:f}=m,t=c.getProxy(D.MainContext.MainThreadKeytar);if(f.appRoot){let r=f.appRoot.fsPath;o.platform==="win32"&&(r=r.replace(/\\/g,"/")),r[r.length-1]==="/"&&(r=r.substr(0,r.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${r}/node_modules.asar/keytar`),this.alternativeNames.add(`${r}/node_modules/keytar`)}this._impl={getPassword:(r,i)=>t.$getPassword(r,i),setPassword:(r,i,s)=>t.$setPassword(r,i,s),deletePassword:(r,i)=>t.$deletePassword(r,i),findPassword:r=>t.$findPassword(r),findCredentials(r){return t.$findCredentials(r)}}}load(c,m){return this._impl}alternativeModuleName(c){const m=c.length;if(m<=7||!this.alternativeNames)return;const f=m-7;if((c.charAt(f)==="/"||c.charAt(f)==="\\")&&c.endsWith("keytar")&&(c=c.replace(/\\/g,"/"),this.alternativeNames.has(c)))return"keytar"}};w=He([ze(0,_.IExtHostRpcService),ze(1,k.IExtHostInitDataService)],w);let v=class{constructor(c,m,f){this._extensionPaths=c,this._appUriScheme=m,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=f.getProxy(D.MainContext.MainThreadTelemetry);const t=f.getProxy(D.MainContext.MainThreadWindow);this._impl=(r,i)=>{const s=T.URI.parse(r);return i?this.callOriginal(r,i):s.scheme==="http"||s.scheme==="https"?t.$openUri(s,r,{allowTunneling:!0}):s.scheme==="mailto"||s.scheme===this._appUriScheme?t.$openUri(s,r,{}):this.callOriginal(r,i)}}load(c,m,f){const t=this._extensionPaths.findSubstr(m.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=f(c),this._impl}callOriginal(c,m){return this.sendNoForwardTelemetry(),this._original(c,m)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};v=He([ze(2,_.IExtHostRpcService)],v)}),define(we[211],_e([0,1,11,12,75,7,2,4,203,17,57,60,28,144,14,67,33,37]),function(Z,e,g,T,D,E,C,y,_,k,n,I,o,h,d,u,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class S{constructor(m,f,t,r){this._disposables=new E.DisposableStore,this._isTerminating=!1,this._hostUtils=t,this._rpcProtocol=new _.RPCProtocol(m,null,r),f=S._transform(f,this._rpcProtocol);const i=new I.ServiceCollection(...n.getSingletonServiceDescriptors());i.set(o.IExtHostInitDataService,Object.assign({_serviceBrand:void 0},f)),i.set(d.IExtHostRpcService,new d.ExtHostRpcService(this._rpcProtocol)),i.set(u.IURITransformerService,new u.URITransformerService(r)),i.set(w.IHostUtils,t);const s=new h.InstantiationService(i,!0),l=s.invokeFunction(A=>A.get(v.IExtHostTerminalService));this._disposables.add(l),this._logService=s.invokeFunction(A=>A.get(k.ILogService)),D.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",f),this._extensionService=s.invokeFunction(A=>A.get(w.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const b=new WeakMap;this._extensionService.getExtensionPathIndex().then(A=>{Error.prepareStackTrace=(a,F)=>{let N="",H,le;for(const fe of F)N+=`
	at ${fe.toString()}`,le=fe.getFileName(),!H&&le&&(H=A.findSubstr(le));return b.set(a,H),`${a.name||"Error"}: ${a.message||""}${N}`}});const p=this._rpcProtocol.getProxy(y.MainContext.MainThreadExtensionService),P=this._rpcProtocol.getProxy(y.MainContext.MainThreadErrors);T.setUnexpectedErrorHandler(A=>{const a=T.transformErrorForSerialization(A),F=b.get(A);F?p.$onExtensionRuntimeError(F.identifier,a):P.$onUnexpectedError(a)})}terminate(m){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${m}`),this._logService.flush(),this._disposables.dispose(),T.setUnexpectedErrorHandler(t=>{this._logService.error(t)}),this._rpcProtocol.dispose();const f=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([g.timeout(4e3),f]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}static _transform(m,f){m.extensions.forEach(r=>r.extensionLocation=C.URI.revive(f.transformIncomingURIs(r.extensionLocation))),m.environment.appRoot=C.URI.revive(f.transformIncomingURIs(m.environment.appRoot));const t=m.environment.extensionDevelopmentLocationURI;return t&&(m.environment.extensionDevelopmentLocationURI=t.map(r=>C.URI.revive(f.transformIncomingURIs(r)))),m.environment.extensionTestsLocationURI=C.URI.revive(f.transformIncomingURIs(m.environment.extensionTestsLocationURI)),m.environment.globalStorageHome=C.URI.revive(f.transformIncomingURIs(m.environment.globalStorageHome)),m.environment.workspaceStorageHome=C.URI.revive(f.transformIncomingURIs(m.environment.workspaceStorageHome)),m.logsLocation=C.URI.revive(f.transformIncomingURIs(m.logsLocation)),m.logFile=C.URI.revive(f.transformIncomingURIs(m.logFile)),m.workspace=f.transformIncomingURIs(m.workspace),m}}e.ExtensionHostMain=S}),define(we[212],_e([0,1,13,18,56,27,25,52,38]),function(Z,e,g,T,D,E,C,y,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class k{constructor(o,h,d){this.config=o,this.provider=h,this.sessionToken=d,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=o.filePattern,this.includePattern=o.includePattern&&E.parse(o.includePattern),this.maxResults=o.maxResults||void 0,this.exists=o.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=o.excludePattern&&E.parse(o.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(o=>o.cancel()),this.activeCancellationTokens=new Set}search(o){const h=this.config.folderQueries||[];return new Promise((d,u)=>{const w=v=>{this.resultCount++,o(v)};if(this.isCanceled)return d({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(v=>{const S=v.toString(),c=g.basename(S);this.globalExcludePattern&&this.globalExcludePattern(S,c)||this.matchFile(w,{base:v,basename:c})}),Promise.all(h.map(v=>this.searchInFolder(v,w))).then(v=>{d({limitHit:this.isLimitHit,stats:v[0]||void 0})},v=>{u(new Error(D.toErrorMessage(v)))})})}async searchInFolder(o,h){const d=new T.CancellationTokenSource,u=this.getSearchOptionsForFolder(o),w=this.initDirectoryTree(),v=new _.QueryGlobTester(this.config,o),S=!v.hasSiblingExcludeClauses();let c;try{this.activeCancellationTokens.add(d),c=y.StopWatch.create();const m=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},u,d.token),f=c.elapsed(),t=y.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(m&&m.forEach(r=>{const i=g.posix.relative(o.folder.path,r.path);if(S){const s=g.basename(r.path);this.matchFile(h,{base:o.folder,relativePath:i,basename:s});return}this.addDirectoryEntries(w,o.folder,i,h)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(w,v,h),{providerTime:f,postProcessTime:t.elapsed()})}finally{d.dispose(),this.activeCancellationTokens.delete(d)}}getSearchOptionsForFolder(o){const h=_.resolvePatternsForProvider(this.config.includePattern,o.includePattern),d=_.resolvePatternsForProvider(this.config.excludePattern,o.excludePattern);return{folder:o.folder,excludes:d,includes:h,useIgnoreFiles:!o.disregardIgnoreFiles,useGlobalIgnoreFiles:!o.disregardGlobalIgnoreFiles,followSymlinks:!o.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const o={rootEntries:[],pathToEntries:Object.create(null)};return o.pathToEntries["."]=o.rootEntries,o}addDirectoryEntries({pathToEntries:o},h,d,u){if(d===this.filePattern){const v=g.basename(this.filePattern);this.matchFile(u,{base:h,relativePath:this.filePattern,basename:v})}function w(v){const S=g.basename(v),c=g.dirname(v);let m=o[c];m||(m=o[c]=[],w(c)),m.push({base:h,relativePath:v,basename:S})}w(d)}matchDirectoryTree({rootEntries:o,pathToEntries:h},d,u){const w=this,v=this.filePattern;function S(c){const m=E.hasSiblingFn(()=>c.map(f=>f.basename));for(let f=0,t=c.length;f<t;f++){const r=c[f],{relativePath:i,basename:s}=r;if(!d.includedInQuerySync(i,s,v!==s?m:void 0))continue;const l=h[i];if(l)S(l);else{if(i===v)continue;w.matchFile(u,r)}if(w.isLimitHit)break}}S(o)}matchFile(o,h){(!this.includePattern||h.relativePath&&this.includePattern(h.relativePath,h.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||o(h))}}class n{constructor(){this.sessions=new Map}fileSearch(o,h,d,u){const w=this.getSessionTokenSource(o.cacheKey),v=new k(o,h,w&&w.token);let S=0;const c=m=>{S+=m.length,d(m.map(f=>this.rawMatchToSearchItem(f)))};return this.doSearch(v,n.BATCH_SIZE,c,u).then(m=>({limitHit:m.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:S,detailStats:m.stats}}))}clearCache(o){const h=this.getSessionTokenSource(o);h&&h.cancel()}getSessionTokenSource(o){if(!!o)return this.sessions.has(o)||this.sessions.set(o,new T.CancellationTokenSource),this.sessions.get(o)}rawMatchToSearchItem(o){return o.relativePath?{resource:C.joinPath(o.base,o.relativePath)}:{resource:o.base}}doSearch(o,h,d,u){u.onCancellationRequested(()=>{o.cancel()});const w=S=>{S&&(v.push(S),h>0&&v.length>=h&&(d(v),v=[]))};let v=[];return o.search(w).then(S=>(v.length&&d(v),S),S=>(v.length&&d(v),Promise.reject(S)))}}e.FileSearchManager=n,n.BATCH_SIZE=512}),define(we[213],_e([0,1,13,16,18,56,25,27,2,38,15,10]),function(Z,e,g,T,D,E,C,y,_,k,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class o{constructor(c,m,f){this.query=c,this.provider=m,this.fileUtils=f,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(c,m){const f=this.query.folderQueries||[],t=new D.CancellationTokenSource;return m.onCancellationRequested(()=>t.cancel()),new Promise((r,i)=>{this.collector=new d(c);let s=!1;const l=(b,p)=>{if(!s&&!this.isLimitHit){const P=this.resultSize(b);w(b)&&typeof this.query.maxResults=="number"&&this.resultCount+P>this.query.maxResults&&(this.isLimitHit=!0,s=!0,t.cancel(),b=this.trimResultToSize(b,this.query.maxResults-this.resultCount));const A=this.resultSize(b);this.resultCount+=A,(A>0||!w(b))&&this.collector.add(b,p)}};Promise.all(f.map((b,p)=>this.searchInFolder(b,P=>l(P,p),t.token))).then(b=>{t.dispose(),this.collector.flush();const p=b.some(P=>!!P&&!!P.limitHit);r({limitHit:this.isLimitHit||p,messages:T.flatten(b.map(P=>(P==null?void 0:P.message)?I.isArray(P.message)?P.message:[P.message]:[])),stats:{type:"textSearchProvider"}})},b=>{t.dispose();const p=E.toErrorMessage(b);i(new Error(p))})})}resultSize(c){return w(c)?Array.isArray(c.ranges)?c.ranges.length:1:0}trimResultToSize(c,m){const f=Array.isArray(c.ranges)?c.ranges:[c.ranges],t=Array.isArray(c.preview.matches)?c.preview.matches:[c.preview.matches];return{ranges:f.slice(0,m),preview:{matches:t.slice(0,m),text:c.preview.text},uri:c.uri}}async searchInFolder(c,m,f){const t=new k.QueryGlobTester(this.query,c),r=[],i={report:b=>{if(!this.validateProviderResult(b))return;const p=c.folder.scheme===n.Schemas.file?y.hasSiblingPromiseFn(()=>this.fileUtils.readdir(C.dirname(b.uri))):void 0,P=C.relativePath(c.folder,b.uri);P&&r.push(t.includedInQuery(P,g.basename(P),p).then(A=>{A&&m(b)}))}},s=this.getSearchOptionsForFolder(c),l=await this.provider.provideTextSearchResults(h(this.query.contentPattern),s,i,f);return await Promise.all(r),l}validateProviderResult(c){if(w(c)){if(Array.isArray(c.ranges)){if(!Array.isArray(c.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(c.preview.matches.length!==c.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(c.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(c){const m=k.resolvePatternsForProvider(this.query.includePattern,c.includePattern),f=k.resolvePatternsForProvider(this.query.excludePattern,c.excludePattern),t={folder:_.URI.from(c.folder),excludes:f,includes:m,useIgnoreFiles:!c.disregardIgnoreFiles,useGlobalIgnoreFiles:!c.disregardGlobalIgnoreFiles,followSymlinks:!c.ignoreSymlinks,encoding:c.fileEncoding&&this.fileUtils.toCanonicalName(c.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return t.usePCRE2=this.query.usePCRE2,t}}e.TextSearchManager=o;function h(S){return{isCaseSensitive:S.isCaseSensitive||!1,isRegExp:S.isRegExp||!1,isWordMatch:S.isWordMatch||!1,isMultiline:S.isMultiline||!1,pattern:S.pattern}}class d{constructor(c){this._onResult=c,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new v(512,m=>this.sendItems(m))}add(c,m){this._currentFileMatch&&(this._currentFolderIdx!==m||!C.isEqual(this._currentUri,c.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=m,this._currentFileMatch={resource:c.uri,results:[]}),this._currentFileMatch.results.push(u(c))}pushToCollector(){const c=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,c)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(c){this._onResult(c)}}e.TextSearchResultsCollector=d;function u(S){return w(S)?{preview:{matches:T.mapArrayOrNot(S.preview.matches,c=>({startLineNumber:c.start.line,startColumn:c.start.character,endLineNumber:c.end.line,endColumn:c.end.character})),text:S.preview.text},ranges:T.mapArrayOrNot(S.ranges,c=>({startLineNumber:c.start.line,startColumn:c.start.character,endLineNumber:c.end.line,endColumn:c.end.character}))}:{text:S.text,lineNumber:S.lineNumber}}function w(S){return!!S.preview}e.extensionResultIsMatch=w;class v{constructor(c,m){this.maxBatchSize=c,this.cb=m,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(c,m){!c||this.addItemToBatch(c,m)}addItems(c,m){!c||this.addItemsToBatch(c,m)}addItemToBatch(c,m){this.batch.push(c),this.batchSize+=m,this.onUpdate()}addItemsToBatch(c,m){this.batch=this.batch.concat(c),this.batchSize+=m,this.onUpdate()}onUpdate(){this.totalNumberCompleted<v.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},v.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=v,v.TIMEOUT=4e3,v.START_BATCH_AFTER_COUNT=50}),define(we[104],_e([0,1,7,4,5,212,14,67,17,2,213]),function(Z,e,g,T,D,E,C,y,_,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=D.createDecorator("IExtHostSearch");let I=class{constructor(u,w,v){this.extHostRpc=u,this._uriTransformer=w,this._logService=v,this._proxy=this.extHostRpc.getProxy(T.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new E.FileSearchManager}_transformScheme(u){return this._uriTransformer.transformOutgoingScheme(u)}registerTextSearchProvider(u,w){if(this._textSearchUsedSchemes.has(u))throw new Error(`a text search provider for the scheme '${u}' is already registered`);this._textSearchUsedSchemes.add(u);const v=this._handlePool++;return this._textSearchProvider.set(v,w),this._proxy.$registerTextSearchProvider(v,this._transformScheme(u)),g.toDisposable(()=>{this._textSearchUsedSchemes.delete(u),this._textSearchProvider.delete(v),this._proxy.$unregisterProvider(v)})}registerFileSearchProvider(u,w){if(this._fileSearchUsedSchemes.has(u))throw new Error(`a file search provider for the scheme '${u}' is already registered`);this._fileSearchUsedSchemes.add(u);const v=this._handlePool++;return this._fileSearchProvider.set(v,w),this._proxy.$registerFileSearchProvider(v,this._transformScheme(u)),g.toDisposable(()=>{this._fileSearchUsedSchemes.delete(u),this._fileSearchProvider.delete(v),this._proxy.$unregisterProvider(v)})}$provideFileSearchResults(u,w,v,S){const c=o(v),m=this._fileSearchProvider.get(u);if(m)return this._fileSearchManager.fileSearch(c,m,f=>{this._proxy.$handleFileMatch(u,w,f.map(t=>t.resource))},S);throw new Error("unknown provider: "+u)}$clearCache(u){return this._fileSearchManager.clearCache(u),Promise.resolve(void 0)}$provideTextSearchResults(u,w,v,S){const c=this._textSearchProvider.get(u);if(!c||!c.provideTextSearchResults)throw new Error(`Unknown provider ${u}`);const m=o(v);return this.createTextSearchManager(m,c).search(t=>this._proxy.$handleTextMatch(u,w,t),S)}createTextSearchManager(u,w){return new n.TextSearchManager(u,w,{readdir:v=>Promise.resolve([]),toCanonicalName:v=>v})}};I=He([ze(0,C.IExtHostRpcService),ze(1,y.IURITransformerService),ze(2,_.ILogService)],I),e.ExtHostSearch=I;function o(d){return Object.assign(Object.assign({},d),{folderQueries:d.folderQueries&&d.folderQueries.map(h),extraFileResources:d.extraFileResources&&d.extraFileResources.map(u=>k.URI.revive(u))})}e.reviveQuery=o;function h(d){return Object.assign(Object.assign({},d),{folder:k.URI.revive(d.folder)})}}),define(we[214],_e([0,1,18,12,3,41,2,122,83,116,55,59,4,178,177,71,179,32,180,181,182,165,183,36,33,184,166,186,187,188,99,168,192,193,194,73,37,195,169,9,6,198,46,100,30,29,76,157,185,150,98,102,103,104,17,67,14,28,189,155,66,70,175,196,154,74,72,201,199,200,176,44,207,197,69,64,92,190,101,191,15,146]),function(Z,e,g,T,D,E,C,y,_,k,n,I,o,h,d,u,w,v,S,c,m,f,t,r,i,s,l,b,p,P,A,a,F,N,H,le,fe,X,z,Y,R,B,M,U,q,V,oe,ge,Re,$e,Me,We,Je,Qe,Ye,W,Q,te,re,K,se,he,Ae,Be,pe,Ke,j,ee,me,Fe,Le,Ge,Ee,be,De,ie,de,O,G,ae,Ce,Ie){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Oe(Ue){const qe=Ue.get(te.IExtHostInitDataService),rt=Ue.get(Ge.IExtHostFileSystemInfo),nt=Ue.get(j.IExtHostConsumerFileSystem),Ze=Ue.get(i.IExtHostExtensionService),ot=Ue.get(q.IExtHostWorkspace),ve=Ue.get(de.IExtHostTelemetry),ye=Ue.get(v.IExtHostConfiguration),ue=Ue.get(W.IURITransformerService),$=Ue.get(Q.IExtHostRpcService),Ne=Ue.get(le.IExtHostStorage),Pe=Ue.get(Ke.IExtensionStoragePaths),Ve=Ue.get(Ye.ILogService),Xe=Ue.get(se.IExtHostTunnelService),lt=Ue.get(he.IExtHostApiDeprecationService),ut=Ue.get(U.IExtHostWindow),it=Ue.get(De.IExtHostSecretState),mt=Ue.get(ie.IExtHostEditorTabs);$.set(o.ExtHostContext.ExtHostFileSystemInfo,rt),$.set(o.ExtHostContext.ExtHostLogService,Ve),$.set(o.ExtHostContext.ExtHostWorkspace,ot),$.set(o.ExtHostContext.ExtHostConfiguration,ye),$.set(o.ExtHostContext.ExtHostExtensionService,Ze),$.set(o.ExtHostContext.ExtHostStorage,Ne),$.set(o.ExtHostContext.ExtHostTunnelService,Xe),$.set(o.ExtHostContext.ExtHostWindow,ut),$.set(o.ExtHostContext.ExtHostSecretState,it),$.set(o.ExtHostContext.ExtHostTelemetry,ve),$.set(o.ExtHostContext.ExtHostEditorTabs,mt);const yt=$.set(o.ExtHostContext.ExtHostDecorations,Ue.get(Me.IExtHostDecorations)),vt=$.set(o.ExtHostContext.ExtHostDocumentsAndEditors,Ue.get(r.IExtHostDocumentsAndEditors)),wt=$.set(o.ExtHostContext.ExtHostCommands,Ue.get(u.IExtHostCommands)),gt=$.set(o.ExtHostContext.ExtHostTerminalService,Ue.get(fe.IExtHostTerminalService)),ht=$.set(o.ExtHostContext.ExtHostDebugService,Ue.get(Je.IExtHostDebugService)),kt=$.set(o.ExtHostContext.ExtHostSearch,Ue.get(Qe.IExtHostSearch)),Et=$.set(o.ExtHostContext.ExtHostTask,Ue.get(We.IExtHostTask)),Pt=$.set(o.ExtHostContext.ExtHostOutputService,Ue.get(A.IExtHostOutputService)),Ft=$.set(o.ExtHostContext.ExtHostUrls,new B.ExtHostUrls($)),_t=$.set(o.ExtHostContext.ExtHostDocuments,new t.ExtHostDocuments($,vt)),qt=$.set(o.ExtHostContext.ExtHostDocumentContentProviders,new m.ExtHostDocumentContentProvider($,vt,Ve)),Kt=$.set(o.ExtHostContext.ExtHostDocumentSaveParticipant,new f.ExtHostDocumentSaveParticipant(Ve,_t,$.getProxy(o.MainContext.MainThreadBulkEdits))),ft=$.set(o.ExtHostContext.ExtHostNotebook,new re.ExtHostNotebookController($,wt,vt,_t,Ve,Pe)),Gt=$.set(o.ExtHostContext.ExtHostNotebookKernels,new O.ExtHostNotebookKernels($,qe,ft,Ve)),Qt=$.set(o.ExtHostContext.ExtHostNotebookRenderers,new ae.ExtHostNotebookRenderers($,ft)),Dt=$.set(o.ExtHostContext.ExtHostEditors,new X.ExtHostEditors($,vt)),ln=$.set(o.ExtHostContext.ExtHostTreeViews,new z.ExtHostTreeViews($.getProxy(o.MainContext.MainThreadTreeViews),wt,Ve)),Yt=$.set(o.ExtHostContext.ExtHostEditorInsets,new ge.ExtHostEditorInsets($.getProxy(o.MainContext.MainThreadEditorInsets),Dt,qe)),xt=$.set(o.ExtHostContext.ExtHostDiagnostics,new S.ExtHostDiagnostics($,Ve)),ct=$.set(o.ExtHostContext.ExtHostLanguageFeatures,new b.ExtHostLanguageFeatures($,ue,_t,wt,xt,Ve,lt)),Jt=$.set(o.ExtHostContext.ExtHostFileSystem,new s.ExtHostFileSystem($,ct)),Mt=$.set(o.ExtHostContext.ExtHostFileSystemEventService,new l.ExtHostFileSystemEventService($,Ve,vt)),Lt=$.set(o.ExtHostContext.ExtHostQuickOpen,F.createExtHostQuickOpen($,ot,wt)),Vt=$.set(o.ExtHostContext.ExtHostSCM,new N.ExtHostSCM($,wt,Ve)),wn=$.set(o.ExtHostContext.ExtHostComments,new w.ExtHostComments($,wt,_t)),un=$.set(o.ExtHostContext.ExtHostProgress,new a.ExtHostProgress($.getProxy(o.MainContext.MainThreadProgress))),_n=$.set(o.ExtHostContext.ExtHosLabelService,new Re.ExtHostLabelService($)),cn=$.set(o.ExtHostContext.ExtHostTheming,new K.ExtHostTheming($)),Bt=$.set(o.ExtHostContext.ExtHostAuthentication,new Ae.ExtHostAuthentication($)),Xt=$.set(o.ExtHostContext.ExtHostTimeline,new Be.ExtHostTimeline($,wt)),Ht=$.set(o.ExtHostContext.ExtHostWebviews,new M.ExtHostWebviews($,{remote:qe.remote},ot,Ve,lt)),Zt=$.set(o.ExtHostContext.ExtHostWebviewPanels,new Fe.ExtHostWebviewPanels($,Ht,ot)),En=$.set(o.ExtHostContext.ExtHostCustomEditors,new me.ExtHostCustomEditors($,_t,Pe,Ht,Zt)),yn=$.set(o.ExtHostContext.ExtHostWebviewViews,new ee.ExtHostWebviewViews($,Ht)),Nt=$.set(o.ExtHostContext.ExtHostTesting,new Ee.ExtHostTesting($,vt,ot)),jt=$.set(o.ExtHostContext.ExtHostUriOpeners,new be.ExtHostUriOpeners($)),Sn=oe.values(o.ExtHostContext);$.assertRegistered(Sn);const Dn=new Le.ExtHostBulkEdits($,vt),en=new d.ExtHostClipboard($),tn=new P.ExtHostMessageService($,Ve),$t=new c.ExtHostDialogs($),Tt=new H.ExtHostStatusBar($,wt.converter),nn=new p.ExtHostLanguages($,_t);return h.ExtHostApiCommands.register(wt),function(Te,Wt,dn){const pt=function(){let J=!Te.isUnderDevelopment;function ce(ke){J||(Ve.info(`Extension '${Te.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),J=!0)}return function ke(st){if(Array.isArray(st))st.forEach(ke);else if(typeof st=="string")ce(st);else{const bt=st;typeof bt.scheme=="undefined"&&ce(st),!Te.enableProposedApi&&typeof bt.exclusive=="boolean"&&V.throwProposedApiError(Te)}return st}}(),Cn={getSession(J,ce,ke){return Bt.getSession(Te,J,ce,ke)},get onDidChangeSessions(){return Bt.onDidChangeSessions},registerAuthenticationProvider(J,ce,ke,st){return Bt.registerAuthenticationProvider(J,ce,ke,st)},get onDidChangeAuthenticationProviders(){return V.checkProposedApiEnabled(Te),Bt.onDidChangeAuthenticationProviders},get providers(){return V.checkProposedApiEnabled(Te),Bt.providers},logout(J,ce){return V.checkProposedApiEnabled(Te),Bt.removeSession(J,ce)}},kn={registerCommand(J,ce,ke){return wt.registerCommand(!0,J,ce,ke)},registerTextEditorCommand(J,ce,ke){return wt.registerCommand(!0,J,(...st)=>{const bt=Dt.getActiveTextEditor();if(!bt){Ve.warn("Cannot execute "+J+" because there is no active text editor.");return}return bt.edit(Ct=>{ce.apply(ke,[bt,Ct,...st])}).then(Ct=>{Ct||Ve.warn("Edits from command "+J+" were not applied.")},Ct=>{Ve.warn("An error occurred while running command "+J,Ct)})})},registerDiffInformationCommand:(J,ce,ke)=>(V.checkProposedApiEnabled(Te),wt.registerCommand(!0,J,async(...st)=>{const bt=vt.activeEditor(!0);if(!bt){Ve.warn("Cannot execute "+J+" because there is no active text editor.");return}const Ct=await Dt.getDiffInformation(bt.id);ce.apply(ke,[Ct,...st])})),executeCommand(J,...ce){return wt.executeCommand(J,...ce)},getCommands(J=!1){return wt.getCommands(J)}},hn={get machineId(){return qe.telemetryInfo.machineId},get sessionId(){return qe.telemetryInfo.sessionId},get language(){return qe.environment.appLanguage},get appName(){return qe.environment.appName},get appRoot(){var J,ce;return(ce=(J=qe.environment.appRoot)===null||J===void 0?void 0:J.fsPath)!==null&&ce!==void 0?ce:""},get uriScheme(){return qe.environment.appUriScheme},get clipboard(){return en.value},get shell(){return gt.getDefaultShell(!1)},get isTelemetryEnabled(){return ve.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return ve.onDidChangeTelemetryEnabled},get isNewAppInstall(){const J=Date.now()-new Date(qe.telemetryInfo.firstSessionDate).getTime();return isNaN(J)?!1:J<1e3*60*60*24},openExternal(J,ce){return ut.openUri(J,{allowTunneling:!!qe.remote.authority,allowContributedOpeners:ce==null?void 0:ce.allowContributedOpeners})},async asExternalUri(J){if(J.scheme===qe.environment.appUriScheme)return Ft.createAppUri(J);const ce=Ie.matchesScheme(J,Ce.Schemas.http)||Ie.matchesScheme(J,Ce.Schemas.https);ce||V.checkProposedApiEnabled(Te);try{return await ut.asExternalUri(J,{allowTunneling:!!qe.remote.authority})}catch(ke){if(ce)return J;throw ke}},get remoteName(){return $e.getRemoteName(qe.remote.authority)},get uiKind(){return qe.uiKind}};qe.environment.extensionTestsLocationURI||Object.freeze(hn);const fn=qe.remote.isRemote?R.ExtensionKind.Workspace:R.ExtensionKind.UI,rn={registerTestController(J){return V.checkProposedApiEnabled(Te),Nt.registerTestController(Te.identifier.value,J)},createDocumentTestObserver(J){return V.checkProposedApiEnabled(Te),Nt.createTextDocumentTestObserver(J)},createWorkspaceTestObserver(J){return V.checkProposedApiEnabled(Te),Nt.createWorkspaceTestObserver(J)},runTests(J){return V.checkProposedApiEnabled(Te),Nt.runTests(J)},createTestItem(J,ce){return new R.TestItemImpl(J.id,J.label,J.uri,ce)},createTestRun(J,ce,ke){return V.checkProposedApiEnabled(Te),Nt.createTestRun(Te.identifier.value,J,ce,ke)},get onDidChangeTestResults(){return V.checkProposedApiEnabled(Te),Nt.onResultsChanged},get testResults(){return V.checkProposedApiEnabled(Te),Nt.results}};rn.createTestRunTask=rn.createTestRun;const sn={getExtension(J){const ce=Wt.getExtensionDescription(J);if(ce)return new i.Extension(Ze,Te.identifier,ce,fn)},get all(){return Wt.getAllExtensionDescriptions().map(J=>new i.Extension(Ze,Te.identifier,J,fn))},get onDidChange(){return Wt.onDidChange}},In={createDiagnosticCollection(J){return xt.createDiagnosticCollection(Te.identifier,J)},get onDidChangeDiagnostics(){return xt.onDidChangeDiagnostics},getDiagnostics:J=>xt.getDiagnostics(J),getLanguages(){return nn.getLanguages()},setTextDocumentLanguage(J,ce){return nn.changeLanguage(J.uri,ce)},match(J,ce){return n.score(Y.LanguageSelector.from(J),ce.uri,ce.languageId,!0)},registerCodeActionsProvider(J,ce,ke){return ct.registerCodeActionProvider(Te,pt(J),ce,ke)},registerCodeLensProvider(J,ce){return ct.registerCodeLensProvider(Te,pt(J),ce)},registerDefinitionProvider(J,ce){return ct.registerDefinitionProvider(Te,pt(J),ce)},registerDeclarationProvider(J,ce){return ct.registerDeclarationProvider(Te,pt(J),ce)},registerImplementationProvider(J,ce){return ct.registerImplementationProvider(Te,pt(J),ce)},registerTypeDefinitionProvider(J,ce){return ct.registerTypeDefinitionProvider(Te,pt(J),ce)},registerHoverProvider(J,ce){return ct.registerHoverProvider(Te,pt(J),ce,Te.identifier)},registerEvaluatableExpressionProvider(J,ce){return ct.registerEvaluatableExpressionProvider(Te,pt(J),ce,Te.identifier)},registerInlineValuesProvider(J,ce){return ct.registerInlineValuesProvider(Te,pt(J),ce,Te.identifier)},registerDocumentHighlightProvider(J,ce){return ct.registerDocumentHighlightProvider(Te,pt(J),ce)},registerLinkedEditingRangeProvider(J,ce){return ct.registerLinkedEditingRangeProvider(Te,pt(J),ce)},registerReferenceProvider(J,ce){return ct.registerReferenceProvider(Te,pt(J),ce)},registerRenameProvider(J,ce){return ct.registerRenameProvider(Te,pt(J),ce)},registerDocumentSymbolProvider(J,ce,ke){return ct.registerDocumentSymbolProvider(Te,pt(J),ce,ke)},registerWorkspaceSymbolProvider(J){return ct.registerWorkspaceSymbolProvider(Te,J)},registerDocumentFormattingEditProvider(J,ce){return ct.registerDocumentFormattingEditProvider(Te,pt(J),ce)},registerDocumentRangeFormattingEditProvider(J,ce){return ct.registerDocumentRangeFormattingEditProvider(Te,pt(J),ce)},registerOnTypeFormattingEditProvider(J,ce,ke,...st){return ct.registerOnTypeFormattingEditProvider(Te,pt(J),ce,[ke].concat(st))},registerDocumentSemanticTokensProvider(J,ce,ke){return ct.registerDocumentSemanticTokensProvider(Te,pt(J),ce,ke)},registerDocumentRangeSemanticTokensProvider(J,ce,ke){return ct.registerDocumentRangeSemanticTokensProvider(Te,pt(J),ce,ke)},registerSignatureHelpProvider(J,ce,ke,...st){return typeof ke=="object"?ct.registerSignatureHelpProvider(Te,pt(J),ce,ke):ct.registerSignatureHelpProvider(Te,pt(J),ce,typeof ke=="undefined"?[]:[ke,...st])},registerCompletionItemProvider(J,ce,...ke){return ct.registerCompletionItemProvider(Te,pt(J),ce,ke)},registerInlineCompletionItemProvider(J,ce){return V.checkProposedApiEnabled(Te),ct.registerInlineCompletionsProvider(Te,pt(J),ce)},registerDocumentLinkProvider(J,ce){return ct.registerDocumentLinkProvider(Te,pt(J),ce)},registerColorProvider(J,ce){return ct.registerColorProvider(Te,pt(J),ce)},registerFoldingRangeProvider(J,ce){return ct.registerFoldingRangeProvider(Te,pt(J),ce)},registerSelectionRangeProvider(J,ce){return ct.registerSelectionRangeProvider(Te,J,ce)},registerCallHierarchyProvider(J,ce){return ct.registerCallHierarchyProvider(Te,J,ce)},setLanguageConfiguration:(J,ce)=>ct.setLanguageConfiguration(Te,J,ce),getTokenInformationAtPosition(J,ce){return V.checkProposedApiEnabled(Te),nn.tokenAtPosition(J,ce)},registerInlayHintsProvider(J,ce){return V.checkProposedApiEnabled(Te),ct.registerInlayHintsProvider(Te,J,ce)}},Pn={get activeTextEditor(){return Dt.getActiveTextEditor()},get visibleTextEditors(){return Dt.getVisibleTextEditors()},get activeTerminal(){return gt.activeTerminal},get terminals(){return gt.terminals},async showTextDocument(J,ce,ke){const st=await(C.URI.isUri(J)?Promise.resolve(mn.openTextDocument(J)):Promise.resolve(J));return Dt.showTextDocument(st,ce,ke)},createTextEditorDecorationType(J){return Dt.createTextEditorDecorationType(Te,J)},onDidChangeActiveTextEditor(J,ce,ke){return Dt.onDidChangeActiveTextEditor(J,ce,ke)},onDidChangeVisibleTextEditors(J,ce,ke){return Dt.onDidChangeVisibleTextEditors(J,ce,ke)},onDidChangeTextEditorSelection(J,ce,ke){return Dt.onDidChangeTextEditorSelection(J,ce,ke)},onDidChangeTextEditorOptions(J,ce,ke){return Dt.onDidChangeTextEditorOptions(J,ce,ke)},onDidChangeTextEditorVisibleRanges(J,ce,ke){return Dt.onDidChangeTextEditorVisibleRanges(J,ce,ke)},onDidChangeTextEditorViewColumn(J,ce,ke){return Dt.onDidChangeTextEditorViewColumn(J,ce,ke)},onDidCloseTerminal(J,ce,ke){return gt.onDidCloseTerminal(J,ce,ke)},onDidOpenTerminal(J,ce,ke){return gt.onDidOpenTerminal(J,ce,ke)},onDidChangeActiveTerminal(J,ce,ke){return gt.onDidChangeActiveTerminal(J,ce,ke)},onDidChangeTerminalDimensions(J,ce,ke){return V.checkProposedApiEnabled(Te),gt.onDidChangeTerminalDimensions(J,ce,ke)},onDidWriteTerminalData(J,ce,ke){return V.checkProposedApiEnabled(Te),gt.onDidWriteTerminalData(J,ce,ke)},get state(){return ut.state},onDidChangeWindowState(J,ce,ke){return ut.onDidChangeWindowState(J,ce,ke)},showInformationMessage(J,...ce){return tn.showMessage(Te,E.default.Info,J,ce[0],ce.slice(1))},showWarningMessage(J,...ce){return tn.showMessage(Te,E.default.Warning,J,ce[0],ce.slice(1))},showErrorMessage(J,...ce){return tn.showMessage(Te,E.default.Error,J,ce[0],ce.slice(1))},showQuickPick(J,ce,ke){return Lt.showQuickPick(J,!!Te.enableProposedApi,ce,ke)},showWorkspaceFolderPick(J){return Lt.showWorkspaceFolderPick(J)},showInputBox(J,ce){return Lt.showInput(J,ce)},showOpenDialog(J){return $t.showOpenDialog(J)},showSaveDialog(J){return $t.showSaveDialog(J)},createStatusBarItem(J,ce,ke){let st,bt,Ct;return typeof J=="string"?(st=J,bt=ce,Ct=ke):(bt=J,Ct=ce),Tt.createStatusBarEntry(Te,st,bt,Ct)},setStatusBarMessage(J,ce){return Tt.setStatusBarMessage(J,ce)},withScmProgress(J){return lt.report("window.withScmProgress",Te,"Use 'withProgress' instead."),un.withProgress(Te,{location:R.ProgressLocation.SourceControl},(ce,ke)=>J({report(st){}}))},withProgress(J,ce){return un.withProgress(Te,J,ce)},createOutputChannel(J){return Pt.createOutputChannel(J)},createWebviewPanel(J,ce,ke,st){return Zt.createWebviewPanel(Te,J,ce,ke,st)},createWebviewTextEditorInset(J,ce,ke,st){return V.checkProposedApiEnabled(Te),Yt.createWebviewEditorInset(J,ce,ke,st,Te)},createTerminal(J,ce,ke){return typeof J=="object"?"pty"in J?gt.createExtensionTerminal(J):(J.iconPath&&V.checkProposedApiEnabled(Te),gt.createTerminalFromOptions(J)):gt.createTerminal(J,ce,ke)},registerTerminalLinkProvider(J){return gt.registerLinkProvider(J)},registerTerminalProfileProvider(J,ce){return gt.registerProfileProvider(J,ce)},registerTreeDataProvider(J,ce){return ln.registerTreeDataProvider(J,ce,Te)},createTreeView(J,ce){return ln.createTreeView(J,ce,Te)},registerWebviewPanelSerializer:(J,ce)=>Zt.registerWebviewPanelSerializer(Te,J,ce),registerCustomEditorProvider:(J,ce,ke={})=>En.registerCustomEditorProvider(Te,J,ce,ke),registerFileDecorationProvider(J){return yt.registerFileDecorationProvider(J,Te.identifier)},registerUriHandler(J){return Ft.registerUriHandler(Te.identifier,J)},createQuickPick(){return Lt.createQuickPick(Te.identifier,!!Te.enableProposedApi)},createInputBox(){return Lt.createInputBox(Te.identifier)},get activeColorTheme(){return cn.activeColorTheme},onDidChangeActiveColorTheme(J,ce,ke){return cn.onDidChangeActiveColorTheme(J,ce,ke)},registerWebviewViewProvider(J,ce,ke){return yn.registerWebviewViewProvider(Te,J,ce,ke==null?void 0:ke.webviewOptions)},get activeNotebookEditor(){return V.checkProposedApiEnabled(Te),ft.activeNotebookEditor},onDidChangeActiveNotebookEditor(J,ce,ke){return V.checkProposedApiEnabled(Te),ft.onDidChangeActiveNotebookEditor(J,ce,ke)},get visibleNotebookEditors(){return V.checkProposedApiEnabled(Te),ft.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return V.checkProposedApiEnabled(Te),ft.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(J,ce,ke){return V.checkProposedApiEnabled(Te),ft.onDidChangeNotebookEditorSelection(J,ce,ke)},onDidChangeNotebookEditorVisibleRanges(J,ce,ke){return V.checkProposedApiEnabled(Te),ft.onDidChangeNotebookEditorVisibleRanges(J,ce,ke)},showNotebookDocument(J,ce){return V.checkProposedApiEnabled(Te),ft.showNotebookDocument(J,ce)},registerExternalUriOpener(J,ce,ke){return V.checkProposedApiEnabled(Te),jt.registerExternalUriOpener(Te.identifier,J,ce,ke)},get openEditors(){return V.checkProposedApiEnabled(Te),mt.tabs},get onDidChangeOpenEditors(){return V.checkProposedApiEnabled(Te),mt.onDidChangeTabs},getInlineCompletionItemController(J){return V.checkProposedApiEnabled(Te),b.InlineCompletionController.get(J)}},mn={get rootPath(){return lt.report("workspace.rootPath",Te,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ot.getPath()},set rootPath(J){throw T.readonly()},getWorkspaceFolder(J){return ot.getWorkspaceFolder(J)},get workspaceFolders(){return ot.getWorkspaceFolders()},get name(){return ot.name},set name(J){throw T.readonly()},get workspaceFile(){return ot.workspaceFile},set workspaceFile(J){throw T.readonly()},updateWorkspaceFolders:(J,ce,...ke)=>ot.updateWorkspaceFolders(Te,J,ce||0,...ke),onDidChangeWorkspaceFolders:function(J,ce,ke){return ot.onDidChangeWorkspace(J,ce,ke)},asRelativePath:(J,ce)=>ot.getRelativePath(J,ce),findFiles:(J,ce,ke,st)=>ot.findFiles(Y.GlobPattern.from(J),Y.GlobPattern.from(ce),ke,Te.identifier,st),findTextInFiles:(J,ce,ke,st)=>{let bt,Ct;return typeof ce=="object"?(bt=ce,Ct=ke):(bt={},Ct=ce,st=ke),ot.findTextInFiles(J,bt||{},Ct,Te.identifier,st)},saveAll:J=>ot.saveAll(J),applyEdit(J){return Dn.applyWorkspaceEdit(J)},createFileSystemWatcher:(J,ce,ke,st)=>Mt.createFileSystemWatcher(Y.GlobPattern.from(J),ce,ke,st),get textDocuments(){return _t.getAllDocumentData().map(J=>J.document)},set textDocuments(J){throw T.readonly()},openTextDocument(J){let ce;const ke=J;if(typeof J=="string")ce=Promise.resolve(C.URI.file(J));else if(C.URI.isUri(J))ce=Promise.resolve(J);else if(!ke||typeof ke=="object")ce=_t.createDocumentData(ke);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ce.then(st=>_t.ensureDocumentData(st).then(bt=>bt.document))},onDidOpenTextDocument:(J,ce,ke)=>_t.onDidAddDocument(J,ce,ke),onDidCloseTextDocument:(J,ce,ke)=>_t.onDidRemoveDocument(J,ce,ke),onDidChangeTextDocument:(J,ce,ke)=>_t.onDidChangeDocument(J,ce,ke),onDidSaveTextDocument:(J,ce,ke)=>_t.onDidSaveDocument(J,ce,ke),onWillSaveTextDocument:(J,ce,ke)=>Kt.getOnWillSaveTextDocumentEvent(Te)(J,ce,ke),get notebookDocuments(){return ft.notebookDocuments.map(J=>J.apiNotebook)},async openNotebookDocument(J,ce){let ke;if(C.URI.isUri(J))ke=J,await ft.openNotebookDocument(J);else if(typeof J=="string")ke=C.URI.revive(await ft.createNotebookDocument({viewType:J,content:ce}));else throw new Error("Invalid arguments");return ft.getNotebookDocument(ke).apiNotebook},get onDidOpenNotebookDocument(){return ft.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return ft.onDidCloseNotebookDocument},registerNotebookSerializer(J,ce,ke,st){return ft.registerNotebookSerializer(Te,J,ce,ke,Te.enableProposedApi?st:void 0)},registerNotebookContentProvider:(J,ce,ke,st)=>(V.checkProposedApiEnabled(Te),ft.registerNotebookContentProvider(Te,J,ce,ke,Te.enableProposedApi?st:void 0)),onDidChangeConfiguration:(J,ce,ke)=>dn.onDidChangeConfiguration(J,ce,ke),getConfiguration(J,ce){return ce=arguments.length===1?void 0:ce,dn.getConfiguration(J,ce,Te)},registerTextDocumentContentProvider(J,ce){return qt.registerTextDocumentContentProvider(J,ce)},registerTaskProvider:(J,ce)=>(lt.report("window.registerTaskProvider",Te,"Use the corresponding function on the 'tasks' namespace instead"),Et.registerTaskProvider(Te,J,ce)),registerFileSystemProvider(J,ce,ke){return Jt.registerFileSystemProvider(Te.identifier,J,ce,ke,Te.enableProposedApi)},get fs(){return nt.value},registerFileSearchProvider:(J,ce)=>(V.checkProposedApiEnabled(Te),kt.registerFileSearchProvider(J,ce)),registerTextSearchProvider:(J,ce)=>(V.checkProposedApiEnabled(Te),kt.registerTextSearchProvider(J,ce)),registerRemoteAuthorityResolver:(J,ce)=>(V.checkProposedApiEnabled(Te),Ze.registerRemoteAuthorityResolver(J,ce)),registerResourceLabelFormatter:J=>(V.checkProposedApiEnabled(Te),_n.$registerResourceLabelFormatter(J)),onDidCreateFiles:(J,ce,ke)=>Mt.onDidCreateFile(J,ce,ke),onDidDeleteFiles:(J,ce,ke)=>Mt.onDidDeleteFile(J,ce,ke),onDidRenameFiles:(J,ce,ke)=>Mt.onDidRenameFile(J,ce,ke),onWillCreateFiles:(J,ce,ke)=>Mt.getOnWillCreateFileEvent(Te)(J,ce,ke),onWillDeleteFiles:(J,ce,ke)=>Mt.getOnWillDeleteFileEvent(Te)(J,ce,ke),onWillRenameFiles:(J,ce,ke)=>Mt.getOnWillRenameFileEvent(Te)(J,ce,ke),openTunnel:J=>(V.checkProposedApiEnabled(Te),Xe.openTunnel(Te,J).then(ce=>{if(!ce)throw new Error("cannot open tunnel");return ce})),get tunnels(){return V.checkProposedApiEnabled(Te),Xe.getTunnels()},onDidChangeTunnels:(J,ce,ke)=>(V.checkProposedApiEnabled(Te),Xe.onDidChangeTunnels(J,ce,ke)),registerPortAttributesProvider:(J,ce)=>(V.checkProposedApiEnabled(Te),Xe.registerPortsAttributesProvider(J,ce)),registerTimelineProvider:(J,ce)=>(V.checkProposedApiEnabled(Te),Xt.registerTimelineProvider(J,ce,Te.identifier,wt.converter)),get isTrusted(){return ot.trusted},requestWorkspaceTrust:J=>(V.checkProposedApiEnabled(Te),ot.requestWorkspaceTrust(J)),onDidGrantWorkspaceTrust:(J,ce,ke)=>ot.onDidGrantWorkspaceTrust(J,ce,ke)},An={get inputBox(){return lt.report("scm.inputBox",Te,"Use 'SourceControl.inputBox' instead"),Vt.getLastInputBox(Te)},createSourceControl(J,ce,ke){return Vt.createSourceControl(Te,J,ce,ke)}},Tn={createCommentController(J,ce){return wn.createCommentController(Te,J,ce)}},Rn={get activeDebugSession(){return ht.activeDebugSession},get activeDebugConsole(){return ht.activeDebugConsole},get breakpoints(){return ht.breakpoints},onDidStartDebugSession(J,ce,ke){return ht.onDidStartDebugSession(J,ce,ke)},onDidTerminateDebugSession(J,ce,ke){return ht.onDidTerminateDebugSession(J,ce,ke)},onDidChangeActiveDebugSession(J,ce,ke){return ht.onDidChangeActiveDebugSession(J,ce,ke)},onDidReceiveDebugSessionCustomEvent(J,ce,ke){return ht.onDidReceiveDebugSessionCustomEvent(J,ce,ke)},onDidChangeBreakpoints(J,ce,ke){return ht.onDidChangeBreakpoints(J,ce,ke)},registerDebugConfigurationProvider(J,ce,ke){return ht.registerDebugConfigurationProvider(J,ce,ke||R.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(J,ce){return ht.registerDebugAdapterDescriptorFactory(Te,J,ce)},registerDebugAdapterTrackerFactory(J,ce){return ht.registerDebugAdapterTrackerFactory(J,ce)},startDebugging(J,ce,ke){return!ke||typeof ke=="object"&&"configuration"in ke?ht.startDebugging(J,ce,{parentSession:ke}):ht.startDebugging(J,ce,ke||{})},stopDebugging(J){return ht.stopDebugging(J)},addBreakpoints(J){return ht.addBreakpoints(J)},removeBreakpoints(J){return ht.removeBreakpoints(J)},asDebugSourceUri(J,ce){return ht.asDebugSourceUri(J,ce)}},gn={registerTaskProvider:(J,ce)=>Et.registerTaskProvider(Te,J,ce),fetchTasks:J=>Et.fetchTasks(J),executeTask:J=>Et.executeTask(Te,J),get taskExecutions(){return Et.taskExecutions},onDidStartTask:(J,ce,ke)=>Et.onDidStartTask(J,ce,ke),onDidEndTask:(J,ce,ke)=>Et.onDidEndTask(J,ce,ke),onDidStartTaskProcess:(J,ce,ke)=>Et.onDidStartTaskProcess(J,ce,ke),onDidEndTaskProcess:(J,ce,ke)=>Et.onDidEndTaskProcess(J,ce,ke)},pn={createNotebookController(J,ce,ke,st,bt){return Gt.createNotebookController(Te,J,ce,ke,st,Te.enableProposedApi?bt:void 0)},registerNotebookCellStatusBarItemProvider:(J,ce)=>ft.registerNotebookCellStatusBarItemProvider(Te,J,ce),get onDidSaveNotebookDocument(){return V.checkProposedApiEnabled(Te),ft.onDidSaveNotebookDocument},createNotebookEditorDecorationType(J){return V.checkProposedApiEnabled(Te),ft.createNotebookEditorDecorationType(J)},createRendererMessaging(J){return V.checkProposedApiEnabled(Te),Qt.createRendererMessaging(J)},onDidChangeNotebookDocumentMetadata(J,ce,ke){return V.checkProposedApiEnabled(Te),ft.onDidChangeNotebookDocumentMetadata(J,ce,ke)},onDidChangeNotebookCells(J,ce,ke){return V.checkProposedApiEnabled(Te),ft.onDidChangeNotebookCells(J,ce,ke)},onDidChangeNotebookCellExecutionState(J,ce,ke){return V.checkProposedApiEnabled(Te),ft.onDidChangeNotebookCellExecutionState(J,ce,ke)},onDidChangeCellOutputs(J,ce,ke){return V.checkProposedApiEnabled(Te),ft.onDidChangeCellOutputs(J,ce,ke)},onDidChangeCellMetadata(J,ce,ke){return V.checkProposedApiEnabled(Te),ft.onDidChangeCellMetadata(J,ce,ke)},createConcatTextDocument(J,ce){return V.checkProposedApiEnabled(Te),new pe.ExtHostNotebookConcatDocument(ft,_t,J,ce)}};return{version:qe.version,authentication:Cn,commands:kn,comments:Tn,debug:Rn,env:hn,extensions:sn,languages:In,notebooks:pn,scm:An,tasks:gn,test:rn,window:Pn,workspace:mn,Breakpoint:R.Breakpoint,CallHierarchyIncomingCall:R.CallHierarchyIncomingCall,CallHierarchyItem:R.CallHierarchyItem,CallHierarchyOutgoingCall:R.CallHierarchyOutgoingCall,CancellationError:T.CancellationError,CancellationTokenSource:g.CancellationTokenSource,CandidatePortSource:o.CandidatePortSource,CodeAction:R.CodeAction,CodeActionKind:R.CodeActionKind,CodeActionTriggerKind:R.CodeActionTriggerKind,CodeLens:R.CodeLens,Color:R.Color,ColorInformation:R.ColorInformation,ColorPresentation:R.ColorPresentation,ColorThemeKind:R.ColorThemeKind,CommentMode:R.CommentMode,CommentThreadCollapsibleState:R.CommentThreadCollapsibleState,CompletionItem:R.CompletionItem,CompletionItemKind:R.CompletionItemKind,CompletionItemTag:R.CompletionItemTag,CompletionList:R.CompletionList,CompletionTriggerKind:R.CompletionTriggerKind,ConfigurationTarget:R.ConfigurationTarget,CustomExecution:R.CustomExecution,DebugAdapterExecutable:R.DebugAdapterExecutable,DebugAdapterInlineImplementation:R.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:R.DebugAdapterNamedPipeServer,DebugAdapterServer:R.DebugAdapterServer,DebugConfigurationProviderTriggerKind:R.DebugConfigurationProviderTriggerKind,DebugConsoleMode:R.DebugConsoleMode,DecorationRangeBehavior:R.DecorationRangeBehavior,Diagnostic:R.Diagnostic,DiagnosticRelatedInformation:R.DiagnosticRelatedInformation,DiagnosticSeverity:R.DiagnosticSeverity,DiagnosticTag:R.DiagnosticTag,Disposable:R.Disposable,DocumentHighlight:R.DocumentHighlight,DocumentHighlightKind:R.DocumentHighlightKind,DocumentLink:R.DocumentLink,DocumentSymbol:R.DocumentSymbol,EndOfLine:R.EndOfLine,EnvironmentVariableMutatorType:R.EnvironmentVariableMutatorType,EvaluatableExpression:R.EvaluatableExpression,InlineValueText:R.InlineValueText,InlineValueVariableLookup:R.InlineValueVariableLookup,InlineValueEvaluatableExpression:R.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:R.InlineCompletionTriggerKind,EventEmitter:D.Emitter,ExtensionKind:R.ExtensionKind,ExtensionMode:R.ExtensionMode,ExternalUriOpenerPriority:R.ExternalUriOpenerPriority,FileChangeType:R.FileChangeType,FileDecoration:R.FileDecoration,FileSystemError:R.FileSystemError,FileType:I.FileType,FilePermission:I.FilePermission,FoldingRange:R.FoldingRange,FoldingRangeKind:R.FoldingRangeKind,FunctionBreakpoint:R.FunctionBreakpoint,InlineCompletionItem:R.InlineSuggestion,InlineCompletionList:R.InlineSuggestions,Hover:R.Hover,IndentAction:k.IndentAction,Location:R.Location,MarkdownString:R.MarkdownString,OverviewRulerLane:_.OverviewRulerLane,ParameterInformation:R.ParameterInformation,PortAutoForwardAction:R.PortAutoForwardAction,Position:R.Position,ProcessExecution:R.ProcessExecution,ProgressLocation:R.ProgressLocation,QuickInputButtons:R.QuickInputButtons,Range:R.Range,RelativePattern:R.RelativePattern,Selection:R.Selection,SelectionRange:R.SelectionRange,SemanticTokens:R.SemanticTokens,SemanticTokensBuilder:R.SemanticTokensBuilder,SemanticTokensEdit:R.SemanticTokensEdit,SemanticTokensEdits:R.SemanticTokensEdits,SemanticTokensLegend:R.SemanticTokensLegend,ShellExecution:R.ShellExecution,ShellQuoting:R.ShellQuoting,SignatureHelp:R.SignatureHelp,SignatureHelpTriggerKind:R.SignatureHelpTriggerKind,SignatureInformation:R.SignatureInformation,SnippetString:R.SnippetString,SourceBreakpoint:R.SourceBreakpoint,StandardTokenType:R.StandardTokenType,StatusBarAlignment:R.StatusBarAlignment,SymbolInformation:R.SymbolInformation,SymbolKind:R.SymbolKind,SymbolTag:R.SymbolTag,Task:R.Task,TaskGroup:R.TaskGroup,TaskPanelKind:R.TaskPanelKind,TaskRevealKind:R.TaskRevealKind,TaskScope:R.TaskScope,TextDocumentSaveReason:R.TextDocumentSaveReason,TextEdit:R.TextEdit,TextEditorCursorStyle:y.TextEditorCursorStyle,TextEditorLineNumbersStyle:R.TextEditorLineNumbersStyle,TextEditorRevealType:R.TextEditorRevealType,TextEditorSelectionChangeKind:R.TextEditorSelectionChangeKind,ThemeColor:R.ThemeColor,ThemeIcon:R.ThemeIcon,TreeItem:R.TreeItem,TreeItemCollapsibleState:R.TreeItemCollapsibleState,UIKind:o.UIKind,Uri:C.URI,ViewColumn:R.ViewColumn,WorkspaceEdit:R.WorkspaceEdit,InlayHint:R.InlayHint,InlayHintKind:R.InlayHintKind,RemoteAuthorityResolverError:R.RemoteAuthorityResolverError,ResolvedAuthority:R.ResolvedAuthority,SourceControlInputBoxValidationType:R.SourceControlInputBoxValidationType,ExtensionRuntime:R.ExtensionRuntime,TimelineItem:R.TimelineItem,NotebookRange:R.NotebookRange,NotebookCellKind:R.NotebookCellKind,NotebookCellExecutionState:R.NotebookCellExecutionState,NotebookCellData:R.NotebookCellData,NotebookData:R.NotebookData,NotebookRendererScript:R.NotebookRendererScript,NotebookCellStatusBarAlignment:R.NotebookCellStatusBarAlignment,NotebookEditorRevealType:R.NotebookEditorRevealType,NotebookCellOutput:R.NotebookCellOutput,NotebookCellOutputItem:R.NotebookCellOutputItem,NotebookCellStatusBarItem:R.NotebookCellStatusBarItem,NotebookControllerAffinity:R.NotebookControllerAffinity,PortAttributes:R.PortAttributes,LinkedEditingRanges:R.LinkedEditingRanges,TestItemStatus:R.TestItemStatus,TestResultState:R.TestResultState,TestMessage:R.TestMessage,TextSearchCompleteMessageType:G.TextSearchCompleteMessageType,TestMessageSeverity:R.TestMessageSeverity,WorkspaceTrustState:R.WorkspaceTrustState}}}e.createApiFactoryAndRegisterActors=Oe}),define(we[215],_e([0,1,57,99,30,98,32,71,36,37,102,103,104,74,73,66,70,100,72,44,69,92,64]),function(Z,e,g,T,D,E,C,y,_,k,n,I,o,h,d,u,w,v,S,c,m,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),g.registerSingleton(h.IExtensionStoragePaths,h.ExtensionStoragePaths),g.registerSingleton(w.IExtHostApiDeprecationService,w.ExtHostApiDeprecationService),g.registerSingleton(y.IExtHostCommands,y.ExtHostCommands),g.registerSingleton(C.IExtHostConfiguration,C.ExtHostConfiguration),g.registerSingleton(S.IExtHostConsumerFileSystem,S.ExtHostConsumerFileSystem),g.registerSingleton(I.IExtHostDebugService,I.WorkerExtHostDebugService),g.registerSingleton(E.IExtHostDecorations,E.ExtHostDecorations),g.registerSingleton(_.IExtHostDocumentsAndEditors,_.ExtHostDocumentsAndEditors),g.registerSingleton(c.IExtHostFileSystemInfo,c.ExtHostFileSystemInfo),g.registerSingleton(T.IExtHostOutputService,T.ExtHostOutputService),g.registerSingleton(o.IExtHostSearch,o.ExtHostSearch),g.registerSingleton(d.IExtHostStorage,d.ExtHostStorage),g.registerSingleton(n.IExtHostTask,n.WorkerExtHostTask),g.registerSingleton(k.IExtHostTerminalService,k.WorkerExtHostTerminalService),g.registerSingleton(u.IExtHostTunnelService,u.ExtHostTunnelService),g.registerSingleton(v.IExtHostWindow,v.ExtHostWindow),g.registerSingleton(D.IExtHostWorkspace,D.ExtHostWorkspace),g.registerSingleton(m.IExtHostSecretState,m.ExtHostSecretState),g.registerSingleton(f.IExtHostTelemetry,f.ExtHostTelemetry),g.registerSingleton(t.IExtHostEditorTabs,t.ExtHostEditorTabs)}),define(we[216],_e([0,1,214,33,210,6,11,4]),function(Z,e,g,T,D,E,C,y){"use strict";var _;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;var k;(function(d){var u;const w=(u=self.trustedTypes)===null||u===void 0?void 0:u.createPolicy("TrustedFunctionWorkaround",{createScript:(S,...c)=>{c.forEach(r=>{var i;if(!((i=self.trustedTypes)===null||i===void 0?void 0:i.isScript(r)))throw new Error("TrustedScripts only, please")});const m=c.slice(0,-1).join(","),f=c.pop().toString();return`(function anonymous(${m}) {
${f}
})`}});function v(...S){return w?self.eval(w.createScript("",...S)):new Function(...S)}d.create=v})(k||(k={}));class n extends D.RequireInterceptor{_installInterceptor(){}getModule(u,w){for(let v of this._alternatives){let S=v(u);if(S){u=S;break}}if(this._factories.has(u))return this._factories.get(u).load(u,w,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class I extends T.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=E.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const u=this._extHostContext.getProxy(y.MainContext.MainThreadConsole);h(u,this._initData.environment.isExtensionDevelopmentDebug);const w=this._instaService.invokeFunction(g.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(n,w,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(u){return u.browser}async _loadCommonJSModule(u,w,v){var S,c,m,f,t,r,i,s;w=w.with({path:o(w.path,".js")}),u&&performance.mark(`code/extHost/willFetchExtensionCode/${u.value}`);const l=await fetch(w.toString(!0));if(u&&performance.mark(`code/extHost/didFetchExtensionCode/${u.value}`),l.status!==200)throw new Error(l.statusText);const b=await l.text(),p=`${w.toString(!0)}#vscode-extension`,P=`${b}
//# sourceURL=${p}`;let A;try{A=k.create((c=(S=I._ttpExtensionScripts)===null||S===void 0?void 0:S.createScript("module"))!==null&&c!==void 0?c:"module",(f=(m=I._ttpExtensionScripts)===null||m===void 0?void 0:m.createScript("exports"))!==null&&f!==void 0?f:"exports",(r=(t=I._ttpExtensionScripts)===null||t===void 0?void 0:t.createScript("require"))!==null&&r!==void 0?r:"require",(s=(i=I._ttpExtensionScripts)===null||i===void 0?void 0:i.createScript(P))!==null&&s!==void 0?s:P)}catch(H){throw console.error(u?`Loading code for extension ${u.value} failed: ${H.message}`:`Loading code failed: ${H.message}`),console.error(`${w.toString(!0)}${typeof H.line=="number"?` line ${H.line}`:""}${typeof H.column=="number"?` column ${H.column}`:""}`),console.error(H),H}const a={},F={exports:a},N=H=>{const le=this._fakeModules.getModule(H,w);if(le===void 0)throw new Error(`Cannot load module '${H}'`);return le};try{return v.codeLoadingStart(),u&&performance.mark(`code/extHost/willLoadExtensionCode/${u.value}`),A(F,a,N),F.exports!==a?F.exports:a}finally{u&&performance.mark(`code/extHost/didLoadExtensionCode/${u.value}`),v.codeLoadingStop()}}async $setRemoteEnvironment(u){throw new Error("Not supported")}async _waitForDebuggerAttachment(u=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const w=Date.now()+u;for(;Date.now()<w&&!("__jsDebugIsReady"in globalThis);)await C.timeout(10)}}e.ExtHostExtensionService=I,I._ttpExtensionScripts=(_=self.trustedTypes)===null||_===void 0?void 0:_.createPolicy("ExtensionScripts",{createScript:d=>d});function o(d,u){return d.endsWith(u)?d:d+u}function h(d,u){w("info","log"),w("log","log"),w("warn","warn"),w("error","error");function w(c,m){const f=console[c];console[c]=function(){d.$logExtensionHostMessage({type:"__$console",severity:m,arguments:S(arguments)}),u&&f.apply(console,arguments)}}const v=1e5;function S(c){const m=[],f=[];if(c.length)for(let t=0;t<c.length;t++){if(typeof c[t]=="undefined")c[t]="undefined";else if(c[t]instanceof Error){const r=c[t];r.stack?c[t]=r.stack:c[t]=r.toString()}f.push(c[t])}try{const t=JSON.stringify(f,function(r,i){if(i&&typeof i=="object"){if(m.indexOf(i)!==-1)return"[Circular]";m.push(i)}return i});return t.length>v?"Output omitted for a large object that exceeds the limits":t}catch(t){return`Output omitted for an object that cannot be inspected ('${t.toString()}')`}}}}),define(we[217],_e([0,1,57,17,33,216,202]),function(Z,e,g,T,D,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),g.registerSingleton(D.IExtHostExtensionService,E.ExtHostExtensionService),g.registerSingleton(T.ILogService,C.ExtHostLogService)}),define(we[219],_e([0,1,23,3,172,211,204,13,75,215,217]),function(Z,e,g,T,D,E,C,y,_){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0});const n=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const I=postMessage.bind(self);if(self.postMessage=()=>console.trace("'postMessage' has been blocked"),self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const w=(k=self.trustedTypes)===null||k===void 0?void 0:k.createPolicy("extensionHostWorker",{createScriptURL:S=>S}),v=self.Worker;Worker=function(S,c){const m=`importScripts('${S}');`;c=c||{},c.name=c.name||y.basename(S.toString());const f=new Blob([m],{type:"application/javascript"}),t=URL.createObjectURL(f);return new v(w?w.createScriptURL(t):t,c)}}else self.Worker=class extends C.NestedWorker{constructor(w,v){super(I,w,Object.assign({name:y.basename(w.toString())},v))}};const o=new class{exit(w){n()}async exists(w){return!0}async realpath(w){return w}};class h{constructor(){const v=new MessageChannel,S=new T.Emitter;let c=!1;I(v.port2,[v.port2]),v.port1.onmessage=m=>{const{data:f}=m;if(!(f instanceof ArrayBuffer)){console.warn("UNKNOWN data received",f);return}const t=g.VSBuffer.wrap(new Uint8Array(f,0,f.byteLength));if(D.isMessageOfType(t,2)){c=!0,u("received terminate message from renderer");return}S.fire(t)},this.protocol={onMessage:S.event,send:m=>{if(!c){const f=m.buffer.buffer.slice(m.buffer.byteOffset,m.buffer.byteOffset+m.buffer.byteLength);v.port1.postMessage(f,[f])}}}}}function d(w){return new Promise(v=>{const S=w.onMessage(c=>{S.dispose();const m=JSON.parse(c.toString());w.send(D.createMessageOfType(0)),v({protocol:w,initData:m})});w.send(D.createMessageOfType(1))})}let u=w=>n();(function(){const v=new h;_.mark("code/extHost/willConnectToRenderer"),d(v.protocol).then(S=>{_.mark("code/extHost/didWaitForInitData");const c=new E.ExtensionHostMain(S.protocol,S.initData,o,null);u=m=>c.terminate(m)})})()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/b4c1bd0a9b03c749ea011b06c6d2676c8091a70c/core/vs/workbench/services/extensions/worker/extensionHostWorker.js.map
